(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   3278390,      71411]
NotebookOptionsPosition[   3275394,      71350]
NotebookOutlinePosition[   3276350,      71380]
CellTagsIndexPosition[   3276179,      71373]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["DMAudio 002 Project Report", "Title",
 CellTags->
  "ProjectTitleCell",ExpressionUUID->"65008252-a536-4032-bf6b-0f2d3999f7d3"],

Cell[CellGroupData[{

Cell["Project Comments", "Section",
 CellTags->
  "ProjectCommentsSectionCell",ExpressionUUID->"4f386c08-970b-4f00-aa3b-\
eedc4c5b4485"],

Cell["\<\
Experiments run by Conor with 50/50 split on data using an interleaved split \
(every second row as training/test).\
\>", "Text",
 CellChangeTimes->{{3.742809486068734*^9, 
  3.7428095108841877`*^9}},ExpressionUUID->"50191752-3b23-4624-8017-\
0455be3bebba"],

Cell["", "Text",
 CellTags->
  "Project Comment1",ExpressionUUID->"a546ae76-15cb-40d5-9e10-ab8455b58f7c"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.742809397631892*^9, 
  3.742809399503956*^9}},ExpressionUUID->"abc1b738-fc2e-4679-a120-\
7db929e2c426"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Analysis of Data", "Section",
 CellChangeTimes->{{3.7428095156768436`*^9, 
  3.7428095235156393`*^9}},ExpressionUUID->"ae5868e3-34b6-4bdd-b003-\
99f0b3a12fb8"],

Cell[BoxData[
 GraphicsBox[{
   {Opacity[0], 
    PointBox[{{0., 0.4733333333333333}, {0., 10.333333333333334`}}]}, {{}, 
    {RGBColor[0.982864, 0.7431472, 0.3262672], EdgeForm[None], 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 0.6666666666666666}, {1., 1.3333333333333335`}, 
            "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 475.61734693877554`}, {
           183.43105761574395`, 212.55426876632995`}}],
         StatusArea[#, 
          Style[
          "Column 10 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"100.0\\\"\", 100.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 10 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"100.0\\\\\\\"\\\", \
100.`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\", \
{FontColor -> RGBColor[0, 0, 1], FontFamily -> \"Helvetica\", FontWeight -> \
\"Bold\", FontSize -> 12, FontSlant -> \"Plain\", Background -> None, \
ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 10 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"100.0\\\\\\\"\\\", \
100.`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 10 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"100.0\\\"\", 100.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 1.6666666666666667`}, {0.12859037248337593`, 
            2.3333333333333335`}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 104.73029317824337`}, {
           139.74624088986496`, 168.86945204045097`}}],
         StatusArea[#, 
          Style[
          "Column 9 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"12.9\\\"\", 12.859037248337593`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 9 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"12.9\\\\\\\"\\\", \
12.859037248337593`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 9 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"12.9\\\\\\\"\\\", \
12.859037248337593`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 9 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"12.9\\\"\", 12.859037248337593`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[1, 0, 0], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 2.666666666666667}, {0.2248420359660927, 
            3.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 145.6966708282011}, {
           96.06142416398598, 125.18463531457198`}}],
         StatusArea[#, 
          Style[
          "Column 8 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"22.5\\\"\", 22.48420359660927`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 8 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"22.5\\\\\\\"\\\", \
22.48420359660927`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[1, 0, 0], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 8 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"22.5\\\\\\\"\\\", \
22.48420359660927`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 8 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"22.5\\\"\", 22.48420359660927`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 3.6666666666666674`}, {0.5025236675220491, 
            4.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 263.88279014467787`}, {
           52.37660743810699, 81.49981858869296}}],
         StatusArea[#, 
          Style[
          "Column 7 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"50.3\\\"\", 50.252366752204914`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 7 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"50.3\\\\\\\"\\\", \
50.252366752204914`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 7 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"50.3\\\\\\\"\\\", \
50.252366752204914`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 7 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"50.3\\\"\", 50.252366752204914`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 4.666666666666667}, {0.6659756085335774, 
            5.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 333.4507716299978}, {
           8.691790712227998, 37.815001862814}}],
         StatusArea[#, 
          Style[
          "Column 6 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"66.6\\\"\", 66.59756085335773`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 6 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"66.6\\\\\\\"\\\", \
66.59756085335773`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 6 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"66.6\\\\\\\"\\\", \
66.59756085335773`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 6 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"66.6\\\"\", 66.59756085335773`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 5.666666666666667}, {0.1357191985999346, 
            6.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 
           107.76444523676093`}, {-34.99302601365099, -5.869814863064988}}],
         StatusArea[#, 
          Style[
          "Column 5 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"13.6\\\"\", 13.571919859993459`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 5 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"13.6\\\\\\\"\\\", \
13.571919859993459`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 5 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"13.6\\\\\\\"\\\", \
13.571919859993459`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 5 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"13.6\\\"\", 13.571919859993459`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 6.666666666666667}, {0.7569301553306499, 
            7.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 
           372.16260452978645`}, {-78.67784273952998, -49.554631588944005`}}],
         
         StatusArea[#, 
          Style[
          "Column 4 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"75.7\\\"\", 75.693015533065`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 4 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"75.7\\\\\\\"\\\", \
75.693015533065`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 4 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"75.7\\\\\\\"\\\", \
75.693015533065`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 4 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"75.7\\\"\", 75.693015533065`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 7.666666666666667}, {0.7829844323689181, 
            8.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 
           383.25175679922205`}, {-122.36265946540897`, -93.239448314823}}],
         StatusArea[#, 
          Style[
          "Column 3 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"78.3\\\"\", 78.29844323689181`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 3 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"78.3\\\\\\\"\\\", \
78.29844323689181`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 3 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"78.3\\\\\\\"\\\", \
78.29844323689181`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 3 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"78.3\\\"\", 78.29844323689181`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[1, 0, 0], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 8.666666666666668}, {0.12781363671264828`, 
            9.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 
           104.39970096023383`}, {-166.04747619128796`, \
-136.92426504070198`}}],
         StatusArea[#, 
          Style[
          "Column 2 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"12.8\\\"\", 12.781363671264828`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 2 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"12.8\\\\\\\"\\\", \
12.781363671264828`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[1, 0, 0], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 2 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"12.8\\\\\\\"\\\", \
12.781363671264828`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 2 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"12.8\\\"\", 12.781363671264828`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[1, 0, 0], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}, 
     {RGBColor[0, 0, 1], EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 9.666666666666668}, {0.08692462037448427, 
            10.333333333333334`}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{49.999999999999986`, 
           86.99662630744822}, {-209.73229291716694`, -180.60908176658097`}}],
         
         StatusArea[#, 
          Style[
          "Column 1 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"8.7\\\"\", 8.692462037448427`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
           FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
            FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
            Background -> None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"Column 1 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"8.7\\\\\\\"\\\", \
8.692462037448427`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\", {FontColor -> RGBColor[0, 0, 1], FontFamily -> \
\"Helvetica\", FontWeight -> \"Bold\", FontSize -> 12, FontSlant -> \
\"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        StyleBox[
         StyleBox[
         "\"Column 1 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"8.7\\\\\\\"\\\", \
8.692462037448427`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[5, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) %\"", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}, StripOnInput -> 
          False], {}, StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "Column 1 \[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"8.7\\\"\", 8.692462037448427`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[5, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 5], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) %", {
          FontColor -> RGBColor[0, 0, 1], FontFamily -> "Helvetica", 
           FontWeight -> "Bold", FontSize -> 12, FontSlant -> "Plain", 
           Background -> None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}}, {}, {}}, {}, {}, {}, {}, 
   StyleBox[{
     {Thickness[Tiny], 
      LineBox[{{0., 0.4733333333333333}, {0., 10.530533333333334`}}], 
      StyleBox[{}, "GraphicsLabel",
       StripOnInput->False]}, 
     StyleBox[{
       {Thickness[Tiny], 
        LineBox[{{0., 0.6666666666666666}, 
          Offset[{-6., 0.}, {0., 0.6666666666666666}]}], 
        LineBox[{{0., 10.333333333333334`}, 
          Offset[{-6., 0.}, {0., 
           10.333333333333334`}]}], {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {
          LineBox[{{0., 1.3333333333333335`}, 
            Offset[{-4., 0.}, {0., 1.3333333333333335`}]}], 
          LineBox[{{0., 1.666666666666667}, 
            Offset[{-4., 0.}, {0., 1.666666666666667}]}], 
          LineBox[{{0., 2.3333333333333335`}, 
            Offset[{-4., 0.}, {0., 2.3333333333333335`}]}], 
          LineBox[{{0., 2.666666666666667}, 
            Offset[{-4., 0.}, {0., 2.666666666666667}]}], 
          LineBox[{{0., 3.333333333333334}, 
            Offset[{-4., 0.}, {0., 3.333333333333334}]}], 
          LineBox[{{0., 3.6666666666666674`}, 
            Offset[{-4., 0.}, {0., 3.6666666666666674`}]}], 
          LineBox[{{0., 4.333333333333334}, 
            Offset[{-4., 0.}, {0., 4.333333333333334}]}], 
          LineBox[{{0., 4.666666666666668}, 
            Offset[{-4., 0.}, {0., 4.666666666666668}]}], 
          LineBox[{{0., 5.333333333333335}, 
            Offset[{-4., 0.}, {0., 5.333333333333335}]}], 
          LineBox[{{0., 5.666666666666668}, 
            Offset[{-4., 0.}, {0., 5.666666666666668}]}], 
          LineBox[{{0., 6.333333333333335}, 
            Offset[{-4., 0.}, {0., 6.333333333333335}]}], 
          LineBox[{{0., 6.666666666666668}, 
            Offset[{-4., 0.}, {0., 6.666666666666668}]}], 
          LineBox[{{0., 7.333333333333335}, 
            Offset[{-4., 0.}, {0., 7.333333333333335}]}], 
          LineBox[{{0., 7.666666666666668}, 
            Offset[{-4., 0.}, {0., 7.666666666666668}]}], 
          LineBox[{{0., 8.333333333333334}, 
            Offset[{-4., 0.}, {0., 8.333333333333334}]}], 
          LineBox[{{0., 8.666666666666668}, 
            Offset[{-4., 0.}, {0., 8.666666666666668}]}], 
          LineBox[{{0., 9.333333333333334}, 
            Offset[{-4., 0.}, {0., 9.333333333333334}]}], 
          LineBox[{{0., 9.666666666666668}, 
            Offset[{-4., 0.}, {0., 9.666666666666668}]}]}, {}}}, 
       StyleBox[
        {Thickness[Tiny], 
         InsetBox["\<\"Column 10\"\>", Offset[{-2, 0}, {0., 1.}], {1, 0}, 
          Automatic, {1, 0}], 
         InsetBox["\<\"Column 9\"\>", Offset[{-2, 0}, {0., 2.}], {1, 0}, 
          Automatic, {1, 0}], 
         InsetBox["\<\"Column 8\"\>", 
          Offset[{-2, 0}, {0., 3.0000000000000004}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 7\"\>", 
          Offset[{-2, 0}, {0., 4.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 6\"\>", 
          Offset[{-2, 0}, {0., 5.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 5\"\>", 
          Offset[{-2, 0}, {0., 6.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 4\"\>", 
          Offset[{-2, 0}, {0., 7.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 3\"\>", Offset[{-2, 0}, {0., 8.}], {1, 0},
           Automatic, {1, 0}], 
         InsetBox["\<\"Column 2\"\>", 
          Offset[{-2, 0}, {0., 9.000000000000002}], {1, 0}, Automatic, {1, 
          0}], InsetBox["\<\"Column 1\"\>", 
          Offset[{-2, 0}, {0., 10.000000000000002}], {1, 0}, Automatic, {1, 
          0}]}, "GraphicsLabel",
        StripOnInput->False]}, "GraphicsTicks",
      StripOnInput->False]}, "GraphicsAxes",
    StripOnInput->False,
    Antialiasing->False]},
  AspectRatio->1,
  Axes->{True, False},
  AxesLabel->{None, None},
  AxesOrigin->{0., 0.4733333333333333},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Identity[
       Part[#, 1]], 
      Identity[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Identity[
       Part[#, 1]], 
      Identity[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{Automatic, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->500,
  PlotLabel->FormBox["\"Correlation with Column 10\"", TraditionalForm],
  PlotRange->{{All, All}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.05]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, None}]], "Output",ExpressionUUID->"427e98a7-b165-4a1d-\
8e01-357994efb668"],

Cell["\<\
What variables are present in \[OpenCurlyDoubleQuote]interesting\
\[CloseCurlyDoubleQuote] models? Hover over them to see exact figures.\
\>", "Text",
 CellChangeTimes->{{3.742809542446516*^9, 
  3.742809588702362*^9}},ExpressionUUID->"cb060cfb-c65a-41de-85c6-\
494d727700ce"],

Cell[BoxData[
 GraphicsBox[{
   {Opacity[0], 
    PointBox[{{0., 0.4933333333333333}, {0., 9.333333333333334}}]}, {{}, 
    {RGBColor[0.982864, 0.7431472, 0.3262672], EdgeForm[None], 
     {RGBColor[0.2833398918918919, 0.1671124864864865, 0.7125665945945946], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 0.6666666666666666}, {9.121621621621621, 
            1.3333333333333335`}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 90.44319313091088}, {
           184.886861531943, 217.8774333262716}}],
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]9\", Hue[Rational[9, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"9.1\\\"\", 9.121621621621621`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 27  of the \
296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]9\\\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"9.1\\\\\\\"\\\", \
9.121621621621621`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 27  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]9\\\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"9.1\\\\\\\"\\\", \
9.121621621621621`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 27  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]9\", Hue[Rational[9, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"9.1\\\"\", 9.121621621621621`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 27  of the \
296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[0.9015607297297297, 0.5445156756756755, 0.2092498918918919], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 1.6666666666666667`}, {83.10810810810811, 
            2.3333333333333335`}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 475.26020408163265`}, {
           135.40100384045013`, 168.39157563477872`}}],
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]8\", Hue[Rational[4, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"83.1\\\"\
\", 83.10810810810811`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
246  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"83.1\\\\\\\"\\\", \
83.10810810810811`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 246  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"83.1\\\\\\\"\\\", \
83.10810810810811`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 246  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]8\", Hue[Rational[4, 5], 1, \
Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"83.1\\\"\
\", 83.10810810810811`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
246  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[
      0.34139686486486487`, 0.11591248648648649`, 0.6384643783783783], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           RectangleBox[{0., 2.666666666666667}, {5.0675675675675675`, 
            3.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 69.3573295171727}, {
           85.9151461489572, 118.90571794328582`}}],
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]7\", Hue[Rational[7, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"5.1\\\"\", 5.0675675675675675`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 15  of the \
296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]7\\\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"5.1\\\\\\\"\\\", \
5.0675675675675675`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 15  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]7\\\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"5.1\\\\\\\"\\\", \
5.0675675675675675`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 15  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]7\", Hue[Rational[7, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"5.1\\\"\", 5.0675675675675675`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 15  of the \
296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[0.7437454594594594, 0.7333226756756757, 0.2825884054054054], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 3.6666666666666674`}, {65.2027027027027, 
            4.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 382.1309731209557}, {
           36.42928845746431, 69.4198602517929}}],
         StatusArea[#, 
          Style[
          
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]6\", Hue[Rational[3, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.2\\\"\
\", 65.2027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
193  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"65.2\\\\\\\"\\\", \
65.2027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 193  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"65.2\\\\\\\"\\\", \
65.2027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 193  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]6\", Hue[Rational[3, 5], 1, \
Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.2\\\"\
\", 65.2027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
193  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[
      0.24944156756756758`, 0.39175005405405405`, 0.8127868378378379], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 4.666666666666667}, {20.27027027027027, 
            5.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 
           148.42931806869086`}, {-13.056569234028558`, 19.93400256030003}}],
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]5\", Hue[Rational[1, 2], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"20.3\\\"\
\", 20.27027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
60  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"20.3\\\\\\\"\\\", \
20.27027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 60  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"20.3\\\\\\\"\\\", \
20.27027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 60  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]5\", Hue[Rational[1, 2], 1, \
Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"20.3\\\"\
\", 20.27027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
60  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[0.7534223243243243, 0.7310055945945946, 0.27844375675675676`], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 5.666666666666667}, {65.87837837837837, 
            6.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 
           385.64528372324537`}, {-62.54242692552148, -29.551855131192866`}}],
         
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]4\", Hue[Rational[2, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.9\\\"\
\", 65.87837837837837`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
195  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"65.9\\\\\\\"\\\", \
65.87837837837837`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 195  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"65.9\\\\\\\"\\\", \
65.87837837837837`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 195  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]4\", Hue[Rational[2, 5], 1, \
Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.9\\\"\
\", 65.87837837837837`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
195  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[0.8918918918918919, 0.6042180270270271, 0.22141221621621623`], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 6.666666666666667}, {79.72972972972973, 
            7.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 
           457.68865107018416`}, {-112.02828461701435`, -79.03771282268573}}],
         
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]3\", Hue[Rational[3, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"79.7\\\"\
\", 79.72972972972973`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
236  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"79.7\\\\\\\"\\\", \
79.72972972972973`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 236  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"79.7\\\\\\\"\\\", \
79.72972972972973`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 236  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]3\", Hue[Rational[3, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"79.7\\\"\
\", 79.72972972972973`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
236  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[0.41940594594594593`, 0.1116245945945946, 0.5715953513513514], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 7.666666666666667}, {2.027027027027027, 
            8.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 
           53.54293180686908}, {-161.51414230850722`, -128.5235705141786}}],
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]2\", Hue[Rational[1, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"2.0\\\"\", 2.027027027027027`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 6  of the \
296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]2\\\", \
Hue[Rational[1, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"2.0\\\\\\\"\\\", \
2.027027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 6  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]2\\\", \
Hue[Rational[1, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"2.0\\\\\\\"\\\", \
2.027027027027027`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 6  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]2\", Hue[Rational[1, 5], 1, \
Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"2.0\\\"\", 2.027027027027027`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 6  of the \
296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], "Tooltip"]& ]}, 
     {RGBColor[
      0.24964994594594594`, 0.24741670270270266`, 0.7767625945945945], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        TagBox[
         DynamicBox[{
           FEPrivate`If[
            CurrentValue["MouseOver"], 
            EdgeForm[{
              GrayLevel[0.5], 
              AbsoluteThickness[1.5], 
              Opacity[0.66]}], {}, {}], 
           
           RectangleBox[{0., 8.666666666666668}, {13.513513513513512`, 
            9.333333333333334}, "RoundingRadius" -> 0]},
          
          ImageSizeCache->{{42.999999999999986`, 
           113.2862120457939}, {-211.00000000000014`, -178.00942820567158`}}],
         
         StatusArea[#, 
          Style[
          "\!\(\*FormBox[StyleBox[\"column\[Bullet]1\", Hue[Rational[1, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"13.5\\\"\
\", 13.513513513513512`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\"\", \"0\"]]]]], TraditionalForm]\) % ( 40  of the 296 models )", {
           FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
            FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
            None, ShowStringCharacters -> False}]]& ,
         TagBoxNote->
          "Style[\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]1\\\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"13.5\\\\\\\"\\\", \
13.513513513513512`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 40  of the 296 models )\", {FontWeight -> \"Plain\", \
FontFamily -> \"Helvetica\", FontSize -> 12, FontColor -> GrayLevel[0], \
FontSlant -> \"Plain\", Background -> None, ShowStringCharacters -> False}]"],
        
        StyleBox[
         StyleBox[
         "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]1\\\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"13.5\\\\\\\"\\\", \
13.513513513513512`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\\\"\\\", \\\"0\\\"]]]]], \
TraditionalForm]\\) % ( 40  of the 296 models )\"", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], {}, 
         StripOnInput -> False],
        TooltipStyle->"TextStyling"],
       Annotation[#, 
        Style[
         Style[
         "\!\(\*FormBox[StyleBox[\"column\[Bullet]1\", Hue[Rational[1, 10], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) \
\[DoubleLongRightArrow] \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"13.5\\\"\
\", 13.513513513513512`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\"\", \"0\"]]]]], TraditionalForm]\) % ( 40  of the 296 models )", {
          FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}], {}], 
        "Tooltip"]& ]}}, {}, {}}, {}, {}, {}, {}, 
   StyleBox[{
     {Thickness[Tiny], 
      LineBox[{{0., 0.4933333333333333}, {0., 9.510133333333334}}], 
      StyleBox[
       {Thickness[Tiny], 
        InsetBox["\<\"%\"\>", Offset[{0., 10.}, {0., 9.333333333333332}], {0, -1},
          Automatic, {1, 0}]}, "GraphicsLabel",
       StripOnInput->False]}, 
     StyleBox[{
       {Thickness[Tiny], 
        LineBox[{{0., 0.6666666666666666}, 
          Offset[{-6., 0.}, {0., 0.6666666666666666}]}], 
        LineBox[{{0., 9.333333333333334}, 
          Offset[{-6., 0.}, {0., 
           9.333333333333334}]}], {{}, {}, {}, {}, {}, {}, {}, {}, {}, {
          LineBox[{{0., 1.3333333333333335`}, 
            Offset[{-4., 0.}, {0., 1.3333333333333335`}]}], 
          LineBox[{{0., 1.666666666666667}, 
            Offset[{-4., 0.}, {0., 1.666666666666667}]}], 
          LineBox[{{0., 2.3333333333333335`}, 
            Offset[{-4., 0.}, {0., 2.3333333333333335`}]}], 
          LineBox[{{0., 2.666666666666667}, 
            Offset[{-4., 0.}, {0., 2.666666666666667}]}], 
          LineBox[{{0., 3.333333333333334}, 
            Offset[{-4., 0.}, {0., 3.333333333333334}]}], 
          LineBox[{{0., 3.6666666666666674`}, 
            Offset[{-4., 0.}, {0., 3.6666666666666674`}]}], 
          LineBox[{{0., 4.333333333333334}, 
            Offset[{-4., 0.}, {0., 4.333333333333334}]}], 
          LineBox[{{0., 4.666666666666668}, 
            Offset[{-4., 0.}, {0., 4.666666666666668}]}], 
          LineBox[{{0., 5.333333333333335}, 
            Offset[{-4., 0.}, {0., 5.333333333333335}]}], 
          LineBox[{{0., 5.666666666666668}, 
            Offset[{-4., 0.}, {0., 5.666666666666668}]}], 
          LineBox[{{0., 6.333333333333335}, 
            Offset[{-4., 0.}, {0., 6.333333333333335}]}], 
          LineBox[{{0., 6.666666666666668}, 
            Offset[{-4., 0.}, {0., 6.666666666666668}]}], 
          LineBox[{{0., 7.333333333333335}, 
            Offset[{-4., 0.}, {0., 7.333333333333335}]}], 
          LineBox[{{0., 7.666666666666668}, 
            Offset[{-4., 0.}, {0., 7.666666666666668}]}], 
          LineBox[{{0., 8.333333333333334}, 
            Offset[{-4., 0.}, {0., 8.333333333333334}]}], 
          LineBox[{{0., 8.666666666666668}, 
            Offset[{-4., 0.}, {0., 8.666666666666668}]}]}, {}}}, 
       StyleBox[
        {Thickness[Tiny], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]9",
             StripOnInput->False,
             LineColor->Hue[
               Rational[9, 10], 1, 
               Rational[5, 6]],
             FrontFaceColor->Hue[
               Rational[9, 10], 1, 
               Rational[5, 6]],
             BackFaceColor->Hue[
               Rational[9, 10], 1, 
               Rational[5, 6]],
             GraphicsColor->Hue[
               Rational[9, 10], 1, 
               Rational[5, 6]],
             FontColor->Hue[
               Rational[9, 10], 1, 
               Rational[5, 6]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]9\\\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"9.1\\\\\\\"\\\", 9.121621621621621`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 27  of the 296 models )\"", \
{FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, FontColor -> 
              GrayLevel[0], FontSlant -> "Plain", Background -> None, 
              ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]9\", Hue[Rational[9, \
10], 1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) is \
used by \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"9.1\\\"\", \
9.121621621621621`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
27  of the 296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 1.}], {1, 0}, Automatic, {1, 0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]8",
             StripOnInput->False,
             LineColor->Hue[
               Rational[4, 5], 1, 
               Rational[1, 2]],
             FrontFaceColor->Hue[
               Rational[4, 5], 1, 
               Rational[1, 2]],
             BackFaceColor->Hue[
               Rational[4, 5], 1, 
               Rational[1, 2]],
             GraphicsColor->Hue[
               Rational[4, 5], 1, 
               Rational[1, 2]],
             FontColor->Hue[
               Rational[4, 5], 1, 
               Rational[1, 2]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"83.1\\\\\\\"\\\", 83.10810810810811`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 246  of the 296 models \
)\"", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
              FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]8\", Hue[Rational[4, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"83.1\\\"\", 83.10810810810811`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 246  of the \
296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 2.}], {1, 0}, Automatic, {1, 0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]7",
             StripOnInput->False,
             LineColor->Hue[
               Rational[7, 10], 1, 
               Rational[5, 6]],
             FrontFaceColor->Hue[
               Rational[7, 10], 1, 
               Rational[5, 6]],
             BackFaceColor->Hue[
               Rational[7, 10], 1, 
               Rational[5, 6]],
             GraphicsColor->Hue[
               Rational[7, 10], 1, 
               Rational[5, 6]],
             FontColor->Hue[
               Rational[7, 10], 1, 
               Rational[5, 6]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]7\\\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"5.1\\\\\\\"\\\", 5.0675675675675675`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 15  of the 296 models )\"", \
{FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, FontColor -> 
              GrayLevel[0], FontSlant -> "Plain", Background -> None, 
              ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]7\", Hue[Rational[7, \
10], 1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) is \
used by \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"5.1\\\"\", \
5.0675675675675675`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
15  of the 296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 3.0000000000000004}], {1, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]6",
             StripOnInput->False,
             LineColor->Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]],
             FrontFaceColor->Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]],
             BackFaceColor->Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]],
             GraphicsColor->Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]],
             FontColor->Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"65.2\\\\\\\"\\\", 65.2027027027027`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 193  of the 296 models \
)\"", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
              FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]6\", Hue[Rational[3, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.2\\\"\", 65.2027027027027`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 193  of the \
296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 4.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]5",
             StripOnInput->False,
             LineColor->Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]],
             FrontFaceColor->Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]],
             BackFaceColor->Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]],
             GraphicsColor->Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]],
             FontColor->Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"20.3\\\\\\\"\\\", 20.27027027027027`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 60  of the 296 models )\"", \
{FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, FontColor -> 
              GrayLevel[0], FontSlant -> "Plain", Background -> None, 
              ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]5\", Hue[Rational[1, 2], \
1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"20.3\\\"\", 20.27027027027027`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 60  of the \
296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 5.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]4",
             StripOnInput->False,
             LineColor->Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]],
             FrontFaceColor->Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]],
             BackFaceColor->Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]],
             GraphicsColor->Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]],
             FontColor->Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"65.9\\\\\\\"\\\", 65.87837837837837`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 195  of the 296 models \
)\"", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
              FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]4\", Hue[Rational[2, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"65.9\\\"\", 65.87837837837837`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 195  of the \
296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 6.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]3",
             StripOnInput->False,
             LineColor->Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]],
             FrontFaceColor->Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]],
             BackFaceColor->Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]],
             GraphicsColor->Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]],
             FontColor->Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"79.7\\\\\\\"\\\", 79.72972972972973`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 236  of the 296 models \
)\"", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
              FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]3\", Hue[Rational[3, \
10], 1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) is \
used by \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"79.7\\\"\", \
79.72972972972973`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
236  of the 296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 7.000000000000001}], {1, 0}, Automatic, {1, 
          0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]2",
             StripOnInput->False,
             LineColor->Hue[
               Rational[1, 5], 1, 
               Rational[1, 2]],
             FrontFaceColor->Hue[
               Rational[1, 5], 1, 
               Rational[1, 2]],
             BackFaceColor->Hue[
               Rational[1, 5], 1, 
               Rational[1, 2]],
             GraphicsColor->Hue[
               Rational[1, 5], 1, 
               Rational[1, 2]],
             FontColor->Hue[
               Rational[1, 5], 1, 
               Rational[1, 2]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]2\\\", \
Hue[Rational[1, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"2.0\\\\\\\"\\\", 2.027027027027027`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 6  of the 296 models )\"", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]2\", Hue[Rational[1, 5], \
1, Rational[1, 2]], Rule[StripOnInput, False]], TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"2.0\\\"\", 2.027027027027027`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( 6  of the \
296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 8.}], {1, 0}, Automatic, {1, 0}], InsetBox[
          TagBox[
           TooltipBox[
            StyleBox["column\[Bullet]1",
             StripOnInput->False,
             LineColor->Hue[
               Rational[1, 10], 1, 
               Rational[5, 6]],
             FrontFaceColor->Hue[
               Rational[1, 10], 1, 
               Rational[5, 6]],
             BackFaceColor->Hue[
               Rational[1, 10], 1, 
               Rational[5, 6]],
             GraphicsColor->Hue[
               Rational[1, 10], 1, 
               Rational[5, 6]],
             FontColor->Hue[
               Rational[1, 10], 1, 
               Rational[5, 6]]],
            StyleBox[
            "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]1\\\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"13.5\\\\\\\"\\\", 13.513513513513512`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % ( 40  of the 296 models )\"", \
{FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, FontColor -> 
              GrayLevel[0], FontSlant -> "Plain", Background -> None, 
              ShowStringCharacters -> False}, StripOnInput -> False],
            TooltipDelay->0.1,
            TooltipStyle->"TextStyling"],
           Annotation[#, 
            Style[
            "\!\(\*FormBox[StyleBox[\"column\[Bullet]1\", Hue[Rational[1, \
10], 1, Rational[5, 6]], Rule[StripOnInput, False]], TraditionalForm]\) is \
used by \!\(\*FormBox[TagBox[InterpretationBox[\"\\\"13.5\\\"\", \
13.513513513513512`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[3, 1], Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, \
Slot[1]]]], Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % ( \
40  of the 296 models )", {
             FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12,
               FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
              None, ShowStringCharacters -> False}], "Tooltip"]& ], 
          Offset[{-2, 0}, {0., 9.000000000000002}], {1, 0}, Automatic, {1, 
          0}]}, "GraphicsLabel",
        StripOnInput->False]}, "GraphicsTicks",
      StripOnInput->False]}, "GraphicsAxes",
    StripOnInput->False,
    Antialiasing->False]},
  AspectRatio->1,
  Axes->{True, False},
  AxesLabel->{None, 
    FormBox["\"%\"", TraditionalForm]},
  AxesOrigin->{0., 0.4933333333333333},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Identity[
       Part[#, 1]], 
      Identity[
       Part[#, 2]]}& ), "CopiedValueFunction" -> ({
      Identity[
       Part[#, 1]], 
      Identity[
       Part[#, 2]]}& )},
  DisplayFunction->Identity,
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{Automatic, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImageSize->500,
  PlotLabel->FormBox["\"column\[Bullet]10\"", TraditionalForm],
  PlotRange->{{All, All}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.05]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, None}]], "Output",ExpressionUUID->"dc8ef6f1-37cb-4247-\
a032-e2e66df42163"],

Cell["Performance of different types of models using training data", "Text",
 CellChangeTimes->{{3.74280961739218*^9, 
  3.742809638895618*^9}},ExpressionUUID->"3362d0c1-ea83-4cb3-9240-\
ed9c58db8332"],

Cell[BoxData[
 TemplateBox[{TagBox[
    GridBox[{{"\" \"", 
       StyleBox[
       "\"num \[DoubleLongRightArrow] %\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"Variables Used\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"ParetoFrontPlot\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False]}, {
       StyleBox[
       "\"1\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"54 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"18.2\\\\\\\"\\\", \
18.243243243243246`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[4, 1], Rule[ExponentFunction, Automatic], Rule[NumberPadding, \
List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\"", {
        FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}}, 
         GridBoxAlignment -> {"Columns" -> {{Left}}}, DefaultBaseStyle -> 
         "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"], 
       TagBox[
        GridBox[{{
           GraphicsBox[{{{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[
                  0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxV1Xk81VkbAHBaVFJhRJbXkqakxFCGGhyXbMm1L5GtMBoqMiEUmSnpZq+Z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                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  GrayLevel[0.5], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQFqDuJdWpt6Dt+wh/B1HG5Ezpw6ies6lK/n4Kib
eMJ1wjUo38jh19kjJYphJ6B8S4e8e5Mf2Z09CuVbOehvqN2uH7YLwm9wcPht
/2hTagiUz+DoEPB6YmKBxg4o39nhS6nR7BLJrVD1bg5zWV97rmLYApV3d+A5
oeJS6rUZKu/hME8r+neuKJTP4OWQOl9w20vJTVC+t8OXczNn80itgfAdAhwk
Lpb53J26Giof6MDJo754pdJyCP9AkMN2ZilBw1PLoPxgh0/Smw5PaF4K1Z/k
wKjd3674bBFUPtnB6fnvU/93L7IHADflXOU=
                  
                  "]]}, {}}}, {}, {}, {}, {}}, {{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[0, 0, 1], 
                  PointSize[0.03]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAwA2IQDQF2Dp77chn/rNttD+E7OgS8nphYoLEDzj9478iE
OT674Hweza/Sd3pg6p0dvpQazS6R3Arnm5zi2hC6GKq/wcVh1rlLdq9DtsP5
11mL7Kd9QfCPXzw4v00EZp+rw/+jUqfdp2yH831iOfkTNiHkS7wTp4QZwdzj
5qAYZ/TSK34v1Dw3h7msrz1XMWyByrs7LPDbPeFr4WY4X7J72ebJB3dC+R4O
LI+kXAR6tsL5rlMSFyVJQOUbPBye9RjEhV3dAufbCQQaOyZshfP3rDyzN1Rw
G1S/p0Otk/AW7n8weU+HhniuNfmLNsP5R/unLHzRCbPPy+H9fivjtO0w+7wc
Vpff1Ga23AznT4oODKqcB/O/t8PySYwLuqQ3w/llp/5dubwIFp7eDpW7P/+T
c4CZ7+Pw2C935kJtqPsafBySX8/9dTVsM5wfIVgfx8QIC09fh2OzWTqeOm+C
yvs5JK10r2WbtAHO10vy2REfDrPf30FQd9HuuMqNcP5XL4sK/80w+/wdap5N
3jRDaguc/8thh7LEPYT8Eg3lApn47XD+9vIvMUYXYPEf4LCxb2F2xV2ofocA
B/HDa5ru2UDtcwh0mBJ3hOf4pfVwvpuYfChzM8y9gQ6h3Gb7V+tD9R8IdDjg
LjZ5tRjUfodgh73ClZubtq2H80O67GbrKMDiM8Sh8FLeZWUzqH6FBAfmIzpn
Bayh4XsgzWHLbvFT/qeh4fGgxMH5mye7n9ZWewDM5fm6
                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[1, 0, 0], 
                  PointSize[0.03]], 
                 
                 PointBox[{{30., 0.1081388}, {34., 0.09436705000000001}, {38.,
                   0.08241967}, {45., 0.07813515}, {46., 0.07595763}, {53., 
                  0.07508869}, {54., 0.074639}, {58., 0.07134852}, {61., 
                  0.06472817}, {69., 0.06215498}, {77., 0.06193932}}]}, {}}, {
               
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1081388}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.80\"", 0.800061422670007, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.79\"", 19.789098178446487`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.800061422670007, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    19.789098178446487`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.09436705000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.2792678309107002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.24783345853136146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    36.819424146231384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.10273149999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.6999608711343289, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.1312340565987507, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.94\"", 40.93549296600853, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.6999608711343289, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.1312340565987507, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    40.93549296600853, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1076181}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7147944364841358, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.65\"", 0.654288182502567, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.72\"", 22.718464205230013`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.7147944364841358, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.654288182502567, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.718464205230013`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.08241967}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.62\"", 2.6248961302373313`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.7586070419485609`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1880569366993785`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"54.59\"", 54.5898093120803, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.6248961302373313`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7586070419485609`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.1880569366993785`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    54.5898093120803, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.09624229000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.4172135657118963`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7361891056524232`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.7046357704345062, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    71.48309026794081, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.09113951}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.509520586469478, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.14\"", 9.137578640043257, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.93\"", 31.928368879178368`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.509520586469478, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    9.137578640043257, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    31.928368879178368`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.09357585}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4907970088213184, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.27543008176316136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.88\"", 39.88006338431486, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.33\"", 33.33120471027875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.4907970088213184, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.27543008176316136`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.88006338431486, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    33.33120471027875, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.0940632}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.974280626740573, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7279936611153469, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.40\"", 38.40037845197193, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.90\"", 15.900980311886437`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.974280626740573, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.7279936611153469, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    38.40037845197193, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    15.900980311886437`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.09210633}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.26\"", 0.2613837425403077, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.54\"", 1.537971234251219, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.0955931972692687`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4258501184519454`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.69\"", 33.68638097098219, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.2613837425403077, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.537971234251219, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.0955931972692687`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.4258501184519454`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    33.68638097098219, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.09647179}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.8438575255030141, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    2.527764546077162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.44921156638948345`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.130657927313153, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    94.1141569500062, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.1023306}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.27\"", 3.270545085817316, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9910252284625017, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.95\"", 19.945017770533486`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12855082281585825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.270545085817316, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.9910252284625017, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    19.945017770533486`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.12855082281585825`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{44., 0.1147353}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.90\"", 4.895959016506049, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.319874548432116, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"27.95\"", 27.952871411648076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.92\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.002921998204547513, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.895959016506049, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.319874548432116, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    27.952871411648076`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                    NumberForm[
                    0.002921998204547513, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.07813515}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[-
                    NumberForm[
                    1.7044153746685882`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4351705392786716`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.0054125568516, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    36.22633469690617, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.07595763}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.327285545019054, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4867827577795298`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.004381834899129271, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    0.7387541921476599, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    34.169395285760274`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.10060999999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.96\"", 3.9563497714735996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2190385883610415`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.85\"", 4.854682493293969, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.74\"", 14.739524643215601`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.35\"", 0.3495160177488737, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.9563497714735996`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.2190385883610415`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    4.854682493293969, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    14.739524643215601`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.3495160177488737, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{48., 0.08416845}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.38\"", 2.3815863564696684`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"12.51\"", 12.508533750856664`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.00\"", 28.99814853260185, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.3815863564696684`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    12.508533750856664`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    28.99814853260185, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{48., 0.09802834}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.24\"", 0.23831903616534328`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2517195693311689, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.93\"", 37.930281029104044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.23831903616534328`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.2517195693311689, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    37.930281029104044`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.08138027}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.968456006882272, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.205100037981496, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    23.283052672760757`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    37.98221013200929, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    11.242037793589047`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.08349998}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"7.66\"", 7.6569380414546355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.505929605016708, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9897309759518025, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.1043628156090113`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.25\"", 36.2535293671652, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    7.6569380414546355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.505929605016708, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.9897309759518025, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.1043628156090113`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    36.2535293671652, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.08620201}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.587528111969979, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.26\"", 1.2586266338891074`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1369402766817056`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"62.97\"", 62.96637726250138, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.84\"", 11.843595200345533`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.587528111969979, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.2586266338891074`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.1369402766817056`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    62.96637726250138, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    11.843595200345533`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{50., 0.08590768}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.57\"", 4.574057649334719, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7305744270726424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.401252758898537, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.37\"", 1.3673579371682862`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"73.89\"", 73.88690157002681, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.18102542537128208`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.574057649334719, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.7305744270726424`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.401252758898537, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.3673579371682862`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    73.88690157002681, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.18102542537128208`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{51., 0.07669733000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"38.16\"", 38.156252121582966`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.17\"", 0.1732272614251599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.2097737058116267`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.51\"", 36.51001932860815, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    38.156252121582966`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.1732272614251599, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.2097737058116267`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    36.51001932860815, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{51., 0.08413557}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.42\"", 3.417916493069216, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.46\"", 19.461536685433543`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.00\"", 38.99826876426373, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.08\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.020836393362705503`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    3.417916493069216, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    19.461536685433543`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    38.99826876426373, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.020836393362705503`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{52., 0.1004547}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20030800320363745`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.38803262238392094`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"17.84\"", 17.83820291209179, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.20030800320363745`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.38803262238392094`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    17.83820291209179, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.07508869}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.68\"", 1.6754180078879022`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.609247587273656, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.78\"", 0.775927113305604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.24\"", 39.23882870265161, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.63\"", 1.6278615888052534`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.6754180078879022`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.609247587273656, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.775927113305604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.23882870265161, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    1.6278615888052534`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.09616812}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.2110000873680857`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.17652950625169156`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"20.13\"", 20.130848137845224`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.97\"", 13.969333758913198`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.2110000873680857`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.17652950625169156`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    20.130848137845224`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    13.969333758913198`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.074639}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1791842411156355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.52\"", 1.519769176051439, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.30\"", 0.3035028627497163, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0036606222253982054`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.98\"", 0.9793278669498523, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"35.11\"", 35.11474796976265, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1791842411156355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.519769176051439, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3035028627497163, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.0036606222253982054`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    0.9793278669498523, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    35.11474796976265, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.0923283}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.49\"", 3.492337993454053, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.76\"", 3.755527184219944, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    RowBox[{"1", "/", "4"}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.81\"", 39.80809236848403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.61\"", 33.61140388651015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    3.492337993454053, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    3.755527184219944, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 4] + 
                   NumberForm[
                    39.80809236848403, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    33.61140388651015, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{55., 0.08300966}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.30\"", 2.303392364324776, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.41\"", 13.407042848359572`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.32\"", 32.31619441872326, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.57\"", 24.567759471645402`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.303392364324776, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    13.407042848359572`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    32.31619441872326, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    24.567759471645402`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{56., 0.08660326}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.53\"", 6.525866783132166, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.42\"", 1.4207167103458065`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5291186322409439, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"35.58\"", 35.58406495462135, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.09\"", 11.091704734752817`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    6.525866783132166, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4207167103458065`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.5291186322409439, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    35.58406495462135, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    11.091704734752817`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{57., 0.07554376}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.91\"", 1.9127296793309145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1896624065580257`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.39\"", 9.389652400706387, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11682361543790983`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"20.93\"", 20.934293491768756`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3853069793564571, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.9127296793309145`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.1896624065580257`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    9.389652400706387, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.11682361543790983`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    20.934293491768756`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.3853069793564571, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{57., 0.1015779}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.1753379890946919, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.41\"", 0.4067947020129766, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"6.50\"", 6.502492239855063, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"17.45\"", 17.44724330784225, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.1753379890946919, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.4067947020129766, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    6.502492239855063, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    17.44724330784225, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.07134852}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.17\"", 3.1667002299708544`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.5102067587317884`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.86\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.003857652757967782, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.02\"", 1.019171869624514, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.13\"", 29.129538193148512`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9687887360131929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.1667002299708544`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.5102067587317884`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.003857652757967782, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    1.019171869624514, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    29.129538193148512`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.9687887360131929, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{61., 0.06472817}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4862695093685902, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.31\"", 1.310533166814912, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.77\"", 5.7730732780111325`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.59\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005593773301711825, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.64\"", 24.635059833768167`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.28306158419509087`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.4862695093685902, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.310533166814912, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.7730732780111325`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0005593773301711825, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    24.635059833768167`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.28306158419509087`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{61., 0.07555197}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.29\"", 0.28695855292017847`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.86\"", 0.8566521727596482, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"6.24\"", 6.242452565675829, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"50.80\"", 50.79955005330436, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.90\"", 7.9043365969594515`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.25006311196767467`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.28695855292017847`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.8566521727596482, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    6.242452565675829, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    50.79955005330436, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    7.9043365969594515`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.25006311196767467`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{62., 0.06825821}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.37\"", 4.369453083286095, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.59\"", 1.593800081314036, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.27\"", 0.274372358653739, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.37\"", 4.36920960483673, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.29\"", 0.28954858712821135`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"64.40\"", 64.39662808474061, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.38\"", 0.3768770055185326, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.369453083286095, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.593800081314036, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.274372358653739, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    4.36920960483673, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.28954858712821135`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    64.39662808474061, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.3768770055185326, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{62., 0.08867356}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.4455512215273088, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.68\"", 1.676131391657559, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8382633706204627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.00\"", 37.002174565936166`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.4455512215273088, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.676131391657559, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2])^Rational[1, 2] - 
                   NumberForm[
                    0.8382633706204627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    37.002174565936166`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{63., 0.07853083}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"33.85\"", 33.847412331608595`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.24\"", 0.23774698891049564`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.16\"", 1.1553617097104292`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.37\"", 32.37014571247055, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    33.847412331608595`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.23774698891049564`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.1553617097104292`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    32.37014571247055, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{63., 0.08932639}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.09\"", 1.0859326878632647`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3211162538418365, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.30\"", 1.302680220292556, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.59\"", 19.58632172078479, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.0859326878632647`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.3211162538418365, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.302680220292556, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    19.58632172078479, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{63., 0.09129503}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.17\"", 1.1734863994592848`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.37342278501074166`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.47\"", 1.4672403243917815`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"18.35\"", 18.34909001683993, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1734863994592848`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.37342278501074166`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.4672403243917815`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    18.34909001683993, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{63., 0.09302058}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8375917726083537, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"28.82\"", 28.820780127031053`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.13\"", 8.134137104341335, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.8375917726083537, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    28.820780127031053`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    8.134137104341335, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{64., 0.08150437}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.82\"", 1.8236360153513191`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.51\"", 38.51460289274781, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.03\"", 46.03239429662927, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.19\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.051870364568124154`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.8236360153513191`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    38.51460289274781, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2))^Rational[1, 2] + 
                   NumberForm[
                    46.03239429662927, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.051870364568124154`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{65., 0.06733504}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.2266754241773118, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.48\"", 1.4842821891368936`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.06\"", 4.064660464143793, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"27.78\"", 27.778632225915576`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"7.65\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.07648179301283968, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.2045537742598663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.2266754241773118, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4842821891368936`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    4.064660464143793, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    27.778632225915576`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.07648179301283968, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.2045537742598663, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{69., 0.06215498}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.17\"", 4.171050194201448, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4446344120860954`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.69\"", 5.692187295388681, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.98\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0004980847865635973, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"19.46\"", 19.456327988352626`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.92\"", 22.91674451927204, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.16092649942618553`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.171050194201448, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4446344120860954`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.692187295388681, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0004980847865635973, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    19.456327988352626`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.91674451927204, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.16092649942618553`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{69., 0.0644991}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.96\"", 0.9640583500442382, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.3300179718398595`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12700241684526753`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.97\"", 5.9741026957462, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.25\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005254030501725188, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.80\"", 25.797577683270834`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.27\"", 0.2661759584762838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.9640583500442382, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3300179718398595`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.12700241684526753`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    5.9741026957462, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0005254030501725188, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    25.797577683270834`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.2661759584762838, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{70., 0.0788524}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"39.74\"", 39.7371034729414, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.77\"", 0.7660335266857293, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.72\"", 15.720510079371447`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.88\"", 36.883290113441284`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    39.7371034729414, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.7660335266857293, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    15.720510079371447`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                    NumberForm[
                    36.883290113441284`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{71., 0.08628342}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.32249364844838135`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.38\"", 0.3822158983283785, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.10\"", 21.10223213809954, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"10.91\"", 10.911373945550494`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.32249364844838135`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.3822158983283785, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    21.10223213809954, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    10.911373945550494`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{77., 0.06193932}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1430978051593532`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.38\"", 1.3847484058786608`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.85\"", 5.846653953398393, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.08\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005083811591599984, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"116.69\"", 116.68827828692032`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.74\"", 22.739907623516135`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.26\"", 0.2553735003507182, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1430978051593532`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3847484058786608`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.846653953398393, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0005083811591599984, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    116.68827828692032`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-3) + 
                   NumberForm[
                    22.739907623516135`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.2553735003507182, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{77., 0.08642844}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.17833009762090996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42789708463142984`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.38\"", 1.3844207955598027`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"20.65\"", 20.6497529910493, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.17833009762090996`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.42789708463142984`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.3844207955598027`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    20.6497529910493, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{80., 0.07895111}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.85\"", 2.8492412751875795`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.86\"", 0.8592239420915304, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.18\"", 15.180998816050957`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.73\"", 33.73131222629697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.8492412751875795`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.8592239420915304, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    15.180998816050957`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    33.73131222629697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{129., 0.08293252}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.53\"", 3.5325844310424013`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.76\"", 0.7603765628453577, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"17.30\"", 17.3021666635264, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.37\"", 24.367972953892533`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    3.5325844310424013`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.7603765628453577, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    17.3021666635264, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    24.367972953892533`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2))/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{182., 0.07732104000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"38.04\"", 38.04129262726823, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7425980623237194, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.83\"", 13.825328713406654`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"35.36\"", 35.36474970259603, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}]]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    38.04129262726823, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.7425980623237194, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    13.825328713406654`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                    NumberForm[
                    35.36474970259603, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]/(2 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])))^Rational[-1, 2]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{334., 0.08267677}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"33.14\"", 33.13554732377437, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.91\"", 0.914542176973521, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.94\"", 32.94311125528041, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.01\"", 38.011625062216325`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"2", " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]}], 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], ")"}]}], 
                    RowBox[{
                    RowBox[{
                    SqrtBox["3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    RowBox[{
                    RowBox[{"2", " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}]]]}]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    33.13554732377437, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.914542176973521, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    32.94311125528041, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-1) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]))^Rational[1, 2] + 
                   NumberForm[
                    38.011625062216325`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^(-1) ((2 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2))/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]))/(3^Rational[1, 2] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]/(2 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])))^Rational[-1, 2])), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1081388}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.80\"", 0.800061422670007, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.79\"", 19.789098178446487`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.800061422670007, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    19.789098178446487`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.09436705000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.2792678309107002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.24783345853136146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    36.819424146231384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.08241967}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.62\"", 2.6248961302373313`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.7586070419485609`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1880569366993785`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"54.59\"", 54.5898093120803, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.6248961302373313`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7586070419485609`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.1880569366993785`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    54.5898093120803, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.07813515}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.7044153746685882`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4351705392786716`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.0054125568516, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    36.22633469690617, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.07595763}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.327285545019054, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4867827577795298`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.004381834899129271, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    0.7387541921476599, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    34.169395285760274`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.07508869}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.68\"", 1.6754180078879022`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.609247587273656, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.78\"", 0.775927113305604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.24\"", 39.23882870265161, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.63\"", 1.6278615888052534`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.6754180078879022`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.609247587273656, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.775927113305604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.23882870265161, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    1.6278615888052534`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.074639}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1791842411156355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.52\"", 1.519769176051439, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.30\"", 0.3035028627497163, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0036606222253982054`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.98\"", 0.9793278669498523, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"35.11\"", 35.11474796976265, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1791842411156355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.519769176051439, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3035028627497163, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.0036606222253982054`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    0.9793278669498523, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    35.11474796976265, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.07134852}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.17\"", 3.1667002299708544`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.5102067587317884`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.86\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.003857652757967782, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.02\"", 1.019171869624514, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.13\"", 29.129538193148512`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9687887360131929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.1667002299708544`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.5102067587317884`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.003857652757967782, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    1.019171869624514, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    29.129538193148512`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.9687887360131929, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{61., 0.06472817}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4862695093685902, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.31\"", 1.310533166814912, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.77\"", 5.7730732780111325`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.59\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005593773301711825, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.64\"", 24.635059833768167`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.28306158419509087`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.4862695093685902, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.310533166814912, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.7730732780111325`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0005593773301711825, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    24.635059833768167`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.28306158419509087`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{69., 0.06215498}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.17\"", 4.171050194201448, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4446344120860954`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.69\"", 5.692187295388681, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.98\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0004980847865635973, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"19.46\"", 19.456327988352626`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.92\"", 22.91674451927204, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.16092649942618553`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.171050194201448, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4446344120860954`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.692187295388681, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0004980847865635973, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    19.456327988352626`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.91674451927204, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.16092649942618553`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{77., 0.06193932}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1430978051593532`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.38\"", 1.3847484058786608`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.85\"", 5.846653953398393, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.08\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005083811591599984, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"116.69\"", 116.68827828692032`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.74\"", 22.739907623516135`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.26\"", 0.2553735003507182, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1430978051593532`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3847484058786608`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.846653953398393, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.0005083811591599984, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    116.68827828692032`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-3) + 
                   NumberForm[
                    22.739907623516135`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.2553735003507182, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}}}, {
            ImageSize -> 250, DisplayFunction -> Identity, 
             PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, AxesOrigin -> {5.953125, 0}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, ImagePadding -> All, DisplayFunction -> Identity, 
             AspectRatio -> NCache[
               Rational[3, 5], 0.6], Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {5.953125, 0}, 
             DisplayFunction :> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, 
             FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
             GridLines -> {Automatic, Automatic}, GridLinesStyle -> 
             Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 250, 
             Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}]}}, 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         AutoDelete -> False, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
         BaselinePosition -> Center, FrameStyle -> Directive[
           GrayLevel[0.85]]], "Grid"]}, {
       StyleBox[
       "\"2\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"53 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"17.9\\\\\\\"\\\", \
17.905405405405407`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[4, 1], Rule[ExponentFunction, Automatic], Rule[NumberPadding, \
List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\"", {
        FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}}, 
         GridBoxAlignment -> {"Columns" -> {{Left}}}, DefaultBaseStyle -> 
         "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"], 
       TagBox[
        GridBox[{{
           GraphicsBox[{{{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[
                  0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxV1Xk81VkbAHBaVFJhRJbXkqakxFCGGhyXbMm1L5GtMBoqMiEUmSnpZq+Z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                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  GrayLevel[0.5], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQFqDuJdWpt6Dt+wh/B1HG5Ezpw6ies6lK/n4Kib
eMJ1wjUo38jh19kjJYphJ6B8S4e8e5Mf2Z09CuVbOehvqN2uH7YLwm9wcPht
/2hTagiUz+DoEPB6YmKBxg4o39nhS6nR7BLJrVD1bg5zWV97rmLYApV3d+A5
oeJS6rUZKu/hME8r+neuKJTP4OWQOl9w20vJTVC+t8OXczNn80itgfAdAhwk
Lpb53J26Giof6MDJo754pdJyCP9AkMN2ZilBw1PLoPxgh0/Smw5PaF4K1Z/k
wKjd3674bBFUPtnB6fnvU/93L7IHADflXOU=
                  
                  "]]}, {}}}, {}, {}, {}, {}}, {{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[0, 0, 1], 
                  PointSize[0.03]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAwBWIQDQFWDvobarfrh+2yh/FPv0r/vfDxQTj/830NuT3S
h6F8a4d5OSKLfzgdgvO74hZm+aschfJtHaRfyaz4kXIEyrdzODh1kfe7NJh+
e4ctWhUHtC0Owvk/3STFPL5C5RscHH7bP9qUGrILzi8OqNh/IAlmvqPDMXul
mO3fd8L5XA0feaR+Ifi6PG96vFx3wfl2dad6hPx3w/nhBg+kfxYh+P73ciRW
se+H8//67M0TlIDyG5wchHrusVi92wnnL89MTEiHuY/B2UHo/6uAi43b4Xzd
6tyJ/Fd3wvlK39Y9W8qOUC+Xmumjy7APap6zw7z0RfukD+6B8xep/aqZIrgX
qt7F4S278uT7T7ZB5V0c2o/l/eK7uRPO/7VjIu9/l11wvnPgAv8nngg+Sngy
uDr8sr119pjmDjjf+Ok8zhWnd8L5jY9y7nvAw8/NwU3x5Jp7D2HudXNYuv9T
9bftO+H80zetF6/1gql3dxCLm1xfbrMVzv999dKkWjcEX2S/Zd/Tup1w/tO1
8aFJzgj9LWGFX5y8YXwPB0Vdp/yfiTD1ng45Mc3PizW2QO33dLigeeK827pt
cP5kvUWT7rvD9Hs7FE9wkvct3ATnn1FOm+x/Eaqfwddh4hr/aqdYqHyDn4P6
1fQ5B4Jh9vk7aN2YcPKzFiw8/R32zfX5elwDKu8Q7CDz0m9F36dt9gBiOPqE

                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[1, 0, 0], 
                  PointSize[0.03]], 
                 
                 PointBox[{{26., 0.1028776}, {33., 0.10285029999999999`}, {
                  34., 0.1014361}, {37., 0.1012913}, {38., 0.09182461}, {40., 
                  0.08942983}, {46., 0.0829539}, {50., 0.07874226000000001}, {
                  54., 0.07204134}, {58., 0.07173553}}]}, {}}, {
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1028776}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5972434214759587, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.135346220113384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1397593}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.11263818940082906`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.48\"", 1.4817333950435745`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"50.00\"", 49.99948499944974, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.11263818940082906`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4817333950435745`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    49.99948499944974, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1492839}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.89\"", 1.8877579499714372`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.11\"", 1.1141498521526363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"61.80\"", 61.79788023563619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.8877579499714372`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.1141498521526363`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    61.79788023563619, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{27., 0.14266879999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.47\"", 3.4733768128077096`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.29\"", 2.2947176471822623`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7390571409205557`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"69.87\"", 69.87005969257898, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    3.4733768128077096`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    2.2947176471822623`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.7390571409205557`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    69.87005969257898, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{27., 0.1651706}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"12.78\"", 12.78294649513016, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.81\"", 1.808660756198177, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.89\"", 1.8870406144298306`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5279812363075969, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    12.78294649513016, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.808660756198177, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.8870406144298306`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.5279812363075969, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{29., 0.15933139999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.80\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.113808720357664, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    68.58401194252002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.037977703625019794`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.15157869999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.70\"", 3.701310916637267, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.12494529027972003`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"62.05\"", 62.047111180947645`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.701310916637267, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.12494529027972003`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    62.047111180947645`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{31., 0.1345267}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.35\"", 7.346577942384855, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4900078078905312`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.51\"", 8.511572782690058, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.65\"", 0.6478243898384884, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    7.346577942384855, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4900078078905312`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    8.511572782690058, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                   NumberForm[
                    0.6478243898384884, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{31., 0.1559229}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.65\"", 19.647397022440057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.94\"", 1.9376445174038723`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.88\"", 1.8781078831523041`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.07\"", 4.065868403752875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    19.647397022440057`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9376445174038723`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.8781078831523041`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    4.065868403752875, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.10285029999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.55\"", 0.5541585846053176, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.52\"", 40.517482091573655`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.6601111251628, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5541585846053176, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    40.517482091573655`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.6601111251628, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.16707619999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.16\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.051580114275771215`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.87\"", 0.8699842403421914, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.09\"", 33.0913772376397, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.051580114275771215`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.8699842403421914, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    33.0913772376397, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1014361}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34193365474032633`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.1634125138335718, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.63\"", 39.632976405655924`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.34193365474032633`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.1634125138335718, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.632976405655924`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1014725}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7737971007854787`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.72\"", 1.7170648977776652`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"38.57\"", 38.568963917616095`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"49.75\"", 49.74902719138321, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.7737971007854787`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7170648977776652`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    38.568963917616095`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    49.74902719138321, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1026198}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15\"", 0.14716972250701452`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.32\"", 41.31831456916278, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.78\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017757842334691583`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.14716972250701452`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.31831456916278, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.017757842334691583`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1066753}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.52\"", 7.522722918376416, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7323486222041777`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.72\"", 46.72326912590955, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.30\"", 0.30367783575558216`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    7.522722918376416, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7323486222041777`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    46.72326912590955, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.30367783575558216`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1072231}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7001000647386643, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.41\"", 2.4116164871779526`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7089224305540724`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"97.43\"", 97.42865136137979, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.7001000647386643, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    2.4116164871779526`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.7089224305540724`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    97.42865136137979, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.12121069999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.42\"", 0.4239544358569544, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7287797654294157`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7318493630662637, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"60.73\"", 60.732262299445466`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.4239544358569544, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7287797654294157`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.7318493630662637, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    60.732262299445466`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.121461}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.69\"", 3.687045513169484, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6665245757735663`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.02\"", 46.01872375913119, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15\"", 0.1510087764196619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.687045513169484, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6665245757735663`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    46.01872375913119, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.1510087764196619, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{37., 0.1012913}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"8.80\"", 8.7972880237627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.55\"", 41.554635399336284`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    8.7972880237627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.554635399336284`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{37., 0.1028504}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.56\"", 0.562094266253516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.47\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.006467079430521311, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.50\"", 41.496680215114196`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.562094266253516, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                    NumberForm[
                    0.006467079430521311, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    41.496680215114196`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.09182461}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.32\"", 3.3161211098694103`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.64\"", 7.640079808526499, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.60\"", 40.59802745639896, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.4331737532023043, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.3161211098694103`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    7.640079808526499, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    40.59802745639896, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.4331737532023043, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.10090729999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2846834920032194, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.68\"", 0.6849160887725014, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.53\"", 39.53433067245735, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.2846834920032194, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.6849160887725014, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    39.53433067245735, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.1016792}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5056525266429981, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.6158725575337699, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                   NumberForm[
                    38.90598516721604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.1171902}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.455130666388669, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.64\"", 1.639476437808372, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.93\"", 46.93014069688936, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"7.99\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.00798733238757964, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    5.455130666388669, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.639476437808372, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    46.93014069688936, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.00798733238757964, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^2, 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{39., 0.1123216}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.56\"", 0.5609723918235984, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.3296515545605452`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.98\"", 39.97824305988735, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5609723918235984, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3296515545605452`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.97824305988735, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{39., 0.1135495}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"39.36\"", 39.36273566747982, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.02\"", 40.02278070069497, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox["1", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    39.36273566747982, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    40.02278070069497, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-1) + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{40., 0.08942983}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.65\"", 6.654151143496604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.17\"", 36.167997834187815`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.47\"", 39.46835412703028, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    6.654151143496604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    36.167997834187815`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    39.46835412703028, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.1009683}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.46\"", 0.4561433248499897, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.2323785753612857, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"42.18\"", 42.18196598969191, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.30\"", 36.29549509408725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.4561433248499897, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.2323785753612857, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    42.18196598969191, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    36.29549509408725, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.10261529999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.14122659815171057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.06\"", 41.05805495874132, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.53\"", 41.53043546947574, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.73\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017289553434700258`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.14122659815171057`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.05805495874132, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.53043546947574, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.017289553434700258`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.10268999999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.54\"", 0.5357906739710565, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11559224527540383`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.55\"", 38.547275015336425`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.56\"", 41.56113749958525, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5357906739710565, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.11559224527540383`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    38.547275015336425`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.56113749958525, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.10285029999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.55\"", 0.5541585846053246, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1426290335891378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.66011112516278, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5541585846053246, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.1426290335891378`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.66011112516278, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.09438746}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.80\"", 4.804997787358584, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.55\"", 1.5515334548896909`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.90\"", 1.9006717189578692`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"74.87\"", 74.87297061060097, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.19839309481075026`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.804997787358584, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.5515334548896909`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.9006717189578692`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    74.87297061060097, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.19839309481075026`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.1007638}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.35\"", 1.3549222717633242`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3214412937174662, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.67\"", 37.66792160105517, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.97\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04970935950067351, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.3549222717633242`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.3214412937174662, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    37.66792160105517, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.04970935950067351, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.1026197}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.14356620035591044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.61\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0016122392755023877`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.33\"", 41.33285041838605, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.79\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017871299972486904`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.14356620035591044`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.0016122392755023877`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    41.33285041838605, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.017871299972486904`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{44., 0.12063399999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.00\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08996339524355666, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4851357198533663`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"48.27\"", 48.2721529534372, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.08996339524355666, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4851357198533663`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    48.2721529534372, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.10046329999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.3374395436350541, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.88\"", 0.8841542521009678, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.99\"", 41.99110394620097, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.59\"", 36.58646456859302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.3374395436350541, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.8841542521009678, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    41.99110394620097, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    36.58646456859302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.102702}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.20\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06196779934807173, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.88\"", 40.88089182228566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.57\"", 41.57498146216827, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10209533904171754`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.06196779934807173, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    40.88089182228566, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.57498146216827, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.10209533904171754`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.0829539}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    7.049735524240697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    4.947790998755661, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.32760617817725146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    37.27833291350976, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.5129035402029928, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.08310685}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7384792522568443, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.29\"", 1.285264518386828, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.12\"", 8.123213701923364, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"64.04\"", 64.04375676779595, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.35\"", 0.34804145725483043`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.7384792522568443, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.285264518386828, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    8.123213701923364, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    64.04375676779595, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.34804145725483043`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.09959254000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.35\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.023487159880212206`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.05\"", 2.048176434710453, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7001756227823914, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.53\"", 39.5263239576966, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.023487159880212206`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    2.048176434710453, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] - 
                   NumberForm[
                    0.7001756227823914, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    39.5263239576966, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.10259069999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.54\"", 0.5408329965786647, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"12.64\"", 12.64415348680826, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.62\"", 41.615927441944216`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5408329965786647, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                    NumberForm[
                    12.64415348680826, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2) + 
                   NumberForm[
                    41.615927441944216`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.1027109}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.42\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09416528563617034, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.008375030356284304, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.19\"", 41.18624424547026, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10164527553265464`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.09416528563617034, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.008375030356284304, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    41.18624424547026, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.10164527553265464`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{48., 0.09915122}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.59\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.025888401239006285`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"43.23\"", 43.22967265776525, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"60.46\"", 60.462958755976516`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.025888401239006285`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    43.22967265776525, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    60.462958755976516`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/(Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{50., 0.07874226000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.33\"", 13.332881571990963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.89\"", 4.891023200202385, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3203281568193796, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.02\"", 39.01666051421709, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.84\"", 3.8425977098849375`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    13.332881571990963`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    4.891023200202385, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3203281568193796, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    39.01666051421709, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    3.8425977098849375`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{51., 0.08859675}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.24\"", 6.243554728436393, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.63\"", 33.63043920857394, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.08\"", 41.07689177167747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.13\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005127556182505385, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    6.243554728436393, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    33.63043920857394, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.07689177167747, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.005127556182505385, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{51., 0.10265919999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7108357067844768, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.07\"", 41.06637413039861, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"2.70\"", 2.698214167359468, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.7108357067844768, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.06637413039861, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    2.698214167359468, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/(Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.07204134}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.50\"", 4.499847977031774, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.46\"", 1.4634281161182365`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.01\"", 5.014719987621032, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3182494724130434, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"64.10\"", 64.09928143333231, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.41\"", 0.40762183517129075`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.499847977031774, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.4634281161182365`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.014719987621032, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3182494724130434, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    64.09928143333231, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.40762183517129075`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.08131883000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.60\"", 1.6025608071539752`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.08\"", 1.080844410303587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"12.77\"", 12.768770835031061`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.15\"", 1.1455468155000321`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"57.82\"", 57.81529869530676, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42635186270775766`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.6025608071539752`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.080844410303587, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    12.768770835031061`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                   NumberForm[
                    1.1455468155000321`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    57.81529869530676, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.42635186270775766`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.07173553}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.90\"", 9.901680008227654, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2245131981324286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.87\"", 4.873817000770366, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.31\"", 0.3064788953886152, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"61.62\"", 61.61501435592084, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.105511484032275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    9.901680008227654, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.2245131981324286`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    4.873817000770366, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3064788953886152, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    61.61501435592084, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    3.105511484032275, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{61., 0.09893421000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"9.19\"", 9.185638248572948, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.44\"", 40.43694823231722, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox["1", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"7.04\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.007038681156781916, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    9.185638248572948, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    40.43694823231722, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-1))/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                    NumberForm[
                    0.007038681156781916, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{62., 0.1022179}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.48\"", 0.4780019926175835, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.12143735673113137`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"10.91\"", 10.911831774278841`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"43.07\"", 43.07063919288189, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.4780019926175835, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.12143735673113137`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    10.911831774278841`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2) + 
                   NumberForm[
                    43.07063919288189, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{63., 0.09827852000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"7.02\"", 7.015545716579693, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.44\"", 34.44463597885299, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.24\"", 13.242292636430701`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.98\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005979687163553947, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    7.015545716579693, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    34.44463597885299, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    13.242292636430701`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.005979687163553947, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{77., 0.08963863}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"5.16\"", 5.161461940675795, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.10\"", 24.1002303449374, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox["3", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"45.92\"", 45.92057057160447, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.53\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.025260681245778564`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    5.161461940675795, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    24.1002303449374, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    45.92057057160447, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.025260681245778564`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1028776}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5972434214759587, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.135346220113384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.10285029999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.55\"", 0.5541585846053176, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.52\"", 40.517482091573655`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.6601111251628, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5541585846053176, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    40.517482091573655`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    41.6601111251628, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.1014361}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34193365474032633`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.1634125138335718, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.63\"", 39.632976405655924`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.34193365474032633`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.1634125138335718, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    39.632976405655924`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{37., 0.1012913}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"8.80\"", 8.7972880237627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.55\"", 41.554635399336284`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    8.7972880237627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    41.554635399336284`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{38., 0.09182461}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.32\"", 3.3161211098694103`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.64\"", 7.640079808526499, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.60\"", 40.59802745639896, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.4331737532023043, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.3161211098694103`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    7.640079808526499, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    40.59802745639896, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.4331737532023043, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{40., 0.08942983}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.65\"", 6.654151143496604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.17\"", 36.167997834187815`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.47\"", 39.46835412703028, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    6.654151143496604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    36.167997834187815`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    39.46835412703028, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.0829539}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    7.049735524240697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    4.947790998755661, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.32760617817725146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    37.27833291350976, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.5129035402029928, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{50., 0.07874226000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.33\"", 13.332881571990963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.89\"", 4.891023200202385, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3203281568193796, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.02\"", 39.01666051421709, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.84\"", 3.8425977098849375`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    13.332881571990963`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    4.891023200202385, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3203281568193796, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    39.01666051421709, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    3.8425977098849375`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.07204134}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.50\"", 4.499847977031774, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.46\"", 1.4634281161182365`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.01\"", 5.014719987621032, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3182494724130434, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"64.10\"", 64.09928143333231, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.41\"", 0.40762183517129075`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.499847977031774, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.4634281161182365`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.014719987621032, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3182494724130434, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    64.09928143333231, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.40762183517129075`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.07173553}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.90\"", 9.901680008227654, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2245131981324286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.87\"", 4.873817000770366, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.31\"", 0.3064788953886152, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"61.62\"", 61.61501435592084, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.105511484032275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    9.901680008227654, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.2245131981324286`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    4.873817000770366, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.3064788953886152, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                   NumberForm[
                    61.61501435592084, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    3.105511484032275, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}}}, {
            ImageSize -> 250, DisplayFunction -> Identity, 
             PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, AxesOrigin -> {5.953125, 0}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, ImagePadding -> All, DisplayFunction -> Identity, 
             AspectRatio -> NCache[
               Rational[3, 5], 0.6], Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {5.953125, 0}, 
             DisplayFunction :> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, 
             FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
             GridLines -> {Automatic, Automatic}, GridLinesStyle -> 
             Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 250, 
             Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}]}}, 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         AutoDelete -> False, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
         BaselinePosition -> Center, FrameStyle -> Directive[
           GrayLevel[0.85]]], "Grid"]}, {
       StyleBox[
       "\"3\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"28 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"9.5\\\\\\\"\\\", \
9.45945945945946`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[4, 1], Rule[ExponentFunction, Automatic], Rule[NumberPadding, \
List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\"", {
        FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}}, 
         GridBoxAlignment -> {"Columns" -> {{Left}}}, DefaultBaseStyle -> 
         "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"], 
       TagBox[
        GridBox[{{
           GraphicsBox[{{{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[
                  0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxV1Xk81VkbAHBaVFJhRJbXkqakxFCGGhyXbMm1L5GtMBoqMiEUmSnpZq+Z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                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  GrayLevel[0.5], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQFqDuJdWpt6Dt+wh/B1HG5Ezpw6ies6lK/n4Kib
eMJ1wjUo38jh19kjJYphJ6B8S4e8e5Mf2Z09CuVbOehvqN2uH7YLwm9wcPht
/2hTagiUz+DoEPB6YmKBxg4o39nhS6nR7BLJrVD1bg5zWV97rmLYApV3d+A5
oeJS6rUZKu/hME8r+neuKJTP4OWQOl9w20vJTVC+t8OXczNn80itgfAdAhwk
Lpb53J26Giof6MDJo754pdJyCP9AkMN2ZilBw1PLoPxgh0/Smw5PaF4K1Z/k
wKjd3674bBFUPtnB6fnvU/93L7IHADflXOU=
                  
                  "]]}, {}}}, {}, {}, {}, {}}, {{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[0, 0, 1], 
                  PointSize[0.03]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQDQGuDjv2RU5RXrfTHsxtcHOoeS4/zcB9B4TP4O7A
c0LFpdRrM1Tew2GeVvTvXFEE/9DaryomRdugfC+H5i+3enet3QTV7+3w5dzM
2TxSa6B8X4fCnZ8cGNO3wPkCGw8e8py1Farf12HeyvvzvKo2QOX9HLoXJu09
+2kjnJ/0bL3f3ASo+Q1+DrmCRxd9jIXKOwQ4SFws87k7dTWcb+bwNH/tHph5
gQ6cPOqLVyoth8oHOvBNSJj4RwSqvyHQYbvp9hpm8VVQ9UEO7/qrH1tOXQ9V
H+SQfdji1TpeqPkHghy2M0sJGp5aBlUf7JC57WHa8qtQ/QeCHT5Jbzo8oXkp
VD7U4RvHzmq/LTD1sQ73N0nVToqBhqdDkgOjdn+74rNFUP3JDk7Pf5/6vxvB
dzOK0O97vMgeAID8iKk=
                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[1, 0, 0], 
                  PointSize[0.03]], 
                 
                 PointBox[{{42., 0.1003134}, {45., 0.09483627}, {46., 
                  0.07535489000000001}, {49., 0.07454574}, {53., 
                  0.07296339}, {54., 0.05488624}, {65., 0.05387775}, {68., 
                  0.045186330000000004`}, {75., 0.04451135}, {79., 
                  0.042019390000000004`}, {146., 0.03691201}, {158., 
                  0.03659057}}]}, {}}, {
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.1003134}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.03\"", 4.0340757366395215`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.65\"", 1.6497530669259788`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6916151024476624, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4863301602932236, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.53\"", 22.525643869122245`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.0340757366395215`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6497530669259788`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.6916151024476624, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.4863301602932236, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.525643869122245`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.09483627}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.73\"", 5.731009008032428, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.6981071258602871`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.04\"", 1.040220066640162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.10523566074613683`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.07\"", 21.072689855621764`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    5.731009008032428, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6981071258602871`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.040220066640162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    0.10523566074613683`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    21.072689855621764`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.07535489000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.844906569833192, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9331671585071581`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3694162958661281, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.2449582851700662`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    51.04087439182302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.07454574}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.1346046653275597`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.5661079421576403, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.9736432501341529, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    41.463770769155424`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    14.128156845155987`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.08768011}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6700752445202611`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.6128394340247934`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6853465073594838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.324592179540275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.46\"", 25.461775420180842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.6700752445202611`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6128394340247934`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.6853465073594838, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.324592179540275, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    25.461775420180842`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.07296339}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20314314873607078`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6244921498077787, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.66\"", 3.662196691386353, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.90\"", 40.898576346226065`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.82\"", 14.816199514213286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.20314314873607078`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.6244921498077787, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    3.662196691386353, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    40.898576346226065`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    14.816199514213286`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.05488624}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.27\"", 1.265719881683939, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7692395722395753`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.13\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0041311005358574395`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.61\"", 0.6115892683572458, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.89\"", 0.885069789107805, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.81\"", 31.811547380786145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.265719881683939, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7692395722395753`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.0041311005358574395`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 - 
                   NumberForm[
                    0.6115892683572458, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.885069789107805, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    31.811547380786145`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.07969673000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.97\"", 1.9729664096584907`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7433223534124929`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.92\"", 0.9176507142405912, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5074875102678369, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3211001964463878`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.42\"", 31.424458209434672`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.023813505117294666`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.9729664096584907`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7433223534124929`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.9176507142405912, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.5074875102678369, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.3211001964463878`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    31.424458209434672`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.023813505117294666`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.0843855}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.94\"", 0.939376363630239, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.95\"", 0.9472642018669709, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.46\"", 0.4563181285651866, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"2.51\"", 2.5085941954643554`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.2079598998861962`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"37.33\"", 37.328140971465594`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"59.78\"", 59.77994228823977, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.939376363630239, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.9472642018669709, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.4563181285651866, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    2.5085941954643554`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.2079598998861962`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    37.328140971465594`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    59.77994228823977, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{59., 0.06436602}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.99\"", 1.9911960372671988`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0122098532584647`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.15711019488154507`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.89\"", 15.885776626153888`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.70\"", 39.70116754284203, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.9911960372671988`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.0122098532584647`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    0.15711019488154507`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    15.885776626153888`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    39.70116754284203, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{60., 0.07011114}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.08\"", 2.076010564838923, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.3969009436459829, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.4255273884406343, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"43.32\"", 43.31738956336126, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"20.82\"", 20.822682215628916`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.72\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.047201214208275236`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.076010564838923, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.3969009436459829, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.4255273884406343, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    43.31738956336126, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    20.822682215628916`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.047201214208275236`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{60., 0.07178672}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.28\"", 4.283666323141551, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.15\"", 1.146541525775333, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.15889737089531714`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"43.71\"", 43.712879212749876`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.32\"", 14.315921560372054`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.55\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08551727552295021, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.283666323141551, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.146541525775333, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    0.15889737089531714`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    43.712879212749876`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    14.315921560372054`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.08551727552295021, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{61., 0.06783972}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6689095958046123`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.48\"", 0.4844500767047143, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.23\"", 5.232759941103382, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.85\"", 37.84809944410268, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"10.94\"", 10.941200476157212`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.17\"", 0.17072983932883973`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.6689095958046123`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.4844500767047143, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.232759941103382, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    37.84809944410268, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    10.941200476157212`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.17072983932883973`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{65., 0.05387775}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.77\"", 0.7740455332970302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.83\"", 1.831315089051493, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6308271103915639, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.68\"", 2.6803741043783083`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.71\"", 32.71041393693684, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.37\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08368324334499018, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.7740455332970302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.831315089051493, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.6308271103915639, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    2.6803741043783083`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    32.71041393693684, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.08368324334499018, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{65., 0.06537899}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.34\"", 1.3409161237368847`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.42\"", 1.4215954793111478`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.48\"", 0.47576171931708944`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.69\"", 8.694539766367576, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.11198893387720997`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.20\"", 22.20451748959845, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.28371813063387175`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.3409161237368847`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4215954793111478`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.47576171931708944`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    8.694539766367576, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - (
                    NumberForm[
                    0.11198893387720997`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.20451748959845, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.28371813063387175`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{68., 0.045186330000000004`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.00\"", 3.0030735095811236`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7748114526147136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.07\"", 1.068558042408596, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.45068001536080515`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.75\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0006754717128026783, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12877589444763254`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.99\"", 29.992020836968734`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.0030735095811236`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7748114526147136`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.068558042408596, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.45068001536080515`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - (
                    NumberForm[
                    0.0006754717128026783, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.12877589444763254`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    29.992020836968734`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{69., 0.06672648}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8370326614279553, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.50\"", 0.5037125299159624, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.4451101903791155, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.68\"", 5.67605570046591, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"47.44\"", 47.4445540239365, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.78\"", 9.783997114738636, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.1629732598842357, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.8370326614279553, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.5037125299159624, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.4451101903791155, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.67605570046591, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    47.4445540239365, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    9.783997114738636, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.1629732598842357, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{70., 0.05095683}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.25461958449910993`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.75\"", 1.749632049163452, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.62\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0002620902423656974, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "4"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6260793012499333, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.21\"", 3.212215922167721, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.34\"", 29.339710425780346`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.29\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06285049913631523, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.25461958449910993`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.749632049163452, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.0002620902423656974, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^4 - 
                   NumberForm[
                    0.6260793012499333, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    3.212215922167721, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    29.339710425780346`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.06285049913631523, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{72., 0.06168538}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.75\"", 0.750216374224373, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.54\"", 1.536319396880792, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.3998640467043184, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.21\"", 8.210428753867035, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.06\"", 25.064930708229426`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.78\"", 2.779652641815286, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3186481272717307, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.750216374224373, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.536319396880792, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3998640467043184, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    8.210428753867035, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    25.064930708229426`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - (
                    NumberForm[
                    2.779652641815286, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.3186481272717307, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{73., 0.05283877}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.39\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.023872421906787483`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7685902213529892`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5677104009040314, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.43\"", 3.432346276651955, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"30.04\"", 30.042732101348324`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"7.91\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.07907713284595196, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.02\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.0801795220043345, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.023872421906787483`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7685902213529892`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.5677104009040314, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    3.432346276651955, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    30.042732101348324`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.07907713284595196, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.0801795220043345, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{75., 0.04451135}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.30\"", 1.3005524764676786`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.34\"", 1.3404943403945884`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.11\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005107239670135105, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.21\"", 0.21243058013783078`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.23\"", 41.22676745117566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.10\"", 24.10212755731563, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.17\"", 0.1673161181950697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.3005524764676786`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.3404943403945884`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0005107239670135105, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.21243058013783078`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    41.22676745117566, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    24.10212755731563, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.1673161181950697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{76., 0.0524113}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.33408939136517146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.95\"", 1.9520640528239452`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.12\"", 1.118734581016635, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.14091548355800226`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.54\"", 38.543070845709074`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.60\"", 1.603645871316251, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8350765163894631, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.33408939136517146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9520640528239452`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.118734581016635, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    0.14091548355800226`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    38.543070845709074`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    1.603645871316251, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.8350765163894631, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{79., 0.042019390000000004`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.18\"", 2.1799678487354632`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.44\"", 2.444211508695685, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.25\"", 1.247517961563627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.19\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005191623613028871, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.18047952464725842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.31\"", 40.31019460627466, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.70\"", 15.696735714881733`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.1799678487354632`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    2.444211508695685, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                   NumberForm[
                    1.247517961563627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0005191623613028871, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.18047952464725842`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    40.31019460627466, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    15.696735714881733`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{84., 0.04434438}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.99\"", 1.9858112367859027`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.78\"", 0.7833847208106663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.10\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005095227470766554, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08659933584203565, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0102097403015682`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.81\"", 37.80829883378698, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.53\"", 21.52514081689174, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.9858112367859027`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.7833847208106663, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0005095227470766554, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.08659933584203565, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    1.0102097403015682`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2)^Rational[1, 2] + 
                   NumberForm[
                    37.80829883378698, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    21.52514081689174, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{116., 0.07563129}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.32\"", 4.318536687065079, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"28.36\"", 28.357744312779918`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"13.45\"", 13.450950907896152`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.14\"", 29.141528950250038`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.318536687065079, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    28.357744312779918`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    13.450950907896152`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                    NumberForm[
                    29.141528950250038`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/(Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{146., 0.03691201}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.18\"", 4.177455269502173, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.02\"", 1.0182139511182582`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.18\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0011817474099172682`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11946486003125685`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.13784178743690126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{"1", "+", 
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.92\"", 41.92131869102695, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"16.15\"", 16.15409092578409, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.177455269502173, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.0182139511182582`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0011817474099172682`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.11946486003125685`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    0.13784178743690126`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (1 + 
                    Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.92131869102695, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    16.15409092578409, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{158., 0.03659057}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.14\"", 4.144869682226397, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.005937025142562, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.19\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.001191287051429883, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11687321149478715`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.1392597646150832, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.93\"", 41.925090462591044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"16.23\"", 16.23403268371322, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.144869682226397, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.005937025142562, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.001191287051429883, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.11687321149478715`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    0.1392597646150832, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.925090462591044`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    16.23403268371322, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{158., 0.03689236}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.20\"", 4.19960153642915, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.02\"", 1.0198011573856278`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.18\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0011794918042244858`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11956518226863402`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.1374989892864598, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.91\"", 41.910898430163776`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"16.15\"", 16.14653704012348, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.19960153642915, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.0198011573856278`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0011794918042244858`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.11956518226863402`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    0.1374989892864598, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.910898430163776`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    16.14653704012348, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{42., 0.1003134}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.03\"", 4.0340757366395215`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.65\"", 1.6497530669259788`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6916151024476624, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4863301602932236, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.53\"", 22.525643869122245`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.0340757366395215`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6497530669259788`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.6916151024476624, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.4863301602932236, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    22.525643869122245`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{45., 0.09483627}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.73\"", 5.731009008032428, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.6981071258602871`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.04\"", 1.040220066640162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.10523566074613683`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.07\"", 21.072689855621764`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    5.731009008032428, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.6981071258602871`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.040220066640162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    0.10523566074613683`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    21.072689855621764`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.07535489000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.844906569833192, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9331671585071581`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3694162958661281, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.2449582851700662`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    51.04087439182302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{49., 0.07454574}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.1346046653275597`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.5661079421576403, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.9736432501341529, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    41.463770769155424`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    14.128156845155987`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.07296339}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20314314873607078`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6244921498077787, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.66\"", 3.662196691386353, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.90\"", 40.898576346226065`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.82\"", 14.816199514213286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.20314314873607078`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    0.6244921498077787, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    3.662196691386353, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    40.898576346226065`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    14.816199514213286`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{54., 0.05488624}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.27\"", 1.265719881683939, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7692395722395753`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.13\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0041311005358574395`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.61\"", 0.6115892683572458, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.89\"", 0.885069789107805, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.81\"", 31.811547380786145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.265719881683939, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7692395722395753`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.0041311005358574395`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 - 
                   NumberForm[
                    0.6115892683572458, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.885069789107805, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    31.811547380786145`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{65., 0.05387775}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.77\"", 0.7740455332970302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.83\"", 1.831315089051493, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6308271103915639, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.68\"", 2.6803741043783083`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.71\"", 32.71041393693684, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.37\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08368324334499018, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.7740455332970302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.831315089051493, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.6308271103915639, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    2.6803741043783083`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
                   NumberForm[
                    32.71041393693684, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.08368324334499018, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{68., 0.045186330000000004`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.00\"", 3.0030735095811236`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7748114526147136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.07\"", 1.068558042408596, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.45068001536080515`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.75\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0006754717128026783, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12877589444763254`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.99\"", 29.992020836968734`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    3.0030735095811236`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7748114526147136`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    1.068558042408596, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.45068001536080515`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - (
                    NumberForm[
                    0.0006754717128026783, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.12877589444763254`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    29.992020836968734`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{75., 0.04451135}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.30\"", 1.3005524764676786`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.34\"", 1.3404943403945884`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.11\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005107239670135105, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.21\"", 0.21243058013783078`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.23\"", 41.22676745117566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.10\"", 24.10212755731563, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.17\"", 0.1673161181950697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.3005524764676786`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.3404943403945884`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0005107239670135105, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.21243058013783078`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    41.22676745117566, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    24.10212755731563, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.1673161181950697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{79., 0.042019390000000004`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.18\"", 2.1799678487354632`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.44\"", 2.444211508695685, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.25\"", 1.247517961563627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.19\"", "\[Times]", 
                    SuperscriptBox["10", "\"-4\""]}], 0.0005191623613028871, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.18047952464725842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.31\"", 40.31019460627466, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.70\"", 15.696735714881733`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.1799678487354632`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    2.444211508695685, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                   NumberForm[
                    1.247517961563627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0005191623613028871, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.18047952464725842`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    40.31019460627466, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    15.696735714881733`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{146., 0.03691201}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.18\"", 4.177455269502173, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.02\"", 1.0182139511182582`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.18\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0011817474099172682`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11946486003125685`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.13784178743690126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{"1", "+", 
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.92\"", 41.92131869102695, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"16.15\"", 16.15409092578409, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.177455269502173, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.0182139511182582`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.0011817474099172682`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.11946486003125685`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    0.13784178743690126`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (1 + 
                    Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.92131869102695, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    16.15409092578409, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{158., 0.03659057}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.14\"", 4.144869682226397, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.005937025142562, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.19\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.001191287051429883, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11687321149478715`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.14\"", 0.1392597646150832, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    RowBox[{
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.93\"", 41.925090462591044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"16.23\"", 16.23403268371322, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    4.144869682226397, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.005937025142562, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] - (
                    NumberForm[
                    0.001191287051429883, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    0.11687321149478715`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    0.1392597646150832, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    41.925090462591044`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    16.23403268371322, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}}}, {
            ImageSize -> 250, DisplayFunction -> Identity, 
             PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, AxesOrigin -> {5.953125, 0}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, ImagePadding -> All, DisplayFunction -> Identity, 
             AspectRatio -> NCache[
               Rational[3, 5], 0.6], Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {5.953125, 0}, 
             DisplayFunction :> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, 
             FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
             GridLines -> {Automatic, Automatic}, GridLinesStyle -> 
             Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 250, 
             Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}]}}, 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         AutoDelete -> False, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
         BaselinePosition -> Center, FrameStyle -> Directive[
           GrayLevel[0.85]]], "Grid"]}, {
       StyleBox[
       "\"4\"", {
        FontWeight -> "Bold", FontFamily -> "Helvetica", FontSize -> 10, 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       StyleBox[
       "\"22 \[DoubleLongRightArrow] \
\\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\\\\\\\"7.4\\\\\\\"\\\", \
7.4324324324324325`, Rule[AutoDelete, True]], Function[NumberForm[Slot[1], \
List[4, 1], Rule[ExponentFunction, Automatic], Rule[NumberPadding, \
List[\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) %\"", {
        FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False], 
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\)\"", {
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
             FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
             None, ShowStringCharacters -> False}, StripOnInput -> False]}}, 
         GridBoxAlignment -> {"Columns" -> {{Left}}}, DefaultBaseStyle -> 
         "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"], 
       TagBox[
        GridBox[{{
           GraphicsBox[{{{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[
                  0.6666666666666666, 0.6666666666666666, 0.6666666666666666], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxV1Xk81VkbAHBaVFJhRJbXkqakxFCGGhyXbMm1L5GtMBoqMiEUmSnpZq+Z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                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  GrayLevel[0.5], 
                  PointSize[0.02]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQFqDuJdWpt6Dt+wh/B1HG5Ezpw6ies6lK/n4Kib
eMJ1wjUo38jh19kjJYphJ6B8S4e8e5Mf2Z09CuVbOehvqN2uH7YLwm9wcPht
/2hTagiUz+DoEPB6YmKBxg4o39nhS6nR7BLJrVD1bg5zWV97rmLYApV3d+A5
oeJS6rUZKu/hME8r+neuKJTP4OWQOl9w20vJTVC+t8OXczNn80itgfAdAhwk
Lpb53J26Giof6MDJo754pdJyCP9AkMN2ZilBw1PLoPxgh0/Smw5PaF4K1Z/k
wKjd3674bBFUPtnB6fnvU/93L7IHADflXOU=
                  
                  "]]}, {}}}, {}, {}, {}, {}}, {{}, {{{}, {
                 Hue[0.67, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[0, 0, 1], 
                  PointSize[0.03]], 
                 PointBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQDQFWDj0lXyXZHh2wh/FlhNaevl98EM53Sm7kWuR5
GMq3drjc89t1f84hOL+GZbF5Y99xKN/OgdEmYmuU2AE4H9U8O4ftNSqqtjww
/fYOX7pz13adhprf4OBw9OnlfSKVe+F80yUOodaVMPMcHS4p7D7I9msfVN7Z
YWp+jo74A5h6F4eex2Vypwt3w/l+CVZrby/YA+efqWG3L2TYDzXP3cGp//98
saPboHwvh7wSL/GzE3ZC1Xs5eEVyFVYFboXzs8odDnzvgqn3dZjpIPknoXcL
lB/g8Msp90DPuR32AFrzZVE=
                  "]]}, {
                 Hue[0.9060679774997897, 0.6, 0.6], 
                 Directive[
                  AbsoluteThickness[1.6], 
                  RGBColor[1, 0, 0], 
                  PointSize[0.03]], 
                 PointBox[{{26., 0.1318977}, {30., 0.1256822}, {33., 
                  0.11512879999999999`}, {41., 0.1072051}, {46., 
                  0.08894483}, {53., 0.08327451}, {58., 0.08028227}}]}, {}}, {
               
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1318977}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.85\"", 1.8452839659983178`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.511772640046844, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.51\"", 25.50545983649296, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.8452839659983178`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.511772640046844, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    25.50545983649296, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1363487}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.17\"", 2.174970638082915, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.97\"", 25.973364996234398`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.174970638082915, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    25.973364996234398`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1506846}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.71\"", 2.714663536371762, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.6992318174463283, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"56.02\"", 56.01783828172497, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.714663536371762, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.6992318174463283, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    56.01783828172497, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{27., 0.14394369999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.52\"", 1.5175861499890386`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.99\"", 1.9874056965170552`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.04\"", 1.0364713171226168`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"60.13\"", 60.1286563817407, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.5175861499890386`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9874056965170552`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.0364713171226168`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    60.1286563817407, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{27., 0.1840364}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.76\"", 11.75663792584013, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7100848960685717`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0141153649569057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.40469052094093616`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    11.75663792584013, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7100848960685717`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    1.0141153649569057`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.40469052094093616`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1256822}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.55\"", 0.5547993431525761, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.07\"", 1.0675587238026052`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"82.33\"", 82.32801551969636, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5547993431525761, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.0675587238026052`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    82.32801551969636, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1363487}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"23.80\"", 23.798394358151473`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.97\"", 25.973364996234388`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    23.798394358151473`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    25.973364996234388`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1409985}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.40\"", 2.398296075979615, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2530999394351878, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"27.86\"", 27.857001253203226`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.398296075979615, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    0.2530999394351878, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^2 + 
                   NumberForm[
                    27.857001253203226`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{31., 0.15464909999999998`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    7.249569600913545, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.4456221384884378`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    5.4612970662714355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                   NumberForm[
                    0.47151508096227146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.11512879999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.78\"", 4.779700372923058, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.36\"", 1.3588896588398107`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"28.15\"", 28.150020751209208`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.779700372923058, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3588896588398107`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    28.150020751209208`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.1286997}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.4892598925651224`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    37.870051197694124`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    21.19142255107015, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{34., 0.12100259999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.21\"", 2.205421760920544, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.92\"", 1.9234214780240957`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9734132106862983, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"82.62\"", 82.62290403248778, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    2.205421760920544, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                   NumberForm[
                    1.9234214780240957`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.9734132106862983, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    82.62290403248778, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{39., 0.1167006}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.65\"", 1.645484035954365, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.94\"", 1.9428602297315127`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.77\"", 0.7696063680405483, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"108.44\"", 108.4440301206738, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.645484035954365, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.9428602297315127`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.7696063680405483, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + (
                    NumberForm[
                    108.4440301206738, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.1072051}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"5.39\"", 5.388488532154807, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.61084890976613, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.31\"", 0.3135127747178217, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.21\"", 32.20832710066633, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    5.388488532154807, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.61084890976613, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3135127747178217, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    32.20832710066633, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.1118295}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.75\"", 2.7530371991874634`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.48\"", 1.475926002952032, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"26.73\"", 26.728435127709723`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.77\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06769853139701822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    2.7530371991874634`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.475926002952032, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    26.728435127709723`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] - 
                   NumberForm[
                    0.06769853139701822, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.1211005}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.89\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.038939420148409794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.18\"", 39.18371072963305, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.85\"", 21.8462052882725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.88\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09875226201681911, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.038939420148409794`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    39.18371072963305, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    21.8462052882725, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.09875226201681911, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.08894483}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6898741078351978, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.60\"", 1.596089617367446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5053563017523753, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.03\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005027584566729023, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.28\"", 32.28061386026539, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.6898741078351978, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.596089617367446, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.5053563017523753, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.005027584566729023, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    32.28061386026539, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{52., 0.09986574000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"5.07\"", 5.071685481188336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.21\"", 24.214805485555132`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.49\"", 37.48718749549277, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.61\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0026085211939116826`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    5.071685481188336, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    24.214805485555132`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
                   NumberForm[
                    37.48718749549277, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                   NumberForm[
                    0.0026085211939116826`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^2, 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.08327451}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.623861826954152, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7109732088166947`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.3339992072804259, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.89\"", 33.887450948010994`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10008040185977453`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.623861826954152, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7109732088166947`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.3339992072804259, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    33.887450948010994`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.10008040185977453`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.08805798000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.15\"", 1.1470873334633718`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7300611329733, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5691075463075546, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.07\"", 38.06597673413077, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.925370956651333, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    1.1470873334633718`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7300611329733, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.5691075463075546, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    38.06597673413077, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    1.925370956651333, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.08028227}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.56\"", 0.5598440509802566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.763965432623472, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12659692767414124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.01\"", 2.0054589531648657`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.15\"", 37.154199710888015`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.5598440509802566, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.763965432623472, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.12659692767414124`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - (
                    NumberForm[
                    2.0054589531648657`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2) + 
                   NumberForm[
                    37.154199710888015`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{64., 0.09690170000000001}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"5.82\"", 5.820638005658056, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.34\"", 31.34255707289824, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.75\"", 11.747034164337029`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.03\"", 37.026687116195575`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    5.820638005658056, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    31.34255707289824, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] - (
                    NumberForm[
                    11.747034164337029`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2) + 
                   NumberForm[
                    37.026687116195575`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[0, 0, 1]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{26., 0.1318977}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.85\"", 1.8452839659983178`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.511772640046844, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.51\"", 25.50545983649296, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    1.8452839659983178`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.511772640046844, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    25.50545983649296, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{30., 0.1256822}}]}, 
                  StyleBox[
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.55\"", 0.5547993431525761, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.07\"", 1.0675587238026052`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"82.33\"", 82.32801551969636, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  Style[
                  NumberForm[
                    0.5547993431525761, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.0675587238026052`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    82.32801551969636, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{33., 0.11512879999999999`}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"4.78\"", 4.779700372923058, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.36\"", 1.3588896588398107`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"28.15\"", 28.150020751209208`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    4.779700372923058, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.3588896588398107`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    28.150020751209208`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{41., 0.1072051}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"5.39\"", 5.388488532154807, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.61084890976613, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.31\"", 0.3135127747178217, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.21\"", 32.20832710066633, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    5.388488532154807, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.61084890976613, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                   NumberForm[
                    0.3135127747178217, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    32.20832710066633, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{46., 0.08894483}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6898741078351978, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.60\"", 1.596089617367446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5053563017523753, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.03\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005027584566729023, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.28\"", 32.28061386026539, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.6898741078351978, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.596089617367446, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.5053563017523753, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                   NumberForm[
                    0.005027584566729023, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                   NumberForm[
                    32.28061386026539, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{53., 0.08327451}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.623861826954152, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7109732088166947`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.3339992072804259, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.89\"", 33.887450948010994`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10008040185977453`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.623861826954152, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.7109732088166947`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.3339992072804259, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                   NumberForm[
                    33.887450948010994`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                   NumberForm[
                    0.10008040185977453`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ], 
                TagBox[
                 TooltipBox[{
                   Opacity[0.], 
                   PointBox[{{58., 0.08028227}}]}, 
                  StyleBox[
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.56\"", 0.5598440509802566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.763965432623472, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12659692767414124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.01\"", 2.0054589531648657`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.15\"", 37.154199710888015`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                   RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
                  0.1, TooltipDelay -> 0.05], Annotation[#, 
                  
                  Style[-NumberForm[
                    0.5598440509802566, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                   NumberForm[
                    1.763965432623472, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                   NumberForm[
                    0.12659692767414124`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - (
                    NumberForm[
                    2.0054589531648657`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2) + 
                   NumberForm[
                    37.154199710888015`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                   RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}}}, {
            ImageSize -> 250, DisplayFunction -> Identity, 
             PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, AxesOrigin -> {5.953125, 0}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, ImagePadding -> All, DisplayFunction -> Identity, 
             AspectRatio -> NCache[
               Rational[3, 5], 0.6], Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {5.953125, 0}, 
             DisplayFunction :> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, 
             FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
             GridLines -> {Automatic, Automatic}, GridLinesStyle -> 
             Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 250, 
             Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                   (Identity[#]& )[
                    Part[#, 1]], 
                   (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
             PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
             True, PlotRangePadding -> {{
                Scaled[0.02], 
                Scaled[0.02]}, {
                Scaled[0.02], 
                Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}]}}, 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         AutoDelete -> False, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
         BaselinePosition -> Center, FrameStyle -> Directive[
           GrayLevel[0.85]]], "Grid"]}}, 
     GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
     AutoDelete -> False, 
     GridBoxDividers -> {"Columns" -> {{True}}, "Rows" -> {{True}}}, 
     GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
     GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
      GridBoxItemStyle -> {"Columns" -> {{
          Directive[
          FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
           FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, "Rows" -> {{
          Directive[
          FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
           FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
     BaselinePosition -> Center, FrameStyle -> Directive[
       GrayLevel[0.85]]], "Grid"],TagBox[
    TooltipBox[
     StyleBox[
     "\"column\[Bullet]10\"", {
      FontSize -> 12, FontWeight -> "Bold", FontFamily -> "Helvetica", 
       FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
       ShowStringCharacters -> False}, StripOnInput -> False], 
     GraphicsBox[{{}, {{{}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           PointSize[0.011000000000000001`], 
           RGBColor[0.368417, 0.506779, 0.709798], 
           AbsoluteThickness[1.6]], 
          PointBox[CompressedData["
1:eJw1k09Ik3EYx186zCBMsRGFDnRIZoip5dZM53dzm3O+pG5mjS4iDPVigYgR
EYV6kQ5KHezSwIMR7CLe6iDRRQSRoEQQI2h00JAQghYG/Z69z/eFl/f9vB/e
9/n71ozcT2ZOWZYVMKdcneNXZ35toikabIE+QHM0eOg6F1Y+ja/D8493tmLK
5RiUF+YSym58dBdylc9t5QvYHN0fnm+/pVwFj724/e5Dn3I1ZuuP0/6H/cpe
/M1V2otlA8q1OF+QB+RL2C1d2Rj9R76MV97s1Mx4UvkK7vmXvNkv5AYnXiil
3OjEWyI34acrlV87IjejGO7qoHILSoyeeEC+BinPXiVfh4SvPya3Ykfy89xW
9sF0q3QlTvbDdDOVnyTfgGTjzZIDeLNhGrZJbnPq+U2+iTLz+f3qIeV2p982
uQPTJpv0NDmIBgmwTO7Et+L8yECb+fzUd+WnwEszHXeBPoQj6c/ZO+pDiEsB
tcpWGMtSfoA+jBPpXx99F4ZkPzL0XVg1evsRfQRnpL8L9BFkig2jj2LdZJN7
Tx/FRSn3E30Mk2ZbD3/Qx7Al+3ZC3406mU/FXfXdeCYDqlO24tiTeXXQx+GT
fU/R92BB0hmj78GB/B9P6BOIyDxf0CfwWhbiLX0v/sh81+l7kZT1/0xvIyfz
PqC34SrepPEfM/ntLA==
           "]]}, {}}}, {}, {}, {}, {}}, {
      DisplayFunction -> Identity, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.05]}}, AxesOrigin -> {0., 0}, 
       PlotRange -> {{0., 57.}, {0, 100.00000000000009`}}, PlotRangeClipping -> 
       True, ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
       NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
       AxesLabel -> {None, None}, AxesOrigin -> {0., 0}, DisplayFunction :> 
       Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
          FormBox["\"Cumulative Percent\"", TraditionalForm], None}, {
          FormBox["\"Popularity-Ordered Combinations\"", TraditionalForm], 
          None}}, 
       FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
       GridLines -> {Automatic, Automatic}, GridLinesStyle -> Directive[
         GrayLevel[0.5, 0.4]], 
       Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& )}}, PlotLabel -> FormBox[
         StyleBox[
         "\"The 296 models have 57 VariableCombinations\"", {
          FontFamily -> "Helvetica", FontWeight -> "Bold", FontSize -> 12, 
           FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> 
           None, ShowStringCharacters -> False}, StripOnInput -> False], 
         TraditionalForm], PlotRange -> {{0., 57.}, {0, 100.00000000000009`}},
        PlotRangeClipping -> True, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], TooltipDelay -> 
     0.1], Annotation[#, 
     Graphics[{{}, {{{}, {
          Hue[0.67, 0.6, 0.6], 
          Directive[
           PointSize[0.011000000000000001`], 
           RGBColor[0.368417, 0.506779, 0.709798], 
           AbsoluteThickness[1.6]], 
          Point[CompressedData["
1:eJw1k09Ik3EYx186zCBMsRGFDnRIZoip5dZM53dzm3O+pG5mjS4iDPVigYgR
EYV6kQ5KHezSwIMR7CLe6iDRRQSRoEQQI2h00JAQghYG/Z69z/eFl/f9vB/e
9/n71ozcT2ZOWZYVMKdcneNXZ35toikabIE+QHM0eOg6F1Y+ja/D8493tmLK
5RiUF+YSym58dBdylc9t5QvYHN0fnm+/pVwFj724/e5Dn3I1ZuuP0/6H/cpe
/M1V2otlA8q1OF+QB+RL2C1d2Rj9R76MV97s1Mx4UvkK7vmXvNkv5AYnXiil
3OjEWyI34acrlV87IjejGO7qoHILSoyeeEC+BinPXiVfh4SvPya3Ykfy89xW
9sF0q3QlTvbDdDOVnyTfgGTjzZIDeLNhGrZJbnPq+U2+iTLz+f3qIeV2p982
uQPTJpv0NDmIBgmwTO7Et+L8yECb+fzUd+WnwEszHXeBPoQj6c/ZO+pDiEsB
tcpWGMtSfoA+jBPpXx99F4ZkPzL0XVg1evsRfQRnpL8L9BFkig2jj2LdZJN7
Tx/FRSn3E30Mk2ZbD3/Qx7Al+3ZC3406mU/FXfXdeCYDqlO24tiTeXXQx+GT
fU/R92BB0hmj78GB/B9P6BOIyDxf0CfwWhbiLX0v/sh81+l7kZT1/0xvIyfz
PqC34SrepPEfM/ntLA==
           "]]}, {}}}, {}, {}, {}, {}}, {
      DisplayFunction -> Identity, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.05]}}, AxesOrigin -> {0., 0}, 
       PlotRange -> {{0., 57.}, {0, 100.00000000000009`}}, PlotRangeClipping -> 
       True, ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
       GoldenRatio^(-1), Axes -> {True, True}, AxesLabel -> {None, None}, 
       AxesOrigin -> {0., 0}, DisplayFunction :> Identity, 
       Frame -> {{True, True}, {True, True}}, 
       FrameLabel -> {{"Cumulative Percent", None}, {
         "Popularity-Ordered Combinations", None}}, 
       FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
       GridLines -> {Automatic, Automatic}, GridLinesStyle -> Directive[
         GrayLevel[0.5, 0.4]], 
       Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& ), "CopiedValueFunction" -> ({
             (Identity[#]& )[
              Part[#, 1]], 
             (Identity[#]& )[
              Part[#, 2]]}& )}}, PlotLabel -> 
       Style["The 296 models have 57 VariableCombinations", {
         FontFamily -> "Helvetica", FontWeight -> "Bold", FontSize -> 12, 
          FontColor -> GrayLevel[0], FontSlant -> "Plain", Background -> None,
           ShowStringCharacters -> False}], 
       PlotRange -> {{0., 57.}, {0, 100.00000000000009`}}, PlotRangeClipping -> 
       True, PlotRangePadding -> {{
          Scaled[0.02], 
          Scaled[0.02]}, {
          Scaled[0.02], 
          Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}], "Tooltip"]& ]},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {2, 1}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )]], "Output",ExpressionUUID->\
"4ff4e99c-56c7-4b01-a904-9bc6d402146f"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnW9sG/eZ54U7HHBviLv3i3txb4QALox9weCaPeSFCqLAwRBM7GXzorSA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    "], {{0, 68}, {1295, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, Magnification -> 
    Automatic],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->500,
  ImageSizeRaw->{1295, 68},
  PlotRange->{{0, 1295}, {0, 68}}]], "Output",ExpressionUUID->"87b84c20-1f46-\
44f7-a0e0-115fabf685c2"],

Cell[BoxData[
 TemplateBox[{TagBox[
    GridBox[{{
       GraphicsBox[{{{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              AbsoluteThickness[1.6], 
              GrayLevel[0.85], 
              PointSize[0.01]], 
             PointBox[CompressedData["
1:eJxV1Xk81VkbAHBaVFJhRJbXkqakxFCGGhyXbMm1L5GtMBoqMiEUmSnpZq+Z
GMptUbi2u7mu5dpFCNXYKUlRmqyFyTvvvPf3nJn7z/18P+f8znPO8zzn91Py
PmXrs0JAQEBFUEDgf////21HUvGqJZTabgPCvv4rbo/a94Enaja15bS9ABuy
f9lrMjEGPrHMkT8g/w4cebwtobAb+45YVJyT8nuwj3j6o36vSbCW6ubP6RYf
wE7cfklZf2z5gbVX48MI70bdLjevpwj/Dp5I9jqt4tQNvkG9n9PTik0TIdv3
TQ2AhTQ//llrOQR2qiipDivH5rkqGn5UHgG/36m7Y84a23LbZf2NnNdgjkzP
9RsdY2Abw3FZvRHi/HuQoZpX08Gk5+ARF51lH1of+NNBu8vb0wfx/AeGlwu/
Hgb/GlRQbsB5AXaaqBsNW/0S/EZr8ZflCey/zxNJ5PsbxBG1vkT26AWbG2le
UVjbB2Zaa+oy6cT6mmihtS5EybEJ7Gd2+rz8l0fgs0JLT7h+zWANddlP+Q2t
YG3BS6Pt7HYwaWnDNt3cLnBT8pk1jud6wWF0oQ95U9gBf0i/urLYD45/jh7m
9w+A6zWpLud/HgKv07XgOD7HfvHoK1qMLXEeLaSw9cK5qPk2sEREbXem+ROw
ynoPjwlb7Mr2FV/2C3aCW723+DolYYsqGjVuzMXWYy6M56IucKlfjoaA/FO+
tdHTcv22xPROcCKtplr3PDH/WxTQG5FT6tkEPua0TAl91wpedefbmITFdrCn
V+hpX9Un4Pk/ZDdPtmCfm70htdqXiKeLTg6mvtRvrQfvoMh1D2s1gY8YUAuO
6D/mez9SL4piqzuWgSkhs9JCL3lgOXFay9CZanDLuN9i9gj2VGF8f5hcDXh6
SEW+XLYWTDoWI0w1x3b+LBza1VkPHk0Kv+KY2gB+sla74MLv2HI2E6ZPHZrA
7JnaY+nGj8AhP9U4VsVhf9l1SagihfABlBUgcecTqQbcRVk8WBWAHe+efYK8
rR689/yl/uIo7Mi/C9LItx6SHZd78Ol4Hd/6yFC1PqEhuwxsXhkouFTABQt+
58w8IskD/zuf+mg+Ts/lORWbHbntaz2RGnD1deqhSd9a8Noj/b3/odWD41Y0
Fvp/aACbJH2Y11Ak8mWAGKphvF061eC5yhyVw7o1YDG2/YeyplrwzNVAWnwL
9mcTaUmzWex8x+1LtgZ14Hnz5f4XPGzT9ji1X+34+4lGaNHgZYmPfRm4frSr
UiK8ArzvLnI4EM4Dn7EOq+J5E+czRNZ/v/BLwQ0GW93Y8xywcPRHEZkFbDWR
dxSLg2Xg6sG6pN8ssfXPN1PEyVywk8aw7OdgbJGds7L9FOztueI8ld/KwXY6
OzKkHleCOxW51UIL2OTBgC25a6rAf1pWnBTbwnc0CV3hMnjUQxywOGVw1f5J
7Bx/L08/Il8CRmjmR82MEGkmWHx53Lojhg3e2yxc5HCnFKwWEZi86RkHvHWu
4PW9NXi9B9o6Yn/2Ysv7+FuqCfD3H22EPJ0HTgZfKwVn+VErZavLwdTtC5Fp
YhXg66cCdksN8y1gjN6vUU4desXijxuj9LZO/Ql7Nvj31cEGN2awGzuqb12S
KAUf7hxJEyFxwJcbTi5s7MFeKE3esGxcBjayuU1+ZY79734zRpSRs/ItQVyw
led+Wt/tcvDjyDUGQQJEvQ6i5XqZFtM0NnhBr7e1YWcp2PLouk2eJdillS5p
ygUcsNZo1roHLdg+GT6ee6axu/eJxvT8wyGHvNIcNcvAMS8Dhsygf02Qkrvm
WwuPCrCJ0qP8wRdEvUxQ5uoJ81wBBjhyTOGGhmkp+F7VVMQcmwNu6Tlwh2ZR
Bv7erOXbZDLRv6ZIpGmb8Y8WdPBtK27SbBC2pHvqhdDvmODFZ50pUSbYpMTl
W5L1LLBElW7C6HkOWPrqfXpqNfYozcPB26gM/JNj0AzpEGEztOqljLEohQlm
C98t17uHfTDNi+q9hQNWUiOd+uxFnNcMZam6LgZupoNfUzTcHZ8xwPqiNlqG
nkxw+cPHFQ5iLHANbXbb3mDs/arqwyvciP4wRwFusWNnVBjgKNJXjPVfmGC7
W9xE/wSi381RtIdw/ikqHVyfmJb95goT/GRnU7tJAQucuoeaMmRK5MMC+dwS
Y72VLgGfDLGQak3igD9U7dfyhXpboNiZ3mtltBJwXmjPrpW6dLCFi3DQORsm
+EQo4s3Hs8Aprja24VlEvx9CM203M0Rk8sFnkkgKh4NKwDkpgrfjZeng5fXR
TdfeYOdRintKPmFf07l2USaTAX6s7JtK7sAOl/wmV8KeBT7b/OVpF5UNHqC3
D7nWEvn9az53+os8IvJviX4a3+SdzaSDN4Su3lD7PQNMf6diGz+B549YBd7M
3sUCmy6cGwoh4kVbomMTmQvPHOng1QtNz5veMMCfHxp1FD1ngp3FLrivECTq
dxg1ZKyKGzUqASfnkyNIR7GDOFNI0I8BDjt8UfLG99g3kfSS5zVs0eLqGvN0
Jrjq54+5ukJE/Q+jrIdDWRbnivjjVqjLcUnM0pEGjlKgO6vvKgSvm6sR89Yu
BmtOl3hWx2BfzfauaJ3C9n5daJXpSfTXX35oGiWUUgT2Ex3gKsgUgwPF6qkf
j2JL2InntErh5/d4W5Z6ONHBO575/cazI/qbjHw3aiRNoyKwmBqV6x5eDJ5e
+4A8V4VtRXq7XmmMDnYTn57k/cOzFjphZDoLrNqd9GhalXg/klHk69SSX2UY
4AVUqrxlkAW+q6J8Ws6DDWaHzrhpPsGuzLScbVQh9m+NhlRv0oSCC8DFCdk/
hA0wwAukQB6ljX/fkDXa0nHWcuB6HlgbjZ6ilReBpWrzLw5+R5zXBq0T2XHn
4dYcsJ3HR/WBC4VgXu3ApMI48bwNSnOvE2nsLASbSCo4rIzF4xuTPJOXJIh6
2SD2PnbkSqlcsMN67ao8df7+eX+tbyqZmifJAm9uab7Y4krcV1s0mRgxonu9
ELxovvN+L4+IZ4t+qNUZL9iQB47v68oIFiTi2yLTE3GNHe78/PBsEXuljNg3
zff569khf9YL35xn/P0hO1TxVTj9IqsQTBkbdmLYFoHt4/UzdiuywHJvrR4k
TBH1tUOX9d+rxk4Wgl8Fp8becuE/z7NDU7IltUmx9/jx7VFQ58kuZW1+PpA9
Ohvw9R/uikzwyKnB/AtDxH11QHNrORFWjPvgoEZkdPcQMe6MblHsKcWyfPNc
kcWGQAFtRSLfbug4ZyhaZozon6NoqEQmKsWNDn4VW9WXOsW3oidaWbe7VfQA
sR9vJLgr8bLSayp/vWOINLbYvMzFNtF0Vk8Y4Xv4OJJr2OSaQSLi+yIGV6qZ
3ELc1xPIMpOsbbaP/30YDkFGc+ZrrFSZBv8FXrJikA==
              "]]}, {
             Hue[0.9060679774997897, 0.6, 0.6], 
             Directive[
              AbsoluteThickness[1.6], 
              GrayLevel[0.5], 
              PointSize[0.015]], 
             PointBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQFqDuJdWpt6Dt+wh/B1HG5Ezpw6ies6lK/n4Kib
eMJ1wjUo38jh19kjJYphJ6B8S4e8e5Mf2Z09CuVbOehvqN2uH7YLwm9wcPht
/2hTagiUz+DoEPB6YmKBxg4o39nhS6nR7BLJrVD1bg5zWV97rmLYApV3d+A5
oeJS6rUZKu/hME8r+neuKJTP4OWQOl9w20vJTVC+t8OXczNn80itgfAdAhwk
Lpb53J26Giof6MDJo754pdJyCP9AkMN2ZilBw1PLoPxgh0/Smw5PaF4K1Z/k
wKjd3674bBFUPtnB6fnvU/93L7IHADflXOU=
              
              "]]}, {}}}, {}, {}, {}, {}}, {{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              AbsoluteThickness[1.6], 
              RGBColor[0, 0, 1], 
              PointSize[0.015]], 
             PointBox[CompressedData["
1:eJxV0gtMk1cUB/BqEJR1kzIGIoyJMgUcSsAHoNBLKX2BAgKdOoYFh4ylgCC+
IiBkhgF2CLaaRRyPotMRik5a+qQPoBWtTMU5lTFAEJ2wSaYgUlTmsn7nzi+5
+fLLvbk595y/Z2r2lrS5JBLpyJv17/+/LwBZujvzPLldVMLprN2FHq+vgPfZ
vryhTr9q9XrE7z10TsEjzgejrH7hUFi3EbxC4H53MJDYD0GrLxbIV3NVYEHe
pKvtkB7s7igxD+wxgM2j6TP1w9hPL5T3HXBvBz8b8PbQuHWAaTuL7cVs7K3T
9vtv9RjBI5UHy7hCE/jG/HXNh+9gu8eNMX9JxPXKJzp2nqJfAecdaefqSrFf
ryyxbTtOeAOq4Ts1vKC1g28JZiJ1fOzy5PqvYryM4DWFJX0/FWDn2zSsL664
bHUocht1P//ii06rw1C4r7HCVK8Cs7WZc142q8FzNm6VbXfWg9/uZxiaKg3d
9qsYW57v9XEouR1sOCGOerKrAzx/e1/vhxIjuHTu5QsZ4yYwo3J8yn8J0S8q
kvoe0K8MMoCfa895bwpuB1PkCeOqrg7wxNFMSbkZe5rh6syaxG7iLn+5hdoJ
nmLP9t3XYzOvl/p9F2+tpwihGerQpbQEFdg4ckvrdLANvPYMStxwUA/eE3tA
p08l3heOYseqUnZ7K8Am6tIk+ZQSbF/0N3mxBduP/KeAE6kCG/o7K09HY4cV
XhU4xqjBn/oPuk3nYpN9Jt36BNjLGx313qc14PigFdUu17TgniVqg60FO6af
v6jRTgd+Fd2WRVlkdRENlamlenGUEuwo6LcJeYJ9LiOFl070ixSBJvYGVOe5
ysCOs6OxN4vl4DVX7S8mNijAfocyqxbeVoKXPm9+eNYO33d+XRDlVS+2R1pG
tB/JWn9RBOJt/T0r91sFuCZdrHUzaMDi5ZZ8EaUNfCKb/4nLoNUkOvrLbplw
4EGrdZ+OTv3cEzaWIAffmZdLPTmBffmmobbESQHe1DMsItOU4G9MWZb37mFb
FFXvztJV4Ii4upgHbOy380ZHguF9HuYcNXgzL0TyW50GfC3fjppDIuYViWaN
i81MkRxsCe3tNvkowNGfL1jIu4St0G4TLWtWggNHahacN2OnVafxVj3DvrvW
ofje/5wXlSLiBqjAxUP8ARbkl4E8kwMec3a0gRmeV5r67xPzYqDv542xG0lS
cP6jj076MxXgs7qnh57LlWDzvQ0NEo4K/CXLvL4qhsgvE5G7vOh7OS3gus3q
yskcbOdk4eH9G2Xgmds9xwsY2LRjs7XOxlawky64YqRQCXY9+kOL0IA9ItmR
mBqhAh/h5kzQogizkM3QYrqDQAaW25/RhJ7FjhSliFMXKcGefrTs6RTivSxU
4/vZTOYHLeCHAv9k7m0pOMwhLjCcJwNrfrzWlkhpBbdLJr3W5GKH+K4enJtE
5ION+ElfP9rjLQUX0N6XvvNaBo6vVR/LqCDyzkZFO+ybssUtYOMxUf0fZTLw
DZ+u64zmVrBwlfj4AJPoBwel1VJaH7teAmflcVy6K5XgcV1I4K438/4HzMdk
gA==
              "]]}, {
             Hue[0.9060679774997897, 0.6, 0.6], 
             Directive[
              AbsoluteThickness[1.6], 
              RGBColor[1, 0, 0], 
              PointSize[0.02]], 
             
             PointBox[{{18., 0.19012849999999998`}, {25., 
              0.17032609999999998`}, {26., 0.1028776}, {33., 
              0.10285029999999999`}, {34., 0.09436705000000001}, {38., 
              0.08241967}, {45., 0.07813515}, {46., 0.07535489000000001}, {
              49., 0.07454574}, {52., 0.0707079}}]}, {}}, {
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{18., 0.19012849999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.8914097926737627, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  732.5832364133336, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{18., 0.2030676}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.11\"", 2.1144353796292608`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.26\"", 34.26299891735344, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.1144353796292608`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 34.26299891735344, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{18., 0.2062907}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5909646413341895, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"67.17\"", 67.1673578147976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.5909646413341895, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 67.1673578147976, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{23., 0.1904517}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"6.47\"", 6.46957351566761, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"11.97\"", 11.97175537933934, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.78\"", 0.7840331357133206, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                6.46957351566761, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 11.97175537933934, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
               NumberForm[
                0.7840331357133206, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{25., 0.17032609999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"6.56\"", 6.558527645565748, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"36.62\"", 36.618371875581836`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 6.558527645565748, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 36.618371875581836`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{25., 0.18908319999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"11.74\"", 11.739186854014871`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"56.82\"", 56.81796994101466, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 11.739186854014871`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 56.81796994101466, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1028776}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5972434214759587, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.135346220113384`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1318977}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.85\"", 1.8452839659983178`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.511772640046844, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.51\"", 25.50545983649296, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.8452839659983178`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.511772640046844, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 25.50545983649296, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1363487}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.17\"", 2.174970638082915, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.97\"", 25.973364996234398`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.174970638082915, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 25.973364996234398`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1397593}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.11263818940082906`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.48\"", 1.4817333950435745`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"50.00\"", 49.99948499944974, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.11263818940082906`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4817333950435745`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 49.99948499944974, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1414939}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.07\"", 1.0749331755578786`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3182166396578419`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"559.78\"", 559.7767600663503, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.0749331755578786`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.3182166396578419`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + (
                 NumberForm[
                  559.7767600663503, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1492839}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.89\"", 1.8877579499714372`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.11\"", 1.1141498521526363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"61.80\"", 61.79788023563619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.8877579499714372`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.1141498521526363`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 61.79788023563619, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1506846}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.71\"", 2.714663536371762, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.6992318174463283, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"56.02\"", 56.01783828172497, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.714663536371762, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.6992318174463283, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 56.01783828172497, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1704964}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.64\"", 0.6405373618876019, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.705807438734326, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.31\"", 29.311261343864413`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.6405373618876019, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.705807438734326, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 29.311261343864413`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.17637139999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.19\"", 2.1908135489152247`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7280268689895092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"117.25\"", 117.24727812838044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.1908135489152247`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.7280268689895092, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 117.24727812838044`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "9"]], 
                  Hue[
                   Rational[9, 10], 1, 
                   Rational[5, 6]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.17845149999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"3.79\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037904821366972936`, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.27\"", 0.27052206054968353`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.62\"", 31.61926901658651, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.037904821366972936`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.27052206054968353`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "7"]], 
                  Hue[
                   Rational[7, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 31.61926901658651, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1901193}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.86\"", 0.8620951567752905, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.62\"", 732.6165153538162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"0.91\"", 0.905359277852415, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.8620951567752905, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  732.6165153538162, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 0.905359277852415, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "9"]], 
                 Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1974061}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.82\"", 1.8238346381181219`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.2276930591967809, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"30.45\"", 30.45228953761438, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.8238346381181219`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.2276930591967809, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 30.45228953761438, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1994857}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.65\"", 2.6460164233139727`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.39\"", 34.39353742461602, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"17.90\"", 17.900772447150747`, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.6460164233139727`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 34.39353742461602, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                17.900772447150747`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                TraditionalForm[
                 Subscript["column\[Bullet]", "9"]], 
                Hue[
                 Rational[9, 10], 1, 
                 Rational[5, 6]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.19979059999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.46\"", 0.4554306763251354, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.99\"", 34.986490627050756`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.45\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06446968886515927, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.4554306763251354, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 34.986490627050756`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.06446968886515927, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{27., 0.14266879999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"3.47\"", 3.4733768128077096`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.29\"", 2.2947176471822623`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7390571409205557`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"69.87\"", 69.87005969257898, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 3.4733768128077096`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.2947176471822623`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.7390571409205557`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 69.87005969257898, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{27., 0.14394369999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.52\"", 1.5175861499890386`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.99\"", 1.9874056965170552`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.04\"", 1.0364713171226168`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"60.13\"", 60.1286563817407, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.5175861499890386`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.9874056965170552`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.0364713171226168`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 60.1286563817407, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{27., 0.1651706}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"12.78\"", 12.78294649513016, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.81\"", 1.808660756198177, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.89\"", 1.8870406144298306`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5279812363075969, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                12.78294649513016, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.808660756198177, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.8870406144298306`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.5279812363075969, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{27., 0.1678984}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"50.01\"", 50.00667984513152, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.02\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.040185011163644084`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"186.50\"", 186.50001958712824`, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.8816688678351774`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                50.00667984513152, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.040185011163644084`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "1"]], 
                 Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]]] - 
               NumberForm[
                186.50001958712824`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/(
               NumberForm[
                3.8816688678351774`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "4"]], 
                 Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{27., 0.1840364}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"11.76\"", 11.75663792584013, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7100848960685717`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0141153649569057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.40469052094093616`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                11.75663792584013, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7100848960685717`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.0141153649569057`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.40469052094093616`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{29., 0.15933139999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.80\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.113808720357664, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 68.58401194252002, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + (
                 NumberForm[
                  0.037977703625019794`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.104031}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.6035548758175392, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"420.96\"", 420.9599406483028, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.6035548758175392, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  420.9599406483028, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1081388}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.80\"", 0.800061422670007, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.79\"", 19.789098178446487`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.800061422670007, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 19.789098178446487`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1256822}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.55\"", 0.5547993431525761, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.07\"", 1.0675587238026052`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"82.33\"", 82.32801551969636, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5547993431525761, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.0675587238026052`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 82.32801551969636, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1363487}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"23.80\"", 23.798394358151473`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.97\"", 25.973364996234388`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 23.798394358151473`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  25.973364996234388`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.13778189999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"3.22\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.03221642688660536, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"3.26\"", 3.2641826217541627`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"541.09\"", 541.0894357654424, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.03221642688660536, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 3.2641826217541627`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + (
                 NumberForm[
                  541.0894357654424, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1409985}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.40\"", 2.398296075979615, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2530999394351878, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"27.86\"", 27.857001253203226`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.398296075979615, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.2530999394351878, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^2 + 
               NumberForm[
                 27.857001253203226`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.15157869999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.70\"", 3.701310916637267, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.12494529027972003`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"62.05\"", 62.047111180947645`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.701310916637267, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.12494529027972003`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
               NumberForm[
                 62.047111180947645`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.16934559999999999`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 3.882350562760903, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.0321890071965854`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 63.363724799250285`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1791813}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.21\"", 2.214831444750322, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.59\"", 1.5925205267573528`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.87\"", 31.871301371710505`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.214831444750322, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.5925205267573528`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "7"]], 
                   Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
               NumberForm[
                 31.871301371710505`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{30., 0.1884824}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2170341589085145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.17\"", 1.170553481638129, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.09\"", 51.08826447265663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.2170341589085145`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.170553481638129, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 51.08826447265663, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1345267}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"7.35\"", 7.346577942384855, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4900078078905312`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"8.51\"", 8.511572782690058, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.65\"", 0.6478243898384884, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                7.346577942384855, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4900078078905312`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 8.511572782690058, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
               NumberForm[
                0.6478243898384884, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1423737}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4376907446392891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"221501.35\"", 221501.3451429473, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  SuperscriptBox[
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.22\"", 2.216203884016891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.4376907446392891, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  221501.3451429473, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 2.216203884016891, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1545633}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"4.96\"", 4.961335236514884, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"29.27\"", 29.265545755151418`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.45\"", 4.446163100193115, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.95\"", 0.9515846064267578, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 4.961335236514884, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 29.265545755151418`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
               NumberForm[
                4.446163100193115, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "6"]], 
                 Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]] - 
               NumberForm[
                0.9515846064267578, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.15464909999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                7.249569600913545, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4456221384884378`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 5.4612970662714355`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
               NumberForm[
                0.47151508096227146`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1559229}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"19.65\"", 19.647397022440057`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.94\"", 1.9376445174038723`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.88\"", 1.8781078831523041`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.07\"", 4.065868403752875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                19.647397022440057`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.9376445174038723`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.8781078831523041`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                4.065868403752875, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1581825}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                11.135546219979584`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 8.280454674605123, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.5908371539294913, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]]^2 - 
               NumberForm[
                0.8978305425889783, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.16213629999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"9.65\"", 9.654320192829715, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"183.70\"", 183.7041059022446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[-
                NumberForm[
                 9.654320192829715, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 183.7041059022446, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-1) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{31., 0.1744261}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                8.159680560964581, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.04011738767128822, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "1"]], 
                 Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 5.224685491056446, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.22854010099263636`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]]^2, 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{33., 0.10285029999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.55\"", 0.5541585846053176, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.52\"", 40.517482091573655`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.6601111251628, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5541585846053176, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 40.517482091573655`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 41.6601111251628, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{33., 0.11512879999999999`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"4.78\"", 4.779700372923058, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.36\"", 1.3588896588398107`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"28.15\"", 28.150020751209208`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 4.779700372923058, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.3588896588398107`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 28.150020751209208`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{33., 0.1286997}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.4892598925651224`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 37.870051197694124`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 21.19142255107015, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{33., 0.16707619999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"5.16\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.051580114275771215`, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.87\"", 0.8699842403421914, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"33.09\"", 33.0913772376397, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.051580114275771215`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.8699842403421914, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 33.0913772376397, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.09436705000000001}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.2792678309107002, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.24783345853136146`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 36.819424146231384`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1014361}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.34\"", 0.34193365474032633`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.16\"", 0.1634125138335718, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.63\"", 39.632976405655924`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.34193365474032633`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.1634125138335718, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 39.632976405655924`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1014725}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.77\"", 1.7737971007854787`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.72\"", 1.7170648977776652`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"38.57\"", 38.568963917616095`, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"49.75\"", 49.74902719138321, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.7737971007854787`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7170648977776652`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 38.568963917616095`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 49.74902719138321, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1026198}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.15\"", 0.14716972250701452`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.32\"", 41.31831456916278, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.78\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017757842334691583`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.14716972250701452`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.31831456916278, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.017757842334691583`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.10273149999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.70\"", 0.6999608711343289, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"0.13\"", 0.1312340565987507, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.94\"", 40.93549296600853, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.6999608711343289, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.1312340565987507, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                TraditionalForm[
                 Subscript["column\[Bullet]", "4"]], 
                Hue[
                 Rational[2, 5], 1, 
                 Rational[1, 2]]] + 
               NumberForm[
                 40.93549296600853, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1066753}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"7.52\"", 7.522722918376416, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7323486222041777`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.72\"", 46.72326912590955, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.30\"", 0.30367783575558216`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                7.522722918376416, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7323486222041777`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 46.72326912590955, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.30367783575558216`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1072231}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.70\"", 0.7001000647386643, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.41\"", 2.4116164871779526`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7089224305540724`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"97.43\"", 97.42865136137979, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.7001000647386643, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                2.4116164871779526`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.7089224305540724`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 97.42865136137979, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1076181}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.71\"", 0.7147944364841358, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.65\"", 0.654288182502567, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.72\"", 22.718464205230013`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.7147944364841358, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.654288182502567, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 22.718464205230013`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.11175779999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"4.46\"", 4.462634557048332, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.89\"", 1.8928450262432572`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.58\"", 0.5751502464673955, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.32\"", 24.32201848317338, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                4.462634557048332, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.8928450262432572`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.5751502464673955, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 24.32201848317338, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.1203017}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.04\"", 2.0437790052654843`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.83\"", 1.83058221119067, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"2\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.59\"", 1.5869510869788097`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"24.82\"", 24.81904901230133, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.0437790052654843`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.83058221119067, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "2"]], 
                 Hue[
                  Rational[1, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 1.5869510869788097`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 24.81904901230133, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.12100259999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.21\"", 2.205421760920544, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.92\"", 1.9234214780240957`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9734132106862983, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"82.62\"", 82.62290403248778, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.205421760920544, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.9234214780240957`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.9734132106862983, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 82.62290403248778, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.12121069999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.42\"", 0.4239544358569544, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7287797654294157`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7318493630662637, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"60.73\"", 60.732262299445466`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.4239544358569544, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7287797654294157`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.7318493630662637, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "6"]], 
                 Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 60.732262299445466`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.121461}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.69\"", 3.687045513169484, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6665245757735663`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.02\"", 46.01872375913119, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.15\"", 0.1510087764196619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.687045513169484, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.6665245757735663`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 46.01872375913119, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.1510087764196619, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{37., 0.09881036}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.42612172604868076`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                NumberForm[
                 0.06256007839813221, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]]) Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 44.23179551124747, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{37., 0.1012913}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"8.80\"", 8.7972880237627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"41.55\"", 41.554635399336284`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 8.7972880237627, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.554635399336284`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{37., 0.1028504}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.56\"", 0.562094266253516, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.47\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.006467079430521311, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.50\"", 41.496680215114196`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.562094266253516, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                NumberForm[
                 0.006467079430521311, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]]) Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "6"]], 
                 Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 41.496680215114196`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.08241967}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.62\"", 2.6248961302373313`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.7586070419485609`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1880569366993785`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"54.59\"", 54.5898093120803, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.6248961302373313`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7586070419485609`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.1880569366993785`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 54.5898093120803, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.09182461}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.32\"", 3.3161211098694103`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"7.64\"", 7.640079808526499, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.60\"", 40.59802745639896, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.4331737532023043, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.3161211098694103`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 7.640079808526499, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
               NumberForm[
                 40.59802745639896, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.4331737532023043, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.09624229000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.4172135657118963`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7361891056524232`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 0.7046357704345062, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 71.48309026794081, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.10090729999999999`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2846834920032194, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.68\"", 0.6849160887725014, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.53\"", 39.53433067245735, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.2846834920032194, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.6849160887725014, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
               NumberForm[
                 39.53433067245735, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.1016792}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5056525266429981, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.6158725575337699, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
               NumberForm[
                 38.90598516721604, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.104904}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.56\"", 3.559914978697402, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.97\"", 4.966488405218334, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.72\"", 0.7222295065089801, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.38\"", 22.378130601234687`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.559914978697402, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 4.966488405218334, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] - 
               NumberForm[
                0.7222295065089801, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 22.378130601234687`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.1171902}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"5.46\"", 5.455130666388669, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.64\"", 1.639476437808372, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"46.93\"", 46.93014069688936, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"7.99\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.00798733238757964, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                5.455130666388669, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.639476437808372, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 46.93014069688936, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.00798733238757964, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]^2, 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{39., 0.09590831}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6320647414300411, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.87\"", 1.8687964773614916`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"67757.14\"", 67757.13995983037, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  SuperscriptBox[
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4303812581132638`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.6320647414300411, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.8687964773614916`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + (
                 NumberForm[
                  67757.13995983037, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 1.4303812581132638`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{39., 0.1123216}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.56\"", 0.5609723918235984, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.3296515545605452`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.98\"", 39.97824305988735, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5609723918235984, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.3296515545605452`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 39.97824305988735, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{39., 0.1135495}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"39.36\"", 39.36273566747982, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.02\"", 40.02278070069497, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox["1", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 39.36273566747982, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  40.02278070069497, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-1) + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{39., 0.1167006}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.65\"", 1.645484035954365, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.94\"", 1.9428602297315127`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.77\"", 0.7696063680405483, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"108.44\"", 108.4440301206738, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  SuperscriptBox[
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.645484035954365, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.9428602297315127`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 0.7696063680405483, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + (
                 NumberForm[
                  108.4440301206738, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^(-2), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{40., 0.08942983}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"6.65\"", 6.654151143496604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"36.17\"", 36.167997834187815`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.47\"", 39.46835412703028, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 6.654151143496604, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 36.167997834187815`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 39.46835412703028, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.09113951}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.51\"", 0.509520586469478, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"9.14\"", 9.137578640043257, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.93\"", 31.928368879178368`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.509520586469478, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 9.137578640043257, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 31.928368879178368`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.09357585}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.49\"", 0.4907970088213184, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.27543008176316136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.88\"", 39.88006338431486, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.33\"", 33.33120471027875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.4907970088213184, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.27543008176316136`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 39.88006338431486, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 33.33120471027875, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.0940632}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.97\"", 0.974280626740573, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7279936611153469, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.40\"", 38.40037845197193, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"15.90\"", 15.900980311886437`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.974280626740573, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.7279936611153469, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 38.40037845197193, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 15.900980311886437`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.09866408}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.84\"", 1.843879361859205, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.11\"", 2.1097565699850467`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.81\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0018113708319922258`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"55.71\"", 55.70800454238432, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.843879361859205, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.1097565699850467`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + (
                 NumberForm[
                  0.0018113708319922258`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 55.70800454238432, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.1009683}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.46\"", 0.4561433248499897, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.2323785753612857, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"42.18\"", 42.18196598969191, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.30\"", 36.29549509408725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.4561433248499897, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.2323785753612857, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 42.18196598969191, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 36.29549509408725, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.10261529999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.14\"", 0.14122659815171057`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.06\"", 41.05805495874132, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.53\"", 41.53043546947574, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.73\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017289553434700258`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.14122659815171057`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.05805495874132, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 41.53043546947574, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.017289553434700258`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.10268999999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.54\"", 0.5357906739710565, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.12\"", 0.11559224527540383`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.55\"", 38.547275015336425`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.56\"", 41.56113749958525, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5357906739710565, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.11559224527540383`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 38.547275015336425`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 41.56113749958525, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.10285029999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.55\"", 0.5541585846053246, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1426290335891378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.66011112516278, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5541585846053246, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.1426290335891378`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]]) + 
               NumberForm[
                 41.66011112516278, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.1072051}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"5.39\"", 5.388488532154807, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.61084890976613, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.31\"", 0.3135127747178217, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"32.21\"", 32.20832710066633, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 5.388488532154807, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.61084890976613, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.3135127747178217, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "4"]], 
                 Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 32.20832710066633, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.1118295}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.75\"", 2.7530371991874634`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.48\"", 1.475926002952032, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"26.73\"", 26.728435127709723`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.77\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06769853139701822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.7530371991874634`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.475926002952032, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 26.728435127709723`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] - 
               NumberForm[
                0.06769853139701822, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{41., 0.1211005}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.89\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.038939420148409794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.18\"", 39.18371072963305, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.85\"", 21.8462052882725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.88\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09875226201681911, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.038939420148409794`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 39.18371072963305, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 21.8462052882725, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.09875226201681911, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.09210633}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.26\"", 0.2613837425403077, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.54\"", 1.537971234251219, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.0955931972692687`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4258501184519454`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.69\"", 33.68638097098219, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.2613837425403077, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.537971234251219, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                1.0955931972692687`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "4"]], 
                 Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 1.4258501184519454`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 33.68638097098219, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.09438746}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"4.80\"", 4.804997787358584, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.55\"", 1.5515334548896909`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.90\"", 1.9006717189578692`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"74.87\"", 74.87297061060097, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.19839309481075026`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                4.804997787358584, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.5515334548896909`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.9006717189578692`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 74.87297061060097, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.19839309481075026`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.09647179}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.8438575255030141, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                2.527764546077162, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.44921156638948345`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 1.130657927313153, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 94.1141569500062, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1003134}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"4.03\"", 4.0340757366395215`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.65\"", 1.6497530669259788`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6916151024476624, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4863301602932236, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"22.53\"", 22.525643869122245`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                4.0340757366395215`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.6497530669259788`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.6916151024476624, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.4863301602932236, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 22.525643869122245`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1007638}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.35\"", 1.3549222717633242`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3214412937174662, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.67\"", 37.66792160105517, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.97\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04970935950067351, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.3549222717633242`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.3214412937174662, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 37.66792160105517, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.04970935950067351, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1013669}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.58\"", 3.5784966338509947`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7094941200674296`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7129668266286451, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20325703469711126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"23.64\"", 23.643167835772363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.5784966338509947`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7094941200674296`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.7129668266286451, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.20325703469711126`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "7"]], 
                  Hue[
                   Rational[7, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 23.643167835772363`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1013771}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34137677056759286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.71\"", 2.706173995605092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3180494881255718`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2521102772782762, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"103.53\"", 103.53091868397507`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.34137677056759286`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                2.706173995605092, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.3180494881255718`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 0.2521102772782762, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "7"]], 
                  Hue[
                   Rational[7, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 103.53091868397507`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1023306}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.27\"", 3.270545085817316, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9910252284625017, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"19.95\"", 19.945017770533486`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.13\"", 0.12855082281585825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.270545085817316, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.9910252284625017, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 19.945017770533486`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.12855082281585825`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{42., 0.1026197}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.14\"", 0.14356620035591044`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.61\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0016122392755023877`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.33\"", 41.33285041838605, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.79\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.017871299972486904`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.14356620035591044`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.0016122392755023877`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 41.33285041838605, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.017871299972486904`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{44., 0.1147353}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"4.90\"", 4.895959016506049, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.319874548432116, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"27.95\"", 27.952871411648076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.92\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.002921998204547513, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 4.895959016506049, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.319874548432116, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 27.952871411648076`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + (
                 NumberForm[
                  0.002921998204547513, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{44., 0.12063399999999999`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.00\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.08996339524355666, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4851357198533663`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"48.27\"", 48.2721529534372, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.08996339524355666, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4851357198533663`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 48.2721529534372, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.07813515}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.7044153746685882`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4351705392786716`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 39.0054125568516, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 36.22633469690617, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.09483627}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"5.73\"", 5.731009008032428, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.6981071258602871`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.04\"", 1.040220066640162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.11\"", 0.10523566074613683`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.07\"", 21.072689855621764`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                5.731009008032428, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.6981071258602871`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                1.040220066640162, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + (
                 NumberForm[
                  0.10523566074613683`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                   Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 21.072689855621764`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.10046329999999999`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.3374395436350541, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.88\"", 0.8841542521009678, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.99\"", 41.99110394620097, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.59\"", 36.58646456859302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.3374395436350541, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.8841542521009678, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
               NumberForm[
                 41.99110394620097, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 36.58646456859302, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.102702}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"6.20\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06196779934807173, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.88\"", 40.88089182228566, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.57\"", 41.57498146216827, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10209533904171754`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.06196779934807173, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 40.88089182228566, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 41.57498146216827, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.10209533904171754`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.1184016}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3878718536857819, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.84\"", 1.8411646388985723`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"1724.48\"", 1724.4828658601489`, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"45.07\"", 45.067026597599686`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.3878718536857819, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.8411646388985723`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1724.4828658601489`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-1)/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 45.067026597599686`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.07535489000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.844906569833192, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.9331671585071581`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.3694162958661281, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.2449582851700662`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 51.04087439182302, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.07595763}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.327285545019054, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4867827577795298`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.004381834899129271, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]]^3 + 
               NumberForm[
                 0.7387541921476599, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 34.169395285760274`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.0829539}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                7.049735524240697, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 4.947790998755661, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.32760617817725146`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]]^2 + 
               NumberForm[
                 37.27833291350976, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.5129035402029928, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.08310685}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.74\"", 0.7384792522568443, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.29\"", 1.285264518386828, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"8.12\"", 8.123213701923364, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"64.04\"", 64.04375676779595, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.35\"", 0.34804145725483043`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.7384792522568443, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.285264518386828, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 8.123213701923364, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
               NumberForm[
                 64.04375676779595, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.34804145725483043`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.08894483}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6898741078351978, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.60\"", 1.596089617367446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5053563017523753, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.03\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005027584566729023, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"32.28\"", 32.28061386026539, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.6898741078351978, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.596089617367446, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 0.5053563017523753, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.005027584566729023, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]]^3 + 
               NumberForm[
                 32.28061386026539, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.09959254000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.35\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.023487159880212206`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.05\"", 2.048176434710453, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7001756227823914, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.53\"", 39.5263239576966, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.023487159880212206`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.048176434710453, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] - 
               NumberForm[
                0.7001756227823914, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 39.5263239576966, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.10060999999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.96\"", 3.9563497714735996`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2190385883610415`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.85\"", 4.854682493293969, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.74\"", 14.739524643215601`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.35\"", 0.3495160177488737, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.9563497714735996`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.2190385883610415`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 4.854682493293969, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + 
               NumberForm[
                 14.739524643215601`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.3495160177488737, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.10259069999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.54\"", 0.5408329965786647, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"12.64\"", 12.64415348680826, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  SuperscriptBox[
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.62\"", 41.615927441944216`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5408329965786647, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                NumberForm[
                 12.64415348680826, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]^(-2) + 
               NumberForm[
                 41.615927441944216`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.1027109}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"9.42\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09416528563617034, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"8.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.008375030356284304, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.19\"", 41.18624424547026, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.10\"", 0.10164527553265464`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.09416528563617034, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.008375030356284304, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 41.18624424547026, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.10164527553265464`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{48., 0.08416845}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.38\"", 2.3815863564696684`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"12.51\"", 12.508533750856664`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"29.00\"", 28.99814853260185, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.3815863564696684`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 12.508533750856664`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 28.99814853260185, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{48., 0.08455263}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.13\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.01131060349452628, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.57\"", 1.5676754955760699`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"42.09\"", 42.09122779000564, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1894.65\"", 1894.6500023378076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.01131060349452628, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.5676754955760699`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 42.09122779000564, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + (
                 NumberForm[
                  1894.6500023378076`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{48., 0.09802834}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.24\"", 0.23831903616534328`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2517195693311689, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.93\"", 37.930281029104044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.23831903616534328`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.2517195693311689, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 37.930281029104044`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{48., 0.09915122}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                   RowBox[{"\"2.59\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.025888401239006285`, 
                   AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"43.23\"", 43.22967265776525, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"60.46\"", 60.462958755976516`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.025888401239006285`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 43.22967265776525, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 60.462958755976516`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/(Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.07454574}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.1346046653275597`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.5661079421576403, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.9736432501341529, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 41.463770769155424`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 14.128156845155987`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.08138027}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.968456006882272, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.205100037981496, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 23.283052672760757`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 37.98221013200929, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 11.242037793589047`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.08349998}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"7.66\"", 7.6569380414546355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.505929605016708, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9897309759518025, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.1043628156090113`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"36.25\"", 36.2535293671652, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 7.6569380414546355`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.505929605016708, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.9897309759518025, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "4"]], 
                 Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 1.1043628156090113`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 36.2535293671652, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.08620201}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.59\"", 0.587528111969979, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.26\"", 1.2586266338891074`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.14\"", 1.1369402766817056`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"62.97\"", 62.96637726250138, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.84\"", 11.843595200345533`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.587528111969979, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.2586266338891074`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.1369402766817056`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 62.96637726250138, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 11.843595200345533`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.08768011}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6700752445202611`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.6128394340247934`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6853465073594838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.324592179540275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"25.46\"", 25.461775420180842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.6700752445202611`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.6128394340247934`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.6853465073594838, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.324592179540275, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 25.461775420180842`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.09124773}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"5.08\"", 5.079657272389968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.14\"", 2.1416843796551266`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"2\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.701018874083056, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.3327063353751012, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"31.82\"", 31.822493563484503`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[-
                NumberForm[
                 5.079657272389968, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                2.1416843796551266`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "2"]], 
                 Hue[
                  Rational[1, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 1.701018874083056, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.3327063353751012, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "4"]], 
                 Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]] + 
               NumberForm[
                 31.822493563484503`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{50., 0.07874226000000001}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"13.33\"", 13.332881571990963`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"4.89\"", 4.891023200202385, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.3203281568193796, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.02\"", 39.01666051421709, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"3.84\"", 3.8425977098849375`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                13.332881571990963`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 4.891023200202385, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] - 
               NumberForm[
                0.3203281568193796, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]]^2 + 
               NumberForm[
                 39.01666051421709, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                3.8425977098849375`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]^Rational[1, 2], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{50., 0.08590768}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"4.57\"", 4.574057649334719, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7305744270726424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.401252758898537, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.37\"", 1.3673579371682862`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"73.89\"", 73.88690157002681, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.18\"", 0.18102542537128208`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                4.574057649334719, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                1.7305744270726424`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "3"]], 
                 Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.401252758898537, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 1.3673579371682862`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 73.88690157002681, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                0.18102542537128208`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{50., 0.09201679}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"1.19\"", 1.1885141225150353`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"424.86\"", 424.85509285667996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7295798543619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1816964386067825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                1.1885141225150353`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  424.85509285667996`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) (1 + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) - 
               NumberForm[
                1.7295798543619, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]]^Rational[1, 2] + 
               NumberForm[
                 1.1816964386067825`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{51., 0.07669733000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"38.16\"", 38.156252121582966`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.17\"", 0.1732272614251599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.2097737058116267`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.51\"", 36.51001932860815, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 38.156252121582966`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.1732272614251599, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 1.2097737058116267`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + (
                 NumberForm[
                  36.51001932860815, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] + Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{51., 0.08413557}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"3.42\"", 3.417916493069216, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"19.46\"", 19.461536685433543`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.00\"", 38.99826876426373, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.08\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.020836393362705503`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 3.417916493069216, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 19.461536685433543`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 38.99826876426373, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + (
                 NumberForm[
                  0.020836393362705503`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{51., 0.08859675}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"6.24\"", 6.243554728436393, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"33.63\"", 33.63043920857394, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.08\"", 41.07689177167747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"5.13\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.005127556182505385, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 6.243554728436393, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 33.63043920857394, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 41.07689177167747, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + (
                 NumberForm[
                  0.005127556182505385, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{51., 0.10265919999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.71\"", 0.7108357067844768, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.07\"", 41.06637413039861, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 FractionBox[
                  TagBox[
                   InterpretationBox[
                   "\"2.70\"", 2.698214167359468, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                  RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.7108357067844768, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.06637413039861, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - 
               NumberForm[
                2.698214167359468, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/(Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "6"]], 
                 Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]] + Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]]^2 + Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "8"]], 
                 Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{52., 0.0707079}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-5\""]}], 
                    0.000016630662056455233`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.669738076043367, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.368519451653811, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.5324564370095887, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 31.38409410219968, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - ((
                 NumberForm[
                  0.000016630662056455233`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "9"]], 
                 Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]]], 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{52., 0.09986574000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"5.07\"", 5.071685481188336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"24.21\"", 24.214805485555132`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.49\"", 37.48718749549277, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"2.61\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.0026085211939116826`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 5.071685481188336, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 24.214805485555132`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2] + 
               NumberForm[
                 37.48718749549277, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 0.0026085211939116826`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]^2, 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{52., 0.1004547}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.20\"", 0.20030800320363745`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.38803262238392094`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"17.84\"", 17.83820291209179, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "+", 
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[0, 0, 1], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.20030800320363745`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.38803262238392094`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 17.83820291209179, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[0, 0, 1]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{18., 0.19012849999999998`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.8914097926737627, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                 NumberForm[
                  732.5832364133336, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]], 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{25., 0.17032609999999998`}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"6.56\"", 6.558527645565748, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"36.62\"", 36.618371875581836`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 6.558527645565748, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 36.618371875581836`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{26., 0.1028776}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5972434214759587, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 41.135346220113384`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{33., 0.10285029999999999`}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.55\"", 0.5541585846053176, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"40.52\"", 40.517482091573655`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.66\"", 41.6601111251628, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.5541585846053176, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 40.517482091573655`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 41.6601111251628, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{34., 0.09436705000000001}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                0.2792678309107002, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 0.24783345853136146`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 36.819424146231384`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{38., 0.08241967}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"2.62\"", 2.6248961302373313`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.76\"", 1.7586070419485609`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1880569366993785`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"54.59\"", 54.5898093120803, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 2.6248961302373313`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.7586070419485609`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
               NumberForm[
                 1.1880569366993785`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 54.5898093120803, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{45., 0.07813515}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 1.7044153746685882`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.4351705392786716`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 39.0054125568516, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 36.22633469690617, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{46., 0.07535489000000001}}]}, 
              StyleBox[
               RowBox[{
                 RowBox[{"-", 
                   TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                 "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              
              Style[-NumberForm[
                 0.844906569833192, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 1.9331671585071581`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.3694162958661281, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 1.2449582851700662`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 51.04087439182302, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{49., 0.07454574}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                3.1346046653275597`, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
               NumberForm[
                0.5661079421576403, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 0.9736432501341529, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "6"]], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]]] + 
               NumberForm[
                 41.463770769155424`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) + 
               NumberForm[
                 14.128156845155987`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]), 
               RGBColor[1, 0, 0]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], 
               PointBox[{{52., 0.0707079}}]}, 
              StyleBox[
               RowBox[{
                 TagBox[
                  InterpretationBox[
                  "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
                  NumberForm[#, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                 RowBox[{
                   TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                   
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                 FractionBox[
                  RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                  StyleBox[
                   TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                 RowBox[{
                   RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-5\""]}], 
                    0.000016630662056455233`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                   SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                   StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}]}], 
               RGBColor[1, 0, 0], StripOnInput -> False], TooltipDelay -> 
              0.05, TooltipDelay -> 0.05], Annotation[#, 
              Style[
              NumberForm[
                2.669738076043367, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
               NumberForm[
                 2.368519451653811, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] - 
               NumberForm[
                0.5324564370095887, {8, 2}, 
                 ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "5"]], 
                 Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]] + 
               NumberForm[
                 31.38409410219968, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]]) - ((
                 NumberForm[
                  0.000016630662056455233`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                 TraditionalForm[
                  Subscript["column\[Bullet]", "9"]], 
                 Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]]], 
               RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}}}, {
        ImageSize -> 500, DisplayFunction -> Identity, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.02]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, AxesOrigin -> {5.953125, 0}, 
         PlotRange -> {{11., 334.}, {0, 0.9834645}}, PlotRangeClipping -> 
         True, ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
         NCache[
           Rational[3, 5], 0.6], Axes -> {False, False}, 
         AxesLabel -> {None, None}, AxesOrigin -> {5.953125, 0}, 
         DisplayFunction :> Identity, Frame -> {{True, True}, {True, True}}, 
         FrameLabel -> {{
            FormBox["\"1-\\!\\(R\\^2\\)\"", TraditionalForm], None}, {
            FormBox["\"Complexity\"", TraditionalForm], None}}, 
         FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
         GridLines -> {Automatic, Automatic}, GridLinesStyle -> Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 500, 
         Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& ), "CopiedValueFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& )}}, PlotRange -> {{11., 334.}, {0, 0.9834645}},
          PlotRangeClipping -> True, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.02]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}]}}, 
     GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
     AutoDelete -> False, 
     GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{None}}}, 
     GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
     GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
      GridBoxItemStyle -> {"Columns" -> {{
          Directive[
          FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
           FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, "Rows" -> {{
          Directive[
          FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> "Plain", 
           FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}, 
     BaselinePosition -> Center, FrameStyle -> Directive[
       GrayLevel[0.85]]], "Grid"],StyleBox[
   "\"Pareto Front Context Plot 50/50 Split \[LongDash] \
\\!\\(\\*FormBox[RowBox[{\\\"132\\\", \\\" \\\", \
\\\"\\\\\\\"of\\\\\\\"\\\"}], TraditionalForm]\\) 296 unique models \
selected\"", {
    Background -> None, FontFamily -> "Helvetica", FontWeight -> "Bold", 
     FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> "Plain", 
     ShowStringCharacters -> False}, StripOnInput -> False]},
  "Labeled",
  DisplayFunction->(GridBox[{{
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, 
    GridBoxItemSize -> {"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
    BaselinePosition -> {2, 1}]& ),
  InterpretationFunction->(RowBox[{"Labeled", "[", 
     RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )]], "Output",ExpressionUUID->\
"1b7e6f2a-53d7-42da-95aa-9349362292c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Test Results", "Section",
 CellChangeTimes->{{3.7428123261021338`*^9, 
  3.742812327924272*^9}},ExpressionUUID->"c7c38725-8292-46f1-97ff-\
e961c28855e7"],

Cell[CellGroupData[{

Cell["Ensemble 1 (R^2 of 0.935403)", "Subsection",
 CellChangeTimes->{{3.7428123122366*^9, 3.742812316051799*^9}, {
  3.7428123638159847`*^9, 3.74281238029418*^9}, {3.7428129814179173`*^9, 
  3.7428129821997623`*^9}},ExpressionUUID->"7d3197a6-c275-47d2-8c85-\
fd3a3414e939"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, 
     {RGBColor[0, 0, 1], PointSize[0.01], AbsoluteThickness[1.6], 
      PointBox[CompressedData["
1:eJxTTMoPSmViYGCQBGIQDQFGDr/OHilRDDthD+FbOehvqN2uH7YLyrd1kH4l
s+JHyhEo386BI+rOLdm1R+F8twnvvxsowPTbO3zbt1zD1/IQnP+lO3dt1+nD
cP6aMLU/QfZH4Hz38x26M4KPQfgNDg6mSxxCrSsPQOUdHQJeT0ws0NgBlXdy
6Ny95cAi751QeWcHk1NcG0IX74Dzlb6te7aUHer+BmeHhIi7eUW9MHlXB59Y
Tv6ETQh+6uzUBL3PUPMa3Bzmsr72XMWwBSrv7sBzQsWl1GsznL/Ab/eEr4UI
vljc5Ppym61Q/R4O87Sif+eKbobzn/UYxIVdhZnn6RA8f3d/Zt92KN/LIXW+
4LaXkpvsAdVOceA=
       "]]}, 
     {RGBColor[1, 0, 0], PointSize[0.02], AbsoluteThickness[1.6], 
      PointBox[{{18., 0.19012849999999998`}, {26., 0.1028776}, {34., 
       0.09436705000000001}, {45., 0.07813515}, {46., 0.07535489000000001}, {
       49., 0.07454574}, {52., 0.0707079}}]}, {}}, {
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{18., 0.19012849999999998`}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[1, 10], 1, 
             Rational[5, 6]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.8914097926737627, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
          NumberForm[
           732.5832364133336, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "1"]], 
           Hue[
            Rational[1, 10], 1, 
            Rational[5, 6]]]) Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{26., 0.1028776}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.5972434214759587, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          41.135346220113384`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{29., 0.15933139999999998`}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"3.80\"", "\[Times]", 
                  SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[4, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         2.113808720357664, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          68.58401194252002, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + (
          NumberForm[
           0.037977703625019794`, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "6"]], 
            Hue[
             Rational[3, 5], 1, 
             Rational[1, 2]]]) Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{30., 0.16934559999999999`}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          3.882350562760903, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          2.0321890071965854`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          63.363724799250285`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{30., 0.1884824}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"1.22\"", 1.2170341589085145`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.17\"", 1.170553481638129, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"51.09\"", 51.08826447265663, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          1.2170341589085145`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.170553481638129, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          51.08826447265663, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{31., 0.1423737}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"0.44\"", 0.4376907446392891, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"221501.35\"", 221501.3451429473, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           SuperscriptBox[
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 10], 1, 
              Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"2.22\"", 2.216203884016891, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          0.4376907446392891, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
          NumberForm[
           221501.3451429473, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "1"]], 
             Hue[
              Rational[1, 10], 1, 
              Rational[5, 6]]]^(-2)) Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] + 
        NumberForm[
          2.216203884016891, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{31., 0.15464909999999998`}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SqrtBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[4, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         7.249569600913545, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.4456221384884378`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] + 
        NumberForm[
          5.4612970662714355`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]^Rational[1, 2] - 
        NumberForm[
         0.47151508096227146`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "8"]], 
          Hue[
           Rational[4, 5], 1, 
           Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{31., 0.1581825}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[4, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         11.135546219979584`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          8.280454674605123, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] - 
        NumberForm[
         0.5908371539294913, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]]^2 - 
        NumberForm[
         0.8978305425889783, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "8"]], 
          Hue[
           Rational[4, 5], 1, 
           Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{31., 0.1744261}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"4.01\"", "\[Times]", 
                  SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         8.159680560964581, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
        NumberForm[
         0.04011738767128822, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "1"]], 
          Hue[
           Rational[1, 10], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          5.224685491056446, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] - 
        NumberForm[
         0.22854010099263636`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]]^2, 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{33., 0.1286997}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         2.4892598925651224`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          37.870051197694124`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          21.19142255107015, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{34., 0.09436705000000001}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.2792678309107002, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          0.24783345853136146`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          36.819424146231384`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{37., 0.09881036}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"6.26\"", "\[Times]", 
                  SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.42612172604868076`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
         NumberForm[
          0.06256007839813221, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]]) Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          44.23179551124747, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{38., 0.09624229000000001}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[3, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          2.4172135657118963`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.7361891056524232`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] + 
        NumberForm[
          0.7046357704345062, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          71.48309026794081, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{38., 0.1016792}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SqrtBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.5056525266429981, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          0.6158725575337699, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]^Rational[1, 2] + 
        NumberForm[
          38.90598516721604, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{39., 0.09590831}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"0.63\"", 0.6320647414300411, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.87\"", 1.8687964773614916`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"67757.14\"", 67757.13995983037, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           SuperscriptBox[
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 10], 1, 
              Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.43\"", 1.4303812581132638`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          0.6320647414300411, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.8687964773614916`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] + (
          NumberForm[
           67757.13995983037, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "1"]], 
             Hue[
              Rational[1, 10], 1, 
              Rational[5, 6]]]^(-2)) Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          1.4303812581132638`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{42., 0.09647179}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.8438575255030141, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
        NumberForm[
         2.527764546077162, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "3"]], 
          Hue[
           Rational[3, 10], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          0.44921156638948345`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          1.130657927313153, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          94.1141569500062, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{42., 0.1013669}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"3.58\"", 3.5784966338509947`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.71\"", 1.7094941200674296`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.71\"", 0.7129668266286451, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.20\"", 0.20325703469711126`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"7\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[7, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"23.64\"", 23.643167835772363`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         3.5784966338509947`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.7094941200674296`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.7129668266286451, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          0.20325703469711126`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "7"]], 
           Hue[
            Rational[7, 10], 1, 
            Rational[5, 6]]] + 
        NumberForm[
          23.643167835772363`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{45., 0.07813515}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          1.7044153746685882`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.4351705392786716`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          39.0054125568516, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          36.22633469690617, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{46., 0.07535489000000001}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          0.844906569833192, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.9331671585071581`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.3694162958661281, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          1.2449582851700662`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          51.04087439182302, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{46., 0.07595763}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"4.38\"", "\[Times]", 
                  SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          1.327285545019054, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.4867827577795298`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.004381834899129271, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]]^3 + 
        NumberForm[
          0.7387541921476599, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          34.169395285760274`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{46., 0.0829539}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[4, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         7.049735524240697, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          4.947790998755661, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] - 
        NumberForm[
         0.32760617817725146`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]]^2 + 
        NumberForm[
          37.27833291350976, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) - 
        NumberForm[
         0.5129035402029928, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "8"]], 
          Hue[
           Rational[4, 5], 1, 
           Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{49., 0.07454574}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         3.1346046653275597`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
        NumberForm[
         0.5661079421576403, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          0.9736432501341529, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          41.463770769155424`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          14.128156845155987`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{49., 0.08138027}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           TagBox[
            InterpretationBox[
            "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
            NumberForm[#, {8, 2}, 
             ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          0.968456006882272, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.205100037981496, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          23.283052672760757`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "8"]], 
          Hue[
           Rational[4, 5], 1, 
           Rational[1, 2]]] + 
        NumberForm[
          37.98221013200929, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          11.242037793589047`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{50., 0.09201679}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"1.19\"", 1.1885141225150353`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"424.86\"", 424.85509285667996`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{"1", "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[1, 10], 1, 
             Rational[5, 6]], StripOnInput -> False]], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.73\"", 1.7295798543619, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            SqrtBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[1, 2], 1, 
               Rational[5, 6]], StripOnInput -> False]]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.18\"", 1.1816964386067825`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         1.1885141225150353`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
          NumberForm[
           424.85509285667996`, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "1"]], 
           Hue[
            Rational[1, 10], 1, 
            Rational[5, 6]]]) (1 + Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]] + Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]) - 
        NumberForm[
         1.7295798543619, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "5"]], 
           Hue[
            Rational[1, 2], 1, 
            Rational[5, 6]]]^Rational[1, 2] + 
        NumberForm[
          1.1816964386067825`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{52., 0.0707079}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "-", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"1.66\"", "\[Times]", 
                  SuperscriptBox["10", "\"-5\""]}], 0.000016630662056455233`, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False], " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "3"], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"9\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[9, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}]}], 
        RGBColor[0, 0, 1], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         2.669738076043367, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          2.368519451653811, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.5324564370095887, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          31.38409410219968, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) - ((
          NumberForm[
           0.000016630662056455233`, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]) Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]^3) Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "9"]], 
          Hue[
           Rational[9, 10], 1, 
           Rational[5, 6]]], 
        RGBColor[0, 0, 1]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{18., 0.19012849999999998`}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"1\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[1, 10], 1, 
             Rational[5, 6]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.8914097926737627, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
          NumberForm[
           732.5832364133336, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "1"]], 
           Hue[
            Rational[1, 10], 1, 
            Rational[5, 6]]]) Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]], 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{26., 0.1028776}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.5972434214759587, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          41.135346220113384`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{34., 0.09436705000000001}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"4\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             RowBox[{"(", 
               RowBox[{
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]], StripOnInput -> False], "+", 
                 StyleBox[
                  TagBox[
                   FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                  Hue[
                   Rational[3, 5], 1, 
                   Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         0.2792678309107002, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          0.24783345853136146`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "4"]], 
           Hue[
            Rational[2, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          36.819424146231384`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "3"]], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]]] + Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "6"]], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]]])/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{45., 0.07813515}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          1.7044153746685882`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.4351705392786716`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          39.0054125568516, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          36.22633469690617, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{46., 0.07535489000000001}}]},
       StyleBox[
        RowBox[{
          RowBox[{"-", 
            TagBox[
             InterpretationBox[
             "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             SqrtBox[
              StyleBox[
               TagBox[
                FormBox[
                 SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                 TraditionalForm], TraditionalForm, Editable -> True], 
               Hue[
                Rational[2, 5], 1, 
                Rational[1, 2]], StripOnInput -> False]]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[-
         NumberForm[
          0.844906569833192, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          1.9331671585071581`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.3694162958661281, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          1.2449582851700662`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          51.04087439182302, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
             TraditionalForm[
              Subscript["column\[Bullet]", "4"]], 
             Hue[
              Rational[2, 5], 1, 
              Rational[1, 2]]]^Rational[1, 2]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{49., 0.07454574}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"6\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 5], 1, 
              Rational[1, 2]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[3, 10], 1, 
               Rational[5, 6]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         3.1346046653275597`, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
        NumberForm[
         0.5661079421576403, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          0.9736432501341529, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "6"]], 
           Hue[
            Rational[3, 5], 1, 
            Rational[1, 2]]] + 
        NumberForm[
          41.463770769155424`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) + 
        NumberForm[
          14.128156845155987`, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]), 
        RGBColor[1, 0, 0]], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{52., 0.0707079}}]},
       StyleBox[
        RowBox[{
          TagBox[
           InterpretationBox[
           "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
           NumberForm[#, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "-", 
          RowBox[{
            TagBox[
             InterpretationBox[
             "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
             NumberForm[#, {8, 2}, 
              ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"5\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[1, 2], 1, 
              Rational[5, 6]], StripOnInput -> False]}], "+", 
          FractionBox[
           RowBox[{
             TagBox[
              InterpretationBox[
              "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
              NumberForm[#, {8, 2}, 
               ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False]}], 
           StyleBox[
            TagBox[
             FormBox[
              SubscriptBox["\"column\[Bullet]\"", "\"8\""], TraditionalForm], 
             TraditionalForm, Editable -> True], 
            Hue[
             Rational[4, 5], 1, 
             Rational[1, 2]], StripOnInput -> False]], "-", 
          RowBox[{
            RowBox[{"(", 
              TagBox[
               InterpretationBox[
                RowBox[{"\"1.66\"", "\[Times]", 
                  SuperscriptBox["10", "\"-5\""]}], 0.000016630662056455233`, 
                AutoDelete -> True], 
               NumberForm[#, {8, 2}, 
                ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], ")"}], 
            " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"3\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[3, 10], 1, 
              Rational[5, 6]], StripOnInput -> False], " ", 
            SuperscriptBox[
             StyleBox[
              TagBox[
               FormBox[
                SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                TraditionalForm], TraditionalForm, Editable -> True], 
              Hue[
               Rational[2, 5], 1, 
               Rational[1, 2]], StripOnInput -> False], "3"], " ", 
            StyleBox[
             TagBox[
              FormBox[
               SubscriptBox["\"column\[Bullet]\"", "\"9\""], TraditionalForm],
               TraditionalForm, Editable -> True], 
             Hue[
              Rational[9, 10], 1, 
              Rational[5, 6]], StripOnInput -> False]}]}], 
        RGBColor[1, 0, 0], StripOnInput -> False],
       TooltipDelay->0.05],
      Annotation[#, 
       Style[
       NumberForm[
         2.669738076043367, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
        NumberForm[
          2.368519451653811, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "3"]], 
           Hue[
            Rational[3, 10], 1, 
            Rational[5, 6]]] - 
        NumberForm[
         0.5324564370095887, {8, 2}, 
          ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "5"]], 
          Hue[
           Rational[1, 2], 1, 
           Rational[5, 6]]] + 
        NumberForm[
          31.38409410219968, {8, 2}, 
           ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]/Style[
           TraditionalForm[
            Subscript["column\[Bullet]", "8"]], 
           Hue[
            Rational[4, 5], 1, 
            Rational[1, 2]]]) - ((
          NumberForm[
           0.000016630662056455233`, {8, 2}, 
            ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "3"]], 
            Hue[
             Rational[3, 10], 1, 
             Rational[5, 6]]]) Style[
            TraditionalForm[
             Subscript["column\[Bullet]", "4"]], 
            Hue[
             Rational[2, 5], 1, 
             Rational[1, 2]]]^3) Style[
          TraditionalForm[
           Subscript["column\[Bullet]", "9"]], 
          Hue[
           Rational[9, 10], 1, 
           Rational[5, 6]]], 
        RGBColor[1, 0, 0]], "Tooltip"]& ]}}, {}, {}, {}, {}},
  AspectRatio->NCache[
    Rational[3, 5], 0.6],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{17.46875, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"1-\\!\\(R\\^2\\)\"", TraditionalForm], None}, {
     FormBox["\"Complexity\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{Automatic, Automatic},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->500,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotLabel->FormBox[
    StyleBox[
    "\"Ensemble1 \[LongDash] 25 unique models\"", {
     Background -> None, FontFamily -> "Helvetica", FontWeight -> "Bold", 
      FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> "Plain", 
      ShowStringCharacters -> False}, StripOnInput -> False], TraditionalForm],
  PlotRange->{{18., 52.}, {0, 0.19012849999999998`}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",ExpressionUUID->"3c2a0422-75fa-\
4305-8ff6-46319856289b"],

Cell[BoxData[
 TemplateBox[{TemplateBox[{
     TemplateBox[{
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Expression\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], 
           PaneBox[
            ItemBox[
             TemplateBox[{
               TagBox[
                GridBox[{{
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.80\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2170341589085145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.17\"", 1.170553481638129, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.09\"", 51.08826447265663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4376907446392891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"221501.35\"", 221501.3451429473, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.22\"", 2.216203884016891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6320647414300411, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.87\"", 1.8687964773614916`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"67757.14\"", 67757.13995983037, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4303812581132638`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.58\"", 3.5784966338509947`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7094941200674296`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7129668266286451, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20325703469711126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"23.64\"", 23.643167835772363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1885141225150353`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"424.86\"", 424.85509285667996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7295798543619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1816964386067825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-5\""]}], 
                    0.000016630662056455233`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Center}}, "Rows" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxDividers -> {
                  "Columns" -> {{True}}, "Rows" -> {{True}}}, 
                 GridBoxFrame -> {
                  "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}, BaselinePosition -> Center, FrameStyle -> 
                 Directive[
                   GrayLevel[0.85]]], "Grid"], 
               StyleBox[
               "\"MedianAverage[models, 0.7]\"", {
                FontWeight -> "Bold", FontSize -> 12, FontFamily -> 
                 "Helvetica", FontSlant -> "Plain", FontColor -> GrayLevel[0],
                  Background -> None, ShowStringCharacters -> False}, 
                StripOnInput -> False]}, "Labeled", 
              DisplayFunction -> (GridBox[{{
                  ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
                  TagBox[
                   ItemBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], DefaultBaseStyle -> "Labeled"], 
                   "SkipImageSizeLevel"]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Center}}, "Rows" -> {{Center}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {2, 1}]& ), 
              InterpretationFunction -> (RowBox[{"Labeled", "[", 
                 RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )], BaseStyle -> 
             Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]], 
             StripOnInput -> False], Alignment -> Center, ImageSize -> 500]}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Ensemble\\\\\\\"\
\\\"}, {\\\"\\\\\\\"Quality\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             "\"This uses values embedded in the ensemble rather\\nthan being \
recalculated using the supplied data\"", TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "This uses values embedded in the ensemble rather\nthan being \
recalculated using the supplied data", "Tooltip"]& ], 
           TagBox[
            GridBox[{{
               StyleBox[
               "\"\\!\\(R\\^2\\)\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None], 
               "0.9354034859048082`"}, {
               StyleBox[
               "\"# Variables\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "8"}, {
               StyleBox[
               "\"# Models\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "25"}, {
               StyleBox[
               "\"Avg Model Complexity\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None], "37.72`"}}, 
             AutoDelete -> False, BaselinePosition -> Center, FrameStyle -> 
             Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Model\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Quality\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             "\"This uses values embedded in the model rather\\nthan being \
recalculated using the supplied data\"", TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "This uses values embedded in the model rather\nthan being \
recalculated using the supplied data", "Tooltip"]& ], 
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Model\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], 
               StyleBox[
               "\"Complexity\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], 
               StyleBox[
               "\"1-\\!\\(R\\^2\\)\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None]}, {
               StyleBox[
               "\"1\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "18", "0.19012849999999998`"}, {
               StyleBox[
               "\"2\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "26", "0.1028776`"}, {
               StyleBox[
               "\"3\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "29", "0.15933139999999998`"}, {
               StyleBox[
               "\"4\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "30", "0.16934559999999999`"}, {
               StyleBox[
               "\"5\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "30", "0.1884824`"}, {
               StyleBox[
               "\"6\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.1423737`"}, {
               StyleBox[
               "\"7\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.15464909999999998`"}, {
               StyleBox[
               "\"8\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.1581825`"}, {
               StyleBox[
               "\"9\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.1744261`"}, {
               StyleBox[
               "\"10\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "33", "0.1286997`"}, {
               StyleBox[
               "\"11\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "34", "0.09436705000000001`"}, {
               StyleBox[
               "\"12\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "37", "0.09881036`"}, {
               StyleBox[
               "\"13\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "38", "0.09624229000000001`"}, {
               StyleBox[
               "\"14\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "38", "0.1016792`"}, {
               StyleBox[
               "\"15\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "39", "0.09590831`"}, {
               StyleBox[
               "\"16\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "42", "0.09647179`"}, {
               StyleBox[
               "\"17\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "42", "0.1013669`"}, {
               StyleBox[
               "\"18\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "45", "0.07813515`"}, {
               StyleBox[
               "\"19\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "46", "0.07535489000000001`"}, {
               StyleBox[
               "\"20\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "46", "0.07595763`"}, {
               StyleBox[
               "\"21\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "46", "0.0829539`"}, {
               StyleBox[
               "\"22\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "49", "0.07454574`"}, {
               StyleBox[
               "\"23\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "49", "0.08138027`"}, {
               StyleBox[
               "\"24\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "50", "0.09201679`"}, {
               StyleBox[
               "\"25\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "52", "0.0707079`"}}, AutoDelete -> 
             False, BaselinePosition -> Center, FrameStyle -> Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Variables\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], 
           TagBox[
            GridBox[{{
               StyleBox[
               "column\[Bullet]1", StripOnInput -> False, LineColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]]], 
               StyleBox[
               "column\[Bullet]3", StripOnInput -> False, LineColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]4", StripOnInput -> False, LineColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]5", StripOnInput -> False, LineColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]6", StripOnInput -> False, LineColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]7", StripOnInput -> False, LineColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]8", StripOnInput -> False, LineColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]9", StripOnInput -> False, LineColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]]]}}, AutoDelete -> False, BaselinePosition -> 
             Center, FrameStyle -> Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"R-Squared\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], "0.9279704054189611`"}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Adjusted\\\\\\\"\\\
\"}, {\\\"\\\\\\\"R-Squared\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
            ShowStringCharacters -> False, FontFamily -> "Helvetica", 
            FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
            FontColor -> GrayLevel[0], Background -> None], 
           "0.9268622578100221`"}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Noise\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Power\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             
             "\"The noise power, \
\\!\\(\\*FractionBox[SuperscriptBox[SubscriptBox[\\(\[Sigma]\\), \
\\(error\\)], \\(2\\)], SuperscriptBox[SubscriptBox[\\(\[Sigma]\\), \
\\(observed\\)], \\(2\\)]]\\), is the ratio of the energy (2-norm) of \
the\\nprediction error normalized by the energy of the observed response.\"", 
             TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "The noise power, \!\(\*FractionBox[SuperscriptBox[SubscriptBox[\
\(\[Sigma]\), \(error\)], \(2\)], SuperscriptBox[SubscriptBox[\(\[Sigma]\), \
\(observed\)], \(2\)]]\), is the ratio of the energy (2-norm) of the\n\
prediction error normalized by the energy of the observed response.", 
             "Tooltip"]& ], "0.02059327100064474`"}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"ANOVA\\\\\\\"\\\
\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
              FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
              None], "\"WARNING: This is calculated aginst the supplied data \
using the\\ntop-level bases with the associated coefficients ignored.\"", 
             TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "WARNING: This is calculated aginst the supplied data using the\n\
top-level bases with the associated coefficients ignored.", "Tooltip"]& ], 
           PaneBox[
            TagBox[
             DynamicModuleBox[{Typeset`var$$ = 1}, 
              InterpretationBox[
               TagBox[
                PanelBox[
                 GridBox[{{
                    ItemBox[
                    GridBox[{{
                    GridBox[{{
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[FirstPage]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ =!= 1, Typeset`var$$ = 1], Enabled -> 
                    Automatic, Evaluator -> Automatic, ImageSize -> Small, 
                    Method -> "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipFirstSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipFirstSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[LeftPointer]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ > 1, 
                    PreDecrement[Typeset`var$$]], Enabled -> Automatic, 
                    Evaluator -> Automatic, ImageSize -> Small, Method -> 
                    "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipPreviousSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipPreviousSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[RightPointer]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ < 25, 
                    PreIncrement[Typeset`var$$]], Enabled -> Automatic, 
                    Evaluator -> Automatic, ImageSize -> Small, Method -> 
                    "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipNextSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipNextSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[LastPage]\"", StripOnInput -> False, FontSize -> 18],
                     Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ =!= 25, Typeset`var$$ = 25], Enabled -> 
                    Automatic, Evaluator -> Automatic, ImageSize -> Small, 
                    Method -> "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipLastSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipLastSlide"]], 
                    "Tooltip"]& ]}}, AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}]}}, AutoDelete -> 
                    False, GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    Alignment -> Left, StripOnInput -> False]}, {
                    ItemBox[
                    StyleBox[
                    PaneSelectorBox[{1 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]1"], "1", 
                    "2483.680713651287`", "2483.680713651287`", 
                    "182.44377433203175`", "1.546689729460779`*^-20"}, {
                    "\"Error\"", "65", "884.8712266472207`", 
                    "13.613403486880319`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 2 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "2948.551938695938`", 
                    "2948.551938695938`", "456.3235125808232`", 
                    "4.320242444005296`*^-31"}, {
                    "\"Error\"", "65", "420.0000016025697`", 
                    "6.46153848619338`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 3 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.80\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "2620.4792353510866`", "2620.4792353510866`", 
                    "379.5190643128533`", "1.3379994865914068`*^-28"}, {
                    RowBox[{"column\[Bullet]6", " ", "column\[Bullet]8"}], 
                    "1", "306.16955216082306`", "306.16955216082306`", 
                    "44.34195867291161`", "7.351380752823406`*^-9"}, {
                    "\"Error\"", "64", "441.90315278659807`", 
                    "6.904736762290595`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 4 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "126.29374051726167`", 
                    "8.691108933291702`*^-17"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "1177.5229624264607`", "1177.5229624264607`", 
                    "102.26941374491662`", "6.7674154808517424`*^-15"}, {
                    "\"Error\"", "64", "736.8915772144961`", 
                    "11.513930893976502`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 5 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2170341589085145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.17\"", 1.170553481638129, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.09\"", 51.08826447265663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]4", "1", "2328.1835886742692`", 
                    "2328.1835886742692`", "320.81399698836606`", 
                    "1.2737401090864183`*^-26"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "575.9130875961023`", "575.9130875961023`", 
                    "79.3584236433968`", "8.177611280837822`*^-13"}, {
                    "\"Error\"", "64", "464.4552640281362`", 
                    "7.257113500439628`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 6 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4376907446392891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"221501.35\"", 221501.3451429473, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.22\"", 2.216203884016891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]3", 
                    SuperscriptBox["column\[Bullet]1", "2"]], "1", 
                    "1419.2682217609483`", "1419.2682217609483`", 
                    "140.0074341290238`", "9.226335974705387`*^-18"}, {
                    "column\[Bullet]6", "1", "1300.5098390806058`", 
                    "1300.5098390806058`", "128.29220216268163`", 
                    "6.205763868679455`*^-17"}, {
                    "\"Error\"", "64", "648.7738794569539`", 
                    "10.137091866514904`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 7 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "411.95617762113596`", 
                    "2.4835473650303474`*^-29"}, {
                    SqrtBox["column\[Bullet]4"], "1", "187.7140095943114`", 
                    "187.7140095943114`", "31.2511701531435`", 
                    "5.210365514401743`*^-7"}, {
                    "column\[Bullet]8", "1", "327.955045169002`", 
                    "327.955045169002`", "54.598902560914325`", 
                    "4.1809651197068507`*^-10"}, {
                    "\"Error\"", "63", "378.41727354494157`", 
                    "6.006623389602247`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 8 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "87.2296172043491`", 
                    "1.6800294998417172`*^-13"}, {
                    SuperscriptBox["column\[Bullet]6", "2"], "1", 
                    "45.72194978555876`", "45.72194978555876`", 
                    "2.742731309866094`", "0.10267070075664675`"}, {
                    "column\[Bullet]8", "1", "818.4683749902408`", 
                    "818.4683749902408`", "49.09761829382847`", 
                    "1.9433774420568964`*^-9"}, {
                    "\"Error\"", "63", "1050.2242148651571`", 
                    "16.67022563278027`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 9 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
                    BaseStyle -> Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                     StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]1", "1", "150.30256741333596`", 
                    "150.30256741333596`", "17.599168020788028`", 
                    "0.00008698280231639891`"}, {
                    "column\[Bullet]4", "1", "2522.2132280652677`", 
                    "2522.2132280652677`", "295.32998104353265`", 
                    "1.821496237406981`*^-25"}, {
                    SuperscriptBox["column\[Bullet]4", "2"], "1", 
                    "157.99583883183868`", "157.99583883183868`", 
                    "18.499985476230524`", "0.000060241873524132396`"}, {
                    "\"Error\"", "63", "538.0403059880655`", 
                    "8.54032231727088`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 10 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "2620.4792353510866`", "2620.4792353510866`", 
                    "474.8931471600359`", "2.590589535204342`*^-31"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "394.9181646778561`", "394.9181646778561`", 
                    "71.5685617975926`", "4.998508269220859`*^-12"}, {
                    "\"Error\"", "64", "353.15454026956536`", 
                    "5.518039691711959`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 11 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]4", "1", "2328.1835886742692`", 
                    "2328.1835886742692`", "520.8390888152892`", 
                    "1.8797918071378162`*^-32"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "754.2843136268602`", 
                    "754.2843136268602`", "168.74131255292684`", 
                    "1.3253345139356597`*^-19"}, {
                    "\"Error\"", "64", "286.0840379973786`", 
                    "4.47006309370904`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 12 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    RowBox[{"column\[Bullet]3", " ", "column\[Bullet]5"}], 
                    "1", "2105.044334098867`", "2105.044334098867`", 
                    "344.0815874865773`", "1.9356904525074272`*^-27"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "871.9643144866459`", 
                    "871.9643144866459`", "142.5275756430311`", 
                    "6.212225122978837`*^-18"}, {
                    "\"Error\"", "64", "391.54329171299537`", 
                    "6.117863933015553`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 13 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "615.8928918975049`", 
                    "3.151383058141268`*^-34"}, {
                    "column\[Bullet]4", "1", "192.87638476116945`", 
                    "192.87638476116945`", "48.00680753601049`", 
                    "2.6601592194704165`*^-9"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]6"], "column\[Bullet]8"], "1", 
                    "448.0955861543571`", "448.0955861543571`", 
                    "111.5307018476366`", "1.4267621871869728`*^-15"}, {
                    "\"Error\"", "63", "253.11435739272815`", 
                    "4.0176882125829865`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 14 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    SqrtBox["column\[Bullet]3"], "1", "2831.0739775144216`", 
                    "2831.0739775144216`", "630.6540211463608`", 
                    "7.562101393129175`*^-35"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "250.17505423912826`", 
                    "250.17505423912826`", "55.72934695437907`", 
                    "2.826759892574983`*^-10"}, {
                    "\"Error\"", "64", "287.3029085449581`", 
                    "4.48910794601497`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 15 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6320647414300411, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.87\"", 1.8687964773614916`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"67757.14\"", 67757.13995983037, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4303812581132638`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "260.9886928971925`", 
                    "4.399859672585616`*^-24"}, {
                    FractionBox["column\[Bullet]4", 
                    SuperscriptBox["column\[Bullet]1", "2"]], "1", 
                    "84.13024325542528`", "84.13024325542528`", 
                    "8.873448115003661`", "0.004105061662725922`"}, {
                    "column\[Bullet]6", "1", "212.64540532620276`", 
                    "212.64540532620276`", "22.42829567635065`", 
                    "0.000012811522024052728`"}, {
                    "\"Error\"", "63", "597.3106797266269`", 
                    "9.481121900422648`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 16 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "550.4740249787889`", 
                    "1.5517862495063123`*^-32"}, {
                    "column\[Bullet]4", "1", "192.87638476116945`", 
                    "192.87638476116945`", "42.907623904072544`", 
                    "1.2821315364789258`*^-8"}, {
                    "column\[Bullet]6", "1", "1.9787934822829811`", 
                    "1.9787934822829811`", "0.440205920630267`", 
                    "0.509482662032176`"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "420.53159117225096`", "420.53159117225096`", 
                    "93.55220638412143`", "5.3210222132688726`*^-14"}, {
                    "\"Error\"", "62", "278.69955889255124`", 
                    "4.49515417568631`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 17 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.58\"", 3.5784966338509947`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7094941200674296`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7129668266286451, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20325703469711126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"23.64\"", 23.643167835772363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "484.38554655959024`", 
                    "5.382075575038363`*^-31"}, {
                    "column\[Bullet]5", "1", "5.164176210780624`", 
                    "5.164176210780624`", "1.0109060737267825`", 
                    "0.31859386868386297`"}, {
                    "column\[Bullet]7", "1", "127.76209762294275`", 
                    "127.76209762294275`", "25.00989029179227`", 
                    "4.974596979727383`*^-6"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "444.4353523585032`", "444.4353523585032`", 
                    "86.99981928196044`", "2.048796312694095`*^-13"}, {
                    "\"Error\"", "62", "316.72470211602814`", 
                    "5.108462937355292`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 18 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "313.4348289186167`", 
                    "3.836924823208056`*^-26"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1492.0538258993606`", "1492.0538258993606`", 
                    "321.6075973609235`", "1.9465140573109833`*^-26"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "130.0809547961967`", "130.0809547961967`", 
                    "28.038548347411627`", "1.6068855570962655`*^-6"}, {
                    "\"Error\"", "63", "292.2797589453992`", 
                    "4.639361253101574`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 19 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "548.4711068659574`", 
                    "1.71794312713935`*^-32"}, {
                    "column\[Bullet]5", "1", "5.164176210780624`", 
                    "5.164176210780624`", "1.1446517699227787`", 
                    "0.28881909427653196`"}, {
                    "column\[Bullet]6", "1", "128.81103909358671`", 
                    "128.81103909358671`", "28.551268947071513`", 
                    "1.384689549268551`*^-6"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "480.39379330761085`", "480.39379330761085`", 
                    "106.48041107147912`", "4.373966982448835`*^-15"}, {
                    "\"Error\"", "62", "279.7173196962766`", 
                    "4.51156967252059`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 20 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "506.5717209170595`", 
                    "1.5632843620951457`*^-31"}, {
                    SuperscriptBox["column\[Bullet]4", "3"], "1", 
                    "73.01626856653138`", "73.01626856653138`", 
                    "14.947864558497528`", "0.000267396013021589`"}, {
                    "column\[Bullet]6", "1", "70.73514801822466`", 
                    "70.73514801822466`", "14.48087437032289`", 
                    "0.000326569542772727`"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "447.4817092872054`", "447.4817092872054`", 
                    "91.60829653648057`", "7.889320097139959`*^-14"}, {
                    "\"Error\"", "62", "302.85320243629326`", 
                    "4.884729071553117`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 21 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "269.0573746888656`", 
                    "3.1232952848238678`*^-24"}, {
                    SuperscriptBox["column\[Bullet]6", "2"], "1", 
                    "45.72194978555876`", "45.72194978555876`", 
                    "8.459879905018452`", "0.005033536581247921`"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1451.6122957793875`", "1451.6122957793875`", 
                    "268.590157430699`", "3.2635845750230933`*^-24"}, {
                    "column\[Bullet]8", "1", "81.9974183695781`", 
                    "81.9974183695781`", "15.171888232712366`", 
                    "0.00024307549117042572`"}, {
                    "\"Error\"", "62", "335.08287570643245`", 
                    "5.404562511394071`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 22 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]5", "1", "433.9827101430128`", 
                    "433.9827101430128`", "103.19610147580498`", 
                    "8.096953137138698`*^-15"}, {
                    "column\[Bullet]6", "1", "1023.8879020280781`", 
                    "1023.8879020280781`", "243.4687773683875`", 
                    "3.8169270632665933`*^-23"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1488.4668339515213`", "1488.4668339515213`", 
                    "353.9403087952821`", "2.582520173311955`*^-27"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "161.47859772175207`", "161.47859772175207`", 
                    "38.3977549501298`", "5.164670409816981`*^-8"}, {
                    "\"Error\"", "62", "260.7358964541437`", 
                    "4.205417684744253`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 23 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "366.5938198398049`", 
                    "1.0174249676304984`*^-27"}, {
                    FractionBox["1", "column\[Bullet]8"], "1", 
                    "482.85274416173434`", "482.85274416173434`", 
                    "121.72909645425469`", "2.91486778020785`*^-16"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1071.0941645559965`", "1071.0941645559965`", 
                    "270.02709717468974`", "2.851637772660299`*^-24"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "114.53735615709638`", "114.53735615709638`", 
                    "28.87532284706738`", "1.2351695869236348`*^-6"}, {
                    "\"Error\"", "62", "245.93027476612943`", 
                    "3.9666173349375713`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 24 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1885141225150353`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"424.86\"", 424.85509285667996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7295798543619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1816964386067825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox[
                    
                    RowBox[{"1", "+", "column\[Bullet]3", "+", 
                    "column\[Bullet]4"}], "column\[Bullet]1"], "1", 
                    "2530.5456285289747`", "2530.5456285289747`", 
                    "347.48001518608976`", "2.4891608927898902`*^-27"}, {
                    SqrtBox["column\[Bullet]5"], "1", "107.75200716524796`", 
                    "107.75200716524796`", "14.795887757960381`", 
                    "0.0002819143156199056`"}, {
                    "column\[Bullet]6", "1", "271.45274011158426`", 
                    "271.45274011158426`", "37.27433372189794`", 
                    "7.023077379527653`*^-8"}, {
                    "\"Error\"", "63", "458.8015644927008`", 
                    "7.282564515757155`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 25 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-5\""]}], 
                    0.000016630662056455233`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "589.0658328473589`", 
                    "2.326925923414222`*^-33"}, {
                    "column\[Bullet]5", "1", "5.164176210780624`", 
                    "5.164176210780624`", "1.2293724131115507`", 
                    "0.27181162992334695`"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "535.6825650558949`", "535.6825650558949`", 
                    "127.52341143777562`", "1.1050509758935025`*^-16"}, {
                    RowBox[{"column\[Bullet]3", " ", 
                    SuperscriptBox["column\[Bullet]4", "3"], " ", 
                    "column\[Bullet]9"}], "1", "92.79863224739847`", 
                    "92.79863224739847`", "22.091437976356445`", 
                    "0.000014919046915917597`"}, {
                    "\"Error\"", "62", "260.44095479418115`", 
                    "4.20066056119647`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"]}, 
                    Dynamic[Typeset`var$$], Alignment -> {Center, Top}, 
                    ImageSize -> Automatic, TransitionDirection -> Horizontal,
                     TransitionDuration -> 0.5, TransitionEffect -> 
                    Automatic], Deployed -> False, StripOnInput -> False], 
                    Background -> GrayLevel[1], Frame -> True, FrameStyle -> 
                    GrayLevel[0.8235294117647058], StripOnInput -> False]}}, 
                  AutoDelete -> False, 
                  GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                 BaseStyle -> {}, BaselinePosition -> Center, 
                 DefaultBaseStyle -> "SlideView", FrameMargins -> 6, 
                 ImageMargins -> Automatic], Deploy, DefaultBaseStyle -> 
                "Deploy"], 
               SlideView[{
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.8914097926737627, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    732.5832364133336, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1^(-1) \
$CellContext`column\[Bullet]4, 1, 2483.680713651287, 2483.680713651287, 
                    182.44377433203175`, 1.546689729460779*^-20}, {
                    "Error", 65, 884.8712266472207, 13.613403486880319`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.5972434214759587, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    41.135346220113384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    2948.551938695938, 2948.551938695938, 456.3235125808232, 
                    4.320242444005296*^-31}, {
                    "Error", 65, 420.0000016025697, 6.46153848619338}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    2.113808720357664, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    68.58401194252002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                    NumberForm[
                    0.037977703625019794`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    2620.4792353510866`, 2620.4792353510866`, 
                    379.5190643128533, 
                    1.3379994865914068`*^-28}, {$CellContext`column\[Bullet]6 \
$CellContext`column\[Bullet]8, 1, 306.16955216082306`, 306.16955216082306`, 
                    44.34195867291161, 7.351380752823406*^-9}, {
                    "Error", 64, 441.90315278659807`, 6.904736762290595}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    3.882350562760903, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    2.0321890071965854`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    63.363724799250285`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 126.29374051726167`,
                     8.691108933291702*^-17}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    1177.5229624264607`, 1177.5229624264607`, 
                    102.26941374491662`, 6.7674154808517424`*^-15}, {
                    "Error", 64, 736.8915772144961, 11.513930893976502`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    1.2170341589085145`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.170553481638129, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    51.08826447265663, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]4, 1, 
                    2328.1835886742692`, 2328.1835886742692`, 
                    320.81399698836606`, 
                    1.2737401090864183`*^-26}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    575.9130875961023, 575.9130875961023, 79.3584236433968, 
                    8.177611280837822*^-13}, {
                    "Error", 64, 464.4552640281362, 7.257113500439628}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.4376907446392891, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    221501.3451429473, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    2.216203884016891, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1^(-2) \
$CellContext`column\[Bullet]3, 1, 1419.2682217609483`, 1419.2682217609483`, 
                    140.0074341290238, 
                    9.226335974705387*^-18}, {$CellContext`column\[Bullet]6, 
                    1, 1300.5098390806058`, 1300.5098390806058`, 
                    128.29220216268163`, 6.205763868679455*^-17}, {
                    "Error", 64, 648.7738794569539, 10.137091866514904`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    7.249569600913545, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.4456221384884378`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    5.4612970662714355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                    NumberForm[
                    0.47151508096227146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 411.95617762113596`,
                     2.4835473650303474`*^-29}, \
{$CellContext`column\[Bullet]4^Rational[1, 2], 1, 187.7140095943114, 
                    187.7140095943114, 31.2511701531435, 
                    5.210365514401743*^-7}, {$CellContext`column\[Bullet]8, 1,
                     327.955045169002, 327.955045169002, 54.598902560914325`, 
                    4.1809651197068507`*^-10}, {
                    "Error", 63, 378.41727354494157`, 6.006623389602247}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    11.135546219979584`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    8.280454674605123, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.5908371539294913, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 - 
                    NumberForm[
                    0.8978305425889783, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 87.2296172043491, 
                    1.6800294998417172`*^-13}, \
{$CellContext`column\[Bullet]6^2, 1, 45.72194978555876, 45.72194978555876, 
                    2.742731309866094, 
                    0.10267070075664675`}, {$CellContext`column\[Bullet]8, 1, 
                    818.4683749902408, 818.4683749902408, 49.09761829382847, 
                    1.9433774420568964`*^-9}, {
                    "Error", 63, 1050.2242148651571`, 16.67022563278027}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    8.159680560964581, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    0.04011738767128822, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    5.224685491056446, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.22854010099263636`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2, BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1, 1, 
                    150.30256741333596`, 150.30256741333596`, 
                    17.599168020788028`, 
                    0.00008698280231639891}, {$CellContext`column\[Bullet]4, 
                    1, 2522.2132280652677`, 2522.2132280652677`, 
                    295.32998104353265`, 
                    1.821496237406981*^-25}, {$CellContext`column\[Bullet]4^2,
                     1, 157.99583883183868`, 157.99583883183868`, 
                    18.499985476230524`, 0.000060241873524132396`}, {
                    "Error", 63, 538.0403059880655, 8.54032231727088}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    2.4892598925651224`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    37.870051197694124`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    21.19142255107015, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    2620.4792353510866`, 2620.4792353510866`, 
                    474.8931471600359, 
                    2.590589535204342*^-31}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    394.9181646778561, 394.9181646778561, 71.5685617975926, 
                    4.998508269220859*^-12}, {
                    "Error", 64, 353.15454026956536`, 5.518039691711959}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.2792678309107002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.24783345853136146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    36.819424146231384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]4, 1, 
                    2328.1835886742692`, 2328.1835886742692`, 
                    520.8390888152892, 
                    1.8797918071378162`*^-32}, \
{($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    754.2843136268602, 754.2843136268602, 168.74131255292684`,
                     1.3253345139356597`*^-19}, {
                    "Error", 64, 286.0840379973786, 4.47006309370904}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.42612172604868076`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                    NumberForm[
                    0.06256007839813221, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    44.23179551124747, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3 \
$CellContext`column\[Bullet]5, 1, 2105.044334098867, 2105.044334098867, 
                    344.0815874865773, 
                    1.9356904525074272`*^-27}, \
{($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    871.9643144866459, 871.9643144866459, 142.5275756430311, 
                    6.212225122978837*^-18}, {
                    "Error", 64, 391.54329171299537`, 6.117863933015553}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    2.4172135657118963`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.7361891056524232`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.7046357704345062, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    71.48309026794081, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 615.8928918975049, 
                    3.151383058141268*^-34}, {$CellContext`column\[Bullet]4, 
                    1, 192.87638476116945`, 192.87638476116945`, 
                    48.00680753601049, 
                    2.6601592194704165`*^-9}, {$CellContext`column\[Bullet]6^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    448.0955861543571, 448.0955861543571, 111.5307018476366, 
                    1.4267621871869728`*^-15}, {
                    "Error", 63, 253.11435739272815`, 4.0176882125829865`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.5056525266429981, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.6158725575337699, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                    NumberForm[
                    38.90598516721604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3^
                    Rational[1, 2], 1, 2831.0739775144216`, 
                    2831.0739775144216`, 630.6540211463608, 
                    7.562101393129175*^-35}, {($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    250.17505423912826`, 250.17505423912826`, 
                    55.72934695437907, 2.826759892574983*^-10}, {
                    "Error", 64, 287.3029085449581, 4.48910794601497}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.6320647414300411, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.8687964773614916`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + (
                    NumberForm[
                    67757.13995983037, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    1.4303812581132638`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 260.9886928971925, 
                    4.399859672585616*^-24}, \
{$CellContext`column\[Bullet]1^(-2) $CellContext`column\[Bullet]4, 1, 
                    84.13024325542528, 84.13024325542528, 8.873448115003661, 
                    0.004105061662725922}, {$CellContext`column\[Bullet]6, 1, 
                    212.64540532620276`, 212.64540532620276`, 
                    22.42829567635065, 0.000012811522024052728`}, {
                    "Error", 63, 597.3106797266269, 9.481121900422648}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.8438575255030141, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    2.527764546077162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.44921156638948345`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    1.130657927313153, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    94.1141569500062, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 550.4740249787889, 
                    1.5517862495063123`*^-32}, {$CellContext`column\[Bullet]4,
                     1, 192.87638476116945`, 192.87638476116945`, 
                    42.907623904072544`, 
                    1.2821315364789258`*^-8}, {$CellContext`column\[Bullet]6, 
                    1, 1.9787934822829811`, 1.9787934822829811`, 
                    0.440205920630267, 
                    0.509482662032176}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    420.53159117225096`, 420.53159117225096`, 
                    93.55220638412143, 5.3210222132688726`*^-14}, {
                    "Error", 62, 278.69955889255124`, 4.49515417568631}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    3.5784966338509947`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.7094941200674296`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.7129668266286451, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.20325703469711126`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "7"]], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    23.643167835772363`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 484.38554655959024`,
                     5.382075575038363*^-31}, {$CellContext`column\[Bullet]5, 
                    1, 5.164176210780624, 5.164176210780624, 
                    1.0109060737267825`, 
                    0.31859386868386297`}, {$CellContext`column\[Bullet]7, 1, 
                    127.76209762294275`, 127.76209762294275`, 
                    25.00989029179227, 
                    4.974596979727383*^-6}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    444.4353523585032, 444.4353523585032, 86.99981928196044, 
                    2.048796312694095*^-13}, {
                    "Error", 62, 316.72470211602814`, 5.108462937355292}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    1.7044153746685882`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.4351705392786716`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    39.0054125568516, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    36.22633469690617, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 313.4348289186167, 
                    3.836924823208056*^-26}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1492.0538258993606`, 1492.0538258993606`, 
                    321.6075973609235, 
                    1.9465140573109833`*^-26}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    130.0809547961967, 130.0809547961967, 28.038548347411627`,
                     1.6068855570962655`*^-6}, {
                    "Error", 63, 292.2797589453992, 4.639361253101574}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.844906569833192, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.9331671585071581`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.3694162958661281, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    1.2449582851700662`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    51.04087439182302, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 548.4711068659574, 
                    1.71794312713935*^-32}, {$CellContext`column\[Bullet]5, 1,
                     5.164176210780624, 5.164176210780624, 
                    1.1446517699227787`, 
                    0.28881909427653196`}, {$CellContext`column\[Bullet]6, 1, 
                    128.81103909358671`, 128.81103909358671`, 
                    28.551268947071513`, 
                    1.384689549268551*^-6}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    480.39379330761085`, 480.39379330761085`, 
                    106.48041107147912`, 4.373966982448835*^-15}, {
                    "Error", 62, 279.7173196962766, 4.51156967252059}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    1.327285545019054, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.4867827577795298`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.004381834899129271, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                    NumberForm[
                    0.7387541921476599, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    34.169395285760274`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 506.5717209170595, 
                    1.5632843620951457`*^-31}, \
{$CellContext`column\[Bullet]4^3, 1, 73.01626856653138, 73.01626856653138, 
                    14.947864558497528`, 
                    0.000267396013021589}, {$CellContext`column\[Bullet]6, 1, 
                    70.73514801822466, 70.73514801822466, 14.48087437032289, 
                    0.000326569542772727}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    447.4817092872054, 447.4817092872054, 91.60829653648057, 
                    7.889320097139959*^-14}, {
                    "Error", 62, 302.85320243629326`, 4.884729071553117}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    7.049735524240697, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    4.947790998755661, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.32760617817725146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                    NumberForm[
                    37.27833291350976, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                    NumberForm[
                    0.5129035402029928, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 269.0573746888656, 
                    3.1232952848238678`*^-24}, \
{$CellContext`column\[Bullet]6^2, 1, 45.72194978555876, 45.72194978555876, 
                    8.459879905018452, 
                    0.005033536581247921}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1451.6122957793875`, 1451.6122957793875`, 
                    268.590157430699, 
                    3.2635845750230933`*^-24}, {$CellContext`column\[Bullet]8,
                     1, 81.9974183695781, 81.9974183695781, 
                    15.171888232712366`, 0.00024307549117042572`}, {
                    "Error", 62, 335.08287570643245`, 5.404562511394071}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    3.1346046653275597`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    0.5661079421576403, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.9736432501341529, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    41.463770769155424`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    14.128156845155987`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]5, 1, 
                    433.9827101430128, 433.9827101430128, 103.19610147580498`,
                     8.096953137138698*^-15}, {$CellContext`column\[Bullet]6, 
                    1, 1023.8879020280781`, 1023.8879020280781`, 
                    243.4687773683875, 
                    3.8169270632665933`*^-23}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1488.4668339515213`, 1488.4668339515213`, 
                    353.9403087952821, 
                    2.582520173311955*^-27}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    161.47859772175207`, 161.47859772175207`, 
                    38.3977549501298, 5.164670409816981*^-8}, {
                    "Error", 62, 260.7358964541437, 4.205417684744253}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.968456006882272, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.205100037981496, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    23.283052672760757`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    37.98221013200929, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    11.242037793589047`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 366.5938198398049, 
                    1.0174249676304984`*^-27}, \
{$CellContext`column\[Bullet]8^(-1), 1, 482.85274416173434`, 
                    482.85274416173434`, 121.72909645425469`, 
                    2.91486778020785*^-16}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1071.0941645559965`, 1071.0941645559965`, 
                    270.02709717468974`, 
                    2.851637772660299*^-24}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    114.53735615709638`, 114.53735615709638`, 
                    28.87532284706738, 1.2351695869236348`*^-6}, {
                    "Error", 62, 245.93027476612943`, 3.9666173349375713`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    1.1885141225150353`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    424.85509285667996`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) (1 + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) - 
                    NumberForm[
                    1.7295798543619, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                    NumberForm[
                    1.1816964386067825`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1^(-1) (
                    1 + $CellContext`column\[Bullet]3 + $CellContext`column\
\[Bullet]4), 1, 2530.5456285289747`, 2530.5456285289747`, 347.48001518608976`,
                     2.4891608927898902`*^-27}, \
{$CellContext`column\[Bullet]5^Rational[1, 2], 1, 107.75200716524796`, 
                    107.75200716524796`, 14.795887757960381`, 
                    0.0002819143156199056}, {$CellContext`column\[Bullet]6, 1,
                     271.45274011158426`, 271.45274011158426`, 
                    37.27433372189794, 7.023077379527653*^-8}, {
                    "Error", 63, 458.8015644927008, 7.282564515757155}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    2.669738076043367, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    2.368519451653811, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.5324564370095887, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    31.38409410219968, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - ((
                    NumberForm[
                    0.000016630662056455233`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "9"]], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 589.0658328473589, 
                    2.326925923414222*^-33}, {$CellContext`column\[Bullet]5, 
                    1, 5.164176210780624, 5.164176210780624, 
                    1.2293724131115507`, 
                    0.27181162992334695`}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    535.6825650558949, 535.6825650558949, 127.52341143777562`,
                     1.1050509758935025`*^-16}, \
{($CellContext`column\[Bullet]3 $CellContext`column\[Bullet]4^3) \
$CellContext`column\[Bullet]9, 1, 92.79863224739847, 92.79863224739847, 
                    22.091437976356445`, 0.000014919046915917597`}, {
                    "Error", 62, 260.44095479418115`, 4.20066056119647}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]]}, Alignment -> {Center, Top}, ImageSize -> 
                Automatic, Alignment -> {Center, Center}, BaselinePosition -> 
                Center]], DynamicModuleValues :> {}], Setting[#, {0}]& ], 
            Alignment -> Center, ImageSize -> 500]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Variable\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Presence\\\\\\\"\\\"}, {\\\"\\\\\\\"Map\\\\\\\"\\\"}}, \
Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", List[List[Center]]]]], \
Rule[DefaultBaseStyle, \\\"Column\\\"], Rule[GridBoxItemSize, \
List[Rule[\\\"Columns\\\", List[List[Automatic]]], Rule[\\\"Rows\\\", \
List[List[Automatic]]]]]], \\\"Column\\\"], TraditionalForm]\\)\"", 
            StripOnInput -> False, ShowStringCharacters -> False, FontFamily -> 
            "Helvetica", FontSize -> 10, FontWeight -> Bold, FontSlant -> 
            "Plain", FontColor -> GrayLevel[0], Background -> None], 
           ItemBox[
            GraphicsBox[{
              RasterBox[CompressedData["
1:eJxTTMoPSmVmYGDgAGJJIAaxIeCD/Sg9SlNOowNy1dNanFr+GijxoeJOUsWp
la5GafrQ6GCg3TNQ/sUlPlDmjJZvAys+SuOn0cFwsZdU83Gpp5b4YCvfaB0O
Q6XcG2zuwSVO63RC63w3Kj60xAdbfTTY3DlQ9drg9RcAmNf1Wg==
               "], {{0, 
               0}, {25, 8}}, {0, 1}], {{
                GrayLevel[
                 NCache[-1 + GoldenRatio, 0.6180339887498949]], 
                StyleBox[
                 
                 LineBox[{{{0, 8}, {25, 8}}, {{0, 7}, {25, 7}}, {{0, 6}, {25, 
                  6}}, {{0, 5}, {25, 5}}, {{0, 4}, {25, 4}}, {{0, 3}, {25, 
                  3}}, {{0, 2}, {25, 2}}, {{0, 1}, {25, 1}}, {{0, 0}, {25, 
                  0}}}], Antialiasing -> False]}, {
                GrayLevel[
                 NCache[-1 + GoldenRatio, 0.6180339887498949]], 
                StyleBox[
                 
                 LineBox[{{{0, 0}, {0, 8}}, {{1, 0}, {1, 8}}, {{2, 0}, {2, 
                  8}}, {{3, 0}, {3, 8}}, {{4, 0}, {4, 8}}, {{5, 0}, {5, 
                  8}}, {{6, 0}, {6, 8}}, {{7, 0}, {7, 8}}, {{8, 0}, {8, 
                  8}}, {{9, 0}, {9, 8}}, {{10, 0}, {10, 8}}, {{11, 0}, {11, 
                  8}}, {{12, 0}, {12, 8}}, {{13, 0}, {13, 8}}, {{14, 0}, {14, 
                  8}}, {{15, 0}, {15, 8}}, {{16, 0}, {16, 8}}, {{17, 0}, {17, 
                  8}}, {{18, 0}, {18, 8}}, {{19, 0}, {19, 8}}, {{20, 0}, {20, 
                  8}}, {{21, 0}, {21, 8}}, {{22, 0}, {22, 8}}, {{23, 0}, {23, 
                  8}}, {{24, 0}, {24, 8}}, {{25, 0}, {25, 8}}}], Antialiasing -> 
                 False]}}}, AspectRatio -> 140./Dynamic[
               DataModeler`DataModelerGUI`Private`optValue[
               DataModeler`ModelReview`ModelSummaryTable, ImageSize]], Frame -> 
             True, FrameLabel -> {
               FormBox["\"Models\"", TraditionalForm], None}, 
             FrameTicks -> {{{{7.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]1", 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]1\\\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"20.0\\\\\\\"\\\", 20.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]1\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"20.0\\\"\", 20.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {6.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]3", 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"80.0\\\\\\\"\\\", 80.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]3\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"80.0\\\"\", 80.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {5.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]4", 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"72.0\\\\\\\"\\\", 72.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]4\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"72.0\\\"\", 72.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {4.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]5", 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"24.0\\\\\\\"\\\", 24.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]5\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"24.0\\\"\", 24.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {3.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]6", 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"72.0\\\\\\\"\\\", 72.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]6\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"72.0\\\"\", 72.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {2.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]7", 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]7\\\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"4.0\\\\\\\"\\\", 4.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]7\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"4.0\\\"\", 4.`, Rule[AutoDelete, \
True]], Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 models", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}], "Tooltip"]& ], TraditionalForm]}, {1.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]8", 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"80.0\\\\\\\"\\\", 80.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]8\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"80.0\\\"\", 80.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {0.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]9", 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]9\\\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"4.0\\\\\\\"\\\", 4.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 25 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]9\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"4.0\\\"\", 4.`, Rule[AutoDelete, \
True]], Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\"\", \"0\"]]]]], TraditionalForm]\) % of the 25 models", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}], "Tooltip"]& ], TraditionalForm]}}, None}, {
               None, None}}, GridLinesStyle -> Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 500, 
             Method -> {
              "AxisPadding" -> Scaled[0.02], "DefaultBoundaryStyle" -> 
               Automatic, "DefaultPlotStyle" -> Automatic, "DomainPadding" -> 
               Scaled[0.02], "RangePadding" -> Scaled[0.05]}, PlotLabel -> 
             None], ItemSize -> Automatic, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Model\\\\\\\"\\\"}\
, {\\\"\\\\\\\"Prediction\\\\\\\"\\\"}, {\\\"\\\\\\\"Plot\\\\\\\"\\\"}}, \
Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", List[List[Center]]]]], \
Rule[DefaultBaseStyle, \\\"Column\\\"], Rule[GridBoxItemSize, \
List[Rule[\\\"Columns\\\", List[List[Automatic]]], Rule[\\\"Rows\\\", \
List[List[Automatic]]]]]], \\\"Column\\\"], TraditionalForm]\\)\"", 
            StripOnInput -> False, ShowStringCharacters -> False, FontFamily -> 
            "Helvetica", FontSize -> 10, FontWeight -> Bold, FontSlant -> 
            "Plain", FontColor -> GrayLevel[0], Background -> None], 
           ItemBox[
            TagBox[
             TooltipBox[
              GraphicsBox[{{}, {{{}, {
                   RGBColor[0, 0, 1], 
                   PointSize[Medium], 
                   AbsoluteThickness[1.6], 
                   PointBox[CompressedData["
1:eJxTTMoPSmViYGBwBmIQbQwG7A7bYj79mf6K1wHGP8smlqllIQznC98ozm7S
4obz5Y5dOHX9n4gDAxhwOJgtTNi9bQMDnH+1J7P2mL8gnN/44EHuCwM2OF8y
31n8SQ9C/gCXTf/HVwoOs2YCgaSxgzM357p2AX04/2KgrrLPZD04//10u48N
hxHyJr+knTQNdSH8mUYOvn4SbGklBnB+wh/3L72ahnD+P4er0i4TEPKPF8rd
nXkWwV9TtrGES9YQ6l8zB7+Lk3VOxZjC+XMqjt6Vv28G5097fF/A2dkEzl+8
sUBnrYEF1DxThxU1Vf9ufTGE8022nDa3nmIE54suSeM/oYWQX733Vf+mZQj5
Erfuf7ZKJlD/mjnIaj2c+EkSwY9StGhYLmQJ5zO8YYlxOIaQzzy889nEcxYO
Z8+AAI+DqaLGCj9mITi/Vt9zgoo8O5yvPPtKJNd8hHzjEiUHbnkBOP+zdnhs
91F+OF+218T4l50onH8+qPHwcjEeOF+jsGQNy3OEvOc7rWm/5go4pIGBjIOX
yNXlC2bKwPmTF0y9oswoC+c/LU/IP/gbwResfzhT7ZgknO9+UVU7v0MKmp5k
HKY9uyuVICAP5//LWPb/ZRhC/t6fcFmdtcpwvsr/T8nqPZLQ8FZxuF7L8lLC
Tw3OP7nxmtasVE04P1KPf02EvDqc32H195lZAEL+ro+/4+nVinC+7VG72B3C
GnD+/iCWCKY5CPU/wgL26Xsh+FIvd8hP2qgO9Z+Og+qH3iBXXU04/8ovLab7
F3XgfK+u/x7L9yHUr/pYrHCbXxvOv6v+5+uNYB1o+APlz/92mquhB+czqLoF
f2RCyNeeVa/eZqoL57u9U/th2KDlAADThraQ
                    "]]}, {}}, {
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 3.739547706743532}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.739547706743532`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "350.95`"}, {
                    "column\[Bullet]3", "0.076604`"}, {
                    "column\[Bullet]4", "1.4922`"}, {
                    "column\[Bullet]5", "3.0296`"}, {
                    "column\[Bullet]6", "2.4288`"}, {
                    "column\[Bullet]7", "7.7585`"}, {
                    "column\[Bullet]8", "27.326`"}, {
                    "column\[Bullet]9", "36.57`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.739547706743532}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    350.95}, {$CellContext`column\[Bullet]3, 
                    0.076604}, {$CellContext`column\[Bullet]4, 
                    1.4922}, {$CellContext`column\[Bullet]5, 
                    3.0296}, {$CellContext`column\[Bullet]6, 
                    2.4288}, {$CellContext`column\[Bullet]7, 
                    7.7585}, {$CellContext`column\[Bullet]8, 
                    27.326}, {$CellContext`column\[Bullet]9, 36.57}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 4.8048492831891965`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.8048492831891965`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "328.29`"}, {
                    "column\[Bullet]3", "0.043521`"}, {
                    "column\[Bullet]4", "2.4749`"}, {
                    "column\[Bullet]5", "6.2193`"}, {
                    "column\[Bullet]6", "2.5864`"}, {
                    "column\[Bullet]7", "6.4752`"}, {
                    "column\[Bullet]8", "23.65`"}, {
                    "column\[Bullet]9", "44.15`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.8048492831891965`}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    328.29}, {$CellContext`column\[Bullet]3, 
                    0.043521}, {$CellContext`column\[Bullet]4, 
                    2.4749}, {$CellContext`column\[Bullet]5, 
                    6.2193}, {$CellContext`column\[Bullet]6, 
                    2.5864}, {$CellContext`column\[Bullet]7, 
                    6.4752}, {$CellContext`column\[Bullet]8, 
                    23.65}, {$CellContext`column\[Bullet]9, 44.15}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 3.395756568405895}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.395756568405895`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "353.52`"}, {
                    "column\[Bullet]3", "0.074992`"}, {
                    "column\[Bullet]4", "1.4033`"}, {
                    "column\[Bullet]5", "2.8071`"}, {
                    "column\[Bullet]6", "2.1907`"}, {
                    "column\[Bullet]7", "7.3389`"}, {
                    "column\[Bullet]8", "27.263`"}, {
                    "column\[Bullet]9", "36.224`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 3.395756568405895}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    353.52}, {$CellContext`column\[Bullet]3, 
                    0.074992}, {$CellContext`column\[Bullet]4, 
                    1.4033}, {$CellContext`column\[Bullet]5, 
                    2.8071}, {$CellContext`column\[Bullet]6, 
                    2.1907}, {$CellContext`column\[Bullet]7, 
                    7.3389}, {$CellContext`column\[Bullet]8, 
                    27.263}, {$CellContext`column\[Bullet]9, 36.224}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 5.248870057098911}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.248870057098911`"}, {
                    "\"Observed\"", "2.9`"}, {"column\[Bullet]1", "325.6`"}, {
                    "column\[Bullet]3", "0.04209`"}, {
                    "column\[Bullet]4", "2.5085`"}, {
                    "column\[Bullet]5", "6.4914`"}, {
                    "column\[Bullet]6", "2.8532`"}, {
                    "column\[Bullet]7", "6.2225`"}, {
                    "column\[Bullet]8", "22.929`"}, {
                    "column\[Bullet]9", "44.949`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.248870057098911}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    325.6}, {$CellContext`column\[Bullet]3, 
                    0.04209}, {$CellContext`column\[Bullet]4, 
                    2.5085}, {$CellContext`column\[Bullet]5, 
                    6.4914}, {$CellContext`column\[Bullet]6, 
                    2.8532}, {$CellContext`column\[Bullet]7, 
                    6.2225}, {$CellContext`column\[Bullet]8, 
                    22.929}, {$CellContext`column\[Bullet]9, 44.949}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 2.086286033522039}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.086286033522039`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "285.64`"}, {
                    "column\[Bullet]3", "0.0096654`"}, {
                    "column\[Bullet]4", "1.2824`"}, {
                    "column\[Bullet]5", "3.5583`"}, {
                    "column\[Bullet]6", "0.93475`"}, {
                    "column\[Bullet]7", "4.4397`"}, {
                    "column\[Bullet]8", "24.376`"}, {
                    "column\[Bullet]9", "40.362`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.086286033522039}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    285.64}, {$CellContext`column\[Bullet]3, 
                    0.0096654}, {$CellContext`column\[Bullet]4, 
                    1.2824}, {$CellContext`column\[Bullet]5, 
                    3.5583}, {$CellContext`column\[Bullet]6, 
                    0.93475}, {$CellContext`column\[Bullet]7, 
                    4.4397}, {$CellContext`column\[Bullet]8, 
                    24.376}, {$CellContext`column\[Bullet]9, 40.362}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 4.327905616347569}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.327905616347569`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "333.36`"}, {
                    "column\[Bullet]3", "0.25416`"}, {
                    "column\[Bullet]4", "2.6108`"}, {
                    "column\[Bullet]5", "4.8841`"}, {
                    "column\[Bullet]6", "2.067`"}, {
                    "column\[Bullet]7", "7.2514`"}, {
                    "column\[Bullet]8", "25.735`"}, {
                    "column\[Bullet]9", "41.052`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.327905616347569}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    333.36}, {$CellContext`column\[Bullet]3, 
                    0.25416}, {$CellContext`column\[Bullet]4, 
                    2.6108}, {$CellContext`column\[Bullet]5, 
                    4.8841}, {$CellContext`column\[Bullet]6, 
                    2.067}, {$CellContext`column\[Bullet]7, 
                    7.2514}, {$CellContext`column\[Bullet]8, 
                    25.735}, {$CellContext`column\[Bullet]9, 41.052}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 2.7738808235408787`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.7738808235408787`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "280.31`"}, {
                    "column\[Bullet]3", "0.032604`"}, {
                    "column\[Bullet]4", "2.4018`"}, {
                    "column\[Bullet]5", "3.9752`"}, {
                    "column\[Bullet]6", "0.90314`"}, {
                    "column\[Bullet]7", "4.6652`"}, {
                    "column\[Bullet]8", "25.418`"}, {
                    "column\[Bullet]9", "39.787`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.7738808235408787`}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    280.31}, {$CellContext`column\[Bullet]3, 
                    0.032604}, {$CellContext`column\[Bullet]4, 
                    2.4018}, {$CellContext`column\[Bullet]5, 
                    3.9752}, {$CellContext`column\[Bullet]6, 
                    0.90314}, {$CellContext`column\[Bullet]7, 
                    4.6652}, {$CellContext`column\[Bullet]8, 
                    25.418}, {$CellContext`column\[Bullet]9, 39.787}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 4.387588847628444}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.387588847628444`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "337.55`"}, {
                    "column\[Bullet]3", "0.25098`"}, {
                    "column\[Bullet]4", "2.2948`"}, {
                    "column\[Bullet]5", "4.836`"}, {
                    "column\[Bullet]6", "2.4206`"}, {
                    "column\[Bullet]7", "6.7155`"}, {
                    "column\[Bullet]8", "26.782`"}, {
                    "column\[Bullet]9", "42.383`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.387588847628444}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    337.55}, {$CellContext`column\[Bullet]3, 
                    0.25098}, {$CellContext`column\[Bullet]4, 
                    2.2948}, {$CellContext`column\[Bullet]5, 
                    4.836}, {$CellContext`column\[Bullet]6, 
                    2.4206}, {$CellContext`column\[Bullet]7, 
                    6.7155}, {$CellContext`column\[Bullet]8, 
                    26.782}, {$CellContext`column\[Bullet]9, 42.383}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 8.45887420280394}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "8.45887420280394`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "84.801`"}, {
                    "column\[Bullet]3", "0.023225`"}, {
                    "column\[Bullet]4", "2.8469`"}, {
                    "column\[Bullet]5", "1.144`"}, {
                    "column\[Bullet]6", "0.41367`"}, {
                    "column\[Bullet]7", "0.99846`"}, {
                    "column\[Bullet]8", "7.96`"}, {
                    "column\[Bullet]9", "10.278`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 8.45887420280394}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    84.801}, {$CellContext`column\[Bullet]3, 
                    0.023225}, {$CellContext`column\[Bullet]4, 
                    2.8469}, {$CellContext`column\[Bullet]5, 
                    1.144}, {$CellContext`column\[Bullet]6, 
                    0.41367}, {$CellContext`column\[Bullet]7, 
                    0.99846}, {$CellContext`column\[Bullet]8, 
                    7.96}, {$CellContext`column\[Bullet]9, 10.278}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 15.532285154918673`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.532285154918673`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "481.33`"}, {
                    "column\[Bullet]3", "2.3203`"}, {
                    "column\[Bullet]4", "14.958`"}, {
                    "column\[Bullet]5", "11.811`"}, {
                    "column\[Bullet]6", "6.2482`"}, {
                    "column\[Bullet]7", "16.464`"}, {
                    "column\[Bullet]8", "28.218`"}, {
                    "column\[Bullet]9", "39.915`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.532285154918673`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    481.33}, {$CellContext`column\[Bullet]3, 
                    2.3203}, {$CellContext`column\[Bullet]4, 
                    14.958}, {$CellContext`column\[Bullet]5, 
                    11.811}, {$CellContext`column\[Bullet]6, 
                    6.2482}, {$CellContext`column\[Bullet]7, 
                    16.464}, {$CellContext`column\[Bullet]8, 
                    28.218}, {$CellContext`column\[Bullet]9, 39.915}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 15.287690257341554`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.287690257341554`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "502.85`"}, {
                    "column\[Bullet]3", "2.076`"}, {
                    "column\[Bullet]4", "10.148`"}, {
                    "column\[Bullet]5", "6.3476`"}, {
                    "column\[Bullet]6", "6.7924`"}, {
                    "column\[Bullet]7", "16.656`"}, {
                    "column\[Bullet]8", "26.531`"}, {
                    "column\[Bullet]9", "45.039`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.287690257341554`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    502.85}, {$CellContext`column\[Bullet]3, 
                    2.076}, {$CellContext`column\[Bullet]4, 
                    10.148}, {$CellContext`column\[Bullet]5, 
                    6.3476}, {$CellContext`column\[Bullet]6, 
                    6.7924}, {$CellContext`column\[Bullet]7, 
                    16.656}, {$CellContext`column\[Bullet]8, 
                    26.531}, {$CellContext`column\[Bullet]9, 45.039}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 15.881843127146537`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.881843127146537`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "481.46`"}, {
                    "column\[Bullet]3", "2.3247`"}, {
                    "column\[Bullet]4", "13.512`"}, {
                    "column\[Bullet]5", "11.24`"}, {
                    "column\[Bullet]6", "6.5212`"}, {
                    "column\[Bullet]7", "16.437`"}, {
                    "column\[Bullet]8", "27.152`"}, {
                    "column\[Bullet]9", "40.157`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.881843127146537`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    481.46}, {$CellContext`column\[Bullet]3, 
                    2.3247}, {$CellContext`column\[Bullet]4, 
                    13.512}, {$CellContext`column\[Bullet]5, 
                    11.24}, {$CellContext`column\[Bullet]6, 
                    6.5212}, {$CellContext`column\[Bullet]7, 
                    16.437}, {$CellContext`column\[Bullet]8, 
                    27.152}, {$CellContext`column\[Bullet]9, 40.157}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 14.596017900386052`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.596017900386052`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "504.22`"}, {
                    "column\[Bullet]3", "2.175`"}, {
                    "column\[Bullet]4", "9.31`"}, {
                    "column\[Bullet]5", "5.6544`"}, {
                    "column\[Bullet]6", "6.1498`"}, {
                    "column\[Bullet]7", "16.944`"}, {
                    "column\[Bullet]8", "26.384`"}, {
                    "column\[Bullet]9", "44.574`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.596017900386052`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    504.22}, {$CellContext`column\[Bullet]3, 
                    2.175}, {$CellContext`column\[Bullet]4, 
                    9.31}, {$CellContext`column\[Bullet]5, 
                    5.6544}, {$CellContext`column\[Bullet]6, 
                    6.1498}, {$CellContext`column\[Bullet]7, 
                    16.944}, {$CellContext`column\[Bullet]8, 
                    26.384}, {$CellContext`column\[Bullet]9, 44.574}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.454681759771393`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.454681759771393`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "449.06`"}, {
                    "column\[Bullet]3", "3.9959`"}, {
                    "column\[Bullet]4", "9.0628`"}, {
                    "column\[Bullet]5", "2.9384`"}, {
                    "column\[Bullet]6", "5.1599`"}, {
                    "column\[Bullet]7", "11.975`"}, {
                    "column\[Bullet]8", "25.811`"}, {
                    "column\[Bullet]9", "42.422`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 16.454681759771393`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    449.06}, {$CellContext`column\[Bullet]3, 
                    3.9959}, {$CellContext`column\[Bullet]4, 
                    9.0628}, {$CellContext`column\[Bullet]5, 
                    2.9384}, {$CellContext`column\[Bullet]6, 
                    5.1599}, {$CellContext`column\[Bullet]7, 
                    11.975}, {$CellContext`column\[Bullet]8, 
                    25.811}, {$CellContext`column\[Bullet]9, 42.422}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 17.162322299551647`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.162322299551647`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "490.04`"}, {
                    "column\[Bullet]3", "3.641`"}, {
                    "column\[Bullet]4", "11.151`"}, {
                    "column\[Bullet]5", "7.6245`"}, {
                    "column\[Bullet]6", "7.3421`"}, {
                    "column\[Bullet]7", "17.862`"}, {
                    "column\[Bullet]8", "29.307`"}, {
                    "column\[Bullet]9", "45.273`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.162322299551647`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    490.04}, {$CellContext`column\[Bullet]3, 
                    3.641}, {$CellContext`column\[Bullet]4, 
                    11.151}, {$CellContext`column\[Bullet]5, 
                    7.6245}, {$CellContext`column\[Bullet]6, 
                    7.3421}, {$CellContext`column\[Bullet]7, 
                    17.862}, {$CellContext`column\[Bullet]8, 
                    29.307}, {$CellContext`column\[Bullet]9, 45.273}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.563539256633696`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.563539256633696`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "443.1`"}, {
                    "column\[Bullet]3", "3.8976`"}, {
                    "column\[Bullet]4", "9.2719`"}, {
                    "column\[Bullet]5", "3.4631`"}, {
                    "column\[Bullet]6", "4.6121`"}, {
                    "column\[Bullet]7", "10.64`"}, {
                    "column\[Bullet]8", "23.97`"}, {
                    "column\[Bullet]9", "43.062`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 16.563539256633696`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    443.1}, {$CellContext`column\[Bullet]3, 
                    3.8976}, {$CellContext`column\[Bullet]4, 
                    9.2719}, {$CellContext`column\[Bullet]5, 
                    3.4631}, {$CellContext`column\[Bullet]6, 
                    4.6121}, {$CellContext`column\[Bullet]7, 
                    10.64}, {$CellContext`column\[Bullet]8, 
                    23.97}, {$CellContext`column\[Bullet]9, 43.062}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.803129024485212`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.803129024485212`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "484.38`"}, {
                    "column\[Bullet]3", "3.1734`"}, {
                    "column\[Bullet]4", "10.662`"}, {
                    "column\[Bullet]5", "7.7974`"}, {
                    "column\[Bullet]6", "7.8007`"}, {
                    "column\[Bullet]7", "16.382`"}, {
                    "column\[Bullet]8", "29.218`"}, {
                    "column\[Bullet]9", "45.361`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 16.803129024485212`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    484.38}, {$CellContext`column\[Bullet]3, 
                    3.1734}, {$CellContext`column\[Bullet]4, 
                    10.662}, {$CellContext`column\[Bullet]5, 
                    7.7974}, {$CellContext`column\[Bullet]6, 
                    7.8007}, {$CellContext`column\[Bullet]7, 
                    16.382}, {$CellContext`column\[Bullet]8, 
                    29.218}, {$CellContext`column\[Bullet]9, 45.361}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 17.113440793348374`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.113440793348374`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "123.01`"}, {
                    "column\[Bullet]3", "1.168`"}, {
                    "column\[Bullet]4", "2.118`"}, {
                    "column\[Bullet]5", "2.085`"}, {
                    "column\[Bullet]6", "1.1875`"}, {
                    "column\[Bullet]7", "3.3023`"}, {
                    "column\[Bullet]8", "5.1231`"}, {
                    "column\[Bullet]9", "12.093`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.113440793348374`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    123.01}, {$CellContext`column\[Bullet]3, 
                    1.168}, {$CellContext`column\[Bullet]4, 
                    2.118}, {$CellContext`column\[Bullet]5, 
                    2.085}, {$CellContext`column\[Bullet]6, 
                    1.1875}, {$CellContext`column\[Bullet]7, 
                    3.3023}, {$CellContext`column\[Bullet]8, 
                    5.1231}, {$CellContext`column\[Bullet]9, 12.093}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 21.36245993241146}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "21.36245993241146`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "395.63`"}, {
                    "column\[Bullet]3", "4.4166`"}, {
                    "column\[Bullet]4", "9.4434`"}, {
                    "column\[Bullet]5", "5.2949`"}, {
                    "column\[Bullet]6", "5.6166`"}, {
                    "column\[Bullet]7", "13.454`"}, {
                    "column\[Bullet]8", "19.036`"}, {
                    "column\[Bullet]9", "46"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 21.36245993241146}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    395.63}, {$CellContext`column\[Bullet]3, 
                    4.4166}, {$CellContext`column\[Bullet]4, 
                    9.4434}, {$CellContext`column\[Bullet]5, 
                    5.2949}, {$CellContext`column\[Bullet]6, 
                    5.6166}, {$CellContext`column\[Bullet]7, 
                    13.454}, {$CellContext`column\[Bullet]8, 
                    19.036}, {$CellContext`column\[Bullet]9, 46}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 22.871579991064763`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "22.871579991064763`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "429.01`"}, {
                    "column\[Bullet]3", "5.8707`"}, {
                    "column\[Bullet]4", "12.294`"}, {
                    "column\[Bullet]5", "5.2104`"}, {
                    "column\[Bullet]6", "6.3098`"}, {
                    "column\[Bullet]7", "12.685`"}, {
                    "column\[Bullet]8", "22.878`"}, {
                    "column\[Bullet]9", "44.879`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 22.871579991064763`}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    429.01}, {$CellContext`column\[Bullet]3, 
                    5.8707}, {$CellContext`column\[Bullet]4, 
                    12.294}, {$CellContext`column\[Bullet]5, 
                    5.2104}, {$CellContext`column\[Bullet]6, 
                    6.3098}, {$CellContext`column\[Bullet]7, 
                    12.685}, {$CellContext`column\[Bullet]8, 
                    22.878}, {$CellContext`column\[Bullet]9, 44.879}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 20.262742094669726`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.262742094669726`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "383.51`"}, {
                    "column\[Bullet]3", "3.9862`"}, {
                    "column\[Bullet]4", "9.7398`"}, {
                    "column\[Bullet]5", "5.7647`"}, {
                    "column\[Bullet]6", "4.6835`"}, {
                    "column\[Bullet]7", "12.484`"}, {
                    "column\[Bullet]8", "18.37`"}, {
                    "column\[Bullet]9", "45.513`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.262742094669726`}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    383.51}, {$CellContext`column\[Bullet]3, 
                    3.9862}, {$CellContext`column\[Bullet]4, 
                    9.7398}, {$CellContext`column\[Bullet]5, 
                    5.7647}, {$CellContext`column\[Bullet]6, 
                    4.6835}, {$CellContext`column\[Bullet]7, 
                    12.484}, {$CellContext`column\[Bullet]8, 
                    18.37}, {$CellContext`column\[Bullet]9, 45.513}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 24.190142419350774`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "24.190142419350774`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "423.59`"}, {
                    "column\[Bullet]3", "6.0992`"}, {
                    "column\[Bullet]4", "12.774`"}, {
                    "column\[Bullet]5", "5.2123`"}, {
                    "column\[Bullet]6", "7.5576`"}, {
                    "column\[Bullet]7", "12.976`"}, {
                    "column\[Bullet]8", "23.546`"}, {
                    "column\[Bullet]9", "45.163`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 24.190142419350774`}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    423.59}, {$CellContext`column\[Bullet]3, 
                    6.0992}, {$CellContext`column\[Bullet]4, 
                    12.774}, {$CellContext`column\[Bullet]5, 
                    5.2123}, {$CellContext`column\[Bullet]6, 
                    7.5576}, {$CellContext`column\[Bullet]7, 
                    12.976}, {$CellContext`column\[Bullet]8, 
                    23.546}, {$CellContext`column\[Bullet]9, 45.163}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 17.95646658411411}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.95646658411411`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "382.47`"}, {
                    "column\[Bullet]3", "4.558`"}, {
                    "column\[Bullet]4", "9.4998`"}, {
                    "column\[Bullet]5", "4.2863`"}, {
                    "column\[Bullet]6", "4.0496`"}, {
                    "column\[Bullet]7", "10.55`"}, {
                    "column\[Bullet]8", "22.604`"}, {
                    "column\[Bullet]9", "43.469`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.95646658411411}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    382.47}, {$CellContext`column\[Bullet]3, 
                    4.558}, {$CellContext`column\[Bullet]4, 
                    9.4998}, {$CellContext`column\[Bullet]5, 
                    4.2863}, {$CellContext`column\[Bullet]6, 
                    4.0496}, {$CellContext`column\[Bullet]7, 
                    10.55}, {$CellContext`column\[Bullet]8, 
                    22.604}, {$CellContext`column\[Bullet]9, 43.469}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 18.579028594238665`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "18.579028594238665`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "417.96`"}, {
                    "column\[Bullet]3", "3.4999`"}, {
                    "column\[Bullet]4", "11.517`"}, {
                    "column\[Bullet]5", "5.9722`"}, {
                    "column\[Bullet]6", "5.9796`"}, {
                    "column\[Bullet]7", "14.03`"}, {
                    "column\[Bullet]8", "23.395`"}, {
                    "column\[Bullet]9", "45.627`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 18.579028594238665`}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    417.96}, {$CellContext`column\[Bullet]3, 
                    3.4999}, {$CellContext`column\[Bullet]4, 
                    11.517}, {$CellContext`column\[Bullet]5, 
                    5.9722}, {$CellContext`column\[Bullet]6, 
                    5.9796}, {$CellContext`column\[Bullet]7, 
                    14.03}, {$CellContext`column\[Bullet]8, 
                    23.395}, {$CellContext`column\[Bullet]9, 45.627}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 17.16711517578013}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.16711517578013`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "385.89`"}, {
                    "column\[Bullet]3", "4.1518`"}, {
                    "column\[Bullet]4", "9.0139`"}, {
                    "column\[Bullet]5", "4.5748`"}, {
                    "column\[Bullet]6", "4.4834`"}, {
                    "column\[Bullet]7", "10.033`"}, {
                    "column\[Bullet]8", "23.256`"}, {
                    "column\[Bullet]9", "44.391`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.16711517578013}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    385.89}, {$CellContext`column\[Bullet]3, 
                    4.1518}, {$CellContext`column\[Bullet]4, 
                    9.0139}, {$CellContext`column\[Bullet]5, 
                    4.5748}, {$CellContext`column\[Bullet]6, 
                    4.4834}, {$CellContext`column\[Bullet]7, 
                    10.033}, {$CellContext`column\[Bullet]8, 
                    23.256}, {$CellContext`column\[Bullet]9, 44.391}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 18.6511621425722}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "18.6511621425722`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "432.21`"}, {
                    "column\[Bullet]3", "3.0879`"}, {
                    "column\[Bullet]4", "11.139`"}, {
                    "column\[Bullet]5", "5.8922`"}, {
                    "column\[Bullet]6", "6.6017`"}, {
                    "column\[Bullet]7", "15.174`"}, {
                    "column\[Bullet]8", "22.937`"}, {
                    "column\[Bullet]9", "44.985`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 18.6511621425722}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    432.21}, {$CellContext`column\[Bullet]3, 
                    3.0879}, {$CellContext`column\[Bullet]4, 
                    11.139}, {$CellContext`column\[Bullet]5, 
                    5.8922}, {$CellContext`column\[Bullet]6, 
                    6.6017}, {$CellContext`column\[Bullet]7, 
                    15.174}, {$CellContext`column\[Bullet]8, 
                    22.937}, {$CellContext`column\[Bullet]9, 44.985}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 20.13375845814012}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.13375845814012`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "104.64`"}, {
                    "column\[Bullet]3", "1.2003`"}, {
                    "column\[Bullet]4", "3.4599`"}, {
                    "column\[Bullet]5", "1.2469`"}, {
                    "column\[Bullet]6", "1.8204`"}, {
                    "column\[Bullet]7", "2.3453`"}, {
                    "column\[Bullet]8", "6.1338`"}, {
                    "column\[Bullet]9", "13.694`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.13375845814012}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    104.64}, {$CellContext`column\[Bullet]3, 
                    1.2003}, {$CellContext`column\[Bullet]4, 
                    3.4599}, {$CellContext`column\[Bullet]5, 
                    1.2469}, {$CellContext`column\[Bullet]6, 
                    1.8204}, {$CellContext`column\[Bullet]7, 
                    2.3453}, {$CellContext`column\[Bullet]8, 
                    6.1338}, {$CellContext`column\[Bullet]9, 13.694}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 20.101357572051814`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.101357572051814`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "397.12`"}, {
                    "column\[Bullet]3", "4.3753`"}, {
                    "column\[Bullet]4", "12.63`"}, {
                    "column\[Bullet]5", "6.236`"}, {
                    "column\[Bullet]6", "4.6257`"}, {
                    "column\[Bullet]7", "12.523`"}, {
                    "column\[Bullet]8", "21.378`"}, {
                    "column\[Bullet]9", "47.173`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.101357572051814`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    397.12}, {$CellContext`column\[Bullet]3, 
                    4.3753}, {$CellContext`column\[Bullet]4, 
                    12.63}, {$CellContext`column\[Bullet]5, 
                    6.236}, {$CellContext`column\[Bullet]6, 
                    4.6257}, {$CellContext`column\[Bullet]7, 
                    12.523}, {$CellContext`column\[Bullet]8, 
                    21.378}, {$CellContext`column\[Bullet]9, 47.173}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 25.072868360236818`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "25.072868360236818`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "425.48`"}, {
                    "column\[Bullet]3", "6.2747`"}, {
                    "column\[Bullet]4", "13.025`"}, {
                    "column\[Bullet]5", "7.5405`"}, {
                    "column\[Bullet]6", "7.9011`"}, {
                    "column\[Bullet]7", "15.131`"}, {
                    "column\[Bullet]8", "22.819`"}, {
                    "column\[Bullet]9", "47.515`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 25.072868360236818`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    425.48}, {$CellContext`column\[Bullet]3, 
                    6.2747}, {$CellContext`column\[Bullet]4, 
                    13.025}, {$CellContext`column\[Bullet]5, 
                    7.5405}, {$CellContext`column\[Bullet]6, 
                    7.9011}, {$CellContext`column\[Bullet]7, 
                    15.131}, {$CellContext`column\[Bullet]8, 
                    22.819}, {$CellContext`column\[Bullet]9, 47.515}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 20.774419547273283`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.774419547273283`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "391.07`"}, {
                    "column\[Bullet]3", "4.5357`"}, {
                    "column\[Bullet]4", "13.001`"}, {
                    "column\[Bullet]5", "6.3219`"}, {
                    "column\[Bullet]6", "4.9742`"}, {
                    "column\[Bullet]7", "13.822`"}, {
                    "column\[Bullet]8", "21.549`"}, {
                    "column\[Bullet]9", "45.417`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.774419547273283`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    391.07}, {$CellContext`column\[Bullet]3, 
                    4.5357}, {$CellContext`column\[Bullet]4, 
                    13.001}, {$CellContext`column\[Bullet]5, 
                    6.3219}, {$CellContext`column\[Bullet]6, 
                    4.9742}, {$CellContext`column\[Bullet]7, 
                    13.822}, {$CellContext`column\[Bullet]8, 
                    21.549}, {$CellContext`column\[Bullet]9, 45.417}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 24.806913776733754`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "24.806913776733754`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "426.27`"}, {
                    "column\[Bullet]3", "6.7675`"}, {
                    "column\[Bullet]4", "12.632`"}, {
                    "column\[Bullet]5", "8.0609`"}, {
                    "column\[Bullet]6", "7.8022`"}, {
                    "column\[Bullet]7", "15.366`"}, {
                    "column\[Bullet]8", "23.678`"}, {
                    "column\[Bullet]9", "46.834`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 24.806913776733754`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    426.27}, {$CellContext`column\[Bullet]3, 
                    6.7675}, {$CellContext`column\[Bullet]4, 
                    12.632}, {$CellContext`column\[Bullet]5, 
                    8.0609}, {$CellContext`column\[Bullet]6, 
                    7.8022}, {$CellContext`column\[Bullet]7, 
                    15.366}, {$CellContext`column\[Bullet]8, 
                    23.678}, {$CellContext`column\[Bullet]9, 46.834}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.503229739617656}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.503229739617656`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "317.76`"}, {
                    "column\[Bullet]3", "0.13914`"}, {
                    "column\[Bullet]4", "2.4186`"}, {
                    "column\[Bullet]5", "5.7358`"}, {
                    "column\[Bullet]6", "2.2551`"}, {
                    "column\[Bullet]7", "7.0779`"}, {
                    "column\[Bullet]8", "23.868`"}, {
                    "column\[Bullet]9", "37.857`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.503229739617656}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    317.76}, {$CellContext`column\[Bullet]3, 
                    0.13914}, {$CellContext`column\[Bullet]4, 
                    2.4186}, {$CellContext`column\[Bullet]5, 
                    5.7358}, {$CellContext`column\[Bullet]6, 
                    2.2551}, {$CellContext`column\[Bullet]7, 
                    7.0779}, {$CellContext`column\[Bullet]8, 
                    23.868}, {$CellContext`column\[Bullet]9, 37.857}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 2.8902064583143656`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.8902064583143656`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "354.22`"}, {
                    "column\[Bullet]3", "0.10735`"}, {
                    "column\[Bullet]4", "1.7602`"}, {
                    "column\[Bullet]5", "4.9685`"}, {
                    "column\[Bullet]6", "1.4607`"}, {
                    "column\[Bullet]7", "5.2356`"}, {
                    "column\[Bullet]8", "24.261`"}, {
                    "column\[Bullet]9", "41.266`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.8902064583143656`}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    354.22}, {$CellContext`column\[Bullet]3, 
                    0.10735}, {$CellContext`column\[Bullet]4, 
                    1.7602}, {$CellContext`column\[Bullet]5, 
                    4.9685}, {$CellContext`column\[Bullet]6, 
                    1.4607}, {$CellContext`column\[Bullet]7, 
                    5.2356}, {$CellContext`column\[Bullet]8, 
                    24.261}, {$CellContext`column\[Bullet]9, 41.266}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.655312923051301}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.655312923051301`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "309.37`"}, {
                    "column\[Bullet]3", "0.13867`"}, {
                    "column\[Bullet]4", "2.4399`"}, {
                    "column\[Bullet]5", "5.8753`"}, {
                    "column\[Bullet]6", "2.4094`"}, {
                    "column\[Bullet]7", "6.6234`"}, {
                    "column\[Bullet]8", "24.325`"}, {
                    "column\[Bullet]9", "38.006`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.655312923051301}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    309.37}, {$CellContext`column\[Bullet]3, 
                    0.13867}, {$CellContext`column\[Bullet]4, 
                    2.4399}, {$CellContext`column\[Bullet]5, 
                    5.8753}, {$CellContext`column\[Bullet]6, 
                    2.4094}, {$CellContext`column\[Bullet]7, 
                    6.6234}, {$CellContext`column\[Bullet]8, 
                    24.325}, {$CellContext`column\[Bullet]9, 38.006}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.030316354860703}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.030316354860703`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "354.59`"}, {
                    "column\[Bullet]3", "0.10803`"}, {
                    "column\[Bullet]4", "1.8532`"}, {
                    "column\[Bullet]5", "4.7755`"}, {
                    "column\[Bullet]6", "2.4708`"}, {
                    "column\[Bullet]7", "5.7003`"}, {
                    "column\[Bullet]8", "26.043`"}, {
                    "column\[Bullet]9", "42.092`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.030316354860703}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    354.59}, {$CellContext`column\[Bullet]3, 
                    0.10803}, {$CellContext`column\[Bullet]4, 
                    1.8532}, {$CellContext`column\[Bullet]5, 
                    4.7755}, {$CellContext`column\[Bullet]6, 
                    2.4708}, {$CellContext`column\[Bullet]7, 
                    5.7003}, {$CellContext`column\[Bullet]8, 
                    26.043}, {$CellContext`column\[Bullet]9, 42.092}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 3.971457223150986}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.971457223150986`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "80.549`"}, {
                    "column\[Bullet]3", "0"}, {
                    "column\[Bullet]4", "0.23556`"}, {
                    "column\[Bullet]5", "0.65964`"}, {
                    "column\[Bullet]6", "0.61828`"}, {
                    "column\[Bullet]7", "1.4995`"}, {
                    "column\[Bullet]8", "6.2371`"}, {
                    "column\[Bullet]9", "10.143`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.971457223150986}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    80.549}, {$CellContext`column\[Bullet]3, 
                    0}, {$CellContext`column\[Bullet]4, 
                    0.23556}, {$CellContext`column\[Bullet]5, 
                    0.65964}, {$CellContext`column\[Bullet]6, 
                    0.61828}, {$CellContext`column\[Bullet]7, 
                    1.4995}, {$CellContext`column\[Bullet]8, 
                    6.2371}, {$CellContext`column\[Bullet]9, 10.143}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 5.311501312334511}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.311501312334511`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "368.14`"}, {
                    "column\[Bullet]3", "0.23302`"}, {
                    "column\[Bullet]4", "2.1478`"}, {
                    "column\[Bullet]5", "2.6785`"}, {
                    "column\[Bullet]6", "2.5631`"}, {
                    "column\[Bullet]7", "9.5897`"}, {
                    "column\[Bullet]8", "21.61`"}, {
                    "column\[Bullet]9", "39.752`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.311501312334511}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    368.14}, {$CellContext`column\[Bullet]3, 
                    0.23302}, {$CellContext`column\[Bullet]4, 
                    2.1478}, {$CellContext`column\[Bullet]5, 
                    2.6785}, {$CellContext`column\[Bullet]6, 
                    2.5631}, {$CellContext`column\[Bullet]7, 
                    9.5897}, {$CellContext`column\[Bullet]8, 
                    21.61}, {$CellContext`column\[Bullet]9, 39.752}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 3.5110621713487045`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.5110621713487045`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "358.93`"}, {
                    "column\[Bullet]3", "0.02045`"}, {
                    "column\[Bullet]4", "2.5561`"}, {
                    "column\[Bullet]5", "4.244`"}, {
                    "column\[Bullet]6", "1.5919`"}, {
                    "column\[Bullet]7", "6.8468`"}, {
                    "column\[Bullet]8", "25.028`"}, {
                    "column\[Bullet]9", "41.052`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.5110621713487045`}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    358.93}, {$CellContext`column\[Bullet]3, 
                    0.02045}, {$CellContext`column\[Bullet]4, 
                    2.5561}, {$CellContext`column\[Bullet]5, 
                    4.244}, {$CellContext`column\[Bullet]6, 
                    1.5919}, {$CellContext`column\[Bullet]7, 
                    6.8468}, {$CellContext`column\[Bullet]8, 
                    25.028}, {$CellContext`column\[Bullet]9, 41.052}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 5.475603766066605}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.475603766066605`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "368.06`"}, {
                    "column\[Bullet]3", "0.23339`"}, {
                    "column\[Bullet]4", "2.4591`"}, {
                    "column\[Bullet]5", "2.5755`"}, {
                    "column\[Bullet]6", "2.6119`"}, {
                    "column\[Bullet]7", "9.6519`"}, {
                    "column\[Bullet]8", "22.526`"}, {
                    "column\[Bullet]9", "39.377`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.475603766066605}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    368.06}, {$CellContext`column\[Bullet]3, 
                    0.23339}, {$CellContext`column\[Bullet]4, 
                    2.4591}, {$CellContext`column\[Bullet]5, 
                    2.5755}, {$CellContext`column\[Bullet]6, 
                    2.6119}, {$CellContext`column\[Bullet]7, 
                    9.6519}, {$CellContext`column\[Bullet]8, 
                    22.526}, {$CellContext`column\[Bullet]9, 39.377}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.154276224489487}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.154276224489487`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "358.81`"}, {
                    "column\[Bullet]3", "0"}, {
                    "column\[Bullet]4", "2.185`"}, {
                    "column\[Bullet]5", "3.7891`"}, {
                    "column\[Bullet]6", "2.1297`"}, {
                    "column\[Bullet]7", "6.5699`"}, {
                    "column\[Bullet]8", "23.158`"}, {
                    "column\[Bullet]9", "41.835`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.154276224489487}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    358.81}, {$CellContext`column\[Bullet]3, 
                    0}, {$CellContext`column\[Bullet]4, 
                    2.185}, {$CellContext`column\[Bullet]5, 
                    3.7891}, {$CellContext`column\[Bullet]6, 
                    2.1297}, {$CellContext`column\[Bullet]7, 
                    6.5699}, {$CellContext`column\[Bullet]8, 
                    23.158}, {$CellContext`column\[Bullet]9, 41.835}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.150026914959264}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.150026914959264`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "455.92`"}, {
                    "column\[Bullet]3", "1.4683`"}, {
                    "column\[Bullet]4", "5.1854`"}, {
                    "column\[Bullet]5", "5.7923`"}, {
                    "column\[Bullet]6", "2.1978`"}, {
                    "column\[Bullet]7", "8.449`"}, {
                    "column\[Bullet]8", "27.789`"}, {
                    "column\[Bullet]9", "38.103`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.150026914959264}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    455.92}, {$CellContext`column\[Bullet]3, 
                    1.4683}, {$CellContext`column\[Bullet]4, 
                    5.1854}, {$CellContext`column\[Bullet]5, 
                    5.7923}, {$CellContext`column\[Bullet]6, 
                    2.1978}, {$CellContext`column\[Bullet]7, 
                    8.449}, {$CellContext`column\[Bullet]8, 
                    27.789}, {$CellContext`column\[Bullet]9, 38.103}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.251113244659922}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.251113244659922`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "522.89`"}, {
                    "column\[Bullet]3", "0.25599`"}, {
                    "column\[Bullet]4", "3.9894`"}, {
                    "column\[Bullet]5", "4.0052`"}, {
                    "column\[Bullet]6", "3.7642`"}, {
                    "column\[Bullet]7", "9.1212`"}, {
                    "column\[Bullet]8", "23.253`"}, {
                    "column\[Bullet]9", "35.749`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 7.251113244659922}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    522.89}, {$CellContext`column\[Bullet]3, 
                    0.25599}, {$CellContext`column\[Bullet]4, 
                    3.9894}, {$CellContext`column\[Bullet]5, 
                    4.0052}, {$CellContext`column\[Bullet]6, 
                    3.7642}, {$CellContext`column\[Bullet]7, 
                    9.1212}, {$CellContext`column\[Bullet]8, 
                    23.253}, {$CellContext`column\[Bullet]9, 35.749}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.4958550837163545`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.4958550837163545`"}, {
                    "\"Observed\"", "7.1`"}, {"column\[Bullet]1", "449.6`"}, {
                    "column\[Bullet]3", "1.5059`"}, {
                    "column\[Bullet]4", "4.4903`"}, {
                    "column\[Bullet]5", "5.4743`"}, {
                    "column\[Bullet]6", "3.0233`"}, {
                    "column\[Bullet]7", "7.9431`"}, {
                    "column\[Bullet]8", "29.027`"}, {
                    "column\[Bullet]9", "37.303`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.4958550837163545`}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    449.6}, {$CellContext`column\[Bullet]3, 
                    1.5059}, {$CellContext`column\[Bullet]4, 
                    4.4903}, {$CellContext`column\[Bullet]5, 
                    5.4743}, {$CellContext`column\[Bullet]6, 
                    3.0233}, {$CellContext`column\[Bullet]7, 
                    7.9431}, {$CellContext`column\[Bullet]8, 
                    29.027}, {$CellContext`column\[Bullet]9, 37.303}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 6.443506626499372}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.443506626499372`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "512.86`"}, {
                    "column\[Bullet]3", "0.21101`"}, {
                    "column\[Bullet]4", "3.3275`"}, {
                    "column\[Bullet]5", "4.5047`"}, {
                    "column\[Bullet]6", "3.588`"}, {
                    "column\[Bullet]7", "9.8523`"}, {
                    "column\[Bullet]8", "23.922`"}, {
                    "column\[Bullet]9", "37.464`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.443506626499372}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    512.86}, {$CellContext`column\[Bullet]3, 
                    0.21101}, {$CellContext`column\[Bullet]4, 
                    3.3275}, {$CellContext`column\[Bullet]5, 
                    4.5047}, {$CellContext`column\[Bullet]6, 
                    3.588}, {$CellContext`column\[Bullet]7, 
                    9.8523}, {$CellContext`column\[Bullet]8, 
                    23.922}, {$CellContext`column\[Bullet]9, 37.464}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 6.633236574347683}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.633236574347683`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "141.73`"}, {
                    "column\[Bullet]3", "0.050792`"}, {
                    "column\[Bullet]4", "0.94377`"}, {
                    "column\[Bullet]5", "0.78211`"}, {
                    "column\[Bullet]6", "1.5099`"}, {
                    "column\[Bullet]7", "1.8776`"}, {
                    "column\[Bullet]8", "7.9649`"}, {
                    "column\[Bullet]9", "11.082`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.633236574347683}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    141.73}, {$CellContext`column\[Bullet]3, 
                    0.050792}, {$CellContext`column\[Bullet]4, 
                    0.94377}, {$CellContext`column\[Bullet]5, 
                    0.78211}, {$CellContext`column\[Bullet]6, 
                    1.5099}, {$CellContext`column\[Bullet]7, 
                    1.8776}, {$CellContext`column\[Bullet]8, 
                    7.9649}, {$CellContext`column\[Bullet]9, 11.082}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 7.765991611284013}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.765991611284013`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "494.74`"}, {
                    "column\[Bullet]3", "0.29517`"}, {
                    "column\[Bullet]4", "6.0598`"}, {
                    "column\[Bullet]5", "6.2497`"}, {
                    "column\[Bullet]6", "3.7783`"}, {
                    "column\[Bullet]7", "12.67`"}, {
                    "column\[Bullet]8", "26.983`"}, {
                    "column\[Bullet]9", "38.495`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.765991611284013}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    494.74}, {$CellContext`column\[Bullet]3, 
                    0.29517}, {$CellContext`column\[Bullet]4, 
                    6.0598}, {$CellContext`column\[Bullet]5, 
                    6.2497}, {$CellContext`column\[Bullet]6, 
                    3.7783}, {$CellContext`column\[Bullet]7, 
                    12.67}, {$CellContext`column\[Bullet]8, 
                    26.983}, {$CellContext`column\[Bullet]9, 38.495}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 6.584877008945339}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.584877008945339`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "535.93`"}, {
                    "column\[Bullet]3", "0.46916`"}, {
                    "column\[Bullet]4", "5.7882`"}, {
                    "column\[Bullet]5", "4.6833`"}, {
                    "column\[Bullet]6", "2.2977`"}, {
                    "column\[Bullet]7", "8.6707`"}, {
                    "column\[Bullet]8", "24.869`"}, {
                    "column\[Bullet]9", "39.804`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.584877008945339}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    535.93}, {$CellContext`column\[Bullet]3, 
                    0.46916}, {$CellContext`column\[Bullet]4, 
                    5.7882}, {$CellContext`column\[Bullet]5, 
                    4.6833}, {$CellContext`column\[Bullet]6, 
                    2.2977}, {$CellContext`column\[Bullet]7, 
                    8.6707}, {$CellContext`column\[Bullet]8, 
                    24.869}, {$CellContext`column\[Bullet]9, 39.804}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 9.838227192869848}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "9.838227192869848`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "507.65`"}, {
                    "column\[Bullet]3", "0.76836`"}, {
                    "column\[Bullet]4", "6.3921`"}, {
                    "column\[Bullet]5", "6.08`"}, {
                    "column\[Bullet]6", "4.8374`"}, {
                    "column\[Bullet]7", "12.295`"}, {
                    "column\[Bullet]8", "26.182`"}, {
                    "column\[Bullet]9", "37.883`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 9.838227192869848}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    507.65}, {$CellContext`column\[Bullet]3, 
                    0.76836}, {$CellContext`column\[Bullet]4, 
                    6.3921}, {$CellContext`column\[Bullet]5, 
                    6.08}, {$CellContext`column\[Bullet]6, 
                    4.8374}, {$CellContext`column\[Bullet]7, 
                    12.295}, {$CellContext`column\[Bullet]8, 
                    26.182}, {$CellContext`column\[Bullet]9, 37.883}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 6.386869012552584}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.386869012552584`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "535.16`"}, {
                    "column\[Bullet]3", "0.3249`"}, {
                    "column\[Bullet]4", "5.3768`"}, {
                    "column\[Bullet]5", "5.0641`"}, {
                    "column\[Bullet]6", "2.5499`"}, {
                    "column\[Bullet]7", "8.9237`"}, {
                    "column\[Bullet]8", "25.047`"}, {
                    "column\[Bullet]9", "39.322`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.386869012552584}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    535.16}, {$CellContext`column\[Bullet]3, 
                    0.3249}, {$CellContext`column\[Bullet]4, 
                    5.3768}, {$CellContext`column\[Bullet]5, 
                    5.0641}, {$CellContext`column\[Bullet]6, 
                    2.5499}, {$CellContext`column\[Bullet]7, 
                    8.9237}, {$CellContext`column\[Bullet]8, 
                    25.047}, {$CellContext`column\[Bullet]9, 39.322}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.152533799932753`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.152533799932753`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "482.03`"}, {
                    "column\[Bullet]3", "1.3671`"}, {
                    "column\[Bullet]4", "8.6916`"}, {
                    "column\[Bullet]5", "5.5778`"}, {
                    "column\[Bullet]6", "3.6361`"}, {
                    "column\[Bullet]7", "10.906`"}, {
                    "column\[Bullet]8", "24.312`"}, {
                    "column\[Bullet]9", "35.16`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.152533799932753`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    482.03}, {$CellContext`column\[Bullet]3, 
                    1.3671}, {$CellContext`column\[Bullet]4, 
                    8.6916}, {$CellContext`column\[Bullet]5, 
                    5.5778}, {$CellContext`column\[Bullet]6, 
                    3.6361}, {$CellContext`column\[Bullet]7, 
                    10.906}, {$CellContext`column\[Bullet]8, 
                    24.312}, {$CellContext`column\[Bullet]9, 35.16}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.698441828449079`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.698441828449079`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "546.08`"}, {
                    "column\[Bullet]3", "0.86053`"}, {
                    "column\[Bullet]4", "8.2416`"}, {
                    "column\[Bullet]5", "3.005`"}, {
                    "column\[Bullet]6", "6.7219`"}, {
                    "column\[Bullet]7", "15.683`"}, {
                    "column\[Bullet]8", "27.71`"}, {
                    "column\[Bullet]9", "41.967`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.698441828449079`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    546.08}, {$CellContext`column\[Bullet]3, 
                    0.86053}, {$CellContext`column\[Bullet]4, 
                    8.2416}, {$CellContext`column\[Bullet]5, 
                    3.005}, {$CellContext`column\[Bullet]6, 
                    6.7219}, {$CellContext`column\[Bullet]7, 
                    15.683}, {$CellContext`column\[Bullet]8, 
                    27.71}, {$CellContext`column\[Bullet]9, 41.967}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.561223389485507`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.561223389485507`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "478.1`"}, {
                    "column\[Bullet]3", "1.3527`"}, {
                    "column\[Bullet]4", "8.6401`"}, {
                    "column\[Bullet]5", "5.4848`"}, {
                    "column\[Bullet]6", "4.0197`"}, {
                    "column\[Bullet]7", "10.366`"}, {
                    "column\[Bullet]8", "24.363`"}, {
                    "column\[Bullet]9", "35.811`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.561223389485507`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    478.1}, {$CellContext`column\[Bullet]3, 
                    1.3527}, {$CellContext`column\[Bullet]4, 
                    8.6401}, {$CellContext`column\[Bullet]5, 
                    5.4848}, {$CellContext`column\[Bullet]6, 
                    4.0197}, {$CellContext`column\[Bullet]7, 
                    10.366}, {$CellContext`column\[Bullet]8, 
                    24.363}, {$CellContext`column\[Bullet]9, 35.811}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.65666887131853}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.65666887131853`"}, {
                    "\"Observed\"", "10.3`"}, {"column\[Bullet]1", "543"}, {
                    "column\[Bullet]3", "0.84787`"}, {
                    "column\[Bullet]4", "8.3698`"}, {
                    "column\[Bullet]5", "3.2232`"}, {
                    "column\[Bullet]6", "6.3927`"}, {
                    "column\[Bullet]7", "15.684`"}, {
                    "column\[Bullet]8", "26.848`"}, {
                    "column\[Bullet]9", "42.609`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.65666887131853}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    543}, {$CellContext`column\[Bullet]3, 
                    0.84787}, {$CellContext`column\[Bullet]4, 
                    8.3698}, {$CellContext`column\[Bullet]5, 
                    3.2232}, {$CellContext`column\[Bullet]6, 
                    6.3927}, {$CellContext`column\[Bullet]7, 
                    15.684}, {$CellContext`column\[Bullet]8, 
                    26.848}, {$CellContext`column\[Bullet]9, 42.609}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 8.835535088472563}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "8.835535088472563`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "143.11`"}, {
                    "column\[Bullet]3", "0.40296`"}, {
                    "column\[Bullet]4", "1.3237`"}, {
                    "column\[Bullet]5", "0.64428`"}, {
                    "column\[Bullet]6", "1.0514`"}, {
                    "column\[Bullet]7", "3.0034`"}, {
                    "column\[Bullet]8", "6.7439`"}, {
                    "column\[Bullet]9", "11.048`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 8.835535088472563}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    143.11}, {$CellContext`column\[Bullet]3, 
                    0.40296}, {$CellContext`column\[Bullet]4, 
                    1.3237}, {$CellContext`column\[Bullet]5, 
                    0.64428}, {$CellContext`column\[Bullet]6, 
                    1.0514}, {$CellContext`column\[Bullet]7, 
                    3.0034}, {$CellContext`column\[Bullet]8, 
                    6.7439}, {$CellContext`column\[Bullet]9, 11.048}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.038515962517176`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.038515962517176`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "543.88`"}, {
                    "column\[Bullet]3", "1.3812`"}, {
                    "column\[Bullet]4", "5.623`"}, {
                    "column\[Bullet]5", "3.3965`"}, {
                    "column\[Bullet]6", "6.0126`"}, {
                    "column\[Bullet]7", "13.757`"}, {
                    "column\[Bullet]8", "24.836`"}, {
                    "column\[Bullet]9", "41.74`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 12.038515962517176`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    543.88}, {$CellContext`column\[Bullet]3, 
                    1.3812}, {$CellContext`column\[Bullet]4, 
                    5.623}, {$CellContext`column\[Bullet]5, 
                    3.3965}, {$CellContext`column\[Bullet]6, 
                    6.0126}, {$CellContext`column\[Bullet]7, 
                    13.757}, {$CellContext`column\[Bullet]8, 
                    24.836}, {$CellContext`column\[Bullet]9, 41.74}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.804705381896722`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.804705381896722`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "546.51`"}, {
                    "column\[Bullet]3", "1.2991`"}, {
                    "column\[Bullet]4", "7.3685`"}, {
                    "column\[Bullet]5", "3.7206`"}, {
                    "column\[Bullet]6", "6.4331`"}, {
                    "column\[Bullet]7", "16.695`"}, {
                    "column\[Bullet]8", "26.379`"}, {
                    "column\[Bullet]9", "40.665`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.804705381896722`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    546.51}, {$CellContext`column\[Bullet]3, 
                    1.2991}, {$CellContext`column\[Bullet]4, 
                    7.3685}, {$CellContext`column\[Bullet]5, 
                    3.7206}, {$CellContext`column\[Bullet]6, 
                    6.4331}, {$CellContext`column\[Bullet]7, 
                    16.695}, {$CellContext`column\[Bullet]8, 
                    26.379}, {$CellContext`column\[Bullet]9, 40.665}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.644895503336997`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.644895503336997`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "536.68`"}, {
                    "column\[Bullet]3", "1.4521`"}, {
                    "column\[Bullet]4", "6.3842`"}, {
                    "column\[Bullet]5", "3.7362`"}, {
                    "column\[Bullet]6", "6.0247`"}, {
                    "column\[Bullet]7", "12.645`"}, {
                    "column\[Bullet]8", "24.301`"}, {
                    "column\[Bullet]9", "42.08`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.644895503336997`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    536.68}, {$CellContext`column\[Bullet]3, 
                    1.4521}, {$CellContext`column\[Bullet]4, 
                    6.3842}, {$CellContext`column\[Bullet]5, 
                    3.7362}, {$CellContext`column\[Bullet]6, 
                    6.0247}, {$CellContext`column\[Bullet]7, 
                    12.645}, {$CellContext`column\[Bullet]8, 
                    24.301}, {$CellContext`column\[Bullet]9, 42.08}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.846817961999978`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.846817961999978`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "548.12`"}, {
                    "column\[Bullet]3", "1.1934`"}, {
                    "column\[Bullet]4", "7.4775`"}, {
                    "column\[Bullet]5", "4.1336`"}, {
                    "column\[Bullet]6", "6.1911`"}, {
                    "column\[Bullet]7", "15.129`"}, {
                    "column\[Bullet]8", "28.879`"}, {
                    "column\[Bullet]9", "40.1`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.846817961999978`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    548.12}, {$CellContext`column\[Bullet]3, 
                    1.1934}, {$CellContext`column\[Bullet]4, 
                    7.4775}, {$CellContext`column\[Bullet]5, 
                    4.1336}, {$CellContext`column\[Bullet]6, 
                    6.1911}, {$CellContext`column\[Bullet]7, 
                    15.129}, {$CellContext`column\[Bullet]8, 
                    28.879}, {$CellContext`column\[Bullet]9, 40.1}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 12.588419513536858`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.588419513536858`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "476.72`"}, {
                    "column\[Bullet]3", "2.0181`"}, {
                    "column\[Bullet]4", "6.0249`"}, {
                    "column\[Bullet]5", "4.8816`"}, {
                    "column\[Bullet]6", "5.7373`"}, {
                    "column\[Bullet]7", "13.676`"}, {
                    "column\[Bullet]8", "25.969`"}, {
                    "column\[Bullet]9", "42.807`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.588419513536858`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    476.72}, {$CellContext`column\[Bullet]3, 
                    2.0181}, {$CellContext`column\[Bullet]4, 
                    6.0249}, {$CellContext`column\[Bullet]5, 
                    4.8816}, {$CellContext`column\[Bullet]6, 
                    5.7373}, {$CellContext`column\[Bullet]7, 
                    13.676}, {$CellContext`column\[Bullet]8, 
                    25.969}, {$CellContext`column\[Bullet]9, 42.807}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 14.40990454458862}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.40990454458862`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "513.04`"}, {
                    "column\[Bullet]3", "1.1795`"}, {
                    "column\[Bullet]4", "11.01`"}, {
                    "column\[Bullet]5", "6.2992`"}, {
                    "column\[Bullet]6", "5.9536`"}, {
                    "column\[Bullet]7", "17.597`"}, {
                    "column\[Bullet]8", "24.377`"}, {
                    "column\[Bullet]9", "43.709`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.40990454458862}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    513.04}, {$CellContext`column\[Bullet]3, 
                    1.1795}, {$CellContext`column\[Bullet]4, 
                    11.01}, {$CellContext`column\[Bullet]5, 
                    6.2992}, {$CellContext`column\[Bullet]6, 
                    5.9536}, {$CellContext`column\[Bullet]7, 
                    17.597}, {$CellContext`column\[Bullet]8, 
                    24.377}, {$CellContext`column\[Bullet]9, 43.709}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 11.872370034402724`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.872370034402724`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "479.57`"}, {
                    "column\[Bullet]3", "1.6137`"}, {
                    "column\[Bullet]4", "6.5073`"}, {
                    "column\[Bullet]5", "4.5171`"}, {
                    "column\[Bullet]6", "5.2461`"}, {
                    "column\[Bullet]7", "13.349`"}, {
                    "column\[Bullet]8", "25.671`"}, {
                    "column\[Bullet]9", "43.178`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.872370034402724`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    479.57}, {$CellContext`column\[Bullet]3, 
                    1.6137}, {$CellContext`column\[Bullet]4, 
                    6.5073}, {$CellContext`column\[Bullet]5, 
                    4.5171}, {$CellContext`column\[Bullet]6, 
                    5.2461}, {$CellContext`column\[Bullet]7, 
                    13.349}, {$CellContext`column\[Bullet]8, 
                    25.671}, {$CellContext`column\[Bullet]9, 43.178}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 13.530968679574318`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "13.530968679574318`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "516.99`"}, {
                    "column\[Bullet]3", "1.4319`"}, {
                    "column\[Bullet]4", "9.6825`"}, {
                    "column\[Bullet]5", "5.6339`"}, {
                    "column\[Bullet]6", "5.4707`"}, {
                    "column\[Bullet]7", "18.345`"}, {
                    "column\[Bullet]8", "24.9`"}, {
                    "column\[Bullet]9", "44.029`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 13.530968679574318`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    516.99}, {$CellContext`column\[Bullet]3, 
                    1.4319}, {$CellContext`column\[Bullet]4, 
                    9.6825}, {$CellContext`column\[Bullet]5, 
                    5.6339}, {$CellContext`column\[Bullet]6, 
                    5.4707}, {$CellContext`column\[Bullet]7, 
                    18.345}, {$CellContext`column\[Bullet]8, 
                    24.9}, {$CellContext`column\[Bullet]9, 44.029}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 14.163764655142524`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.163764655142524`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "119.5`"}, {
                    "column\[Bullet]3", "0.35884`"}, {
                    "column\[Bullet]4", "1.9558`"}, {
                    "column\[Bullet]5", "1.0669`"}, {
                    "column\[Bullet]6", "2.0195`"}, {
                    "column\[Bullet]7", "3.7138`"}, {
                    "column\[Bullet]8", "5.4228`"}, {
                    "column\[Bullet]9", "10.293`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.163764655142524`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    119.5}, {$CellContext`column\[Bullet]3, 
                    0.35884}, {$CellContext`column\[Bullet]4, 
                    1.9558}, {$CellContext`column\[Bullet]5, 
                    1.0669}, {$CellContext`column\[Bullet]6, 
                    2.0195}, {$CellContext`column\[Bullet]7, 
                    3.7138}, {$CellContext`column\[Bullet]8, 
                    5.4228}, {$CellContext`column\[Bullet]9, 10.293}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 15.079324811209364`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.079324811209364`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "548.83`"}, {
                    "column\[Bullet]3", "1.0885`"}, {
                    "column\[Bullet]4", "9.4613`"}, {
                    "column\[Bullet]5", "6.25`"}, {
                    "column\[Bullet]6", "8.5286`"}, {
                    "column\[Bullet]7", "17.548`"}, {
                    "column\[Bullet]8", "26.191`"}, {
                    "column\[Bullet]9", "45.894`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.079324811209364`}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    548.83}, {$CellContext`column\[Bullet]3, 
                    1.0885}, {$CellContext`column\[Bullet]4, 
                    9.4613}, {$CellContext`column\[Bullet]5, 
                    6.25}, {$CellContext`column\[Bullet]6, 
                    8.5286}, {$CellContext`column\[Bullet]7, 
                    17.548}, {$CellContext`column\[Bullet]8, 
                    26.191}, {$CellContext`column\[Bullet]9, 45.894}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 14.005747415840688`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.005747415840688`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "521.59`"}, {
                    "column\[Bullet]3", "1.2334`"}, {
                    "column\[Bullet]4", "8.0874`"}, {
                    "column\[Bullet]5", "8.1225`"}, {
                    "column\[Bullet]6", "8.0376`"}, {
                    "column\[Bullet]7", "21.222`"}, {
                    "column\[Bullet]8", "27.015`"}, {
                    "column\[Bullet]9", "40.157`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.005747415840688`}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    521.59}, {$CellContext`column\[Bullet]3, 
                    1.2334}, {$CellContext`column\[Bullet]4, 
                    8.0874}, {$CellContext`column\[Bullet]5, 
                    8.1225}, {$CellContext`column\[Bullet]6, 
                    8.0376}, {$CellContext`column\[Bullet]7, 
                    21.222}, {$CellContext`column\[Bullet]8, 
                    27.015}, {$CellContext`column\[Bullet]9, 40.157}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 14.604907845123984`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.604907845123984`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "543.43`"}, {
                    "column\[Bullet]3", "1.0863`"}, {
                    "column\[Bullet]4", "8.3086`"}, {
                    "column\[Bullet]5", "5.6697`"}, {
                    "column\[Bullet]6", "8.4702`"}, {
                    "column\[Bullet]7", "18.159`"}, {
                    "column\[Bullet]8", "26.114`"}, {
                    "column\[Bullet]9", "45.312`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.604907845123984`}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    543.43}, {$CellContext`column\[Bullet]3, 
                    1.0863}, {$CellContext`column\[Bullet]4, 
                    8.3086}, {$CellContext`column\[Bullet]5, 
                    5.6697}, {$CellContext`column\[Bullet]6, 
                    8.4702}, {$CellContext`column\[Bullet]7, 
                    18.159}, {$CellContext`column\[Bullet]8, 
                    26.114}, {$CellContext`column\[Bullet]9, 45.312}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 13.25038123584012}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "13.25038123584012`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "529.7`"}, {
                    "column\[Bullet]3", "0.79776`"}, {
                    "column\[Bullet]4", "7.8321`"}, {
                    "column\[Bullet]5", "7.2456`"}, {
                    "column\[Bullet]6", "8.2711`"}, {
                    "column\[Bullet]7", "21.125`"}, {
                    "column\[Bullet]8", "28.161`"}, {
                    "column\[Bullet]9", "40.084`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 13.25038123584012}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    529.7}, {$CellContext`column\[Bullet]3, 
                    0.79776}, {$CellContext`column\[Bullet]4, 
                    7.8321}, {$CellContext`column\[Bullet]5, 
                    7.2456}, {$CellContext`column\[Bullet]6, 
                    8.2711}, {$CellContext`column\[Bullet]7, 
                    21.125}, {$CellContext`column\[Bullet]8, 
                    28.161}, {$CellContext`column\[Bullet]9, 40.084}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ]}}, {}, {}, {}, {}}, AspectRatio -> 
               105./Dynamic[
                 DataModeler`DataModelerGUI`Private`optValue[
                 DataModeler`ModelReview`ModelSummaryTable, ImageSize]], 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {1.2909502850177075`, 1.2909502850177075`}, 
               DisplayFunction -> Identity, 
               Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
                  FormBox["\"Predicted\"", TraditionalForm], None}, {
                  FormBox["\"Observed\"", TraditionalForm], None}}, 
               FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}},
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImagePadding -> All, ImageSize -> 500, 
               Method -> {
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{1.1668227404534477`, 25.99233165330541}, {
                1.1668227404534477`, 25.99233165330541}}, PlotRangeClipping -> 
               True, PlotRangePadding -> {{0, 0}, {0, 0}}, Prolog -> {
                 RGBColor[0, 1, 0], 
                 Thickness[Medium], 
                 
                 LineBox[{{1.1668227404534477`, 1.1668227404534477`}, {
                  25.99233165330541, 25.99233165330541}}]}, 
               Ticks -> {Automatic, Automatic}], 
              RowBox[{"MedianAverage", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.89\"", 0.8914097926737627, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.58\"", 732.5832364133336, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.11\"", 2.113808720357664, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"68.58\"", 68.58401194252002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.80\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.037977703625019794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.22\"", 1.2170341589085145`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.17\"", 1.170553481638129, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.09\"", 51.08826447265663, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4376907446392891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"221501.35\"", 221501.3451429473, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.22\"", 2.216203884016891, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.25\"", 7.249569600913545, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.45\"", 1.4456221384884378`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.46\"", 5.4612970662714355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.47\"", 0.47151508096227146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.49\"", 2.4892598925651224`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.87\"", 37.870051197694124`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.19\"", 21.19142255107015, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.63\"", 0.6320647414300411, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.87\"", 1.8687964773614916`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"67757.14\"", 67757.13995983037, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "2"]], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.43\"", 1.4303812581132638`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.8438575255030141, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.53\"", 2.527764546077162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.45\"", 0.44921156638948345`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.13\"", 1.130657927313153, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"94.11\"", 94.1141569500062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.58\"", 3.5784966338509947`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7094941200674296`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7129668266286451, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.20325703469711126`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"23.64\"", 23.643167835772363`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.84\"", 0.844906569833192, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.93\"", 1.9331671585071581`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.37\"", 0.3694162958661281, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.24\"", 1.2449582851700662`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"51.04\"", 51.04087439182302, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.33\"", 1.327285545019054, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.49\"", 1.4867827577795298`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.38\"", "\[Times]", 
                    SuperscriptBox["10", "\"-3\""]}], 0.004381834899129271, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.74\"", 0.7387541921476599, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"34.17\"", 34.169395285760274`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"7.05\"", 7.049735524240697, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.95\"", 4.947790998755661, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.33\"", 0.32760617817725146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.28\"", 37.27833291350976, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5129035402029928, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.968456006882272, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.21\"", 1.205100037981496, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"23.28\"", 23.283052672760757`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"37.98\"", 37.98221013200929, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.24\"", 11.242037793589047`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.19\"", 1.1885141225150353`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"424.86\"", 424.85509285667996`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.73\"", 1.7295798543619, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.18\"", 1.1816964386067825`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.67\"", 2.669738076043367, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.37\"", 2.368519451653811, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.53\"", 0.5324564370095887, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"31.38\"", 31.38409410219968, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "-", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"1.66\"", "\[Times]", 
                    SuperscriptBox["10", "\"-5\""]}], 
                    0.000016630662056455233`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "3"], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}]}]}], "}"}], ",", 
                  TagBox[
                   InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                "]"}], TooltipDelay -> 0.15], Annotation[#, 
              
              DataModeler`DataExploration`MedianAverage[{
               NumberForm[
                 0.8914097926737627, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                  NumberForm[
                   732.5832364133336, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]], 
                NumberForm[
                 0.5972434214759587, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  41.135346220113384`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 2.113808720357664, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  68.58401194252002, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + (
                  NumberForm[
                   0.037977703625019794`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], -
                 NumberForm[
                  3.882350562760903, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  2.0321890071965854`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  63.363724799250285`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  1.2170341589085145`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.170553481638129, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  51.08826447265663, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  0.4376907446392891, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                  NumberForm[
                   221501.3451429473, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  2.216203884016891, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], 
                NumberForm[
                 7.249569600913545, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.4456221384884378`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  5.4612970662714355`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2] - 
                NumberForm[
                 0.47151508096227146`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
                NumberForm[
                 11.135546219979584`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  8.280454674605123, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.5908371539294913, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 - 
                NumberForm[
                 0.8978305425889783, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
                NumberForm[
                 8.159680560964581, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 0.04011738767128822, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  5.224685491056446, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.22854010099263636`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2, 
                NumberForm[
                 2.4892598925651224`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  37.870051197694124`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  21.19142255107015, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.2792678309107002, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.24783345853136146`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  36.819424146231384`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.42612172604868076`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                 NumberForm[
                  0.06256007839813221, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  44.23179551124747, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  2.4172135657118963`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.7361891056524232`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  0.7046357704345062, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  71.48309026794081, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.5056525266429981, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.6158725575337699, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                NumberForm[
                  38.90598516721604, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  0.6320647414300411, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.8687964773614916`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + (
                  NumberForm[
                   67757.13995983037, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]^(-2)) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  1.4303812581132638`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], 
                NumberForm[
                 0.8438575255030141, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 2.527764546077162, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  0.44921156638948345`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  1.130657927313153, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  94.1141569500062, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 3.5784966338509947`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.7094941200674296`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.7129668266286451, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  0.20325703469711126`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "7"]], 
                   Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  23.643167835772363`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  1.7044153746685882`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.4351705392786716`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  39.0054125568516, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  36.22633469690617, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  0.844906569833192, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.9331671585071581`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.3694162958661281, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  1.2449582851700662`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  51.04087439182302, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  1.327285545019054, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.4867827577795298`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.004381834899129271, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3 + 
                NumberForm[
                  0.7387541921476599, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  34.169395285760274`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 7.049735524240697, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  4.947790998755661, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.32760617817725146`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 + 
                NumberForm[
                  37.27833291350976, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - 
                NumberForm[
                 0.5129035402029928, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
                NumberForm[
                 3.1346046653275597`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 0.5661079421576403, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  0.9736432501341529, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  41.463770769155424`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  14.128156845155987`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  0.968456006882272, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.205100037981496, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  23.283052672760757`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]] + 
                NumberForm[
                  37.98221013200929, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  11.242037793589047`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 1.1885141225150353`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                  NumberForm[
                   424.85509285667996`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) (1 + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]) - 
                NumberForm[
                 1.7295798543619, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                   Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                NumberForm[
                  1.1816964386067825`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]], 
                NumberForm[
                 2.669738076043367, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  2.368519451653811, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.5324564370095887, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  31.38409410219968, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) - ((
                  NumberForm[
                   0.000016630662056455233`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^3) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "9"]], 
                  Hue[
                   Rational[9, 10], 1, 
                   Rational[5, 6]]]}, 
               NumberForm[
               0.7, {8, 2}, ExponentFunction -> (If[-2 < # < 8, Null, #]& )]],
               "Tooltip"]& ], ItemSize -> Automatic, StripOnInput -> False]}},
          AutoDelete -> False, BaselinePosition -> Center, FrameStyle -> 
         Directive[
           GrayLevel[0.85]], 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{
              GrayLevel[0.85]}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}], 
        "Grid"], 
       StyleBox[
       "\"Ensemble1 [Test] Summary Table\"", {
        FontWeight -> "Bold", FontSize -> 12, FontFamily -> "Helvetica", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False]}, "Labeled", 
      DisplayFunction -> (GridBox[{{
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, 
        GridBoxItemSize -> {
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
        BaselinePosition -> {2, 1}]& ), 
      InterpretationFunction -> (RowBox[{"Labeled", "[", 
         RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )]}, "RowDefault"]},
  "RowDefault"]], "Output",ExpressionUUID->"65fdf5be-ca29-4758-bd13-\
9432f75d79f6"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ensemble 2 (R^2 of 0.93058)", "Subsection",
 CellChangeTimes->{{3.742812397313259*^9, 
  3.742812416473749*^9}},ExpressionUUID->"243ff226-54b1-455a-8774-\
8d270485621d"],

Cell[BoxData[
 TemplateBox[{TemplateBox[{
     TemplateBox[{
       TagBox[
        GridBox[{{
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Expression\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], 
           PaneBox[
            ItemBox[
             TemplateBox[{
               TagBox[
                GridBox[{{
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.56\"", 6.558527645565748, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.62\"", 36.618371875581836`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.19\"", 2.1908135489152247`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7280268689895092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"117.25\"", 117.24727812838044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.86\"", 0.8620951567752905, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.62\"", 732.6165153538162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.91\"", 0.905359277852415, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.47\"", 3.4733768128077096`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.29\"", 2.2947176471822623`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7390571409205557`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"69.87\"", 69.87005969257898, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.76\"", 11.75663792584013, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7100848960685717`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0141153649569057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.40469052094093616`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4907970088213184, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.27543008176316136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.88\"", 39.88006338431486, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.33\"", 33.33120471027875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.89\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.038939420148409794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.18\"", 39.18371072963305, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.85\"", 21.8462052882725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.88\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09875226201681911, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34137677056759286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.71\"", 2.706173995605092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3180494881255718`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2521102772782762, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"103.53\"", 103.53091868397507`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"7.66\"", 7.6569380414546355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.505929605016708, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9897309759518025, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.1043628156090113`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.25\"", 36.2535293671652, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}]}, {
                   RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6700752445202611`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.6128394340247934`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6853465073594838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.324592179540275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.46\"", 25.461775420180842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Center}}, "Rows" -> {{Center}}}, AutoDelete -> 
                 False, GridBoxDividers -> {
                  "Columns" -> {{True}}, "Rows" -> {{True}}}, 
                 GridBoxFrame -> {
                  "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}, BaselinePosition -> Center, FrameStyle -> 
                 Directive[
                   GrayLevel[0.85]]], "Grid"], 
               StyleBox[
               "\"MedianAverage[models, 0.7]\"", {
                FontWeight -> "Bold", FontSize -> 12, FontFamily -> 
                 "Helvetica", FontSlant -> "Plain", FontColor -> GrayLevel[0],
                  Background -> None, ShowStringCharacters -> False}, 
                StripOnInput -> False]}, "Labeled", 
              DisplayFunction -> (GridBox[{{
                  ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
                  TagBox[
                   ItemBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], DefaultBaseStyle -> "Labeled"], 
                   "SkipImageSizeLevel"]}}, 
                GridBoxAlignment -> {
                 "Columns" -> {{Center}}, "Rows" -> {{Center}}}, AutoDelete -> 
                False, GridBoxItemSize -> {
                 "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                BaselinePosition -> {2, 1}]& ), 
              InterpretationFunction -> (RowBox[{"Labeled", "[", 
                 RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )], BaseStyle -> 
             Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]], 
             StripOnInput -> False], Alignment -> Center, ImageSize -> 500]}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Ensemble\\\\\\\"\
\\\"}, {\\\"\\\\\\\"Quality\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             "\"This uses values embedded in the ensemble rather\\nthan being \
recalculated using the supplied data\"", TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "This uses values embedded in the ensemble rather\nthan being \
recalculated using the supplied data", "Tooltip"]& ], 
           TagBox[
            GridBox[{{
               StyleBox[
               "\"\\!\\(R\\^2\\)\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None], 
               "0.9305849928118266`"}, {
               StyleBox[
               "\"# Variables\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "8"}, {
               StyleBox[
               "\"# Models\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "20"}, {
               StyleBox[
               "\"Avg Model Complexity\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None], "35.6`"}}, 
             AutoDelete -> False, BaselinePosition -> Center, FrameStyle -> 
             Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Model\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Quality\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             "\"This uses values embedded in the model rather\\nthan being \
recalculated using the supplied data\"", TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "This uses values embedded in the model rather\nthan being \
recalculated using the supplied data", "Tooltip"]& ], 
           TagBox[
            GridBox[{{
               StyleBox[
               "\"Model\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], 
               StyleBox[
               "\"Complexity\"", StripOnInput -> False, ShowStringCharacters -> 
                False, FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], 
               StyleBox[
               "\"1-\\!\\(R\\^2\\)\"", StripOnInput -> False, 
                ShowStringCharacters -> False, FontFamily -> "Helvetica", 
                FontSize -> 10, FontWeight -> "Bold", FontSlant -> "Plain", 
                FontColor -> GrayLevel[0], Background -> None]}, {
               StyleBox[
               "\"1\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "25", "0.17032609999999998`"}, {
               StyleBox[
               "\"2\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "26", "0.1028776`"}, {
               StyleBox[
               "\"3\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "26", "0.17637139999999998`"}, {
               StyleBox[
               "\"4\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "26", "0.1901193`"}, {
               StyleBox[
               "\"5\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "27", "0.14266879999999998`"}, {
               StyleBox[
               "\"6\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "27", "0.1840364`"}, {
               StyleBox[
               "\"7\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "30", "0.16934559999999999`"}, {
               StyleBox[
               "\"8\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.1581825`"}, {
               StyleBox[
               "\"9\"", StripOnInput -> False, ShowStringCharacters -> False, 
                FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "31", "0.1744261`"}, {
               StyleBox[
               "\"10\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "34", "0.09436705000000001`"}, {
               StyleBox[
               "\"11\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "37", "0.09881036`"}, {
               StyleBox[
               "\"12\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "38", "0.09624229000000001`"}, {
               StyleBox[
               "\"13\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "38", "0.1016792`"}, {
               StyleBox[
               "\"14\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "41", "0.09357585`"}, {
               StyleBox[
               "\"15\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "41", "0.1211005`"}, {
               StyleBox[
               "\"16\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "42", "0.1013771`"}, {
               StyleBox[
               "\"17\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "45", "0.07813515`"}, {
               StyleBox[
               "\"18\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "49", "0.07454574`"}, {
               StyleBox[
               "\"19\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "49", "0.08349998`"}, {
               StyleBox[
               "\"20\"", StripOnInput -> False, ShowStringCharacters -> False,
                 FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                "Bold", FontSlant -> "Plain", FontColor -> GrayLevel[0], 
                Background -> None], "49", "0.08768011`"}}, AutoDelete -> 
             False, BaselinePosition -> Center, FrameStyle -> Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Variables\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], 
           TagBox[
            GridBox[{{
               StyleBox[
               "column\[Bullet]1", StripOnInput -> False, LineColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[1, 10], 1, 
                  Rational[5, 6]]], 
               StyleBox[
               "column\[Bullet]3", StripOnInput -> False, LineColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[3, 10], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]4", StripOnInput -> False, LineColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[2, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]5", StripOnInput -> False, LineColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[1, 2], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]6", StripOnInput -> False, LineColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[3, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]7", StripOnInput -> False, LineColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[7, 10], 1, 
                  Rational[5, 6]]]}, {
               StyleBox[
               "column\[Bullet]8", StripOnInput -> False, LineColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], FrontFaceColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], BackFaceColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], GraphicsColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]], FontColor -> Hue[
                  Rational[4, 5], 1, 
                  Rational[1, 2]]], 
               StyleBox[
               "column\[Bullet]9", StripOnInput -> False, LineColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], FrontFaceColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], BackFaceColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], GraphicsColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]], FontColor -> Hue[
                  Rational[9, 10], 1, 
                  Rational[5, 6]]]}}, AutoDelete -> False, BaselinePosition -> 
             Center, FrameStyle -> Directive[
               GrayLevel[0.85]], 
             GridBoxAlignment -> {
              "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
             GridBoxDividers -> {
              "Columns" -> {False, {True}, False}, 
               "Rows" -> {False, {True}, False}}, 
             GridBoxFrame -> {
              "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxItemStyle -> {"Columns" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}, "Rows" -> {{
                  Directive[
                  FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                   "Plain", FontSlant -> "Plain", FontColor -> 
                   GrayLevel[0]]}}}], "Grid"]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"R-Squared\\\\\\\"\
\\\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
            FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
            FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
            None], "0.9280472154038485`"}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Adjusted\\\\\\\"\\\
\"}, {\\\"\\\\\\\"R-Squared\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
            ShowStringCharacters -> False, FontFamily -> "Helvetica", 
            FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
            FontColor -> GrayLevel[0], Background -> None], 
           "0.9269402494869846`"}, {
           TagBox[
            TooltipBox[
             StyleBox[
             
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Noise\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Power\\\\\\\"\\\"}}, Rule[GridBoxAlignment, \
List[Rule[\\\"Columns\\\", List[List[Center]]]]], Rule[DefaultBaseStyle, \
\\\"Column\\\"], Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", \
List[List[Automatic]]], Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \
\\\"Column\\\"], TraditionalForm]\\)\"", StripOnInput -> False, 
              ShowStringCharacters -> False, FontFamily -> "Helvetica", 
              FontSize -> 10, FontWeight -> Bold, FontSlant -> "Plain", 
              FontColor -> GrayLevel[0], Background -> None], 
             "\"The noise power, \
\\!\\(\\*FractionBox[SuperscriptBox[SubscriptBox[\\(\[Sigma]\\), \
\\(error\\)], \\(2\\)], SuperscriptBox[SubscriptBox[\\(\[Sigma]\\), \
\\(observed\\)], \\(2\\)]]\\), is the ratio of the energy (2-norm) of \
the\\nprediction error normalized by the energy of the observed response.\"", 
             TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "The noise power, \!\(\*FractionBox[SuperscriptBox[SubscriptBox[\
\(\[Sigma]\), \(error\)], \(2\)], SuperscriptBox[SubscriptBox[\(\[Sigma]\), \
\(observed\)], \(2\)]]\), is the ratio of the energy (2-norm) of the\n\
prediction error normalized by the energy of the observed response.", 
             "Tooltip"]& ], "0.020632642639266206`"}, {
           TagBox[
            TooltipBox[
             StyleBox[
             "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"ANOVA\\\\\\\"\\\
\"}}, Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", \
List[List[Center]]]]], Rule[DefaultBaseStyle, \\\"Column\\\"], \
Rule[GridBoxItemSize, List[Rule[\\\"Columns\\\", List[List[Automatic]]], \
Rule[\\\"Rows\\\", List[List[Automatic]]]]]], \\\"Column\\\"], \
TraditionalForm]\\)\"", StripOnInput -> False, ShowStringCharacters -> False, 
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> Bold, 
              FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> 
              None], "\"WARNING: This is calculated aginst the supplied data \
using the\\ntop-level bases with the associated coefficients ignored.\"", 
             TooltipStyle -> "TextStyling"], 
            Annotation[#, 
             "WARNING: This is calculated aginst the supplied data using the\n\
top-level bases with the associated coefficients ignored.", "Tooltip"]& ], 
           PaneBox[
            TagBox[
             DynamicModuleBox[{Typeset`var$$ = 1}, 
              InterpretationBox[
               TagBox[
                PanelBox[
                 GridBox[{{
                    ItemBox[
                    GridBox[{{
                    GridBox[{{
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[FirstPage]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ =!= 1, Typeset`var$$ = 1], Enabled -> 
                    Automatic, Evaluator -> Automatic, ImageSize -> Small, 
                    Method -> "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipFirstSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipFirstSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[LeftPointer]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ > 1, 
                    PreDecrement[Typeset`var$$]], Enabled -> Automatic, 
                    Evaluator -> Automatic, ImageSize -> Small, Method -> 
                    "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipPreviousSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipPreviousSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[RightPointer]\"", StripOnInput -> False, FontSize -> 
                    18], Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ < 20, 
                    PreIncrement[Typeset`var$$]], Enabled -> Automatic, 
                    Evaluator -> Automatic, ImageSize -> Small, Method -> 
                    "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipNextSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipNextSlide"]], 
                    "Tooltip"]& ], 
                    TagBox[
                    TooltipBox[
                    ButtonBox[
                    StyleBox[
                    "\"\[LastPage]\"", StripOnInput -> False, FontSize -> 18],
                     Appearance -> "Palette", ButtonFunction :> 
                    If[Typeset`var$$ =!= 20, Typeset`var$$ = 20], Enabled -> 
                    Automatic, Evaluator -> Automatic, ImageSize -> Small, 
                    Method -> "Preemptive"], 
                    DynamicBox[
                    ToBoxes[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipLastSlide"], 
                    StandardForm]]], Annotation[#, 
                    Dynamic[
                    FEPrivate`FrontEndResource[
                    "SlideshowToolbarText", "TooltipLastSlide"]], 
                    "Tooltip"]& ]}}, AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.4]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}]}}, AutoDelete -> 
                    False, GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Center}}, "RowsIndexed" -> {}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    Alignment -> Left, StripOnInput -> False]}, {
                    ItemBox[
                    StyleBox[
                    PaneSelectorBox[{1 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.56\"", 6.558527645565748, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.62\"", 36.618371875581836`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    SqrtBox[
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"]], "1",
                     "2845.3158327864076`", "2845.3158327864076`", 
                    "353.46476757978604`", "5.559748525671475`*^-28"}, {
                    "\"Error\"", "65", "523.2361075121004`", 
                    "8.049786269416929`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 2 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "2948.551938695938`", 
                    "2948.551938695938`", "456.3235125808232`", 
                    "4.320242444005296`*^-31"}, {
                    "\"Error\"", "65", "420.0000016025697`", 
                    "6.46153848619338`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 3 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.19\"", 2.1908135489152247`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7280268689895092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"117.25\"", 117.24727812838044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]4", "1", "2328.1835886742692`", 
                    "2328.1835886742692`", "363.25098752794486`", 
                    "4.437522864442828`*^-28"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]9"], "1", 
                    "630.1733217657434`", "630.1733217657434`", 
                    "98.32174857633105`", "1.470739986530755`*^-14"}, {
                    "\"Error\"", "64", "410.1950298584953`", 
                    "6.409297341538989`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 4 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.86\"", 0.8620951567752905, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.62\"", 732.6165153538162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.91\"", 0.905359277852415, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]1"], "1", 
                    "2483.680713651287`", "2483.680713651287`", 
                    "186.44626256114435`", "1.2528424335110582`*^-20"}, {
                    FractionBox["1", "column\[Bullet]9"], "1", 
                    "32.31691158524154`", "32.31691158524154`", 
                    "2.4259830780459986`", "0.12427000225851625`"}, {
                    "\"Error\"", "64", "852.5543150619793`", 
                    "13.321161172843427`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 5 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.47\"", 3.4733768128077096`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.29\"", 2.2947176471822623`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7390571409205557`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"69.87\"", 69.87005969257898, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "341.89124989684615`", 
                    "3.838104289244436`*^-27"}, {
                    "column\[Bullet]6", "1", "121.30175862503575`", 
                    "121.30175862503575`", "16.75998634615997`", 
                    "0.00012302517058007244`"}, {
                    FractionBox["1", "column\[Bullet]8"], "1", 
                    "316.81696711245786`", "316.81696711245786`", 
                    "43.773875195414476`", "9.281159983756373`*^-9"}, {
                    "\"Error\"", "63", "455.9676025707612`", 
                    "7.237580993186685`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 6 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.76\"", 11.75663792584013, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7100848960685717`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0141153649569057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.40469052094093616`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "364.0904266744513`", 
                    "7.110586405848063`*^-28"}, {
                    "column\[Bullet]4", "1", "192.87638476116945`", 
                    "192.87638476116945`", "28.37964079308306`", 
                    "1.4228775967280087`*^-6"}, {
                    "column\[Bullet]8", "1", "273.0434164036101`", 
                    "273.0434164036101`", "40.1753386659842`", 
                    "2.7990715534934043`*^-8"}, {
                    "\"Error\"", "63", "428.16652714347526`", 
                    "6.796294081642464`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 7 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "126.29374051726167`", 
                    "8.691108933291702`*^-17"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "1177.5229624264607`", "1177.5229624264607`", 
                    "102.26941374491662`", "6.7674154808517424`*^-15"}, {
                    "\"Error\"", "64", "736.8915772144961`", 
                    "11.513930893976502`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 8 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "87.2296172043491`", 
                    "1.6800294998417172`*^-13"}, {
                    SuperscriptBox["column\[Bullet]6", "2"], "1", 
                    "45.72194978555876`", "45.72194978555876`", 
                    "2.742731309866094`", "0.10267070075664675`"}, {
                    "column\[Bullet]8", "1", "818.4683749902408`", 
                    "818.4683749902408`", "49.09761829382847`", 
                    "1.9433774420568964`*^-9"}, {
                    "\"Error\"", "63", "1050.2242148651571`", 
                    "16.67022563278027`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 9 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], 
                    BaseStyle -> Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                     StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]1", "1", "150.30256741333596`", 
                    "150.30256741333596`", "17.599168020788028`", 
                    "0.00008698280231639891`"}, {
                    "column\[Bullet]4", "1", "2522.2132280652677`", 
                    "2522.2132280652677`", "295.32998104353265`", 
                    "1.821496237406981`*^-25"}, {
                    SuperscriptBox["column\[Bullet]4", "2"], "1", 
                    "157.99583883183868`", "157.99583883183868`", 
                    "18.499985476230524`", "0.000060241873524132396`"}, {
                    "\"Error\"", "63", "538.0403059880655`", 
                    "8.54032231727088`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 10 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]4", "1", "2328.1835886742692`", 
                    "2328.1835886742692`", "520.8390888152892`", 
                    "1.8797918071378162`*^-32"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "754.2843136268602`", 
                    "754.2843136268602`", "168.74131255292684`", 
                    "1.3253345139356597`*^-19"}, {
                    "\"Error\"", "64", "286.0840379973786`", 
                    "4.47006309370904`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 11 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    RowBox[{"column\[Bullet]3", " ", "column\[Bullet]5"}], 
                    "1", "2105.044334098867`", "2105.044334098867`", 
                    "344.0815874865773`", "1.9356904525074272`*^-27"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "871.9643144866459`", 
                    "871.9643144866459`", "142.5275756430311`", 
                    "6.212225122978837`*^-18"}, {
                    "\"Error\"", "64", "391.54329171299537`", 
                    "6.117863933015553`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 12 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "615.8928918975049`", 
                    "3.151383058141268`*^-34"}, {
                    "column\[Bullet]4", "1", "192.87638476116945`", 
                    "192.87638476116945`", "48.00680753601049`", 
                    "2.6601592194704165`*^-9"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]6"], "column\[Bullet]8"], "1", 
                    "448.0955861543571`", "448.0955861543571`", 
                    "111.5307018476366`", "1.4267621871869728`*^-15"}, {
                    "\"Error\"", "63", "253.11435739272815`", 
                    "4.0176882125829865`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 13 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    SqrtBox["column\[Bullet]3"], "1", "2831.0739775144216`", 
                    "2831.0739775144216`", "630.6540211463608`", 
                    "7.562101393129175`*^-35"}, {
                    FractionBox[
                    RowBox[{"column\[Bullet]3", "+", "column\[Bullet]6"}], 
                    "column\[Bullet]8"], "1", "250.17505423912826`", 
                    "250.17505423912826`", "55.72934695437907`", 
                    "2.826759892574983`*^-10"}, {
                    "\"Error\"", "64", "287.3029085449581`", 
                    "4.48910794601497`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 14 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4907970088213184, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.27543008176316136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.88\"", 39.88006338431486, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.33\"", 33.33120471027875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]4", "1", "2328.1835886742692`", 
                    "2328.1835886742692`", "576.1260295031783`", 
                    "2.1164386270281313`*^-33"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "651.9008665685019`", "651.9008665685019`", 
                    "161.3176296374703`", "4.972727780618655`*^-19"}, {
                    FractionBox["column\[Bullet]6", "column\[Bullet]8"], "1", 
                    "133.87810951065921`", "133.87810951065921`", 
                    "33.1291157814956`", "2.749497908247319`*^-7"}, {
                    "\"Error\"", "63", "254.5893755450773`", 
                    "4.041101199128211`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 15 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.89\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.038939420148409794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.18\"", 39.18371072963305, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.85\"", 21.8462052882725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.88\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09875226201681911, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "2620.4792353510866`", "2620.4792353510866`", 
                    "492.5998151288078`", "1.7581312391125042`*^-31"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "394.9181646778561`", "394.9181646778561`", 
                    "74.2370373658986`", "3.0015840805171805`*^-12"}, {
                    "column\[Bullet]8", "1", "18.013951993157207`", 
                    "18.013951993157207`", "3.3862773273910647`", 
                    "0.07045248429146554`"}, {
                    "\"Error\"", "63", "335.140588276408`", 
                    "5.319691877403301`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 16 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34137677056759286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.71\"", 2.706173995605092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3180494881255718`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2521102772782762, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"103.53\"", 103.53091868397507`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "415.7365331906414`", 
                    "3.487162411689341`*^-29"}, {
                    "column\[Bullet]6", "1", "121.30175862503575`", 
                    "121.30175862503575`", "20.379985220380178`", 
                    "0.000028992801514873315`"}, {
                    "column\[Bullet]7", "1", "0.6600919174129558`", 
                    "0.6600919174129558`", "0.11090246071825645`", 
                    "0.740242545521191`"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "403.1002143315309`", "403.1002143315309`", 
                    "67.72512207183394`", "1.5831235541562502`*^-11"}, {
                    "\"Error\"", "62", "369.02426343427555`", 
                    "5.952004248939928`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 17 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]6", "1", "1454.137400657551`", 
                    "1454.137400657551`", "313.4348289186167`", 
                    "3.836924823208056`*^-26"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1492.0538258993606`", "1492.0538258993606`", 
                    "321.6075973609235`", "1.9465140573109833`*^-26"}, {
                    FractionBox[
                    SqrtBox["column\[Bullet]4"], "column\[Bullet]8"], "1", 
                    "130.0809547961967`", "130.0809547961967`", 
                    "28.038548347411627`", "1.6068855570962655`*^-6"}, {
                    "\"Error\"", "63", "292.2797589453992`", 
                    "4.639361253101574`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 18 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]5", "1", "433.9827101430128`", 
                    "433.9827101430128`", "103.19610147580498`", 
                    "8.096953137138698`*^-15"}, {
                    "column\[Bullet]6", "1", "1023.8879020280781`", 
                    "1023.8879020280781`", "243.4687773683875`", 
                    "3.8169270632665933`*^-23"}, {
                    FractionBox["column\[Bullet]3", "column\[Bullet]8"], "1", 
                    "1488.4668339515213`", "1488.4668339515213`", 
                    "353.9403087952821`", "2.582520173311955`*^-27"}, {
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"], "1", 
                    "161.47859772175207`", "161.47859772175207`", 
                    "38.3977549501298`", "5.164670409816981`*^-8"}, {
                    "\"Error\"", "62", "260.7358964541437`", 
                    "4.205417684744253`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 19 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"7.66\"", 7.6569380414546355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.505929605016708, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9897309759518025, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.1043628156090113`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.25\"", 36.2535293671652, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "499.8356236092047`", 
                    "2.263608096720188`*^-31"}, {
                    "column\[Bullet]4", "1", "192.87638476116945`", 
                    "192.87638476116945`", "38.96052852358967`", 
                    "4.3249668758644954`*^-8"}, {
                    "column\[Bullet]6", "1", "1.9787934822829811`", 
                    "1.9787934822829811`", "0.39971114143518743`", 
                    "0.529563105083139`"}, {
                    SqrtBox[
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"]], "1",
                     "392.29650856085027`", "392.29650856085027`", 
                    "79.24287532875145`", "1.0952531057401948`*^-12"}, {
                    "\"Error\"", "62", "306.9346415039523`", 
                    "4.950558733934715`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"], 20 -> TagBox[
                    GridBox[{{
                    TemplateBox[{
                    ItemBox[
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6700752445202611`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.6128394340247934`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6853465073594838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.324592179540275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.46\"", 25.461775420180842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], BaseStyle -> 
                    Directive[FontFamily -> "Helvetica", FontSize -> 10, 
                    FontWeight -> "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    
                    GridBox[{{"\"\"", "\"DF\"", "\"SS\"", "\"MS\"", 
                    "\"F\[Hyphen]Statistic\"", "\"P\[Hyphen]Value\""}, {
                    "column\[Bullet]3", "1", "2474.465611990253`", 
                    "2474.465611990253`", "475.37139878180756`", 
                    "9.023281690232879`*^-31"}, {
                    "column\[Bullet]5", "1", "5.164176210780624`", 
                    "5.164176210780624`", "0.9920936694286904`", 
                    "0.3231027901305985`"}, {
                    "column\[Bullet]6", "1", "128.81103909358671`", 
                    "128.81103909358671`", "24.745982945063297`", 
                    "5.484612182669695`*^-6"}, {
                    SqrtBox[
                    FractionBox["column\[Bullet]4", "column\[Bullet]8"]], "1",
                     "437.3805736055483`", "437.3805736055483`", 
                    "84.0255019376191`", "3.8546010416100026`*^-13"}, {
                    "\"Error\"", "62", "322.73053939833903`", 
                    "5.205331280618371`", "", ""}, {
                    "\"Total\"", "66", "3368.551940298508`", "", "", ""}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "ColumnsIndexed" -> {2 -> GrayLevel[0.7]}, 
                    "RowsIndexed" -> {2 -> GrayLevel[0.7]}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "ColumnsIndexed" -> {2 -> 1}, 
                    "RowsIndexed" -> {2 -> 0.75}}], "Grid"], "DialogStyle", 
                    StripOnInput -> False]}, "Labeled", 
                    DisplayFunction -> (GridBox[{{
                    TagBox[
                    ItemBox[
                    FrameBox[
                    PaneBox[
                    TagBox[#, "SkipImageSizeLevel"], 
                    Alignment -> {Center, Baseline}, BaselinePosition -> 
                    Baseline], FrameMargins -> 4, FrameStyle -> Automatic], 
                    DefaultBaseStyle -> "Labeled"], "SkipImageSizeLevel"]}, {
                    ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]& ), 
                    InterpretationFunction -> (RowBox[{"Labeled", "[", 
                    RowBox[{#, ",", #2, ",", 
                    RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]& )]}}, 
                    AutoDelete -> False, BaselinePosition -> Center, 
                    FrameStyle -> Directive[
                    GrayLevel[0.85]], 
                    GridBoxAlignment -> {
                    "Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
                    GridBoxDividers -> {
                    "Columns" -> {{None}}, "Rows" -> {{None}}}, 
                    GridBoxFrame -> {
                    "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxItemStyle -> {"Columns" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}, "Rows" -> {{
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]}}}], "Grid"]}, 
                    Dynamic[Typeset`var$$], Alignment -> {Center, Top}, 
                    ImageSize -> Automatic, TransitionDirection -> Horizontal,
                     TransitionDuration -> 0.5, TransitionEffect -> 
                    Automatic], Deployed -> False, StripOnInput -> False], 
                    Background -> GrayLevel[1], Frame -> True, FrameStyle -> 
                    GrayLevel[0.8235294117647058], StripOnInput -> False]}}, 
                  AutoDelete -> False, 
                  GridBoxAlignment -> {"Columns" -> {{Left}}}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                 BaseStyle -> {}, BaselinePosition -> Center, 
                 DefaultBaseStyle -> "SlideView", FrameMargins -> 6, 
                 ImageMargins -> Automatic], Deploy, DefaultBaseStyle -> 
                "Deploy"], 
               SlideView[{
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    6.558527645565748, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    36.618371875581836`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, \
{($CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8)^Rational[1, 2],
                     1, 2845.3158327864076`, 2845.3158327864076`, 
                    353.46476757978604`, 5.559748525671475*^-28}, {
                    "Error", 65, 523.2361075121004, 8.049786269416929}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.5972434214759587, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    41.135346220113384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    2948.551938695938, 2948.551938695938, 456.3235125808232, 
                    4.320242444005296*^-31}, {
                    "Error", 65, 420.0000016025697, 6.46153848619338}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    2.1908135489152247`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.7280268689895092, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    117.24727812838044`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "9"]], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]4, 1, 
                    2328.1835886742692`, 2328.1835886742692`, 
                    363.25098752794486`, 
                    4.437522864442828*^-28}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]9, 1, 
                    630.1733217657434, 630.1733217657434, 98.32174857633105, 
                    1.470739986530755*^-14}, {
                    "Error", 64, 410.1950298584953, 6.409297341538989}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.8620951567752905, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                    NumberForm[
                    732.6165153538162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    0.905359277852415, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "9"]], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1^(-1) \
$CellContext`column\[Bullet]4, 1, 2483.680713651287, 2483.680713651287, 
                    186.44626256114435`, 
                    1.2528424335110582`*^-20}, \
{$CellContext`column\[Bullet]9^(-1), 1, 32.31691158524154, 32.31691158524154, 
                    2.4259830780459986`, 0.12427000225851625`}, {
                    "Error", 64, 852.5543150619793, 13.321161172843427`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    3.4733768128077096`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    2.2947176471822623`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    1.7390571409205557`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    69.87005969257898, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 341.89124989684615`,
                     3.838104289244436*^-27}, {$CellContext`column\[Bullet]6, 
                    1, 121.30175862503575`, 121.30175862503575`, 
                    16.75998634615997, 
                    0.00012302517058007244`}, \
{$CellContext`column\[Bullet]8^(-1), 1, 316.81696711245786`, 
                    316.81696711245786`, 43.773875195414476`, 
                    9.281159983756373*^-9}, {
                    "Error", 63, 455.9676025707612, 7.237580993186685}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    11.75663792584013, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.7100848960685717`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    1.0141153649569057`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.40469052094093616`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 364.0904266744513, 
                    7.110586405848063*^-28}, {$CellContext`column\[Bullet]4, 
                    1, 192.87638476116945`, 192.87638476116945`, 
                    28.37964079308306, 
                    1.4228775967280087`*^-6}, {$CellContext`column\[Bullet]8, 
                    1, 273.0434164036101, 273.0434164036101, 40.1753386659842,
                     2.7990715534934043`*^-8}, {
                    "Error", 63, 428.16652714347526`, 6.796294081642464}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    3.882350562760903, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    2.0321890071965854`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    63.363724799250285`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 126.29374051726167`,
                     8.691108933291702*^-17}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    1177.5229624264607`, 1177.5229624264607`, 
                    102.26941374491662`, 6.7674154808517424`*^-15}, {
                    "Error", 64, 736.8915772144961, 11.513930893976502`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    11.135546219979584`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    8.280454674605123, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.5908371539294913, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 - 
                    NumberForm[
                    0.8978305425889783, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 87.2296172043491, 
                    1.6800294998417172`*^-13}, \
{$CellContext`column\[Bullet]6^2, 1, 45.72194978555876, 45.72194978555876, 
                    2.742731309866094, 
                    0.10267070075664675`}, {$CellContext`column\[Bullet]8, 1, 
                    818.4683749902408, 818.4683749902408, 49.09761829382847, 
                    1.9433774420568964`*^-9}, {
                    "Error", 63, 1050.2242148651571`, 16.67022563278027}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    8.159680560964581, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    0.04011738767128822, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    5.224685491056446, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                    NumberForm[
                    0.22854010099263636`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2, BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]1, 1, 
                    150.30256741333596`, 150.30256741333596`, 
                    17.599168020788028`, 
                    0.00008698280231639891}, {$CellContext`column\[Bullet]4, 
                    1, 2522.2132280652677`, 2522.2132280652677`, 
                    295.32998104353265`, 
                    1.821496237406981*^-25}, {$CellContext`column\[Bullet]4^2,
                     1, 157.99583883183868`, 157.99583883183868`, 
                    18.499985476230524`, 0.000060241873524132396`}, {
                    "Error", 63, 538.0403059880655, 8.54032231727088}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.2792678309107002, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.24783345853136146`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    36.819424146231384`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]4, 1, 
                    2328.1835886742692`, 2328.1835886742692`, 
                    520.8390888152892, 
                    1.8797918071378162`*^-32}, \
{($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    754.2843136268602, 754.2843136268602, 168.74131255292684`,
                     1.3253345139356597`*^-19}, {
                    "Error", 64, 286.0840379973786, 4.47006309370904}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.42612172604868076`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                    NumberForm[
                    0.06256007839813221, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    44.23179551124747, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3 \
$CellContext`column\[Bullet]5, 1, 2105.044334098867, 2105.044334098867, 
                    344.0815874865773, 
                    1.9356904525074272`*^-27}, \
{($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    871.9643144866459, 871.9643144866459, 142.5275756430311, 
                    6.212225122978837*^-18}, {
                    "Error", 64, 391.54329171299537`, 6.117863933015553}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    2.4172135657118963`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.7361891056524232`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.7046357704345062, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    71.48309026794081, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 615.8928918975049, 
                    3.151383058141268*^-34}, {$CellContext`column\[Bullet]4, 
                    1, 192.87638476116945`, 192.87638476116945`, 
                    48.00680753601049, 
                    2.6601592194704165`*^-9}, {$CellContext`column\[Bullet]6^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    448.0955861543571, 448.0955861543571, 111.5307018476366, 
                    1.4267621871869728`*^-15}, {
                    "Error", 63, 253.11435739272815`, 4.0176882125829865`}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.5056525266429981, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.6158725575337699, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                    NumberForm[
                    38.90598516721604, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3^
                    Rational[1, 2], 1, 2831.0739775144216`, 
                    2831.0739775144216`, 630.6540211463608, 
                    7.562101393129175*^-35}, {($CellContext`column\[Bullet]3 + \
$CellContext`column\[Bullet]6)/$CellContext`column\[Bullet]8, 1, 
                    250.17505423912826`, 250.17505423912826`, 
                    55.72934695437907, 2.826759892574983*^-10}, {
                    "Error", 64, 287.3029085449581, 4.48910794601497}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    0.4907970088213184, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    0.27543008176316136`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    39.88006338431486, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    33.33120471027875, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]4, 1, 
                    2328.1835886742692`, 2328.1835886742692`, 
                    576.1260295031783, 
                    2.1164386270281313`*^-33}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    651.9008665685019, 651.9008665685019, 161.3176296374703, 
                    4.972727780618655*^-19}, \
{$CellContext`column\[Bullet]6/$CellContext`column\[Bullet]8, 1, 
                    133.87810951065921`, 133.87810951065921`, 
                    33.1291157814956, 2.749497908247319*^-7}, {
                    "Error", 63, 254.5893755450773, 4.041101199128211}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.038939420148409794`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    39.18371072963305, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    21.8462052882725, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    0.09875226201681911, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    2620.4792353510866`, 2620.4792353510866`, 
                    492.5998151288078, 
                    1.7581312391125042`*^-31}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    394.9181646778561, 394.9181646778561, 74.2370373658986, 
                    3.0015840805171805`*^-12}, {$CellContext`column\[Bullet]8,
                     1, 18.013951993157207`, 18.013951993157207`, 
                    3.3862773273910647`, 0.07045248429146554}, {
                    "Error", 63, 335.140588276408, 5.319691877403301}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    0.34137677056759286`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    2.706173995605092, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    1.3180494881255718`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    0.2521102772782762, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "7"]], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    103.53091868397507`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 415.7365331906414, 
                    3.487162411689341*^-29}, {$CellContext`column\[Bullet]6, 
                    1, 121.30175862503575`, 121.30175862503575`, 
                    20.379985220380178`, 
                    0.000028992801514873315`}, {$CellContext`column\[Bullet]7,
                     1, 0.6600919174129558, 0.6600919174129558, 
                    0.11090246071825645`, 
                    0.740242545521191}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    403.1002143315309, 403.1002143315309, 67.72512207183394, 
                    1.5831235541562502`*^-11}, {
                    "Error", 62, 369.02426343427555`, 5.952004248939928}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    1.7044153746685882`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.4351705392786716`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    39.0054125568516, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    36.22633469690617, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]6, 1, 
                    1454.137400657551, 1454.137400657551, 313.4348289186167, 
                    3.836924823208056*^-26}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1492.0538258993606`, 1492.0538258993606`, 
                    321.6075973609235, 
                    1.9465140573109833`*^-26}, {$CellContext`column\[Bullet]4^
                    Rational[1, 2]/$CellContext`column\[Bullet]8, 1, 
                    130.0809547961967, 130.0809547961967, 28.038548347411627`,
                     1.6068855570962655`*^-6}, {
                    "Error", 63, 292.2797589453992, 4.639361253101574}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    Item[
                    NumberForm[
                    3.1346046653275597`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                    NumberForm[
                    0.5661079421576403, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.9736432501341529, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    41.463770769155424`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                    NumberForm[
                    14.128156845155987`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]5, 1, 
                    433.9827101430128, 433.9827101430128, 103.19610147580498`,
                     8.096953137138698*^-15}, {$CellContext`column\[Bullet]6, 
                    1, 1023.8879020280781`, 1023.8879020280781`, 
                    243.4687773683875, 
                    3.8169270632665933`*^-23}, \
{$CellContext`column\[Bullet]3/$CellContext`column\[Bullet]8, 1, 
                    1488.4668339515213`, 1488.4668339515213`, 
                    353.9403087952821, 
                    2.582520173311955*^-27}, \
{$CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8, 1, 
                    161.47859772175207`, 161.47859772175207`, 
                    38.3977549501298, 5.164670409816981*^-8}, {
                    "Error", 62, 260.7358964541437, 4.205417684744253}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    7.6569380414546355`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.505929605016708, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.9897309759518025, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    1.1043628156090113`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    36.2535293671652, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 499.8356236092047, 
                    2.263608096720188*^-31}, {$CellContext`column\[Bullet]4, 
                    1, 192.87638476116945`, 192.87638476116945`, 
                    38.96052852358967, 
                    4.3249668758644954`*^-8}, {$CellContext`column\[Bullet]6, 
                    1, 1.9787934822829811`, 1.9787934822829811`, 
                    0.39971114143518743`, 
                    0.529563105083139}, \
{($CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8)^Rational[1, 2],
                     1, 392.29650856085027`, 392.29650856085027`, 
                    79.24287532875145, 1.0952531057401948`*^-12}, {
                    "Error", 62, 306.9346415039523, 4.950558733934715}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                 Grid[{{
                    Labeled[
                    
                    Item[-NumberForm[
                    1.6700752445202611`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                    NumberForm[
                    1.6128394340247934`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                    NumberForm[
                    0.6853465073594838, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "5"]], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]]] + 
                    NumberForm[
                    0.324592179540275, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                    NumberForm[
                    25.461775420180842`, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], BaseStyle -> 
                    Directive[
                    FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]], 
                    Style[
                    
                    Grid[{{"", "DF", "SS", "MS", "F\[Hyphen]Statistic", 
                    "P\[Hyphen]Value"}, {$CellContext`column\[Bullet]3, 1, 
                    2474.465611990253, 2474.465611990253, 475.37139878180756`,
                     9.023281690232879*^-31}, {$CellContext`column\[Bullet]5, 
                    1, 5.164176210780624, 5.164176210780624, 
                    0.9920936694286904, 
                    0.3231027901305985}, {$CellContext`column\[Bullet]6, 1, 
                    128.81103909358671`, 128.81103909358671`, 
                    24.745982945063297`, 
                    
                    5.484612182669695*^-6}, \
{($CellContext`column\[Bullet]4/$CellContext`column\[Bullet]8)^Rational[1, 2],
                     1, 437.3805736055483, 437.3805736055483, 
                    84.0255019376191, 3.8546010416100026`*^-13}, {
                    "Error", 62, 322.73053939833903`, 5.205331280618371}, {
                    "Total", 66, 3368.551940298508}}, 
                    Alignment -> {Left, Automatic}, 
                    Dividers -> {{2 -> GrayLevel[0.7]}, {
                    2 -> GrayLevel[0.7]}}, 
                    Spacings -> {{2 -> 1}, {2 -> 0.75}}], "DialogStyle"], 
                    Frame -> True]}}, Dividers -> None, ItemSize -> Automatic,
                   ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]],
                   ItemSize -> Automatic, Alignment -> {Center, Center}, 
                  BaselinePosition -> Center, Dividers -> All, Frame -> True, 
                  FrameStyle -> Directive[
                    GrayLevel[0.85]], ItemStyle -> 
                  Directive[
                   FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
                    "Plain", FontSlant -> "Plain", FontColor -> 
                    GrayLevel[0]]]}, Alignment -> {Center, Top}, ImageSize -> 
                Automatic, Alignment -> {Center, Center}, BaselinePosition -> 
                Center]], DynamicModuleValues :> {}], Setting[#, {0}]& ], 
            Alignment -> Center, ImageSize -> 500]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Variable\\\\\\\"\\\
\"}, {\\\"\\\\\\\"Presence\\\\\\\"\\\"}, {\\\"\\\\\\\"Map\\\\\\\"\\\"}}, \
Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", List[List[Center]]]]], \
Rule[DefaultBaseStyle, \\\"Column\\\"], Rule[GridBoxItemSize, \
List[Rule[\\\"Columns\\\", List[List[Automatic]]], Rule[\\\"Rows\\\", \
List[List[Automatic]]]]]], \\\"Column\\\"], TraditionalForm]\\)\"", 
            StripOnInput -> False, ShowStringCharacters -> False, FontFamily -> 
            "Helvetica", FontSize -> 10, FontWeight -> Bold, FontSlant -> 
            "Plain", FontColor -> GrayLevel[0], Background -> None], 
           ItemBox[
            GraphicsBox[{
              RasterBox[CompressedData["
1:eJxTTMoPSmVmYGDgAGIRIAaxIeCDPXk0OiAkPkoPLI0OqB1fpJpPLffQ2t6h
Ij5K04dGB8PFPaSag0s9rc0ZKvaSKj7SaHQw0O6hlvtJFR9s+YvW5gyV8Bwo
ewcq/IdKOTlQ4kO93BsoewcvDQBJG5kD
               "], {{0, 0}, {20, 8}}, {0, 
               1}], {{
                GrayLevel[
                 NCache[-1 + GoldenRatio, 0.6180339887498949]], 
                StyleBox[
                 
                 LineBox[{{{0, 8}, {20, 8}}, {{0, 7}, {20, 7}}, {{0, 6}, {20, 
                  6}}, {{0, 5}, {20, 5}}, {{0, 4}, {20, 4}}, {{0, 3}, {20, 
                  3}}, {{0, 2}, {20, 2}}, {{0, 1}, {20, 1}}, {{0, 0}, {20, 
                  0}}}], Antialiasing -> False]}, {
                GrayLevel[
                 NCache[-1 + GoldenRatio, 0.6180339887498949]], 
                StyleBox[
                 
                 LineBox[{{{0, 0}, {0, 8}}, {{1, 0}, {1, 8}}, {{2, 0}, {2, 
                  8}}, {{3, 0}, {3, 8}}, {{4, 0}, {4, 8}}, {{5, 0}, {5, 
                  8}}, {{6, 0}, {6, 8}}, {{7, 0}, {7, 8}}, {{8, 0}, {8, 
                  8}}, {{9, 0}, {9, 8}}, {{10, 0}, {10, 8}}, {{11, 0}, {11, 
                  8}}, {{12, 0}, {12, 8}}, {{13, 0}, {13, 8}}, {{14, 0}, {14, 
                  8}}, {{15, 0}, {15, 8}}, {{16, 0}, {16, 8}}, {{17, 0}, {17, 
                  8}}, {{18, 0}, {18, 8}}, {{19, 0}, {19, 8}}, {{20, 0}, {20, 
                  8}}}], Antialiasing -> False]}}}, AspectRatio -> 
             140./Dynamic[
               DataModeler`DataModelerGUI`Private`optValue[
               DataModeler`ModelReview`ModelSummaryTable, ImageSize]], Frame -> 
             True, FrameLabel -> {
               FormBox["\"Models\"", TraditionalForm], None}, 
             FrameTicks -> {{{{7.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]1", 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]1\\\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"10.0\\\\\\\"\\\", 10.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]1\", \
Hue[Rational[1, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"10.0\\\"\", 10.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {6.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]3", 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]3\\\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"75.0\\\\\\\"\\\", 75.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]3\", \
Hue[Rational[3, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"75.0\\\"\", 75.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {5.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]4", 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]4\\\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"70.0\\\\\\\"\\\", 70.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]4\", \
Hue[Rational[2, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"70.0\\\"\", 70.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {4.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]5", 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]5\\\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"15.0\\\\\\\"\\\", 15.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]5\", \
Hue[Rational[1, 2], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"15.0\\\"\", 15.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {3.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]6", 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]6\\\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"70.0\\\\\\\"\\\", 70.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]6\", \
Hue[Rational[3, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"70.0\\\"\", 70.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {2.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]7", 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]7\\\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"5.0\\\\\\\"\\\", 5.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]7\", \
Hue[Rational[7, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"5.0\\\"\", 5.`, Rule[AutoDelete, \
True]], Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 models", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}], "Tooltip"]& ], TraditionalForm]}, {1.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]8", 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]8\\\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"85.0\\\\\\\"\\\", 85.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]8\", \
Hue[Rational[4, 5], 1, Rational[1, 2]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"85.0\\\"\", 85.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}, {0.5, 
                  FormBox[
                   TagBox[
                    TooltipBox[
                    StyleBox["column\[Bullet]9", 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], 
                    StyleBox[
                    "\"\\!\\(\\*FormBox[StyleBox[\\\"column\[Bullet]9\\\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\\) is used by \\!\\(\\*FormBox[TagBox[InterpretationBox[\\\"\
\\\\\\\"10.0\\\\\\\"\\\", 10.`, Rule[AutoDelete, True]], \
Function[NumberForm[Slot[1], List[3, 1], Rule[ExponentFunction, \
Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], Rule[NumberPadding, List[\
\\\"\\\", \\\"0\\\"]]]]], TraditionalForm]\\) % of the 20 models\"", {
                    FontWeight -> "Plain", FontFamily -> "Helvetica", 
                    FontSize -> 12, FontColor -> GrayLevel[0], FontSlant -> 
                    "Plain", Background -> None, ShowStringCharacters -> 
                    False}, StripOnInput -> False], TooltipDelay -> 0.1, 
                    LabelStyle -> "TextStyling"], Annotation[#, 
                    Style[
                    "\!\(\*FormBox[StyleBox[\"column\[Bullet]9\", \
Hue[Rational[9, 10], 1, Rational[5, 6]], Rule[StripOnInput, False]], \
TraditionalForm]\) is used by \
\!\(\*FormBox[TagBox[InterpretationBox[\"\\\"10.0\\\"\", 10.`, \
Rule[AutoDelete, True]], Function[NumberForm[Slot[1], List[3, 1], \
Rule[ExponentFunction, Function[If[Less[-1, Slot[1], 3], Null, Slot[1]]]], \
Rule[NumberPadding, List[\"\", \"0\"]]]]], TraditionalForm]\) % of the 20 \
models", {FontWeight -> "Plain", FontFamily -> "Helvetica", FontSize -> 12, 
                    FontColor -> GrayLevel[0], FontSlant -> "Plain", 
                    Background -> None, ShowStringCharacters -> False}], 
                    "Tooltip"]& ], TraditionalForm]}}, None}, {None, None}}, 
             GridLinesStyle -> Directive[
               GrayLevel[0.5, 0.4]], ImageSize -> 500, 
             Method -> {
              "AxisPadding" -> Scaled[0.02], "DefaultBoundaryStyle" -> 
               Automatic, "DefaultPlotStyle" -> Automatic, "DomainPadding" -> 
               Scaled[0.02], "RangePadding" -> Scaled[0.05]}, PlotLabel -> 
             None], ItemSize -> Automatic, StripOnInput -> False]}, {
           StyleBox[
           "\"\\!\\(\\*FormBox[TagBox[GridBox[{{\\\"\\\\\\\"Model\\\\\\\"\\\"}\
, {\\\"\\\\\\\"Prediction\\\\\\\"\\\"}, {\\\"\\\\\\\"Plot\\\\\\\"\\\"}}, \
Rule[GridBoxAlignment, List[Rule[\\\"Columns\\\", List[List[Center]]]]], \
Rule[DefaultBaseStyle, \\\"Column\\\"], Rule[GridBoxItemSize, \
List[Rule[\\\"Columns\\\", List[List[Automatic]]], Rule[\\\"Rows\\\", \
List[List[Automatic]]]]]], \\\"Column\\\"], TraditionalForm]\\)\"", 
            StripOnInput -> False, ShowStringCharacters -> False, FontFamily -> 
            "Helvetica", FontSize -> 10, FontWeight -> Bold, FontSlant -> 
            "Plain", FontColor -> GrayLevel[0], Background -> None], 
           ItemBox[
            TagBox[
             TooltipBox[
              GraphicsBox[{{}, {{{}, {
                   RGBColor[0, 0, 1], 
                   PointSize[Medium], 
                   AbsoluteThickness[1.6], 
                   PointBox[CompressedData["
1:eJxTTMoPSmViYGBwBmIQbQwG7A5TZX2Ftt3hcYDxnU6e4tdLEIbzRW9f+2Kn
xgXnhzYzxhfaiDowgAGHg/zZEua3Kxng/B+Z0vNMcwTh/AcuL/uVvrDC+Zvl
P3ztakPIG06U679pIuswayYQSBo7eNzekMoxSR/OLz97edWzCj04P4yn7oaM
hgGcvzm3l9+UTxfCn2nkIF6+XO+tiQGcn3vt/BQmEUM4X8Pkgs7aZIQ8awmn
idd6BF/j2nOWTcyGUP+aOUxMbNq+u8gUzr/6tF96830zOF/2RWq3nIEJnJ8X
ZFT32tsCap6pQ7H62taiTYZw/nbu1bvrGozg/HzPfywPXhnA+W3aptd9JiLk
O4M7Ajq7jaH+NXO4ePmT075XCP4OabeNzXGWcP6EVCv9N/NN4Hy/n1e2CopY
Opw9AwI8Dt/UyyN5g4Tg/Bk2RxrUT7LD+c6CbNertyLkrZ7zpbUoCsD5UYnb
P72Q5oPzjYROGTcXisL5jpcyNYL38cD5523Uaz6ziMH5f10XfQu4K+CQBgYy
DpkTW64VPJaB84UX7vubkygL52/SYp0/6T6Cf1uvy/qatRScv2KKTHqJvww0
Pck4sPquY5JJkYfzTdue7LrBLQ3nT2+I7Smapwznv1p14OhGbyloeKs4SOya
pBFRoQbnWyt/fntfWxPONzebMuuqpTqcf5XpoN2pvxpw/tSWIwfVVJXg/KS8
XSG7xRDyb6M7Pba3Icx7abNbcVMwgq8kVSvN2qwO9Z+Ow7s7/45mKmjC+eeW
CvHd2q0D5/9Ywr7aZTlCvW34QvUcBm04f1GgtpXLPF1o+Os46M7kWa5Uqwfn
F/3Q864V0YHztf9eVeNrQqj/V/VrY3uZlgMA4iyyWA==
                    "]]}, {}}, {
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 3.6077691488059807`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.6077691488059807`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "350.95`"}, {
                    "column\[Bullet]3", "0.076604`"}, {
                    "column\[Bullet]4", "1.4922`"}, {
                    "column\[Bullet]5", "3.0296`"}, {
                    "column\[Bullet]6", "2.4288`"}, {
                    "column\[Bullet]7", "7.7585`"}, {
                    "column\[Bullet]8", "27.326`"}, {
                    "column\[Bullet]9", "36.57`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.6077691488059807`}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    350.95}, {$CellContext`column\[Bullet]3, 
                    0.076604}, {$CellContext`column\[Bullet]4, 
                    1.4922}, {$CellContext`column\[Bullet]5, 
                    3.0296}, {$CellContext`column\[Bullet]6, 
                    2.4288}, {$CellContext`column\[Bullet]7, 
                    7.7585}, {$CellContext`column\[Bullet]8, 
                    27.326}, {$CellContext`column\[Bullet]9, 36.57}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 4.843925711395345}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.843925711395345`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "328.29`"}, {
                    "column\[Bullet]3", "0.043521`"}, {
                    "column\[Bullet]4", "2.4749`"}, {
                    "column\[Bullet]5", "6.2193`"}, {
                    "column\[Bullet]6", "2.5864`"}, {
                    "column\[Bullet]7", "6.4752`"}, {
                    "column\[Bullet]8", "23.65`"}, {
                    "column\[Bullet]9", "44.15`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.843925711395345}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    328.29}, {$CellContext`column\[Bullet]3, 
                    0.043521}, {$CellContext`column\[Bullet]4, 
                    2.4749}, {$CellContext`column\[Bullet]5, 
                    6.2193}, {$CellContext`column\[Bullet]6, 
                    2.5864}, {$CellContext`column\[Bullet]7, 
                    6.4752}, {$CellContext`column\[Bullet]8, 
                    23.65}, {$CellContext`column\[Bullet]9, 44.15}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 3.2686747673100265`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.2686747673100265`"}, {
                    "\"Observed\"", "2.9`"}, {
                    "column\[Bullet]1", "353.52`"}, {
                    "column\[Bullet]3", "0.074992`"}, {
                    "column\[Bullet]4", "1.4033`"}, {
                    "column\[Bullet]5", "2.8071`"}, {
                    "column\[Bullet]6", "2.1907`"}, {
                    "column\[Bullet]7", "7.3389`"}, {
                    "column\[Bullet]8", "27.263`"}, {
                    "column\[Bullet]9", "36.224`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.2686747673100265`}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    353.52}, {$CellContext`column\[Bullet]3, 
                    0.074992}, {$CellContext`column\[Bullet]4, 
                    1.4033}, {$CellContext`column\[Bullet]5, 
                    2.8071}, {$CellContext`column\[Bullet]6, 
                    2.1907}, {$CellContext`column\[Bullet]7, 
                    7.3389}, {$CellContext`column\[Bullet]8, 
                    27.263}, {$CellContext`column\[Bullet]9, 36.224}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{2.9, 5.309026226489398}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.309026226489398`"}, {
                    "\"Observed\"", "2.9`"}, {"column\[Bullet]1", "325.6`"}, {
                    "column\[Bullet]3", "0.04209`"}, {
                    "column\[Bullet]4", "2.5085`"}, {
                    "column\[Bullet]5", "6.4914`"}, {
                    "column\[Bullet]6", "2.8532`"}, {
                    "column\[Bullet]7", "6.2225`"}, {
                    "column\[Bullet]8", "22.929`"}, {
                    "column\[Bullet]9", "44.949`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.309026226489398}, {
                    "Observed", 2.9}, {$CellContext`column\[Bullet]1, 
                    325.6}, {$CellContext`column\[Bullet]3, 
                    0.04209}, {$CellContext`column\[Bullet]4, 
                    2.5085}, {$CellContext`column\[Bullet]5, 
                    6.4914}, {$CellContext`column\[Bullet]6, 
                    2.8532}, {$CellContext`column\[Bullet]7, 
                    6.2225}, {$CellContext`column\[Bullet]8, 
                    22.929}, {$CellContext`column\[Bullet]9, 44.949}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 2.0829715986270823`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.0829715986270823`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "285.64`"}, {
                    "column\[Bullet]3", "0.0096654`"}, {
                    "column\[Bullet]4", "1.2824`"}, {
                    "column\[Bullet]5", "3.5583`"}, {
                    "column\[Bullet]6", "0.93475`"}, {
                    "column\[Bullet]7", "4.4397`"}, {
                    "column\[Bullet]8", "24.376`"}, {
                    "column\[Bullet]9", "40.362`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.0829715986270823`}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    285.64}, {$CellContext`column\[Bullet]3, 
                    0.0096654}, {$CellContext`column\[Bullet]4, 
                    1.2824}, {$CellContext`column\[Bullet]5, 
                    3.5583}, {$CellContext`column\[Bullet]6, 
                    0.93475}, {$CellContext`column\[Bullet]7, 
                    4.4397}, {$CellContext`column\[Bullet]8, 
                    24.376}, {$CellContext`column\[Bullet]9, 40.362}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 4.355673284934248}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.355673284934248`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "333.36`"}, {
                    "column\[Bullet]3", "0.25416`"}, {
                    "column\[Bullet]4", "2.6108`"}, {
                    "column\[Bullet]5", "4.8841`"}, {
                    "column\[Bullet]6", "2.067`"}, {
                    "column\[Bullet]7", "7.2514`"}, {
                    "column\[Bullet]8", "25.735`"}, {
                    "column\[Bullet]9", "41.052`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.355673284934248}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    333.36}, {$CellContext`column\[Bullet]3, 
                    0.25416}, {$CellContext`column\[Bullet]4, 
                    2.6108}, {$CellContext`column\[Bullet]5, 
                    4.8841}, {$CellContext`column\[Bullet]6, 
                    2.067}, {$CellContext`column\[Bullet]7, 
                    7.2514}, {$CellContext`column\[Bullet]8, 
                    25.735}, {$CellContext`column\[Bullet]9, 41.052}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 2.7442065470755637`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.7442065470755637`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "280.31`"}, {
                    "column\[Bullet]3", "0.032604`"}, {
                    "column\[Bullet]4", "2.4018`"}, {
                    "column\[Bullet]5", "3.9752`"}, {
                    "column\[Bullet]6", "0.90314`"}, {
                    "column\[Bullet]7", "4.6652`"}, {
                    "column\[Bullet]8", "25.418`"}, {
                    "column\[Bullet]9", "39.787`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.7442065470755637`}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    280.31}, {$CellContext`column\[Bullet]3, 
                    0.032604}, {$CellContext`column\[Bullet]4, 
                    2.4018}, {$CellContext`column\[Bullet]5, 
                    3.9752}, {$CellContext`column\[Bullet]6, 
                    0.90314}, {$CellContext`column\[Bullet]7, 
                    4.6652}, {$CellContext`column\[Bullet]8, 
                    25.418}, {$CellContext`column\[Bullet]9, 39.787}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 4.381389467984195}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.381389467984195`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "337.55`"}, {
                    "column\[Bullet]3", "0.25098`"}, {
                    "column\[Bullet]4", "2.2948`"}, {
                    "column\[Bullet]5", "4.836`"}, {
                    "column\[Bullet]6", "2.4206`"}, {
                    "column\[Bullet]7", "6.7155`"}, {
                    "column\[Bullet]8", "26.782`"}, {
                    "column\[Bullet]9", "42.383`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.381389467984195}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    337.55}, {$CellContext`column\[Bullet]3, 
                    0.25098}, {$CellContext`column\[Bullet]4, 
                    2.2948}, {$CellContext`column\[Bullet]5, 
                    4.836}, {$CellContext`column\[Bullet]6, 
                    2.4206}, {$CellContext`column\[Bullet]7, 
                    6.7155}, {$CellContext`column\[Bullet]8, 
                    26.782}, {$CellContext`column\[Bullet]9, 42.383}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3., 7.301611171951934}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.301611171951934`"}, {
                    "\"Observed\"", "3"}, {"column\[Bullet]1", "84.801`"}, {
                    "column\[Bullet]3", "0.023225`"}, {
                    "column\[Bullet]4", "2.8469`"}, {
                    "column\[Bullet]5", "1.144`"}, {
                    "column\[Bullet]6", "0.41367`"}, {
                    "column\[Bullet]7", "0.99846`"}, {
                    "column\[Bullet]8", "7.96`"}, {
                    "column\[Bullet]9", "10.278`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.301611171951934}, {
                    "Observed", 3}, {$CellContext`column\[Bullet]1, 
                    84.801}, {$CellContext`column\[Bullet]3, 
                    0.023225}, {$CellContext`column\[Bullet]4, 
                    2.8469}, {$CellContext`column\[Bullet]5, 
                    1.144}, {$CellContext`column\[Bullet]6, 
                    0.41367}, {$CellContext`column\[Bullet]7, 
                    0.99846}, {$CellContext`column\[Bullet]8, 
                    7.96}, {$CellContext`column\[Bullet]9, 10.278}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 15.785220315779625`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.785220315779625`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "481.33`"}, {
                    "column\[Bullet]3", "2.3203`"}, {
                    "column\[Bullet]4", "14.958`"}, {
                    "column\[Bullet]5", "11.811`"}, {
                    "column\[Bullet]6", "6.2482`"}, {
                    "column\[Bullet]7", "16.464`"}, {
                    "column\[Bullet]8", "28.218`"}, {
                    "column\[Bullet]9", "39.915`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.785220315779625`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    481.33}, {$CellContext`column\[Bullet]3, 
                    2.3203}, {$CellContext`column\[Bullet]4, 
                    14.958}, {$CellContext`column\[Bullet]5, 
                    11.811}, {$CellContext`column\[Bullet]6, 
                    6.2482}, {$CellContext`column\[Bullet]7, 
                    16.464}, {$CellContext`column\[Bullet]8, 
                    28.218}, {$CellContext`column\[Bullet]9, 39.915}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 15.236134851794061`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.236134851794061`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "502.85`"}, {
                    "column\[Bullet]3", "2.076`"}, {
                    "column\[Bullet]4", "10.148`"}, {
                    "column\[Bullet]5", "6.3476`"}, {
                    "column\[Bullet]6", "6.7924`"}, {
                    "column\[Bullet]7", "16.656`"}, {
                    "column\[Bullet]8", "26.531`"}, {
                    "column\[Bullet]9", "45.039`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 15.236134851794061`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    502.85}, {$CellContext`column\[Bullet]3, 
                    2.076}, {$CellContext`column\[Bullet]4, 
                    10.148}, {$CellContext`column\[Bullet]5, 
                    6.3476}, {$CellContext`column\[Bullet]6, 
                    6.7924}, {$CellContext`column\[Bullet]7, 
                    16.656}, {$CellContext`column\[Bullet]8, 
                    26.531}, {$CellContext`column\[Bullet]9, 45.039}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 16.156690150044902`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.156690150044902`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "481.46`"}, {
                    "column\[Bullet]3", "2.3247`"}, {
                    "column\[Bullet]4", "13.512`"}, {
                    "column\[Bullet]5", "11.24`"}, {
                    "column\[Bullet]6", "6.5212`"}, {
                    "column\[Bullet]7", "16.437`"}, {
                    "column\[Bullet]8", "27.152`"}, {
                    "column\[Bullet]9", "40.157`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 16.156690150044902`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    481.46}, {$CellContext`column\[Bullet]3, 
                    2.3247}, {$CellContext`column\[Bullet]4, 
                    13.512}, {$CellContext`column\[Bullet]5, 
                    11.24}, {$CellContext`column\[Bullet]6, 
                    6.5212}, {$CellContext`column\[Bullet]7, 
                    16.437}, {$CellContext`column\[Bullet]8, 
                    27.152}, {$CellContext`column\[Bullet]9, 40.157}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{19.1, 14.527748571409438`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.527748571409438`"}, {
                    "\"Observed\"", "19.1`"}, {
                    "column\[Bullet]1", "504.22`"}, {
                    "column\[Bullet]3", "2.175`"}, {
                    "column\[Bullet]4", "9.31`"}, {
                    "column\[Bullet]5", "5.6544`"}, {
                    "column\[Bullet]6", "6.1498`"}, {
                    "column\[Bullet]7", "16.944`"}, {
                    "column\[Bullet]8", "26.384`"}, {
                    "column\[Bullet]9", "44.574`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.527748571409438`}, {
                    "Observed", 19.1}, {$CellContext`column\[Bullet]1, 
                    504.22}, {$CellContext`column\[Bullet]3, 
                    2.175}, {$CellContext`column\[Bullet]4, 
                    9.31}, {$CellContext`column\[Bullet]5, 
                    5.6544}, {$CellContext`column\[Bullet]6, 
                    6.1498}, {$CellContext`column\[Bullet]7, 
                    16.944}, {$CellContext`column\[Bullet]8, 
                    26.384}, {$CellContext`column\[Bullet]9, 44.574}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.2067441138125}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.2067441138125`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "449.06`"}, {
                    "column\[Bullet]3", "3.9959`"}, {
                    "column\[Bullet]4", "9.0628`"}, {
                    "column\[Bullet]5", "2.9384`"}, {
                    "column\[Bullet]6", "5.1599`"}, {
                    "column\[Bullet]7", "11.975`"}, {
                    "column\[Bullet]8", "25.811`"}, {
                    "column\[Bullet]9", "42.422`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 16.2067441138125}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    449.06}, {$CellContext`column\[Bullet]3, 
                    3.9959}, {$CellContext`column\[Bullet]4, 
                    9.0628}, {$CellContext`column\[Bullet]5, 
                    2.9384}, {$CellContext`column\[Bullet]6, 
                    5.1599}, {$CellContext`column\[Bullet]7, 
                    11.975}, {$CellContext`column\[Bullet]8, 
                    25.811}, {$CellContext`column\[Bullet]9, 42.422}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 17.078164387456514`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.078164387456514`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "490.04`"}, {
                    "column\[Bullet]3", "3.641`"}, {
                    "column\[Bullet]4", "11.151`"}, {
                    "column\[Bullet]5", "7.6245`"}, {
                    "column\[Bullet]6", "7.3421`"}, {
                    "column\[Bullet]7", "17.862`"}, {
                    "column\[Bullet]8", "29.307`"}, {
                    "column\[Bullet]9", "45.273`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.078164387456514`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    490.04}, {$CellContext`column\[Bullet]3, 
                    3.641}, {$CellContext`column\[Bullet]4, 
                    11.151}, {$CellContext`column\[Bullet]5, 
                    7.6245}, {$CellContext`column\[Bullet]6, 
                    7.3421}, {$CellContext`column\[Bullet]7, 
                    17.862}, {$CellContext`column\[Bullet]8, 
                    29.307}, {$CellContext`column\[Bullet]9, 45.273}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.389361191588392`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.389361191588392`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "443.1`"}, {
                    "column\[Bullet]3", "3.8976`"}, {
                    "column\[Bullet]4", "9.2719`"}, {
                    "column\[Bullet]5", "3.4631`"}, {
                    "column\[Bullet]6", "4.6121`"}, {
                    "column\[Bullet]7", "10.64`"}, {
                    "column\[Bullet]8", "23.97`"}, {
                    "column\[Bullet]9", "43.062`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 16.389361191588392`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    443.1}, {$CellContext`column\[Bullet]3, 
                    3.8976}, {$CellContext`column\[Bullet]4, 
                    9.2719}, {$CellContext`column\[Bullet]5, 
                    3.4631}, {$CellContext`column\[Bullet]6, 
                    4.6121}, {$CellContext`column\[Bullet]7, 
                    10.64}, {$CellContext`column\[Bullet]8, 
                    23.97}, {$CellContext`column\[Bullet]9, 43.062}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 16.68472600203315}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.68472600203315`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "484.38`"}, {
                    "column\[Bullet]3", "3.1734`"}, {
                    "column\[Bullet]4", "10.662`"}, {
                    "column\[Bullet]5", "7.7974`"}, {
                    "column\[Bullet]6", "7.8007`"}, {
                    "column\[Bullet]7", "16.382`"}, {
                    "column\[Bullet]8", "29.218`"}, {
                    "column\[Bullet]9", "45.361`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 16.68472600203315}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    484.38}, {$CellContext`column\[Bullet]3, 
                    3.1734}, {$CellContext`column\[Bullet]4, 
                    10.662}, {$CellContext`column\[Bullet]5, 
                    7.7974}, {$CellContext`column\[Bullet]6, 
                    7.8007}, {$CellContext`column\[Bullet]7, 
                    16.382}, {$CellContext`column\[Bullet]8, 
                    29.218}, {$CellContext`column\[Bullet]9, 45.361}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{18.6, 17.014435106850357`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.014435106850357`"}, {
                    "\"Observed\"", "18.6`"}, {
                    "column\[Bullet]1", "123.01`"}, {
                    "column\[Bullet]3", "1.168`"}, {
                    "column\[Bullet]4", "2.118`"}, {
                    "column\[Bullet]5", "2.085`"}, {
                    "column\[Bullet]6", "1.1875`"}, {
                    "column\[Bullet]7", "3.3023`"}, {
                    "column\[Bullet]8", "5.1231`"}, {
                    "column\[Bullet]9", "12.093`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.014435106850357`}, {
                    "Observed", 18.6}, {$CellContext`column\[Bullet]1, 
                    123.01}, {$CellContext`column\[Bullet]3, 
                    1.168}, {$CellContext`column\[Bullet]4, 
                    2.118}, {$CellContext`column\[Bullet]5, 
                    2.085}, {$CellContext`column\[Bullet]6, 
                    1.1875}, {$CellContext`column\[Bullet]7, 
                    3.3023}, {$CellContext`column\[Bullet]8, 
                    5.1231}, {$CellContext`column\[Bullet]9, 12.093}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 21.4481768315614}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "21.4481768315614`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "395.63`"}, {
                    "column\[Bullet]3", "4.4166`"}, {
                    "column\[Bullet]4", "9.4434`"}, {
                    "column\[Bullet]5", "5.2949`"}, {
                    "column\[Bullet]6", "5.6166`"}, {
                    "column\[Bullet]7", "13.454`"}, {
                    "column\[Bullet]8", "19.036`"}, {
                    "column\[Bullet]9", "46"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 21.4481768315614}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    395.63}, {$CellContext`column\[Bullet]3, 
                    4.4166}, {$CellContext`column\[Bullet]4, 
                    9.4434}, {$CellContext`column\[Bullet]5, 
                    5.2949}, {$CellContext`column\[Bullet]6, 
                    5.6166}, {$CellContext`column\[Bullet]7, 
                    13.454}, {$CellContext`column\[Bullet]8, 
                    19.036}, {$CellContext`column\[Bullet]9, 46}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 22.87382671607141}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "22.87382671607141`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "429.01`"}, {
                    "column\[Bullet]3", "5.8707`"}, {
                    "column\[Bullet]4", "12.294`"}, {
                    "column\[Bullet]5", "5.2104`"}, {
                    "column\[Bullet]6", "6.3098`"}, {
                    "column\[Bullet]7", "12.685`"}, {
                    "column\[Bullet]8", "22.878`"}, {
                    "column\[Bullet]9", "44.879`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 22.87382671607141}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    429.01}, {$CellContext`column\[Bullet]3, 
                    5.8707}, {$CellContext`column\[Bullet]4, 
                    12.294}, {$CellContext`column\[Bullet]5, 
                    5.2104}, {$CellContext`column\[Bullet]6, 
                    6.3098}, {$CellContext`column\[Bullet]7, 
                    12.685}, {$CellContext`column\[Bullet]8, 
                    22.878}, {$CellContext`column\[Bullet]9, 44.879}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 20.1879660724445}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.1879660724445`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "383.51`"}, {
                    "column\[Bullet]3", "3.9862`"}, {
                    "column\[Bullet]4", "9.7398`"}, {
                    "column\[Bullet]5", "5.7647`"}, {
                    "column\[Bullet]6", "4.6835`"}, {
                    "column\[Bullet]7", "12.484`"}, {
                    "column\[Bullet]8", "18.37`"}, {
                    "column\[Bullet]9", "45.513`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.1879660724445}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    383.51}, {$CellContext`column\[Bullet]3, 
                    3.9862}, {$CellContext`column\[Bullet]4, 
                    9.7398}, {$CellContext`column\[Bullet]5, 
                    5.7647}, {$CellContext`column\[Bullet]6, 
                    4.6835}, {$CellContext`column\[Bullet]7, 
                    12.484}, {$CellContext`column\[Bullet]8, 
                    18.37}, {$CellContext`column\[Bullet]9, 45.513}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.2, 24.29656208733143}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "24.29656208733143`"}, {
                    "\"Observed\"", "22.2`"}, {
                    "column\[Bullet]1", "423.59`"}, {
                    "column\[Bullet]3", "6.0992`"}, {
                    "column\[Bullet]4", "12.774`"}, {
                    "column\[Bullet]5", "5.2123`"}, {
                    "column\[Bullet]6", "7.5576`"}, {
                    "column\[Bullet]7", "12.976`"}, {
                    "column\[Bullet]8", "23.546`"}, {
                    "column\[Bullet]9", "45.163`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 24.29656208733143}, {
                    "Observed", 22.2}, {$CellContext`column\[Bullet]1, 
                    423.59}, {$CellContext`column\[Bullet]3, 
                    6.0992}, {$CellContext`column\[Bullet]4, 
                    12.774}, {$CellContext`column\[Bullet]5, 
                    5.2123}, {$CellContext`column\[Bullet]6, 
                    7.5576}, {$CellContext`column\[Bullet]7, 
                    12.976}, {$CellContext`column\[Bullet]8, 
                    23.546}, {$CellContext`column\[Bullet]9, 45.163}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 17.69705996968646}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "17.69705996968646`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "382.47`"}, {
                    "column\[Bullet]3", "4.558`"}, {
                    "column\[Bullet]4", "9.4998`"}, {
                    "column\[Bullet]5", "4.2863`"}, {
                    "column\[Bullet]6", "4.0496`"}, {
                    "column\[Bullet]7", "10.55`"}, {
                    "column\[Bullet]8", "22.604`"}, {
                    "column\[Bullet]9", "43.469`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 17.69705996968646}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    382.47}, {$CellContext`column\[Bullet]3, 
                    4.558}, {$CellContext`column\[Bullet]4, 
                    9.4998}, {$CellContext`column\[Bullet]5, 
                    4.2863}, {$CellContext`column\[Bullet]6, 
                    4.0496}, {$CellContext`column\[Bullet]7, 
                    10.55}, {$CellContext`column\[Bullet]8, 
                    22.604}, {$CellContext`column\[Bullet]9, 43.469}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 18.501933793315143`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "18.501933793315143`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "417.96`"}, {
                    "column\[Bullet]3", "3.4999`"}, {
                    "column\[Bullet]4", "11.517`"}, {
                    "column\[Bullet]5", "5.9722`"}, {
                    "column\[Bullet]6", "5.9796`"}, {
                    "column\[Bullet]7", "14.03`"}, {
                    "column\[Bullet]8", "23.395`"}, {
                    "column\[Bullet]9", "45.627`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 18.501933793315143`}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    417.96}, {$CellContext`column\[Bullet]3, 
                    3.4999}, {$CellContext`column\[Bullet]4, 
                    11.517}, {$CellContext`column\[Bullet]5, 
                    5.9722}, {$CellContext`column\[Bullet]6, 
                    5.9796}, {$CellContext`column\[Bullet]7, 
                    14.03}, {$CellContext`column\[Bullet]8, 
                    23.395}, {$CellContext`column\[Bullet]9, 45.627}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 16.91748076637435}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "16.91748076637435`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "385.89`"}, {
                    "column\[Bullet]3", "4.1518`"}, {
                    "column\[Bullet]4", "9.0139`"}, {
                    "column\[Bullet]5", "4.5748`"}, {
                    "column\[Bullet]6", "4.4834`"}, {
                    "column\[Bullet]7", "10.033`"}, {
                    "column\[Bullet]8", "23.256`"}, {
                    "column\[Bullet]9", "44.391`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 16.91748076637435}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    385.89}, {$CellContext`column\[Bullet]3, 
                    4.1518}, {$CellContext`column\[Bullet]4, 
                    9.0139}, {$CellContext`column\[Bullet]5, 
                    4.5748}, {$CellContext`column\[Bullet]6, 
                    4.4834}, {$CellContext`column\[Bullet]7, 
                    10.033}, {$CellContext`column\[Bullet]8, 
                    23.256}, {$CellContext`column\[Bullet]9, 44.391}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 18.567578745346985`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "18.567578745346985`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "432.21`"}, {
                    "column\[Bullet]3", "3.0879`"}, {
                    "column\[Bullet]4", "11.139`"}, {
                    "column\[Bullet]5", "5.8922`"}, {
                    "column\[Bullet]6", "6.6017`"}, {
                    "column\[Bullet]7", "15.174`"}, {
                    "column\[Bullet]8", "22.937`"}, {
                    "column\[Bullet]9", "44.985`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 18.567578745346985`}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    432.21}, {$CellContext`column\[Bullet]3, 
                    3.0879}, {$CellContext`column\[Bullet]4, 
                    11.139}, {$CellContext`column\[Bullet]5, 
                    5.8922}, {$CellContext`column\[Bullet]6, 
                    6.6017}, {$CellContext`column\[Bullet]7, 
                    15.174}, {$CellContext`column\[Bullet]8, 
                    22.937}, {$CellContext`column\[Bullet]9, 44.985}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{21.6, 19.545064004214087`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "19.545064004214087`"}, {
                    "\"Observed\"", "21.6`"}, {
                    "column\[Bullet]1", "104.64`"}, {
                    "column\[Bullet]3", "1.2003`"}, {
                    "column\[Bullet]4", "3.4599`"}, {
                    "column\[Bullet]5", "1.2469`"}, {
                    "column\[Bullet]6", "1.8204`"}, {
                    "column\[Bullet]7", "2.3453`"}, {
                    "column\[Bullet]8", "6.1338`"}, {
                    "column\[Bullet]9", "13.694`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 19.545064004214087`}, {
                    "Observed", 21.6}, {$CellContext`column\[Bullet]1, 
                    104.64}, {$CellContext`column\[Bullet]3, 
                    1.2003}, {$CellContext`column\[Bullet]4, 
                    3.4599}, {$CellContext`column\[Bullet]5, 
                    1.2469}, {$CellContext`column\[Bullet]6, 
                    1.8204}, {$CellContext`column\[Bullet]7, 
                    2.3453}, {$CellContext`column\[Bullet]8, 
                    6.1338}, {$CellContext`column\[Bullet]9, 13.694}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 19.916965660366092`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "19.916965660366092`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "397.12`"}, {
                    "column\[Bullet]3", "4.3753`"}, {
                    "column\[Bullet]4", "12.63`"}, {
                    "column\[Bullet]5", "6.236`"}, {
                    "column\[Bullet]6", "4.6257`"}, {
                    "column\[Bullet]7", "12.523`"}, {
                    "column\[Bullet]8", "21.378`"}, {
                    "column\[Bullet]9", "47.173`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 19.916965660366092`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    397.12}, {$CellContext`column\[Bullet]3, 
                    4.3753}, {$CellContext`column\[Bullet]4, 
                    12.63}, {$CellContext`column\[Bullet]5, 
                    6.236}, {$CellContext`column\[Bullet]6, 
                    4.6257}, {$CellContext`column\[Bullet]7, 
                    12.523}, {$CellContext`column\[Bullet]8, 
                    21.378}, {$CellContext`column\[Bullet]9, 47.173}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 25.369196967712668`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "25.369196967712668`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "425.48`"}, {
                    "column\[Bullet]3", "6.2747`"}, {
                    "column\[Bullet]4", "13.025`"}, {
                    "column\[Bullet]5", "7.5405`"}, {
                    "column\[Bullet]6", "7.9011`"}, {
                    "column\[Bullet]7", "15.131`"}, {
                    "column\[Bullet]8", "22.819`"}, {
                    "column\[Bullet]9", "47.515`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 25.369196967712668`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    425.48}, {$CellContext`column\[Bullet]3, 
                    6.2747}, {$CellContext`column\[Bullet]4, 
                    13.025}, {$CellContext`column\[Bullet]5, 
                    7.5405}, {$CellContext`column\[Bullet]6, 
                    7.9011}, {$CellContext`column\[Bullet]7, 
                    15.131}, {$CellContext`column\[Bullet]8, 
                    22.819}, {$CellContext`column\[Bullet]9, 47.515}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 20.624697639233602`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "20.624697639233602`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "391.07`"}, {
                    "column\[Bullet]3", "4.5357`"}, {
                    "column\[Bullet]4", "13.001`"}, {
                    "column\[Bullet]5", "6.3219`"}, {
                    "column\[Bullet]6", "4.9742`"}, {
                    "column\[Bullet]7", "13.822`"}, {
                    "column\[Bullet]8", "21.549`"}, {
                    "column\[Bullet]9", "45.417`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 20.624697639233602`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    391.07}, {$CellContext`column\[Bullet]3, 
                    4.5357}, {$CellContext`column\[Bullet]4, 
                    13.001}, {$CellContext`column\[Bullet]5, 
                    6.3219}, {$CellContext`column\[Bullet]6, 
                    4.9742}, {$CellContext`column\[Bullet]7, 
                    13.822}, {$CellContext`column\[Bullet]8, 
                    21.549}, {$CellContext`column\[Bullet]9, 45.417}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{22.1, 25.078395237441605`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "25.078395237441605`"}, {
                    "\"Observed\"", "22.1`"}, {
                    "column\[Bullet]1", "426.27`"}, {
                    "column\[Bullet]3", "6.7675`"}, {
                    "column\[Bullet]4", "12.632`"}, {
                    "column\[Bullet]5", "8.0609`"}, {
                    "column\[Bullet]6", "7.8022`"}, {
                    "column\[Bullet]7", "15.366`"}, {
                    "column\[Bullet]8", "23.678`"}, {
                    "column\[Bullet]9", "46.834`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 25.078395237441605`}, {
                    "Observed", 22.1}, {$CellContext`column\[Bullet]1, 
                    426.27}, {$CellContext`column\[Bullet]3, 
                    6.7675}, {$CellContext`column\[Bullet]4, 
                    12.632}, {$CellContext`column\[Bullet]5, 
                    8.0609}, {$CellContext`column\[Bullet]6, 
                    7.8022}, {$CellContext`column\[Bullet]7, 
                    15.366}, {$CellContext`column\[Bullet]8, 
                    23.678}, {$CellContext`column\[Bullet]9, 46.834}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.580129049203597}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.580129049203597`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "317.76`"}, {
                    "column\[Bullet]3", "0.13914`"}, {
                    "column\[Bullet]4", "2.4186`"}, {
                    "column\[Bullet]5", "5.7358`"}, {
                    "column\[Bullet]6", "2.2551`"}, {
                    "column\[Bullet]7", "7.0779`"}, {
                    "column\[Bullet]8", "23.868`"}, {
                    "column\[Bullet]9", "37.857`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.580129049203597}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    317.76}, {$CellContext`column\[Bullet]3, 
                    0.13914}, {$CellContext`column\[Bullet]4, 
                    2.4186}, {$CellContext`column\[Bullet]5, 
                    5.7358}, {$CellContext`column\[Bullet]6, 
                    2.2551}, {$CellContext`column\[Bullet]7, 
                    7.0779}, {$CellContext`column\[Bullet]8, 
                    23.868}, {$CellContext`column\[Bullet]9, 37.857}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 2.9732198772322356`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "2.9732198772322356`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "354.22`"}, {
                    "column\[Bullet]3", "0.10735`"}, {
                    "column\[Bullet]4", "1.7602`"}, {
                    "column\[Bullet]5", "4.9685`"}, {
                    "column\[Bullet]6", "1.4607`"}, {
                    "column\[Bullet]7", "5.2356`"}, {
                    "column\[Bullet]8", "24.261`"}, {
                    "column\[Bullet]9", "41.266`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 2.9732198772322356`}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    354.22}, {$CellContext`column\[Bullet]3, 
                    0.10735}, {$CellContext`column\[Bullet]4, 
                    1.7602}, {$CellContext`column\[Bullet]5, 
                    4.9685}, {$CellContext`column\[Bullet]6, 
                    1.4607}, {$CellContext`column\[Bullet]7, 
                    5.2356}, {$CellContext`column\[Bullet]8, 
                    24.261}, {$CellContext`column\[Bullet]9, 41.266}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.677230224366499}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.677230224366499`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "309.37`"}, {
                    "column\[Bullet]3", "0.13867`"}, {
                    "column\[Bullet]4", "2.4399`"}, {
                    "column\[Bullet]5", "5.8753`"}, {
                    "column\[Bullet]6", "2.4094`"}, {
                    "column\[Bullet]7", "6.6234`"}, {
                    "column\[Bullet]8", "24.325`"}, {
                    "column\[Bullet]9", "38.006`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.677230224366499}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    309.37}, {$CellContext`column\[Bullet]3, 
                    0.13867}, {$CellContext`column\[Bullet]4, 
                    2.4399}, {$CellContext`column\[Bullet]5, 
                    5.8753}, {$CellContext`column\[Bullet]6, 
                    2.4094}, {$CellContext`column\[Bullet]7, 
                    6.6234}, {$CellContext`column\[Bullet]8, 
                    24.325}, {$CellContext`column\[Bullet]9, 38.006}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.032731623324986}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.032731623324986`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "354.59`"}, {
                    "column\[Bullet]3", "0.10803`"}, {
                    "column\[Bullet]4", "1.8532`"}, {
                    "column\[Bullet]5", "4.7755`"}, {
                    "column\[Bullet]6", "2.4708`"}, {
                    "column\[Bullet]7", "5.7003`"}, {
                    "column\[Bullet]8", "26.043`"}, {
                    "column\[Bullet]9", "42.092`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.032731623324986}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    354.59}, {$CellContext`column\[Bullet]3, 
                    0.10803}, {$CellContext`column\[Bullet]4, 
                    1.8532}, {$CellContext`column\[Bullet]5, 
                    4.7755}, {$CellContext`column\[Bullet]6, 
                    2.4708}, {$CellContext`column\[Bullet]7, 
                    5.7003}, {$CellContext`column\[Bullet]8, 
                    26.043}, {$CellContext`column\[Bullet]9, 42.092}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 3.7636279070103855`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.7636279070103855`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "80.549`"}, {
                    "column\[Bullet]3", "0"}, {
                    "column\[Bullet]4", "0.23556`"}, {
                    "column\[Bullet]5", "0.65964`"}, {
                    "column\[Bullet]6", "0.61828`"}, {
                    "column\[Bullet]7", "1.4995`"}, {
                    "column\[Bullet]8", "6.2371`"}, {
                    "column\[Bullet]9", "10.143`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 3.7636279070103855`}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    80.549}, {$CellContext`column\[Bullet]3, 
                    0}, {$CellContext`column\[Bullet]4, 
                    0.23556}, {$CellContext`column\[Bullet]5, 
                    0.65964}, {$CellContext`column\[Bullet]6, 
                    0.61828}, {$CellContext`column\[Bullet]7, 
                    1.4995}, {$CellContext`column\[Bullet]8, 
                    6.2371}, {$CellContext`column\[Bullet]9, 10.143}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 5.360852059563102}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.360852059563102`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "368.14`"}, {
                    "column\[Bullet]3", "0.23302`"}, {
                    "column\[Bullet]4", "2.1478`"}, {
                    "column\[Bullet]5", "2.6785`"}, {
                    "column\[Bullet]6", "2.5631`"}, {
                    "column\[Bullet]7", "9.5897`"}, {
                    "column\[Bullet]8", "21.61`"}, {
                    "column\[Bullet]9", "39.752`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.360852059563102}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    368.14}, {$CellContext`column\[Bullet]3, 
                    0.23302}, {$CellContext`column\[Bullet]4, 
                    2.1478}, {$CellContext`column\[Bullet]5, 
                    2.6785}, {$CellContext`column\[Bullet]6, 
                    2.5631}, {$CellContext`column\[Bullet]7, 
                    9.5897}, {$CellContext`column\[Bullet]8, 
                    21.61}, {$CellContext`column\[Bullet]9, 39.752}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 3.5929320485395526`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "3.5929320485395526`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "358.93`"}, {
                    "column\[Bullet]3", "0.02045`"}, {
                    "column\[Bullet]4", "2.5561`"}, {
                    "column\[Bullet]5", "4.244`"}, {
                    "column\[Bullet]6", "1.5919`"}, {
                    "column\[Bullet]7", "6.8468`"}, {
                    "column\[Bullet]8", "25.028`"}, {
                    "column\[Bullet]9", "41.052`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 3.5929320485395526`}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    358.93}, {$CellContext`column\[Bullet]3, 
                    0.02045}, {$CellContext`column\[Bullet]4, 
                    2.5561}, {$CellContext`column\[Bullet]5, 
                    4.244}, {$CellContext`column\[Bullet]6, 
                    1.5919}, {$CellContext`column\[Bullet]7, 
                    6.8468}, {$CellContext`column\[Bullet]8, 
                    25.028}, {$CellContext`column\[Bullet]9, 41.052}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 5.50483507146346}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "5.50483507146346`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "368.06`"}, {
                    "column\[Bullet]3", "0.23339`"}, {
                    "column\[Bullet]4", "2.4591`"}, {
                    "column\[Bullet]5", "2.5755`"}, {
                    "column\[Bullet]6", "2.6119`"}, {
                    "column\[Bullet]7", "9.6519`"}, {
                    "column\[Bullet]8", "22.526`"}, {
                    "column\[Bullet]9", "39.377`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 5.50483507146346}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    368.06}, {$CellContext`column\[Bullet]3, 
                    0.23339}, {$CellContext`column\[Bullet]4, 
                    2.4591}, {$CellContext`column\[Bullet]5, 
                    2.5755}, {$CellContext`column\[Bullet]6, 
                    2.6119}, {$CellContext`column\[Bullet]7, 
                    9.6519}, {$CellContext`column\[Bullet]8, 
                    22.526}, {$CellContext`column\[Bullet]9, 39.377}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{3.6, 4.216129163412458}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "4.216129163412458`"}, {
                    "\"Observed\"", "3.6`"}, {
                    "column\[Bullet]1", "358.81`"}, {
                    "column\[Bullet]3", "0"}, {
                    "column\[Bullet]4", "2.185`"}, {
                    "column\[Bullet]5", "3.7891`"}, {
                    "column\[Bullet]6", "2.1297`"}, {
                    "column\[Bullet]7", "6.5699`"}, {
                    "column\[Bullet]8", "23.158`"}, {
                    "column\[Bullet]9", "41.835`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 4.216129163412458}, {
                    "Observed", 3.6}, {$CellContext`column\[Bullet]1, 
                    358.81}, {$CellContext`column\[Bullet]3, 
                    0}, {$CellContext`column\[Bullet]4, 
                    2.185}, {$CellContext`column\[Bullet]5, 
                    3.7891}, {$CellContext`column\[Bullet]6, 
                    2.1297}, {$CellContext`column\[Bullet]7, 
                    6.5699}, {$CellContext`column\[Bullet]8, 
                    23.158}, {$CellContext`column\[Bullet]9, 41.835}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.222110130158719}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.222110130158719`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "455.92`"}, {
                    "column\[Bullet]3", "1.4683`"}, {
                    "column\[Bullet]4", "5.1854`"}, {
                    "column\[Bullet]5", "5.7923`"}, {
                    "column\[Bullet]6", "2.1978`"}, {
                    "column\[Bullet]7", "8.449`"}, {
                    "column\[Bullet]8", "27.789`"}, {
                    "column\[Bullet]9", "38.103`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.222110130158719}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    455.92}, {$CellContext`column\[Bullet]3, 
                    1.4683}, {$CellContext`column\[Bullet]4, 
                    5.1854}, {$CellContext`column\[Bullet]5, 
                    5.7923}, {$CellContext`column\[Bullet]6, 
                    2.1978}, {$CellContext`column\[Bullet]7, 
                    8.449}, {$CellContext`column\[Bullet]8, 
                    27.789}, {$CellContext`column\[Bullet]9, 38.103}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.345142330894549}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.345142330894549`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "522.89`"}, {
                    "column\[Bullet]3", "0.25599`"}, {
                    "column\[Bullet]4", "3.9894`"}, {
                    "column\[Bullet]5", "4.0052`"}, {
                    "column\[Bullet]6", "3.7642`"}, {
                    "column\[Bullet]7", "9.1212`"}, {
                    "column\[Bullet]8", "23.253`"}, {
                    "column\[Bullet]9", "35.749`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.345142330894549}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    522.89}, {$CellContext`column\[Bullet]3, 
                    0.25599}, {$CellContext`column\[Bullet]4, 
                    3.9894}, {$CellContext`column\[Bullet]5, 
                    4.0052}, {$CellContext`column\[Bullet]6, 
                    3.7642}, {$CellContext`column\[Bullet]7, 
                    9.1212}, {$CellContext`column\[Bullet]8, 
                    23.253}, {$CellContext`column\[Bullet]9, 35.749}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.468332752886157}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.468332752886157`"}, {
                    "\"Observed\"", "7.1`"}, {"column\[Bullet]1", "449.6`"}, {
                    "column\[Bullet]3", "1.5059`"}, {
                    "column\[Bullet]4", "4.4903`"}, {
                    "column\[Bullet]5", "5.4743`"}, {
                    "column\[Bullet]6", "3.0233`"}, {
                    "column\[Bullet]7", "7.9431`"}, {
                    "column\[Bullet]8", "29.027`"}, {
                    "column\[Bullet]9", "37.303`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.468332752886157}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    449.6}, {$CellContext`column\[Bullet]3, 
                    1.5059}, {$CellContext`column\[Bullet]4, 
                    4.4903}, {$CellContext`column\[Bullet]5, 
                    5.4743}, {$CellContext`column\[Bullet]6, 
                    3.0233}, {$CellContext`column\[Bullet]7, 
                    7.9431}, {$CellContext`column\[Bullet]8, 
                    29.027}, {$CellContext`column\[Bullet]9, 37.303}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 6.558434419926665}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.558434419926665`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "512.86`"}, {
                    "column\[Bullet]3", "0.21101`"}, {
                    "column\[Bullet]4", "3.3275`"}, {
                    "column\[Bullet]5", "4.5047`"}, {
                    "column\[Bullet]6", "3.588`"}, {
                    "column\[Bullet]7", "9.8523`"}, {
                    "column\[Bullet]8", "23.922`"}, {
                    "column\[Bullet]9", "37.464`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.558434419926665}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    512.86}, {$CellContext`column\[Bullet]3, 
                    0.21101}, {$CellContext`column\[Bullet]4, 
                    3.3275}, {$CellContext`column\[Bullet]5, 
                    4.5047}, {$CellContext`column\[Bullet]6, 
                    3.588}, {$CellContext`column\[Bullet]7, 
                    9.8523}, {$CellContext`column\[Bullet]8, 
                    23.922}, {$CellContext`column\[Bullet]9, 37.464}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7.1, 7.0775924788660305`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.0775924788660305`"}, {
                    "\"Observed\"", "7.1`"}, {
                    "column\[Bullet]1", "141.73`"}, {
                    "column\[Bullet]3", "0.050792`"}, {
                    "column\[Bullet]4", "0.94377`"}, {
                    "column\[Bullet]5", "0.78211`"}, {
                    "column\[Bullet]6", "1.5099`"}, {
                    "column\[Bullet]7", "1.8776`"}, {
                    "column\[Bullet]8", "7.9649`"}, {
                    "column\[Bullet]9", "11.082`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.0775924788660305`}, {
                    "Observed", 7.1}, {$CellContext`column\[Bullet]1, 
                    141.73}, {$CellContext`column\[Bullet]3, 
                    0.050792}, {$CellContext`column\[Bullet]4, 
                    0.94377}, {$CellContext`column\[Bullet]5, 
                    0.78211}, {$CellContext`column\[Bullet]6, 
                    1.5099}, {$CellContext`column\[Bullet]7, 
                    1.8776}, {$CellContext`column\[Bullet]8, 
                    7.9649}, {$CellContext`column\[Bullet]9, 11.082}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 7.847763101471405}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "7.847763101471405`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "494.74`"}, {
                    "column\[Bullet]3", "0.29517`"}, {
                    "column\[Bullet]4", "6.0598`"}, {
                    "column\[Bullet]5", "6.2497`"}, {
                    "column\[Bullet]6", "3.7783`"}, {
                    "column\[Bullet]7", "12.67`"}, {
                    "column\[Bullet]8", "26.983`"}, {
                    "column\[Bullet]9", "38.495`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 7.847763101471405}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    494.74}, {$CellContext`column\[Bullet]3, 
                    0.29517}, {$CellContext`column\[Bullet]4, 
                    6.0598}, {$CellContext`column\[Bullet]5, 
                    6.2497}, {$CellContext`column\[Bullet]6, 
                    3.7783}, {$CellContext`column\[Bullet]7, 
                    12.67}, {$CellContext`column\[Bullet]8, 
                    26.983}, {$CellContext`column\[Bullet]9, 38.495}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 6.761568947027219}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.761568947027219`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "535.93`"}, {
                    "column\[Bullet]3", "0.46916`"}, {
                    "column\[Bullet]4", "5.7882`"}, {
                    "column\[Bullet]5", "4.6833`"}, {
                    "column\[Bullet]6", "2.2977`"}, {
                    "column\[Bullet]7", "8.6707`"}, {
                    "column\[Bullet]8", "24.869`"}, {
                    "column\[Bullet]9", "39.804`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.761568947027219}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    535.93}, {$CellContext`column\[Bullet]3, 
                    0.46916}, {$CellContext`column\[Bullet]4, 
                    5.7882}, {$CellContext`column\[Bullet]5, 
                    4.6833}, {$CellContext`column\[Bullet]6, 
                    2.2977}, {$CellContext`column\[Bullet]7, 
                    8.6707}, {$CellContext`column\[Bullet]8, 
                    24.869}, {$CellContext`column\[Bullet]9, 39.804}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 9.809467684186798}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "9.809467684186798`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "507.65`"}, {
                    "column\[Bullet]3", "0.76836`"}, {
                    "column\[Bullet]4", "6.3921`"}, {
                    "column\[Bullet]5", "6.08`"}, {
                    "column\[Bullet]6", "4.8374`"}, {
                    "column\[Bullet]7", "12.295`"}, {
                    "column\[Bullet]8", "26.182`"}, {
                    "column\[Bullet]9", "37.883`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 9.809467684186798}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    507.65}, {$CellContext`column\[Bullet]3, 
                    0.76836}, {$CellContext`column\[Bullet]4, 
                    6.3921}, {$CellContext`column\[Bullet]5, 
                    6.08}, {$CellContext`column\[Bullet]6, 
                    4.8374}, {$CellContext`column\[Bullet]7, 
                    12.295}, {$CellContext`column\[Bullet]8, 
                    26.182}, {$CellContext`column\[Bullet]9, 37.883}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{7., 6.573920335659503}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "6.573920335659503`"}, {
                    "\"Observed\"", "7"}, {"column\[Bullet]1", "535.16`"}, {
                    "column\[Bullet]3", "0.3249`"}, {
                    "column\[Bullet]4", "5.3768`"}, {
                    "column\[Bullet]5", "5.0641`"}, {
                    "column\[Bullet]6", "2.5499`"}, {
                    "column\[Bullet]7", "8.9237`"}, {
                    "column\[Bullet]8", "25.047`"}, {
                    "column\[Bullet]9", "39.322`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 6.573920335659503}, {
                    "Observed", 7}, {$CellContext`column\[Bullet]1, 
                    535.16}, {$CellContext`column\[Bullet]3, 
                    0.3249}, {$CellContext`column\[Bullet]4, 
                    5.3768}, {$CellContext`column\[Bullet]5, 
                    5.0641}, {$CellContext`column\[Bullet]6, 
                    2.5499}, {$CellContext`column\[Bullet]7, 
                    8.9237}, {$CellContext`column\[Bullet]8, 
                    25.047}, {$CellContext`column\[Bullet]9, 39.322}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.235047595892908`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.235047595892908`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "482.03`"}, {
                    "column\[Bullet]3", "1.3671`"}, {
                    "column\[Bullet]4", "8.6916`"}, {
                    "column\[Bullet]5", "5.5778`"}, {
                    "column\[Bullet]6", "3.6361`"}, {
                    "column\[Bullet]7", "10.906`"}, {
                    "column\[Bullet]8", "24.312`"}, {
                    "column\[Bullet]9", "35.16`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.235047595892908`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    482.03}, {$CellContext`column\[Bullet]3, 
                    1.3671}, {$CellContext`column\[Bullet]4, 
                    8.6916}, {$CellContext`column\[Bullet]5, 
                    5.5778}, {$CellContext`column\[Bullet]6, 
                    3.6361}, {$CellContext`column\[Bullet]7, 
                    10.906}, {$CellContext`column\[Bullet]8, 
                    24.312}, {$CellContext`column\[Bullet]9, 35.16}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.585692821435819`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.585692821435819`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "546.08`"}, {
                    "column\[Bullet]3", "0.86053`"}, {
                    "column\[Bullet]4", "8.2416`"}, {
                    "column\[Bullet]5", "3.005`"}, {
                    "column\[Bullet]6", "6.7219`"}, {
                    "column\[Bullet]7", "15.683`"}, {
                    "column\[Bullet]8", "27.71`"}, {
                    "column\[Bullet]9", "41.967`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 12.585692821435819`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    546.08}, {$CellContext`column\[Bullet]3, 
                    0.86053}, {$CellContext`column\[Bullet]4, 
                    8.2416}, {$CellContext`column\[Bullet]5, 
                    3.005}, {$CellContext`column\[Bullet]6, 
                    6.7219}, {$CellContext`column\[Bullet]7, 
                    15.683}, {$CellContext`column\[Bullet]8, 
                    27.71}, {$CellContext`column\[Bullet]9, 41.967}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.612957792846926`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.612957792846926`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "478.1`"}, {
                    "column\[Bullet]3", "1.3527`"}, {
                    "column\[Bullet]4", "8.6401`"}, {
                    "column\[Bullet]5", "5.4848`"}, {
                    "column\[Bullet]6", "4.0197`"}, {
                    "column\[Bullet]7", "10.366`"}, {
                    "column\[Bullet]8", "24.363`"}, {
                    "column\[Bullet]9", "35.811`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.612957792846926`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    478.1}, {$CellContext`column\[Bullet]3, 
                    1.3527}, {$CellContext`column\[Bullet]4, 
                    8.6401}, {$CellContext`column\[Bullet]5, 
                    5.4848}, {$CellContext`column\[Bullet]6, 
                    4.0197}, {$CellContext`column\[Bullet]7, 
                    10.366}, {$CellContext`column\[Bullet]8, 
                    24.363}, {$CellContext`column\[Bullet]9, 35.811}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.495683632908746`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.495683632908746`"}, {
                    "\"Observed\"", "10.3`"}, {"column\[Bullet]1", "543"}, {
                    "column\[Bullet]3", "0.84787`"}, {
                    "column\[Bullet]4", "8.3698`"}, {
                    "column\[Bullet]5", "3.2232`"}, {
                    "column\[Bullet]6", "6.3927`"}, {
                    "column\[Bullet]7", "15.684`"}, {
                    "column\[Bullet]8", "26.848`"}, {
                    "column\[Bullet]9", "42.609`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.495683632908746`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    543}, {$CellContext`column\[Bullet]3, 
                    0.84787}, {$CellContext`column\[Bullet]4, 
                    8.3698}, {$CellContext`column\[Bullet]5, 
                    3.2232}, {$CellContext`column\[Bullet]6, 
                    6.3927}, {$CellContext`column\[Bullet]7, 
                    15.684}, {$CellContext`column\[Bullet]8, 
                    26.848}, {$CellContext`column\[Bullet]9, 42.609}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 9.072561316718103}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "9.072561316718103`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "143.11`"}, {
                    "column\[Bullet]3", "0.40296`"}, {
                    "column\[Bullet]4", "1.3237`"}, {
                    "column\[Bullet]5", "0.64428`"}, {
                    "column\[Bullet]6", "1.0514`"}, {
                    "column\[Bullet]7", "3.0034`"}, {
                    "column\[Bullet]8", "6.7439`"}, {
                    "column\[Bullet]9", "11.048`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 9.072561316718103}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    143.11}, {$CellContext`column\[Bullet]3, 
                    0.40296}, {$CellContext`column\[Bullet]4, 
                    1.3237}, {$CellContext`column\[Bullet]5, 
                    0.64428}, {$CellContext`column\[Bullet]6, 
                    1.0514}, {$CellContext`column\[Bullet]7, 
                    3.0034}, {$CellContext`column\[Bullet]8, 
                    6.7439}, {$CellContext`column\[Bullet]9, 11.048}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.04439797187587}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.04439797187587`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "543.88`"}, {
                    "column\[Bullet]3", "1.3812`"}, {
                    "column\[Bullet]4", "5.623`"}, {
                    "column\[Bullet]5", "3.3965`"}, {
                    "column\[Bullet]6", "6.0126`"}, {
                    "column\[Bullet]7", "13.757`"}, {
                    "column\[Bullet]8", "24.836`"}, {
                    "column\[Bullet]9", "41.74`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.04439797187587}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    543.88}, {$CellContext`column\[Bullet]3, 
                    1.3812}, {$CellContext`column\[Bullet]4, 
                    5.623}, {$CellContext`column\[Bullet]5, 
                    3.3965}, {$CellContext`column\[Bullet]6, 
                    6.0126}, {$CellContext`column\[Bullet]7, 
                    13.757}, {$CellContext`column\[Bullet]8, 
                    24.836}, {$CellContext`column\[Bullet]9, 41.74}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.763117090957133`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.763117090957133`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "546.51`"}, {
                    "column\[Bullet]3", "1.2991`"}, {
                    "column\[Bullet]4", "7.3685`"}, {
                    "column\[Bullet]5", "3.7206`"}, {
                    "column\[Bullet]6", "6.4331`"}, {
                    "column\[Bullet]7", "16.695`"}, {
                    "column\[Bullet]8", "26.379`"}, {
                    "column\[Bullet]9", "40.665`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.763117090957133`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    546.51}, {$CellContext`column\[Bullet]3, 
                    1.2991}, {$CellContext`column\[Bullet]4, 
                    7.3685}, {$CellContext`column\[Bullet]5, 
                    3.7206}, {$CellContext`column\[Bullet]6, 
                    6.4331}, {$CellContext`column\[Bullet]7, 
                    16.695}, {$CellContext`column\[Bullet]8, 
                    26.379}, {$CellContext`column\[Bullet]9, 40.665}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 12.663468412500565`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.663468412500565`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "536.68`"}, {
                    "column\[Bullet]3", "1.4521`"}, {
                    "column\[Bullet]4", "6.3842`"}, {
                    "column\[Bullet]5", "3.7362`"}, {
                    "column\[Bullet]6", "6.0247`"}, {
                    "column\[Bullet]7", "12.645`"}, {
                    "column\[Bullet]8", "24.301`"}, {
                    "column\[Bullet]9", "42.08`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.663468412500565`}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    536.68}, {$CellContext`column\[Bullet]3, 
                    1.4521}, {$CellContext`column\[Bullet]4, 
                    6.3842}, {$CellContext`column\[Bullet]5, 
                    3.7362}, {$CellContext`column\[Bullet]6, 
                    6.0247}, {$CellContext`column\[Bullet]7, 
                    12.645}, {$CellContext`column\[Bullet]8, 
                    24.301}, {$CellContext`column\[Bullet]9, 42.08}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{10.3, 11.75589834119916}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.75589834119916`"}, {
                    "\"Observed\"", "10.3`"}, {
                    "column\[Bullet]1", "548.12`"}, {
                    "column\[Bullet]3", "1.1934`"}, {
                    "column\[Bullet]4", "7.4775`"}, {
                    "column\[Bullet]5", "4.1336`"}, {
                    "column\[Bullet]6", "6.1911`"}, {
                    "column\[Bullet]7", "15.129`"}, {
                    "column\[Bullet]8", "28.879`"}, {
                    "column\[Bullet]9", "40.1`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.75589834119916}, {
                    "Observed", 10.3}, {$CellContext`column\[Bullet]1, 
                    548.12}, {$CellContext`column\[Bullet]3, 
                    1.1934}, {$CellContext`column\[Bullet]4, 
                    7.4775}, {$CellContext`column\[Bullet]5, 
                    4.1336}, {$CellContext`column\[Bullet]6, 
                    6.1911}, {$CellContext`column\[Bullet]7, 
                    15.129}, {$CellContext`column\[Bullet]8, 
                    28.879}, {$CellContext`column\[Bullet]9, 40.1}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 12.56330698715325}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "12.56330698715325`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "476.72`"}, {
                    "column\[Bullet]3", "2.0181`"}, {
                    "column\[Bullet]4", "6.0249`"}, {
                    "column\[Bullet]5", "4.8816`"}, {
                    "column\[Bullet]6", "5.7373`"}, {
                    "column\[Bullet]7", "13.676`"}, {
                    "column\[Bullet]8", "25.969`"}, {
                    "column\[Bullet]9", "42.807`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 12.56330698715325}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    476.72}, {$CellContext`column\[Bullet]3, 
                    2.0181}, {$CellContext`column\[Bullet]4, 
                    6.0249}, {$CellContext`column\[Bullet]5, 
                    4.8816}, {$CellContext`column\[Bullet]6, 
                    5.7373}, {$CellContext`column\[Bullet]7, 
                    13.676}, {$CellContext`column\[Bullet]8, 
                    25.969}, {$CellContext`column\[Bullet]9, 42.807}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 14.366898002411201`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.366898002411201`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "513.04`"}, {
                    "column\[Bullet]3", "1.1795`"}, {
                    "column\[Bullet]4", "11.01`"}, {
                    "column\[Bullet]5", "6.2992`"}, {
                    "column\[Bullet]6", "5.9536`"}, {
                    "column\[Bullet]7", "17.597`"}, {
                    "column\[Bullet]8", "24.377`"}, {
                    "column\[Bullet]9", "43.709`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.366898002411201`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    513.04}, {$CellContext`column\[Bullet]3, 
                    1.1795}, {$CellContext`column\[Bullet]4, 
                    11.01}, {$CellContext`column\[Bullet]5, 
                    6.2992}, {$CellContext`column\[Bullet]6, 
                    5.9536}, {$CellContext`column\[Bullet]7, 
                    17.597}, {$CellContext`column\[Bullet]8, 
                    24.377}, {$CellContext`column\[Bullet]9, 43.709}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 11.82669577091518}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "11.82669577091518`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "479.57`"}, {
                    "column\[Bullet]3", "1.6137`"}, {
                    "column\[Bullet]4", "6.5073`"}, {
                    "column\[Bullet]5", "4.5171`"}, {
                    "column\[Bullet]6", "5.2461`"}, {
                    "column\[Bullet]7", "13.349`"}, {
                    "column\[Bullet]8", "25.671`"}, {
                    "column\[Bullet]9", "43.178`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 11.82669577091518}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    479.57}, {$CellContext`column\[Bullet]3, 
                    1.6137}, {$CellContext`column\[Bullet]4, 
                    6.5073}, {$CellContext`column\[Bullet]5, 
                    4.5171}, {$CellContext`column\[Bullet]6, 
                    5.2461}, {$CellContext`column\[Bullet]7, 
                    13.349}, {$CellContext`column\[Bullet]8, 
                    25.671}, {$CellContext`column\[Bullet]9, 43.178}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 13.500825155682486`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "13.500825155682486`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "516.99`"}, {
                    "column\[Bullet]3", "1.4319`"}, {
                    "column\[Bullet]4", "9.6825`"}, {
                    "column\[Bullet]5", "5.6339`"}, {
                    "column\[Bullet]6", "5.4707`"}, {
                    "column\[Bullet]7", "18.345`"}, {
                    "column\[Bullet]8", "24.9`"}, {
                    "column\[Bullet]9", "44.029`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 13.500825155682486`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    516.99}, {$CellContext`column\[Bullet]3, 
                    1.4319}, {$CellContext`column\[Bullet]4, 
                    9.6825}, {$CellContext`column\[Bullet]5, 
                    5.6339}, {$CellContext`column\[Bullet]6, 
                    5.4707}, {$CellContext`column\[Bullet]7, 
                    18.345}, {$CellContext`column\[Bullet]8, 
                    24.9}, {$CellContext`column\[Bullet]9, 44.029}}, Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.2, 14.809114282405805`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.809114282405805`"}, {
                    "\"Observed\"", "14.2`"}, {
                    "column\[Bullet]1", "119.5`"}, {
                    "column\[Bullet]3", "0.35884`"}, {
                    "column\[Bullet]4", "1.9558`"}, {
                    "column\[Bullet]5", "1.0669`"}, {
                    "column\[Bullet]6", "2.0195`"}, {
                    "column\[Bullet]7", "3.7138`"}, {
                    "column\[Bullet]8", "5.4228`"}, {
                    "column\[Bullet]9", "10.293`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.809114282405805`}, {
                    "Observed", 14.2}, {$CellContext`column\[Bullet]1, 
                    119.5}, {$CellContext`column\[Bullet]3, 
                    0.35884}, {$CellContext`column\[Bullet]4, 
                    1.9558}, {$CellContext`column\[Bullet]5, 
                    1.0669}, {$CellContext`column\[Bullet]6, 
                    2.0195}, {$CellContext`column\[Bullet]7, 
                    3.7138}, {$CellContext`column\[Bullet]8, 
                    5.4228}, {$CellContext`column\[Bullet]9, 10.293}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 15.244405002868541`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "15.244405002868541`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "548.83`"}, {
                    "column\[Bullet]3", "1.0885`"}, {
                    "column\[Bullet]4", "9.4613`"}, {
                    "column\[Bullet]5", "6.25`"}, {
                    "column\[Bullet]6", "8.5286`"}, {
                    "column\[Bullet]7", "17.548`"}, {
                    "column\[Bullet]8", "26.191`"}, {
                    "column\[Bullet]9", "45.894`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    Grid[{{"Predicted", 15.244405002868541`}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    548.83}, {$CellContext`column\[Bullet]3, 
                    1.0885}, {$CellContext`column\[Bullet]4, 
                    9.4613}, {$CellContext`column\[Bullet]5, 
                    6.25}, {$CellContext`column\[Bullet]6, 
                    8.5286}, {$CellContext`column\[Bullet]7, 
                    17.548}, {$CellContext`column\[Bullet]8, 
                    26.191}, {$CellContext`column\[Bullet]9, 45.894}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 14.04001841495867}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.04001841495867`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "521.59`"}, {
                    "column\[Bullet]3", "1.2334`"}, {
                    "column\[Bullet]4", "8.0874`"}, {
                    "column\[Bullet]5", "8.1225`"}, {
                    "column\[Bullet]6", "8.0376`"}, {
                    "column\[Bullet]7", "21.222`"}, {
                    "column\[Bullet]8", "27.015`"}, {
                    "column\[Bullet]9", "40.157`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.04001841495867}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    521.59}, {$CellContext`column\[Bullet]3, 
                    1.2334}, {$CellContext`column\[Bullet]4, 
                    8.0874}, {$CellContext`column\[Bullet]5, 
                    8.1225}, {$CellContext`column\[Bullet]6, 
                    8.0376}, {$CellContext`column\[Bullet]7, 
                    21.222}, {$CellContext`column\[Bullet]8, 
                    27.015}, {$CellContext`column\[Bullet]9, 40.157}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 14.75401421892328}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "14.75401421892328`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "543.43`"}, {
                    "column\[Bullet]3", "1.0863`"}, {
                    "column\[Bullet]4", "8.3086`"}, {
                    "column\[Bullet]5", "5.6697`"}, {
                    "column\[Bullet]6", "8.4702`"}, {
                    "column\[Bullet]7", "18.159`"}, {
                    "column\[Bullet]8", "26.114`"}, {
                    "column\[Bullet]9", "45.312`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 14.75401421892328}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    543.43}, {$CellContext`column\[Bullet]3, 
                    1.0863}, {$CellContext`column\[Bullet]4, 
                    8.3086}, {$CellContext`column\[Bullet]5, 
                    5.6697}, {$CellContext`column\[Bullet]6, 
                    8.4702}, {$CellContext`column\[Bullet]7, 
                    18.159}, {$CellContext`column\[Bullet]8, 
                    26.114}, {$CellContext`column\[Bullet]9, 45.312}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ], 
                  TagBox[
                   TooltipBox[{
                    Opacity[0.], 
                    PointBox[{{14.4, 13.231504022432542`}}]}, 
                    TagBox[
                    
                    GridBox[{{"\"Predicted\"", "13.231504022432542`"}, {
                    "\"Observed\"", "14.4`"}, {
                    "column\[Bullet]1", "529.7`"}, {
                    "column\[Bullet]3", "0.79776`"}, {
                    "column\[Bullet]4", "7.8321`"}, {
                    "column\[Bullet]5", "7.2456`"}, {
                    "column\[Bullet]6", "8.2711`"}, {
                    "column\[Bullet]7", "21.125`"}, {
                    "column\[Bullet]8", "28.161`"}, {
                    "column\[Bullet]9", "40.084`"}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Right, "."}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, GridBoxDividers -> {"Columns" -> {{
                    GrayLevel[0.85]}}, "Rows" -> {{
                    GrayLevel[0.85]}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], 
                    "Grid"], TooltipDelay -> 0.15], Annotation[#, 
                    
                    Grid[{{"Predicted", 13.231504022432542`}, {
                    "Observed", 14.4}, {$CellContext`column\[Bullet]1, 
                    529.7}, {$CellContext`column\[Bullet]3, 
                    0.79776}, {$CellContext`column\[Bullet]4, 
                    7.8321}, {$CellContext`column\[Bullet]5, 
                    7.2456}, {$CellContext`column\[Bullet]6, 
                    8.2711}, {$CellContext`column\[Bullet]7, 
                    21.125}, {$CellContext`column\[Bullet]8, 
                    28.161}, {$CellContext`column\[Bullet]9, 40.084}}, 
                    Dividers -> {
                    GrayLevel[0.85], 
                    GrayLevel[0.85]}, Alignment -> {{Right, "."}, Baseline}], 
                    "Tooltip"]& ]}}, {}, {}, {}, {}}, AspectRatio -> 
               105./Dynamic[
                 DataModeler`DataModelerGUI`Private`optValue[
                 DataModeler`ModelReview`ModelSummaryTable, ImageSize]], 
               Axes -> {False, False}, AxesLabel -> {None, None}, 
               AxesOrigin -> {1.2772682008567209`, 1.2772682008567209`}, 
               DisplayFunction -> Identity, 
               Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
                  FormBox["\"Predicted\"", TraditionalForm], None}, {
                  FormBox["\"Observed\"", TraditionalForm], None}}, 
               FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}},
                GridLines -> {None, None}, GridLinesStyle -> Directive[
                 GrayLevel[0.5, 0.4]], ImagePadding -> All, ImageSize -> 500, 
               Method -> {
                "CoordinatesToolOptions" -> {"DisplayFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& ), "CopiedValueFunction" -> ({
                    (Identity[#]& )[
                    Part[#, 1]], 
                    (Identity[#]& )[
                    Part[#, 2]]}& )}}, 
               PlotRange -> {{1.1515225838636587`, 26.30064598247609}, {
                1.1515225838636587`, 26.30064598247609}}, PlotRangeClipping -> 
               True, PlotRangePadding -> {{0, 0}, {0, 0}}, Prolog -> {
                 RGBColor[0, 1, 0], 
                 Thickness[Medium], 
                 
                 LineBox[{{1.1515225838636587`, 1.1515225838636587`}, {
                  26.30064598247609, 26.30064598247609}}]}, 
               Ticks -> {Automatic, Automatic}], 
              RowBox[{"MedianAverage", "[", 
                RowBox[{
                  RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"6.56\"", 6.558527645565748, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.62\"", 36.618371875581836`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.5972434214759587, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.14\"", 41.135346220113384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.19\"", 2.1908135489152247`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.73\"", 0.7280268689895092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"117.25\"", 117.24727812838044`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.86\"", 0.8620951567752905, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"732.62\"", 732.6165153538162, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"0.91\"", 0.905359277852415, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"9\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.47\"", 3.4733768128077096`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.29\"", 2.2947176471822623`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7390571409205557`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    TagBox[
                    InterpretationBox[
                    "\"69.87\"", 69.87005969257898, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.76\"", 11.75663792584013, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.71\"", 1.7100848960685717`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.01\"", 1.0141153649569057`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.40\"", 0.40469052094093616`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"3.88\"", 3.882350562760903, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.03\"", 2.0321890071965854`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"63.36\"", 63.363724799250285`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"11.14\"", 11.135546219979584`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.28\"", 8.280454674605123, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5908371539294913, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.90\"", 0.8978305425889783, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"8.16\"", 8.159680560964581, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"4.01\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.04011738767128822, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"1\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.22\"", 5.224685491056446, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.23\"", 0.22854010099263636`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SuperscriptBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], "2"]}]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.2792678309107002, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.24783345853136146`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.82\"", 36.819424146231384`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.43\"", 0.42612172604868076`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"6.26\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.06256007839813221, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"44.23\"", 44.23179551124747, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"2.42\"", 2.4172135657118963`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.74\"", 1.7361891056524232`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.70\"", 0.7046357704345062, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"71.48\"", 71.48309026794081, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.51\"", 0.5056525266429981, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.62\"", 0.6158725575337699, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"38.91\"", 38.90598516721604, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    RowBox[{"(", 
                    RowBox[{
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False], "+", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], ")"}]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.49\"", 0.4907970088213184, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "+", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.28\"", 0.27543008176316136`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.88\"", 39.88006338431486, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"33.33\"", 33.33120471027875, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"3.89\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.038939420148409794`, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.18\"", 39.18371072963305, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"21.85\"", 21.8462052882725, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    TagBox[
                    InterpretationBox[
                    RowBox[{"\"9.88\"", "\[Times]", 
                    SuperscriptBox["10", "\"-2\""]}], 0.09875226201681911, 
                    AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], 
                    ")"}], " ", 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"0.34\"", 0.34137677056759286`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.71\"", 2.706173995605092, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.32\"", 1.3180494881255718`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.25\"", 0.2521102772782762, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"7\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"103.53\"", 103.53091868397507`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.70\"", 1.7044153746685882`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.44\"", 1.4351705392786716`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"39.01\"", 39.0054125568516, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.23\"", 36.22633469690617, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.13\"", 3.1346046653275597`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], "-", 
                    
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.57\"", 0.5661079421576403, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.97\"", 0.9736432501341529, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"41.46\"", 41.463770769155424`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]], "+", 
                    FractionBox[
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"14.13\"", 14.128156845155987`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"7.66\"", 7.6569380414546355`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.51\"", 1.505929605016708, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.99\"", 0.9897309759518025, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.10\"", 1.1043628156090113`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"36.25\"", 36.2535293671652, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}], ",", 
                    RowBox[{
                    RowBox[{"-", 
                    TagBox[
                    InterpretationBox[
                    "\"1.67\"", 1.6700752445202611`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                    "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.61\"", 1.6128394340247934`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"3\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "-", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.69\"", 0.6853465073594838, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"5\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[1, 2], 1, 
                    Rational[5, 6]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.32\"", 0.324592179540275, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"6\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]}], "+", 
                    RowBox[{
                    TagBox[
                    InterpretationBox[
                    "\"25.46\"", 25.461775420180842`, AutoDelete -> True], 
                    NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ], " ", 
                    
                    SqrtBox[
                    FractionBox[
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"4\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False], 
                    StyleBox[
                    TagBox[
                    FormBox[
                    SubscriptBox["\"column\[Bullet]\"", "\"8\""], 
                    TraditionalForm], TraditionalForm, Editable -> True], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]], StripOnInput -> False]]]}]}]}], "}"}], 
                  ",", 
                  TagBox[
                   InterpretationBox["\"0.70\"", 0.7, AutoDelete -> True], 
                   NumberForm[#, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]& ]}], 
                "]"}], TooltipDelay -> 0.15], Annotation[#, 
              
              DataModeler`DataExploration`MedianAverage[{-
                 NumberForm[
                  6.558527645565748, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  36.618371875581836`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], 
                NumberForm[
                 0.5972434214759587, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  41.135346220113384`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 2.1908135489152247`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.7280268689895092, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  117.24727812838044`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "9"]], 
                   Hue[
                    Rational[9, 10], 1, 
                    Rational[5, 6]]]), 
                NumberForm[
                 0.8620951567752905, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + (
                  NumberForm[
                   732.6165153538162, {8, 2}, 
                    ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "1"]], 
                   Hue[
                    Rational[1, 10], 1, 
                    Rational[5, 6]]]) Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  0.905359277852415, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "9"]], 
                  Hue[
                   Rational[9, 10], 1, 
                   Rational[5, 6]]], -
                 NumberForm[
                  3.4733768128077096`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  2.2947176471822623`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  1.7390571409205557`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  69.87005969257898, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )]/Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
                NumberForm[
                 11.75663792584013, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.7100848960685717`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  1.0141153649569057`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.40469052094093616`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], -
                 NumberForm[
                  3.882350562760903, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  2.0321890071965854`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  63.363724799250285`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 11.135546219979584`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  8.280454674605123, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.5908371539294913, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^2 - 
                NumberForm[
                 0.8978305425889783, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "8"]], 
                  Hue[
                   Rational[4, 5], 1, 
                   Rational[1, 2]]], 
                NumberForm[
                 8.159680560964581, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 0.04011738767128822, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "1"]], 
                  Hue[
                   Rational[1, 10], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  5.224685491056446, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] - 
                NumberForm[
                 0.22854010099263636`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^2, 
                NumberForm[
                 0.2792678309107002, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.24783345853136146`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  36.819424146231384`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.42612172604868076`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - (
                 NumberForm[
                  0.06256007839813221, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]) Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  44.23179551124747, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  2.4172135657118963`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.7361891056524232`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  0.7046357704345062, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  71.48309026794081, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.5056525266429981, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.6158725575337699, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]^Rational[1, 2] + 
                NumberForm[
                  38.90598516721604, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] ((Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] + Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]])/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 0.4907970088213184, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  0.27543008176316136`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                   Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  39.88006338431486, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  33.33120471027875, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                    Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  0.038939420148409794`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  39.18371072963305, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  21.8462052882725, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  0.09875226201681911, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]], -
                 NumberForm[
                  0.34137677056759286`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 2.706173995605092, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "3"]], 
                  Hue[
                   Rational[3, 10], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  1.3180494881255718`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  0.2521102772782762, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "7"]], 
                   Hue[
                    Rational[7, 10], 1, 
                    Rational[5, 6]]] + 
                NumberForm[
                  103.53091868397507`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  1.7044153746685882`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.4351705392786716`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  39.0054125568516, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  36.22633469690617, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]^Rational[1, 2]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), 
                NumberForm[
                 3.1346046653275597`, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] - 
                NumberForm[
                 0.5661079421576403, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  0.9736432501341529, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  41.463770769155424`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                    Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]) + 
                NumberForm[
                  14.128156845155987`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                   Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]]), -
                 NumberForm[
                  7.6569380414546355`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.505929605016708, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.9897309759518025, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "4"]], 
                  Hue[
                   Rational[2, 5], 1, 
                   Rational[1, 2]]] + 
                NumberForm[
                  1.1043628156090113`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  36.2535293671652, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2], -
                 NumberForm[
                  1.6700752445202611`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] + 
                NumberForm[
                  1.6128394340247934`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "3"]], 
                   Hue[
                    Rational[3, 10], 1, 
                    Rational[5, 6]]] - 
                NumberForm[
                 0.6853465073594838, {8, 2}, 
                  ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                  TraditionalForm[
                   Subscript["column\[Bullet]", "5"]], 
                  Hue[
                   Rational[1, 2], 1, 
                   Rational[5, 6]]] + 
                NumberForm[
                  0.324592179540275, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] Style[
                   TraditionalForm[
                    Subscript["column\[Bullet]", "6"]], 
                   Hue[
                    Rational[3, 5], 1, 
                    Rational[1, 2]]] + 
                NumberForm[
                  25.461775420180842`, {8, 2}, 
                   ExponentFunction -> (If[-2 < # < 8, Null, #]& )] (Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "4"]], 
                    Hue[
                    Rational[2, 5], 1, 
                    Rational[1, 2]]]/Style[
                    TraditionalForm[
                    Subscript["column\[Bullet]", "8"]], 
                    Hue[
                    Rational[4, 5], 1, 
                    Rational[1, 2]]])^Rational[1, 2]}, 
               NumberForm[
               0.7, {8, 2}, ExponentFunction -> (If[-2 < # < 8, Null, #]& )]],
               "Tooltip"]& ], ItemSize -> Automatic, StripOnInput -> False]}},
          AutoDelete -> False, BaselinePosition -> Center, FrameStyle -> 
         Directive[
           GrayLevel[0.85]], 
         GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
         GridBoxDividers -> {"Columns" -> {{None}}, "Rows" -> {{
              GrayLevel[0.85]}}}, 
         GridBoxFrame -> {"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}}, 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
         GridBoxItemStyle -> {"Columns" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}, 
           "Rows" -> {{
              Directive[
              FontFamily -> "Helvetica", FontSize -> 10, FontWeight -> 
               "Plain", FontSlant -> "Plain", FontColor -> GrayLevel[0]]}}}], 
        "Grid"], 
       StyleBox[
       "\"Ensemble 2 [Test] Summary Table\"", {
        FontWeight -> "Bold", FontSize -> 12, FontFamily -> "Helvetica", 
         FontSlant -> "Plain", FontColor -> GrayLevel[0], Background -> None, 
         ShowStringCharacters -> False}, StripOnInput -> False]}, "Labeled", 
      DisplayFunction -> (GridBox[{{
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}, {
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, 
        GridBoxItemSize -> {
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
        BaselinePosition -> {2, 1}]& ), 
      InterpretationFunction -> (RowBox[{"Labeled", "[", 
         RowBox[{#, ",", #2, ",", "Top"}], "]"}]& )]}, "RowDefault"]},
  "RowDefault"]], "Output",ExpressionUUID->"7b8988e5-6c51-4a1b-b209-\
155919a7a358"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 793},
WindowMargins->{{Automatic, 360}, {Automatic, 15}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ProjectTitleCell"->{
  Cell[580, 22, 132, 2, 98, "Title",ExpressionUUID->"65008252-a536-4032-bf6b-0f2d3999f7d3",
   CellTags->"ProjectTitleCell"]},
 "ProjectCommentsSectionCell"->{
  Cell[737, 28, 136, 3, 67, "Section",ExpressionUUID->"4f386c08-970b-4f00-aa3b-eedc4c5b4485",
   CellTags->"ProjectCommentsSectionCell"]},
 "Project Comment1"->{
  Cell[1146, 41, 105, 2, 35, "Text",ExpressionUUID->"a546ae76-15cb-40d5-9e10-ab8455b58f7c",
   CellTags->"Project Comment1"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ProjectTitleCell", 3275707, 71361},
 {"ProjectCommentsSectionCell", 3275867, 71364},
 {"Project Comment1", 3276029, 71367}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 132, 2, 98, "Title",ExpressionUUID->"65008252-a536-4032-bf6b-0f2d3999f7d3",
 CellTags->"ProjectTitleCell"],
Cell[CellGroupData[{
Cell[737, 28, 136, 3, 67, "Section",ExpressionUUID->"4f386c08-970b-4f00-aa3b-eedc4c5b4485",
 CellTags->"ProjectCommentsSectionCell"],
Cell[876, 33, 267, 6, 58, "Text",ExpressionUUID->"50191752-3b23-4624-8017-0455be3bebba"],
Cell[1146, 41, 105, 2, 35, "Text",ExpressionUUID->"a546ae76-15cb-40d5-9e10-ab8455b58f7c",
 CellTags->"Project Comment1"],
Cell[1254, 45, 152, 3, 30, "Input",ExpressionUUID->"abc1b738-fc2e-4679-a120-7db929e2c426"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1443, 53, 165, 3, 67, "Section",ExpressionUUID->"ae5868e3-34b6-4bdd-b003-99f0b3a12fb8"],
Cell[1611, 58, 35802, 720, 497, "Output",ExpressionUUID->"427e98a7-b165-4a1d-8e01-357994efb668"],
Cell[37416, 780, 286, 6, 35, "Text",ExpressionUUID->"cb060cfb-c65a-41de-85c6-494d727700ce"],
Cell[37705, 788, 58248, 1141, 508, "Output",ExpressionUUID->"dc8ef6f1-37cb-4247-a032-e2e66df42163"],
Cell[95956, 1931, 201, 3, 35, "Text",ExpressionUUID->"3362d0c1-ea83-4cb3-9240-ed9c58db8332"],
Cell[96160, 1936, 1237532, 27727, 714, "Output",ExpressionUUID->"4ff4e99c-56c7-4b01-a904-9bc6d402146f"],
Cell[1333695, 29665, 15270, 257, 43, "Output",ExpressionUUID->"87b84c20-1f46-44f7-a0e0-115fabf685c2"],
Cell[1348968, 29924, 636109, 14641, 348, "Output",ExpressionUUID->"1b7e6f2a-53d7-42da-95aa-9349362292c0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1985114, 44570, 159, 3, 67, "Section",ExpressionUUID->"c7c38725-8292-46f1-97ff-e961c28855e7"],
Cell[CellGroupData[{
Cell[1985298, 44577, 274, 4, 54, "Subsection",ExpressionUUID->"7d3197a6-c275-47d2-8c85-fd3a3414e939"],
Cell[1985575, 44583, 124752, 3337, 346, "Output",ExpressionUUID->"3c2a0422-75fa-4305-8ff6-46319856289b"],
Cell[2110330, 47922, 634265, 12789, 2384, "Output",ExpressionUUID->"65fdf5be-ca29-4758-bd13-9432f75d79f6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2744632, 60716, 175, 3, 54, "Subsection",ExpressionUUID->"243ff226-54b1-455a-8774-8d270485621d"],
Cell[2744810, 60721, 530544, 10624, 2196, "Output",ExpressionUUID->"7b8988e5-6c51-4a1b-b209-155919a7a358"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

