(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     51142,       1296]
NotebookOptionsPosition[     48362,       1244]
NotebookOutlinePosition[     48797,       1263]
CellTagsIndexPosition[     48754,       1260]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "White"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.726563774099002*^9, 3.7265638124328403`*^9}, 
   3.726564196402256*^9, {3.7450608264097023`*^9, 3.7450608270263567`*^9}},
 CellLabel->
  "In[163]:=",ExpressionUUID->"59e162bd-89b5-4caf-a8e1-a41d69ebaca3"],

Cell[TextData[{
 "\n\n",
 StyleBox["Support Vector Regression ", "Title"],
 "\n\nNative code, not from Mathematica. Note the maximizer is Differential \
Evolution. \n"
}], "Text",
 CellChangeTimes->{{3.745060831009235*^9, 
  3.745060885099642*^9}},ExpressionUUID->"7567b56a-a06d-41c3-8c2b-\
d9449386df7d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SupportVectorRegression", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"xm_", ",", "ym_"}], "}"}], ",", "K_", ",", "\[Epsilon]_", ",",
       "c_", ",", " ", "method_"}], "]"}], ":=", 
    RowBox[{"Module", "[", "\n", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "m", ",", "n", ",", "M", ",", "i", ",", "j", ",", "W", ",", "g", ",", 
        "vars", ",", "sol", ",", "b"}], "}"}], ",", "\n", "\n", 
      RowBox[{
       RowBox[{"m", "=", 
        RowBox[{"Length", "[", "ym", "]"}]}], ";", 
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"xm", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", "\n", 
       RowBox[{"M", "=", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"K", "[", 
            RowBox[{
             RowBox[{"xm", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", 
             RowBox[{"xm", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "m"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", "m"}], "}"}]}], "]"}], "+", 
         RowBox[{
          RowBox[{"1", "/", "c"}], " ", 
          RowBox[{"IdentityMatrix", "[", "m", "]"}]}]}]}], ";", "\n", 
       RowBox[{"W", "=", 
        RowBox[{
         RowBox[{
          UnderoverscriptBox["\[Sum]", 
           RowBox[{"i", "=", "1"}], "m"], 
          RowBox[{
           RowBox[{"Subscript", "[", 
            RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], 
           RowBox[{"ym", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}]}], "-", 
         RowBox[{"\[Epsilon]", " ", 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"i", "=", "1"}], "m"], 
           RowBox[{"Abs", "[", 
            RowBox[{"Subscript", "[", 
             RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], "]"}]}]}], "-", 
         RowBox[{
          RowBox[{"1", "/", "2"}], " ", 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"i", "=", "1"}], "m"], 
           RowBox[{
            UnderoverscriptBox["\[Sum]", 
             RowBox[{"j", "=", "1"}], "m"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Subscript", "[", 
               RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], " ", 
              RowBox[{"Subscript", "[", 
               RowBox[{"\[Alpha]", ",", " ", "j"}], "]"}], " ", 
              RowBox[{"M", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ")"}]}]}]}]}]}], ";",
        "\n", 
       RowBox[{"g", "=", 
        RowBox[{"Apply", "[", 
         RowBox[{"And", ",", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "c"}], "<", 
               RowBox[{"Subscript", "[", 
                RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], "<=", "c"}], ",", 
              
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", "m"}], "}"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                UnderoverscriptBox["\[Sum]", 
                 RowBox[{"i", "=", "1"}], "m"], 
                RowBox[{"Subscript", "[", 
                 RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}]}], "==", "0"}], 
              ")"}], "}"}]}], "]"}]}], "]"}]}], ";", "\n", "\n", 
       RowBox[{"vars", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Subscript", "[", 
           RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", "m"}], "}"}]}], "]"}]}], ";", "\n", 
       RowBox[{"sol", "=", 
        RowBox[{
         RowBox[{"NMaximize", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"W", ",", "g"}], "}"}], ",", "vars", ",", 
           RowBox[{"Method", "->", "method"}]}], "]"}], "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"b", "=", 
        RowBox[{
         RowBox[{"1", "/", "m"}], " ", 
         RowBox[{"Apply", "[", 
          RowBox[{"Plus", ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"ym", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], "-", 
                RowBox[{
                 UnderoverscriptBox["\[Sum]", 
                  RowBox[{"i", "=", "1"}], "m"], 
                 RowBox[{
                  RowBox[{"Subscript", "[", 
                   RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], 
                  RowBox[{"K", "[", 
                   RowBox[{
                    RowBox[{"xm", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    RowBox[{"xm", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}]}], "-", 
                "\[Epsilon]", "-", 
                RowBox[{
                 RowBox[{"Subscript", "[", 
                  RowBox[{"\[Alpha]", ",", " ", "j"}], "]"}], "/", "c"}]}], 
               ")"}], "/.", "sol"}], ",", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", "m"}], "}"}]}], "]"}]}], "]"}]}]}], 
       ";", "\n", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             UnderoverscriptBox["\[Sum]", 
              RowBox[{"i", "=", "1"}], "m"], 
             RowBox[{
              RowBox[{"Subscript", "[", 
               RowBox[{"\[Alpha]", ",", " ", "i"}], "]"}], 
              RowBox[{"K", "[", 
               RowBox[{
                RowBox[{"xm", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], ",", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"Subscript", "[", 
                   RowBox[{"x", ",", " ", "j"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"j", ",", "1", ",", "n"}], "}"}]}], "]"}]}], 
               "]"}]}]}], "+", "b"}], ")"}], "/.", "sol"}], ",", 
         RowBox[{"vars", "/.", "sol"}], ",", "M", ",", "  ", "W", ",", " ", 
         "g", ",", "vars", ",", "sol", ",", "b"}], "}"}]}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"waveletKernel", "[", 
    RowBox[{"u_", ",", "v_"}], "]"}], ":=", 
   RowBox[{
    UnderoverscriptBox["\[Product]", 
     RowBox[{"i", "=", "1"}], 
     RowBox[{"Length", "[", "u", "]"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Cos", "[", 
       RowBox[{"1.75", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"u", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "-", 
           RowBox[{"v", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ")"}], "/", "a"}]}], "]"}], " ", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"u", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "-", 
             RowBox[{"v", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ")"}], "^", "2"}], ")"}]}], 
        "/", 
        RowBox[{"(", 
         RowBox[{"2", "*", 
          RowBox[{"a", "^", "2"}]}], ")"}]}], "]"}]}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"rbfKernel", "[", 
    RowBox[{"x_", ",", "z_"}], "]"}], ":=", 
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"x", "-", "z"}], ")"}], ".", 
      RowBox[{"(", 
       RowBox[{"x", "-", "z"}], ")"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"polyKernel", "[", 
    RowBox[{"x_", ",", "z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"e", "+", 
      RowBox[{"x", ".", "z"}]}], ")"}], "^", "d"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"vovkKernel", "[", 
    RowBox[{"x_", ",", "z_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"x", ".", "z"}]}], ")"}], "^", 
    RowBox[{"-", "d"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"fourierKernel", "[", 
    RowBox[{"x_", ",", "z_"}], "]"}], ":=", 
   RowBox[{
    UnderoverscriptBox["\[Product]", 
     RowBox[{"i", "=", "1"}], 
     RowBox[{"Length", "[", "x", "]"}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"q", "^", "2"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"2", " ", "q", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "-", 
            RowBox[{"z", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "+", 
         RowBox[{"q", "^", "2"}]}], ")"}]}], ")"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.745057258792245*^9, 3.74505726830757*^9}},
 CellLabel->"In[28]:=",ExpressionUUID->"a831c5f8-d5a5-4c96-8ce6-ea7370700e27"],

Cell[TextData[{
 "\n",
 StyleBox["Data", "Title"],
 "\n\n"
}], "Text",
 CellChangeTimes->{{3.745060890668942*^9, 
  3.745060892805798*^9}},ExpressionUUID->"edb8dba2-3038-4b29-8c27-\
1e1e61e56946"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"testdata", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", 
        "\"\<aggregatefeaturesConorTest.csv\>\""}], "}"}], "]"}], ",", 
     "\"\<CSV\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", 
        "\"\<aggregatefeaturesConorTrain.csv\>\""}], "}"}], "]"}], ",", 
     "\"\<CSV\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "data"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "testdata"}]}], "Input",
 CellLabel->"In[8]:=",ExpressionUUID->"3e8c615e-54ea-4b1c-9485-664b4354e979"],

Cell[BoxData["68"], "Output",
 CellChangeTimes->{3.7450573281519623`*^9},
 CellLabel->"Out[10]=",ExpressionUUID->"86116eae-1a3a-4e1c-a2a6-eef6014001b1"],

Cell[BoxData["67"], "Output",
 CellChangeTimes->{3.7450573281553307`*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"0cc828a7-1d97-446e-b567-2288533c2a94"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Regression", "Title"]
}], "Text",
 CellChangeTimes->{{3.745061067330772*^9, 
  3.7450610688717613`*^9}},ExpressionUUID->"bdf245a2-4c97-41be-be3a-\
52bef0079c0b"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"input", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#", ",", "1"}], "]"}], "&"}], ",", "data"}], "]"}]}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"output", "=", 
     RowBox[{"0.3", "*", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"First", "@", "#"}], "&"}], ",", "data"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"testinput", "=", 
     RowBox[{"Map", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"#", ",", "1"}], "]"}], "&"}], ",", "testdata"}], "]"}]}], 
    ";", 
    RowBox[{"testoutput", "=", 
     RowBox[{"0.3", "*", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"First", "@", "#"}], "&"}], ",", "testdata"}], "]"}]}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.7450573884490643`*^9, 3.745057396987123*^9}, {
  3.7450574553193817`*^9, 3.745057482848557*^9}, {3.745057524689609*^9, 
  3.745057546693554*^9}, {3.745058010770935*^9, 3.7450580705253143`*^9}, {
  3.745058797604311*^9, 3.745058803513878*^9}, {3.74505922782339*^9, 
  3.745059236912661*^9}},
 CellLabel->
  "In[119]:=",ExpressionUUID->"a17c0c00-78d4-4ad7-9fbb-f69f5af4700f"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
    "some", " ", "experimentation", " ", "needed", " ", "to", " ", "find", 
     " ", "the", " ", "optimum", " ", "values"}], ",", " ", 
    RowBox[{
    "but", " ", "we", " ", "could", " ", "use", " ", "another", " ", "search",
      " ", "optimized", " ", "on", " ", "top", " ", "to", " ", "do", " ", 
     "just", " ", "that"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"epsilon", "=", "0.0025"}], ";", 
    RowBox[{"c", "=", "200.0"}], ";", 
    RowBox[{"a", " ", "=", "14"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"method", "=", "\"\<DifferentialEvolution\>\""}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"there", " ", "are", " ", "many", " ", "more", " ", "kernels"}], 
     ",", " ", 
     RowBox[{
     "there", " ", "is", " ", "an", " ", "entire", " ", "theory", " ", "for", 
      " ", "kernels", " ", "in", " ", 
      RowBox[{"math", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"kernel", "=", "waveletKernel"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Note", " ", 
     RowBox[{"{", 
      RowBox[{"input", ",", "output"}], "}"}], " ", "was", " ", "used", " ", 
     "corresponding", " ", "to", " ", "training", " ", "data"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"F", "=", 
     RowBox[{"SupportVectorRegression", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"input", ",", "output"}], "}"}], ",", "kernel", ",", 
       "epsilon", ",", "c", ",", "method"}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.7450574462524767`*^9, 3.745057446859132*^9}, {
   3.745057557336924*^9, 3.7450575899393272`*^9}, 3.745058852281537*^9, 
   3.745059036828863*^9, {3.745059071007497*^9, 3.745059078902989*^9}, 
   3.7450592671760473`*^9, 3.745060206343998*^9, {3.745060302318562*^9, 
   3.745060327978693*^9}, {3.745060393715119*^9, 3.7450603938822317`*^9}, 
   3.745060593833905*^9, {3.745060906083473*^9, 3.745060933239382*^9}, {
   3.745061036056507*^9, 3.745061053054122*^9}, {3.745061287048671*^9, 
   3.7450613121122513`*^9}},ExpressionUUID->"1b607cdc-eaa5-4a07-9a99-\
5f281e96849a"],

Cell[TextData[{
 "\n",
 StyleBox["Quadratic Kernel Regression ", "Title"]
}], "Text",
 CellChangeTimes->{{3.745060940496131*^9, 
  3.745060973447253*^9}},ExpressionUUID->"8b63a347-f95d-4482-ad40-\
d3197562af57"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "[", 
  RowBox[{
   RowBox[{"F", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", "20"}], "]"}]], "Input",
 CellChangeTimes->{
  3.745057807107708*^9, {3.745057851306018*^9, 3.745057899130251*^9}, 
   3.7450606559365377`*^9, 3.7450607612028313`*^9},
 CellLabel->
  "In[158]:=",ExpressionUUID->"1e2b00e2-43df-495c-ae41-86f462a62e2f"],

Cell[BoxData[
 TagBox[
  RowBox[{"99.42630094310859`", "\[VeryThinSpace]", "-", 
   RowBox[{"112.4399414841167`", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        SubsuperscriptBox["x", "1", "2"], "392"]}], "-", 
      FractionBox[
       SubsuperscriptBox["x", "2", "2"], "392"], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"0.17126`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "3"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"0.79574`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "4"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"0.1713`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "5"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1.937`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "6"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"5.2538`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "7"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"9.5958`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "8"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"2.9`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "9"]}], ")"}], "2"]}]}]], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      SubscriptBox["x", "1"]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      SubscriptBox["x", "2"]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"0.17126`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "3"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"0.79574`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "4"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"0.1713`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "5"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"1.937`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "6"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"5.2538`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "7"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"9.5958`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "8"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"2.9`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "9"]}], ")"}]}], "]"}]}], "+", 
   RowBox[{"\[LeftSkeleton]", "97", "\[RightSkeleton]"}], "+", 
   RowBox[{"47.60637053860282`", " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        SubsuperscriptBox["x", "1", "2"], "392"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"3.8839`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "2"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"11.141`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "3"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"7.9125`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "4"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"8.64`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "5"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"12.952`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "6"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"20.093`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "7"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"44.913`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "8"]}], ")"}], "2"]}], "-", 
      RowBox[{
       FractionBox["1", "392"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"22.2`", "\[VeryThinSpace]", "-", 
          SubscriptBox["x", "9"]}], ")"}], "2"]}]}]], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      SubscriptBox["x", "1"]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"3.8839`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "2"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"11.141`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "3"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"7.9125`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "4"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"8.64`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "5"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"12.952`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "6"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"20.093`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "7"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"44.913`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "8"]}], ")"}]}], "]"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"0.125`", " ", 
      RowBox[{"(", 
       RowBox[{"22.2`", "\[VeryThinSpace]", "-", 
        SubscriptBox["x", "9"]}], ")"}]}], "]"}]}]}],
  Short[#, 20]& ]], "Output",
 CellChangeTimes->{{3.745057852145699*^9, 3.7450578994578533`*^9}, 
   3.745058977096122*^9, 3.745059154583843*^9, 3.7450600776561728`*^9, 
   3.7450602819537153`*^9, 3.7450603829345827`*^9, {3.7450607574577312`*^9, 
   3.745060761489923*^9}},
 CellLabel->
  "Out[158]//Short=",ExpressionUUID->"d3e81ff9-b616-4783-b804-7a12f4314c9d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"en", ".", "wikipedia", ".", "org"}], "/", "wiki"}], "/", 
      "Coefficient_of"}], "_determination"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"rSQUARED", "[", 
     RowBox[{"y_", ",", "yhat_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"ybar", ",", "SStot", ",", "SSreg", ",", "SSres"}], "}"}], ",",
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ybar", "=", 
        RowBox[{"Mean", "@", "y"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"SStot", "=", 
        RowBox[{"Total", "@", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "-", "ybar"}], ")"}], "^", "2"}], "&"}], ",", 
           "y"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"SSreg", "=", 
        RowBox[{"Total", "@", 
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "-", "ybar"}], ")"}], "^", "2"}], "&"}], ",", 
           "yhat"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"SSres", "=", 
        RowBox[{"Total", "@", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "-", 
              RowBox[{"yhat", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], ")"}], "^", "2"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "y"}]}], "}"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"1", "-", 
        RowBox[{"(", 
         RowBox[{"SSres", "/", "SStot"}], ")"}]}]}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{3.74505796175913*^9},
 CellLabel->"In[51]:=",ExpressionUUID->"a667bef6-06a8-48f0-bc54-adcfc19b85d6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rSQUARED", "[", 
  RowBox[{"testoutput", " ", ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"F", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "/.", 
      RowBox[{"(", 
       RowBox[{"Flatten", "@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Subscript", "[", 
             RowBox[{"x", ",", "j"}], "]"}], "->", 
            RowBox[{
             RowBox[{"testinput", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"Length", "@", 
             RowBox[{"(", 
              RowBox[{"testinput", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ")"}]}]}], "}"}]}], "]"}]}], 
       ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "testinput"}]}], "}"}]}], "]"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.745058098600264*^9, 3.745058213470421*^9}, {
  3.745058315049027*^9, 3.7450583791204967`*^9}, {3.745058422489977*^9, 
  3.745058427584139*^9}, {3.7450586871958017`*^9, 3.745058700660425*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"de077d0b-63e9-4e95-8ed8-8ff5f0c84b91"],

Cell[BoxData["0.9359990167336184`"], "Output",
 CellChangeTimes->{
  3.745058385516327*^9, 3.745058439870469*^9, {3.7450586900884027`*^9, 
   3.745058701932995*^9}, 3.745059181831388*^9, 3.745060084440893*^9, 
   3.745060285655945*^9, 3.745060387802706*^9, 3.7450605876069*^9, 
   3.745060766434866*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"8aa09c54-1d80-41cb-84e5-b22a372a969a"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["SVR", "Title"]
}], "Text",
 CellChangeTimes->{{3.7450609933100233`*^9, 
  3.745060995655211*^9}},ExpressionUUID->"99bcf54e-710e-468d-8beb-\
0a9b37a303e8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"svr", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"F", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "/.", 
     RowBox[{"(", 
      RowBox[{"Flatten", "@", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Subscript", "[", 
            RowBox[{"x", ",", "j"}], "]"}], "->", 
           RowBox[{
            RowBox[{"testinput", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "[", 
            RowBox[{"[", "j", "]"}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Length", "@", 
            RowBox[{"(", 
             RowBox[{"testinput", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ")"}]}]}], "}"}]}], "]"}]}], 
      ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "@", "testinput"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.745061099227271*^9, 3.74506110126159*^9}},
 CellLabel->
  "In[164]:=",ExpressionUUID->"46f196ab-9d64-4a7b-b25c-0ecbb5a2da29"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "95.29820595050776`", ",", "98.87332412364586`", ",", "92.6767660478315`", 
   ",", "97.45775077612247`", ",", "90.74242957201557`", ",", 
   "107.89776592715661`", ",", "97.38883949663112`", ",", 
   "104.94352718752164`", ",", "35.51612919814661`", ",", 
   "131.29521811568515`", ",", "149.33511368492424`", ",", 
   "136.62068991360928`", ",", "148.47373737831768`", ",", 
   "112.92336145968862`", ",", "147.1729821612471`", ",", "111.469601232147`",
    ",", "143.88721850036242`", ",", "30.49316313606964`", ",", 
   "117.88081234727679`", ",", "120.45236351219769`", ",", 
   "114.87078375341287`", ",", "120.21876970965143`", ",", 
   "104.7227784284059`", ",", "128.40948192915556`", ",", 
   "103.09647975570665`", ",", "129.83027827533806`", ",", 
   "44.99772955671989`", ",", "126.38253787144603`", ",", 
   "124.31039942991876`", ",", "126.94652158598586`", ",", 
   "124.70142244882828`", ",", "104.89214002800426`", ",", "98.455199421593`",
    ",", "104.25425646122326`", ",", "101.50189831290187`", ",", 
   "23.624189786254142`", ",", "115.98155340110117`", ",", 
   "110.20473564031275`", ",", "118.89822902923665`", ",", 
   "106.30213158125139`", ",", "159.60744255738018`", ",", 
   "126.48256739281433`", ",", "149.39079287581248`", ",", 
   "131.65284786692544`", ",", "39.70224146321489`", ",", 
   "155.43679437886095`", ",", "157.83973187058965`", ",", 
   "155.11569660645898`", ",", "154.1127178099957`", ",", 
   "131.3767228890988`", ",", "158.15422521646533`", ",", 
   "135.73104147456246`", ",", "160.14071760522376`", ",", 
   "42.711312830097334`", ",", "151.74586219800665`", ",", 
   "155.39239075548045`", ",", "152.9557568416297`", ",", 
   "155.94134821294926`", ",", "143.55802586959248`", ",", 
   "155.6060673031925`", ",", "141.2670544659655`", ",", "159.4238390434567`",
    ",", "34.78465935090165`", ",", "157.02256130383284`", ",", 
   "154.43265351897742`", ",", "157.66488139769118`", ",", 
   "155.96876679310552`"}], "}"}]], "Output",
 CellChangeTimes->{3.745060813427517*^9, 3.745061105465019*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"8666e2ee-9bc0-4b8f-931b-3bdad3272937"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Test Data ", "Title"]
}], "Text",
 CellChangeTimes->{{3.745061086670128*^9, 
  3.745061088593001*^9}},ExpressionUUID->"660b5ee4-51fc-46b3-a104-\
643738459c93"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "testoutput"}]], "Input",
 CellChangeTimes->{{3.745060807500684*^9, 3.745060807600197*^9}},
 CellLabel->
  "In[161]:=",ExpressionUUID->"ec2ba2e2-dc32-4cf3-bab1-5e55feba7e13"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "105.285`", ",", "98.48700000000001`", ",", "106.056`", ",", "97.68`", ",", 
   "85.692`", ",", "100.008`", ",", "84.093`", ",", "101.265`", ",", 
   "25.4403`", ",", "144.399`", ",", "150.855`", ",", "144.438`", ",", 
   "151.266`", ",", "134.718`", ",", "147.012`", ",", "132.93`", ",", 
   "145.314`", ",", "36.903`", ",", "118.689`", ",", "128.703`", ",", 
   "115.053`", ",", "127.07699999999998`", ",", "114.741`", ",", 
   "125.38799999999999`", ",", "115.767`", ",", "129.66299999999998`", ",", 
   "31.392`", ",", "119.136`", ",", "127.644`", ",", "117.321`", ",", 
   "127.88099999999999`", ",", "95.32799999999999`", ",", "106.266`", ",", 
   "92.81099999999999`", ",", "106.377`", ",", "24.1647`", ",", "110.442`", 
   ",", "107.679`", ",", "110.41799999999999`", ",", "107.643`", ",", 
   "136.776`", ",", "156.867`", ",", "134.88`", ",", "153.858`", ",", 
   "42.519`", ",", "148.422`", ",", "160.77899999999997`", ",", "152.295`", 
   ",", "160.54799999999997`", ",", "144.60899999999998`", ",", "163.824`", 
   ",", "143.43`", ",", "162.9`", ",", "42.933`", ",", "163.164`", ",", 
   "163.953`", ",", "161.004`", ",", "164.436`", ",", "143.016`", ",", 
   "153.91199999999998`", ",", "143.87099999999998`", ",", "155.097`", ",", 
   "35.85`", ",", "164.649`", ",", "156.477`", ",", "163.02899999999997`", 
   ",", "158.91`"}], "}"}]], "Output",
 CellChangeTimes->{{3.7450608025217752`*^9, 3.745060808036933*^9}},
 CellLabel->
  "Out[161]=",ExpressionUUID->"963f8673-94f8-405b-9128-1a9a4cdfa71d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"svr", ",", "testoutput"}], "}"}], ",", " ", 
   RowBox[{"PlotLegends", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<SVR\>\"", ",", "\"\<Test Data\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7450611079647923`*^9, 3.7450611599084873`*^9}},
 CellLabel->
  "In[167]:=",ExpressionUUID->"a128acc1-d524-4a9b-89ad-860208f505b1"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{}, {}, {
        Hue[0.67, 0.6, 0.6], 
        Directive[
         PointSize[
          NCache[
           Rational[1, 72], 0.013888888888888888`]], 
         RGBColor[0.368417, 0.506779, 0.709798], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJw1k3sslXEYx0/qj2bomHA6o+M2U8xyyzW+HA6O29lpCQeH42izEeMYRZxm
NJpLmU0KbbZGurjs5JLckqYVS6sxoenQrImyRqHb+j3v9u7d5/f57ft7nud9
X0tFpjRVh8PhCP/e/57/rw2/ac+0SeM3Z8EWcDFvvkLbE8P4IDqaKqwk9uS5
KBevToQlkD+M7RnpVsnDaMY85Nh6/Fb9iGNsBoHMYGgphvZbQCOdG1L4kLdC
jqi0lDvqz9gGg/uEGdlpSYxtYXXnDPruKhjbwWTPtPO9UTLj46iMEc/ZVZN3
wNZ6WxzPO56xIyzalwzLU8mfgLbq9Df9BRljJ0yd1+cpdynPGXr7czf8inwZ
u+BDwrCXPD+BsSuedJmUbZolMnbDdtfzz/09dN5JPDZql3IMyLvjElfFCXCk
fj3wbnjmAl+f+vOE+WJ6n8N4LGMvcJYHW655kfdGq6NNg6ZYxNgHK28F6oJ6
OeNTeKB3vW7eiNgXZk6iqdoBYj+obuzwtQ7EwPiXwmmeJ6tHDTR4juxaNtL7
8YdulnYgiEveH07fj/AFSVRfALJzF1ZeNLszHwAVZM9e/6L+hdBZKEnhV7L5
qoVY9bhVV9hH8wsE16ZbEF1L+YHoGJPbZ22mMB8Er5oYxVITq1cdhJ2WQ0mX
7ymYF6HtkZulVsXmoxahwUWm93FWyHww+OWuHj8zWJ46GGvOcuPFfsoPwW5z
4kR3CvkQ5OUkK24KyYeiQ/eYuUE65Ydir7E3bX2MvBhFdqadyi3yYujqu42q
DyiZD4O1X3G4niyI+TDE55/jL2xR/eGQjhjkVaXT+eEQu8ur645SfgQK60PL
BEXkI8C7Yhg795W+z0gkvfT/pMwhHwlp16Tmaiv5KAhfLZvUrJGPwliUpidT
Sf+XBMNPC6Z7bzMPCXwkTuEzEbRfgvuxcRqRhvGwBLP97tac4hT8AVaRGeU=

         "]]}, {
        Hue[0.9060679774997897, 0.6, 0.6], 
        Directive[
         PointSize[
          NCache[
           Rational[1, 72], 0.013888888888888888`]], 
         RGBColor[0.880722, 0.611041, 0.142051], 
         AbsoluteThickness[1.6]], 
        LineBox[CompressedData["
1:eJw1k3tIk2EUxoeUWIywCzJKYonJXJGZLl1r7dnmpnPOLTFatmptClFWUmEX
RL4hEhFDpKTIQiQqCsF/ulEhUmJFBRVSf5gYRNRQS4miC0Xv63vOB2M83+98
533O5V0RO1jTkKbT6dziJ//VM+2Y//Zyk72mDvQC9336tFU9YdIZGMtNT3S1
Mc/E5Oa7y9v3MV8Ch2XnPV/jFtIGJM8dWNSm20Y6G896Pbe/zWVuRH6k4+H3
EPMcDO8v1u40WUnnovbDle4hfYx0HkS0KTLK2oQHR84Y5ixgbVbnfWa9Gh9f
5oz+ehMlvQY3Zl4HYlHma/HDJAxcYl4IaV9vZr5O1XvYRboIe+WBfTtIF+OV
SN+axd9bkNGXXVf/KEJ6PfoP7emcGtpFugSJLvfpxn7mpRDd+DsSZm6F6PbJ
rBnmG/D12rC/xML5bSicPcBBeiNimWHrzSfsx45pGZ/ifJuQLg+sZe7AdVn/
T+ZA76yBrUprwLICUXEnz9cJafdTEXMn5DiM55m7cOvq8cf55lLiLjX/i9uJ
u/G7VXRsguI1N+R4Bi8wL8O/kWOpvBTzMnilHcNu4h6I4poHuuPEPZDrYnrH
/fCq/DbmXowHxQa4PMTLIctJJGPEy9U8DPXEK2CXCz+Pv6+AbN+phcx9kOEt
i/l7H760iApPMK9U+zNFfrVKvHgunghzv5r3UfKj+SHTORqYV6n9aSWtVan+
GpkH1H1JMg+o/X7P/alG80DP0gI7+6+GWA7b+B/mQTyVAXHmQeVv0kk8pO7X
WcqPEFbKheng+JDqV5T4YAjtE+LCj8XxHwxsI6c=
         "]]}}}, {}, {}, {}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0., 0}, 
     PlotRange -> {{0., 67.}, {0, 164.649}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {True, True}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0., 0}, DisplayFunction :> 
     Identity, Frame -> {{False, False}, {False, False}}, 
     FrameLabel -> {{None, None}, {None, None}}, 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     GridLines -> {None, None}, GridLinesStyle -> Directive[
       GrayLevel[0.5, 0.4]], 
     Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{0., 67.}, {0, 164.649}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.02]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{"\"SVR\"", "\"Test Data\""}, "LineLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[
                    NCache[
                    Rational[1, 4], 0.25]], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[
                    NCache[
                    Rational[1, 4], 0.25]], 
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #}, {
                   GraphicsBox[{{
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[
                    NCache[
                    Rational[1, 4], 0.25]], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {
                    LineBox[{{0, 10}, {20, 10}}]}}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[
                    NCache[
                    Rational[1, 4], 0.25]], 
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    AbsoluteThickness[1.6]], {}}}, AspectRatio -> Full, 
                    ImageSize -> {20, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.1] -> Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontFamily -> "Arial"}, Background -> Automatic, StripOnInput -> 
         False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"LineLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.368417`", ",", "0.506779`", ",", "0.709798`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}], 
               ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", 
                    FractionBox["1", "72"], "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    StyleBox[
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.880722`", ",", "0.611041`", ",", "0.142051`"}],
                     "]"}], NumberMarks -> False]], Appearance -> None, 
                    BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}]}], "]"}]}],
              "}"}], ",", 
           RowBox[{"{", 
             RowBox[{#, ",", #2}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"True", ",", "True"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", 
             RowBox[{"{", "}"}]}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.7450611236734867`*^9, 3.745061160561198*^9}},
 CellLabel->
  "Out[167]=",ExpressionUUID->"e2fcd788-492b-47e7-bd1e-42a7229544e9"]
}, Open  ]]
},
WindowSize->{928, 926},
WindowMargins->{{Automatic, 496}, {Automatic, 13}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
Background->GrayLevel[1],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1216, 31, 94, "Input",ExpressionUUID->"59e162bd-89b5-4caf-a8e1-a41d69ebaca3"],
Cell[1777, 53, 305, 8, 189, "Text",ExpressionUUID->"7567b56a-a06d-41c3-8c2b-d9449386df7d"],
Cell[2085, 63, 9199, 258, 761, "Input",ExpressionUUID->"a831c5f8-d5a5-4c96-8ce6-ea7370700e27"],
Cell[11287, 323, 196, 7, 143, "Text",ExpressionUUID->"edb8dba2-3038-4b29-8c27-1e1e61e56946"],
Cell[CellGroupData[{
Cell[11508, 334, 872, 23, 94, "Input",ExpressionUUID->"3e8c615e-54ea-4b1c-9485-664b4354e979"],
Cell[12383, 359, 152, 2, 34, "Output",ExpressionUUID->"86116eae-1a3a-4e1c-a2a6-eef6014001b1"],
Cell[12538, 363, 152, 2, 34, "Output",ExpressionUUID->"0cc828a7-1d97-446e-b567-2288533c2a94"]
}, Open  ]],
Cell[12705, 368, 195, 6, 97, "Text",ExpressionUUID->"bdf245a2-4c97-41be-be3a-52bef0079c0b"],
Cell[12903, 376, 1354, 40, 115, "Input",ExpressionUUID->"a17c0c00-78d4-4ad7-9fbb-f69f5af4700f"],
Cell[14260, 418, 2352, 52, 304, "Input",ExpressionUUID->"1b607cdc-eaa5-4a07-9a99-5f281e96849a"],
Cell[16615, 472, 211, 6, 97, "Text",ExpressionUUID->"8b63a347-f95d-4482-ad40-d3197562af57"],
Cell[CellGroupData[{
Cell[16851, 482, 362, 9, 30, "Input",ExpressionUUID->"1e2b00e2-43df-495c-ae41-86f462a62e2f"],
Cell[17216, 493, 7118, 198, 223, "Output",ExpressionUUID->"d3e81ff9-b616-4783-b804-7a12f4314c9d"]
}, Open  ]],
Cell[24349, 694, 2184, 60, 241, "Input",ExpressionUUID->"a667bef6-06a8-48f0-bc54-adcfc19b85d6"],
Cell[CellGroupData[{
Cell[26558, 758, 1311, 35, 94, "Input",ExpressionUUID->"de077d0b-63e9-4e95-8ed8-8ff5f0c84b91"],
Cell[27872, 795, 386, 7, 34, "Output",ExpressionUUID->"8aa09c54-1d80-41cb-84e5-b22a372a969a"]
}, Open  ]],
Cell[28273, 805, 188, 6, 97, "Text",ExpressionUUID->"99bcf54e-710e-468d-8beb-0a9b37a303e8"],
Cell[CellGroupData[{
Cell[28486, 815, 1085, 31, 94, "Input",ExpressionUUID->"46f196ab-9d64-4a7b-b25c-0ecbb5a2da29"],
Cell[29574, 848, 2178, 37, 140, "Output",ExpressionUUID->"8666e2ee-9bc0-4b8f-931b-3bdad3272937"]
}, Open  ]],
Cell[31767, 888, 193, 6, 97, "Text",ExpressionUUID->"660b5ee4-51fc-46b3-a104-643738459c93"],
Cell[CellGroupData[{
Cell[31985, 898, 220, 4, 52, "Input",ExpressionUUID->"ec2ba2e2-dc32-4cf3-bab1-5e55feba7e13"],
Cell[32208, 904, 1553, 24, 140, "Output",ExpressionUUID->"963f8673-94f8-405b-9128-1a9a4cdfa71d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33798, 933, 426, 11, 30, "Input",ExpressionUUID->"a128acc1-d524-4a9b-89ad-860208f505b1"],
Cell[34227, 946, 14119, 295, 246, "Output",ExpressionUUID->"e2fcd788-492b-47e7-bd1e-42a7229544e9"]
}, Open  ]]
}
]
*)

