(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    359416,       6760]
NotebookOptionsPosition[    354154,       6670]
NotebookOutlinePosition[    354564,       6688]
CellTagsIndexPosition[    354521,       6685]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.713781903060691*^9, 3.713781903277442*^9}, {
   3.714199282807151*^9, 3.714199283764227*^9}, 3.71419935223492*^9, {
   3.731242518992098*^9, 3.731242519448473*^9}, {3.7312551042697477`*^9, 
   3.731255112579124*^9}, {3.73906187066437*^9, 3.739061897280053*^9}, {
   3.739273089849491*^9, 3.7392730906119223`*^9}, {3.739470760509063*^9, 
   3.739470763787024*^9}, {3.745010186321981*^9, 
   3.745010188570477*^9}},ExpressionUUID->"b5260f66-0901-4ca6-9508-\
95314d52b121"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"testdata", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", 
        "\"\<aggregatefeaturesConorTest.csv\>\""}], "}"}], "]"}], ",", 
     "\"\<CSV\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", 
        "\"\<aggregatefeaturesConorTrain.csv\>\""}], "}"}], "]"}], ",", 
     "\"\<CSV\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "data"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "testdata"}]}], "Input",
 CellChangeTimes->{{3.745004894409554*^9, 3.745004898288335*^9}, {
  3.745004955410329*^9, 3.745004992036372*^9}, {3.745007868567322*^9, 
  3.745007908751813*^9}, {3.7450096970065937`*^9, 3.745009707753516*^9}},
 CellLabel->
  "In[178]:=",ExpressionUUID->"96364fb8-a271-4fa9-a100-91457a7db652"],

Cell[BoxData["68"], "Output",
 CellChangeTimes->{3.745009708177561*^9},
 CellLabel->
  "Out[180]=",ExpressionUUID->"fbba753d-bfb5-4e04-a0cd-7983c45511a3"],

Cell[BoxData["67"], "Output",
 CellChangeTimes->{3.745009708185809*^9},
 CellLabel->
  "Out[181]=",ExpressionUUID->"62c1057e-3785-47f7-b113-56e69bc98646"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Dimensions", "@", "data"}], "\[IndentingNewLine]", 
 RowBox[{"Short", "@", "data"}]}], "Input",
 CellChangeTimes->{{3.745004994066811*^9, 3.7450050051651907`*^9}, {
  3.745005561769952*^9, 3.745005564772695*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"f8b948e9-3a89-4a84-8434-187e1206cb65"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"68", ",", "10"}], "}"}]], "Output",
 CellChangeTimes->{{3.745004995148529*^9, 3.745005005638373*^9}, 
   3.74500556520197*^9, 3.7450079142882442`*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"08f5f95d-1364-4a99-863b-666cb928a7b3"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "298.07`", ",", "0", ",", "0.14803`", ",", "1.427`", ",", "6.1786`", ",",
       "1.2856`", ",", "5.3646`", ",", "25.02`", ",", "37.126`", ",", 
      "2.9`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "66", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"119.68`", ",", "0", ",", "0.8179`", ",", 
      RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", "6.059`", 
      ",", "11.052`", ",", "14.4`"}], "}"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{{3.745004995148529*^9, 3.745005005638373*^9}, 
   3.74500556520197*^9, 3.7450079142998047`*^9},
 CellLabel->
  "Out[93]//Short=",ExpressionUUID->"79d60625-64ba-422e-b233-d4c6772d8731"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Shape of Data", "Title"],
 " "
}], "Text",
 CellChangeTimes->{{3.745009351185052*^9, 
  3.745009355043277*^9}},ExpressionUUID->"2ebc40b9-6072-4783-966c-\
a3460deb9526"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CommunityGraphPlot", "@", 
    RowBox[{"NearestNeighborGraph", "[", 
     RowBox[{"data", ",", "n", ",", 
      RowBox[{"DistanceFunction", "\[Rule]", "EuclideanDistance"}]}], "]"}]}],
    ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"n", ",", "1", ",", "10", ",", "1"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.745005856828361*^9, 3.745005895664955*^9}, {
  3.745006098686412*^9, 3.745006126810741*^9}, {3.745006698086523*^9, 
  3.74500676512492*^9}, {3.745006838469461*^9, 3.745006838847086*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"25d3cdbc-5bfd-4dbd-b412-7fb43cc02964"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`n$$ = 3, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`n$$], 1, 10, 1}}, Typeset`size$$ = {
    360., {181., 186.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = False, $CellContext`n$204306$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`n$$ = 1}, 
      "ControllerVariables" :> {
        Hold[$CellContext`n$$, $CellContext`n$204306$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> CommunityGraphPlot[
        NearestNeighborGraph[$CellContext`data, $CellContext`n$$, 
         DistanceFunction -> EuclideanDistance]], 
      "Specifications" :> {{$CellContext`n$$, 1, 10, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{405., {226., 232.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`data = {{
         298.07, 0, 0.14803, 1.427, 6.1786, 1.2856, 5.3646, 25.02, 37.126, 
          2.9}, {328.69, 0.020577, 0, 1.9245, 3.966, 2.3692, 7.1231, 25.84, 
          41.116, 2.9}, {
         301.1, 0, 0.14725, 1.5705, 6.1053, 1.4319, 5.8367, 24.709, 38.417, 
          2.9}, {326.18, 0.020413, 0, 1.996, 4.0808, 2.3384, 6.8547, 26.495, 
          40.381, 2.9}, {
         75.422, 0, 0, 0.17126, 0.79574, 0.1713, 1.937, 5.2538, 9.5958, 
          2.9}, {339.77, 0, 0.011899, 1.9008, 4.9568, 2.0731, 6.5288, 26.922, 
          45.282, 3}, {
         316.61, 0, 2.702, 3.713, 10.082, 1.9535, 8.0334, 24.57, 43.132, 3}, {
         340.99, 0, 0.010769, 1.637, 4.7973, 1.884, 5.7882, 26.397, 44.111, 
          3}, {311.06, 0.0087775, 2.6972, 2.5557, 9.782, 1.7171, 9.0338, 
          24.513, 43.896, 3}, {
         448.83, 0, 2.2783, 9.4935, 5.4512, 6.6822, 14.288, 25.729, 44.027, 
          19.1}, {452.67, 0, 3.2945, 12.374, 5.6994, 6.0237, 14.343, 21.461, 
          46.926, 19.1}, {
         443.82, 0, 2.9799, 9.6421, 6.572, 6.0811, 13.638, 26.035, 43.982, 
          19.1}, {460.05, 0, 3.411, 13.613, 5.6329, 6.1978, 14.178, 22.524, 
          48.237, 19.1}, {
         126.91, 0, 1.3638, 2.8817, 2.8756, 1.5884, 3.1707, 6.7671, 11.128, 
          19.1}, {480.92, 0, 3.1893, 10.835, 5.353, 7.4598, 16.929, 26.984, 
          47.435, 18.6}, {
         481.51, 0, 2.6557, 8.9213, 8.9872, 6.3895, 17.532, 23.054, 47.453, 
          18.6}, {486.12, 0, 3.1569, 11.088, 4.4518, 7.2875, 18, 28.114, 
          47.547, 18.6}, {
         489.36, 0, 2.5895, 9.6074, 8.6665, 6.6872, 18.757, 23.851, 46.616, 
          18.6}, {339.82, 0, 3.1188, 10.578, 6.0321, 4.0106, 9.9523, 18.669, 
          43.417, 22.2}, {
         393.35, 0, 3.8839, 11.141, 7.9125, 8.64, 12.952, 20.093, 44.913, 
          22.2}, {339.83, 0, 3.517, 10.283, 6.3951, 4.6226, 10.258, 19.768, 
          43.431, 22.2}, {
         399.89, 0, 4.4101, 11.16, 8.5347, 8.0866, 13.338, 19.96, 44.863, 
          22.2}, {96.22, 0, 0.76659, 3.3105, 2.7219, 1.2887, 3.1592, 4.6633, 
          11.387, 22.2}, {409.86, 0.0040729, 4.291, 12.385, 5.5748, 7.7321, 
         15.343, 20.761, 45.26, 21.6}, {
         401.83, 0, 5.2026, 7.8299, 6.1791, 6.2723, 12.483, 22.701, 52.742, 
          21.6}, {402.96, 0.004126, 4.797, 13.539, 5.3281, 6.5946, 13.674, 
         20.136, 45.761, 21.6}, {
         398.63, 0, 5.3191, 8.1309, 6.3015, 6.355, 12.196, 23.341, 51.78, 
          21.6}, {374.04, 0, 5.423, 5.9608, 4.0366, 4.6014, 10.937, 20.596, 
          42.203, 22.1}, {
         413.83, 0, 5.3412, 14.417, 7.0638, 5.8726, 13.085, 20.183, 43.912, 
          22.1}, {379.64, 0, 5.5937, 5.5036, 4.379, 4.583, 10.463, 20.424, 
          41.996, 22.1}, {
         412.86, 0, 4.8581, 13.715, 5.8044, 5.557, 11.635, 19.624, 46.92, 
          22.1}, {83.345, 0, 0.76589, 1.7157, 1.1212, 0.99757, 3.0034, 3.0333,
           8.3878, 22.1}, {
         368.75, 0, 0.061722, 2.242, 5.365, 2.8693, 8.4913, 26.402, 43.182, 
          3.6}, {356.07, 0, 0, 3.0454, 3.4362, 1.0232, 5.4525, 21.125, 44.646,
           3.6}, {
         367.16, 0, 0.062287, 2.1849, 5.1677, 1.9962, 7.901, 25.65, 42.197, 
          3.6}, {364.52, 0, 0, 3.0269, 3.6821, 1.3556, 6.1767, 20.868, 44.925,
           3.6}, {316.45, 0.03027, 0.0381, 1.7243, 3.4106, 2.6521, 7.2047, 
         26.769, 35.709, 3.6}, {
         356.01, 0, 0.034182, 1.6444, 3.4746, 2.3203, 7.8351, 24.909, 38.732, 
          3.6}, {330.73, 0.030236, 0.037951, 1.5938, 3.9134, 2.8885, 6.9513, 
         26.786, 36.74, 3.6}, {
         354.54, 0, 0.034195, 1.3959, 3.7291, 2.0723, 8.6462, 24.295, 39.266, 
          3.6}, {85.922, 0, 0.018525, 0.82561, 1.9665, 0.77235, 1.5914, 
          7.1383, 9.5168, 3.6}, {
         514.19, 0, 0.45133, 5.2488, 7.0565, 3.8657, 6.7734, 28.586, 42.472, 
          7.1}, {537.19, 0, 1.4028, 4.4866, 4.9556, 2.8621, 9.6881, 25.508, 
          39.049, 7.1}, {
         527.51, 0, 0.31515, 6.3232, 7.0721, 3.6295, 6.0766, 26.73, 43.361, 
          7.1}, {530.43, 0, 1.5741, 4.7036, 4.8877, 3.0257, 9.3533, 26.163, 
          38.35, 7.1}, {
         449.83, 0, 1.3469, 3.4711, 4.8935, 3.4552, 8.6223, 23.526, 37.068, 
          7}, {521.6, 2.5275, 2.4019, 5.9517, 9.4731, 3.4461, 10.415, 24.746, 
          41.046, 7}, {
         447.58, 0, 1.014, 3.0486, 5.1883, 2.5549, 9.862, 24.593, 36.96, 7}, {
         513.15, 2.5131, 2.4127, 5.4529, 9.2966, 3.4688, 10.312, 24.689, 
          42.218, 7}, {
         141.95, 0, 0.37033, 1.661, 1.667, 0.50864, 3.4617, 6.727, 11.409, 
          7}, {564.3, 0, 1.2316, 8.6987, 4.5689, 5.716, 11.071, 27.508, 
          46.614, 10.3}, {
         569.63, 0, 1.7371, 6.3861, 5.185, 3.058, 14.391, 27.227, 43.732, 
          10.3}, {568.79, 0, 1.2343, 8.463, 4.3834, 5.8108, 10.536, 27.76, 
          46.801, 10.3}, {
         565.22, 0, 1.3969, 6.9929, 5.2629, 3.693, 14.843, 27.472, 44.082, 
          10.3}, {469.32, 0, 0.47045, 5.2537, 4.0281, 4.9216, 9.4816, 27.036, 
          44.474, 10.3}, {
         578.79, 0, 2.7845, 4.5151, 4.1784, 4.3609, 12.761, 29.015, 42.997, 
          10.3}, {485.97, 0, 0.4079, 5.3451, 5.0558, 5.0734, 10.138, 27.493, 
          44.258, 10.3}, {
         584.26, 0, 2.7873, 4.207, 3.8473, 4.6176, 13.802, 27.787, 43.434, 
          10.3}, {144.51, 0, 0.10609, 1.5732, 1.9576, 1.3848, 5.0028, 5.2031, 
          11.344, 10.3}, {
         537.72, 0, 1.7997, 10.13, 3.8547, 7.1451, 15.534, 26.603, 46.637, 
          14.2}, {514.67, 0, 1.7646, 8.7439, 6.0053, 7.5025, 17.859, 23.824, 
          45.342, 14.2}, {
         530.53, 0, 2.124, 10.35, 4.4208, 8.0947, 15.291, 27.037, 47.444, 
          14.2}, {515.01, 0, 1.6623, 10.297, 6.4704, 7.2281, 16.791, 23.877, 
          44.601, 14.2}, {
         463.84, 0, 1.9974, 6.1949, 3.8962, 5.297, 14.954, 26.88, 40.988, 
          14.4}, {539.74, 0, 1.2715, 8.518, 5.7353, 5.4379, 20.232, 28.599, 
          40.853, 14.4}, {
         453.75, 0, 2.2541, 7.4077, 4.7139, 4.9729, 13.959, 27.744, 41.904, 
          14.4}, {543.79, 0, 1.3584, 9.5964, 6.3108, 5.638, 19.173, 27.318, 
          41.8, 14.4}, {
         119.68, 0, 0.8179, 2.1511, 2.3651, 1.2368, 4.8513, 6.059, 11.052, 
          14.4}}}; Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.7450058769712963`*^9, 3.745005895908454*^9}, {
   3.745006098967247*^9, 3.7450061270677547`*^9}, {3.745006698356682*^9, 
   3.745006766188263*^9}, 3.74500683983912*^9, 3.7450068787651033`*^9, 
   3.745007925709927*^9},
 CellLabel->"Out[94]=",ExpressionUUID->"1524ef44-669e-41fb-9b84-c9425457238e"]
}, Open  ]],

Cell[TextData[{
 "\[LineSeparator]",
 StyleBox["Cluster Analysis ", "Title"]
}], "Text",
 CellChangeTimes->{{3.7450093658829107`*^9, 
  3.7450093692635202`*^9}},ExpressionUUID->"f5ad171a-da16-438d-84aa-\
0c2172ec31ce"],

Cell["\<\

2 Cluster found!\
\>", "Text",
 CellChangeTimes->{{3.745009387050706*^9, 
  3.7450093952963247`*^9}},ExpressionUUID->"740fdd0f-c629-4027-a90e-\
fa6a1f73f4b5"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"clusters", "=", 
   RowBox[{"FindClusters", "[", "data", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "clusters"}]}], "Input",
 CellChangeTimes->{{3.745006019674918*^9, 3.745006020720809*^9}, {
   3.7450062294168653`*^9, 3.745006250258287*^9}, 3.745006437299245*^9, {
   3.74500658235511*^9, 3.745006582612513*^9}, 3.7450066272430964`*^9},
 CellLabel->"In[95]:=",ExpressionUUID->"c5b9ad86-7bce-422a-9b73-5a42fc101a38"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.745006251040501*^9, 3.7450064379577837`*^9, {3.74500658305376*^9, 
   3.745006587235416*^9}, 3.745006628153879*^9, 3.7450079363281927`*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"5e6a4194-afac-4bb4-a811-c0d0825b5af4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "@", 
  RowBox[{"clusters", "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.745006273585753*^9, 3.7450062801387577`*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"6f0e970f-57b4-4d75-8ba8-86f72f9dcbc4"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "298.07`", ",", "0", ",", "0.14803`", ",", "1.427`", ",", "6.1786`", ",",
       "1.2856`", ",", "5.3646`", ",", "25.02`", ",", "37.126`", ",", 
      "2.9`"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "58", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"543.79`", ",", "0", ",", "1.3584`", ",", 
      RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", "27.318`", 
      ",", "41.8`", ",", "14.4`"}], "}"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.745006280512292*^9, 3.745006480490109*^9, 
  3.7450065895235577`*^9, 3.7450066289576397`*^9, 3.745007937487001*^9},
 CellLabel->
  "Out[97]//Short=",ExpressionUUID->"ce82f9b0-1f85-42ec-b6eb-282434d74e4d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "@", 
  RowBox[{"clusters", "[", 
   RowBox[{"[", "2", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{3.745006288959812*^9},
 CellLabel->"In[98]:=",ExpressionUUID->"48637d52-3548-4efc-a08e-e36b84f2dfa7"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "75.422`", ",", "0", ",", "0", ",", "0.17126`", ",", "0.79574`", ",", 
      "0.1713`", ",", "1.937`", ",", "5.2538`", ",", "9.5958`", ",", "2.9`"}],
      "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "}"}], ",", 
    RowBox[{"\[LeftSkeleton]", "5", "\[RightSkeleton]"}], ",", 
    RowBox[{"{", 
     RowBox[{"119.68`", ",", "0", ",", "0.8179`", ",", 
      RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], ",", "6.059`", 
      ",", "11.052`", ",", "14.4`"}], "}"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.745006289485055*^9, 3.745006482756467*^9, 
  3.745006590489846*^9, 3.7450066296165237`*^9, 3.745007938849676*^9},
 CellLabel->
  "Out[98]//Short=",ExpressionUUID->"c83c5be2-fdf3-422e-9ec2-e235d3f143c1"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Cluster 1", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009404133128*^9, 
  3.745009405579015*^9}},ExpressionUUID->"f70cf314-8255-4cb8-840b-\
fd2ce86c108d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"reduced", "=", 
   RowBox[{"DimensionReduce", "[", 
    RowBox[{
     RowBox[{"clusters", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPointPlot3D", "[", 
  RowBox[{"reduced", ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Bottom"}]}], "]"}]}], "Input",
 CellChangeTimes->{3.745006314254012*^9, 3.745009642695332*^9},
 CellLabel->
  "In[172]:=",ExpressionUUID->"a3578630-5aa8-4551-b23a-6ee9516af543"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[0.3315753, 0.4561011, 0.6388182], PointSize[
     NCache[
      Rational[3, 250], 0.012]], Point3DBox[CompressedData["
1:eJwNyX040wkcAPDVNlZO9Kpu3Qk7F0IvRy48358izVJRji6FGUrk5XgSdZ2X
U13X69W8FeJIz+U1Vqi+P0yFhSUxFHmZXrzN2qww1x+fvz4G3DD3gPkUCsXu
K+pXJaZNy/xXaxMvBOzOorUKXN8Y06QTWYHNnmx2wR4G0bV2eher4BWytifN
P0FIoTSzwZrrpEUwNvc9ruz9hCRju1FbbBYG3zWxlnstIB6+Et3QMBOjZKfr
s++3D4KmGTMmoJZOBO42lG/PF+HPlVr11TYSYP17J13iNwVXueWtsZNqXJxv
vJCuUCK5WuDodkGTOGWaNOOnJcF7qfZJg7XdMBEsydBZq4JrFG12EFON81PK
+C67FHh4Xa7DUN0UlpTw60O9+qGc88Vz5GIH2Bs+NBJ1Ucl1THa5Y1w/NvwX
ZbNpngQu3u+KpN1U4bGOANc/Fc0gOmi74ohzEe4uvCzX7aKTjhmapfZxL9A8
vk620qkLysumBc8X00hdC4l2oEIOV/LEZa3jr+BlSPGltiwaucJ+gitOvIfJ
/BY+1WwUZy/UJC9/RCVjltn8yG6ehgfbJvNm4wbBv+lt0OEAOtkeV5l2xKwd
CIv32soXH7D6/OSxG999wpPpPrphSCNFBbTYD9y3cNvg++pBCwZZ4tptHZjx
Ba1ft6W8Kq5B3qOz7c5tSnQ39aYWMqlkyJpWaz++BFLSlYmaqxaQClf/9Xu3
zqKHRW6gjUqCxJ5OnfQCBhnhoP9Uz2QCH9ntLsk1GoCYoA7Xlf9okOO7Uqjv
hiZR6OxxNsS3G8rv9vGU45qkVb5AcDR8Clkz6Uv17KTgb07X2qCgk55GGrzQ
Hhmm/+4woMvpgAIraljKsAwFO3N+oCar0Ssi4OhhmgyM9yd9buAwyASDj1Zh
rFkkjC9ZGlT5Y6CLVrwkXIZf2HrCWXMK6c4SW11MHAXt37Ii9Xo1yC/5ViV/
ecximGgZoV/ZB66rnawP9s0nKFMjEzu4e6HtwZOLtKInsEMr87yLHZ3INo4W
O9OUGCjLYVA1J6CxeuOFUDadWDI+zfSOEKO+mcro5nURpFQG/H3jDJWIbb8f
fMpYgZZ9Yz7WhqMw9mzIYEPhN8TGyWSLFTP16KxD9TAZfg/bei8tmpMyiBrv
NFOPRjE6JjZk5jh9gGPyeDPVVi0ifH8Hr/7bGize18853zUAt9bQttjqMAgr
lUh7iNeFP13R9M58PAzvyvw2H2ROgb9DMDf8ugy6gqLeJPgOY7bLiOD4IhUc
GBEH8qgfIWFaI9gr+AHW75H2cIRymOLcHH/jPgyPu007coukGHL6UKH7os/A
PicaG9AZBbZsb1pgwD3kVFyyg/pZoGVnE/d7m7E7hL9jblAIE28c64sOvob3
QqW2OKgVTeSOS5sd9cg/Tlo575NQiLHosRNUUz5MuHLOvcuIAsFplu3qsW5Y
aMza35/XhvXjSwyPkivIaXlNa21GN0a75i1Zb6OGww9j7LkLWyGZ0yIPryKh
VhRnYtU0DUqud5DPPiGqq7yW9+Z1oK6pIooSPQcpljeq5p62gd2hZ1KHlttY
3eLp5LRbDV5rD/heE9aiblvStAXzIwilDpdZpTLwjkYf3uAAnF1sm7vpTgtE
bNZvmVk6j0hoNWZEpddBrI857alyCCx5Z3KPG34CVuSv2VsyGsAXO7F3YxY8
4dl1cngUojT1Gt++7wVU7WQ2KTI/Y0hIgW5aoRrecDKbyAVSoF5d5hJZrMY1
Y25LnXonIFt5kvf4QjCmJvvmFJnNocuuGFWEmxr4mpfFTNO34LuOabnfQI39
M3eK4u1HoVGclNVJf4qTt1JKRyruY8XnrPTnq+TgXdbTeMh86OtX5MSMjqAy
39FM5UYlMs4V6QsIEb7UrTvTk9mI+tKxBrcFMsgZ1UuKE3YCpaW9cCZUjtap
v/RG0CiE7QaXmSr9TvwfOCHnCQ==
     "]]}, 
   {RGBColor[0.3315753, 0.4561011, 0.6388182], Opacity[0.3], 
    Line3DBox[CompressedData["
1:eJyF1m1U09cdwPHUJBBlCD5U2sUVgYwJCKgdyAqc358WxBBRQZm4omAIYBHl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     "]]}},
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGrids->None,
  FaceGridsStyle->Automatic,
  ImageSize->500,
  PlotRange->{All, All, All},
  PlotRangePadding->{{Automatic, Automatic}, {Automatic, Automatic}, {
    Automatic, Automatic}},
  Ticks->{Automatic, Automatic, Automatic},
  ViewPoint->{0.6179706563255446, -2.8530781804634593`, 1.711156674324094},
  ViewVertical->{-0.04181219053432669, -0.11478800498725278`, 
   2.4812741870782937`}]], "Output",
 CellChangeTimes->{3.7450063151238213`*^9, 3.7450065915007277`*^9, 
  3.745006630795185*^9, 3.7450079398418903`*^9, 3.7450096437525387`*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"91ce860c-f17d-4ae9-a510-fdc621c8bb63"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Cluster 2", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009404133128*^9, 
  3.74500941797752*^9}},ExpressionUUID->"766a08eb-4c2c-4d9f-aa3d-\
6ca71d3242d0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"reduced", "=", 
   RowBox[{"DimensionReduce", "[", 
    RowBox[{
     RowBox[{"clusters", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", "3"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPointPlot3D", "[", 
  RowBox[{"reduced", ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Bottom"}]}], "]"}]}], "Input",
 CellChangeTimes->{3.7450063251404743`*^9, 3.745009647633095*^9},
 CellLabel->
  "In[174]:=",ExpressionUUID->"12a1efa8-d076-44cf-b0c3-c410e3d68842"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[0.3315753, 0.4561011, 0.6388182], PointSize[
     NCache[
      Rational[7, 500], 0.014]], 
    Point3DBox[{{3.9549639774988177`, 
     0.013331694434024044`, -0.016812183323249776`}, {-2.890242063419863, 
     0.06023556318067441, 1.3661086101922633`}, {-2.0708867553671646`, 
     1.2166375719345452`, 0.5461144589309391}, {0.9352048149460928, 
     3.2042653790349163`, -0.8805526825827003}, {
     2.344973983520386, -0.7548486557251334, 1.5577869202041565`}, {
     0.3098457972068289, -1.9408490302156152`, -0.3094966094427242}, \
{-0.9338490419650585, -1.3297086210040432`, -1.8459217606550546`}, \
{-1.6500107124200372`, -0.46906390163936396`, -0.4172267533236285}}]}, 
   {RGBColor[0.3315753, 0.4561011, 0.6388182], Opacity[0.3], 
    Line3DBox[CompressedData["
1:eJxTTMoPSmVmYGDgAGImIAaxI3cmqh9ZzO/AEHJwz1LfbnuuOwZtZuYT96OL
rzrf7/i04+/+Jm95a3N59gMak69KG11fZ3//y47NU25/tUcXh6kX1XEQ1p3I
cEB4c8bXiPLP9sGp89mPVj60RxeHqZ+l9WKp0du39pvdRR+HLuJ0eK5w+GKN
7hsMcZj6722eOxoPMTnsnW0Rt0P9xf6IuW6/Nr75YY8uDlO/ZXZxefOVy/aV
f4u3bef9v7/44ce7p85dxhCHqX/ReCVJ/NHb/T/3sfXUuH0lKL7O59/CwrRf
+6PmBs5UYb23f+9ipevXN9/CEIepBwBTINUY
     "]]}},
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGrids->None,
  FaceGridsStyle->Automatic,
  ImageSize->500,
  PlotRange->{All, All, All},
  PlotRangePadding->{{Automatic, Automatic}, {Automatic, Automatic}, {
    Automatic, Automatic}},
  Ticks->{Automatic, Automatic, Automatic},
  ViewPoint->{1.8870129333745747`, -2.410335326326171, 1.4420352991314722`},
  ViewVertical->{0.3149794759839204, -0.015423945526959332`, 
   2.3724328647156647`}]], "Output",
 CellChangeTimes->{3.745006325545266*^9, 3.745006593902217*^9, 
  3.745006634786092*^9, 3.745007941759801*^9, 3.7450096484738617`*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"580250f7-6f2b-424d-b861-7b61c44cd810"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Both", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009426690291*^9, 
  3.745009427494651*^9}},ExpressionUUID->"f34ab015-bd38-4efc-8146-\
2ed667f601e6"],

Cell["\<\


Notice a possible outlier\
\>", "Text",
 CellChangeTimes->{{3.7450098665905247`*^9, 
  3.74500987038107*^9}},ExpressionUUID->"2c43069c-4721-4936-965c-\
4cd13437c7d2"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"reduced", "=", 
   RowBox[{"DimensionReduce", "[", 
    RowBox[{"data", ",", "3"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ListPointPlot3D", "[", 
  RowBox[{"reduced", ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"Filling", "\[Rule]", "Bottom"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.745005940040531*^9, 3.7450059822451267`*^9}, 
   3.745009651322928*^9},
 CellLabel->
  "In[176]:=",ExpressionUUID->"c7f23cd2-0c75-4473-ad5c-acc58a632254"],

Cell[BoxData[
 Graphics3DBox[{
   {RGBColor[0.3315753, 0.4561011, 0.6388182], PointSize[
     NCache[
      Rational[3, 250], 0.012]], Point3DBox[CompressedData["
1:eJwNkns41PkegMdlptymm3FpbYyTS3IZTKjw/altaa1oQjonbOJMKkaXTdnk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     "]]}, 
   {RGBColor[0.3315753, 0.4561011, 0.6388182], Opacity[0.3], 
    Line3DBox[CompressedData["
1:eJyF1ns81OkewPFxm3LtZlxaG+PkklzGJSR6fmpbWiuakM4JmzhSMbpsyibX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     "]]}},
  Axes->True,
  AxesLabel->{None, None, None},
  BoxRatios->{1, 1, 0.4},
  DisplayFunction->Identity,
  FaceGrids->None,
  FaceGridsStyle->Automatic,
  ImageSize->500,
  PlotRange->{All, All, All},
  PlotRangePadding->{{Automatic, Automatic}, {Automatic, Automatic}, {
    Automatic, Automatic}},
  Ticks->{Automatic, Automatic, Automatic},
  ViewPoint->{2.7307085868953647`, 0.35037090151771033`, 1.9673512255887566`},
  
  ViewVertical->{0.002497097620133948, 0.10445690750378633`, 
   2.4863156966913675`}]], "Output",
 CellChangeTimes->{3.7450059492559834`*^9, 3.745005983250701*^9, 
  3.745006601675416*^9, 3.74500794346108*^9, 3.745009652135954*^9},
 CellLabel->"Out[177]=",ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"],ExpressionUUID->"27643d36-ff81-49b5-b832-2866688c70be"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["{x1,x2,x3...xn}\[LongRightArrow]y", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009442345346*^9, 
  3.745009481226914*^9}},ExpressionUUID->"242bf46f-31aa-49a1-929d-\
af76429950c8"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fxy", "=", 
     RowBox[{"Flatten", "@", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{"#", ",", "1"}], "]"}], "->", 
           RowBox[{"First", "@", "#"}]}], "}"}], "&"}], ",", "data"}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"testfxy", "=", 
     RowBox[{"Flatten", "@", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Drop", "[", 
            RowBox[{"#", ",", "1"}], "]"}], "->", 
           RowBox[{"First", "@", "#"}]}], "}"}], "&"}], ",", "testdata"}], 
       "]"}]}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.745005018424614*^9, 3.74500504541844*^9}, {
  3.7450050769883623`*^9, 3.745005099430719*^9}, {3.745007387790833*^9, 
  3.745007388069816*^9}, {3.7450074315646553`*^9, 3.7450074382006197`*^9}, {
  3.745007784607156*^9, 3.745007848395142*^9}, {3.745007948195508*^9, 
  3.745007948532309*^9}, {3.745007999497073*^9, 3.74500801180805*^9}},
 CellLabel->
  "In[159]:=",ExpressionUUID->"92f58ce4-88c1-445c-bf20-db19063d1bba"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "@", "fxy"}]], "Input",
 CellChangeTimes->{{3.745007391585876*^9, 3.7450073944041557`*^9}},
 CellLabel->
  "In[161]:=",ExpressionUUID->"4b9784af-5552-4e87-8bd9-a4e969042f61"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0.14803`", ",", "1.427`", ",", "6.1786`", ",", "1.2856`", 
       ",", "5.3646`", ",", "25.02`", ",", "37.126`", ",", "2.9`"}], "}"}], 
     "\[Rule]", "298.07`"}], ",", 
    RowBox[{"\[LeftSkeleton]", "66", "\[RightSkeleton]"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0.8179`", ",", "2.1511`", ",", 
       RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}], ",", "6.059`", 
       ",", "11.052`", ",", "14.4`"}], "}"}], "\[Rule]", 
     RowBox[{"\[LeftSkeleton]", "7", "\[RightSkeleton]"}]}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.745007394792676*^9, 3.745007440738997*^9, 
  3.745007795530498*^9, 3.745007951549531*^9, 3.7450089766357727`*^9},
 CellLabel->
  "Out[161]//Short=",ExpressionUUID->"f7c7bc09-7ea3-420b-8ad5-c6ed5258b024"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Short", "@", "testfxy"}]], "Input",
 CellChangeTimes->{{3.745009893534939*^9, 3.74500989402911*^9}},
 CellLabel->
  "In[194]:=",ExpressionUUID->"616b145f-6ece-4454-980c-a2a3e91d77f2"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "0", ",", "0.076604`", ",", "1.4922`", ",", "3.0296`", ",", "2.4288`", 
       ",", "7.7585`", ",", "27.326`", ",", "36.57`", ",", "2.9`"}], "}"}], 
     "\[Rule]", "350.95`"}], ",", 
    RowBox[{"\[LeftSkeleton]", "65", "\[RightSkeleton]"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0.0000249`", ",", "0.79776`", ",", 
       RowBox[{"\[LeftSkeleton]", "5", "\[RightSkeleton]"}], ",", "40.084`", 
       ",", "14.4`"}], "}"}], "\[Rule]", "529.7`"}]}], "}"}],
  Short]], "Output",
 CellChangeTimes->{3.745009894759811*^9},
 CellLabel->
  "Out[194]//Short=",ExpressionUUID->"722008e1-d13f-4f58-9df4-2fe8a32beb57"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"en", ".", "wikipedia", ".", "org"}], "/", "wiki"}], "/", 
      "Coefficient_of"}], "_determination"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"rSQUARED", "[", 
    RowBox[{"y_", ",", "yhat_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ybar", ",", "SStot", ",", "SSreg", ",", "SSres"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ybar", "=", 
       RowBox[{"Mean", "@", "y"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SStot", "=", 
       RowBox[{"Total", "@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"#", "-", "ybar"}], ")"}], "^", "2"}], "&"}], ",", "y"}],
          "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SSreg", "=", 
       RowBox[{"Total", "@", 
        RowBox[{"Map", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"#", "-", "ybar"}], ")"}], "^", "2"}], "&"}], ",", 
          "yhat"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"SSres", "=", 
       RowBox[{"Total", "@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"y", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "-", 
             RowBox[{"yhat", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], ")"}], "^", "2"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "@", "y"}]}], "}"}]}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"1", "-", 
       RowBox[{"(", 
        RowBox[{"SSres", "/", "SStot"}], ")"}]}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.742896887621572*^9, 3.74289690697183*^9}, {
   3.7428969524806004`*^9, 3.7428969539744263`*^9}, {3.7428970119698963`*^9, 
   3.742897205956642*^9}, {3.7428972438493*^9, 3.742897297218629*^9}, {
   3.742897429185205*^9, 3.742897432143873*^9}, 3.742897690909665*^9},
 CellLabel->
  "In[162]:=",ExpressionUUID->"b92affb6-f17d-4971-8c77-8da3299b4b37"],

Cell[TextData[{
 StyleBox["NearestNeighbors", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.745009489398719*^9, 
  3.745009499737849*^9}},ExpressionUUID->"6f39b4f0-70f2-4277-a288-\
9115aac55db6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"p", "=", 
    RowBox[{"Predict", "[", 
     RowBox[{"fxy", ",", 
      RowBox[{"Method", "\[Rule]", "\"\<NearestNeighbors\>\""}], ",", " ", 
      RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], "]"}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"rSQUARED", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"testfxy", "[", 
         RowBox[{"[", "i", "]"}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"p", "[", 
        RowBox[{
         RowBox[{"testfxy", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7450080859482927`*^9, 3.745008087461295*^9}, {
   3.7450081255434217`*^9, 3.745008178700078*^9}, {3.745008212867404*^9, 
   3.745008234164225*^9}, {3.745008270411948*^9, 3.7450083564758883`*^9}, 
   3.745008402671173*^9, 3.7450084602052298`*^9, {3.7450086329615107`*^9, 
   3.74500865222691*^9}, {3.745009740921208*^9, 3.7450097423815517`*^9}, {
   3.745009776178315*^9, 3.745009791620936*^9}, {3.745009964346192*^9, 
   3.745010010132306*^9}},
 CellLabel->
  "In[200]:=",ExpressionUUID->"92eef82d-ed1e-483b-bf4f-46ee590ef760"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["PredictorFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NearestNeighbors\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NearestNeighbors\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox[
                 "\"Number of training examples: \"", 
                  "SummaryItemAnnotation"], "\[InvisibleSpace]", 
                 TagBox["68", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  PredictorFunction[
   Association[
   "ExampleNumber" -> 68, "Input" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical"], "f2" -> 
           Association["Type" -> "Numerical"], "f3" -> 
           Association["Type" -> "Numerical"], "f4" -> 
           Association["Type" -> "Numerical"], "f5" -> 
           Association["Type" -> "Numerical"], "f6" -> 
           Association["Type" -> "Numerical"], "f7" -> 
           Association["Type" -> "Numerical"], "f8" -> 
           Association["Type" -> "Numerical"], "f9" -> 
           Association["Type" -> "Numerical"]], "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Preprocessor" -> 
         MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["Transpose", 
               Association["FeatureNumber" -> 9]], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {
                 "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical"}, 
                "FeatureKeys" -> {
                 "f1", "f2", "f3", "f4", "f5", "f6", "f7", "f8", "f9"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> False, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
         Association[
          "(f1f2f3f4f5f6f7f8f9)" -> 
           Association["Type" -> "NumericalVector", "Weight" -> 9]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
               Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2171448911019223696]], 
           MachineLearning`MLProcessor["ImputeMissing", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Imputed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Imputer" -> (DimensionReducerFunction[
               Association[
               "ExampleNumber" -> 68, "Imputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Fill" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, "Method" -> 
                   "Naive", "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "RandomImputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                   "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Method" -> "NaiveSampler", 
                   "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "Preprocessor" -> 
                MachineLearning`MLProcessor["ToMLDataset", 
                  Association[
                  "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 9]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> Automatic, 
                    "ExampleWeights" -> Automatic, "RawExample" -> 
                    Missing["KeyAbsent", "RawExample"]]]}]], "ScalarFeature" -> 
                   True, "Invertibility" -> "Perfect", "Missing" -> 
                   "Allowed"]], "Processor" -> 
                MachineLearning`MLProcessor["Identity"], "Padder" -> 
                MachineLearning`MLProcessor["Identity"], "PostProcessor" -> 
                MachineLearning`MLProcessor["FromMLDataset", 
                  Association[
                  "DatasetFormat" -> Automatic, "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 5]], 
                   "InversePreprocessor" -> 
                   MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> {1}, 
                    "ExampleWeights" -> 1]]}]], "ScalarFeature" -> True, 
                   "Invertibility" -> "Perfect", "Missing" -> "Allowed"]], 
                "Model" -> Association["Matrix" -> CompressedData["
1:eJwBeQGG/iFib1JlAgAAAAkAAAAFAAAAmVBmoywVlb8qELEgZU7Ov34Y3drR
FOo/qlyhgpR23r9Jb1K0KKfKPzVp3NEDrNa/abUD0TAL0j+AFISIiQfMPzFZ
17JLstg/v0E/ryvO4T+KlJfPjoLav6ZgG9zBpck/0LOIhqF1ej88VOIpEaG/
v2mJCAxiAse/TRYsbZN+0r8/Cw2zoo3Tv+9rc6GRntg/jnFgg2cz4j8pslyv
eGLiv+XQ0RgjLNu/KC+yDiZauD8yZxZFLjG+v+qmOUyfhdK/fQyWzeWfv7/n
NWRbIhLav6yDt//GmaW/7x/W+SY5wr/bXvcAlsTZv3qLeBRml9G/Hnk3HfuI
zr9MB8bKxNjhv+lUV0UsDdG/eRFvOOlQtr/0nv5/fCzQPy9kyAdK99a/IkxW
1nTN17+7W3GQWXrFv4i8XVVJ9sY/luetEIvW1j+4D+x3CeTSv6sQUsfGpuA/
l/Ljuh6CtD+ScbC9vFyGP6nsXqi+Tao/UEa+OQ==
                   "], "Processor" -> 
                  MachineLearning`MLProcessor["Standardize", 
                    Association[
                    "Invertibility" -> "Perfect", "Missing" -> "Allowed", 
                    "Input" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                    "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                    "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Output" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]]]], 
                  "FinalDimension" -> 5, "Method" -> "Linear"], 
                "PerformanceGoal" -> Automatic, "Invertibility" -> 
                "Approximate", "Log" -> 
                Association[
                 "TrainingTime" -> 0.007484, "MaxTrainingMemory" -> 66448, 
                  "DataMemory" -> 5240, "FunctionMemory" -> 22520, 
                  "LanguageVersion" -> {11.3, 0}, "Date" -> 
                  DateObject[{2018, 9, 4, 1, 33, 30.468233`8.236422249095618},
                     "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, 
                  "ProcessorType" -> "x86-64", "OperatingSystem" -> "MacOSX", 
                  "SystemWordLength" -> 64, "Evaluations" -> {}]]][#, 
               "ImputedVectors", PerformanceGoal -> "Quality"]& ), "Method" -> 
             "DimensionReduction", "VectorLength" -> 9, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Type" -> "NumericalVector", "Version" -> {11.3, 0}, "ID" -> 
             5500259897043576343]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
              6.145230441176471, 5.1866829411764686`, 4.129278823529412, 
              10.519120588235296`, 22.46829264705883, 39.538005882352955`, 
              12.08235294117647}, 
             "StandardDeviation" -> {0.42556704269130924`, 1.664271125991892, 
              3.9213244765540445`, 1.9849917286159486`, 2.252757467202552, 
              4.539697132504567, 6.700105806787766, 11.106504718564455`, 
              7.167141960044636}, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2687999288024534896]]}, 
         "Invertibility" -> "Perfect", "Missing" -> "Imputed"]]], "Output" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association["f1" -> Association["Type" -> "Numerical"]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["List"], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {"Numerical"}, "FeatureKeys" -> {"f1"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> True, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 2497458904888788241]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Mean" -> {399.8130735294119}, 
             "StandardDeviation" -> {132.8466718223454}, "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 8112975740502046413]], 
           MachineLearning`MLProcessor["FromVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 4157070569169933360]], 
           MachineLearning`MLProcessor["FirstValues", 
            Association[
            "Info" -> Association["Type" -> "Numerical", "Weight" -> 1], 
             "Key" -> "f1", "Invertibility" -> "Perfect", "Missing" -> 
             "Allowed"]]}, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "ProbabilityPostprocessor" -> Identity, 
      "InverseProcessorFunction" -> (399.8130735294119 + 
       132.8466718223454 #& ), 
      "ProcessorFunction" -> (-3.0095829127287295` + 
       0.007527474992653866 #& ), "Name" -> "value", 
      "Quantiles" -> {-2.4418456938327893`, 1.3884196264792183`}], "Prior" -> 
    Automatic, "Utility" -> (DiracDelta[#2 - #]& ), "Threshold" -> 0, 
    "PerformanceGoal" -> "Quality", "BatchProcessing" -> Automatic, "Model" -> 
    Association[
     "NeighborsFunction" -> 
      MachineLearning`PackageScope`NeighborsFunction["Nearest", 
        NearestFunction[
         Hold[
          Nearest[CompressedData["
1:eJxlWGk41O0XlgjRpvRGiihbUYlSeh0RKkoRpTeRkv6SpYhCyJJKKpG0WVK0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            "] -> Automatic, Method -> 
           "KDtree"]]]], "NeighborsNumber" -> 1, 
      "DistributionData" -> {NormalDistribution, 0.14352767271789996`}, 
      "TrainingOutput" -> 
      RawArray["Real32",{-0.008905556052923203, 
        0.3765011727809906, -0.23382650315761566`, 
        0.6485441327095032, -0.5353771448135376, -0.7430601716041565, 
        0.3689737021923065, 0.8671419620513916, 
        1.2782926559448242`, -0.32972654700279236`, 
        0.9839683771133423, -0.24579519033432007`, 0.8531408905982971, 
        1.347244381904602, 0.9832156300544739, 1.3884196281433105`, 
        0.07562799006700516, -2.362807273864746, -0.1518523097038269, 
        0.01518236380070448, -0.19400615990161896`, 
        0.45343196392059326`, -0.45197272300720215`, 1.2381712198257446`, 
        0.35956433415412903`, 0.098210409283638, 
        0.48196110129356384`, -2.3822054862976074`, 
        0.023688409477472305`, -0.442789226770401, 
        0.8645826578140259, -1.9217875003814697`, -0.32927489280700684`, 
        0.523211658000946, -2.1086947917938232`, 
        1.08378267288208, -2.2852892875671387`, -0.5200210809707642, 
        1.0380909442901611`, -0.3407919406890869, -0.6263090372085571, 
        0.6740622520446777, 0.916748046875, 1.2719695568084717`, 
        0.6105303764343262, -0.6680865287780762, -0.45159634947776794`, \
-0.5542711019515991, 0.6149715781211853, -0.26566773653030396`, 
        1.0341013669967651`, -2.0542709827423096`, 
        0.10551206022500992`, -0.048650626093149185`, 1.053296446800232, 
        0.9612354040145874, 0.0005790620925836265, 0.6496732234954834, 
        0.3312610387802124, 0.40600886940956116`, -0.6275134682655334, 
        0.3978791832923889, -0.7658684253692627, -1.941057801246643, \
-2.441845655441284, 1.2450964450836182`, 
        0.8609694242477417, -0.451521098613739}], "DistributionSmoothing" -> 
      0.5, "Processor" -> MachineLearning`MLProcessor["FirstValues", 
        Association[
        "Info" -> Association["Type" -> "NumericalVector", "Weight" -> 9], 
         "Key" -> "(f1f2f3f4f5f6f7f8f9)", "Invertibility" -> "Perfect", 
         "Missing" -> "Allowed"]], "Method" -> "NearestNeighbors", "Options" -> 
      Association[
       "NeighborsNumber" -> 
        Association["Value" -> 1, "Options" -> Association[]], 
        "DistributionSmoothing" -> 
        Association["Value" -> 0.5, "Options" -> Association[]], 
        "NearestMethod" -> 
        Association["Value" -> "KDtree", "Options" -> Association[]]]], 
    "TrainingInformation" -> 
    Association[
     "LossName" -> "StandardDeviation", "BestModelInformation" -> Dataset[
        Association[
        "MeanCrossEntropy" -> 
         PlusMinus[4.84887949535413, 0.19977158565597572`], 
         "StandardDeviation" -> 
         PlusMinus[66.33900027650675, 4.849415225467425], "EvaluationTime" -> 
         0.000017582857142857134`, "TestSize" -> 336, "TrainingSize" -> 54, 
         "TrainingTime" -> 0.004218279999999998, "TrainingMemory" -> 
         132107.51999999996`, "ModelMemory" -> 10568., "ExperimentCount" -> 
         24, "ModelUtility" -> 0.00009534136338873776, 
         "MeanCrossEntropyHistory" -> {
           PlusMinus[6.1551189037672405`, 1.0270999118235975`], 
           PlusMinus[4.829348949509081, 0.3124347008419527], 
           PlusMinus[5.339552690424179, 0.3569026256133419], 
           PlusMinus[8.719812611383196, 2.910507209182495], 
           PlusMinus[5.18369607059009, 0.3078638475407605], 
           PlusMinus[5.588573510626969, 0.4860331457281926], 
           PlusMinus[4.763642973180476, 0.09035580864598801], 
           PlusMinus[4.743047034123813, 0.0924499866163027], 
           PlusMinus[4.896053895533484, 0.26710817690614647`], 
           PlusMinus[4.837820254529691, 0.24870042337139567`], 
           PlusMinus[5.357669688737493, 0.37299484957965134`], 
           PlusMinus[4.8844623412028705`, 0.2719092519120999], 
           PlusMinus[4.883547236113752, 0.3467759224476863], 
           PlusMinus[7.6588727569124355`, 2.1225295600229477`], 
           PlusMinus[5.1007253901074305`, 0.19942460012505644`], 
           PlusMinus[4.607210221750233, 0.10687240090268894`], 
           PlusMinus[4.9240453356411, 0.2117669552928136], 
           PlusMinus[5.218423677384762, 0.33975545882237135`], 
           PlusMinus[5.708263434238852, 0.6673604689497475], 
           PlusMinus[4.968211713848885, 0.15020642061658435`], 
           PlusMinus[5.343926364038635, 0.3856897414724377], 
           PlusMinus[5.37519844040663, 0.4181847988563529], 
           PlusMinus[6.045164710295208, 0.8563677908123045], 
           PlusMinus[4.853519448611142, 0.33929379495103595`]}, 
         "StandardDeviationHistory" -> {
           PlusMinus[76.74130576173782, 20.133184863860674`], 
           PlusMinus[58.28970304905173, 23.196678417055615`], 
           PlusMinus[68.38084320457725, 20.39591645280951], 
           PlusMinus[89.09211614904633, 23.18025839272385], 
           PlusMinus[63.56958844187795, 20.374424014109845`], 
           PlusMinus[72.29092869864287, 18.957278841989773`], 
           PlusMinus[53.58179549098648, 26.544144136648875`], 
           PlusMinus[53.559070272588414`, 26.56911110581999], 
           PlusMinus[59.099008900939076`, 22.667095305281162`], 
           PlusMinus[58.05240302824335, 23.306648089548016`], 
           PlusMinus[68.73091100062679, 20.225194659002412`], 
           PlusMinus[58.92883770264328, 22.78239135664204], 
           PlusMinus[59.039218899097996`, 22.71482259445663], 
           PlusMinus[89.01603769671667, 23.21083075285697], 
           PlusMinus[68.6866119030229, 18.68326221254915], 
           PlusMinus[53.716751847442474`, 26.397078964812106`], 
           PlusMinus[58.98789423684934, 22.740745686513776`], 
           PlusMinus[63.68410732520861, 20.31373834623213], 
           PlusMinus[69.92255551210357, 19.246084903290967`], 
           PlusMinus[58.011423943197634`, 23.335744321324444`], 
           PlusMinus[68.31595842323122, 20.427891513564962`], 
           PlusMinus[68.74745407981122, 20.21705980204071], 
           PlusMinus[73.43084562094192, 18.923900073848717`], 
           PlusMinus[58.66337824092501, 22.940870684282405`]}, 
         "Configuration" -> {
          "NearestNeighbors", "NeighborsNumber" -> Automatic, 
           "DistributionSmoothing" -> 0.5, "NearestMethod" -> Automatic}, 
         "FinalTrainingSize" -> 68], 
        TypeSystem`Struct[{
         "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
          "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
          "ModelMemory", "ExperimentCount", "ModelUtility", 
          "MeanCrossEntropyHistory", "StandardDeviationHistory", 
          "Configuration", "FinalTrainingSize"}, {
         TypeSystem`AnyType, TypeSystem`AnyType, 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Vector[TypeSystem`AnyType, 24], 
          TypeSystem`Vector[TypeSystem`AnyType, 24], 
          TypeSystem`Tuple[{
            TypeSystem`Atom[String], TypeSystem`AnyType, TypeSystem`AnyType, 
            TypeSystem`AnyType}], 
          TypeSystem`Atom[Integer]}], 
        Association["ID" -> 139973131667052]], "Configurations" -> Dataset[
        Association[
        Association[
          "Value" -> "NearestNeighbors", "Options" -> 
           Association[
            "NeighborsNumber" -> Association["Value" -> Automatic], 
             "DistributionSmoothing" -> Association["Value" -> 0.5], 
             "NearestMethod" -> Association["Value" -> Automatic]]] -> 
         Association["Experiments" -> {
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[5.829383401718113, 0.18094778201842826`], 
              "StandardDeviation" -> 
              PlusMinus[81.96988855476671, 5.531558706784089], 
              "EvaluationTime" -> 7.202586206896549*^-6, "TestSize" -> 1102, 
              "TrainingSize" -> 10, "TrainingTime" -> 0.002988, 
              "TrainingMemory" -> 66166., "ModelMemory" -> 6664., 
              "ExperimentCount" -> 19, "ModelUtility" -> 
              0.00006258539287514141, "MeanCrossEntropyHistory" -> {
                PlusMinus[7.093048836985464, 0.7094141692029201], 
                PlusMinus[5.882874558692543, 0.14652977156409536`], 
                PlusMinus[5.7327145259003345`, 0.05863495207456022], 
                PlusMinus[5.9218882701610545`, 0.05867791838865379], 
                PlusMinus[5.728723297352821, 0.055039069336768984`], 
                PlusMinus[6.312419208289266, 0.4056225835108655], 
                PlusMinus[6.031730343153684, 0.06842897237002928], 
                PlusMinus[5.427524765841908, 0.06996373869767585], 
                PlusMinus[7.241363567135666, 0.53913582297076], 
                PlusMinus[6.194092792605175, 0.05555497372701752], 
                PlusMinus[5.60532591881416, 0.06734586201798812], 
                PlusMinus[7.500968438511631, 0.5744132179499154], 
                PlusMinus[6.272342721138336, 0.2003912157403409], 
                PlusMinus[5.7629711761063795`, 0.04551409756712291], 
                PlusMinus[5.857798587323504, 0.11851512429680237`], 
                PlusMinus[5.678622270432113, 0.092603623329658], 
                PlusMinus[6.735931892443647, 0.3934785119779946], 
                PlusMinus[8.442627808095121, 0.8416038197205725], 
                PlusMinus[5.850562485284825, 0.03921023434985686]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[113.77549557550083`, 15.34880523299821], 
                PlusMinus[86.36456442088812, 8.864202058156417], 
                PlusMinus[82.10517854127043, 7.584493962822692], 
                PlusMinus[83.92413862869078, 9.796045855621953], 
                PlusMinus[65.08114930424651, 9.901826772980485], 
                PlusMinus[56.847203157214196`, 6.865352013515046], 
                PlusMinus[115.67646521650704`, 11.410800981387826`], 
                PlusMinus[57.956242768541856`, 6.710935219310019], 
                PlusMinus[113.49637868494655`, 12.424747938625087`], 
                PlusMinus[113.81278776898931`, 9.779395691013224], 
                PlusMinus[78.00798182479588, 8.031234012504871], 
                PlusMinus[86.12764081987699, 7.012707904471427], 
                PlusMinus[115.56594162653401`, 12.318781725624273`], 
                PlusMinus[61.95485169569295, 10.122789662010183`], 
                PlusMinus[86.84189326308947, 9.370931397366894], 
                PlusMinus[73.33828412877378, 8.40513569217806], 
                PlusMinus[112.28446608861336`, 12.392749657699468`], 
                PlusMinus[117.41759872174715`, 12.637288488939847`], 
                PlusMinus[64.9160581268472, 9.926777305043446]}], 
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[4.84887949535413, 0.19977158565597572`], 
              "StandardDeviation" -> 
              PlusMinus[66.33900027650675, 4.849415225467425], 
              "EvaluationTime" -> 0.000017582857142857134`, "TestSize" -> 336,
               "TrainingSize" -> 54, "TrainingTime" -> 0.004218279999999998, 
              "TrainingMemory" -> 132107.51999999996`, "ModelMemory" -> 
              10568., "ExperimentCount" -> 24, "ModelUtility" -> 
              0.00009534136338873776, "MeanCrossEntropyHistory" -> {
                PlusMinus[6.1551189037672405`, 1.0270999118235975`], 
                PlusMinus[4.829348949509081, 0.3124347008419527], 
                PlusMinus[5.339552690424179, 0.3569026256133419], 
                PlusMinus[8.719812611383196, 2.910507209182495], 
                PlusMinus[5.18369607059009, 0.3078638475407605], 
                PlusMinus[5.588573510626969, 0.4860331457281926], 
                PlusMinus[4.763642973180476, 0.09035580864598801], 
                PlusMinus[4.743047034123813, 0.0924499866163027], 
                PlusMinus[4.896053895533484, 0.26710817690614647`], 
                PlusMinus[4.837820254529691, 0.24870042337139567`], 
                PlusMinus[5.357669688737493, 0.37299484957965134`], 
                PlusMinus[4.8844623412028705`, 0.2719092519120999], 
                PlusMinus[4.883547236113752, 0.3467759224476863], 
                PlusMinus[7.6588727569124355`, 2.1225295600229477`], 
                PlusMinus[5.1007253901074305`, 0.19942460012505644`], 
                PlusMinus[4.607210221750233, 0.10687240090268894`], 
                PlusMinus[4.9240453356411, 0.2117669552928136], 
                PlusMinus[5.218423677384762, 0.33975545882237135`], 
                PlusMinus[5.708263434238852, 0.6673604689497475], 
                PlusMinus[4.968211713848885, 0.15020642061658435`], 
                PlusMinus[5.343926364038635, 0.3856897414724377], 
                PlusMinus[5.37519844040663, 0.4181847988563529], 
                PlusMinus[6.045164710295208, 0.8563677908123045], 
                PlusMinus[4.853519448611142, 0.33929379495103595`]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[76.74130576173782, 20.133184863860674`], 
                PlusMinus[58.28970304905173, 23.196678417055615`], 
                PlusMinus[68.38084320457725, 20.39591645280951], 
                PlusMinus[89.09211614904633, 23.18025839272385], 
                PlusMinus[63.56958844187795, 20.374424014109845`], 
                PlusMinus[72.29092869864287, 18.957278841989773`], 
                PlusMinus[53.58179549098648, 26.544144136648875`], 
                PlusMinus[53.559070272588414`, 26.56911110581999], 
                PlusMinus[59.099008900939076`, 22.667095305281162`], 
                PlusMinus[58.05240302824335, 23.306648089548016`], 
                PlusMinus[68.73091100062679, 20.225194659002412`], 
                PlusMinus[58.92883770264328, 22.78239135664204], 
                PlusMinus[59.039218899097996`, 22.71482259445663], 
                PlusMinus[89.01603769671667, 23.21083075285697], 
                PlusMinus[68.6866119030229, 18.68326221254915], 
                PlusMinus[53.716751847442474`, 26.397078964812106`], 
                PlusMinus[58.98789423684934, 22.740745686513776`], 
                PlusMinus[63.68410732520861, 20.31373834623213], 
                PlusMinus[69.92255551210357, 19.246084903290967`], 
                PlusMinus[58.011423943197634`, 23.335744321324444`], 
                PlusMinus[68.31595842323122, 20.427891513564962`], 
                PlusMinus[68.74745407981122, 20.21705980204071], 
                PlusMinus[73.43084562094192, 18.923900073848717`], 
                PlusMinus[58.66337824092501, 22.940870684282405`]}]}, 
           "PredictedPerformances" -> 
           Association[
            "EvaluationTime" -> 0.000017582857142857134`, "ModelMemory" -> 
             10568., "StandardDeviation" -> 
             PlusMinus[66.33900027650675, 4.849415225467425], 
             "TrainingMemory" -> 132107.51999999996`, "TrainingTime" -> 
             0.0058564303999999985`], "Index" -> 1]], 
        TypeSystem`Assoc[
         TypeSystem`Struct[{"Value", "Options"}, {
           TypeSystem`Atom[String], 
           TypeSystem`Assoc[
            TypeSystem`Atom[String], 
            TypeSystem`Struct[{"Value"}, {TypeSystem`AnyType}], 3]}], 
         TypeSystem`Struct[{"Experiments", "PredictedPerformances", "Index"}, {
           TypeSystem`Vector[
            
            TypeSystem`Struct[{
             "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
              "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
              "ModelMemory", "ExperimentCount", "ModelUtility", 
              "MeanCrossEntropyHistory", "StandardDeviationHistory"}, {
             TypeSystem`AnyType, TypeSystem`AnyType, 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength]}], 
            2], 
           
           TypeSystem`Struct[{
            "EvaluationTime", "ModelMemory", "StandardDeviation", 
             "TrainingMemory", "TrainingTime"}, {
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real], TypeSystem`AnyType, 
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real]}], 
           TypeSystem`Atom[Integer]}], 1], 
        Association["ID" -> 139968836699756]], "MaxTrainingSize" -> 68, 
      "LastReportingTime" -> 3.745013611214394`16.326028389637244*^9, 
      "PreprocessorEvaluationTime" -> 3.76953125`2.*^-6, "PreprocessorMemory" -> 
      48112, "RoundPartitioning" -> Dataset[{
         Association[
         "TrainingSizes" -> 10, "TimeBudgets" -> 0.39999999999999997`, 
          "ElapsedTimes" -> 0.40074299999999996`, "ExperimentCounts" -> 19], 
         Association[
         "TrainingSizes" -> 54, "TimeBudgets" -> 0.5, "ElapsedTimes" -> 
          0.504789, "ExperimentCounts" -> 24]}, 
        TypeSystem`Vector[
         TypeSystem`Struct[{
          "TrainingSizes", "TimeBudgets", "ElapsedTimes", 
           "ExperimentCounts"}, {
           TypeSystem`Atom[Integer], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Integer]}], 2], 
        Association[
        "Origin" -> HoldComplete[GeneralUtilities`AssociationTranspose, 
           Dataset`DatasetHandle[139977426634348]], "ID" -> 
         139981721601644]]], "Log" -> 
    Association["Example" -> MachineLearning`MLDataset[
        Association[
        "f1" -> Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {0}, "ID" -> 
           1635758485550590698], "f2" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {3.517}, "ID" -> 
           3792239814675432237], "f3" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.283}, "ID" -> 
           6788520538275450158], "f4" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {6.3951}, "ID" -> 
           3665614283994286067], "f5" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {4.6226}, "ID" -> 
           4198949004418315711], "f6" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.258}, "ID" -> 
           2198503552849512914], "f7" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {19.768}, "ID" -> 
           380823439434077212], "f8" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {43.431}, "ID" -> 
           153932119762769494], "f9" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {22.2}, "ID" -> 
           3753923023160904854]], 
        Association[
        "ExampleNumber" -> 1, "ExampleWeights" -> 1, "RawExample" -> False]], 
      "TrainingTime" -> 1.183046, "MaxTrainingMemory" -> 553016, "DataMemory" -> 
      22624, "FunctionMemory" -> 151120, "LanguageVersion" -> {11.3, 0}, 
      "Date" -> DateObject[{2018, 9, 4, 1, 33, 31.583395`8.25203379258707}, 
        "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, "ProcessorType" -> 
      "x86-64", "OperatingSystem" -> "MacOSX", "SystemWordLength" -> 64, 
      "Evaluations" -> {}]]],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.74500835703795*^9, 3.7450084035746183`*^9, {3.745008643450995*^9, 
   3.7450086540204973`*^9}, 3.745008982739595*^9, 3.7450097460249767`*^9, {
   3.7450097816524563`*^9, 3.7450097934068317`*^9}, {3.745009971015251*^9, 
   3.745010011640894*^9}},
 CellLabel->
  "Out[200]=",ExpressionUUID->"d5f0c327-c57f-47e5-b48a-6d008cf8b117"],

Cell[BoxData["0.8989892680768204`"], "Output",
 CellChangeTimes->{
  3.74500835703795*^9, 3.7450084035746183`*^9, {3.745008643450995*^9, 
   3.7450086540204973`*^9}, 3.745008982739595*^9, 3.7450097460249767`*^9, {
   3.7450097816524563`*^9, 3.7450097934068317`*^9}, {3.745009971015251*^9, 
   3.745010011710022*^9}},
 CellLabel->
  "Out[201]=",ExpressionUUID->"78f206c4-009a-4216-b5b3-9aa6df309d0f"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["RandomForest", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009512787794*^9, 
  3.745009517388918*^9}},ExpressionUUID->"fe1b3969-a22c-4efd-a20b-\
4dd5f481af59"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"p", "=", 
  RowBox[{"Predict", "[", 
   RowBox[{"fxy", ",", 
    RowBox[{"Method", "\[Rule]", "\"\<RandomForest\>\""}], ",", " ", 
    RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rSQUARED", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"testfxy", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{
       RowBox[{"testfxy", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.745008532643311*^9, 3.7450086145288267`*^9}, {
   3.7450097867873297`*^9, 3.745009797176775*^9}, 3.7450100227157593`*^9},
 CellLabel->
  "In[202]:=",ExpressionUUID->"3082f434-e6f6-471f-8321-9de2e44eaa21"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["PredictorFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"RandomForest\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"RandomForest\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox[
                 "\"Number of training examples: \"", 
                  "SummaryItemAnnotation"], "\[InvisibleSpace]", 
                 TagBox["68", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  PredictorFunction[
   Association[
   "ExampleNumber" -> 68, "Input" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical"], "f2" -> 
           Association["Type" -> "Numerical"], "f3" -> 
           Association["Type" -> "Numerical"], "f4" -> 
           Association["Type" -> "Numerical"], "f5" -> 
           Association["Type" -> "Numerical"], "f6" -> 
           Association["Type" -> "Numerical"], "f7" -> 
           Association["Type" -> "Numerical"], "f8" -> 
           Association["Type" -> "Numerical"], "f9" -> 
           Association["Type" -> "Numerical"]], "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Preprocessor" -> 
         MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["Transpose", 
               Association["FeatureNumber" -> 9]], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {
                 "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical"}, 
                "FeatureKeys" -> {
                 "f1", "f2", "f3", "f4", "f5", "f6", "f7", "f8", "f9"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> False, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
         Association[
          "(f1f2f3f4f5f6f7f8f9)" -> 
           Association["Type" -> "NumericalVector", "Weight" -> 9]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
               Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2171448911019223696]], 
           MachineLearning`MLProcessor["ImputeMissing", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Imputed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Imputer" -> (DimensionReducerFunction[
               Association[
               "ExampleNumber" -> 68, "Imputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Fill" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, "Method" -> 
                   "Naive", "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "RandomImputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                   "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Method" -> "NaiveSampler", 
                   "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "Preprocessor" -> 
                MachineLearning`MLProcessor["ToMLDataset", 
                  Association[
                  "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 9]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> Automatic, 
                    "ExampleWeights" -> Automatic, "RawExample" -> 
                    Missing["KeyAbsent", "RawExample"]]]}]], "ScalarFeature" -> 
                   True, "Invertibility" -> "Perfect", "Missing" -> 
                   "Allowed"]], "Processor" -> 
                MachineLearning`MLProcessor["Identity"], "Padder" -> 
                MachineLearning`MLProcessor["Identity"], "PostProcessor" -> 
                MachineLearning`MLProcessor["FromMLDataset", 
                  Association[
                  "DatasetFormat" -> Automatic, "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 5]], 
                   "InversePreprocessor" -> 
                   MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> {1}, 
                    "ExampleWeights" -> 1]]}]], "ScalarFeature" -> True, 
                   "Invertibility" -> "Perfect", "Missing" -> "Allowed"]], 
                "Model" -> Association["Matrix" -> CompressedData["
1:eJwBeQGG/iFib1JlAgAAAAkAAAAFAAAAmVBmoywVlb8qELEgZU7Ov34Y3drR
FOo/qlyhgpR23r9Jb1K0KKfKPzVp3NEDrNa/abUD0TAL0j+AFISIiQfMPzFZ
17JLstg/v0E/ryvO4T+KlJfPjoLav6ZgG9zBpck/0LOIhqF1ej88VOIpEaG/
v2mJCAxiAse/TRYsbZN+0r8/Cw2zoo3Tv+9rc6GRntg/jnFgg2cz4j8pslyv
eGLiv+XQ0RgjLNu/KC+yDiZauD8yZxZFLjG+v+qmOUyfhdK/fQyWzeWfv7/n
NWRbIhLav6yDt//GmaW/7x/W+SY5wr/bXvcAlsTZv3qLeBRml9G/Hnk3HfuI
zr9MB8bKxNjhv+lUV0UsDdG/eRFvOOlQtr/0nv5/fCzQPy9kyAdK99a/IkxW
1nTN17+7W3GQWXrFv4i8XVVJ9sY/luetEIvW1j+4D+x3CeTSv6sQUsfGpuA/
l/Ljuh6CtD+ScbC9vFyGP6nsXqi+Tao/UEa+OQ==
                   "], "Processor" -> 
                  MachineLearning`MLProcessor["Standardize", 
                    Association[
                    "Invertibility" -> "Perfect", "Missing" -> "Allowed", 
                    "Input" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                    "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                    "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Output" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]]]], 
                  "FinalDimension" -> 5, "Method" -> "Linear"], 
                "PerformanceGoal" -> Automatic, "Invertibility" -> 
                "Approximate", "Log" -> 
                Association[
                 "TrainingTime" -> 0.007969, "MaxTrainingMemory" -> 66648, 
                  "DataMemory" -> 5240, "FunctionMemory" -> 22520, 
                  "LanguageVersion" -> {11.3, 0}, "Date" -> 
                  DateObject[{2018, 9, 4, 1, 33, 43.407058`8.390135329092345},
                     "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, 
                  "ProcessorType" -> "x86-64", "OperatingSystem" -> "MacOSX", 
                  "SystemWordLength" -> 64, "Evaluations" -> {}]]][#, 
               "ImputedVectors", PerformanceGoal -> "Quality"]& ), "Method" -> 
             "DimensionReduction", "VectorLength" -> 9, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Type" -> "NumericalVector", "Version" -> {11.3, 0}, "ID" -> 
             5500259897043576343]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
              6.145230441176471, 5.1866829411764686`, 4.129278823529412, 
              10.519120588235296`, 22.46829264705883, 39.538005882352955`, 
              12.08235294117647}, 
             "StandardDeviation" -> {0.42556704269130924`, 1.664271125991892, 
              3.9213244765540445`, 1.9849917286159486`, 2.252757467202552, 
              4.539697132504567, 6.700105806787766, 11.106504718564455`, 
              7.167141960044636}, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2687999288024534896]]}, 
         "Invertibility" -> "Perfect", "Missing" -> "Imputed"]]], "Output" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association["f1" -> Association["Type" -> "Numerical"]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["List"], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {"Numerical"}, "FeatureKeys" -> {"f1"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> True, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 2497458904888788241]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Mean" -> {399.8130735294119}, 
             "StandardDeviation" -> {132.8466718223454}, "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 8112975740502046413]], 
           MachineLearning`MLProcessor["FromVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 4157070569169933360]], 
           MachineLearning`MLProcessor["FirstValues", 
            Association[
            "Info" -> Association["Type" -> "Numerical", "Weight" -> 1], 
             "Key" -> "f1", "Invertibility" -> "Perfect", "Missing" -> 
             "Allowed"]]}, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "ProbabilityPostprocessor" -> Identity, 
      "InverseProcessorFunction" -> (399.8130735294119 + 
       132.8466718223454 #& ), 
      "ProcessorFunction" -> (-3.0095829127287295` + 
       0.007527474992653866 #& ), "Name" -> "value", 
      "Quantiles" -> {-2.4418456938327893`, 1.3884196264792183`}], "Prior" -> 
    Automatic, "Utility" -> (DiracDelta[#2 - #]& ), "Threshold" -> 0, 
    "PerformanceGoal" -> "Quality", "BatchProcessing" -> Automatic, "Model" -> 
    Association["Trees" -> {
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 2, 5, 9, 5, 7, 9, 9, 5, 7, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.0558598041534424`, \
-0.5507822632789612, -1.2672209739685059`, -0.9658291339874268, 
            0.1578642725944519, 0.9791416525840759, 1.3977185487747192`, 
            0.21676598489284515`, 0.636065661907196, 0.32337117195129395`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 9}, {-6, 8}, {-7, -8}, {10, 11}, {-9, -10}, {-11, -12}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.2723119258880615`, -2.1458051204681396`, \
-0.659655749797821, -0.5095729827880859, -0.20439393818378448`, 
            0.4606959819793701, 0.046371202915906906`, -0.19010694324970245`, 
            0.9351150393486023, 1.286439061164856, 0.840591549873352, 
            0.6004312038421631}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 2, 9, 3, 2, 6, 2, 6, 3, 8, 8, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.6212360858917236`, -1.0306596755981445`, \
-1.281173586845398, -1.0099471807479858`, 0.4761080741882324, 
            0.8302050232887268, 0.249342143535614, 
            0.12156745046377182`, -0.422977089881897, 0.4558584690093994, 
            0.3923821449279785, 0.9791416525840759}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {-2, 4}, {-3, -4}, {6, 11}, {
            7, 10}, {8, -8}, {9, -7}, {-5, -6}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3549389839172363`, -0.6968414783477783, \
-0.37033724784851074`, -0.26034829020500183`, 0.536666989326477, 
            0.7925573587417603, 0.3782322406768799, 0.9061468839645386, 
            1.1192560195922852`, 0.845959484577179, -0.3508034646511078, 
            0.4963837265968323, 0.035943176597356796`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 6, 7, 6, 9, 2, 6, 5, 8, 2, 6, 3}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.1642783880233765`, -1.6212360858917236`, 
            0.6647219657897949, 
            0.5652093887329102, -1.183505654335022, -1.0821794271469116`, \
-0.7300972938537598, -0.9966802000999451, 0.13577575981616974`, 
            0.9936319589614868, 0.3693813383579254, 0.3219497799873352}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 12}, {5, -11}, {6, 9}, {
            7, -6}, {8, -5}, {-3, -4}, {-7, 10}, {-8, 
            11}, {-9, -10}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3662939071655273`, -2.0531792640686035`, \
-0.32584989070892334`, -0.5128699541091919, -0.2903013229370117, \
-0.6922873854637146, 
            0.44642069935798645`, -0.4515211284160614, -0.09443022310733795, 
            0.028430715203285217`, 0.7725645303726196, 0.545508086681366, 
            1.0942585468292236`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 4, 9, 3, 1, 7, 9, 7, 5, 6, 5, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.0481107234954834`, \
-1.183505654335022, -1.1666288375854492`, -0.17827676236629486`, \
-0.3410830795764923, 0.29546603560447693`, 0.681885838508606, 
            0.3517117202281952, 0.8423203825950623, 0.8409343957901001, 
            0.4363309144973755}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 
            5}, {-4, -5}, {-6, 7}, {8, 10}, {9, -9}, {-7, -8}, {11, 
            12}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4060616493225098`, -2.106778144836426, \
-0.760166347026825, -0.3668520450592041, -0.5554566979408264, \
-0.042230766266584396`, 0.8091928958892822, 1.016442060470581, 
            1.0903066396713257`, 0.40194404125213623`, 0.3538886606693268, 
            0.7688708305358887, 0.6127510070800781}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 6, 6, 6, 1, 9, 7, 9, 2, 6, 3, 8, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1278971433639526`, -1.5546016693115234`, \
-1.6212360858917236`, -0.3271849453449249, -0.17827676236629486`, 
            0.9093788266181946, 0.7874065637588501, 
            0.29546603560447693`, -0.3795818090438843, 1.1046726703643799`, 
            0.3219497799873352, 0.3492542505264282, 0.8664142489433289}], 
          "Children" -> 
          RawArray["Integer16",{{2, 4}, {3, -3}, {-1, -2}, {5, 6}, {-4, -5}, {
            7, 12}, {8, -11}, {9, 11}, {-6, 10}, {-7, -8}, {-9, -10}, {-12, 
            13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3482773303985596`, -2.035402297973633, \
-1.281407356262207, -0.13787269592285156`, -0.6068882346153259, 
            0.7646178007125854, 0.9967901706695557, 0.8650944828987122, 
            0.4439849853515625, 0.8016077280044556, 
            1.265233039855957, -0.24786525964736938`, 
            0.23321567475795746`, -0.013560047373175621`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 6, 6, 9, 9, 4, 7, 7, 6, 8, 6, 8, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7229012846946716, -1.2151296138763428`, \
-1.6212360858917236`, -1.2672209739685059`, 
            0.9791416525840759, -0.3858368396759033, 0.681885838508606, 
            0.3136827051639557, 0.8423203825950623, 
            0.3776160180568695, -0.04562431946396828, 
            0.3492542505264282, -0.3410830795764923}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {3, 4}, {-1, -2}, {-3, -4}, {6, 12}, {
            7, 8}, {-5, -6}, {9, 10}, {-7, -8}, {11, -11}, {-9, -10}, {-12, 
            13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3728866577148438`, -2.0064525604248047`, \
-0.6543865203857422, -0.2765825390815735, 0.8755189776420593, 
            1.3486595153808594`, 0.18021473288536072`, 0.7069196701049805, 
            0.9496431350708008, 1.1392791271209717`, 
            0.6413933038711548, -0.3316987454891205, 0.06332056224346161, 
            0.018249809741973877`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 5, 3, 3, 9, 3, 9, 7, 6, 2, 7, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.3434245586395264`, -1.2609341144561768`, \
-0.6202573776245117, -1.1666288375854492`, -1.2672209739685059`, 
            1.0161795616149902`, 0.29546603560447693`, 
            0.7499444484710693, -0.02293558046221733, -0.2767139673233032, \
-0.2548157870769501, 1.5912402868270874`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 11}, {8, -10}, {9, -9}, {10, -8}, {-6, -7}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.231818914413452, -1.9747803211212158`, \
-0.760166347026825, -0.5549378395080566, -0.3723444938659668, 
            0.7917732000350952, 0.8808096051216125, 1.0258711576461792`, 
            1.3551914691925049`, 0.5098728537559509, -0.20672759413719177`, 
            0.08140532672405243, 0.8168207406997681}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 2, 1, 9, 7, 8, 4, 3, 4, 6, 5, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.1084744930267334`, \
-0.16858145594596863`, 0.9791416525840759, 0.4866650402545929, 
            0.3235936164855957, 0.25829681754112244`, 0.01266652625054121, 
            0.03839666396379471, 0.8528937697410583, 0.21898548305034637`, 
            0.7738609910011292}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, -13}, {5, 11}, {6, 
            8}, {-3, 7}, {-4, -5}, {-6, 9}, {10, -9}, {-7, -8}, {-10, 
            12}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3825669288635254`, -2.0748300552368164`, \
-0.0419323593378067, 0.3975028395652771, 0.7775800824165344, 
            0.8143869638442993, 1.2666815519332886`, 1.1415935754776, 
            0.8393654227256775, -0.2158484160900116, 0.10186123847961426`, 
            0.03071046806871891, -0.5874423980712891}], "NominalSplits" -> {},
           "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 6, 3, 8, 3, 7, 7, 5, 3, 7, 9, 5, 7}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-2.532660484313965, 
            0.6949537396430969, -0.9153872728347778, 0.14207836985588074`, 
            0.8917572498321533, 0.5323359966278076, 
            0.13025277853012085`, -0.2992238700389862, 
            1.1304266452789307`, -0.34809789061546326`, 0.29546603560447693`, 
            0.21676598489284515`, 0.6584534049034119}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 11}, {4, 5}, {-2, -3}, {6, 9}, {
            7, -7}, {-4, 8}, {-5, -6}, {-8, 10}, {-9, -10}, {12, 
            13}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.1288504600524902`, -0.6024469137191772, \
-0.39992034435272217`, -0.14012448489665985`, 0.5046338438987732, 
            0.33126115798950195`, 1.0487987995147705`, -0.4515361487865448, 
            0.01950313150882721, 0.10551207512617111`, 1.2936787605285645`, 
            1.0033891201019287`, 0.5186800956726074, 0.7581191062927246}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 3, 5, 2, 7, 7, 3, 2, 7, 2, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.532660484313965, -0.7905060052871704, \
-0.9966802000999451, -1.113134741783142, 
            0.5323359966278076, -0.2794422507286072, 1.1304266452789307`, 
            0.929940402507782, 
            0.08741762489080429, -0.07584524899721146, \
-0.22854401171207428`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {4, -4}, {-2, -3}, {6, 10}, {
            7, 8}, {-5, -6}, {9, -9}, {-7, -8}, {11, -12}, {-10, -11}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.0442004203796387`, -0.3492377698421478, \
-0.6868299841880798, -0.3629039525985718, -0.22991222143173218`, 
            0.04886781424283981, 0.47462937235832214`, 0.3630485236644745, 
            0.009160518646240234, 0.8623695373535156, 1.239601492881775, 
            0.664590060710907}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 8, 7, 3, 8, 7, 6, 5, 9, 5, 4, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7229012846946716, -2.532660484313965, \
-2.569286584854126, -1.0581196546554565`, -0.07257061451673508, 
            0.3136827051639557, 0.6949537396430969, 0.21898548305034637`, 
            0.29546603560447693`, -0.22185203433036804`, \
-0.11641506850719452`, -0.41570913791656494`}], "Children" -> 
          RawArray["Integer16",{{2, 6}, {3, 4}, {-1, -2}, {5, -5}, {-3, -4}, {
            7, 9}, {8, -8}, {-6, -7}, {10, -13}, {11, 
            12}, {-9, -10}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4109606742858887`, -2.093334674835205, \
-0.6165421009063721, -0.5216772556304932, -0.25273919105529785`, \
-0.1990065723657608, 0.06176489591598511, 0.6009855270385742, 
            1.0035699605941772`, 0.880164623260498, 1.367832064628601, 
            1.2127660512924194`, 0.8644019961357117}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 5, 8, 7, 6, 6, 7, 9, 2, 3, 9, 5}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.1642783880233765`, -0.7812997102737427, 
            0.3923821449279785, -0.2794422507286072, -0.05751938372850418, 
            0.09205006062984467, 0.7874065637588501, 
            0.29546603560447693`, -0.5103297233581543, -0.04935333505272865, 
            0.9093788266181946, 0.21676598489284515`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 7}, {-4, 
            6}, {-5, -6}, {8, 12}, {9, 11}, {-7, 
            10}, {-8, -9}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2465615272521973`, -0.6255688667297363, \
-0.3138135075569153, -0.4515511989593506, -0.17292922735214233`, 
            0.061112500727176666`, 0.364141047000885, 0.8689334988594055, 
            1.044456958770752, 0.45349472761154175`, 0.28895658254623413`, 
            1.378125786781311, 0.80524742603302}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 3, 9, 4, 2, 6, 7, 9, 5, 7, 9, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -1.1296006441116333`, \
-1.183505654335022, 
            0.08983264863491058, -1.096712589263916, -1.042122483253479, 
            0.1578642725944519, 1.327955722808838, 0.21676598489284515`, 
            0.33995094895362854`, 0.29546603560447693`, 0.6627020239830017}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {
            6, -5}, {-3, -4}, {8, 9}, {-7, -8}, {10, 11}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2536354064941406`, -2.129056215286255, \
-0.41441065073013306`, -0.5211502909660339, -0.24280321598052979`, \
-0.7176324129104614, 0.25431519746780396`, -0.17101511359214783`, 
            0.779868483543396, 1.185824990272522, 0.8499605655670166, 
            1.0110294818878174`, 0.633940577507019}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 4, 2, 9, 3, 7, 9, 7, 9, 7, 9, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.0481107234954834`, \
-1.0311282873153687`, -1.281173586845398, -1.0823971033096313`, 
            0.3136827051639557, 1.327955722808838, 0.08741762489080429, 
            0.32337117195129395`, 0.681885838508606, -0.7091184854507446, 
            0.21676598489284515`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 9}, {8, -8}, {-6, -7}, {10, -13}, {11, 
            12}, {-9, -10}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.397115468978882, -2.102609872817993, \
-0.6172008514404297, -0.40250468254089355`, -0.2527392506599426, 
            0.16538774967193604`, -0.06690473854541779, -0.22206483781337738`,
             0.9008462429046631, 1.0051206350326538`, 1.2870396375656128`, 
            1.17098069190979, 0.5125986337661743}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 4, 7, 9, 3, 4, 2, 4, 8, 8, 4, 9}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.5546016693115234`, -2.0481107234954834`, 
            0.6817365884780884, -1.183505654335022, 
            1.1959656476974487`, -0.5793892741203308, 
            0.3300982117652893, -0.11641506850719452`, 0.3442121744155884, 
            0.6646550297737122, -0.3858368396759033, -0.24868391454219818`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 11}, {-3, 5}, {6, 
            10}, {-4, 7}, {8, -8}, {-5, 9}, {-6, -7}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3941335678100586`, -2.070692777633667, \
-0.5438706874847412, 0.3632678687572479, 1.0213799476623535`, 
            0.7567703723907471, 0.8662888407707214, 0.5499021410942078, 
            0.03650662302970886, 0.4256556034088135, 1.1656063795089722`, 
            0.9349042773246765, 0.6814141273498535}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 8, 9, 5, 8, 7, 8, 6, 3, 7, 6, 4, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -2.695916175842285, \
-1.183505654335022, -0.9658291339874268, 0.3235936164855957, 
            0.13025277853012085`, 0.35051479935646057`, 0.6949537396430969, 
            1.2740005254745483`, 0.4866650402545929, 
            0.8528937697410583, -0.3112269639968872, -0.03823118656873703}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 10}, {-6, 8}, {9, -9}, {-7, -8}, {-10, 11}, {12, 
            13}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3824946880340576`, -2.0216641426086426`, \
-0.7117459177970886, -0.4423563480377197, -0.4027932584285736, \
-0.24784643948078156`, -0.028778091073036194`, 0.04571380093693733, 
            0.3312045633792877, 0.6465870141983032, 1.3030016422271729`, 
            1.0264232158660889`, 1.0533115863800049`, 0.6077451705932617}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 7, 4, 7, 2, 3, 7, 5, 2, 6, 3, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.5507822632789612, -2.288022518157959, \
-0.009563234634697437, 0.47487419843673706`, 0.5534993410110474, 
            0.8538618683815002, 
            0.6817365884780884, -0.22185203433036804`, -0.12078984826803207`, 
            0.6209399700164795, 1.1304266452789307`, -0.01236218772828579}], 
          "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 10}, {
            7, 9}, {8, -7}, {-5, -6}, {-8, -9}, {11, -13}, {
            12, -12}, {-10, -11}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2364375591278076`, -0.29549533128738403`, \
-0.523684561252594, -0.7544643878936768, 0.7228403091430664, 
            0.5559436082839966, 1.0118844509124756`, 0.9971264004707336, 
            0.9974989891052246, -0.2717348635196686, -0.04915875196456909, 
            0.04118978977203369, 0.3682316541671753}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 3, 6, 4, 4, 7, 3, 2, 2, 6, 3, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.5546016693115234`, -0.6202573776245117, \
-0.5475520491600037, -0.7579794526100159, 0.03839666396379471, 
            0.6817365884780884, 0.21616919338703156`, 
            0.4761080741882324, -0.9302433133125305, -0.8251036405563354, 
            1.2740005254745483`, 1.327955722808838}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {4, -4}, {-2, -3}, {6, 
            8}, {-5, 7}, {-6, -7}, {9, 11}, {-8, 10}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2015507221221924`, -0.37203097343444824`, \
-0.5553719997406006, -0.06820333003997803, 0.499758243560791, 
            1.1934454441070557`, 0.9148338437080383, 0.9612354040145874, 
            0.8609694838523865, 0.7917168140411377, 
            0.2000119984149933, -0.35084110498428345`, 0.2756781578063965}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 9, 3, 6, 3, 8, 2, 9, 6, 9, 7, 9, 3, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.183505654335022, \
-1.0185667276382446`, 
            0.6949537396430969, -0.7905060052871704, -0.2171705663204193, \
-1.1124558448791504`, -0.24868391454219818`, -0.01236218772828579, 
            1.327955722808838, 0.4866650402545929, -0.24868391454219818`, 
            0.6050938963890076, 0.7110242247581482}], "Children" -> 
          RawArray["Integer16",{{2, 4}, {-1, 3}, {-2, -3}, {5, 11}, {6, 
            8}, {-4, 7}, {-5, -6}, {-7, 9}, {-8, 10}, {-9, -10}, {-11, 
            12}, {-12, 13}, {-13, 14}, {-14, -15}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4023265838623047`, -2.0667855739593506`, \
-2.1697800159454346`, -0.6966909766197205, -0.4677239656448364, \
-0.36364537477493286`, 0.8000973463058472, -0.37662273645401, 
            0.1005815714597702, 0.07745338976383209, 0.6365252733230591, 
            1.344368815422058, 0.7296526432037354, 0.9426237344741821, 
            0.9003945589065552}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 6, 9, 7, 6, 3, 4, 5, 9, 5, 4, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7905060052871704, -1.2485018968582153`, \
-1.281173586845398, 0.587111234664917, 1.0625994205474854`, 
            0.6511752605438232, -0.5793892741203308, 
            0.4190957844257355, -0.7091184854507446, -0.22185203433036804`, 
            0.3111937642097473, 0.32337117195129395`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {-2, 4}, {-3, -4}, {6, 12}, {
            7, 11}, {-5, 8}, {9, -9}, {-6, 
            10}, {-7, -8}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.088404417037964, -0.6368582844734192, \
-0.28883084654808044`, -0.6006404161453247, 0.08463084697723389, 
            0.2608603537082672, 1.0383670330047607`, 0.6941230297088623, 
            1.2466206550598145`, 0.1516743004322052, -0.04786776378750801, 
            1.0218567848205566`, 0.6384197473526001}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 5, 3, 9, 3, 2, 2, 8, 4, 6, 5, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -0.9468746185302734, \
-1.1496703624725342`, 
            0.9791416525840759, -0.6819457411766052, -0.17378602921962738`, \
-0.8484176993370056, 0.11839855462312698`, 0.6978956460952759, 
            0.09205006062984467, 0.9512879848480225, 1.373213291168213}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 10}, {-4, 6}, {
            7, 9}, {-5, 8}, {-6, -7}, {-8, -9}, {-10, 11}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.291281223297119, -0.6679924726486206, \
-0.51670902967453, 0.06678858399391174, 0.7798233032226562, 
            1.0118577480316162`, 1.2013050317764282`, 0.44084855914115906`, 
            0.7835997343063354, -0.2801656424999237, 
            0.08110422641038895, -0.010693332180380821`, 
            0.0005790628492832184}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 7, 6, 9, 9, 9, 9, 8, 7, 8, 9, 2, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.8322520852088928, -2.3434245586395264`, \
-1.61870276927948, -1.2672209739685059`, 
            0.9791416525840759, -1.183505654335022, 
            0.29546603560447693`, -0.2223927229642868, 0.636065661907196, 
            0.24129951000213623`, 0.9093788266181946, 0.23480124771595, 
            0.3693813383579254}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {3, 4}, {-1, -2}, {-3, -4}, {6, 
            13}, {-5, 7}, {8, 11}, {-6, 9}, {10, -9}, {-7, -8}, {
            12, -12}, {-10, -11}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.1511647701263428`, -2.0463924407958984`, \
-0.6117960810661316, -0.37547215819358826`, -0.35582804679870605`, 
            0.3637985587120056, 0.9595229029655457, 0.9334027171134949, 
            1.2444943189620972`, 0.5944404006004333, 0.6459847092628479, 
            0.3834264278411865, -0.3409048318862915, 0.06287428736686707}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 6, 3, 8, 4, 7, 3, 7, 9, 4, 2, 4, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.5648038387298584`, -0.446686327457428, \
-0.7905060052871704, 0.14207836985588074`, -0.11581052839756012`, 
            0.03473189100623131, 1.1304266452789307`, 
            0.7874065637588501, -0.7091184854507446, -0.14769983291625977`, \
-0.07584524899721146, -0.06593626737594604, 0.15662889182567596`}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 6}, {4, -5}, {-2, 5}, {-3, -4}, {
            7, 8}, {-6, -7}, {9, -14}, {10, 11}, {-8, -9}, {12, 
            13}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2808494567871094`, -0.6308470964431763, \
-0.3883279263973236, -0.2386140078306198, 
            0.8860359191894531, -0.19525574147701263`, 0.06629392504692078, 
            0.19717788696289062`, 0.5569949150085449, 0.7414030432701111, 
            0.9699295163154602, 0.6074628829956055, 0.5419676303863525, 
            1.3301944732666016`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 4, 3, 5, 8, 9, 7, 7, 6, 2, 9, 9, 6, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2417094707489014`, -1.62674880027771, \
-0.9153872728347778, -0.9966802000999451, 0.14207836985588074`, 
            0.9093788266181946, 0.6817365884780884, 
            0.3171154856681824, -0.25680580735206604`, -0.35560736060142517`, 
            0.29546603560447693`, 1.3977185487747192`, 0.6949537396430969, 
            0.4999603033065796}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 12}, {8, 10}, {-6, 9}, {-7, -8}, {-9, 11}, {-10, -11}, {
            13, -15}, {14, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.021310806274414, -2.180479049682617, \
-0.6549510955810547, -0.47068604826927185`, -0.29733961820602417`, 
            0.5425070524215698, 0.9667304158210754, 0.5347288250923157, 
            0.9040266275405884, 1.2239443063735962`, 0.9752551317214966, 
            0.05882289633154869, 0.04830325022339821, 
            0.30286362767219543`, -0.09970195591449738}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 7, 2, 9, 3, 7, 9, 2, 3, 5, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.5507822632789612, -2.3434245586395264`, \
-1.0821794271469116`, -1.2672209739685059`, -1.1477832794189453`, 
            0.5323359966278076, 0.9791416525840759, 0.9936319589614868, 
            1.2740005254745483`, 0.21676598489284515`, -0.3779594898223877}], 
          "Children" -> 
          RawArray["Integer16",{{2, 6}, {-1, 3}, {4, -5}, {-2, 5}, {-3, -4}, {
            7, 10}, {-6, 8}, {-7, 9}, {-8, -9}, {-10, 11}, {-11, -12}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.2037665843963623`, -0.5039574503898621, \
-0.3856772184371948, -0.24895663559436798`, -0.6867546439170837, 
            0.43791282176971436`, -0.4515511989593506, -0.09089481085538864, 
            0.052415136247873306`, 1.247194766998291, 0.7417342662811279, 
            0.6896629333496094}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 6, 2, 9, 1, 9, 9, 8, 7, 4, 5, 7, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.532660484313965, -1.6212360858917236`, \
-0.8970876336097717, -1.183505654335022, -0.17827676236629486`, \
-1.2672209739685059`, 0.9093788266181946, 0.4091290831565857, 
            0.6584534049034119, -0.0008478328236378729, 
            1.0033131837844849`, -0.3743661344051361, 0.4326014220714569}], 
          "Children" -> 
          RawArray["Integer16",{{2, 4}, {-1, 3}, {-2, -3}, {5, 7}, {
            6, -6}, {-4, -5}, {8, 12}, {9, 11}, {-7, 
            10}, {-8, -9}, {-10, -11}, {-12, 13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.340200901031494, -1.9362401962280273`, \
-2.0950889587402344`, -0.5717348456382751, -0.310036838054657, \
-0.579149603843689, 0.6535875201225281, 1.3333561420440674`, 
            1.1491963863372803`, 0.6220600008964539, 
            0.7638649940490723, -0.1124647930264473, -0.08489540964365005, 
            0.12696537375450134`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 9, 7, 7, 6, 9, 7, 2, 9, 4, 8, 3, 2, 2}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.2151296138763428`, 
            0.32337117195129395`, -2.4491095542907715`, 
            0.6647219657897949, -0.446686327457428, -1.2672209739685059`, 
            0.47487419843673706`, 0.4761080741882324, -0.7091184854507446, 
            0.3111937642097473, 0.5603017807006836, 
            1.0722830295562744`, -0.30339232087135315`, -0.3779594898223877}],
           "Children" -> 
          RawArray["Integer16",{{2, 4}, {3, -3}, {-1, -2}, {5, 12}, {6, 
            8}, {-4, 7}, {-5, -6}, {9, 10}, {-7, -8}, {11, -11}, {-9, -10}, {
            13, -15}, {14, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.1005618572235107`, -1.9410581588745117`, \
-2.3095178604125977`, -0.5867596864700317, -0.26666510105133057`, \
-0.006609708070755005, 0.6264885663986206, 0.8445596694946289, 
            0.04965820163488388, 0.21807792782783508`, -0.035226624459028244`,
             0.982884407043457, 1.0609180927276611`, 1.1806106567382812`, 
            0.6301016807556152}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 8, 6, 9, 1, 6, 2, 7, 4, 5, 9, 6, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.3434245586395264`, -2.5579609870910645`, \
-0.01236218772828579, -1.183505654335022, -0.17827676236629486`, \
-0.8789838552474976, -1.1196054220199585`, -0.3051134943962097, 
            0.9419772624969482, 0.7464279532432556, -0.24868391454219818`, 
            0.12156745046377182`, 0.8423203825950623}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 10}, {5, 8}, {6, 
            7}, {-3, -4}, {-5, -6}, {-7, 9}, {-8, -9}, {11, 13}, {
            12, -12}, {-10, -11}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.315131902694702, -2.194413900375366, \
-0.4156903326511383, -0.2814001142978668, -0.5495476126670837, \
-0.6209269165992737, -0.2374827265739441, 0.5300616025924683, 
            0.9230899810791016, 1.2516906261444092`, 1.33000648021698, 
            0.7828719615936279, 0.10664118826389313`, 0.85792076587677}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 5, 6, 9, 6, 1, 9, 6, 7, 9, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -1.3901668787002563`, \
-0.05751938372850418, -1.183505654335022, -1.031438946723938, \
-0.17827676236629486`, 0.29546603560447693`, -0.02293558046221733, 
            0.7468101978302002, 0.9093788266181946, 1.6478806734085083`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {-3, 
            6}, {-4, -5}, {8, 10}, {-7, 9}, {-8, -9}, {11, -12}, {-10, -11}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-2.301738739013672, -2.097973585128784, \
-0.6648647785186768, -0.3773660361766815, -0.5963122248649597, 
            0.2953926920890808, 0.8849444389343262, 1.0637784004211426`, 
            1.3147916793823242`, 0.5281923413276672, 0.9137971997261047, 
            0.1991540491580963}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 6, 2, 3, 8, 9, 9, 5, 3, 5, 2, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2417094707489014`, -1.6212360858917236`, \
-1.0306596755981445`, -1.0581196546554565`, -0.2171705663204193, 
            0.9093788266181946, -0.7091184854507446, 0.10281673818826675`, 
            0.3219497799873352, 0.7464279532432556, 0.8599397540092468, 
            0.09205006062984467}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 11}, {-6, 8}, {-7, 9}, {-8, 10}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3829469680786133`, -1.9217872619628906`, \
-0.6398584842681885, -0.4066823124885559, -0.266664981842041, 
            0.055574800819158554`, 1.221320629119873, 0.5462645888328552, 
            1.1770782470703125`, 0.8177832365036011, 
            0.3667718768119812, -0.15887795388698578`, 
            0.047496747225522995`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 6, 9, 3, 8, 9, 4, 5, 1, 6, 7, 9, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2417094707489014`, -0.05751938372850418, \
-1.183505654335022, -1.0763533115386963`, -0.2171705663204193, \
-0.24868391454219818`, -0.06593626737594604, 
            0.10281673818826675`, -0.17827676236629486`, 0.49383899569511414`,
             0.03473189100623131, 1.327955722808838, 0.8538618683815002}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 8}, {4, 6}, {5, -4}, {-2, -3}, {
            7, -7}, {-5, -6}, {9, 11}, {10, -10}, {-8, -9}, {12, 
            13}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2495384216308594`, -0.6551844477653503, \
-0.6184502840042114, -0.3493839204311371, 0.5961905121803284, 
            0.5099820494651794, -0.4515400528907776, 1.347244381904602, 
            1.261694312095642, 0.8849444389343262, 0.22254547476768494`, 
            0.013112306594848633`, 0.6287769675254822, 0.924300491809845}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 7, 8, 9, 2, 6, 7, 9, 5, 5, 8, 9, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2609341144561768`, -2.4491095542907715`, \
-2.695916175842285, -1.183505654335022, -1.099058985710144, \
-0.8071949481964111, 0.1578642725944519, 0.9791416525840759, 
            0.20957478880882263`, 0.21676598489284515`, 0.24129951000213623`, 
            0.9093788266181946, 0.9769108295440674}], "Children" -> 
          RawArray["Integer16",{{2, 4}, {3, -3}, {-1, -2}, {5, 7}, {
            6, -6}, {-4, -5}, {8, 10}, {-7, 9}, {-8, -9}, {11, 
            12}, {-10, -11}, {13, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.441845655441284, -2.1969916820526123`, \
-1.0596652030944824`, -0.40942105650901794`, -0.3341526985168457, \
-0.505538284778595, 0.3936035931110382, -0.16239076852798462`, 
            0.04065748676657677, 0.9308997392654419, 1.367832064628601, 
            0.5442321300506592, 0.8435272574424744, 0.34068894386291504`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 8, 9, 9, 7, 9, 7, 6, 9, 7, 6, 7, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -2.703029155731201, \
-1.183505654335022, -1.2672209739685059`, 0.1578642725944519, 
            0.9791416525840759, -0.4245145916938782, 0.535912275314331, 
            0.29546603560447693`, 0.681885838508606, -0.14474987983703613`, 
            0.7499444484710693, 0.6584534049034119}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            9}, {-5, 7}, {-6, 8}, {-7, -8}, {10, 13}, {11, 
            12}, {-9, -10}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3773560523986816`, -2.1474952697753906`, \
-0.7131761312484741, -0.2978665828704834, 
            0.38362717628479004`, -0.31414464116096497`, \
-0.11466658115386963`, 0.0513518750667572, 0.7620885372161865, 
            0.9379566311836243, 1.1042574644088745`, 1.2491989135742188`, 
            0.5017395615577698, 0.7212218642234802}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 4, 3, 9, 2, 7, 6, 7, 9, 9, 4, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -1.62674880027771, \
-0.6202573776245117, -1.2672209739685059`, -1.0825189352035522`, \
-0.3051134943962097, -0.01236218772828579, 0.6817365884780884, 
            0.9093788266181946, 0.29546603560447693`, -0.40467822551727295`, 
            0.5808975100517273}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 8}, {-6, -7}, {9, 11}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.046527147293091, -2.2129054069519043`, \
-0.7117459177970886, -0.3047604262828827, 
            0.12080788612365723`, -0.37664151191711426`, 0.03631305694580078, 
            0.8205469250679016, 0.6120057106018066, 0.3654508590698242, 
            1.3290153741836548`, 0.785901665687561, 1.08378267288208}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 8, 6, 2, 2, 2, 4, 9, 7, 9, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6202573776245117, -2.532660484313965, \
-0.7859159708023071, -1.113134741783142, 
            0.5551817417144775, -0.836929202079773, -0.3112269639968872, \
-0.24868391454219818`, 0.7238255143165588, 0.9791416525840759, 
            0.2014070302248001}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 
            10}, {-5, 7}, {-6, 8}, {-7, 9}, {-8, -9}, {-10, 11}, {-11, -12}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-2.167245626449585, -0.3492377698421478, \
-0.5587686896324158, -0.6340749263763428, 0.6171044111251831, 
            1.1320055723190308`, 1.0281438827514648`, 0.8569799065589905, 
            0.7296525835990906, 
            0.4835096299648285, -0.3316987454891205, -0.08615248650312424}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 3, 3, 5, 5, 9, 6, 9, 7, 5, 4, 9, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -0.7905060052871704, \
-1.0581196546554565`, -0.8030064702033997, 
            0.10281673818826675`, -0.6951659321784973, 1.0625994205474854`, 
            0.9791416525840759, 0.6817365884780884, 0.5183519124984741, 
            0.19552578032016754`, 1.3977185487747192`, 0.8801030516624451}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {4, -4}, {-2, -3}, {6, 
            7}, {-5, -6}, {8, 13}, {9, 11}, {10, -9}, {-7, -8}, {-10, 
            12}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2251672744750977`, -0.4720899164676666, \
-0.5554567575454712, -0.2775799632072449, 0.6934680938720703, 
            1.2788044214248657`, 0.5025863647460938, 0.395975798368454, 
            0.9834792613983154, -0.11605916917324066`, 
            0.04647783935070038, -0.011728361248970032`, 0.9193826913833618, 
            0.7589722871780396}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 9, 9, 2, 7, 9, 5, 3, 8, 4, 9, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.532660484313965, -1.183505654335022, \
-1.2672209739685059`, -1.099058985710144, 0.1578642725944519, 
            0.9791416525840759, 0.2014070302248001, 1.8855286836624146`, 
            0.3776160180568695, -0.0008478328236378729, -0.7091184854507446, 
            0.29546603560447693`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {-2, 4}, {-3, -4}, {6, 
            9}, {-5, 7}, {-6, 8}, {-7, -8}, {10, 12}, {-9, 
            11}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.091169834136963, -0.6176148056983948, \
-0.3013856112957001, -0.44854018092155457`, 
            0.39075320959091187`, -0.30172431468963623`, -0.01825844496488571,
             0.10259139537811279`, 1.1064512729644775`, 0.7297467589378357, 
            0.968662440776825, 0.7686073780059814, 0.4774196147918701}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 4, 6, 7, 7, 2, 3, 8, 4, 6, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7229012846946716, -1.1642783880233765`, \
-1.6212360858917236`, 0.3642789125442505, 0.3136827051639557, 
            0.4761080741882324, 1.1304266452789307`, 0.5151930451393127, 
            0.19552578032016754`, 0.7577332258224487, 0.21676598489284515`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 5}, {3, 4}, {-1, -2}, {-3, -4}, {6, 
            10}, {-5, 7}, {-6, 8}, {9, -9}, {-7, -8}, {11, -12}, {-10, -11}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-2.3727598190307617`, -2.003523349761963, \
-0.4198116064071655, -0.5027230381965637, 
            0.5818356871604919, -0.398678183555603, 0.07562799006700516, 
            0.028430726379156113`, 0.19937966763973236`, 0.9913023114204407, 
            0.4880732595920563, 0.9362657070159912}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 5, 9, 6, 7, 7, 6, 2, 5, 9, 7, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.3434245586395264`, -0.5507822632789612, \
-1.2672209739685059`, -0.8789838552474976, 0.47487419843673706`, 
            0.1578642725944519, 0.2458048164844513, 1.45870041847229, 
            0.7738609910011292, 0.29546603560447693`, 
            0.6817365884780884, -0.17655526101589203`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 6}, {4, 5}, {-2, -3}, {-4, -5}, {
            7, 10}, {-6, 8}, {-7, 9}, {-8, -9}, {11, -13}, {
            12, -12}, {-10, -11}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2084779739379883`, -0.4473809599876404, \
-0.6291883587837219, -0.20721152424812317`, -0.4055432379245758, 
            0.26518484950065613`, 0.250641793012619, 0.10551206022500992`, 
            0.009762585163116455, 0.8131700754165649, 0.9740103483200073, 
            1.2581939697265625`, 0.503005862236023}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 2, 5, 4, 5, 3, 9, 9, 2, 2, 9, 5, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -0.8970876336097717, \
-0.5507822632789612, -0.009563234634697437, -0.9130938053131104, \
-1.0099471807479858`, 
            0.9093788266181946, -0.24868391454219818`, -0.3795818090438843, \
-0.05932150036096573, 0.9791416525840759, 0.21898548305034637`, 
            1.2788459062576294`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {
            6, -5}, {-3, -4}, {8, 11}, {9, 10}, {-7, -8}, {-9, -10}, {-11, 
            12}, {-12, 13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.017699718475342, -2.357976198196411, \
-0.36804139614105225`, -0.32927489280700684`, -0.5704767107963562, \
-0.682087779045105, 0.9803363084793091, 1.2973265647888184`, 
            0.9844200015068054, 0.6927456259727478, 
            0.42288923263549805`, -0.3766227066516876, 0.004523459356278181, 
            0.07449886202812195}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 8, 9, 7, 3, 3, 5, 4, 9, 8, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2485018968582153`, -2.703029155731201, \
-1.183505654335022, 0.3808458149433136, -0.9153872728347778, 
            1.0161795616149902`, 0.10281673818826675`, -0.11641506850719452`, 
            0.9093788266181946, 0.44442370533943176`, -0.3410830795764923}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 11}, {8, 9}, {-6, -7}, {10, -10}, {-8, -9}, {-11, -12}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.3773560523986816`, -2.1026101112365723`, \
-0.7357208728790283, -0.47779178619384766`, -0.4666888117790222, 
            1.2689586877822876`, 0.7714678645133972, 0.598561704158783, 
            1.1009576320648193`, 0.13623924553394318`, -0.23586969077587128`, 
            0.6995333433151245}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 6, 9, 2, 3, 9, 6, 6, 9, 2, 9, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.6212360858917236`, \
-1.183505654335022, -1.0821794271469116`, -1.0581196546554565`, 
            0.32337117195129395`, -0.04562431946396828, -0.8251036405563354, \
-0.24868391454219818`, -0.30339232087135315`, 0.9791416525840759, 
            0.3693813383579254}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 11}, {8, 9}, {-6, -7}, {-8, 10}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3511834144592285`, -2.0016350746154785`, \
-0.46887731552124023`, -0.283558189868927, -0.746312141418457, 
            0.9010757803916931, 0.5281046628952026, 1.1901029348373413`, 
            1.0634585618972778`, 0.8206221461296082, 
            0.35734373331069946`, -0.27650728821754456`, 
            0.042293816804885864`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 3, 9, 5, 9, 7, 9, 5, 2, 8, 5, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.61870276927948, -0.6202573776245117, \
-1.2672209739685059`, -1.0707671642303467`, 0.9093788266181946, 
            0.681885838508606, -0.6951659321784973, 
            1.4784197807312012`, -0.30339232087135315`, 0.3492542505264282, 
            0.9182174205780029, 0.4326014220714569}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {4, -4}, {-2, -3}, {6, 10}, {
            7, 9}, {-5, 8}, {-6, -7}, {-8, -9}, {-10, 11}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2241933345794678`, -0.7174452543258667, \
-0.52298903465271, -0.16199275851249695`, 0.9843699336051941, 
            0.717006504535675, 0.9242753386497498, 1.0109732151031494`, 
            1.2789323329925537`, -0.2886114716529846, 0.40344953536987305`, 
            0.0031384038738906384`, 0.06380986422300339}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 5, 2, 7, 9, 7, 4, 9, 6, 4, 3, 3, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -0.7812997102737427, \
-1.0821794271469116`, 0.47487419843673706`, 0.9791416525840759, 
            0.6817365884780884, 
            0.25829681754112244`, -0.7091184854507446, -0.18305639922618866`, 
            1.914626121520996, 0.6627020239830017, 
            0.06142556294798851, -0.3545157015323639}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {4, -4}, {-2, -3}, {6, 13}, {
            7, 12}, {8, 10}, {-5, 9}, {-6, -7}, {
            11, -10}, {-8, -9}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.0252742767333984`, -0.31427639722824097`, \
-0.4938066601753235, -0.685926616191864, 0.2719570994377136, 
            0.8809360265731812, 0.46103477478027344`, 0.9129090309143066, 
            0.6218593120574951, 0.8849442005157471, 1.0704439878463745`, 
            0.8847373723983765, -0.10953284800052643`, 0.01853209361433983}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 4, 2, 1, 9, 8, 3, 9, 8, 4, 3, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6202573776245117, -1.1642783880233765`, \
-1.0821794271469116`, -0.17827676236629486`, 0.9791416525840759, 
            0.3776160180568695, -0.22860398888587952`, 0.9093788266181946, 
            0.44442370533943176`, 0.08378727734088898, 1.1304266452789307`, 
            0.23994894325733185`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 11}, {
            7, 8}, {-5, -6}, {9, -10}, {-7, 10}, {-8, -9}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2206552028656006`, -0.386279433965683, \
-0.5412808656692505, -0.6886082291603088, 0.982538104057312, 
            1.0359231233596802`, 0.5733446478843689, 0.7369919419288635, 
            0.7822321653366089, 
            0.404541015625, -0.16871385276317596`, -0.4515587091445923, \
-0.00017368793487548828`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 6, 9, 2, 2, 2, 7, 3, 6, 3, 5, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2417094707489014`, -0.3271849453449249, \
-1.2672209739685059`, -1.0306596755981445`, -1.099058985710144, 
            0.7967289090156555, 0.3171154856681824, -0.36763864755630493`, 
            0.8302050232887268, 0.6050938963890076, 0.21898548305034637`, 
            1.8855286836624146`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 6}, {4, 5}, {-2, -3}, {-4, -5}, {
            7, 11}, {-6, 8}, {-7, 9}, {-8, 10}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.086545944213867, -0.6043288111686707, \
-0.6367533802986145, -0.30322983860969543`, -0.007279586978256702, 
            0.5812861323356628, 1.0720304250717163`, 0.6415005922317505, 
            1.1095454692840576`, 0.8319888114929199, -0.3122251629829407, 
            0.022493423894047737`, 0.10113108158111572`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 4, 9, 2, 2, 7, 9, 8, 3, 6, 7, 3, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -2.0481107234954834`, \
-1.183505654335022, -1.1196054220199585`, -1.096712589263916, 
            0.13025277853012085`, 0.9791416525840759, 0.35051479935646057`, 
            1.2788459062576294`, -0.08395286649465561, 0.681885838508606, 
            0.8829082250595093, -0.3858368396759033}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 10}, {-6, 8}, {-7, 9}, {-8, -9}, {-10, 11}, {12, -14}, {-11, 
            13}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.397115468978882, -2.2798993587493896`, \
-0.3133730888366699, -0.5275862216949463, -0.430067777633667, 
            0.5064253807067871, -0.22021685540676117`, -0.009206656366586685, 
            0.05342194065451622, 0.6950450539588928, 0.5494223237037659, 
            1.0272663831710815`, 0.8029888868331909, 1.2748149633407593`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 6, 9, 9, 4, 7, 2, 3, 6, 6, 6, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6557202935218811, -1.1160701513290405`, \
-1.2672209739685059`, 0.9093788266181946, -0.3112269639968872, 
            0.7521832585334778, -0.3103022277355194, 0.21616919338703156`, 
            1.5447901487350464`, 0.6209399700164795, 0.2458048164844513, 
            0.6709080934524536}], "Children" -> 
          RawArray["Integer16",{{2, 4}, {-1, 3}, {-2, -3}, {5, 10}, {6, 
            7}, {-4, -5}, {-6, 8}, {-7, 9}, {-8, -9}, {11, 
            12}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-1.3486605882644653`, -0.6186525225639343, \
-0.4813864231109619, 1.0043226480484009`, 1.3336046934127808`, 
            0.2919299900531769, 1.049242377281189, 0.6246631741523743, 
            0.9141586422920227, -0.17669296264648438`, -0.018992364406585693`,
             0.33880358934402466`, 0.4312109053134918}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 4, 3, 2, 9, 6, 3, 4, 6, 9, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6557202935218811, -1.2417094707489014`, \
-0.9153872728347778, -1.0821794271469116`, 
            0.29546603560447693`, -0.7859159708023071, -0.41570913791656494`, \
-0.3112269639968872, 0.6209399700164795, 1.3977185487747192`, 
            0.32337117195129395`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 
            9}, {-5, 7}, {-6, 8}, {-7, -8}, {10, 11}, {-9, -10}, {-11, -12}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-2.2787868976593018`, -0.43377774953842163`, \
-0.705573320388794, -0.29759931564331055`, 0.7066562175750732, 
            1.3201563358306885`, 1.2116745710372925`, 1.0619207620620728`, 
            0.007830530405044556, -0.19012199342250824`, 0.42499691247940063`,
             0.5719896554946899}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 3, 9, 4, 8, 3, 9, 9, 4, 3, 9, 5, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.1296006441116333`, \
-1.183505654335022, 0.08983264863491058, 
            0.14207836985588074`, -1.1477832794189453`, 0.9093788266181946, 
            0.32337117195129395`, 0.27638253569602966`, -0.20404596626758575`,
             0.9791416525840759, 0.21898548305034637`, 0.4999603033065796}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {
            6, -5}, {-3, -4}, {8, 11}, {9, -10}, {10, -9}, {-7, -8}, {-11, 
            12}, {-12, 13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.374446153640747, -2.110598564147949, \
-0.38006651401519775`, -0.5678582191467285, -0.2901923358440399, \
-0.6659413576126099, 1.0150998830795288`, 1.2026307582855225`, 
            0.8913353085517883, 0.6214275360107422, 
            0.3806600868701935, -0.301705539226532, 
            0.03454679250717163, -0.016470670700073242`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 2, 7, 1, 9, 9, 7, 5, 3, 3, 7, 2, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.5546016693115234`, -1.0311282873153687`, \
-0.20048826932907104`, -0.17827676236629486`, 
            0.9093788266181946, -0.7091184854507446, 0.681885838508606, 
            1.1354622840881348`, 
            0.5910680294036865, -0.41570913791656494`, -0.4030223786830902, 
            1.214088797569275, 0.5151930451393127}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {-2, 4}, {-3, -4}, {6, 
            11}, {-5, 7}, {8, 9}, {-6, -7}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, 13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2095580101013184`, -0.28156954050064087`, \
-0.4820675849914551, -0.5539377331733704, 0.2608603537082672, 
            0.7263593673706055, 0.9531935453414917, 1.3575382232666016`, 
            1.2751309871673584`, 1.0138521194458008`, -0.4515587091445923, 
            0.28348037600517273`, 0.049916286021471024`, 
            0.004132026340812445}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 5, 2, 4, 4, 7, 5, 9, 6, 6, 6, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.3901668787002563`, -0.5507822632789612, \
-1.0821794271469116`, -0.11581052839756012`, -0.734301745891571, 
            0.13025277853012085`, 0.9879986047744751, 
            0.29546603560447693`, -0.02293558046221733, 0.9524598717689514, 
            1.4119619131088257`, 0.21302779018878937`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 6}, {4, -5}, {5, -4}, {-2, -3}, {
            7, 8}, {-6, -7}, {9, 11}, {-8, 10}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.32216215133667, -0.33126968145370483`, \
-0.4807061553001404, -0.23622027039527893`, -0.7141870260238647, \
-0.0238601453602314, 0.30124521255493164`, 0.9054756164550781, 
            1.2768373489379883`, 0.9818227291107178, 0.4439849853515625, 
            0.4199347496032715, 0.9737309217453003}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 4, 3, 3, 4, 3, 5, 7, 6, 6, 2, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.6222652196884155`, \
-0.7905060052871704, -1.0763533115386963`, -0.0008478328236378729, 
            0.01266652625054121, 0.7464279532432556, 0.13025277853012085`, 
            0.6949537396430969, 0.535912275314331, -0.5103297233581543, 
            0.6697219610214233}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            8}, {-5, 7}, {-6, -7}, {9, 11}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.298144578933716, -2.112025260925293, \
-0.5025681257247925, -0.32741817831993103`, 0.7058910131454468, 
            1.2737762928009033`, 1.0380910634994507`, -0.0634295642375946, 
            0.05882289260625839, 0.32350775599479675`, 0.6353333592414856, 
            1.0344024896621704`, 0.7375564575195312}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{2, 2, 2, 5, 7, 9, 3, 5, 8, 6, 6, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6281591057777405, -0.836929202079773, \
-1.0306596755981445`, -1.1973676681518555`, 0.47487419843673706`, 
            0.9093788266181946, -0.6202573776245117, 0.7464279532432556, 
            0.24129951000213623`, -0.02293558046221733, 0.6209399700164795, 
            1.5302633047103882`}], "Children" -> 
          RawArray["Integer16",{{2, 6}, {3, -5}, {4, -4}, {-1, 5}, {-2, -3}, {
            7, 11}, {-6, 8}, {9, -10}, {10, -9}, {-7, -8}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-0.754464328289032, -0.31427639722824097`, \
-0.4367295503616333, 
            0.7806729078292847, -2.2486793994903564`, -0.03297841548919678, 
            0.946801483631134, 1.0634584426879883`, 1.321744680404663, 
            0.7699497938156128, -0.23779724538326263`, 0.06372202932834625, 
            0.23948605358600616`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 3, 2, 9, 3, 6, 5, 7, 2, 9, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1278971433639526`, -0.9153872728347778, \
-1.1196054220199585`, 0.9093788266181946, -0.36763864755630493`, 
            1.1046726703643799`, 0.5183519124984741, 0.636065661907196, 
            0.4363309144973755, 0.9791416525840759, 0.3693813383579254}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 10}, {-4, 6}, {
            7, 9}, {8, -7}, {-5, -6}, {-8, -9}, {-10, 11}, {-11, -12}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.081723690032959, -0.5448241233825684, \
-0.3842792809009552, 1.1267646551132202`, 0.9021985530853271, 
            0.7527565360069275, 1.1248825788497925`, 0.8165009021759033, 
            0.620135486125946, 0.40676161646842957`, -0.26596882939338684`, 
            0.04411797598004341}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 2, 2, 7, 6, 4, 9, 2, 8, 8, 5, 8, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -0.8970876336097717, \
-1.096712589263916, 
            0.3642789125442505, -0.9565441012382507, -0.0008478328236378729, 
            0.29546603560447693`, -0.8745132088661194, -0.04402878135442734, 
            0.3442121744155884, -0.22185203433036804`, 0.4001253545284271, 
            0.929940402507782}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 10}, {8, -9}, {-6, 9}, {-7, -8}, {11, 12}, {-10, -11}, {-12, 
            13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-1.933349609375, -2.1833858489990234`, \
-0.28156954050064087`, -0.3324928283691406, -0.5358916521072388, 
            0.6485441327095032, 0.8442584276199341, 1.2187612056732178`, 
            0.2662995755672455, 0.6492780447006226, 
            0.9571330547332764, -0.1707274615764618, 0.48453301191329956`, 
            0.024907827377319336`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 9, 6, 4, 6, 2, 9, 2, 3, 7, 5, 5, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.349409580230713, -1.183505654335022, \
-1.031438946723938, -0.734301745891571, -0.5475520491600037, 
            0.5534993410110474, 
            0.29546603560447693`, -0.3103022277355194, -0.22860398888587952`, 
            0.681885838508606, 0.21898548305034637`, 0.9182174205780029, 
            0.5063772797584534}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 6}, {-2, 4}, {-3, 5}, {-4, -5}, {
            7, 11}, {8, -10}, {9, 10}, {-6, -7}, {-8, -9}, {-11, 12}, {-12, 
            13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.26094126701355, -0.6793965697288513, \
-0.32273852825164795`, -0.5551555752754211, -0.3423915505409241, 
            0.4933840334415436, 0.7735567092895508, 0.9701178669929504, 
            1.2925946712493896`, 0.4933731257915497, -0.3316836953163147, 
            0.31466296315193176`, -0.002883576089516282, 
            0.14480549097061157`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 9, 3, 8, 3, 6, 2, 2, 9, 6, 2, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7905060052871704, -1.183505654335022, \
-1.0763533115386963`, -0.07257061451673508, 
            1.0161795616149902`, -0.01236218772828579, 
            0.3236089050769806, -0.5103297233581543, 0.32337117195129395`, 
            0.7231494188308716, 0.929940402507782, -0.3743661344051361}], 
          "Children" -> 
          RawArray["Integer16",{{2, 5}, {3, -4}, {4, -3}, {-1, -2}, {6, 11}, {
            7, 9}, {8, -7}, {-5, -6}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-0.5819534063339233, -0.4172334671020508, \
-0.2599791884422302, -2.006453037261963, 0.6188482046127319, 
            0.9665988087654114, 0.27156829833984375`, 1.3030016422271729`, 
            0.9638375043869019, 0.4365701675415039, 
            0.696682333946228, -0.22547101974487305`, 0.009812772274017334}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 7, 3, 8, 7, 8, 2, 5, 7, 2, 8, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7812997102737427, -2.288022518157959, \
-1.0581196546554565`, 0.14207836985588074`, 0.03473189100623131, 
            0.3492542505264282, -1.0825189352035522`, 0.7043461799621582, 
            0.6817365884780884, -0.2767139673233032, 0.13055358827114105`, 
            0.15662889182567596`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 
            7}, {-5, -6}, {-7, 8}, {9, 12}, {10, -11}, {-8, 
            11}, {-9, -10}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.252932548522949, -0.5406087636947632, \
-0.44508516788482666`, -0.3177579641342163, -0.2863360345363617, 
            0.09690921753644943, -0.403796911239624, 0.5691103935241699, 
            0.7325883507728577, 0.8690428137779236, 1.1494439840316772`, 
            0.9480623602867126, 0.4952309727668762}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 9, 3, 2, 1, 7, 5, 7, 5, 4, 3, 5}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.1642783880233765`, 
            0.32337117195129395`, -0.7905060052871704, -1.0990667343139648`, \
-0.17827676236629486`, 0.03473189100623131, 0.21898548305034637`, 
            0.3171154856681824, 0.10281673818826675`, 0.03839666396379471, 
            0.3219497799873352, 1.3387242555618286`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 8}, {-6, -7}, {-8, 9}, {10, 11}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3085854053497314`, -2.1697797775268555`, \
-0.37660765647888184`, -0.540100634098053, -0.5805670022964478, \
-0.28858137130737305`, -0.003259937046095729, 0.5069648623466492, 
            1.1811280250549316`, 0.8830626010894775, 0.556577205657959, 
            0.9625602960586548, 0.6862460970878601}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 5, 9, 9, 2, 4, 2, 2, 9, 6, 8, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -1.3901668787002563`, \
-1.183505654335022, -1.2672209739685059`, 
            0.929940402507782, -0.3112269639968872, -0.05932150036096573, \
-0.5103297233581543, -0.24868391454219818`, 0.8423203825950623, 
            0.35051479935646057`, 1.0943571329116821`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            11}, {-5, 7}, {8, 10}, {-6, 9}, {-7, -8}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.155165672302246, -2.0483617782592773`, \
-0.6218979358673096, -0.37746956944465637`, 1.1203231811523438`, 
            0.5040542483329773, 1.1673376560211182`, 0.9844200015068054, 
            0.26345106959342957`, 0.6232368350028992, -0.39158734679222107`, 
            0.056451741605997086`, -0.024035777896642685`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 4, 7, 4, 5, 4, 2, 3, 2, 7, 3, 6}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.2151296138763428`, -2.0481107234954834`, 
            0.64442378282547, 
            0.608776867389679, -0.7812997102737427, -0.734301745891571, \
-0.5103297233581543, 1.588435173034668, 0.4761080741882324, 
            0.21025151014328003`, -0.20404596626758575`, 
            1.0511448383331299`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 11}, {5, 9}, {6, 
            7}, {-3, -4}, {-5, 8}, {-6, -7}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4077656269073486`, -2.1123178005218506`, \
-0.33326447010040283`, -0.5598198175430298, -0.1324464976787567, 
            0.2586836516857147, 0.06828868389129639, 0.6927868127822876, 
            0.9119682312011719, -0.13578113913536072`, 0.6158297061920166, 
            1.1110697984695435`, 0.7484148740768433}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 8, 9, 3, 7, 9, 6, 5, 3, 2, 6, 6, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7229012846946716, -2.5346412658691406`, \
-1.2672209739685059`, -1.127407431602478, 0.1578642725944519, 
            1.3977185487747192`, 0.6949537396430969, 
            0.6337660551071167, -0.41570913791656494`, -0.07584524899721146, \
-0.08395286649465561, 1.381563425064087, 0.4041770398616791}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {-2, 4}, {-3, -4}, {6, 9}, {
            7, -8}, {8, -7}, {-5, -6}, {-9, 10}, {11, 13}, {-10, 
            12}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.185307502746582, -0.5944893956184387, \
-0.45727962255477905`, 0.0549086332321167, 0.2373557984828949, 
            0.0253143310546875, 0.3049148917198181, -0.31724345684051514`, 
            1.3678319454193115`, 0.773556649684906, 1.173924207687378, 
            1.0685396194458008`, 0.5034595727920532, 0.6964063048362732}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 4, 2, 1, 4, 2, 3, 4, 2, 2, 5, 6, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.62674880027771, \
-1.0821794271469116`, -0.17827676236629486`, -0.734301745891571, 
            0.4761080741882324, 0.01266652625054121, 
            0.0008146425825543702, -0.5103297233581543, -0.30339232087135315`,
             0.21898548305034637`, -0.12485867738723755`, 
            0.8599397540092468}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 11}, {8, 10}, {9, -8}, {-6, -7}, {-9, -10}, {12, 
            13}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-1.9266051054000854`, -2.235750675201416, \
-0.31625235080718994`, -0.34429216384887695`, -0.5473566055297852, 
            0.4727210998535156, 0.8833448886871338, 0.8875540494918823, 
            1.1097400188446045`, 
            0.8117696642875671, -0.5930752158164978, -0.24784648418426514`, 
            0.5199748277664185, 0.00846786517649889}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 6, 5, 3, 5, 7, 4, 1, 7, 9, 9, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -1.8904610872268677`, \
-0.5507822632789612, -1.127407431602478, -0.9966802000999451, 
            0.1578642725944519, 0.3111937642097473, -0.17827676236629486`, 
            0.6817365884780884, 0.29546603560447693`, -0.6951659321784973, 
            0.21616919338703156`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 9}, {8, -8}, {-6, -7}, {10, 12}, {
            11, -11}, {-9, -10}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4023265838623047`, -2.0064523220062256`, \
-0.6043288111686707, -0.5737672448158264, -0.10549561679363251`, 
            0.04541270434856415, 0.036673303693532944`, -0.25704342126846313`,
             0.9397068023681641, 0.7285460829734802, 0.38402843475341797`, 
            1.2943906784057617`, 0.9468686580657959}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 8, 4, 8, 2, 7, 5, 2, 3, 5, 5}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-0.6202573776245117, -2.5346412658691406`, 
            0.08983264863491058, -0.25192496180534363`, 0.5551817417144775, 
            0.7499444484710693, -0.4755411148071289, 0.15662889182567596`, 
            0.6627020239830017, 0.21898548305034637`, 1.4784197807312012`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 10}, {
            7, -9}, {-5, 8}, {9, -8}, {-6, -7}, {-10, 11}, {-11, -12}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.2716498374938965`, -0.5737673044204712, \
-0.37981435656547546`, -0.7149074077606201, 1.1434755325317383`, 
            0.7817052006721497, 0.9797026515007019, 0.5812107920646667, 
            1.2431697845458984`, -0.40006327629089355`, 0.3759312331676483, 
            0.03274284303188324}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 9, 9, 2, 7, 6, 7, 7, 8, 9, 5, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -1.183505654335022, \
-1.2672209739685059`, 0.7967289090156555, 
            0.6817365884780884, -0.25680580735206604`, 0.6171107292175293, 
            0.9130762219429016, 0.4091290831565857, 0.9791416525840759, 
            0.20957478880882263`, 0.4999603033065796}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 10}, {6, 
            8}, {-4, 7}, {-5, -6}, {9, -9}, {-7, -8}, {-10, 11}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.230717420578003, -0.5588521361351013, \
-0.31905919313430786`, 0.972225546836853, 0.7545183897018433, 
            0.5599960088729858, 1.157363772392273, 0.9001122713088989, 
            1.2737572193145752`, 0.40898972749710083`, -0.1771446317434311, 
            0.05317729339003563, -0.021009737625718117`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 8, 7, 6, 2, 8, 9, 5, 4, 4, 5, 7, 6}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-2.532660484313965, -0.07257061451673508, 
            0.3171154856681824, -1.031438946723938, -1.0821794271469116`, 
            0.14207836985588074`, 0.9093788266181946, 
            0.21676598489284515`, -0.0008478328236378729, -0.5836713910102844,
             0.7043461799621582, -0.2794422507286072, 0.09205006062984467}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 5}, {-2, 4}, {-3, -4}, {6, 
            7}, {-5, -6}, {8, 12}, {9, 10}, {-7, -8}, {-9, 11}, {-10, -11}, {
            13, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray["Real32",{-2.0677239894866943`, 
            0.3663390576839447, -0.7544642686843872, -0.4273427128791809, \
-0.3894382417201996, -0.30530741810798645`, 1.2164318561553955`, 
            0.9028034210205078, 0.7126631736755371, 1.0832709074020386`, 
            0.8418710231781006, -0.23732678592205048`, 0.06277483701705933, 
            0.2723020911216736}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 4, 5, 1, 4, 4, 9, 3, 9, 7, 7, 3}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6202573776245117, -1.2417094707489014`, \
-0.9658291339874268, -0.17827676236629486`, -0.0008478328236378729, \
-0.6710269451141357, -0.24868391454219818`, -0.22735442221164703`, 
            0.9791416525840759, 0.08741762489080429, 0.3314436376094818, 
            1.2740005254745483`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {-2, 4}, {-3, -4}, {6, 
            9}, {-5, 7}, {8, -8}, {-6, -7}, {10, 12}, {-9, 
            11}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.231468915939331, -0.664217472076416, \
-0.3420715928077698, -0.5635299682617188, 1.1882319450378418`, 
            0.9013919830322266, 1.2651007175445557`, 0.38249826431274414`, 
            0.515684187412262, 0.8638299107551575, 
            0.9926437139511108, -0.10852415859699249`, 0.06828869879245758}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 7, 9, 7, 4, 1, 3, 2, 8, 9, 6, 8, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.4491095542907715`, \
-1.183505654335022, -0.20048826932907104`, 
            0.08983264863491058, -0.17827676236629486`, 1.0722830295562744`, 
            0.5551817417144775, -0.2223927229642868, 
            0.29546603560447693`, -0.02293558046221733, -0.04402878135442734, 
            0.5603017807006836}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {-3, 5}, {
            6, -6}, {-4, -5}, {8, 13}, {9, -12}, {-7, 10}, {11, -11}, {
            12, -10}, {-8, -9}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.32873797416687, -2.0354018211364746`, \
-0.3133730888366699, -0.29902949929237366`, -0.5666788816452026, \
-0.6709319353103638, 0.3637985587120056, 1.0213799476623535`, 
            0.7687015533447266, 1.117084264755249, 0.5624446868896484, 
            0.02999909780919552, -0.05779650807380676, 0.4256556034088135}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 6, 6, 2, 9, 2, 7, 8, 9, 5, 8, 6, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.5507822632789612, -1.2485018968582153`, \
-1.6555554866790771`, -1.0968021154403687`, -1.281173586845398, \
-1.0306596755981445`, 0.03473189100623131, 0.48395010828971863`, 
            0.32337117195129395`, 0.4190957844257355, 
            0.21302779018878937`, -0.08395286649465561, \
-0.30339232087135315`}], "Children" -> 
          RawArray["Integer16",{{2, 7}, {3, 4}, {-1, -2}, {5, 
            6}, {-3, -4}, {-5, -6}, {8, 9}, {-7, -8}, {10, -14}, {11, 
            13}, {-9, 12}, {-10, -11}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.387416362762451, -2.1458051204681396`, \
-0.5495476126670837, -0.39883965253829956`, -0.7198755741119385, \
-0.6471977233886719, -0.21645310521125793`, 0.22369341552257538`, 
            0.6044029593467712, 0.8329295516014099, 1.0932486057281494`, 
            1.1564480066299438`, 0.895708441734314, 0.5257930755615234}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 7, 6, 2, 8, 5, 6, 4, 8, 3, 7, 4, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6557202935218811, -2.288022518157959, \
-1.6212360858917236`, -1.0821794271469116`, 
            0.14207836985588074`, -0.3032633662223816, -0.02293558046221733, \
-0.3112269639968872, 0.31143859028816223`, 1.0587671995162964`, 
            0.4866650402545929, 0.13325852155685425`, 1.0943571329116821`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 6}, {3, 4}, {-1, -2}, {5, -5}, {-3, -4}, {
            7, 8}, {-6, -7}, {9, 10}, {-8, -9}, {11, 13}, {
            12, -12}, {-10, -11}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3438079357147217`, -2.0269010066986084`, \
-0.6044794321060181, -0.3470998704433441, -0.702637791633606, 
            0.9433350563049316, 1.2782927751541138`, 0.5292900800704956, 
            1.2181735038757324`, 0.37349018454551697`, 0.8175923228263855, 
            0.9237335324287415, 0.002410745248198509, 0.22070752084255219`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 4, 5, 6, 5, 6, 2, 9, 6, 9, 7, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.3434245586395264`, -2.0481107234954834`, \
-0.5507822632789612, -0.5475520491600037, -0.8030064702033997, \
-0.9565441012382507, 0.929940402507782, 
            0.29546603560447693`, -0.04562431946396828, 
            0.9093788266181946, -0.4030223786830902, 0.19552578032016754`}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {
            6, -5}, {-3, -4}, {8, 11}, {9, 10}, {-7, -8}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.402085781097412, -2.127427339553833, \
-0.32584989070892334`, -0.41345083713531494`, -0.5691605806350708, \
-0.13654136657714844`, 0.7400781512260437, 1.0304882526397705`, 
            0.6274797320365906, 
            0.42083796858787537`, -0.451521098613739, -0.09498223662376404, 
            0.043259844183921814`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 8, 9, 7, 1, 2, 9, 8, 3, 7, 9, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.695916175842285, \
-1.183505654335022, 0.3642789125442505, -0.12992480397224426`, 
            0.929940402507782, 0.29546603560447693`, 0.3442121744155884, 
            0.21616919338703156`, 0.6584534049034119, 0.9093788266181946, 
            1.7627373933792114`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 12}, {8, 10}, {-6, 9}, {-7, -8}, {
            11, -11}, {-9, -10}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.390254020690918, -2.058365821838379, \
-0.36604124307632446`, -0.5745764970779419, -0.5737673044204712, 
            0.6870847940444946, 1.297525405883789, 0.9746449589729309, 
            0.578011691570282, 0.40344950556755066`, 0.7208380699157715, 
            0.010870196856558323`, 0.0511009618639946}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 9, 2, 7, 6, 3, 7, 3, 9, 7, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7949718832969666, -1.183505654335022, \
-1.0821794271469116`, -0.2548157870769501, 
            0.09205006062984467, -0.6819457411766052, 
            0.6817365884780884, -0.04935333505272865, 0.32337117195129395`, 
            0.7468101978302002, 0.4190957844257355}], "Children" -> 
          RawArray["Integer16",{{2, 4}, {3, -3}, {-1, -2}, {5, 
            6}, {-4, -5}, {-6, 7}, {8, 10}, {-7, 9}, {-8, -9}, {-10, 
            11}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-0.38229843974113464`, -0.7234981060028076, \
-2.15964412689209, -0.322782427072525, 
            0.037601690739393234`, -0.02791779488325119, 0.8822722434997559, 
            0.7660781741142273, 0.5377396941184998, 1.129141092300415, 
            0.7625854015350342, 1.0532814264297485`}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 5, 9, 2, 6, 8, 4, 8, 9, 9}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.1354327201843262`, -0.7949718832969666, 
            0.9093788266181946, -0.836929202079773, 0.9524598717689514, 
            0.21302779018878937`, -0.40467822551727295`, 0.6391744613647461, 
            0.9791416525840759, 1.327955722808838}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {-2, 3}, {4, 9}, {-3, 5}, {6, 
            8}, {-4, 7}, {-5, -6}, {-7, -8}, {-9, 10}, {-10, -11}}], 
          "LeafValues" -> 
          RawArray["Real32",{-1.8597180843353271`, -0.48624786734580994`, 
            0.5172197818756104, 0.8928984999656677, 1.2970612049102783`, 
            1.251664161682129, 0.919941782951355, 0.748797595500946, 
            0.38937315344810486`, 
            0.025335045531392097`, -0.18324188888072968`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 8, 3, 2, 4, 3, 7, 2, 6, 6, 5, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -2.703029155731201, \
-0.7905060052871704, -1.0968021154403687`, -0.734301745891571, 
            1.0161795616149902`, 
            0.5323359966278076, -0.05932150036096573, -0.08395286649465561, \
-0.8251036405563354, 0.21898548305034637`, -0.3545157015323639}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 11}, {8, 9}, {-6, -7}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.375739574432373, -2.100726366043091, \
-0.3311944007873535, -0.4996216297149658, -0.6954302787780762, 
            0.6629215478897095, 0.3960726857185364, 0.8810226321220398, 
            0.8158799409866333, 1.0308946371078491`, -0.45154619216918945`, 
            0.012679477222263813`, 0.2908197045326233}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 7, 3, 5, 4, 6, 2, 2, 6, 6, 5, 6, 8, 6}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-2.288022518157959, 
            0.6647219657897949, -0.6202573776245117, -0.8030064702033997, \
-0.19616350531578064`, -1.042122483253479, 
            0.4363309144973755, -0.03823118656873703, 0.3693813383579254, 
            0.6209399700164795, 0.21676598489284515`, 0.8528937697410583, 
            0.44442370533943176`, -0.22854401171207428`}], "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 11}, {4, 7}, {5, -5}, {
            6, -4}, {-2, -3}, {8, 9}, {-6, -7}, {-8, 10}, {-9, -10}, {12, 
            13}, {-11, -12}, {14, -15}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.1455092430114746`, -0.3576534688472748, \
-0.30046346783638, -0.6176148056983948, -0.0313183069229126, 
            0.9388976097106934, 
            0.6363797187805176, -0.2765260934829712, -0.008077533915638924, 
            0.1725442260503769, 1.2526692152023315`, 1.245096206665039, 
            0.523211658000946, 0.7134309411048889, 0.9078505635261536}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 8, 2, 9, 3, 5, 2, 9, 6, 3, 9, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.695916175842285, \
-0.8970876336097717, -1.183505654335022, -1.16068696975708, \
-0.9658291339874268, -1.1196054220199585`, 0.9093788266181946, 
            0.9524598717689514, -0.22860398888587952`, 0.9791416525840759, 
            0.6337660551071167}], "Children" -> 
          RawArray["Integer16",{{2, 4}, {-1, 3}, {-2, -3}, {5, 8}, {-4, 
            6}, {-5, 7}, {-6, -7}, {9, 11}, {10, -10}, {-8, -9}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.392266035079956, -1.9314227104187012`, \
-2.1584889888763428`, -0.693002462387085, -0.5465930700302124, \
-0.5448241233825684, -0.33653146028518677`, 0.9787745475769043, 
            1.2660982608795166`, 0.8053414821624756, 
            0.39566609263420105`, -0.164253830909729, -0.008516630157828331}],
           "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 8, 9, 7, 7, 4, 9, 9, 3, 2, 7, 5, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.7229012846946716, -2.5346412658691406`, \
-1.2672209739685059`, 0.3808458149433136, 
            0.47487419843673706`, -0.7579794526100159, 0.9093788266181946, 
            0.32337117195129395`, 0.3219497799873352, -0.3103022277355194, 
            0.7238255143165588, 1.1332428455352783`, 0.929940402507782}], 
          "Children" -> 
          RawArray["Integer16",{{2, 7}, {-1, 3}, {4, 5}, {-2, -3}, {
            6, -6}, {-4, -5}, {8, 12}, {9, -11}, {10, 
            11}, {-7, -8}, {-9, -10}, {13, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.1769464015960693`, -0.7357208728790283, \
-0.4450850486755371, -0.3038320243358612, -0.1182045042514801, \
-0.5630180239677429, 0.6345645785331726, 1.0267055034637451`, 
            0.9991738796234131, 1.2004019021987915`, 0.6531925201416016, 
            0.40517011284828186`, 0.026021957397460938`, 
            0.0010607719887048006`}], "NominalSplits" -> {}, "RootIndex" -> 1,
           "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 3, 3, 4, 6, 5, 3, 9, 3, 2, 2, 5, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.3434245586395264`, -1.143549919128418, \
-0.6202573776245117, -0.009563234634697437, -0.7300972938537598, \
-0.9966802000999451, 0.8829082250595093, 
            0.9093788266181946, -0.41570913791656494`, -0.07584524899721146, \
-0.35560736060142517`, 0.21898548305034637`, 0.8599397540092468}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, -6}, {
            6, -5}, {-3, -4}, {8, 12}, {9, -11}, {-7, 10}, {
            11, -10}, {-8, -9}, {-12, 13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-1.9362401962280273`, -2.1833863258361816`, \
-0.38466206192970276`, -0.5554567575454712, -0.22046524286270142`, \
-0.6496591567993164, 1.200966715812683, 0.8279050588607788, 
            1.1671440601348877`, 0.668853223323822, 
            0.16423892974853516`, -0.4515587091445923, 0.551703155040741, 
            0.04939472675323486}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 5, 9, 9, 4, 1, 2, 6, 6, 4, 3, 2, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -1.4901421070098877`, \
-1.183505654335022, -1.2672209739685059`, -0.19616350531578064`, \
-0.17827676236629486`, 0.8599397540092468, 
            0.7231494188308716, -0.02293558046221733, 0.0008146425825543702, 
            0.8538618683815002, 0.4363309144973755, -0.3545157015323639}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {5, 
            6}, {-3, -4}, {-5, -6}, {8, 13}, {9, 11}, {
            10, -9}, {-7, -8}, {-10, 12}, {-11, -12}, {-13, -14}}], 
          "LeafValues" -> 
          RawArray[
            "Real32",{-2.296889066696167, -2.038658857345581, \
-0.5281959772109985, -0.6937176585197449, -0.29588302969932556`, \
-0.5468940734863281, 0.4769552946090698, 0.9017685055732727, 
            1.3302698135375977`, 0.39897820353507996`, 0.7980247139930725, 
            0.5671531558036804, -0.10953284800052643`, 
            0.0031168886926025152`}], "NominalSplits" -> {}, "RootIndex" -> 1,
           "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 9, 3, 9, 5, 8, 6, 6, 2, 8, 8, 3, 6}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.183505654335022, \
-1.0581196546554565`, 0.9791416525840759, 
            0.21676598489284515`, -0.10696487128734589`, -0.02293558046221733,
             0.9769108295440674, 0.08055955171585083, 0.6391744613647461, 
            0.4558584690093994, 1.1304266452789307`, -0.05751938372850418}], 
          "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 12}, {6, 
            8}, {-4, 7}, {-5, -6}, {9, 10}, {-7, -8}, {11, -11}, {-9, -10}, {
            13, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3288230895996094`, -0.5730647444725037, \
-0.31384366750717163`, 0.6124122142791748, 0.9475461840629578, 
            1.2892260551452637`, 0.5442321300506592, 0.4086059331893921, 
            0.9678407907485962, 0.8611802458763123, 
            0.7245712280273438, -0.45153990387916565`, -0.11611565947532654`, 
            0.09209809452295303}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 8, 4, 4, 9, 4, 9, 9, 6, 7, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6557202935218811, -0.3447534441947937, \
-0.009563234634697437, -0.734301745891571, 
            0.9791416525840759, -0.3112269639968872, -0.24868391454219818`, \
-0.7091184854507446, 0.8423203825950623, 0.4866650402545929, 
            0.21898548305034637`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {-1, 3}, {4, -4}, {-2, -3}, {6, 
            11}, {-5, 7}, {8, 9}, {-6, -7}, {10, -10}, {-8, -9}, {-11, -12}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-1.890224814414978, -0.32125064730644226`, \
-0.4464239478111267, -0.7024118304252625, 1.2260143756866455`, 
            0.5798504948616028, 1.0893404483795166`, 0.3973146378993988, 
            0.38732191920280457`, 0.6756860613822937, -0.3157379925251007, 
            0.05333409830927849}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 8, 3, 8, 7, 3, 3, 2, 6, 3, 8, 3, 8, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2151296138763428`, -2.5648038387298584`, \
-0.6202573776245117, -0.2223927229642868, 
            0.27263858914375305`, -1.1666288375854492`, -1.0581196546554565`, 
            0.5534993410110474, 0.49383899569511414`, -0.22860398888587952`, 
            0.3442121744155884, 0.7079418301582336, 0.5603017807006836, 
            0.7967289090156555}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 8}, {-3, 5}, {-4, 
            6}, {-5, 7}, {-6, -7}, {9, 13}, {10, 12}, {-8, 
            11}, {-9, -10}, {-11, -12}, {-13, 14}, {-14, -15}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2603602409362793`, -2.07104229927063, \
-0.006993591785430908, -0.32116028666496277`, -0.7521834969520569, \
-0.4910553991794586, -0.6367534399032593, 1.1346684694290161`, 
            0.9278699159622192, 0.9518072605133057, 0.6390594840049744, 
            0.8730321526527405, -0.3327563405036926, 0.6398875117301941, 
            0.25815853476524353`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 5, 3, 9, 7, 9, 6, 8, 7, 9, 9, 8}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.2485018968582153`, -1.3901668787002563`, \
-0.7905060052871704, -1.281173586845398, 0.03473189100623131, 
            1.327955722808838, -0.08395286649465561, 0.3442121744155884, 
            0.4866650402545929, 0.29546603560447693`, -0.24868391454219818`, 
            0.21302779018878937`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            7}, {-5, -6}, {8, 9}, {-7, -8}, {10, 11}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4071760177612305`, -2.1613118648529053`, \
-0.6683273911476135, -0.35044872760772705`, 
            0.22254547476768494`, -0.007671046536415815, 0.8296400904655457, 
            0.5858778953552246, 0.8620483875274658, 0.5894082188606262, 
            1.2808842658996582`, 0.9067177176475525, 0.8303514122962952}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 3, 6, 9, 6, 4, 7, 5, 2, 9, 7, 2}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-2.288022518157959, -1.1659404039382935`, 
            0.6949537396430969, -1.183505654335022, -0.7300972938537598, \
-0.6149562001228333, 
            0.503231942653656, -0.11700275540351868`, -0.5103297233581543, 
            1.3977185487747192`, 0.4866650402545929, 0.4761080741882324}], 
          "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 11}, {5, 8}, {6, -6}, {
            7, -5}, {-3, -4}, {9, 10}, {-7, -8}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.292071580886841, -2.333747148513794, \
-0.49415668845176697`, -0.5468941330909729, -0.5986266136169434, \
-0.3826634883880615, 0.8208479881286621, 0.9744387865066528, 
            0.1374608278274536, -0.28816547989845276`, 0.6332525610923767, 
            0.3445395529270172, 1.1884145736694336`}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 5, 6, 7, 3, 5, 7, 2, 7, 6, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -0.5507822632789612, \
-0.7300972938537598, -0.15033981204032898`, 1.0551968812942505`, 
            0.8409343957901001, 0.7874065637588501, -0.03823118656873703, 
            0.21025151014328003`, -0.08395286649465561, 1.0033131837844849`}],
           "Children" -> 
          RawArray["Integer16",{{-1, 2}, {3, 4}, {-2, -3}, {5, 7}, {-4, 
            6}, {-5, -6}, {8, -12}, {9, 11}, {-7, 10}, {-8, -9}, {-10, -11}}],
           "LeafValues" -> 
          RawArray[
            "Real32",{-2.2443249225616455`, -0.5555185079574585, \
-0.0683600902557373, -0.23730796575546265`, 0.15302297472953796`, 
            0.04965822398662567, 0.7690138220787048, 0.7824127078056335, 
            1.149208903312683, 0.5501901507377625, 0.6939473152160645, 
            1.1958560943603516`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 8, 5, 4, 7, 6, 9, 6, 8, 4, 7, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.695916175842285, \
-0.7812997102737427, -0.734301745891571, 0.3136827051639557, 
            0.8423203825950623, -0.24868391454219818`, -0.4178297519683838, 
            0.3280954957008362, -0.3112269639968872, -0.2794422507286072, 
            0.25829681754112244`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, -13}, {8, 11}, {9, 10}, {-6, -7}, {-8, -9}, {-10, 
            12}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.392266035079956, -2.0788750648498535`, \
-0.3061354458332062, -0.657642126083374, -0.48360320925712585`, 
            0.010304570198059082`, 0.9612354040145874, 1.2738890647888184`, 
            1.0035699605941772`, -0.06223234534263611, 0.3972340226173401, 
            0.24621933698654175`, 0.9062634110450745}], "NominalSplits" -> {},
           "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 5, 5, 4, 6, 7, 8, 4, 6, 6, 9, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.2609341144561768`, \
-0.6557202935218811, 0.0008146425825543702, -0.7300972938537598, 
            0.03473189100623131, 0.23994894325733185`, 
            0.3111937642097473, -0.22854401171207428`, -0.4178297519683838, 
            0.32337117195129395`, -0.3032633662223816}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 9}, {-6, 8}, {-7, -8}, {10, 11}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.281696319580078, -1.9217872619628906`, \
-0.41104838252067566`, 
            0.033135414123535156`, -0.6954488754272461, -0.17292922735214233`,
             0.14885149896144867`, -0.00032423934317193925`, 
            0.7899852991104126, 0.6382128000259399, 1.0186915397644043`, 
            1.11277174949646, 0.6373095512390137}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 7, 9, 8, 9, 3, 7, 9, 2, 6, 2, 2, 8, 2}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.6574196815490723`, \
-1.183505654335022, -0.10093237459659576`, -1.2672209739685059`, \
-1.1477832794189453`, 0.13025277853012085`, 1.3977185487747192`, 
            1.45870041847229, 0.3693813383579254, 
            0.249342143535614, -0.03823118656873703, -0.04402878135442734, 
            0.08055955171585083}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 7}, {-3, 5}, {-4, 
            6}, {-5, -6}, {8, 11}, {9, -10}, {-7, 10}, {-8, -9}, {12, -15}, {
            13, 14}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.309518337249756, -2.1324002742767334`, \
-0.6076259016990662, -0.49610254168510437`, -0.33525925874710083`, \
-0.27163320779800415`, 0.29102668166160583`, -0.04466106370091438, 
            0.017308879643678665`, -0.3508222997188568, 0.6968328356742859, 
            0.9425546526908875, 0.48196110129356384`, 0.5319809913635254, 
            0.9637198448181152}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{4, 7, 3, 8, 8, 5, 6, 9, 8, 9, 6, 9, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-1.1642783880233765`, -2.569286584854126, \
-0.7952237725257874, 0.14207836985588074`, -0.10093237459659576`, 
            0.7464279532432556, -0.01236218772828579, -0.6951659321784973, \
-0.2223927229642868, -0.24868391454219818`, 0.9769108295440674, 
            0.9791416525840759, 0.19552578032016754`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {5, -5}, {-3, -4}, {
            7, 12}, {8, 10}, {9, -8}, {-6, -7}, {-9, 11}, {-10, -11}, {-12, 
            13}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.363567352294922, -2.0533978939056396`, \
-0.6160842180252075, -0.4961777329444885, -0.3712330758571625, 
            0.3680327534675598, 0.9455782771110535, -0.0017091751797124743`, 
            1.307327151298523, 0.254827082157135, 1.0609180927276611`, 
            0.6934982538223267, 0.07562799006700516, 0.006525769829750061}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 5, 7, 9, 2, 5, 9, 5, 6, 9, 5, 7}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.5507822632789612, -1.2609341144561768`, \
-0.23884586989879608`, -1.2672209739685059`, -1.1124558448791504`, 
            1.4973742961883545`, 0.9093788266181946, 
            0.21676598489284515`, -0.04562431946396828, 0.29546603560447693`, 
            0.7043461799621582, 0.21025151014328003`}], "Children" -> 
          RawArray["Integer16",{{2, 6}, {-1, 3}, {-2, 4}, {5, -5}, {-3, -4}, {
            7, -13}, {8, -12}, {9, 10}, {-6, -7}, {11, -11}, {-8, 
            12}, {-9, -10}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2632579803466797`, -1.1378889083862305`, \
-0.47833144664764404`, -0.6666563749313354, -0.4304064214229584, 
            0.9071881771087646, 1.2326760292053223`, 0.7332847118377686, 
            0.8661182522773743, 1.0848665237426758`, 
            0.5726563930511475, -0.06608352810144424, 0.1925758421421051}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 8, 2, 9, 4, 7, 6, 4, 9, 7, 7, 6, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.532660484313965, -2.5579609870910645`, \
-1.0306596755981445`, -1.281173586845398, -0.8625138998031616, 
            0.3136827051639557, 0.6949537396430969, 0.4999603033065796, 
            0.29546603560447693`, 0.6817365884780884, 0.6171107292175293, 
            1.4119619131088257`, 0.9093788266181946}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 6}, {-3, 5}, {-4, -5}, {
            7, 9}, {8, -8}, {-6, -7}, {10, 12}, {11, -11}, {-9, -10}, {
            13, -14}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.325192451477051, -2.0710418224334717`, \
-0.6600697636604309, -0.32936522364616394`, -0.3774808347225189, \
-0.15322230756282806`, -0.5997069478034973, 0.729238748550415, 
            1.0057604312896729`, 0.8152275085449219, 1.2617443799972534`, 
            0.4469131529331207, 0.3406893014907837, 1.0761611461639404`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 8, 5, 8, 9, 8, 6, 3, 7, 7, 6, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.538512945175171, -2.695916175842285, \
-0.7949718832969666, -0.024490682408213615`, 0.9093788266181946, 
            0.21302779018878937`, 1.0511448383331299`, 0.04538506269454956, 
            0.6817365884780884, -0.3743661344051361, 0.535912275314331, 
            0.07124314457178116}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            10}, {-5, 7}, {8, -9}, {9, -8}, {-6, -7}, {-10, 11}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.414109945297241, -2.0619683265686035`, \
-0.3341526985168457, -0.494653582572937, 0.5530769228935242, 
            0.8247058391571045, 0.9397257566452026, 1.2278048992156982`, 
            0.7456735372543335, -0.27072617411613464`, -0.058006200939416885`,
             0.023688409477472305`, 0.18618153035640717`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{7, 5, 2, 9, 7, 6, 4, 5, 4, 7, 9, 4}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-2.288022518157959, -1.6072031259536743`, \
-1.0306596755981445`, -1.281173586845398, 
            0.03473189100623131, -0.01236218772828579, 0.25829681754112244`, 
            0.21676598489284515`, -0.15062175691127777`, 0.3314436376094818, 
            0.29546603560447693`, 0.13325852155685425`}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 
            8}, {-5, 7}, {-6, -7}, {9, 11}, {-8, 10}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.3166487216949463`, -2.2469141483306885`, \
-0.63899827003479, -0.33612483739852905`, -0.3231131136417389, 
            0.21078380942344666`, 0.018155694007873535`, 1.2768248319625854`, 
            0.6105868220329285, 1.0752766132354736`, 0.9387283325195312, 
            0.49985143542289734`, 0.6756279468536377}], "NominalSplits" -> {},
           "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{3, 4, 1, 7, 4, 3, 2, 5, 8, 6, 2, 9, 2, 5}], 
          "NumericalThresholds" -> 
          RawArray[
            "Real32",{-0.6202573776245117, -1.6222652196884155`, \
-0.17827676236629486`, 
            0.3136827051639557, -0.11581052839756012`, -1.127407431602478, 
            0.5551817417144775, 0.21676598489284515`, 0.26416897773742676`, 
            0.9769108295440674, -0.05932150036096573, 0.9791416525840759, 
            1.45870041847229, 0.20957478880882263`}], "Children" -> 
          RawArray["Integer16",{{2, 7}, {-1, 3}, {4, 6}, {-2, 
            5}, {-3, -4}, {-5, -6}, {8, 12}, {9, 10}, {-7, -8}, {-9, 
            11}, {-10, -11}, {-12, 13}, {-13, 14}, {-14, -15}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.2099151611328125`, -0.439973920583725, \
-0.39940086007118225`, -0.0854787826538086, -0.5468941926956177, \
-0.6064553260803223, 0.9328567981719971, 1.2941906452178955`, 
            0.46761369705200195`, 0.9672009944915771, 0.8191668391227722, 
            0.42288923263549805`, -0.31975263357162476`, -0.1771446317434311, 
            0.028393089771270752`}], "NominalSplits" -> {}, "RootIndex" -> 1, 
          "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{8, 9, 3, 6, 6, 7, 2, 4, 8, 6, 9, 9}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-2.532660484313965, 
            0.9791416525840759, -0.7952237725257874, -1.031438946723938, 
            0.6949537396430969, 0.13025277853012085`, 0.9936319589614868, 
            0.07124314457178116, 0.6646550297737122, -0.22854401171207428`, 
            0.29546603560447693`, 0.9093788266181946}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 5}, {-3, -4}, {6, 11}, {
            7, 10}, {-5, 8}, {-6, 9}, {-7, -8}, {-9, -10}, {-11, 
            12}, {-12, -13}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.0869882106781006`, -2.2852888107299805`, \
-0.6966909766197205, -0.3731922507286072, -0.4515587091445923, \
-0.09006679058074951, 0.05122014880180359, -0.0028835758566856384`, 
            0.7226520776748657, 1.0887634754180908`, 1.115559458732605, 
            0.573914647102356, 0.19874726235866547`}], "NominalSplits" -> {}, 
          "RootIndex" -> 1, "NominalDimension" -> 0]], 
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{6, 7, 7, 5, 3, 2, 9, 8, 4, 5, 9, 2}], 
          "NumericalThresholds" -> 
          RawArray["Real32",{-1.2485018968582153`, -2.569286584854126, 
            0.6817365884780884, -0.6557202935218811, -1.1496703624725342`, 
            0.8599397540092468, 0.29546603560447693`, 0.3442121744155884, 
            0.08378727734088898, 
            0.21898548305034637`, -0.24868391454219818`, \
-0.3779594898223877}], "Children" -> 
          RawArray["Integer16",{{2, 3}, {-1, -2}, {4, 11}, {5, 6}, {-3, -4}, {
            7, 10}, {8, 9}, {-5, -6}, {-7, -8}, {-9, -10}, {
            12, -13}, {-11, -12}}], "LeafValues" -> 
          RawArray[
            "Real32",{-2.4027066230773926`, -2.1938419342041016`, \
-0.4870056211948395, -0.5901771783828735, 0.9629818201065063, 
            0.801888108253479, 0.6105303764343262, 
            0.5281346440315247, -0.2158484160900116, 0.02875334955751896, 
            1.1830099821090698`, 1.3505940437316895`, 0.8079508543014526}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]], 
        
        MachineLearning`DecisionTree[
         Association[
         "FeatureIndices" -> 
          RawArray["Integer16",{5, 9, 8, 7, 9, 2, 9, 9, 8, 9, 7, 6, 9}], 
          "NumericalThresholds" -> 
          RawArray[
            
            "Real32",{-0.6557202935218811, -1.183505654335022, \
-0.10093237459659576`, 0.47487419843673706`, 
            0.9791416525840759, -0.8745132088661194, 
            0.29546603560447693`, -0.6951659321784973, -0.04402878135442734, \
-0.24868391454219818`, 0.7468101978302002, 0.8423203825950623, 
            1.3977185487747192`}], "Children" -> 
          RawArray["Integer16",{{2, 5}, {3, -4}, {-1, 4}, {-2, -3}, {6, 
            13}, {-5, 7}, {8, 12}, {9, 10}, {-6, -7}, {
            11, -10}, {-8, -9}, {-11, -12}, {-13, -14}}], "LeafValues" -> 
          RawArray[
            "Real32",{-0.7230800986289978, -0.3722379505634308, \
-0.4984424114227295, -1.7016948461532593`, -0.08478249609470367, 
            0.8442584276199341, 0.8888589143753052, 1.1073588132858276`, 
            1.3185495138168335`, 0.9056577682495117, 0.41379979252815247`, 
            0.7382152080535889, 0.03806588798761368, -0.22548982501029968`}], 
          "NominalSplits" -> {}, "RootIndex" -> 1, "NominalDimension" -> 0]]},
       "Processor" -> MachineLearning`MLProcessor["FirstValues", 
        Association[
        "Info" -> Association["Type" -> "NumericalVector", "Weight" -> 9], 
         "Key" -> "(f1f2f3f4f5f6f7f8f9)", "Invertibility" -> "Perfect", 
         "Missing" -> "Allowed"]], 
      "DistributionData" -> {NormalDistribution, 0.32849797334738684`}, 
      "Method" -> "RandomForest", "Options" -> 
      Association[
       "FeatureFraction" -> 
        Association["Value" -> Rational[1, 3], "Options" -> Association[]], 
        "LeafSize" -> Association["Value" -> 4, "Options" -> Association[]], 
        "TreeNumber" -> 
        Association["Value" -> 100, "Options" -> Association[]], 
        "DistributionSmoothing" -> 
        Association["Value" -> 0.5, "Options" -> Association[]], 
        "Implementation" -> 
        Association["Value" -> "DAAL", "Options" -> Association[]]]], 
    "TrainingInformation" -> 
    Association[
     "LossName" -> "StandardDeviation", "BestModelInformation" -> Dataset[
        Association[
        "MeanCrossEntropy" -> 
         PlusMinus[5.274740961873521, 0.0525194518496523], 
         "StandardDeviation" -> 
         PlusMinus[70.81917558126206, 4.863484594637622], "EvaluationTime" -> 
         0.00039050446428571416`, "TestSize" -> 210, "TrainingSize" -> 54, 
         "TrainingTime" -> 0.011125812500000002`, "TrainingMemory" -> 
         307862.99999999994`, "ModelMemory" -> 175162.99999999997`, 
         "ExperimentCount" -> 15, "ModelUtility" -> 0.00008380525358981259, 
         "MeanCrossEntropyHistory" -> {
           PlusMinus[5.340816939307848, 0.13146798826956355`], 
           PlusMinus[5.161218500507405, 0.07341614577511302], 
           PlusMinus[5.328499840636935, 0.15696270894485803`], 
           PlusMinus[5.469873432635317, 0.18032330365077945`], 
           PlusMinus[5.208381569641051, 0.06511685736750465], 
           PlusMinus[5.458210886529819, 0.23085584153648442`], 
           PlusMinus[5.561718473747794, 0.1838998585877169], 
           PlusMinus[5.344736727284514, 0.1936411480232165], 
           PlusMinus[5.384780032295038, 0.14326894755566155`], 
           PlusMinus[5.134681323380561, 0.07603489110139947], 
           PlusMinus[5.453149312995448, 0.1998590808978697], 
           PlusMinus[5.336322001508848, 0.14266863090778542`], 
           PlusMinus[5.707394502052759, 0.21542775664923727`], 
           PlusMinus[5.641515348144767, 0.2073592343162268], 
           PlusMinus[5.396097227229174, 0.16547908183233404`]}, 
         "StandardDeviationHistory" -> {
           PlusMinus[68.55624491145574, 18.148600392431785`], 
           PlusMinus[60.82568207801174, 21.28119316301548], 
           PlusMinus[68.14412841251047, 18.57728721282181], 
           PlusMinus[72.41752811641796, 17.19686646155419], 
           PlusMinus[62.48564590108132, 20.37499752640209], 
           PlusMinus[71.92064916884719, 17.81702650212274], 
           PlusMinus[75.16624445018319, 16.38313389221481], 
           PlusMinus[68.66758278771606, 18.60058606134611], 
           PlusMinus[69.94581970895176, 17.83586160703784], 
           PlusMinus[61.36969371907388, 20.950384464469078`], 
           PlusMinus[71.63734689539585, 17.505593657068854`], 
           PlusMinus[68.39886674159906, 18.33373292338754], 
           PlusMinus[80.97335806839192, 15.590241225256161`], 
           PlusMinus[77.62675989082811, 15.95436261388356], 
           PlusMinus[70.21881291179194, 18.230659372661368`]}, 
         "Configuration" -> {
          "RandomForest", "FeatureFraction" -> Automatic, "LeafSize" -> 
           Automatic, "TreeNumber" -> Automatic, "DistributionSmoothing" -> 
           0.5, "Implementation" -> Automatic}, "FinalTrainingSize" -> 68], 
        TypeSystem`Struct[{
         "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
          "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
          "ModelMemory", "ExperimentCount", "ModelUtility", 
          "MeanCrossEntropyHistory", "StandardDeviationHistory", 
          "Configuration", "FinalTrainingSize"}, {
         TypeSystem`AnyType, TypeSystem`AnyType, 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Vector[TypeSystem`AnyType, 15], 
          TypeSystem`Vector[TypeSystem`AnyType, 15], 
          TypeSystem`Tuple[{
            TypeSystem`Atom[String], TypeSystem`AnyType, TypeSystem`AnyType, 
            TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
          TypeSystem`Atom[Integer]}], 
        Association["ID" -> 244903477675641]], "Configurations" -> Dataset[
        Association[
        Association[
          "Value" -> "RandomForest", "Options" -> 
           Association[
            "FeatureFraction" -> Association["Value" -> Automatic], 
             "LeafSize" -> Association["Value" -> Automatic], "TreeNumber" -> 
             Association["Value" -> Automatic], "DistributionSmoothing" -> 
             Association["Value" -> 0.5], "Implementation" -> 
             Association["Value" -> Automatic]]] -> Association["Experiments" -> {
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[5.989963794690937, 0.08942104781639737], 
              "StandardDeviation" -> 
              PlusMinus[97.53587320276567, 6.007027691123413], 
              "EvaluationTime" -> 0.00009848706896551721, "TestSize" -> 638, 
              "TrainingSize" -> 10, "TrainingTime" -> 0.010580666666666669`, 
              "TrainingMemory" -> 259613.3333333333, "ModelMemory" -> 163760.,
               "ExperimentCount" -> 11, "ModelUtility" -> 
              0.000044305731796760786`, "MeanCrossEntropyHistory" -> {
                PlusMinus[6.642557359921144, 0.3573430574757921], 
                PlusMinus[5.894656674803445, 0.03321002513581245], 
                PlusMinus[6.106463958831726, 0.07822497875270047], 
                PlusMinus[6.080751897423578, 0.08322838939832022], 
                PlusMinus[6.189008767597433, 0.10765789875817891`], 
                PlusMinus[5.876475651701238, 0.05957558160834259], 
                PlusMinus[5.984895935114439, 0.060406952001595925`], 
                PlusMinus[5.988914931216836, 0.057514523052746756`], 
                PlusMinus[6.76037396498336, 0.32318208060166387`], 
                PlusMinus[6.259157931827107, 0.07311422110890765], 
                PlusMinus[6.049864583123826, 0.08689475967670181]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[121.09758694255028`, 14.255402730267566`], 
                PlusMinus[78.1243119024718, 6.708941644728737], 
                PlusMinus[107.82281300204923`, 10.90129890658466], 
                PlusMinus[106.5460991187311, 10.075777984534877`], 
                PlusMinus[118.5120966850057, 13.837984047172625`], 
                PlusMinus[87.18764459347518, 6.927909069165781], 
                PlusMinus[89.83536917157508, 10.273392032182919`], 
                PlusMinus[93.1560638632752, 8.777963685304652], 
                PlusMinus[133.60142385069793`, 14.047983480891999`], 
                PlusMinus[122.78362804547429`, 12.9727734845815], 
                PlusMinus[102.74376555120345`, 10.991632651398904`]}], 
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[5.274740961873521, 0.0525194518496523], 
              "StandardDeviation" -> 
              PlusMinus[70.81917558126206, 4.863484594637622], 
              "EvaluationTime" -> 0.00039050446428571416`, "TestSize" -> 210, 
              "TrainingSize" -> 54, "TrainingTime" -> 0.011125812500000002`, 
              "TrainingMemory" -> 307862.99999999994`, "ModelMemory" -> 
              175162.99999999997`, "ExperimentCount" -> 15, "ModelUtility" -> 
              0.00008380525358981259, "MeanCrossEntropyHistory" -> {
                PlusMinus[5.340816939307848, 0.13146798826956355`], 
                PlusMinus[5.161218500507405, 0.07341614577511302], 
                PlusMinus[5.328499840636935, 0.15696270894485803`], 
                PlusMinus[5.469873432635317, 0.18032330365077945`], 
                PlusMinus[5.208381569641051, 0.06511685736750465], 
                PlusMinus[5.458210886529819, 0.23085584153648442`], 
                PlusMinus[5.561718473747794, 0.1838998585877169], 
                PlusMinus[5.344736727284514, 0.1936411480232165], 
                PlusMinus[5.384780032295038, 0.14326894755566155`], 
                PlusMinus[5.134681323380561, 0.07603489110139947], 
                PlusMinus[5.453149312995448, 0.1998590808978697], 
                PlusMinus[5.336322001508848, 0.14266863090778542`], 
                PlusMinus[5.707394502052759, 0.21542775664923727`], 
                PlusMinus[5.641515348144767, 0.2073592343162268], 
                PlusMinus[5.396097227229174, 0.16547908183233404`]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[68.55624491145574, 18.148600392431785`], 
                PlusMinus[60.82568207801174, 21.28119316301548], 
                PlusMinus[68.14412841251047, 18.57728721282181], 
                PlusMinus[72.41752811641796, 17.19686646155419], 
                PlusMinus[62.48564590108132, 20.37499752640209], 
                PlusMinus[71.92064916884719, 17.81702650212274], 
                PlusMinus[75.16624445018319, 16.38313389221481], 
                PlusMinus[68.66758278771606, 18.60058606134611], 
                PlusMinus[69.94581970895176, 17.83586160703784], 
                PlusMinus[61.36969371907388, 20.950384464469078`], 
                PlusMinus[71.63734689539585, 17.505593657068854`], 
                PlusMinus[68.39886674159906, 18.33373292338754], 
                PlusMinus[80.97335806839192, 15.590241225256161`], 
                PlusMinus[77.62675989082811, 15.95436261388356], 
                PlusMinus[70.21881291179194, 18.230659372661368`]}]}, 
           "PredictedPerformances" -> 
           Association[
            "EvaluationTime" -> 0.00039050446428571416`, "ModelMemory" -> 
             175162.99999999997`, "StandardDeviation" -> 
             PlusMinus[70.81917558126206, 4.863484594637622], 
             "TrainingMemory" -> 307862.99999999994`, "TrainingTime" -> 
             0.01814621916666667], "Index" -> 1]], 
        TypeSystem`Assoc[
         TypeSystem`Struct[{"Value", "Options"}, {
           TypeSystem`Atom[String], 
           TypeSystem`Assoc[
            TypeSystem`Atom[String], 
            TypeSystem`Struct[{"Value"}, {TypeSystem`AnyType}], 5]}], 
         TypeSystem`Struct[{"Experiments", "PredictedPerformances", "Index"}, {
           TypeSystem`Vector[
            
            TypeSystem`Struct[{
             "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
              "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
              "ModelMemory", "ExperimentCount", "ModelUtility", 
              "MeanCrossEntropyHistory", "StandardDeviationHistory"}, {
             TypeSystem`AnyType, TypeSystem`AnyType, 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength]}], 
            2], 
           
           TypeSystem`Struct[{
            "EvaluationTime", "ModelMemory", "StandardDeviation", 
             "TrainingMemory", "TrainingTime"}, {
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real], TypeSystem`AnyType, 
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real]}], 
           TypeSystem`Atom[Integer]}], 1], 
        Association["ID" -> 244899182708345]], "MaxTrainingSize" -> 68, 
      "LastReportingTime" -> 3.745013624150145`16.326028391137353*^9, 
      "PreprocessorEvaluationTime" -> 3.65234375`2.*^-6, "PreprocessorMemory" -> 
      48112, "RoundPartitioning" -> Dataset[{
         Association[
         "TrainingSizes" -> 10, "TimeBudgets" -> 0.39999999999999997`, 
          "ElapsedTimes" -> 0.42539299999999997`, "ExperimentCounts" -> 11], 
         Association[
         "TrainingSizes" -> 54, "TimeBudgets" -> 0.5, "ElapsedTimes" -> 
          0.516641, "ExperimentCounts" -> 15]}, 
        TypeSystem`Vector[
         TypeSystem`Struct[{
          "TrainingSizes", "TimeBudgets", "ElapsedTimes", 
           "ExperimentCounts"}, {
           TypeSystem`Atom[Integer], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Integer]}], 2], 
        Association[
        "Origin" -> HoldComplete[GeneralUtilities`AssociationTranspose, 
           Dataset`DatasetHandle[244907772642937]], "ID" -> 
         244912067610233]]], "Log" -> 
    Association["Example" -> MachineLearning`MLDataset[
        Association[
        "f1" -> Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {0}, "ID" -> 
           1635758485550590698], "f2" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {3.517}, "ID" -> 
           3792239814675432237], "f3" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.283}, "ID" -> 
           6788520538275450158], "f4" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {6.3951}, "ID" -> 
           3665614283994286067], "f5" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {4.6226}, "ID" -> 
           4198949004418315711], "f6" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.258}, "ID" -> 
           2198503552849512914], "f7" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {19.768}, "ID" -> 
           380823439434077212], "f8" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {43.431}, "ID" -> 
           153932119762769494], "f9" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {22.2}, "ID" -> 
           3753923023160904854]], 
        Association[
        "ExampleNumber" -> 1, "ExampleWeights" -> 1, "RawExample" -> False]], 
      "TrainingTime" -> 1.626089, "MaxTrainingMemory" -> 828352, "DataMemory" -> 
      22624, "FunctionMemory" -> 317000, "LanguageVersion" -> {11.3, 0}, 
      "Date" -> DateObject[{2018, 9, 4, 1, 33, 44.964663`8.405446319981381}, 
        "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, "ProcessorType" -> 
      "x86-64", "OperatingSystem" -> "MacOSX", "SystemWordLength" -> 64, 
      "Evaluations" -> {}]]],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.745008547818294*^9, 3.745008617180893*^9}, 
   3.745008986105492*^9, 3.745009798731946*^9, 3.7450100250130253`*^9},
 CellLabel->
  "Out[202]=",ExpressionUUID->"31befb80-305b-4748-929f-566d0666cf00"],

Cell[BoxData["0.9234715376980172`"], "Output",
 CellChangeTimes->{{3.745008547818294*^9, 3.745008617180893*^9}, 
   3.745008986105492*^9, 3.745009798731946*^9, 3.745010025408259*^9},
 CellLabel->
  "Out[203]=",ExpressionUUID->"3658e555-3105-4dee-848a-530160b21450"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["GaussianProcess", "Title"]
}], "Text",
 CellChangeTimes->{{3.745009526740106*^9, 
  3.745009532059379*^9}},ExpressionUUID->"d1bd7652-a4d6-434a-a0bc-\
193597464878"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"p", "=", 
  RowBox[{"Predict", "[", 
   RowBox[{"fxy", ",", 
    RowBox[{"Method", "\[Rule]", "\"\<GaussianProcess\>\""}], ",", " ", 
    RowBox[{"PerformanceGoal", "\[Rule]", "\"\<Quality\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"rSQUARED", "[", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"testfxy", "[", 
       RowBox[{"[", "i", "]"}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}], ",", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"p", "[", 
      RowBox[{
       RowBox[{"testfxy", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "testdata"}]}], "}"}]}], "]"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{
  3.745008674107614*^9, {3.745009807821225*^9, 3.745009812908972*^9}, {
   3.74501003230732*^9, 3.745010032579454*^9}},
 CellLabel->
  "In[204]:=",ExpressionUUID->"dc16428b-f2e7-4b00-96c4-b49886a67e26"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["PredictorFunction",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"GaussianProcess\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[{{}, {{}, {
                PointSize[0.125], 
                GrayLevel[0.55], 
                
                PointBox[{{-1, 1.5}, {0, 2.3}, {1, 0.8}, {2, 2}, {3, 1.3}, {
                  4, 4.}}]}, {
                GrayLevel[0.7], 
                AbsoluteThickness[1.5], 
                
                BSplineCurveBox[{{-1, 2}, {0, 2}, {1, 1}, {2, 1}, {4, 2}, {5, 
                 4}}]}}, {}}, Axes -> {False, False}, 
             AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, 
             BaseStyle -> {FontFamily -> "Arial", 
               AbsoluteThickness[1.5]}, DisplayFunction -> Identity, 
             Frame -> {{True, True}, {True, True}}, 
             FrameLabel -> {{None, None}, {None, None}}, FrameStyle -> 
             Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]], FrameTicks -> {{None, None}, {None, None}}, 
             GridLines -> {None, None}, LabelStyle -> {FontFamily -> "Arial"},
              Method -> {"ScalingFunctions" -> None}, PlotRange -> {All, All},
              PlotRangeClipping -> True, PlotRangePadding -> {{1, 1}, {1, 1}},
              Ticks -> {None, None}, Axes -> False, AspectRatio -> 1, 
             ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}], Frame -> True, 
             FrameTicks -> None, FrameStyle -> Directive[
               Opacity[0.5], 
               Thickness[Tiny], 
               RGBColor[0.368417, 0.506779, 0.709798]], Background -> 
             GrayLevel[0.94]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Input type: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  TagBox[
                   TooltipBox[
                    TemplateBox[{"\"Mixed\"", 
                    StyleBox[
                    
                    TemplateBox[{"\" (number: \"", "9", "\")\""}, 
                    "RowDefault"], 
                    GrayLevel[0.5], StripOnInput -> False]}, "RowDefault"], 
                    TagBox[
                    RowBox[{"{", 
                    
                    RowBox[{
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\"", ",", "\"Numerical\"", ",", 
                    "\"Numerical\""}], "}"}], Short[#, 10]& ]], 
                   Annotation[#, 
                    
                    Short[{"Numerical", "Numerical", "Numerical", "Numerical",
                     "Numerical", "Numerical", "Numerical", "Numerical", 
                    "Numerical"}, 10], "Tooltip"]& ], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Method: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"GaussianProcess\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox[
                 "\"Number of training examples: \"", 
                  "SummaryItemAnnotation"], "\[InvisibleSpace]", 
                 TagBox["68", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel"],
    DynamicModuleValues:>{}], "]"}],
  PredictorFunction[
   Association[
   "ExampleNumber" -> 68, "Input" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical"], "f2" -> 
           Association["Type" -> "Numerical"], "f3" -> 
           Association["Type" -> "Numerical"], "f4" -> 
           Association["Type" -> "Numerical"], "f5" -> 
           Association["Type" -> "Numerical"], "f6" -> 
           Association["Type" -> "Numerical"], "f7" -> 
           Association["Type" -> "Numerical"], "f8" -> 
           Association["Type" -> "Numerical"], "f9" -> 
           Association["Type" -> "Numerical"]], "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Preprocessor" -> 
         MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["Transpose", 
               Association["FeatureNumber" -> 9]], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {
                 "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical", "Numerical", "Numerical", "Numerical", 
                  "Numerical"}, 
                "FeatureKeys" -> {
                 "f1", "f2", "f3", "f4", "f5", "f6", "f7", "f8", "f9"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> False, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
           Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
           Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
         Association[
          "(f1f2f3f4f5f6f7f8f9)" -> 
           Association["Type" -> "NumericalVector", "Weight" -> 9]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1], "f2" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f3" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f4" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f5" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f6" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f7" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f8" -> 
               Association["Type" -> "Numerical", "Weight" -> 1], "f9" -> 
               Association["Type" -> "Numerical", "Weight" -> 1]], "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2171448911019223696]], 
           MachineLearning`MLProcessor["ImputeMissing", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Imputed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Imputer" -> (DimensionReducerFunction[
               Association[
               "ExampleNumber" -> 68, "Imputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Fill" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, "Method" -> 
                   "Naive", "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "RandomImputer" -> 
                MachineLearning`MLProcessor["ImputeMissing", 
                  Association[
                  "Invertibility" -> "Perfect", "Missing" -> "Imputed", 
                   "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                   "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Method" -> "NaiveSampler", 
                   "VectorLength" -> 9, "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Type" -> 
                   "NumericalVector"]], "Preprocessor" -> 
                MachineLearning`MLProcessor["ToMLDataset", 
                  Association[
                  "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 9]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                   "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> Automatic, 
                    "ExampleWeights" -> Automatic, "RawExample" -> 
                    Missing["KeyAbsent", "RawExample"]]]}]], "ScalarFeature" -> 
                   True, "Invertibility" -> "Perfect", "Missing" -> 
                   "Allowed"]], "Processor" -> 
                MachineLearning`MLProcessor["Identity"], "Padder" -> 
                MachineLearning`MLProcessor["Identity"], "PostProcessor" -> 
                MachineLearning`MLProcessor["FromMLDataset", 
                  Association[
                  "DatasetFormat" -> Automatic, "Input" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
                   Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Length" -> 5]], 
                   "InversePreprocessor" -> 
                   MachineLearning`MLProcessor["Sequence", 
                    Association["Processors" -> {
                    MachineLearning`MLProcessor["List"], 
                    MachineLearning`MLProcessor["WrapMLDataset", 
                    Association[
                    "FeatureTypes" -> {"NumericalVector"}, 
                    "FeatureKeys" -> {"f1"}, "FeatureWeights" -> {1}, 
                    "ExampleWeights" -> 1]]}]], "ScalarFeature" -> True, 
                   "Invertibility" -> "Perfect", "Missing" -> "Allowed"]], 
                "Model" -> Association["Matrix" -> CompressedData["
1:eJwBeQGG/iFib1JlAgAAAAkAAAAFAAAAmVBmoywVlb8qELEgZU7Ov34Y3drR
FOo/qlyhgpR23r9Jb1K0KKfKPzVp3NEDrNa/abUD0TAL0j+AFISIiQfMPzFZ
17JLstg/v0E/ryvO4T+KlJfPjoLav6ZgG9zBpck/0LOIhqF1ej88VOIpEaG/
v2mJCAxiAse/TRYsbZN+0r8/Cw2zoo3Tv+9rc6GRntg/jnFgg2cz4j8pslyv
eGLiv+XQ0RgjLNu/KC+yDiZauD8yZxZFLjG+v+qmOUyfhdK/fQyWzeWfv7/n
NWRbIhLav6yDt//GmaW/7x/W+SY5wr/bXvcAlsTZv3qLeBRml9G/Hnk3HfuI
zr9MB8bKxNjhv+lUV0UsDdG/eRFvOOlQtr/0nv5/fCzQPy9kyAdK99a/IkxW
1nTN17+7W3GQWXrFv4i8XVVJ9sY/luetEIvW1j+4D+x3CeTSv6sQUsfGpuA/
l/Ljuh6CtD+ScbC9vFyGP6nsXqi+Tao/UEa+OQ==
                   "], "Processor" -> 
                  MachineLearning`MLProcessor["Standardize", 
                    Association[
                    "Invertibility" -> "Perfect", "Missing" -> "Allowed", 
                    "Input" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]], 
                    "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
                    6.145230441176471, 5.1866829411764686`, 4.129278823529412,
                     10.519120588235296`, 22.46829264705883, 
                    39.538005882352955`, 12.08235294117647}, 
                    "StandardDeviation" -> {0.42556704269130924`, 
                    1.664271125991892, 3.9213244765540445`, 
                    1.9849917286159486`, 2.252757467202552, 4.539697132504567,
                     6.700105806787766, 11.106504718564455`, 
                    7.167141960044636}, "Output" -> 
                    Association[
                    "f1" -> Association[
                    "Type" -> "NumericalVector", "Weight" -> 1]]]], 
                  "FinalDimension" -> 5, "Method" -> "Linear"], 
                "PerformanceGoal" -> Automatic, "Invertibility" -> 
                "Approximate", "Log" -> 
                Association[
                 "TrainingTime" -> 0.007298, "MaxTrainingMemory" -> 66584, 
                  "DataMemory" -> 5240, "FunctionMemory" -> 22520, 
                  "LanguageVersion" -> {11.3, 0}, "Date" -> 
                  DateObject[{2018, 9, 4, 1, 33, 53.235797`8.478778735034831},
                     "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, 
                  "ProcessorType" -> "x86-64", "OperatingSystem" -> "MacOSX", 
                  "SystemWordLength" -> 64, "Evaluations" -> {}]]][#, 
               "ImputedVectors", PerformanceGoal -> "Quality"]& ), "Method" -> 
             "DimensionReduction", "VectorLength" -> 9, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Type" -> "NumericalVector", "Version" -> {11.3, 0}, "ID" -> 
             5500259897043576343]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Mean" -> {0.07586871176470587, 1.8633270588235293`, 
              6.145230441176471, 5.1866829411764686`, 4.129278823529412, 
              10.519120588235296`, 22.46829264705883, 39.538005882352955`, 
              12.08235294117647}, 
             "StandardDeviation" -> {0.42556704269130924`, 1.664271125991892, 
              3.9213244765540445`, 1.9849917286159486`, 2.252757467202552, 
              4.539697132504567, 6.700105806787766, 11.106504718564455`, 
              7.167141960044636}, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 2687999288024534896]]}, 
         "Invertibility" -> "Perfect", "Missing" -> "Imputed"]]], "Output" -> 
    Association["Preprocessor" -> MachineLearning`MLProcessor["ToMLDataset", 
        Association[
        "Input" -> Association["f1" -> Association["Type" -> "Numerical"]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Preprocessor" -> MachineLearning`MLProcessor["Sequence", 
           Association["Processors" -> {
              MachineLearning`MLProcessor["List"], 
              MachineLearning`MLProcessor["WrapMLDataset", 
               Association[
               "FeatureTypes" -> {"Numerical"}, "FeatureKeys" -> {"f1"}, 
                "FeatureWeights" -> Automatic, "ExampleWeights" -> Automatic, 
                "RawExample" -> Missing["KeyAbsent", "RawExample"]]]}]], 
         "ScalarFeature" -> True, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "Processor" -> MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Output" -> 
         Association[
          "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
         "Processors" -> {
           MachineLearning`MLProcessor["ToVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 2497458904888788241]], 
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Mean" -> {399.8130735294119}, 
             "StandardDeviation" -> {132.8466718223454}, "Output" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 8112975740502046413]], 
           MachineLearning`MLProcessor["FromVector", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "f1" -> Association[
                "Type" -> "NumericalVector", "Weight" -> 1]], "Output" -> 
             Association[
              "f1" -> Association["Type" -> "Numerical", "Weight" -> 1]], 
             "Version" -> {11.3, 0}, "ID" -> 4157070569169933360]], 
           MachineLearning`MLProcessor["FirstValues", 
            Association[
            "Info" -> Association["Type" -> "Numerical", "Weight" -> 1], 
             "Key" -> "f1", "Invertibility" -> "Perfect", "Missing" -> 
             "Allowed"]]}, "Invertibility" -> "Perfect", "Missing" -> 
         "Allowed"]], "ProbabilityPostprocessor" -> Identity, 
      "InverseProcessorFunction" -> (399.8130735294119 + 
       132.8466718223454 #& ), 
      "ProcessorFunction" -> (-3.0095829127287295` + 
       0.007527474992653866 #& ), "Name" -> "value", 
      "Quantiles" -> {-2.4418456938327893`, 1.3884196264792183`}], "Prior" -> 
    Automatic, "Utility" -> (DiracDelta[#2 - #]& ), "Threshold" -> 0, 
    "PerformanceGoal" -> "Quality", "BatchProcessing" -> Automatic, "Model" -> 
    Association[
     AssumeDeterministic -> False, "EstimationMethod" -> "MaximumPosterior", 
      "NominalCovarianceType" -> "HammingDistance", "NumericalCovarianceType" -> 
      "SquaredExponential", "OptimizationMethod" -> Automatic, 
      "TrainedGPModel" -> 
      Association[
       "CovarianceFunction" -> 
        Association[Method -> "SquaredExponential" + "WN", "HyperParameters" -> {
            Association[
            "NumericalLengthScale" -> 1.116960441045699, "SignalVariance" -> 
             0.5033608015629546, "NoiseVariance" -> 0.0011066400350658349`], 
            Association[
            "NumericalLengthScale" -> 1.116960441045699, "SignalVariance" -> 
             0.5033608015629546, "NoiseVariance" -> 0.0011066400350658349`]}],
         "MeanFunction" -> Association[], "Purpose" -> 
        Association["task" -> "FunctionOptimization"], 
        "TrainingData" -> {CompressedData["
1:eJxlVmk4FAobRZZEUdyrJJXoUjdlp+1VpEQ3e6IS4aPShopCmxbUValE1igk
FDch3hGy7zOWYYwZBoPBjHUQX3/S8zQ/3r/nOeddznvWO523cBHg4+PT/lGi
P+plWIzbxg/lOFjQlvZFgIFCIQ/SXYpH8KDD6oRdMZNY62L19MPLMezd//e1
rSpjuPdOk4dcjSDBJJtZjdpCBKktnrtvLG6GnzjqEX5XShyJSLENOHY/nwWH
DNhqVNl2iIkNAI/ubnB+Jm7w/NZ3cBwQbjln1gNWMSYr15yugN9xDtrE70sT
7cG50qo1dmm96H9HdQZbx/C9o5/V1I4xrK6qrAkWmUahc7HWQQ+ECbrTX+a4
E4IE0wNhNKLaJGRLpJpzHhbi5jsHukiHOXjAMuf7a4VRZAQopLK39eLJIvoe
NoOGzmL/VVgWMrHhtaGIbWoXPKl8JzjVXYcyT6s3Ojtx8Ceft8QRHatPiagV
YuG5fQMbpqdTbJ1l+9DW0demVmoc1sarSr3uGoHp44Q7pUV0ONK/QezL926Q
k6LYpO8mLehy8mmI9z7KwRE9o7QB7ijKHghR7FnajzWpxu217ix8xzr8zHC+
DYOpdkLp26vhr+uenkWdUTx8gtZIrw7K6oTcVaof3u7tRt/jw+RmZQF9MT3d
Etqfw6jQ+SerGuh4aLPRyX9s6yFqjnjt5XoSPNzoTyTkjC7gVPmrfVrS1w4u
a4SmL5NYIPBtiDtrwYVdB7cbMlvYMNFFHNixfBbGbmSuSHEvhugGJ7cCVjcs
eUuLNjcZAm7nsTwbL2n9FAMu0diFBI4PS0ziCK/xkVPw6p7n8yArbspZI0nE
c40OEWfevcPv/W8zEmQawehmvPCDi4XwzHhtlO1jxgIfXYMhscyjrXhG21s9
aXU3sNuUpINKqdh928/0nlUvGDZeKVe79goFh8PdlG71gW7wx1NRvgzoqt4Q
4bWncgGn7cRn7lfvfghRexyjqDAGp1aKKPhdjkDjinvOcqaT0GQ2YamdOw7J
MdfCpt52w9fz1RpOx3sXdGWrGz9zsSpFnTn72ZHITnCUWmZxb+UQlivorXwy
x6c/NZ8taqvNxrNh6sTs6CZ0m5xcdq60Dv6WF9eVf9/K0+fKFfeFfcWZsDN4
IurJklGgCd0wl7vUCCpRz9pEgjKwIe/lR6fCIrxS6qe/KqYbK6X/8YpvbIKf
+/ywyv95nnoxEj8ltEh94KCZANVC3oONxkvDN2q86MbmvU1S+UlMfODvI0A5
248Sb3J07m2ng18HOUlKMhMqmRfY05xffNZr3t8X9IgKO9rX7Svk64Pzzy06
PtTNwPiFlKBo/2FIUS9JDq+fhMND1qvItvFQw760WObMr/78xPnJp9tuhetx
mX780PSQv76sH9PXUqKVi0YxdkyqsnbdMIbfPaQv7N6ILeqTgdpVVPh9n/+z
2YpZEQ3Y8dhA5i+HNnwWg4PhfFUo+03mycF9dHzoeefazB+V+IUdNuyWRIbo
3KLN2wyTcWWR3qlu+V/7k2PpwDm7iYhaGY8/G1oO4GfJlFz5pFGM0NbLL5T/
4QOr+VjW37lYKOJZvYG1iCCcxhA9oCxEKHiterLSYGRBl6uqk5KdE7++3Y0G
/2Pv+fXdyY9uyxCYoOIBB/I0+qBc70NWQEUnXCyX+CKtTUY7IcqG6yWtIBkY
VxwxNbGAc13zrn2S6hgUlJL2CZ4fh2l+l8l3V0bBfvcRoZMx8/Cv9+DYmy9U
MDG/sJMk24aXAmX/GMmhLsz9J07m8bJ0j/ZmXLZ0hZH5026oCpJSK75UDJfz
QzFnOR0sqcVHz7zg0zcjJrg7pQ6Cz3kl+xMmBTy+ujzxpJuC1DDuin/W5FqU
BtlrG0pW0ZjgPOpDzvhWjXrjrctDG4ax3TNZc4tLF4QNcHKP+jfB7312c7cA
9iUu/PtP+YX02+NgYCA13ms6Bd6qdvcEP89A+pfM21+D6SDpXZ/QebYdZz5u
Cavw4NXlEXz8dE4tE54ESmUe0xqHKePZQL+3FJyJXndnQnoCDpK7TOQvciHn
1goXYcN+GAxXZqV85N1Dx8Xha94Z9gAjozh5fN0QlFvF6unK0cEhONOxRHEA
Lt99M+kb2w20Y/GatC4qkKYeiclsI8Pvc8+oOObUN1YD9Xva+Fz3N0H5+vC0
olskbLn9dvyxYDMMxMaX+JF7QOgwWaTOow/Yx3qX099ULvRZuWJHXERwId6a
ztno9ePvzDVRhdLCOJjt4bkqlG8Y9wfJhuIOBtbs6lCyn+/F+lW+ZvnPu0D5
u6SknEgzj8+LfZ4hd4QOQkprtPah1Gm4luJ0P1XnK3RemY7ytu6H8+9z4xzu
MEGpV3t7pFglWjwhG1a1Mnh02c/aPy7VYuPOXDr1z5ZRjCsZiD823wyfnlE8
H+8Zw+DIqbMXHTkY0qBMl6wjgYSg7pGd6tX4u2+I1Swutp9ioTDLcvJBKwdP
DSUnuYp9x1jpveoJX7gYPBdhOzk9hS4dkqY07iLCtRVa5HKOIOF3n//pG6sa
B27KqXJxvWTyA3YvP8HTaue7xjWzmH3VK+Gj4RwyovhfDFULEQLW+PWOmwgT
fucjzs3ctKW5AQPpJnGTXjXQp3vfULfuAx4lyaeaq1XgMsvDn3fNDsKedLVI
ReleqI1yW+pURub5F975iRSDo4N4Q/OQhgapCl27y+wlXjOh7XPmP/aXCKhW
vk9kx/d+NOeIilEiB4GSf2bnFc16nruw2e9zKOTWCJg2exmllLOhjdZx4VRO
B/QbvljrYVgB3F6ph4tDPiF6ZXyiWXWgBDUhfqyviecu3oNwj6gRv755i6Pc
OmMayMpeuNpT1wbh91r5BQWGwbT4UHw+kOBEYmDpgSdZUL//5RWuIgeas7o0
rpLHF3DGyOmbXjcTUZF74j7brAefKI80+rTXooq4jZlTTSP2lfcxlKzaUcbL
dafCQB7ohtINGfRq/H1e/TSGKWsFB412i8TedhzBP1QkXa0DwjCuXee68WY6
ylCk+JyVOnBDgsu4TTEN1tUXzhZ4kHh8XpFSkdaow8KBQ//bp/hvORoaH1sa
960E1Z0twgPJraAhYqaRr5mPerTNKUTVXpgIcdp6hti2MK9QQaWpc3/9+oNC
hfUNjFw20mtmPQodetDqdHhwgB4TLxNEg/eE9qE67Zq8/hgFdrgJNxUYfeX5
g1nBXlqlOmwMVt8eP7tjFE9Pfk2x+UyCO5kHzRz0RnHrOJe+v2AEJfdr17/M
aYCZh3WxEql5PHcRODG08fqlOsiq7UtKogxCUSnq5dk9h7Eg01Ja7Y+8GKp5
4D8FJjiMb7yxltwO0rcr1GO8eP0nS8fGZPk5AhpNloswfuSv8Mv+TOX7ncCa
6Rb9mDwO4XPuBekwDpTQIBESqxg2MzOiyzooPDmz4LZA3GNaFi5Jq9S9npQJ
dUuc7FL883CQrzn/ziIqzqftokS2MsErv2JPeTsDzrQP3bXPbOG5iy30BhX/
H3nVZ2/Mt/ABDmpErvUVFRjCxI0q+nL9THzpz/k6FNOFOT2NBiP/EcH3/CGb
zVuyeHxMsJ0eIxFUDBf1QiJCVnBgwM96RCK6A7+tT9qQ+G0GVISDX9HFRiBi
+aiz5UA3lG9bF73TuZdHFz8czPBdzsEy4uLp2JgRnLuZS5VKzEe6qfKj5OtD
KH/+qStzUxcGPKhytlreDh4XUobMN9Qu7GHcU8131tbS+nF1WtTpRhLwLbIY
5WOUoFF1i8+Qzhy4Ki+2VDrbiLTWq979IZkom33UofhuA1jWpvkcOFXLk1eZ
2ZJt5vZ0mHJ79IdiFxkNzp7RF5fqQpe+1jyX+U9wsYO7z+JPCnCl+Hctyx8C
loOCML8VkafPs1oaUSL+pVjQmGg4mNaMl1eI95+Qq8OO7+dfkAap+PxfzozQ
tga0VjWKjQzrhIC0vBpNw3ye/HN37ezf79zpsD/70yRdohPNqF2HG3T6MOqg
iq7abDkorn/jkVnEgJlX5GveCX3gtqR9911W0wIfNv/7ofvhZVijqB1RsmcK
WHmOgYafp8HINTFw9WgW2PTeFGnR4cKR2Yu9S7ePgLuCgersVSLiw7QAdUYn
j/84nT7u8OomB1+gnY+J6wQSq9qTW7OnUddG/eOZzkm09f/oG3xlHkUirV5p
XllE2Ca+mDpvJ0z4fX/4nzmQmhMF9FefNb5YtrkYe8vennrQ/6Mvmkd3Wy8u
g//lbqW/PfIGW7Ticu7XN2MSlqvIYhVPHjMWj6sty+DT1x3dZHTbiwJMafd8
m0UtQHrDmrFsZkGaoyks2tEKqUdFIwmOT3HMTkt319PRBV3/B2QUUGo=
          
          "], CompressedData["
1:eJwBvQFC/iFib1JlAQAAADYAAAC7rG5Um94AwHsQ6YosV/E/B9N/vUVIAsAK
/bpOA6Tgv6w/7z4FnPA/EhZF84jP1b+DGbdJuQrkv3aAuv7qkeU/DdUn/v9V
7T/gBnfI/Fn0P5HDkvd2ieM/E2PWBvdg5b8fpBNs9Obcv7H/fMmWvOG/zBMr
3Nit4z8Y9UY3swDRv3ymG+Oti/A/XQmPqiVvAMCePfyt1gK7P7MVLxG86Ki/
5GAfXk3a8D+70e3IcMLuP8suE1uG+UI/TjTegx/K5D98+bV/YTPVP2STd5sM
/Nk/d77kFpcU5L+iYI9J2nbZP54iwIj+gei/RMq8qZIO/79AHydl5ogDwLXO
cU/q6/M/Ae7Vzw+N6z+C722yuOXcv6GJK4wTPYK/CQG7VZgY2D8mB/PsBu7N
v6xpg5PfwOQ/G/TARs8h4b/zvi8rJsfnvzdzANFDndc/Vttfi6C/6z/d1w4D
43P0PzRfHlk9GtW/FFurSat87z+4Y8mIN3bPv9Y9LRruTOs/b2lJFFCO9T/7
026pgHbvP/ukjX/3NvY/7tcXFltcsz8cRfJ2B+cCwKdcKHnlb8O/3jANWO4X
jz91s+gL
          "]}, "Nominal-Numerical" -> 
        Association["NumericalVector" -> CompressedData["
1:eJxlVmk4FAobRZZEUdyrJJXoUjdlp+1VpEQ3e6IS4aPShopCmxbUValE1igk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           "]]], 
      "CholeskyTraining" -> CompressedData["
1:eJzt2mdQFmu3LmrABCJRkSBKlhwki9CDIEkUJEoSREABkRwERKLknINIDio5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       "], "HyperparameterSample" -> {}, 
      "GPModelSample" -> {}, "CholeskySample" -> {}, 
      "FeatureType" -> {
       "Numerical", "Numerical", "Numerical", "Numerical", "Numerical", 
        "Numerical", "Numerical", "Numerical", "Numerical"}, 
      "InputFeatures" -> {}, "Processor" -> 
      MachineLearning`MLProcessor["Sequence", 
        Association[
        "Input" -> Association[
          "(f1f2f3f4f5f6f7f8f9)" -> 
           Association["Type" -> "NumericalVector", "Weight" -> 9]], "Output" -> 
         Association[
          "(f1f2f3f4f5f6f7f8f9)" -> 
           Association["Type" -> "NumericalVector", "Weight" -> 9]], 
         "Processors" -> {
           MachineLearning`MLProcessor["Standardize", 
            Association[
            "Invertibility" -> "Perfect", "Missing" -> "Allowed", "Input" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Mean" -> {0.04604035707689126, 
              0.0025011596837362956`, -0.012309114957882901`, 
              0.11060463269478515`, 0.012367012685519076`, 
              0.03198283288285437, 0.05294194187815216, 
              0.0037720343806291394`, -0.036036521746359795`}, 
             "StandardDeviation" -> {1.1175696339971777`, 0.9605170946726027, 
              0.9602165811714687, 1.037717851759597, 1.0068478245135886`, 
              1.0162133441828511`, 0.962090587772831, 0.9686404489887727, 
              0.9986491340376171}, "Output" -> 
             Association[
              "(f1f2f3f4f5f6f7f8f9)" -> 
               Association["Type" -> "NumericalVector", "Weight" -> 9]], 
             "Version" -> {11.3, 0}, "ID" -> 4637115738349129565]], 
           MachineLearning`MLProcessor["FirstValues", 
            Association[
            "Info" -> Association["Type" -> "NumericalVector", "Weight" -> 9],
              "Key" -> "(f1f2f3f4f5f6f7f8f9)", "Invertibility" -> "Perfect", 
             "Missing" -> "Allowed"]]}, "Invertibility" -> "Perfect", 
         "Missing" -> "Allowed"]], "Method" -> "GaussianProcess", "Options" -> 
      Association[
       AssumeDeterministic -> 
        Association["Value" -> False, "Options" -> Association[]], 
        "CovarianceType" -> 
        Association[
         "Value" -> Association[
           "Numerical" -> "SquaredExponential", "Nominal" -> 
            "HammingDistance"], "Options" -> Association[]], 
        "EstimationMethod" -> 
        Association[
         "Value" -> "MaximumPosterior", "Options" -> Association[]], 
        "OptimizationMethod" -> 
        Association["Value" -> Automatic, "Options" -> Association[]], 
        "SearchMethod" -> 
        Association[
         "Value" -> "SimulatedAnnealing", "Options" -> Association[]], 
        "InputFeatures" -> 
        Association["Value" -> {}, "Options" -> Association[]]]], 
    "TrainingInformation" -> 
    Association[
     "LossName" -> "StandardDeviation", "BestModelInformation" -> Dataset[
        Association[
        "MeanCrossEntropy" -> 
         PlusMinus[4.7686120585310965`, 0.23911142422273393`], 
         "StandardDeviation" -> 
         PlusMinus[63.11601462276976, 15.50366059245441], "EvaluationTime" -> 
         0.00015438095238095234`, "TestSize" -> 28, "TrainingSize" -> 54, 
         "TrainingTime" -> 0.21723166666666666`, "TrainingMemory" -> 
         362474.6666666666, "ModelMemory" -> 55152., "ExperimentCount" -> 2, 
         "ModelUtility" -> 0.00009851202875663186, "MeanCrossEntropyHistory" -> {
           PlusMinus[5.018800875610996, 0.23022787950455129`], 
           PlusMinus[4.62827804448684, 0.17242706684385628`]}, 
         "StandardDeviationHistory" -> {
           PlusMinus[66.59723113750954, 19.36521516906864], 
           PlusMinus[58.05779638355035, 23.34294199768002]}, 
         "Configuration" -> {
          "GaussianProcess", AssumeDeterministic -> False, 
           "CovarianceType" -> {
            None, "Numerical" -> "SquaredExponential", "Nominal" -> 
             "HammingDistance"}, "EstimationMethod" -> "MaximumPosterior", 
           "OptimizationMethod" -> Automatic, "SearchMethod" -> 
           "SimulatedAnnealing", "InputFeatures" -> {}}], 
        TypeSystem`Struct[{
         "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
          "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
          "ModelMemory", "ExperimentCount", "ModelUtility", 
          "MeanCrossEntropyHistory", "StandardDeviationHistory", 
          "Configuration"}, {TypeSystem`AnyType, TypeSystem`AnyType, 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Real], 
          TypeSystem`Atom[Integer], 
          TypeSystem`Atom[Real], 
          TypeSystem`Vector[TypeSystem`AnyType, 2], 
          TypeSystem`Vector[TypeSystem`AnyType, 2], 
          TypeSystem`Tuple[{
            TypeSystem`Atom[String], TypeSystem`AnyType, TypeSystem`AnyType, 
            TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType, 
            TypeSystem`AnyType}]}], 
        Association["ID" -> 8972334171778]], "Configurations" -> Dataset[
        Association[
        Association[
          "Value" -> "GaussianProcess", "Options" -> 
           Association[
            AssumeDeterministic -> Association["Value" -> False], 
             "CovarianceType" -> 
             Association[
              "Value" -> None, "Options" -> 
               Association[
                "Numerical" -> Association["Value" -> "SquaredExponential"], 
                 "Nominal" -> Association["Value" -> "HammingDistance"]]], 
             "EstimationMethod" -> Association["Value" -> "MaximumPosterior"],
              "OptimizationMethod" -> Association["Value" -> Automatic], 
             "SearchMethod" -> Association["Value" -> "SimulatedAnnealing"], 
             "InputFeatures" -> Association["Value" -> {}]]] -> 
         Association["Experiments" -> {
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[6.795360458353772, 0.4101589211541707], 
              "StandardDeviation" -> 
              PlusMinus[138.74730188746395`, 18.60550033086022], 
              "EvaluationTime" -> 0.000040689655172413795`, "TestSize" -> 58, 
              "TrainingSize" -> 10, "TrainingTime" -> 0.337903, 
              "TrainingMemory" -> 204760, "ModelMemory" -> 22512, 
              "ExperimentCount" -> 1, "ModelUtility" -> 
              0.000021280837300470914`, "MeanCrossEntropyHistory" -> {
                PlusMinus[6.795360458353772, 0.29002615451227254`]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[138.74730188746395`, 13.156075451319815`]}], 
             Association[
             "MeanCrossEntropy" -> 
              PlusMinus[4.7686120585310965`, 0.23911142422273393`], 
              "StandardDeviation" -> 
              PlusMinus[63.11601462276976, 15.50366059245441], 
              "EvaluationTime" -> 0.00015438095238095234`, "TestSize" -> 28, 
              "TrainingSize" -> 54, "TrainingTime" -> 0.21723166666666666`, 
              "TrainingMemory" -> 362474.6666666666, "ModelMemory" -> 55152., 
              "ExperimentCount" -> 2, "ModelUtility" -> 
              0.00009851202875663186, "MeanCrossEntropyHistory" -> {
                PlusMinus[5.018800875610996, 0.23022787950455129`], 
                PlusMinus[4.62827804448684, 0.17242706684385628`]}, 
              "StandardDeviationHistory" -> {
                PlusMinus[66.59723113750954, 19.36521516906864], 
                PlusMinus[58.05779638355035, 23.34294199768002]}]}, 
           "PredictedPerformances" -> 
           Association[
            "EvaluationTime" -> 0.00015438095238095234`, "ModelMemory" -> 
             55152., "StandardDeviation" -> 
             PlusMinus[63.11601462276976, 15.50366059245441], 
             "TrainingMemory" -> 362474.6666666666, "TrainingTime" -> 
             0.4856205333333333], "Index" -> 1]], 
        TypeSystem`Assoc[
         TypeSystem`Struct[{"Value", "Options"}, {
           TypeSystem`Atom[String], 
           TypeSystem`Assoc[TypeSystem`AnyType, 
            TypeSystem`Struct[{"Value", "Options"}, {TypeSystem`AnyType, 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Value"}, {
                 TypeSystem`Atom[String]}], 2]}], 6]}], 
         TypeSystem`Struct[{"Experiments", "PredictedPerformances", "Index"}, {
           TypeSystem`Vector[
            
            TypeSystem`Struct[{
             "MeanCrossEntropy", "StandardDeviation", "EvaluationTime", 
              "TestSize", "TrainingSize", "TrainingTime", "TrainingMemory", 
              "ModelMemory", "ExperimentCount", "ModelUtility", 
              "MeanCrossEntropyHistory", "StandardDeviationHistory"}, {
             TypeSystem`AnyType, TypeSystem`AnyType, 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Real], 
              TypeSystem`Atom[Integer], 
              TypeSystem`Atom[Real], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength], 
              TypeSystem`Vector[TypeSystem`AnyType, TypeSystem`AnyLength]}], 
            2], 
           
           TypeSystem`Struct[{
            "EvaluationTime", "ModelMemory", "StandardDeviation", 
             "TrainingMemory", "TrainingTime"}, {
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real], TypeSystem`AnyType, 
             TypeSystem`Atom[Real], 
             TypeSystem`Atom[Real]}], 
           TypeSystem`Atom[Integer]}], 1], 
        Association["ID" -> 8968039204482]], "MaxTrainingSize" -> 68, 
      "LastReportingTime" -> 3.745013634055436`16.32602839228603*^9, 
      "PreprocessorEvaluationTime" -> 3.5771484375`2.*^-6, 
      "PreprocessorMemory" -> 48112, "RoundPartitioning" -> Dataset[{
         Association[
         "TrainingSizes" -> 10, "TimeBudgets" -> 0.4, "ElapsedTimes" -> 
          0.342386, "ExperimentCounts" -> 1], 
         Association[
         "TrainingSizes" -> 54, "TimeBudgets" -> 0.5, "ElapsedTimes" -> 
          0.514446, "ExperimentCounts" -> 2]}, 
        TypeSystem`Vector[
         TypeSystem`Struct[{
          "TrainingSizes", "TimeBudgets", "ElapsedTimes", 
           "ExperimentCounts"}, {
           TypeSystem`Atom[Integer], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Real], 
           TypeSystem`Atom[Integer]}], 2], 
        Association[
        "Origin" -> HoldComplete[GeneralUtilities`AssociationTranspose, 
           Dataset`DatasetHandle[8976629139074]], "ID" -> 8980924106370]]], 
    "Log" -> Association["Example" -> MachineLearning`MLDataset[
        Association[
        "f1" -> Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {0}, "ID" -> 
           1635758485550590698], "f2" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {3.517}, "ID" -> 
           3792239814675432237], "f3" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.283}, "ID" -> 
           6788520538275450158], "f4" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {6.3951}, "ID" -> 
           3665614283994286067], "f5" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {4.6226}, "ID" -> 
           4198949004418315711], "f6" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {10.258}, "ID" -> 
           2198503552849512914], "f7" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {19.768}, "ID" -> 
           380823439434077212], "f8" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {43.431}, "ID" -> 
           153932119762769494], "f9" -> 
         Association[
          "Type" -> "Numerical", "Weight" -> 1, "Values" -> {22.2}, "ID" -> 
           3753923023160904854]], 
        Association[
        "ExampleNumber" -> 1, "ExampleWeights" -> 1, "RawExample" -> False]], 
      "TrainingTime" -> 1.12291, "MaxTrainingMemory" -> 640672, "DataMemory" -> 
      22624, "FunctionMemory" -> 183888, "LanguageVersion" -> {11.3, 0}, 
      "Date" -> DateObject[{2018, 9, 4, 1, 33, 54.303484`8.487402668355973}, 
        "Instant", "Gregorian", 1.], "ProcessorCount" -> 4, "ProcessorType" -> 
      "x86-64", "OperatingSystem" -> "MacOSX", "SystemWordLength" -> 64, 
      "Evaluations" -> {}]]],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{3.7450086759069443`*^9, 3.7450089900189257`*^9, 
  3.74500981481642*^9, 3.74501003432745*^9},
 CellLabel->
  "Out[204]=",ExpressionUUID->"d54ea026-61ab-459c-898b-f5f256bff489"],

Cell[BoxData["0.9112779266545832`"], "Output",
 CellChangeTimes->{3.7450086759069443`*^9, 3.7450089900189257`*^9, 
  3.74500981481642*^9, 3.745010034568488*^9},
 CellLabel->
  "Out[205]=",ExpressionUUID->"8b6cd387-e1e9-4cc0-b659-21a14285b8ed"]
}, Open  ]]
},
WindowSize->{1117, 953},
WindowMargins->{{585, Automatic}, {96, Automatic}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1273, 30, 94, "Input",ExpressionUUID->"b5260f66-0901-4ca6-9508-95314d52b121"],
Cell[CellGroupData[{
Cell[1856, 54, 1089, 27, 94, "Input",ExpressionUUID->"96364fb8-a271-4fa9-a100-91457a7db652"],
Cell[2948, 83, 154, 3, 34, "Output",ExpressionUUID->"fbba753d-bfb5-4e04-a0cd-7983c45511a3"],
Cell[3105, 88, 154, 3, 34, "Output",ExpressionUUID->"62c1057e-3785-47f7-b113-56e69bc98646"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3296, 96, 316, 5, 52, "Input",ExpressionUUID->"f8b948e9-3a89-4a84-8434-187e1206cb65"],
Cell[3615, 103, 269, 5, 34, "Output",ExpressionUUID->"08f5f95d-1364-4a99-863b-666cb928a7b3"],
Cell[3887, 110, 755, 18, 34, "Output",ExpressionUUID->"79d60625-64ba-422e-b233-d4c6772d8731"]
}, Open  ]],
Cell[4657, 131, 195, 6, 73, "Text",ExpressionUUID->"2ebc40b9-6072-4783-966c-a3460deb9526"],
Cell[CellGroupData[{
Cell[4877, 141, 767, 14, 94, "Input",ExpressionUUID->"25d3cdbc-5bfd-4dbd-b412-7fb43cc02964"],
Cell[5647, 157, 8149, 140, 477, "Output",ExpressionUUID->"1524ef44-669e-41fb-9b84-c9425457238e"]
}, Open  ]],
Cell[13811, 300, 218, 6, 97, "Text",ExpressionUUID->"f5ad171a-da16-438d-84aa-0c2172ec31ce"],
Cell[14032, 308, 169, 6, 58, "Text",ExpressionUUID->"740fdd0f-c629-4027-a90e-fa6a1f73f4b5"],
Cell[CellGroupData[{
Cell[14226, 318, 473, 8, 52, "Input",ExpressionUUID->"c5b9ad86-7bce-422a-9b73-5a42fc101a38"],
Cell[14702, 328, 271, 4, 34, "Output",ExpressionUUID->"5e6a4194-afac-4bb4-a811-c0d0825b5af4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15010, 337, 259, 5, 30, "Input",ExpressionUUID->"6f0e970f-57b4-4d75-8ba8-86f72f9dcbc4"],
Cell[15272, 344, 776, 18, 34, "Output",ExpressionUUID->"ce82f9b0-1f85-42ec-b6eb-282434d74e4d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16085, 367, 233, 5, 30, "Input",ExpressionUUID->"48637d52-3548-4efc-a08e-e36b84f2dfa7"],
Cell[16321, 374, 859, 20, 56, "Output",ExpressionUUID->"c83c5be2-fdf3-422e-9ec2-e235d3f143c1"]
}, Open  ]],
Cell[17195, 397, 192, 6, 97, "Text",ExpressionUUID->"f70cf314-8255-4cb8-840b-fd2ce86c108d"],
Cell[CellGroupData[{
Cell[17412, 407, 597, 15, 52, "Input",ExpressionUUID->"a3578630-5aa8-4551-b23a-6ee9516af543"],
Cell[18012, 424, 5263, 97, 408, "Output",ExpressionUUID->"91ce860c-f17d-4ae9-a510-fdc621c8bb63"]
}, Open  ]],
Cell[23290, 524, 191, 6, 97, "Text",ExpressionUUID->"766a08eb-4c2c-4d9f-aa3d-6ca71d3242d0"],
Cell[CellGroupData[{
Cell[23506, 534, 599, 15, 52, "Input",ExpressionUUID->"12a1efa8-d076-44cf-b0c3-c410e3d68842"],
Cell[24108, 551, 1905, 40, 361, "Output",ExpressionUUID->"580250f7-6f2b-424d-b861-7b61c44cd810"]
}, Open  ]],
Cell[26028, 594, 187, 6, 97, "Text",ExpressionUUID->"f34ab015-bd38-4efc-8146-2ed667f601e6"],
Cell[26218, 602, 178, 7, 81, "Text",ExpressionUUID->"2c43069c-4721-4936-965c-4cd13437c7d2"],
Cell[CellGroupData[{
Cell[26421, 613, 562, 13, 52, "Input",ExpressionUUID->"c7f23cd2-0c75-4473-ad5c-acc58a632254"],
Cell[26986, 628, 37616, 628, 437, 5556, 102, "CachedBoxData", "BoxData", "Output",ExpressionUUID->"27643d36-ff81-49b5-b832-2866688c70be"]
}, Open  ]],
Cell[64617, 1259, 216, 6, 97, "Text",ExpressionUUID->"242bf46f-31aa-49a1-929d-af76429950c8"],
Cell[64836, 1267, 1244, 33, 73, "Input",ExpressionUUID->"92f58ce4-88c1-445c-bf20-db19063d1bba"],
Cell[CellGroupData[{
Cell[66105, 1304, 206, 4, 30, "Input",ExpressionUUID->"4b9784af-5552-4e87-8bd9-a4e969042f61"],
Cell[66314, 1310, 890, 21, 67, "Output",ExpressionUUID->"f7c7bc09-7ea3-420b-8ad5-c6ed5258b024"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67241, 1336, 207, 4, 30, "Input",ExpressionUUID->"616b145f-6ece-4454-980c-a2a3e91d77f2"],
Cell[67451, 1342, 728, 19, 67, "Output",ExpressionUUID->"722008e1-d13f-4f58-9df4-2fe8a32beb57"]
}, Open  ]],
Cell[68194, 1364, 2367, 63, 241, "Input",ExpressionUUID->"b92affb6-f17d-4971-8c77-8da3299b4b37"],
Cell[70564, 1429, 199, 6, 96, "Text",ExpressionUUID->"6f39b4f0-70f2-4277-a288-9115aac55db6"],
Cell[CellGroupData[{
Cell[70788, 1439, 1591, 39, 73, "Input",ExpressionUUID->"92eef82d-ed1e-483b-bf4f-46ee590ef760"],
Cell[72382, 1480, 51585, 935, 63, "Output",ExpressionUUID->"d5f0c327-c57f-47e5-b48a-6d008cf8b117"],
Cell[123970, 2417, 399, 7, 34, "Output",ExpressionUUID->"78f206c4-009a-4216-b5b3-9aa6df309d0f"]
}, Open  ]],
Cell[124384, 2427, 195, 6, 97, "Text",ExpressionUUID->"fe1b3969-a22c-4efd-a20b-4dd5f481af59"],
Cell[CellGroupData[{
Cell[124604, 2437, 1164, 32, 52, "Input",ExpressionUUID->"3082f434-e6f6-471f-8321-9de2e44eaa21"],
Cell[125771, 2471, 161209, 2957, 63, "Output",ExpressionUUID->"31befb80-305b-4748-929f-566d0666cf00"],
Cell[286983, 5430, 265, 4, 34, "Output",ExpressionUUID->"3658e555-3105-4dee-848a-530160b21450"]
}, Open  ]],
Cell[287263, 5437, 198, 6, 97, "Text",ExpressionUUID->"d1bd7652-a4d6-434a-a0bc-193597464878"],
Cell[CellGroupData[{
Cell[287486, 5447, 1163, 33, 52, "Input",ExpressionUUID->"dc16428b-f2e7-4b00-96c4-b49886a67e26"],
Cell[288652, 5482, 65240, 1179, 63, "Output",ExpressionUUID->"d54ea026-61ab-459c-898b-f5f256bff489"],
Cell[353895, 6663, 243, 4, 34, "Output",ExpressionUUID->"8b6cd387-e1e9-4cc0-b659-21a14285b8ed"]
}, Open  ]]
}
]
*)

