(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     51782,       1242]
NotebookOptionsPosition[     47054,       1157]
NotebookOutlinePosition[     47409,       1173]
CellTagsIndexPosition[     47366,       1170]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<(ops1 (\[Lambda] \[ScriptY] . (ops2 3 \[ScriptY])) \
\[ScriptX])\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<(\[Lambda] \[ScriptY] . (ops2 3 \[ScriptY]))\>\"", ",", 
          "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops2 3 \[ScriptY])\>\"", ",", "rules2"}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", " ", "ops1", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "ops2", " ", "3", " ", "y"}], ")"}]}]}], 
            ")"}], " ", "x"}], ")"}], "/.", "rules"}], "]"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
        "\"\<(ops1 (\[Lambda] \[ScriptY] . (ops2 3 \[ScriptY])) \[ScriptX])\>\
\"", ",", "rules2"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"trace0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{"x", "->", "\"\<\[ScriptX]\>\""}], "}"}]}], "}"}], ",", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"StringQ", "[", 
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", "True"}],
               ",", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<\[ScriptX]\>\"", "\[Rule]", "\"\<2\>\""}], 
                 "}"}]}], "]"}], ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ii", "\[Equal]", 
              RowBox[{"Length", "@", "list"}]}], ",", " ", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"tmp2", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<\[ScriptY]\>\"", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<y\>\"", "\[Rule]", "\"\<\[ScriptY]\>\""}], 
                    "}"}]}], "]"}], ")"}]}], "}"}]}], "]"}], ",", "tmp2"}], 
            "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"jj", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQB2IQ/X5OiwTDp9eOap+dpMB014mv7ED6bYjrTxC9xWHJ
PxDtVH6cmQNI95V85gTRbf/WWoJohWnXbUG0VuN2BxCt4lnpCaLv/a/zAtFT
zp2JBdF1F7XjQLSlNGsKiDZ15gHT31ZkZIBojx+2+SD6k/CmEhAduViyHER/
nbSgFUTPEJ3XA6KzU85MBNFyt6dMAtF+Wiuvg2iztI1gekVt920Q/WhT/BsQ
vTQzgJ8TSCveTALTOzoUVUG0mNA8MH2iRdQIRDtUGZqA6PpXgnYg+lFLmCOI
vnK/OABEfxK6FAyiLZjCY0G06PGlYHpff30KiE47czcVRLcUHs4H0cndNwpB
9FNzTgceIC1U4+gPogE4xLv0
  "],
 EmphasizeSyntaxErrors->True,
 CellLabel->
  "In[166]:=",ExpressionUUID->"7df64f4f-32f3-43cb-bb24-31ffbc8a17f9"],

Cell[BoxData["\<\"(* (\[Lambda] \[ScriptY] . (+ 3 \[ScriptY])) \
\[ScriptX])\"\>"], "Output",
 CellChangeTimes->{
  3.750756528962874*^9, 3.750756562621726*^9, 3.7507724441982594`*^9, {
   3.750772712000194*^9, 3.7507727284526377`*^9}, 3.7507727685492153`*^9, 
   3.750773258196813*^9, 3.750773500075239*^9, {3.750773597268322*^9, 
   3.750773626888958*^9}, {3.750773689040332*^9, 3.7507737014863234`*^9}, 
   3.750773811964959*^9, {3.750773852115047*^9, 3.750773861339439*^9}, {
   3.750773910392045*^9, 3.7507739431142273`*^9}, 3.75077446190263*^9, {
   3.750774524273314*^9, 3.750774543527956*^9}, {3.750774595330085*^9, 
   3.7507746384999323`*^9}, {3.7507749076285763`*^9, 3.750774954563785*^9}, {
   3.750775086492379*^9, 3.750775107944228*^9}, {3.750775190556348*^9, 
   3.750775202299388*^9}, {3.750775285119466*^9, 3.7507752954862843`*^9}, 
   3.750775398254586*^9, 3.750775456436392*^9, 3.750775501683063*^9, 
   3.750775534830814*^9, 3.750775600528679*^9, {3.750775695082594*^9, 
   3.75077575826416*^9}, {3.750781500383108*^9, 3.750781563967348*^9}, {
   3.750781877482033*^9, 3.750781900689468*^9}, 3.7507834558241653`*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"53e67d77-95f2-4d10-8db2-5ad728c8806d"],

Cell[BoxData[
 RowBox[{"x", " ", 
  RowBox[{"(", 
   RowBox[{"3", "+", "y$6099"}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.750756528962874*^9, 3.750756562621726*^9, 3.7507724441982594`*^9, {
   3.750772712000194*^9, 3.7507727284526377`*^9}, 3.7507727685492153`*^9, 
   3.750773258196813*^9, 3.750773500075239*^9, {3.750773597268322*^9, 
   3.750773626888958*^9}, {3.750773689040332*^9, 3.7507737014863234`*^9}, 
   3.750773811964959*^9, {3.750773852115047*^9, 3.750773861339439*^9}, {
   3.750773910392045*^9, 3.7507739431142273`*^9}, 3.75077446190263*^9, {
   3.750774524273314*^9, 3.750774543527956*^9}, {3.750774595330085*^9, 
   3.7507746384999323`*^9}, {3.7507749076285763`*^9, 3.750774954563785*^9}, {
   3.750775086492379*^9, 3.750775107944228*^9}, {3.750775190556348*^9, 
   3.750775202299388*^9}, {3.750775285119466*^9, 3.7507752954862843`*^9}, 
   3.750775398254586*^9, 3.750775456436392*^9, 3.750775501683063*^9, 
   3.750775534830814*^9, 3.750775600528679*^9, {3.750775695082594*^9, 
   3.75077575826416*^9}, {3.750781500383108*^9, 3.750781563967348*^9}, {
   3.750781877482033*^9, 3.750781900689468*^9}, 3.750783455837172*^9},
 CellLabel->
  "Out[176]=",ExpressionUUID->"c01361c4-68c5-424e-9e67-084dd980e0f2"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(* (\[Lambda] \[ScriptY] . (+ 3 \[ScriptY])) \[ScriptX])\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] \[ScriptY] . (+ 3 \[ScriptY]))\"","\"[\"","y",
       OverscriptBox["\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$6099", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" substitute a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(+ 3 \[ScriptY]$6099)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.750756528962874*^9, 3.750756562621726*^9, 3.7507724441982594`*^9, {
   3.750772712000194*^9, 3.7507727284526377`*^9}, 3.7507727685492153`*^9, 
   3.750773258196813*^9, 3.750773500075239*^9, {3.750773597268322*^9, 
   3.750773626888958*^9}, {3.750773689040332*^9, 3.7507737014863234`*^9}, 
   3.750773811964959*^9, {3.750773852115047*^9, 3.750773861339439*^9}, {
   3.750773910392045*^9, 3.7507739431142273`*^9}, 3.75077446190263*^9, {
   3.750774524273314*^9, 3.750774543527956*^9}, {3.750774595330085*^9, 
   3.7507746384999323`*^9}, {3.7507749076285763`*^9, 3.750774954563785*^9}, {
   3.750775086492379*^9, 3.750775107944228*^9}, {3.750775190556348*^9, 
   3.750775202299388*^9}, {3.750775285119466*^9, 3.7507752954862843`*^9}, 
   3.750775398254586*^9, 3.750775456436392*^9, 3.750775501683063*^9, 
   3.750775534830814*^9, 3.750775600528679*^9, {3.750775695082594*^9, 
   3.75077575826416*^9}, {3.750781500383108*^9, 3.750781563967348*^9}, {
   3.750781877482033*^9, 3.750781900689468*^9}, 3.7507834558484907`*^9},
 CellLabel->
  "Out[181]=",ExpressionUUID->"55c3b05d-bba6-426e-81dc-57f46a2807f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", " ", "ops1", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "ops2", " ", "3", " ", "y"}], ")"}]}]}], 
            ")"}], " ", "x"}], ")"}], "/.", "rules"}], "]"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
        "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", "rules2"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"trace0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{"x", "->", "\"\<\[ScriptX]\>\""}], "}"}]}], "}"}], ",", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"StringQ", "[", 
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", "True"}],
               ",", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<2\>\""}], "}"}]}], 
               "]"}], ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ii", "\[Equal]", 
              RowBox[{"Length", "@", "list"}]}], ",", " ", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"tmp2", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<y\>\"", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}], ")"}]}], "}"}]}], 
              "]"}], ",", "tmp2"}], "]"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]",
           "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"jj", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750756548144157*^9, 3.750756562092181*^9}, {
   3.750772654266864*^9, 3.750772682166617*^9}, {3.7507727251328983`*^9, 
   3.750772766233308*^9}, {3.750772815607978*^9, 3.7507731974373198`*^9}, {
   3.750773230737076*^9, 3.750773253734517*^9}, {3.7507733237901783`*^9, 
   3.750773331968734*^9}, {3.750773486400217*^9, 3.750773489369323*^9}, {
   3.750773536159573*^9, 3.750773536383204*^9}, {3.750773571270625*^9, 
   3.750773625936558*^9}, {3.7507736695649347`*^9, 3.75077368880119*^9}, {
   3.750773805017939*^9, 3.750773860940136*^9}, {3.750773902387258*^9, 
   3.7507739086517477`*^9}, {3.750774461286414*^9, 3.750774461543727*^9}, {
   3.750774492359089*^9, 3.7507746269905863`*^9}, {3.750774906512896*^9, 
   3.750774907089005*^9}, {3.7507750810479393`*^9, 3.7507750849397078`*^9}, {
   3.7507751846724586`*^9, 3.750775201546173*^9}, {3.750775280559875*^9, 
   3.750775306703721*^9}, {3.750775427621073*^9, 3.7507754545648127`*^9}, {
   3.750775530719021*^9, 3.750775533180552*^9}, {3.7507755879862967`*^9, 
   3.750775598931201*^9}, {3.750775678107607*^9, 3.750775694767015*^9}, {
   3.750781440288073*^9, 3.7507815620463953`*^9}, {3.750781665953886*^9, 
   3.750781698060912*^9}, 3.7507820297638817`*^9, 3.75078212803508*^9, {
   3.75078357017374*^9, 3.7507835928586206`*^9}},
 CellLabel->
  "In[227]:=",ExpressionUUID->"778b9dcf-6cda-4891-bf2f-0a89050ec2db"],

Cell[BoxData["\<\"(* (\[Lambda] y . (^ 3 y)) x)\"\>"], "Output",
 CellChangeTimes->{
  3.7507816993127317`*^9, {3.750781850518671*^9, 3.750781872950053*^9}, {
   3.750782004021734*^9, 3.750782030580799*^9}, 3.7507820743264112`*^9, 
   3.750782128645109*^9, 3.750782321583581*^9, 3.750782605705841*^9, 
   3.750783045879299*^9, {3.750783093844316*^9, 3.7507831121825027`*^9}, 
   3.750783235371558*^9, {3.750783327820861*^9, 3.750783334524405*^9}, 
   3.75078346457677*^9, {3.750783571644721*^9, 3.7507835931499023`*^9}},
 CellLabel->
  "Out[235]=",ExpressionUUID->"96bac231-6f0d-4bda-b0f8-582ee3b17a71"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "y$6170"], " ", "x"}]], "Output",
 CellChangeTimes->{
  3.7507816993127317`*^9, {3.750781850518671*^9, 3.750781872950053*^9}, {
   3.750782004021734*^9, 3.750782030580799*^9}, 3.7507820743264112`*^9, 
   3.750782128645109*^9, 3.750782321583581*^9, 3.750782605705841*^9, 
   3.750783045879299*^9, {3.750783093844316*^9, 3.7507831121825027`*^9}, 
   3.750783235371558*^9, {3.750783327820861*^9, 3.750783334524405*^9}, 
   3.75078346457677*^9, {3.750783571644721*^9, 3.7507835931630993`*^9}},
 CellLabel->
  "Out[236]=",ExpressionUUID->"920194c6-74bb-4e36-8099-3bfdaa586ed6"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{"\"(* (\[Lambda] y . (^ 3 y)) x)\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] y . (^ 3 y))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$6170", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" substitute a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{RowBox[{"\"(^ 3 \"", "~~", 
         RowBox[{"Construct", "\[LeftDoubleBracket]", 
           RowBox[{"Null", ",", "y$6170", ",", "Null"}], 
           "\[RightDoubleBracket]"}], "~~", "\")\""}]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7507816993127317`*^9, {3.750781850518671*^9, 3.750781872950053*^9}, {
   3.750782004021734*^9, 3.750782030580799*^9}, 3.7507820743264112`*^9, 
   3.750782128645109*^9, 3.750782321583581*^9, 3.750782605705841*^9, 
   3.750783045879299*^9, {3.750783093844316*^9, 3.7507831121825027`*^9}, 
   3.750783235371558*^9, {3.750783327820861*^9, 3.750783334524405*^9}, 
   3.75078346457677*^9, {3.750783571644721*^9, 3.750783593235005*^9}},
 CellLabel->
  "Out[241]=",ExpressionUUID->"844134c9-b98d-4cbd-8b7a-d02d90f278a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "0", "\[Rule]", 
        "\"\<((\[Lambda] \[ScriptX] . (Power (\[Lambda] \[ScriptY] . (Plus 3 \
\[ScriptY])) \[ScriptX])))\>\""}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "1", "\[Rule]", 
        "\"\<((\[Lambda] \[ScriptX] . (Power (\[Lambda] \[ScriptY] . (Plus 3 \
\[ScriptY])) \[ScriptX])))\>\""}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "2", "\[Rule]", 
        "\"\<(Power (\[Lambda] \[ScriptY] . (Plus 3 \[ScriptY])) \
\[ScriptX])\>\""}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "3", "\[Rule]", 
        "\"\<(\[Lambda] \[ScriptY] . (Plus 3 \[ScriptY]))\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"4", "\[Rule]", "\"\<(Plus 3 \[ScriptY])\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"5", "\[Rule]", "\"\<2\>\""}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{"(", 
         RowBox[{"0", " ", 
          RowBox[{"(", 
           RowBox[{"1", " ", "\[Lambda]", " ", 
            RowBox[{"x", " ", ".", " ", 
             RowBox[{"(", 
              RowBox[{"2", " ", "Power", " ", 
               RowBox[{"(", 
                RowBox[{"3", " ", "\[Lambda]", " ", 
                 RowBox[{"y", " ", ".", " ", 
                  RowBox[{"(", 
                   RowBox[{"4", " ", "Plus", " ", "3", " ", "y"}], ")"}]}]}], 
                ")"}], " ", "x"}], ")"}]}]}], " ", ")"}], 
          RowBox[{"(", 
           RowBox[{"5", " ", "2"}], ")"}]}], ")"}], "]"}], ",", 
       "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)) 2)\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750766149510957*^9, 3.750766173731985*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"aa039ac6-0344-4b43-96f1-0700f87d8b9e"],

Cell[BoxData["\<\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)) 2)\"\>"], \
"Output",
 CellChangeTimes->{
  3.750757196346587*^9, {3.750757366616794*^9, 3.750757432508459*^9}, 
   3.750757607478038*^9, {3.750757671360572*^9, 3.750757681060494*^9}, 
   3.750757984995781*^9, {3.750758062278949*^9, 3.75075809077977*^9}, 
   3.7507582289388638`*^9, 3.750758604702846*^9, {3.750758656122205*^9, 
   3.7507586853109713`*^9}, 3.750758871185137*^9, 3.750759046021256*^9, 
   3.750759129671949*^9, 3.7507602304921703`*^9, 3.7507608721566753`*^9, 
   3.750765765335113*^9, 3.750766176080558*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"a183b9fd-5e22-4417-9bee-bbfcd184e40f"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"3", "+", "y$3176"}], ")"}], "2"]], "Output",
 CellChangeTimes->{
  3.750757196346587*^9, {3.750757366616794*^9, 3.750757432508459*^9}, 
   3.750757607478038*^9, {3.750757671360572*^9, 3.750757681060494*^9}, 
   3.750757984995781*^9, {3.750758062278949*^9, 3.75075809077977*^9}, 
   3.7507582289388638`*^9, 3.750758604702846*^9, {3.750758656122205*^9, 
   3.7507586853109713`*^9}, 3.750758871185137*^9, 3.750759046021256*^9, 
   3.750759129671949*^9, 3.7507602304921703`*^9, 3.7507608721566753`*^9, 
   3.750765765335113*^9, 3.750766176093319*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"6be8f6d8-c0a5-40f7-b5ba-666666998e54"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"\<\"((\[Lambda] \[ScriptX] . (^ (\[Lambda] \[ScriptY] . (+ 3 \
\[ScriptY])) \[ScriptX])))\"\>", ",", "\<\"\"\>", ",", "\<\"[\"\>", ",", "x", 
       ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\
\[Beta] conversion\\\"\\)]\\) \"\>", ",", 
       TemplateBox[{
        "\"2\"",FrameStyle -> None,Background -> RGBColor[0.88, 1, 0.88]},
        "Highlighted"], ",", "\<\"]\"\>"}], "}"}]},
    {
     RowBox[{"{", "\<\"2\"\>", "}"}]},
    {
     RowBox[{
     "{", "\<\"(^ (\[Lambda] \[ScriptY] . (+ 3 \[ScriptY])) \[ScriptX])\"\>", 
      "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"\<\"(\[Lambda] \[ScriptY] . (+ 3 \[ScriptY]))\"\>", 
       ",", "\<\"[\"\>", ",", "y", 
       ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\
\[Alpha] conversion\\\"\\)]\\) \"\>", ",", 
       TemplateBox[{
        "y$3176",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
        "Highlighted"], ",", "\<\"]\"\>", 
       ",", "\<\" substitute a new copy\"\>"}], "}"}]},
    {
     RowBox[{"{", "\<\"(+ 3 \[ScriptY])\"\>", "}"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.750757196346587*^9, {3.750757366616794*^9, 3.750757432508459*^9}, 
   3.750757607478038*^9, {3.750757671360572*^9, 3.750757681060494*^9}, 
   3.750757984995781*^9, {3.750758062278949*^9, 3.75075809077977*^9}, 
   3.7507582289388638`*^9, 3.750758604702846*^9, {3.750758656122205*^9, 
   3.7507586853109713`*^9}, 3.750758871185137*^9, 3.750759046021256*^9, 
   3.750759129671949*^9, 3.7507602304921703`*^9, 3.7507608721566753`*^9, 
   3.750765765335113*^9, 3.75076617610433*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"39b86fd5-738b-4a43-b934-c73ab0962ec0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"trace0", "=", 
    RowBox[{"Drop", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trace", "=", 
   RowBox[{"Row", "/@", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"trace0", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{"x", "->", "\"\<\[ScriptX]\>\""}], "}"}]}], "}"}], ",", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"tmp2", "=", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"StringQ", "[", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", "True"}], 
            ",", 
            RowBox[{"StringReplace", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"\"\<\[ScriptX]\>\"", "\[Rule]", "\"\<2\>\""}], 
               "}"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "[", 
             RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ii", "\[Equal]", 
            RowBox[{"Length", "@", "list"}]}], ",", " ", 
           RowBox[{"StringReplace", "[", 
            RowBox[{"tmp2", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<\[ScriptY]\>\"", "\[Rule]", 
               RowBox[{"ToString", "[", 
                RowBox[{"\[Xi]1", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",",
            "tmp2"}], "]"}]}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"ii", ",", "1", ",", 
          RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"jj", ",", "1", ",", 
          RowBox[{"Length", "[", 
           RowBox[{"list", "[", 
            RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
     "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{"trace", ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.750758244074996*^9, 3.750758274234948*^9}, {
   3.750758339779537*^9, 3.750758390629533*^9}, {3.7507587168079033`*^9, 
   3.750758740431766*^9}, {3.750758918389207*^9, 3.75075902528829*^9}, {
   3.7507594127225857`*^9, 3.750759540511594*^9}, {3.750759616350568*^9, 
   3.750759694493495*^9}, {3.750759994784457*^9, 3.750760077023435*^9}, {
   3.750760222703403*^9, 3.7507602252888117`*^9}, {3.7507603248766613`*^9, 
   3.7507603443057747`*^9}, 3.750760399949225*^9, {3.7507604608233967`*^9, 
   3.750760488240821*^9}, {3.75076091147309*^9, 3.7507609188175507`*^9}, {
   3.750761033908736*^9, 3.7507610381930103`*^9}, {3.7507658314529676`*^9, 
   3.750765835468046*^9}, {3.7507662815838003`*^9, 3.750766285003093*^9}, {
   3.750766317015582*^9, 3.750766323118137*^9}, {3.750766574426174*^9, 
   3.750766734504128*^9}, {3.750766788044384*^9, 3.7507668336856823`*^9}, {
   3.7507668746048203`*^9, 3.750766910614915*^9}, {3.75076939503089*^9, 
   3.750769413630725*^9}, {3.75076944447432*^9, 3.7507694772722387`*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"0949a75c-b59d-47a4-945c-5d2a06564e5c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"((\[Lambda] \[ScriptX] . (^ (\[Lambda] \[ScriptY] . (+ 3 \
\[ScriptY])) \[ScriptX])))\"","\"\"","\"[\"","\"\[ScriptX]\"",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"2\"", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(^ (\[Lambda] \[ScriptY] . (+ 3 \[ScriptY])) 2)\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] \[ScriptY] . (+ 3 \[ScriptY]))\"","\"[\"","y",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Alpha] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "y$3176", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" substitute a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(+ 3 y$3176)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7507596631207447`*^9, 3.7507596948135853`*^9, 3.750759798611129*^9, {
   3.7507602262111464`*^9, 3.750760237528833*^9}, {3.7507603394056473`*^9, 
   3.750760350551675*^9}, {3.750760400603737*^9, 3.750760427171788*^9}, 
   3.75076049145252*^9, 3.750760521875169*^9, 3.750760922072054*^9, 
   3.750761039132451*^9, 3.7507657749009447`*^9, {3.750765835795423*^9, 
   3.75076584121418*^9}, {3.750766179697713*^9, 3.750766188672333*^9}, 
   3.7507662853139677`*^9, 3.7507663257080812`*^9, 3.7507668023843937`*^9, 
   3.7507668344808683`*^9, {3.750766877964126*^9, 3.750766924229616*^9}, 
   3.750769478125049*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"bf2aa384-befa-4f89-9579-5b242909ec69"]
}, Open  ]],

Cell[BoxData["x"], "Input",ExpressionUUID->"d915511a-697c-41a6-af52-579762a2c87f"],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]1"], "Input",
 CellLabel->"In[51]:=",ExpressionUUID->"23b043e2-35bb-4a8d-855a-a247422356aa"],

Cell[BoxData[
 RowBox[{"{", "y$3176", "}"}]], "Output",
 CellChangeTimes->{3.750766556487136*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"fa92c0f5-0e8c-4c54-bd35-abb1f248d368"]
}, Open  ]],

Cell[BoxData["y$3176"], "Input",ExpressionUUID->"e291733c-02f8-443e-84f3-61f39c0a3755"],

Cell[BoxData["\"\<(+ 3 \[ScriptY])\>\""], "Input",ExpressionUUID->"6df89987-e218-4cba-aec5-eedc2a464c1a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"trace", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7507607979751253`*^9, 3.75076080667505*^9}, {
  3.7507611557589607`*^9, 3.750761179393811*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"c2e69dcb-4241-4741-8015-e93fec3d1196"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.750760799672846*^9, 3.750760806873136*^9}, {
  3.750761156278911*^9, 3.7507611796717577`*^9}},
 CellLabel->"Out[71]=",ExpressionUUID->"2c17a777-1943-4c0a-ab0b-1bfe1d233cea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"trace", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trace", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "[", 
  RowBox[{"[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trace", "[", 
   RowBox[{"[", "2", "]"}], "]"}], "[", 
  RowBox[{"[", "3", "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.750761191500948*^9, 3.7507612055617523`*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"49efcd2b-8dde-42f3-b106-7d02f847a2d6"],

Cell[BoxData["\<\"(^ (\[Lambda] y . (+ 3 y)) 2)\"\>"], "Output",
 CellChangeTimes->{{3.750761185643475*^9, 3.750761205788673*^9}},
 CellLabel->"Out[76]=",ExpressionUUID->"27e1d187-d0ef-406d-a1ea-3b7f18d723d5"],

Cell[BoxData["\<\"(\[Lambda] y . (+ 3 y))\"\>"], "Output",
 CellChangeTimes->{{3.750761185643475*^9, 3.7507612058025017`*^9}},
 CellLabel->"Out[77]=",ExpressionUUID->"22f801cf-b7bc-4774-a422-97732d47846a"],

Cell[BoxData["\<\"(+ 3 y)\"\>"], "Output",
 CellChangeTimes->{{3.750761185643475*^9, 3.750761205810556*^9}},
 CellLabel->"Out[78]=",ExpressionUUID->"c8702203-b63b-4afc-901f-7b2faf1deb06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"res", "[", "\"\<trace\>\"", "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.750760850849338*^9, 3.750760882931796*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"6e2aa187-0dd8-4c09-ad39-c78b562b3c73"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)))\"\>", 
     ",", "\<\"\"\>", ",", "\<\"[\"\>", ",", "x", 
     ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \
\\(\\\"\[Beta] conversion\\\"\\)]\\) \"\>", ",", 
     TemplateBox[{
      "\"2\"",FrameStyle -> None,Background -> RGBColor[0.88, 1, 0.88]},
      "Highlighted"], ",", "\<\"]\"\>"}], "}"}], ",", 
   RowBox[{"{", "\<\"2\"\>", "}"}], ",", 
   RowBox[{"{", "\<\"(^ (\[Lambda] y . (+ 3 y)) x)\"\>", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"(\[Lambda] y . (+ 3 y))\"\>", ",", "\<\"[\"\>", ",", "y", 
     ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\
\[Alpha] conversion\\\"\\)]\\) \"\>", ",", 
     TemplateBox[{
      "y$4381",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
      "Highlighted"], ",", "\<\"]\"\>", 
     ",", "\<\" substitute a new copy\"\>"}], "}"}], ",", 
   RowBox[{"{", "\<\"(+ 3 y)\"\>", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.750760854064609*^9, 3.750760883714025*^9}},
 CellLabel->"Out[56]=",ExpressionUUID->"43a977a9-881b-4b99-b1b3-a261ec822608"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"trace0", "[", 
  RowBox[{"[", "2", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.750760929454517*^9, 3.750760965966399*^9}, {
  3.750761222449308*^9, 3.750761233272133*^9}},
 CellLabel->"In[81]:=",ExpressionUUID->"dba61100-444f-4b45-b0f3-871a08cc4ef6"],

Cell[BoxData[
 RowBox[{"{", "\<\"(^ (\[Lambda] y . (+ 3 y)) x)\"\>", "}"}]], "Output",
 CellChangeTimes->{{3.750760934844524*^9, 3.750760966323393*^9}, {
  3.750761223442629*^9, 3.7507612349871273`*^9}},
 CellLabel->"Out[81]=",ExpressionUUID->"f2d93a55-afba-4c2d-bdec-7954f8884a0c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"i", ",", 
     RowBox[{"-", "j"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"j", ",", "1", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7507597267159224`*^9, 3.750759743284718*^9}},
 CellLabel->
  "In[383]:=",ExpressionUUID->"9729fe46-4985-4ebc-8381-a3c2a7846c12"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", 
       RowBox[{"-", "5"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", 
       RowBox[{"-", "5"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "4"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "5"}]}], "}"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.750759744687862*^9},
 CellLabel->
  "Out[383]=",ExpressionUUID->"e0a66bf0-b362-4d6a-ad8f-3473db2a8a47"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<trace\>\"", "]"}]], "Input",
 CellLabel->
  "In[366]:=",ExpressionUUID->"00572d63-950d-4e19-9c0f-ec1114a346ff"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)))\"\>", 
     ",", "\<\"\"\>", ",", "\<\"[\"\>", ",", "x", 
     ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \
\\(\\\"\[Beta] conversion\\\"\\)]\\) \"\>", ",", 
     TemplateBox[{
      "\"2\"",FrameStyle -> None,Background -> RGBColor[0.88, 1, 0.88]},
      "Highlighted"], ",", "\<\"]\"\>"}], "}"}], ",", 
   RowBox[{"{", "\<\"2\"\>", "}"}], ",", 
   RowBox[{"{", "\<\"(^ (\[Lambda] y . (+ 3 y)) x)\"\>", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"(\[Lambda] y . (+ 3 y))\"\>", ",", "\<\"[\"\>", ",", "y", 
     ",", "\<\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\
\[Alpha] conversion\\\"\\)]\\) \"\>", ",", 
     TemplateBox[{
      "y$10159",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
      "Highlighted"], ",", "\<\"]\"\>", 
     ",", "\<\" substitute a new copy\"\>"}], "}"}], ",", 
   RowBox[{"{", "\<\"(+ 3 y)\"\>", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.7507590592896147`*^9, 3.750759147839031*^9},
 CellLabel->
  "Out[366]=",ExpressionUUID->"32816ade-d12b-4a6d-b463-34fd67ed403f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["order2"], "Input",
 CellChangeTimes->{{3.750758448528447*^9, 3.7507584497602367`*^9}},
 CellLabel->
  "In[234]:=",ExpressionUUID->"fb65d593-0e06-4f7f-9a4c-f0e6ffef260c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1", ",", "5", ",", "2", ",", "3", ",", "4"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.7507584499856577`*^9},
 CellLabel->
  "Out[234]=",ExpressionUUID->"1df1be57-539b-4eca-a6dc-3b3eaec953bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", " ", 
  RowBox[{"\[Rho]", "[", 
   RowBox[{"order2", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{3.750758464487492*^9},
 CellLabel->
  "In[235]:=",ExpressionUUID->"9d9e4a9c-aea2-479f-bf56-cb1e55294913"],

Cell[BoxData["\<\"2\"\>"], "Output",
 CellChangeTimes->{3.750758464817526*^9},
 CellLabel->
  "Out[235]=",ExpressionUUID->"3ec110da-bbce-4985-b6a4-e4ec381f0d32"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]3"], "Input",
 CellLabel->
  "In[236]:=",ExpressionUUID->"9748c1ac-7f49-47ce-b956-521df6523e1d"],

Cell[BoxData[
 RowBox[{"{", 
  TemplateBox[{"y","\"\[LongRightArrow]\"","y$5728"},
   "RowDefault"], "}"}]], "Output",
 CellChangeTimes->{3.750758491318169*^9},
 CellLabel->
  "Out[236]=",ExpressionUUID->"5b15b48f-fbd9-4d89-8063-f61f480f2b74"]
}, Open  ]],

Cell[BoxData[
 TemplateBox[{"\"(^ (\[Lambda] y . (+ 3 y)) x)\""},
  "RowDefault"]], "Input",ExpressionUUID->"7817d265-8a3d-4576-ad07-\
d9ec17e27614"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{
   TemplateBox[{"\"(^ (\[Lambda] y . (+ 3 y)) x)\""},
    "RowDefault"], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<2\>\""}], "}"}]}], "]"}]], "Input",
 CellLabel->
  "In[314]:=",ExpressionUUID->"a9f048d2-caad-4426-8f96-2f4b630f6339"],

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{
   TemplateBox[{"\"(^ (\[Lambda] y . (+ 3 y)) x)\""},
    "RowDefault"], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"2\"\>"}], "}"}]}], "]"}]], "Output",
 CellChangeTimes->{3.750758797605756*^9},
 CellLabel->
  "Out[314]=",ExpressionUUID->"72458049-f908-45af-81ba-249f0d65f046"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{63, Automatic}, {161, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 8477, 202, 1501, "Input",ExpressionUUID->"7df64f4f-32f3-43cb-bb24-31ffbc8a17f9"],
Cell[9060, 226, 1219, 18, 34, "Output",ExpressionUUID->"53e67d77-95f2-4d10-8db2-5ad728c8806d"],
Cell[10282, 246, 1226, 20, 34, "Output",ExpressionUUID->"c01361c4-68c5-424e-9e67-084dd980e0f2"],
Cell[11511, 268, 1948, 40, 93, "Output",ExpressionUUID->"55c3b05d-bba6-426e-81dc-57f46a2807f1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13496, 313, 8969, 204, 1480, "Input",ExpressionUUID->"778b9dcf-6cda-4891-bf2f-0a89050ec2db"],
Cell[22468, 519, 603, 9, 34, "Output",ExpressionUUID->"96bac231-6f0d-4bda-b0f8-582ee3b17a71"],
Cell[23074, 530, 618, 11, 35, "Output",ExpressionUUID->"920194c6-74bb-4e36-8099-3bfdaa586ed6"],
Cell[23695, 543, 1474, 34, 93, "Output",ExpressionUUID->"844134c9-b98d-4cbd-8b7a-d02d90f278a1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25206, 582, 2420, 57, 367, "Input",ExpressionUUID->"aa039ac6-0344-4b43-96f1-0700f87d8b9e"],
Cell[27629, 641, 667, 10, 34, "Output",ExpressionUUID->"a183b9fd-5e22-4417-9bee-bbfcd184e40f"],
Cell[28299, 653, 684, 12, 34, "Output",ExpressionUUID->"6be8f6d8-c0a5-40f7-b5ba-666666998e54"],
Cell[28986, 667, 1970, 43, 145, "Output",ExpressionUUID->"39b86fd5-738b-4a43-b934-c73ab0962ec0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30993, 715, 4028, 92, 346, "Input",ExpressionUUID->"0949a75c-b59d-47a4-945c-5d2a06564e5c"],
Cell[35024, 809, 1963, 44, 127, "Output",ExpressionUUID->"bf2aa384-befa-4f89-9579-5b242909ec69"]
}, Open  ]],
Cell[37002, 856, 82, 0, 30, "Input",ExpressionUUID->"d915511a-697c-41a6-af52-579762a2c87f"],
Cell[CellGroupData[{
Cell[37109, 860, 111, 1, 30, "Input",ExpressionUUID->"23b043e2-35bb-4a8d-855a-a247422356aa"],
Cell[37223, 863, 176, 3, 34, "Output",ExpressionUUID->"fa92c0f5-0e8c-4c54-bd35-abb1f248d368"]
}, Open  ]],
Cell[37414, 869, 87, 0, 30, "Input",ExpressionUUID->"e291733c-02f8-443e-84f3-61f39c0a3755"],
Cell[37504, 871, 105, 0, 30, "Input",ExpressionUUID->"6df89987-e218-4cba-aec5-eedc2a464c1a"],
Cell[CellGroupData[{
Cell[37634, 875, 312, 6, 30, "Input",ExpressionUUID->"c2e69dcb-4241-4741-8015-e93fec3d1196"],
Cell[37949, 883, 224, 3, 34, "Output",ExpressionUUID->"2c17a777-1943-4c0a-ab0b-1bfe1d233cea"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38210, 891, 550, 14, 73, "Input",ExpressionUUID->"49efcd2b-8dde-42f3-b106-7d02f847a2d6"],
Cell[38763, 907, 209, 2, 34, "Output",ExpressionUUID->"27e1d187-d0ef-406d-a1ea-3b7f18d723d5"],
Cell[38975, 911, 205, 2, 34, "Output",ExpressionUUID->"22f801cf-b7bc-4774-a422-97732d47846a"],
Cell[39183, 915, 187, 2, 34, "Output",ExpressionUUID->"c8702203-b63b-4afc-901f-7b2faf1deb06"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39407, 922, 252, 5, 52, "Input",ExpressionUUID->"6e2aa187-0dd8-4c09-ad39-c78b562b3c73"],
Cell[39662, 929, 1166, 23, 101, "Output",ExpressionUUID->"43a977a9-881b-4b99-b1b3-a261ec822608"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40865, 957, 276, 5, 30, "Input",ExpressionUUID->"dba61100-444f-4b45-b0f3-871a08cc4ef6"],
Cell[41144, 964, 282, 4, 34, "Output",ExpressionUUID->"f2d93a55-afba-4c2d-bdec-7954f8884a0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41463, 973, 430, 12, 30, "Input",ExpressionUUID->"9729fe46-4985-4ebc-8381-a3c2a7846c12"],
Cell[41896, 987, 1585, 56, 77, "Output",ExpressionUUID->"e0a66bf0-b362-4d6a-ad8f-3473db2a8a47"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43518, 1048, 151, 3, 30, "Input",ExpressionUUID->"00572d63-950d-4e19-9c0f-ec1114a346ff"],
Cell[43672, 1053, 1171, 24, 101, "Output",ExpressionUUID->"32816ade-d12b-4a6d-b463-34fd67ed403f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44880, 1082, 183, 3, 30, "Input",ExpressionUUID->"fb65d593-0e06-4f7f-9a4c-f0e6ffef260c"],
Cell[45066, 1087, 243, 6, 34, "Output",ExpressionUUID->"1df1be57-539b-4eca-a6dc-3b3eaec953bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45346, 1098, 271, 7, 30, "Input",ExpressionUUID->"9d9e4a9c-aea2-479f-bf56-cb1e55294913"],
Cell[45620, 1107, 161, 3, 34, "Output",ExpressionUUID->"3ec110da-bbce-4985-b6a4-e4ec381f0d32"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45818, 1115, 115, 2, 30, "Input",ExpressionUUID->"9748c1ac-7f49-47ce-b956-521df6523e1d"],
Cell[45936, 1119, 243, 6, 34, "Output",ExpressionUUID->"5b15b48f-fbd9-4d89-8063-f61f480f2b74"]
}, Open  ]],
Cell[46194, 1128, 149, 3, 30, "Input",ExpressionUUID->"7817d265-8a3d-4576-ad07-d9ec17e27614"],
Cell[CellGroupData[{
Cell[46368, 1135, 312, 8, 30, "Input",ExpressionUUID->"a9f048d2-caad-4426-8f96-2f4b630f6339"],
Cell[46683, 1145, 355, 9, 34, "Output",ExpressionUUID->"72458049-f908-45af-81ba-249f0d65f046"]
}, Open  ]]
}
]
*)

