(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    139669,       3477]
NotebookOptionsPosition[    138920,       3455]
NotebookOutlinePosition[    139276,       3471]
CellTagsIndexPosition[    139233,       3468]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"0.6", "^", "2"}], "-", 
   RowBox[{"4", "*", "7", "*", "0.5"}]}]}]], "Input",
 CellChangeTimes->{{3.749491322789205*^9, 3.749491338294744*^9}},
 CellLabel->
  "In[249]:=",ExpressionUUID->"358caa97-09f6-4309-88ce-4f96c2464831"],

Cell[BoxData[
 RowBox[{"-", "13.64`"}]], "Output",
 CellChangeTimes->{{3.7494913337834673`*^9, 3.749491338672439*^9}},
 CellLabel->
  "Out[249]=",ExpressionUUID->"ba23d945-3780-47c8-9152-2abe4647c41d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"While", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"a", "^", 
     RowBox[{"-", "1"}]}], "<", "0"}], ",", "\[IndentingNewLine]", "1"}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.749491486916918*^9, 
  3.749491511513958*^9}},ExpressionUUID->"7a3a254f-4bce-48c5-ab26-\
07ed9f0ae394"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"logic3", "[", 
  RowBox[{"\"\<\>\"", ",", 
   RowBox[{"{", "}"}], ",", 
   RowBox[{"{", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749486502877392*^9, 3.7494865097226963`*^9}, {
  3.749488446613769*^9, 3.749488446893509*^9}, {3.749490730741432*^9, 
  3.749490732044986*^9}},
 CellLabel->
  "In[247]:=",ExpressionUUID->"236e64a4-6e9c-487f-8988-54818afd29a6"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"question labeled\"\>", "\[Rule]", 
    FrameBox[
     TagBox[GridBox[{
        {
         TemplateBox[{"\"\"",RowBox[{
             RowBox[{"-", "0.04285714285714286`"}], "+", 
             RowBox[{"0.26380264732313413`", " ", "\[ImaginaryI]"}]}],
           "\" matches which AST\""},
          "RowDefault"]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"],
     FrameStyle->{
       Thickness[Large], 
       Directive[
        Thickness[5]], 
       RGBColor[1, 0.85, 0.85]},
     ImageMargins->5,
     RoundingRadius->10,
     StripOnInput->False]}], ",", 
   RowBox[{"\<\"question\"\>", "\[Rule]", 
    FrameBox[
     TagBox[GridBox[{
        {
         TemplateBox[{"\"\"",RowBox[{
             RowBox[{"-", "0.04285714285714286`"}], "+", 
             RowBox[{"0.26380264732313413`", " ", "\[ImaginaryI]"}]}],
           "\" matches which AST\""},
          "RowDefault"]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"],
     FrameStyle->{
       Thickness[Large], 
       Directive[
        Thickness[5]], 
       RGBColor[1, 0.85, 0.85]},
     ImageMargins->5,
     RoundingRadius->10,
     StripOnInput->False]}], ",", 
   RowBox[{"\<\"anime\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"tutorial_anime\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"example\"\>", "\[Rule]", 
    TagBox[GridBox[{
       {
        TemplateBox[{StyleBox["\"\"", 
           RGBColor[1, 0.5, 0], FontSize -> 18, FontWeight -> Bold, 
           StripOnInput -> False]},
         "RowDefault"]},
       {"\<\"\"\>"}
      },
      DefaultBaseStyle->"Column",
      GridBoxAlignment->{"Columns" -> {{Left}}},
      GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
     
     "Column"]}], ",", 
   RowBox[{"\<\"example PDF\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"example_anime\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"solution\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       StyleBox[
        "\"Solution\"", FontSize -> 18, FontWeight -> Bold, StripOnInput -> 
         False]},
       "RowDefault"], ",", 
      TemplateBox[{100},
       "Spacer1"], ",", 
      GraphicsBox[
       TagBox[
        GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
         1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
         3.2882248037882764`}, {0., 2.4661686028412073`}, {0.8220562009470691,
          2.4661686028412073`}, {1.6441124018941382`, 3.2882248037882764`}, {
         1.6441124018941382`, 2.4661686028412073`}, {0.8220562009470691, 
         1.6441124018941382`}, {0.41102810047353455`, 0.8220562009470695}, {
         1.2330843014206037`, 0.8220562009470695}, {2.4661686028412073`, 
         1.6441124018941382`}, {2.0551405023676725`, 0.8220562009470695}, {
         2.8771967033147416`, 0.8220562009470695}, {2.4661686028412073`, 
         0.}, {3.2882248037882764`, 0.}, {2.8771967033147416`, 
         4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
         3.2882248037882764`, 3.2882248037882764`}}, {
          {RGBColor[0.55, 0.45, 0.45], 
           LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 7}, {
            7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 14}, {
            13, 15}, {16, 17}, {16, 18}}]}, {
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"/\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 1],
             TagBox[
              RowBox[{"\"/\"", "[", 
                RowBox[{
                  RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                  RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "7"}], "]"}]}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "/"[
               "+"[
                "*"[-1, 0.6], 
                "Sqrt"[
                 "-"[
                  "*"[0.6, 0.6], 
                  "*"[4, 
                   "*"[7, 0.5]]]]], 
               "*"[2, 7]]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"+\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 2],
             TagBox[
              RowBox[{"\"+\"", "[", 
                RowBox[{
                  RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                  RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "+"[
               "*"[-1, 0.6], 
               "Sqrt"[
                "-"[
                 "*"[0.6, 0.6], 
                 "*"[4, 
                  "*"[7, 0.5]]]]]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"*\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 3],
             TagBox[
              RowBox[{"\"*\"", "[", 
                RowBox[{
                  RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "*"[-1, 0.6]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox[
                 RowBox[{"-", "1"}],
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 4],
             TagBox[
              RowBox[{"-", "1"}], HoldForm]],
            Annotation[#, 
             HoldForm[-1], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["0.6`",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 5],
             TagBox["0.6`", HoldForm]],
            Annotation[#, 
             HoldForm[0.6], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 6],
             TagBox[
              RowBox[{"\"Sqrt\"", "[", 
                RowBox[{"\"-\"", "[", 
                  RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
                "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "Sqrt"[
               "-"[
                "*"[0.6, 0.6], 
                "*"[4, 
                 "*"[7, 0.5]]]]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"-\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 7],
             TagBox[
              RowBox[{"\"-\"", "[", 
                RowBox[{
                  RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                  RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
              HoldForm]],
            Annotation[#, 
             HoldForm[
              "-"[
               "*"[0.6, 0.6], 
               "*"[4, 
                "*"[7, 0.5]]]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"*\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 8],
             TagBox[
              RowBox[{"\"*\"", "[", 
                RowBox[{"0.6`", ",", "0.6`"}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "*"[0.6, 0.6]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["0.6`",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 9],
             TagBox["0.6`", HoldForm]],
            Annotation[#, 
             HoldForm[0.6], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["0.6`",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 10],
             TagBox["0.6`", HoldForm]],
            Annotation[#, 
             HoldForm[0.6], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"*\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 11],
             TagBox[
              RowBox[{"\"*\"", "[", 
                RowBox[{"4", ",", 
                  RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "*"[4, 
               "*"[7, 0.5]]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["4",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 12],
             TagBox["4", HoldForm]],
            Annotation[#, 
             HoldForm[4], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"*\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 13],
             TagBox[
              RowBox[{"\"*\"", "[", 
                RowBox[{"7", ",", "0.5`"}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "*"[7, 0.5]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["7",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 14],
             TagBox["7", HoldForm]],
            Annotation[#, 
             HoldForm[7], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["0.5`",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 15],
             TagBox["0.5`", HoldForm]],
            Annotation[#, 
             HoldForm[0.5], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox["\<\"*\"\>", "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 16],
             TagBox[
              RowBox[{"\"*\"", "[", 
                RowBox[{"2", ",", "7"}], "]"}], HoldForm]],
            Annotation[#, 
             HoldForm[
              "*"[2, 7]], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["2",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 17],
             TagBox["2", HoldForm]],
            Annotation[#, 
             HoldForm[2], "Tooltip"]& ], 
           TagBox[
            TooltipBox[InsetBox[
              FrameBox[
               StyleBox[
                TagBox["7",
                 HoldForm], "StandardForm", "Output",
                StripOnInput->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontSize->Scaled[0.05],
                FontColor->GrayLevel[0]],
               Background->RGBColor[1., 1., 0.871],
               FrameStyle->GrayLevel[0.5],
               StripOnInput->False], 18],
             TagBox["7", HoldForm]],
            Annotation[#, 
             HoldForm[7], "Tooltip"]& ]}}],
        Annotation[#, 
         VertexCoordinateRules -> {{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}]& ],
       AspectRatio->NCache[
        Rational[1, 2] 7^Rational[1, 2], 1.3228756555322954`],
       FormatType:>StandardForm,
       FrameTicks->Automatic,
       ImageSize->400,
       PlotRange->All,
       PlotRangePadding->Scaled[0.1]]}], "}"}]}], ",", 
   RowBox[{"\<\"correct\"\>", "\[Rule]", 
    FrameBox[
     GraphicsBox[
      TagBox[
       GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
        1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
        3.2882248037882764`}, {0., 2.4661686028412073`}, {0.8220562009470691, 
        2.4661686028412073`}, {1.6441124018941382`, 3.2882248037882764`}, {
        1.6441124018941382`, 2.4661686028412073`}, {0.8220562009470691, 
        1.6441124018941382`}, {0.41102810047353455`, 0.8220562009470695}, {
        1.2330843014206037`, 0.8220562009470695}, {2.4661686028412073`, 
        1.6441124018941382`}, {2.0551405023676725`, 0.8220562009470695}, {
        2.8771967033147416`, 0.8220562009470695}, {2.4661686028412073`, 0.}, {
        3.2882248037882764`, 0.}, {2.8771967033147416`, 4.110281004735345}, {
        2.4661686028412073`, 3.2882248037882764`}, {3.2882248037882764`, 
        3.2882248037882764`}}, {
         {RGBColor[0.55, 0.45, 0.45], 
          LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 7}, {
           7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 14}, {13,
            15}, {16, 17}, {16, 18}}]}, {
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"/\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 1],
            TagBox[
             RowBox[{"\"/\"", "[", 
               RowBox[{
                 RowBox[{"\"+\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"2", ",", "7"}], "]"}]}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "/"[
              "+"[
               "*"[-1, 0.6], 
               "Sqrt"[
                "-"[
                 "*"[0.6, 0.6], 
                 "*"[4, 
                  "*"[7, 0.5]]]]], 
              "*"[2, 7]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"+\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 2],
            TagBox[
             RowBox[{"\"+\"", "[", 
               RowBox[{
                 RowBox[{"\"*\"", "[", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                 RowBox[{"\"Sqrt\"", "[", 
                   RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
                   "]"}]}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "+"[
              "*"[-1, 0.6], 
              "Sqrt"[
               "-"[
                "*"[0.6, 0.6], 
                "*"[4, 
                 "*"[7, 0.5]]]]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 3],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{
                 RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[-1, 0.6]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                RowBox[{"-", "1"}],
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 4],
            TagBox[
             RowBox[{"-", "1"}], HoldForm]],
           Annotation[#, 
            HoldForm[-1], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["0.6`",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 5],
            TagBox["0.6`", HoldForm]],
           Annotation[#, 
            HoldForm[0.6], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 6],
            TagBox[
             RowBox[{"\"Sqrt\"", "[", 
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
               "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "Sqrt"[
              "-"[
               "*"[0.6, 0.6], 
               "*"[4, 
                "*"[7, 0.5]]]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"-\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 7],
            TagBox[
             RowBox[{"\"-\"", "[", 
               RowBox[{
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}]}], "]"}], 
             HoldForm]],
           Annotation[#, 
            HoldForm[
             "-"[
              "*"[0.6, 0.6], 
              "*"[4, 
               "*"[7, 0.5]]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 8],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"0.6`", ",", "0.6`"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[0.6, 0.6]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["0.6`",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 9],
            TagBox["0.6`", HoldForm]],
           Annotation[#, 
            HoldForm[0.6], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["0.6`",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 10],
            TagBox["0.6`", HoldForm]],
           Annotation[#, 
            HoldForm[0.6], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 11],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"4", ",", 
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"7", ",", "0.5`"}], "]"}]}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[4, 
              "*"[7, 0.5]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["4",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 12],
            TagBox["4", HoldForm]],
           Annotation[#, 
            HoldForm[4], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 13],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"7", ",", "0.5`"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[7, 0.5]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["7",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 14],
            TagBox["7", HoldForm]],
           Annotation[#, 
            HoldForm[7], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["0.5`",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 15],
            TagBox["0.5`", HoldForm]],
           Annotation[#, 
            HoldForm[0.5], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 16],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"2", ",", "7"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[2, 7]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["2",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 17],
            TagBox["2", HoldForm]],
           Annotation[#, 
            HoldForm[2], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["7",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 18],
            TagBox["7", HoldForm]],
           Annotation[#, 
            HoldForm[7], "Tooltip"]& ]}}],
       Annotation[#, 
        VertexCoordinateRules -> {{1.9523834772492892`, 4.932337205682415}, {
         1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
         3.2882248037882764`}, {0., 2.4661686028412073`}, {0.8220562009470691,
          2.4661686028412073`}, {1.6441124018941382`, 3.2882248037882764`}, {
         1.6441124018941382`, 2.4661686028412073`}, {0.8220562009470691, 
         1.6441124018941382`}, {0.41102810047353455`, 0.8220562009470695}, {
         1.2330843014206037`, 0.8220562009470695}, {2.4661686028412073`, 
         1.6441124018941382`}, {2.0551405023676725`, 0.8220562009470695}, {
         2.8771967033147416`, 0.8220562009470695}, {2.4661686028412073`, 
         0.}, {3.2882248037882764`, 0.}, {2.8771967033147416`, 
         4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
         3.2882248037882764`, 3.2882248037882764`}}]& ],
      AspectRatio->NCache[
       Rational[1, 2] 7^Rational[1, 2], 1.3228756555322954`],
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->400,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]],
     FrameStyle->{
       Thickness[Large], 
       Directive[
        Thickness[5]], 
       RGBColor[1, 0.5, 0]},
     ImageMargins->5,
     RoundingRadius->10,
     StripOnInput->False]}], ",", 
   RowBox[{"\<\"wrong\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      FrameBox[
       GraphicsBox[
        TagBox[
         GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}, {
           {RGBColor[0.55, 0.45, 0.45], 
            LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 
             7}, {7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 
             14}, {13, 15}, {16, 17}, {16, 18}}]}, {
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"/\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 1],
              TagBox[
               RowBox[{"\"/\"", "[", 
                 RowBox[{
                   RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "9"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "9"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"3", ",", "0.2`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "3"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "/"[
                "+"[
                 "*"[-1, 9], 
                 "Sqrt"[
                  "-"[
                   "*"[9, 9], 
                   "*"[4, 
                    "*"[3, 0.2]]]]], 
                "*"[2, 3]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"+\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 2],
              TagBox[
               RowBox[{"\"+\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "9"}], "]"}], ",", 
                   RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "9"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"3", ",", "0.2`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "+"[
                "*"[-1, 9], 
                "Sqrt"[
                 "-"[
                  "*"[9, 9], 
                  "*"[4, 
                   "*"[3, 0.2]]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 3],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", "9"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[-1, 9]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox[
                  RowBox[{"-", "1"}],
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 4],
              TagBox[
               RowBox[{"-", "1"}], HoldForm]],
             Annotation[#, 
              HoldForm[-1], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 5],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 6],
              TagBox[
               RowBox[{"\"Sqrt\"", "[", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "9"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"3", ",", "0.2`"}], "]"}]}], "]"}]}], "]"}], 
                 "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "Sqrt"[
                "-"[
                 "*"[9, 9], 
                 "*"[4, 
                  "*"[3, 0.2]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"-\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 7],
              TagBox[
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "9"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"3", ",", "0.2`"}], "]"}]}], "]"}]}], "]"}], 
               HoldForm]],
             Annotation[#, 
              HoldForm[
               "-"[
                "*"[9, 9], 
                "*"[4, 
                 "*"[3, 0.2]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 8],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"9", ",", "9"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[9, 9]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 9],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 10],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 11],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"4", ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"3", ",", "0.2`"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[4, 
                "*"[3, 0.2]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["4",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 12],
              TagBox["4", HoldForm]],
             Annotation[#, 
              HoldForm[4], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 13],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"3", ",", "0.2`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[3, 0.2]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["3",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 14],
              TagBox["3", HoldForm]],
             Annotation[#, 
              HoldForm[3], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.2`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 15],
              TagBox["0.2`", HoldForm]],
             Annotation[#, 
              HoldForm[0.2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 16],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"2", ",", "3"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[2, 3]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["2",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 17],
              TagBox["2", HoldForm]],
             Annotation[#, 
              HoldForm[2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["3",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 18],
              TagBox["3", HoldForm]],
             Annotation[#, 
              HoldForm[3], "Tooltip"]& ]}}],
         Annotation[#, 
          VertexCoordinateRules -> {{1.9523834772492892`, 
           4.932337205682415}, {1.0275702511838363`, 4.110281004735345}, {
           0.41102810047353455`, 3.2882248037882764`}, {0., 
           2.4661686028412073`}, {0.8220562009470691, 2.4661686028412073`}, {
           1.6441124018941382`, 3.2882248037882764`}, {1.6441124018941382`, 
           2.4661686028412073`}, {0.8220562009470691, 1.6441124018941382`}, {
           0.41102810047353455`, 0.8220562009470695}, {1.2330843014206037`, 
           0.8220562009470695}, {2.4661686028412073`, 1.6441124018941382`}, {
           2.0551405023676725`, 0.8220562009470695}, {2.8771967033147416`, 
           0.8220562009470695}, {2.4661686028412073`, 0.}, {
           3.2882248037882764`, 0.}, {2.8771967033147416`, 
           4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
           3.2882248037882764`, 3.2882248037882764`}}]& ],
        AspectRatio->NCache[2^Rational[1, 2], 1.4142135623730951`],
        FormatType:>StandardForm,
        FrameTicks->Automatic,
        ImageSize->400,
        PlotRange->All,
        PlotRangePadding->Scaled[0.1]],
       FrameStyle->{
         Thickness[Large], 
         Directive[
          Thickness[5]], 
         RGBColor[1, 0.5, 0]},
       ImageMargins->5,
       RoundingRadius->10,
       StripOnInput->False], ",", 
      FrameBox[
       GraphicsBox[
        TagBox[
         GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}, {
           {RGBColor[0.55, 0.45, 0.45], 
            LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 
             7}, {7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 
             14}, {13, 15}, {16, 17}, {16, 18}}]}, {
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"/\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 1],
              TagBox[
               RowBox[{"\"/\"", "[", 
                 RowBox[{
                   RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.2`"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.2`", ",", "0.2`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.9`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "0.6`"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "/"[
                "+"[
                 "*"[-1, 0.2], 
                 "Sqrt"[
                  "-"[
                   "*"[0.2, 0.2], 
                   "*"[4, 
                    "*"[0.6, 0.9]]]]], 
                "*"[2, 0.6]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"+\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 2],
              TagBox[
               RowBox[{"\"+\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.2`"}], "]"}], ",", 
                   RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.2`", ",", "0.2`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.9`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "+"[
                "*"[-1, 0.2], 
                "Sqrt"[
                 "-"[
                  "*"[0.2, 0.2], 
                  "*"[4, 
                   "*"[0.6, 0.9]]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 3],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", "0.2`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[-1, 0.2]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox[
                  RowBox[{"-", "1"}],
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 4],
              TagBox[
               RowBox[{"-", "1"}], HoldForm]],
             Annotation[#, 
              HoldForm[-1], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.2`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 5],
              TagBox["0.2`", HoldForm]],
             Annotation[#, 
              HoldForm[0.2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 6],
              TagBox[
               RowBox[{"\"Sqrt\"", "[", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.2`", ",", "0.2`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.9`"}], "]"}]}], "]"}]}], "]"}], 
                 "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "Sqrt"[
                "-"[
                 "*"[0.2, 0.2], 
                 "*"[4, 
                  "*"[0.6, 0.9]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"-\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 7],
              TagBox[
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"0.2`", ",", "0.2`"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.9`"}], "]"}]}], "]"}]}], "]"}], 
               HoldForm]],
             Annotation[#, 
              HoldForm[
               "-"[
                "*"[0.2, 0.2], 
                "*"[4, 
                 "*"[0.6, 0.9]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 8],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"0.2`", ",", "0.2`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[0.2, 0.2]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.2`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 9],
              TagBox["0.2`", HoldForm]],
             Annotation[#, 
              HoldForm[0.2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.2`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 10],
              TagBox["0.2`", HoldForm]],
             Annotation[#, 
              HoldForm[0.2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 11],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"4", ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.9`"}], "]"}]}], "]"}], HoldForm]],
             
             Annotation[#, 
              HoldForm[
               "*"[4, 
                "*"[0.6, 0.9]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["4",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 12],
              TagBox["4", HoldForm]],
             Annotation[#, 
              HoldForm[4], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 13],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"0.6`", ",", "0.9`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[0.6, 0.9]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 14],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.9`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 15],
              TagBox["0.9`", HoldForm]],
             Annotation[#, 
              HoldForm[0.9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 16],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"2", ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[2, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["2",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 17],
              TagBox["2", HoldForm]],
             Annotation[#, 
              HoldForm[2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 18],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ]}}],
         Annotation[#, 
          VertexCoordinateRules -> {{1.9523834772492892`, 
           4.932337205682415}, {1.0275702511838363`, 4.110281004735345}, {
           0.41102810047353455`, 3.2882248037882764`}, {0., 
           2.4661686028412073`}, {0.8220562009470691, 2.4661686028412073`}, {
           1.6441124018941382`, 3.2882248037882764`}, {1.6441124018941382`, 
           2.4661686028412073`}, {0.8220562009470691, 1.6441124018941382`}, {
           0.41102810047353455`, 0.8220562009470695}, {1.2330843014206037`, 
           0.8220562009470695}, {2.4661686028412073`, 1.6441124018941382`}, {
           2.0551405023676725`, 0.8220562009470695}, {2.8771967033147416`, 
           0.8220562009470695}, {2.4661686028412073`, 0.}, {
           3.2882248037882764`, 0.}, {2.8771967033147416`, 
           4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
           3.2882248037882764`, 3.2882248037882764`}}]& ],
        AspectRatio->NCache[
         Rational[1, 3] 14^Rational[1, 2], 1.247219128924647],
        FormatType:>StandardForm,
        FrameTicks->Automatic,
        ImageSize->400,
        PlotRange->All,
        PlotRangePadding->Scaled[0.1]],
       FrameStyle->{
         Thickness[Large], 
         Directive[
          Thickness[5]], 
         RGBColor[1, 0.5, 0]},
       ImageMargins->5,
       RoundingRadius->10,
       StripOnInput->False], ",", 
      FrameBox[
       GraphicsBox[
        TagBox[
         GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}, {
           {RGBColor[0.55, 0.45, 0.45], 
            LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 
             7}, {7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 
             14}, {13, 15}, {16, 17}, {16, 18}}]}, {
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"/\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 1],
              TagBox[
               RowBox[{"\"/\"", "[", 
                 RowBox[{
                   RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "6"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"6", ",", "6"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.8`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "9"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "/"[
                "+"[
                 "*"[-1, 6], 
                 "Sqrt"[
                  "-"[
                   "*"[6, 6], 
                   "*"[4, 
                    "*"[9, 0.8]]]]], 
                "*"[2, 9]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"+\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 2],
              TagBox[
               RowBox[{"\"+\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "6"}], "]"}], ",", 
                   RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"6", ",", "6"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.8`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "+"[
                "*"[-1, 6], 
                "Sqrt"[
                 "-"[
                  "*"[6, 6], 
                  "*"[4, 
                   "*"[9, 0.8]]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 3],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", "6"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[-1, 6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox[
                  RowBox[{"-", "1"}],
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 4],
              TagBox[
               RowBox[{"-", "1"}], HoldForm]],
             Annotation[#, 
              HoldForm[-1], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["6",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 5],
              TagBox["6", HoldForm]],
             Annotation[#, 
              HoldForm[6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 6],
              TagBox[
               RowBox[{"\"Sqrt\"", "[", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"6", ",", "6"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.8`"}], "]"}]}], "]"}]}], "]"}], 
                 "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "Sqrt"[
                "-"[
                 "*"[6, 6], 
                 "*"[4, 
                  "*"[9, 0.8]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"-\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 7],
              TagBox[
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"6", ",", "6"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.8`"}], "]"}]}], "]"}]}], "]"}], 
               HoldForm]],
             Annotation[#, 
              HoldForm[
               "-"[
                "*"[6, 6], 
                "*"[4, 
                 "*"[9, 0.8]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 8],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"6", ",", "6"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[6, 6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["6",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 9],
              TagBox["6", HoldForm]],
             Annotation[#, 
              HoldForm[6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["6",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 10],
              TagBox["6", HoldForm]],
             Annotation[#, 
              HoldForm[6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 11],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"4", ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.8`"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[4, 
                "*"[9, 0.8]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["4",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 12],
              TagBox["4", HoldForm]],
             Annotation[#, 
              HoldForm[4], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 13],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"9", ",", "0.8`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[9, 0.8]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 14],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.8`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 15],
              TagBox["0.8`", HoldForm]],
             Annotation[#, 
              HoldForm[0.8], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 16],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"2", ",", "9"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[2, 9]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["2",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 17],
              TagBox["2", HoldForm]],
             Annotation[#, 
              HoldForm[2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 18],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ]}}],
         Annotation[#, 
          VertexCoordinateRules -> {{1.9523834772492892`, 
           4.932337205682415}, {1.0275702511838363`, 4.110281004735345}, {
           0.41102810047353455`, 3.2882248037882764`}, {0., 
           2.4661686028412073`}, {0.8220562009470691, 2.4661686028412073`}, {
           1.6441124018941382`, 3.2882248037882764`}, {1.6441124018941382`, 
           2.4661686028412073`}, {0.8220562009470691, 1.6441124018941382`}, {
           0.41102810047353455`, 0.8220562009470695}, {1.2330843014206037`, 
           0.8220562009470695}, {2.4661686028412073`, 1.6441124018941382`}, {
           2.0551405023676725`, 0.8220562009470695}, {2.8771967033147416`, 
           0.8220562009470695}, {2.4661686028412073`, 0.}, {
           3.2882248037882764`, 0.}, {2.8771967033147416`, 
           4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
           3.2882248037882764`, 3.2882248037882764`}}]& ],
        AspectRatio->NCache[2^Rational[1, 2], 1.4142135623730951`],
        FormatType:>StandardForm,
        FrameTicks->Automatic,
        ImageSize->400,
        PlotRange->All,
        PlotRangePadding->Scaled[0.1]],
       FrameStyle->{
         Thickness[Large], 
         Directive[
          Thickness[5]], 
         RGBColor[1, 0.5, 0]},
       ImageMargins->5,
       RoundingRadius->10,
       StripOnInput->False], ",", 
      FrameBox[
       GraphicsBox[
        TagBox[
         GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}, {
           {RGBColor[0.55, 0.45, 0.45], 
            LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 
             7}, {7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 
             14}, {13, 15}, {16, 17}, {16, 18}}]}, {
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"/\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 1],
              TagBox[
               RowBox[{"\"/\"", "[", 
                 RowBox[{
                   RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"10", ",", "10"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "10"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "/"[
                "+"[
                 "*"[-1, 0.6], 
                 "Sqrt"[
                  "-"[
                   "*"[0.6, 0.6], 
                   "*"[4, 
                    "*"[10, 10]]]]], 
                "*"[2, 10]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"+\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 2],
              TagBox[
               RowBox[{"\"+\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                   RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"10", ",", "10"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "+"[
                "*"[-1, 0.6], 
                "Sqrt"[
                 "-"[
                  "*"[0.6, 0.6], 
                  "*"[4, 
                   "*"[10, 10]]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 3],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[-1, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox[
                  RowBox[{"-", "1"}],
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 4],
              TagBox[
               RowBox[{"-", "1"}], HoldForm]],
             Annotation[#, 
              HoldForm[-1], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 5],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 6],
              TagBox[
               RowBox[{"\"Sqrt\"", "[", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"10", ",", "10"}], "]"}]}], "]"}]}], "]"}], "]"}],
                HoldForm]],
             Annotation[#, 
              HoldForm[
               "Sqrt"[
                "-"[
                 "*"[0.6, 0.6], 
                 "*"[4, 
                  "*"[10, 10]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"-\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 7],
              TagBox[
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"10", ",", "10"}], "]"}]}], "]"}]}], "]"}], 
               HoldForm]],
             Annotation[#, 
              HoldForm[
               "-"[
                "*"[0.6, 0.6], 
                "*"[4, 
                 "*"[10, 10]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 8],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"0.6`", ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[0.6, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 9],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 10],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 11],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"4", ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"10", ",", "10"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[4, 
                "*"[10, 10]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["4",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 12],
              TagBox["4", HoldForm]],
             Annotation[#, 
              HoldForm[4], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 13],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"10", ",", "10"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[10, 10]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["10",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 14],
              TagBox["10", HoldForm]],
             Annotation[#, 
              HoldForm[10], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["10",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 15],
              TagBox["10", HoldForm]],
             Annotation[#, 
              HoldForm[10], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 16],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"2", ",", "10"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[2, 10]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["2",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 17],
              TagBox["2", HoldForm]],
             Annotation[#, 
              HoldForm[2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["10",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 18],
              TagBox["10", HoldForm]],
             Annotation[#, 
              HoldForm[10], "Tooltip"]& ]}}],
         Annotation[#, 
          VertexCoordinateRules -> {{1.9523834772492892`, 
           4.932337205682415}, {1.0275702511838363`, 4.110281004735345}, {
           0.41102810047353455`, 3.2882248037882764`}, {0., 
           2.4661686028412073`}, {0.8220562009470691, 2.4661686028412073`}, {
           1.6441124018941382`, 3.2882248037882764`}, {1.6441124018941382`, 
           2.4661686028412073`}, {0.8220562009470691, 1.6441124018941382`}, {
           0.41102810047353455`, 0.8220562009470695}, {1.2330843014206037`, 
           0.8220562009470695}, {2.4661686028412073`, 1.6441124018941382`}, {
           2.0551405023676725`, 0.8220562009470695}, {2.8771967033147416`, 
           0.8220562009470695}, {2.4661686028412073`, 0.}, {
           3.2882248037882764`, 0.}, {2.8771967033147416`, 
           4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
           3.2882248037882764`, 3.2882248037882764`}}]& ],
        AspectRatio->NCache[
         Rational[1, 2] 7^Rational[1, 2], 1.3228756555322954`],
        FormatType:>StandardForm,
        FrameTicks->Automatic,
        ImageSize->400,
        PlotRange->All,
        PlotRangePadding->Scaled[0.1]],
       FrameStyle->{
         Thickness[Large], 
         Directive[
          Thickness[5]], 
         RGBColor[1, 0.5, 0]},
       ImageMargins->5,
       RoundingRadius->10,
       StripOnInput->False], ",", 
      FrameBox[
       GraphicsBox[
        TagBox[
         GraphicsComplexBox[{{1.9523834772492892`, 4.932337205682415}, {
          1.0275702511838363`, 4.110281004735345}, {0.41102810047353455`, 
          3.2882248037882764`}, {0., 2.4661686028412073`}, {
          0.8220562009470691, 2.4661686028412073`}, {1.6441124018941382`, 
          3.2882248037882764`}, {1.6441124018941382`, 2.4661686028412073`}, {
          0.8220562009470691, 1.6441124018941382`}, {0.41102810047353455`, 
          0.8220562009470695}, {1.2330843014206037`, 0.8220562009470695}, {
          2.4661686028412073`, 1.6441124018941382`}, {2.0551405023676725`, 
          0.8220562009470695}, {2.8771967033147416`, 0.8220562009470695}, {
          2.4661686028412073`, 0.}, {3.2882248037882764`, 0.}, {
          2.8771967033147416`, 4.110281004735345}, {2.4661686028412073`, 
          3.2882248037882764`}, {3.2882248037882764`, 
          3.2882248037882764`}}, {
           {RGBColor[0.55, 0.45, 0.45], 
            LineBox[{{1, 2}, {1, 16}, {2, 3}, {2, 6}, {3, 4}, {3, 5}, {6, 
             7}, {7, 8}, {7, 11}, {8, 9}, {8, 10}, {11, 12}, {11, 13}, {13, 
             14}, {13, 15}, {16, 17}, {16, 18}}]}, {
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"/\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 1],
              TagBox[
               RowBox[{"\"/\"", "[", 
                 RowBox[{
                   RowBox[{"\"+\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.6`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "9"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "/"[
                "+"[
                 "*"[-1, 0.6], 
                 "Sqrt"[
                  "-"[
                   "*"[0.6, 0.6], 
                   "*"[4, 
                    "*"[9, 0.6]]]]], 
                "*"[2, 9]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"+\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 2],
              TagBox[
               RowBox[{"\"+\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], ",", 
                   RowBox[{"\"Sqrt\"", "[", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.6`"}], "]"}]}], "]"}]}], "]"}], 
                    "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "+"[
                "*"[-1, 0.6], 
                "Sqrt"[
                 "-"[
                  "*"[0.6, 0.6], 
                  "*"[4, 
                   "*"[9, 0.6]]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 3],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{
                   RowBox[{"-", "1"}], ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[-1, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox[
                  RowBox[{"-", "1"}],
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 4],
              TagBox[
               RowBox[{"-", "1"}], HoldForm]],
             Annotation[#, 
              HoldForm[-1], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 5],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"Sqrt\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 6],
              TagBox[
               RowBox[{"\"Sqrt\"", "[", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.6`"}], "]"}]}], "]"}]}], "]"}], 
                 "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "Sqrt"[
                "-"[
                 "*"[0.6, 0.6], 
                 "*"[4, 
                  "*"[9, 0.6]]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"-\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 7],
              TagBox[
               RowBox[{"\"-\"", "[", 
                 RowBox[{
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"0.6`", ",", "0.6`"}], "]"}], ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"4", ",", 
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.6`"}], "]"}]}], "]"}]}], "]"}], 
               HoldForm]],
             Annotation[#, 
              HoldForm[
               "-"[
                "*"[0.6, 0.6], 
                "*"[4, 
                 "*"[9, 0.6]]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 8],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"0.6`", ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[0.6, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 9],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 10],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 11],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"4", ",", 
                   RowBox[{"\"*\"", "[", 
                    RowBox[{"9", ",", "0.6`"}], "]"}]}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[4, 
                "*"[9, 0.6]]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["4",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 12],
              TagBox["4", HoldForm]],
             Annotation[#, 
              HoldForm[4], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 13],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"9", ",", "0.6`"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[9, 0.6]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 14],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["0.6`",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 15],
              TagBox["0.6`", HoldForm]],
             Annotation[#, 
              HoldForm[0.6], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox["\<\"*\"\>", "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 16],
              TagBox[
               RowBox[{"\"*\"", "[", 
                 RowBox[{"2", ",", "9"}], "]"}], HoldForm]],
             Annotation[#, 
              HoldForm[
               "*"[2, 9]], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["2",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 17],
              TagBox["2", HoldForm]],
             Annotation[#, 
              HoldForm[2], "Tooltip"]& ], 
            TagBox[
             TooltipBox[InsetBox[
               FrameBox[
                StyleBox[
                 TagBox["9",
                  HoldForm], "StandardForm", "Output",
                 StripOnInput->False,
                 LineColor->GrayLevel[0],
                 FrontFaceColor->GrayLevel[0],
                 BackFaceColor->GrayLevel[0],
                 GraphicsColor->GrayLevel[0],
                 FontSize->Scaled[0.05],
                 FontColor->GrayLevel[0]],
                Background->RGBColor[1., 1., 0.871],
                FrameStyle->GrayLevel[0.5],
                StripOnInput->False], 18],
              TagBox["9", HoldForm]],
             Annotation[#, 
              HoldForm[9], "Tooltip"]& ]}}],
         Annotation[#, 
          VertexCoordinateRules -> {{1.9523834772492892`, 
           4.932337205682415}, {1.0275702511838363`, 4.110281004735345}, {
           0.41102810047353455`, 3.2882248037882764`}, {0., 
           2.4661686028412073`}, {0.8220562009470691, 2.4661686028412073`}, {
           1.6441124018941382`, 3.2882248037882764`}, {1.6441124018941382`, 
           2.4661686028412073`}, {0.8220562009470691, 1.6441124018941382`}, {
           0.41102810047353455`, 0.8220562009470695}, {1.2330843014206037`, 
           0.8220562009470695}, {2.4661686028412073`, 1.6441124018941382`}, {
           2.0551405023676725`, 0.8220562009470695}, {2.8771967033147416`, 
           0.8220562009470695}, {2.4661686028412073`, 0.}, {
           3.2882248037882764`, 0.}, {2.8771967033147416`, 
           4.110281004735345}, {2.4661686028412073`, 3.2882248037882764`}, {
           3.2882248037882764`, 3.2882248037882764`}}]& ],
        AspectRatio->NCache[
         Rational[1, 2] 7^Rational[1, 2], 1.3228756555322954`],
        FormatType:>StandardForm,
        FrameTicks->Automatic,
        ImageSize->400,
        PlotRange->All,
        PlotRangePadding->Scaled[0.1]],
       FrameStyle->{
         Thickness[Large], 
         Directive[
          Thickness[5]], 
         RGBColor[1, 0.5, 0]},
       ImageMargins->5,
       RoundingRadius->10,
       StripOnInput->False]}], "}"}]}], ",", 
   RowBox[{"\<\"video\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"molecule\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"abcd\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.749486510102583*^9, 3.7494884471461363`*^9, 3.7494885283083467`*^9, 
   3.749488575920476*^9, 3.7494886101881533`*^9, 3.749488643435883*^9, {
   3.749488710000826*^9, 3.74948871293781*^9}, {3.74948993243653*^9, 
   3.749489959719489*^9}, {3.749490250117344*^9, 3.7494902560719*^9}, 
   3.7494902877941027`*^9, 3.749490389468761*^9, 3.7494904920491123`*^9, {
   3.749490650868819*^9, 3.749490659195663*^9}, {3.749490732481038*^9, 
   3.749490745914014*^9}, {3.749490967809002*^9, 3.749491063712068*^9}, 
   3.749491106290402*^9, {3.749491273533087*^9, 3.749491278755856*^9}},
 CellLabel->
  "Out[247]=",ExpressionUUID->"c646b2da-cb82-4690-9a2d-b89f28a5d3e8"]
}, Open  ]]
},
WindowSize->{808, 910},
WindowMargins->{{185, Automatic}, {Automatic, 218}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 296, 7, 52, "Input",ExpressionUUID->"358caa97-09f6-4309-88ce-4f96c2464831"],
Cell[879, 31, 201, 4, 34, "Output",ExpressionUUID->"ba23d945-3780-47c8-9152-2abe4647c41d"]
}, Open  ]],
Cell[1095, 38, 326, 9, 73, "Input",ExpressionUUID->"7a3a254f-4bce-48c5-ab26-07ed9f0ae394"],
Cell[CellGroupData[{
Cell[1446, 51, 386, 9, 30, "Input",ExpressionUUID->"236e64a4-6e9c-487f-8988-54818afd29a6"],
Cell[1835, 62, 137069, 3390, 4336, "Output",ExpressionUUID->"c646b2da-cb82-4690-9a2d-b89f28a5d3e8"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)

