(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     82012,       1766]
NotebookOptionsPosition[     80658,       1737]
NotebookOutlinePosition[     81044,       1754]
CellTagsIndexPosition[     81001,       1751]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"ea4cd128-64ee-418e-adb7-a5f722736585"],

Cell[TextData[{
 "\n",
 StyleBox["Cloud Libraries", "Title"]
}], "Text",
 CellChangeTimes->{{3.743591388320754*^9, 
  3.743591403158967*^9}},ExpressionUUID->"6ed3a729-90d7-48fe-8708-\
2d06df1d6550"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "init", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"CloudGet", "[", 
  "\"\<https://www.wolframcloud.com/objects/ccn/module/v5\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"init", "[", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.743591044100066*^9, 3.743591074844936*^9}, {
   3.743592808007864*^9, 3.743592817276636*^9}, {3.747645999216069*^9, 
   3.7476460093427067`*^9}, 3.747647933421784*^9, 3.749457146980092*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"b8e1aaaa-b037-457e-8e2b-e56ccd25d81f"],

Cell[BoxData[
 RowBox[{"{", "NHoldRest", "}"}]], "Output",
 CellChangeTimes->{3.749457336084852*^9, 3.749480268588223*^9, 
  3.74986442598844*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"0a38ff47-0302-4a94-b274-37e23bef4a9d"],

Cell[BoxData[
 RowBox[{"{", "\<\"vesion 5\"\>", "}"}]], "Output",
 CellChangeTimes->{3.749457336084852*^9, 3.749480268588223*^9, 
  3.749864425999837*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"25ff3631-3a18-4044-b5f0-08ceb8025dfe"]
}, Open  ]],

Cell[TextData[StyleBox["Logic and Word Functions ", "Title"]], "Text",
 CellChangeTimes->{{3.7435914178749313`*^9, 
  3.743591421271768*^9}},ExpressionUUID->"c807bd37-c960-400d-b9ef-\
2d53221263af"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"logic1", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "d", ",", "\[Theta]", ",", "\[Theta]0",
          ",", "k", ",", "example", ",", "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "aa", ",", "bb", ",", "cc", ",", "dd", 
         ",", "expr1", ",", "expr2", ",", "expr3", ",", "rule1", ",", 
         "rule1num", ",", "arith1", ",", "ar1", ",", "arnum1", ",", "arith2", 
         ",", "ar2", ",", "arnum2", ",", "arith3", ",", "ar3", ",", "arnum3", 
         ",", "finalxpr", ",", "finalxprnum", ",", "rule3", ",", "rule3num", 
         ",", "rule2", ",", "rule2num"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"expr1", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"a", "\[SmallCircle]", "b"}], "\[CirclePlus]", 
                 RowBox[{"c", "\[SmallCircle]", "d"}]}], ",", 
                RowBox[{
                 RowBox[{"a", "/", "b"}], "+", 
                 RowBox[{"c", "/", "d"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"a", "\[SmallCircle]", "b"}], ",", 
                RowBox[{"a", "/", "b"}]}], "}"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"expr2", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"myPARAN2", "[", "a", "]"}], "\[CircleTimes]", 
                  RowBox[{"myPARAN2", "[", "b", "]"}]}], "+", "c"}], ",", 
                RowBox[{
                 RowBox[{"a", "*", "b"}], "+", "c"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"myPARAN2", "[", "a", "]"}], "\[CircleTimes]", 
                 RowBox[{"myPARAN2", "[", "b", "]"}]}], ",", 
                RowBox[{"a", "*", "b"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"c", ",", "c"}], "}"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"expr3", "=", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"myPARAN2", "[", "a", "]"}], "*", 
                RowBox[{"(", 
                 RowBox[{"b", "+", "c"}], ")"}]}], ",", 
               RowBox[{"a", "*", 
                RowBox[{"(", 
                 RowBox[{"b", "+", "c"}], ")"}]}]}], "}"}], "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule1", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", "cc"}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", 
              RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule1num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith1", "=", 
            RowBox[{"RandomChoice", "@", "expr1"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar1", "=", 
            RowBox[{
             RowBox[{"arith1", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule1", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum1", "=", 
            RowBox[{
             RowBox[{"arith1", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule1num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule2", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", 
                RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", "\[IndentingNewLine]", 
              
              RowBox[{"CircleTimes", "\[Rule]", "Times"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule2num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith2", "=", 
            RowBox[{"RandomChoice", "@", "expr2"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar2", "=", 
            RowBox[{
             RowBox[{"arith2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule2", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum2", "=", 
            RowBox[{
             RowBox[{"arith2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule2num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule3", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", 
                RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", "\[IndentingNewLine]", 
              
              RowBox[{"NonCommutativeMultiply", "\[Rule]", "\"\< \>\""}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule3num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith3", "=", 
            RowBox[{"RandomChoice", "@", "expr3"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar3", "=", 
            RowBox[{
             RowBox[{"arith3", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule3", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum3", "=", 
            RowBox[{
             RowBox[{"arith3", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule3num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"finalxpr", "=", 
            RowBox[{"ar1", "+", "ar2", "+", "ar3"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"finalxprnum", "=", 
            RowBox[{"Simplify", "[", 
             RowBox[{"arnum1", "+", "arnum2", "+", "arnum3"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"Row", "@", 
             RowBox[{"{", "finalxprnum", "}"}]}]}], "  ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"finalxprnum", "+", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                   RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "5"}], "}"}], "]"}]}], ")"}]}], 
                "}"}]}]}], "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"3", ",", 
                 RowBox[{"Length", "@", "wrong"}]}], "}"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", "finalxpr", ",", "\"\< is equal to\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", "finalxpr", ",", "\"\< is equal to\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\"\<\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic2", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "d", ",", "\[Theta]", ",", "\[Theta]0",
          ",", "k", ",", "example", ",", "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "aa", ",", "bb", ",", "cc", ",", "dd", 
         ",", "expr1", ",", "expr2", ",", "expr3", ",", "rule1", ",", 
         "rule1num", ",", "arith1", ",", "ar1", ",", "arnum1", ",", "arith2", 
         ",", "ar2", ",", "arnum2", ",", "arith3", ",", "ar3", ",", "arnum3", 
         ",", "finalxpr", ",", "finalxprnum", ",", "rule3", ",", "rule3num", 
         ",", "rule2", ",", "rule2num", ",", "finalxprnum0", ",", 
         "finalxpr0"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"expr1", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"a", "\[SmallCircle]", "b"}], "\[CirclePlus]", 
                 RowBox[{"c", "\[SmallCircle]", "d"}]}], ",", 
                RowBox[{
                 RowBox[{"a", "/", "b"}], "+", 
                 RowBox[{"c", "/", "d"}]}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"a", "\[SmallCircle]", "b"}], ",", 
                RowBox[{"a", "/", "b"}]}], "}"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"expr2", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"myPARAN2", "[", "a", "]"}], "\[CircleTimes]", 
                  RowBox[{"myPARAN2", "[", "b", "]"}]}], "+", "c"}], ",", 
                RowBox[{
                 RowBox[{"a", "*", "b"}], "+", "c"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"myPARAN2", "[", "a", "]"}], "\[CircleTimes]", 
                 RowBox[{"myPARAN2", "[", "b", "]"}]}], ",", 
                RowBox[{"a", "*", "b"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"c", ",", "c"}], "}"}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"expr3", "=", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
                RowBox[{"myPARAN2", "[", "a", "]"}], "*", 
                RowBox[{"(", 
                 RowBox[{"b", "+", "c"}], ")"}]}], ",", 
               RowBox[{"a", "*", 
                RowBox[{"(", 
                 RowBox[{"b", "+", "c"}], ")"}]}]}], "}"}], "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule1", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", "cc"}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", 
              RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule1num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith1", "=", 
            RowBox[{"RandomChoice", "@", "expr1"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar1", "=", 
            RowBox[{
             RowBox[{"arith1", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule1", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum1", "=", 
            RowBox[{
             RowBox[{"arith1", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule1num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule2", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", 
                RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", "\[IndentingNewLine]", 
              
              RowBox[{"CircleTimes", "\[Rule]", "Times"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule2num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith2", "=", 
            RowBox[{"RandomChoice", "@", "expr2"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar2", "=", 
            RowBox[{
             RowBox[{"arith2", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule2", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum2", "=", 
            RowBox[{
             RowBox[{"arith2", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule2num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Table", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                  RowBox[{"RandomInteger", "[", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"rule3", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", 
               RowBox[{"ToString", "@", "aa"}]}], ",", 
              RowBox[{"b", "\[Rule]", 
               RowBox[{"ToString", "@", "bb"}]}], ",", 
              RowBox[{"c", "\[Rule]", 
               RowBox[{"ToString", "@", 
                RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
              RowBox[{"d", "\[Rule]", 
               RowBox[{"ToString", "@", "dd"}]}], ",", "\[IndentingNewLine]", 
              
              RowBox[{"NonCommutativeMultiply", "\[Rule]", "\"\< \>\""}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"rule3num", "=", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"a", "\[Rule]", "aa"}], ",", 
              RowBox[{"b", "\[Rule]", "bb"}], ",", 
              RowBox[{"c", "\[Rule]", "cc"}], ",", 
              RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
              RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
             "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"arith3", "=", 
            RowBox[{"RandomChoice", "@", "expr3"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ar3", "=", 
            RowBox[{
             RowBox[{"arith3", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule3", ")"}]}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"arnum3", "=", 
            RowBox[{
             RowBox[{"arith3", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/.", 
             RowBox[{"(", "rule3num", ")"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"finalxpr0", "=", 
            RowBox[{"ar1", "+", "ar2", "+", "ar3"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"finalxprnum0", "=", 
            RowBox[{"Simplify", "[", 
             RowBox[{"arnum1", "+", "arnum2", "+", "arnum3"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", "finalxpr0"}], " ", ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{
            "Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
                
                RowBox[{"RandomSample", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                    RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"rule1", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", 
                   RowBox[{"ToString", "@", "aa"}]}], ",", 
                  RowBox[{"b", "\[Rule]", 
                   RowBox[{"ToString", "@", "bb"}]}], ",", 
                  RowBox[{"c", "\[Rule]", 
                   RowBox[{"ToString", "@", "cc"}]}], ",", 
                  RowBox[{"d", "\[Rule]", 
                   RowBox[{"ToString", "@", "dd"}]}], ",", 
                  RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"rule1num", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", "aa"}], ",", 
                  RowBox[{"b", "\[Rule]", "bb"}], ",", 
                  RowBox[{"c", "\[Rule]", "cc"}], ",", 
                  RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
                  
                  RowBox[{"SmallCircle", "\[Rule]", "Divide"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"arith1", "=", 
                RowBox[{"RandomChoice", "@", "expr1"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"ar1", "=", 
                RowBox[{
                 RowBox[{"arith1", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule1", ")"}]}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"arnum1", "=", 
                RowBox[{
                 RowBox[{"arith1", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule1num", ")"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
                
                RowBox[{"RandomSample", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                    RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"rule2", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", 
                   RowBox[{"ToString", "@", "aa"}]}], ",", 
                  RowBox[{"b", "\[Rule]", 
                   RowBox[{"ToString", "@", "bb"}]}], ",", 
                  RowBox[{"c", "\[Rule]", 
                   RowBox[{"ToString", "@", 
                    RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
                  RowBox[{"d", "\[Rule]", 
                   RowBox[{"ToString", "@", "dd"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"CircleTimes", "\[Rule]", "Times"}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"rule2num", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", "aa"}], ",", 
                  RowBox[{"b", "\[Rule]", "bb"}], ",", 
                  RowBox[{"c", "\[Rule]", "cc"}], ",", 
                  RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
                  
                  RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"arith2", "=", 
                RowBox[{"RandomChoice", "@", "expr2"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"ar2", "=", 
                RowBox[{
                 RowBox[{"arith2", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule2", ")"}]}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"arnum2", "=", 
                RowBox[{
                 RowBox[{"arith2", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule2num", ")"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"aa", ",", "bb", ",", "cc", ",", "dd"}], "}"}], "=", 
                
                RowBox[{"RandomSample", "[", 
                 RowBox[{
                  RowBox[{"Table", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}], "^", 
                    RowBox[{"RandomInteger", "[", "]"}]}], ")"}], "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "15"}], "}"}], "]"}]}], ")"}], ",", 
                    RowBox[{"{", "10", "}"}]}], "]"}], ",", "4"}], "]"}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"rule3", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", 
                   RowBox[{"ToString", "@", "aa"}]}], ",", 
                  RowBox[{"b", "\[Rule]", 
                   RowBox[{"ToString", "@", "bb"}]}], ",", 
                  RowBox[{"c", "\[Rule]", 
                   RowBox[{"ToString", "@", 
                    RowBox[{"myPARAN", "[", "cc", "]"}]}]}], ",", 
                  RowBox[{"d", "\[Rule]", 
                   RowBox[{"ToString", "@", "dd"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                  "NonCommutativeMultiply", "\[Rule]", "\"\< \>\""}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"rule3num", "=", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"a", "\[Rule]", "aa"}], ",", 
                  RowBox[{"b", "\[Rule]", "bb"}], ",", 
                  RowBox[{"c", "\[Rule]", "cc"}], ",", 
                  RowBox[{"d", "\[Rule]", "dd"}], ",", "\[IndentingNewLine]", 
                  
                  RowBox[{"CircleTimes", "\[Rule]", "Times"}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"CirclePlus", "\[Rule]", "Plus"}]}], 
                 "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"arith3", "=", 
                RowBox[{"RandomChoice", "@", "expr3"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"ar3", "=", 
                RowBox[{
                 RowBox[{"arith3", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule3", ")"}]}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"arnum3", "=", 
                RowBox[{
                 RowBox[{"arith3", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "/.", 
                 RowBox[{"(", "rule3num", ")"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"finalxpr", "=", 
                RowBox[{"ar1", "+", "ar2", "+", "ar3"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"finalxprnum", "=", 
                RowBox[{"Simplify", "[", 
                 RowBox[{"arnum1", "+", "arnum2", "+", "arnum3"}], "]"}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", " ", "[", 
                RowBox[{
                 RowBox[{"finalxprnum", "!=", "finalxprnum0"}], ",", 
                 "finalxpr", ",", "Nothing"}], "]"}]}], "\[IndentingNewLine]",
               "\[IndentingNewLine]", "\[IndentingNewLine]", ",", "10"}], 
             "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"3", ",", 
                 RowBox[{"Length", "@", "wrong"}]}], "}"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", "finalxprnum0", ",", "\"\< is equal to\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", "finalxprnum0", ",", "\"\< is equal to\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}]}], 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\"\<\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{
           "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.743591378145288*^9, 3.7435913783228416`*^9}, 
   3.7435914245272923`*^9, {3.747645912435511*^9, 3.747645912931457*^9}, {
   3.747646046339014*^9, 3.747646104958357*^9}, {3.747646178268447*^9, 
   3.7476462659830914`*^9}, {3.747646303851428*^9, 3.747646587917054*^9}, {
   3.7476468978391333`*^9, 3.747647021994542*^9}, {3.747647067615756*^9, 
   3.747647120247527*^9}, {3.747647157595894*^9, 3.7476478158261003`*^9}, {
   3.747648021545681*^9, 3.7476480304993067`*^9}, 3.747648158538848*^9, {
   3.747648217601945*^9, 3.747648277189116*^9}, {3.74764836065056*^9, 
   3.7476483863363857`*^9}, 3.747648584754449*^9, {3.747648653315894*^9, 
   3.747648675106042*^9}, 3.747648712019691*^9, {3.747652072587161*^9, 
   3.7476521769394712`*^9}, {3.747652214338584*^9, 3.747652299051979*^9}, {
   3.747652333005484*^9, 3.7476523859824667`*^9}, {3.747652425461397*^9, 
   3.747652498575881*^9}, {3.7476526613459806`*^9, 3.747652721734255*^9}, {
   3.7476527607964582`*^9, 3.7476528915116158`*^9}, {3.747652934960745*^9, 
   3.747652942452117*^9}, {3.7476531362383423`*^9, 3.747653140118181*^9}, 
   3.747653175139617*^9, {3.74765321397654*^9, 3.7476532305923443`*^9}, {
   3.7476532609698353`*^9, 3.7476532794190617`*^9}, {3.7476533395760403`*^9, 
   3.747653349136445*^9}, {3.7476533958824873`*^9, 3.7476534498820887`*^9}, {
   3.747653509228681*^9, 3.7476535109926033`*^9}, {3.7476536234851427`*^9, 
   3.7476536745256968`*^9}, {3.747653792136223*^9, 3.7476538165727882`*^9}, {
   3.749310498199704*^9, 3.749310752574253*^9}, {3.7493108956394367`*^9, 
   3.749310896112463*^9}, {3.749310930797447*^9, 3.749310930970457*^9}, {
   3.7493127297564497`*^9, 3.749312836278832*^9}, {3.74931287267999*^9, 
   3.7493129446128283`*^9}, 3.749312984136682*^9, 3.749313023986938*^9, {
   3.7493130638110533`*^9, 3.749313117922997*^9}, {3.749313196778408*^9, 
   3.7493132260951347`*^9}, {3.749313261396337*^9, 3.749313274873561*^9}, {
   3.749313315894134*^9, 3.749313324330102*^9}, 3.7493134487578793`*^9, {
   3.749313483062097*^9, 3.7493135468583813`*^9}, {3.749313588317573*^9, 
   3.7493136097019663`*^9}, {3.749459796146912*^9, 3.749459839728794*^9}, {
   3.749459869739799*^9, 3.749459980040701*^9}, {3.749460036153413*^9, 
   3.7494600454723454`*^9}, {3.7494601361625147`*^9, 3.749460289854395*^9}, {
   3.749460362210907*^9, 3.749460445361331*^9}, {3.749460626277074*^9, 
   3.749460661886858*^9}, {3.749460695366205*^9, 3.749460725505011*^9}, {
   3.749460813300625*^9, 3.74946085107701*^9}, {3.749460895226184*^9, 
   3.7494609003419933`*^9}, {3.749460948349914*^9, 3.7494609835143642`*^9}, 
   3.749461021621361*^9, 3.749461073085087*^9, 3.749461143765396*^9, 
   3.7494613447386847`*^9, {3.749461386868702*^9, 3.749461415996285*^9}, 
   3.74946148893038*^9, {3.7494616380859528`*^9, 3.749461649257185*^9}, {
   3.749461734433096*^9, 3.749461737111203*^9}, {3.749461811170672*^9, 
   3.749461813678812*^9}, {3.749461846046998*^9, 3.7494618634717484`*^9}, {
   3.7494619637133827`*^9, 3.749462155650631*^9}, 3.749462236372751*^9, {
   3.74946236714539*^9, 3.7494624788826103`*^9}, {3.749462531138633*^9, 
   3.7494625549998417`*^9}, {3.749462832358444*^9, 3.749462891617042*^9}, {
   3.749462927186809*^9, 3.74946294517558*^9}, {3.749463014976994*^9, 
   3.749463027250081*^9}, {3.7494630630716867`*^9, 3.749463138252387*^9}, {
   3.749463175103156*^9, 3.749463185340044*^9}, 3.749463225487875*^9, {
   3.7494632788424587`*^9, 3.7494633158129807`*^9}, {3.749463360595656*^9, 
   3.749463381216318*^9}, {3.749463519944255*^9, 3.749463564439849*^9}, {
   3.749463701387545*^9, 3.749463723391382*^9}, {3.749468294813879*^9, 
   3.7494682948985233`*^9}, {3.749470009012959*^9, 3.749470010744133*^9}, 
   3.749470045182426*^9, 3.749480401719941*^9},
 CellLabel->"In[4]:=",ExpressionUUID->"23492e2a-b216-4751-9773-f8572f7b738b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"LaunchKernels", "[", "64", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 3.730843910893158*^9, 3.730844121510347*^9, 
   3.730844251350174*^9, {3.730844390877315*^9, 3.730844392778469*^9}, {
   3.743597517958117*^9, 3.743597520679738*^9}, 
   3.74359770736696*^9},ExpressionUUID->"bf8c716b-e954-4fb8-99c8-\
dc528fa5dced"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9, 3.730844128232019*^9, 3.730844253679215*^9, 
   3.7308443463882*^9, 
   3.743597667837785*^9},ExpressionUUID->"7cd15d09-32f7-4e5e-a7a0-\
20c149582d6c"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 
   3.71567570442386*^9},ExpressionUUID->"ca2c833e-9bf8-45e1-8429-\
cee1bb943d91"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<artith1_\>\"", ",", 
     "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<artith1_\>\"", ",", 
     "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<artith1_\>\"", ",", 
     "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<artith1_\>\"", ",", 
      "\"\<pdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic1", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], 
           RowBox[{"(*", 
            RowBox[{",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"logic2", ",", 
               RowBox[{"{", "}"}], ",", 
               RowBox[{"<|", 
                RowBox[{
                 RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
                 RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
                 RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
                 RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], 
                "|>"}]}], "}"}]}], "*)"}], "\[IndentingNewLine]", "}"}]}], 
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"6", "\[Rule]", "\"\<6. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "8", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.730843810079851*^9, 3.730843837162004*^9}, {3.730844126877118*^9, 
   3.73084412854283*^9}, {3.730844386133678*^9, 3.730844388043399*^9}, {
   3.743597528738099*^9, 3.743597584436431*^9}, {3.743597697322775*^9, 
   3.743597699998611*^9}, {3.7476089314393787`*^9, 3.747608964867762*^9}, {
   3.7476563245503187`*^9, 3.747656369313794*^9}, {3.749463433670292*^9, 
   3.74946344994176*^9}, {3.749864475312401*^9, 
   3.7498644776293573`*^9}},ExpressionUUID->"b9bf5bc8-478b-4cdc-9ea3-\
71b9fc2c8c79"]
},
WindowSize->{1337, 1078},
WindowMargins->{{Automatic, 495}, {Automatic, 41}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1313, 32, 94, "Input",ExpressionUUID->"ea4cd128-64ee-418e-adb7-a5f722736585"],
Cell[1874, 54, 198, 6, 97, "Text",ExpressionUUID->"6ed3a729-90d7-48fe-8708-2d06df1d6550"],
Cell[CellGroupData[{
Cell[2097, 64, 572, 10, 94, "Input",ExpressionUUID->"b8e1aaaa-b037-457e-8e2b-e56ccd25d81f"],
Cell[2672, 76, 224, 4, 34, "Output",ExpressionUUID->"0a38ff47-0302-4a94-b274-37e23bef4a9d"],
Cell[2899, 82, 232, 4, 34, "Output",ExpressionUUID->"25ff3631-3a18-4044-b5f0-08ceb8025dfe"]
}, Open  ]],
Cell[3146, 89, 198, 3, 73, "Text",ExpressionUUID->"c807bd37-c960-400d-b9ef-2d53221263af"],
Cell[3347, 94, 62702, 1330, 8998, "Input",ExpressionUUID->"23492e2a-b216-4751-9773-f8572f7b738b"],
Cell[CellGroupData[{
Cell[66074, 1428, 841, 17, 178, "Input",ExpressionUUID->"bf8c716b-e954-4fb8-99c8-dc528fa5dced"],
Cell[66918, 1447, 777, 17, 34, "Output",ExpressionUUID->"7cd15d09-32f7-4e5e-a7a0-20c149582d6c"]
}, Open  ]],
Cell[67710, 1467, 321, 9, 120, "Text",ExpressionUUID->"ca2c833e-9bf8-45e1-8429-cee1bb943d91"],
Cell[68034, 1478, 12620, 257, 1228, "Input",ExpressionUUID->"b9bf5bc8-478b-4cdc-9ea3-71b9fc2c8c79"]
}
]
*)

