(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23375,        542]
NotebookOptionsPosition[     22018,        513]
NotebookOutlinePosition[     22403,        530]
CellTagsIndexPosition[     22360,        527]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/"}], 
     "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, {
   3.749410557138061*^9, 3.749410580471854*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"d7dd49c4-394e-46a4-9507-bf690e1940f3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"c", "=", 
   RowBox[{
    RowBox[{"-", "0.0122561"}], "+", 
    RowBox[{"0.744862", "I"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"General", "::", "ovfl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"RecurrenceTable", "::", "excptn"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zinit", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"a", "+", 
      RowBox[{"\[ImaginaryI]", " ", "b"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"-", "1.3"}], ",", "1.3", ",", 
       RowBox[{"2.6", "/", "249"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", 
       RowBox[{"-", "1.3"}], ",", "1.3", ",", 
       RowBox[{"2.6", "/", "249"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"iterates", "=", " ", 
    RowBox[{"RecurrenceTable", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"z", "[", 
          RowBox[{"k", "+", "1"}], "]"}], "==", 
         RowBox[{
          RowBox[{
           RowBox[{"z", "[", "k", "]"}], "^", "2"}], "+", "c"}]}], ",", 
        RowBox[{
         RowBox[{"z", "[", "0", "]"}], "\[Equal]", "zinit"}]}], "}"}], ",", 
      " ", "z", ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", "300"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dims", "=", 
   RowBox[{"Dimensions", "@", "iterates"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "@", 
         RowBox[{
          RowBox[{
           RowBox[{"iterates", "[", 
            RowBox[{"[", "k", "]"}], "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], " ", "\[LessEqual]", " ", "500"}],
        ",", " ", 
       RowBox[{"Abs", "@", 
        RowBox[{
         RowBox[{
          RowBox[{"iterates", "[", 
           RowBox[{"[", "k", "]"}], "]"}], "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", " ", "0"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.749401657317675*^9, 3.749401681047645*^9}, {
   3.749401748726652*^9, 3.749401773599543*^9}, {3.749401819725972*^9, 
   3.749401843407687*^9}, {3.749401907560339*^9, 3.749401953940276*^9}, 
   3.749402072429715*^9, {3.749402185021524*^9, 3.749402222881575*^9}, {
   3.749403629051532*^9, 3.749403629230139*^9}, {3.7494100757538137`*^9, 
   3.7494100770123453`*^9}, {3.749410257062257*^9, 3.74941025718449*^9}, {
   3.749410803620495*^9, 3.749410835129724*^9}, 3.74941089083123*^9, {
   3.749410928293929*^9, 3.749410946306004*^9}, 3.74941121643545*^9, {
   3.749411318013163*^9, 3.7494113376769*^9}, {3.749411370145705*^9, 
   3.7494113723830853`*^9}},
 CellLabel->
  "In[112]:=",ExpressionUUID->"aac2e6b1-8412-404d-9d01-42ea38933c5b"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"p", "[", "z_", "]"}], ":=", 
   RowBox[{
    RowBox[{"z", "^", "4"}], "-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"aa", "=", "2"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"General", "::", "ovfl"}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Off", "[", 
    RowBox[{"RecurrenceTable", "::", "excptn"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"zinit", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"p", "[", "z", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{"z", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"a", "+", 
          RowBox[{"\[ImaginaryI]", " ", "b"}]}], ")"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", 
       RowBox[{"-", "1.3"}], ",", "1.3", ",", 
       RowBox[{"2.6", "/", "249"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"b", ",", 
       RowBox[{"-", "1.3"}], ",", "1.3", ",", 
       RowBox[{"2.6", "/", "249"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"iterates", "=", " ", 
    RowBox[{"RecurrenceTable", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"z", "[", 
          RowBox[{"k", "+", "1"}], "]"}], "==", 
         RowBox[{
          RowBox[{"z", "[", "k", "]"}], "-", 
          RowBox[{"aa", "*", 
           RowBox[{
            RowBox[{"p", "[", 
             RowBox[{"z", "[", "k", "]"}], "]"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"p", "'"}], "[", 
              RowBox[{"z", "[", "k", "]"}], "]"}], ")"}]}]}]}]}], ",", 
        RowBox[{
         RowBox[{"z", "[", "0", "]"}], "\[Equal]", "zinit"}]}], "}"}], ",", 
      " ", "z", ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "0", ",", "300"}], "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dims", "=", 
   RowBox[{"Dimensions", "@", "iterates"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"data", " ", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "@", 
         RowBox[{
          RowBox[{
           RowBox[{"iterates", "[", 
            RowBox[{"[", "k", "]"}], "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "j", "]"}], "]"}]}], " ", "\[LessEqual]", " ", "500"}],
        ",", " ", 
       RowBox[{"Abs", "@", 
        RowBox[{
         RowBox[{
          RowBox[{"iterates", "[", 
           RowBox[{"[", "k", "]"}], "]"}], "[", 
          RowBox[{"[", "i", "]"}], "]"}], "[", 
         RowBox[{"[", "j", "]"}], "]"}]}], ",", " ", "0"}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"k", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "1", ",", 
       RowBox[{"dims", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.749401657317675*^9, 3.749401681047645*^9}, {
   3.749401748726652*^9, 3.749401773599543*^9}, {3.749401819725972*^9, 
   3.749401843407687*^9}, {3.749401907560339*^9, 3.749401953940276*^9}, 
   3.749402072429715*^9, {3.749402185021524*^9, 3.749402222881575*^9}, 
   3.749402362671871*^9, 3.74940240204961*^9, {3.749402494366828*^9, 
   3.749402558728531*^9}, {3.7494026063550863`*^9, 3.749402695738103*^9}, {
   3.74940274132086*^9, 3.74940274595466*^9}, {3.7494027946354237`*^9, 
   3.749402883893058*^9}, {3.749402928085307*^9, 3.749402931740041*^9}, 
   3.749402983808813*^9, {3.749403016039487*^9, 3.749403067914207*^9}, {
   3.749403267942627*^9, 3.7494032935818167`*^9}, 3.749403330943818*^9, 
   3.7494035006764603`*^9, {3.749403536181319*^9, 3.749403555317569*^9}, 
   3.749410048689698*^9, {3.749410348470187*^9, 3.749410348637513*^9}, 
   3.74941101026341*^9, {3.749411433541404*^9, 3.749411434260013*^9}},
 CellLabel->
  "In[122]:=",ExpressionUUID->"ae671d40-27ef-4e69-8974-c0f22a5d4487"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Reverse", "@", 
  RowBox[{"Abs", "@", 
   RowBox[{"iterates", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "3", ",", "3"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.74940994222017*^9, 3.749409961292471*^9}, {
  3.749411954324801*^9, 3.7494119588225813`*^9}},
 CellLabel->
  "In[131]:=",ExpressionUUID->"3e20b37b-49fb-46ed-a09d-befc876e9daa"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.9804498986054172`", ",", "1.0208049816331788`", ",", 
   "0.9803877932740676`", ",", "1.020875458850878`", ",", 
   "0.9803250847004604`", ",", "1.0209466515951138`", ",", 
   "0.9802617629997542`", ",", "1.0210185720239189`", ",", 
   "0.9801978180580537`", ",", "1.0210912325861505`", ",", 
   "0.9801332395255226`", ",", "1.0211646460304913`", ",", 
   "0.9800680168092414`", ",", "1.0212388254147888`", ",", 
   "0.9800021390657998`", ",", "1.0213137841157578`", ",", 
   "0.9799355951936098`", ",", "1.0213895358390517`", ",", 
   "0.979868373824928`", ",", "1.0214660946297307`", ",", 
   "0.9798004633175739`", ",", "1.0215434748831353`", ",", 
   "0.979731851746331`", ",", "1.0216216913561926`", ",", 
   "0.9796625268940152`", ",", "1.0217007591791671`", ",", 
   "0.9795924762421956`", ",", "1.0217806938678853`", ",", 
   "0.979521686961552`", ",", "1.0218615113364513`", ",", 
   "0.9794501459018502`", ",", "1.0219432279104785`", ",", 
   "0.9793778395815217`", ",", "1.0220258603408616`", ",", 
   "0.9793047541768226`", ",", "1.0221094258181183`", ",", 
   "0.9792308755105567`", ",", "1.0221939419873234`", ",", 
   "0.9791561890403399`", ",", "1.0222794269636695`", ",", 
   "0.9790806798463834`", ",", "1.022365899348682`", ",", 
   "0.9790043326187743`", ",", "1.022453378247124`", ",", 
   "0.9789271316442236`", ",", "1.0225418832846236`", ",", 
   "0.978849060792263`", ",", "1.0226314346260623`", ",", 
   "0.9787701035008548`", ",", "1.0227220529947618`", ",", 
   "0.9786902427613934`", ",", "1.0228137596925113`", ",", 
   "0.9786094611030592`", ",", "1.0229065766204815`", ",", 
   "0.9785277405764987`", ",", "1.023000526301067`", ",", 
   "0.9784450627367915`", ",", "1.0230956319007112`", ",", 
   "0.9783614086256706`", ",", "1.0231919172537625`", ",", 
   "0.9782767587529525`", ",", "1.0232894068874205`", ",", 
   "0.9781910930771417`", ",", "1.0233881260478292`", ",", 
   "0.978104390985157`", ",", "1.0234881007273808`", ",", 
   "0.9780166312711417`", ",", "1.0235893576932977`", ",", 
   "0.9779277921142999`", ",", "1.0236919245175629`", ",", 
   "0.9778378510557122`", ",", "1.023795829608275`", ",", 
   "0.9777467849740692`", ",", "1.023901102242509`", ",", 
   "0.977654570060267`", ",", "1.0240077726007697`", ",", 
   "0.9775611817907963`", ",", "1.024115871803127`", ",", 
   "0.9774665948998631`", ",", "1.0242254319471331`", ",", 
   "0.977370783350161`", ",", "1.0243364861476294`", ",", 
   "0.9772737203022238`", ",", "1.0244490685785461`", ",", 
   "0.9771753780822727`", ",", "1.0245632145168249`", ",", 
   "0.9770757281484699`", ",", "1.0246789603885842`", ",", 
   "0.9769747410554862`", ",", "1.02479634381767`", ",", 
   "0.9768723864172781`", ",", "1.0249154036767336`", ",", 
   "0.9767686328679721`", ",", "1.0250361801409988`", ",", 
   "0.9766634480207347`", ",", "1.0251587147448815`", ",", 
   "0.9765567984245087`", ",", "1.0252830504416497`", ",", 
   "0.9764486495184819`", ",", "1.0254092316663097`", ",", 
   "0.9763389655841457`", ",", "1.0255373044019356`", ",", 
   "0.9762277096947918`", ",", "1.02566731624966`", ",", "0.976114843662284`",
    ",", "1.0257993165025707`", ",", "0.9760003279809261`", ",", 
   "1.0259333562237745`", ",", "0.9758841217682408`", ",", 
   "1.0260694883289052`", ",", "0.9757661827024527`", ",", 
   "1.026207767673381`", ",", "0.9756464669564575`", ",", 
   "1.0263482511447348`", ",", "0.9755249291280423`", ",", 
   "1.0264909977603738`", ",", "0.9754015221660987`", ",", 
   "1.0266360687711449`", ",", "0.975276197292557`", ",", 
   "1.0267835277711204`", ",", "0.9751489039197436`", ",", 
   "1.026933440814052`", ",", "0.975019589562837`", ",", 
   "1.0270858765369733`", ",", "0.97488819974708`", ",", 
   "1.0272409062914758`", ",", "0.9747546779093681`", ",", 
   "1.027398604283231`", ",", "0.9746189652938065`", ",", 
   "1.027559047720375`", ",", "0.974481000840794`", ",", 
   "1.0277223169714282`", ",", "0.9743407210691516`", ",", 
   "1.027888495733483`", ",", "0.9741980599507754`", ",", 
   "1.028057671211461`", ",", "0.9740529487772428`", ",", 
   "1.028229934309307`", ",", "0.9739053160177562`", ",", "1.02840537983407`",
    ",", "0.9737550871677466`", ",", "1.028584106713915`", ",", 
   "0.9736021845874031`", ",", "1.0287662182312005`", ",", 
   "0.9734465273293235`", ",", "1.028951822271866`", ",", 
   "0.9732880309544069`", ",", "1.0291410315925`", ",", "0.973126607335027`", 
   ",", "1.0293339641065826`", ",", "0.9729621644444303`", ",", 
   "1.0295307431915597`", ",", "0.9727946061312033`", ",", 
   "1.029731498018556`", ",", "0.9726238318775379`", ",", 
   "1.0299363639067298`", ",", "0.972449736539898`", ",", 
   "1.0301454827044783`", ",", "0.9722722100705485`", ",", 
   "1.0303590031999232`", ",", "0.9720911372182511`", ",", 
   "1.030577081563383`", ",", "0.9719063972062532`", ",", 
   "1.0307998818248105`", ",", "0.9717178633855023`", ",", 
   "1.0310275763895127`", ",", "0.9715254028607935`", ",", 
   "1.0312603465958345`", ",", "0.9713288760873108`", ",", 
   "1.0314983833189004`", ",", "0.9711281364347437`", ",", 
   "1.031741887624979`", ",", "0.9709230297158453`", ",", 
   "1.0319910714815648`", ",", "0.9707133936759407`", ",", 
   "1.0322461585288687`", ",", "0.9704990574394954`", ",", 
   "1.0325073849191024`", ",", "0.9702798409093958`", ",", 
   "1.0327750002307003`", ",", "0.9700555541140752`", ",", 
   "1.0330492684655248`", ",", "0.9698259964970362`", ",", 
   "1.0333304691381062`", ",", "0.9695909561426421`", ",", 
   "1.0336188984671233`", ",", "0.9693502089312915`", ",", 
   "1.0339148706806698`", ",", "0.969103517616209`", ",", 
   "1.0342187194483712`", ",", "0.9688506308130858`", ",", 
   "1.0345307994551893`", ",", "0.9685912818926418`", ",", 
   "1.0348514881337847`", ",", "0.9683251877648574`", ",", 
   "1.035181187574671`", ",", "0.9680520475420806`", ",", 
   "1.0355203266361381`", ",", "0.9677715410664366`", ",", 
   "1.0358693632791198`", ",", "0.9674833272849003`", ",", 
   "1.0362287871559126`", ",", "0.9671870424529851`", ",", 
   "1.036599122486028`", ",", "0.966882298145191`", ",", 
   "1.0369809312576002`", ",", "0.9665686790470659`", ",", 
   "1.0373748167988301`", ",", "0.9662457404998661`", ",", 
   "1.037781427771115`", ",", "0.9659130057642524`", ",", "1.03820146264401`",
    ",", "0.9655699629640715`", ",", "1.0386356747222987`", ",", 
   "0.9652160616648844`", ",", "1.039084877807557`", ",", 
   "0.9648507090343058`", ",", "1.0395499525911052`", ",", 
   "0.9644732655221243`", ",", "1.0400318538927513`", ",", 
   "0.9640830399872805`", ",", "1.0405316188808875`", ",", 
   "0.9636792841856447`", ",", "1.0410503764352221`", ",", 
   "0.9632611865166543`", ",", "1.041589357844827`", ",", 
   "0.9628278649075687`", ",", "1.0421499090726858`", ",", 
   "0.9623783586905373`", ",", "1.0427335048654192`", ",", 
   "0.9619116192987592`", ",", "1.0433417650457026`", ",", 
   "0.9614264995723655`", ",", "1.0439764733982553`", ",", 
   "0.9609217414204375`", ",", "1.044639599652253`", ",", 
   "0.9603959615304372`", ",", "1.0453333251790724`", ",", 
   "0.9598476347471359`", ",", "1.0460600731716705`", ",", 
   "0.959275074655764`", ",", "1.0468225442604324`", ",", 
   "0.9586764107930159`", ",", "1.0476237587632529`", ",", 
   "0.9580495617672858`", ",", "1.048467107083141`", ",", 
   "0.9573922033859408`", ",", "1.0493564101798938`", ",", 
   "0.9567017306485812`", ",", "1.0502959925885629`", ",", 
   "0.9559752121517828`", ",", "1.0512907711862094`", ",", 
   "0.9552093350355559`", ",", "1.0523463638909958`", ",", 
   "0.9544003380461428`", ",", "1.053469223817066`", ",", 
   "0.953543929538319`", ",", "1.0546668062565512`", ",", 
   "0.9526351862121933`", ",", "1.0559477784425615`", ",", 
   "0.9516684269549823`", ",", "1.0573222857073288`", ",", 
   "0.950637054157541`", ",", "1.0588022929174281`", ",", 
   "0.949533352023568`", ",", "1.060402027777091`", ",", 
   "0.9483482272578145`", ",", "1.0621385640816778`", ",", 
   "0.9470708714264836`", ",", "1.064032600482919`", ",", 
   "0.9456883151185647`", ",", "1.0661095175223458`", ",", 
   "0.9441848299485888`", ",", "1.0684008390777884`", ",", 
   "0.9425411122488231`", ",", "1.0709462955814835`", ",", 
   "0.9407331463669035`", ",", "1.0737968070676782`", ",", 
   "0.9387305854658557`", ",", "1.0770189163448067`", ",", 
   "0.9364943838283484`", ",", "1.0807015920184522`", ",", 
   "0.9339732272326271`", ",", "1.0849670722457168`", ",", 
   "0.9310979530188969`", ",", "1.08998895781542`", ",", 
   "0.9277724392698916`", ",", "1.0960241472580994`", ",", 
   "0.9238579093505056`", ",", "1.1034733576165796`", ",", 
   "0.9191439943663665`", ",", "1.1130070332686393`", ",", 
   "0.9132904065206532`", ",", "1.1258633750133917`", ",", 
   "0.9056939115381659`", ",", "1.144704989399569`", ",", 
   "0.8951227197158016`", ",", "1.4846851624812036`", ",", 
   "2.929598484073744`", ",", "5.85421277929196`", ",", 
   "11.707802435494331`"}], "}"}]], "Output",
 CellChangeTimes->{{3.7494099528101873`*^9, 3.749409962576867*^9}, 
   3.7494119591197977`*^9},
 CellLabel->
  "Out[131]=",ExpressionUUID->"69317870-0552-4060-837f-ea4f446fb74d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"z", "-", 
    RowBox[{"aa", "*", 
     RowBox[{
      RowBox[{"p", "[", "z", "]"}], "/", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"p", "'"}], "[", "z", "]"}], ")"}]}]}]}], ")"}], "/.", 
  RowBox[{"{", 
   RowBox[{"z", "\[Rule]", "5.85421277929196`"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.749411978352933*^9, 3.749412022442473*^9}},
 CellLabel->
  "In[133]:=",ExpressionUUID->"6db89a97-708f-442e-9e24-7ec6fc9c664d"],

Cell[BoxData["2.929598484073744`"], "Output",
 CellChangeTimes->{{3.74941200839676*^9, 3.749412022919655*^9}},
 CellLabel->
  "Out[133]=",ExpressionUUID->"1f645ad2-b27b-4b92-bbd9-e5f38031d34a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Image3D", "@", "data"}]], "Input",
 CellChangeTimes->{{3.749410004454544*^9, 3.749410025407261*^9}, {
  3.749410416938486*^9, 3.749410422674555*^9}, {3.7494104952288723`*^9, 
  3.749410497196373*^9}},
 CellLabel->"In[50]:=",ExpressionUUID->"959aab39-20b5-4b00-98c4-f187117dd464"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Manipulate", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixPlot", "[", 
     RowBox[{
      RowBox[{"data", "[", 
       RowBox[{"[", "n", "]"}], "]"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
      RowBox[{"ColorFunction", "\[Rule]", "\"\<TemperatureMap\>\""}]}], "]"}],
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"n", ",", "1", ",", "40", ",", "1"}], "}"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.749401970394863*^9, 3.7494020218235693`*^9}, {
   3.749402117422015*^9, 3.7494021310308943`*^9}, 3.749403139142782*^9, {
   3.749403257041648*^9, 3.749403257387988*^9}, 3.749403487291308*^9, {
   3.7494100962070208`*^9, 3.749410101089656*^9}, {3.7494106274199*^9, 
   3.749410641874511*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"4aaed154-dfaf-4bdb-9768-c1ee99c1ba6f"],

Cell[BoxData[
 RowBox[{"Image3D", "[", 
  RowBox[{
   RowBox[{"Reverse", "@", "data"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}]], "Input",
 CellLabel->
  "In[134]:=",ExpressionUUID->"4a0b0d08-a6fb-4a41-b105-651a95e3ba8c"],

Cell[BoxData[
 RowBox[{"ImageAssemble", "[", 
  RowBox[{
   RowBox[{"ImagePartition", "[", 
    RowBox[{
     RowBox[{"Image3D", "[", 
      RowBox[{
       RowBox[{"Reverse", "@", "data"}], ",", 
       RowBox[{"ImageSize", "\[Rule]", "500"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Scaled", "[", 
       RowBox[{"1", "/", "2"}], "]"}], "}"}]}], "]"}], "/.", 
   RowBox[{"i_Image3D", "\[RuleDelayed]", 
    RowBox[{"ImagePad", "[", 
     RowBox[{"i", ",", "20", ",", "0"}], "]"}]}]}], "]"}]], "Input",Expression\
UUID->"4000a1a3-a61b-4d6f-9e6c-1ef1a9a732ff"]
},
WindowSize->{808, 911},
WindowMargins->{{766, Automatic}, {168, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1205, 28, 115, "Input",ExpressionUUID->"d7dd49c4-394e-46a4-9507-bf690e1940f3"],
Cell[1766, 50, 3486, 95, 199, "Input",ExpressionUUID->"aac2e6b1-8412-404d-9d01-42ea38933c5b"],
Cell[5255, 147, 4305, 115, 283, "Input",ExpressionUUID->"ae671d40-27ef-4e69-8974-c0f22a5d4487"],
Cell[CellGroupData[{
Cell[9585, 266, 378, 9, 30, "Input",ExpressionUUID->"3e20b37b-49fb-46ed-a09d-befc876e9daa"],
Cell[9966, 277, 9188, 155, 728, "Output",ExpressionUUID->"69317870-0552-4060-837f-ea4f446fb74d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19191, 437, 483, 14, 30, "Input",ExpressionUUID->"6db89a97-708f-442e-9e24-7ec6fc9c664d"],
Cell[19677, 453, 193, 3, 34, "Output",ExpressionUUID->"1f645ad2-b27b-4b92-bbd9-e5f38031d34a"]
}, Open  ]],
Cell[19885, 459, 303, 5, 30, "Input",ExpressionUUID->"959aab39-20b5-4b00-98c4-f187117dd464"],
Cell[20191, 466, 1009, 20, 199, "Input",ExpressionUUID->"4aaed154-dfaf-4bdb-9768-c1ee99c1ba6f"],
Cell[21203, 488, 239, 6, 30, "Input",ExpressionUUID->"4a0b0d08-a6fb-4a41-b105-651a95e3ba8c"],
Cell[21445, 496, 569, 15, 52, "Input",ExpressionUUID->"4000a1a3-a61b-4d6f-9e6c-1ef1a9a732ff"]
}
]
*)

