(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   1211289,      21054]
NotebookOptionsPosition[   1210753,      21036]
NotebookOutlinePosition[   1211109,      21052]
CellTagsIndexPosition[   1211066,      21049]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"CloudDeploy", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"gameoflife", "[", "]"}], ",", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.749377981748507*^9, 3.7493779944779367`*^9}},
 CellLabel->"In[57]:=",ExpressionUUID->"78a4fbe8-8134-4f46-809a-a6225ff5f877"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/867d70d2-1e36-4f0f-b553-\
e1430c34780c\"",
     "https://www.wolframcloud.com/objects/867d70d2-1e36-4f0f-b553-\
e1430c34780c"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/867d70d2-1e36-4f0f-b553-e1430c34780c"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{3.7493779989662657`*^9, 3.749378451049142*^9, 
  3.749378500220532*^9, 3.749378572579381*^9, 3.749379279139494*^9, 
  3.7493793699523783`*^9, 3.749379550138056*^9, 3.749379589838893*^9, 
  3.749379700960952*^9, 3.749379761812077*^9, 3.749379825955052*^9, 
  3.749379856240891*^9, 3.7493799128450727`*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"443a7999-cf0f-4069-84a0-2397b3661fd3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"gameoflife", "[", "]"}], ":=", 
  RowBox[{"DynamicModule", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", 
    RowBox[{"Manipulate", "[", 
     RowBox[{
      RowBox[{"ArrayPlot", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{"av", ",", "Mean", ",", "Last"}], "]"}], "@", 
         RowBox[{"CellularAutomaton", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"224", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"2", ",", "2", ",", "2"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"2", ",", "2", ",", "2"}], "}"}]}], "}"}]}], "}"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"conf", ",", "0"}], "}"}], ",", 
           RowBox[{"t", "+", "1"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"t", "+", "1"}]}], "}"}], ",", "Automatic"}], "}"}]}], 
          "]"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"370", ",", "370"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"conf", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",",
               "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
               "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
               "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",",
               "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
             "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", 
              ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",",
               "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
          ",", "\"\<configuration\>\""}], "}"}], ",", 
        RowBox[{"Evaluate", "[", 
         RowBox[{"ccnconnorryan`LifeConfigurations", "[", 
          RowBox[{"[", 
           RowBox[{"1", ";;", "50"}], "]"}], "]"}], "]"}], ",", "PopupMenu"}],
        "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"t", ",", "0", ",", "\"\<steps\>\""}], "}"}], ",", "0", ",", 
        "200", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"av", ",", "False", ",", "\"\<average all steps\>\""}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"True", ",", "False"}], "}"}]}], "}"}], ",", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"SaveDefinitions", "\[Rule]", "True"}], ","}], "*)"}], 
      RowBox[{"Initialization", "\[RuleDelayed]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ccnconnorryan`LifeConfigurations", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<101\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<4 boats\>\""}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Achim's p144\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<Achim's p4\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<acorn\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<A for All\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<agar\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<agar virus eliminated\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<aircraft carrier\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<airforce\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<AK47 reaction\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<ants\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<aVerage\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<B\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<baker's dozen\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<bakery\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<barberpole\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<barge\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<beacon\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<beacon maker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<beehive\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<beehive and dock\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<beehive with tail\>\""}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<B-heptomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<B-heptomino shuttle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<biblock\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<big glider\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<big S\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<biloaf\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<bipole\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<bipond\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<blinker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<blinker ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<block\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<block and dock\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<block and glider\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<blocker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<block on table\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<boat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<boat maker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<boat on boat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<boat-ship-tie\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<bookends\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<boss\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<brain\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<buckaroo\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<bunnies\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<burloaf\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<Canada goose\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<canoe\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<carnival shuttle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<caterer\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<cauldron\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<cavity\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<centinal\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<century\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<champagne Glass\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<chemist\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<C-heptomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Cheshire cat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<cis-beacon on anvil\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<cis-beacon on table\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<cis-boat with tail\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<cis-mirrored R-bee\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<clean fuse\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<clock\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<cloverleaf\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Coe ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<conduit\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<confused eaters\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<converter\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<cow\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<cross\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<crown\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<dart\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<dead spark coil\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<diamond\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<dirty fuse\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<double-barrelled\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<double block reaction\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<double wing\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<dragon\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<eater1\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<eater2\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<eater3\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<eater4\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<ecologist\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<edge-repair spaceship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<edge shooter\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<elevener\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Eureka\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<factory\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<Fast Forward Force Field\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<figure 8\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<filter\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<fleet-4 ships\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<flotilla\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<fountain\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<fourteener\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<fumarole\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Garden of Eden\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Garden of Eden (Flammenkamp)\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<glider\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<glider-block cycle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<gliderless\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<glider pusher\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<gliders by the dozen\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<glider synthesis\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Gosper glider gun\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<original Gosper gun\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<gourmet\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<gray counter\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<great on-off\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<hammer\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<handshake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<harvester\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<hat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<heavyweight emulator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<heavyweight spaceship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<heavyweight volcano\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<Heptominoes\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Herschel\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<Hertz oscillator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<HighLife\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<hivenudger\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Hockey Game\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<honeycomb\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<honeyfarm\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<hook with tail\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<houndstooth agar\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<hustler\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<hustler II\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<induction coil\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<infinite growth\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<integral\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Internal Combustion Engine\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<jam\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<keys\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<kickback reaction\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<killer toads\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Kok's galaxy\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<lake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<light bulb\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<lightspeed wire\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<lightweight emulator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<lightweight spaceship\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<loaf\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<loaf siamese barge\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<long boat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long canoe\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<long integral\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long long barge\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long long boat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<long long canoe\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long long ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long long snake\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long shillelagh\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<long ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<long snake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<loop\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<lumps of muck\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<LWSS\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<Maltese Cross\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<mango\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<mazing\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<metamorphosis\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<metamorphosis II\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<Methuselahs\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<middleweight emulator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", 
              "\"\<middleweight spaceship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<middleweight volcano\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<mini pressure cooker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<MIT oscillator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<mold\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<monogram, JHC\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<multum in parvo\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<muttering moat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<MWSS out of the blue\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<negentropy\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<new gun\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Noah's ark\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<octagon II\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<onion rings\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], 
               "}"}], "\[Rule]", "\"\<O-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Orion\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<p\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<p2misc\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<p3misc\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<p54 shuttle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<paperclip\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<pedestle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<penny lane\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<pentadecathlon\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<phoenix\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<pi\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Pinwheel\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<pipsquirter\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<pi ship\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<pond\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<P-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<pre-pulsar\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<pressure cooker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<pseudo-barberpole\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<puffer\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<Puffer p128\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Puffer p140\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<puffer train\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<puff suppressor\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<pulsar\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<pulsar quadrant\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<pulse-divider\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<pure glider generator\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<pyrotechneczum\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<python\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<Q\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Q-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", 
              "\"\<barberpole intersection\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<quapole\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<queen bee\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<queen bee shuttle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<R\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<R2D2\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<rabbits\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<reflector\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<rephaser\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<reverse fuse\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<revolver\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<ring of fire\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<roteightor\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<r-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<rumbling river\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<sailboat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Schick engine\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<scorpion\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<scrubber\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<shillelagh\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<ship on ship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<sidecar\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<sidewalk\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<siesta\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<skewed quad\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<smiley\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<snacker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<snail\>\""}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<snake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<snake bridge snake\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<snake pit\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<snake siamese snake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<sombreros\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<space rake\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<spark coil\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<Spark Fuse\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<sparky\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<S-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<spider\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<spiral\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<squaredance\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<stairstep hexomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], 
               "}"}], "\[Rule]", "\"\<star\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Summers' Spaceship\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<superfountain\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<superstring\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<swan\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<switch engine\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<T\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<table on table\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<teardrop\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<thunderbird\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<time bomb\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", 
              "\"\<titanic toroidal traveler\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<toad\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<toad-flipper\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<toad-sucker\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<toaster\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<total aperiodic\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<T-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<traffic circle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<traffic lights\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<trans-beacon on table\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "1"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<trans-boat with tail\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<trans-loaf with tail\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<transparent block reaction\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<trice tongs\>\""}], 
             ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
                 "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<tripole\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<tub\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<tubber\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1", ",", "0", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}],
                 ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], 
                 "}"}]}], "}"}], "\[Rule]", "\"\<tub with tail\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1"}], "}"}]}], "}"}], "\[Rule]", "\"\<tumbler\>\""}], ",", 
             
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<turtle\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<twinhat\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<two eaters\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<two glider fuse\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<unix\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<U-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<V-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
              "\"\<washer woman\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<wasp\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<weekender\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "1", ",", 
                  "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "1", ",", "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "0", ",", "0", ",", "1", ",", "0", ",", "1", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "1", ",", "1", ",", "1", ",", "0", ",", "1", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "1", ",", "1", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
                  "1", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0", ",", 
                  "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
                  "0"}], "}"}]}], "}"}], "\[Rule]", "\"\<wickstretcher\>\""}],
              ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<W-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<X-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Y-pentomino\>\""}], ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "1", ",", "1"}], "}"}]}], "}"}], 
              "\[Rule]", "\"\<Z-pentomino\>\""}]}], "}"}]}], ";"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ")"}]}]}], 
     "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.749376969946414*^9, 3.749377063589224*^9}, {
   3.749377384787939*^9, 3.749377385811674*^9}, 3.749377453979032*^9, {
   3.74937749051628*^9, 3.7493775129767313`*^9}, 3.749377562338756*^9, {
   3.749377596636891*^9, 3.749377640892864*^9}, 3.749377905175788*^9, {
   3.749378131626205*^9, 3.749378141532546*^9}, {3.749378246682613*^9, 
   3.74937825339039*^9}, {3.749378431974478*^9, 3.7493784357459106`*^9}, 
   3.749378556010363*^9, {3.7493792673509207`*^9, 3.749379269791771*^9}, {
   3.7493793502426558`*^9, 3.7493793587691708`*^9}, {3.7493795423748627`*^9, 
   3.749379545984206*^9}, {3.749379583490519*^9, 3.74937958396286*^9}, {
   3.749379677710183*^9, 3.7493796947322683`*^9}, {3.749379754033194*^9, 
   3.749379754840455*^9}, {3.749379788810584*^9, 3.749379821003113*^9}, {
   3.749379851448299*^9, 3.749379851677373*^9}, {3.7493798941083603`*^9, 
   3.7493799022634087`*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"54693e61-63e3-4de5-a46a-ef12afe6c302"]
},
WindowSize->{808, 911},
WindowMargins->{{Automatic, 623}, {212, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 416, 7, 115, "Input",ExpressionUUID->"78a4fbe8-8134-4f46-809a-a6225ff5f877"],
Cell[999, 31, 819, 17, 37, "Output",ExpressionUUID->"443a7999-cf0f-4069-84a0-2397b3661fd3"]
}, Open  ]],
Cell[1833, 51, 1208916, 20983, 70906, "Input",ExpressionUUID->"54693e61-63e3-4de5-a46a-ef12afe6c302"]
}
]
*)

