(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     35498,        831]
NotebookOptionsPosition[     34549,        808]
NotebookOutlinePosition[     34934,        825]
CellTagsIndexPosition[     34891,        822]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"00e7a5a8-29f9-4bbe-a165-7936ba52582f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "stack", " ", "is", " ", "just", " ", "an", " ", "ordered", " ", "list"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"initSTACK", "[", "]"}], ":=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Xi]", "=", 
        RowBox[{"{", "}"}]}], ";", 
       RowBox[{"ctr0", "=", "0"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"pop", "[", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\[Xi]", "===", 
           RowBox[{"{", "}"}]}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"<|", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\"\<item\>\"", "\[Rule]", "\"\<\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
               "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
               " ", "list"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"\"\<stack\>\"", "\[Rule]", 
              RowBox[{"(", "\[Xi]", ")"}]}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "|>"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ctr0", "--"}], ";", "\[IndentingNewLine]", 
           RowBox[{"res", "=", 
            RowBox[{"<|", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\"\<item\>\"", "\[Rule]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Last", "@", "\[Xi]"}], ")"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Drop", "[", 
                 RowBox[{"s", ",", 
                  RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
                "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
                " ", "list"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"\"\<stack\>\"", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{"\[Xi]", "=", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"\[Xi]", ",", 
                   RowBox[{"-", "1"}]}], "]"}]}], ")"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "res"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"push", "[", "item_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"item", "=!=", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ctr0", "++"}], ";", "\[IndentingNewLine]", 
           RowBox[{"res", "=", 
            RowBox[{"<|", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\"\<item\>\"", "\[Rule]", "item"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Drop", "[", 
                 RowBox[{"s", ",", 
                  RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
                "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
                " ", "list"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"\"\<stack\>\"", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"\[Xi]", ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"item", ",", 
                    RowBox[{"Highlighted", "@", "ctr0"}]}], "]"}], ",", 
                    "item"}], "}"}]}], "]"}], ")"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"res", "=", "Nothing"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", "res"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"plotSTACK", "[", "]"}], ":=", 
     RowBox[{"Column", "[", 
      RowBox[{
       RowBox[{"Reverse", "@", 
        RowBox[{"(", 
         RowBox[{"\[Xi]", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ",", 
       RowBox[{"ItemSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.751055271073818*^9, 3.7510553048905993`*^9}, {
  3.751056067610993*^9, 3.751056074381667*^9}, {3.751056502374153*^9, 
  3.751056546699079*^9}, {3.75105875874233*^9, 3.751058835935111*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"3470d8db-447f-410e-8152-3b28506695eb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"vv", "=", 
     RowBox[{"Release", "@", 
      RowBox[{"Map", "[", 
       RowBox[{
        RowBox[{"Hold", "[", 
         RowBox[{"RandomChoice", "@", 
          RowBox[{"{", 
           RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], ",", 
        RowBox[{"RandomSample", "[", 
         RowBox[{
          RowBox[{"Complement", "[", 
           RowBox[{
            RowBox[{"CharacterRange", "[", 
             RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\""}], 
             "}"}]}], "]"}], ",", "7"}], "]"}]}], "]"}]}]}], 
    StyleBox[";",
     FontWeight->"Plain"]}], "\[IndentingNewLine]", 
   StyleBox["\[IndentingNewLine]",
    FontWeight->"Plain"], 
   RowBox[{
    RowBox[{"ops", "=", 
     StyleBox[
      RowBox[{"RandomSample", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "\"\<+\>\"", ",", "\"\<-\>\"", ",", "\"\</\>\"", ",", "\"\<^\>\"", 
          ",", "\"\<*\>\""}], "}"}], ",", "5"}], "]"}],
      FontWeight->"Plain"]}], 
    StyleBox[";",
     FontWeight->"Plain"]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression", "=", 
     RowBox[{"RandomChoice", "@", 
      RowBox[{"{", 
       RowBox[{
       "\"\<(((A1ops1A2)ops2(A3ops3A4))ops1(A5ops4A6))ops5A7\>\"", ",", 
        "\"\<(A1ops1A2)ops2A3\>\"", ",", "\"\<(A1ops1A2)ops2(A3ops3A4)\>\"", 
        ",", "\"\<(A1ops1A2)ops2A3)ops3A4\>\""}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression", "=", 
     RowBox[{"StringPartition", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{"expression", ",", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\"\<ops\>\"", "<>", 
                RowBox[{"ToString", "[", "i", "]"}]}], ")"}], "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"ops", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ")"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "@", "ops"}]}], "}"}]}], "]"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"\"\<A\>\"", "<>", 
                RowBox[{"ToString", "[", "i", "]"}]}], ")"}], "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"vv", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ")"}]}], ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "1", ",", 
               RowBox[{"Length", "@", "vv"}]}], "}"}]}], "]"}]}], "]"}]}], 
        "]"}], ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"xpr", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Reverse", "@", "expression"}], ")"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
        RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<(\>\""}]}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"precedence", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<(\>\"", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<)\>\"", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<!\>\"", "\[Rule]", "2"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<^\>\"", "\[Rule]", "3"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<Exp\>\"", "\[Rule]", "3"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<*\>\"", "\[Rule]", "4"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<Times\>\"", "\[Rule]", "4"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\"\</\>\"", "\[Rule]", "4"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<Divide\>\"", "\[Rule]", "4"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<+\>\"", "\[Rule]", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<Plus\>\"", "\[Rule]", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<-\>\"", "\[Rule]", "5"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<Subtract\>\"", "\[Rule]", "5"}]}], "\[IndentingNewLine]", 
      "|>"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rightassociative", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<+\>\"", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\"\<-\>\"", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\"\<*\>\"", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\"\</\>\"", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"\"\<^\>\"", "\[Rule]", "True"}]}], "\[IndentingNewLine]", 
      "|>"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"initSTACK", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"output", "=", "\"\<\>\""}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"push", "[", "\"\<(\>\"", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"xpr", "=", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"xpr", ",", "\"\<)\>\""}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"history", "=", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"comment", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"xpr", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"ops", ",", "x"}], "]"}], "\[Equal]", "False"}], "&&", 
              RowBox[{"x", "\[NotEqual]", "\"\<)\>\""}], "&&", 
              RowBox[{"x", "\[NotEqual]", "\"\<(\>\""}]}], ",", " ", 
             RowBox[{
              RowBox[{"output", "=", 
               RowBox[{"StringJoin", "[", 
                RowBox[{"output", ",", "x"}], "]"}]}], ";", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"comment", ",", "\"\<output\>\""}], "]"}]}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"x", "\[Equal]", "\"\<(\>\""}], ",", 
             RowBox[{
              RowBox[{"push", "[", "x", "]"}], ";", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"comment", ",", "\"\<\[DoubleStruckCapitalO]\>\""}], 
               "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"x", "\[Equal]", "\"\<)\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"y", "=", 
               RowBox[{
                RowBox[{"pop", "[", "]"}], "[", "\"\<item\>\"", "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"y", "=!=", "\"\<(\>\""}], ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{
                 "comment", ",", 
                  "\"\<\[DoubleStruckCapitalX] until '('\>\""}], "]"}], ",", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"comment", ",", "\"\<\[DoubleStruckCapitalX]\>\""}], 
                 "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"While", "[", 
               RowBox[{
                RowBox[{"y", "=!=", "\"\<(\>\""}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"output", "=", 
                  RowBox[{"StringJoin", "[", 
                   RowBox[{"output", ",", "y"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"comment", ",", "\"\<output\>\""}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"y", "=", 
                  RowBox[{
                   RowBox[{"pop", "[", "]"}], "[", "\"\<item\>\"", "]"}]}], 
                 ";"}]}], "\[IndentingNewLine]", "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"MemberQ", "[", 
               RowBox[{"ops", ",", "x"}], "]"}], "\[Equal]", "True"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"While", "[", 
               RowBox[{
                RowBox[{"\[Xi]", "=!=", 
                 RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"y", "=", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Last", "@", "\[Xi]"}], ")"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], ";", " ", 
                 RowBox[{"(*", 
                  RowBox[{
                  "get", " ", "top", " ", "of", " ", "the", " ", "stack"}], 
                  "*)"}], "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"comment", ",", "\"\<Get stack top\>\""}], "]"}], 
                 ";", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{"y", "\[Equal]", "\"\<(\>\""}], ",", 
                   RowBox[{"Break", "[", "]"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"precedence", "[", "y", "]"}], "<", 
                    RowBox[{"precedence", "[", "x", "]"}]}], ",", 
                   RowBox[{"Break", "[", "]"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"rightassociative", "[", "y", "]"}], "\[Equal]", 
                    "True"}], "&&", 
                    RowBox[{
                    RowBox[{"precedence", "[", "y", "]"}], "==", 
                    RowBox[{"precedence", "[", "x", "]"}]}]}], ",", " ", 
                   RowBox[{"Break", "[", "]"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"y", "=", 
                  RowBox[{
                   RowBox[{"pop", "[", "]"}], "[", "\"\<item\>\"", "]"}]}], 
                 ";", "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"comment", ",", "\"\<\[DoubleStruckCapitalX]\>\""}],
                   "]"}], ";", "\[IndentingNewLine]", 
                 RowBox[{"output", "=", 
                  RowBox[{"StringJoin", "[", 
                   RowBox[{"output", ",", "y"}], "]"}]}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"comment", ",", "\"\<output\>\""}], "]"}], ";"}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"comment", ",", "\"\<\[DoubleStruckCapitalO]\>\""}], 
               "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"push", "[", "x", "]"}], ";"}]}], "\[IndentingNewLine]",
             "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "output"}], ",", "\[IndentingNewLine]", 
          RowBox[{"StringJoin", "@", 
           RowBox[{"Reverse", "@", 
            RowBox[{"(", 
             RowBox[{"\[Xi]", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "2"}], "]"}], "]"}], ")"}]}]}], ",", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Row", "@", 
             RowBox[{"Riffle", "[", 
              RowBox[{"comment", ",", "\"\<, \>\""}], "]"}]}], ",", "Bold", 
            ",", " ", "Orange"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "xpr"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"history", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"history", ",", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"StringReverse", "@", 
           RowBox[{"StringJoin", "[", 
            RowBox[{"output", ",", 
             RowBox[{"StringJoin", "[", 
              RowBox[{
               RowBox[{"Reverse", "[", "\[Xi]", "]"}], "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}]}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"\[Xi]", "=!=", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<Flush\>\"", ",", "Bold", ",", "Red"}], "]"}], ",", 
            "\"\<\>\""}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"Row", "@", 
           RowBox[{"{", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"\[Xi]", "=!=", 
               RowBox[{"{", "}"}]}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<Flush and reverse\>\"", ",", "Bold", ",", " ", "Orange"}],
                "]"}], ",", 
              RowBox[{"Style", "[", 
               RowBox[{"\"\<Reverse\>\"", ",", "Bold", ",", " ", "Orange"}], 
               "]"}]}], "]"}], "}"}]}]}], "\[IndentingNewLine]", "}"}], 
        "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"StringJoin", "@", "expression"}], "\[IndentingNewLine]", 
   RowBox[{"StringJoin", "@", "xpr"}], "\[IndentingNewLine]", 
   RowBox[{"output", "=", 
    RowBox[{"StringReverse", "@", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"output", ",", 
       RowBox[{"StringJoin", "[", 
        RowBox[{
         RowBox[{"Reverse", "[", "\[Xi]", "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}], "]"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", 
   RowBox[{"Grid", "[", 
    RowBox[{
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"#", ",", "Bold", ",", " ", "Black"}], "]"}], "&"}], "/@", 
         
         RowBox[{"{", 
          RowBox[{
          "\"\<Output\>\"", ",", "\"\<Stack\>\"", ",", "\"\<Comment\>\""}], 
          "}"}]}], "}"}], ",", "history"}], "]"}], ",", 
     RowBox[{"Alignment", "\[Rule]", "Left"}], ",", 
     RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.751053942690691*^9, {3.7510540098957376`*^9, 3.7510541662792673`*^9}, {
   3.751054208795226*^9, 3.751054209389683*^9}, {3.751054459261908*^9, 
   3.751054642320384*^9}, {3.751054676724813*^9, 3.7510546842608843`*^9}, {
   3.751054748218816*^9, 3.751054807169413*^9}, {3.751054910638939*^9, 
   3.7510549376976833`*^9}, {3.751054979141725*^9, 3.7510549975116453`*^9}, {
   3.7510550372707663`*^9, 3.751055056283284*^9}, {3.751055237198938*^9, 
   3.75105525379582*^9}, {3.751055375643993*^9, 3.751055387377309*^9}, {
   3.7510556436355124`*^9, 3.751055680938838*^9}, {3.751055881817321*^9, 
   3.7510559248322687`*^9}, {3.7510560530984993`*^9, 3.751056054322493*^9}, {
   3.751056126201754*^9, 3.751056126594111*^9}, {3.751056205053844*^9, 
   3.751056290194368*^9}, {3.751056322606483*^9, 3.751056442053919*^9}, {
   3.751058493683135*^9, 3.751058495480873*^9}, {3.7510586351082373`*^9, 
   3.751058670669814*^9}, {3.751058967237832*^9, 3.751059106750854*^9}, {
   3.751059143785843*^9, 3.751059206877124*^9}, {3.751059369692832*^9, 
   3.751059501667048*^9}, {3.7510595427531776`*^9, 3.751059561180175*^9}, {
   3.751059593000046*^9, 3.751059639155538*^9}, {3.751059708853098*^9, 
   3.7510597888729963`*^9}, {3.751059900682273*^9, 3.75105998183984*^9}, {
   3.751060013415866*^9, 3.751060040236676*^9}, {3.751060081266995*^9, 
   3.751060081479301*^9}, {3.7510603297616873`*^9, 3.751060330457273*^9}, {
   3.751060721066866*^9, 3.751060728343233*^9}, 3.751060824725616*^9, {
   3.7510609881484957`*^9, 3.7510609896400146`*^9}, {3.7510610400420847`*^9, 
   3.751061092922236*^9}, {3.751061232060214*^9, 3.75106123889989*^9}, {
   3.751061351179336*^9, 3.7510613858836927`*^9}, {3.751061432585369*^9, 
   3.751061496101371*^9}, 3.7510615614221563`*^9, {3.751062194111349*^9, 
   3.7510622000042477`*^9}, {3.7510622406867247`*^9, 3.7510622431838093`*^9}, 
   3.751062334169245*^9, {3.751062408410327*^9, 3.7510624339410353`*^9}, 
   3.7510627866924667`*^9, {3.751062887645055*^9, 3.751062911286839*^9}, {
   3.7510629855510063`*^9, 3.751063109269606*^9}, {3.75106321032063*^9, 
   3.751063217227046*^9}, {3.751063280272201*^9, 3.751063287595666*^9}, {
   3.751063322835842*^9, 3.751063330919629*^9}, 3.751063365740656*^9, {
   3.751063422138204*^9, 3.751063436638372*^9}, {3.751063473507769*^9, 
   3.751063488467437*^9}, {3.751063622864284*^9, 3.751063684052099*^9}, {
   3.751063723981229*^9, 3.751063766820025*^9}, {3.751063846349869*^9, 
   3.751063846786064*^9}, {3.7510641517963047`*^9, 3.7510641592603703`*^9}, {
   3.751064196017682*^9, 3.7510641965322657`*^9}, {3.751064559015945*^9, 
   3.751064589919022*^9}, {3.751064672328615*^9, 3.751064673821906*^9}, {
   3.7510647619370613`*^9, 3.75106476623201*^9}, {3.751066117967341*^9, 
   3.751066157667506*^9}, {3.751066202243145*^9, 3.751066282049952*^9}, {
   3.751066496729856*^9, 3.7510665386228733`*^9}, {3.751066571226705*^9, 
   3.75106659273925*^9}, {3.751066781516425*^9, 3.751066810360051*^9}, {
   3.7510668565132523`*^9, 3.7510669709109173`*^9}, 3.751067054332985*^9, {
   3.7510671837111473`*^9, 3.7510672934871407`*^9}, {3.751067330099156*^9, 
   3.7510673896458387`*^9}, 3.751067441367282*^9, {3.751067507018174*^9, 
   3.751067573259246*^9}, {3.751067840903142*^9, 3.7510678507677593`*^9}, {
   3.75106795523763*^9, 3.751067998213172*^9}, {3.751068232388115*^9, 
   3.751068241104638*^9}, {3.751068453545519*^9, 3.7510684748615723`*^9}, {
   3.751068999011386*^9, 3.751069040654612*^9}, {3.751069856289982*^9, 
   3.751069900045929*^9}, {3.7510699734209623`*^9, 3.751070001901779*^9}, {
   3.751070080367765*^9, 3.7510701332522697`*^9}, {3.75107019262182*^9, 
   3.751070198008995*^9}, {3.7510703286028852`*^9, 3.751070334783124*^9}, {
   3.751070373029191*^9, 3.751070515028143*^9}, {3.751070551923468*^9, 
   3.751070587547844*^9}, {3.7510707342418337`*^9, 3.7510708669799833`*^9}, {
   3.751070907405243*^9, 3.75107092216286*^9}, {3.7510709974632463`*^9, 
   3.751071000092437*^9}, {3.751071117923634*^9, 3.751071126770729*^9}, {
   3.751071224771644*^9, 3.751071234502121*^9}, {3.751071461691367*^9, 
   3.751071466773446*^9}, {3.751071707800701*^9, 3.751071872353056*^9}, {
   3.751074231456266*^9, 3.751074242637518*^9}, {3.751075205081945*^9, 
   3.751075205517939*^9}, {3.751075278636441*^9, 3.7510752803774853`*^9}, 
   3.751075322578369*^9, {3.751075356158441*^9, 3.751075367659856*^9}, {
   3.751075412244728*^9, 3.751075626456127*^9}, {3.7510763094487753`*^9, 
   3.751076608321945*^9}, {3.7510766442863817`*^9, 3.751076678714305*^9}, {
   3.751076781189888*^9, 3.7510768311751337`*^9}, {3.751076893511428*^9, 
   3.7510770451091747`*^9}, 3.7510770810544*^9, {3.751077111722684*^9, 
   3.7510771247618237`*^9}, {3.751077256850725*^9, 3.751077258030265*^9}, {
   3.7510772983372602`*^9, 3.75107729952927*^9}, {3.751077408977502*^9, 
   3.751077438188633*^9}},
 CellLabel->
  "In[992]:=",ExpressionUUID->"fdd7892e-19fa-4f72-ae9d-0a4e2c05600f"],

Cell[BoxData["\<\"(M^N)-t)+G\"\>"], "Output",
 CellChangeTimes->{{3.751077081766082*^9, 3.751077090463283*^9}, {
   3.751077126529503*^9, 3.751077154517375*^9}, {3.75107730013452*^9, 
   3.7510773141333027`*^9}, 3.751077375271357*^9, {3.751077438960548*^9, 
   3.75107746313103*^9}},
 CellLabel->
  "Out[1003]=",ExpressionUUID->"1067e2eb-fc3a-4694-a316-4b118f120dfa"],

Cell[BoxData["\<\"G+(t-(N^M)\"\>"], "Output",
 CellChangeTimes->{{3.751077081766082*^9, 3.751077090463283*^9}, {
   3.751077126529503*^9, 3.751077154517375*^9}, {3.75107730013452*^9, 
   3.7510773141333027`*^9}, 3.751077375271357*^9, {3.751077438960548*^9, 
   3.751077463142625*^9}},
 CellLabel->
  "Out[1004]=",ExpressionUUID->"e4105423-8740-40ca-816d-fb669bb761f2"],

Cell[BoxData["\<\"+(-^MNtG\"\>"], "Output",
 CellChangeTimes->{{3.751077081766082*^9, 3.751077090463283*^9}, {
   3.751077126529503*^9, 3.751077154517375*^9}, {3.75107730013452*^9, 
   3.7510773141333027`*^9}, 3.751077375271357*^9, {3.751077438960548*^9, 
   3.75107746314889*^9}},
 CellLabel->
  "Out[1005]=",ExpressionUUID->"9a5ce927-bb44-4fbd-a480-87a8dfb1f653"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"Output\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontWeight->Bold,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"Stack\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontWeight->Bold,
      FontColor->GrayLevel[0]], 
     StyleBox["\<\"Comment\"\>",
      StripOnInput->False,
      LineColor->GrayLevel[0],
      FrontFaceColor->GrayLevel[0],
      BackFaceColor->GrayLevel[0],
      GraphicsColor->GrayLevel[0],
      FontWeight->Bold,
      FontColor->GrayLevel[0]]},
    {"\<\"G\"\>", "\<\"\"\>", 
     StyleBox[
      TemplateBox[{"\"output\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"G\"\>", "\<\"+\"\>", 
     StyleBox[
      TemplateBox[{"\"\[DoubleStruckCapitalO]\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"G\"\>", "\<\"(+\"\>", 
     StyleBox[
      TemplateBox[{"\"\[DoubleStruckCapitalO]\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"Gt\"\>", "\<\"(+\"\>", 
     StyleBox[
      TemplateBox[{"\"output\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"Gt\"\>", "\<\"-(+\"\>", 
     StyleBox[
      TemplateBox[{"\"Get stack top\"","\", \"","\"\[DoubleStruckCapitalO]\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"Gt\"\>", "\<\"(-(+\"\>", 
     StyleBox[
      TemplateBox[{"\"\[DoubleStruckCapitalO]\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"GtN\"\>", "\<\"(-(+\"\>", 
     StyleBox[
      TemplateBox[{"\"output\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"GtN\"\>", "\<\"^(-(+\"\>", 
     StyleBox[
      TemplateBox[{"\"Get stack top\"","\", \"","\"\[DoubleStruckCapitalO]\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"GtNM\"\>", "\<\"^(-(+\"\>", 
     StyleBox[
      TemplateBox[{"\"output\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"GtNM^\"\>", "\<\"-(+\"\>", 
     StyleBox[
      TemplateBox[{
       "\"\[DoubleStruckCapitalX] until '('\"","\", \"","\"output\""},
       "RowDefault"],
      StripOnInput->False,
      LineColor->RGBColor[1, 0.5, 0],
      FrontFaceColor->RGBColor[1, 0.5, 0],
      BackFaceColor->RGBColor[1, 0.5, 0],
      GraphicsColor->RGBColor[1, 0.5, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0.5, 0]]},
    {"\<\"+(-^MNtG\"\>", 
     StyleBox["\<\"Flush\"\>",
      StripOnInput->False,
      LineColor->RGBColor[1, 0, 0],
      FrontFaceColor->RGBColor[1, 0, 0],
      BackFaceColor->RGBColor[1, 0, 0],
      GraphicsColor->RGBColor[1, 0, 0],
      FontWeight->Bold,
      FontColor->RGBColor[1, 0, 0]], 
     TemplateBox[{StyleBox["\"Flush and reverse\"", Bold, 
        RGBColor[1, 0.5, 0], StripOnInput -> False]},
      "RowDefault"]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.751077081766082*^9, 3.751077090463283*^9}, {
   3.751077126529503*^9, 3.751077154517375*^9}, {3.75107730013452*^9, 
   3.7510773141333027`*^9}, 3.751077375271357*^9, {3.751077438960548*^9, 
   3.75107746315583*^9}},
 CellLabel->
  "Out[1006]=",ExpressionUUID->"1d0b24d3-aa85-4225-8953-e9aefea04584"]
}, Open  ]]
},
WindowSize->{932, 1156},
WindowMargins->{{Automatic, 808}, {Automatic, 93}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1313, 32, 94, "Input",ExpressionUUID->"00e7a5a8-29f9-4bbe-a165-7936ba52582f"],
Cell[1874, 54, 5645, 133, 997, "Input",ExpressionUUID->"3470d8db-447f-410e-8152-3b28506695eb"],
Cell[CellGroupData[{
Cell[7544, 191, 20265, 427, 2131, "Input",ExpressionUUID->"fdd7892e-19fa-4f72-ae9d-0a4e2c05600f"],
Cell[27812, 620, 367, 6, 34, "Output",ExpressionUUID->"1067e2eb-fc3a-4694-a316-4b118f120dfa"],
Cell[28182, 628, 368, 6, 34, "Output",ExpressionUUID->"e4105423-8740-40ca-816d-fb669bb761f2"],
Cell[28553, 636, 365, 6, 34, "Output",ExpressionUUID->"9a5ce927-bb44-4fbd-a480-87a8dfb1f653"],
Cell[28921, 644, 5612, 161, 249, "Output",ExpressionUUID->"1d0b24d3-aa85-4225-8953-e9aefea04584"]
}, Open  ]]
}
]
*)

