(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    115961,       2292]
NotebookOptionsPosition[    113342,       2239]
NotebookOutlinePosition[    113704,       2255]
CellTagsIndexPosition[    113661,       2252]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", "\"\<var x = 3;\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", "\"\<x\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.7222923682581472`*^9, 3.7222923695146227`*^9}, 
   3.722292632195874*^9, {3.722292701373337*^9, 
   3.722292727093281*^9}},ExpressionUUID->"e93cda9b-bfc5-4f41-9e22-\
0e6e72c19d6f"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.722292702786078*^9, 
  3.722292728292986*^9}},ExpressionUUID->"4ea06b81-7a1d-4694-9bba-\
6c19f4c13a8e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"session", "=", 
  RowBox[{"StartExternalSession", "[", "\"\<NodeJS\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.7222923761109037`*^9, 
  3.722292408283045*^9}},ExpressionUUID->"6aacf631-a604-4a60-9f57-\
679caea6e64e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["ExternalSessionObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4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               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"0ea7fa1c-280c-471d-aaf7-07af064a5411\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"]], 
                    ExternalSessionObject[
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4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               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"0ea7fa1c-280c-471d-aaf7-07af064a5411\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"]], 
                    ExternalSessionObject[
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Process: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"ProcessObject", "[", "41", "]"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Epilog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Prolog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Version: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"8.9.3\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Executable: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"/usr/local/bin/node\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"ReturnType: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Expression\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Socket: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  InterpretationBox[
                   RowBox[{
                    TagBox["SocketObject", "SummaryHead"], "[", 
                    
                    DynamicModuleBox[{
                    Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
                    TemplateBox[{
                    PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"7da2aa74-efa1-4fda-8d82-13a2d9d241f7\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"60694\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"7da2aa74-efa1-4fda-8d82-13a2d9d241f7\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"60694\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourceIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    
                    RowBox[{"IPAddress", "[", "\"::85f1:e036:b7ab:aa\"", 
                    "]"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourcePort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"0\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]}, 
                    Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
                    "SummaryPanel", 
                    DisplayFunction -> (
                    ButtonBox[#, Active -> False, Alignment -> Left, 
                    Appearance -> {
                    "Default" -> 
                    FrontEnd`FileName[{"Typeset", "SummaryBox"}, 
                    "Panel.9.png"]}, FrameMargins -> 7, BaseStyle -> {}, 
                    DefaultBaseStyle -> {"Panel", Background -> None}, 
                    BaselinePosition -> Baseline]& )], 
                    DynamicModuleValues :> {}], "]"}], 
                   SocketObject["7da2aa74-efa1-4fda-8d82-13a2d9d241f7"], 
                   Selectable -> False, Editable -> False, SelectWithContents -> 
                   True], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"SessionTime: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"]], 
                    ExternalSessionObject[
                    "0ea7fa1c-280c-471d-aaf7-07af064a5411"]["SessionTime"], 
                    None], StandardForm]], "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel",
     DisplayFunction->(
      ButtonBox[#, Active -> False, Alignment -> Left, 
       Appearance -> {
        "Default" -> 
         FrontEnd`FileName[{"Typeset", "SummaryBox"}, "Panel.9.png"]}, 
       FrameMargins -> 7, BaseStyle -> {}, 
       DefaultBaseStyle -> {"Panel", Background -> None}, BaselinePosition -> 
       Baseline]& )],
    DynamicModuleValues:>{}], "]"}],
  ExternalSessionObject["0ea7fa1c-280c-471d-aaf7-07af064a5411"],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.722292091002982*^9, 3.722292332676516*^9, {3.7222923766935577`*^9, 
   3.722292402916788*^9}, 3.722292435852639*^9, 3.722292623312697*^9, 
   3.722292676929791*^9, 3.722294698531299*^9, 3.7222951743797693`*^9, 
   3.72229534460408*^9},ExpressionUUID->"68c428db-77b6-4e09-8c56-\
6bc88d62faf5"]
}, Open  ]],

Cell["\<\
This package has installed:
\t\[Bullet]\tNode.js v8.9.3 to /usr/local/bin/node
\t\[Bullet]\tnpm v5.5.1 to /usr/local/bin/npm
Make sure that /usr/local/bin is in your $PATH.
\
\>", "Text",
 CellChangeTimes->{
  3.72229239759732*^9},ExpressionUUID->"6486ea2e-e54e-4b80-a5b0-039078e20139"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RegisterExternalEvaluator", "[", 
  RowBox[{"\"\<NodeJS\>\"", ",", "\"\</usr/local/bin/node\>\""}], 
  "]"}]], "Input",ExpressionUUID->"bfd06e11-3ba2-4f37-8577-6af546fb31fb"],

Cell[BoxData["\<\"3118408d-1164-40a1-ac06-b486a3a8abcf\"\>"], "Output",
 CellChangeTimes->{3.722292354290621*^9, 3.722292437952622*^9, 
  3.722292545055882*^9, 3.722292620327548*^9, 3.722293897346118*^9, 
  3.722294702156458*^9, 
  3.722295181521455*^9},ExpressionUUID->"64f93078-20d1-4841-bfe9-\
4fa9151a2f33"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
   "code", "=", 
    "\"\<var fib = function (number) {\nif (number == 1 || number == 2) {\n\
return 1;\n}\nint fibo1 = 1, fibo2 = 1, fibonacci = 1;\nfor (int i = 3; i <= \
number; i++) {\nfibonacci = fibo1 + fibo2;\nfibo1 = fibo2;\nfibo2 = \
fibonacci;\n}\nreturn fibonacci;\n};\\n\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", " ", 
       "\"\<script1.js\>\""}], "}"}], "]"}], ",", 
    RowBox[{"code", "<>", "\n", "\"\<module.exports = {fib : fib}\>\""}], 
    ",", "\"\<Text\>\""}], "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.722292886928218*^9, 3.722292899241078*^9}, {
   3.722292971851001*^9, 3.722292982526635*^9}, {3.7222931906800613`*^9, 
   3.722293323891683*^9}, {3.722293706793757*^9, 3.722293741601124*^9}, {
   3.722293825843096*^9, 3.722293826068758*^9}, {3.722293918106028*^9, 
   3.722293918522025*^9}, {3.7222941546665277`*^9, 3.722294183317964*^9}, {
   3.722294244981151*^9, 3.722294257603046*^9}, 3.722294475805999*^9, 
   3.722294906968499*^9, 3.722294943295508*^9, {3.722295094483713*^9, 
   3.722295095214353*^9}, {3.7222952088530397`*^9, 3.7222952098315687`*^9}, {
   3.722295625617289*^9, 3.722295627113852*^9}, {3.722295667738359*^9, 
   3.72229568302641*^9}, {3.7222960612701683`*^9, 3.7222960670750217`*^9}, 
   3.722296587228446*^9},ExpressionUUID->"67680003-bac6-4c7a-96b0-\
ddec49e243b7"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
    "code", "=", 
     "\"\<var fib = function fibonacci(num){\n  var a = 1, b = 0, temp;\n\n  \
while (num >= 0){\n    temp = a;\n    a = a + b;\n    b = temp;\n    num--;\n \
 }\n\n  return b;\n};\nmodule.exports = {fib : fib}\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Export", "[", 
     RowBox[{
      RowBox[{"FileNameJoin", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], ",", " ", 
         "\"\<script1.js\>\""}], "}"}], "]"}], ",", "code", ",", 
      "\"\<Text\>\""}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.722297543142239*^9, 3.722297571013091*^9}, {
   3.722297601242198*^9, 3.722297604594677*^9}, {3.722297810035355*^9, 
   3.7222978187088223`*^9}, 3.722297863191844*^9, 3.7222979074731894`*^9, {
   3.722298166710948*^9, 3.722298171627303*^9}, {3.7222982246423683`*^9, 
   3.722298237294663*^9}, {3.722298272171071*^9, 3.7222982950873203`*^9}, {
   3.722298463306118*^9, 
   3.722298484439024*^9}},ExpressionUUID->"ccbc4df9-fb81-4eaf-814a-\
5320018c34e1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilePrint", "[", 
  RowBox[{"FileNameJoin", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<script1.js\>\""}], 
    "}"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{
  3.722293401780489*^9, {3.7222948459554777`*^9, 3.7222948769826803`*^9}, 
   3.722294946333354*^9, {3.722295098780636*^9, 
   3.722295105901762*^9}},ExpressionUUID->"73d02cf4-7bb0-4c6e-9557-\
624c358ca62d"],

Cell["\<\
var fib = function fibonacci(num){
  var a = 1, b = 0, temp;

  while (num >= 0){
    temp = a;
    a = a + b;
    b = temp;
    num--;
  }

  return b;
};
module.exports = {fib : fib}\
\>", "Print",
 CellChangeTimes->{
  3.722298496419278*^9},ExpressionUUID->"6356d568-dcbf-470a-a62c-\
00a9c6b525ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"session", "=", 
  RowBox[{
  "StartExternalSession", "[", "\"\<NodeJS\>\"", 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", 
   RowBox[{"File", "[", 
    RowBox[{"FileNameJoin", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", " ", 
       "\"\<script1.js\>\""}], "}"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.722292920639902*^9, 3.72229292107757*^9}, {
  3.722293421165736*^9, 3.722293441571328*^9}, {3.722295111065987*^9, 
  3.722295111841859*^9}},ExpressionUUID->"a989d325-abca-4ff9-8218-\
d33fa5f6ce53"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["ExternalSessionObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4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               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"]], 
                    ExternalSessionObject[
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4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               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"]], 
                    ExternalSessionObject[
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Process: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"ProcessObject", "[", "71", "]"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Epilog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Prolog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Version: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"8.9.3\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Executable: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"/usr/local/bin/node\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"ReturnType: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Expression\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Socket: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  InterpretationBox[
                   RowBox[{
                    TagBox["SocketObject", "SummaryHead"], "[", 
                    
                    DynamicModuleBox[{
                    Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
                    TemplateBox[{
                    PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"11591c26-0e55-4f55-8773-67c70348dd82\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"61775\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"11591c26-0e55-4f55-8773-67c70348dd82\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"61775\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourceIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    
                    RowBox[{"IPAddress", "[", "\"::85f1:e036:b7ab:aa\"", 
                    "]"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourcePort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"0\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]}, 
                    Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
                    "SummaryPanel", 
                    DisplayFunction -> (
                    ButtonBox[#, Active -> False, Alignment -> Left, 
                    Appearance -> {
                    "Default" -> 
                    FrontEnd`FileName[{"Typeset", "SummaryBox"}, 
                    "Panel.9.png"]}, FrameMargins -> 7, BaseStyle -> {}, 
                    DefaultBaseStyle -> {"Panel", Background -> None}, 
                    BaselinePosition -> Baseline]& )], 
                    DynamicModuleValues :> {}], "]"}], 
                   SocketObject["11591c26-0e55-4f55-8773-67c70348dd82"], 
                   Selectable -> False, Editable -> False, SelectWithContents -> 
                   True], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"SessionTime: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"]], 
                    ExternalSessionObject[
                    "6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"]["SessionTime"], 
                    None], StandardForm]], "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel",
     DisplayFunction->(
      ButtonBox[#, Active -> False, Alignment -> Left, 
       Appearance -> {
        "Default" -> 
         FrontEnd`FileName[{"Typeset", "SummaryBox"}, "Panel.9.png"]}, 
       FrameMargins -> 7, BaseStyle -> {}, 
       DefaultBaseStyle -> {"Panel", Background -> None}, BaselinePosition -> 
       Baseline]& )],
    DynamicModuleValues:>{}], "]"}],
  ExternalSessionObject["6b166cd5-830b-4e42-b8b4-0a2afdc1eb0b"],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.722292921478457*^9, 3.722292985423801*^9, {3.7222934313596497`*^9, 
   3.722293442465357*^9}, 3.722293571304214*^9, 3.722293748381534*^9, 
   3.722293835971793*^9, 3.722293901562035*^9, 3.722293937604497*^9, 
   3.722294192485528*^9, 3.722294275125457*^9, 3.7222944847917137`*^9, {
   3.722294884686256*^9, 3.7222949121461973`*^9}, 3.72229495115912*^9, 
   3.722295112524603*^9, 3.722295215723112*^9, 3.72229534933547*^9, 
   3.722295634588698*^9, 3.7222956915887203`*^9, 3.722296084479694*^9, 
   3.722296595092142*^9, 3.7222975835189867`*^9, 3.7222976178000393`*^9, {
   3.7222978454517803`*^9, 3.722297874661656*^9}, 3.7222979108392773`*^9, 
   3.7222981858892517`*^9, {3.72229825085058*^9, 3.722298307289987*^9}, 
   3.7222984989281178`*^9},ExpressionUUID->"c6f65b09-e232-4658-a904-\
6f00f54f0b9b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", "\"\<script1.fib(10)\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"DeleteObject", "[", "session", "]"}], "*)"}]}]}], "Input",
 CellChangeTimes->{{3.722293526756277*^9, 3.7222935311882677`*^9}, {
  3.722294690882596*^9, 3.722294691244076*^9}, {3.72229536595117*^9, 
  3.722295368616644*^9}, {3.722297937094325*^9, 3.722297937386683*^9}, {
  3.722298192834565*^9, 3.722298193159865*^9}, {3.7222983127170057`*^9, 
  3.722298316563251*^9}},ExpressionUUID->"195cfd6f-e876-4aa3-b8ae-\
610303a60954"],

Cell[BoxData["89"], "Output",
 CellChangeTimes->{
  3.7222935314831333`*^9, 3.722293753708242*^9, 3.722294691917499*^9, 
   3.722295369167272*^9, {3.722297926737072*^9, 3.722297937651389*^9}, {
   3.722298189288374*^9, 3.722298193905476*^9}, {3.722298254724666*^9, 
   3.72229831698699*^9}, 
   3.722298500693264*^9},ExpressionUUID->"b761dc0b-67c1-4b56-9bf7-\
e3d7bd5f8acf"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"script", "=", 
   RowBox[{"FileNameJoin", "[", 
    RowBox[{"{", 
     RowBox[{"$TemporaryDirectory", ",", "\"\<powers.js\>\""}], "}"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
   "script", ",", 
    "\"\<var square = function(x){ return x*x;};\nvar cube = function(x){ \
return x*x*x;};\nmodule.exports = {square : square, cube : cube}\>\"", ",", 
    "\"\<Text\>\""}], "]"}], ";"}]}], "Input",ExpressionUUID->"860c9414-2d74-\
45ac-a27b-da27f81d085b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilePrint", "[", "script", "]"}]], "Input",ExpressionUUID->"93da94e6-eb21-45f5-aa95-62c841daaac1"],

Cell["\<\
var square = function(x){ return x*x;};
var cube = function(x){ return x*x*x;};
module.exports = {square : square, cube : cube}\
\>", "Print",
 CellChangeTimes->{
  3.722294070995439*^9},ExpressionUUID->"e1b52763-08f1-4e77-9fa5-\
829fe5245133"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"session", "=", 
  RowBox[{"StartExternalSession", "[", "\"\<NodeJS\>\"", "]"}]}], "\n", 
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", 
   RowBox[{"File", "[", "script", "]"}]}], "]"}]}], "Input",ExpressionUUID->\
"b8a94c7f-e46f-48c6-8b7a-a81a61de75be"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["ExternalSessionObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4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               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"b1598418-5516-4297-9bfb-9495bfff892c\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "b1598418-5516-4297-9bfb-9495bfff892c"]], 
                    ExternalSessionObject[
                    "b1598418-5516-4297-9bfb-9495bfff892c"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 3.5 CurrentValue["FontCapHeight"]/
                AbsoluteCurrentValue[Magnification]}]], 
            GraphicsBox[
             TagBox[
              RasterBox[CompressedData["
1:eJztXAlYVFeWpqgCEYpip0BAKFAEZC8BRQ0CClGDgqwigii7UAtQbLKJqAi4
BDQqGreoMdEo4pJMur9punsyk0k60z1f0j0zX6cz09/04mTS6W9MujtKUXfO
ebxXXsqqolDRJNb5vmcV7913z7nnv2e5595SslW+oczSwsKizgb+2VDcmFhb
W9yc6Qh/ZMvqKstlpSWrZfWl5aW1i7fy4eZyuErgEliYicfjoUosHB0dU6VS
6adisTiLz+dbso8t4bmlkdfN9IQJ9M1MSycnp9y4uDiCV0RExM/c3NzSqGZm
TJ4SUXhkx8bGaqKiou4tWrSIwHcSEhJy08HBIYZr+gzFfG5IBw8SHR2tBr81
Dp/jMTExaC/jPj4+DWxz/jMU9bkgA3gQvOD7fcQkNDT0V1zzZyjqc0HG8EA7
ATw04Lc+5Jo/Q1GfCzIBD4wjH3HNn6GozwWZ8fh2kRmPbxeZ8fh20XcVD7au
MOPy8FiaaT4Uu5nGg/ckay5sXzzq7xnBhRHa0lK73qK/zwAvms8s/JwJPGg+
FhNrycfBhUf3B/LGzp49290Ar8ciWveOzg6OtkLb2Vo2lk+Oj8WEPiwnOuYh
X04/PGdn57wnhQc7hxm5gQXPzs7Om3omMLWfB6/wtKVfkUgUHRwcPIJ1NpD1
D97e3jUCgcCKG9/j2CKjD96Efmbb2tiszUtV7T3dcaehT/nr2BWLCi3ZMiti
/5g2P2lMLi4uSbDm/ofw8PBPPDw8CvAejPPFJ4CHLp+VwOefoI+v5s+ff9LW
1taXajjlPKPbgC14BgQEvAx9MTUDrOegjGz98yN3d/e11KvT8mG6vmnpqrjM
7qEdHx+/cZD0X9hFes50kp0n2kh587bRwPD5y7l28I5gurGFHpNQKJwfFBR0
EfWOY8K6IY4H7o2Avk7hPcTgUfDQ4bMA6BLHB3TH1CeB35d+fn5NVlZWnP3r
nc/sPeY+zH1rsAE5yHIH+2DrONyc0eB3rv4J47hmb28fTvVjdEsFNMmDOa9t
ExK5QNpyQHnr7A+OkKPD/WT/+V1jfee6NHtPdYy3Djaq2440AS6tJK8q67TY
y13CvWdKbKHjnLW1tQj00AVy32VtQMPqXVs3ZLHQvabEg+Yza9YsR4lE0g3v
fE3N4XFWb2PYJ/KH+fxLmM9Z3NSi++BwxWdY84e2P8c5w+KAfWj0yUmN4xt/
f//9NjY27rSYeuTWzgP3OW6eJarNg2fePTx27odHyJG3etUDb/aMH3x9N+l7
rYsAHmTXUCtpOlinbjpQp+k+2U7aX2n+8+qclFahva2Qg8WAreA9zndbeHp6
FkZFRX1KjUmtZzxqA/eN4aHLpxj4fDYFHwYXbj6DL7vl4OAg1cEWfWcExIjr
2Be2ZfvSh8Oki+PJzrnfg11VgX0JHpKdN/HdxtbGOn3zWvkr1/r+58LoMTJ0
4wA5PrJfjbYxeHkf0cWj7XAjaTxQR5oP1qvxe8/ZLtK4X/nvS5KlG6dyW5B/
vADjHaXGZGhuGbumtA/IAxKAz09MmMO681nNzucxiAsDMJ89sL+5c+c2gj7v
69iXvj4M8dC1xQ8gnwhgZZ/wj4CHf7AkrvdM5y8u/vg4OXn7EDl2ff/YiZsH
CV768OgCPDpeaQYbqWeuloEGzY6BhjG833e+m2zvKHvXw0fszy5XuJych+MK
DAw8TflutZExPQoezAU+0AlixBkT+RjSnXY+Y3wQi8W5emKEPn2rqX4NtgN7
/Wbx4sXEy8urgbU/AWfTWeVZPxq80ktO3Dhw7/jIAQ2HhTE8wEeRlpdVYBO1
pPlQPYGYgjYz3n6k8V7/xd0kNSfl4IS/4Am42AW+89iSJUsIyDJmRFZmfk4x
//TiwfGZM2fOVhP5jJugX8aHUTZhCn53ubhnqG/sF/fTwJeqKDyYuLGhZMNo
7T75OPonGgtT8GgAPNBv4XfEBO6PqfbXqpM3JB9h+EzG43WQEXV939jYcUxs
zmPMPxvDoxLeN8SHaPnEMXw0rE8nxmxoCiw0rP6/wtwE/MAc8JXJYWFh73G+
0gAeBGR9CI/siqzRyo4KjAvq0+8MMLFjOnio+pUY38mOwQbS0F87JttdQ1Zl
rTqsB4/z7NjH9MnIPvsdyLgNcpzMyMjIfzM0ninwqGDXZIb5SKM/c3VxzbWy
tPYGH/pa3OKJWKZP5zo+6CE54D3cF7uFOTsdvzCXAFnKoc3X7LsaqQl45FZm
j1Z3bydVnZVM/D5569C08KjrVTCfzYdUZPvOSgaPFP14XDCAB8r51bx58zAX
dOXGA2sBW4ihzfDsC93xPAIe3Pt3ff18O7C90NmO7yf1ZXIoR5FjfFh42Puo
W4oP4ztZmf+gz34wP0c5IC6HsEJYWzyonzD6RazYnF2tB496XTzyqnNGlftk
pKy1RI1x+hRlI6bgoeyRkXrABHweKdtROibfIzNkHw/hwckFet9t8UCxfDrv
h9ywRI9+p4UHfkfesLa8yugoMSi9bKj4M/nlKpLVmT4s8rQXioSiEPa9cc6n
4d8LFy58G+Z+oCF/hu1gjR5OrxVZwrHzQcar08FjkyxvtK5fTqp3VarhIoev
7COvQp6FmJiCR22PnMh3V4N9VQCmHB4rp4UHxLUWaII4cPUelNEKxwPP8p8U
HiDDZexz477sn9VcqiDbjhX+tf66nCxKj8qZLbCVgN8aw1jC1jp+BX4zm8vf
pQZyAxaPMM5NUXjwWfu4Nh08Nis3jqoOKom8Z7u6amcF43dOvT0wLTxk3dUE
Y9Cj4gFyteP8ousI+B3vQU5YNAN4fCh7oxLx+Fv9COCxPipztpVtwLLly7D9
n319fZvRX1I6tpwhPOp08Siqzx9tGqwjtb01avD/oNMy0P8esJGXydFrpuPx
mPbBzZNZrJ/COhoesrXw8PDY8AT91RVGRyuC0kqObfm1/M0qkrEj7XVXHxcx
35KPNZVOW1tbP2pOaOs/TwuP4oaC0dajKsY+KtrLMQaQ+j4lszacjn08Ch5c
fgK54Ye4b2ChQ1j/g/G8zcZZo/VEE+P5lxCrFNhutoMNT7LIL06XJ4XDpDU/
vKs3XzMBD2Px4yE8tjVvHm073gD+plxd3lbO+J1SwKT3XBcZgpg+cLlnJvFg
dMWuO9SQex7F+jWsse1hru6G+1+zY9HNNR8r34W14seQ72rr4CinxUTNQqsX
XTKABzNPMJ4bwWMYxqE2gEetLh5lbYU/ajikHAcMGPtgbAR8lmJPzYR9XJme
fUC+Ow54DOrBA9cfGgN6Gudq3/B5B/T1n9TaQ19e89B5OB081Ab4aOvgWK9Y
GLrwlkgkiqLswuCeFLw7aX3J9Y9yAh7c2mNSfoX/BAUFXWbnxz1uLAbwYPCr
aC/+qWKvjJS2lHwDWGgQD8ZGWkrJrhOt5JVrfeTARZPw0JS0bPumrreWpGSv
OqqLB6wvGLlA13/TN2+l1NprqtopdV70l3rwKGXrJfcNYMnhz9XB7+N+EujU
g8LloX0DDg+2nsPVRv4E+biM3c/UtSumdgdrk2CQ84dUzQFzuPu6eHC1vgXh
81NLd5T8Rg6YlAMW5a1ljJ2Ut5WR6q4q8vIbe8nBS3tIrxE8oN1YFeQCir1y
sllZ8C9ib3Ek1irZnInh4+rquhbk+V+uPmGsbmSKHqGfe5B71Vg8qK9z9URx
cHDwDVNq4nQdHD7/6OPjI8d9Jg4WWrnQ9q8UhuMwv44Bhj762lLE3Ee4IC/J
42oOuI4EnmOAh4KyD2YfCj/tHYUOiesTukCnX9V016C/Gq9oL0MfxtSlBt7s
YeKJLh6qPqUa14Oq/XWAY+md2MQYmfUsaytaFvo7yO8FOc5RrGNNs8Y7ab8N
9D1M7bfp1QWsHdJhDfGvJtTbJ9XBw8PDP3Jzc8tg93C0fXN1NfCR7zg4OGhz
DxP2d7XnTmCu2GEuDby+WLp0KdZ3G2k82O9aOxN7uwemF6ddkEPs2A62AbmW
GnyXBrHoP7+L7GHxaDvSNN50sG689XATUfXX3k/NSRkQOYtoe7fE8w6450id
e9DycXR0jIV17zum7IHQuoL59XMTfo/D4+7DXJ8F/kSBc3+KermGqz+irwPZ
brPrQG3/YA+nAeM8fXuHphCNG+TUPpC7DDk7O6fqPmP/5rE5BkOB4fOSC+Sb
3lOAL8LYXt+nGNt/oVuz+9V2TefRFmavo2uojRQqNt3y8ffS7qPhPjq7Z6sr
J+LDzRPtvieML4euG9K60vHTd3CvmvIlU57X0Dlz4AEx4iDumRrar2Vj26ew
FtrCxoNJ9qGjrkc9w8EzwZ7oxpZce4GVgBeTIC0tbdn2W8xhcV9w39mdpO9C
N1Huqf44Ij48Q/se2ABzse/icEKTQtYmbnthV8Bi/2VUOwG1T8WMCW2YrRt+
ye2hc3t06GNBj4OYA1MyTuecEY/2BejjIN+5SsVWrrb/BciwA/fzjXTEnyZv
Y2Q5HftifQzTVuQkcl65IaGnrlfxl+4TrV+szEhU2dja2Ew0ZI4G8Wnb8pF6
R2bvyXinYURBVCNyUjciI+t2rLkonuceMKl/3uS5gutiiC2von5wrmJdFPwa
vYc93fNRk4ZkQf2GCnKL1bAG/QAw/z/wQ4fRf1B8vrW/taLPi7iIXfwcXRw8
6Wf0c2cvJ3GqcuWg8lo1Ub5VTZLKEvZJovyi1ypTT9UNy4jsUiVZUfxCh72b
0J59hTtTN2kOQ6xc7OLikvKoftoY0XaJv9WFXJSOeY+D91Mj1r9MOi/K4sCM
a5bDLKv43LiaqnOld1VgE5nt64e9Q7wW0n34L/JbsrE36ycNtxWk9MSW30Wm
h28SWAu4/vlcLkPz4T3+WTtjY3qS50WfCbGxRRvLUIUhKxasKTqS/0njbSUp
Opz/SVDSgtVUez6TZfEm/ATfhm8RlRaRXzZU/N8Nt5RkY0/2T+fF+MdT7R+c
RbZ8UHef2SE9tfPhM0PsesVnoXdoVmf6iOqGnFSdLb27JCd2u43Qhl3T8Lhc
yoL9mztrx+AidBEKwW+1g//S1F2D2NK05rTrXJe5+IxvxbcC21kVn7+4KPql
yGS+gC/geJppMnH56txwn2jQ5dfyt6pIavXKQ05eTvR5uwfn+Sx52jPAul3h
PxDfJWmta87XXa0h5ae2/h5wcvdc4OEbl7doS1ZX+rEXipbm+IR4B1K8zUQR
d540NlPagfM6YJl/kvYZm19hTIDvk96zdxWKRG72fiJ3kY/Qyc5Ot19pWtRW
9HehScHpznOdnJYVLClJrkisXbFteeGcQE8mJzPj8TBxeEjXRXYqrlRr7F3t
vTFGgE9hfL2Du0hcMrTlF8sL45kagGegR1B2Z8Zw9cXy+7jvgxfE/L9saF13
yWOehx9vwnYsfcK8lzbcVGik66Ly0XIiVoetiM6ITIPPBIvvg4+fIeLwWLQ+
qhPzWWcf5/n0fRdvZ0n9dRlZWZl41NrWWlB2svi3ijeqSNqONZfjC+I6lm5c
vDOzY/3Nums1ZMtAwcd2oonzvv4xklWAB5GmRW6k2T31AX7HSBcPiBsB9H1Y
f/gq39o+DvbR7R0yJ1h1Q0FSZMmHdPtZq0gdaP9xEwleueAl/DsgRpJC4wEx
namJmH2UcTIFj9qr1SSheNk+Vz8Xb1wDFh7O/xTiTTXoPMFN4iqxsbextnOy
tZq/JCDZ0duRyalgbZJM40H/7sFMhskUPBRXtpNVlYmHMQ6kVCf1Ky5vJ7jW
wLwY4wf4sM8zWtOGg5YHvshj475E6pdkxmP6ZDIeVUmHuXfEQe6SiNWhecs3
x3esUaacy9+X8xGes2l8W0kW58VUYBtdf2XGwzSahr/aHfFiWG5Bf+4PbB20
v9HREug/Rv5GlTp7Z8a7+DfYxyq0ITMe0yPT8KghEM87o16KKGgbbSQplcn9
to7a3+RiW6zDv4SxZW1z6lm8F7AI7OOW2T6mSxQeHQwe3k7zMQfSya9IUmnC
IWsHa6vCwfx/xrgBMeNPuXsyP8jdnfneloFNv8GcuOq10s/nRHuGYX2X8ld5
NB8zGSdOTzHp0bsAD7VILGJq77AenIV6xfUHHT/sXYTCJXmxVVmd6bc39ef+
x6a+nM829mT/Y1J5wm53iZv2N6C+kXOXqG4qxgHnApqPmYwTp6fwlIVFOJ83
dKy74RXhGco9h/W5O+ChSalKGmRrgMbXD9AiIE4Sv6k3533VdQUJiJnYR3zC
/8/A95lQy5ZWNlbWK8sTD+A6G/1TcvmKQ37RvrEQx3ehL1peFN+Cugb8rBgM
J+rtk/bn3f3dJGubXjxTd72GyN6sUC/fEq8CO+OZa7mPTnPDvCOzd2Xcrh+R
EfA3BNfjlWdL/ug8xwnXedq4ws53xlaELnZ2LxQubam5WDFWPywn6xrXnhfP
d/dnuzRj8Yik3V/j8SzANmJiMqRK6brICntXe0fBbDAJa1a13F6UNd8iPC00
e9uxov/Ctcem/pz358UFLH+oPzM9MlHnd7QUsSY0q/K1ks+zutNvegXPCcbS
rJ/UNy6vP/PvMeaUn9x2JzojsggxY/pg9xCfhfzfV2LOvQmYWGElDnYPWlOb
MoT7I7LXK0lmx/q/w9xYeXk7nm/oFrmJHLjXzHH76ZFnkEdQZuf6YeXlarKu
bc0JN9+J/Vgk9qzPd47+H4mwvo4=
               "], {{0, 61}, {100, 0}}, {0, 255},
                ColorFunction -> RGBColor], 
              BoxForm`ImageTag[
              "Byte", ColorSpace -> "RGB", Interleaving -> True, 
               MetaInformation -> 
               Association[
                "Comments" -> Association["Software" -> "www.inkscape.org"]]],
               Selectable -> False], DefaultBaseStyle -> "ImageGraphics", 
             ImageSizeRaw -> {100, 61}, PlotRange -> {{0, 100}, {0, 61}}], 
            GridBox[{{
               RowBox[{
                 TagBox["\"System: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"NodeJS\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                 "\"b1598418-5516-4297-9bfb-9495bfff892c\"", 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"EvaluationCount: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "b1598418-5516-4297-9bfb-9495bfff892c"]], 
                    ExternalSessionObject[
                    "b1598418-5516-4297-9bfb-9495bfff892c"][
                    "EvaluationCount"], None], StandardForm]], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Process: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  RowBox[{"ProcessObject", "[", "19", "]"}], 
                  "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Epilog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Prolog: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["None", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Version: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"8.9.3\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Executable: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"/usr/local/bin/node\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"ReturnType: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"Expression\"", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Socket: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  InterpretationBox[
                   RowBox[{
                    TagBox["SocketObject", "SummaryHead"], "[", 
                    
                    DynamicModuleBox[{
                    Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
                    TemplateBox[{
                    PaneSelectorBox[{False -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquarePlusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = True), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"2da86a2c-79b1-44b2-aaa6-2a37be3ccc37\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"60475\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}], True -> GridBox[{{
                    PaneBox[
                    ButtonBox[
                    DynamicBox[
                    FEPrivate`FrontEndResource[
                    "FEBitmaps", "SquareMinusIconMedium"]], 
                    ButtonFunction :> (Typeset`open$$ = False), Appearance -> 
                    None, Evaluator -> Automatic, Method -> "Preemptive"], 
                    Alignment -> {Center, Center}, ImageSize -> 
                    Dynamic[{Automatic, 3.5 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    GraphicsBox[
                    GeometricTransformationBox[{{{
                    FilledCurveBox[{{
                    
                    Line[{{36.558, 8.569}, {40.947, 8.569}, {40.947, 
                    43.684000000000005`}, {36.558, 43.684000000000005`}, {
                    36.558, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{59.053, 8.569}, {63.443, 8.569}, {63.443, 
                    43.684000000000005`}, {59.053, 43.684000000000005`}, {
                    59.053, 8.569}}]}}]}, {{
                    FilledCurveBox[{{
                    
                    Line[{{55.487, 8.569}, {56.95, 8.569}, {56.95, 
                    21.188000000000002`}, {55.487, 21.188000000000002`}, {
                    55.487, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{52.562, 8.569}, {54.025, 8.569}, {54.025, 
                    21.188000000000002`}, {52.562, 21.188000000000002`}, {
                    52.562, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{49.636, 8.569}, {51.099000000000004`, 8.569}, {
                    51.099000000000004`, 21.188000000000002`}, {49.636, 
                    21.188000000000002`}, {49.636, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{46.709, 8.569}, {48.172000000000004`, 8.569}, {
                    48.172000000000004`, 21.188000000000002`}, {46.709, 
                    21.188000000000002`}, {46.709, 8.569}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{43.783, 8.569}, {45.246, 8.569}, {45.246, 
                    21.188000000000002`}, {43.783, 21.188000000000002`}, {
                    43.783, 8.569}}]}}]}}, {
                    FilledCurveBox[{{
                    
                    Line[{{40.947, 4.911}, {59.787000000000006`, 4.911}, {
                    59.787000000000006`, 6.922}, {40.947, 6.922}, {40.947, 
                    4.911}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 31.675}, {56.678000000000004`, 31.675}, {
                    56.678000000000004`, 39.051}, {44.057, 39.051}, {44.057, 
                    31.675}}]}}]}, {
                    FilledCurveBox[{{
                    
                    Line[{{44.057, 43.685}, {56.678000000000004`, 43.685}, {
                    56.678000000000004`, 65.089}, {44.057, 65.089}, {44.057, 
                    43.685}}]}}]}}}, {{{1, 0}, {0, -1}}, Center}], 
                    PlotRange -> {{20, 80}, {0, 70}}, 
                    BaseStyle -> {CacheGraphics -> False}, ImageSize -> 30], 
                    GridBox[{{
                    RowBox[{
                    TagBox["\"UUID: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    "\"2da86a2c-79b1-44b2-aaa6-2a37be3ccc37\"", 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"Protocol: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"ZMQ_PAIR\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox[
                    "\"DestinationIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    RowBox[{"IPAddress", "[", "\"127.0.0.1\"", "]"}], 
                    "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"DestinationPort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"60475\"", "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourceIPAddress: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox[
                    
                    RowBox[{"IPAddress", "[", "\"::85f1:e036:b7ab:aa\"", 
                    "]"}], "SummaryItem"]}]}, {
                    RowBox[{
                    TagBox["\"SourcePort: \"", "SummaryItemAnnotation"], 
                    "\[InvisibleSpace]", 
                    TagBox["\"0\"", "SummaryItem"]}]}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, 
                    AutoDelete -> False, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{2}}, "Rows" -> {{Automatic}}}, 
                    BaseStyle -> {
                    ShowStringCharacters -> False, NumberMarks -> False, 
                    PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
                    GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> 
                    False, GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    BaselinePosition -> {1, 1}]}, 
                    Dynamic[Typeset`open$$], ImageSize -> Automatic]}, 
                    "SummaryPanel", 
                    DisplayFunction -> (
                    ButtonBox[#, Active -> False, Alignment -> Left, 
                    Appearance -> {
                    "Default" -> 
                    FrontEnd`FileName[{"Typeset", "SummaryBox"}, 
                    "Panel.9.png"]}, FrameMargins -> 7, BaseStyle -> {}, 
                    DefaultBaseStyle -> {"Panel", Background -> None}, 
                    BaselinePosition -> Baseline]& )], 
                    DynamicModuleValues :> {}], "]"}], 
                   SocketObject["2da86a2c-79b1-44b2-aaa6-2a37be3ccc37"], 
                   Selectable -> False, Editable -> False, SelectWithContents -> 
                   True], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"SessionTime: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  DynamicBox[
                   ToBoxes[
                    If[
                    And[
                    ValueQ[ExternalEvaluate`Private`$Links], 
                    KeyExistsQ[
                    ExternalEvaluate`Private`$Links, 
                    "b1598418-5516-4297-9bfb-9495bfff892c"]], 
                    ExternalSessionObject[
                    "b1598418-5516-4297-9bfb-9495bfff892c"]["SessionTime"], 
                    None], StandardForm]], "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel",
     DisplayFunction->(
      ButtonBox[#, Active -> False, Alignment -> Left, 
       Appearance -> {
        "Default" -> 
         FrontEnd`FileName[{"Typeset", "SummaryBox"}, "Panel.9.png"]}, 
       FrameMargins -> 7, BaseStyle -> {}, 
       DefaultBaseStyle -> {"Panel", Background -> None}, BaselinePosition -> 
       Baseline]& )],
    DynamicModuleValues:>{}], "]"}],
  ExternalSessionObject["b1598418-5516-4297-9bfb-9495bfff892c"],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{
  3.722294076569222*^9},ExpressionUUID->"e56f1f6d-d8b3-430f-a0b6-\
aefa2a543b91"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ExternalEvaluate", "[", 
  RowBox[{"session", ",", "\"\<powers.square(3)\>\""}], "]"}]], "Input",Expres\
sionUUID->"463b6d95-06cc-458e-98dd-083c05c68a97"],

Cell[BoxData["9"], "Output",
 CellChangeTimes->{
  3.722294085373155*^9},ExpressionUUID->"3584b570-9256-4383-a7b2-\
5d399824d7cc"]
}, Open  ]]
},
WindowSize->{1207, 915},
WindowMargins->{{457, Automatic}, {Automatic, 130}},
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 430, 9, 52, "Input",ExpressionUUID->"e93cda9b-bfc5-4f41-9e22-0e6e72c19d6f"],
Cell[1013, 33, 154, 3, 34, "Output",ExpressionUUID->"4ea06b81-7a1d-4694-9bba-6c19f4c13a8e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1204, 41, 243, 5, 30, "Input",ExpressionUUID->"6aacf631-a604-4a60-9f57-679caea6e64e"],
Cell[1450, 48, 34620, 652, 76, "Output",ExpressionUUID->"68c428db-77b6-4e09-8c56-6bc88d62faf5"]
}, Open  ]],
Cell[36085, 703, 296, 8, 127, "Text",ExpressionUUID->"6486ea2e-e54e-4b80-a5b0-039078e20139"],
Cell[CellGroupData[{
Cell[36406, 715, 198, 3, 30, "Input",ExpressionUUID->"bfd06e11-3ba2-4f37-8577-6af546fb31fb"],
Cell[36607, 720, 311, 5, 34, "Output",ExpressionUUID->"64f93078-20d1-4841-bfe9-4fa9151a2f33"]
}, Open  ]],
Cell[36933, 728, 1564, 31, 325, "Input",ExpressionUUID->"67680003-bac6-4c7a-96b0-ddec49e243b7"],
Cell[38500, 761, 1159, 26, 346, "Input",ExpressionUUID->"ccbc4df9-fb81-4eaf-814a-5320018c34e1"],
Cell[CellGroupData[{
Cell[39684, 791, 442, 11, 30, "Input",ExpressionUUID->"73d02cf4-7bb0-4c6e-9557-624c358ca62d"],
Cell[40129, 804, 311, 17, 228, "Print",ExpressionUUID->"6356d568-dcbf-470a-a62c-00a9c6b525ba"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40477, 826, 669, 17, 73, "Input",ExpressionUUID->"a989d325-abca-4ff9-8218-d33fa5f6ce53"],
Cell[41149, 845, 35130, 659, 76, "Output",ExpressionUUID->"c6f65b09-e232-4658-a904-6f00f54f0b9b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76316, 1509, 604, 12, 52, "Input",ExpressionUUID->"195cfd6f-e876-4aa3-b8ae-610303a60954"],
Cell[76923, 1523, 374, 7, 34, "Output",ExpressionUUID->"b761dc0b-67c1-4b56-9bf7-e3d7bd5f8acf"]
}, Open  ]],
Cell[77312, 1533, 524, 14, 94, "Input",ExpressionUUID->"860c9414-2d74-45ac-a27b-da27f81d085b"],
Cell[CellGroupData[{
Cell[77861, 1551, 122, 1, 30, "Input",ExpressionUUID->"93da94e6-eb21-45f5-aa95-62c841daaac1"],
Cell[77986, 1554, 254, 7, 58, "Print",ExpressionUUID->"e1b52763-08f1-4e77-9fa5-829fe5245133"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78277, 1566, 293, 6, 52, "Input",ExpressionUUID->"b8a94c7f-e46f-48c6-8b7a-a81a61de75be"],
Cell[78573, 1574, 34405, 649, 76, "Output",ExpressionUUID->"e56f1f6d-d8b3-430f-a0b6-aefa2a543b91"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113015, 2228, 178, 3, 30, "Input",ExpressionUUID->"463b6d95-06cc-458e-98dd-083c05c68a97"],
Cell[113196, 2233, 130, 3, 34, "Output",ExpressionUUID->"3584b570-9256-4383-a7b2-5d399824d7cc"]
}, Open  ]]
}
]
*)

