(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     42896,       1032]
NotebookOptionsPosition[     42219,       1011]
NotebookOutlinePosition[     42579,       1027]
CellTagsIndexPosition[     42536,       1024]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Column", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Column", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Multicolumn", "[", 
           RowBox[{"pad1", ",", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "10"}], "}"}], ",", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
            RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Multicolumn", "[", 
           RowBox[{"pad2", ",", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "5"}], "}"}], ",", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
            RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Multicolumn", "[", 
           RowBox[{"pad3", ",", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "5"}], "}"}], ",", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
            RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}]}], "}"}], 
        ",", 
        RowBox[{"Dividers", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"All", ",", "Gray"}], "}"}]}]}], "]"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"Transpose", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\"\<S\>\"", "<>", 
              RowBox[{"StringJoin", "[", 
               RowBox[{"#", ",", "\"\<:  \>\""}], "]"}]}], "&"}], "/@", 
            RowBox[{"(", 
             RowBox[{"ToString", "/@", 
              RowBox[{"Range", "[", 
               RowBox[{"Length", "[", 
                RowBox[{"StringSplit", "[", 
                 RowBox[{
                  RowBox[{"StringJoin", "[", "expr", "]"}], ",", 
                  RowBox[{"{", "\"\<\\n\>\"", "}"}]}], "]"}], "]"}], "]"}]}], 
             ")"}]}], ",", 
           RowBox[{"StringSplit", "[", 
            RowBox[{
             RowBox[{"StringJoin", "[", "expr", "]"}], ",", 
             RowBox[{"{", "\"\<\\n\>\"", "}"}]}], "]"}]}], "}"}], "]"}], ",", 
        
        RowBox[{"Background", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"LightGreen", ",", "White"}], "}"}], "}"}]}], ",", 
        RowBox[{"Dividers", "\[Rule]", "Center"}]}], "]"}]}], 
     "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"assoc", "=", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<quants\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\[ForAll]\>\"", ",", "\"\<\[Exists]\>\"", ",", 
            "\"\<\[NotExists]\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<member\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<\[Element]\>\"", ",", "\"\<\[NotElement]\>\""}], 
           "}"}]}], ",", 
         RowBox[{"\"\<subset\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\[Subset]\>\"", ",", "\"\<\[SubsetEqual]\>\"", ",", 
            "\"\<\[NotSubset]\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<space\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<\[SpaceKey]\>\"", ",", "Black"}], "]"}], "}"}]}], 
         ",", 
         RowBox[{"\"\<enter\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<\[EnterKey]\>\"", ",", "Blue"}], "]"}], "}"}]}], ",", 
         RowBox[{"\"\<del\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Style", "[", 
            RowBox[{"\"\<\[DeleteKey]\>\"", ",", "Red"}], "]"}], "}"}]}], ",", 
         RowBox[{"\"\<clear\>\"", "\[Rule]", 
          RowBox[{"{", "\"\<C\>\"", "}"}]}], ",", 
         RowBox[{"\"\<seperators\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<, \>\"", ",", "\"\<|\>\"", ",", "\"\<:\>\"", ",", "\"\<(\>\"",
             ",", "\"\<)\>\"", ",", "\"\<[\>\"", ",", "\"\<]\>\"", ",", 
            "\"\<{\>\"", ",", "\"\<}\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<logic\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\[And]\>\"", ",", "\"\<\[Or]\>\"", ",", 
            "\"\<\[DoubleLongLeftRightArrow]\>\"", ",", 
            "\"\<\[DoubleLongRightArrow]\>\"", ",", "\"\<\[Not]\>\"", ",", 
            "\"\<T\>\"", ",", "\"\<F\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<arith\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<+\>\"", ",", "\"\<-\>\"", ",", "\"\<\[Cross]\>\"", ",", 
            "\"\</\>\"", ",", "\"\<>\>\"", ",", 
            "\"\<\[GreaterSlantEqual]\>\"", ",", "\"\<<\>\"", ",", 
            "\"\<\[LessSlantEqual]\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<eq\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<=\>\"", ",", "\"\<\[Congruent]\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<digits\>\"", "\[Rule]", 
          RowBox[{"ToString", "/@", 
           RowBox[{
            RowBox[{"Range", "[", 
             RowBox[{"0", ",", "9"}], "]"}], "~", "Join", "~", 
            RowBox[{"{", 
             RowBox[{
             "\"\<.\>\"", ",", "\"\<\[PlusMinus]\>\"", ",", 
              "\"\<\[MinusPlus]\>\"", ",", "\"\<\[TildeTilde]\>\"", ",", 
              "\"\<\[Proportional]\>\""}], "}"}]}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<sets\>\"", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<\[DoubleStruckCapitalN]\>\"", ",", 
            "\"\<\[DoubleStruckCapitalZ]\>\"", ",", 
            "\"\<\[DoubleStruckCapitalQ]\>\"", ",", 
            "\"\<\[DoubleStruckCapitalC]\>\"", ",", 
            "\"\<\[DoubleStruckCapitalR]\>\"", ",", "\"\<\[EmptySet]\>\"", 
            ",", "\"\<\[Infinity]\>\"", ",", 
            "\"\<\!\(\*SubscriptBox[\(\[Aleph]\), \(0\)]\)\>\"", ",", 
            "\"\<\!\(\*SubscriptBox[\(\[Aleph]\), \(1\)]\)\>\"", ",", 
            "\"\<\!\(\*SuperscriptBox[\(2\), SubscriptBox[\(\[Aleph]\), \
\(0\)]]\)\>\""}], "}"}]}], ",", 
         RowBox[{"\"\<powerset\>\"", "\[Rule]", 
          RowBox[{"{", "\"\<\[ScriptCapitalP]\>\"", "}"}]}]}], "|>"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
      "sample1", "=", 
       "\"\<positive Integers Real positive negative for every number such \
that set of any some then if true false there is are since therefore \
is\>\""}], ";", "\[IndentingNewLine]", 
      RowBox[{"words", "=", 
       RowBox[{"<|", 
        RowBox[{"\"\<general\>\"", "\[Rule]", 
         RowBox[{"Sort", "@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"StringJoin", "[", 
              RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
            RowBox[{"(", 
             RowBox[{"DeleteDuplicates", "[", 
              RowBox[{"StringSplit", "[", "sample1", "]"}], "]"}], ")"}]}], 
           ")"}]}]}], "|>"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"sym", "=", 
       RowBox[{"{", 
        RowBox[{
        "\"\<p\>\"", ",", "\"\<q\>\"", ",", "\"\<r\>\"", ",", "\"\<x\>\"", 
         ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"\"\<x\>\"", "^", "2"}], ",", "TraditionalForm"}], "]"}], 
         ",", 
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"\"\<y\>\"", "^", "2"}], ",", "TraditionalForm"}], "]"}], 
         ",", 
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"Sqrt", "[", 
            RowBox[{
             RowBox[{"\"\<x\>\"", "^", "2"}], "+", 
             RowBox[{"\"\<y\>\"", "^", "2"}]}], "]"}], ",", 
           "TraditionalForm"}], "]"}], ",", 
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"Sqrt", "[", "\"\<\>\"", "]"}], ",", "TraditionalForm"}], 
          "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"expr", "=", 
       RowBox[{"{", "\"\< \>\"", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"pad1", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<quants\>\"", "]"}]}], ")"}], "~", "Join",
         "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<member\>\"", "]"}]}], ")"}], "~", "Join",
         "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<subset\>\"", "]"}]}], ")"}], "~", "Join",
         "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<sets\>\"", "]"}]}], ")"}], "~", 
        "\[IndentingNewLine]", "Join", "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Tooltip", "[", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             ",", "\"\<Power Set\>\""}], "]"}], "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<powerset\>\"", "]"}]}], ")"}], "~", 
        "Join", "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<logic\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", 
               RowBox[{"ToString", "[", 
                RowBox[{"#", ",", "StandardForm"}], "]"}]}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"(", "sym", ")"}]}], ")"}], "~", "Join", "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<arith\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<eq\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Button", "[", 
            RowBox[{"#", ",", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"expr", ",", "#"}], "]"}], ",", 
             RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
           "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<seperators\>\"", "]"}]}], ")"}], "~", 
        "Join", "~", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Tooltip", "[", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "\"\< \>\""}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             ",", "\"\<Space\>\""}], "]"}], "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<space\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Tooltip", "[", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "\"\<\\n \>\""}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             ",", "\"\<New Line\>\""}], "]"}], "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<enter\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Tooltip", "[", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", "expr", "]"}], ">", "0"}], ",", 
                 RowBox[{"expr", "=", 
                  RowBox[{"Delete", "[", 
                   RowBox[{"expr", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}]}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             ",", "\"\<Delete\>\""}], "]"}], "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<del\>\"", "]"}]}], ")"}], "~", "Join", 
        "~", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Tooltip", "[", 
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"expr", "=", 
                RowBox[{"{", "\"\< \>\"", "}"}]}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             ",", "\"\<Clear All\>\""}], "]"}], "&"}], "/@", 
          RowBox[{"assoc", "[", "\"\<clear\>\"", "]"}]}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"pad2", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Button", "[", 
           RowBox[{"#", ",", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"expr", ",", "#"}], "]"}], ",", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
          "&"}], "/@", 
         RowBox[{"assoc", "[", "\"\<digits\>\"", "]"}]}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"pad3", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Button", "[", 
           RowBox[{"#", ",", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"expr", ",", "#"}], "]"}], ",", 
            RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
          "&"}], "/@", 
         RowBox[{"words", "[", "\"\<general\>\"", "]"}]}], ")"}]}], ";"}], 
     ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.722876788385455*^9, 3.7228767891160517`*^9}, 
   3.722877064535769*^9, 
   3.722877105494843*^9},ExpressionUUID->"e94cc8ad-ec72-48f8-a68d-\
7f1ad0cc169f"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {}, 
    Typeset`size$$ = {362., {211.634033203125, 217.365966796875}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {}, "ControllerVariables" :> {}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Column[{
         Column[{
           
           Multicolumn[$CellContext`pad1, {Automatic, 10}, Appearance -> 
            "Horizontal", ItemSize -> Automatic], 
           
           Multicolumn[$CellContext`pad2, {Automatic, 5}, Appearance -> 
            "Horizontal", ItemSize -> Automatic], 
           
           Multicolumn[$CellContext`pad3, {Automatic, 5}, Appearance -> 
            "Horizontal", ItemSize -> Automatic]}, Dividers -> {All, Gray}], 
         Grid[
          Transpose[{
            Map[StringJoin["S", 
              StringJoin[#, ":  "]]& , 
             Map[ToString, 
              Range[
               Length[
                StringSplit[
                 StringJoin[$CellContext`expr], {"\n"}]]]]], 
            StringSplit[
             StringJoin[$CellContext`expr], {"\n"}]}], 
          Background -> {{LightGreen, White}}, Dividers -> Center]}], 
      "Specifications" :> {}, "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{407., {242., 248.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>(($CellContext`assoc = 
       Association[
        "quants" -> {"\[ForAll]", "\[Exists]", "\[NotExists]"}, 
         "member" -> {"\[Element]", "\[NotElement]"}, 
         "subset" -> {"\[Subset]", "\[SubsetEqual]", "\[NotSubset]"}, "space" -> {
           Style["\[SpaceKey]", Black]}, "enter" -> {
           Style["\[EnterKey]", Blue]}, "del" -> {
           Style["\[DeleteKey]", Red]}, "clear" -> {"C"}, 
         "seperators" -> {", ", "|", ":", "(", ")", "[", "]", "{", "}"}, 
         "logic" -> {
          "\[And]", "\[Or]", "\[DoubleLongLeftRightArrow]", 
           "\[DoubleLongRightArrow]", "\[Not]", "T", "F"}, 
         "arith" -> {
          "+", "-", "\[Cross]", "/", ">", "\[GreaterSlantEqual]", "<", 
           "\[LessSlantEqual]"}, "eq" -> {"=", "\[Congruent]"}, "digits" -> 
         Map[ToString, 
           Join[
            Range[0, 9], {
            ".", "\[PlusMinus]", "\[MinusPlus]", "\[TildeTilde]", 
             "\[Proportional]"}]], 
         "sets" -> {
          "\[DoubleStruckCapitalN]", "\[DoubleStruckCapitalZ]", 
           "\[DoubleStruckCapitalQ]", "\[DoubleStruckCapitalC]", 
           "\[DoubleStruckCapitalR]", "\[EmptySet]", "\[Infinity]", 
           "\!\(\*SubscriptBox[\(\[Aleph]\), \(0\)]\)", 
           "\!\(\*SubscriptBox[\(\[Aleph]\), \(1\)]\)", 
           "\!\(\*SuperscriptBox[\(2\), SubscriptBox[\(\[Aleph]\), \
\(0\)]]\)"}, "powerset" -> {"\[ScriptCapitalP]"}]; $CellContext`sample1 = 
       "positive Integers Real positive negative for every number such that \
set of any some then if true false there is are since therefore is"; \
$CellContext`words = Association["general" -> Sort[
           Map[StringJoin[#, " "]& , 
            DeleteDuplicates[
             StringSplit[$CellContext`sample1]]]]]; $CellContext`sym = {
        "p", "q", "r", "x", "y", "z", 
         ToString["x"^2, TraditionalForm], 
         ToString["y"^2, TraditionalForm], 
         ToString[
          Sqrt["x"^2 + "y"^2], TraditionalForm], 
         ToString[
          Sqrt[""], TraditionalForm]}; $CellContext`expr = {
        " "}; $CellContext`pad1 = Join[
         Join[
          Join[
           Join[
            Join[
             Join[
              Join[
               Join[
                Join[
                 Join[
                  Join[
                   Join[
                    Join[
                    Map[Button[#, 
                    AppendTo[$CellContext`expr, #], Appearance -> 
                    "Palette"]& , 
                    $CellContext`assoc["quants"]], 
                    Map[Button[#, 
                    AppendTo[$CellContext`expr, #], Appearance -> 
                    "Palette"]& , 
                    $CellContext`assoc["member"]]], 
                    Map[Button[#, 
                    AppendTo[$CellContext`expr, #], Appearance -> 
                    "Palette"]& , 
                    $CellContext`assoc["subset"]]], 
                   Map[Button[#, 
                    AppendTo[$CellContext`expr, #], Appearance -> 
                    "Palette"]& , 
                    $CellContext`assoc["sets"]]], 
                  Map[Tooltip[
                    Button[#, 
                    AppendTo[$CellContext`expr, #], Appearance -> "Palette"], 
                    "Power Set"]& , 
                   $CellContext`assoc["powerset"]]], 
                 Map[Button[#, 
                   AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
                  $CellContext`assoc["logic"]]], 
                Map[Button[#, 
                  AppendTo[$CellContext`expr, 
                   ToString[#, StandardForm]], Appearance -> 
                  "Palette"]& , $CellContext`sym]], 
               Map[Button[#, 
                 AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
                $CellContext`assoc["arith"]]], 
              Map[Button[#, 
                AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
               $CellContext`assoc["eq"]]], 
             Map[Button[#, 
               AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
              $CellContext`assoc["seperators"]]], 
            Map[Tooltip[
              Button[#, 
               AppendTo[$CellContext`expr, " "], Appearance -> "Palette"], 
              "Space"]& , 
             $CellContext`assoc["space"]]], 
           Map[Tooltip[
             Button[#, 
              AppendTo[$CellContext`expr, "\n "], Appearance -> "Palette"], 
             "New Line"]& , 
            $CellContext`assoc["enter"]]], 
          Map[Tooltip[
            Button[#, 
             If[
             Length[$CellContext`expr] > 0, $CellContext`expr = 
              Delete[$CellContext`expr, -1]], Appearance -> "Palette"], 
            "Delete"]& , 
           $CellContext`assoc["del"]]], 
         Map[Tooltip[
           Button[#, $CellContext`expr = {" "}, Appearance -> "Palette"], 
           "Clear All"]& , 
          $CellContext`assoc["clear"]]]; $CellContext`pad2 = Map[Button[#, 
          AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
         $CellContext`assoc["digits"]]; $CellContext`pad3 = Map[Button[#, 
          AppendTo[$CellContext`expr, #], Appearance -> "Palette"]& , 
         $CellContext`words["general"]]; Null); Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.722877313529277*^9},ExpressionUUID->"d243e2de-4c99-44af-8531-\
405ece6dded9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Column", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Column", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Multicolumn", "[", 
             RowBox[{"pad1", ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "10"}], "}"}], ",", 
              RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
              RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Multicolumn", "[", 
             RowBox[{"pad2", ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "5"}], "}"}], ",", 
              RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
              RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Multicolumn", "[", 
             RowBox[{"pad3", ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", ",", "5"}], "}"}], ",", 
              RowBox[{"Appearance", "\[Rule]", "\"\<Horizontal\>\""}], ",", 
              RowBox[{"ItemSize", "\[Rule]", "Automatic"}]}], "]"}]}], "}"}], 
          ",", 
          RowBox[{"Dividers", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"All", ",", "Gray"}], "}"}]}]}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Grid", "[", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"\"\<S\>\"", "<>", 
                RowBox[{"StringJoin", "[", 
                 RowBox[{"#", ",", "\"\<:  \>\""}], "]"}]}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{"ToString", "/@", 
                RowBox[{"Range", "[", 
                 RowBox[{"Length", "[", 
                  RowBox[{"StringSplit", "[", 
                   RowBox[{
                    RowBox[{"StringJoin", "[", "expr", "]"}], ",", 
                    RowBox[{"{", "\"\<\\n\>\"", "}"}]}], "]"}], "]"}], 
                 "]"}]}], ")"}]}], ",", 
             RowBox[{"StringSplit", "[", 
              RowBox[{
               RowBox[{"StringJoin", "[", "expr", "]"}], ",", 
               RowBox[{"{", "\"\<\\n\>\"", "}"}]}], "]"}]}], "}"}], "]"}], 
          ",", 
          RowBox[{"Background", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"LightGreen", ",", "White"}], "}"}], "}"}]}], ",", 
          RowBox[{"Dividers", "\[Rule]", "Center"}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Initialization", "\[RuleDelayed]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"assoc", "=", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<quants\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\[ForAll]\>\"", ",", "\"\<\[Exists]\>\"", ",", 
              "\"\<\[NotExists]\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<member\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<\[Element]\>\"", ",", "\"\<\[NotElement]\>\""}], 
             "}"}]}], ",", 
           RowBox[{"\"\<subset\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\[Subset]\>\"", ",", "\"\<\[SubsetEqual]\>\"", ",", 
              "\"\<\[NotSubset]\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<space\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<\[SpaceKey]\>\"", ",", "Black"}], "]"}], "}"}]}], 
           ",", 
           RowBox[{"\"\<enter\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<\[EnterKey]\>\"", ",", "Blue"}], "]"}], "}"}]}], 
           ",", 
           RowBox[{"\"\<del\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<\[DeleteKey]\>\"", ",", "Red"}], "]"}], "}"}]}], 
           ",", 
           RowBox[{"\"\<clear\>\"", "\[Rule]", 
            RowBox[{"{", "\"\<C\>\"", "}"}]}], ",", 
           RowBox[{"\"\<seperators\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<, \>\"", ",", "\"\<|\>\"", ",", "\"\<:\>\"", ",", 
              "\"\<(\>\"", ",", "\"\<)\>\"", ",", "\"\<[\>\"", ",", 
              "\"\<]\>\"", ",", "\"\<{\>\"", ",", "\"\<}\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<logic\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\[And]\>\"", ",", "\"\<\[Or]\>\"", ",", 
              "\"\<\[DoubleLongLeftRightArrow]\>\"", ",", 
              "\"\<\[DoubleLongRightArrow]\>\"", ",", "\"\<\[Not]\>\"", ",", 
              "\"\<T\>\"", ",", "\"\<F\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<arith\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<+\>\"", ",", "\"\<-\>\"", ",", "\"\<\[Cross]\>\"", ",", 
              "\"\</\>\"", ",", "\"\<>\>\"", ",", 
              "\"\<\[GreaterSlantEqual]\>\"", ",", "\"\<<\>\"", ",", 
              "\"\<\[LessSlantEqual]\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<eq\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<=\>\"", ",", "\"\<\[Congruent]\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<digits\>\"", "\[Rule]", 
            RowBox[{"ToString", "/@", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{"0", ",", "9"}], "]"}], "~", "Join", "~", 
              RowBox[{"{", 
               RowBox[{
               "\"\<.\>\"", ",", "\"\<\[PlusMinus]\>\"", ",", 
                "\"\<\[MinusPlus]\>\"", ",", "\"\<\[TildeTilde]\>\"", ",", 
                "\"\<\[Proportional]\>\""}], "}"}]}]}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<sets\>\"", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
             "\"\<\[DoubleStruckCapitalN]\>\"", ",", 
              "\"\<\[DoubleStruckCapitalZ]\>\"", ",", 
              "\"\<\[DoubleStruckCapitalQ]\>\"", ",", 
              "\"\<\[DoubleStruckCapitalC]\>\"", ",", 
              "\"\<\[DoubleStruckCapitalR]\>\"", ",", "\"\<\[EmptySet]\>\"", 
              ",", "\"\<\[Infinity]\>\"", ",", 
              "\"\<\!\(\*SubscriptBox[\(\[Aleph]\), \(0\)]\)\>\"", ",", 
              "\"\<\!\(\*SubscriptBox[\(\[Aleph]\), \(1\)]\)\>\"", ",", 
              "\"\<\!\(\*SuperscriptBox[\(2\), SubscriptBox[\(\[Aleph]\), \(0\
\)]]\)\>\""}], "}"}]}], ",", 
           RowBox[{"\"\<powerset\>\"", "\[Rule]", 
            RowBox[{"{", "\"\<\[ScriptCapitalP]\>\"", "}"}]}]}], "|>"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
        "sample1", "=", 
         "\"\<positive Integers Real positive negative for every number such \
that set of any some then if true false there is are since therefore \
is\>\""}], ";", "\[IndentingNewLine]", 
        RowBox[{"words", "=", 
         RowBox[{"<|", 
          RowBox[{"\"\<general\>\"", "\[Rule]", 
           RowBox[{"Sort", "@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"StringJoin", "[", 
                RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{"DeleteDuplicates", "[", 
                RowBox[{"StringSplit", "[", "sample1", "]"}], "]"}], ")"}]}], 
             ")"}]}]}], "|>"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"sym", "=", 
         RowBox[{"{", 
          RowBox[{
          "\"\<p\>\"", ",", "\"\<q\>\"", ",", "\"\<r\>\"", ",", "\"\<x\>\"", 
           ",", "\"\<y\>\"", ",", "\"\<z\>\"", ",", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"\"\<x\>\"", "^", "2"}], ",", "TraditionalForm"}], "]"}],
            ",", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"\"\<y\>\"", "^", "2"}], ",", "TraditionalForm"}], "]"}],
            ",", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"Sqrt", "[", 
              RowBox[{
               RowBox[{"\"\<x\>\"", "^", "2"}], "+", 
               RowBox[{"\"\<y\>\"", "^", "2"}]}], "]"}], ",", 
             "TraditionalForm"}], "]"}], ",", 
           RowBox[{"ToString", "[", 
            RowBox[{
             RowBox[{"Sqrt", "[", "\"\<\>\"", "]"}], ",", "TraditionalForm"}],
             "]"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expr", "=", 
         RowBox[{"{", "\"\< \>\"", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"pad1", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<quants\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<member\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<subset\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<sets\>\"", "]"}]}], ")"}], "~", 
          "\[IndentingNewLine]", "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Tooltip", "[", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"expr", ",", "#"}], "]"}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], 
                "]"}], ",", "\"\<Power Set\>\""}], "]"}], "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<powerset\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<logic\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"#", ",", "StandardForm"}], "]"}]}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"(", "sym", ")"}]}], ")"}], "~", "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<arith\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<eq\>\"", "]"}]}], ")"}], "~", "Join", 
          "~", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Button", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"expr", ",", "#"}], "]"}], ",", 
               RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
             "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<seperators\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Tooltip", "[", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"expr", ",", "\"\< \>\""}], "]"}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], 
                "]"}], ",", "\"\<Space\>\""}], "]"}], "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<space\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Tooltip", "[", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"expr", ",", "\"\<\\n \>\""}], "]"}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], 
                "]"}], ",", "\"\<New Line\>\""}], "]"}], "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<enter\>\"", "]"}]}], ")"}], "~", 
          "Join", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Tooltip", "[", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", "expr", "]"}], ">", "0"}], ",", 
                   RowBox[{"expr", "=", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"expr", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}]}], "]"}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], 
                "]"}], ",", "\"\<Delete\>\""}], "]"}], "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<del\>\"", "]"}]}], ")"}], "~", "Join", 
          "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Tooltip", "[", 
              RowBox[{
               RowBox[{"Button", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"expr", "=", 
                  RowBox[{"{", "\"\< \>\"", "}"}]}], ",", 
                 RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], 
                "]"}], ",", "\"\<Clear All\>\""}], "]"}], "&"}], "/@", 
            RowBox[{"assoc", "[", "\"\<clear\>\"", "]"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"pad2", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{"#", ",", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"expr", ",", "#"}], "]"}], ",", 
              RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
            "&"}], "/@", 
           RowBox[{"assoc", "[", "\"\<digits\>\"", "]"}]}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pad3", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Button", "[", 
             RowBox[{"#", ",", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"expr", ",", "#"}], "]"}], ",", 
              RowBox[{"Appearance", "\[Rule]", "\"\<Palette\>\""}]}], "]"}], 
            "&"}], "/@", 
           RowBox[{"words", "[", "\"\<general\>\"", "]"}]}], ")"}]}], ";"}], 
       ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Permissions", "->", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722876853090372*^9, 3.7228769169439507`*^9}, 
   3.722877112661606*^9},ExpressionUUID->"e02da355-5532-4d7d-a393-\
0d93a81aba4e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/0279bdbb-8fcd-4775-8301-\
7991cdefbb5c\"",
     "https://www.wolframcloud.com/objects/0279bdbb-8fcd-4775-8301-\
7991cdefbb5c"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/0279bdbb-8fcd-4775-8301-7991cdefbb5c"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{{3.722876847398258*^9, 3.722876918128673*^9}, 
   3.722877077375064*^9, {3.722877114747525*^9, 
   3.722877119262994*^9}},ExpressionUUID->"220c9f43-e488-4199-960b-\
ac969a593558"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{534, Automatic}, {Automatic, 44}},
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 16214, 395, 1322, "Input",ExpressionUUID->"e94cc8ad-ec72-48f8-a68d-7f1ad0cc169f"],
Cell[16797, 419, 7624, 167, 509, "Output",ExpressionUUID->"d243e2de-4c99-44af-8531-405ece6dded9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24458, 591, 17127, 400, 1408, "Input",ExpressionUUID->"e02da355-5532-4d7d-a393-0d93a81aba4e"],
Cell[41588, 993, 615, 15, 37, "Output",ExpressionUUID->"220c9f43-e488-4199-960b-ac969a593558"]
}, Open  ]]
}
]
*)

