(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    261987,       5358]
NotebookOptionsPosition[    261335,       5339]
NotebookOutlinePosition[    261703,       5355]
CellTagsIndexPosition[    261660,       5352]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9, 3.772617869780849*^9, {3.772717208049241*^9, 
   3.772717208858294*^9}, {3.772717660184099*^9, 3.77271766257882*^9}},
 CellLabel->
  "In[346]:=",ExpressionUUID->"d6c51a68-17a0-48f8-a859-ba05498dddb1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"CloudConnect", "[", 
  RowBox[{"\"\<wayne@compclassnotes.com\>\"", ",", "\"\<Wolf!123\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"DeleteObject", "@", 
  InterpretationBox[
   RowBox[{"CloudObject", "[", 
    TemplateBox[{
     "\"https://www.wolframcloud.com/obj/ccn/lambda\"",
      "https://www.wolframcloud.com/obj/ccn/lambda"},
     "HyperlinkURL"], "]"}],
   CloudObject["https://www.wolframcloud.com/obj/ccn/lambda"],
   SelectWithContents->True]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ClearNotations", "[", "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"TODO", ":", "\[IndentingNewLine]", 
     RowBox[{"1.", " ", "Does", " ", "not", " ", "parallelize"}]}], ",", " ", 
    
    RowBox[{
    "requires", " ", "removing", " ", "of", " ", "global", " ", "vars"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", "operators", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Notation", "[", 
   RowBox[{
    TemplateBox[{RowBox[{"(", 
        RowBox[{"\[Paragraph]", " ", "i_", " ", "op_", " ", "x_"}], " ", 
        ")"}]},
     "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
    TemplateBox[{RowBox[{
        RowBox[{"AppendTo", "[", 
          RowBox[{"order", ",", "i_"}], "]"}], ";", 
        RowBox[{"AppendTo", "[", 
          RowBox[{"\[Xi]2", ",", 
            RowBox[{"i_", "->", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}]}], "]"}], ";", 
        RowBox[{"Construct", "[", 
          RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
     "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{
          "\[Paragraph]", " ", "i_", " ", "op_", " ", "x_", " ", "y_"}], 
         ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"AppendTo", "[", 
           RowBox[{"order", ",", "i_"}], "]"}], ";", 
         RowBox[{"AppendTo", "[", 
           RowBox[{"\[Xi]2", ",", 
             RowBox[{"i_", "->", 
               RowBox[{"If", "[", 
                 RowBox[{
                   RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], "}"}], ",", 
                   "Nothing"}], "]"}]}]}], "]"}], ";", 
         RowBox[{"Construct", "[", 
           RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FIXME", ":", " ", 
     RowBox[{"kludge", " ", "tag", " ", "for", " ", "e2"}]}], ",", " ", 
    RowBox[{"since", " ", "if", " ", 
     RowBox[{"(", 
      RowBox[{"\[Paragraph]", " ", "k_", " ", "e2_"}], ")"}], " ", "does", 
     " ", "not", " ", "expand", " ", "instead", " ", "explands", " ", 
     RowBox[{"(", 
      RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
       RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], " ", "first"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"FIXME", ":", " ", 
    RowBox[{
     RowBox[{
     "make", " ", "sure", " ", "tag", " ", "for", " ", "e2", " ", "as", " ", 
      "i"}], "+", 
     RowBox[{
     "1", " ", "to", " ", "avoid", " ", "the", " ", "issue", " ", 
      "above"}]}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{
           RowBox[{"\[Paragraph]", " ", "j_"}], ",", 
           RowBox[{"k_", " ", 
             RowBox[{"(", 
               RowBox[{
                 RowBox[{"(", 
                   RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
                    RowBox[{"x_", " ", ".", "  ", "expr_"}]}], ")"}], " ", 
                 "e2_"}], ")"}]}]}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     "\[IndentingNewLine]", 
     TemplateBox[{RowBox[{"Block", "[", 
         RowBox[{
           RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"j_", ";", 
             RowBox[{"AppendTo", "[", 
               RowBox[{"order", ",", "i_"}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]2", ",", 
                 RowBox[{"i_", "->", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", "\"\"", ",", 
                    "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]6", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"(", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
                    ",", "\"]\""}], "}"}]}], ")"}], ")"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"\[Beta]ONLY\[Xi]", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"\[Beta]ONLY\[Xi]", ",", 
                    RowBox[{"i_", "->", 
                    RowBox[{"{", 
                    RowBox[{"\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], 
                    "}"}]}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"\[Beta]\[Xi]", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"\[Beta]\[Xi]", ",", 
                    RowBox[{"Last", "@", 
                    RowBox[{"Normal", "@", "\[Xi]2"}]}]}], "]"}]}]}], "]"}], 
             ";", 
             RowBox[{
               RowBox[{"Function", "[", 
                 RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
    "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
    " ", "replacements", " ", "into", " ", "\[Xi]2"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
           RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Block", "[", 
         RowBox[{
           RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
             RowBox[{"AppendTo", "[", 
               RowBox[{"order", ",", "i_"}], "]"}], ";", 
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]2", ",", 
                 RowBox[{"i_", "->", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", "\"[\"", ",", 
                    " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\
\[ScriptI]\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\
\[ScriptE]\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}]}], "]"}], ";", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"AppendTo", "[", 
                   RowBox[{"\[Xi]3", ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"AppendTo", "[", 
                   RowBox[{"\[Xi]1", ",", "tmp"}], "]"}]}], "]"}], ";", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"\[Alpha]\[Xi]", "=", 
                   RowBox[{"Append", "[", 
                    RowBox[{"\[Alpha]\[Xi]", ",", 
                    RowBox[{"Last", "@", 
                    RowBox[{"Normal", "@", "\[Xi]2"}]}]}], "]"}]}]}], "]"}], 
             ";", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"AppendTo", "[", 
                   RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", "tmp", "]"}]}], "}"}], ")"}]}]}],
                    "]"}]}], "]"}], ";", 
             RowBox[{
               RowBox[{"Function", "[", 
                 RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", "which",
     " ", 
    RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
    "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
    "complete", " ", 
    RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"\[Paragraph]", " ", "i_", " ", "x_"}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"AppendTo", "[", 
           RowBox[{"order", ",", "i_"}], "]"}], ";", 
         RowBox[{"AppendTo", "[", 
           RowBox[{"\[Xi]2", ",", 
             RowBox[{"If", "[", 
               RowBox[{
                 RowBox[{"order2", "=!=", 
                   RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"i_", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ")"}]}], ",", 
                 "Nothing"}], "]"}]}], "]"}], ";", "x_"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ", 
    "operators"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"StringReplace", "[", 
         RowBox[{"x_", ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
               RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
               RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
               RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
               RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
               RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
               RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
               RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
               RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
               RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
               RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
               RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
               RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
   " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"ToString", "/@", 
             RowBox[{"Level", "[", 
               RowBox[{"x_", ",", 
                 RowBox[{"{", 
                   RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"Table", "[", 
             RowBox[{
               RowBox[{"StringTake", "[", 
                 RowBox[{"i", ",", "1"}], "]"}], ",", 
               RowBox[{"{", 
                 RowBox[{"i", ",", 
                   RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
             "]"}], ",", "NameQ"}], "]"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"operator", " ", "for", " ", 
    RowBox[{"initialization", "."}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"\[Xi]1", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Xi]5", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[Xi]6", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[Xi]2", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[Xi]3", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Xi]4", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Alpha]\[Xi]", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[Beta]\[Xi]", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[Beta]ONLY\[Xi]", "=", 
           RowBox[{"<|", "|>"}]}], ";", 
         RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
         RowBox[{"order", "=", 
           RowBox[{"{", "}"}]}], ";"}]},
      "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"init", "[", "]"}], ":=", 
    RowBox[{
    "{", "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     
     RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"(", 
            RowBox[{"\[Paragraph]", " ", "i_", " ", "op_", " ", "x_"}], " ", 
            ")"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{
            RowBox[{"AppendTo", "[", 
              RowBox[{"order", ",", "i_"}], "]"}], ";", 
            RowBox[{"AppendTo", "[", 
              RowBox[{"\[Xi]2", ",", 
                RowBox[{"i_", "->", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], "}"}], ",", 
                    "Nothing"}], "]"}]}]}], "]"}], ";", 
            RowBox[{"Construct", "[", 
              RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"(", 
            
            RowBox[{"\[Paragraph]", " ", "i_", " ", "op_", " ", "x_", " ", 
              "y_"}], ")"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{
            RowBox[{"AppendTo", "[", 
              RowBox[{"order", ",", "i_"}], "]"}], ";", 
            RowBox[{"AppendTo", "[", 
              RowBox[{"\[Xi]2", ",", 
                RowBox[{"i_", "->", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], "}"}], ",", 
                    "Nothing"}], "]"}]}]}], "]"}], ";", 
            RowBox[{"Construct", "[", 
              RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
        "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
        "assumer", " ", "expr", " ", "is", " ", "tagged", " ", "as", " ", 
         "i"}], "+", "1"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Notation", "[", 
         RowBox[{
          TemplateBox[{RowBox[{"(", 
              RowBox[{"\[Paragraph]", " ", "j_", " ", 
                RowBox[{"(", 
                  RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
                    RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], " ", 
                RowBox[{"(", 
                  RowBox[{"\[Paragraph]", " ", "k_", " ", "e2_"}], ")"}]}], 
              ")"}]},
           "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
          "\[IndentingNewLine]", 
          TemplateBox[{RowBox[{"Block", "[", 
              RowBox[{
                RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                  RowBox[{"AppendTo", "[", 
                    RowBox[{"order", ",", "j_"}], "]"}], ";", 
                  RowBox[{"AppendTo", "[", 
                    RowBox[{"order", ",", "i_"}], "]"}], ";", 
                  "\[IndentingNewLine]", 
                  RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]2", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", "\"\"", ",", 
                    "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", "j_", ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", "i_", ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
                  RowBox[{
                    RowBox[{"Function", "[", 
                    RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", 
                    "]"}]}]}], "]"}]},
           "NotationTemplateTag"]}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"FIXME", ":", " ", 
         RowBox[{"kludge", " ", "tag", " ", "for", " ", "e2"}]}], ",", " ", 
        RowBox[{"since", " ", "if", " ", 
         RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "k_", " ", "e2_"}], ")"}], " ", "does",
          " ", "not", " ", "expand", " ", "instead", " ", "explands", " ", 
         RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
           RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], " ", "first"}]}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"FIXME", ":", " ", 
        RowBox[{
         RowBox[{
         "make", " ", "sure", " ", "tag", " ", "for", " ", "e2", " ", "as", 
          " ", "i"}], "+", 
         RowBox[{
         "1", " ", "to", " ", "avoid", " ", "the", " ", "issue", " ", 
          "above"}]}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"(", 
            RowBox[{
              RowBox[{"\[Paragraph]", " ", "j_"}], ",", 
              RowBox[{"k_", " ", 
                RowBox[{"(", 
                  RowBox[{
                    RowBox[{"(", 
                    
                    RowBox[{
                    "\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
                    RowBox[{"x_", " ", ".", "  ", "expr_"}]}], ")"}], " ", 
                    "e2_"}], ")"}]}]}], ")"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        "\[IndentingNewLine]", 
        TemplateBox[{RowBox[{"Block", "[", 
            RowBox[{
              RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"j_", ";", 
                RowBox[{"AppendTo", "[", 
                  RowBox[{"order", ",", "i_"}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"AppendTo", "[", 
                  RowBox[{"\[Xi]2", ",", 
                    RowBox[{"i_", "->", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", "\"\"", ",", 
                    "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]6", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"(", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
                    ",", "\"]\""}], "}"}]}], ")"}], ")"}]}]}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}]}], "]"}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"\[Beta]ONLY\[Xi]", "=", 
                    RowBox[{"Append", "[", 
                    RowBox[{"\[Beta]ONLY\[Xi]", ",", 
                    RowBox[{"i_", "->", 
                    RowBox[{"{", 
                    RowBox[{"\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], "]"}]}], "}"}], 
                    ")"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "k_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], 
                    "}"}]}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"\[Beta]\[Xi]", "=", 
                    RowBox[{"Append", "[", 
                    RowBox[{"\[Beta]\[Xi]", ",", 
                    RowBox[{"Last", "@", 
                    RowBox[{"Normal", "@", "\[Xi]2"}]}]}], "]"}]}]}], "]"}], 
                ";", 
                RowBox[{
                  RowBox[{"Function", "[", 
                    RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", 
                  "]"}]}]}], "]"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
        "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "all", " ", "other", " ", "interm", " ", "transformations", " ", "and",
         " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"(", 
            RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
              RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{"Block", "[", 
            RowBox[{
              RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
                RowBox[{"AppendTo", "[", 
                  RowBox[{"order", ",", "i_"}], "]"}], ";", 
                RowBox[{"AppendTo", "[", 
                  RowBox[{"\[Xi]2", ",", 
                    RowBox[{"i_", "->", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", "\"[\"", ",", 
                    " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\
\[ScriptI]\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\
\[ScriptE]\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}]}], "]"}], ";", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]3", ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{"x_", ",", "\"\[LongRightArrow]\"", ",", " ", 
                    "tmp"}], "}"}], "]"}]}], "]"}]}], "]"}], ";", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]1", ",", "tmp"}], "]"}]}], "]"}], ";", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\[Alpha]\[Xi]", "=", 
                    RowBox[{"Append", "[", 
                    RowBox[{"\[Alpha]\[Xi]", ",", 
                    RowBox[{"Last", "@", 
                    RowBox[{"Normal", "@", "\[Xi]2"}]}]}], "]"}]}]}], "]"}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"\[Xi]5", ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i_", "+", "1"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"ToString", "[", "x_", "]"}], ")"}], "\[Rule]", 
                    RowBox[{"ToString", "[", "tmp", "]"}]}], "}"}], ")"}]}]}],
                     "]"}]}], "]"}], ";", 
                RowBox[{
                  RowBox[{"Function", "[", 
                    RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", 
                  "]"}]}]}], "]"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
        "which", " ", 
        RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", 
        " ", "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", 
        " ", "complete", " ", 
        RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Notation", "[", 
         RowBox[{
          TemplateBox[{RowBox[{"(", 
              RowBox[{"\[Paragraph]", " ", "i_", " ", 
                RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
           "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
          TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
              RowBox[{"{", 
                RowBox[{"i_", ",", 
                  RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
           "NotationTemplateTag"]}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"(", 
            RowBox[{"\[Paragraph]", " ", "i_", " ", "x_"}], ")"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{
            RowBox[{"AppendTo", "[", 
              RowBox[{"order", ",", "i_"}], "]"}], ";", 
            RowBox[{"AppendTo", "[", 
              RowBox[{"\[Xi]2", ",", 
                RowBox[{"If", "[", 
                  RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"i_", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ")"}]}], ",", 
                    "Nothing"}], "]"}]}], "]"}], ";", "x_"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", 
        " ", "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{"StringReplace", "[", 
            RowBox[{"x_", ",", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                  RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                  RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                  RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                  RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                  RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                  RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                  RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                  RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                  RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                  RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                  RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                  RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}],
        " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{"Select", "[", 
            RowBox[{
              RowBox[{"ToString", "/@", 
                RowBox[{"Level", "[", 
                  RowBox[{"x_", ",", 
                    RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
            "]"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{"Select", "[", 
            RowBox[{
              RowBox[{"Table", "[", 
                RowBox[{
                  RowBox[{"StringTake", "[", 
                    RowBox[{"i", ",", "1"}], "]"}], ",", 
                  RowBox[{"{", 
                    RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
                "]"}], ",", "NameQ"}], "]"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"operator", " ", "for", " ", 
        RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Notation", "[", 
       RowBox[{
        TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
         "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
        TemplateBox[{RowBox[{
            RowBox[{"\[Xi]1", "=", 
              RowBox[{"{", "}"}]}], ";", 
            RowBox[{"\[Xi]5", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[Xi]6", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[Xi]2", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[Xi]3", "=", 
              RowBox[{"{", "}"}]}], ";", 
            RowBox[{"\[Xi]4", "=", 
              RowBox[{"{", "}"}]}], ";", 
            RowBox[{"\[Alpha]\[Xi]", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[Beta]\[Xi]", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[Beta]ONLY\[Xi]", "=", 
              RowBox[{"<|", "|>"}]}], ";", 
            RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
            RowBox[{"order", "=", 
              RowBox[{"{", "}"}]}], ";"}]},
         "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[Omicron]", ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"eval\[Lambda]", "[", 
        RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
           ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"order2", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "pass1", " ", "collect", " ", "order", " ", "of", " ", 
            "evaluations"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"input", "=", 
           RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
          "\[Omicron]", ";", "\[IndentingNewLine]", 
          RowBox[{"output1", "=", 
           RowBox[{"ReleaseHold", "[", "expr", "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
          RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "pass1", " ", "collect", " ", "order", " ", "of", " ", 
            "evaluations"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"input", "=", 
           RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
          "\[Omicron]", ";", "\[IndentingNewLine]", 
          RowBox[{"output2", "=", 
           RowBox[{"ReleaseHold", "[", "expr", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"bound", "=", 
           RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Xi]4", "=", 
           RowBox[{"ToExpression", "/@", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"DeleteCases", "[", 
               RowBox[{
                RowBox[{"\[Nu]", " ", "output1"}], ",", "\"\<tmp\>\""}], 
               "]"}], ",", "bound"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
               RowBox[{"\[Xi]4", "=!=", 
                RowBox[{"{", "}"}]}]}], ",", 
              RowBox[{"output2", "=", " ", 
               RowBox[{
                RowBox[{"\[CurlyRho]", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "/.", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"\[Xi]4", "[", 
                    RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
                   RowBox[{"\[CurlyRho]", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"jj", ",", "1", ",", 
                    RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}],
              "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"pass2", "=", 
           RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", "output1"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<free\>\"", "->", 
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"\[Nu]", " ", "output2"}], ",", "\"\<tmp\>\""}], 
                 "]"}], ",", "bound"}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"\"\<bound\>\"", "\[Rule]", 
              RowBox[{"Intersection", "[", 
               RowBox[{
                RowBox[{"DeleteCases", "[", 
                 RowBox[{
                  RowBox[{"\[Nu]", " ", "output2"}], ",", "\"\<tmp\>\""}], 
                 "]"}], ",", "bound"}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<order\>\"", "\[Rule]", "order2"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<replace\>\"", "->", "\[Xi]5"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<replace2\>\"", "->", "\[Xi]6"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<\[Alpha]\>\"", "->", "\[Alpha]\[Xi]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<\[Beta]\>\"", "\[Rule]", "\[Beta]\[Xi]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\<\[Beta]ONLY\>\"", "\[Rule]", "\[Beta]ONLY\[Xi]"}], 
             ",", "\[IndentingNewLine]", 
             RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"<|", 
                RowBox[{"Sequence", "@@", 
                 RowBox[{"Map", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}], "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"(", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}], ")"}]}], "&"}], 
                   " ", ",", 
                   RowBox[{"Normal", "@", "\[Rho]"}]}], "]"}]}], "|>"}], 
               ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "|>"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "pass2"}]}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"trace\[Lambda]", "[", "res_", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"MissingQ", "[", 
             RowBox[{
              RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
              RowBox[{
               RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "True"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Row", "[", 
            RowBox[{
             RowBox[{"res", "[", "\"\<trace\>\"", "]"}], "[", 
             RowBox[{
              RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
              RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"StringReplace", "[", 
            RowBox[{
             RowBox[{"StringJoin", "[", 
              RowBox[{
               RowBox[{"res", "[", "\"\<trace\>\"", "]"}], "[", 
               RowBox[{
                RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
              RowBox[{
               RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}], "]"}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "@", 
            RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"trace\[Beta]", "[", "res_", "]"}], ":=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"MissingQ", "[", 
             RowBox[{
              RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
              RowBox[{
               RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Equal]", 
            "True"}], ",", "\[IndentingNewLine]", "Nothing", ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"MissingQ", "[", 
               RowBox[{
                RowBox[{"res", "[", "\"\<replace2\>\"", "]"}], "[", 
                RowBox[{
                 RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Equal]", 
              "False"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Row", "@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"StringJoin", "[", 
                   RowBox[{
                    RowBox[{"res", "[", "\"\<trace\>\"", "]"}], "[", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
                   RowBox[{
                    RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}], ",", 
                RowBox[{
                 RowBox[{"res", "[", "\"\<replace2\>\"", "]"}], "[", 
                 RowBox[{
                  RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}]}], ",", 
             "Nothing"}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "@", 
            RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Alpha]0", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 \
x))\>\"", ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                 ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", "  ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "1", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y \
x)))\>\"", ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"Column", "[", 
               RowBox[{"Row", "/@", 
                RowBox[{"(", 
                 RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", "2", ",", "3"}], 
               "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Alpha]-Conversion\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]",
                    "parsetrace"}], "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", "}"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}]}], "\[IndentingNewLine]", 
               "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Alpha]1", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 \
x))\>\"", ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", "  ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "1", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y \
x)))\>\"", ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"Column", "[", 
               RowBox[{"Row", "/@", 
                RowBox[{"(", 
                 RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"Row", "/@", 
                   RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                  "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "\[Rule]", 
                   RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}]}], 
                  "}"}]}], ",", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"Row", "/@", 
                   RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                  "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Alpha]\>\"", "\[Rule]", "\"\<\[Beta]\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Alpha]-Conversion\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Column", "[", 
                    RowBox[{"Row", "/@", 
                    RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "}"}]}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                   RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Column", "[", 
                 RowBox[{"Row", "/@", 
                  RowBox[{"(", 
                   RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                 "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]",
               ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Alpha]2", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression", ",", "\[Rho]"}], 
          "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Clear", "[", "res", "]"}], ";", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Module", "[", 
                   RowBox[{
                    RowBox[{"{", "\[Rho]0", "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"\[Rho]0", "=", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<stitch\>\"", "\[Rule]", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{"StringJoin", "@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 \>\"", ",", "rules2"}], "]"}], ",", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    RowBox[{"\[Rho]0", "[", "1", "]"}], ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
                    RowBox[{"1", "+", "1"}], "]"}]}], "]"}], ",", "\"\<)\>\"",
                     ",", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\< (ops3 2 x))\>\"", ",", "rules2"}], "]"}]}], 
                    "}"}]}], ")"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 \
x))\>\"", ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                   "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]",
                  "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"Clear", "[", "res", "]"}], ";", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Module", "[", 
                   RowBox[{
                    RowBox[{"{", "\[Rho]0", "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"\[Rho]0", "=", 
                    RowBox[{"<|", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "|>"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", "  ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", "  ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "1", " ", "ops3", " ", "2", "  ", 
                    "x"}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<stitch\>\"", "\[Rule]", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{"StringJoin", "@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 (ops3 2 x) \>\"", ",", "rules2"}], 
                    "]"}], ",", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    RowBox[{"\[Rho]0", "[", "2", "]"}], ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
                    RowBox[{"2", "+", "1"}], "]"}]}], "]"}], ",", 
                    "\"\<)\>\""}], "}"}]}], ")"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y \
x)))\>\"", ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                   "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox[
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"TODO", ":", " ", 
                 RowBox[{
                 "this", " ", "needs", " ", "to", " ", "be", " ", "a", " ", 
                  RowBox[{"colum", "@", 
                   RowBox[{"{", "}"}]}]}]}], ",", " ", 
                RowBox[{"assymed", " ", "single", " ", "alpha"}]}], "*)"}],
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"\[Mho]", " ", 
               RowBox[{"ReleaseHold", "@", 
                RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}]}]}]}], ";",
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"Row", "/@", 
                   RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                  "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "\[Rule]", 
                   RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}]}], 
                  "}"}]}], ",", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"Row", "/@", 
                   RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                  "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Alpha]\>\"", "\[Rule]", "\"\<\[Beta]\>\""}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"\[Mho]", " ", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], 
                    "]"}]}], ")"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "]"}], 
                    "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ops", "=", 
                  RowBox[{"RandomChoice", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
                    "}"}]}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"StringReplace", "[", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], 
                    "]"}]}], ")"}], ",", "ops"}], "]"}]}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ops", "=", 
                  RowBox[{"RandomChoice", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
                    "}"}]}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"StringReplace", "[", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], 
                    "]"}]}], ")"}], ",", "ops"}], "]"}]}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"ops", "=", 
                  RowBox[{"RandomChoice", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
                    "}"}]}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"StringReplace", "[", 
                  RowBox[{
                   RowBox[{"StringReplace", "[", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"ReleaseHold", "[", 
                    RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], 
                    "]"}]}], ")"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "]"}], 
                    "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}], 
                    "]"}]}], "}"}]}], "]"}], ",", "ops"}], "]"}]}]}], 
               "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Perform \[Alpha]-Conversions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Perform \[Alpha]-Conversions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Alpha]-Conversion\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Column", "[", 
                    RowBox[{"Row", "/@", 
                    RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                    "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "}"}]}]}], ";", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                   RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Column", "[", 
                 RowBox[{"Row", "/@", 
                  RowBox[{"(", 
                   RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                 "]"}]}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]",
               ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Beta]0", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 y x)) (ops3 y x))\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "y", "  ", 
                    "x"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] x . (ops1 y x)) (ops3 y x))\>\"", 
                    ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "|>"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] y . (ops1 y x)) (ops3 y x))\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "3", " ", "ops3", " ", "y", "  ",
                     "x"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] y . (ops1 y x)) (ops3 y x))\>\"", 
                    ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "|>"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"Column", "[", 
               RowBox[{"Row", "/@", 
                RowBox[{"(", 
                 RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", "2", ",", "3"}], 
               "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Beta]-Reduction\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]",
                    "parsetrace"}], "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", "}"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}]}], "\[IndentingNewLine]", 
               "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Beta]", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"y2", ",", "x2"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<u\>\"", ",", 
                  "\"\<w\>\"", ",", "\"\<z\>\"", ",", "\"\<2\>\"", ",", 
                  "\"\<6\>\"", ",", "\"\<7\>\""}], "}"}], ",", "2"}], "]"}]}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<x2\>\"", "\[Rule]", "x2"}], ",", 
                RowBox[{"\"\<y2\>\"", "\[Rule]", "y2"}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 y x)) (ops3 y2 x2))\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y2 x2)\>\"", ",", "rules2"}], 
                    "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "|>"}], ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "y2", "  ", 
                    "x2"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] x . (ops1 y x)) (ops3 y2 x2))\>\"", 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] y . (ops1 y x)) (ops3 y2 x2))\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops1 y x))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y2 x2)\>\"", ",", "rules2"}], 
                    "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "|>"}], ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"3", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops3", " ", "y2", "  ", 
                    "x2"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] y . (ops1 y x)) (ops3 y2 x2))\>\"", 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "y"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "x"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], "\[IndentingNewLine]", 
             RowBox[{"correct", "=", 
              RowBox[{"Sequence", "@@", 
               RowBox[{"(", 
                RowBox[{"trace\[Beta]", "[", "res", "]"}], ")"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"(", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], ")"}]}], ")"}],
                  "/.", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Beta]\>\"", "\[Rule]", "\"\<\[Alpha]\>\""}], 
                  "}"}]}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"Sequence", "@@", 
                   RowBox[{"(", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], ")"}]}], ")"}],
                  "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "\[Rule]", 
                   RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}]}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify all the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify all the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Beta]-Reduction\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Sequence", "@@", 
                    RowBox[{"(", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], ")"}]}]}], " ",
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Sequence", "@@", 
                 RowBox[{"(", 
                  RowBox[{"trace\[Beta]", "[", "res", "]"}], ")"}]}]}], " ", 
               "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
            ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Alpha]\[Beta]0", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) \
(ops3 y x))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) \
x)))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"5", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y x)\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"5", 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "ops1", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "3", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "4", " ", "ops2", " ", "3", " ", 
                    "y"}], ")"}]}]}], ")"}], " ", "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "5", " ", "ops3", " ", "y", "  ", 
                    "x"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", 
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) \
(ops3 y x))\>\"", ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "|>"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) \
(ops3 u w))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) \
x)))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"5", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 u w)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"6", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<x\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], " ", ",", 
                    RowBox[{"5", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "ops1", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "3", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "4", " ", "ops2", " ", "3", " ", 
                    "y"}], ")"}]}]}], ")"}], " ", "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "5", " ", "ops3", " ", "u", "  ", 
                    "w"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 \
y)) x)) (ops3 u w))\>\"", ")"}]}]}], "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", "|>"}]}], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
             
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"Column", "[", 
               RowBox[{"Row", "/@", 
                RowBox[{"(", 
                 RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], "]"}]}], 
             ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", "2", ",", "3"}], 
               "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions if any\\n\>\"", 
                    ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{"\"\<\[Beta]-Reduction\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]",
                    "parsetrace"}], "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", "}"}]}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}]}], "\[IndentingNewLine]", 
               "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"logic\[Lambda]\[Alpha]\[Beta]", "[", 
        RowBox[{"ctr0_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
           "aa", ",", "a", ",", "b", ",", "c", ",", "example", ",", "choices",
            ",", 
           RowBox[{"molecule", "=", 
            RowBox[{"{", "}"}]}], ",", 
           RowBox[{"wrongmolecule", "=", 
            RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", "parsetrace", 
           ",", "list", ",", "trace", ",", "trace0", ",", "res", ",", "tmp1", 
           ",", "tmp2", ",", "tmp3", ",", "tmp4", ",", "tmp5", ",", "tmp6", 
           ",", "tmp7", ",", "ops", ",", "ops0", ",", "ops1", ",", "ops2", 
           ",", "ops3", ",", "ops4", ",", "ops5", ",", "ops6", ",", "ops7", 
           ",", "rules", ",", "rules2", ",", "expression"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"vv", "=", 
           RowBox[{"Release", "@", 
            RowBox[{"Map", "[", 
             RowBox[{
              RowBox[{"Hold", "[", 
               RowBox[{"RandomChoice", "@", 
                RowBox[{"{", 
                 RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
              ",", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"Complement", "[", 
                 RowBox[{
                  RowBox[{"CharacterRange", "[", 
                   RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                    "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
             "]"}]}]}], 
          StyleBox[";",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{"correct", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"wrong", "=", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"choices", "=", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"While", "[", 
           RowBox[{
            RowBox[{"Or", "@@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "===", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
               RowBox[{"Permutations", "[", 
                RowBox[{"choices", ",", " ", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            StyleBox["\[IndentingNewLine]",
             FontWeight->"Plain"], 
            RowBox[{
             RowBox[{"ops0", "=", 
              RowBox[{
              "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"op1", "\[Rule]", "Plus"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op2", "\[Rule]", "Times"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"ops", "=", 
              RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", 
                RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", 
                "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"y2", ",", "x2"}], "}"}], "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "\"\<x\>\"", ",", "\"\<y\>\"", ",", "\"\<u\>\"", ",", 
                  "\"\<w\>\"", ",", "\"\<z\>\"", ",", "\"\<2\>\"", ",", 
                  "\"\<6\>\"", ",", "\"\<7\>\""}], "}"}], ",", "2"}], "]"}]}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"rules", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ops1", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
                RowBox[{"ops2", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
                RowBox[{"ops3", "\[Rule]", 
                 RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"rules2", "=", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<ops1\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops2\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<ops3\>\"", "\[Rule]", 
                 RowBox[{"ops", "[", 
                  RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}], ",", 
                RowBox[{"\"\<x2\>\"", "\[Rule]", "x2"}], ",", 
                RowBox[{"\"\<y2\>\"", "\[Rule]", "y2"}]}], "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"expression", "=", 
              RowBox[{"RandomChoice", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) \
(ops3 y2 x2))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) \
x)))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"5", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 y2 x2)\>\"", ",", "rules2"}], 
                    "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "|>"}], ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], ",", 
                    RowBox[{"5", 
                    RowBox[{"(", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "ops1", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "3", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "4", " ", "ops2", " ", "3", " ", 
                    "y"}], ")"}]}]}], ")"}], " ", "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "5", " ", "ops3", " ", "y2", "  ", 
                    "x2"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 \
y)) x)) (ops3 y2 x2))\>\"", ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"0", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) \
(ops3 x y))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"1", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) \
x)))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"2", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", 
                    "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"3", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{
                    "\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"4", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"5", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<(ops3 x y)\>\"", ",", "rules2"}], "]"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"6", "\[Rule]", 
                    RowBox[{"StringReplace", "[", 
                    RowBox[{"\"\<x\>\"", ",", "rules2"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
                    ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<hold\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"Hold", "[", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"\[Paragraph]", " ", "0"}], " ", ",", 
                    RowBox[{"5", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                    RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "2", " ", "ops1", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Paragraph]", " ", "3", " ", "\[Lambda]", " ", 
                    RowBox[{"y", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "4", " ", "ops2", " ", "3", " ", 
                    "y"}], ")"}]}]}], ")"}], " ", "x"}], ")"}]}]}], ")"}], 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "5", " ", "ops3", " ", "x", "  ", 
                    "y"}], ")"}]}], ")"}]}]}], ")"}], "]"}], ")"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<expr\>\"", "\[Rule]", 
                    RowBox[{
                    "(", "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 \
y)) x)) (ops3 x y))\>\"", ")"}]}], ",", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"\[Rho]", "=", 
              RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"res", "=", 
              RowBox[{"eval\[Lambda]", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", 
                 "rules"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", 
                  "rules2"}], "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"trace", "=", 
              RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"parsetrace", "=", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Evaluation: \>\"", ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", 
                    "rules"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace", ",", 
                   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
                   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
                "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             StyleBox["\[IndentingNewLine]",
              FontWeight->"Plain"], 
             RowBox[{"correct", "=", 
              RowBox[{"Column", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"Row", "/@", 
                   RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Column", "[", 
                  RowBox[{"trace\[Beta]", "[", "res", "]"}], "]"}]}], "}"}], 
               "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<None\>\"", ",", 
                RowBox[{"Column", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Column", "[", 
                    RowBox[{"Row", "/@", 
                    RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                    "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<\[Alpha]\>\"", "\[Rule]", "\"\<\[Beta]\>\""}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"Column", "[", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<\[Beta]\>\"", "\[Rule]", "\"\<\[Alpha]\>\""}], 
                    "}"}]}]}], "}"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"Column", "[", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Column", "[", 
                    RowBox[{"Row", "/@", 
                    RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Column", "[", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], "]"}]}], "}"}],
                   "]"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "\[Rule]", 
                   RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}]}], 
                  "}"}]}]}], "\[IndentingNewLine]", "}"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"wrong", "=", 
              RowBox[{"RandomSample", "[", 
               RowBox[{"wrong", ",", "3"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"choices", "=", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"If", " ", "[", 
           RowBox[{
            RowBox[{"mywords", "=!=", 
             RowBox[{"{", "}"}]}], ",", " ", 
            RowBox[{"words", "=", 
             RowBox[{"mywords", "[", 
              RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
            RowBox[{
             RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify all the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<question\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME1", "@", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    "ctr0", ",", 
                    "\"\<Identify the \[Alpha]-Conversions and \
\[Beta]-Reductions if any\\n\>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}]}], 
                 "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"(*", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ImageResize", "[", 
                   RowBox[{
                    RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
                 "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<example\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"example", "=", 
                RowBox[{"Column", "@", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    "\"\<\[Alpha]-Conversions and \[Beta]-Reductions\>\"", 
                    ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                    RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], 
                   ",", "\[IndentingNewLine]", 
                   RowBox[{"Column", "[", 
                    RowBox[{"Row", "/@", 
                    RowBox[{"(", 
                    RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"Column", "[", 
                    RowBox[{"trace\[Beta]", "[", "res", "]"}], "]"}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], 
               ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"makeEXAMPLE", "\[Equal]", "True"}], ",", "example", 
                 ",", 
                 RowBox[{"example", "=", 
                  RowBox[{"{", "}"}]}]}], "]"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
             "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
              "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
              "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
             RowBox[{
             "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{"Column", "@", 
                RowBox[{"{", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"Style", "[", 
                    RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                   "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "}"}]}], "*)"}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<solution\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Solution\>\"", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
                   RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], ",",
                 "\[IndentingNewLine]", 
                RowBox[{"Column", "[", 
                 RowBox[{"Row", "/@", 
                  RowBox[{"(", 
                   RowBox[{"Values", "@", 
                    RowBox[{"res", "[", "\"\<\[Alpha]\>\"", "]"}]}], ")"}]}], 
                 "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Column", "[", 
                 RowBox[{"trace\[Beta]", "[", "res", "]"}], "]"}]}], 
               "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
            ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<correct\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrong\>\"", "\[Rule]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<video\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"\"\<molecule\>\"", "\[Rule]", 
             RowBox[{"(", "molecule", ")"}]}], ",", " ", 
            RowBox[{"(*", 
             RowBox[{
             "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
              "example"}], "*)"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<abcd\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"{", "res", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "}"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"CloudSave", "[", 
  RowBox[{"init", ",", 
   RowBox[{"CloudObject", "[", "\"\</lambda\>\"", "]"}], ",", 
   RowBox[{"Permissions", "->", "\"\<Public\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.772621450563332*^9, 3.772621457209585*^9}, {
   3.7726214896942244`*^9, 3.7726215206173162`*^9}, {3.772621590970408*^9, 
   3.772621590996914*^9}, {3.772621694627057*^9, 3.772621694928823*^9}, {
   3.7726221156200027`*^9, 3.7726221161244993`*^9}, {3.7726222663873587`*^9, 
   3.7726222777920723`*^9}, {3.7726223962006607`*^9, 3.772622429715948*^9}, 
   3.7726228587521477`*^9, {3.772624377037305*^9, 3.772624392731822*^9}, {
   3.7726528986825657`*^9, 3.772652917437992*^9}, {3.772652995643586*^9, 
   3.772653009874446*^9}, {3.7726530478351717`*^9, 3.772653049439094*^9}, {
   3.7726540407498083`*^9, 3.7726540415579863`*^9}, {3.772654125035782*^9, 
   3.7726541253502207`*^9}, {3.772656168316392*^9, 3.7726561713861103`*^9}, 
   3.772656311609728*^9, {3.772657712440543*^9, 3.7726577249931602`*^9}, {
   3.77266271124646*^9, 3.772662711821637*^9}, {3.77266277694619*^9, 
   3.772662777328291*^9}, 3.772662820241228*^9, 3.7726629488652887`*^9, {
   3.7726629896684513`*^9, 3.772662989881096*^9}, {3.772663026411894*^9, 
   3.772663026612608*^9}, {3.772663088703685*^9, 3.772663090739448*^9}, 
   3.7726666781906357`*^9, 3.772666998007763*^9, {3.77266761971496*^9, 
   3.772667621827474*^9}, {3.772667685157764*^9, 3.772667685706573*^9}, {
   3.77266805783213*^9, 3.772668122900544*^9}, {3.7726685625047693`*^9, 
   3.772668586454028*^9}, {3.772696012280809*^9, 3.772696025679927*^9}, {
   3.772696073448432*^9, 3.772696132330346*^9}, {3.7726962454821243`*^9, 
   3.772696255516302*^9}, {3.7726962862821083`*^9, 3.7726963089022408`*^9}, {
   3.7726964207319593`*^9, 3.7726964891190367`*^9}, 3.772697388404653*^9, {
   3.772698702625886*^9, 3.772698714065999*^9}, {3.7726987654514933`*^9, 
   3.7726987986965637`*^9}, {3.772699199396449*^9, 3.772699216821624*^9}, {
   3.772699662610878*^9, 3.772699663835929*^9}, {3.772699718080703*^9, 
   3.772699718762248*^9}, {3.772699779811179*^9, 3.772699783545266*^9}, 
   3.7726999137043257`*^9, {3.772700487343964*^9, 3.772700499911003*^9}, {
   3.7727016456209717`*^9, 3.772701687798152*^9}, {3.772702048311962*^9, 
   3.772702072374218*^9}, {3.7727021083218184`*^9, 3.77270211612663*^9}, {
   3.772702181728948*^9, 3.772702190379285*^9}, 3.7727025737036963`*^9, {
   3.772702708174295*^9, 3.7727027120411463`*^9}, 3.7727028026779547`*^9, {
   3.772703102115817*^9, 3.772703104537876*^9}, 3.772703254696645*^9, {
   3.772703332714746*^9, 3.772703358923224*^9}, {3.772703465908174*^9, 
   3.7727034690467367`*^9}, {3.772703567777932*^9, 3.7727036102348127`*^9}, {
   3.7727039619753447`*^9, 3.7727039985577803`*^9}, 3.772704077945464*^9, 
   3.772704132351427*^9, 3.7727042216653214`*^9, {3.772704862311245*^9, 
   3.7727048774766273`*^9}, {3.772705019594089*^9, 3.772705021827921*^9}, {
   3.772705522124056*^9, 3.772705555435577*^9}, {3.772709526716898*^9, 
   3.7727095297636547`*^9}, {3.772709644034519*^9, 3.7727096782210617`*^9}, {
   3.772710455698419*^9, 3.77271047400095*^9}, 3.7727106692986393`*^9, {
   3.772710760659082*^9, 3.7727107646287107`*^9}, {3.772710876370688*^9, 
   3.772710881033011*^9}, {3.772711055235149*^9, 3.772711072607666*^9}, {
   3.7727112819265614`*^9, 3.7727113731281776`*^9}, {3.772713152076025*^9, 
   3.772713181558051*^9}, {3.7727132230158663`*^9, 3.772713276242342*^9}, {
   3.772713453149252*^9, 3.772713453580439*^9}, {3.772713750989222*^9, 
   3.772713766681642*^9}, {3.772713932874609*^9, 3.7727139499011374`*^9}, {
   3.77271632248999*^9, 3.7727163297897453`*^9}, {3.772716445423193*^9, 
   3.772716453464788*^9}, {3.772736370591382*^9, 3.7727363711942453`*^9}, {
   3.772736433227867*^9, 3.772736463714521*^9}, 3.772791900761485*^9, 
   3.772791948359412*^9, {3.7727919843063793`*^9, 3.772792020514181*^9}, {
   3.772793235609476*^9, 3.772793273747929*^9}, {3.77279333102177*^9, 
   3.772793391291967*^9}, {3.772793609629334*^9, 3.772793630024808*^9}, {
   3.7727937453711443`*^9, 3.77279377019042*^9}, {3.772793865211238*^9, 
   3.7727938708458567`*^9}, {3.7727939228481283`*^9, 
   3.7727939451793137`*^9}, {3.77279397520302*^9, 3.772794057385833*^9}, 
   3.772795285761483*^9, {3.7727956810283213`*^9, 3.772795682643708*^9}, {
   3.772801723141214*^9, 3.772801739137705*^9}, {3.7728018111432343`*^9, 
   3.772801824548828*^9}, {3.7728023103239813`*^9, 3.772802340866478*^9}, {
   3.7728026128497066`*^9, 3.772802616298902*^9}, {3.77280285992549*^9, 
   3.772802862691537*^9}, {3.772874543415694*^9, 3.7728746065532303`*^9}, 
   3.772875144220708*^9, {3.7728752509380417`*^9, 3.772875297909623*^9}, {
   3.7728753438438673`*^9, 3.77287540314406*^9}, {3.772875798026917*^9, 
   3.772875823048503*^9}, {3.772876321361783*^9, 3.7728763555151043`*^9}, {
   3.772876590646121*^9, 3.772876624305608*^9}, 3.772877051377294*^9, {
   3.772878369482252*^9, 3.772878377068788*^9}, {3.772878498852017*^9, 
   3.7728785686039753`*^9}, {3.772878975868486*^9, 3.772878995751678*^9}, {
   3.772879475627365*^9, 3.772879476672917*^9}, {3.773844506000709*^9, 
   3.773844528229525*^9}, {3.77384456029253*^9, 3.773844641547073*^9}, 
   3.7738447596625977`*^9, {3.773844997009038*^9, 3.773845013166876*^9}, {
   3.773845063434045*^9, 3.77384507367969*^9}, {3.7738499623246403`*^9, 
   3.773849964304418*^9}, {3.773850009151545*^9, 3.773850009945354*^9}, {
   3.773850575496423*^9, 3.773850579138632*^9}, {3.773851675598463*^9, 
   3.773851694140264*^9}, {3.773852097568078*^9, 3.7738521557500467`*^9}, {
   3.773852320310973*^9, 3.773852335149056*^9}, {3.773852777295662*^9, 
   3.7738528137606697`*^9}, {3.77385473244346*^9, 3.773854735762673*^9}, {
   3.773854770221949*^9, 3.7738548535527487`*^9}, {3.7738549196844463`*^9, 
   3.7738549237458763`*^9}, {3.773855099993278*^9, 3.7738551180203133`*^9}, 
   3.7738551724058332`*^9, {3.773855230611424*^9, 3.773855335659527*^9}, {
   3.77385537766152*^9, 3.773855379538142*^9}, 3.77385541309718*^9, 
   3.773855443207967*^9, 3.773855590892954*^9, 3.773855822368966*^9, 
   3.773855887491766*^9, {3.773855940133437*^9, 3.773855971108996*^9}, {
   3.7738560709935093`*^9, 3.7738561082139473`*^9}, {3.773856376833444*^9, 
   3.7738563984560223`*^9}, {3.77385687803098*^9, 3.773856895653463*^9}, {
   3.773856953055046*^9, 3.773856995412726*^9}, {3.773857054459784*^9, 
   3.773857087255291*^9}, {3.7738571615953608`*^9, 3.77385718060308*^9}, {
   3.7738572263394547`*^9, 3.773857229225913*^9}, {3.773861829767767*^9, 
   3.77386186061544*^9}, {3.773861908720977*^9, 3.7738619958654537`*^9}, {
   3.773862184477048*^9, 3.773862186272058*^9}, {3.773862248332159*^9, 
   3.7738623092765617`*^9}, {3.773863045538228*^9, 3.773863158792912*^9}, {
   3.773863297613583*^9, 3.7738633218952303`*^9}, {3.773863366369875*^9, 
   3.77386337256082*^9}, 3.7738635518169193`*^9, {3.773864148477647*^9, 
   3.7738642866608067`*^9}, {3.7738643442505207`*^9, 3.773864402067193*^9}, {
   3.7738644424369793`*^9, 3.773864449299774*^9}, {3.773864622406461*^9, 
   3.773864638662839*^9}, {3.7738735217878227`*^9, 3.7738735412748537`*^9}, {
   3.773873646490089*^9, 3.7738736658016233`*^9}, {3.7738737569064627`*^9, 
   3.773873801889728*^9}, {3.7738739505945597`*^9, 3.773873950859569*^9}, {
   3.773873998429508*^9, 3.773874036089151*^9}, {3.773874103067029*^9, 
   3.773874114152049*^9}, {3.77387416910723*^9, 3.773874193505479*^9}, 
   3.7738742802761507`*^9, {3.7738743107954607`*^9, 3.7738744762133913`*^9}, {
   3.773874534045062*^9, 3.773874581562549*^9}, {3.773874654946589*^9, 
   3.7738746884116983`*^9}, 3.773874751880859*^9, {3.7738752195350943`*^9, 
   3.773875265091758*^9}, {3.77387530256643*^9, 3.773875315775504*^9}, {
   3.773875387742896*^9, 3.7738754118434963`*^9}, {3.773875443251883*^9, 
   3.773875445861846*^9}, {3.773875480785041*^9, 3.773875488714943*^9}, {
   3.773875678589466*^9, 3.7738757127424726`*^9}, {3.7738757771742783`*^9, 
   3.7738758037099648`*^9}, {3.7770390365428133`*^9, 3.777039081400311*^9}, {
   3.777039134359131*^9, 3.777039149318007*^9}, {3.777039212172895*^9, 
   3.7770392123564587`*^9}, {3.7770394787056017`*^9, 3.77703950500469*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"bdc11047-ac8c-4240-bb3c-3db4ef2a2ace"],

Cell[BoxData["\<\"wayne@compclassnotes.com\"\>"], "Output",
 CellChangeTimes->{
  3.77385533766485*^9, {3.7738555928594027`*^9, 3.773855599458355*^9}, 
   3.7738559734677*^9, 3.7738561198539886`*^9, {3.7738564008707037`*^9, 
   3.7738564071907883`*^9}, 3.773856999779457*^9, 3.773857090071233*^9, 
   3.7738572464509983`*^9, 3.773857316216033*^9, 3.773862020911998*^9, 
   3.773862310852098*^9, 3.7738631602369623`*^9, 3.7738633739118547`*^9, 
   3.7738635613679256`*^9, 3.773864405131872*^9, 3.773864451030094*^9, 
   3.773864641316986*^9, 3.773864806087475*^9, 3.7738735452722588`*^9, 
   3.773873803183744*^9, 3.773873855758327*^9, 3.773873952353492*^9, 
   3.7738740015777884`*^9, 3.773874036901786*^9, 3.773874115079082*^9, 
   3.773874196551429*^9, 3.773874691952145*^9, 3.7738747542241383`*^9, 
   3.773875331391897*^9, 3.77387544806667*^9, 3.773875489493843*^9, 
   3.773875808256876*^9, 3.77387585448628*^9, 3.777039264700491*^9, 
   3.777039540009622*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"02ba447f-5f72-4817-b686-2433b7d80467"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/obj/ccn/lambda\"",
     "https://www.wolframcloud.com/obj/ccn/lambda"},
    "HyperlinkURL"], "]"}],
  CloudObject["https://www.wolframcloud.com/obj/ccn/lambda"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.77385533766485*^9, {3.7738555928594027`*^9, 3.773855599458355*^9}, 
   3.7738559734677*^9, 3.7738561198539886`*^9, {3.7738564008707037`*^9, 
   3.7738564071907883`*^9}, 3.773856999779457*^9, 3.773857090071233*^9, 
   3.7738572464509983`*^9, 3.773857316216033*^9, 3.773862020911998*^9, 
   3.773862310852098*^9, 3.7738631602369623`*^9, 3.7738633739118547`*^9, 
   3.7738635613679256`*^9, 3.773864405131872*^9, 3.773864451030094*^9, 
   3.773864641316986*^9, 3.773864806087475*^9, 3.7738735452722588`*^9, 
   3.773873803183744*^9, 3.773873855758327*^9, 3.773873952353492*^9, 
   3.7738740015777884`*^9, 3.773874036901786*^9, 3.773874115079082*^9, 
   3.773874196551429*^9, 3.773874691952145*^9, 3.7738747542241383`*^9, 
   3.773875331391897*^9, 3.77387544806667*^9, 3.773875489493843*^9, 
   3.773875808256876*^9, 3.77387585448628*^9, 3.777039264700491*^9, 
   3.7770395447197*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"db9937f2-ac9e-47ee-bcd7-d480a4268d50"]
}, Open  ]]
},
WindowSize->{1184, 1058},
WindowMargins->{{Automatic, 45}, {85, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1440, 34, 94, "Input",ExpressionUUID->"d6c51a68-17a0-48f8-a859-ba05498dddb1"],
Cell[CellGroupData[{
Cell[2023, 58, 256945, 5236, 37948, "Input",ExpressionUUID->"bdc11047-ac8c-4240-bb3c-3db4ef2a2ace"],
Cell[258971, 5296, 1043, 15, 34, "Output",ExpressionUUID->"02ba447f-5f72-4817-b686-2433b7d80467"],
Cell[260017, 5313, 1302, 23, 37, "Output",ExpressionUUID->"db9937f2-ac9e-47ee-bcd7-d480a4268d50"]
}, Open  ]]
}
]
*)

