(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    279713,       6066]
NotebookOptionsPosition[    270653,       5933]
NotebookOutlinePosition[    271022,       5949]
CellTagsIndexPosition[    270979,       5946]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9, {3.7467904563706017`*^9, 3.746790457458392*^9}, 
   3.746820283433523*^9, {3.74682967888512*^9, 3.7468297021398363`*^9}},
 CellLabel->
  "In[121]:=",ExpressionUUID->"675323c7-0aa0-4d16-84e5-172b6aed42a7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_"}], " ", ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_", " ", "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "\[Lambda]", " ", 
            RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"[\"", 
                    ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], ",", 
                    "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]3", ",", 
                  RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
              RowBox[{"ctr", "++"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"j_", " ", 
            RowBox[{"(", " ", 
              RowBox[{"i_", " ", "\[Lambda]", " ", 
                RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      "\[IndentingNewLine]", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "j_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"\"", 
                    ",", "\"[\"", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], " ", ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", "x_"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"ToString", "/@", 
              RowBox[{"Level", "[", 
                RowBox[{"x_", ",", 
                  RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"Table", "[", 
              RowBox[{
                RowBox[{"StringTake", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
              "]"}], ",", "NameQ"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"\[Xi]1", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]2", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]3", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]4", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
          RowBox[{"order", "=", 
            RowBox[{"{", "}"}]}], ";"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
         ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"order2", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"pass2", "=", 
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", 
              RowBox[{"output1", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<free\>\"", "->", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<bound\>\"", "\[Rule]", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<order\>\"", "\[Rule]", "order"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "pass2"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", " ", "ops1", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "ops2", " ", "3", " ", "y"}], ")"}]}]}], 
            ")"}], " ", "x"}], ")"}], "/.", "rules"}], "]"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
        "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", "rules2"}], 
        "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "FIXME", " ", "need", " ", "to", " ", "clearn", " ", "Notations", " ", 
     "or", " ", 
     RowBox[{"ToString", "@", 
      RowBox[{"\[Xi]1", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], " ", 
     RowBox[{"fails", "!!"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"<<", "Notation`"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"trace0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{"x", "->", "\"\<x\>\""}], "}"}]}], "}"}], ",", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"StringQ", "[", 
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", "True"}],
               ",", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<2\>\""}], "}"}]}], 
               "]"}], ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ii", "\[Equal]", 
              RowBox[{"Length", "@", "list"}]}], ",", " ", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"tmp2", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<y\>\"", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"ToString", "@", 
                   RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], "}"}]}], "]"}],
              ",", "tmp2"}], "]"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"jj", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750756548144157*^9, 3.750756562092181*^9}, {
   3.750772654266864*^9, 3.750772682166617*^9}, {3.7507727251328983`*^9, 
   3.750772766233308*^9}, {3.750772815607978*^9, 3.7507731974373198`*^9}, {
   3.750773230737076*^9, 3.750773253734517*^9}, {3.7507733237901783`*^9, 
   3.750773331968734*^9}, {3.750773486400217*^9, 3.750773489369323*^9}, {
   3.750773536159573*^9, 3.750773536383204*^9}, {3.750773571270625*^9, 
   3.750773625936558*^9}, {3.7507736695649347`*^9, 3.75077368880119*^9}, {
   3.750773805017939*^9, 3.750773860940136*^9}, {3.750773902387258*^9, 
   3.7507739086517477`*^9}, {3.750774461286414*^9, 3.750774461543727*^9}, {
   3.750774492359089*^9, 3.7507746269905863`*^9}, {3.750774906512896*^9, 
   3.750774907089005*^9}, {3.7507750810479393`*^9, 3.7507750849397078`*^9}, {
   3.7507751846724586`*^9, 3.750775201546173*^9}, {3.750775280559875*^9, 
   3.750775306703721*^9}, {3.750775427621073*^9, 3.7507754545648127`*^9}, {
   3.750775530719021*^9, 3.750775533180552*^9}, {3.7507755879862967`*^9, 
   3.750775598931201*^9}, {3.750775678107607*^9, 3.750775694767015*^9}, {
   3.750781440288073*^9, 3.7507815620463953`*^9}, {3.750781665953886*^9, 
   3.750781698060912*^9}, 3.7507820297638817`*^9, 3.75078212803508*^9, {
   3.75078357017374*^9, 3.7507835928586206`*^9}, {3.750784337853649*^9, 
   3.750784339505505*^9}, 3.750786343182468*^9, {3.750786379088431*^9, 
   3.7507863801336317`*^9}, {3.750786466535458*^9, 3.750786522993929*^9}, 
   3.7507867366933823`*^9, 3.75078686210635*^9, {3.750787268060708*^9, 
   3.7507872706340837`*^9}, 3.75078761695899*^9, 3.750787991522579*^9, {
   3.750805864862166*^9, 3.750805894392887*^9}, 3.7508060311538687`*^9},
 CellLabel->
  "In[199]:=",ExpressionUUID->"032bf690-a7dd-49ac-a8c4-b1b1024a3e4c"],

Cell[BoxData["\<\"(^ (\[Lambda] y . (* 3 y)) x)\"\>"], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787992906582*^9, {
   3.7508015164457493`*^9, 3.750801527262321*^9}, 3.750803235170147*^9, 
   3.7508058981500053`*^9, 3.750806035971616*^9, {3.772617301718657*^9, 
   3.772617319364539*^9}, 3.772617450715187*^9},
 CellLabel->
  "Out[220]=",ExpressionUUID->"7ff4c832-7070-4e5b-b51e-b3e42a59e265"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "x"], " ", 
  SuperscriptBox["y$7687", "x"]}]], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787992906582*^9, {
   3.7508015164457493`*^9, 3.750801527262321*^9}, 3.750803235170147*^9, 
   3.7508058981500053`*^9, 3.750806035971616*^9, {3.772617301718657*^9, 
   3.772617319364539*^9}, 3.77261745071705*^9},
 CellLabel->
  "Out[221]=",ExpressionUUID->"13881798-2ad4-4e28-ae50-e73a78533d4e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{"\"(^ (\[Lambda] y . (* 3 y)) x)\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] y . (* 3 y))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$7687", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\[ScriptT]\
\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\[ScriptW] \
\[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(* 3 y$7687)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   FrameStyle->RGBColor[1, 0.5, 0],
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787992906582*^9, {
   3.7508015164457493`*^9, 3.750801527262321*^9}, 3.750803235170147*^9, 
   3.7508058981500053`*^9, 3.750806035971616*^9, {3.772617301718657*^9, 
   3.772617319364539*^9}, 3.772617450847014*^9},
 CellLabel->
  "Out[227]=",ExpressionUUID->"8143a68b-20f8-443b-b08f-96497f5b2b84"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.750787701374638*^9, 
  3.750787702243284*^9}},ExpressionUUID->"d0c952d8-c305-4865-87b5-\
beff67d8511d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_"}], " ", ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_", " ", "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "\[Lambda]", " ", 
            RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"[\"", 
                    ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], ",", 
                    "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]3", ",", 
                  RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
              RowBox[{"ctr", "++"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"j_", " ", 
            RowBox[{"(", " ", 
              RowBox[{"i_", " ", "\[Lambda]", " ", 
                RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      "\[IndentingNewLine]", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "j_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"\"", 
                    ",", "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", "x_"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"ToString", "/@", 
              RowBox[{"Level", "[", 
                RowBox[{"x_", ",", 
                  RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"Table", "[", 
              RowBox[{
                RowBox[{"StringTake", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
              "]"}], ",", "NameQ"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"\[Xi]1", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]2", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]3", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]4", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
          RowBox[{"order", "=", 
            RowBox[{"{", "}"}]}], ";"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
         ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"order2", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"pass2", "=", 
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", 
              RowBox[{"output1", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<free\>\"", "->", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<bound\>\"", "\[Rule]", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<order\>\"", "\[Rule]", "order"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "pass2"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"unary", " ", "operators"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"op4", "\[Rule]", "Sqrt"}], ",", "\[IndentingNewLine]", 
       RowBox[{"op5", "\[Rule]", "Sin"}], ",", "\[IndentingNewLine]", 
       RowBox[{"op6", "\[Rule]", "Cos"}], ",", "\[IndentingNewLine]", 
       RowBox[{"op7", "\[Rule]", "Log"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"unary", " ", "operators"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"\"\<op4\>\"", "\[Rule]", "\"\<Sqrt\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<op5\>\"", "\[Rule]", "\"\<Sin\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<op6\>\"", "\[Rule]", "\"\<Cos\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<op7\>\"", "\[Rule]", "\"\<Log\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"op4", ",", "op5", ",", "op6", ",", "op6", ",", "op7"}], "]"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op4", ",", "op5", ",", "op6", ",", "op6", ",", "op7"}], 
        "}"}], ",", " ", "3"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] y . (ops1 y))\>\"", ",", "rules2"}], "]"}]}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops1 y)\>\"", ",", "rules2"}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", " ", "\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"2", " ", "ops1", " ", "y"}], ")"}]}]}], ")"}], "/.", 
         "rules"}], "]"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"\"\<(\[Lambda] y . (ops1 y))\>\"", ",", "rules2"}], "]"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", "rules"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "FIXME", " ", "need", " ", "to", " ", "clearn", " ", "Notations", " ", 
     "or", " ", 
     RowBox[{"ToString", "@", 
      RowBox[{"\[Xi]1", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], " ", 
     RowBox[{"fails", "!!"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"<<", "Notation`"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"trace0", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{"x", "->", "\"\<x\>\""}], "}"}]}], "}"}], ",", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"StringQ", "[", 
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", "True"}],
               ",", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<2\>\""}], "}"}]}], 
               "]"}], ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"ii", "\[Equal]", 
              RowBox[{"Length", "@", "list"}]}], ",", " ", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"tmp2", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<y\>\"", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"ToString", "@", 
                   RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], "}"}]}], "]"}],
              ",", "tmp2"}], "]"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"jj", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
       "]"}]}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750756548144157*^9, 3.750756562092181*^9}, {
   3.750772654266864*^9, 3.750772682166617*^9}, {3.7507727251328983`*^9, 
   3.750772766233308*^9}, {3.750772815607978*^9, 3.7507731974373198`*^9}, {
   3.750773230737076*^9, 3.750773253734517*^9}, {3.7507733237901783`*^9, 
   3.750773331968734*^9}, {3.750773486400217*^9, 3.750773489369323*^9}, {
   3.750773536159573*^9, 3.750773536383204*^9}, {3.750773571270625*^9, 
   3.750773625936558*^9}, {3.7507736695649347`*^9, 3.75077368880119*^9}, {
   3.750773805017939*^9, 3.750773860940136*^9}, {3.750773902387258*^9, 
   3.7507739086517477`*^9}, {3.750774461286414*^9, 3.750774461543727*^9}, {
   3.750774492359089*^9, 3.7507746269905863`*^9}, {3.750774906512896*^9, 
   3.750774907089005*^9}, {3.7507750810479393`*^9, 3.7507750849397078`*^9}, {
   3.7507751846724586`*^9, 3.750775201546173*^9}, {3.750775280559875*^9, 
   3.750775306703721*^9}, {3.750775427621073*^9, 3.7507754545648127`*^9}, {
   3.750775530719021*^9, 3.750775533180552*^9}, {3.7507755879862967`*^9, 
   3.750775598931201*^9}, {3.750775678107607*^9, 3.750775694767015*^9}, {
   3.750781440288073*^9, 3.7507815620463953`*^9}, {3.750781665953886*^9, 
   3.750781698060912*^9}, 3.7507820297638817`*^9, 3.75078212803508*^9, {
   3.75078357017374*^9, 3.7507835928586206`*^9}, {3.750784337853649*^9, 
   3.750784339505505*^9}, 3.750786343182468*^9, {3.750786379088431*^9, 
   3.7507863801336317`*^9}, {3.750786466535458*^9, 3.750786522993929*^9}, 
   3.7507867366933823`*^9, 3.75078686210635*^9, {3.750787268060708*^9, 
   3.7507872706340837`*^9}, 3.75078761695899*^9, {3.750787804049242*^9, 
   3.750787831756508*^9}, {3.750787865998913*^9, 3.7507878807314243`*^9}, {
   3.7507879158883543`*^9, 3.750787929937417*^9}, 3.750787977383539*^9, {
   3.750788015013485*^9, 3.750788020479826*^9}, {3.750799131177376*^9, 
   3.7507992799540663`*^9}, {3.75079938482472*^9, 3.750799386083733*^9}, {
   3.750799452139338*^9, 3.750799525349197*^9}, {3.750799586247746*^9, 
   3.750799637491521*^9}, 3.7508015006980133`*^9, 3.750805916589566*^9, {
   3.750806042510343*^9, 3.7508060427950563`*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"9f82f00a-f80b-456f-b68a-6ab7e08573c4"],

Cell[BoxData["\<\"(\[Lambda] y . (Cos y))\"\>"], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787941974307*^9, 
   3.750799104756102*^9, 3.7507993184161243`*^9, 3.7507993866189747`*^9, 
   3.7507994714709473`*^9, {3.750799510490801*^9, 3.7507995162891073`*^9}, 
   3.75079964099901*^9, 3.750801501720544*^9, 3.750803240431809*^9, 
   3.7508059179167223`*^9, 3.750806043366693*^9, 3.750847854583796*^9, 
   3.750849950337061*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"2c153023-e41a-413f-89e1-c7b20e0416aa"],

Cell[BoxData[
 RowBox[{"Cos", "[", "y$6837", "]"}]], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787941974307*^9, 
   3.750799104756102*^9, 3.7507993184161243`*^9, 3.7507993866189747`*^9, 
   3.7507994714709473`*^9, {3.750799510490801*^9, 3.7507995162891073`*^9}, 
   3.75079964099901*^9, 3.750801501720544*^9, 3.750803240431809*^9, 
   3.7508059179167223`*^9, 3.750806043366693*^9, 3.750847854583796*^9, 
   3.7508499503519707`*^9},
 CellLabel->"Out[98]=",ExpressionUUID->"57348c23-d700-4f12-9dd1-0cfb3eafea56"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(\[Lambda] y . (Cos y))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$6837", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\[ScriptT]\
\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\[ScriptW] \
\[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(Cos y$6837)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   FrameStyle->RGBColor[1, 0.5, 0],
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.750786487518751*^9, 3.750786493656869*^9}, 
   3.750786540205503*^9, 3.750786654372602*^9, 3.750786738547923*^9, {
   3.750786844217244*^9, 3.750786867473859*^9}, {3.750787179864318*^9, 
   3.750787200425922*^9}, {3.750787256083234*^9, 3.750787297839342*^9}, {
   3.750787559790597*^9, 3.75078756686436*^9}, 3.750787941974307*^9, 
   3.750799104756102*^9, 3.7507993184161243`*^9, 3.7507993866189747`*^9, 
   3.7507994714709473`*^9, {3.750799510490801*^9, 3.7507995162891073`*^9}, 
   3.75079964099901*^9, 3.750801501720544*^9, 3.750803240431809*^9, 
   3.7508059179167223`*^9, 3.750806043366693*^9, 3.750847854583796*^9, 
   3.750849950479653*^9},
 CellLabel->
  "Out[104]=",ExpressionUUID->"8fef1ead-bc04-4204-a11d-294f580ecdb2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", "op_", " ", "x_"}], " ", 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          
          RowBox[{"\[Paragraph]", " ", "i_", " ", "op_", " ", "x_", " ", 
            "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
            RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"[\"", 
                    ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], ",", 
                    "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]3", ",", 
                  RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
              RowBox[{"ctr", "++"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "j_", " ", 
            RowBox[{"(", 
              RowBox[{"\[Paragraph]", " ", "i_", " ", "\[Lambda]", " ", 
                RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      "\[IndentingNewLine]", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "j_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"\"", 
                    ",", "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "i_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", "x_"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"ToString", "/@", 
              RowBox[{"Level", "[", 
                RowBox[{"x_", ",", 
                  RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"Table", "[", 
              RowBox[{
                RowBox[{"StringTake", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
              "]"}], ",", "NameQ"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"\[Xi]1", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]2", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]3", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]4", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
          RowBox[{"order", "=", 
            RowBox[{"{", "}"}]}], ";"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
         ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"order2", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"pass2", "=", 
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", 
              RowBox[{"output1", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<free\>\"", "->", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<bound\>\"", "\[Rule]", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<order\>\"", "\[Rule]", "order"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "pass2"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) (ops3 u \
w))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) (ops3 u \
w))\>\"", ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<(ops1 (\[Lambda] y . (ops2 3 y)) x)\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] y . (ops2 3 y))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops2 3 y)\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops3 u w)\>\"", ",", "rules2"}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Hold", "[", 
         RowBox[{"(", 
          RowBox[{"\[Paragraph]", " ", "0", " ", 
           RowBox[{"(", 
            RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
             RowBox[{"x", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"\[Paragraph]", " ", "2", " ", "ops1", " ", 
                RowBox[{"(", 
                 RowBox[{"\[Paragraph]", " ", "3", " ", "\[Lambda]", " ", 
                  RowBox[{"y", " ", ".", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "4", " ", "ops2", " ", "3", " ", 
                    "y"}], ")"}]}]}], ")"}], " ", "x"}], ")"}]}]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
            "\[Paragraph]", " ", "5", " ", "ops3", " ", "u", "  ", "w"}], 
            ")"}]}], ")"}], "]"}], "/.", "rules"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
        "\"\<((\[Lambda] x . (ops1 (\[Lambda] y . (ops2 3 y)) x)) (ops3 u w))\
\>\"", ",", "rules2"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", "rules"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[Xi]1", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "FIXME", " ", "need", " ", "to", " ", "clearn", " ", "Notations", " ", 
     "or", " ", 
     RowBox[{"ToString", "@", 
      RowBox[{"\[Xi]1", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], " ", 
     RowBox[{"fails", "!!"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"trace0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", 
        RowBox[{"Drop", "[", 
         RowBox[{
          RowBox[{
          "Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"tmp2", "=", 
              RowBox[{"If", " ", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"StringQ", "[", 
                  RowBox[{
                   RowBox[{"list", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}], "[", 
                   RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", 
                 "True"}], ",", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"list", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}], "[", 
                   RowBox[{"[", "jj", "]"}], "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<x\>\"", "\[Rule]", 
                    RowBox[{"\[Rho]", "[", "5", "]"}]}], "}"}]}], "]"}], ",", 
                
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ii", "\[Equal]", 
                RowBox[{"Length", "@", "list"}]}], ",", " ", 
               RowBox[{"StringReplace", "[", 
                RowBox[{"tmp2", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<y\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"ToString", "@", 
                    RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], "}"}]}], "]"}],
                ",", "tmp2"}], "]"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"ii", ",", "1", ",", 
              RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"jj", ",", "1", ",", 
              RowBox[{"Length", "[", 
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",",
           "2"}], "]"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.750800074971767*^9, 3.750800075923998*^9}, {
   3.750800110324942*^9, 3.750800296226242*^9}, {3.750800339137415*^9, 
   3.7508003760321703`*^9}, {3.750800503307643*^9, 3.750800529900928*^9}, {
   3.75080058715584*^9, 3.750800595198045*^9}, {3.750800871437765*^9, 
   3.7508008998424397`*^9}, 3.750801487963344*^9, {3.7508016412887993`*^9, 
   3.750801662775044*^9}, {3.7508017157686996`*^9, 3.750801725338338*^9}, {
   3.7508018150574827`*^9, 3.750801815452977*^9}, 3.750802048511408*^9, {
   3.750802090001588*^9, 3.750802102734088*^9}, 3.750803022135676*^9, {
   3.750803588212942*^9, 3.75080359346465*^9}, {3.750803671824861*^9, 
   3.750803678741746*^9}, {3.7508038950299187`*^9, 3.75080389759293*^9}, {
   3.750803934619444*^9, 3.750803943555007*^9}, {3.7508041638735037`*^9, 
   3.7508042255347643`*^9}, {3.7508047896098957`*^9, 3.750804844771015*^9}, {
   3.7508048961152267`*^9, 3.7508049278949957`*^9}, {3.750805037036891*^9, 
   3.750805046765666*^9}, {3.750805076898918*^9, 3.750805081667498*^9}, {
   3.7508051197475767`*^9, 3.75080512791271*^9}, 3.750805168442399*^9, {
   3.7508052917403517`*^9, 3.750805312719563*^9}, {3.7508053800431843`*^9, 
   3.750805386375671*^9}, 3.750805476322907*^9, {3.750805553333996*^9, 
   3.7508055556004963`*^9}, {3.750805684338319*^9, 3.75080568899289*^9}, {
   3.750805925484189*^9, 3.7508059257559*^9}, {3.750806050002329*^9, 
   3.750806050218904*^9}, {3.7508465958831387`*^9, 3.750846638542132*^9}, {
   3.750854877774288*^9, 3.7508548839140987`*^9}, 3.750854930142601*^9, {
   3.750856239163047*^9, 3.750856264657694*^9}, 3.75085629728414*^9},
 EmphasizeSyntaxErrors->True,
 CellLabel->
  "In[109]:=",ExpressionUUID->"43d0e384-d11a-4629-8976-978a85536cf9"],

Cell[BoxData["\<\"((\[Lambda] x . (+ (\[Lambda] y . (^ 3 y)) x)) (* u \
w))\"\>"], "Output",
 CellChangeTimes->{{3.750800275414709*^9, 3.750800296639471*^9}, 
   3.750800378995553*^9, {3.750800506472884*^9, 3.750800531390964*^9}, {
   3.750800591138949*^9, 3.750800595661457*^9}, {3.750800878148429*^9, 
   3.750800900403452*^9}, 3.750801489327134*^9, {3.7508016493888083`*^9, 
   3.750801663672106*^9}, {3.750801720530077*^9, 3.7508017307553997`*^9}, 
   3.750801816304676*^9, 3.750802049039596*^9, {3.7508020914143333`*^9, 
   3.750802103320108*^9}, 3.750802287302725*^9, 3.7508030228563213`*^9, 
   3.750803245723743*^9, 3.750803595035482*^9, 3.7508037568156757`*^9, {
   3.750803898440484*^9, 3.750803915115375*^9}, 3.7508039451905107`*^9, {
   3.750804168447823*^9, 3.750804218605338*^9}, 3.750804350520115*^9, {
   3.7508047941833067`*^9, 3.7508048459829197`*^9}, 3.75080489893988*^9, 
   3.750804938816942*^9, 3.7508050473859673`*^9, 3.7508050856448593`*^9, {
   3.750805143806098*^9, 3.750805211227956*^9}, 3.750805258171213*^9, {
   3.750805293329452*^9, 3.7508053138633966`*^9}, {3.750805380789398*^9, 
   3.7508053878904*^9}, 3.750805480828751*^9, 3.75080555752435*^9, {
   3.7508056896076107`*^9, 3.7508057230649443`*^9}, 3.7508059264389143`*^9, 
   3.7508060508514957`*^9, {3.7508464785622473`*^9, 3.750846494029797*^9}, {
   3.750846639869967*^9, 3.7508466462496653`*^9}, {3.750855302414564*^9, 
   3.750855332198267*^9}, 3.75085578630278*^9, {3.750856241035501*^9, 
   3.750856266324923*^9}, 3.750856300500111*^9, 3.7726173154547567`*^9, 
   3.772617405321849*^9},
 CellLabel->
  "Out[130]=",ExpressionUUID->"7736a68a-09c2-4046-8f02-b35bf46338a9"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["3", "y$7363"], "+", 
  RowBox[{"u", " ", "w"}]}]], "Output",
 CellChangeTimes->{{3.750800275414709*^9, 3.750800296639471*^9}, 
   3.750800378995553*^9, {3.750800506472884*^9, 3.750800531390964*^9}, {
   3.750800591138949*^9, 3.750800595661457*^9}, {3.750800878148429*^9, 
   3.750800900403452*^9}, 3.750801489327134*^9, {3.7508016493888083`*^9, 
   3.750801663672106*^9}, {3.750801720530077*^9, 3.7508017307553997`*^9}, 
   3.750801816304676*^9, 3.750802049039596*^9, {3.7508020914143333`*^9, 
   3.750802103320108*^9}, 3.750802287302725*^9, 3.7508030228563213`*^9, 
   3.750803245723743*^9, 3.750803595035482*^9, 3.7508037568156757`*^9, {
   3.750803898440484*^9, 3.750803915115375*^9}, 3.7508039451905107`*^9, {
   3.750804168447823*^9, 3.750804218605338*^9}, 3.750804350520115*^9, {
   3.7508047941833067`*^9, 3.7508048459829197`*^9}, 3.75080489893988*^9, 
   3.750804938816942*^9, 3.7508050473859673`*^9, 3.7508050856448593`*^9, {
   3.750805143806098*^9, 3.750805211227956*^9}, 3.750805258171213*^9, {
   3.750805293329452*^9, 3.7508053138633966`*^9}, {3.750805380789398*^9, 
   3.7508053878904*^9}, 3.750805480828751*^9, 3.75080555752435*^9, {
   3.7508056896076107`*^9, 3.7508057230649443`*^9}, 3.7508059264389143`*^9, 
   3.7508060508514957`*^9, {3.7508464785622473`*^9, 3.750846494029797*^9}, {
   3.750846639869967*^9, 3.7508466462496653`*^9}, {3.750855302414564*^9, 
   3.750855332198267*^9}, 3.75085578630278*^9, {3.750856241035501*^9, 
   3.750856266324923*^9}, 3.750856300500111*^9, 3.7726173154547567`*^9, 
   3.772617405323791*^9},
 CellLabel->
  "Out[131]=",ExpressionUUID->"881279a6-e66a-449c-a9e1-9ebc7660f50f"],

Cell[BoxData[
 RowBox[{"{", "y$7363", "}"}]], "Output",
 CellChangeTimes->{{3.750800275414709*^9, 3.750800296639471*^9}, 
   3.750800378995553*^9, {3.750800506472884*^9, 3.750800531390964*^9}, {
   3.750800591138949*^9, 3.750800595661457*^9}, {3.750800878148429*^9, 
   3.750800900403452*^9}, 3.750801489327134*^9, {3.7508016493888083`*^9, 
   3.750801663672106*^9}, {3.750801720530077*^9, 3.7508017307553997`*^9}, 
   3.750801816304676*^9, 3.750802049039596*^9, {3.7508020914143333`*^9, 
   3.750802103320108*^9}, 3.750802287302725*^9, 3.7508030228563213`*^9, 
   3.750803245723743*^9, 3.750803595035482*^9, 3.7508037568156757`*^9, {
   3.750803898440484*^9, 3.750803915115375*^9}, 3.7508039451905107`*^9, {
   3.750804168447823*^9, 3.750804218605338*^9}, 3.750804350520115*^9, {
   3.7508047941833067`*^9, 3.7508048459829197`*^9}, 3.75080489893988*^9, 
   3.750804938816942*^9, 3.7508050473859673`*^9, 3.7508050856448593`*^9, {
   3.750805143806098*^9, 3.750805211227956*^9}, 3.750805258171213*^9, {
   3.750805293329452*^9, 3.7508053138633966`*^9}, {3.750805380789398*^9, 
   3.7508053878904*^9}, 3.750805480828751*^9, 3.75080555752435*^9, {
   3.7508056896076107`*^9, 3.7508057230649443`*^9}, 3.7508059264389143`*^9, 
   3.7508060508514957`*^9, {3.7508464785622473`*^9, 3.750846494029797*^9}, {
   3.750846639869967*^9, 3.7508466462496653`*^9}, {3.750855302414564*^9, 
   3.750855332198267*^9}, 3.75085578630278*^9, {3.750856241035501*^9, 
   3.750856266324923*^9}, 3.750856300500111*^9, 3.7726173154547567`*^9, 
   3.772617405325465*^9},
 CellLabel->
  "Out[133]=",ExpressionUUID->"e22f9685-f3a6-4691-8f23-d90d1b89253e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"((\[Lambda] x . (+ (\[Lambda] y . (^ 3 y)) x)) (* u w))\"","\"\"",
       "\"[\"","x",OverscriptBox["\"\[LongRightArrow]\"", "\"\[Beta]\""],
       TemplateBox[{
        "\"(* u w)\"", FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] y . (^ 3 y))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$7363", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptS]\[ScriptT]\[ScriptI]\[ScriptT]\
\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\[ScriptW] \
\[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(^ 3 y$7363)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   FrameStyle->RGBColor[1, 0.5, 0],
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.750800275414709*^9, 3.750800296639471*^9}, 
   3.750800378995553*^9, {3.750800506472884*^9, 3.750800531390964*^9}, {
   3.750800591138949*^9, 3.750800595661457*^9}, {3.750800878148429*^9, 
   3.750800900403452*^9}, 3.750801489327134*^9, {3.7508016493888083`*^9, 
   3.750801663672106*^9}, {3.750801720530077*^9, 3.7508017307553997`*^9}, 
   3.750801816304676*^9, 3.750802049039596*^9, {3.7508020914143333`*^9, 
   3.750802103320108*^9}, 3.750802287302725*^9, 3.7508030228563213`*^9, 
   3.750803245723743*^9, 3.750803595035482*^9, 3.7508037568156757`*^9, {
   3.750803898440484*^9, 3.750803915115375*^9}, 3.7508039451905107`*^9, {
   3.750804168447823*^9, 3.750804218605338*^9}, 3.750804350520115*^9, {
   3.7508047941833067`*^9, 3.7508048459829197`*^9}, 3.75080489893988*^9, 
   3.750804938816942*^9, 3.7508050473859673`*^9, 3.7508050856448593`*^9, {
   3.750805143806098*^9, 3.750805211227956*^9}, 3.750805258171213*^9, {
   3.750805293329452*^9, 3.7508053138633966`*^9}, {3.750805380789398*^9, 
   3.7508053878904*^9}, 3.750805480828751*^9, 3.75080555752435*^9, {
   3.7508056896076107`*^9, 3.7508057230649443`*^9}, 3.7508059264389143`*^9, 
   3.7508060508514957`*^9, {3.7508464785622473`*^9, 3.750846494029797*^9}, {
   3.750846639869967*^9, 3.7508466462496653`*^9}, {3.750855302414564*^9, 
   3.750855332198267*^9}, 3.75085578630278*^9, {3.750856241035501*^9, 
   3.750856266324923*^9}, 3.750856300500111*^9, 3.7726173154547567`*^9, 
   3.7726174053703423`*^9},
 CellLabel->
  "Out[138]=",ExpressionUUID->"f16a0c0c-093c-46e4-ae8b-8b0881dcd93b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_"}], " ", ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_", " ", "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "\[Lambda]", " ", 
            RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"[\"", 
                    ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", 
                    "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\
\[ScriptI]\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\
\[ScriptE]\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]3", ",", 
                  RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
              RowBox[{"ctr", "++"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"j_", " ", 
            RowBox[{"(", " ", 
              RowBox[{"i_", " ", "\[Lambda]", " ", 
                RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      "\[IndentingNewLine]", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "j_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"\"", 
                    ",", "\"[\"", ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Beta]\""}], 
                    "]"}], ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", "x_"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"ToString", "/@", 
              RowBox[{"Level", "[", 
                RowBox[{"x_", ",", 
                  RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"Table", "[", 
              RowBox[{
                RowBox[{"StringTake", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
              "]"}], ",", "NameQ"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"\[Xi]1", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]2", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]3", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]4", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
          RowBox[{"order", "=", 
            RowBox[{"{", "}"}]}], ";"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
         ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"order2", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"(*", 
         RowBox[{"KLUDGE", ":", " ", 
          RowBox[{
          "We", " ", "just", " ", "substitute", " ", "the", " ", "x$", " ", 
           "vars"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"pass2", "=", 
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", 
              RowBox[{"output1", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<free\>\"", "->", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<bound\>\"", "\[Rule]", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<order\>\"", "\[Rule]", "order"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "pass2"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops0", "=", 
     RowBox[{
     "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ops", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Clear", "[", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
     RowBox[{"RandomSample", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"ops1", "\[Rule]", 
        RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
       RowBox[{"ops2", "\[Rule]", 
        RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
       RowBox[{"ops3", "\[Rule]", 
        RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"rules2", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<ops1\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops2\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
       RowBox[{"\"\<ops3\>\"", "\[Rule]", 
        RowBox[{"ops", "[", 
         RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"0", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] t . (ops1 \[Phi] t))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops1 \[Phi] t)\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] y . (ops2 5 y))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops2 5 y)\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"4", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] z . (ops3 5 z))\>\"", ",", "rules2"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"5", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops3 5 z)\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"6", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] t . (ops1 \[Omega] t))\>\"", ",", "rules2"}],
          "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"7", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(ops1 \[Omega] t)\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"8", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<start\>\"", ",", "rules2"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"9", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{
         "\"\<((\[Lambda] y . (ops2 5 y))(\[Lambda] z . (ops3 5 z)))\>\"", 
          ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"10", "\[Rule]", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"\"\<(\[Lambda] t . (ops1 \[Phi] t))\>\"", ",", "rules2"}], 
         "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Hold", "[", 
         RowBox[{"(", 
          RowBox[{"8", " ", 
           RowBox[{"(", 
            RowBox[{"10", " ", 
             RowBox[{"(", 
              RowBox[{"0", " ", "\[Lambda]", " ", 
               RowBox[{"t", " ", ".", " ", 
                RowBox[{"(", 
                 RowBox[{"1", " ", "ops1", " ", "\[Phi]", " ", "t"}], 
                 ")"}]}]}], ")"}], " ", 
             RowBox[{"(", 
              RowBox[{"9", " ", 
               RowBox[{"(", 
                RowBox[{"2", " ", "\[Lambda]", " ", 
                 RowBox[{"y", " ", ".", " ", 
                  RowBox[{"(", 
                   RowBox[{"3", " ", "ops2", " ", "5", " ", "y"}], ")"}]}]}], 
                ")"}], 
               RowBox[{"(", 
                RowBox[{"4", " ", "\[Lambda]", " ", 
                 RowBox[{"z", " ", ".", " ", 
                  RowBox[{"(", 
                   RowBox[{"5", " ", "ops3", " ", "5", " ", "z"}], ")"}]}]}], 
                ")"}]}], ")"}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"6", " ", "\[Lambda]", " ", 
             RowBox[{"t", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"7", "ops1", " ", "\[Omega]", " ", "t"}], ")"}]}]}], 
            ")"}]}], ")"}], "]"}], "/.", "rules"}], ",", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
        "\"\<(((\[Lambda] t . (ops1 \[Phi] t)) ((\[Lambda] y . (ops2 5 y))(\
\[Lambda] z . (ops3 5 z)))) (\[Lambda] t . (ops1 \[Omega] t)))\>\"", ",", 
         "rules2"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", "rules"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Column", "[", 
     RowBox[{
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
      RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[Xi]1", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "FIXME", " ", "need", " ", "to", " ", "clearn", " ", "Notations", " ", 
     "or", " ", 
     RowBox[{"ToString", "@", 
      RowBox[{"\[Xi]1", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], " ", 
     RowBox[{"fails", "!!"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"<<", "Notation`"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace0", "=", 
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tmp2", "=", "\"\<\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"list", "=", 
     RowBox[{"Drop", "[", 
      RowBox[{"trace0", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"trace", "=", 
     RowBox[{"Row", "/@", 
      RowBox[{"Join", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"trace0", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"StringQ", "[", 
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", 
                "True"}], "&&", 
               RowBox[{"ii", "\[Equal]", "3"}]}], ",", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}], "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<z\>\"", "\[Rule]", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], 
              ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", 
               RowBox[{"[", "jj", "]"}], "]"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"StringQ", "[", 
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", 
                "True"}], "&&", 
               RowBox[{"ii", "\[Equal]", "4"}]}], ",", 
              RowBox[{"tmp3", "=", 
               RowBox[{"StringReplace", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<y\>\"", "\[Rule]", 
                   RowBox[{"StringReplace", "[", 
                    RowBox[{
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"(", 
                    RowBox[{"\[Rho]", "[", "5", "]"}], ")"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<z\>\"", "\[Rule]", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
                   "}"}]}], "]"}]}], ",", "tmp2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"StringQ", "[", 
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", 
                "True"}], "&&", 
               RowBox[{"ii", "\[Equal]", "5"}]}], ",", 
              RowBox[{"tmp4", "=", 
               RowBox[{"StringReplace", "[", 
                RowBox[{
                 RowBox[{"\[Mho]", " ", 
                  RowBox[{"\[Rho]", "[", "1", "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<t\>\"", "\[Rule]", 
                   RowBox[{"StringJoin", "[", "tmp3", "]"}]}], "}"}]}], 
                "]"}]}], ",", "tmp2"}], "]"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"tmp2", "=", 
            RowBox[{"If", " ", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"StringQ", "[", 
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], "]"}], "\[Equal]", 
                "True"}], "&&", 
               RowBox[{"ii", "\[Equal]", "7"}]}], ",", 
              RowBox[{"tmp7", "=", 
               RowBox[{"StringReplace", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"list", "[", 
                   RowBox[{"[", "ii", "]"}], "]"}], "[", 
                  RowBox[{"[", "jj", "]"}], "]"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<t\>\"", "\[Rule]", 
                   RowBox[{"ToString", "[", 
                    RowBox[{"\[Xi]1", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}], "}"}]}], "]"}]}],
               ",", "tmp2"}], "]"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "tmp2"}], ",", "\[IndentingNewLine]", " ", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{"Length", "@", "list"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"jj", ",", "1", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"list", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], "]"}]}], "}"}]}], "]"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"Final", " ", "Beta", " ", "conversion"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"tmp4", ",", "\"\<[\>\"", ",", 
           RowBox[{"ToString", "[", 
            RowBox[{"\[Xi]1", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
           RowBox[{"Overscript", "[", 
            RowBox[{"\"\<\[LongRightArrow]\>\"", ",", "\"\<\[Beta]\>\""}], 
            "]"}], ",", 
           RowBox[{"Highlighted", "[", 
            RowBox[{"tmp7", ",", 
             RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], ",", 
           "\"\<]\>\""}], "}"}], "}"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{"trace", ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.746955137505748*^9, 3.7469551397521772`*^9}, {
   3.74695541886154*^9, 3.746955425205697*^9}, {3.746955922014029*^9, 
   3.746955931968585*^9}, {3.7469563614034967`*^9, 3.746956439116593*^9}, {
   3.747041213869625*^9, 3.7470412334848022`*^9}, {3.7508057975929747`*^9, 
   3.750805799683043*^9}, {3.7508059584357977`*^9, 3.750805959034832*^9}, {
   3.750806056628419*^9, 3.750806056844667*^9}, {3.750806118545301*^9, 
   3.750806316821113*^9}, {3.750806350175521*^9, 3.7508063589086657`*^9}, {
   3.750806452851717*^9, 3.750806479649529*^9}, {3.7508112622198*^9, 
   3.7508112890611467`*^9}, 3.7508113265030622`*^9, {3.750811361849946*^9, 
   3.750811380234706*^9}, {3.750811451954056*^9, 3.750811486109049*^9}, {
   3.750811713127289*^9, 3.750811724500538*^9}, {3.75081213218642*^9, 
   3.750812132352646*^9}, {3.750812163954567*^9, 3.750812197277166*^9}, {
   3.750812238836389*^9, 3.750812248196445*^9}, {3.750812290647992*^9, 
   3.750812304863364*^9}, {3.75081237793923*^9, 3.75081241846758*^9}, {
   3.750812568883527*^9, 3.750812646938486*^9}, {3.7508127196261787`*^9, 
   3.7508127221553097`*^9}, {3.7508127823128443`*^9, 3.750812798298399*^9}, {
   3.750812843714654*^9, 3.750812860217922*^9}, {3.75081290478261*^9, 
   3.750812910742478*^9}, {3.75081312674781*^9, 3.75081314897969*^9}, {
   3.7508131970947933`*^9, 3.75081319979368*^9}, {3.750813326159029*^9, 
   3.750813329509666*^9}, {3.750813454086665*^9, 3.7508134781235*^9}, {
   3.7508135254663153`*^9, 3.750813571748402*^9}, {3.7508137701927967`*^9, 
   3.75081377316011*^9}, 3.750814190370878*^9, {3.750814372169507*^9, 
   3.750814373820318*^9}, {3.750817722142379*^9, 3.750817760931381*^9}, {
   3.75081802825696*^9, 3.75081807062346*^9}, 3.750844291587368*^9, {
   3.750844388830369*^9, 3.7508444365443573`*^9}, 3.7508444799713173`*^9, {
   3.750845101881528*^9, 3.750845109663703*^9}, {3.750845184659213*^9, 
   3.7508451942430143`*^9}, {3.750845319471883*^9, 3.750845320143525*^9}, {
   3.75084536380861*^9, 3.750845388699622*^9}, {3.750845430194515*^9, 
   3.750845453267548*^9}, {3.750845484781131*^9, 3.7508454880082483`*^9}, {
   3.750845528577031*^9, 3.7508455474771433`*^9}, {3.7508455967981787`*^9, 
   3.7508456236848993`*^9}, {3.750845662985106*^9, 3.750845687732197*^9}, {
   3.750845749050507*^9, 3.750845902386387*^9}, {3.750845943800428*^9, 
   3.750845960830698*^9}, {3.750846002628017*^9, 3.750846022504673*^9}, {
   3.7508461503312902`*^9, 3.7508461913362503`*^9}, {3.7508463173630733`*^9, 
   3.750846332605549*^9}, {3.750846400557109*^9, 3.750846411931058*^9}, {
   3.772617875172735*^9, 
   3.7726178817990007`*^9}},ExpressionUUID->"2b45e18d-71c8-4c7d-b907-\
696c576f5065"],

Cell[BoxData["\<\"(((\[Lambda] t . (^ \[Phi] t)) ((\[Lambda] y . (* 5 y))(\
\[Lambda] z . (+ 5 z)))) (\[Lambda] t . (^ \[Omega] t)))\"\>"], "Output",
 CellChangeTimes->{
  3.746955106954196*^9, 3.746955140685182*^9, 3.746955558290291*^9, 
   3.746955932590701*^9, 3.7469561184709167`*^9, 3.7469564399853697`*^9, 
   3.747020906186179*^9, 3.747021034142799*^9, 3.747021229453643*^9, 
   3.747021288356635*^9, 3.747028281598288*^9, 3.747028430403532*^9, 
   3.7470381837974033`*^9, 3.747038380646566*^9, 3.747040045449848*^9, {
   3.7470411964820623`*^9, 3.7470412346546993`*^9}, 3.750805800662084*^9, 
   3.750805959868999*^9, 3.7508060574190683`*^9, 3.750806318744566*^9, 
   3.75080636028094*^9, {3.750806453604784*^9, 3.750806480214375*^9}, {
   3.750811274957848*^9, 3.7508112896141357`*^9}, 3.750811362355947*^9, {
   3.750811459486635*^9, 3.750811487430488*^9}, 3.750811611112715*^9, {
   3.750811713617751*^9, 3.750811725749598*^9}, 3.750812198045038*^9, {
   3.7508122940811243`*^9, 3.750812305283649*^9}, {3.75081237950986*^9, 
   3.750812419165646*^9}, 3.750812570088552*^9, 3.7508126056914682`*^9, {
   3.750812704613411*^9, 3.750812723019064*^9}, 3.750812861043928*^9, 
   3.750812911323453*^9, 3.7508131004270144`*^9, {3.750813132229782*^9, 
   3.7508131512668867`*^9}, 3.750813201330151*^9, 3.7508133300862007`*^9, {
   3.750813461843886*^9, 3.750813478649815*^9}, {3.750813532690269*^9, 
   3.750813572419249*^9}, 3.750813774585676*^9, 3.750814191883851*^9, 
   3.750814376728705*^9, {3.750818044191114*^9, 3.750818071592938*^9}, 
   3.7508444470744963`*^9, 3.7508444814378347`*^9, {3.750845110902753*^9, 
   3.7508451169698343`*^9}, 3.7508451947509747`*^9, 3.750845320631317*^9, 
   3.750845368263474*^9, 3.750845498837776*^9, 3.750845549068527*^9, 
   3.7508456244315567`*^9, {3.750845664048977*^9, 3.7508456896907988`*^9}, 
   3.75084577743287*^9, {3.750845841336618*^9, 3.7508459034063473`*^9}, {
   3.7508459452978573`*^9, 3.7508459614630404`*^9}, 3.750846023126398*^9, {
   3.750846186865293*^9, 3.75084622722687*^9}, 3.750846338987412*^9, 
   3.750846419171332*^9, 3.7508464674674273`*^9, 3.772617411078423*^9},
 CellLabel->
  "Out[160]=",ExpressionUUID->"aae6cad6-c111-465e-81c8-92e2605acb04"],

Cell[BoxData[
 SuperscriptBox["\[Phi]", 
  RowBox[{"5", " ", 
   RowBox[{"(", 
    RowBox[{"5", "+", 
     SuperscriptBox["\[Omega]", "t$7452"]}], ")"}]}]]], "Output",
 CellChangeTimes->{
  3.746955106954196*^9, 3.746955140685182*^9, 3.746955558290291*^9, 
   3.746955932590701*^9, 3.7469561184709167`*^9, 3.7469564399853697`*^9, 
   3.747020906186179*^9, 3.747021034142799*^9, 3.747021229453643*^9, 
   3.747021288356635*^9, 3.747028281598288*^9, 3.747028430403532*^9, 
   3.7470381837974033`*^9, 3.747038380646566*^9, 3.747040045449848*^9, {
   3.7470411964820623`*^9, 3.7470412346546993`*^9}, 3.750805800662084*^9, 
   3.750805959868999*^9, 3.7508060574190683`*^9, 3.750806318744566*^9, 
   3.75080636028094*^9, {3.750806453604784*^9, 3.750806480214375*^9}, {
   3.750811274957848*^9, 3.7508112896141357`*^9}, 3.750811362355947*^9, {
   3.750811459486635*^9, 3.750811487430488*^9}, 3.750811611112715*^9, {
   3.750811713617751*^9, 3.750811725749598*^9}, 3.750812198045038*^9, {
   3.7508122940811243`*^9, 3.750812305283649*^9}, {3.75081237950986*^9, 
   3.750812419165646*^9}, 3.750812570088552*^9, 3.7508126056914682`*^9, {
   3.750812704613411*^9, 3.750812723019064*^9}, 3.750812861043928*^9, 
   3.750812911323453*^9, 3.7508131004270144`*^9, {3.750813132229782*^9, 
   3.7508131512668867`*^9}, 3.750813201330151*^9, 3.7508133300862007`*^9, {
   3.750813461843886*^9, 3.750813478649815*^9}, {3.750813532690269*^9, 
   3.750813572419249*^9}, 3.750813774585676*^9, 3.750814191883851*^9, 
   3.750814376728705*^9, {3.750818044191114*^9, 3.750818071592938*^9}, 
   3.7508444470744963`*^9, 3.7508444814378347`*^9, {3.750845110902753*^9, 
   3.7508451169698343`*^9}, 3.7508451947509747`*^9, 3.750845320631317*^9, 
   3.750845368263474*^9, 3.750845498837776*^9, 3.750845549068527*^9, 
   3.7508456244315567`*^9, {3.750845664048977*^9, 3.7508456896907988`*^9}, 
   3.75084577743287*^9, {3.750845841336618*^9, 3.7508459034063473`*^9}, {
   3.7508459452978573`*^9, 3.7508459614630404`*^9}, 3.750846023126398*^9, {
   3.750846186865293*^9, 3.75084622722687*^9}, 3.750846338987412*^9, 
   3.750846419171332*^9, 3.7508464674674273`*^9, 3.7726174110851107`*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"762fac81-166e-42b3-9909-efa766c514c3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"z$7451", ",", "t$7452"}], "}"}]], "Output",
 CellChangeTimes->{
  3.746955106954196*^9, 3.746955140685182*^9, 3.746955558290291*^9, 
   3.746955932590701*^9, 3.7469561184709167`*^9, 3.7469564399853697`*^9, 
   3.747020906186179*^9, 3.747021034142799*^9, 3.747021229453643*^9, 
   3.747021288356635*^9, 3.747028281598288*^9, 3.747028430403532*^9, 
   3.7470381837974033`*^9, 3.747038380646566*^9, 3.747040045449848*^9, {
   3.7470411964820623`*^9, 3.7470412346546993`*^9}, 3.750805800662084*^9, 
   3.750805959868999*^9, 3.7508060574190683`*^9, 3.750806318744566*^9, 
   3.75080636028094*^9, {3.750806453604784*^9, 3.750806480214375*^9}, {
   3.750811274957848*^9, 3.7508112896141357`*^9}, 3.750811362355947*^9, {
   3.750811459486635*^9, 3.750811487430488*^9}, 3.750811611112715*^9, {
   3.750811713617751*^9, 3.750811725749598*^9}, 3.750812198045038*^9, {
   3.7508122940811243`*^9, 3.750812305283649*^9}, {3.75081237950986*^9, 
   3.750812419165646*^9}, 3.750812570088552*^9, 3.7508126056914682`*^9, {
   3.750812704613411*^9, 3.750812723019064*^9}, 3.750812861043928*^9, 
   3.750812911323453*^9, 3.7508131004270144`*^9, {3.750813132229782*^9, 
   3.7508131512668867`*^9}, 3.750813201330151*^9, 3.7508133300862007`*^9, {
   3.750813461843886*^9, 3.750813478649815*^9}, {3.750813532690269*^9, 
   3.750813572419249*^9}, 3.750813774585676*^9, 3.750814191883851*^9, 
   3.750814376728705*^9, {3.750818044191114*^9, 3.750818071592938*^9}, 
   3.7508444470744963`*^9, 3.7508444814378347`*^9, {3.750845110902753*^9, 
   3.7508451169698343`*^9}, 3.7508451947509747`*^9, 3.750845320631317*^9, 
   3.750845368263474*^9, 3.750845498837776*^9, 3.750845549068527*^9, 
   3.7508456244315567`*^9, {3.750845664048977*^9, 3.7508456896907988`*^9}, 
   3.75084577743287*^9, {3.750845841336618*^9, 3.7508459034063473`*^9}, {
   3.7508459452978573`*^9, 3.7508459614630404`*^9}, 3.750846023126398*^9, {
   3.750846186865293*^9, 3.75084622722687*^9}, 3.750846338987412*^9, 
   3.750846419171332*^9, 3.7508464674674273`*^9, 3.772617411087282*^9},
 CellLabel->
  "Out[163]=",ExpressionUUID->"81ec6830-0a94-4bec-909b-643ca7fdd78c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(\[Lambda] t . (^ \[Phi] t))\"","\"\"","\"[\"","t",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Beta]\""],
       TemplateBox[{
        "\"((\[Lambda] y . (* 5 y))(\[Lambda] z . (+ 5 z)))\"", FrameStyle -> 
         None, Background -> RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"((\[Lambda] y . (* 5 y))(\[Lambda] z . (+ 5 z)))\"","\"\"","\"[\"",
       "y",OverscriptBox["\"\[LongRightArrow]\"", "\"\[Beta]\""],
       TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] z . (+ 5 z))\"","\"[\"","z",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "z$7451", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(+ 5 z$7451)\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(* 5 (+ 5 z$7451))\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(^ \[Phi] (* 5 (+ 5 z$7451)))\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] t . (^ \[Omega] t))\"","\"[\"","t",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "t$7452", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(^ \[Omega] t$7452)\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(^ \[Phi] (* 5 (+ 5 z$7451)))\"","\"[\"","\"z$7451\"",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Beta]\""],
       TemplateBox[{
        "\"(^ \[Omega] t$7452)\"", FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   FrameStyle->RGBColor[1, 0.5, 0],
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746955106954196*^9, 3.746955140685182*^9, 3.746955558290291*^9, 
   3.746955932590701*^9, 3.7469561184709167`*^9, 3.7469564399853697`*^9, 
   3.747020906186179*^9, 3.747021034142799*^9, 3.747021229453643*^9, 
   3.747021288356635*^9, 3.747028281598288*^9, 3.747028430403532*^9, 
   3.7470381837974033`*^9, 3.747038380646566*^9, 3.747040045449848*^9, {
   3.7470411964820623`*^9, 3.7470412346546993`*^9}, 3.750805800662084*^9, 
   3.750805959868999*^9, 3.7508060574190683`*^9, 3.750806318744566*^9, 
   3.75080636028094*^9, {3.750806453604784*^9, 3.750806480214375*^9}, {
   3.750811274957848*^9, 3.7508112896141357`*^9}, 3.750811362355947*^9, {
   3.750811459486635*^9, 3.750811487430488*^9}, 3.750811611112715*^9, {
   3.750811713617751*^9, 3.750811725749598*^9}, 3.750812198045038*^9, {
   3.7508122940811243`*^9, 3.750812305283649*^9}, {3.75081237950986*^9, 
   3.750812419165646*^9}, 3.750812570088552*^9, 3.7508126056914682`*^9, {
   3.750812704613411*^9, 3.750812723019064*^9}, 3.750812861043928*^9, 
   3.750812911323453*^9, 3.7508131004270144`*^9, {3.750813132229782*^9, 
   3.7508131512668867`*^9}, 3.750813201330151*^9, 3.7508133300862007`*^9, {
   3.750813461843886*^9, 3.750813478649815*^9}, {3.750813532690269*^9, 
   3.750813572419249*^9}, 3.750813774585676*^9, 3.750814191883851*^9, 
   3.750814376728705*^9, {3.750818044191114*^9, 3.750818071592938*^9}, 
   3.7508444470744963`*^9, 3.7508444814378347`*^9, {3.750845110902753*^9, 
   3.7508451169698343`*^9}, 3.7508451947509747`*^9, 3.750845320631317*^9, 
   3.750845368263474*^9, 3.750845498837776*^9, 3.750845549068527*^9, 
   3.7508456244315567`*^9, {3.750845664048977*^9, 3.7508456896907988`*^9}, 
   3.75084577743287*^9, {3.750845841336618*^9, 3.7508459034063473`*^9}, {
   3.7508459452978573`*^9, 3.7508459614630404`*^9}, 3.750846023126398*^9, {
   3.750846186865293*^9, 3.75084622722687*^9}, 3.750846338987412*^9, 
   3.750846419171332*^9, 3.7508464674674273`*^9, 3.772617411230311*^9},
 CellLabel->
  "Out[170]=",ExpressionUUID->"b03104d3-c085-46e8-8bf0-a5d4bb7bb0c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]", "=", 
   RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"1", "\[Rule]", "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Plus 3 y))\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"3", "\[Rule]", "\"\<(Plus 3 y)\>\""}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", "Power", " ", 
         RowBox[{"(", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"3", " ", "Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}],
          " ", "x"}], ")"}], "]"}], ",", 
      "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746731419252219*^9, 3.746731448337809*^9}, {
   3.746732254551585*^9, 3.746732261839855*^9}, {3.746732749166667*^9, 
   3.74673275245325*^9}, {3.746733562690836*^9, 3.746733563300418*^9}, 
   3.746744609988122*^9, 3.746822505146982*^9},
 CellLabel->"In[30]:=",ExpressionUUID->"d407a503-662e-4347-96fd-afb9c340e044"],

Cell[BoxData["\<\"(^ (\[Lambda] y . (+ 3 y)) x)\"\>"], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829708992607*^9, {
   3.746874942984201*^9, 3.746874955384158*^9}, 3.7468935037082443`*^9, 
   3.747020957203841*^9, 3.7470212951953382`*^9, 3.747038422937244*^9, 
   3.747040047882695*^9, 3.747041262507015*^9},
 CellLabel->"Out[32]=",ExpressionUUID->"0a330ffe-2589-4df9-b531-5ce610e60cb9"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"3", "+", "y$3202"}], ")"}], "x"]], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829708992607*^9, {
   3.746874942984201*^9, 3.746874955384158*^9}, 3.7468935037082443`*^9, 
   3.747020957203841*^9, 3.7470212951953382`*^9, 3.747038422937244*^9, 
   3.747040047882695*^9, 3.7470412625183973`*^9},
 CellLabel->"Out[33]=",ExpressionUUID->"54ab00d7-2e8c-4b3b-9f74-84a1a8bb730c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ (\[Lambda] y . (+ 3 y)) x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (+ 3 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\"\[LongRightArrow]\"","y$3202","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 3 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829708992607*^9, {
   3.746874942984201*^9, 3.746874955384158*^9}, 3.7468935037082443`*^9, 
   3.747020957203841*^9, 3.7470212951953382`*^9, 3.747038422937244*^9, 
   3.747040047882695*^9, 3.747041262528323*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"4e76c504-b055-45d6-93bc-38ee86505c3e"]
}, Open  ]],

Cell["\<\

Constant argument passing requires () or (2) in case below, you also need to \
tag the paran (5 2). Ignore the gray x.

Note 2 appears again since it has to be evaluated, there is no way for the \
evaluator to know this is a constant since we could enter some expression \
quite complex. \
\>", "Text",
 CellChangeTimes->{{3.747041273614312*^9, 
  3.747041392966799*^9}},ExpressionUUID->"2bf1cecf-4c87-40cd-bfd6-\
f7106eae54e6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_"}], " ", ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "op_", " ", "x_", " ", "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", 
          RowBox[{"Construct", "[", 
            RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "\[Lambda]", " ", 
            RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "tmp", "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"[\"", 
                    ",", " ", "x_", ",", 
                    RowBox[{"Overscript", "[", 
                    RowBox[{"\"\[LongRightArrow]\"", ",", "\"\[Alpha]\""}], 
                    "]"}], " ", ",", 
                    RowBox[{
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]}],
                     ",", "\"]\"", ",", " ", "\" substitute a new copy\""}], 
                    "}"}], ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]3", ",", 
                  RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
              RowBox[{"ctr", "++"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"j_", " ", 
            RowBox[{"(", " ", 
              RowBox[{"i_", " ", "\[Lambda]", " ", 
                RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
          ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      "\[IndentingNewLine]", 
      TemplateBox[{RowBox[{"Block", "[", 
          RowBox[{
            RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "j_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"order", ",", "i_"}], "]"}], ";", 
              RowBox[{"AppendTo", "[", 
                RowBox[{"\[Xi]2", ",", 
                  RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", "\"\"", 
                    ",", "\"[\"", ",", " ", "x_", ",", 
                    "\" \!\(\*OverscriptBox[\(\[LongRightArrow]\), \(\\\"\\<\
\[Beta] conversion\\>\\\"\)]\) \"", ",", " ", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"ctr", "++"}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", "\"]\""}], "}"}], 
                    ",", "Nothing"}], "]"}]}], "]"}], ";", 
              RowBox[{
                RowBox[{"Function", "[", 
                  RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", 
            RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
          RowBox[{"{", 
            RowBox[{"i_", ",", 
              RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"i_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"AppendTo", "[", 
            RowBox[{"order", ",", "i_"}], "]"}], ";", 
          RowBox[{"AppendTo", "[", 
            RowBox[{"\[Xi]2", ",", 
              RowBox[{"If", "[", 
                RowBox[{
                  RowBox[{"order2", "=!=", 
                    RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"{", 
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", 
                    RowBox[{"order2", "[", 
                    RowBox[{"[", "ctr", "]"}], "]"}], "]"}]}], "}"}], ",", 
                  "Nothing"}], "]"}]}], "]"}], ";", 
          RowBox[{"ctr", "++"}], ";", "x_"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"StringReplace", "[", 
          RowBox[{"x_", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
                RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
                RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
                RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
                RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
                RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
                RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
                RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
                RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
                RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
                RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
                RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}], ",", 
                RowBox[{"\"Minus\"", "\[Rule]", "\"-\""}]}], "}"}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"ToString", "/@", 
              RowBox[{"Level", "[", 
                RowBox[{"x_", ",", 
                  RowBox[{"{", 
                    RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
          "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"Select", "[", 
          RowBox[{
            RowBox[{"Table", "[", 
              RowBox[{
                RowBox[{"StringTake", "[", 
                  RowBox[{"i", ",", "1"}], "]"}], ",", 
                RowBox[{"{", 
                  RowBox[{"i", ",", 
                    RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
              "]"}], ",", "NameQ"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{
          RowBox[{"\[Xi]1", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]2", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]3", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[Xi]4", "=", 
            RowBox[{"{", "}"}]}], ";", 
          RowBox[{"\[CurlyRho]", "=", "Nothing"}], ";", 
          RowBox[{"order", "=", 
            RowBox[{"{", "}"}]}], ";"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2", 
         ",", "pass1", ",", "pass2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"order2", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"order2", "=", "order"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "pass1", " ", "collect", " ", "order", " ", "of", " ", 
          "evaluations"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"pass2", "=", 
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
             RowBox[{"\"\<output1\>\"", "\[Rule]", 
              RowBox[{"output1", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
             RowBox[{"\"\<output\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<free\>\"", "->", 
            RowBox[{"Complement", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<bound\>\"", "\[Rule]", 
            RowBox[{"Intersection", "[", 
             RowBox[{
              RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<order\>\"", "\[Rule]", "order"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "pass2"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "0", "\[Rule]", 
        "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)))\>\""}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
       "1", "\[Rule]", 
        "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)))\>\""}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
       "2", "\[Rule]", "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] y . (Plus 3 y))\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"4", "\[Rule]", "\"\<(Plus 3 y)\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"5", "\[Rule]", "\"\<2\>\""}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{"(", 
         RowBox[{"0", " ", 
          RowBox[{"(", 
           RowBox[{"1", " ", "\[Lambda]", " ", 
            RowBox[{"x", " ", ".", " ", 
             RowBox[{"(", 
              RowBox[{"2", " ", "Power", " ", 
               RowBox[{"(", 
                RowBox[{"3", " ", "\[Lambda]", " ", 
                 RowBox[{"y", " ", ".", " ", 
                  RowBox[{"(", 
                   RowBox[{"4", " ", "Plus", " ", "3", " ", "y"}], ")"}]}]}], 
                ")"}], " ", "x"}], ")"}]}]}], " ", ")"}], "2"}], ")"}], "]"}],
        ",", "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)) \
2)\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{
     RowBox[{"Row", "/@", 
      RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.747027912105825*^9, 3.747027950686598*^9}, {
   3.747028194344617*^9, 3.747028194635914*^9}, {3.7470282292874804`*^9, 
   3.747028243080372*^9}, {3.747037456031262*^9, 3.747037457852131*^9}, 
   3.747037574743327*^9, {3.7470376503669662`*^9, 3.747037653436729*^9}, 
   3.747037947699747*^9, 3.74703814045935*^9, {3.747038366768466*^9, 
   3.747038368701456*^9}, {3.747038559709367*^9, 3.747038570047412*^9}, 
   3.7508029317507133`*^9, {3.750804075579973*^9, 3.7508040769979277`*^9}, 
   3.7726174956467657`*^9},
 CellLabel->
  "In[256]:=",ExpressionUUID->"03998b9c-2f8e-4f41-8677-4334b6011aa4"],

Cell[BoxData["\<\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)) 2)\"\>"], \
"Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.746829668679809*^9, 
   3.746874976054893*^9, {3.7468752447823677`*^9, 3.746875263964403*^9}, {
   3.746875363121565*^9, 3.7468753704224052`*^9}, 3.746875725666551*^9, 
   3.746876142915164*^9, {3.7468762801055098`*^9, 3.746876286210243*^9}, {
   3.74689345155661*^9, 3.7468934627389812`*^9}, 3.7468935510892677`*^9, 
   3.746893653833994*^9, 3.7468936869136477`*^9, 3.7469286641999817`*^9, 
   3.7469287100916843`*^9, 3.746928814957541*^9, 3.746928872092854*^9, 
   3.74692892746037*^9, 3.74692933220971*^9, 3.746929385581471*^9, {
   3.7469296203865767`*^9, 3.746929631240574*^9}, 3.746929980971881*^9, {
   3.74693012319983*^9, 3.746930151296632*^9}, 3.746930694979073*^9, 
   3.7469308838720217`*^9, 3.746931087284906*^9, {3.747021299766975*^9, 
   3.747021325007205*^9}, 3.747021357382917*^9, 3.747021429519197*^9, 
   3.747026714156151*^9, 3.747026817738985*^9, {3.7470268651953983`*^9, 
   3.747026890060197*^9}, 3.7470270484104433`*^9, 3.747027642927552*^9, {
   3.747027704596735*^9, 3.74702770721262*^9}, 3.747028516265346*^9, 
   3.747028605091875*^9, 3.747028679299958*^9, 3.747028731448607*^9, 
   3.7470289044026823`*^9, 3.747028995880806*^9, 3.7470385861482983`*^9, 
   3.747040050348563*^9, 3.7470412676392927`*^9, {3.750802934641426*^9, 
   3.750802940516588*^9}, 3.750803986242268*^9, 3.7508040797577257`*^9, 
   3.772617374747807*^9, 3.7726174139421597`*^9, {3.772617472043445*^9, 
   3.772617496444407*^9}},
 CellLabel->
  "Out[271]=",ExpressionUUID->"8728a9c2-983c-4562-b1e5-bac7f1146107"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"3", "+", "y$7909"}], ")"}], "2"]], "Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.746829668679809*^9, 
   3.746874976054893*^9, {3.7468752447823677`*^9, 3.746875263964403*^9}, {
   3.746875363121565*^9, 3.7468753704224052`*^9}, 3.746875725666551*^9, 
   3.746876142915164*^9, {3.7468762801055098`*^9, 3.746876286210243*^9}, {
   3.74689345155661*^9, 3.7468934627389812`*^9}, 3.7468935510892677`*^9, 
   3.746893653833994*^9, 3.7468936869136477`*^9, 3.7469286641999817`*^9, 
   3.7469287100916843`*^9, 3.746928814957541*^9, 3.746928872092854*^9, 
   3.74692892746037*^9, 3.74692933220971*^9, 3.746929385581471*^9, {
   3.7469296203865767`*^9, 3.746929631240574*^9}, 3.746929980971881*^9, {
   3.74693012319983*^9, 3.746930151296632*^9}, 3.746930694979073*^9, 
   3.7469308838720217`*^9, 3.746931087284906*^9, {3.747021299766975*^9, 
   3.747021325007205*^9}, 3.747021357382917*^9, 3.747021429519197*^9, 
   3.747026714156151*^9, 3.747026817738985*^9, {3.7470268651953983`*^9, 
   3.747026890060197*^9}, 3.7470270484104433`*^9, 3.747027642927552*^9, {
   3.747027704596735*^9, 3.74702770721262*^9}, 3.747028516265346*^9, 
   3.747028605091875*^9, 3.747028679299958*^9, 3.747028731448607*^9, 
   3.7470289044026823`*^9, 3.747028995880806*^9, 3.7470385861482983`*^9, 
   3.747040050348563*^9, 3.7470412676392927`*^9, {3.750802934641426*^9, 
   3.750802940516588*^9}, 3.750803986242268*^9, 3.7508040797577257`*^9, 
   3.772617374747807*^9, 3.7726174139421597`*^9, {3.772617472043445*^9, 
   3.7726174964463453`*^9}},
 CellLabel->
  "Out[272]=",ExpressionUUID->"a183d380-2938-4178-8427-e807ca7718e5"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)))\"","\"\"","\"[\"",
       "x","\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(^ (\[Lambda] y . (+ 3 y)) x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(^ (\[Lambda] y . (+ 3 y)) x)\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] y . (+ 3 y))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "y$7909", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" substitute a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(+ 3 y)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.746829668679809*^9, 
   3.746874976054893*^9, {3.7468752447823677`*^9, 3.746875263964403*^9}, {
   3.746875363121565*^9, 3.7468753704224052`*^9}, 3.746875725666551*^9, 
   3.746876142915164*^9, {3.7468762801055098`*^9, 3.746876286210243*^9}, {
   3.74689345155661*^9, 3.7468934627389812`*^9}, 3.7468935510892677`*^9, 
   3.746893653833994*^9, 3.7468936869136477`*^9, 3.7469286641999817`*^9, 
   3.7469287100916843`*^9, 3.746928814957541*^9, 3.746928872092854*^9, 
   3.74692892746037*^9, 3.74692933220971*^9, 3.746929385581471*^9, {
   3.7469296203865767`*^9, 3.746929631240574*^9}, 3.746929980971881*^9, {
   3.74693012319983*^9, 3.746930151296632*^9}, 3.746930694979073*^9, 
   3.7469308838720217`*^9, 3.746931087284906*^9, {3.747021299766975*^9, 
   3.747021325007205*^9}, 3.747021357382917*^9, 3.747021429519197*^9, 
   3.747026714156151*^9, 3.747026817738985*^9, {3.7470268651953983`*^9, 
   3.747026890060197*^9}, 3.7470270484104433`*^9, 3.747027642927552*^9, {
   3.747027704596735*^9, 3.74702770721262*^9}, 3.747028516265346*^9, 
   3.747028605091875*^9, 3.747028679299958*^9, 3.747028731448607*^9, 
   3.7470289044026823`*^9, 3.747028995880806*^9, 3.7470385861482983`*^9, 
   3.747040050348563*^9, 3.7470412676392927`*^9, {3.750802934641426*^9, 
   3.750802940516588*^9}, 3.750803986242268*^9, 3.7508040797577257`*^9, 
   3.772617374747807*^9, 3.7726174139421597`*^9, {3.772617472043445*^9, 
   3.772617496448317*^9}},
 CellLabel->
  "Out[273]=",ExpressionUUID->"35d8bcee-f8d6-49da-8fc6-491b2726a27b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"0", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus 5 z)\>\""}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"0", " ", 
         RowBox[{"(", 
          RowBox[{"1", " ", "\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"2", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
          ")"}], 
         RowBox[{"(", 
          RowBox[{"3", " ", "\[Lambda]", " ", 
           RowBox[{"z", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"4", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
          ")"}]}], ")"}], "]"}], ",", 
      "\"\<((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z)))\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"Row", "/@", 
    RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.74674465052884*^9, 3.74674468882358*^9}, {
   3.746744744392996*^9, 3.7467448116981773`*^9}, 3.7467481432201557`*^9, 
   3.746822514989729*^9, {3.74682991465591*^9, 3.746829915025915*^9}, {
   3.746890141463118*^9, 3.746890153937014*^9}, {3.7468901961488457`*^9, 
   3.7468902241065617`*^9}, {3.7470214878700657`*^9, 3.747021488048026*^9}, 
   3.747038625736861*^9, {3.772617487196628*^9, 3.7726174882865133`*^9}},
 CellLabel->
  "In[251]:=",ExpressionUUID->"457740d9-5528-44dd-b8ff-93e2d1bc93cc"],

Cell[BoxData["\<\"((\[Lambda] y . (/ 5 y))(\[Lambda] z . (+ 5 z)))\"\>"], \
"Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.746829915373103*^9, 3.746876555395301*^9, {
   3.746890143386264*^9, 3.746890224435688*^9}, 3.746929719438306*^9, 
   3.746930014282955*^9, 3.74693013143426*^9, 3.7469301803006268`*^9, 
   3.746930698029249*^9, 3.746930781937656*^9, 3.746930885955471*^9, {
   3.747021472168948*^9, 3.7470214885206747`*^9}, {3.747038598508513*^9, 
   3.74703862650325*^9}, 3.747040053882596*^9, 3.7470414036995792`*^9, 
   3.772617424788808*^9, {3.772617473324415*^9, 3.772617489266776*^9}},
 CellLabel->
  "Out[253]=",ExpressionUUID->"73d9c1b3-fc00-4726-9656-e52ec2c40794"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z$7828"}]]], "Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.746829915373103*^9, 3.746876555395301*^9, {
   3.746890143386264*^9, 3.746890224435688*^9}, 3.746929719438306*^9, 
   3.746930014282955*^9, 3.74693013143426*^9, 3.7469301803006268`*^9, 
   3.746930698029249*^9, 3.746930781937656*^9, 3.746930885955471*^9, {
   3.747021472168948*^9, 3.7470214885206747`*^9}, {3.747038598508513*^9, 
   3.74703862650325*^9}, 3.747040053882596*^9, 3.7470414036995792`*^9, 
   3.772617424788808*^9, {3.772617473324415*^9, 3.772617489268577*^9}},
 CellLabel->
  "Out[254]=",ExpressionUUID->"f6810bce-3430-4051-b2c9-a12ef26a74b0"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(\[Lambda] y . (/ 5 y))\"","\"\"","\"[\"","y",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"]\""},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"(\[Lambda] z . (+ 5 z))\"","\"[\"","z",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "z$7828", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" substitute a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(+ 5 z)\""},
      "RowDefault"]},
    {
     TemplateBox[{"\"(/ 5 y)\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.746829915373103*^9, 3.746876555395301*^9, {
   3.746890143386264*^9, 3.746890224435688*^9}, 3.746929719438306*^9, 
   3.746930014282955*^9, 3.74693013143426*^9, 3.7469301803006268`*^9, 
   3.746930698029249*^9, 3.746930781937656*^9, 3.746930885955471*^9, {
   3.747021472168948*^9, 3.7470214885206747`*^9}, {3.747038598508513*^9, 
   3.74703862650325*^9}, 3.747040053882596*^9, 3.7470414036995792`*^9, 
   3.772617424788808*^9, {3.772617473324415*^9, 3.772617489270603*^9}},
 CellLabel->
  "Out[255]=",ExpressionUUID->"a0d2645d-7101-4918-aed7-4e3da6dfb031"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] y . (Sqrt y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Sqrt y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(plus 5 z)\>\""}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", "\[Lambda]", " ", 
         RowBox[{"y", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Sqrt", " ", "y"}], ")"}]}]}], ")"}], "]"}], 
      ",", "\"\<(\[Lambda] y . (Sqrt y))\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
   RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.7468158141639013`*^9, 3.746815843672864*^9}, {
   3.746816063648964*^9, 3.7468160639623833`*^9}, 3.7468161607877483`*^9, 
   3.746822521076622*^9, 3.7507577812099447`*^9},
 CellLabel->
  "In[194]:=",ExpressionUUID->"5c95b0d2-d973-4297-9066-2effa5b1510b"],

Cell[BoxData["\<\"(\[Lambda] y . (\[Sqrt] y))\"\>"], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.746829672997272*^9, 
   3.747021524849259*^9, 3.747038642705626*^9, 3.747041406333611*^9, 
   3.750757782020062*^9, 3.750758118009325*^9, 3.7726174375472193`*^9},
 CellLabel->
  "Out[196]=",ExpressionUUID->"25d6c8d6-ab85-4f57-a6c7-a5159e651f57"],

Cell[BoxData[
 SqrtBox["y$7612"]], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.746829672997272*^9, 
   3.747021524849259*^9, 3.747038642705626*^9, 3.747041406333611*^9, 
   3.750757782020062*^9, 3.750758118009325*^9, 3.772617437548867*^9},
 CellLabel->
  "Out[197]=",ExpressionUUID->"513aa4f4-d475-4d6e-8451-6613b1c409bc"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"\<\"(\[Lambda] y . (\[Sqrt] y))\"\>", ",", "\<\"[\"\>", ",", 
       "y", ",", 
       OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
       TemplateBox[{
        "y$7612",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
        "Highlighted"], ",", "\<\"]\"\>", 
       ",", "\<\" substitute a new copy\"\>"}], "}"}]},
    {
     RowBox[{"{", "\<\"(\[Sqrt] y)\"\>", "}"}]}
   },
   DefaultBaseStyle->"Column",
   FrameStyle->RGBColor[1, 0.5, 0],
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.746829672997272*^9, 
   3.747021524849259*^9, 3.747038642705626*^9, 3.747041406333611*^9, 
   3.750757782020062*^9, 3.750758118009325*^9, 3.772617437550786*^9},
 CellLabel->
  "Out[198]=",ExpressionUUID->"59cf3478-d08f-40e3-b319-d53d54c0b559"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["\[Lambda] passing", "Title"]
}], "Text",
 CellChangeTimes->{{3.746787416308563*^9, 3.746787423260519*^9}, {
  3.7468223551128693`*^9, 
  3.7468223672569838`*^9}},ExpressionUUID->"04e7e40d-fa6d-4d46-846a-\
1415ba9cc26a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"0", "->", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"1", "\[Rule]", "\"\<(Power \[Phi] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<(\[Lambda] t . (Power \[Omega] t))\>\""}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"7", "\[Rule]", "\"\<hi\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"8", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"9", "->", "\"\<(Power \[Omega] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"10", "\[Rule]", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}]}],
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"7", " ", 
         RowBox[{"(", 
          RowBox[{"10", " ", 
           RowBox[{"(", 
            RowBox[{"0", " ", "\[Lambda]", " ", 
             RowBox[{"t", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"1", " ", "Power", " ", "\[Phi]", " ", "t"}], 
               ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{"8", " ", 
             RowBox[{"(", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               RowBox[{"y", " ", ".", " ", 
                RowBox[{"(", 
                 RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
              ")"}], 
             RowBox[{"(", 
              RowBox[{"4", " ", "\[Lambda]", " ", 
               RowBox[{"z", " ", ".", " ", 
                RowBox[{"(", 
                 RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
              ")"}]}], ")"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"6", " ", "\[Lambda]", " ", 
           RowBox[{"t", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"9", "Power", " ", "\[Omega]", " ", "t"}], ")"}]}]}], 
          ")"}]}], ")"}], "]"}], ",", 
      "\"\<(((\[Lambda] t . (Power \[Phi] t)) ((\[Lambda] y . (Divide 5 y))(\
\[Lambda] z . (Plus 5 z)))) (\[Lambda] t . (Power \[Omega] t)))\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "[", "\"\<input\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "[", "\"\<output\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746798666337422*^9, 3.746798669188867*^9}, 3.746802184278227*^9, {
   3.746814912957217*^9, 3.746814994806048*^9}, {3.746818103386856*^9, 
   3.746818109775998*^9}, {3.746818169323722*^9, 3.746818173374352*^9}, 
   3.746822528682509*^9, 3.746829906388666*^9, {3.746930242317486*^9, 
   3.746930302662155*^9}, 3.746930550843446*^9, 3.746930585245942*^9, {
   3.746930715252674*^9, 3.7469307232167807`*^9}, {3.746931143132213*^9, 
   3.746931163572239*^9}, {3.746931761690571*^9, 3.746931768024487*^9}, 
   3.746933194460229*^9, {3.7469332658416777`*^9, 3.746933267764292*^9}, 
   3.746933313194333*^9, {3.7469334673437767`*^9, 3.74693347963925*^9}, {
   3.747038663379657*^9, 3.74703866632521*^9}, {3.747038723748372*^9, 
   3.7470387401490593`*^9}, {3.7470388375547028`*^9, 3.747038847205607*^9}, {
   3.747039337896555*^9, 3.747039341078453*^9}, {3.747039382784157*^9, 
   3.747039400211117*^9}, {3.747039445594553*^9, 3.7470394638294353`*^9}, 
   3.7470395178445797`*^9, 3.747039668281844*^9, {3.747040022256022*^9, 
   3.747040029894569*^9}, 3.747040080590046*^9},
 CellLabel->
  "In[1304]:=",ExpressionUUID->"5fea9086-92cd-4a61-acb7-8bf27d803db6"],

Cell[BoxData["\<\"(((\[Lambda] t . (^ \[Phi] t)) ((\[Lambda] y . (/ 5 y))(\
\[Lambda] z . (+ 5 z)))) (\[Lambda] t . (^ \[Omega] t)))\"\>"], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071041307`*^9, 3.7469301894863586`*^9, 
   3.746930250956169*^9, {3.746930296985018*^9, 3.746930303873067*^9}, 
   3.746930551695118*^9, 3.746930586361396*^9, {3.7469307018800077`*^9, 
   3.7469307241379147`*^9}, 3.746930819438603*^9, 3.746930888189323*^9, 
   3.746931089501164*^9, {3.7469311466483603`*^9, 3.7469311640084877`*^9}, 
   3.746931210307184*^9, {3.74693125740372*^9, 3.746931260838195*^9}, 
   3.746931416752873*^9, 3.746931503119215*^9, {3.746931757695343*^9, 
   3.746931768381029*^9}, {3.746931864111205*^9, 3.746931866012125*^9}, 
   3.746931962334569*^9, 3.746932090178526*^9, 3.7469321585205507`*^9, 
   3.746932222275649*^9, {3.746932683150024*^9, 3.7469326891523046`*^9}, 
   3.746933026727298*^9, 3.746933150737129*^9, 3.746933195852413*^9, 
   3.746933268906106*^9, 3.746933313847851*^9, 3.746933473665682*^9, 
   3.746933516079612*^9, {3.747038649644993*^9, 3.747038669932601*^9}, 
   3.7470387407531977`*^9, {3.747038838502965*^9, 3.747038862779599*^9}, {
   3.747040075638856*^9, 3.747040080926572*^9}, 3.7470414084664497`*^9, 
   3.750803393602645*^9},
 CellLabel->
  "Out[1306]=",ExpressionUUID->"fe18d101-868a-4b5b-a402-77848024c9c2"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071041307`*^9, 3.7469301894863586`*^9, 
   3.746930250956169*^9, {3.746930296985018*^9, 3.746930303873067*^9}, 
   3.746930551695118*^9, 3.746930586361396*^9, {3.7469307018800077`*^9, 
   3.7469307241379147`*^9}, 3.746930819438603*^9, 3.746930888189323*^9, 
   3.746931089501164*^9, {3.7469311466483603`*^9, 3.7469311640084877`*^9}, 
   3.746931210307184*^9, {3.74693125740372*^9, 3.746931260838195*^9}, 
   3.746931416752873*^9, 3.746931503119215*^9, {3.746931757695343*^9, 
   3.746931768381029*^9}, {3.746931864111205*^9, 3.746931866012125*^9}, 
   3.746931962334569*^9, 3.746932090178526*^9, 3.7469321585205507`*^9, 
   3.746932222275649*^9, {3.746932683150024*^9, 3.7469326891523046`*^9}, 
   3.746933026727298*^9, 3.746933150737129*^9, 3.746933195852413*^9, 
   3.746933268906106*^9, 3.746933313847851*^9, 3.746933473665682*^9, 
   3.746933516079612*^9, {3.747038649644993*^9, 3.747038669932601*^9}, 
   3.7470387407531977`*^9, {3.747038838502965*^9, 3.747038862779599*^9}, {
   3.747040075638856*^9, 3.747040080926572*^9}, 3.7470414084664497`*^9, 
   3.750803393613728*^9},
 CellLabel->
  "Out[1307]=",ExpressionUUID->"00af3f8e-ae13-4256-bb46-cb8c4d7d1b28"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}, Dividers -> All]]], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071041307`*^9, 3.7469301894863586`*^9, 
   3.746930250956169*^9, {3.746930296985018*^9, 3.746930303873067*^9}, 
   3.746930551695118*^9, 3.746930586361396*^9, {3.7469307018800077`*^9, 
   3.7469307241379147`*^9}, 3.746930819438603*^9, 3.746930888189323*^9, 
   3.746931089501164*^9, {3.7469311466483603`*^9, 3.7469311640084877`*^9}, 
   3.746931210307184*^9, {3.74693125740372*^9, 3.746931260838195*^9}, 
   3.746931416752873*^9, 3.746931503119215*^9, {3.746931757695343*^9, 
   3.746931768381029*^9}, {3.746931864111205*^9, 3.746931866012125*^9}, 
   3.746931962334569*^9, 3.746932090178526*^9, 3.7469321585205507`*^9, 
   3.746932222275649*^9, {3.746932683150024*^9, 3.7469326891523046`*^9}, 
   3.746933026727298*^9, 3.746933150737129*^9, 3.746933195852413*^9, 
   3.746933268906106*^9, 3.746933313847851*^9, 3.746933473665682*^9, 
   3.746933516079612*^9, {3.747038649644993*^9, 3.747038669932601*^9}, 
   3.7470387407531977`*^9, {3.747038838502965*^9, 3.747038862779599*^9}, {
   3.747040075638856*^9, 3.747040080926572*^9}, 3.7470414084664497`*^9, 
   3.7508033936226482`*^9},
 CellLabel->
  "Out[1308]=",ExpressionUUID->"ef253a02-4e75-4e1c-93d5-2b1f5e47de8e"]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.7469305562591248`*^9},ExpressionUUID->"9c783d49-3182-41cc-8815-\
f4524f7dc2fd"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"0", "->", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"1", "\[Rule]", "\"\<(Power \[Phi] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<(\[Lambda] t . (Power \[Omega] t))\>\""}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"7", "\[Rule]", "\"\<hi\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"8", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"9", "->", "\"\<(Power \[Omega] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"10", "\[Rule]", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}]}],
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"10", " ", 
         RowBox[{"(", 
          RowBox[{"0", " ", "\[Lambda]", " ", 
           RowBox[{"t", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"1", " ", "Power", " ", "\[Phi]", " ", "t"}], ")"}]}]}], 
          ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"8", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
            ")"}], 
           RowBox[{"(", 
            RowBox[{"4", " ", "\[Lambda]", " ", 
             RowBox[{"z", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
            ")"}]}], ")"}]}], ")"}], "]"}], ",", 
      "\"\<(((\[Lambda] t . (Power \[Phi] t)) ((\[Lambda] y . (Divide 5 y))(\
\[Lambda] z . (Plus 5 z)))) (\[Lambda] t . (Power \[Omega] t)))\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "[", "\"\<input\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "[", "\"\<output\>\"", "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746798666337422*^9, 3.746798669188867*^9}, 3.746802184278227*^9, {
   3.746814912957217*^9, 3.746814994806048*^9}, {3.746818103386856*^9, 
   3.746818109775998*^9}, {3.746818169323722*^9, 3.746818173374352*^9}, 
   3.746822528682509*^9, 3.746829906388666*^9, {3.746930242317486*^9, 
   3.746930302662155*^9}, 3.746930550843446*^9, 3.746930585245942*^9, {
   3.746930715252674*^9, 3.7469307232167807`*^9}, {3.746931143132213*^9, 
   3.746931163572239*^9}, {3.746931761690571*^9, 3.746931768024487*^9}, 
   3.746933194460229*^9, {3.7469332658416777`*^9, 3.746933267764292*^9}, 
   3.746933313194333*^9, {3.7469334673437767`*^9, 3.74693347963925*^9}, {
   3.747038663379657*^9, 3.74703866632521*^9}, {3.747038723748372*^9, 
   3.7470387401490593`*^9}, {3.7470388375547028`*^9, 3.747038847205607*^9}, {
   3.747039337896555*^9, 3.747039341078453*^9}, {3.747039382784157*^9, 
   3.747039400211117*^9}, {3.747039445594553*^9, 3.7470394638294353`*^9}, 
   3.7470395178445797`*^9, 3.747039668281844*^9, {3.747040022256022*^9, 
   3.747040029894569*^9}, 3.747040080590046*^9, {3.7470401679466553`*^9, 
   3.747040175021541*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"79d5165c-3ac5-4d3f-9632-019571cd76f8"],

Cell[BoxData["\<\"(((\[Lambda] t . (^ \[Phi] t)) ((\[Lambda] y . (/ 5 y))(\
\[Lambda] z . (+ 5 z)))) (\[Lambda] t . (^ \[Omega] t)))\"\>"], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931710711*^9, 
   3.746931458034284*^9, 3.7470391974186077`*^9, 3.7470401931502934`*^9, 
   3.747041412416452*^9},
 CellLabel->"Out[57]=",ExpressionUUID->"0a1ee025-7ca3-4ebe-a523-deb3f5baf667"],

Cell[BoxData[
 SuperscriptBox["\[Phi]", 
  FractionBox["5", 
   RowBox[{"5", "+", "z$3293"}]]]], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931710711*^9, 
   3.746931458034284*^9, 3.7470391974186077`*^9, 3.7470401931502934`*^9, 
   3.747041412427743*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"2be9b090-f27f-40e3-b9ff-a49a3a321e87"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] t . (^ \[Phi] t))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","t",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$3293","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ \[Phi] t)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931710711*^9, 
   3.746931458034284*^9, 3.7470391974186077`*^9, 3.7470401931502934`*^9, 
   3.74704141243645*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"4b0c1377-a16a-49b9-9601-2a1b71c082ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "1", "\[Rule]", 
       "\"\<(((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z))) \
xxx)\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<((\[Lambda] y . (Divide 5 y))\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", 
         RowBox[{"(", 
          RowBox[{"6", 
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
            ")"}], 
           RowBox[{"(", 
            RowBox[{"4", " ", "\[Lambda]", " ", 
             RowBox[{"z", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
            ")"}]}], ")"}], " ", "xxx"}], ")"}], "]"}], ",", 
      "\"\<(((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z))) \
xxx)\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output1\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output2\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746793523048279*^9, 3.746793526534601*^9}, {3.746815157231485*^9, 
   3.746815157455863*^9}, 3.746817232937687*^9, {3.7468173277429867`*^9, 
   3.746817388077971*^9}, {3.7468174599032917`*^9, 3.746817522258999*^9}, {
   3.746817904472562*^9, 3.746817910523632*^9}, 3.746822540877493*^9, {
   3.7470402562948027`*^9, 3.747040271762055*^9}, {3.747040310565401*^9, 
   3.7470403239627867`*^9}},
 CellLabel->"In[60]:=",ExpressionUUID->"5d8209de-7dfa-4da6-823e-26e75ecf3ef5"],

Cell[BoxData["\<\"(((\[Lambda] y . (/ 5 y))(\[Lambda] z . (+ 5 z))) \
xxx)\"\>"], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716445415*^9, 3.7470402447230988`*^9, 3.747040324508439*^9, 
   3.747041415567645*^9},
 CellLabel->"Out[62]=",ExpressionUUID->"136fc50b-ff57-49f1-a97a-cb0aa518efe1"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z$3318"}]]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716445415*^9, 3.7470402447230988`*^9, 3.747040324508439*^9, 
   3.747041415578837*^9},
 CellLabel->"Out[63]=",ExpressionUUID->"9aa78569-2c4f-492f-ad50-33358e580b11"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "xxx"}]]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716445415*^9, 3.7470402447230988`*^9, 3.747040324508439*^9, 
   3.74704141558473*^9},
 CellLabel->"Out[64]=",ExpressionUUID->"439776a7-92b8-472b-80b5-19d590ea10f1"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"((\[Lambda] y . (/ 5 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$3318","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716445415*^9, 3.7470402447230988`*^9, 3.747040324508439*^9, 
   3.747041415590888*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"aa5a1c4f-fe2f-4719-a96c-cf6afe477060"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["\[Lambda] x", "Title"]
}], "Text",
 CellChangeTimes->{{3.7466099220880203`*^9, 
  3.746609930627089*^9}},ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-\
5c197a10ae7f"],

Cell["\<\

place a space between \[Lambda]  and variable name otherwise Mathematica \
interpret then as a single symbol.\
\>", "Text",
 CellChangeTimes->{{3.746609934080645*^9, 
  3.746609993188505*^9}},ExpressionUUID->"537278c6-b157-4293-8ad9-\
a7445d850ccc"],

Cell["\<\

Replace operators with math symbols, for now only arithmetic operations \
supported but we could make more..\
\>", "Text",
 CellChangeTimes->{{3.7465259788294973`*^9, 3.74652601831695*^9}, {
  3.746609410036293*^9, 
  3.746609411148735*^9}},ExpressionUUID->"3bb0307b-077c-4bff-aa91-\
bcf0be33c48f"],

Cell["\<\

\[Mho] is a custom defined operator which coverts the arithmetic operator \
names to symbols. Had to do this otherwise Mathematica evaluates / in the \
Lambda expressions which outputs nonsense:\
\>", "Text",
 CellChangeTimes->{{3.746566103652384*^9, 
  3.746566203239883*^9}},ExpressionUUID->"8d1383d3-1524-40bc-8d25-\
caa0b1904007"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", "\"\<\[Lambda] z . (Power 5 z)\>\""}]], "Input",
 CellChangeTimes->{{3.746609855149599*^9, 3.746609855610057*^9}},
 CellLabel->
  "In[726]:=",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],

Cell[BoxData["\<\"\[Lambda] z . (^ 5 z)\"\>"], "Output",
 CellChangeTimes->{3.7466098565046473`*^9, 3.7466914131906633`*^9, 
  3.7466953507486877`*^9, 3.7468153411403522`*^9, 3.747040351925331*^9},
 CellLabel->
  "Out[726]=",ExpressionUUID->"5ff39c65-228e-4e13-ac5c-8010d1c31629"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Evaluate", "Title"],
 "\n\n\[Omicron] is an operator that empties the  stack. Normally in the \
online interpreters this is done invisibly, but since we are using \
Mathematica\[CloseCurlyQuote]s interpreter we need to manually empty the \
stack if needed .\n\[Xi] is the stack, both are weird letters to make sure \
not used in general. \n\n",
 StyleBox["z is free z$3133  is bound.",
  FontWeight->"Bold"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.746526023489603*^9, 3.746526027845748*^9}, {
  3.746566233581366*^9, 3.746566349738411*^9}, {3.746567117801462*^9, 
  3.746567161417678*^9}, {3.746691424967721*^9, 
  3.74669143443966*^9}},ExpressionUUID->"ba63361b-1bdd-49bc-af32-\
eef69722d648"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", "\[Lambda]", " ", 
         RowBox[{"z", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], ")"}],
        "]"}], ",", "\"\<(\[Lambda] z . (Divide b z))\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746777674299324*^9, 3.746777729331813*^9}, 
   3.746822684430538*^9},
 CellLabel->"In[66]:=",ExpressionUUID->"4a3c35ae-f757-486f-9014-5fbba6540527"],

Cell[BoxData["\<\"(\[Lambda] z . (/ b z))\"\>"], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.7468297275141287`*^9, 3.7470403575520887`*^9, 
  3.747041419237978*^9},
 CellLabel->"Out[68]=",ExpressionUUID->"ab1628f5-62eb-48f2-aa28-e1cd0a020dfa"],

Cell[BoxData[
 FractionBox["b", "z$3335"]], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.7468297275141287`*^9, 3.7470403575520887`*^9, 
  3.7470414192487507`*^9},
 CellLabel->"Out[69]=",ExpressionUUID->"9b3cdae9-10fa-4298-ae06-32f65085c89f"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (/ b z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$3335","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ b z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.7468297275141287`*^9, 3.7470403575520887`*^9, 
  3.7470414192579317`*^9},
 CellLabel->"Out[70]=",ExpressionUUID->"c2b158b8-fcb2-46cd-85a3-56db092a5a2e"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FractionBox["b", "z$"]],
  CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
    3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
    3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
    3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
    3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
    3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
    3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
    3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
    3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
    3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
    3.746609967520733*^9, 3.7466464251767597`*^9, 3.746646970190507*^9, 
    3.746650997558325*^9, 3.7466516118415527`*^9, 3.746691415007823*^9},
  ExpressionUUID->"efc54b74-5e81-46fe-8a7e-65fb741bfab8"],
 "  is the result of the evaluation of  \[Lambda] expression and z is a bound \
variable.\n\nNotice z is treated as a placeholder it is replaced by new \
variables e.g. r and notice the bound variable stack \[Xi] is empty  "
}], "Text",
 CellChangeTimes->{
  3.746609550660516*^9, {3.7466096452109747`*^9, 3.746609707040083*^9}, 
   3.746691449229912*^9, {3.746777758933131*^9, 
   3.7467777597762957`*^9}},ExpressionUUID->"fe82ef0f-42c5-423b-a36b-\
1af62e1981e0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z)) r\>\""}], ",",
       "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<r\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z))\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"1", "\[Lambda]", " ", 
           RowBox[{"z", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], 
          ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"3", " ", "r"}], ")"}]}], ")"}], "]"}], ",", 
      "\"\<(\[Lambda] z . (Divide b z) r)\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7467778453992558`*^9, 3.746777847086232*^9}, {
  3.746777883572171*^9, 3.746777890624325*^9}, {3.746777951884495*^9, 
  3.746777958767597*^9}, {3.746778024503306*^9, 3.746778030869089*^9}, {
  3.746822692968585*^9, 3.746822695347866*^9}, {3.747040370495143*^9, 
  3.7470404047965*^9}},
 CellLabel->"In[71]:=",ExpressionUUID->"58cf5de7-0e94-4b12-af12-f1d8c46e0923"],

Cell[BoxData["\<\"(\[Lambda] z . (/ b z) r)\"\>"], "Output",
 CellChangeTimes->{
  3.74677789337457*^9, 3.7467779612590027`*^9, 3.746778031298463*^9, 
   3.746787438323415*^9, 3.746788066806037*^9, 3.746815353917341*^9, 
   3.746822695693172*^9, 3.746829250283016*^9, 3.746829729815508*^9, {
   3.747040362944871*^9, 3.7470404124114647`*^9}, 3.747041421043187*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"20ca7876-de69-4659-b9ec-a60668927ec5"],

Cell[BoxData[
 FractionBox["b", "r"]], "Output",
 CellChangeTimes->{
  3.74677789337457*^9, 3.7467779612590027`*^9, 3.746778031298463*^9, 
   3.746787438323415*^9, 3.746788066806037*^9, 3.746815353917341*^9, 
   3.746822695693172*^9, 3.746829250283016*^9, 3.746829729815508*^9, {
   3.747040362944871*^9, 3.7470404124114647`*^9}, 3.7470414210541*^9},
 CellLabel->"Out[74]=",ExpressionUUID->"d9c52104-6b3c-420f-90ea-136e054db33e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (/ b z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"r\"", FrameStyle -> None, Background -> RGBColor[0.87, 0.94, 1]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"r\"", FrameStyle -> None, Background -> RGBColor[0.87, 0.94, 1]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ b z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.74677789337457*^9, 3.7467779612590027`*^9, 3.746778031298463*^9, 
   3.746787438323415*^9, 3.746788066806037*^9, 3.746815353917341*^9, 
   3.746822695693172*^9, 3.746829250283016*^9, 3.746829729815508*^9, {
   3.747040362944871*^9, 3.7470404124114647`*^9}, 3.74704142106392*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"8b6ca195-a115-424b-8873-83c2bb4d8dd3"]
}, Open  ]],

Cell["\<\

Notice z is NOT added to to the stack.\
\>", "Text",
 CellChangeTimes->{{3.746566375377954*^9, 3.746566391510274*^9}, {
   3.746566424643417*^9, 3.746566442647777*^9}, {3.7465664783286457`*^9, 
   3.74656649280707*^9}, 3.746609461314722*^9, {3.7466095154620447`*^9, 
   3.7466095580426197`*^9}, {3.74677808300422*^9, 
   3.746778113028812*^9}},ExpressionUUID->"ef9e9a56-5785-4d41-aa60-\
36d483d5411e"],

Cell[TextData[{
 "\n",
 StyleBox["Find  variables", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{
  3.746526035811522*^9, {3.746526075749*^9, 3.746526079191697*^9}, {
   3.7465261769910593`*^9, 3.7465261776870413`*^9}, {3.746526219370544*^9, 
   3.7465262427132483`*^9}, {3.7465263879882298`*^9, 
   3.7465263921157427`*^9}, {3.746566515037902*^9, 3.746566562843948*^9}, {
   3.7465665972538767`*^9, 3.746566599728979*^9}, 3.746609738608721*^9, {
   3.7466942534227057`*^9, 
   3.746694259778351*^9}},ExpressionUUID->"f95ff3c1-9237-464a-afd8-\
06e0eabefd8e"],

Cell["\<\



bound variables are instanced with trailing $ and unique random integer. \
\>", "Text",
 CellChangeTimes->{{3.746566672720667*^9, 3.746566702803372*^9}, {
   3.746693425724551*^9, 3.7466934308642683`*^9}, {3.74669427203047*^9, 
   3.74669433623482*^9}, 
   3.746778132920499*^9},ExpressionUUID->"88450169-06ab-4ef8-9120-\
f29966174203"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z))\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", "\[Lambda]", " ", 
         RowBox[{"z", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], ")"}],
        "]"}], ",", "\"\<(\[Lambda] z . (Divide b z))\>\""}], "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.746521046004383*^9, 3.7465210464345016`*^9}, 
   3.746521156519286*^9, {3.746526270750854*^9, 3.746526297483017*^9}, {
   3.746526403547892*^9, 3.74652640727075*^9}, {3.746693391660252*^9, 
   3.746693407488431*^9}, {3.746701842275391*^9, 3.746701871647664*^9}, {
   3.7467781376939497`*^9, 3.746778141031637*^9}, {3.74679231925487*^9, 
   3.746792324215098*^9}, 3.746815362300208*^9, 3.746829264972105*^9},
 CellLabel->"In[76]:=",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", "\[Rule]", "\<\"(\[Lambda] z . (/ b z))\"\>"}], 
   ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["b", "z$3357"]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"b\"\>", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$3357\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$3357", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (/ b z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$3357","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ b z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}], ",", 
   RowBox[{"\<\"order\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.746521047376712*^9, {3.7465211469010067`*^9, 3.746521158454754*^9}, 
   3.746524983091058*^9, 3.746526082148794*^9, 3.7465262979497232`*^9, 
   3.746526407565949*^9, 3.746646999225676*^9, 3.746651644278997*^9, 
   3.746691487981122*^9, 3.746691855268795*^9, {3.746693399975061*^9, 
   3.746693412112399*^9}, 3.746694277395198*^9, 3.7466958591777782`*^9, 
   3.746701797999772*^9, {3.746701852149356*^9, 3.746701872017351*^9}, 
   3.746702048531907*^9, 3.746705810780843*^9, 3.746714526266816*^9, 
   3.746778141393407*^9, 3.746787444762025*^9, 3.746788069004819*^9, 
   3.746792220329565*^9, 3.746792324737323*^9, 3.746815364082244*^9, 
   3.7468227106488037`*^9, {3.746829254973358*^9, 3.7468292654705553`*^9}, 
   3.7468297323155613`*^9, 3.747040434568304*^9, 3.7470414234818687`*^9},
 CellLabel->"Out[77]=",ExpressionUUID->"93e7ce4e-01e5-49bd-a3aa-56e747f02e61"]
}, Open  ]],

Cell["\<\

No free variables\
\>", "Text",
 CellChangeTimes->{{3.746566735270732*^9, 3.746566738669067*^9}, 
   3.7466247200826893`*^9},ExpressionUUID->"9a26861f-0101-4c3c-84a6-\
7756074f32a1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "=", 
  RowBox[{"eval", "[", 
   RowBox[{
    RowBox[{"Hold", "[", 
     RowBox[{"(", 
      RowBox[{"1", "\[Lambda]", " ", 
       RowBox[{"z", " ", ".", " ", 
        RowBox[{"(", 
         RowBox[{"2", " ", "Divide", " ", "5", " ", "z"}], ")"}]}]}], ")"}], 
     "]"}], ",", "\"\<(\[Lambda] z . (Divide 5 z))\>\""}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.74656671190559*^9, 3.746566713862462*^9}, {
  3.7466934402838182`*^9, 3.746693450394846*^9}, {3.746701966195958*^9, 
  3.746701981561635*^9}, {3.7467781882317133`*^9, 3.746778200814443*^9}},
 CellLabel->"In[78]:=",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", "\[Rule]", "\<\"(\[Lambda] z . (/ 5 z))\"\>"}], 
   ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", "z$3366"]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$3366\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$3366", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (/ 5 z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$3366","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}], ",", 
   RowBox[{"\<\"order\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.7465667153816566`*^9, 3.74664700054091*^9, 3.746651645222691*^9, 
   3.746691489431587*^9, {3.746693447339995*^9, 3.7466934509409513`*^9}, 
   3.746694284097788*^9, 3.746694858744688*^9, 3.746695860178841*^9, 
   3.746701788062584*^9, 3.746701981905672*^9, 3.7467020503119917`*^9, 
   3.7467058322834797`*^9, 3.7467782029856243`*^9, 3.746787449930174*^9, 
   3.746788070856764*^9, 3.746822721001281*^9, 3.746829284910284*^9, 
   3.746829733466333*^9, 3.747040440598267*^9, 3.747041425135056*^9},
 CellLabel->"Out[79]=",ExpressionUUID->"acaed77f-d5f6-45b7-8d3e-be6529d127c7"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Passing \[Lambda]", "Title"]
}], "Text",
 CellChangeTimes->{{3.7465261213917913`*^9, 3.746526125192377*^9}, {
  3.7465405602732353`*^9, 3.746540561823556*^9}, {3.7466934914018507`*^9, 
  3.746693500076517*^9}},ExpressionUUID->"15ef489a-5536-452d-ae09-\
86b73d643a13"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] x . (Divide 5 x))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 x)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus (-3) z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus (-3) z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(\[Lambda] x . (Divide 5 x))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<(Minus 3)\>\""}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "shorthand", " ", "does", " ", "not", " ", 
     "work"}], ",", " ", 
    RowBox[{
    "we", " ", "need", " ", "to", " ", "explictly", " ", "use", " ", "the", 
     " ", "operator", " ", "Minus"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"eval", "[", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"(", 
       RowBox[{"5", 
        RowBox[{"(", 
         RowBox[{"1", " ", "\[Lambda]", " ", 
          RowBox[{"x", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "Divide", " ", "5", " ", "x"}], ")"}]}]}], 
         ")"}], 
        RowBox[{"(", 
         RowBox[{"3", " ", "\[Lambda]", " ", 
          RowBox[{"z", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"4", " ", "Plus", " ", 
             RowBox[{"(", 
              RowBox[{"6", "Minus", " ", "3"}], ")"}], " ", "z"}], ")"}]}]}], 
         ")"}]}], ")"}], "]"}], ",", 
     "\"\<((\[Lambda] x . (Divide 5 x))(\[Lambda] z . (Plus (-3) z)))\>\""}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.746778248801133*^9, 3.746778343748313*^9}, {
   3.746792545496859*^9, 3.746792557904111*^9}, 3.7468227288022547`*^9, {
   3.7470404611936493`*^9, 3.747040480587948*^9}, {3.747040718126395*^9, 
   3.747040746216217*^9}, 3.747040776581806*^9, {3.747040807071198*^9, 
   3.747040855996521*^9}, {3.747040932554719*^9, 3.747040968498886*^9}, {
   3.7470414593000298`*^9, 
   3.747041479143866*^9}},ExpressionUUID->"51e0e516-fe34-43b8-b996-\
29821fa65eee"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", 
    "\[Rule]", "\<\"((\[Lambda] x . (/ 5 x))(\[Lambda] z . (+ (-3) \
z)))\"\>"}], ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", 
     RowBox[{
      RowBox[{"-", "3"}], "+", "z$3375"}]]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$3375\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$3375", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] x . (/ 5 x))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","x",
        "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
        TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$3375","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(- 3)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 x)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}], ",", 
   RowBox[{"\<\"order\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"5", ",", "1", ",", "3", ",", "4", ",", "6", ",", "2"}], 
     "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.7467783441130457`*^9, 3.746787455515502*^9, 3.746788072757584*^9, 
   3.746788836342998*^9, {3.746792553109366*^9, 3.746792558359297*^9}, 
   3.746802303256876*^9, 3.746815388711474*^9, 3.746822730369752*^9, 
   3.746829330123887*^9, 3.7468297350512*^9, 3.7470404809520283`*^9, {
   3.747040517620268*^9, 3.7470405210732737`*^9}, {3.7470407209631433`*^9, 
   3.74704074683748*^9}, 3.747040777036759*^9, {3.7470408111553698`*^9, 
   3.747040878634709*^9}, {3.747040963362213*^9, 3.747040968784465*^9}, 
   3.747041016350184*^9, 3.747041446209539*^9},
 CellLabel->"Out[81]=",ExpressionUUID->"848e6ac5-5287-4271-8340-89fb99ee549f"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] x . (/ 5 x))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","x",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$3375","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(- 3)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7467783441130457`*^9, 3.746787455515502*^9, 3.746788072757584*^9, 
   3.746788836342998*^9, {3.746792553109366*^9, 3.746792558359297*^9}, 
   3.746802303256876*^9, 3.746815388711474*^9, 3.746822730369752*^9, 
   3.746829330123887*^9, 3.7468297350512*^9, 3.7470404809520283`*^9, {
   3.747040517620268*^9, 3.7470405210732737`*^9}, {3.7470407209631433`*^9, 
   3.74704074683748*^9}, 3.747040777036759*^9, {3.7470408111553698`*^9, 
   3.747040878634709*^9}, {3.747040963362213*^9, 3.747040968784465*^9}, 
   3.747041016350184*^9, 3.7470414462230673`*^9},
 CellLabel->"Out[82]=",ExpressionUUID->"b008d503-add3-46ac-ab3b-602c6b099007"]
}, Open  ]],

Cell["\<\
Notice the left most \[Lambda] expressions variable name does not matter:\
\>", "Text",
 CellChangeTimes->{{3.746566772814043*^9, 
  3.746566795268664*^9}},ExpressionUUID->"aa52d49c-00db-4d8a-9969-\
669c9e099932"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] W . (Divide 5 W))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 W)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus (-3) z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus (-3) z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(\[Lambda] x . (Divide 5 x))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<(Minus 3)\>\""}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"eval", "[", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"(", 
       RowBox[{"5", 
        RowBox[{"(", 
         RowBox[{"1", " ", "\[Lambda]", " ", 
          RowBox[{"W", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "Divide", " ", "5", " ", "W"}], ")"}]}]}], 
         ")"}], 
        RowBox[{"(", 
         RowBox[{"3", " ", "\[Lambda]", " ", 
          RowBox[{"z", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"4", " ", "Plus", " ", 
             RowBox[{"(", 
              RowBox[{"6", "Minus", " ", "3"}], ")"}], " ", "z"}], ")"}]}]}], 
         ")"}]}], ")"}], "]"}], ",", 
     "\"\<((\[Lambda] W . (Divide 5 W))(\[Lambda] z . (Plus (-3) z)))\>\""}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.746778248801133*^9, 3.746778343748313*^9}, {
   3.746792545496859*^9, 3.746792557904111*^9}, 3.7468227288022547`*^9, {
   3.7470404611936493`*^9, 3.747040480587948*^9}, {3.747040718126395*^9, 
   3.747040746216217*^9}, 3.747040776581806*^9, {3.747040807071198*^9, 
   3.747040855996521*^9}, {3.747040932554719*^9, 3.747040968498886*^9}, {
   3.7470410539891863`*^9, 3.747041073956813*^9}},
 CellLabel->"In[83]:=",ExpressionUUID->"82890f21-d791-44bb-8ea4-674367ea1e35"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", 
    "\[Rule]", "\<\"((\[Lambda] W . (/ 5 W))(\[Lambda] z . (+ (-3) \
z)))\"\>"}], ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", 
     RowBox[{
      RowBox[{"-", "3"}], "+", "z$3412"}]]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$3412\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$3412", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] x . (/ 5 x))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","W",
        "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
        TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$3412","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(- 3)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 W)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}], ",", 
   RowBox[{"\<\"order\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"5", ",", "1", ",", "3", ",", "4", ",", "6", ",", "2"}], 
     "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.746566765695786*^9, 3.7465686952108593`*^9, 3.7466103667775707`*^9, 
   3.7466464547338142`*^9, 3.746647007326498*^9, 3.746651044086858*^9, 
   3.7466516732335367`*^9, 3.746691498181324*^9, 3.746693469546282*^9, 
   3.746694425060371*^9, 3.7466958637232943`*^9, 3.746705966308043*^9, {
   3.746706602306652*^9, 3.746706631681217*^9}, 3.7467079130849037`*^9, 
   3.746778459331584*^9, 3.746787461984809*^9, 3.746788075306526*^9, 
   3.746788839094862*^9, 3.746802306224625*^9, 3.746815396313405*^9, 
   3.746822736423072*^9, 3.746829333674715*^9, 3.7468297364817657`*^9, 
   3.747041075515362*^9, 3.747041483452314*^9},
 CellLabel->"Out[84]=",ExpressionUUID->"914b0dd7-f15b-499a-84fa-1329679307b3"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] x . (/ 5 x))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","W",
       "\" \\!\\(\\*OverscriptBox[\\(\[LongRightArrow]\\), \\(\\\"\[Beta] \
conversion\\\"\\)]\\) \"",
       TemplateBox[{
        "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$3412","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(- 3)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 W)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746566765695786*^9, 3.7465686952108593`*^9, 3.7466103667775707`*^9, 
   3.7466464547338142`*^9, 3.746647007326498*^9, 3.746651044086858*^9, 
   3.7466516732335367`*^9, 3.746691498181324*^9, 3.746693469546282*^9, 
   3.746694425060371*^9, 3.7466958637232943`*^9, 3.746705966308043*^9, {
   3.746706602306652*^9, 3.746706631681217*^9}, 3.7467079130849037`*^9, 
   3.746778459331584*^9, 3.746787461984809*^9, 3.746788075306526*^9, 
   3.746788839094862*^9, 3.746802306224625*^9, 3.746815396313405*^9, 
   3.746822736423072*^9, 3.746829333674715*^9, 3.7468297364817657`*^9, 
   3.747041075515362*^9, 3.747041483464245*^9},
 CellLabel->"Out[85]=",ExpressionUUID->"cf7a9ed3-b934-4352-9c45-d8a53436e56e"]
}, Open  ]]
},
WindowSize->{1397, 1225},
WindowMargins->{{Automatic, 331}, {47, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1439, 34, 94, "Input",ExpressionUUID->"675323c7-0aa0-4d16-84e5-172b6aed42a7"],
Cell[CellGroupData[{
Cell[2022, 58, 28643, 650, 3610, "Input",ExpressionUUID->"032bf690-a7dd-49ac-a8c4-b1b1024a3e4c"],
Cell[30668, 710, 696, 10, 34, "Output",ExpressionUUID->"7ff4c832-7070-4e5b-b51e-b3e42a59e265"],
Cell[31367, 722, 734, 13, 34, "Output",ExpressionUUID->"13881798-2ad4-4e28-ae50-e73a78533d4e"],
Cell[32104, 737, 1585, 35, 93, "Output",ExpressionUUID->"8143a68b-20f8-443b-b08f-96497f5b2b84"]
}, Open  ]],
Cell[33704, 775, 304, 6, 157, "Input",ExpressionUUID->"d0c952d8-c305-4865-87b5-beff67d8511d"],
Cell[CellGroupData[{
Cell[34033, 785, 29607, 667, 3736, "Input",ExpressionUUID->"9f82f00a-f80b-456f-b68a-6ab7e08573c4"],
Cell[63643, 1454, 807, 11, 34, "Output",ExpressionUUID->"2c153023-e41a-413f-89e1-c7b20e0416aa"],
Cell[64453, 1467, 813, 12, 34, "Output",ExpressionUUID->"57348c23-d700-4f12-9dd1-0cfb3eafea56"],
Cell[65269, 1481, 1622, 34, 75, "Output",ExpressionUUID->"8fef1ead-bc04-4204-a11d-294f580ecdb2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66928, 1520, 30242, 684, 3799, "Input",ExpressionUUID->"43d0e384-d11a-4629-8976-978a85536cf9"],
Cell[97173, 2206, 1662, 24, 34, "Output",ExpressionUUID->"7736a68a-09c2-4046-8f02-b35bf46338a9"],
Cell[98838, 2232, 1672, 26, 35, "Output",ExpressionUUID->"881279a6-e66a-449c-a9e1-9ebc7660f50f"],
Cell[100513, 2260, 1625, 24, 34, "Output",ExpressionUUID->"e22f9685-f3a6-4691-8f23-d90d1b89253e"],
Cell[102141, 2286, 2777, 53, 107, "Output",ExpressionUUID->"f16a0c0c-093c-46e4-ae8b-8b0881dcd93b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104955, 2344, 37768, 843, 4318, "Input",ExpressionUUID->"2b45e18d-71c8-4c7d-b907-696c576f5065"],
Cell[142726, 3189, 2215, 31, 34, "Output",ExpressionUUID->"aae6cad6-c111-465e-81c8-92e2605acb04"],
Cell[144944, 3222, 2235, 35, 41, "Output",ExpressionUUID->"762fac81-166e-42b3-9909-efa766c514c3"],
Cell[147182, 3259, 2149, 32, 34, "Output",ExpressionUUID->"81ec6830-0a94-4bec-909b-643ca7fdd78c"],
Cell[149334, 3293, 4700, 96, 263, "Output",ExpressionUUID->"b03104d3-c085-46e8-8bf0-a5d4bb7bb0c4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[154071, 3394, 1677, 37, 262, "Input",ExpressionUUID->"d407a503-662e-4347-96fd-afb9c340e044"],
Cell[155751, 3433, 786, 11, 34, "Output",ExpressionUUID->"0a330ffe-2589-4df9-b531-5ce610e60cb9"],
Cell[156540, 3446, 827, 14, 34, "Output",ExpressionUUID->"54ab00d7-2e8c-4b3b-9f74-84a1a8bb730c"],
Cell[157370, 3462, 1640, 37, 121, "Output",ExpressionUUID->"4e76c504-b055-45d6-93bc-38ee86505c3e"]
}, Open  ]],
Cell[159025, 3502, 439, 11, 104, "Text",ExpressionUUID->"2bf1cecf-4c87-40cd-bfd6-f7106eae54e6"],
Cell[CellGroupData[{
Cell[159489, 3517, 21444, 489, 2518, "Input",ExpressionUUID->"03998b9c-2f8e-4f41-8677-4334b6011aa4"],
Cell[180936, 4008, 2754, 40, 34, "Output",ExpressionUUID->"8728a9c2-983c-4562-b1e5-bac7f1146107"],
Cell[183693, 4050, 2773, 42, 34, "Output",ExpressionUUID->"a183d380-2938-4178-8427-e807ca7718e5"],
Cell[186469, 4094, 3815, 70, 127, "Output",ExpressionUUID->"35d8bcee-f8d6-49da-8fc6-491b2726a27b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190321, 4169, 2356, 53, 325, "Input",ExpressionUUID->"457740d9-5528-44dd-b8ff-93e2d1bc93cc"],
Cell[192680, 4224, 1308, 19, 34, "Output",ExpressionUUID->"73d9c1b3-fc00-4726-9656-e52ec2c40794"],
Cell[193991, 4245, 1299, 20, 52, "Output",ExpressionUUID->"f6810bce-3430-4051-b2c9-a12ef26a74b0"],
Cell[195293, 4267, 2318, 49, 127, "Output",ExpressionUUID->"a0d2645d-7101-4918-aed7-4e3da6dfb031"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197648, 4321, 1694, 39, 325, "Input",ExpressionUUID->"5c95b0d2-d973-4297-9066-2effa5b1510b"],
Cell[199345, 4362, 587, 9, 40, "Output",ExpressionUUID->"25d6c8d6-ab85-4f57-a6c7-a5159e651f57"],
Cell[199935, 4373, 567, 10, 41, "Output",ExpressionUUID->"513aa4f4-d475-4d6e-8451-6613b1c409bc"],
Cell[200505, 4385, 1287, 28, 87, "Output",ExpressionUUID->"59cf3478-d08f-40e3-b319-d53d54c0b559"]
}, Open  ]],
Cell[201807, 4416, 253, 7, 97, "Text",ExpressionUUID->"04e7e40d-fa6d-4d46-846a-1415ba9cc26a"],
Cell[CellGroupData[{
Cell[202085, 4427, 5237, 105, 556, "Input",ExpressionUUID->"5fea9086-92cd-4a61-acb7-8bf27d803db6"],
Cell[207325, 4534, 3403, 48, 34, "Output",ExpressionUUID->"fe18d101-868a-4b5b-a402-77848024c9c2"],
Cell[210731, 4584, 3282, 47, 34, "Output",ExpressionUUID->"00af3f8e-ae13-4256-bb46-cb8c4d7d1b28"],
Cell[214016, 4633, 3604, 57, 41, "Output",ExpressionUUID->"ef253a02-4e75-4e1c-93d5-2b1f5e47de8e"]
}, Open  ]],
Cell[217635, 4693, 149, 3, 52, "Input",ExpressionUUID->"9c783d49-3182-41cc-8815-f4524f7dc2fd"],
Cell[CellGroupData[{
Cell[217809, 4700, 4945, 97, 556, "Input",ExpressionUUID->"79d5165c-3ac5-4d3f-9632-019571cd76f8"],
Cell[222757, 4799, 925, 13, 34, "Output",ExpressionUUID->"0a1ee025-7ca3-4ebe-a523-deb3f5baf667"],
Cell[223685, 4814, 882, 15, 43, "Output",ExpressionUUID->"2be9b090-f27f-40e3-b9ff-a49a3a321e87"],
Cell[224570, 4831, 2764, 66, 221, "Output",ExpressionUUID->"4b0c1377-a16a-49b9-9601-2a1b71c082ad"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227371, 4902, 3437, 69, 388, "Input",ExpressionUUID->"5d8209de-7dfa-4da6-823e-26e75ecf3ef5"],
Cell[230811, 4973, 936, 14, 34, "Output",ExpressionUUID->"136fc50b-ff57-49f1-a97a-cb0aa518efe1"],
Cell[231750, 4989, 921, 15, 52, "Output",ExpressionUUID->"9aa78569-2c4f-492f-ad50-33358e580b11"],
Cell[232674, 5006, 917, 15, 51, "Output",ExpressionUUID->"439776a7-92b8-472b-80b5-19d590ea10f1"],
Cell[233594, 5023, 2196, 50, 155, "Output",ExpressionUUID->"aa5a1c4f-fe2f-4719-a96c-cf6afe477060"]
}, Open  ]],
Cell[235805, 5076, 196, 6, 97, "Text",ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-5c197a10ae7f"],
Cell[236004, 5084, 260, 7, 58, "Text",ExpressionUUID->"537278c6-b157-4293-8ad9-a7445d850ccc"],
Cell[236267, 5093, 309, 8, 58, "Text",ExpressionUUID->"3bb0307b-077c-4bff-aa91-bcf0be33c48f"],
Cell[236579, 5103, 345, 8, 58, "Text",ExpressionUUID->"8d1383d3-1524-40bc-8d25-caa0b1904007"],
Cell[CellGroupData[{
Cell[236949, 5115, 230, 4, 30, "Input",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],
Cell[237182, 5121, 280, 4, 34, "Output",ExpressionUUID->"5ff39c65-228e-4e13-ac5c-8010d1c31629"]
}, Open  ]],
Cell[237477, 5128, 729, 16, 235, "Text",ExpressionUUID->"ba63361b-1bdd-49bc-af32-eef69722d648"],
Cell[CellGroupData[{
Cell[238231, 5148, 1358, 32, 283, "Input",ExpressionUUID->"4a3c35ae-f757-486f-9014-5fbba6540527"],
Cell[239592, 5182, 370, 5, 34, "Output",ExpressionUUID->"ab1628f5-62eb-48f2-aa28-e1cd0a020dfa"],
Cell[239965, 5189, 367, 6, 53, "Output",ExpressionUUID->"9b3cdae9-10fa-4298-ae06-32f65085c89f"],
Cell[240335, 5197, 1033, 25, 89, "Output",ExpressionUUID->"c2b158b8-fcb2-46cd-85a3-56db092a5a2e"]
}, Open  ]],
Cell[241383, 5225, 1450, 24, 87, "Text",ExpressionUUID->"fe82ef0f-42c5-423b-a36b-1af62e1981e0"],
Cell[CellGroupData[{
Cell[242858, 5253, 1934, 44, 346, "Input",ExpressionUUID->"58cf5de7-0e94-4b12-af12-f1d8c46e0923"],
Cell[244795, 5299, 443, 6, 34, "Output",ExpressionUUID->"20ca7876-de69-4659-b9ec-a60668927ec5"],
Cell[245241, 5307, 429, 7, 51, "Output",ExpressionUUID->"d9c52104-6b3c-420f-90ea-136e054db33e"],
Cell[245673, 5316, 1438, 36, 121, "Output",ExpressionUUID->"8b6ca195-a115-424b-8873-83c2bb4d8dd3"]
}, Open  ]],
Cell[247126, 5355, 412, 9, 58, "Text",ExpressionUUID->"ef9e9a56-5785-4d41-aa60-36d483d5411e"],
Cell[247541, 5366, 560, 13, 120, "Text",ExpressionUUID->"f95ff3c1-9237-464a-afd8-06e0eabefd8e"],
Cell[248104, 5381, 349, 10, 104, "Text",ExpressionUUID->"88450169-06ab-4ef8-9120-f29966174203"],
Cell[CellGroupData[{
Cell[248478, 5395, 1456, 30, 283, "Input",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],
Cell[249937, 5427, 2037, 42, 53, "Output",ExpressionUUID->"93e7ce4e-01e5-49bd-a3aa-56e747f02e61"]
}, Open  ]],
Cell[251989, 5472, 193, 6, 58, "Text",ExpressionUUID->"9a26861f-0101-4c3c-84a6-7756074f32a1"],
Cell[CellGroupData[{
Cell[252207, 5482, 1126, 25, 220, "Input",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],
Cell[253336, 5509, 1733, 38, 52, "Output",ExpressionUUID->"acaed77f-d5f6-45b7-8d3e-be6529d127c7"]
}, Open  ]],
Cell[255084, 5550, 301, 7, 97, "Text",ExpressionUUID->"15ef489a-5536-452d-ae09-86b73d643a13"],
Cell[CellGroupData[{
Cell[255410, 5561, 2610, 62, 346, "Input",ExpressionUUID->"51e0e516-fe34-43b8-b996-29821fa65eee"],
Cell[258023, 5625, 2743, 63, 87, "Output",ExpressionUUID->"848e6ac5-5287-4271-8340-89fb99ee549f"],
Cell[260769, 5690, 2189, 53, 187, "Output",ExpressionUUID->"b008d503-add3-46ac-ab3b-602c6b099007"]
}, Open  ]],
Cell[262973, 5746, 223, 5, 35, "Text",ExpressionUUID->"aa52d49c-00db-4d8a-9969-669c9e099932"],
Cell[CellGroupData[{
Cell[263221, 5755, 2342, 53, 346, "Input",ExpressionUUID->"82890f21-d791-44bb-8ea4-674367ea1e35"],
Cell[265566, 5810, 2812, 64, 87, "Output",ExpressionUUID->"914b0dd7-f15b-499a-84fa-1329679307b3"],
Cell[268381, 5876, 2256, 54, 187, "Output",ExpressionUUID->"cf7a9ed3-b934-4352-9c45-d8a53436e56e"]
}, Open  ]]
}
]
*)

