(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    117399,       2519]
NotebookOptionsPosition[    110400,       2412]
NotebookOutlinePosition[    110785,       2429]
CellTagsIndexPosition[    110742,       2426]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9, {3.7467904563706017`*^9, 3.746790457458392*^9}, 
   3.746820283433523*^9, {3.74682967888512*^9, 3.7468297021398363`*^9}},
 CellLabel->
  "In[121]:=",ExpressionUUID->"675323c7-0aa0-4d16-84e5-172b6aed42a7"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{"<<", "Notation`"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "operators", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"i_", " ", "op_", " ", "x_"}], " ", ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"AppendTo", "[", 
           RowBox[{"\[Xi]2", ",", 
             RowBox[{"Row", "@", 
               RowBox[{"{", 
                 RowBox[{"Highlighted", "[", 
                   RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], 
                 "}"}]}]}], "]"}], ";", 
         RowBox[{"Construct", "[", 
           RowBox[{"op_", ",", " ", "x_"}], " ", "]"}]}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"i_", " ", "op_", " ", "x_", " ", "y_"}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"AppendTo", "[", 
           RowBox[{"\[Xi]2", ",", 
             RowBox[{"Row", "@", 
               RowBox[{"{", 
                 RowBox[{"Highlighted", "[", 
                   RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], 
                 "}"}]}]}], "]"}], ";", 
         RowBox[{"Construct", "[", 
           RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]1"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "all", " ", "other", " ", "interm", " ", "transformations", " ", "and", 
     " ", "replacements", " ", "into", " ", "\[Xi]2"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"i_", " ", "\[Lambda]", " ", 
           RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Block", "[", 
         RowBox[{
           RowBox[{"{", "tmp", "}"}], ",", 
           RowBox[{
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]2", ",", 
                 RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], 
                    ",", "\" \"", ",", " ", "x_", ",", " ", 
                    "\"\[LongRightArrow]\"", " ", ",", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"Unique", "[", "x_", "]"}]}], ",", " ", 
                    "\" a new copy\""}], "}"}]}]}], "]"}], ";", 
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]3", ",", 
                 RowBox[{"Row", "[", 
                   RowBox[{"{", 
                    
                    RowBox[{
                    "x_", ",", "\"\[LongRightArrow]\"", ",", " ", "tmp"}], 
                    "}"}], "]"}]}], "]"}], ";", 
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]1", ",", "tmp"}], "]"}], ";", 
             RowBox[{
               RowBox[{"Function", "[", 
                 RowBox[{"x_", ",", "expr_"}], "]"}], "[", "tmp", "]"}]}]}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "\[Lambda]", " ", "with", " ", 
     "explicit"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{
           RowBox[{"(", " ", 
             RowBox[{"i_", " ", "\[Lambda]", " ", 
               RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}], 
         ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     "\[IndentingNewLine]", 
     TemplateBox[{RowBox[{"Block", "[", 
         RowBox[{
           RowBox[{"{", "tmp", "}"}], ",", 
           RowBox[{
             RowBox[{"AppendTo", "[", 
               RowBox[{"\[Xi]2", ",", 
                 RowBox[{"Row", "@", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"\[Mho]", " ", 
                    RowBox[{"\[Rho]", "[", "i_", "]"}]}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], 
                    ",", "\" \"", ",", " ", "x_", ",", " ", 
                    "\" , Redex: \[Beta] conversion\""}], "}"}]}]}], "]"}], 
             ";", 
             RowBox[{
               RowBox[{"Function", "[", 
                 RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]}]}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Beta]", " ", "conversion", " ", "without", " ", "knowing", " ", 
     "which", " ", 
     RowBox[{"\[Lambda]", ".", " ", "After"}], " ", "this", " ", "pass", " ", 
     "a", " ", "post", " ", "prcessing", " ", "required", " ", "to", " ", 
     "complete", " ", 
     RowBox[{"\[Beta]", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"i_", " ", 
           RowBox[{"(", "e_", ")"}], " ", "f_"}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"\[CurlyRho]", "=", 
         RowBox[{"{", 
           RowBox[{"i_", ",", 
             RowBox[{"(", "e_", ")"}], ",", "f_"}], "}"}]}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operator", " ", "to", " ", "convert", " ", "the", " ", "arithmatic", " ",
      "operators"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"StringReplace", "[", 
         RowBox[{"x_", ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"\"Plus\"", "\[Rule]", "\"+\""}], ",", 
               RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
               RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
               RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
               RowBox[{"\"Power\"", "\[Rule]", "\"^\""}], ",", 
               RowBox[{"\"Sqrt\"", "\[Rule]", "\"\[Sqrt]\""}], ",", 
               RowBox[{"\"Mod\"", "\[Rule]", "\"Mod\""}], ",", 
               RowBox[{"\"Log\"", "\[Rule]", "\"Log\""}], ",", 
               RowBox[{"\"Exp\"", "\[Rule]", "\"Exp\""}], ",", 
               RowBox[{"\"Sin\"", "\[Rule]", "\"Sin\""}], ",", 
               RowBox[{"\"Cos\"", "\[Rule]", "\"Cos\""}], ",", 
               RowBox[{"\"Abs\"", "\[Rule]", "\"Abs\""}]}], "}"}]}], "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "operators", " ", "to", " ", "searach", " ", "for", " ", "variables"}], 
    " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"ToString", "/@", 
             RowBox[{"Level", "[", 
               RowBox[{"x_", ",", 
                 RowBox[{"{", 
                   RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"Table", "[", 
             RowBox[{
               RowBox[{"StringTake", "[", 
                 RowBox[{"i", ",", "1"}], "]"}], ",", 
               RowBox[{"{", 
                 RowBox[{"i", ",", 
                   RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
             "]"}], ",", "NameQ"}], "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"operator", " ", "for", " ", 
     RowBox[{"initialization", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Omicron]", ";"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"\[Xi]1", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Xi]2", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Xi]3", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[Xi]4", "=", 
           RowBox[{"{", "}"}]}], ";", 
         RowBox[{"\[CurlyRho]", "=", "Nothing"}]}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"expr_", ",", "sexpr_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "all", ",", "bound", ",", "input", ",", "output1", ",", "output2"}], 
        "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"input", "=", 
         RowBox[{"\[Mho]", " ", "sexpr"}]}], ";", "\[IndentingNewLine]", 
        "\[Omicron]", ";", "\[IndentingNewLine]", 
        RowBox[{"output2", "=", 
         RowBox[{"output1", "=", 
          RowBox[{"ReleaseHold", "[", "expr", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"bound", "=", 
         RowBox[{"ToString", "/@", "\[Xi]1"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"\[Xi]4", "=", 
         RowBox[{"ToExpression", "/@", 
          RowBox[{"Intersection", "[", 
           RowBox[{
            RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}]}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"\[CurlyRho]", " ", "=!=", "Nothing"}], "&&", 
           RowBox[{"\[Xi]4", "=!=", 
            RowBox[{"{", "}"}]}]}], ",", 
          RowBox[{"output2", "=", " ", 
           RowBox[{
            RowBox[{"\[CurlyRho]", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Xi]4", "[", 
                RowBox[{"[", "jj", "]"}], "]"}], "\[Rule]", 
               RowBox[{"\[CurlyRho]", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"jj", ",", "1", ",", 
                RowBox[{"Length", "@", "\[Xi]4"}]}], "}"}]}], "]"}]}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<input\>\"", "->", "input"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"output1", "===", "output2"}], ",", 
            RowBox[{"\"\<output\>\"", "\[Rule]", "output1"}], ",", 
            RowBox[{"\"\<output1\>\"", "\[Rule]", 
             RowBox[{"output1", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"output1", "===", "output2"}], ",", "Nothing", ",", 
            RowBox[{"\"\<output2\>\"", "\[Rule]", "output2"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<free\>\"", "->", 
           RowBox[{"Complement", "[", 
            RowBox[{
             RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<bound\>\"", "\[Rule]", 
           RowBox[{"Intersection", "[", 
            RowBox[{
             RowBox[{"\[Nu]", " ", "output1"}], ",", "bound"}], "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<stack\>\"", "\[Rule]", "\[Xi]1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<trace\>\"", "->", "\[Xi]2"}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "|>"}]}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.741884966938229*^9, 3.741884968652132*^9}, {
   3.7418850028831463`*^9, 3.741885004201413*^9}, {3.741885204804133*^9, 
   3.741885207231092*^9}, 3.741885574830003*^9, 3.7418867444594927`*^9, {
   3.741943718173574*^9, 3.741943718669817*^9}, 3.741944445968795*^9, {
   3.746438295807288*^9, 3.7464384109459963`*^9}, {3.746438543247486*^9, 
   3.746438572103177*^9}, {3.7464387178455877`*^9, 3.746438805521862*^9}, 
   3.746438837698395*^9, {3.7464391383051157`*^9, 3.746439138572727*^9}, {
   3.7464398685092154`*^9, 3.746439965135532*^9}, {3.746440020803397*^9, 
   3.7464400621016293`*^9}, 3.746440126287815*^9, {3.746440213170883*^9, 
   3.746440219491139*^9}, {3.746442292002969*^9, 3.7464422936100473`*^9}, {
   3.746443068580141*^9, 3.746443082192377*^9}, {3.7464435484242268`*^9, 
   3.746443556197298*^9}, {3.7464437159059563`*^9, 3.7464437183456173`*^9}, {
   3.746443755337791*^9, 3.746443765326571*^9}, {3.746449122713505*^9, 
   3.746449123217516*^9}, {3.746517908497835*^9, 3.7465179149530888`*^9}, {
   3.7465180208638983`*^9, 3.7465180379964533`*^9}, {3.746518226020875*^9, 
   3.7465182347058983`*^9}, {3.746518302522826*^9, 3.746518308653159*^9}, 
   3.746518353761698*^9, {3.7465184015283318`*^9, 3.746518408420697*^9}, {
   3.7465184413296547`*^9, 3.746518464559195*^9}, {3.746518691121707*^9, 
   3.746518749998335*^9}, {3.7465187808473377`*^9, 3.746518782343112*^9}, 
   3.746518850486842*^9, {3.746518918628833*^9, 3.7465189258386183`*^9}, {
   3.7465189933302937`*^9, 3.7465190469583883`*^9}, {3.746519095925078*^9, 
   3.7465191065956373`*^9}, {3.746519215375276*^9, 3.746519218208782*^9}, {
   3.746519271537499*^9, 3.746519301100882*^9}, {3.7465193888640833`*^9, 
   3.746519406212596*^9}, {3.746519548302512*^9, 3.7465195558081427`*^9}, {
   3.746519644243801*^9, 3.746519692427041*^9}, {3.746519962207954*^9, 
   3.746520090076126*^9}, {3.746520175163761*^9, 3.746520268042531*^9}, {
   3.746520582857682*^9, 3.7465205869513617`*^9}, {3.7465207665975237`*^9, 
   3.746520771060738*^9}, {3.746520813183613*^9, 3.7465208137325487`*^9}, {
   3.7465210029286737`*^9, 3.7465210321552677`*^9}, 3.746522404275511*^9, {
   3.746525380985317*^9, 3.746525469276286*^9}, {3.74652552631448*^9, 
   3.746525551536097*^9}, {3.746525628975909*^9, 3.746525658176279*^9}, {
   3.746525712032557*^9, 3.746525718320133*^9}, {3.74652590192612*^9, 
   3.746525923781946*^9}, {3.7465284605108356`*^9, 3.746528467348728*^9}, {
   3.7465289060854197`*^9, 3.746528914364828*^9}, {3.746529060110991*^9, 
   3.746529078662787*^9}, {3.746529162804944*^9, 3.746529163185218*^9}, 
   3.746529342914136*^9, {3.746529383183393*^9, 3.7465294069204473`*^9}, {
   3.746529480373765*^9, 3.746529481688757*^9}, 3.746529544882347*^9, {
   3.746533258425908*^9, 3.7465332610672703`*^9}, 3.746533832585009*^9, {
   3.746533885859384*^9, 3.746533925447526*^9}, {3.746534029073909*^9, 
   3.7465340690105553`*^9}, {3.746534183256856*^9, 3.7465342187506447`*^9}, {
   3.746534248789212*^9, 3.746534301838954*^9}, {3.746534612442665*^9, 
   3.746534631119721*^9}, {3.7465346791099586`*^9, 3.7465347578209352`*^9}, {
   3.7465348034358463`*^9, 3.746534810478689*^9}, {3.746534897547264*^9, 
   3.746534906385626*^9}, 3.74653506167351*^9, {3.7465351319194117`*^9, 
   3.746535159417595*^9}, {3.746535218680316*^9, 3.746535223010232*^9}, {
   3.746535260047853*^9, 3.7465352962828836`*^9}, {3.746535447824605*^9, 
   3.746535449825451*^9}, {3.7465358898667707`*^9, 3.746535893679187*^9}, {
   3.746541310956003*^9, 3.746541389188208*^9}, {3.746566992800914*^9, 
   3.746567009371809*^9}, {3.746567052565855*^9, 3.746567092735874*^9}, {
   3.7465677855818157`*^9, 3.746567794298473*^9}, {3.746568146982937*^9, 
   3.7465682021898947`*^9}, {3.7465686160261497`*^9, 3.746568660170498*^9}, {
   3.7465687322300987`*^9, 3.746568843785166*^9}, {3.7465691686029177`*^9, 
   3.7465691729101*^9}, {3.746609822672832*^9, 3.7466098306691637`*^9}, {
   3.7466149184788647`*^9, 3.7466149469401484`*^9}, {3.746615094734571*^9, 
   3.746615103272112*^9}, {3.7466152284810953`*^9, 3.746615231378025*^9}, {
   3.746615299443328*^9, 3.746615330222188*^9}, {3.746615383391465*^9, 
   3.7466154224407797`*^9}, {3.746615456630966*^9, 3.746615464920679*^9}, {
   3.746615837698468*^9, 3.746615845329034*^9}, 3.746616047403758*^9, {
   3.746616090139949*^9, 3.7466161140793333`*^9}, {3.746616147816036*^9, 
   3.746616180695897*^9}, {3.7466163640704203`*^9, 3.746616365396945*^9}, {
   3.746616495732643*^9, 3.746616496116905*^9}, {3.746616564953828*^9, 
   3.746616592133308*^9}, 3.7466166455650473`*^9, {3.746616689789775*^9, 
   3.7466167196992188`*^9}, {3.7466167598308153`*^9, 3.746616760740314*^9}, {
   3.746616986286227*^9, 3.746617020958962*^9}, {3.746617157514001*^9, 
   3.7466171675504913`*^9}, {3.746617550058576*^9, 3.746617553327485*^9}, {
   3.7466176020662317`*^9, 3.746617622056006*^9}, 3.746617876491611*^9, {
   3.746618056831653*^9, 3.746618058877672*^9}, {3.746618905209826*^9, 
   3.7466189063664722`*^9}, {3.746644495645113*^9, 3.7466445136767*^9}, {
   3.7466450334283133`*^9, 3.746645036934874*^9}, {3.74664613995013*^9, 
   3.746646142817054*^9}, {3.746646293718017*^9, 3.7466463231348543`*^9}, {
   3.746646763639003*^9, 3.7466467992243567`*^9}, {3.746646838157529*^9, 
   3.746646847854662*^9}, {3.7466475746557627`*^9, 3.7466476169672403`*^9}, {
   3.746647706414455*^9, 3.746647711824068*^9}, 3.74664802753292*^9, {
   3.7466485977907457`*^9, 3.746648599284348*^9}, {3.746648842639731*^9, 
   3.746648921051874*^9}, 3.746648988271893*^9, {3.74664976871133*^9, 
   3.746649769635315*^9}, {3.746650206613771*^9, 3.74665020796213*^9}, {
   3.746650401848735*^9, 3.74665040301733*^9}, {3.7466504366694202`*^9, 
   3.746650464600868*^9}, {3.7466508961259947`*^9, 3.7466509111549263`*^9}, {
   3.746651440400255*^9, 3.746651472078389*^9}, {3.7466520167360783`*^9, 
   3.746652028377984*^9}, 3.74665208476468*^9, {3.746667224682798*^9, 
   3.7466672384721603`*^9}, {3.74666761079985*^9, 3.74666761118064*^9}, {
   3.746667895655025*^9, 3.746667993365225*^9}, {3.746668279466935*^9, 
   3.746668291324188*^9}, {3.74666834949885*^9, 3.746668373979082*^9}, {
   3.7466684716869307`*^9, 3.746668486187231*^9}, {3.746668599141638*^9, 
   3.746668697006712*^9}, {3.74669108600336*^9, 3.746691093817964*^9}, {
   3.7466915490472*^9, 3.746691556820407*^9}, 3.74669237764589*^9, {
   3.74669279839312*^9, 3.746692975412273*^9}, {3.74669301955914*^9, 
   3.746693019977831*^9}, {3.746693239298107*^9, 3.746693247356285*^9}, {
   3.746693311726941*^9, 3.746693347377523*^9}, {3.7466945825831547`*^9, 
   3.746694626625354*^9}, {3.7466946611088657`*^9, 3.7466946868588657`*^9}, {
   3.746694738488648*^9, 3.746694831817712*^9}, {3.746694880273576*^9, 
   3.746694882050569*^9}, {3.746694927647642*^9, 3.746694931010412*^9}, {
   3.746694975338089*^9, 3.746694977147623*^9}, {3.746695264996686*^9, 
   3.74669527164435*^9}, {3.746695302212943*^9, 3.746695309635659*^9}, {
   3.746695409225325*^9, 3.746695412057661*^9}, {3.74669571732201*^9, 
   3.74669583035252*^9}, {3.746695998873698*^9, 3.746696065446677*^9}, {
   3.7466961086525297`*^9, 3.7466961579344387`*^9}, {3.746696189112446*^9, 
   3.7466962243441143`*^9}, {3.746696509607576*^9, 3.7466965106849833`*^9}, {
   3.746696562874758*^9, 3.7466966117589273`*^9}, 3.746696700244774*^9, {
   3.7466967937741632`*^9, 3.746696879172529*^9}, {3.746696926257052*^9, 
   3.7466969534814672`*^9}, {3.746697007899493*^9, 3.7466970109802732`*^9}, {
   3.746697332241612*^9, 3.74669737110437*^9}, {3.746698592892839*^9, 
   3.7466986151556263`*^9}, {3.746698648469734*^9, 3.74669867258928*^9}, 
   3.7466994482234163`*^9, {3.74669957924288*^9, 3.746699588049958*^9}, {
   3.7466998961383057`*^9, 3.746699930811297*^9}, {3.746700005489848*^9, 
   3.7467000097822857`*^9}, {3.746700055991889*^9, 3.746700058645496*^9}, 
   3.7467001123447313`*^9, {3.746700389709627*^9, 3.746700450737215*^9}, {
   3.746701206409217*^9, 3.7467012166665993`*^9}, {3.746701311176064*^9, 
   3.746701317778674*^9}, {3.74670145669838*^9, 3.746701467980275*^9}, {
   3.746701633673911*^9, 3.7467016469815083`*^9}, {3.746701923953459*^9, 
   3.7467019337492*^9}, {3.746702040473737*^9, 3.746702043121418*^9}, {
   3.746705507340571*^9, 3.746705508398809*^9}, {3.746705668312028*^9, 
   3.7467056865254583`*^9}, {3.746705738250491*^9, 3.746705739016499*^9}, {
   3.74670648004235*^9, 3.746706480986746*^9}, {3.746707112905838*^9, 
   3.746707128898122*^9}, {3.7467073561173897`*^9, 3.746707473773902*^9}, {
   3.7467075282339697`*^9, 3.746707702532205*^9}, {3.746707755128168*^9, 
   3.746707759536845*^9}, {3.746715237014436*^9, 3.7467152469694033`*^9}, {
   3.746715325823546*^9, 3.746715326958372*^9}, {3.746715592240155*^9, 
   3.746715608067247*^9}, {3.7467159022966757`*^9, 3.746715925839696*^9}, {
   3.7467159652391148`*^9, 3.7467159707277*^9}, {3.74671626392262*^9, 
   3.746716316536893*^9}, 3.7467165314499283`*^9, {3.7467185194205*^9, 
   3.746718528020431*^9}, {3.746718621770376*^9, 3.746718631049818*^9}, {
   3.7467189095273867`*^9, 3.746718913598433*^9}, {3.746719004776272*^9, 
   3.74671904753253*^9}, {3.7467191872953863`*^9, 3.746719190612005*^9}, {
   3.746719326571822*^9, 3.7467193776801453`*^9}, {3.746719409093474*^9, 
   3.746719493118868*^9}, {3.74671957229078*^9, 3.746719577606925*^9}, {
   3.7467201121399603`*^9, 3.746720115974009*^9}, {3.746720157612709*^9, 
   3.746720165429744*^9}, {3.746721589042747*^9, 3.746721607310823*^9}, {
   3.746721789913954*^9, 3.746721800262734*^9}, {3.7467219182233753`*^9, 
   3.746721928537384*^9}, {3.746722393566765*^9, 3.746722470954582*^9}, {
   3.7467225554333467`*^9, 3.746722564916033*^9}, {3.746722749938816*^9, 
   3.7467227629466763`*^9}, {3.7467228558029547`*^9, 3.746722868603902*^9}, {
   3.746722974279737*^9, 3.746722983108364*^9}, {3.746723056461516*^9, 
   3.74672313850734*^9}, 3.746723176112198*^9, {3.746723220467927*^9, 
   3.746723255612091*^9}, {3.746723493666603*^9, 3.7467235088534403`*^9}, 
   3.746723547004036*^9, {3.746723671341504*^9, 3.7467237475986547`*^9}, {
   3.746731652870738*^9, 3.746731682456213*^9}, {3.746731757466365*^9, 
   3.746731822779154*^9}, {3.7467319187559433`*^9, 3.746731921645673*^9}, {
   3.746732313795846*^9, 3.74673232709135*^9}, {3.746732417365584*^9, 
   3.7467324200407248`*^9}, {3.746732797914384*^9, 3.746732800296962*^9}, {
   3.746732872300767*^9, 3.746732873400939*^9}, {3.746732934907288*^9, 
   3.746732937887252*^9}, {3.746733056909597*^9, 3.746733076579947*^9}, 
   3.746733230443243*^9, {3.74673347485105*^9, 3.746733479280706*^9}, {
   3.746744617570675*^9, 3.7467446226662273`*^9}, {3.746745139321703*^9, 
   3.74674518346233*^9}, {3.7467452312315083`*^9, 3.7467453172648573`*^9}, {
   3.746745585850676*^9, 3.7467456077622147`*^9}, {3.746746163399572*^9, 
   3.746746177814323*^9}, {3.746746659027157*^9, 3.746746659250586*^9}, 
   3.746746750772019*^9, 3.746747638290497*^9, {3.746747971497452*^9, 
   3.746747993726611*^9}, {3.7467480881650248`*^9, 3.746748097274192*^9}, {
   3.746748555314919*^9, 3.746748574348598*^9}, {3.746748657027727*^9, 
   3.746748659118915*^9}, {3.7467486958971453`*^9, 3.746748716686575*^9}, {
   3.746748813630784*^9, 3.7467488159583473`*^9}, {3.746749318528282*^9, 
   3.746749326604053*^9}, {3.746750866994573*^9, 3.746750906124537*^9}, 
   3.746775775469632*^9, {3.7467759340507317`*^9, 3.746775967226611*^9}, {
   3.746776634257474*^9, 3.746776645532627*^9}, {3.7467766920427322`*^9, 
   3.7467766929412937`*^9}, {3.746776736109392*^9, 3.746776738380528*^9}, {
   3.7467768276522627`*^9, 3.746776918282865*^9}, {3.746777394606339*^9, 
   3.74677739613393*^9}, {3.746777483437948*^9, 3.746777485944471*^9}, {
   3.746777545325666*^9, 3.746777549362298*^9}, {3.74678799607852*^9, 
   3.746788018748786*^9}, {3.746788448528613*^9, 3.746788449954431*^9}, {
   3.7467886511419477`*^9, 3.74678868493673*^9}, {3.746788720723526*^9, 
   3.746788752169354*^9}, {3.746789381593814*^9, 3.746789391381032*^9}, {
   3.7467894477225723`*^9, 3.746789452029991*^9}, {3.746789522930388*^9, 
   3.746789545440984*^9}, {3.746789618422423*^9, 3.746789618705195*^9}, {
   3.74679011928168*^9, 3.746790149957541*^9}, {3.746790193260891*^9, 
   3.746790217020164*^9}, {3.7467904112019043`*^9, 3.746790414742997*^9}, {
   3.7467931124217587`*^9, 3.746793115555118*^9}, {3.746793837097526*^9, 
   3.746793838727351*^9}, {3.7468018600485363`*^9, 3.746801923486373*^9}, {
   3.7468019660466213`*^9, 3.746801981054262*^9}, {3.7468020266100388`*^9, 
   3.746802072979226*^9}, 3.746813602951804*^9, {3.746813665640524*^9, 
   3.746813668043352*^9}, {3.7468137414862432`*^9, 3.746813793595786*^9}, {
   3.7468138511925373`*^9, 3.746813862044683*^9}, {3.746814078777577*^9, 
   3.74681408634846*^9}, 3.746814166316235*^9, {3.746814352776232*^9, 
   3.746814353161537*^9}, {3.7468144294167223`*^9, 3.7468144304360456`*^9}, 
   3.74681450888412*^9, {3.7468146121753902`*^9, 3.746814668512229*^9}, {
   3.7468147090251217`*^9, 3.746814734595386*^9}, {3.74681478901301*^9, 
   3.7468148032886744`*^9}, 3.746814889763534*^9, {3.746815708982895*^9, 
   3.7468157722001877`*^9}, {3.7468161704142323`*^9, 3.746816267186357*^9}, {
   3.746816387475595*^9, 3.74681642296769*^9}, {3.746816524506029*^9, 
   3.746816583239194*^9}, {3.746816869995455*^9, 3.7468168781862164`*^9}, 
   3.746817036254928*^9, {3.746817563356881*^9, 3.746817671469274*^9}, {
   3.746817775607258*^9, 3.746817791160324*^9}, 3.7468178730965853`*^9, {
   3.746818073992395*^9, 3.746818079153825*^9}, {3.746818214641391*^9, 
   3.746818223381268*^9}, 3.746822195447853*^9, {3.74682228524536*^9, 
   3.746822296899527*^9}, {3.7468224232297983`*^9, 3.746822426493421*^9}, {
   3.746822599532084*^9, 3.746822615079357*^9}, 3.746822773157826*^9, {
   3.746822806851802*^9, 3.746822979742187*^9}, {3.746829642886588*^9, 
   3.746829660450078*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"3551e59d-8c7b-4643-8fe4-a48c58dd4d4d"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]", "=", 
   RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"1", "\[Rule]", "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Plus 3 y))\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"3", "\[Rule]", "\"\<(Plus 3 y)\>\""}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", "Power", " ", 
         RowBox[{"(", 
          RowBox[{"2", " ", "\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"3", " ", "Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}],
          " ", "x"}], ")"}], "]"}], ",", 
      "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746731419252219*^9, 3.746731448337809*^9}, {
   3.746732254551585*^9, 3.746732261839855*^9}, {3.746732749166667*^9, 
   3.74673275245325*^9}, {3.746733562690836*^9, 3.746733563300418*^9}, 
   3.746744609988122*^9, 3.746822505146982*^9},
 CellLabel->
  "In[122]:=",ExpressionUUID->"d407a503-662e-4347-96fd-afb9c340e044"],

Cell[BoxData["\<\"(^ (\[Lambda] y . (+ 3 y)) x)\"\>"], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829708992607*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"af3973f5-054d-405c-b346-d04bede21fa9"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"3", "+", "y$4558"}], ")"}], "x"]], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829709004155*^9},
 CellLabel->
  "Out[125]=",ExpressionUUID->"c04a54d1-25f2-44d1-84cd-1c305deb144b"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ (\[Lambda] y . (+ 3 y)) x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (+ 3 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\"\[LongRightArrow]\"","y$4558","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 3 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7468144833615427`*^9, 3.7468145378759947`*^9, {3.746814718580776*^9, 
   3.746814738321492*^9}, 3.74681480901016*^9, 3.746814858525419*^9, 
   3.746814893185761*^9, 3.746815132447194*^9, 3.746816803045817*^9, 
   3.746817877597849*^9, 3.746818084829569*^9, 3.7468223041709223`*^9, 
   3.74682250736773*^9, {3.746822610949604*^9, 3.7468226184846563`*^9}, 
   3.746829094826931*^9, 3.746829663995585*^9, 3.746829709015204*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"0efbc1d3-b6d3-4066-bc9c-28c47c16a705"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "1", "\[Rule]", 
        "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)) 2)\>\""}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
       "2", "\[Rule]", "\"\<(Power (\[Lambda] y . (Plus 3 y)) x)\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] y . (Plus 3 y))\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"4", "\[Rule]", "\"\<(Plus 3 y)\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"res", "=", 
     RowBox[{"eval", "[", 
      RowBox[{
       RowBox[{"Hold", "[", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", " ", "\[Lambda]", " ", 
            RowBox[{"x", " ", ".", " ", 
             RowBox[{"(", 
              RowBox[{"2", " ", "Power", " ", 
               RowBox[{"(", 
                RowBox[{"3", " ", "\[Lambda]", " ", 
                 RowBox[{"y", " ", ".", " ", 
                  RowBox[{"(", 
                   RowBox[{"4", " ", "Plus", " ", "3", " ", "y"}], ")"}]}]}], 
                ")"}], " ", "x"}], ")"}]}]}], ")"}], " ", "2"}], ")"}], "]"}],
        ",", "\"\<((\[Lambda] x . (Power (\[Lambda] y . (Plus 3 y)) x)) \
2)\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{
     RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
     RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.746731571814259*^9, 3.746731597700734*^9}, {
   3.7467318460566874`*^9, 3.7467318487445917`*^9}, {3.7467320003296623`*^9, 
   3.746732105428492*^9}, {3.746732202103722*^9, 3.74673220637633*^9}, {
   3.746732287335506*^9, 3.746732290955291*^9}, {3.74673260254207*^9, 
   3.746732610933177*^9}, {3.746732763859507*^9, 3.7467327741061068`*^9}, {
   3.74673289117756*^9, 3.746732891277141*^9}, {3.746732947911873*^9, 
   3.7467329520198812`*^9}, {3.746733123404332*^9, 3.746733137871488*^9}, {
   3.746733380415783*^9, 3.746733380671912*^9}, 3.746744597238944*^9, {
   3.746822462143929*^9, 3.7468224920963163`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"7fc307ca-8227-4e14-a6ce-57035891ea04"],

Cell[BoxData["\<\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)) 2)\"\>"], \
"Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.746829668679809*^9},
 CellLabel->"Out[90]=",ExpressionUUID->"fb00b559-0557-4590-a817-a1b0dd64e1cb"],

Cell[BoxData[
 SuperscriptBox[
  RowBox[{"(", 
   RowBox[{"3", "+", "y$3460"}], ")"}], "2"]], "Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.7468296686913223`*^9},
 CellLabel->"Out[91]=",ExpressionUUID->"8293749b-430e-40e2-b782-c492a8bb8c7b"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"((\[Lambda] x . (^ (\[Lambda] y . (+ 3 y)) x)) 2)\"", FrameStyle -> 
         None, Background -> RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"",
       "x","\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ (\[Lambda] y . (+ 3 y)) x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (+ 3 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\"\[LongRightArrow]\"","y$3460","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 3 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7467316003335123`*^9, {3.746731834757791*^9, 3.746731852076228*^9}, 
   3.7467319272643557`*^9, 3.746732105760125*^9, 3.7467322094424753`*^9, {
   3.746732291267314*^9, 3.7467323315339746`*^9}, 3.746732424093248*^9, 
   3.746732552749091*^9, 3.746732611312992*^9, 3.746732775296713*^9, 
   3.746732805695553*^9, {3.7467328794977694`*^9, 3.746732898018417*^9}, {
   3.7467329483348722`*^9, 3.74673295233976*^9}, 3.746732994370429*^9, 
   3.7467330877995853`*^9, {3.7467331250891953`*^9, 3.746733139293721*^9}, 
   3.7467332347783327`*^9, 3.7467333849838*^9, 3.746733484401978*^9, 
   3.746744484348135*^9, 3.74674465415954*^9, 3.746775811484717*^9, 
   3.746777559465919*^9, 3.7467873960272093`*^9, 3.746788049733675*^9, 
   3.746791887399637*^9, 3.746802218790958*^9, 3.7468144767060843`*^9, 
   3.7468145348747377`*^9, 3.74681476999701*^9, 3.746814822279482*^9, 
   3.746814896170084*^9, 3.746816136804614*^9, 3.746816804847376*^9, 
   3.746817895253169*^9, 3.7468180865628853`*^9, 3.746822307105055*^9, 
   3.7468224310435963`*^9, {3.746822466321643*^9, 3.746822493028882*^9}, 
   3.7468226207372417`*^9, 3.7468290998912573`*^9, 3.7468296687015953`*^9},
 CellLabel->"Out[92]=",ExpressionUUID->"930c21f3-ceac-4adf-a28d-8c6863d35107"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus 5 z)\>\""}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", " ", "\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"2", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
          ")"}], 
         RowBox[{"(", 
          RowBox[{"3", " ", "\[Lambda]", " ", 
           RowBox[{"z", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"4", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
          ")"}]}], ")"}], "]"}], ",", 
      "\"\<((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z)))\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.74674465052884*^9, 3.74674468882358*^9}, {
   3.746744744392996*^9, 3.7467448116981773`*^9}, 3.7467481432201557`*^9, 
   3.746822514989729*^9, {3.74682991465591*^9, 3.746829915025915*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"457740d9-5528-44dd-b8ff-93e2d1bc93cc"],

Cell[BoxData["\<\"((\[Lambda] y . (/ 5 y))(\[Lambda] z . (+ 5 z)))\"\>"], \
"Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.746829915373103*^9},
 CellLabel->
  "Out[173]=",ExpressionUUID->"753e88e6-9442-4647-8229-52cb173066c9"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z$4740"}]]], "Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.746829915387074*^9},
 CellLabel->
  "Out[174]=",ExpressionUUID->"dd377f43-721f-4582-b875-577ac470abb4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4740","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.746744800553533*^9, 3.746744812104883*^9}, 
   3.7467456627566*^9, 3.746747131227647*^9, 3.746748025305746*^9, 
   3.746748104913588*^9, 3.746748143724792*^9, 3.746748373679309*^9, 
   3.746775806975687*^9, 3.7467775616668787`*^9, 3.746787407334322*^9, {
   3.7467880517832737`*^9, 3.746788053767128*^9}, 3.746788773774384*^9, 
   3.7467901586548977`*^9, 3.746791965624415*^9, 3.746802226777479*^9, 
   3.746814473955263*^9, 3.746814532973776*^9, 3.746814898421377*^9, 
   3.7468151427126923`*^9, 3.746816806281396*^9, 3.7468180911971292`*^9, 
   3.746822516148527*^9, 3.746822622836556*^9, 3.746829102521126*^9, 
   3.7468296712292633`*^9, 3.7468299153976307`*^9},
 CellLabel->
  "Out[175]=",ExpressionUUID->"e0aa4854-6c30-4dfa-9949-a60d6344f418"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] y . (Sqrt y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Sqrt y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(plus 5 z)\>\""}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", "\[Lambda]", " ", 
         RowBox[{"y", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Sqrt", " ", "y"}], ")"}]}]}], ")"}], "]"}], 
      ",", "\"\<(\[Lambda] y . (Sqrt y))\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.7468158141639013`*^9, 3.746815843672864*^9}, {
   3.746816063648964*^9, 3.7468160639623833`*^9}, 3.7468161607877483`*^9, 
   3.746822521076622*^9},
 CellLabel->"In[98]:=",ExpressionUUID->"5c95b0d2-d973-4297-9066-2effa5b1510b"],

Cell[BoxData["\<\"(\[Lambda] y . (\[Sqrt] y))\"\>"], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.746829672997272*^9},
 CellLabel->
  "Out[100]=",ExpressionUUID->"53cce0a5-b856-4f75-b765-bf5735abc841"],

Cell[BoxData[
 SqrtBox["y$3490"]], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.7468296730085077`*^9},
 CellLabel->
  "Out[101]=",ExpressionUUID->"351ee21f-d386-4b4b-a65a-265575049381"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (\[Sqrt] y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\"\[LongRightArrow]\"","y$3490","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Sqrt] y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746815879511882*^9, 3.746816064983245*^9, {3.746816131357266*^9, 
   3.746816161732726*^9}, 3.74681628608528*^9, 3.746816808147272*^9, 
   3.746816909730091*^9, 3.746818093763918*^9, 3.746822521939431*^9, 
   3.746822624769683*^9, 3.746829105169218*^9, 3.7468296730179167`*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"744ffcdb-1edb-447f-a33b-be33d47e6e98"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["\[Lambda] passing", "Title"]
}], "Text",
 CellChangeTimes->{{3.746787416308563*^9, 3.746787423260519*^9}, {
  3.7468223551128693`*^9, 
  3.7468223672569838`*^9}},ExpressionUUID->"04e7e40d-fa6d-4d46-846a-\
1415ba9cc26a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"0", "->", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"1", "\[Rule]", "\"\<(Power \[Phi] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<((e) f)\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"7", "\[Rule]", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"6", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"0", " ", "\[Lambda]", " ", 
             RowBox[{"t", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"1", " ", "Power", " ", "\[Phi]", " ", "t"}], 
               ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"2", " ", "\[Lambda]", " ", 
               RowBox[{"y", " ", ".", " ", 
                RowBox[{"(", 
                 RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
              ")"}], 
             RowBox[{"(", 
              RowBox[{"4", " ", "\[Lambda]", " ", 
               RowBox[{"z", " ", ".", " ", 
                RowBox[{"(", 
                 RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
              ")"}]}], ")"}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"7", " ", "\[Lambda]", " ", 
           RowBox[{"t", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"1", "Power", " ", "\[Omega]", " ", "t"}], ")"}]}]}], 
          ")"}]}], ")"}], "]"}], ",", 
      "\"\<(((\[Lambda] t . (Power \[Phi] t)) ((\[Lambda] y . (Divide 5 y))(\
\[Lambda] z . (Plus 5 z)))) (\[Lambda] t . (Power \[Omega] t)))\>\""}], 
     "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output1\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output2\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746798666337422*^9, 3.746798669188867*^9}, 3.746802184278227*^9, {
   3.746814912957217*^9, 3.746814994806048*^9}, {3.746818103386856*^9, 
   3.746818109775998*^9}, {3.746818169323722*^9, 3.746818173374352*^9}, 
   3.746822528682509*^9, 3.746829906388666*^9},
 CellLabel->
  "In[165]:=",ExpressionUUID->"468cff77-7840-4121-b51e-38dad55c926d"],

Cell[BoxData["\<\"(((\[Lambda] t . (^ \[Phi] t)) ((\[Lambda] y . (/ 5 y))(\
\[Lambda] z . (+ 5 z)))) (\[Lambda] t . (^ \[Omega] t)))\"\>"], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071041307`*^9},
 CellLabel->
  "Out[167]=",ExpressionUUID->"f1a2709b-e56d-48b0-867e-754e9817e5e8"],

Cell[BoxData[
 SuperscriptBox["\[Phi]", 
  FractionBox["5", 
   RowBox[{"5", "+", "z$4712"}]]]], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.746829907118155*^9},
 CellLabel->
  "Out[168]=",ExpressionUUID->"6034003e-117b-41fd-8102-b1a598eaf5ff"],

Cell[BoxData[
 SuperscriptBox["\[Phi]", 
  FractionBox["5", 
   RowBox[{"5", "+", 
    SuperscriptBox["\[Omega]", "t$4713"]}]]]], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071268*^9},
 CellLabel->
  "Out[169]=",ExpressionUUID->"754b1cc0-badc-4534-9498-90014603ff39"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] t . (^ \[Phi] t))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","t",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4712","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ \[Phi] t)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] t . (^ \[Phi] t))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","t",
       "\"\[LongRightArrow]\"","t$4713","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ \[Phi] t)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7467448702589083`*^9, 3.7467452108121767`*^9, 3.746745329601129*^9, 
   3.746745613406086*^9, 3.7467456865369883`*^9, 3.746745813667428*^9, {
   3.746746183816524*^9, 3.746746196203232*^9}, {3.746746664232449*^9, 
   3.746746666382224*^9}, 3.746746755093176*^9, 3.7467476555234413`*^9, 
   3.746747998746817*^9, 3.7467481063963337`*^9, 3.746748156012457*^9, 
   3.746748245163196*^9, 3.7467484715104227`*^9, 3.746748561022274*^9, {
   3.746748665087647*^9, 3.7467486783913918`*^9}, 3.746748723621932*^9, {
   3.7467488475945787`*^9, 3.7467488543770857`*^9}, {3.746748923364621*^9, 
   3.746748928586033*^9}, 3.746749201387486*^9, 3.7467493330336227`*^9, 
   3.7467508732719517`*^9, 3.746750913145309*^9, 3.746775683054144*^9, 
   3.746775781485903*^9, 3.746776236741291*^9, 3.74677629565893*^9, 
   3.746776447674266*^9, {3.746776923638295*^9, 3.746776938285178*^9}, 
   3.746777413998748*^9, 3.746788460450719*^9, 3.746788762451482*^9, 
   3.746788935091139*^9, 3.7467890301676083`*^9, {3.746789089189003*^9, 
   3.7467891250827427`*^9}, 3.746789156409193*^9, 3.7467892153933687`*^9, 
   3.746789308874131*^9, {3.746789400149725*^9, 3.7467894100713673`*^9}, 
   3.74678946148595*^9, 3.74678955288306*^9, 3.7467895832729053`*^9, 
   3.746789625805346*^9, 3.7467901627335663`*^9, {3.7467902288435183`*^9, 
   3.7467902413956823`*^9}, 3.746793131803444*^9, 3.74679376711806*^9, 
   3.7467938445761957`*^9, 3.746798669456505*^9, 3.746802084600506*^9, 
   3.746802184646579*^9, 3.7468022293440866`*^9, 3.746802449744516*^9, 
   3.746814416753376*^9, 3.7468144568159533`*^9, {3.746814495264206*^9, 
   3.7468145294889107`*^9}, 3.746814652410736*^9, 3.746814900393922*^9, {
   3.746814975943283*^9, 3.746814996034236*^9}, {3.7468151356610327`*^9, 
   3.746815144697258*^9}, 3.746816759766612*^9, 3.746816810129682*^9, 
   3.746817815512371*^9, {3.746818095629973*^9, 3.7468181100061007`*^9}, 
   3.746818174841165*^9, 3.7468223307941093`*^9, 3.746822529507299*^9, 
   3.7468226272724257`*^9, 3.746829108019558*^9, 3.746829675079535*^9, 
   3.746829712342952*^9, 3.7468299071384783`*^9},
 CellLabel->
  "Out[170]=",ExpressionUUID->"b4b5d014-4e36-4603-8f92-51e9d301fc80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"0", "->", "\"\<(\[Lambda] t . (Power \[Phi] t))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"1", "\[Rule]", "\"\<(Power \[Phi] t)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"6", "\[Rule]", "\"\<((e) f)\>\""}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"\[Omicron]", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0", " ", "\[Lambda]", " ", 
           RowBox[{"t", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"1", "Power", " ", "\[Phi]", " ", "t"}], ")"}]}]}], 
          ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
            ")"}], 
           RowBox[{"(", 
            RowBox[{"4", " ", "\[Lambda]", " ", 
             RowBox[{"z", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
            ")"}]}], ")"}]}], ")"}], "]"}], ",", 
      "\"\<((\[Lambda] t . (Power \[Phi] t)) ((\[Lambda] y . (Divide 5 y))(\
\[Lambda] z . (Plus 5 z))))\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746793566924152*^9, 3.746793569859166*^9}, 3.746793643080846*^9, {
   3.746793706527536*^9, 3.7467937116119223`*^9}, 3.746802278577594*^9, {
   3.746815151483678*^9, 3.746815151965673*^9}, 3.7468225337223043`*^9, {
   3.746829930946204*^9, 3.7468299313388042`*^9}},
 CellLabel->
  "In[176]:=",ExpressionUUID->"72d6d3a4-724a-4e79-b3b1-cad2bab0f744"],

Cell[BoxData["Nothing"], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931710711*^9},
 CellLabel->
  "Out[177]=",ExpressionUUID->"df8dcfa3-4609-43c0-a37f-3e7e4cee0094"],

Cell[BoxData["\<\"((\[Lambda] t . (^ \[Phi] t)) ((\[Lambda] y . (/ 5 y))(\
\[Lambda] z . (+ 5 z))))\"\>"], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.7468299317246923`*^9},
 CellLabel->
  "Out[179]=",ExpressionUUID->"5317489c-1da8-463c-abdb-1b9f68faafbf"],

Cell[BoxData[
 SuperscriptBox["\[Phi]", 
  FractionBox["5", 
   RowBox[{"5", "+", "z$4755"}]]]], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931733571*^9},
 CellLabel->
  "Out[180]=",ExpressionUUID->"c08e43ba-b20a-4588-80e1-2384ac956cb2"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] t . (^ \[Phi] t))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","t",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4755","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(^ \[Phi] t)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.74679357039361*^9, 3.7467936124204893`*^9, 3.7467936440276337`*^9, {
   3.746793691242639*^9, 3.74679371561944*^9}, 3.746802134046836*^9, 
   3.746802278959588*^9, {3.746814412919422*^9, 3.746814414019822*^9}, 
   3.7468144534651613`*^9, 3.7468145167810926`*^9, {3.7468151465109158`*^9, 
   3.7468151532990217`*^9}, 3.746815311303611*^9, 3.746816755013679*^9, 
   3.746816813516438*^9, 3.7468173060028257`*^9, 3.746817811746645*^9, 
   3.746818192479517*^9, 3.74682253527538*^9, 3.746822633153345*^9, 
   3.7468292075498037`*^9, 3.74682971389287*^9, 3.746829931744422*^9},
 CellLabel->
  "Out[181]=",ExpressionUUID->"180ae1ff-1aee-4803-a010-7ae12dac2608"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "1", "\[Rule]", 
       "\"\<(((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z))) \
xxx)\>\""}], ",", "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(\[Lambda] y . (Divide 5 y))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(Divide 5 y)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(\[Lambda] z . (Plus 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"5", "\[Rule]", "\"\<(Plus 5 z)\>\""}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"2", " ", "\[Lambda]", " ", 
             RowBox[{"y", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"3", " ", "Divide", " ", "5", " ", "y"}], ")"}]}]}], 
            ")"}], 
           RowBox[{"(", 
            RowBox[{"4", " ", "\[Lambda]", " ", 
             RowBox[{"z", " ", ".", " ", 
              RowBox[{"(", 
               RowBox[{"5", " ", "Plus", " ", "5", " ", "z"}], ")"}]}]}], 
            ")"}]}], ")"}], " ", "xxx"}], ")"}], "]"}], ",", 
      "\"\<(((\[Lambda] y . (Divide 5 y))(\[Lambda] z . (Plus 5 z))) \
xxx)\>\""}], "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output1\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output2\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746744838631774*^9, 3.746744869389061*^9}, 
   3.746747449274741*^9, {3.7467489209465837`*^9, 3.746748922991848*^9}, {
   3.746775570797285*^9, 3.746775681451222*^9}, {3.7467761168104143`*^9, 
   3.746776134065675*^9}, {3.746776165638184*^9, 3.7467762355761547`*^9}, {
   3.746776286192973*^9, 3.746776294236432*^9}, {3.746776361095991*^9, 
   3.7467763715119963`*^9}, {3.746776402708933*^9, 3.7467764473157187`*^9}, 
   3.746776936160572*^9, {3.746777411650419*^9, 3.7467774248333883`*^9}, 
   3.746788934827374*^9, 3.746789028373212*^9, {3.746789085837081*^9, 
   3.746789154541396*^9}, {3.7467892114234133`*^9, 3.746789214437319*^9}, {
   3.7467893044298677`*^9, 3.746789308319902*^9}, {3.746789561225769*^9, 
   3.7467895824196033`*^9}, {3.746790235044033*^9, 3.746790240566288*^9}, {
   3.746793523048279*^9, 3.746793526534601*^9}, {3.746815157231485*^9, 
   3.746815157455863*^9}, 3.746817232937687*^9, {3.7468173277429867`*^9, 
   3.746817388077971*^9}, {3.7468174599032917`*^9, 3.746817522258999*^9}, {
   3.746817904472562*^9, 3.746817910523632*^9}, 3.746822540877493*^9},
 CellLabel->
  "In[139]:=",ExpressionUUID->"5d8209de-7dfa-4da6-823e-26e75ecf3ef5"],

Cell[BoxData["\<\"(((\[Lambda] y . (/ 5 y))(\[Lambda] z . (+ 5 z))) \
xxx)\"\>"], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716445415*^9},
 CellLabel->
  "Out[141]=",ExpressionUUID->"322ad9d8-c479-4ecc-9637-1b5d43412611"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z$4619"}]]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.7468297164565973`*^9},
 CellLabel->
  "Out[142]=",ExpressionUUID->"3e1256cd-5d14-40e7-973c-0ca15d16a82e"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "xxx"}]]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.746829716465045*^9},
 CellLabel->
  "Out[143]=",ExpressionUUID->"385263ba-f387-4656-a7cd-2a28c9fcbc90"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] y . (/ 5 y))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","y",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ 5 z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4619","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ 5 z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 y)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.746793527128604*^9, 3.746802136966255*^9, 3.746802294748539*^9, 
   3.7468143894465218`*^9, 3.746814437464736*^9, 3.746814518899963*^9, 
   3.7468151586167707`*^9, 3.746815322988247*^9, {3.746816592146541*^9, 
   3.746816597945609*^9}, 3.7468166988510017`*^9, 3.746816816753721*^9, 
   3.746816884105077*^9, 3.746817047705636*^9, 3.7468170847046213`*^9, 
   3.746817250035905*^9, 3.746817331145252*^9, {3.7468173661386843`*^9, 
   3.746817391162551*^9}, 3.746817522569776*^9, 3.746817681987265*^9, 
   3.74681779640974*^9, {3.74681790060392*^9, 3.7468179107272043`*^9}, 
   3.7468225412285213`*^9, 3.74682263750552*^9, 3.7468292127263308`*^9, 
   3.7468297164749517`*^9},
 CellLabel->
  "Out[144]=",ExpressionUUID->"21e32f53-ce90-49bf-8df4-396968d65205"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["\[Lambda] x", "Title"]
}], "Text",
 CellChangeTimes->{{3.7466099220880203`*^9, 
  3.746609930627089*^9}},ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-\
5c197a10ae7f"],

Cell["\<\

place a space between \[Lambda]  and variable name otherwise Mathematica \
interpret then as a single symbol.\
\>", "Text",
 CellChangeTimes->{{3.746609934080645*^9, 
  3.746609993188505*^9}},ExpressionUUID->"537278c6-b157-4293-8ad9-\
a7445d850ccc"],

Cell["\<\

Replace operators with math symbols, for now only arithmetic operations \
supported but we could make more..\
\>", "Text",
 CellChangeTimes->{{3.7465259788294973`*^9, 3.74652601831695*^9}, {
  3.746609410036293*^9, 
  3.746609411148735*^9}},ExpressionUUID->"3bb0307b-077c-4bff-aa91-\
bcf0be33c48f"],

Cell["\<\

\[Mho] is a custom defined operator which coverts the arithmetic operator \
names to symbols. Had to do this otherwise Mathematica evaluates / in the \
Lambda expressions which outputs nonsense:\
\>", "Text",
 CellChangeTimes->{{3.746566103652384*^9, 
  3.746566203239883*^9}},ExpressionUUID->"8d1383d3-1524-40bc-8d25-\
caa0b1904007"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", "\"\<\[Lambda] z . (Power 5 z)\>\""}]], "Input",
 CellChangeTimes->{{3.746609855149599*^9, 3.746609855610057*^9}},
 CellLabel->
  "In[306]:=",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],

Cell[BoxData["\<\"\[Lambda] z . (^ 5 z)\"\>"], "Output",
 CellChangeTimes->{3.7466098565046473`*^9, 3.7466914131906633`*^9, 
  3.7466953507486877`*^9, 3.7468153411403522`*^9},
 CellLabel->
  "Out[306]=",ExpressionUUID->"64c7ae62-0a58-498c-bef4-0ef9139d8c5c"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Evaluate", "Title"],
 "\n\n\[Omicron] is an operator that empties the  stack. Normally in the \
online interpreters this is done invisibly, but since we are using \
Mathematica\[CloseCurlyQuote]s interpreter we need to manually empty the \
stack if needed .\n\[Xi] is the stack, both are weird letters to make sure \
not used in general. \n\n",
 StyleBox["z is free z$3133  is bound.",
  FontWeight->"Bold"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.746526023489603*^9, 3.746526027845748*^9}, {
  3.746566233581366*^9, 3.746566349738411*^9}, {3.746567117801462*^9, 
  3.746567161417678*^9}, {3.746691424967721*^9, 
  3.74669143443966*^9}},ExpressionUUID->"ba63361b-1bdd-49bc-af32-\
eef69722d648"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", "\[Lambda]", " ", 
         RowBox[{"z", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], ")"}],
        "]"}], ",", "\"\<(\[Lambda] z . (Divide b z))\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.746777674299324*^9, 3.746777729331813*^9}, 
   3.746822684430538*^9},
 CellLabel->
  "In[146]:=",ExpressionUUID->"4a3c35ae-f757-486f-9014-5fbba6540527"],

Cell[BoxData["\<\"(\[Lambda] z . (/ b z))\"\>"], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.7468297275141287`*^9},
 CellLabel->
  "Out[148]=",ExpressionUUID->"05d39739-4811-4b83-aa3d-083711984a79"],

Cell[BoxData[
 FractionBox["b", "z$4635"]], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.746829727522766*^9},
 CellLabel->
  "Out[149]=",ExpressionUUID->"d98c3945-e3e2-428b-bc74-14e3986021af"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (/ b z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4635","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ b z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.746777735308552*^9, 3.746787434543055*^9, 
  3.746788063388145*^9, 3.7468153495936728`*^9, 3.746822685890512*^9, 
  3.746829245464679*^9, 3.746829727532282*^9},
 CellLabel->
  "Out[150]=",ExpressionUUID->"a2374a42-694e-4bb6-94af-0393f8c32a24"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FractionBox["b", "z$"]],
  CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
    3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
    3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
    3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
    3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
    3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
    3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
    3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
    3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
    3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
    3.746609967520733*^9, 3.7466464251767597`*^9, 3.746646970190507*^9, 
    3.746650997558325*^9, 3.7466516118415527`*^9, 3.746691415007823*^9},
  ExpressionUUID->"efc54b74-5e81-46fe-8a7e-65fb741bfab8"],
 "  is the result of the evaluation of  \[Lambda] expression and z is a bound \
variable.\n\nNotice z is treated as a placeholder it is replaced by new \
variables e.g. r and notice the bound variable stack \[Xi] is empty  "
}], "Text",
 CellChangeTimes->{
  3.746609550660516*^9, {3.7466096452109747`*^9, 3.746609707040083*^9}, 
   3.746691449229912*^9, {3.746777758933131*^9, 
   3.7467777597762957`*^9}},ExpressionUUID->"fe82ef0f-42c5-423b-a36b-\
1af62e1981e0"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z)) r\>\""}], ",",
       "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "\[Lambda]", " ", 
           RowBox[{"z", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], 
          ")"}], " ", "r"}], ")"}], "]"}], ",", 
      "\"\<(\[Lambda] z . (Divide b z) r)\>\""}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<input\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "[", "\"\<output\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7467778453992558`*^9, 3.746777847086232*^9}, {
  3.746777883572171*^9, 3.746777890624325*^9}, {3.746777951884495*^9, 
  3.746777958767597*^9}, {3.746778024503306*^9, 3.746778030869089*^9}, {
  3.746822692968585*^9, 3.746822695347866*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"58cf5de7-0e94-4b12-af12-f1d8c46e0923"],

Cell[BoxData["\<\"(\[Lambda] z . (/ b z) r)\"\>"], "Output",
 CellChangeTimes->{3.74677789337457*^9, 3.7467779612590027`*^9, 
  3.746778031298463*^9, 3.746787438323415*^9, 3.746788066806037*^9, 
  3.746815353917341*^9, 3.746822695693172*^9, 3.746829250283016*^9, 
  3.746829729815508*^9},
 CellLabel->
  "Out[153]=",ExpressionUUID->"3092d837-58fe-4f53-bac8-adadef17e8ed"],

Cell[BoxData[
 FractionBox["b", "r"]], "Output",
 CellChangeTimes->{3.74677789337457*^9, 3.7467779612590027`*^9, 
  3.746778031298463*^9, 3.746787438323415*^9, 3.746788066806037*^9, 
  3.746815353917341*^9, 3.746822695693172*^9, 3.746829250283016*^9, 
  3.746829729826655*^9},
 CellLabel->
  "Out[154]=",ExpressionUUID->"06114278-2d41-4319-a0a4-476013a54059"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (/ b z)) r\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ b z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.74677789337457*^9, 3.7467779612590027`*^9, 
  3.746778031298463*^9, 3.746787438323415*^9, 3.746788066806037*^9, 
  3.746815353917341*^9, 3.746822695693172*^9, 3.746829250283016*^9, 
  3.7468297298359337`*^9},
 CellLabel->
  "Out[155]=",ExpressionUUID->"b16137be-c516-4159-adf5-451e669d009e"]
}, Open  ]],

Cell["\<\

Notice z is NOT added to to the stack.\
\>", "Text",
 CellChangeTimes->{{3.746566375377954*^9, 3.746566391510274*^9}, {
   3.746566424643417*^9, 3.746566442647777*^9}, {3.7465664783286457`*^9, 
   3.74656649280707*^9}, 3.746609461314722*^9, {3.7466095154620447`*^9, 
   3.7466095580426197`*^9}, {3.74677808300422*^9, 
   3.746778113028812*^9}},ExpressionUUID->"ef9e9a56-5785-4d41-aa60-\
36d483d5411e"],

Cell[TextData[{
 "\n",
 StyleBox["Find  variables", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{
  3.746526035811522*^9, {3.746526075749*^9, 3.746526079191697*^9}, {
   3.7465261769910593`*^9, 3.7465261776870413`*^9}, {3.746526219370544*^9, 
   3.7465262427132483`*^9}, {3.7465263879882298`*^9, 
   3.7465263921157427`*^9}, {3.746566515037902*^9, 3.746566562843948*^9}, {
   3.7465665972538767`*^9, 3.746566599728979*^9}, 3.746609738608721*^9, {
   3.7466942534227057`*^9, 
   3.746694259778351*^9}},ExpressionUUID->"f95ff3c1-9237-464a-afd8-\
06e0eabefd8e"],

Cell["\<\



bound variables are instanced with trailing $ and unique random integer. \
\>", "Text",
 CellChangeTimes->{{3.746566672720667*^9, 3.746566702803372*^9}, {
   3.746693425724551*^9, 3.7466934308642683`*^9}, {3.74669427203047*^9, 
   3.74669433623482*^9}, 
   3.746778132920499*^9},ExpressionUUID->"88450169-06ab-4ef8-9120-\
f29966174203"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide b z))\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"2", "\[Rule]", "\"\<(Divide b z)\>\""}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{"Hold", "[", 
       RowBox[{"(", 
        RowBox[{"1", "\[Lambda]", " ", 
         RowBox[{"z", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Divide", " ", "b", " ", "z"}], ")"}]}]}], ")"}],
        "]"}], ",", "\"\<(\[Lambda] z . (Divide b z))\>\""}], "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.746521046004383*^9, 3.7465210464345016`*^9}, 
   3.746521156519286*^9, {3.746526270750854*^9, 3.746526297483017*^9}, {
   3.746526403547892*^9, 3.74652640727075*^9}, {3.746693391660252*^9, 
   3.746693407488431*^9}, {3.746701842275391*^9, 3.746701871647664*^9}, {
   3.7467781376939497`*^9, 3.746778141031637*^9}, {3.74679231925487*^9, 
   3.746792324215098*^9}, 3.746815362300208*^9, 3.746829264972105*^9},
 CellLabel->
  "In[156]:=",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", "\[Rule]", "\<\"(\[Lambda] z . (/ b z))\"\>"}], 
   ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["b", "z$4652"]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"b\"\>", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$4652\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$4652", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (/ b z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$4652","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ b z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.746521047376712*^9, {3.7465211469010067`*^9, 3.746521158454754*^9}, 
   3.746524983091058*^9, 3.746526082148794*^9, 3.7465262979497232`*^9, 
   3.746526407565949*^9, 3.746646999225676*^9, 3.746651644278997*^9, 
   3.746691487981122*^9, 3.746691855268795*^9, {3.746693399975061*^9, 
   3.746693412112399*^9}, 3.746694277395198*^9, 3.7466958591777782`*^9, 
   3.746701797999772*^9, {3.746701852149356*^9, 3.746701872017351*^9}, 
   3.746702048531907*^9, 3.746705810780843*^9, 3.746714526266816*^9, 
   3.746778141393407*^9, 3.746787444762025*^9, 3.746788069004819*^9, 
   3.746792220329565*^9, 3.746792324737323*^9, 3.746815364082244*^9, 
   3.7468227106488037`*^9, {3.746829254973358*^9, 3.7468292654705553`*^9}, 
   3.7468297323155613`*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"0771e4b8-d42b-4793-b4be-59a345fc7285"]
}, Open  ]],

Cell["\<\

No free variables\
\>", "Text",
 CellChangeTimes->{{3.746566735270732*^9, 3.746566738669067*^9}, 
   3.7466247200826893`*^9},ExpressionUUID->"9a26861f-0101-4c3c-84a6-\
7756074f32a1"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] z . (Divide 5 z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "=", 
  RowBox[{"eval", "[", 
   RowBox[{
    RowBox[{"Hold", "[", 
     RowBox[{"(", 
      RowBox[{"1", "\[Lambda]", " ", 
       RowBox[{"z", " ", ".", " ", 
        RowBox[{"(", 
         RowBox[{"2", " ", "Divide", " ", "5", " ", "z"}], ")"}]}]}], ")"}], 
     "]"}], ",", "\"\<(\[Lambda] z . (Divide 5 z))\>\""}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.74656671190559*^9, 3.746566713862462*^9}, {
  3.7466934402838182`*^9, 3.746693450394846*^9}, {3.746701966195958*^9, 
  3.746701981561635*^9}, {3.7467781882317133`*^9, 3.746778200814443*^9}},
 CellLabel->
  "In[158]:=",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", "\[Rule]", "\<\"(\[Lambda] z . (/ 5 z))\"\>"}], 
   ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", "z$4661"]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$4661\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$4661", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (/ 5 z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$4661","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.7465667153816566`*^9, 3.74664700054091*^9, 3.746651645222691*^9, 
   3.746691489431587*^9, {3.746693447339995*^9, 3.7466934509409513`*^9}, 
   3.746694284097788*^9, 3.746694858744688*^9, 3.746695860178841*^9, 
   3.746701788062584*^9, 3.746701981905672*^9, 3.7467020503119917`*^9, 
   3.7467058322834797`*^9, 3.7467782029856243`*^9, 3.746787449930174*^9, 
   3.746788070856764*^9, 3.746822721001281*^9, 3.746829284910284*^9, 
   3.746829733466333*^9},
 CellLabel->
  "Out[159]=",ExpressionUUID->"a4fc6710-0878-4943-99f3-2f309eacc2a5"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Passing \[Lambda]", "Title"]
}], "Text",
 CellChangeTimes->{{3.7465261213917913`*^9, 3.746526125192377*^9}, {
  3.7465405602732353`*^9, 3.746540561823556*^9}, {3.7466934914018507`*^9, 
  3.746693500076517*^9}},ExpressionUUID->"15ef489a-5536-452d-ae09-\
86b73d643a13"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] x . (Divide 5 x)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 x)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus (-3) z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus (-3) z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"eval", "[", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", " ", "\[Lambda]", " ", 
          RowBox[{"x", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"2", " ", "Divide", " ", "5", " ", "x"}], ")"}]}]}], 
         ")"}], 
        RowBox[{"(", 
         RowBox[{"3", " ", "\[Lambda]", " ", 
          RowBox[{"z", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"4", " ", "Plus", " ", 
             RowBox[{"(", 
              RowBox[{"-", "3"}], ")"}], " ", "z"}], ")"}]}]}], ")"}]}], 
       ")"}], "]"}], ",", 
     "\"\<((\[Lambda] x . (Divide 5 x))(\[Lambda] z . (Plus (-3) z)))\>\""}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "[", 
  RowBox[{
   RowBox[{"res", "[", "\"\<trace\>\"", "]"}], ",", 
   RowBox[{"Dividers", "\[Rule]", "All"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.746778248801133*^9, 3.746778343748313*^9}, {
   3.746792545496859*^9, 3.746792557904111*^9}, 3.7468227288022547`*^9},
 CellLabel->
  "In[160]:=",ExpressionUUID->"51e0e516-fe34-43b8-b996-29821fa65eee"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", 
    "\[Rule]", "\<\"((\[Lambda] x . (/ 5 x))(\[Lambda] z . (+ (-3) \
z)))\"\>"}], ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", 
     RowBox[{
      RowBox[{"-", "3"}], "+", "z$4670"}]]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$4670\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$4670", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] x . (/ 5 x)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","x",
        "\" , Redex: \[Beta] conversion\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$4670","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 x)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.7467783441130457`*^9, 3.746787455515502*^9, 3.746788072757584*^9, 
   3.746788836342998*^9, {3.746792553109366*^9, 3.746792558359297*^9}, 
   3.746802303256876*^9, 3.746815388711474*^9, 3.746822730369752*^9, 
   3.746829330123887*^9, 3.7468297350512*^9},
 CellLabel->
  "Out[161]=",ExpressionUUID->"aef2c56d-3227-4b3a-a9ec-2d993a115e04"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] x . (/ 5 x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","x",
       "\" , Redex: \[Beta] conversion\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
       "\"\[LongRightArrow]\"","z$4670","\" a new copy\""},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      TemplateBox[{
        "\"(/ 5 x)\"", FrameStyle -> None, Background -> 
         RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7467783441130457`*^9, 3.746787455515502*^9, 3.746788072757584*^9, 
   3.746788836342998*^9, {3.746792553109366*^9, 3.746792558359297*^9}, 
   3.746802303256876*^9, 3.746815388711474*^9, 3.746822730369752*^9, 
   3.746829330123887*^9, 3.7468297350654907`*^9},
 CellLabel->
  "Out[162]=",ExpressionUUID->"adc13744-c752-4020-9aa2-6203427e8e7f"]
}, Open  ]],

Cell["\<\
Notice the left most \[Lambda] expressions variable name does not matter:\
\>", "Text",
 CellChangeTimes->{{3.746566772814043*^9, 
  3.746566795268664*^9}},ExpressionUUID->"aa52d49c-00db-4d8a-9969-\
669c9e099932"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"1", "\[Rule]", "\"\<(\[Lambda] W . (Divide 5 W)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"2", "\[Rule]", "\"\<(Divide 5 W)\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"3", "\[Rule]", "\"\<(\[Lambda] z . (Plus (-3) z))\>\""}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"4", "\[Rule]", "\"\<(Plus (-3) z)\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"res", "=", 
  RowBox[{"eval", "[", 
   RowBox[{
    RowBox[{"Hold", "[", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", " ", "\[Lambda]", " ", 
         RowBox[{"W", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"2", " ", "Divide", " ", "5", " ", "W"}], ")"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{"3", " ", "\[Lambda]", " ", 
         RowBox[{"z", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"4", " ", "Plus", " ", 
            RowBox[{"(", 
             RowBox[{"-", "3"}], ")"}], " ", "z"}], ")"}]}]}], ")"}]}], ")"}],
      "]"}], ",", 
    "\"\<((\[Lambda] W . (Divide 5 W))(\[Lambda] z . (Plus (-3) z)))\>\""}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.746566762520001*^9, 3.746566764420611*^9}, {
   3.7466103612397213`*^9, 3.7466103664363537`*^9}, 3.746693469183671*^9, 
   3.746694424273799*^9, {3.746705955641931*^9, 3.746705964718507*^9}, {
   3.746706599621007*^9, 3.746706630775771*^9}, {3.746778437435186*^9, 
   3.746778458106208*^9}},
 CellLabel->
  "In[163]:=",ExpressionUUID->"3946cdac-dd28-4f38-9c0a-6af80bd44d41"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", 
    "\[Rule]", "\<\"((\[Lambda] W . (/ 5 W))(\[Lambda] z . (+ (-3) \
z)))\"\>"}], ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    FractionBox["5", 
     RowBox[{
      RowBox[{"-", "3"}], "+", "z$4697"}]]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"z$4697\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "z$4697", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] W . (/ 5 W)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","W",
        "\" , Redex: \[Beta] conversion\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(\[Lambda] z . (+ (-3) z))\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"],"\" \"","z",
        "\"\[LongRightArrow]\"","z$4697","\" a new copy\""},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(+ (-3) z)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"], ",", 
      TemplateBox[{
       TemplateBox[{
         "\"(/ 5 W)\"", FrameStyle -> None, Background -> 
          RGBColor[0.87, 0.94, 1]}, "Highlighted"]},
       "RowDefault"]}], "}"}]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.746566765695786*^9, 3.7465686952108593`*^9, 3.7466103667775707`*^9, 
   3.7466464547338142`*^9, 3.746647007326498*^9, 3.746651044086858*^9, 
   3.7466516732335367`*^9, 3.746691498181324*^9, 3.746693469546282*^9, 
   3.746694425060371*^9, 3.7466958637232943`*^9, 3.746705966308043*^9, {
   3.746706602306652*^9, 3.746706631681217*^9}, 3.7467079130849037`*^9, 
   3.746778459331584*^9, 3.746787461984809*^9, 3.746788075306526*^9, 
   3.746788839094862*^9, 3.746802306224625*^9, 3.746815396313405*^9, 
   3.746822736423072*^9, 3.746829333674715*^9, 3.7468297364817657`*^9},
 CellLabel->
  "Out[164]=",ExpressionUUID->"d5688c74-a9f4-48e6-a2b2-baf8e569397a"]
}, Open  ]]
},
WindowSize->{1394, 1136},
WindowMargins->{{Automatic, 491}, {Automatic, 4}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1439, 34, 94, "Input",ExpressionUUID->"675323c7-0aa0-4d16-84e5-172b6aed42a7"],
Cell[2000, 56, 27510, 504, 1546, "Input",ExpressionUUID->"3551e59d-8c7b-4643-8fe4-a48c58dd4d4d"],
Cell[CellGroupData[{
Cell[29535, 564, 1681, 38, 262, "Input",ExpressionUUID->"d407a503-662e-4347-96fd-afb9c340e044"],
Cell[31219, 604, 596, 9, 34, "Output",ExpressionUUID->"af3973f5-054d-405c-b346-d04bede21fa9"],
Cell[31818, 615, 635, 12, 34, "Output",ExpressionUUID->"c04a54d1-25f2-44d1-84cd-1c305deb144b"],
Cell[32456, 629, 1450, 35, 121, "Output",ExpressionUUID->"0efbc1d3-b6d3-4066-bc9c-28c47c16a705"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33943, 669, 2566, 54, 325, "Input",ExpressionUUID->"7fc307ca-8227-4e14-a6ce-57035891ea04"],
Cell[36512, 725, 1343, 19, 34, "Output",ExpressionUUID->"fb00b559-0557-4590-a817-a1b0dd64e1cb"],
Cell[37858, 746, 1362, 21, 34, "Output",ExpressionUUID->"8293749b-430e-40e2-b782-c492a8bb8c7b"],
Cell[39223, 769, 2451, 51, 155, "Output",ExpressionUUID->"930c21f3-ceac-4adf-a28d-8c6863d35107"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41711, 825, 2007, 47, 325, "Input",ExpressionUUID->"457740d9-5528-44dd-b8ff-93e2d1bc93cc"],
Cell[43721, 874, 854, 13, 34, "Output",ExpressionUUID->"753e88e6-9442-4647-8229-52cb173066c9"],
Cell[44578, 889, 845, 14, 52, "Output",ExpressionUUID->"dd377f43-721f-4582-b875-577ac470abb4"],
Cell[45426, 905, 1915, 45, 155, "Output",ExpressionUUID->"e0aa4854-6c30-4dfa-9949-a60d6344f418"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47378, 955, 1612, 37, 325, "Input",ExpressionUUID->"5c95b0d2-d973-4297-9066-2effa5b1510b"],
Cell[48993, 994, 445, 7, 40, "Output",ExpressionUUID->"53cce0a5-b856-4f75-b765-bf5735abc841"],
Cell[49441, 1003, 429, 8, 41, "Output",ExpressionUUID->"351ee21f-d386-4b4b-a65a-265575049381"],
Cell[49873, 1013, 1112, 27, 101, "Output",ExpressionUUID->"744ffcdb-1edb-447f-a33b-be33d47e6e98"]
}, Open  ]],
Cell[51000, 1043, 253, 7, 97, "Text",ExpressionUUID->"04e7e40d-fa6d-4d46-846a-1415ba9cc26a"],
Cell[CellGroupData[{
Cell[51278, 1054, 4091, 85, 472, "Input",ExpressionUUID->"468cff77-7840-4121-b51e-38dad55c926d"],
Cell[55372, 1141, 2337, 33, 34, "Output",ExpressionUUID->"f1a2709b-e56d-48b0-867e-754e9817e5e8"],
Cell[57712, 1176, 2292, 35, 43, "Output",ExpressionUUID->"6034003e-117b-41fd-8102-b1a598eaf5ff"],
Cell[60007, 1213, 2323, 36, 46, "Output",ExpressionUUID->"754b1cc0-badc-4534-9498-90014603ff39"],
Cell[62333, 1251, 4218, 91, 287, "Output",ExpressionUUID->"b4b5d014-4e36-4603-8f92-51e9d301fc80"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66588, 1347, 3564, 75, 409, "Input",ExpressionUUID->"72d6d3a4-724a-4e79-b3b1-cad2bab0f744"],
Cell[70155, 1424, 714, 11, 34, "Output",ExpressionUUID->"df8dcfa3-4609-43c0-a37f-3e7e4cee0094"],
Cell[70872, 1437, 798, 12, 34, "Output",ExpressionUUID->"5317489c-1da8-463c-abdb-1b9f68faafbf"],
Cell[71673, 1451, 786, 14, 43, "Output",ExpressionUUID->"c08e43ba-b20a-4588-80e1-2384ac956cb2"],
Cell[72462, 1467, 2259, 57, 221, "Output",ExpressionUUID->"180ae1ff-1aee-4803-a010-7ae12dac2608"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74758, 1529, 3223, 66, 367, "Input",ExpressionUUID->"5d8209de-7dfa-4da6-823e-26e75ecf3ef5"],
Cell[77984, 1597, 868, 14, 34, "Output",ExpressionUUID->"322ad9d8-c479-4ecc-9637-1b5d43412611"],
Cell[78855, 1613, 855, 15, 52, "Output",ExpressionUUID->"3e1256cd-5d14-40e7-973c-0ca15d16a82e"],
Cell[79713, 1630, 850, 15, 51, "Output",ExpressionUUID->"385263ba-f387-4656-a7cd-2a28c9fcbc90"],
Cell[80566, 1647, 1923, 46, 155, "Output",ExpressionUUID->"21e32f53-ce90-49bf-8df4-396968d65205"]
}, Open  ]],
Cell[82504, 1696, 196, 6, 97, "Text",ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-5c197a10ae7f"],
Cell[82703, 1704, 260, 7, 58, "Text",ExpressionUUID->"537278c6-b157-4293-8ad9-a7445d850ccc"],
Cell[82966, 1713, 309, 8, 58, "Text",ExpressionUUID->"3bb0307b-077c-4bff-aa91-bcf0be33c48f"],
Cell[83278, 1723, 345, 8, 58, "Text",ExpressionUUID->"8d1383d3-1524-40bc-8d25-caa0b1904007"],
Cell[CellGroupData[{
Cell[83648, 1735, 230, 4, 30, "Input",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],
Cell[83881, 1741, 258, 4, 34, "Output",ExpressionUUID->"64c7ae62-0a58-498c-bef4-0ef9139d8c5c"]
}, Open  ]],
Cell[84154, 1748, 729, 16, 235, "Text",ExpressionUUID->"ba63361b-1bdd-49bc-af32-eef69722d648"],
Cell[CellGroupData[{
Cell[84908, 1768, 1362, 33, 283, "Input",ExpressionUUID->"4a3c35ae-f757-486f-9014-5fbba6540527"],
Cell[86273, 1803, 325, 5, 34, "Output",ExpressionUUID->"05d39739-4811-4b83-aa3d-083711984a79"],
Cell[86601, 1810, 318, 6, 53, "Output",ExpressionUUID->"d98c3945-e3e2-428b-bc74-14e3986021af"],
Cell[86922, 1818, 984, 25, 89, "Output",ExpressionUUID->"a2374a42-694e-4bb6-94af-0393f8c32a24"]
}, Open  ]],
Cell[87921, 1846, 1450, 24, 87, "Text",ExpressionUUID->"fe82ef0f-42c5-423b-a36b-1af62e1981e0"],
Cell[CellGroupData[{
Cell[89396, 1874, 1638, 39, 304, "Input",ExpressionUUID->"58cf5de7-0e94-4b12-af12-f1d8c46e0923"],
Cell[91037, 1915, 371, 6, 34, "Output",ExpressionUUID->"3092d837-58fe-4f53-bac8-adadef17e8ed"],
Cell[91411, 1923, 359, 7, 51, "Output",ExpressionUUID->"06114278-2d41-4319-a0a4-476013a54059"],
Cell[91773, 1932, 1018, 26, 89, "Output",ExpressionUUID->"b16137be-c516-4159-adf5-451e669d009e"]
}, Open  ]],
Cell[92806, 1961, 412, 9, 58, "Text",ExpressionUUID->"ef9e9a56-5785-4d41-aa60-36d483d5411e"],
Cell[93221, 1972, 560, 13, 120, "Text",ExpressionUUID->"f95ff3c1-9237-464a-afd8-06e0eabefd8e"],
Cell[93784, 1987, 349, 10, 104, "Text",ExpressionUUID->"88450169-06ab-4ef8-9120-f29966174203"],
Cell[CellGroupData[{
Cell[94158, 2001, 1460, 31, 283, "Input",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],
Cell[95621, 2034, 1892, 40, 53, "Output",ExpressionUUID->"0771e4b8-d42b-4793-b4be-59a345fc7285"]
}, Open  ]],
Cell[97528, 2077, 193, 6, 58, "Text",ExpressionUUID->"9a26861f-0101-4c3c-84a6-7756074f32a1"],
Cell[CellGroupData[{
Cell[97746, 2087, 1130, 26, 220, "Input",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],
Cell[98879, 2115, 1590, 36, 52, "Output",ExpressionUUID->"a4fc6710-0878-4943-99f3-2f309eacc2a5"]
}, Open  ]],
Cell[100484, 2154, 301, 7, 97, "Text",ExpressionUUID->"15ef489a-5536-452d-ae09-86b73d643a13"],
Cell[CellGroupData[{
Cell[100810, 2165, 1855, 46, 304, "Input",ExpressionUUID->"51e0e516-fe34-43b8-b996-29821fa65eee"],
Cell[102668, 2213, 1911, 47, 87, "Output",ExpressionUUID->"aef2c56d-3227-4b3a-a9ec-2d993a115e04"],
Cell[104582, 2262, 1515, 40, 155, "Output",ExpressionUUID->"adc13744-c752-4020-9aa2-6203427e8e7f"]
}, Open  ]],
Cell[106112, 2305, 223, 5, 35, "Text",ExpressionUUID->"aa52d49c-00db-4d8a-9969-669c9e099932"],
Cell[CellGroupData[{
Cell[106360, 2314, 1794, 42, 262, "Input",ExpressionUUID->"3946cdac-dd28-4f38-9c0a-6af80bd44d41"],
Cell[108157, 2358, 2227, 51, 87, "Output",ExpressionUUID->"d5688c74-a9f4-48e6-a2b2-baf8e569397a"]
}, Open  ]]
}
]
*)

