(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     71269,       1658]
NotebookOptionsPosition[     60166,       1481]
NotebookOutlinePosition[     60522,       1497]
CellTagsIndexPosition[     60479,       1494]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{"<<", "Notation`"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"(", 
         RowBox[{"op_", " ", "x_", " ", "y_"}], ")"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Construct", "[", 
         RowBox[{"op_", ",", " ", "x_", " ", ",", "y_"}], " ", "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[Lambda]x", "  ", "push", " ", "x", " ", "into", " ", "stack", " ", 
     "\[Xi]"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Lambda]", " ", 
         RowBox[{"x_", " ", ".", " ", "expr_"}]}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"AppendTo", "[", 
           RowBox[{"\[Xi]", ",", "x_"}], "]"}], ";", 
         RowBox[{
           RowBox[{"Function", "[", 
             RowBox[{"x_", ",", "expr_"}], "]"}], "[", "x_", "]"}]}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{
         RowBox[{"(", 
           RowBox[{"\[Lambda]", " ", 
             RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], "e2_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"Function", "[", 
           RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{
         RowBox[{"(", 
           RowBox[{"\[Lambda]", " ", 
             RowBox[{"x_", " ", ".", " ", "expr_"}]}], ")"}], 
         RowBox[{"(", "e2_", ")"}]}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"Function", "[", 
           RowBox[{"x_", ",", "expr_"}], "]"}], "[", "e2_", "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"FIXME", ":", " ", 
      RowBox[{"this", " ", "did", " ", "not", " ", "work"}]}], ",", " ", 
     RowBox[{
      RowBox[{
      "order", " ", "of", " ", "evaluation", " ", "casuse", " ", "\[Xi]"}], 
      "=", 
      RowBox[{
       RowBox[{"{", "}"}], " ", "righte", " ", "away"}]}]}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{
          RowBox[{"(", " ", "expr_", ")"}], "e2_"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"If", "[", 
          RowBox[{
            RowBox[{"\[Xi]", " ", "===", 
              RowBox[{"{", "}"}]}], ",", "expr_", " ", ",", 
            RowBox[{"expr_", "/.", 
              RowBox[{"{", 
                RowBox[{
                  RowBox[{"\[Xi]", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", "e2_"}], 
                "}"}]}]}], "]"}]},
       "NotationTemplateTag"]}], "]"}], "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"FIXME", ":", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"Quiet", " ", "[", " ", "]"}], " ", "added", " ", "for", " ", 
       "when", " ", "\[Xi]"}], "==", 
      RowBox[{
       RowBox[{"{", "}"}], " ", "no", " ", "error", " ", "warnings"}]}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"TODO", ":", " ", 
     RowBox[{
      RowBox[{"(", "e1", ")"}], "e2", " ", "grab", " ", "the", " ", "oldest", 
      " ", "symbol", " ", "on", " ", "the", " ", "stack"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{
         RowBox[{"(", " ", "expr_", ")"}], "e2_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Quiet", "[", 
         RowBox[{"expr_", "/.", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"\[Xi]", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "\[Rule]", "e2_"}], "}"}]}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Mho]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"StringReplace", "[", 
         RowBox[{"x_", ",", 
           RowBox[{"{", 
             RowBox[{
               RowBox[{"\"Add\"", "\[Rule]", "\"+\""}], ",", 
               RowBox[{"\"Subtract\"", "\[Rule]", "\"-\""}], ",", 
               RowBox[{"\"Divide\"", "\[Rule]", "\"/\""}], ",", 
               RowBox[{"\"Times\"", "\[Rule]", "\"*\""}], ",", 
               RowBox[{"\"Power\"", "\[Rule]", "\"^\""}]}], "}"}]}], "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Nu]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"ToString", "/@", 
             RowBox[{"Level", "[", 
               RowBox[{"x_", ",", 
                 RowBox[{"{", 
                   RowBox[{"-", "1"}], "}"}]}], "]"}]}], ",", "NameQ"}], 
         "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{RowBox[{"\[Upsilon]", " ", "x_"}]},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{"Select", "[", 
         RowBox[{
           RowBox[{"Table", "[", 
             RowBox[{
               RowBox[{"StringTake", "[", 
                 RowBox[{"i", ",", "1"}], "]"}], ",", 
               RowBox[{"{", 
                 RowBox[{"i", ",", 
                   RowBox[{"StringTrim", "/@", 
                    RowBox[{"StringSplit", "[", 
                    RowBox[{"x_", ",", "\"\[Lambda]\""}], "]"}]}]}], "}"}]}], 
             "]"}], ",", "NameQ"}], "]"}]},
      "NotationTemplateTag"]}], "]"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Notation", "[", 
    RowBox[{
     TemplateBox[{"\[Omicron]"},
      "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
     TemplateBox[{RowBox[{
         RowBox[{"\[Xi]", "=", 
           RowBox[{"{", "}"}]}], ";"}]},
      "NotationTemplateTag"]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.741884966938229*^9, 3.741884968652132*^9}, {
   3.7418850028831463`*^9, 3.741885004201413*^9}, {3.741885204804133*^9, 
   3.741885207231092*^9}, 3.741885574830003*^9, 3.7418867444594927`*^9, {
   3.741943718173574*^9, 3.741943718669817*^9}, 3.741944445968795*^9, {
   3.746438295807288*^9, 3.7464384109459963`*^9}, {3.746438543247486*^9, 
   3.746438572103177*^9}, {3.7464387178455877`*^9, 3.746438805521862*^9}, 
   3.746438837698395*^9, {3.7464391383051157`*^9, 3.746439138572727*^9}, {
   3.7464398685092154`*^9, 3.746439965135532*^9}, {3.746440020803397*^9, 
   3.7464400621016293`*^9}, 3.746440126287815*^9, {3.746440213170883*^9, 
   3.746440219491139*^9}, {3.746442292002969*^9, 3.7464422936100473`*^9}, {
   3.746443068580141*^9, 3.746443082192377*^9}, {3.7464435484242268`*^9, 
   3.746443556197298*^9}, {3.7464437159059563`*^9, 3.7464437183456173`*^9}, {
   3.746443755337791*^9, 3.746443765326571*^9}, {3.746449122713505*^9, 
   3.746449123217516*^9}, {3.746517908497835*^9, 3.7465179149530888`*^9}, {
   3.7465180208638983`*^9, 3.7465180379964533`*^9}, {3.746518226020875*^9, 
   3.7465182347058983`*^9}, {3.746518302522826*^9, 3.746518308653159*^9}, 
   3.746518353761698*^9, {3.7465184015283318`*^9, 3.746518408420697*^9}, {
   3.7465184413296547`*^9, 3.746518464559195*^9}, {3.746518691121707*^9, 
   3.746518749998335*^9}, {3.7465187808473377`*^9, 3.746518782343112*^9}, 
   3.746518850486842*^9, {3.746518918628833*^9, 3.7465189258386183`*^9}, {
   3.7465189933302937`*^9, 3.7465190469583883`*^9}, {3.746519095925078*^9, 
   3.7465191065956373`*^9}, {3.746519215375276*^9, 3.746519218208782*^9}, {
   3.746519271537499*^9, 3.746519301100882*^9}, {3.7465193888640833`*^9, 
   3.746519406212596*^9}, {3.746519548302512*^9, 3.7465195558081427`*^9}, {
   3.746519644243801*^9, 3.746519692427041*^9}, {3.746519962207954*^9, 
   3.746520090076126*^9}, {3.746520175163761*^9, 3.746520268042531*^9}, {
   3.746520582857682*^9, 3.7465205869513617`*^9}, {3.7465207665975237`*^9, 
   3.746520771060738*^9}, {3.746520813183613*^9, 3.7465208137325487`*^9}, {
   3.7465210029286737`*^9, 3.7465210321552677`*^9}, 3.746522404275511*^9, {
   3.746525380985317*^9, 3.746525469276286*^9}, {3.74652552631448*^9, 
   3.746525551536097*^9}, {3.746525628975909*^9, 3.746525658176279*^9}, {
   3.746525712032557*^9, 3.746525718320133*^9}, {3.74652590192612*^9, 
   3.746525923781946*^9}, {3.7465284605108356`*^9, 3.746528467348728*^9}, {
   3.7465289060854197`*^9, 3.746528914364828*^9}, {3.746529060110991*^9, 
   3.746529078662787*^9}, {3.746529162804944*^9, 3.746529163185218*^9}, 
   3.746529342914136*^9, {3.746529383183393*^9, 3.7465294069204473`*^9}, {
   3.746529480373765*^9, 3.746529481688757*^9}, 3.746529544882347*^9, {
   3.746533258425908*^9, 3.7465332610672703`*^9}, 3.746533832585009*^9, {
   3.746533885859384*^9, 3.746533925447526*^9}, {3.746534029073909*^9, 
   3.7465340690105553`*^9}, {3.746534183256856*^9, 3.7465342187506447`*^9}, {
   3.746534248789212*^9, 3.746534301838954*^9}, {3.746534612442665*^9, 
   3.746534631119721*^9}, {3.7465346791099586`*^9, 3.7465347578209352`*^9}, {
   3.7465348034358463`*^9, 3.746534810478689*^9}, {3.746534897547264*^9, 
   3.746534906385626*^9}, 3.74653506167351*^9, {3.7465351319194117`*^9, 
   3.746535159417595*^9}, {3.746535218680316*^9, 3.746535223010232*^9}, {
   3.746535260047853*^9, 3.7465352962828836`*^9}, {3.746535447824605*^9, 
   3.746535449825451*^9}, {3.7465358898667707`*^9, 3.746535893679187*^9}, {
   3.746541310956003*^9, 3.746541389188208*^9}, {3.746566992800914*^9, 
   3.746567009371809*^9}, {3.746567052565855*^9, 3.746567092735874*^9}, {
   3.7465677855818157`*^9, 3.746567794298473*^9}, {3.746568146982937*^9, 
   3.7465682021898947`*^9}, {3.7465686160261497`*^9, 3.746568660170498*^9}, {
   3.7465687322300987`*^9, 3.746568843785166*^9}, {3.7465691686029177`*^9, 
   3.7465691729101*^9}, {3.746609822672832*^9, 3.7466098306691637`*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"1132464f-13f9-4aeb-a273-bd82662c329f"],

Cell[TextData[{
 "\n",
 StyleBox["\[Lambda] x", "Title"]
}], "Text",
 CellChangeTimes->{{3.7466099220880203`*^9, 
  3.746609930627089*^9}},ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-\
5c197a10ae7f"],

Cell["\<\

place a space between \[Lambda]  and variable name otherwise Mathematica \
interpret then as a single symbol.\
\>", "Text",
 CellChangeTimes->{{3.746609934080645*^9, 
  3.746609993188505*^9}},ExpressionUUID->"537278c6-b157-4293-8ad9-\
a7445d850ccc"],

Cell["\<\

Replace operators with math symbols, for now only arithmetic operations \
supported but we could make more..\
\>", "Text",
 CellChangeTimes->{{3.7465259788294973`*^9, 3.74652601831695*^9}, {
  3.746609410036293*^9, 
  3.746609411148735*^9}},ExpressionUUID->"3bb0307b-077c-4bff-aa91-\
bcf0be33c48f"],

Cell["\<\

\[Mho] is a custom defined operator which coverts the arithmetic operator \
names to symbols. Had to do this otherwise Mathematica evaluates / in the \
Lambda expressions which outputs nonsense:\
\>", "Text",
 CellChangeTimes->{{3.746566103652384*^9, 
  3.746566203239883*^9}},ExpressionUUID->"8d1383d3-1524-40bc-8d25-\
caa0b1904007"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", "\"\<\[Lambda] z . (Divide 5 z)\>\""}]], "Input",
 CellChangeTimes->{{3.7465185637237453`*^9, 3.7465185731836433`*^9}, 
   3.746518646271891*^9, {3.746518760060885*^9, 3.746518773173272*^9}, {
   3.746519054159803*^9, 3.746519060829493*^9}, {3.7465200193401413`*^9, 
   3.7465200204035683`*^9}, {3.746520182519658*^9, 3.746520189898169*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"d0ab6a7f-3b9b-496c-a8a5-c24f3f42e46d"],

Cell[BoxData["\<\"\[Lambda] z . (/ 5 z)\"\>"], "Output",
 CellChangeTimes->{{3.746518774584053*^9, 3.746518785651566*^9}, 
   3.746518853788385*^9, 3.74651892999861*^9, {3.746519056434767*^9, 
   3.746519061306733*^9}, 3.7465190990675297`*^9, 3.746519221919545*^9, {
   3.746519281605158*^9, 3.746519304782654*^9}, {3.7465193954097567`*^9, 
   3.746519409176744*^9}, 3.746519560207717*^9, 3.74651969650455*^9, {
   3.746520022200635*^9, 3.746520055044441*^9}, 3.74652009327288*^9, {
   3.746520185567648*^9, 3.7465201903364162`*^9}, {3.746520251838245*^9, 
   3.746520277098237*^9}, 3.746525973833799*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"2ed71b70-c300-495a-b497-4a56679626a8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", "\"\<\[Lambda] z . (Power 5 z)\>\""}]], "Input",
 CellChangeTimes->{{3.746609855149599*^9, 3.746609855610057*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],

Cell[BoxData["\<\"\[Lambda] z . (^ 5 z)\"\>"], "Output",
 CellChangeTimes->{3.7466098565046473`*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"aa21bfee-8839-4c64-91e5-6837696df5f4"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Evaluate", "Title"],
 "\n\n\[Omicron] is an operator that empties the  stack. Normally in the \
online interpreters this is done invisibly, but since we are using \
Mathematica\[CloseCurlyQuote]s interpreter we need to manually empty the \
stack if needed .\n\[Xi] is the stack, both are weird letters to make sure \
not used in general. \n"
}], "Text",
 CellChangeTimes->{{3.746526023489603*^9, 3.746526027845748*^9}, {
  3.746566233581366*^9, 3.746566349738411*^9}, {3.746567117801462*^9, 
  3.746567161417678*^9}},ExpressionUUID->"ba63361b-1bdd-49bc-af32-\
eef69722d648"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", " ", 
  RowBox[{"(*", 
   RowBox[{"empty", " ", "or", " ", 
    RowBox[{"{", "}"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Mho]", 
  "\"\<\[Lambda] z . (Divide b z)\>\""}], "\[IndentingNewLine]", 
 RowBox[{"\[Lambda]", " ", 
  RowBox[{"z", " ", ".", " ", 
   RowBox[{"(", 
    RowBox[{"Divide", " ", "b", " ", "z"}], ")"}]}]}], "\[IndentingNewLine]", 

 RowBox[{"\[Xi]", "  ", 
  RowBox[{"(*", 
   RowBox[{"var", " ", "z", " ", "added"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.7464385858341227`*^9, 3.74643863535165*^9}, {
   3.746438810810639*^9, 3.746438815320754*^9}, {3.746438937612007*^9, 
   3.74643893867907*^9}, {3.746439037537033*^9, 3.746439039174515*^9}, {
   3.746439972078212*^9, 3.74643997298814*^9}, 3.746521184461454*^9, {
   3.746566221386742*^9, 3.746566222018199*^9}, {3.746566369608197*^9, 
   3.74656642072717*^9}, {3.7466094359344807`*^9, 3.746609450245675*^9}, {
   3.746609967043853*^9, 
   3.7466099708239393`*^9}},ExpressionUUID->"edffe629-cea6-481d-8fb2-\
46834373f0a2"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
   3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
   3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
   3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
   3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
   3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
   3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
   3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
   3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
   3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
   3.746609967520733*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"348eb714-06fd-4327-ade7-0d5dfd349e1d"],

Cell[BoxData["\<\"\[Lambda] z . (/ b z)\"\>"], "Output",
 CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
   3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
   3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
   3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
   3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
   3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
   3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
   3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
   3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
   3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
   3.746609967531262*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"77a44d18-fbfd-408e-955b-c2510269b86a"],

Cell[BoxData[
 FractionBox["b", "z"]], "Output",
 CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
   3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
   3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
   3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
   3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
   3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
   3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
   3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
   3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
   3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
   3.746609967539844*^9},
 CellLabel->"Out[60]=",ExpressionUUID->"96cb65fb-a8ae-46cd-a444-07473cb04bf6"],

Cell[BoxData[
 RowBox[{"{", "z", "}"}]], "Output",
 CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
   3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
   3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
   3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
   3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
   3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
   3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
   3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
   3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
   3.746568860963537*^9, {3.746609436959559*^9, 3.7466094504950438`*^9}, 
   3.746609967548204*^9},
 CellLabel->"Out[61]=",ExpressionUUID->"64a12d1d-14fe-4969-b171-f85f637dc2df"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FractionBox["b", "z"]],
  CellChangeTimes->{{3.7464386123674307`*^9, 3.7464386357532387`*^9}, {
    3.746438817311989*^9, 3.7464388404810123`*^9}, 3.746438939364357*^9, 
    3.746439039779114*^9, 3.74643914134385*^9, 3.746439973486784*^9, 
    3.746440027273931*^9, 3.746440129555759*^9, 3.746440221518366*^9, 
    3.746442432585248*^9, 3.746442792551305*^9, 3.746443086054763*^9, 
    3.746443737227227*^9, 3.7465183120238237`*^9, 3.746518469001689*^9, 
    3.746520278751359*^9, 3.746521145233376*^9, 3.746521186528223*^9, 
    3.746566230846435*^9, {3.746566370539898*^9, 3.746566397296259*^9}, 
    3.746567065588859*^9, {3.746567096813675*^9, 3.746567107899699*^9}, 
    3.746568860963537*^9, {3.746609436959559*^9, 3.746609450514915*^9}},
  ExpressionUUID->"7e267551-99c6-49fa-bced-b13a04755f86"],
 "  is the result of the evaluation of  \[Lambda] expression and z is a bound \
variable.\n\nNotice z is treated as a placeholder it is replaced by new \
variables e.g. r and notice the bound variable stack \[Xi] is empty  "
}], "Text",
 CellChangeTimes->{
  3.746609550660516*^9, {3.7466096452109747`*^9, 
   3.746609707040083*^9}},ExpressionUUID->"fe82ef0f-42c5-423b-a36b-\
1af62e1981e0"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", " ", 
  RowBox[{"(*", 
   RowBox[{"empty", " ", "or", " ", 
    RowBox[{"{", "}"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Mho]", 
  "\"\<\[Lambda] z . (Divide b z)\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "b", " ", "z"}], ")"}]}]}], ")"}], 
  "r"}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", "  ", 
  RowBox[{"(*", 
   RowBox[{"var", " ", "z", " ", "added"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.74660962358703*^9, 3.746609634364051*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"c1444116-ecfb-4be9-b32e-a7670545bacf"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.746609635419797*^9},
 CellLabel->"Out[42]=",ExpressionUUID->"458c5666-f5bd-4956-8f6e-9b1364281e34"],

Cell[BoxData["\<\"\[Lambda] z . (/ b z)\"\>"], "Output",
 CellChangeTimes->{3.746609635427629*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"2a7b25ec-9f73-4961-84f3-9d2ca7e8ece8"],

Cell[BoxData[
 FractionBox["b", "r"]], "Output",
 CellChangeTimes->{3.746609635435239*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"6e02f4fb-10f8-4e12-a572-16cbe0ef249c"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.74660963544289*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"e3ed9c58-b02d-4b67-890b-e67015393be1"]
}, Open  ]],

Cell["\<\

Notice z is now added to to the stack. It serves as a record that \[Lambda] \
identified z as a bound variable or local variable:\
\>", "Text",
 CellChangeTimes->{{3.746566375377954*^9, 3.746566391510274*^9}, {
   3.746566424643417*^9, 3.746566442647777*^9}, {3.7465664783286457`*^9, 
   3.74656649280707*^9}, 3.746609461314722*^9, {3.7466095154620447`*^9, 
   3.7466095580426197`*^9}},ExpressionUUID->"ef9e9a56-5785-4d41-aa60-\
36d483d5411e"],

Cell[TextData[{
 "\n",
 StyleBox["Find  bound variables", "Title"],
 "\n\[Upsilon] operator  finds all the bound variables in a \[Lambda] \
expression; you need  to wrap the expression by \"  \" :"
}], "Text",
 CellChangeTimes->{
  3.746526035811522*^9, {3.746526075749*^9, 3.746526079191697*^9}, {
   3.7465261769910593`*^9, 3.7465261776870413`*^9}, {3.746526219370544*^9, 
   3.7465262427132483`*^9}, {3.7465263879882298`*^9, 
   3.7465263921157427`*^9}, {3.746566515037902*^9, 3.746566562843948*^9}, {
   3.7465665972538767`*^9, 3.746566599728979*^9}, 
   3.746609738608721*^9},ExpressionUUID->"f95ff3c1-9237-464a-afd8-\
06e0eabefd8e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Upsilon]", " ", "\"\<\[Lambda] z . (Divide b z)\>\""}]], "Input",
 CellLabel->
  "In[647]:=",ExpressionUUID->"4ee3eeda-8d01-4753-be20-3d2ddbe21288"],

Cell[BoxData[
 RowBox[{"{", "\<\"z\"\>", "}"}]], "Output",
 CellChangeTimes->{3.7465263305615597`*^9, 3.7465263944793043`*^9, 
  3.7465665128303337`*^9, 3.7465665656685543`*^9},
 CellLabel->
  "Out[647]=",ExpressionUUID->"f74a5ec0-798e-44c9-9d66-9440923e05fb"]
}, Open  ]],

Cell["\<\

\[Nu]  operator finds all the variables; no need  to wrap by \"  \" :\
\>", "Text",
 CellChangeTimes->{{3.746566592743128*^9, 
  3.746566636803493*^9}},ExpressionUUID->"0949ce62-1e70-4d1f-9257-\
c4696713a3e8"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Nu]", " ", "\[Lambda]", " ", 
  RowBox[{"z", " ", ".", " ", 
   RowBox[{"(", 
    RowBox[{"Divide", " ", "b", " ", "z"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.746610399029746*^9, 3.7466103995124083`*^9}},
 CellLabel->"In[70]:=",ExpressionUUID->"f7354ed9-5e6e-4456-a1d7-9a3cd3ed9332"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"b\"\>", ",", "\<\"z\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.746526348283798*^9, 3.746566614731422*^9, 
  3.7465686884763308`*^9, 3.74661030077254*^9, 3.746610400323936*^9},
 CellLabel->"Out[71]=",ExpressionUUID->"b0955519-dd34-4a67-a220-2295581aa4c6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Nu]", " ", "\[Lambda]", " ", 
  RowBox[{"z", " ", ".", " ", 
   RowBox[{"(", 
    RowBox[{"Divide", " ", "5", " ", "z"}], ")"}]}]}]}], "Input",
 CellChangeTimes->{
  3.746566651131834*^9, {3.746610402516432*^9, 3.746610402920829*^9}},
 CellLabel->"In[72]:=",ExpressionUUID->"648cdb2b-1dc5-4606-8350-e1bfbd53e179"],

Cell[BoxData[
 RowBox[{"{", "\<\"z\"\>", "}"}]], "Output",
 CellChangeTimes->{3.746566651792883*^9, 3.7465686895926933`*^9, 
  3.746610302325816*^9, 3.746610403858392*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"db1c1768-482f-4e98-8149-2ea0523e8a0a"]
}, Open  ]],

Cell["\<\

Subtract the two operators below and get all the free or global variables:\
\>", "Text",
 CellChangeTimes->{{3.746566672720667*^9, 
  3.746566702803372*^9}},ExpressionUUID->"88450169-06ab-4ef8-9120-\
f29966174203"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", " ", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", "\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "b", " ", "z"}], ")"}]}]}], ",", 
   RowBox[{"\[Upsilon]", " ", "\"\<\[Lambda] z . (Divide b z)\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.746521046004383*^9, 3.7465210464345016`*^9}, 
   3.746521156519286*^9, {3.746526270750854*^9, 3.746526297483017*^9}, {
   3.746526403547892*^9, 3.74652640727075*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],

Cell[BoxData[
 RowBox[{"{", "\<\"b\"\>", "}"}]], "Output",
 CellChangeTimes->{
  3.746521047376712*^9, {3.7465211469010067`*^9, 3.746521158454754*^9}, 
   3.746524983091058*^9, 3.746526082148794*^9, 3.7465262979497232`*^9, 
   3.746526407565949*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"923dba70-cb28-4406-a038-623d8f195b45"]
}, Open  ]],

Cell["\<\

No free varaiables\
\>", "Text",
 CellChangeTimes->{{3.746566735270732*^9, 
  3.746566738669067*^9}},ExpressionUUID->"9a26861f-0101-4c3c-84a6-\
7756074f32a1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", " ", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", "\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "5", " ", "z"}], ")"}]}]}], ",", 
   RowBox[{"\[Upsilon]", " ", "\"\<\[Lambda] z . (Divide 5 z)\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.74656671190559*^9, 3.746566713862462*^9}},
 CellLabel->
  "In[650]:=",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.7465667153816566`*^9},
 CellLabel->
  "Out[650]=",ExpressionUUID->"c0c48bbe-e572-49a6-ab20-dbdb9d3a2146"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["Nested expressions", "Title"]
}], "Text",
 CellChangeTimes->{{3.7465261213917913`*^9, 3.746526125192377*^9}, {
  3.7465405602732353`*^9, 
  3.746540561823556*^9}},ExpressionUUID->"15ef489a-5536-452d-ae09-\
86b73d643a13"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "5", " ", "x"}], ")"}]}]}], ")"}], 
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Plus", " ", "5", " ", "z"}], ")"}]}]}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", "  "}]}], "Input",
 CellChangeTimes->{{3.746610324721634*^9, 3.746610332427018*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"cdd4c71e-6509-4899-9bc5-3e847f1461e1"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z"}]]], "Output",
 CellChangeTimes->{3.746526114678678*^9, 3.7465405650017138`*^9, 
  3.746566751806278*^9, 3.746568693877893*^9, 3.7466103329003057`*^9},
 CellLabel->"Out[65]=",ExpressionUUID->"5dfd67c5-d3fd-43cd-a0e5-a71e730c1a98"],

Cell[BoxData[
 RowBox[{"{", "z", "}"}]], "Output",
 CellChangeTimes->{3.746526114678678*^9, 3.7465405650017138`*^9, 
  3.746566751806278*^9, 3.746568693877893*^9, 3.746610332908173*^9},
 CellLabel->"Out[66]=",ExpressionUUID->"8229d9ff-2e1c-4bb8-8b8e-321d71dbd2df"]
}, Open  ]],

Cell["\<\
Notice the left most \[Lambda] expressions variable name does not matter:\
\>", "Text",
 CellChangeTimes->{{3.746566772814043*^9, 
  3.746566795268664*^9}},ExpressionUUID->"aa52d49c-00db-4d8a-9969-\
669c9e099932"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"y", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "5", " ", "y"}], ")"}]}]}], ")"}], 
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Plus", " ", "5", " ", "z"}], ")"}]}]}], 
   ")"}]}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746566762520001*^9, 3.746566764420611*^9}, {
  3.7466103612397213`*^9, 3.7466103664363537`*^9}},
 CellLabel->"In[67]:=",ExpressionUUID->"3946cdac-dd28-4f38-9c0a-6af80bd44d41"],

Cell[BoxData[
 FractionBox["5", 
  RowBox[{"5", "+", "z"}]]], "Output",
 CellChangeTimes->{3.746566765695786*^9, 3.7465686952108593`*^9, 
  3.7466103667775707`*^9},
 CellLabel->"Out[68]=",ExpressionUUID->"ccdc80c4-caf0-44d3-b917-e332aeac1c0e"],

Cell[BoxData[
 RowBox[{"{", "z", "}"}]], "Output",
 CellChangeTimes->{3.746566765695786*^9, 3.7465686952108593`*^9, 
  3.746610366785715*^9},
 CellLabel->"Out[69]=",ExpressionUUID->"e29b7466-c148-4d6f-a9cc-9a4802877770"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Nu]", " ", 
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Divide", " ", "5", " ", "x"}], ")"}]}]}], ")"}], 
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"z", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Plus", " ", "5", " ", "z"}], ")"}]}]}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.746525009820507*^9, 3.74652501021049*^9}, {
  3.746610410009166*^9, 3.7466104104019823`*^9}},
 CellLabel->"In[74]:=",ExpressionUUID->"98509f0b-e9f8-4557-8d43-49df85c6ea83"],

Cell[BoxData[
 RowBox[{"{", "\<\"z\"\>", "}"}]], "Output",
 CellChangeTimes->{3.746525011335861*^9, 3.746526092602249*^9, 
  3.746566816696046*^9, 3.746568696211959*^9, 3.74661041069485*^9},
 CellLabel->"Out[75]=",ExpressionUUID->"1265247c-f9c4-46a1-8d86-7f01142e9574"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Upsilon]", " ", 
  "\"\<(\[Lambda] x . (Divide 5 x))(\[Lambda] z . (Plus 5 z))\>\""}]], "Input",\

 CellChangeTimes->{
  3.746525574387404*^9, {3.746525667987195*^9, 3.7465256702588053`*^9}, {
   3.746525724294436*^9, 3.7465257266333313`*^9}},
 CellLabel->
  "In[654]:=",ExpressionUUID->"9a6a73bc-beda-4afe-a057-5e73b67d6cbc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"x\"\>", ",", "\<\"z\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.746525576894226*^9, 3.746525635243594*^9, 
  3.746525670705035*^9, 3.7465257273348837`*^9, 3.746566829165653*^9},
 CellLabel->
  "Out[654]=",ExpressionUUID->"92be840c-b819-41a8-a1dd-ea8c1ca4fb69"]
}, Open  ]],

Cell["\<\

No free variables\
\>", "Text",
 CellChangeTimes->{{3.746526566111806*^9, 
  3.746526569834943*^9}},ExpressionUUID->"19c8910c-4230-410a-bd23-\
bca69ffe6e34"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", " ", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", 
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"x", " ", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Divide", " ", "5", " ", "x"}], ")"}]}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"z", " ", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Plus", " ", "5", " ", "z"}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
   "\[Upsilon]", " ", 
    "\"\<(\[Lambda] x . (Divide 5 x))(\[Lambda] z . (Plus 5 z))\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.746526545055523*^9, 3.746526548093223*^9}},
 CellLabel->
  "In[655]:=",ExpressionUUID->"fecc4ad1-4aeb-4262-a59f-cfb4e3350a13"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.746526549029429*^9, 3.746566849318268*^9},
 CellLabel->
  "Out[655]=",ExpressionUUID->"62214f45-2dc9-404a-9d11-808da155cd48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Lambda]", " ", 
  RowBox[{
  "x", " ", ".", " ", "x"}]}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746567359320817*^9, 3.746567362391313*^9}},
 CellLabel->"In[76]:=",ExpressionUUID->"1fc2ed24-1588-4f52-a8ef-1db3d2a82981"],

Cell[BoxData["x"], "Output",
 CellChangeTimes->{3.746567362698242*^9, 3.746568666586306*^9, 
  3.746568700129506*^9, 3.746610415196054*^9},
 CellLabel->"Out[77]=",ExpressionUUID->"5d41fd15-415b-4f74-a9f3-3bb3ff82a31b"],

Cell[BoxData[
 RowBox[{"{", "x", "}"}]], "Output",
 CellChangeTimes->{3.746567362698242*^9, 3.746568666586306*^9, 
  3.746568700129506*^9, 3.746610415206093*^9},
 CellLabel->"Out[78]=",ExpressionUUID->"1c077438-89c2-4067-8185-aefa8567642f"]
}, Open  ]],

Cell["\<\

The bound variable is replaced by z, while y is unchanged since it is free or \
global\
\>", "Text",
 CellChangeTimes->{{3.746610455290452*^9, 
  3.746610479016829*^9}},ExpressionUUID->"b0885a93-c8ae-45eb-ba52-\
63a1eb6ac6b6"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", "y"}]}], ")"}], 
  "z"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.7466104368852463`*^9, 3.746610466395381*^9}},
 CellLabel->"In[82]:=",ExpressionUUID->"020f0af9-f256-4df5-b8e4-6c0eafc049fa"],

Cell[BoxData["y"], "Output",
 CellChangeTimes->{{3.7466104467558517`*^9, 3.746610466610896*^9}},
 CellLabel->"Out[83]=",ExpressionUUID->"364cfc65-ba30-4333-af5d-92890f38310e"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.7466104467558517`*^9, 3.746610466623534*^9}},
 CellLabel->"Out[84]=",ExpressionUUID->"0f400339-3d83-4c6d-997b-b58482c9140e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{"\[Lambda]", " ", 
  RowBox[{"x", " ", ".", " ", 
   RowBox[{"(", 
    RowBox[{"Power", " ", "x", " ", "2"}], 
    ")"}]}]}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.7465672792079067`*^9, 3.746567335583761*^9}},
 CellLabel->
  "In[982]:=",ExpressionUUID->"c67bdadf-1b2c-49cf-911b-c51a8a58e8ee"],

Cell[BoxData[
 SuperscriptBox["x", "2"]], "Output",
 CellChangeTimes->{{3.746567286458538*^9, 3.746567336570924*^9}, 
   3.746567454289784*^9, 3.746568667886544*^9, 3.746568701297101*^9},
 CellLabel->
  "Out[983]=",ExpressionUUID->"c18c54c1-0d2b-4b5c-8d7f-7f1902f8ef51"],

Cell[BoxData[
 RowBox[{"{", "x", "}"}]], "Output",
 CellChangeTimes->{{3.746567286458538*^9, 3.746567336570924*^9}, 
   3.746567454289784*^9, 3.746568667886544*^9, 3.7465687013076973`*^9},
 CellLabel->
  "Out[984]=",ExpressionUUID->"63587b4c-f478-4e16-a2bf-97a9fef530f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"y", " ", ".", "  ", "x"}]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Lambda]", " ", 
        RowBox[{"x", " ", ".", " ", "x"}]}], ")"}], " ", "x"}], ")"}], " ", 
    "x"}], ")"}]}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.7465203008818893`*^9, 3.746520315045223*^9}, 
   3.7465203569306383`*^9, {3.746520517616602*^9, 3.746520556913027*^9}, {
   3.74652061372876*^9, 3.746520616055336*^9}, {3.746566874786462*^9, 
   3.746566884452436*^9}},
 CellLabel->"In[85]:=",ExpressionUUID->"8effcf15-1d45-4efb-a8d4-0b8eb0f1fa0c"],

Cell[BoxData["x"], "Output",
 CellChangeTimes->{
  3.746520315715178*^9, 3.7465203574226837`*^9, {3.74652052364007*^9, 
   3.746520557351288*^9}, {3.7465205925110903`*^9, 3.7465206164355087`*^9}, 
   3.7465248348119907`*^9, {3.7465668581372004`*^9, 3.746566896337721*^9}, {
   3.746567074827029*^9, 3.746567103585239*^9}, 3.74656717007185*^9, 
   3.746568670036566*^9, 3.746568702830779*^9, 3.746610541285186*^9},
 CellLabel->"Out[86]=",ExpressionUUID->"bc5c48a4-ab86-49aa-9333-350dcdf6370a"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.746520315715178*^9, 3.7465203574226837`*^9, {3.74652052364007*^9, 
   3.746520557351288*^9}, {3.7465205925110903`*^9, 3.7465206164355087`*^9}, 
   3.7465248348119907`*^9, {3.7465668581372004`*^9, 3.746566896337721*^9}, {
   3.746567074827029*^9, 3.746567103585239*^9}, 3.74656717007185*^9, 
   3.746568670036566*^9, 3.746568702830779*^9, 3.7466105412952213`*^9},
 CellLabel->"Out[87]=",ExpressionUUID->"398db0e7-bd1a-4bc5-b8ea-2dc0111cb89d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", " ", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", 
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"y", " ", ".", "  ", "x"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Lambda]", " ", 
          RowBox[{"x", " ", ".", " ", "x"}]}], ")"}], " ", "x"}], ")"}], " ", 
      "x"}], ")"}]}], ",", 
   RowBox[{
   "\[Upsilon]", " ", 
    "\"\<(\[Lambda] y .  x) (((\[Lambda] x . x) x) x)\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.746526591541587*^9, 3.7465266014791594`*^9}},
 CellLabel->
  "In[988]:=",ExpressionUUID->"1ae49f29-82f5-4bd8-9d42-a0df3bbfa3ff"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.74652660321312*^9, 3.746567173440781*^9, 
  3.746568704114307*^9},
 CellLabel->
  "Out[988]=",ExpressionUUID->"0b2d58eb-362d-4a58-a88c-f6ddd2a1757c"]
}, Open  ]],

Cell["\<\


This example demonstrates that the name of the bound variable is not of any \
importance \
\>", "Text",
 CellChangeTimes->{{3.746610574531228*^9, 
  3.7466106053224277`*^9}},ExpressionUUID->"3a2e16fc-09ba-4cb2-9179-\
4d32735d3f2b"],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", "x"}]}], ")"}], " ", 
  "x"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746567190737007*^9, 3.7465671962968197`*^9}},
 CellLabel->"In[88]:=",ExpressionUUID->"dc6cbb5f-355d-42ee-8183-43251d2d2ff0"],

Cell[BoxData["x"], "Output",
 CellChangeTimes->{{3.7465205629753733`*^9, 3.746520590293371*^9}, 
   3.7465248363780813`*^9, 3.746567196681653*^9, 3.7465674442711887`*^9, 
   3.7465686727550917`*^9, 3.7465687058647747`*^9, 3.746610547719221*^9},
 CellLabel->"Out[89]=",ExpressionUUID->"964ebec8-cb2d-4bc1-9397-ec97b6b0dbc3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"y", " ", ".", " ", "y"}]}], ")"}], " ", 
  "x"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746610560986206*^9, 3.746610562324401*^9}},
 CellLabel->"In[91]:=",ExpressionUUID->"937aba43-636a-4235-9038-e3e3bf623d83"],

Cell[BoxData["x"], "Output",
 CellChangeTimes->{{3.7465205629753733`*^9, 3.746520590293371*^9}, 
   3.7465248363780813`*^9, 3.746567196681653*^9, 3.7465674442711887`*^9, 
   3.7465686727550917`*^9, 3.7465687058647747`*^9, {3.746610547731668*^9, 
   3.746610567043262*^9}},
 CellLabel->"Out[92]=",ExpressionUUID->"15e84f34-b30f-4d88-859e-b65886851da2"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.7465205629753733`*^9, 3.746520590293371*^9}, 
   3.7465248363780813`*^9, 3.746567196681653*^9, 3.7465674442711887`*^9, 
   3.7465686727550917`*^9, 3.7465687058647747`*^9, {3.746610547731668*^9, 
   3.7466105670511627`*^9}},
 CellLabel->"Out[93]=",ExpressionUUID->"e29c03e5-b71b-4d28-ac49-a980c5a22dbb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", "x"}]}], ")"}], 
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"y", " ", ".", " ", "y"}]}], 
   ")"}]}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746520346815661*^9, 3.746520397239072*^9}, {
  3.746567206689749*^9, 3.746567211012021*^9}},
 CellLabel->"In[94]:=",ExpressionUUID->"1ca2a77c-0050-45a3-9275-dfd138f13e9f"],

Cell[BoxData["y"], "Output",
 CellChangeTimes->{3.746520397690675*^9, 3.7465248377633457`*^9, 
  3.746567211316407*^9, 3.746568674188505*^9, 3.746568706831745*^9, 
  3.746610617008304*^9},
 CellLabel->"Out[95]=",ExpressionUUID->"5ba1f5ad-6bc5-406e-9342-5d186df60462"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{3.746520397690675*^9, 3.7465248377633457`*^9, 
  3.746567211316407*^9, 3.746568674188505*^9, 3.746568706831745*^9, 
  3.7466106170180817`*^9},
 CellLabel->"Out[96]=",ExpressionUUID->"67ed36fc-cfdd-469e-ba92-1f5e64640054"]
}, Open  ]],

Cell["No free variables ", "Text",
 CellChangeTimes->{{3.746526770336587*^9, 
  3.746526773474667*^9}},ExpressionUUID->"9a154cda-1306-41e9-9047-\
5445e16294ff"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Complement", " ", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", 
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"x", " ", ".", " ", "x"}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"y", " ", ".", " ", "y"}]}], ")"}]}], ",", 
   RowBox[{
   "\[Upsilon]", " ", "\"\<(\[Lambda] x . x)(\[Lambda] y . y)\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.7465266413574142`*^9, 3.746526644507655*^9}},
 CellLabel->
  "In[711]:=",ExpressionUUID->"dbe89c84-66d4-4bf1-9cfe-b82c2411b7f1"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.746526646293138*^9, 3.74656723209291*^9},
 CellLabel->
  "Out[711]=",ExpressionUUID->"189b9182-c991-4198-9e7d-a38e43af8f7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FIXME", ":", " ", 
     RowBox[{
     "Do", " ", "not", " ", "know", " ", "what", " ", "some", " ", "parans", 
      " ", "are", " ", "red"}]}], ",", " ", 
    RowBox[{"need", " ", "to", " ", "call", " ", "techsupport"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"\[Omicron]", "\[IndentingNewLine]", 
   RowBox[{"(", 
    RowBox[{"Plus", " ", 
     RowBox[{"(", 
      RowBox[{"\[Lambda]", " ", 
       RowBox[{"y", " ", ".", " ", 
        RowBox[{"(", 
         RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", "x"}], 
    ")"}], "\[IndentingNewLine]", "\[Xi]"}]}]], "Input",
 CellChangeTimes->{{3.746527745594335*^9, 3.746527765404092*^9}, {
  3.7465674973725367`*^9, 3.746567544243979*^9}, {3.7466106826470127`*^9, 
  3.7466106828478193`*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"41229432-656d-4b78-b1ef-dff61b438b12"],

Cell[BoxData[
 RowBox[{"3", "+", "x", "+", "y"}]], "Output",
 CellChangeTimes->{{3.746527730333095*^9, 3.74652776604134*^9}, 
   3.746540598677574*^9, 3.746567458692889*^9, 3.746567544618479*^9, 
   3.746567810986249*^9, 3.7465686785560617`*^9, 3.746568711549838*^9, {
   3.746610676740529*^9, 3.746610683075259*^9}},
 CellLabel->
  "Out[100]=",ExpressionUUID->"085d49ab-aa04-48f0-954f-609a34e632d3"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{{3.746527730333095*^9, 3.74652776604134*^9}, 
   3.746540598677574*^9, 3.746567458692889*^9, 3.746567544618479*^9, 
   3.746567810986249*^9, 3.7465686785560617`*^9, 3.746568711549838*^9, {
   3.746610676740529*^9, 3.746610683083744*^9}},
 CellLabel->
  "Out[101]=",ExpressionUUID->"4b31972e-e233-4118-b30c-d5818f554d7b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"y", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], " ", ")"}], 
  "7"}]}], "Input",
 CellChangeTimes->{{3.746527843402246*^9, 3.7465278440655127`*^9}, {
  3.7465279255975113`*^9, 3.7465279286675043`*^9}, {3.7465675471546497`*^9, 
  3.746567547608148*^9}},
 CellLabel->
  "In[102]:=",ExpressionUUID->"a06e561e-7fae-4e59-9ff0-7923f25bbd3a"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{
  3.7465278442821083`*^9, 3.746527929054102*^9, 3.7465335148913813`*^9, 
   3.7465406015281076`*^9, {3.7465675216123667`*^9, 3.746567547958206*^9}, 
   3.7465678158715277`*^9, 3.746568679922826*^9, 3.7465687125835037`*^9, 
   3.7466106960789022`*^9},
 CellLabel->
  "Out[103]=",ExpressionUUID->"a8b9c0c5-6e46-4262-b6a1-da694204d2ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Lambda]", " ", 
   RowBox[{"x", " ", ".", " ", 
    RowBox[{"(", 
     RowBox[{"Plus", " ", 
      RowBox[{"(", 
       RowBox[{"\[Lambda]", " ", 
        RowBox[{"y", " ", ".", " ", 
         RowBox[{"(", 
          RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", "x"}], 
     ")"}]}]}], " "}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746529594454496*^9, 3.7465295948545847`*^9}, {
  3.746529636132167*^9, 3.7465296376948223`*^9}, {3.746567554602363*^9, 
  3.746567555020854*^9}, {3.746568271971409*^9, 3.746568272176474*^9}},
 CellLabel->
  "In[104]:=",ExpressionUUID->"7a575fbd-79a5-4198-b1e1-a5b16ade840f"],

Cell[BoxData[
 RowBox[{"3", "+", "x", "+", "y"}]], "Output",
 CellChangeTimes->{{3.746529577187195*^9, 3.7465295957661657`*^9}, 
   3.7465333499064827`*^9, 3.7465334981689157`*^9, 3.746540630607257*^9, 
   3.746567555382791*^9, 3.746567817321258*^9, 3.746568272479664*^9, 
   3.746568681122945*^9, 3.746568713750201*^9, 3.7466107117169867`*^9},
 CellLabel->
  "Out[105]=",ExpressionUUID->"3e0ee837-4b39-4804-a3fa-33c13031d025"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "y"}], "}"}]], "Output",
 CellChangeTimes->{{3.746529577187195*^9, 3.7465295957661657`*^9}, 
   3.7465333499064827`*^9, 3.7465334981689157`*^9, 3.746540630607257*^9, 
   3.746567555382791*^9, 3.746567817321258*^9, 3.746568272479664*^9, 
   3.746568681122945*^9, 3.746568713750201*^9, 3.746610711727223*^9},
 CellLabel->
  "Out[106]=",ExpressionUUID->"fd4e673c-358a-4389-af76-8a89f5606173"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"\[Lambda]", " ", 
    RowBox[{"x", " ", ".", " ", 
     RowBox[{"(", 
      RowBox[{"Plus", " ", 
       RowBox[{"(", 
        RowBox[{"\[Lambda]", " ", 
         RowBox[{"y", " ", ".", " ", 
          RowBox[{"(", 
           RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", "x"}],
       ")"}]}]}], ")"}], " ", "2"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",\

 CellChangeTimes->{{3.746528343361685*^9, 3.746528375896473*^9}, {
   3.7465284306407633`*^9, 3.746528434521236*^9}, {3.7465285087620173`*^9, 
   3.7465285156118917`*^9}, {3.746528558420817*^9, 3.746528583272791*^9}, {
   3.746528780724505*^9, 3.746528789183803*^9}, {3.746528826591235*^9, 
   3.7465288478872623`*^9}, {3.746528930272367*^9, 3.746528933680272*^9}, 
   3.7465289890431547`*^9, {3.7465291191069527`*^9, 3.746529133843647*^9}, {
   3.746529173051669*^9, 3.746529212426186*^9}, {3.746567550822281*^9, 
   3.746567551230151*^9}, {3.746568243340584*^9, 3.746568243579327*^9}},
 CellLabel->
  "In[107]:=",ExpressionUUID->"eaa3d25d-246c-4b9c-b801-cd3d3707a20a"],

Cell[BoxData[
 RowBox[{"5", "+", "y"}]], "Output",
 CellChangeTimes->{{3.7465283440879602`*^9, 3.7465283762833138`*^9}, {
   3.746528431243675*^9, 3.746528434718299*^9}, 3.746528517586235*^9, {
   3.746528563823268*^9, 3.746528583648919*^9}, {3.746528785252676*^9, 
   3.7465287896051073`*^9}, {3.746528829401085*^9, 3.7465288481901617`*^9}, {
   3.746528918344179*^9, 3.74652893418291*^9}, 3.746528989767318*^9, 
   3.746529037748126*^9, {3.746529069025249*^9, 3.746529085730331*^9}, {
   3.746529119419026*^9, 3.7465291342004833`*^9}, {3.746529171518383*^9, 
   3.7465292128023567`*^9}, 3.7465293494628153`*^9, 3.746529410431456*^9, 
   3.746529550307096*^9, 3.7465335091236897`*^9, 3.746540604579316*^9, {
   3.746567524829714*^9, 3.746567551580508*^9}, 3.746567750049321*^9, 
   3.746567818438953*^9, 3.746568020500676*^9, {3.746568244320797*^9, 
   3.746568248889894*^9}, 3.7465682789820557`*^9, 3.7465686827577*^9, 
   3.746568716268259*^9, 3.746610726471743*^9},
 CellLabel->
  "Out[108]=",ExpressionUUID->"15376cb0-8d6a-4638-b6c8-d5485fb03730"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{{3.7465283440879602`*^9, 3.7465283762833138`*^9}, {
   3.746528431243675*^9, 3.746528434718299*^9}, 3.746528517586235*^9, {
   3.746528563823268*^9, 3.746528583648919*^9}, {3.746528785252676*^9, 
   3.7465287896051073`*^9}, {3.746528829401085*^9, 3.7465288481901617`*^9}, {
   3.746528918344179*^9, 3.74652893418291*^9}, 3.746528989767318*^9, 
   3.746529037748126*^9, {3.746529069025249*^9, 3.746529085730331*^9}, {
   3.746529119419026*^9, 3.7465291342004833`*^9}, {3.746529171518383*^9, 
   3.7465292128023567`*^9}, 3.7465293494628153`*^9, 3.746529410431456*^9, 
   3.746529550307096*^9, 3.7465335091236897`*^9, 3.746540604579316*^9, {
   3.746567524829714*^9, 3.746567551580508*^9}, 3.746567750049321*^9, 
   3.746567818438953*^9, 3.746568020500676*^9, {3.746568244320797*^9, 
   3.746568248889894*^9}, 3.7465682789820557`*^9, 3.7465686827577*^9, 
   3.746568716268259*^9, 3.746610726482163*^9},
 CellLabel->
  "Out[109]=",ExpressionUUID->"fa312601-11b6-450b-b60e-f7c18c5cf31e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"x", " ", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Plus", " ", 
         RowBox[{"(", 
          RowBox[{"\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", 
         "x"}], ")"}]}]}], ")"}], " ", "2"}], ")"}], 
  "7"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{
  3.746529641914075*^9, {3.746533309859412*^9, 3.74653332286372*^9}, {
   3.7465675941805267`*^9, 3.7465675946666718`*^9}, {3.746567934363995*^9, 
   3.746567934614429*^9}, {3.746568422635578*^9, 3.746568429214301*^9}, {
   3.74656846628544*^9, 3.7465684684999037`*^9}},
 CellLabel->
  "In[110]:=",ExpressionUUID->"0e4d8b1a-d168-43fc-a153-5056539c2223"],

Cell[BoxData["12"], "Output",
 CellChangeTimes->{
  3.746529642224257*^9, 3.746533283167281*^9, {3.7465333132268257`*^9, 
   3.7465333231282797`*^9}, 3.746540634688088*^9, {3.746567587566287*^9, 
   3.746567594995553*^9}, {3.746567687214034*^9, 3.746567705619508*^9}, 
   3.7465677567359324`*^9, 3.746567820371937*^9, 3.746567895262217*^9, 
   3.746567934906312*^9, 3.746568037840564*^9, {3.746568126733787*^9, 
   3.746568207693844*^9}, 3.746568255444419*^9, 3.746568429547985*^9, 
   3.746568468839017*^9, 3.746568634476241*^9, 3.746568717285187*^9, 
   3.7466107467289047`*^9},
 CellLabel->
  "Out[111]=",ExpressionUUID->"0c3ed743-dd59-4c53-a03d-7b7d80528a50"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{
  3.746529642224257*^9, 3.746533283167281*^9, {3.7465333132268257`*^9, 
   3.7465333231282797`*^9}, 3.746540634688088*^9, {3.746567587566287*^9, 
   3.746567594995553*^9}, {3.746567687214034*^9, 3.746567705619508*^9}, 
   3.7465677567359324`*^9, 3.746567820371937*^9, 3.746567895262217*^9, 
   3.746567934906312*^9, 3.746568037840564*^9, {3.746568126733787*^9, 
   3.746568207693844*^9}, 3.746568255444419*^9, 3.746568429547985*^9, 
   3.746568468839017*^9, 3.746568634476241*^9, 3.746568717285187*^9, 
   3.746610746739283*^9},
 CellLabel->
  "Out[112]=",ExpressionUUID->"7b88a41e-9680-4ba8-a1a7-9cbcc28fec20"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"(", 
   RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"\[Omicron]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"(", 
  RowBox[{"Plus", " ", 
   RowBox[{"(", 
    RowBox[{"\[Lambda]", " ", 
     RowBox[{"y", " ", ".", " ", 
      RowBox[{"(", 
       RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", "x"}], 
  ")"}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\[Omicron]", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"\[Lambda]", " ", 
     RowBox[{"x", " ", ".", " ", 
      RowBox[{"(", 
       RowBox[{"Plus", " ", 
        RowBox[{"(", 
         RowBox[{"\[Lambda]", " ", 
          RowBox[{"y", " ", ".", " ", 
           RowBox[{"(", 
            RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", 
        "x"}], ")"}]}]}], ")"}], " ", "2"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"\[Xi]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", "\[Omicron]", "\
\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"x", " ", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Plus", " ", 
         RowBox[{"(", 
          RowBox[{"\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"Plus", " ", "3", " ", "y"}], ")"}]}]}], ")"}], " ", 
         "x"}], ")"}]}]}], ")"}], " ", "2"}], ")"}], 
  "7"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{{3.746534428567006*^9, 3.7465344707578907`*^9}, {
  3.746534502042541*^9, 3.746534515624525*^9}, {3.7465349575179863`*^9, 
  3.746534969648632*^9}, {3.746535466236829*^9, 3.746535483609652*^9}, {
  3.7465355739100523`*^9, 3.746535577125568*^9}, {3.746535910916709*^9, 
  3.746535944927866*^9}},
 CellLabel->
  "In[113]:=",ExpressionUUID->"d0013884-438f-4d84-b533-19573a2ee95e"],

Cell[BoxData[
 RowBox[{"3", "+", "y"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.74661075024405*^9},
 CellLabel->
  "Out[114]=",ExpressionUUID->"1c479fb2-d4fe-4b6c-902b-7435500d6143"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.7466107502541723`*^9},
 CellLabel->
  "Out[115]=",ExpressionUUID->"2cc7c553-a1fa-4c91-8ea5-f7f14eb320ee"],

Cell[BoxData[
 RowBox[{"3", "+", "x", "+", "y"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.746610750259574*^9},
 CellLabel->
  "Out[117]=",ExpressionUUID->"d03dba10-a117-4076-8ceb-3c5efd6137e5"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.746610750265129*^9},
 CellLabel->
  "Out[118]=",ExpressionUUID->"c5762ca4-7bf5-4ab3-8b64-628d6e1feb48"],

Cell[BoxData[
 RowBox[{"5", "+", "y"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.746610750270609*^9},
 CellLabel->
  "Out[120]=",ExpressionUUID->"ad519cf9-0604-440b-8972-e64906a17732"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.746610750275971*^9},
 CellLabel->
  "Out[121]=",ExpressionUUID->"380b5124-5c4e-4ad7-98c5-999762d2ee45"],

Cell[BoxData["12"], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.746610750281782*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"40597dee-34f4-4950-8f5f-d1213521e620"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{
  3.746534433530366*^9, 3.7465344715439787`*^9, {3.746534506558886*^9, 
   3.746534515850774*^9}, {3.7465349366810703`*^9, 3.746534970157218*^9}, {
   3.746535324083975*^9, 3.746535332887287*^9}, {3.746535455842429*^9, 
   3.7465354908523893`*^9}, {3.7465355783471413`*^9, 3.746535583199016*^9}, 
   3.746535946144915*^9, {3.746567823172817*^9, 3.746567828956469*^9}, 
   3.746568719383492*^9, 3.746568797725412*^9, 3.7466107502873487`*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"8bdc4c38-02ad-435a-b93a-c7f097c0fdca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"\[Omicron]", "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[Lambda]", " ", 
      RowBox[{"x", " ", ".", " ", 
       RowBox[{"(", 
        RowBox[{"Plus", " ", 
         RowBox[{"(", 
          RowBox[{"\[Lambda]", " ", 
           RowBox[{"y", " ", ".", " ", 
            RowBox[{"(", 
             RowBox[{"Plus", " ", "z", " ", "y"}], ")"}]}]}], ")"}], " ", 
         "x"}], ")"}]}]}], ")"}], " ", "2"}], ")"}], 
  "7"}], "\[IndentingNewLine]", "\[Xi]"}], "Input",
 CellChangeTimes->{3.746569026195739*^9},
 CellLabel->
  "In[125]:=",ExpressionUUID->"d05674ff-76cf-40e3-b310-55a79cde9ecd"],

Cell[BoxData[
 RowBox[{"9", "+", "z"}]], "Output",
 CellChangeTimes->{3.746569028785049*^9, 3.74661075803011*^9},
 CellLabel->
  "Out[126]=",ExpressionUUID->"ba13f4ab-fcb0-4214-bc3a-dbc5c61ca03a"],

Cell[BoxData[
 RowBox[{"{", "y", "}"}]], "Output",
 CellChangeTimes->{3.746569028785049*^9, 3.746610758038039*^9},
 CellLabel->
  "Out[127]=",ExpressionUUID->"1e526a18-2e81-4575-a645-348879a6294a"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{685, Automatic}, {122, Automatic}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 10740, 221, 747, "Input",ExpressionUUID->"1132464f-13f9-4aeb-a273-bd82662c329f"],
Cell[11301, 243, 196, 6, 97, "Text",ExpressionUUID->"6a51a7ec-f2eb-4ad0-9ab8-5c197a10ae7f"],
Cell[11500, 251, 260, 7, 58, "Text",ExpressionUUID->"537278c6-b157-4293-8ad9-a7445d850ccc"],
Cell[11763, 260, 309, 8, 58, "Text",ExpressionUUID->"3bb0307b-077c-4bff-aa91-bcf0be33c48f"],
Cell[12075, 270, 345, 8, 81, "Text",ExpressionUUID->"8d1383d3-1524-40bc-8d25-caa0b1904007"],
Cell[CellGroupData[{
Cell[12445, 282, 452, 6, 30, "Input",ExpressionUUID->"d0ab6a7f-3b9b-496c-a8a5-c24f3f42e46d"],
Cell[12900, 290, 683, 9, 34, "Output",ExpressionUUID->"2ed71b70-c300-495a-b497-4a56679626a8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13620, 304, 226, 3, 30, "Input",ExpressionUUID->"43d572a9-e22e-4127-bdb4-e2b147842879"],
Cell[13849, 309, 179, 2, 34, "Output",ExpressionUUID->"aa21bfee-8839-4c64-91e5-6837696df5f4"]
}, Open  ]],
Cell[14043, 314, 608, 12, 212, "Text",ExpressionUUID->"ba63361b-1bdd-49bc-af32-eef69722d648"],
Cell[CellGroupData[{
Cell[14676, 330, 1086, 23, 115, "Input",ExpressionUUID->"edffe629-cea6-481d-8fb2-46834373f0a2"],
Cell[15765, 355, 863, 13, 34, "Output",ExpressionUUID->"348eb714-06fd-4327-ade7-0d5dfd349e1d"],
Cell[16631, 370, 874, 12, 34, "Output",ExpressionUUID->"77a44d18-fbfd-408e-955b-c2510269b86a"],
Cell[17508, 384, 866, 13, 51, "Output",ExpressionUUID->"96cb65fb-a8ae-46cd-a444-07473cb04bf6"],
Cell[18377, 399, 868, 13, 34, "Output",ExpressionUUID->"64a12d1d-14fe-4969-b171-f85f637dc2df"]
}, Open  ]],
Cell[19260, 415, 1227, 21, 108, "Text",ExpressionUUID->"fe82ef0f-42c5-423b-a36b-1af62e1981e0"],
Cell[CellGroupData[{
Cell[20512, 440, 737, 18, 136, "Input",ExpressionUUID->"c1444116-ecfb-4be9-b32e-a7670545bacf"],
Cell[21252, 460, 166, 3, 34, "Output",ExpressionUUID->"458c5666-f5bd-4956-8f6e-9b1364281e34"],
Cell[21421, 465, 177, 2, 34, "Output",ExpressionUUID->"2a7b25ec-9f73-4961-84f3-9d2ca7e8ece8"],
Cell[21601, 469, 169, 3, 51, "Output",ExpressionUUID->"6e02f4fb-10f8-4e12-a572-16cbe0ef249c"],
Cell[21773, 474, 165, 3, 34, "Output",ExpressionUUID->"e3ed9c58-b02d-4b67-890b-e67015393be1"]
}, Open  ]],
Cell[21953, 480, 454, 9, 58, "Text",ExpressionUUID->"ef9e9a56-5785-4d41-aa60-36d483d5411e"],
Cell[22410, 491, 638, 13, 120, "Text",ExpressionUUID->"f95ff3c1-9237-464a-afd8-06e0eabefd8e"],
Cell[CellGroupData[{
Cell[23073, 508, 174, 3, 30, "Input",ExpressionUUID->"4ee3eeda-8d01-4753-be20-3d2ddbe21288"],
Cell[23250, 513, 260, 5, 34, "Output",ExpressionUUID->"f74a5ec0-798e-44c9-9d66-9440923e05fb"]
}, Open  ]],
Cell[23525, 521, 220, 6, 58, "Text",ExpressionUUID->"0949ce62-1e70-4d1f-9257-c4696713a3e8"],
Cell[CellGroupData[{
Cell[23770, 531, 354, 6, 52, "Input",ExpressionUUID->"f7354ed9-5e6e-4456-a1d7-9a3cd3ed9332"],
Cell[24127, 539, 302, 5, 34, "Output",ExpressionUUID->"b0955519-dd34-4a67-a220-2295581aa4c6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24466, 549, 377, 7, 52, "Input",ExpressionUUID->"648cdb2b-1dc5-4606-8350-e1bfbd53e179"],
Cell[24846, 558, 250, 4, 34, "Output",ExpressionUUID->"db1c1768-482f-4e98-8149-2ea0523e8a0a"]
}, Open  ]],
Cell[25111, 565, 225, 6, 58, "Text",ExpressionUUID->"88450169-06ab-4ef8-9120-f29966174203"],
Cell[CellGroupData[{
Cell[25361, 575, 577, 12, 30, "Input",ExpressionUUID->"343bfcd2-e258-4429-81b7-f99aa2e716d7"],
Cell[25941, 589, 328, 6, 34, "Output",ExpressionUUID->"923dba70-cb28-4406-a038-623d8f195b45"]
}, Open  ]],
Cell[26284, 598, 169, 6, 58, "Text",ExpressionUUID->"9a26861f-0101-4c3c-84a6-7756074f32a1"],
Cell[CellGroupData[{
Cell[26478, 608, 457, 11, 30, "Input",ExpressionUUID->"7805c34b-4c45-4ec3-afd5-a0c5f54297a2"],
Cell[26938, 621, 172, 4, 34, "Output",ExpressionUUID->"c0c48bbe-e572-49a6-ab20-dbdb9d3a2146"]
}, Open  ]],
Cell[27125, 628, 254, 7, 97, "Text",ExpressionUUID->"15ef489a-5536-452d-ae09-86b73d643a13"],
Cell[CellGroupData[{
Cell[27404, 639, 596, 15, 73, "Input",ExpressionUUID->"cdd4c71e-6509-4899-9bc5-3e847f1461e1"],
Cell[28003, 656, 287, 5, 51, "Output",ExpressionUUID->"5dfd67c5-d3fd-43cd-a0e5-a71e730c1a98"],
Cell[28293, 663, 264, 4, 34, "Output",ExpressionUUID->"8229d9ff-2e1c-4bb8-8b8e-321d71dbd2df"]
}, Open  ]],
Cell[28572, 670, 223, 5, 35, "Text",ExpressionUUID->"aa52d49c-00db-4d8a-9969-669c9e099932"],
Cell[CellGroupData[{
Cell[28820, 679, 631, 15, 73, "Input",ExpressionUUID->"3946cdac-dd28-4f38-9c0a-6af80bd44d41"],
Cell[29454, 696, 243, 5, 51, "Output",ExpressionUUID->"ccdc80c4-caf0-44d3-b917-e332aeac1c0e"],
Cell[29700, 703, 220, 4, 34, "Output",ExpressionUUID->"e29b7466-c148-4d6f-a9cc-9a4802877770"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29957, 712, 606, 14, 52, "Input",ExpressionUUID->"98509f0b-e9f8-4557-8d43-49df85c6ea83"],
Cell[30566, 728, 269, 4, 34, "Output",ExpressionUUID->"1265247c-f9c4-46a1-8d86-7f01142e9574"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30872, 737, 352, 8, 30, "Input",ExpressionUUID->"9a6a73bc-beda-4afe-a057-5e73b67d6cbc"],
Cell[31227, 747, 307, 6, 34, "Output",ExpressionUUID->"92be840c-b819-41a8-a1dd-ea8c1ca4fb69"]
}, Open  ]],
Cell[31549, 756, 168, 6, 58, "Text",ExpressionUUID->"19c8910c-4230-410a-bd23-bca69ffe6e34"],
Cell[CellGroupData[{
Cell[31742, 766, 713, 20, 52, "Input",ExpressionUUID->"fecc4ad1-4aeb-4262-a59f-cfb4e3350a13"],
Cell[32458, 788, 192, 4, 34, "Output",ExpressionUUID->"62214f45-2dc9-404a-9d11-808da155cd48"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32687, 797, 309, 5, 73, "Input",ExpressionUUID->"1fc2ed24-1588-4f52-a8ef-1db3d2a82981"],
Cell[32999, 804, 218, 3, 34, "Output",ExpressionUUID->"5d41fd15-415b-4f74-a9f3-3bb3ff82a31b"],
Cell[33220, 809, 240, 4, 34, "Output",ExpressionUUID->"1c077438-89c2-4067-8185-aefa8567642f"]
}, Open  ]],
Cell[33475, 816, 237, 7, 58, "Text",ExpressionUUID->"b0885a93-c8ae-45eb-ba52-63a1eb6ac6b6"],
Cell[CellGroupData[{
Cell[33737, 827, 355, 7, 73, "Input",ExpressionUUID->"020f0af9-f256-4df5-b8e4-6c0eafc049fa"],
Cell[34095, 836, 175, 2, 34, "Output",ExpressionUUID->"364cfc65-ba30-4333-af5d-92890f38310e"],
Cell[34273, 840, 192, 3, 34, "Output",ExpressionUUID->"0f400339-3d83-4c6d-997b-b58482c9140e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34502, 848, 380, 8, 73, "Input",ExpressionUUID->"c67bdadf-1b2c-49cf-911b-c51a8a58e8ee"],
Cell[34885, 858, 270, 5, 34, "Output",ExpressionUUID->"c18c54c1-0d2b-4b5c-8d7f-7f1902f8ef51"],
Cell[35158, 865, 271, 5, 34, "Output",ExpressionUUID->"63587b4c-f478-4e16-a2bf-97a9fef530f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35466, 875, 736, 17, 73, "Input",ExpressionUUID->"8effcf15-1d45-4efb-a8d4-0b8eb0f1fa0c"],
Cell[36205, 894, 492, 7, 34, "Output",ExpressionUUID->"bc5c48a4-ab86-49aa-9333-350dcdf6370a"],
Cell[36700, 903, 511, 8, 34, "Output",ExpressionUUID->"398db0e7-bd1a-4bc5-b8ea-2dc0111cb89d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37248, 916, 694, 21, 30, "Input",ExpressionUUID->"1ae49f29-82f5-4bd8-9d42-a0df3bbfa3ff"],
Cell[37945, 939, 216, 5, 34, "Output",ExpressionUUID->"0b2d58eb-362d-4a58-a88c-f6ddd2a1757c"]
}, Open  ]],
Cell[38176, 947, 243, 8, 81, "Text",ExpressionUUID->"3a2e16fc-09ba-4cb2-9179-4d32735d3f2b"],
Cell[CellGroupData[{
Cell[38444, 959, 360, 7, 73, "Input",ExpressionUUID->"dc6cbb5f-355d-42ee-8183-43251d2d2ff0"],
Cell[38807, 968, 323, 4, 34, "Output",ExpressionUUID->"964ebec8-cb2d-4bc1-9397-ec97b6b0dbc3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39167, 977, 358, 7, 73, "Input",ExpressionUUID->"937aba43-636a-4235-9038-e3e3bf623d83"],
Cell[39528, 986, 351, 5, 34, "Output",ExpressionUUID->"15e84f34-b30f-4d88-859e-b65886851da2"],
Cell[39882, 993, 370, 6, 34, "Output",ExpressionUUID->"e29c03e5-b71b-4d28-ac49-a980c5a22dbb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40289, 1004, 493, 11, 73, "Input",ExpressionUUID->"1ca2a77c-0050-45a3-9275-dfd138f13e9f"],
Cell[40785, 1017, 267, 4, 34, "Output",ExpressionUUID->"5ba1f5ad-6bc5-406e-9342-5d186df60462"],
Cell[41055, 1023, 291, 5, 34, "Output",ExpressionUUID->"67ed36fc-cfdd-469e-ba92-1f5e64640054"]
}, Open  ]],
Cell[41361, 1031, 160, 3, 35, "Text",ExpressionUUID->"9a154cda-1306-41e9-9047-5445e16294ff"],
Cell[CellGroupData[{
Cell[41546, 1038, 548, 15, 30, "Input",ExpressionUUID->"dbe89c84-66d4-4bf1-9cfe-b82c2411b7f1"],
Cell[42097, 1055, 191, 4, 34, "Output",ExpressionUUID->"189b9182-c991-4198-9e7d-a38e43af8f7a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42325, 1064, 909, 22, 94, "Input",ExpressionUUID->"41229432-656d-4b78-b1ef-dff61b438b12"],
Cell[43237, 1088, 400, 7, 34, "Output",ExpressionUUID->"085d49ab-aa04-48f0-954f-609a34e632d3"],
Cell[43640, 1097, 390, 7, 34, "Output",ExpressionUUID->"4b31972e-e233-4118-b30c-d5818f554d7b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44067, 1109, 502, 12, 52, "Input",ExpressionUUID->"a06e561e-7fae-4e59-9ff0-7923f25bbd3a"],
Cell[44572, 1123, 383, 7, 34, "Output",ExpressionUUID->"a8b9c0c5-6e46-4262-b6a1-da694204d2ec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44992, 1135, 723, 16, 73, "Input",ExpressionUUID->"7a575fbd-79a5-4198-b1e1-a5b16ade840f"],
Cell[45718, 1153, 427, 7, 34, "Output",ExpressionUUID->"3e0ee837-4b39-4804-a3fa-33c13031d025"],
Cell[46148, 1162, 438, 8, 34, "Output",ExpressionUUID->"fd4e673c-358a-4389-af76-8a89f5606173"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46623, 1175, 1137, 23, 73, "Input",ExpressionUUID->"eaa3d25d-246c-4b9c-b801-cd3d3707a20a"],
Cell[47763, 1200, 1052, 16, 34, "Output",ExpressionUUID->"15376cb0-8d6a-4638-b6c8-d5485fb03730"],
Cell[48818, 1218, 1052, 16, 34, "Output",ExpressionUUID->"fa312601-11b6-450b-b60e-f7c18c5cf31e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49907, 1239, 906, 22, 73, "Input",ExpressionUUID->"0e4d8b1a-d168-43fc-a153-5056539c2223"],
Cell[50816, 1263, 663, 11, 34, "Output",ExpressionUUID->"0c3ed743-dd59-4c53-a03d-7b7d80528a50"],
Cell[51482, 1276, 682, 12, 34, "Output",ExpressionUUID->"7b88a41e-9680-4ba8-a1a7-9cbcc28fec20"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52201, 1293, 2109, 55, 388, "Input",ExpressionUUID->"d0013884-438f-4d84-b533-19573a2ee95e"],
Cell[54313, 1350, 591, 10, 34, "Output",ExpressionUUID->"1c479fb2-d4fe-4b6c-902b-7435500d6143"],
Cell[54907, 1362, 589, 10, 34, "Output",ExpressionUUID->"2cc7c553-a1fa-4c91-8ea5-f7f14eb320ee"],
Cell[55499, 1374, 602, 10, 34, "Output",ExpressionUUID->"d03dba10-a117-4076-8ceb-3c5efd6137e5"],
Cell[56104, 1386, 592, 10, 34, "Output",ExpressionUUID->"c5762ca4-7bf5-4ab3-8b64-628d6e1feb48"],
Cell[56699, 1398, 592, 10, 34, "Output",ExpressionUUID->"ad519cf9-0604-440b-8972-e64906a17732"],
Cell[57294, 1410, 592, 10, 34, "Output",ExpressionUUID->"380b5124-5c4e-4ad7-98c5-999762d2ee45"],
Cell[57889, 1422, 571, 9, 34, "Output",ExpressionUUID->"40597dee-34f4-4950-8f5f-d1213521e620"],
Cell[58463, 1433, 594, 10, 34, "Output",ExpressionUUID->"8bdc4c38-02ad-435a-b93a-c7f097c0fdca"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59094, 1448, 657, 18, 73, "Input",ExpressionUUID->"d05674ff-76cf-40e3-b310-55a79cde9ecd"],
Cell[59754, 1468, 196, 4, 34, "Output",ExpressionUUID->"ba13f4ab-fcb0-4214-bc3a-dbc5c61ca03a"],
Cell[59953, 1474, 197, 4, 34, "Output",ExpressionUUID->"1e526a18-2e81-4575-a645-348879a6294a"]
}, Open  ]]
}
]
*)

