(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     44883,       1160]
NotebookOptionsPosition[     42407,       1108]
NotebookOutlinePosition[     42798,       1125]
CellTagsIndexPosition[     42755,       1122]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},ExpressionUUID->"11478f6b-82f2-4259-be51-\
e2cbaba2651b"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"myLambda", "[", 
    RowBox[{"func_", ",", "s_", ",", "vars0_", ",", "val_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"vars", "=", "vars0"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<\[Lambda]\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"val", "===", "Nothing"}], ",", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<(\>\"", ",", "\"\<\[Lambda]\>\"", ",", "\"\<.\>\"", ",", 
              RowBox[{"Sequence", "@@", "vars"}], ",", "\"\< \>\"", ",", "s", 
              ",", "\"\<)\>\""}], "}"}]}], ",", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<(\>\"", ",", "\"\<(\>\"", ",", "\"\<\[Lambda]\>\"", ",", 
              "\"\<.\>\"", ",", 
              RowBox[{"Sequence", "@@", "vars"}], ",", "\"\< \>\"", ",", "s", 
              ",", "\"\<)\>\"", ",", "val", ",", "\"\<)\>\""}], "}"}]}]}], 
          "]"}], ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<detailed\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"val", "===", "Nothing"}], ",", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<(\>\"", ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{"\"\<\[Lambda]\>\"", ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<Takes\\nparameters\>\""}],
                  "]"}]}], "]"}], ",", 
              RowBox[{"Overscript", "[", 
               RowBox[{"\"\<.\>\"", ",", 
                RowBox[{"Overscript", "[", 
                 RowBox[{
                 "\[OverBrace]", ",", "\"\<End of\\nparameter\\nlist\>\""}], 
                 "]"}]}], "]"}], ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{
                RowBox[{"Row", "@", "vars"}], ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<Parameter\\nnames\>\""}], 
                 "]"}]}], "]"}], ",", "\"\< \>\"", ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{"s", ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<function\\nbody\>\""}], 
                 "]"}]}], "]"}], ",", "\"\<)\>\""}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<(\>\"", ",", "\"\<(\>\"", ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{"\"\<\[Lambda]\>\"", ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<Takes\\nparameters\>\""}],
                  "]"}]}], "]"}], ",", 
              RowBox[{"Overscript", "[", 
               RowBox[{"\"\<.\>\"", ",", 
                RowBox[{"Overscript", "[", 
                 RowBox[{
                 "\[OverBrace]", ",", "\"\<End of\\nparameter\\nlist\>\""}], 
                 "]"}]}], "]"}], ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{
                RowBox[{"Row", "@", "vars"}], ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<Parameter\\nnames\>\""}], 
                 "]"}]}], "]"}], ",", "\"\< \>\"", ",", 
              RowBox[{"Underscript", "[", 
               RowBox[{"s", ",", 
                RowBox[{"Underscript", "[", 
                 RowBox[{"\[UnderBrace]", ",", "\"\<function\\nbody\>\""}], 
                 "]"}]}], "]"}], ",", "\"\<)\>\"", ",", 
              RowBox[{"Overscript", "[", 
               RowBox[{"val", ",", 
                RowBox[{"Overscript", "[", 
                 RowBox[{"\[OverBrace]", ",", "\"\<Argument\\nlist\>\""}], 
                 "]"}]}], "]"}], ",", "\"\<)\>\""}], "}"}]}]}], "]"}], 
         ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<value\>\"", "\[Rule]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"val", "=!=", "Nothing"}], ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"func", "[", 
             RowBox[{"Sequence", "@@", "vars"}], "]"}], "/.", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"vars", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
               RowBox[{"val", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"i", ",", "1", ",", 
                RowBox[{"Length", "@", "vars"}]}], "}"}]}], "]"}]}], ")"}], 
          ",", "Nothing"}], "]"}]}]}], "\[IndentingNewLine]", "|>"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.721714032970881*^9, 3.721714117365961*^9}, {
   3.721714187512929*^9, 3.721714191303487*^9}, {3.721714239185813*^9, 
   3.721714254924555*^9}, {3.721714300072565*^9, 3.721714328029702*^9}, {
   3.721714362906291*^9, 3.721714432400906*^9}, {3.721714858027281*^9, 
   3.721714936386241*^9}, {3.721714971825062*^9, 3.721714976076748*^9}, {
   3.721715128678108*^9, 3.721715168727923*^9}, 3.721715717926709*^9, {
   3.7217157596884003`*^9, 3.721715773244462*^9}, {3.72171588921419*^9, 
   3.721715961609579*^9}, {3.721716047068808*^9, 3.7217160863991833`*^9}, {
   3.721716143225855*^9, 3.721716144914268*^9}, {3.721716216173518*^9, 
   3.721716384872589*^9}, {3.721716421640243*^9, 3.7217164650537786`*^9}, {
   3.721716516288795*^9, 3.72171651680554*^9}, {3.721716551255007*^9, 
   3.721716567969002*^9}, {3.721716646199212*^9, 3.7217167437049522`*^9}, 
   3.721716844216899*^9, {3.7217169286386023`*^9, 3.721716947346908*^9}, {
   3.7217178336620703`*^9, 3.72171783380748*^9}, {3.721723013022931*^9, 
   3.721723045423552*^9}, {3.721723085306816*^9, 
   3.7217230983568087`*^9}},ExpressionUUID->"69231695-5c2f-4470-9a1b-\
497c58ec00a7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myLambda", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#1", "+", "2"}], ")"}], "&"}], ")"}], ",", 
   RowBox[{"Row", "@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<+\>\"", ",", "\"\<(\>\"", ",", "z", ",", "\"\<,\>\"", ",", "2", 
      ",", "\"\<)\>\""}], "}"}]}], ",", 
   RowBox[{"{", "z", "}"}], ",", "Nothing"}], "]"}]], "Input",
 CellChangeTimes->{{3.721723075022995*^9, 
  3.721723075967856*^9}},ExpressionUUID->"0f2da2c3-8b46-45bc-acc7-\
ca41caafa277"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"\[Lambda]\"","\".\"","z","\" \"",
      TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "2", "\")\""}, 
       "RowDefault"],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"z"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "2", "\")\""}, 
        "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "Nothing"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.721723100385717*^9},ExpressionUUID->"3e7d13ed-0057-4109-ae36-\
57ac64a469d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"myLambda", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#1", "+", "2"}], ")"}], "&"}], ")"}], ",", 
    RowBox[{"Row", "@", 
     RowBox[{"{", 
      RowBox[{
      "\"\<+\>\"", ",", "\"\<(\>\"", ",", "z", ",", "\"\<,\>\"", ",", "2", 
       ",", "\"\<)\>\""}], "}"}]}], ",", 
    RowBox[{"{", "z", "}"}], ",", 
    RowBox[{"{", "32", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.721722899569365*^9, 3.721722924255624*^9}, {
  3.721723058867776*^9, 
  3.7217230600365133`*^9}},ExpressionUUID->"1d1e6320-0818-4fbc-9483-\
0e63de6bafaa"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"(\"","\"\[Lambda]\"","\".\"","z","\" \"",
      TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "2", "\")\""}, 
       "RowDefault"],"\")\"",RowBox[{"{", "32", "}"}],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"","\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"z"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "2", "\")\""}, 
        "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\"",
      OverscriptBox[
       RowBox[{"{", "32", "}"}], 
       OverscriptBox["\[OverBrace]", "\"Argument\\nlist\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "34"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.721722925159191*^9, {3.721723052489655*^9, 3.7217230603337193`*^9}, 
   3.721723110386179*^9},ExpressionUUID->"25a6bb27-f3fc-4c1c-8d17-\
7f633023a415"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"myLambda", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#1", "+", "#2"}], ")"}], "&"}], ")"}], ",", 
    RowBox[{"Row", "@", 
     RowBox[{"{", 
      RowBox[{
      "\"\<+\>\"", ",", "\"\<(\>\"", ",", "z", ",", "\"\<,\>\"", ",", "d", 
       ",", "\"\<)\>\""}], "}"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", "d"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.721713671113215*^9, 3.721713671658482*^9}, {
   3.721714124837566*^9, 3.721714138326043*^9}, {3.7217143448604393`*^9, 
   3.721714346559026*^9}, 3.721714399965269*^9, {3.7217144375645533`*^9, 
   3.721714438418955*^9}, {3.721714951809943*^9, 3.721714954542439*^9}, {
   3.721715198193554*^9, 3.721715202051238*^9}, {3.721715547281336*^9, 
   3.721715574506187*^9}, {3.7217156742980433`*^9, 3.721715674713788*^9}, {
   3.7217157772608957`*^9, 3.7217158174131937`*^9}, {3.721715992009857*^9, 
   3.7217160004683*^9}, {3.721716161541057*^9, 3.7217161862120333`*^9}, {
   3.7217166839183693`*^9, 3.721716683996872*^9}, {3.72172311490565*^9, 
   3.721723117515147*^9}},ExpressionUUID->"988c7b51-155a-4d72-8a5d-\
6fde8bc0751c"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"(\"","\"\[Lambda]\"","\".\"","z","d","\" \"",
      TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "d", "\")\""}, 
       "RowDefault"],"\")\"",RowBox[{"{", 
        RowBox[{"3", ",", "2"}], "}"}],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"","\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"z", "d"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "d", "\")\""}, 
        "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\"",
      OverscriptBox[
       RowBox[{"{", 
         RowBox[{"3", ",", "2"}], "}"}], 
       OverscriptBox["\[OverBrace]", "\"Argument\\nlist\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "5"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.72171600102601*^9, {3.721716151189561*^9, 3.721716186671726*^9}, 
   3.72171621951026*^9, 3.721716255642867*^9, 3.721716313389681*^9, {
   3.721716358607012*^9, 3.721716387254346*^9}, {3.721716449281946*^9, 
   3.721716467354631*^9}, 3.72171651905527*^9, {3.7217165549866247`*^9, 
   3.721716572087573*^9}, {3.7217166695687857`*^9, 3.7217166843218718`*^9}, 
   3.721716747010022*^9, {3.721716937361388*^9, 3.721716949393696*^9}, 
   3.721717837634987*^9, 
   3.721723117821165*^9},ExpressionUUID->"805e0380-3e75-478a-a96a-\
869d31708f2b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myLambda", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#1", "+", "#2"}], ")"}], "&"}], ")"}], ",", 
   RowBox[{"Row", "@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<+\>\"", ",", "\"\<(\>\"", ",", "z", ",", "\"\<,\>\"", ",", "d", 
      ",", "\"\<)\>\""}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "u"}], "}"}], ",", "Nothing"}], "]"}]], "Input",
 CellChangeTimes->{{3.721714475523293*^9, 3.721714572861968*^9}, {
   3.721714714809216*^9, 3.721714799793386*^9}, {3.721715603579506*^9, 
   3.721715606063435*^9}, {3.721715638487404*^9, 3.721715641637434*^9}, {
   3.721715874419868*^9, 3.7217158763204327`*^9}, {3.721715980894081*^9, 
   3.721715981567492*^9}, 
   3.721716875964718*^9},ExpressionUUID->"9cc14902-8cd6-4623-9afc-\
585fcebb76dc"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"\[Lambda]\"","\".\"","z","u","\" \"",
      TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "d", "\")\""}, 
       "RowDefault"],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"z", "u"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{"\"+\"", "\"(\"", "z", "\",\"", "d", "\")\""}, 
        "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "Nothing"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.721714483796021*^9, 3.7217145732216787`*^9}, {
   3.721714720602229*^9, 3.7217147261365623`*^9}, {3.721714760481758*^9, 
   3.721714800171432*^9}, 3.7217155572518187`*^9, 3.7217156064715233`*^9, 
   3.7217156418778887`*^9, {3.721715976019926*^9, 3.7217159817849693`*^9}, 
   3.721716779813085*^9, {3.72171686139574*^9, 3.721716877314577*^9}, {
   3.7217169389826517`*^9, 3.721716950603545*^9}, 3.721717839583748*^9, 
   3.721723123788031*^9},ExpressionUUID->"81019e9c-8f50-4d8b-b595-\
f8d59a658b9d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myLambda", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#1", "+", 
       RowBox[{"(", 
        RowBox[{"#2", "*", "#3"}], ")"}]}], ")"}], "&"}], ")"}], ",", 
   RowBox[{"Row", "@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<+\>\"", ",", "\"\<(\>\"", ",", "x", ",", "\"\<,\>\"", ",", 
      "\"\<*\>\"", ",", "\"\<(\>\"", ",", "y", ",", "\"\<,\>\"", ",", "z", 
      ",", "\"\<)\>\"", ",", "\"\<)\>\""}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.721723208385133*^9, 
  3.721723303517715*^9}},ExpressionUUID->"af91dee5-fa0e-459f-a31a-\
9ec7bf5b376e"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"(\"","\"\[Lambda]\"","\".\"","x","y","z","\" \"",
      TemplateBox[{
       "\"+\"", "\"(\"", "x", "\",\"", "\"*\"", "\"(\"", "y", "\",\"", "z", 
        "\")\"", "\")\""}, "RowDefault"],"\")\"",RowBox[{"{", 
        RowBox[{"1", ",", "2", ",", "3"}], "}"}],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"","\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"x", "y", "z"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{
        "\"+\"", "\"(\"", "x", "\",\"", "\"*\"", "\"(\"", "y", "\",\"", "z", 
         "\")\"", "\")\""}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\"",
      OverscriptBox[
       RowBox[{"{", 
         RowBox[{"1", ",", "2", ",", "3"}], "}"}], 
       OverscriptBox["\[OverBrace]", "\"Argument\\nlist\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "7"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.721723281144146*^9, 
  3.721723303895215*^9}},ExpressionUUID->"2071d474-13dc-4e66-b7fe-\
1d1dcabf32b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myLambda", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#1", "+", 
       RowBox[{"(", 
        RowBox[{"#2", "*", "#3"}], ")"}]}], ")"}], "&"}], ")"}], ",", 
   RowBox[{"Row", "@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<+\>\"", ",", "\"\<(\>\"", ",", "x", ",", "\"\<,\>\"", ",", 
      "\"\<*\>\"", ",", "\"\<(\>\"", ",", "y", ",", "\"\<,\>\"", ",", "z", 
      ",", "\"\<)\>\"", ",", "\"\<)\>\""}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", "Nothing"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.721723324523086*^9, 
  3.721723325298674*^9}},ExpressionUUID->"7b3cff95-ff78-44cd-a584-\
8348786f2378"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"\[Lambda]\"\>", "\[Rule]", 
    TemplateBox[{
     "\"(\"","\"\[Lambda]\"","\".\"","x","y","z","\" \"",
      TemplateBox[{
       "\"+\"", "\"(\"", "x", "\",\"", "\"*\"", "\"(\"", "y", "\",\"", "z", 
        "\")\"", "\")\""}, "RowDefault"],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"detailed\"\>", "\[Rule]", 
    TemplateBox[{"\"(\"",UnderscriptBox["\"\[Lambda]\"", 
       UnderscriptBox["\[UnderBrace]", "\"Takes\\nparameters\""]],
      OverscriptBox["\".\"", 
       OverscriptBox["\[OverBrace]", "\"End of\\nparameter\\nlist\""]],
      UnderscriptBox[
       TemplateBox[{"x", "y", "z"}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"Parameter\\nnames\""]],"\" \"",
      UnderscriptBox[
       TemplateBox[{
        "\"+\"", "\"(\"", "x", "\",\"", "\"*\"", "\"(\"", "y", "\",\"", "z", 
         "\")\"", "\")\""}, "RowDefault"], 
       UnderscriptBox["\[UnderBrace]", "\"function\\nbody\""]],"\")\""},
     "RowDefault"]}], ",", 
   RowBox[{"\<\"value\"\>", "\[Rule]", "Nothing"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.7217233259354773`*^9},ExpressionUUID->"2d15b6ae-c0c3-4408-9951-\
011a4b2afca8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TreeForm", "[", 
    RowBox[{
     RowBox[{"lambda", "[", 
      RowBox[{"\"\<xy\\nParameter\\nlist\>\"", ",", 
       RowBox[{"Times", "[", 
        RowBox[{
         RowBox[{"Plus", "[", 
          RowBox[{"1", ",", "\"\<x\\nvariable\>\""}], "]"}], ",", 
         "\"\<y\\nvariable\>\""}], "]"}]}], "]"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", "0.7"}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
     RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
     RowBox[{
     "lambda", "\[Rule]", 
      "\"\<\[Lambda]: takes at least\\none parameter\>\""}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "400"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.721717881514021*^9, 3.7217179443090477`*^9}, {
  3.7217179888269653`*^9, 3.721718105322995*^9}, {3.7217181708917294`*^9, 
  3.721718173207761*^9}, {3.7217182288103657`*^9, 3.7217183083821573`*^9}, {
  3.721718339894662*^9, 3.721718400783193*^9}, {3.721718481425417*^9, 
  3.7217184890289297`*^9}, {3.7217185378003473`*^9, 3.721718552931102*^9}, {
  3.7217185851932573`*^9, 3.721718658268512*^9}, {3.72171870420483*^9, 
  3.721718716916999*^9}, {3.7217188023173532`*^9, 3.721718855337433*^9}, {
  3.7217189162710857`*^9, 3.721718922145914*^9}, {3.721718986556875*^9, 
  3.721719026985608*^9}, {3.721719154394219*^9, 3.721719158682927*^9}, {
  3.7217192834672832`*^9, 3.7217193306697893`*^9}, {3.721719402659486*^9, 
  3.721719556275422*^9}, {3.721719625388089*^9, 
  3.721719818297756*^9}},ExpressionUUID->"d836d64f-2ddf-4092-b517-\
cc82d92b9f1e"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{0.4472135954999579, 2.6832815729997477`}, {0., 
    1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
    0.4472135954999579, 0.894427190999916}, {0., 0.}, {0.8944271909999159, 
    0.}, {1.3416407864998738`, 0.894427190999916}}, {
     {RGBColor[0.55, 0.45, 0.45], 
      LineBox[{{1, 2}, {1, 3}, {3, 4}, {3, 7}, {4, 5}, {4, 6}}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          
          StyleBox["\<\"\[Lambda]: takes at least\\none parameter\"\>", 
           "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 1],
        TagBox[
         RowBox[{"\"\[Lambda]: takes at least\\none parameter\"", "[", 
           RowBox[{"\"xy\\nParameter\\nlist\"", ",", 
             RowBox[{"\"*\"", "[", 
               RowBox[{
                 RowBox[{"\"+\"", "[", 
                   RowBox[{"1", ",", "\"x\\nvariable\""}], "]"}], ",", 
                 "\"y\\nvariable\""}], "]"}]}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "\[Lambda]: takes at least\none parameter"["xy\nParameter\nlist", 
          "*"[
           "+"[1, "x\nvariable"], "y\nvariable"]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"xy\\nParameter\\nlist\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 2],
        TagBox["\"xy\\nParameter\\nlist\"", HoldForm]],
       Annotation[#, 
        HoldForm["xy\nParameter\nlist"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"*\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 3],
        TagBox[
         RowBox[{"\"*\"", "[", 
           RowBox[{
             RowBox[{"\"+\"", "[", 
               RowBox[{"1", ",", "\"x\\nvariable\""}], "]"}], ",", 
             "\"y\\nvariable\""}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "*"[
          "+"[1, "x\nvariable"], "y\nvariable"]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"+\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 4],
        TagBox[
         RowBox[{"\"+\"", "[", 
           RowBox[{"1", ",", "\"x\\nvariable\""}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "+"[1, "x\nvariable"]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 5],
        TagBox["1", HoldForm]],
       Annotation[#, 
        HoldForm[1], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"x\\nvariable\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 6],
        TagBox["\"x\\nvariable\"", HoldForm]],
       Annotation[#, 
        HoldForm["x\nvariable"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"y\\nvariable\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.025806451612903226`],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 7],
        TagBox["\"y\\nvariable\"", HoldForm]],
       Annotation[#, 
        HoldForm["y\nvariable"], "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{0.4472135954999579, 2.6832815729997477`}, {0., 
     1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
     0.4472135954999579, 0.894427190999916}, {0., 0.}, {0.8944271909999159, 
     0.}, {1.3416407864998738`, 0.894427190999916}}]& ],
  AspectRatio->0.7,
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.7217194930451603`*^9, {3.721719526582193*^9, 3.72171955667846*^9}, {
   3.72171964027468*^9, 3.721719702158325*^9}, {3.7217197353846903`*^9, 
   3.721719818628158*^9}},ExpressionUUID->"9604d95f-41c5-4e4b-8aaf-\
fd74674c1a44"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"vars", "=", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TreeForm", "[", 
     RowBox[{
      RowBox[{"lambda", "[", 
       RowBox[{
        RowBox[{"ToString", "@", 
         RowBox[{"Row", "@", "vars"}]}], ",", 
        RowBox[{"Times", "[", 
         RowBox[{
          RowBox[{"Plus", "[", 
           RowBox[{
            RowBox[{"vars", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"vars", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"vars", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
      RowBox[{"AspectRatio", "\[Rule]", "0.7"}]}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
      RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
      RowBox[{"lambda", "\[Rule]", "\"\<\[Lambda]\>\""}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "400"}]}], "}"}]}]}]}]], "Input",
 CellChangeTimes->{{3.721723434675686*^9, 
  3.721723568127996*^9}},ExpressionUUID->"a5ae6dc3-eaea-4395-bb22-\
0992b15bb187"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{0.4472135954999579, 2.6832815729997477`}, {0., 
    1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
    0.4472135954999579, 0.894427190999916}, {0., 0.}, {0.8944271909999159, 
    0.}, {1.3416407864998738`, 0.894427190999916}}, {
     {RGBColor[0.55, 0.45, 0.45], 
      LineBox[{{1, 2}, {1, 3}, {3, 4}, {3, 7}, {4, 5}, {4, 6}}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"\[Lambda]\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 1],
        TagBox[
         RowBox[{"\"\[Lambda]\"", "[", 
           RowBox[{"\"xyz\"", ",", 
             RowBox[{"\"*\"", "[", 
               RowBox[{
                 RowBox[{"\"+\"", "[", 
                   RowBox[{"x", ",", "y"}], "]"}], ",", "z"}], "]"}]}], "]"}],
          HoldForm]],
       Annotation[#, 
        HoldForm[
         "\[Lambda]"["xyz", 
          "*"[
           "+"[$CellContext`x, $CellContext`y], $CellContext`z]]], 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"xyz\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 2],
        TagBox["\"xyz\"", HoldForm]],
       Annotation[#, 
        HoldForm["xyz"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"*\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 3],
        TagBox[
         RowBox[{"\"*\"", "[", 
           RowBox[{
             RowBox[{"\"+\"", "[", 
               RowBox[{"x", ",", "y"}], "]"}], ",", "z"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "*"[
          "+"[$CellContext`x, $CellContext`y], $CellContext`z]], 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"+\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 4],
        TagBox[
         RowBox[{"\"+\"", "[", 
           RowBox[{"x", ",", "y"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "+"[$CellContext`x, $CellContext`y]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["x",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 5],
        TagBox["x", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`x], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["y",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 6],
        TagBox["y", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`y], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["z",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 7],
        TagBox["z", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`z], "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{0.4472135954999579, 2.6832815729997477`}, {0., 
     1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
     0.4472135954999579, 0.894427190999916}, {0., 0.}, {0.8944271909999159, 
     0.}, {1.3416407864998738`, 0.894427190999916}}]& ],
  AspectRatio->0.7,
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{{3.72172350958493*^9, 
  3.721723568781888*^9}},ExpressionUUID->"a741c291-2726-4af6-8c79-\
075e6bad0ec1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"vars", "=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TreeForm", "[", 
   RowBox[{
    RowBox[{"lambda", "[", 
     RowBox[{
      RowBox[{"ToString", "@", 
       RowBox[{"Row", "@", "vars"}]}], ",", 
      RowBox[{"Plus", "[", 
       RowBox[{
        RowBox[{"vars", "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{"vars", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
    RowBox[{"AspectRatio", "\[Rule]", "0.7"}]}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
    RowBox[{"lambda", "\[Rule]", "\"\<\[Lambda]\>\""}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.721734380295082*^9, 
  3.721734410885591*^9}},ExpressionUUID->"be297c74-abb5-4817-86e9-\
9406c97a147f"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{0.4472135954999579, 1.7888543819998317`}, {0., 
    0.8944271909999159}, {0.8944271909999159, 0.8944271909999159}, {
    0.4472135954999579, 0.}, {1.3416407864998738`, 0.}}, {
     {RGBColor[0.55, 0.45, 0.45], LineBox[{{1, 2}, {1, 3}, {3, 4}, {3, 5}}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"\[Lambda]\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 1],
        TagBox[
         RowBox[{"\"\[Lambda]\"", "[", 
           RowBox[{"\"xyz\"", ",", 
             RowBox[{"\"+\"", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "\[Lambda]"["xyz", 
          "+"[$CellContext`x, $CellContext`y]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"xyz\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 2],
        TagBox["\"xyz\"", HoldForm]],
       Annotation[#, 
        HoldForm["xyz"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"+\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 3],
        TagBox[
         RowBox[{"\"+\"", "[", 
           RowBox[{"x", ",", "y"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "+"[$CellContext`x, $CellContext`y]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["x",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 4],
        TagBox["x", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`x], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["y",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 5],
        TagBox["y", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`y], "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{0.4472135954999579, 1.7888543819998317`}, {0., 
     0.8944271909999159}, {0.8944271909999159, 0.8944271909999159}, {
     0.4472135954999579, 0.}, {1.3416407864998738`, 0.}}]& ],
  AspectRatio->0.7,
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{{3.721734406120872*^9, 
  3.721734411185841*^9}},ExpressionUUID->"af550f4f-199f-45ab-825a-\
e346f4f88f48"]
}, Open  ]]
},
WindowSize->{1183, 991},
WindowMargins->{{Automatic, 159}, {177, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1292, 32, 94, "Input",ExpressionUUID->"11478f6b-82f2-4259-be51-e2cbaba2651b"],
Cell[1853, 54, 6207, 130, 409, "Input",ExpressionUUID->"69231695-5c2f-4470-9a1b-497c58ec00a7"],
Cell[CellGroupData[{
Cell[8085, 188, 520, 15, 30, "Input",ExpressionUUID->"0f2da2c3-8b46-45bc-acc7-ca41caafa277"],
Cell[8608, 205, 1112, 26, 114, "Output",ExpressionUUID->"3e7d13ed-0057-4109-ae36-57ac64a469d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9757, 236, 638, 18, 52, "Input",ExpressionUUID->"1d1e6320-0818-4fbc-9483-0e63de6bafaa"],
Cell[10398, 256, 1355, 30, 114, "Output",ExpressionUUID->"25a6bb27-f3fc-4c1c-8d17-7f633023a415"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11790, 291, 1260, 28, 52, "Input",ExpressionUUID->"988c7b51-155a-4d72-8a5d-6fde8bc0751c"],
Cell[13053, 321, 1807, 38, 114, "Output",ExpressionUUID->"805e0380-3e75-478a-a96a-869d31708f2b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14897, 364, 817, 20, 30, "Input",ExpressionUUID->"9cc14902-8cd6-4623-9afc-585fcebb76dc"],
Cell[15717, 386, 1541, 31, 114, "Output",ExpressionUUID->"81019e9c-8f50-4d8b-b595-f8d59a658b9d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17295, 422, 756, 21, 30, "Input",ExpressionUUID->"af91dee5-fa0e-459f-a31a-9ec7bf5b376e"],
Cell[18054, 445, 1500, 33, 114, "Output",ExpressionUUID->"2071d474-13dc-4e66-b7fe-1d1dcabf32b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19591, 483, 706, 20, 30, "Input",ExpressionUUID->"7b3cff95-ff78-44cd-a584-8348786f2378"],
Cell[20300, 505, 1233, 28, 114, "Output",ExpressionUUID->"2d15b6ae-c0c3-4408-9951-011a4b2afca8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21570, 538, 1630, 33, 73, "Input",ExpressionUUID->"d836d64f-2ddf-4092-b517-cc82d92b9f1e"],
Cell[23203, 573, 6578, 171, 280, "Output",ExpressionUUID->"9604d95f-41c5-4e4b-8aaf-fd74674c1a44"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29818, 749, 1229, 34, 94, "Input",ExpressionUUID->"a5ae6dc3-eaea-4395-bb22-0992b15bb187"],
Cell[31050, 785, 6042, 168, 280, "Output",ExpressionUUID->"a741c291-2726-4af6-8c79-075e6bad0ec1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37129, 958, 983, 28, 73, "Input",ExpressionUUID->"be297c74-abb5-4817-86e9-9406c97a147f"],
Cell[38115, 988, 4276, 117, 280, "Output",ExpressionUUID->"af550f4f-199f-45ab-825a-e346f4f88f48"]
}, Open  ]]
}
]
*)

