(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     58044,       1393]
NotebookOptionsPosition[     54063,       1333]
NotebookOutlinePosition[     54402,       1348]
CellTagsIndexPosition[     54359,       1345]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"\n", 
  RowBox[{
   RowBox[{
    RowBox[{"getbit", "[", "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", "x", "}"}], ",", "\n", " ", 
      RowBox[{
       RowBox[{"trouble", " ", "=", " ", "False"}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"atom", "@", " ", "tape"}], ",", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"trouble", " ", "=", " ", "True"}], ";", " ", 
           RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], ")"}]}], 
        "]"}], ";", "\n", " ", 
       RowBox[{"x", " ", "=", " ", 
        RowBox[{"car", "@", " ", "tape"}]}], ";", "\n", " ", 
       RowBox[{"tape", " ", "=", " ", 
        RowBox[{"cdr", "@", " ", "tape"}]}], ";", "\n", " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"x", " ", "===", " ", "0"}], ",", " ", "0", ",", " ", "1"}], 
        " ", "]"}]}]}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"getchar", "[", "]"}], " ", ":=", " ", 
    RowBox[{"FromCharacterCode", "[", "\n", "  ", 
     RowBox[{
      RowBox[{"128", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"64", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"32", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"16", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", "\n", "  ", 
      RowBox[{"8", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"4", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"2", "*", 
       RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
      RowBox[{"getbit", "[", "]"}]}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"getrecord", "[", "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"c", ",", " ", 
        RowBox[{"line", " ", "=", " ", "\"\<\>\""}], ",", " ", "str"}], " ", 
       "}"}], ",", "\n", " ", 
      RowBox[{
       RowBox[{"inputbuffer2", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\n", " ", 
       RowBox[{"While", "[", " ", 
        RowBox[{
         RowBox[{"\"\<\\n\>\"", " ", "=!=", " ", 
          RowBox[{"(", 
           RowBox[{"c", " ", "=", " ", 
            RowBox[{"getchar", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
         RowBox[{"line", " ", "=", " ", 
          RowBox[{"line", " ", "<>", " ", "c"}]}]}], " ", "]"}], ";", "\n", 
       " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{"trouble", ",", " ", 
         RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], "]"}], ";", 
       " ", 
       RowBox[{"(*", " ", 
        RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
        "keep", " ", "only", " ", "printable", " ", "ASCII", " ", "codes"}], 
        " ", "*)"}], "\n", " ", 
       RowBox[{"line", " ", "=", " ", 
        RowBox[{"FromCharacterCode", "@", "\n", " ", 
         RowBox[{"Cases", "[", " ", 
          RowBox[{
           RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
           RowBox[{"n_Integer", " ", "/;", " ", 
            RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], 
          " ", "]"}]}]}], ";", "\n", " ", 
       RowBox[{"str", " ", "=", " ", 
        RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
       RowBox[{"inputbuffer2", " ", "=", " ", 
        RowBox[{"ReadList", "[", 
         RowBox[{"str", ",", " ", "Word", ",", " ", 
          RowBox[{"TokenWords", "->", 
           RowBox[{"{", 
            RowBox[{"\"\<(\>\"", ",", " ", "\"\<)\>\""}], "}"}]}]}], "]"}]}], 
       ";", "\n", " ", 
       RowBox[{"Close", "@", " ", "str"}], ";", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
        "convert", " ", "strings", " ", "of", " ", "digits", " ", "to", " ", 
         "integers"}], " ", "*)"}], "\n", " ", 
       RowBox[{"inputbuffer2", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"DigitQ", "@", "#"}], ",", " ", 
            RowBox[{"ToExpression", "@", "#"}], ",", " ", "#"}], "]"}], "&"}],
          " ", "/@", " ", "inputbuffer2"}]}], " ", ";"}]}], "\n", "]"}]}], 
   "\n", " ", "\n", 
   RowBox[{
    RowBox[{"getexp", "[", 
     RowBox[{"rparenokay_:", "False"}], "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", " ", 
       RowBox[{"w", ",", " ", "d", ",", " ", 
        RowBox[{"l", " ", "=", " ", 
         RowBox[{"{", "}"}]}]}], " ", "}"}], ",", "\n", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{" ", 
          RowBox[{"supply", " ", "unlimited", " ", "number", " ", "of"}], " ",
           ")"}], "'"}], "s", " ", "if", " ", "tokens", " ", "run", " ", 
        "out"}], " ", "*)"}], "\n", " ", 
      RowBox[{
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"inputbuffer2", " ", "==", " ", 
          RowBox[{"{", "}"}]}], ",", " ", 
         RowBox[{"w", " ", "=", " ", "\"\<)\>\""}], ",", "\n", " ", 
         RowBox[{
          RowBox[{"w", " ", "=", " ", 
           RowBox[{"First", "@", " ", "inputbuffer2"}]}], ";", "\n", " ", 
          RowBox[{"inputbuffer2", " ", "=", " ", 
           RowBox[{"Rest", "@", " ", "inputbuffer2"}]}]}]}], " ", "]"}], ";", 
       "\n", " ", 
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", ",", 
         "\n", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"While", "[", " ", 
            RowBox[{
             RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
              RowBox[{"(", 
               RowBox[{"d", " ", "=", " ", 
                RowBox[{"getexp", "[", "True", "]"}]}], ")"}]}], ",", "\n", 
             " ", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", "\n", 
           " ", 
           RowBox[{"Return", "@", " ", "l"}]}], "\n", ")"}], ",", "\n", " ", 
         "_", ",", " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], "\n", " ",
    "\n", 
   RowBox[{
    RowBox[{"atom", "[", "x_", "]"}], " ", ":=", "\n", " ", 
    RowBox[{"MatchQ", "[", " ", 
     RowBox[{"x", ",", " ", 
      RowBox[{
       RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], " ", "]"}]}], 
   "\n", 
   RowBox[{
    RowBox[{"car", "[", "x_", "]"}], " ", ":=", "\n", " ", 
    RowBox[{"If", "[", " ", 
     RowBox[{
      RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
      RowBox[{"First", "@", " ", "x"}]}], " ", "]"}]}], "\n", 
   RowBox[{
    RowBox[{"cdr", "[", "x_", "]"}], " ", ":=", "\n", " ", 
    RowBox[{"If", "[", " ", 
     RowBox[{
      RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
      RowBox[{"Rest", "@", " ", "x"}]}], " ", "]"}]}], "\n", 
   RowBox[{
    RowBox[{"cons", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", "\n", " ", 
    RowBox[{"If", "[", " ", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{"y", ",", 
        RowBox[{"_String", "|", "_Integer"}]}], "]"}], ",", " ", "x", ",", 
      " ", 
      RowBox[{"Prepend", "[", 
       RowBox[{"y", ",", "x"}], "]"}]}], " ", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"eval", "[", 
     RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
    "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
        RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", "args", 
        ",", " ", "x", ",", " ", "y", ",", " ", "z"}], "}"}], ",", "\n", " ", 
      
      RowBox[{
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
         RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", "\n", " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"atom", "@", " ", "e"}], ",", " ", 
         RowBox[{"Block", "[", " ", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", 
           "   ", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", "a"}], 
            ";", "\n", "   ", 
            RowBox[{"pos", " ", "=", " ", 
             RowBox[{"Position", "[", 
              RowBox[{"names", ",", "e", ",", 
               RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", "   ", 
            RowBox[{"Return", "@", " ", 
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"pos", " ", "==", " ", 
                RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
               RowBox[{"values", "[", 
                RowBox[{"[", 
                 RowBox[{"pos", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], " ",
               "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";", "\n", " ", 
       RowBox[{"f", " ", "=", " ", 
        RowBox[{"eval", "[", 
         RowBox[{
          RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], ";", 
       "\n", " ", 
       RowBox[{"e", " ", "=", " ", 
        RowBox[{"cdr", "@", " ", "e"}]}], ";", "\n", " ", 
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"car", "@", " ", "e"}]}], ",", "\n", " ", "\"\<if\>\"", ",",
          " ", 
         RowBox[{"Return", "@", "\n", " ", 
          RowBox[{"If", "[", "\n", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"eval", "[", 
              RowBox[{
               RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}], 
             " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", 
               RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], "]"}], 
            ",", "\n", " ", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", 
               RowBox[{"cdr", "@", 
                RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
             "]"}]}], "\n", " ", "]"}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
       
       RowBox[{"args", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"eval", "[", 
           RowBox[{"#", ",", "a", ",", "d"}], "]"}], "&"}], " ", "/@", " ", 
         "e"}]}], ";", "\n", " ", 
       RowBox[{"x", " ", "=", " ", 
        RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
       RowBox[{"y", " ", "=", " ", 
        RowBox[{"car", "@", 
         RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
       RowBox[{"z", " ", "=", " ", 
        RowBox[{"car", "@", 
         RowBox[{"cdr", "@", 
          RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", " ", 
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"f", ",", "\n", " ", "\"\<read-bit\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", "\"\<read-exp\>\"", 
         ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"getrecord", "[", "]"}], ";", " ", 
            RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
         "\"\<bits\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"Flatten", "[", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", " ", 
              RowBox[{"Rest", "@", " ", 
               RowBox[{"IntegerDigits", "[", 
                RowBox[{
                 RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
            "                            ", 
            RowBox[{"ToCharacterCode", "[", " ", 
             RowBox[{
              RowBox[{"output", "@", "x"}], " ", "<>", " ", "\"\<\\n\>\""}], 
             " ", "]"}]}], " ", "]"}]}], ",", "\n", " ", "\"\<car\>\"", ",", 
         " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"", 
         ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"cdr", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cons\>\"", 
         ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"cons", "[", 
           RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", "\"\<size\>\"", 
         ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"StringLength", "@", " ", 
           RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
         "\"\<length\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", "\"\<+\>\"", 
         ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
            RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", "\"\<-\>\"",
          ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
             RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
             RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
         "\"\<*\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
            RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", "\"\<^\>\"",
          ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
            RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", "\"\<<\>\"",
          ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
             RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", " ", 
            "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
             RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", " ", 
            "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"", ",", 
         " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
             RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", " ", 
            "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"", ",", 
         " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
             RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", " ", 
            "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<base10-to-2\>\"",
          ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"IntegerDigits", "[", 
           RowBox[{
            RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", "\n", 
         " ", "\"\<base2-to-10\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"Fold", "[", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", "#1"}], " ", "+", " ", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}], 
              ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}], ",",
          "\n", " ", "\"\<append\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"Join", "[", " ", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"atom", "@", "x"}], ",", 
              RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"atom", "@", "y"}], ",", 
              RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
         "\n", " ", "\"\<atom\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", ",", 
            " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", "\"\<=\>\"",
          ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"", 
            ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
         "\"\<display\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"AppendTo", "[", 
             RowBox[{"out", ",", "x"}], "]"}], ";", "\n", "               ", 
            RowBox[{"If", "[", " ", 
             RowBox[{"display", ",", " ", 
              RowBox[{"print", "[", " ", 
               RowBox[{"\"\<display\>\"", ",", " ", 
                RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", "]"}],
             ";", "\n", "               ", "x"}], ")"}]}], ",", "\n", " ", 
         "\"\<debug\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"print", "[", " ", 
             RowBox[{"\"\<debug\>\"", ",", " ", 
              RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
            "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", "\n", 
       " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
         RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", "]"}], 
       ";", "\n", " ", 
       RowBox[{"d", "--"}], ";", "\n", " ", 
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"eval", "[", 
           RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", " ", 
         "\"\<try\>\"", ",", " ", 
         RowBox[{"Return", "@", "\n", " ", 
          RowBox[{"Block", "[", " ", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"out", " ", "=", " ", 
               RowBox[{"{", "}"}]}], ",", " ", 
              RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
              RowBox[{"display", " ", "=", " ", "False"}], ",", " ", "xx"}], 
             "}"}], ",", "\n", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], ",", 
               " ", 
               RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
               RowBox[{"xx", " ", "=", " ", 
                RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n", 
             " ", 
             RowBox[{
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                RowBox[{
                 RowBox[{"Catch", "@", " ", 
                  RowBox[{"{", 
                   RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                 RowBox[{
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                 " ", 
                RowBox[{
                 RowBox[{"Catch", "@", " ", 
                  RowBox[{"{", 
                   RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                    "}"}]}], " ", "//", "\n", " ", 
                 RowBox[{
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                   "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
              " ", 
              RowBox[{
               RowBox[{"If", "[", " ", 
                RowBox[{
                 RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], ",", 
                 " ", 
                 RowBox[{"{", 
                  RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                 ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
           "]"}]}]}], " ", 
        RowBox[{"(*", " ", 
         RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], ";", 
       " ", 
       RowBox[{"(*", " ", 
        RowBox[{"end", " ", "switch"}], " ", "*)"}], "\n", " ", 
       RowBox[{"f", " ", "=", " ", 
        RowBox[{"cdr", "@", " ", "f"}]}], ";", "\n", " ", 
       RowBox[{"eval", "[", " ", 
        RowBox[{
         RowBox[{"car", "@", 
          RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
         RowBox[{"bind", "[", 
          RowBox[{
           RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], "]"}], 
         ",", " ", "d"}], " ", "]"}]}]}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"nmb", "[", "n_Integer", "]"}], " ", ":=", " ", "n"}], "\n", 
   RowBox[{
    RowBox[{"nmb", "[", "_", "]"}], " ", ":=", " ", "0"}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"bind", "[", 
     RowBox[{
      RowBox[{"vars_", "?", "atom"}], ",", "args_", ",", "a_"}], "]"}], " ", ":=",
     "\n", " ", "a"}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"bind", "[", 
     RowBox[{"vars_", ",", "args_", ",", "a_"}], "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
        RowBox[{"bind", "[", " ", 
         RowBox[{
          RowBox[{"cdr", "@", " ", "vars"}], ",", " ", 
          RowBox[{"cdr", "@", " ", "args"}], ",", " ", "a"}], " ", "]"}]}], 
       ";", "\n", " ", 
       RowBox[{"pos", " ", "=", " ", 
        RowBox[{"Position", "[", 
         RowBox[{"names", ",", " ", 
          RowBox[{"car", "@", " ", "vars"}], ",", " ", 
          RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{
           RowBox[{"Delete", "[", 
            RowBox[{"names", ",", "pos"}], "]"}], ",", " ", 
           RowBox[{"car", "@", " ", "vars"}]}], "]"}], ",", "\n", "  ", 
         RowBox[{"Prepend", "[", 
          RowBox[{
           RowBox[{"Delete", "[", 
            RowBox[{"values", ",", "pos"}], "]"}], ",", " ", 
           RowBox[{"car", "@", " ", "args"}]}], "]"}]}], "}"}]}]}], "\n", 
     "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"eval", "[", "e_", "]"}], " ", ":=", "\n", 
    RowBox[{"(", "\n", " ", 
     RowBox[{
      RowBox[{"out", " ", "=", " ", 
       RowBox[{"tape", " ", "=", " ", 
        RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
      RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", " ", 
      RowBox[{"print", "[", " ", 
       RowBox[{"\"\<expression\>\"", ",", " ", 
        RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";", "\n", " ", 
      RowBox[{"Catch", "[", " ", 
       RowBox[{"eval", "[", " ", 
        RowBox[{"e", ",", " ", 
         RowBox[{"{", 
          RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], " ", 
        "]"}], " ", "]"}]}], "\n", ")"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"eval", "[", 
     RowBox[{"e_", ",", "Null", ",", "d_"}], "]"}], " ", ":=", " ", 
    RowBox[{"eval", "[", 
     RowBox[{"e", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", "\"\<nil\>\"", "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "d"}], "]"}]}], "\n", " ", 
   "\n", 
   RowBox[{
    RowBox[{"run", "[", "fn_", "]"}], " ", ":=", " ", 
    RowBox[{"run", "[", 
     RowBox[{"fn", ",", " ", "\"\<lisp.m\>\"", ",", " ", "\"\<.r\>\""}], 
     "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"word2", "[", "]"}], ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"w", ",", "line", ",", "str"}], "}"}], ",", "\n", 
      RowBox[{
       RowBox[{"While", "[", "\n", " ", 
        RowBox[{
         RowBox[{"inputbuffer", " ", "==", " ", 
          RowBox[{"{", "}"}]}], ",", "\n", " ", 
         RowBox[{
          RowBox[{"line", " ", "=", " ", 
           RowBox[{"Read", "[", 
            RowBox[{"i", ",", "Record"}], "]"}]}], ";", "\n", " ", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"line", " ", "==", " ", "EndOfFile"}], ",", " ", 
            RowBox[{"Abort", "[", "]"}]}], " ", "]"}], ";", "\n", " ", 
          RowBox[{"Print", "@", " ", "line"}], ";", "\n", " ", 
          RowBox[{"WriteString", "[", 
           RowBox[{"o", ",", "line", ",", "\"\<\\n\>\""}], "]"}], ";", "\n", 
          " ", 
          RowBox[{"(*", " ", 
           RowBox[{
           "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
            "codes"}], " ", "*)"}], "\n", " ", 
          RowBox[{"line", " ", "=", " ", 
           RowBox[{"FromCharacterCode", "@", "\n", " ", 
            RowBox[{"Cases", "[", " ", 
             RowBox[{
              RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
              RowBox[{"n_Integer", " ", "/;", " ", 
               RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], 
             " ", "]"}]}]}], ";", "\n", " ", 
          RowBox[{"str", " ", "=", " ", 
           RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
          RowBox[{"inputbuffer", " ", "=", " ", 
           RowBox[{"ReadList", "[", 
            RowBox[{
            "str", ",", " ", "Word", ",", "\n", "                        ", 
             RowBox[{"TokenWords", "->", 
              RowBox[{"{", 
               RowBox[{
               "\"\<(\>\"", ",", " ", "\"\<)\>\"", ",", " ", "\"\<[\>\"", ",",
                 " ", "\"\<]\>\"", ",", " ", "\"\<'\>\"", ",", " ", 
                "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], ";", "\n", " ", 
          RowBox[{"Close", "@", " ", "str"}]}]}], "\n", "]"}], ";", "\n", 
       RowBox[{"w", " ", "=", " ", 
        RowBox[{"First", "@", " ", "inputbuffer"}]}], ";", "\n", 
       RowBox[{"inputbuffer", " ", "=", " ", 
        RowBox[{"Rest", "@", " ", "inputbuffer"}]}], ";", "\n", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"DigitQ", "@", "w"}], ",", " ", 
         RowBox[{"ToExpression", "@", "w"}], ",", " ", "w"}], "]"}]}]}], "  ", 
     RowBox[{"(*", " ", 
      RowBox[{
      "convert", " ", "string", " ", "of", " ", "digits", " ", "to", " ", 
       "integer"}], " ", "*)"}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"word", "[", "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", "w", "}"}], ",", "\n", 
      RowBox[{"While", "[", " ", 
       RowBox[{"True", ",", "\n", " ", 
        RowBox[{
         RowBox[{"w", " ", "=", " ", 
          RowBox[{"word2", "[", "]"}]}], ";", "\n", " ", 
         RowBox[{"If", "[", " ", 
          RowBox[{
           RowBox[{"w", " ", "=!=", " ", "\"\<[\>\""}], ",", " ", 
           RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
         RowBox[{"While", "[", " ", 
          RowBox[{
           RowBox[{"word", "[", "]"}], " ", "=!=", " ", "\"\<]\>\""}], " ", 
          "]"}]}]}], "\n", "]"}]}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"get", "[", 
     RowBox[{
      RowBox[{"sexp_:", "False"}], ",", 
      RowBox[{"rparenokay_:", "False"}]}], "]"}], " ", ":=", "\n", " ", "\n", 
    
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"w", " ", "=", " ", 
         RowBox[{"word", "[", "]"}]}], ",", " ", "d", ",", " ", 
        RowBox[{"l", " ", "=", 
         RowBox[{"{", "}"}]}], ",", " ", "name", ",", " ", "def", ",", " ", 
        "body", ",", " ", "varlist"}], "}"}], ",", "\n", " ", 
      RowBox[{
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
         RowBox[{"Return", "@", " ", 
          RowBox[{"If", "[", 
           RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
            RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", ",", 
         "\n", " ", 
         RowBox[{
          RowBox[{"While", "[", " ", 
           RowBox[{
            RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
             RowBox[{"(", 
              RowBox[{"d", " ", "=", " ", 
               RowBox[{"get", "[", 
                RowBox[{"sexp", ",", "True"}], "]"}]}], ")"}]}], ",", "\n", 
            " ", 
            RowBox[{"AppendTo", "[", 
             RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", "\n", 
          " ", 
          RowBox[{"Return", "@", " ", "l"}]}]}], "\n", " ", "]"}], ";", "\n", 
       " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{"sexp", ",", " ", 
         RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
       RowBox[{"Switch", "[", "\n", " ", 
        RowBox[{"w", ",", "\n", " ", "\"\<\\\"\>\"", ",", " ", 
         RowBox[{"get", "[", "True", "]"}], ",", "\n", " ", "\"\<cadr\>\"", 
         ",", "\n", " ", 
         RowBox[{"{", 
          RowBox[{"\"\<car\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"\"\<cdr\>\"", ",", 
             RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}], ",", "\n", " ", 
         "\"\<caddr\>\"", ",", "\n", " ", 
         RowBox[{"{", 
          RowBox[{"\"\<car\>\"", ",", 
           RowBox[{"{", 
            RowBox[{"\"\<cdr\>\"", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<cdr\>\"", ",", 
               RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], ",", 
         "\n", " ", "\"\<let\>\"", ",", "\n", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"name", ",", "def", ",", "body"}], "}"}], " ", "=", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"get", "[", "]"}], ",", 
             RowBox[{"get", "[", "]"}], ",", 
             RowBox[{"get", "[", "]"}]}], "}"}]}], ";", "\n", " ", 
          RowBox[{"If", "[", "\n", " ", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MatchQ", "[", 
              RowBox[{"name", ",", 
               RowBox[{
                RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], 
              "]"}]}], ",", "\n", " ", 
            RowBox[{
             RowBox[{"varlist", " ", "=", " ", 
              RowBox[{"Rest", "@", " ", "name"}]}], ";", "\n", " ", 
             RowBox[{"name", " ", "=", " ", 
              RowBox[{"First", "@", " ", "name"}]}], ";", "\n", " ", 
             RowBox[{"def", " ", "=", " ", 
              RowBox[{"{", 
               RowBox[{"\"\<'\>\"", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\<lambda\>\"", ",", "varlist", ",", "def"}], 
                 "}"}]}], "}"}]}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<'\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"\"\<lambda\>\"", ",", 
                RowBox[{"{", "name", "}"}], ",", "body"}], "}"}]}], "}"}], 
            ",", "def"}], "}"}]}], ",", "\n", " ", 
         RowBox[{"\"\<read-bit\>\"", "|", "\"\<read-exp\>\""}], ",", "\n", 
         "                   ", 
         RowBox[{"{", "w", "}"}], ",", "\n", " ", 
         RowBox[{
         "\"\<car\>\"", "|", "\"\<cdr\>\"", "|", "\"\<atom\>\"", "|", 
          "\"\<'\>\"", "|", "\"\<display\>\"", "|", "\"\<eval\>\"", "|", 
          "\"\<bits\>\"", "|", "\"\<debug\>\"", "|", "\n", " ", 
          "\"\<length\>\"", "|", "\"\<size\>\"", "|", "\"\<base2-to-10\>\"", 
          "|", "\"\<base10-to-2\>\""}], ",", "\n", "                   ", 
         RowBox[{"{", 
          RowBox[{"w", ",", 
           RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
         RowBox[{
         "\"\<cons\>\"", "|", "\"\<=\>\"", "|", "\"\<lambda\>\"", "|", 
          "\"\<append\>\"", "|", "\"\<define\>\"", "|", "\"\<+\>\"", "|", 
          "\"\<-\>\"", "|", "\"\<*\>\"", "|", "\"\<^\>\"", "|", "\"\<<\>\"", 
          "|", "\"\<>\>\"", "|", "\"\<<=\>\"", "|", "\"\<>=\>\""}], ",", "\n",
          "                   ", 
         RowBox[{"{", 
          RowBox[{"w", ",", 
           RowBox[{"get", "[", "]"}], ",", 
           RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
         RowBox[{"\"\<if\>\"", "|", "\"\<let\>\"", "|", "\"\<try\>\""}], ",", 
         " ", 
         RowBox[{"{", 
          RowBox[{"w", ",", 
           RowBox[{"get", "[", "]"}], ",", 
           RowBox[{"get", "[", "]"}], ",", 
           RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", "_", ",", " ", 
         "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], "\n", " ", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"output", " ", "S"}], "-", "exp"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"output2", "[", "x_String", "]"}], " ", ":=", " ", 
    RowBox[{"x", "<>", "\"\< \>\""}]}], "\n", 
   RowBox[{
    RowBox[{"output2", "[", "x_Integer", "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], "\n", 
   RowBox[{
    RowBox[{"output2", "[", 
     RowBox[{"{", "x___", "}"}], "]"}], " ", ":=", "\n", 
    RowBox[{"Block", "[", " ", 
     RowBox[{
      RowBox[{"{", "s", "}"}], ",", "\n", " ", 
      RowBox[{
       RowBox[{"s", " ", "=", " ", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"\"\<(\>\"", ",", " ", 
          RowBox[{"output2", " ", "/@", " ", 
           RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";", "\n", " ", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{"s", ",", 
            RowBox[{"-", "1"}]}], "]"}], " ", "==", " ", "\"\< \>\""}], ",", 
         " ", 
         RowBox[{"s", " ", "=", " ", 
          RowBox[{"StringDrop", "[", 
           RowBox[{"s", ",", 
            RowBox[{"-", "1"}]}], "]"}]}]}], " ", "]"}], ";", "\n", " ", 
       RowBox[{"s", " ", "<>", " ", "\"\<) \>\""}]}]}], "\n", "]"}]}], "\n", 
   RowBox[{
    RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
    RowBox[{"StringDrop", "[", " ", 
     RowBox[{
      RowBox[{"output2", "@", "x"}], " ", ",", 
      RowBox[{"-", "1"}]}], " ", "]"}]}], "\n", " ", "\n", 
   RowBox[{"blanks", " ", "=", " ", 
    RowBox[{"StringJoin", "@", " ", 
     RowBox[{"Table", "[", 
      RowBox[{"\"\< \>\"", ",", 
       RowBox[{"{", "12", "}"}]}], "]"}]}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"print", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"print2", "[", 
        RowBox[{"x", ",", 
         RowBox[{"StringTake", "[", 
          RowBox[{"y", ",", "50"}], "]"}]}], "]"}], ";", "\n", " ", 
       RowBox[{"print", "[", 
        RowBox[{"\"\<\>\"", ",", 
         RowBox[{"StringDrop", "[", 
          RowBox[{"y", ",", "50"}], "]"}]}], "]"}]}], ")"}], " ", "/;", " ", 
     RowBox[{
      RowBox[{"StringLength", "[", "y", "]"}], " ", ">", " ", "50"}]}]}], 
   "\n", 
   RowBox[{
    RowBox[{"print", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
    RowBox[{"print2", "[", 
     RowBox[{"x", ",", "y"}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"print2", "[", 
     RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
    RowBox[{"print3", "[", 
     RowBox[{
      RowBox[{"StringTake", "[", 
       RowBox[{
        RowBox[{"x", "<>", "blanks"}], ",", "12"}], "]"}], "<>", "y"}], 
     "]"}]}], "\n", 
   RowBox[{
    RowBox[{"print3", "[", "x_", "]"}], " ", ":=", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Print", "[", "x", "]"}], ";", " ", 
      RowBox[{"WriteString", "[", 
       RowBox[{"o", ",", "x", ",", "\"\<\\n\>\""}], "]"}]}], ")"}]}], "\n", 
   " ", "\n", 
   RowBox[{
    RowBox[{"let", "[", 
     RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", "\n", 
    RowBox[{"(", "\n", " ", 
     RowBox[{
      RowBox[{"print", "[", " ", 
       RowBox[{"\"\<define\>\"", ",", " ", 
        RowBox[{"output", "@", " ", "n"}]}], " ", "]"}], ";", "\n", " ", 
      RowBox[{"print", "[", " ", 
       RowBox[{"\"\<value\>\"", ",", " ", 
        RowBox[{"output", "@", " ", "d"}]}], " ", "]"}], ";", "\n", " ", 
      RowBox[{"PrependTo", "[", 
       RowBox[{"names", ",", "n"}], "]"}], ";", "\n", " ", 
      RowBox[{"PrependTo", "[", 
       RowBox[{"defs", ",", "d"}], "]"}], ";"}], "\n", ")"}]}], "\n", " ", 
   "\n", 
   RowBox[{
    RowBox[{"run", "[", "s_", "]"}], " ", ":=", "\n", 
    RowBox[{"(", "\n", " ", 
     RowBox[{
      RowBox[{"inputbuffer", " ", "=", " ", 
       RowBox[{"{", "}"}]}], ";", "\n", " ", 
      RowBox[{"names", " ", "=", " ", 
       RowBox[{"{", "\"\<nil\>\"", "}"}]}], ";", " ", 
      RowBox[{"defs", " ", "=", " ", 
       RowBox[{"{", 
        RowBox[{"{", "}"}], "}"}]}], ";", "\n", " ", 
      RowBox[{"t0", " ", "=", " ", 
       RowBox[{"SessionTime", "[", "]"}]}], ";", "\n", " ", 
      RowBox[{"o", " ", "=", " ", 
       RowBox[{
       "OpenWrite", "[", 
        "\"\</Users/darashayda1xfer/Desktop/MODULES/connor/lisp \
chiatin/output.txt\>\"", "]"}]}], ";", "\n", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", 
         RowBox[{"OpenRead", "[", "fn", "]"}]}], ";"}], "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"i", "=", 
       RowBox[{"StringToStream", "@", "s"}]}], ";", "\n", " ", 
      RowBox[{"print3", "[", "\"\<LISP Interpreter Run\>\"", "]"}], ";", "\n",
       " ", 
      RowBox[{"print3", "@", " ", "\"\<\>\""}], ";", "\n", " ", 
      RowBox[{"CheckAbort", "[", "\n", " ", 
       RowBox[{
        RowBox[{"While", "[", 
         RowBox[{"True", ",", "\n", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"print3", "@", " ", "\"\<\>\""}], ";", "\n", " ", 
               RowBox[{"Replace", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"{", "\n", " ", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<define\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"func_", ",", "vars___"}], "}"}], ",", "def_"}], 
                    "}"}], " ", ":>", " ", 
                    RowBox[{"let", "[", 
                    RowBox[{"func", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<lambda\>\"", ",", 
                    RowBox[{"{", "vars", "}"}], ",", "def"}], "}"}]}], 
                    "]"}]}], ",", "\n", " ", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<define\>\"", ",", "var_", ",", "def_"}], 
                    "}"}], " ", ":>", " ", 
                    RowBox[{"let", "[", 
                    RowBox[{"var", ",", "def"}], "]"}]}], ",", "\n", " ", 
                   RowBox[{"_", " ", ":>", " ", 
                    RowBox[{"print", "[", " ", 
                    RowBox[{"\"\<value\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", 
                    RowBox[{"eval", "@", " ", "#"}]}]}], " ", "]"}]}]}], "\n",
                   " ", "}"}]}], "]"}]}], "\n", ")"}], "&"}], " ", "@", " ", 
            RowBox[{"get", "[", "]"}]}], ";", "\n", " ", 
           RowBox[{"print3", "@", " ", "\"\<\>\""}]}]}], "\n", " ", "]"}], 
        ",", "Null"}], "\n", " ", "]"}], ";", "\n", " ", 
      RowBox[{"print3", "@", " ", "\"\<End of LISP Run\>\""}], ";", "\n", " ", 
      RowBox[{"print3", "@", " ", "\"\<\>\""}], ";", "\n", " ", 
      RowBox[{"print3", "@", " ", 
       RowBox[{"StringForm", "[", "\n", " ", 
        RowBox[{"\"\<Elapsed time is `` seconds.\>\"", ",", "\n", " ", 
         RowBox[{"Round", "[", 
          RowBox[{
           RowBox[{"SessionTime", "[", "]"}], "-", "t0"}], "]"}]}], "\n", " ",
         "]"}]}], ";", "\n", " ", 
      RowBox[{"Close", "@", " ", "i"}], ";", "\n", " ", 
      RowBox[{"Close", "@", " ", "o"}]}], "\n", ")"}]}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{"$RecursionLimit", " ", "=", " ", 
     RowBox[{"$IterationLimit", " ", "=", " ", "Infinity"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{"$Output", ",", 
      RowBox[{"PageWidth", "->", "Infinity"}]}], "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.7745199874975357`*^9, 3.77452000217109*^9}, {
   3.774520139238029*^9, 3.774520141908882*^9}, {3.77452077076976*^9, 
   3.7745207891048307`*^9}, {3.774520839356698*^9, 3.77452084050237*^9}, {
   3.7745209236156883`*^9, 3.774520924936572*^9}, {3.774521090543704*^9, 
   3.774521099439996*^9}, {3.774521162463912*^9, 3.774521162923237*^9}, 
   3.77452128811065*^9, {3.774521782302965*^9, 3.774521807434683*^9}, {
   3.774521895686737*^9, 3.7745219037055187`*^9}, {3.7745219713223047`*^9, 
   3.7745219714649553`*^9}},
 CellLabel->"In[69]:=",ExpressionUUID->"2ec95271-35c0-417b-8198-4abf7e63883f"],

Cell[BoxData["\<\"            \"\>"], "Output",
 CellChangeTimes->{
  3.774519560855739*^9, 3.774519659060721*^9, 3.77452014258654*^9, 
   3.7745208504779778`*^9, 3.7745209542450533`*^9, {3.774521137614311*^9, 
   3.7745211653678503`*^9}, 3.7745212896163273`*^9, 3.7745218081184587`*^9, {
   3.774521965976968*^9, 3.774521972507268*^9}},
 CellLabel->"Out[92]=",ExpressionUUID->"71ea800d-9089-4722-9040-8408d3891d1e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"run", "[", "\"\<cdr '((a b)c d)\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.774519815686433*^9, 3.77451983195538*^9}, {
   3.7745207967602997`*^9, 3.774520797648529*^9}, {3.77452094874358*^9, 
   3.774520950078084*^9}, {3.7745210040845537`*^9, 3.774521029999269*^9}, {
   3.774521073346449*^9, 3.77452107539363*^9}, {3.774521106365573*^9, 
   3.774521106624119*^9}, 3.774521959427039*^9, 3.774522013754118*^9},
 CellLabel->
  "In[102]:=",ExpressionUUID->"9d0b0b18-c885-4fdd-bc94-7ebe5568259a"],

Cell[CellGroupData[{

Cell[BoxData["\<\"LISP Interpreter Run\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.7745220157621603`*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"7412b6bf-80de-4f5f-8fa6-e329be377cfa"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.77452201576405*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"5b1a83f1-242c-4c92-8942-642abbc3d7e5"],

Cell[BoxData["\<\"cdr '((a b)c d)\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015765687*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"e464ce8b-03b6-41df-b5e9-1ee879eb59fa"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015767047*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"84b60184-8058-429c-be38-fd7d8979009d"],

Cell[BoxData["\<\"expression  (cdr (' ((a b) c d)))\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015768426*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"bff90d6d-1ac3-4d2c-9d86-9f3ae2bcd04c"],

Cell[BoxData["\<\"value       (c d)\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015770071*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"d735409e-e83d-4e1f-98d7-607d54a87915"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015771379*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"0307cb3c-392a-4c3f-8d83-1685cfb08494"],

Cell[BoxData["\<\"End of LISP Run\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.7745220157725697`*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"c88bd53a-4b70-49de-af70-d7cbf27a6437"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015773617*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"9d53985f-472f-45bf-aede-7e5a9b78dfe6"],

Cell[BoxData[
 InterpretationBox["\<\"Elapsed time is \\!\\(\\*RowBox[{\\\"0\\\"}]\\) \
seconds.\"\>",
  StringForm["Elapsed time is `` seconds.", 0],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.7745209596090612`*^9, 3.7745210134402018`*^9, 3.774521107119438*^9, {
   3.774521140618675*^9, 3.7745211693725243`*^9}, 3.774521292758637*^9, 
   3.7745218137137814`*^9, {3.774521960839992*^9, 3.774521974712508*^9}, 
   3.774522015774755*^9},
 CellLabel->
  "During evaluation of \
In[102]:=",ExpressionUUID->"01e9e901-137d-43a0-a03f-caae7261fd86"]
}, Open  ]],

Cell[BoxData["\<\"/Users/darashayda1xfer/Desktop/MODULES/connor/lisp \
chiatin/output.txt\"\>"], "Output",
 CellChangeTimes->{
  3.774520960912918*^9, 3.774521014833641*^9, 3.774521108497694*^9, {
   3.7745211422996798`*^9, 3.7745211710502462`*^9}, 3.774521294460795*^9, 
   3.7745218137266283`*^9, {3.774521960853758*^9, 3.774521974726904*^9}, 
   3.774522015776187*^9},
 CellLabel->
  "Out[102]=",ExpressionUUID->"248e15cd-8197-4c54-a5f3-de1a03083dbd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
  "run", "[", 
   "\"\<define (cat x y) if atom x y cons car x (cat cdr x y)\n\ncat\n\n(cat \
'(a b c) '(d e f))\>\"", "]"}]}]], "Input",
 CellChangeTimes->{3.774522129573372*^9},
 CellLabel->
  "In[103]:=",ExpressionUUID->"48a8242a-6d66-44d6-a7e9-cdaebcab544c"],

Cell[CellGroupData[{

Cell[BoxData["\<\"LISP Interpreter Run\"\>"], "Print",
 CellChangeTimes->{3.7745221312355833`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"a89e131a-70b9-4378-8b33-4c69600b0f1b"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.7745221312373734`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"efb59dc1-38b9-4397-9904-263f7269b382"],

Cell[BoxData["\<\"define (cat x y) if atom x y cons car x (cat cdr x \
y)\"\>"], "Print",
 CellChangeTimes->{3.774522131240843*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"ad1d3d77-91d0-4e45-b88e-b369aacf5c3c"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.7745221312418823`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"8d217782-242c-4f49-88a0-709542b82b02"],

Cell[BoxData["\<\"define      cat\"\>"], "Print",
 CellChangeTimes->{3.7745221312428293`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"ef4c689c-1187-440d-916d-f7b41673c682"],

Cell[BoxData["\<\"value       (lambda (x y) (if (atom x) y (cons (car x) (cat \
(c\"\>"], "Print",
 CellChangeTimes->{3.774522131243832*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"ceb1283c-e711-4491-92f5-2784f59cdeb8"],

Cell[BoxData["\<\"            dr x) y))))\"\>"], "Print",
 CellChangeTimes->{3.774522131244854*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"1fd8602f-1a1a-426f-a41e-121dec0c97dd"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.774522131245839*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"4b577d78-d182-401e-aa62-0583a51dc60c"],

Cell[BoxData["\<\"cat\"\>"], "Print",
 CellChangeTimes->{3.7745221312468147`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"1699c9dd-7ddd-4862-a9b2-838b4433817c"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.774522131247856*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"ebb6e4ba-cfc0-49c3-8673-d3b06720e542"],

Cell[BoxData["\<\"expression  cat\"\>"], "Print",
 CellChangeTimes->{3.774522131248839*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"beb794ba-ff0f-4ef3-8fb8-e1de8147dc60"],

Cell[BoxData["\<\"value       (lambda (x y) (if (atom x) y (cons (car x) (cat \
(c\"\>"], "Print",
 CellChangeTimes->{3.774522131249831*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"e4d67a50-3780-48c1-9168-fab17e9974dc"],

Cell[BoxData["\<\"            dr x) y))))\"\>"], "Print",
 CellChangeTimes->{3.774522131250862*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"d199a66e-5117-4208-bf54-366debc522f6"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.774522131251877*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"54b5edf1-3808-4a7a-8cb8-0798ff6ef1ff"],

Cell[BoxData["\<\"(cat '(a b c) '(d e f))\"\>"], "Print",
 CellChangeTimes->{3.774522131252878*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"f7c6ab29-bf97-42eb-9896-6b2d4c1938ac"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.774522131253883*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"d2944757-ab46-49cd-a7df-a808ad51c6c0"],

Cell[BoxData["\<\"expression  (cat (' (a b c)) (' (d e f)))\"\>"], "Print",
 CellChangeTimes->{3.774522131254884*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"5b15d8de-f867-471e-a99f-bdf2f14cfb0e"],

Cell[BoxData["\<\"value       (a b c d e f)\"\>"], "Print",
 CellChangeTimes->{3.774522131255929*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"3fcc8497-8c13-4290-b90d-7068a2eba833"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.7745221312569323`*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"c48c3390-d36a-4f3c-b5ae-c0c463f22a61"],

Cell[BoxData["\<\"End of LISP Run\"\>"], "Print",
 CellChangeTimes->{3.774522131257955*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"e887b2e3-7ae5-45b3-a636-5dc443798f33"],

Cell[BoxData["\<\"\"\>"], "Print",
 CellChangeTimes->{3.774522131258956*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"9b8ac4b6-ca15-42de-9dd2-5a79b1949997"],

Cell[BoxData[
 InterpretationBox["\<\"Elapsed time is \\!\\(\\*RowBox[{\\\"0\\\"}]\\) \
seconds.\"\>",
  StringForm["Elapsed time is `` seconds.", 0],
  Editable->False]], "Print",
 CellChangeTimes->{3.77452213125998*^9},
 CellLabel->
  "During evaluation of \
In[103]:=",ExpressionUUID->"a6b28745-c665-4a93-a6b1-3fc474496de4"]
}, Open  ]],

Cell[BoxData["\<\"/Users/darashayda1xfer/Desktop/MODULES/connor/lisp \
chiatin/output.txt\"\>"], "Output",
 CellChangeTimes->{3.774522131261055*^9},
 CellLabel->
  "Out[103]=",ExpressionUUID->"aea64661-e16b-4ed3-801d-2ee3e7d0e80a"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{854, Automatic}, {187, Automatic}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 42415, 1008, 6226, "Input",ExpressionUUID->"2ec95271-35c0-417b-8198-4abf7e63883f"],
Cell[42998, 1032, 416, 6, 34, "Output",ExpressionUUID->"71ea800d-9089-4722-9040-8408d3891d1e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43451, 1043, 536, 9, 30, "Input",ExpressionUUID->"9d0b0b18-c885-4fdd-bc94-7ebe5568259a"],
Cell[CellGroupData[{
Cell[44012, 1056, 429, 8, 24, "Print",ExpressionUUID->"7412b6bf-80de-4f5f-8fa6-e329be377cfa"],
Cell[44444, 1066, 406, 8, 24, "Print",ExpressionUUID->"5b1a83f1-242c-4c92-8942-642abbc3d7e5"],
Cell[44853, 1076, 422, 8, 24, "Print",ExpressionUUID->"e464ce8b-03b6-41df-b5e9-1ee879eb59fa"],
Cell[45278, 1086, 407, 8, 24, "Print",ExpressionUUID->"84b60184-8058-429c-be38-fd7d8979009d"],
Cell[45688, 1096, 440, 8, 24, "Print",ExpressionUUID->"bff90d6d-1ac3-4d2c-9d86-9f3ae2bcd04c"],
Cell[46131, 1106, 424, 8, 24, "Print",ExpressionUUID->"d735409e-e83d-4e1f-98d7-607d54a87915"],
Cell[46558, 1116, 407, 8, 24, "Print",ExpressionUUID->"0307cb3c-392a-4c3f-8d83-1685cfb08494"],
Cell[46968, 1126, 424, 8, 24, "Print",ExpressionUUID->"c88bd53a-4b70-49de-af70-d7cbf27a6437"],
Cell[47395, 1136, 407, 8, 24, "Print",ExpressionUUID->"9d53985f-472f-45bf-aede-7e5a9b78dfe6"],
Cell[47805, 1146, 553, 12, 24, "Print",ExpressionUUID->"01e9e901-137d-43a0-a03f-caae7261fd86"]
}, Open  ]],
Cell[48373, 1161, 454, 8, 34, "Output",ExpressionUUID->"248e15cd-8197-4c54-a5f3-de1a03083dbd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48864, 1174, 302, 8, 115, "Input",ExpressionUUID->"48a8242a-6d66-44d6-a7e9-cdaebcab544c"],
Cell[CellGroupData[{
Cell[49191, 1186, 204, 4, 24, "Print",ExpressionUUID->"a89e131a-70b9-4378-8b33-4c69600b0f1b"],
Cell[49398, 1192, 184, 4, 24, "Print",ExpressionUUID->"efb59dc1-38b9-4397-9904-263f7269b382"],
Cell[49585, 1198, 237, 5, 24, "Print",ExpressionUUID->"ad1d3d77-91d0-4e45-b88e-b369aacf5c3c"],
Cell[49825, 1205, 184, 4, 24, "Print",ExpressionUUID->"8d217782-242c-4f49-88a0-709542b82b02"],
Cell[50012, 1211, 199, 4, 24, "Print",ExpressionUUID->"ef4c689c-1187-440d-916d-f7b41673c682"],
Cell[50214, 1217, 246, 5, 24, "Print",ExpressionUUID->"ceb1283c-e711-4491-92f5-2784f59cdeb8"],
Cell[50463, 1224, 205, 4, 24, "Print",ExpressionUUID->"1fd8602f-1a1a-426f-a41e-121dec0c97dd"],
Cell[50671, 1230, 182, 4, 24, "Print",ExpressionUUID->"4b577d78-d182-401e-aa62-0583a51dc60c"],
Cell[50856, 1236, 187, 4, 24, "Print",ExpressionUUID->"1699c9dd-7ddd-4862-a9b2-838b4433817c"],
Cell[51046, 1242, 182, 4, 24, "Print",ExpressionUUID->"ebb6e4ba-cfc0-49c3-8673-d3b06720e542"],
Cell[51231, 1248, 197, 4, 24, "Print",ExpressionUUID->"beb794ba-ff0f-4ef3-8fb8-e1de8147dc60"],
Cell[51431, 1254, 246, 5, 24, "Print",ExpressionUUID->"e4d67a50-3780-48c1-9168-fab17e9974dc"],
Cell[51680, 1261, 205, 4, 24, "Print",ExpressionUUID->"d199a66e-5117-4208-bf54-366debc522f6"],
Cell[51888, 1267, 182, 4, 24, "Print",ExpressionUUID->"54b5edf1-3808-4a7a-8cb8-0798ff6ef1ff"],
Cell[52073, 1273, 205, 4, 24, "Print",ExpressionUUID->"f7c6ab29-bf97-42eb-9896-6b2d4c1938ac"],
Cell[52281, 1279, 182, 4, 24, "Print",ExpressionUUID->"d2944757-ab46-49cd-a7df-a808ad51c6c0"],
Cell[52466, 1285, 223, 4, 24, "Print",ExpressionUUID->"5b15d8de-f867-471e-a99f-bdf2f14cfb0e"],
Cell[52692, 1291, 207, 4, 24, "Print",ExpressionUUID->"3fcc8497-8c13-4290-b90d-7068a2eba833"],
Cell[52902, 1297, 184, 4, 24, "Print",ExpressionUUID->"c48c3390-d36a-4f3c-b5ae-c0c463f22a61"],
Cell[53089, 1303, 197, 4, 24, "Print",ExpressionUUID->"e887b2e3-7ae5-45b3-a636-5dc443798f33"],
Cell[53289, 1309, 182, 4, 24, "Print",ExpressionUUID->"9b8ac4b6-ca15-42de-9dd2-5a79b1949997"],
Cell[53474, 1315, 327, 8, 24, "Print",ExpressionUUID->"a6b28745-c665-4a93-a6b1-3fc474496de4"]
}, Open  ]],
Cell[53816, 1326, 231, 4, 34, "Output",ExpressionUUID->"aea64661-e16b-4ed3-801d-2ee3e7d0e80a"]
}, Open  ]]
}
]
*)

