(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     77160,       1776]
NotebookOptionsPosition[     76718,       1760]
NotebookOutlinePosition[     77108,       1777]
CellTagsIndexPosition[     77065,       1774]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"ba343cbf-54e6-44c7-b1e2-\
54bc131ecd4f"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"word2", "[", "]"}], ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"w", ",", "line", ",", "str"}], "}"}], ",", "\n", 
       RowBox[{
        RowBox[{"While", "[", "\n", " ", 
         RowBox[{
          RowBox[{"inputbuffer", " ", "==", " ", 
           RowBox[{"{", "}"}]}], ",", "\n", " ", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"line", " ", "=", " ", 
             RowBox[{"Read", "[", 
              RowBox[{"i", ",", "Record"}], "]"}]}], ";", "\n", " ", 
            RowBox[{"If", "[", " ", 
             RowBox[{
              RowBox[{"line", " ", "==", " ", "EndOfFile"}], ",", " ", 
              RowBox[{"Abort", "[", "]"}]}], " ", "]"}], ";", "\n", " ", 
            RowBox[{"Print", "@", " ", "line"}], ";", "\n", " ", 
            RowBox[{"Print", "[", 
             RowBox[{"{", 
              RowBox[{"o", ",", "line"}], "}"}], "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"line", "=", "code"}], ";", "\n", " ", 
           RowBox[{"(*", " ", 
            RowBox[{
            "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
             "codes"}], " ", "*)"}], "\n", " ", 
           RowBox[{"line", " ", "=", " ", 
            RowBox[{"FromCharacterCode", "@", "\n", " ", 
             RowBox[{"Cases", "[", " ", 
              RowBox[{
               RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
               RowBox[{"n_Integer", " ", "/;", " ", 
                RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}],
               " ", "]"}]}]}], ";", "\n", " ", 
           RowBox[{"str", " ", "=", " ", 
            RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
           RowBox[{"inputbuffer", " ", "=", " ", 
            RowBox[{"ReadList", "[", 
             RowBox[{
             "str", ",", " ", "Word", ",", "\n", "                        ", 
              RowBox[{"TokenWords", "->", 
               RowBox[{"{", 
                RowBox[{
                "\"\<(\>\"", ",", " ", "\"\<)\>\"", ",", " ", "\"\<[\>\"", 
                 ",", " ", "\"\<]\>\"", ",", " ", "\"\<'\>\"", ",", " ", 
                 "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"Close", "@", " ", "str"}]}]}], "\n", "]"}], ";", "\n", 
        RowBox[{"w", " ", "=", " ", 
         RowBox[{"First", "@", " ", "inputbuffer"}]}], ";", "\n", 
        RowBox[{"inputbuffer", " ", "=", " ", 
         RowBox[{"Rest", "@", " ", "inputbuffer"}]}], ";", "\n", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"DigitQ", "@", "w"}], ",", " ", 
          RowBox[{"ToExpression", "@", "w"}], ",", " ", "w"}], "]"}]}]}], 
      "  ", 
      RowBox[{"(*", " ", 
       RowBox[{
       "convert", " ", "string", " ", "of", " ", "digits", " ", "to", " ", 
        "integer"}], " ", "*)"}], "\n", "]"}]}], ";"}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"word", "[", "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", "w", "}"}], ",", "\n", 
       RowBox[{"While", "[", " ", 
        RowBox[{"True", ",", "\n", " ", 
         RowBox[{
          RowBox[{"w", " ", "=", " ", 
           RowBox[{"word2", "[", "]"}]}], ";", "\n", " ", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"w", " ", "=!=", " ", "\"\<[\>\""}], ",", " ", 
            RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
          RowBox[{"While", "[", " ", 
           RowBox[{
            RowBox[{"word", "[", "]"}], " ", "=!=", " ", "\"\<]\>\""}], " ", 
           "]"}]}]}], "\n", "]"}]}], "\n", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"get", "[", 
      RowBox[{
       RowBox[{"sexp_:", "False"}], ",", 
       RowBox[{"rparenokay_:", "False"}]}], "]"}], " ", ":=", "\n", " ", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"w", " ", "=", " ", 
          RowBox[{"word", "[", "]"}]}], ",", " ", "d", ",", " ", 
         RowBox[{"l", " ", "=", 
          RowBox[{"{", "}"}]}], ",", " ", "name", ",", " ", "def", ",", " ", 
         "body", ",", " ", "varlist"}], "}"}], ",", "\n", " ", 
       RowBox[{
        RowBox[{"Switch", "[", "\n", " ", 
         RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
             RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", ",", 
          "\n", " ", 
          RowBox[{
           RowBox[{"While", "[", " ", 
            RowBox[{
             RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
              RowBox[{"(", 
               RowBox[{"d", " ", "=", " ", 
                RowBox[{"get", "[", 
                 RowBox[{"sexp", ",", "True"}], "]"}]}], ")"}]}], ",", "\n", 
             " ", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", "\n", 
           " ", 
           RowBox[{"Return", "@", " ", "l"}]}]}], "\n", " ", "]"}], ";", "\n",
         " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{"sexp", ",", " ", 
          RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
        RowBox[{"Switch", "[", "\n", " ", 
         RowBox[{"w", ",", "\n", " ", "\"\<\\\"\>\"", ",", " ", 
          RowBox[{"get", "[", "True", "]"}], ",", "\n", " ", "\"\<cadr\>\"", 
          ",", "\n", " ", 
          RowBox[{"{", 
           RowBox[{"\"\<car\>\"", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<cdr\>\"", ",", 
              RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}], ",", "\n", " ", 
          "\"\<caddr\>\"", ",", "\n", " ", 
          RowBox[{"{", 
           RowBox[{"\"\<car\>\"", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<cdr\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"\"\<cdr\>\"", ",", 
                RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], ",", 
          "\n", " ", "\"\<let\>\"", ",", "\n", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"name", ",", "def", ",", "body"}], "}"}], " ", "=", " ", 
            
            RowBox[{"{", 
             RowBox[{
              RowBox[{"get", "[", "]"}], ",", 
              RowBox[{"get", "[", "]"}], ",", 
              RowBox[{"get", "[", "]"}]}], "}"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", "\n", " ", 
            RowBox[{
             RowBox[{"!", 
              RowBox[{"MatchQ", "[", 
               RowBox[{"name", ",", 
                RowBox[{
                 RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], 
               "]"}]}], ",", "\n", " ", 
             RowBox[{
              RowBox[{"varlist", " ", "=", " ", 
               RowBox[{"Rest", "@", " ", "name"}]}], ";", "\n", " ", 
              RowBox[{"name", " ", "=", " ", 
               RowBox[{"First", "@", " ", "name"}]}], ";", "\n", " ", 
              RowBox[{"def", " ", "=", " ", 
               RowBox[{"{", 
                RowBox[{"\"\<'\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<lambda\>\"", ",", "varlist", ",", "def"}], 
                  "}"}]}], "}"}]}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<'\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda\>\"", ",", 
                 RowBox[{"{", "name", "}"}], ",", "body"}], "}"}]}], "}"}], 
             ",", "def"}], "}"}]}], ",", "\n", " ", 
          RowBox[{"\"\<read-bit\>\"", "|", "\"\<read-exp\>\""}], ",", "\n", 
          "                   ", 
          RowBox[{"{", "w", "}"}], ",", "\n", " ", 
          RowBox[{
          "\"\<car\>\"", "|", "\"\<cdr\>\"", "|", "\"\<atom\>\"", "|", 
           "\"\<'\>\"", "|", "\"\<display\>\"", "|", "\"\<eval\>\"", "|", 
           "\"\<bits\>\"", "|", "\"\<debug\>\"", "|", "\n", " ", 
           "\"\<length\>\"", "|", "\"\<size\>\"", "|", "\"\<base2-to-10\>\"", 
           "|", "\"\<base10-to-2\>\""}], ",", "\n", "                   ", 
          RowBox[{"{", 
           RowBox[{"w", ",", 
            RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
          RowBox[{
          "\"\<cons\>\"", "|", "\"\<=\>\"", "|", "\"\<lambda\>\"", "|", 
           "\"\<append\>\"", "|", "\"\<define\>\"", "|", "\"\<+\>\"", "|", 
           "\"\<-\>\"", "|", "\"\<*\>\"", "|", "\"\<^\>\"", "|", "\"\<<\>\"", 
           "|", "\"\<>\>\"", "|", "\"\<<=\>\"", "|", "\"\<>=\>\""}], ",", 
          "\n", "                   ", 
          RowBox[{"{", 
           RowBox[{"w", ",", 
            RowBox[{"get", "[", "]"}], ",", 
            RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
          RowBox[{"\"\<if\>\"", "|", "\"\<let\>\"", "|", "\"\<try\>\""}], ",",
           " ", 
          RowBox[{"{", 
           RowBox[{"w", ",", 
            RowBox[{"get", "[", "]"}], ",", 
            RowBox[{"get", "[", "]"}], ",", 
            RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", "_", ",", " ",
           "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"getbit", "[", "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", "x", "}"}], ",", "\n", " ", 
       RowBox[{
        RowBox[{"trouble", " ", "=", " ", "False"}], ";", " ", 
        RowBox[{"(*", " ", 
         RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"atom", "@", " ", "tape"}], ",", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"trouble", " ", "=", " ", "True"}], ";", " ", 
            RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], ")"}]}], 
         "]"}], ";", "\n", " ", 
        RowBox[{"x", " ", "=", " ", 
         RowBox[{"car", "@", " ", "tape"}]}], ";", "\n", " ", 
        RowBox[{"tape", " ", "=", " ", 
         RowBox[{"cdr", "@", " ", "tape"}]}], ";", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"x", " ", "===", " ", "0"}], ",", " ", "0", ",", " ", "1"}],
          " ", "]"}]}]}], "\n", "]"}]}], ";"}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"getchar", "[", "]"}], " ", ":=", " ", 
     RowBox[{"FromCharacterCode", "[", "\n", "  ", 
      RowBox[{
       RowBox[{"128", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"64", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"32", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"16", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", "\n", "  ", 
       RowBox[{"8", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"4", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"2", "*", 
        RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
       RowBox[{"getbit", "[", "]"}]}], "\n", "]"}]}], ";"}], "\n", " ", "\n", 
   
   RowBox[{
    RowBox[{
     RowBox[{"getrecord", "[", "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", " ", 
        RowBox[{"c", ",", " ", 
         RowBox[{"line", " ", "=", " ", "\"\<\>\""}], ",", " ", "str"}], " ", 
        "}"}], ",", "\n", " ", 
       RowBox[{
        RowBox[{"inputbuffer2", " ", "=", " ", 
         RowBox[{"{", "}"}]}], ";", "\n", " ", 
        RowBox[{"While", "[", " ", 
         RowBox[{
          RowBox[{"\"\<\\n\>\"", " ", "=!=", " ", 
           RowBox[{"(", 
            RowBox[{"c", " ", "=", " ", 
             RowBox[{"getchar", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
          RowBox[{"line", " ", "=", " ", 
           RowBox[{"line", " ", "<>", " ", "c"}]}]}], " ", "]"}], ";", "\n", 
        " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{"trouble", ",", " ", 
          RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], "]"}], ";", 
        " ", 
        RowBox[{"(*", " ", 
         RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
         "keep", " ", "only", " ", "printable", " ", "ASCII", " ", "codes"}], 
         " ", "*)"}], "\n", " ", 
        RowBox[{"line", " ", "=", " ", 
         RowBox[{"FromCharacterCode", "@", "\n", " ", 
          RowBox[{"Cases", "[", " ", 
           RowBox[{
            RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
            RowBox[{"n_Integer", " ", "/;", " ", 
             RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], 
           " ", "]"}]}]}], ";", "\n", " ", 
        RowBox[{"str", " ", "=", " ", 
         RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
        RowBox[{"inputbuffer2", " ", "=", " ", 
         RowBox[{"ReadList", "[", 
          RowBox[{"str", ",", " ", "Word", ",", " ", 
           RowBox[{"TokenWords", "->", 
            RowBox[{"{", 
             RowBox[{"\"\<(\>\"", ",", " ", "\"\<)\>\""}], "}"}]}]}], "]"}]}],
         ";", "\n", " ", 
        RowBox[{"Close", "@", " ", "str"}], ";", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
         "convert", " ", "strings", " ", "of", " ", "digits", " ", "to", " ", 
          "integers"}], " ", "*)"}], "\n", " ", 
        RowBox[{"inputbuffer2", " ", "=", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DigitQ", "@", "#"}], ",", " ", 
             RowBox[{"ToExpression", "@", "#"}], ",", " ", "#"}], "]"}], 
           "&"}], " ", "/@", " ", "inputbuffer2"}]}], " ", ";"}]}], "\n", 
      "]"}]}], ";"}], "\n", " ", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"getexp", "[", 
      RowBox[{"rparenokay_:", "False"}], "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", " ", 
        RowBox[{"w", ",", " ", "d", ",", " ", 
         RowBox[{"l", " ", "=", " ", 
          RowBox[{"{", "}"}]}]}], " ", "}"}], ",", "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{" ", 
           RowBox[{"supply", " ", "unlimited", " ", "number", " ", "of"}], 
           " ", ")"}], "'"}], "s", " ", "if", " ", "tokens", " ", "run", " ", 
         "out"}], " ", "*)"}], "\n", " ", 
       RowBox[{
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"inputbuffer2", " ", "==", " ", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"w", " ", "=", " ", "\"\<)\>\""}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"w", " ", "=", " ", 
            RowBox[{"First", "@", " ", "inputbuffer2"}]}], ";", "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"Rest", "@", " ", "inputbuffer2"}]}]}]}], " ", "]"}], ";",
         "\n", " ", 
        RowBox[{"Switch", "[", "\n", " ", 
         RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
             RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", ",", 
          "\n", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"While", "[", " ", 
             RowBox[{
              RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
               RowBox[{"(", 
                RowBox[{"d", " ", "=", " ", 
                 RowBox[{"getexp", "[", "True", "]"}]}], ")"}]}], ",", "\n", 
              " ", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", "\n", 
            " ", 
            RowBox[{"Return", "@", " ", "l"}]}], "\n", ")"}], ",", "\n", " ", 
          "_", ",", " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"atom", "[", "x_", "]"}], " ", ":=", "\n", " ", 
     RowBox[{"MatchQ", "[", " ", 
      RowBox[{"x", ",", " ", 
       RowBox[{
        RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], " ", "]"}]}],
     ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"car", "[", "x_", "]"}], " ", ":=", "\n", " ", 
     RowBox[{"If", "[", " ", 
      RowBox[{
       RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
       RowBox[{"First", "@", " ", "x"}]}], " ", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"cdr", "[", "x_", "]"}], " ", ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", "\n", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
         RowBox[{"Rest", "@", " ", "x"}]}], " ", "]"}]}], "]"}]}], ";"}], 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"cons", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", "\n", " ", 
     RowBox[{"If", "[", " ", 
      RowBox[{
       RowBox[{"MatchQ", "[", 
        RowBox[{"y", ",", 
         RowBox[{"_String", "|", "_Integer"}]}], "]"}], ",", " ", "x", ",", 
       " ", 
       RowBox[{"Prepend", "[", 
        RowBox[{"y", ",", "x"}], "]"}]}], " ", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"without", " ", "lamda"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
     "\n", 
     RowBox[{"Module", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
         RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", "args", 
         ",", " ", "x", ",", " ", "y", ",", " ", "z"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"debug", "@", "e"}], ";", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<int\>\"", ",", "e"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"e", ",", "_String"}], "]"}], ",", "  ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<str\>\"", ",", "e"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"atom", "@", " ", "e"}], ",", " ", 
            RowBox[{"Block", "[", " ", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n",
               "   ", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
                "a"}], ";", "\n", "   ", 
               RowBox[{"pos", " ", "=", " ", 
                RowBox[{"Position", "[", 
                 RowBox[{"names", ",", "e", ",", 
                  RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", 
               RowBox[{"debug", "@", 
                RowBox[{"{", 
                 RowBox[{"\"\<->\>\"", ",", "a", ",", "e", ",", 
                  RowBox[{"values", "[", 
                   RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 "}"}]}], ";", "  ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{"pos", " ", "==", " ", 
                   RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                  RowBox[{"values", "[", 
                   RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                 " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", " ", 
        RowBox[{"f", " ", "=", 
         RowBox[{"eval", "[", 
          RowBox[{
           RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], ";",
         "\[IndentingNewLine]", " ", 
        RowBox[{"e", " ", "=", " ", 
         RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<f \>\"", ",", "f", ",", "\"\< \>\"", ",", "e"}], 
          "}"}]}], ";", "\n", " ", 
        RowBox[{"Switch", "[", "\n", " ", 
         RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<'() \>\"", ",", "f", ",", "\"\< e= \>\"", ",", "e", ",", 
              RowBox[{"car", "@", " ", "e"}]}], "}"}]}], ";", " ", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"car", "@", " ", "e"}]}]}], ",", "\n", " ", "\"\<if\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", "\n", " ", 
           RowBox[{"If", "[", "\n", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"eval", "[", 
               RowBox[{
                RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}], 
              " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
             RowBox[{"eval", "[", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], "]"}],
              ",", "\n", " ", 
             RowBox[{"eval", "[", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", 
                 RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
              "]"}]}], "\n", " ", "]"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"TODO", ":", " ", 
           RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
          "*)"}], "\n", " ", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{
          "\"\<before args \>\"", ",", "\"\< \>\"", ",", "f", ",", 
           "\"\< \>\"", " ", ",", "e"}], "}"}]}], ";", "\n", 
        RowBox[{"args", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"eval", "[", 
            RowBox[{
             RowBox[{"e", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", 
             RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<args \>\"", ",", "\"\< \>\"", ",", "args"}], "}"}]}], 
        ";", "\n", " ", 
        RowBox[{"x", " ", "=", " ", 
         RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
        RowBox[{"y", " ", "=", " ", 
         RowBox[{"car", "@", 
          RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
        RowBox[{"z", " ", "=", " ", 
         RowBox[{"car", "@", 
          RowBox[{"cdr", "@", 
           RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", 
        "\[IndentingNewLine]", " ", 
        RowBox[{"Switch", "[", "\n", 
         RowBox[{
         "f", ",", "\[IndentingNewLine]", "\n", " ", "\"\<read-bit\>\"", ",", 
          " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", "\"\<read-exp\>\"",
           ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"getrecord", "[", "]"}], ";", " ", 
             RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<bits\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Flatten", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{"Rest", "@", " ", 
                RowBox[{"IntegerDigits", "[", 
                 RowBox[{
                  RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                 "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
             "                            ", 
             RowBox[{"ToCharacterCode", "[", " ", 
              RowBox[{
               RowBox[{"output", "@", "x"}], " ", "<>", " ", "\"\<\\n\>\""}], 
              " ", "]"}]}], " ", "]"}]}], ",", "\n", " ", "\"\<car\>\"", ",", 
          " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"", 
          ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", ",", 
              "y", ",", "z"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
          "\"\<cons\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"cons", "[", 
            RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", "\"\<size\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"StringLength", "@", " ", 
            RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
          "\"\<length\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", "\"\<+\>\"", 
          ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", ",", 
              "y", ",", "z"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
              RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
          "\"\<-\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
              RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<*\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
             RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<^\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
             RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<<\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
          "\"\<base10-to-2\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"IntegerDigits", "[", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", "\n", 
          " ", "\"\<base2-to-10\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Fold", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}], 
               ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}], 
          ",", "\n", " ", "\"\<append\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Join", "[", " ", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"atom", "@", "x"}], ",", 
               RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"atom", "@", "y"}], ",", 
               RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
          "\n", " ", "\"\<atom\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<=\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"", 
             ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<display\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"out", ",", "x"}], "]"}], ";", "\n", "               ", 
             
             RowBox[{"If", "[", " ", 
              RowBox[{"display", ",", " ", 
               RowBox[{"print", "[", " ", 
                RowBox[{"\"\<display\>\"", ",", " ", 
                 RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
              "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", "\n", 
          " ", "\"\<debug\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"print", "[", " ", 
              RowBox[{"\"\<debug\>\"", ",", " ", 
               RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
             "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
        "\[IndentingNewLine]", "\n", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
            RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", "]"}], 
          ";", "\n", " ", 
          RowBox[{"d", "--"}], ";", "\n", " ", 
          RowBox[{"Switch", "[", "\n", " ", 
           RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
            RowBox[{"Return", "@", " ", 
             RowBox[{"eval", "[", 
              RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", " ", 
            "\"\<try\>\"", ",", " ", 
            RowBox[{"Return", "@", "\n", " ", 
             RowBox[{"Block", "[", " ", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"out", " ", "=", " ", 
                  RowBox[{"{", "}"}]}], ",", " ", 
                 RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                 RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                 "xx"}], "}"}], ",", "\n", " ", 
               RowBox[{
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                  ",", " ", 
                  RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                  RowBox[{"xx", " ", "=", " ", 
                   RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n", 
                " ", 
                RowBox[{
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                   RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                 " ", 
                 RowBox[{
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
              "]"}]}]}], " ", 
           RowBox[{"(*", " ", 
            RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
          ";"}], " ", 
         RowBox[{"(*", " ", 
          RowBox[{"end", " ", "switch"}], " ", "*)"}], "\[IndentingNewLine]", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<end \>\"", ",", "e"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"f", " ", "=", " ", 
           RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", "\n", 
          RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
           RowBox[{
            RowBox[{"f", " ", "=", " ", 
             RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"eval", "[", " ", 
             RowBox[{
              RowBox[{"car", "@", 
               RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
              RowBox[{"bind", "[", 
               RowBox[{
                RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
               "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{"eval", "[", " ", 
           RowBox[{
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
            RowBox[{"bind", "[", " ", 
             RowBox[{
              RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], "]"}], 
            ",", " ", "d"}], " ", "]"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval2", "[", 
      RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
     "\n", 
     RowBox[{"Module", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
         RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", "args", 
         ",", " ", "x", ",", " ", "y", ",", " ", "z", ",", "values", ",", 
         "pos", ",", "xxx", ",", "vars", ",", "func", ",", "names0"}], "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"debug", "@", "e"}], ";", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<int\>\"", ",", "e"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", 
        "\[IndentingNewLine]", "   ", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", "a"}], ";", 
        RowBox[{"pos", " ", "=", " ", 
         RowBox[{"Position", "[", 
          RowBox[{"names0", ",", "e", ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"e", ",", "_String"}], "]"}], "&&", 
           RowBox[{"pos", "\[Equal]", 
            RowBox[{"{", "}"}]}]}], ",", "  ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<str\>\"", ",", "e"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", "\n", " ", 
        
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"atom", "@", " ", "e"}], ",", " ", 
          RowBox[{"Block", "[", " ", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"(*", 
              RowBox[{"names", ",", "values", ",", "pos"}], "*)"}], "}"}], 
            ",", "\n", "   ", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", "a"}],
              ";", "\n", "   ", 
             RowBox[{"pos", " ", "=", " ", 
              RowBox[{"Position", "[", 
               RowBox[{"names0", ",", "e", ",", 
                RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", 
             RowBox[{"debug", "@", 
              RowBox[{"{", 
               RowBox[{"\"\<->\>\"", ",", "a", ",", "e", ",", 
                RowBox[{"values", "[", 
                 RowBox[{"[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
               "}"}]}], ";", "  ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"pos", " ", "==", " ", 
                 RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                RowBox[{"values", "[", 
                 RowBox[{"[", 
                  RowBox[{"pos", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
               " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";", "\n", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
        RowBox[{"f", " ", "=", 
         RowBox[{"eval2", "[", 
          RowBox[{
           RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], ";",
         "\[IndentingNewLine]", " ", 
        RowBox[{"e", " ", "=", " ", 
         RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<f \>\"", ",", "f", ",", "\"\< \>\"", ",", "e"}], 
          "}"}]}], ";", "\n", " ", 
        RowBox[{"Switch", "[", "\n", " ", 
         RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<'() \>\"", ",", "f", ",", "\"\< e= \>\"", ",", "e", ",", 
              RowBox[{"car", "@", " ", "e"}]}], "}"}]}], ";", " ", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"car", "@", " ", "e"}]}]}], ",", "\n", " ", "\"\<if\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", "\n", " ", 
           RowBox[{"If", "[", "\n", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"eval2", "[", 
               RowBox[{
                RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}], 
              " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
             RowBox[{"eval2", "[", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], "]"}],
              ",", "\n", " ", 
             RowBox[{"eval2", "[", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", 
                 RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
              "]"}]}], "\n", " ", "]"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{"TODO", ":", " ", 
           RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
          "*)"}], "\n", " ", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{
          "\"\<before args \>\"", ",", "\"\< \>\"", ",", "f", ",", 
           "\"\< \>\"", " ", ",", "e"}], "}"}]}], ";", "\n", 
        RowBox[{"args", " ", "=", " ", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"eval2", "[", 
            RowBox[{
             RowBox[{"e", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", 
             RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<args \>\"", ",", "\"\< \>\"", ",", "args"}], "}"}]}], 
        ";", "\n", " ", 
        RowBox[{"x", " ", "=", " ", 
         RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
        RowBox[{"y", " ", "=", " ", 
         RowBox[{"car", "@", 
          RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
        RowBox[{"z", " ", "=", " ", 
         RowBox[{"car", "@", 
          RowBox[{"cdr", "@", 
           RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", 
        "\[IndentingNewLine]", "\n", " ", 
        RowBox[{"Switch", "[", "\n", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "@", "f"}], "\[GreaterEqual]", "3"}], ",", 
            RowBox[{
             RowBox[{"vars", "=", 
              RowBox[{
               RowBox[{"f", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", 
             RowBox[{"func", "=", 
              RowBox[{
               RowBox[{"f", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ";", 
             RowBox[{"f", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], ",", " ", "f"}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\"\<lambda\>\"", ",", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<...\>\"", ",", "f", ",", "e", ",", "\"\< vars \>\"", ",", 
              "vars", ",", " ", "\"\<  func \>\"", ",", "func"}], "}"}]}], 
           ";", 
           RowBox[{"xxx", "=", 
            RowBox[{"func", "/.", 
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"vars", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], "\[Rule]", 
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}]}], ",", 
               RowBox[{"{", 
                RowBox[{"ii", ",", "1", ",", " ", 
                 RowBox[{"Length", "@", "vars"}]}], "}"}]}], "]"}]}]}], ";", 
           RowBox[{"Return", "@", "xxx"}]}], ",", "\n", " ", 
          "\"\<read-bit\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", "\"\<read-exp\>\"",
           ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"getrecord", "[", "]"}], ";", " ", 
             RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<bits\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Flatten", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"(", " ", 
               RowBox[{"Rest", "@", " ", 
                RowBox[{"IntegerDigits", "[", 
                 RowBox[{
                  RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                 "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
             "                            ", 
             RowBox[{"ToCharacterCode", "[", " ", 
              RowBox[{
               RowBox[{"output", "@", "x"}], " ", "<>", " ", "\"\<\\n\>\""}], 
              " ", "]"}]}], " ", "]"}]}], ",", "\n", " ", "\"\<car\>\"", ",", 
          " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"", 
          ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", ",", 
              "y", ",", "z"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
          "\"\<cons\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"cons", "[", 
            RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", "\"\<size\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"StringLength", "@", " ", 
            RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
          "\"\<length\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", "\"\<+\>\"", 
          ",", " ", 
          RowBox[{
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", ",", 
              "y", ",", "z"}], "}"}]}], ";", 
           RowBox[{"Return", "@", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
              RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
          "\"\<-\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
              RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<*\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
             RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<^\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
             RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
          "\"\<<\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"", 
          ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
              RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
          "\"\<base10-to-2\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"IntegerDigits", "[", 
            RowBox[{
             RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", "\n", 
          " ", "\"\<base2-to-10\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Fold", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}], 
               ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}], 
          ",", "\n", " ", "\"\<append\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"Join", "[", " ", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"atom", "@", "x"}], ",", 
               RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"atom", "@", "y"}], ",", 
               RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
          "\n", " ", "\"\<atom\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", ",", 
             " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<=\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"", 
             ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
          "\"\<display\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"out", ",", "x"}], "]"}], ";", "\n", "               ", 
             
             RowBox[{"If", "[", " ", 
              RowBox[{"display", ",", " ", 
               RowBox[{"print", "[", " ", 
                RowBox[{"\"\<display\>\"", ",", " ", 
                 RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
              "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", "\n", 
          " ", "\"\<debug\>\"", ",", " ", 
          RowBox[{"Return", "@", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"print", "[", " ", 
              RowBox[{"\"\<debug\>\"", ",", " ", 
               RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
             "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
            RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", "]"}], 
          ";", "\n", " ", 
          RowBox[{"d", "--"}], ";", "\n", " ", 
          RowBox[{"Switch", "[", "\n", " ", 
           RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
            RowBox[{"Return", "@", " ", 
             RowBox[{"eval", "[", 
              RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", " ", 
            "\"\<try\>\"", ",", " ", 
            RowBox[{"Return", "@", "\n", " ", 
             RowBox[{"Block", "[", " ", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"out", " ", "=", " ", 
                  RowBox[{"{", "}"}]}], ",", " ", 
                 RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                 RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                 "xx"}], "}"}], ",", "\n", " ", 
               RowBox[{
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                  ",", " ", 
                  RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                  RowBox[{"xx", " ", "=", " ", 
                   RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n", 
                " ", 
                RowBox[{
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                   RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                 " ", 
                 RowBox[{
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
              "]"}]}]}], " ", 
           RowBox[{"(*", " ", 
            RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
          ";"}], " ", 
         RowBox[{"(*", " ", 
          RowBox[{"end", " ", "switch"}], " ", "*)"}], "\[IndentingNewLine]", 
         "*)"}], "\n", 
        RowBox[{"debug", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<end \>\"", ",", "e"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"f", " ", "=", " ", 
           RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", "\n", 
          RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
           RowBox[{
            RowBox[{"f", " ", "=", " ", 
             RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"eval", "[", " ", 
             RowBox[{
              RowBox[{"car", "@", 
               RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
              RowBox[{"bind", "[", 
               RowBox[{
                RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
               "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{"eval", "[", " ", 
           RowBox[{
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
            RowBox[{"bind", "[", " ", 
             RowBox[{
              RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], "]"}], 
            ",", " ", "d"}], " ", "]"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}], 
    ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"nmb", "[", "n_Integer", "]"}], " ", ":=", " ", "n"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"nmb", "[", "x_", "]"}], " ", ":=", "x"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"bind", "[", 
      RowBox[{
       RowBox[{"vars_", "?", "atom"}], ",", "args_", ",", "a_"}], "]"}], " ", 
     ":=", "a"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"bind", "[", 
      RowBox[{"vars_", ",", "args_", ",", "a_"}], "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
         RowBox[{"bind", "[", " ", 
          RowBox[{
           RowBox[{"cdr", "@", " ", "vars"}], ",", " ", 
           RowBox[{"cdr", "@", " ", "args"}], ",", " ", "a"}], " ", "]"}]}], 
        ";", "\n", " ", 
        RowBox[{"pos", " ", "=", " ", 
         RowBox[{"Position", "[", 
          RowBox[{"names", ",", " ", 
           RowBox[{"car", "@", " ", "vars"}], ",", " ", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Prepend", "[", 
           RowBox[{
            RowBox[{"Delete", "[", 
             RowBox[{"names", ",", "pos"}], "]"}], ",", " ", 
            RowBox[{"car", "@", " ", "vars"}]}], "]"}], ",", "\n", "  ", 
          RowBox[{"Prepend", "[", 
           RowBox[{
            RowBox[{"Delete", "[", 
             RowBox[{"values", ",", "pos"}], "]"}], ",", " ", 
            RowBox[{"car", "@", " ", "args"}]}], "]"}]}], "}"}]}]}], "\n", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", "e_", "]"}], " ", ":=", "\n", 
     RowBox[{"(", "\n", " ", 
      RowBox[{
       RowBox[{"out", " ", "=", " ", 
        RowBox[{"tape", " ", "=", " ", 
         RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
       RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", " ", 
       RowBox[{"print", "[", " ", 
        RowBox[{"\"\<expression\>\"", ",", " ", 
         RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"debug", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<names,defs\>\"", ",", "names", ",", "defs"}], "}"}]}], 
       ";", "\n", " ", 
       RowBox[{"Catch", "[", " ", 
        RowBox[{"eval", "[", " ", 
         RowBox[{"e", ",", " ", 
          RowBox[{"{", 
           RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], " ",
          "]"}], " ", "]"}]}], "\n", ")"}]}], ";"}], "\[IndentingNewLine]", 
   "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval2", "[", "e_", "]"}], " ", ":=", "\n", 
     RowBox[{"(", "\n", " ", 
      RowBox[{
       RowBox[{"out", " ", "=", " ", 
        RowBox[{"tape", " ", "=", " ", 
         RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
       RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", " ", 
       RowBox[{"print", "[", " ", 
        RowBox[{"\"\<expression\>\"", ",", " ", 
         RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"debug", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<names,defs\>\"", ",", "names", ",", "defs"}], "}"}]}], 
       ";", "\n", " ", 
       RowBox[{"Catch", "[", " ", 
        RowBox[{"eval2", "[", " ", 
         RowBox[{"e", ",", " ", 
          RowBox[{"{", 
           RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], " ",
          "]"}], " ", "]"}]}], "\n", ")"}]}], ";"}], "\n", " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"eval", "[", 
      RowBox[{"e_", ",", "Null", ",", "d_"}], "]"}], " ", ":=", " ", 
     RowBox[{"eval", "[", 
      RowBox[{"e", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "\"\<nil\>\"", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "d"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"StringDrop", "[", " ", 
      RowBox[{
       RowBox[{"output2", "@", "x"}], " ", ",", 
       RowBox[{"-", "1"}]}], " ", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"let", "[", 
      RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", "\n", 
     RowBox[{"(", "\n", " ", 
      RowBox[{
       RowBox[{"print", "[", " ", 
        RowBox[{"\"\<define\>\"", ",", " ", 
         RowBox[{"output", "@", " ", "n"}]}], " ", "]"}], ";", "\n", " ", 
       RowBox[{"print", "[", " ", 
        RowBox[{"\"\<value\>\"", ",", " ", 
         RowBox[{"output", "@", " ", "d"}]}], " ", "]"}], ";", "\n", " ", 
       RowBox[{"PrependTo", "[", 
        RowBox[{"names", ",", "n"}], "]"}], ";", "\n", " ", 
       RowBox[{"PrependTo", "[", 
        RowBox[{"defs", ",", "d"}], "]"}], ";"}], "\n", ")"}]}], ";"}], 
   "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"output2", "[", "x_String", "]"}], " ", ":=", " ", 
      RowBox[{"x", "<>", "\"\< \>\""}]}], ";", "\n", 
     RowBox[{
      RowBox[{"output2", "[", "x_Integer", "]"}], " ", ":=", " ", 
      RowBox[{
       RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";"}], 
    "*)"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"output2", "[", "x_", "]"}], ":=", 
     RowBox[{
      RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"output2", "[", 
      RowBox[{"{", "x___", "}"}], "]"}], " ", ":=", "\n", 
     RowBox[{"Block", "[", " ", 
      RowBox[{
       RowBox[{"{", "s", "}"}], ",", "\n", " ", 
       RowBox[{
        RowBox[{"s", " ", "=", " ", 
         RowBox[{"StringJoin", "[", 
          RowBox[{"\"\<(\>\"", ",", " ", 
           RowBox[{"output2", " ", "/@", " ", 
            RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"StringTake", "[", 
            RowBox[{"s", ",", 
             RowBox[{"-", "1"}]}], "]"}], " ", "==", " ", "\"\< \>\""}], ",", 
          " ", 
          RowBox[{"s", " ", "=", " ", 
           RowBox[{"StringDrop", "[", 
            RowBox[{"s", ",", 
             RowBox[{"-", "1"}]}], "]"}]}]}], " ", "]"}], ";", "\n", " ", 
        RowBox[{"s", " ", "<>", " ", "\"\<) \>\""}]}]}], "\n", "]"}]}], ";"}],
    "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"StringDrop", "[", " ", 
      RowBox[{
       RowBox[{"output2", "@", "x"}], " ", ",", 
       RowBox[{"-", "1"}]}], " ", "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{"blanks", " ", "=", " ", 
     RowBox[{"StringJoin", "@", " ", 
      RowBox[{"Table", "[", 
       RowBox[{"\"\< \>\"", ",", 
        RowBox[{"{", "12", "}"}]}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"print", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"print2", "[", 
         RowBox[{"x", ",", 
          RowBox[{"StringTake", "[", 
           RowBox[{"y", ",", "50"}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", " ", 
        RowBox[{"print", "[", 
         RowBox[{"\"\<\>\"", ",", 
          RowBox[{"StringDrop", "[", 
           RowBox[{"y", ",", "50"}], "]"}]}], "]"}]}], ")"}], " ", "/;", " ", 
      
      RowBox[{
       RowBox[{"StringLength", "[", "y", "]"}], " ", ">", " ", "50"}]}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"print", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
     RowBox[{"print2", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"print2", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
     RowBox[{"print3", "[", 
      RowBox[{
       RowBox[{"StringTake", "[", 
        RowBox[{
         RowBox[{"x", "<>", "blanks"}], ",", "12"}], "]"}], "<>", "y"}], 
      "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"print3", "[", "x_", "]"}], " ", ":=", " ", 
     RowBox[{"(", 
      RowBox[{"Print", "[", "x", "]"}], 
      RowBox[{"(*", 
       RowBox[{";", " ", 
        RowBox[{"WriteString", "[", 
         RowBox[{"o", ",", "x", ",", "\"\<\\n\>\""}], "]"}]}], "*)"}], 
      ")"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721864180751973*^9, 3.721864181211351*^9}, {
   3.721864222760756*^9, 3.721864242290986*^9}, {3.7218642967995367`*^9, 
   3.7218643900988617`*^9}, {3.721864420410316*^9, 3.721864516541768*^9}, {
   3.721864576012495*^9, 3.7218646147579327`*^9}, {3.7218647381422462`*^9, 
   3.721864743979945*^9}, 3.721864928194749*^9, {3.721865071929214*^9, 
   3.7218650724909697`*^9}, {3.7218656279432793`*^9, 
   3.7218656282476683`*^9}, {3.721865727925737*^9, 3.721865731918797*^9}, {
   3.7218657802413282`*^9, 3.721865780768025*^9}, {3.721865820808866*^9, 
   3.721865821281938*^9}, {3.721866012808086*^9, 3.721866042272065*^9}, 
   3.721866099101348*^9, {3.721866169976863*^9, 3.7218662163330812`*^9}, {
   3.7218662757235613`*^9, 3.72186632652309*^9}, {3.721867011452612*^9, 
   3.72186701163204*^9}, {3.7218677841960497`*^9, 3.721867787964183*^9}, 
   3.721867827185918*^9, {3.7218678823374157`*^9, 3.72186788308949*^9}, {
   3.721867934056573*^9, 3.721867970246462*^9}, {3.721868078104185*^9, 
   3.721868090558421*^9}, 3.721869090745372*^9, {3.721869200958034*^9, 
   3.721869252731243*^9}, {3.72186928795935*^9, 3.7218692913207893`*^9}, {
   3.721869622306172*^9, 3.721869626918003*^9}, 3.721870615401579*^9, {
   3.7218706483627043`*^9, 3.7218706809851303`*^9}, {3.721870822648162*^9, 
   3.721870868038417*^9}, {3.7218709085511436`*^9, 3.72187091976793*^9}, {
   3.7218960233728647`*^9, 3.721896027152012*^9}, {3.721896139218297*^9, 
   3.72189614171425*^9}, {3.721896247335945*^9, 3.721896256626651*^9}, {
   3.721896291818499*^9, 3.7218963243435698`*^9}, {3.72189658194206*^9, 
   3.721896592302796*^9}, {3.721896734958989*^9, 3.721896738343347*^9}, {
   3.7218968616262627`*^9, 3.721896880952729*^9}, {3.721898019421989*^9, 
   3.721898041437955*^9}, {3.721898274906344*^9, 3.721898284490468*^9}, 
   3.721898590964106*^9, {3.7218986805390673`*^9, 3.721898692821916*^9}, {
   3.721898726462758*^9, 3.721898756039422*^9}, 3.7218989268662558`*^9, {
   3.7218989977213*^9, 3.7218990010637608`*^9}, 3.721899346088484*^9, 
   3.7219146239780617`*^9, 3.7219146983057404`*^9, {3.721915002642569*^9, 
   3.721915004338387*^9}, {3.7219160193828707`*^9, 3.721916028065941*^9}, {
   3.721916066160427*^9, 3.721916070100081*^9}, {3.7219161865748997`*^9, 
   3.721916189566887*^9}, 3.721916694203191*^9, 3.7219167520614862`*^9, {
   3.721917406440226*^9, 3.721917485776243*^9}, {3.721917525504282*^9, 
   3.721917531317904*^9}, 3.721917636162994*^9, {3.721917792327011*^9, 
   3.72191780494908*^9}, {3.7219181499419413`*^9, 3.72191817633672*^9}, 
   3.721918222755033*^9, {3.721921624146212*^9, 3.721921678890603*^9}, {
   3.721921722901515*^9, 3.72192175796266*^9}, {3.721921790494143*^9, 
   3.7219217939585047`*^9}, {3.721921893167983*^9, 3.721921901365158*^9}, {
   3.7219219513623962`*^9, 3.721922073102334*^9}, {3.721922114810646*^9, 
   3.721922135590043*^9}, {3.721922251243947*^9, 3.721922252952924*^9}, {
   3.721922748226305*^9, 3.721922753569705*^9}, {3.721922997004706*^9, 
   3.721923008187957*^9}, {3.721923041570983*^9, 3.721923046328455*^9}, {
   3.7219234997307568`*^9, 3.7219235034081793`*^9}, {3.721923672569316*^9, 
   3.721923676394619*^9}, {3.721924314424672*^9, 3.721924321892393*^9}, {
   3.721925163265181*^9, 3.721925182862689*^9}, {3.721925840671072*^9, 
   3.72192585019879*^9}, {3.721926049300531*^9, 3.72192605015177*^9}, {
   3.7219297071074553`*^9, 3.721929708492154*^9}, {3.721929746577079*^9, 
   3.721929747711217*^9}, {3.721931026977687*^9, 3.7219310662201433`*^9}, {
   3.72193114541359*^9, 3.721931150757114*^9}, {3.721931529602199*^9, 
   3.721931531321807*^9}, {3.721931849987727*^9, 3.721931851831608*^9}, {
   3.7219328699040213`*^9, 3.721932875311227*^9}, {3.721932905780499*^9, 
   3.7219329250506153`*^9}, {3.721939539492565*^9, 3.721939542649623*^9}, {
   3.721939583184319*^9, 3.721939598877963*^9}, {3.721939696726117*^9, 
   3.721939700333826*^9}, {3.721940210968512*^9, 3.7219402134985456`*^9}, {
   3.721940453853544*^9, 3.721940456183032*^9}, {3.721940492294046*^9, 
   3.721940525268189*^9}, {3.721940573906904*^9, 3.721940605632248*^9}, {
   3.7219406932739067`*^9, 3.721940695241054*^9}, {3.72194080626939*^9, 
   3.721940819963108*^9}, {3.7219410267574787`*^9, 3.721941032684641*^9}, {
   3.721941285111377*^9, 3.7219412870541286`*^9}, {3.7219415663572702`*^9, 
   3.72194156955091*^9}, {3.721941753520103*^9, 3.721941774578266*^9}, {
   3.721942308724615*^9, 3.721942330413959*^9}, {3.72194241939537*^9, 
   3.721942435728765*^9}, {3.7219430848339767`*^9, 3.72194309186244*^9}, {
   3.7219432058546143`*^9, 3.721943207393794*^9}, {3.721943254434992*^9, 
   3.721943261607173*^9}, {3.7219445522308826`*^9, 3.721944552766852*^9}, 
   3.7219449185755463`*^9, {3.7219506068638773`*^9, 3.7219506644325*^9}, {
   3.721951005348774*^9, 3.721951033012793*^9}, {3.7219515925064983`*^9, 
   3.721951605477394*^9}, {3.721951636596833*^9, 3.72195167043645*^9}, 
   3.7219517164214907`*^9, {3.721951771086102*^9, 3.721951771408766*^9}, {
   3.7219519371158047`*^9, 3.7219519484104757`*^9}, 3.72195209783109*^9, {
   3.721984297286619*^9, 3.72198430037755*^9}, {3.721985330471446*^9, 
   3.721985338210517*^9}, {3.721985469439636*^9, 3.7219854767476873`*^9}, 
   3.721985563886447*^9, {3.721986204649358*^9, 3.721986223008464*^9}, {
   3.721986265595373*^9, 3.72198626899162*^9}, {3.721986315668244*^9, 
   3.721986348687832*^9}, {3.7220111825209618`*^9, 3.722011203681931*^9}, {
   3.722014215913432*^9, 3.7220143047094173`*^9}, {3.722064797062353*^9, 
   3.722064798250634*^9}, {3.7220652501610813`*^9, 3.722065267455434*^9}, {
   3.7220653847569847`*^9, 3.722065384824725*^9}, {3.7220654270354652`*^9, 
   3.722065439804022*^9}, {3.722069415890911*^9, 3.72206949592749*^9}, {
   3.722069881716425*^9, 3.722069912449271*^9}, {3.722069978406415*^9, 
   3.722069979103271*^9}, {3.722203729789789*^9, 3.722203733201858*^9}, {
   3.722205755924243*^9, 3.722205769739451*^9}, {3.7222058282176533`*^9, 
   3.7222058594165773`*^9}, {3.72220855355488*^9, 3.722208555049157*^9}, {
   3.722209070201647*^9, 3.722209074218848*^9}, {3.7222091298521013`*^9, 
   3.722209156896344*^9}, {3.72220920511617*^9, 3.722209205487262*^9}, {
   3.722209263659711*^9, 3.722209278994217*^9}, {3.722212310686336*^9, 
   3.722212325064093*^9}, {3.722212380000111*^9, 3.72221249915273*^9}, {
   3.722212771648139*^9, 3.722212804027883*^9}, {3.722212864568344*^9, 
   3.7222128650705843`*^9}, {3.722212920738988*^9, 3.7222129291074047`*^9}, {
   3.7222129931227922`*^9, 3.722212993425951*^9}, {3.72221310996987*^9, 
   3.72221311219569*^9}, {3.722213184694092*^9, 3.722213199972281*^9}, {
   3.7222132337469587`*^9, 3.7222132351395187`*^9}, {3.722213273987753*^9, 
   3.722213285991846*^9}, 3.722213332287715*^9, {3.7222134255066223`*^9, 
   3.722213432528515*^9}, 3.722213686764551*^9, {3.7222139673814373`*^9, 
   3.722213971959367*^9}, {3.722214053019112*^9, 3.722214098741384*^9}, {
   3.7222141451459618`*^9, 3.722214184536069*^9}, {3.722222744978352*^9, 
   3.722222769896249*^9}, {3.722222898206993*^9, 3.7222229030211983`*^9}, {
   3.722222942702482*^9, 3.7222229474072447`*^9}, {3.722223012620635*^9, 
   3.7222230369778557`*^9}, {3.722273618423113*^9, 3.722273691183381*^9}, {
   3.722273790479323*^9, 3.7222738228461447`*^9}, {3.722274061175516*^9, 
   3.7222741195419207`*^9}, {3.722274276564543*^9, 3.722274277473497*^9}, {
   3.7222743594328947`*^9, 3.722274379830227*^9}, {3.722274885748001*^9, 
   3.722274888563414*^9}, {3.722274969283711*^9, 
   3.7222749724792624`*^9}},ExpressionUUID->"b04d84d0-3bfa-4fc8-92c3-\
afa2f7bf999b"]
},
WindowSize->{1200, 1350},
WindowMargins->{{Automatic, 485}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"ba343cbf-54e6-44c7-b1e2-54bc131ecd4f"],
Cell[1747, 54, 74967, 1704, 8536, "Input",ExpressionUUID->"b04d84d0-3bfa-4fc8-92c3-afa2f7bf999b"]
}
]
*)

