(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    111234,       2515]
NotebookOptionsPosition[    106013,       2421]
NotebookOutlinePosition[    106398,       2438]
CellTagsIndexPosition[    106355,       2435]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"7deb1d31-4a4a-408d-81d3-\
395bcc583d41"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PNG", "\[Equal]", "True"}], ",", 
     RowBox[{"ImportString", "@", 
      RowBox[{"ExportString", "[", 
       RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"highlightCORRECT", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"debug", "\[Equal]", "False"}], ",", "s", ",", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PNG", "=", "True"}], ";"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"debug", "=", "True"}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Clear", "[", "debug", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myFONTSIZE", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myLINEBREAKS", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textFORMAT", "[", "s_", "]"}], ":=", 
   RowBox[{"Text", "[", 
    RowBox[{"Style", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InsertLinebreaks", "[", 
       RowBox[{
        RowBox[{"ToString", "@", "s"}], ",", "myLINEBREAKS"}], "]"}], ",", 
      "myFONTSIZE", ",", 
      RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"textFORMAT2", "[", "s_", "]"}], ":=", 
    RowBox[{"Text", "[", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"InsertLinebreaks", "[", 
        RowBox[{"s", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
       RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lisp", "[", "expression0_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"expression", ",", "list"}], "}"}], ",", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"word2", "[", "]"}], ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"w", ",", "line", ",", "str"}], "}"}], ",", "\n", 
          RowBox[{
           RowBox[{"While", "[", "\n", " ", 
            RowBox[{
             RowBox[{"inputbuffer", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", "\n", " ", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"line", " ", "=", " ", 
                RowBox[{"Read", "[", 
                 RowBox[{"i", ",", "Record"}], "]"}]}], ";", "\n", " ", 
               RowBox[{"If", "[", " ", 
                RowBox[{
                 RowBox[{"line", " ", "==", " ", "EndOfFile"}], ",", " ", 
                 RowBox[{"Abort", "[", "]"}]}], " ", "]"}], ";", "\n", " ", 
               RowBox[{"Print", "@", " ", "line"}], ";", "\n", " ", 
               RowBox[{"Print", "[", 
                RowBox[{"{", 
                 RowBox[{"o", ",", "line"}], "}"}], "]"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"line", "=", "code"}], ";", "\n", " ", 
              RowBox[{"(*", " ", 
               RowBox[{
               "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
                "codes"}], " ", "*)"}], "\n", " ", 
              RowBox[{"line", " ", "=", " ", 
               RowBox[{"FromCharacterCode", "@", "\n", " ", 
                RowBox[{"Cases", "[", " ", 
                 RowBox[{
                  RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
                  RowBox[{"n_Integer", " ", "/;", " ", 
                   RowBox[{
                   "32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], " ",
                  "]"}]}]}], ";", "\n", " ", 
              RowBox[{"str", " ", "=", " ", 
               RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
              RowBox[{"inputbuffer", " ", "=", " ", 
               RowBox[{"ReadList", "[", 
                RowBox[{
                "str", ",", " ", "Word", ",", "\n", 
                 "                        ", 
                 RowBox[{"TokenWords", "->", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<(\>\"", ",", " ", "\"\<)\>\"", ",", " ", "\"\<[\>\"", 
                    ",", " ", "\"\<]\>\"", ",", " ", "\"\<'\>\"", ",", " ", 
                    "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], ";", "\n", " ", 
              RowBox[{"Close", "@", " ", "str"}]}]}], "\n", "]"}], ";", "\n", 
           
           RowBox[{"w", " ", "=", " ", 
            RowBox[{"First", "@", " ", "inputbuffer"}]}], ";", "\n", 
           RowBox[{"inputbuffer", " ", "=", " ", 
            RowBox[{"Rest", "@", " ", "inputbuffer"}]}], ";", 
           "\[IndentingNewLine]", "\n", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DigitQ", "@", "w"}], ",", " ", 
             RowBox[{"ToExpression", "@", "w"}], ",", " ", "w"}], "]"}]}]}], 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "convert", " ", "string", " ", "of", " ", "digits", " ", "to", " ", 
           "integer"}], " ", "*)"}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"word", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "w", "}"}], ",", "\n", 
          RowBox[{"While", "[", " ", 
           RowBox[{"True", ",", "\n", " ", 
            RowBox[{
             RowBox[{"w", " ", "=", " ", 
              RowBox[{"word2", "[", "]"}]}], ";", "\n", " ", 
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"w", " ", "=!=", " ", "\"\<[\>\""}], ",", " ", 
               RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", 
             " ", 
             RowBox[{"While", "[", " ", 
              RowBox[{
               RowBox[{"word", "[", "]"}], " ", "=!=", " ", "\"\<]\>\""}], 
              " ", "]"}]}]}], "\n", "]"}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"get", "[", 
         RowBox[{
          RowBox[{"sexp_:", "False"}], ",", 
          RowBox[{"rparenokay_:", "False"}]}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"w", " ", "=", " ", 
             RowBox[{"word", "[", "]"}]}], ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", 
             RowBox[{"{", "}"}]}], ",", " ", "name", ",", " ", "def", ",", 
            " ", "body", ",", " ", "varlist"}], "}"}], ",", 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", " ", 
             RowBox[{
              RowBox[{"While", "[", " ", 
               RowBox[{
                RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                 RowBox[{"(", 
                  RowBox[{"d", " ", "=", " ", 
                   RowBox[{"get", "[", 
                    RowBox[{"sexp", ",", "True"}], "]"}]}], ")"}]}], ",", 
                "\n", " ", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
              "\n", " ", 
              RowBox[{"Return", "@", " ", "l"}]}]}], "\n", " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"sexp", ",", " ", 
             RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<\\\"\>\"", ",", " ", 
             RowBox[{"get", "[", "True", "]"}], ",", "\n", " ", 
             "\"\<cadr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}], ",", "\n", " ", 
             "\"\<caddr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<cdr\>\"", ",", 
                   RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], ",", 
             "\n", " ", "\"\<let\>\"", ",", "\n", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"name", ",", "def", ",", "body"}], "}"}], " ", "=", 
               " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], ";", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{"!", 
                 RowBox[{"MatchQ", "[", 
                  RowBox[{"name", ",", 
                   RowBox[{
                    RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], 
                  "]"}]}], ",", "\n", " ", 
                RowBox[{
                 RowBox[{"varlist", " ", "=", " ", 
                  RowBox[{"Rest", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"name", " ", "=", " ", 
                  RowBox[{"First", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"def", " ", "=", " ", 
                  RowBox[{"{", 
                   RowBox[{"\"\<'\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<lambda\>\"", ",", "varlist", ",", "def"}], 
                    "}"}]}], "}"}]}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<'\>\"", ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<lambda\>\"", ",", 
                    RowBox[{"{", "name", "}"}], ",", "body"}], "}"}]}], "}"}],
                 ",", "def"}], "}"}]}], ",", "\n", " ", 
             RowBox[{"\"\<read-bit\>\"", "|", "\"\<read-exp\>\""}], ",", "\n",
              "                   ", 
             RowBox[{"{", "w", "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<car\>\"", "|", "\"\<cdr\>\"", "|", "\"\<atom\>\"", "|", 
              "\"\<'\>\"", "|", "\"\<display\>\"", "|", "\"\<eval\>\"", "|", 
              "\"\<bits\>\"", "|", "\"\<debug\>\"", "|", "\n", " ", 
              "\"\<length\>\"", "|", "\"\<size\>\"", "|", 
              "\"\<base2-to-10\>\"", "|", "\"\<base10-to-2\>\""}], ",", "\n", 
             "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<cons\>\"", "|", "\"\<=\>\"", "|", "\"\<lambda\>\"", "|", 
              "\"\<append\>\"", "|", "\"\<define\>\"", "|", "\"\<+\>\"", "|", 
              "\"\<-\>\"", "|", "\"\<*\>\"", "|", "\"\<^\>\"", "|", 
              "\"\<<\>\"", "|", "\"\<>\>\"", "|", "\"\<<=\>\"", "|", 
              "\"\<>=\>\""}], ",", "\n", "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{"\"\<if\>\"", "|", "\"\<let\>\"", "|", "\"\<try\>\""}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", "_", ",", 
             " ", "w"}], "\n", " ", "]"}]}]}], "\[IndentingNewLine]", "\n", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"getbit", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "x", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"trouble", " ", "=", " ", "False"}], ";", " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "tape"}], ",", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"trouble", " ", "=", " ", "True"}], ";", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], ")"}]}], 
            "]"}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"x", " ", "===", " ", "0"}], ",", " ", "0", ",", " ", 
             "1"}], " ", "]"}]}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getchar", "[", "]"}], " ", ":=", " ", 
        RowBox[{"FromCharacterCode", "[", "\n", "  ", 
         RowBox[{
          RowBox[{"128", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"64", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"32", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"16", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", "\n", "  ", 
          RowBox[{"8", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"4", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"2", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"getbit", "[", "]"}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getrecord", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"c", ",", " ", 
            RowBox[{"line", " ", "=", " ", "\"\<\>\""}], ",", " ", "str"}], 
           " ", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"{", "}"}]}], ";", "\n", " ", 
           RowBox[{"While", "[", " ", 
            RowBox[{
             RowBox[{"\"\<\\n\>\"", " ", "=!=", " ", 
              RowBox[{"(", 
               RowBox[{"c", " ", "=", " ", 
                RowBox[{"getchar", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             RowBox[{"line", " ", "=", " ", 
              RowBox[{"line", " ", "<>", " ", "c"}]}]}], " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"trouble", ",", " ", 
             RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], "]"}], ";",
            " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
             "codes"}], " ", "*)"}], "\n", " ", 
           RowBox[{"line", " ", "=", " ", 
            RowBox[{"FromCharacterCode", "@", "\n", " ", 
             RowBox[{"Cases", "[", " ", 
              RowBox[{
               RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
               RowBox[{"n_Integer", " ", "/;", " ", 
                RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}],
               " ", "]"}]}]}], ";", "\n", " ", 
           RowBox[{"str", " ", "=", " ", 
            RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"ReadList", "[", 
             RowBox[{"str", ",", " ", "Word", ",", " ", 
              RowBox[{"TokenWords", "->", 
               RowBox[{"{", 
                RowBox[{"\"\<(\>\"", ",", " ", "\"\<)\>\""}], "}"}]}]}], 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"Close", "@", " ", "str"}], ";", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "convert", " ", "strings", " ", "of", " ", "digits", " ", "to", 
             " ", "integers"}], " ", "*)"}], "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"DigitQ", "@", "#"}], ",", " ", 
                RowBox[{"ToExpression", "@", "#"}], ",", " ", "#"}], "]"}], 
              "&"}], " ", "/@", " ", "inputbuffer2"}]}], " ", ";"}]}], "\n", 
         "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getexp", "[", 
         RowBox[{"rparenokay_:", "False"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"w", ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", " ", 
             RowBox[{"{", "}"}]}]}], " ", "}"}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{" ", 
              RowBox[{"supply", " ", "unlimited", " ", "number", " ", "of"}], 
              " ", ")"}], "'"}], "s", " ", "if", " ", "tokens", " ", "run", 
            " ", "out"}], " ", "*)"}], "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"inputbuffer2", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", " ", 
             RowBox[{"w", " ", "=", " ", "\"\<)\>\""}], ",", "\n", " ", 
             RowBox[{
              RowBox[{"w", " ", "=", " ", 
               RowBox[{"First", "@", " ", "inputbuffer2"}]}], ";", "\n", " ", 
              
              RowBox[{"inputbuffer2", " ", "=", " ", 
               RowBox[{"Rest", "@", " ", "inputbuffer2"}]}]}]}], " ", "]"}], 
           ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"While", "[", " ", 
                RowBox[{
                 RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                  RowBox[{"(", 
                   RowBox[{"d", " ", "=", " ", 
                    RowBox[{"getexp", "[", "True", "]"}]}], ")"}]}], ",", 
                 "\n", " ", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
               "\n", " ", 
               RowBox[{"Return", "@", " ", "l"}]}], "\n", ")"}], ",", "\n", 
             " ", "_", ",", " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"atom", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"MatchQ", "[", " ", 
         RowBox[{"x", ",", " ", 
          RowBox[{
           RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], " ", 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"car", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
          RowBox[{"First", "@", " ", "x"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"cdr", "[", "x_", "]"}], " ", ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "\n", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
            RowBox[{"Rest", "@", " ", "x"}]}], " ", "]"}]}], "]"}]}], ";", 
       "\n", 
       RowBox[{
        RowBox[{"cons", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"y", ",", 
            RowBox[{"_String", "|", "_Integer"}]}], "]"}], ",", " ", "x", ",",
           " ", 
          RowBox[{"Prepend", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], " ", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval0", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z"}], "}"}], ",",
           "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "e"}], ",", " ", 
             RowBox[{"Block", "[", " ", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", 
               "\n", "   ", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
                 "a"}], ";", "\n", "   ", 
                RowBox[{"pos", " ", "=", " ", 
                 RowBox[{"Position", "[", 
                  RowBox[{"names", ",", "e", ",", 
                   RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", "   ", 
                RowBox[{"Print", "[", 
                 RowBox[{
                 "\"\<If atom \>\"", ",", "e", ",", "\"\< \>\"", ",", 
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                   " ", "]"}]}], "]"}], ";", 
                RowBox[{"Return", "@", " ", 
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                   RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                  " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<first f \>\"", ",", "f", ",", "e", ",", "\"\<cdr@e  \>\"", 
             ",", 
             RowBox[{"cdr", "@", " ", "e"}]}], "]"}], ";", "\n", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\n", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "e"}]}], ",", "\n", " ", "\"\<if\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"eval", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                  "]"}], " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                 "]"}], ",", "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                 "]"}]}], "\n", " ", "]"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{"{", "\"\<enter args \>\"", "}"}], "]"}], ";", "\n", " ", 
           
           RowBox[{"args", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"eval", "[", 
               RowBox[{"#", ",", "a", ",", "d"}], "]"}], "&"}], " ", "/@", 
             " ", "e"}]}], ";", 
           RowBox[{"Print", "[", 
            RowBox[{"{", 
             RowBox[{
             "\"\<#\>\"", ",", " ", "e", ",", "\"\<args \>\"", ",", "args"}], 
             "}"}], "]"}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<x  y z \>\"", ",", "x", ",", "\"\< \>\"", ",", "y", ",", 
             "\"\< \>\"", ",", "z"}], "]"}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<read-bit\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"",
              ",", 
             RowBox[{
              RowBox[{"Print", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr \>\"", ",", "e", ",", "x", ",", 
                 RowBox[{"cdr", "@", " ", "x"}]}], "}"}], "]"}], ";", " ", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", 
             RowBox[{"(*", " ", 
              RowBox[{"\"\<+\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                  RowBox[{"nmb", "@", "y"}]}], ")"}]}], ","}], "*)"}], 
             "\[IndentingNewLine]", "\"\<+\>\"", ",", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{"Total", "[", 
                RowBox[{"nmb", "/@", "args"}], "]"}], ")"}]}], ",", "\n", 
             " ", "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                 RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<*\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
             "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
             RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", "]"}],
            ";", "\n", " ", 
           RowBox[{"d", "--"}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"eval", "[", 
               RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", " ", 
             "\"\<try\>\"", ",", " ", 
             RowBox[{"Return", "@", "\n", " ", 
              RowBox[{"Block", "[", " ", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"out", " ", "=", " ", 
                   RowBox[{"{", "}"}]}], ",", " ", 
                  RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                  RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                  "xx"}], "}"}], ",", "\n", " ", 
                RowBox[{
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                   ",", " ", 
                   RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                   RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                  " ", 
                 RowBox[{
                  RowBox[{"If", "[", " ", 
                   RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                  " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
               "]"}]}]}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
           ";", " ", 
           RowBox[{"(*", " ", 
            RowBox[{"end", " ", "switch"}], " ", "*)"}], "\n", " ", 
           RowBox[{"f", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
           "\n", " ", 
           RowBox[{"eval", "[", " ", 
            RowBox[{
             RowBox[{"car", "@", 
              RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
             RowBox[{"bind", "[", 
              RowBox[{
               RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], "]"}],
              ",", " ", "d"}], " ", "]"}]}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Module", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"debug", "@", "e"}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<int\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_String"}], "]"}], ",", "  ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<str\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", "\n", 
           " ", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"atom", "@", " ", "e"}], ",", " ", 
               RowBox[{"Block", "[", " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", 
                 "\n", "   ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
                   "a"}], ";", "\n", "   ", 
                  RowBox[{"pos", " ", "=", " ", 
                   RowBox[{"Position", "[", 
                    RowBox[{"names", ",", "e", ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", "  ", 
                  RowBox[{"Return", "@", " ", 
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";"}], 
            "*)"}], "\[IndentingNewLine]", "\n", "\[IndentingNewLine]", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\[IndentingNewLine]", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<f \>\"", ",", "f", ",", "\"\< \>\"", ",", "e"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<DARA\>\"", ",", "\"\<'() \>\"", ",", "f", ",", 
                 "\"\< e= \>\"", ",", "e", ",", 
                 RowBox[{"car", "@", 
                  RowBox[{"(", 
                   RowBox[{"e", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}], "}"}]}], ";", 
              " ", 
              RowBox[{"Return", "@", 
               RowBox[{"car", "@", 
                RowBox[{"e", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}]}]}], ",", "\n", " ", 
             "\"\<if\>\"", ",", " ", 
             RowBox[{"Return", "@", "\n", " ", 
              RowBox[{"If", "[", "\[IndentingNewLine]", "\n", 
               RowBox[{
                RowBox[{
                 RowBox[{"eval", "[", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"car", "@", " ", "e"}], ")"}], ",", "a", ",", 
                   "d"}], "]"}], "=!=", " ", 
                 RowBox[{"{", "\"\<false\>\"", "}"}]}], ",", " ", 
                RowBox[{"(*", 
                 RowBox[{"DARA", ":", " ", 
                  RowBox[{
                   RowBox[{"{", " ", "}"}], " ", "was", " ", "braced", " ", 
                   "since", " ", "the", " ", "return", " ", "from", " ", 
                   "boolean", " ", "is", " ", 
                   RowBox[{"{", "false", "}"}]}]}], "*)"}], "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                 "]"}], ",", "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                 "]"}]}], "\n", " ", "]"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<before args \>\"", ",", "\"\< \>\"", ",", "f", ",", 
              "\"\< \>\"", " ", ",", "e"}], "}"}]}], ";", "\n", 
           RowBox[{"args", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"eval", "[", 
               RowBox[{
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}],
               ",", 
              RowBox[{"{", 
               RowBox[{"ii", ",", "1", ",", 
                RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<args \>\"", ",", "\"\< \>\"", ",", "args"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<read-bit\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<car@x\>\"", ",", "f", ",", "e", ",", "args", ",", 
                 "\"\<x=\>\"", ",", "x", ",", "y", ",", "z", ",", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "@", "x"}], "\[Equal]", "0"}], ",", 
                   RowBox[{"car", "@", 
                    RowBox[{"{", " ", "x", "}"}]}], ",", 
                   RowBox[{"car", "@", " ", "x"}]}], "]"}]}], "}"}]}], ";", 
              " ", 
              RowBox[{"Return", "@", 
               RowBox[{"car", "@", "x"}]}]}], ",", "\n", " ", "\"\<cdr\>\"", 
             ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", 
                 "\"\<x=\>\"", ",", "x", ",", "y", ",", "z", ",", 
                 RowBox[{"cdr", "@", " ", "x"}]}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\[IndentingNewLine]",
              "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"KLUDE", ":", 
               RowBox[{
                RowBox[{
                "the", " ", "addtional", " ", "code", " ", "was", " ", 
                 "placed", " ", "there", " ", "to", " ", "process"}], " ", 
                "+", " ", 
                RowBox[{"as", " ", "a", " ", "variable"}]}]}], " ", "*)"}], 
             "\n", " ", "\"\<+\>\"", ",", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Return", "@", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                  RowBox[{"nmb", "@", "y"}]}], ")"}]}], ";"}], " ", "*)"}], 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<DARA+\>\"", ",", "f", ",", "e", ",", "args", ",", "x", 
                 ",", "y", ",", "z"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"x", "===", 
                   RowBox[{"{", "}"}]}], "&&", 
                  RowBox[{"y", "===", 
                   RowBox[{"{", "}"}]}]}], ",", "\"\<+\>\"", ",", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                   RowBox[{"nmb", "@", "y"}]}], ")"}]}], "]"}]}]}], ",", "\n", 
             RowBox[{"(*", " ", 
              RowBox[{"\"\<-\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                   RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                  RowBox[{
                   RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                   RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ","}], "*)"}],
              "\[IndentingNewLine]", "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "===", 
                  RowBox[{"{", "}"}]}], "&&", 
                 RowBox[{"y", "===", 
                  RowBox[{"{", "}"}]}]}], ",", "\"\<-\>\"", ",", 
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                   RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                  RowBox[{
                   RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                   RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], "]"}]}], ",", 
             "\n", " ", "\"\<*\>\"", ",", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "===", 
                  RowBox[{"{", "}"}]}], "&&", 
                 RowBox[{"y", "===", 
                  RowBox[{"{", "}"}]}]}], ",", "\"\<*\>\"", ",", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
                  RowBox[{"nmb", "@", "y"}]}], ")"}]}], "]"}]}], ",", "\n", 
             " ", "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"x", "===", 
                  RowBox[{"{", "}"}]}], "&&", 
                 RowBox[{"y", "===", 
                  RowBox[{"{", "}"}]}]}], ",", "\"\<^\>\"", ",", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
                  RowBox[{"nmb", "@", "y"}]}], ")"}]}], "]"}]}], ",", "\n", 
             " ", "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
             "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\n", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", 
              "]"}], ";", "\n", " ", 
             RowBox[{"d", "--"}], ";", "\n", " ", 
             RowBox[{"Switch", "[", "\n", " ", 
              RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", 
               " ", "\"\<try\>\"", ",", " ", 
               RowBox[{"Return", "@", "\n", " ", 
                RowBox[{"Block", "[", " ", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"out", " ", "=", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", 
                    RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                    RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                    "xx"}], "}"}], ",", "\n", " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                    ",", " ", 
                    RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                    RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                    " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
                 "]"}]}]}], " ", 
              RowBox[{"(*", " ", 
               RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
             ";"}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "switch"}], " ", "*)"}], 
            "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<end \>\"", ",", "e"}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"f", " ", "=", " ", 
              RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
             "\n", 
             RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
              RowBox[{
               RowBox[{"f", " ", "=", " ", 
                RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"eval", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
                 RowBox[{"bind", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                  "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
             "\[IndentingNewLine]", "\n", " ", 
             RowBox[{"eval", "[", " ", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
               RowBox[{"bind", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}],
        ";", "\[IndentingNewLine]", "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"nmb", "[", "n_Integer", "]"}], " ", ":=", " ", "n"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nmb", "[", "x_", "]"}], " ", ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"atom", "@", "x"}], "\[Equal]", "True"}], ",", "x", ",", 
          RowBox[{"car", "@", "x"}]}], "]"}]}], ";", "  ", 
       RowBox[{"(*", 
        RowBox[{"DARA", ":", " ", 
         RowBox[{"eval", " ", "returns", " ", 
          RowBox[{"{", 
           RowBox[{"a", "+", "b"}], "}"}]}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{
          RowBox[{"vars_", "?", "atom"}], ",", "args_", ",", "a_"}], "]"}], 
        " ", ":=", "a"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{"vars_", ",", "args_", ",", "a_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", 
          " ", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
            RowBox[{"bind", "[", " ", 
             RowBox[{
              RowBox[{"cdr", "@", " ", "vars"}], ",", " ", 
              RowBox[{"cdr", "@", " ", "args"}], ",", " ", "a"}], " ", 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"pos", " ", "=", " ", 
            RowBox[{"Position", "[", 
             RowBox[{"names", ",", " ", 
              RowBox[{"car", "@", " ", "vars"}], ",", " ", 
              RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"names", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "vars"}]}], "]"}], ",", "\n", "  ", 
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"values", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "args"}]}], "]"}]}], "}"}]}]}], "\n", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", "e_", "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"out", " ", "=", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
          RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", " ", 
          RowBox[{"print", "[", " ", 
           RowBox[{"\"\<expression\>\"", ",", " ", 
            RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";", "\n", " ", 
          RowBox[{"Catch", "[", " ", 
           RowBox[{"eval", "[", " ", 
            RowBox[{"e", ",", " ", 
             RowBox[{"{", 
              RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], 
            " ", "]"}], " ", "]"}]}], "\n", ")"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e_", ",", "Null", ",", "d_"}], "]"}], " ", ":=", " ", 
        RowBox[{"eval", "[", 
         RowBox[{"e", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<nil\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "d"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"let", "[", 
         RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"print", "[", " ", 
           RowBox[{"\"\<define\>\"", ",", " ", 
            RowBox[{"output", "@", " ", "n"}]}], " ", "]"}], ";", "\n", " ", 
          RowBox[{"print", "[", " ", 
           RowBox[{"\"\<value\>\"", ",", " ", 
            RowBox[{"output", "@", " ", "d"}]}], " ", "]"}], ";", "\n", " ", 
          RowBox[{"PrependTo", "[", 
           RowBox[{"names", ",", "n"}], "]"}], ";", "\n", " ", 
          RowBox[{"PrependTo", "[", 
           RowBox[{"defs", ",", "d"}], "]"}], ";"}], "\n", ")"}]}], ";", 
       "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output2", "[", "x_String", "]"}], " ", ":=", " ", 
        RowBox[{"x", "<>", "\"\< \>\""}]}], ";", "\n", 
       RowBox[{
        RowBox[{"output2", "[", "x_Integer", "]"}], " ", ":=", " ", 
        RowBox[{
         RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";", 
       "\n", 
       RowBox[{
        RowBox[{"output2", "[", 
         RowBox[{"{", "x___", "}"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "s", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"s", " ", "=", " ", 
            RowBox[{"StringJoin", "[", 
             RowBox[{"\"\<(\>\"", ",", " ", 
              RowBox[{"output2", " ", "/@", " ", 
               RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"StringTake", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}], " ", "==", " ", "\"\< \>\""}], 
             ",", " ", 
             RowBox[{"s", " ", "=", " ", 
              RowBox[{"StringDrop", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}]}]}], " ", "]"}], ";", "\n", " ", 
           RowBox[{"s", " ", "<>", " ", "\"\<) \>\""}]}]}], "\n", "]"}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{"blanks", " ", "=", " ", 
        RowBox[{"StringJoin", "@", " ", 
         RowBox[{"Table", "[", 
          RowBox[{"\"\< \>\"", ",", 
           RowBox[{"{", "12", "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"print2", "[", 
            RowBox[{"x", ",", 
             RowBox[{"StringTake", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"print", "[", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"StringDrop", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}]}], ")"}], " ", "/;", 
         " ", 
         RowBox[{
          RowBox[{"StringLength", "[", "y", "]"}], " ", ">", " ", "50"}]}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print2", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print2", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print3", "[", 
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{
            RowBox[{"x", "<>", "blanks"}], ",", "12"}], "]"}], "<>", "y"}], 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print3", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"(", 
         RowBox[{"Print", "[", "x", "]"}], 
         RowBox[{"(*", 
          RowBox[{";", " ", 
           RowBox[{"WriteString", "[", 
            RowBox[{"o", ",", "x", ",", "\"\<\\n\>\""}], "]"}]}], "*)"}], 
         ")"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"mylist", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"debugflag", "=", "True"}], ";", "  ", 
       RowBox[{"(*", 
        RowBox[{"on", " ", "off", " ", "here"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"debug", "[", "x_", "]"}], ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"debugflag", "==", "True"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"mylist", ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"ctr", "++"}]}], "}"}]}], "]"}], ",", "Nothing"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"debugflag", "=", "False"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"StringTake", "[", 
               RowBox[{"expression0", ",", "4"}], "]"}], "===", 
              "\"\<(cdr\>\""}], "||", 
             RowBox[{
              RowBox[{"StringTake", "[", 
               RowBox[{"expression0", ",", "4"}], "]"}], "===", 
              "\"\<(car\>\""}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"code", "=", 
              RowBox[{"StringDrop", "[", 
               RowBox[{
                RowBox[{"StringDrop", "[", 
                 RowBox[{"expression0", ",", "1"}], "]"}], ",", 
                RowBox[{"-", "1"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
            ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"code", "=", "expression0"}], ";"}]}], "]"}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", " ", 
          RowBox[{"names", " ", "=", " ", 
           RowBox[{"{", "\"\<nil\>\"", "}"}]}], ";", " ", 
          RowBox[{"defs", " ", "=", " ", 
           RowBox[{"{", 
            RowBox[{"{", "}"}], "}"}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{
              RowBox[{"eval", "@", 
               RowBox[{"(", 
                RowBox[{"get", "[", "]"}], ")"}]}], ",", "InputForm"}], "]"}],
             ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<{\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
              RowBox[{"\"\<}\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
              RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<\>\""}], ",", 
              RowBox[{"\"\<\\\"\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
           "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}]}],
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.668701916815751*^9, 3.66870193624583*^9}, {
   3.668702133786916*^9, 3.668702134347089*^9}, 3.6687022853581867`*^9, {
   3.6687023887130537`*^9, 3.668702431753148*^9}, {3.668702614804088*^9, 
   3.668702625199012*^9}, {3.6687027298143806`*^9, 3.668702756813094*^9}, {
   3.668702877190712*^9, 3.668702935882134*^9}, {3.66870296651546*^9, 
   3.66870298115119*^9}, {3.6687030616129713`*^9, 3.668703076596231*^9}, {
   3.6687032983584623`*^9, 3.668703329036998*^9}, {3.668703359547501*^9, 
   3.668703364937311*^9}, {3.668703409385564*^9, 3.668703409598823*^9}, {
   3.668703451281674*^9, 3.6687034539581423`*^9}, {3.668703510951167*^9, 
   3.668703581870448*^9}, {3.6687039495461273`*^9, 3.668703986468754*^9}, {
   3.668704034787966*^9, 3.668704107158821*^9}, {3.66870434254609*^9, 
   3.668704391482483*^9}, {3.668704866202161*^9, 3.6687049166354513`*^9}, {
   3.6687049703789988`*^9, 3.668705016862217*^9}, {3.6687050581514177`*^9, 
   3.6687051409960737`*^9}, {3.6687051853865957`*^9, 3.66870519864028*^9}, {
   3.66870530439258*^9, 3.6687053058318567`*^9}, {3.668705396406801*^9, 
   3.6687054449499273`*^9}, {3.668705727226926*^9, 3.668705760863277*^9}, {
   3.6687209180348263`*^9, 3.668720939416154*^9}, 3.668722524214611*^9, {
   3.721457652040442*^9, 3.721457659126416*^9}, {3.7214577653528957`*^9, 
   3.721457851048711*^9}, {3.721457919819281*^9, 3.7214579203696547`*^9}, {
   3.721458310459865*^9, 3.7214583299327602`*^9}, {3.721458374957127*^9, 
   3.721458387725543*^9}, {3.721458441637535*^9, 3.721458517261661*^9}, {
   3.721458573941455*^9, 3.721458588881013*^9}, {3.721458621215254*^9, 
   3.7214586315983877`*^9}, {3.721458687018977*^9, 3.721458702386259*^9}, {
   3.721459211034535*^9, 3.7214592617629347`*^9}, {3.7214593029271*^9, 
   3.7214593145595713`*^9}, {3.721459425330224*^9, 3.721459425656097*^9}, {
   3.721463532835463*^9, 3.721463535309825*^9}, 3.721505197215242*^9, {
   3.721505468875614*^9, 3.7215054734755*^9}, {3.721508064655298*^9, 
   3.721508072182108*^9}, {3.7215081096316347`*^9, 3.721508112465963*^9}, {
   3.7215332454364023`*^9, 3.721533280851383*^9}, {3.7215334454449787`*^9, 
   3.721533455479636*^9}, {3.721533538115106*^9, 3.721533546765699*^9}, {
   3.7215353422374*^9, 3.721535357125392*^9}, 3.7215359945581007`*^9, {
   3.7215632700342817`*^9, 3.721563333620592*^9}, {3.721568349314021*^9, 
   3.721568355163103*^9}, {3.72206933003051*^9, 3.7220693303554068`*^9}, 
   3.722069380066366*^9, {3.722069540265856*^9, 3.72206956972978*^9}, {
   3.722069617986521*^9, 3.722069620432428*^9}, {3.722069675297456*^9, 
   3.722069677663872*^9}, 3.722070274881424*^9, {3.722070379491681*^9, 
   3.722070380210538*^9}, {3.722071740854188*^9, 3.722071744839407*^9}, {
   3.722073171158132*^9, 3.722073230321724*^9}, {3.749327287404704*^9, 
   3.7493272985316963`*^9}, {3.749327710791873*^9, 3.7493277446972303`*^9}, {
   3.7493279045282784`*^9, 3.749327904785581*^9}, {3.749327954682212*^9, 
   3.74932795677278*^9}, 3.7493287856727057`*^9, {3.750067168601707*^9, 
   3.750067204171855*^9}, {3.75006724642835*^9, 3.7500672569607687`*^9}, {
   3.7500674018061123`*^9, 3.750067404595216*^9}, {3.7500674571829357`*^9, 
   3.750067459990789*^9}, {3.750067664926825*^9, 3.7500676960219917`*^9}, 
   3.750067816209078*^9, {3.75006794609881*^9, 3.750067966848819*^9}, {
   3.750068011579081*^9, 3.750068053667755*^9}, {3.7500681373784323`*^9, 
   3.750068140183032*^9}, 3.7500687326272497`*^9, {3.750068790234705*^9, 
   3.75006879924474*^9}, {3.750087487467244*^9, 3.750087508883686*^9}, {
   3.750087549239423*^9, 3.750087551915702*^9}, {3.750087664116248*^9, 
   3.750087682170689*^9}, {3.750087741581258*^9, 3.750087742111618*^9}, 
   3.750087970936695*^9, 3.750088009277299*^9, {3.750088645015211*^9, 
   3.7500886617083406`*^9}, 3.750088711321334*^9, {3.750089113741297*^9, 
   3.7500891247089453`*^9}, {3.750091632398831*^9, 3.750091633053605*^9}, {
   3.750091728474266*^9, 3.750091731525568*^9}, {3.750091817041135*^9, 
   3.7500918180862494`*^9}, 3.750092253648355*^9, {3.750092430850401*^9, 
   3.750092462056579*^9}, {3.750092694320958*^9, 3.750092695545211*^9}, {
   3.750092818340394*^9, 3.750092821555091*^9}, 3.750092886104794*^9, {
   3.750093852042632*^9, 3.75009393434836*^9}, {3.750094032887763*^9, 
   3.750094119828692*^9}, {3.750094176317932*^9, 3.7500941969808607`*^9}, {
   3.7500942281944103`*^9, 3.7500942327166023`*^9}, 3.750094288498212*^9, {
   3.750094574957781*^9, 3.750094578445261*^9}, {3.750094608755763*^9, 
   3.7500946975965776`*^9}, {3.750094801327663*^9, 3.750094831968473*^9}, {
   3.750095047051304*^9, 3.750095071179674*^9}, {3.750095168394496*^9, 
   3.7500952163414783`*^9}, 3.750095277119997*^9, {3.7500953471149693`*^9, 
   3.750095358883379*^9}, {3.750095572804308*^9, 3.750095609850218*^9}, {
   3.7500956984140778`*^9, 3.750095700334647*^9}, {3.750095731746829*^9, 
   3.7500957323177013`*^9}, 3.750095996216799*^9, {3.750096244791128*^9, 
   3.750096272497267*^9}, {3.75009630674376*^9, 3.7500963720171947`*^9}, {
   3.7500968856017303`*^9, 3.7500969241701612`*^9}, {3.750099103726658*^9, 
   3.7500991152446823`*^9}, {3.750099562724436*^9, 3.7500995907319098`*^9}, {
   3.750099651969914*^9, 3.750099672273629*^9}, 3.7500997195633287`*^9, {
   3.750352976192173*^9, 3.750353005001573*^9}, {3.7503531359271603`*^9, 
   3.7503531520456123`*^9}, {3.7503532486583557`*^9, 3.750353264799638*^9}, {
   3.7503532965857697`*^9, 3.750353297214403*^9}, {3.7503539538066587`*^9, 
   3.7503539575512667`*^9}, {3.7503539955815353`*^9, 3.750353997985087*^9}, {
   3.750354156540703*^9, 3.750354156775652*^9}, {3.75035458460122*^9, 
   3.750354588142*^9}, {3.7503555880658484`*^9, 3.750355591000386*^9}, {
   3.750355636171095*^9, 3.750355686495369*^9}, {3.750355997105096*^9, 
   3.750356025873666*^9}, {3.7503560661588507`*^9, 3.750356098167746*^9}, {
   3.750356148872407*^9, 3.7503561511212807`*^9}, 3.750356463897779*^9, {
   3.750459866128003*^9, 3.750459951684354*^9}, {3.750459991601725*^9, 
   3.750460003404055*^9}, 3.7504600594815893`*^9, {3.7518088554883738`*^9, 
   3.751808867315341*^9}, {3.751809074000257*^9, 3.751809074227541*^9}, {
   3.7518091070646963`*^9, 3.7518091073935137`*^9}, {3.7518092484004307`*^9, 
   3.751809283400928*^9}, {3.751809318780229*^9, 3.751809321255625*^9}, {
   3.75180940844795*^9, 3.7518094110911837`*^9}, {3.751809442374566*^9, 
   3.751809443025186*^9}, {3.751809479962715*^9, 3.7518094806256447`*^9}, {
   3.751809516888406*^9, 3.751809544079214*^9}, {3.751809800041666*^9, 
   3.7518098511884747`*^9}, {3.751809893856534*^9, 3.751809919205585*^9}, {
   3.751809956081935*^9, 3.75180998866418*^9}, {3.751810510356444*^9, 
   3.751810533227087*^9}, {3.7518134726660137`*^9, 3.751813486585116*^9}, {
   3.751813635253326*^9, 3.7518136569223757`*^9}, {3.751813778084009*^9, 
   3.751813806739793*^9}, {3.751813900566358*^9, 3.751813902794005*^9}, {
   3.751814037211153*^9, 
   3.7518140940352163`*^9}},ExpressionUUID->"7d09a8b1-87b5-4a04-a7de-\
76a1be2ddfc2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"CloudDeploy", "[", 
   RowBox[{
    RowBox[{"FormPage", "[", 
     RowBox[{
      RowBox[{"FormObject", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<expression\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<(* ( + 3 12) 12)\>\""}], 
           "|>"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",",
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"AppearanceRules", "\[Rule]", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Lisp Interpreter \>\"", ",", "Orange", ",", " ", "Bold", 
              ",", 
              RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
           RowBox[{
           "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Run\>\""}]}], 
          "|>"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"lisp", "[", "#expression", "]"}], "&"}]}], "]"}], ",", 
    RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]}]], "Input",\

 CellChangeTimes->{
  3.6687019387415037`*^9, {3.668702018945513*^9, 3.668702021362136*^9}, {
   3.6687020551480513`*^9, 3.668702107897636*^9}, {3.668702178807077*^9, 
   3.6687021958064547`*^9}, {3.668702239952825*^9, 3.6687023436087427`*^9}, {
   3.6687025518166237`*^9, 3.668702596420607*^9}, {3.668702652491873*^9, 
   3.6687026812797422`*^9}, {3.6687036692618027`*^9, 3.668703684450075*^9}, {
   3.7214581991277103`*^9, 3.721458199429619*^9}, {3.7214582473786182`*^9, 
   3.721458296733281*^9}, {3.721458338348125*^9, 3.721458357664834*^9}, 
   3.721458429093857*^9, {3.721458790532482*^9, 3.721458793028949*^9}, {
   3.72145885229639*^9, 3.7214588949001627`*^9}, {3.721459273923686*^9, 
   3.721459278513587*^9}, {3.721459437413912*^9, 3.721459471760054*^9}, {
   3.721459561797625*^9, 3.721459568389389*^9}, {3.721463500119329*^9, 
   3.721463506317503*^9}, 3.721463545830546*^9, 3.72146362007117*^9, {
   3.7214636580407143`*^9, 3.7214637336560707`*^9}, {3.721463766044441*^9, 
   3.7214637708248587`*^9}, 3.721508095043187*^9, 3.721533489347207*^9, 
   3.721534682279892*^9, {3.7215634053304157`*^9, 3.7215634132620077`*^9}, 
   3.7220696505233917`*^9, {3.722073279339679*^9, 3.722073314564149*^9}, 
   3.722073757361457*^9, 3.7500667257274237`*^9, 3.7500667743004704`*^9, {
   3.750068774032662*^9, 3.750068794158147*^9}},
 CellLabel->"In[54]:=",ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-88036260f931"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/48606644-ad2b-44ae-bbd6-\
09e63ce6e47c\"",
     "https://www.wolframcloud.com/objects/48606644-ad2b-44ae-bbd6-\
09e63ce6e47c"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/48606644-ad2b-44ae-bbd6-09e63ce6e47c"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.668702440473839*^9, 3.668702599311335*^9, 3.668702630234618*^9, 
   3.66870276172163*^9, {3.668702884776046*^9, 3.6687029013214397`*^9}, 
   3.668702940803843*^9, 3.668703086106824*^9, 3.6687031423779497`*^9, 
   3.668703336512856*^9, 3.6687033694726467`*^9, 3.668703414525476*^9, 
   3.6687034594849052`*^9, {3.668703521112142*^9, 3.668703586411539*^9}, {
   3.668703678090148*^9, 3.668703687206891*^9}, 3.668703991240896*^9, 
   3.668704097623562*^9, 3.668704397243503*^9, 3.668705280205473*^9, 
   3.668705416430118*^9, 3.6687054505580053`*^9, 3.66870576754501*^9, 
   3.668720951596919*^9, 3.668722539478557*^9, 3.721458392959919*^9, 
   3.7214584315862827`*^9, {3.721458523281312*^9, 3.721458540233698*^9}, 
   3.721458636446863*^9, {3.7214586900420227`*^9, 3.7214587050497217`*^9}, 
   3.7214588022533007`*^9, 3.721458910416202*^9, 3.7214592803511543`*^9, 
   3.7214593180516233`*^9, {3.72145942949817*^9, 3.72145943871248*^9}, 
   3.721459473463122*^9, 3.721459572978836*^9, 3.72146350755993*^9, 
   3.7214635675093613`*^9, 3.721463631482452*^9, {3.721463671717452*^9, 
   3.721463692610738*^9}, 3.721463740218576*^9, 3.7214637714238977`*^9, 
   3.721505681368531*^9, {3.721508087606447*^9, 3.7215081154021397`*^9}, {
   3.72153349165814*^9, 3.72153349720348*^9}, 3.721533552074951*^9, 
   3.7215346840011873`*^9, 3.721563442261989*^9, 3.721568380596117*^9, {
   3.7220733118500633`*^9, 3.722073315854253*^9}, 3.722073759539748*^9, 
   3.749328173109312*^9, 3.749328795589089*^9, 3.7500667315870667`*^9, 
   3.7500667792041597`*^9, 3.750101488259232*^9, 3.750460099571953*^9},
 CellLabel->"Out[54]=",ExpressionUUID->"dba64e54-f60d-4a54-8776-ea249f673ef2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(if (< 100 40) a b)\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.751802077432843*^9, 3.751802084395937*^9}, {
  3.751807058754719*^9, 3.751807077671575*^9}, {3.75180712531621*^9, 
  3.751807135405608*^9}, {3.7518072523986397`*^9, 3.751807259192498*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"2080084a-2841-430a-9fb2-4567ef5089d4"],

Cell[CellGroupData[{

Cell[BoxData["\<\"expression  ((if ((< 100 40)) a b))\"\>"], "Print",
 CellChangeTimes->{
  3.751807080081357*^9, {3.7518071259123793`*^9, 3.751807135848469*^9}, {
   3.751807252818324*^9, 3.7518072596033363`*^9}, 3.751808873268393*^9},
 CellLabel->
  "During evaluation of \
In[27]:=",ExpressionUUID->"dcea259f-f309-4667-bcc6-6e120df44dc3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"\<\"<\"\>", ",", "100", ",", "40"}], "}"}], "}"}], 
     ",", "\<\"a\"\>", ",", "\<\"b\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "\<\"nil\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "\[Infinity]"}], 
  "}"}]], "Print",
 CellChangeTimes->{
  3.751807080081357*^9, {3.7518071259123793`*^9, 3.751807135848469*^9}, {
   3.751807252818324*^9, 3.7518072596033363`*^9}, 3.7518088732796993`*^9},
 CellLabel->
  "During evaluation of \
In[27]:=",ExpressionUUID->"bb4a610b-9a7b-4ed4-8ddb-4c959aefc11f"]
}, Open  ]],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(a)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.751802085253529*^9, {3.751807072326663*^9, 3.751807080089507*^9}, {
   3.751807125927952*^9, 3.751807135862013*^9}, {3.751807252831994*^9, 
   3.751807259616892*^9}, 3.751808873295429*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"775b4ed9-a843-4bb3-bb65-60fbee40eae2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["x"], "Input",
 CellChangeTimes->{3.7518070871491756`*^9},
 CellLabel->"In[13]:=",ExpressionUUID->"82292a8e-a610-4024-ae21-8a3469fb845b"],

Cell[BoxData["x"], "Output",
 CellChangeTimes->{3.7518070874381332`*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"4e33dd06-4040-4ffc-b83c-c2e50d25a4fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
  "lisp", "[", "\"\<(cdr (a ( (* z z ) c) d e fgh))\>\"", "]"}]}]], "Input",
 CellChangeTimes->{{3.721533386443975*^9, 3.721533386854467*^9}, {
  3.72206968635201*^9, 3.722069694342019*^9}, {3.7220737370731907`*^9, 
  3.7220737482457037`*^9}},
 CellLabel->"In[53]:=",ExpressionUUID->"44d4a5b7-13a0-4e04-961c-3f3e04b5a33f"],

Cell[BoxData["\<\"expression  (cdr (a (((* z z)) c) d e fgh))\"\>"], "Print",
 CellChangeTimes->{
  3.722070279444056*^9, 3.72207043078067*^9, 3.722071772625998*^9, {
   3.722073743263591*^9, 3.722073748544653*^9}, 3.7493273865203123`*^9, 
   3.750460090439621*^9},
 CellLabel->
  "During evaluation of \
In[53]:=",ExpressionUUID->"fc7eea23-e6f4-421a-bca5-6fbef358cba6"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(((z^2) c) d e fgh)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.72206969770576*^9, 3.72207027948031*^9, 3.722070430809999*^9, 
   3.7220717726660557`*^9, {3.7220737432742357`*^9, 3.722073748556281*^9}, 
   3.749327386531461*^9, 3.7504600904514847`*^9},
 CellLabel->"Out[53]=",ExpressionUUID->"c9081b28-e685-4432-a471-f2053606009b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(cdr (d e fgh))\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7220704704029207`*^9, 3.722070482687192*^9}, 
   3.72207356478878*^9, {3.750459745255862*^9, 3.7504597454200773`*^9}},
 CellLabel->"In[52]:=",ExpressionUUID->"af57530a-4531-4c40-a3e5-f1ffa1de80f8"],

Cell[BoxData["\<\"expression  (cdr (d e fgh))\"\>"], "Print",
 CellChangeTimes->{3.7504600866732597`*^9},
 CellLabel->
  "During evaluation of \
In[52]:=",ExpressionUUID->"8974b12a-28c8-4bc6-b928-5bbd6b4e295e"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(e fgh)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.722070479624538*^9, 3.722070482949782*^9}, 
   3.7220731865922318`*^9, {3.722073235779633*^9, 3.722073258758074*^9}, 
   3.7220735666025963`*^9, 3.7493273987446327`*^9, {3.750459721986143*^9, 
   3.750459745684373*^9}, 3.7504600395825777`*^9, 3.750460086682892*^9},
 CellLabel->"Out[52]=",ExpressionUUID->"ff0695ce-89bc-4409-814f-d7cea258c0d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<cdr (d e fgh)\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7504597305817738`*^9, 3.7504597496050863`*^9}},
 CellLabel->"In[51]:=",ExpressionUUID->"6aaed11b-4761-4e31-9166-d12280c004e5"],

Cell[BoxData["\<\"expression  (cdr (d e fgh))\"\>"], "Print",
 CellChangeTimes->{{3.750459736905259*^9, 3.750459749852621*^9}, 
   3.7504600352702103`*^9, 3.750460083462179*^9},
 CellLabel->
  "During evaluation of \
In[51]:=",ExpressionUUID->"7adbbd54-8ea5-4d38-85dc-1c356313c795"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(e fgh)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.7504597369136343`*^9, 3.750459749866124*^9}, 
   3.750460035281704*^9, 3.750460083473651*^9},
 CellLabel->"Out[51]=",ExpressionUUID->"0d308d92-45a0-43d3-9cc5-f1315b67fddb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(* ( + 3 12) 12)\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.749327406355009*^9, 3.749327406545581*^9}, 
   3.750097011171878*^9, 3.750097043539555*^9},
 CellLabel->
  "In[296]:=",ExpressionUUID->"7808f686-37d5-45c2-bd72-fa81807d1936"],

Cell[BoxData["\<\"expression  ((* ((+ 3 12)) 12))\"\>"], "Print",
 CellChangeTimes->{
  3.7493274067921467`*^9, 3.7500970124162817`*^9, {3.750097043991557*^9, 
   3.750097045805818*^9}, 3.750459958046404*^9, 3.7504600319041*^9, 
   3.750460081305406*^9, 3.751813934501431*^9},
 CellLabel->
  "During evaluation of \
In[296]:=",ExpressionUUID->"5e8a784d-0c60-4872-a4b7-f6b1edfa9feb"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(180)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.749327406800539*^9, 3.750097012427438*^9, {3.750097044005602*^9, 
   3.750097045817256*^9}, 3.750459958058125*^9, 3.750460031915728*^9, 
   3.750460081316518*^9, 3.751813934512597*^9},
 CellLabel->
  "Out[296]=",ExpressionUUID->"0cf41f62-0fab-475b-9b08-4a3f766a5cc2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["list"], "Input",
 CellChangeTimes->{{3.722073120391779*^9, 
  3.722073120922089*^9}},ExpressionUUID->"6d47f478-1871-4b72-8f35-\
237a61b1d232"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.722073121908452*^9},ExpressionUUID->"59c6add4-8617-432e-b59a-\
1d3b721a8e05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ctr"], "Input",
 CellChangeTimes->{{3.722073155241357*^9, 
  3.722073155742424*^9}},ExpressionUUID->"07f7c144-824f-4709-a04d-\
f83ec33b8614"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.722073156647114*^9},ExpressionUUID->"cbad6367-f3af-4ac2-a5de-\
a3c002001c21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(car (cdr (a b c d)))\>\"", "]"}]], "Input",
 CellChangeTimes->{3.749327210753009*^9, 3.7493273281471243`*^9, 
  3.749327433232409*^9},
 CellLabel->"In[49]:=",ExpressionUUID->"25beb7c3-37dc-4155-8a7f-9a1963350127"],

Cell[BoxData["\<\"expression  (car ((cdr (a b c d))))\"\>"], "Print",
 CellChangeTimes->{3.749327433580162*^9, 3.750096989193447*^9, 
  3.750356539789504*^9, 3.750460075745206*^9},
 CellLabel->
  "During evaluation of \
In[49]:=",ExpressionUUID->"245d538c-8ed8-42a5-99f8-d5dc22149f92"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(b c d)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.749327212669283*^9, {3.749327308933456*^9, 3.749327335461454*^9}, 
   3.749327433588682*^9, 3.750096989206291*^9, 3.750356539800954*^9, 
   3.7504600757568417`*^9},
 CellLabel->"Out[49]=",ExpressionUUID->"43d1c9f6-1567-4900-96f6-2dbe05bdc160"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(cdr (a b c))\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.749327358395507*^9, 3.7493273597446527`*^9}, {
  3.749327421038567*^9, 3.7493274235671577`*^9}},
 CellLabel->"In[48]:=",ExpressionUUID->"33e28cdc-b3ae-47cd-989a-7dd341deb59d"],

Cell[BoxData["\<\"expression  (cdr (a b c))\"\>"], "Print",
 CellChangeTimes->{3.7493274240753517`*^9, 3.7500969874123707`*^9, 
  3.750460073686768*^9},
 CellLabel->
  "During evaluation of \
In[48]:=",ExpressionUUID->"ffaac565-b240-4429-91ab-00646469d673"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(b c)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.749327362940724*^9, 3.749327424081287*^9, 
  3.750096987423986*^9, 3.750460073698406*^9},
 CellLabel->"Out[48]=",ExpressionUUID->"d316182c-aa02-4eea-a476-a427e2e6d60a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<'(+ 2 1)\>\"", "]"}]], "Input",
 CellChangeTimes->{
  3.749327461179345*^9, {3.7500669440199413`*^9, 3.750066944288783*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"c3125590-9894-46cd-ad2f-0e337067fc49"],

Cell[BoxData["\<\"expression  (' ((+ 2 1)))\"\>"], "Print",
 CellChangeTimes->{3.7493274629765167`*^9, 3.7500669451452312`*^9, 
  3.750096984288418*^9, 3.750356484410494*^9, 3.750356532239765*^9, 
  3.750460069473372*^9},
 CellLabel->
  "During evaluation of \
In[47]:=",ExpressionUUID->"e9f2d17c-dae1-4049-a784-bfc0b670df02"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(+ 2 1)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.749327462980052*^9, 3.750066945156609*^9, 
  3.750096984299634*^9, 3.7503564844220324`*^9, 3.750356532251094*^9, 
  3.750460069485477*^9},
 CellLabel->"Out[47]=",ExpressionUUID->"ffe5f3a3-7a96-46a1-8973-8dc029db3ecc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(cdr '(+ 1 2))\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.750066299282528*^9, 3.75006630199887*^9}, {
  3.750066370373561*^9, 3.750066370596711*^9}, {3.750066461871542*^9, 
  3.7500664621507*^9}},
 CellLabel->"In[46]:=",ExpressionUUID->"dfe75968-da08-4eae-8f33-112199c66a35"],

Cell[BoxData["\<\"expression  (cdr (' ((+ 1 2))))\"\>"], "Print",
 CellChangeTimes->{
  3.75006637081667*^9, 3.750066463678171*^9, 3.750096980441131*^9, {
   3.7503565298608713`*^9, 3.750356530954904*^9}, 3.7504600673406*^9},
 CellLabel->
  "During evaluation of \
In[46]:=",ExpressionUUID->"dfc037f2-1fa0-4d1f-ac41-ea3a12294397"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(1 2)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.7500663614161997`*^9, 3.7500663708231277`*^9}, 
   3.750066463686935*^9, 3.750096980452783*^9, {3.750356529872837*^9, 
   3.7503565309663267`*^9}, 3.750460067352672*^9},
 CellLabel->"Out[46]=",ExpressionUUID->"49d8ad12-9153-4946-8ee6-21d109fc1b37"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(car '(+ 1 2))\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.750066584778412*^9, 3.7500665848788557`*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"9a563104-f7c8-4c1f-9647-cf2c2f38a30b"],

Cell[BoxData["\<\"expression  (car (' ((+ 1 2))))\"\>"], "Print",
 CellChangeTimes->{3.750066585454969*^9, 3.750096978320012*^9, 
  3.750356528113679*^9, 3.750460065970242*^9},
 CellLabel->
  "During evaluation of \
In[45]:=",ExpressionUUID->"aaef8582-2b4d-49d5-97a2-8a5121a0d65e"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"+\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.750066585458364*^9, 3.750096978331901*^9, 
  3.750356528125576*^9, 3.750460065982016*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"ade4cf01-61d5-42db-bc62-cef8c070976f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"debugflag", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"lisp", "[", "\"\<(+ 1 2 3)\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.75006695830707*^9, 3.750066960578787*^9}, {
  3.750067892176838*^9, 3.750067907013039*^9}, {3.750068361802725*^9, 
  3.7500683641522627`*^9}, {3.7500687451193027`*^9, 3.750068749527256*^9}},
 CellLabel->
  "In[147]:=",ExpressionUUID->"60070de5-6c7a-4d18-89b9-e17d183ec74f"],

Cell[BoxData["\<\"expression  ((+ 1 2) 3)\"\>"], "Print",
 CellChangeTimes->{
  3.750066961202606*^9, {3.750067209360094*^9, 3.750067211797171*^9}, {
   3.750067265562408*^9, 3.750067268009288*^9}, 3.75006741519559*^9, 
   3.7500674662945557`*^9, 3.7500676740847883`*^9, {3.75006789657382*^9, 
   3.750067907308769*^9}, 3.7500679552296963`*^9, 3.7500680178921623`*^9, {
   3.750068058711089*^9, 3.750068061607945*^9}, 3.750068149553537*^9, 
   3.750068364403325*^9, {3.750068746539007*^9, 3.750068749956859*^9}},
 CellLabel->
  "During evaluation of \
In[147]:=",ExpressionUUID->"07476c8d-ff5d-456a-8a78-4f2e20f763f4"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(3 3)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.750066961206053*^9, {3.750067209368567*^9, 3.7500672118056707`*^9}, {
   3.750067265571208*^9, 3.750067268018297*^9}, 3.750067415331114*^9, 
   3.7500674663132477`*^9, 3.750067674102366*^9, {3.750067896591021*^9, 
   3.750067907592063*^9}, 3.750067955247155*^9, 3.750068017901237*^9, {
   3.750068058719614*^9, 3.750068061617696*^9}, 3.750068149565174*^9, 
   3.750068364417708*^9, {3.7500687465532618`*^9, 3.750068749970504*^9}},
 CellLabel->
  "Out[148]=",ExpressionUUID->"4ea42989-0191-4828-a866-95c8d1b4fae3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["mylist"], "Input",
 CellChangeTimes->{{3.750068104875368*^9, 3.7500681069163322`*^9}},
 CellLabel->
  "In[133]:=",ExpressionUUID->"84412d35-e53e-4e06-830c-b9d91214b3d2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"+\"\>", ",", "1", ",", "2"}], "}"}], ",", "3"}], "}"}], 
     ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"+\"\>", ",", "1", ",", "2"}], "}"}], ",", "1"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"\<\"+\"\>", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"str\"\>", ",", "\<\"+\"\>"}], "}"}], ",", "3"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"f \"\>", ",", "\<\"+\"\>", ",", "\<\" \"\>", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"before args \"\>", ",", "\<\" \"\>", ",", "\<\"+\"\>", 
       ",", "\<\" \"\>", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"int\"\>", ",", "1"}], "}"}], ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"int\"\>", ",", "2"}], "}"}], ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"args \"\>", ",", "\<\" \"\>", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], "}"}], ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"DARA\"\>", ",", "\<\"+\"\>", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}], ",", "1", ",", "2", ",", 
       RowBox[{"{", "}"}]}], "}"}], ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"f \"\>", ",", "3", ",", "\<\" \"\>", ",", 
       RowBox[{"{", "3", "}"}]}], "}"}], ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"before args \"\>", ",", "\<\" \"\>", ",", "3", 
       ",", "\<\" \"\>", ",", 
       RowBox[{"{", "3", "}"}]}], "}"}], ",", "13"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "14"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"int\"\>", ",", "3"}], "}"}], ",", "15"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"args \"\>", ",", "\<\" \"\>", ",", 
       RowBox[{"{", "3", "}"}]}], "}"}], ",", "16"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"end \"\>", ",", 
       RowBox[{"{", "3", "}"}]}], "}"}], ",", "17"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.750068107511135*^9, 3.75006815089929*^9},
 CellLabel->
  "Out[133]=",ExpressionUUID->"cab18fa0-df82-4076-9f48-184c3724b564"]
}, Open  ]]
},
WindowSize->{1259, 1088},
WindowMargins->{{Automatic, 485}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"7deb1d31-4a4a-408d-81d3-395bcc583d41"],
Cell[1747, 54, 81353, 1763, 8599, "Input",ExpressionUUID->"7d09a8b1-87b5-4a04-a7de-76a1be2ddfc2"],
Cell[CellGroupData[{
Cell[83125, 1821, 2616, 49, 199, "Input",ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-88036260f931"],
Cell[85744, 1872, 2103, 35, 37, "Output",ExpressionUUID->"dba64e54-f60d-4a54-8776-ea249f673ef2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[87884, 1912, 373, 5, 30, "Input",ExpressionUUID->"2080084a-2841-430a-9fb2-4567ef5089d4"],
Cell[CellGroupData[{
Cell[88282, 1921, 341, 6, 24, "Print",ExpressionUUID->"dcea259f-f309-4667-bcc6-6e120df44dc3"],
Cell[88626, 1929, 685, 20, 24, "Print",ExpressionUUID->"bb4a610b-9a7b-4ed4-8ddb-4c959aefc11f"]
}, Open  ]],
Cell[89326, 1952, 526, 12, 35, "Output",ExpressionUUID->"775b4ed9-a843-4bb3-bb65-60fbee40eae2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89889, 1969, 150, 2, 30, "Input",ExpressionUUID->"82292a8e-a610-4024-ae21-8a3469fb845b"],
Cell[90042, 1973, 151, 2, 34, "Output",ExpressionUUID->"4e33dd06-4040-4ffc-b83c-c2e50d25a4fb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90230, 1980, 380, 7, 52, "Input",ExpressionUUID->"44d4a5b7-13a0-4e04-961c-3f3e04b5a33f"],
Cell[90613, 1989, 370, 7, 24, "Print",ExpressionUUID->"fc7eea23-e6f4-421a-bca5-6fbef358cba6"],
Cell[90986, 1998, 542, 12, 35, "Output",ExpressionUUID->"c9081b28-e685-4432-a471-f2053606009b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91565, 2015, 299, 4, 30, "Input",ExpressionUUID->"af57530a-4531-4c40-a3e5-f1ffa1de80f8"],
Cell[91867, 2021, 210, 4, 24, "Print",ExpressionUUID->"8974b12a-28c8-4bc6-b928-5bbd6b4e295e"],
Cell[92080, 2027, 605, 12, 35, "Output",ExpressionUUID->"ff0695ce-89bc-4409-814f-d7cea258c0d4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92722, 2044, 226, 3, 30, "Input",ExpressionUUID->"6aaed11b-4761-4e31-9166-d12280c004e5"],
Cell[92951, 2049, 282, 5, 24, "Print",ExpressionUUID->"7adbbd54-8ea5-4d38-85dc-1c356313c795"],
Cell[93236, 2056, 433, 10, 35, "Output",ExpressionUUID->"0d308d92-45a0-43d3-9cc5-f1315b67fddb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93706, 2071, 277, 5, 30, "Input",ExpressionUUID->"7808f686-37d5-45c2-bd72-fa81807d1936"],
Cell[93986, 2078, 382, 7, 24, "Print",ExpressionUUID->"5e8a784d-0c60-4872-a4b7-f6b1edfa9feb"],
Cell[94371, 2087, 528, 13, 35, "Output",ExpressionUUID->"0cf41f62-0fab-475b-9b08-4a3f766a5cc2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94936, 2105, 156, 3, 30, "Input",ExpressionUUID->"6d47f478-1871-4b72-8f35-237a61b1d232"],
Cell[95095, 2110, 147, 4, 34, "Output",ExpressionUUID->"59c6add4-8617-432e-b59a-1d3b721a8e05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95279, 2119, 155, 3, 30, "Input",ExpressionUUID->"07f7c144-824f-4709-a04d-f83ec33b8614"],
Cell[95437, 2124, 130, 3, 34, "Output",ExpressionUUID->"cbad6367-f3af-4ac2-a5de-a3c002001c21"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95604, 2132, 255, 4, 30, "Input",ExpressionUUID->"25beb7c3-37dc-4155-8a7f-9a1963350127"],
Cell[95862, 2138, 285, 5, 24, "Print",ExpressionUUID->"245d538c-8ed8-42a5-99f8-d5dc22149f92"],
Cell[96150, 2145, 506, 12, 35, "Output",ExpressionUUID->"43d1c9f6-1567-4900-96f6-2dbe05bdc160"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96693, 2162, 275, 4, 30, "Input",ExpressionUUID->"33e28cdc-b3ae-47cd-989a-7dd341deb59d"],
Cell[96971, 2168, 257, 5, 24, "Print",ExpressionUUID->"ffaac565-b240-4429-91ab-00646469d673"],
Cell[97231, 2175, 426, 10, 35, "Output",ExpressionUUID->"d316182c-aa02-4eea-a476-a427e2e6d60a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[97694, 2190, 244, 4, 30, "Input",ExpressionUUID->"c3125590-9894-46cd-ad2f-0e337067fc49"],
Cell[97941, 2196, 326, 6, 24, "Print",ExpressionUUID->"e9f2d17c-dae1-4049-a784-bfc0b670df02"],
Cell[98270, 2204, 477, 11, 35, "Output",ExpressionUUID->"ffe5f3a3-7a96-46a1-8973-8dc029db3ecc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98784, 2220, 318, 5, 30, "Input",ExpressionUUID->"dfe75968-da08-4eae-8f33-112199c66a35"],
Cell[99105, 2227, 330, 6, 24, "Print",ExpressionUUID->"dfc037f2-1fa0-4d1f-ac41-ea3a12294397"],
Cell[99438, 2235, 507, 11, 35, "Output",ExpressionUUID->"49d8ad12-9153-4946-8ee6-21d109fc1b37"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99982, 2251, 225, 3, 30, "Input",ExpressionUUID->"9a563104-f7c8-4c1f-9647-cf2c2f38a30b"],
Cell[100210, 2256, 281, 5, 24, "Print",ExpressionUUID->"aaef8582-2b4d-49d5-97a2-8a5121a0d65e"],
Cell[100494, 2263, 422, 10, 34, "Output",ExpressionUUID->"ade4cf01-61d5-42db-bc62-cef8c070976f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[100953, 2278, 450, 8, 52, "Input",ExpressionUUID->"60070de5-6c7a-4d18-89b9-e17d183ec74f"],
Cell[101406, 2288, 618, 10, 24, "Print",ExpressionUUID->"07476c8d-ff5d-456a-8a78-4f2e20f763f4"],
Cell[102027, 2300, 774, 16, 35, "Output",ExpressionUUID->"4ea42989-0191-4828-a866-95c8d1b4fae3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102838, 2321, 183, 3, 30, "Input",ExpressionUUID->"84412d35-e53e-4e06-830c-b9d91214b3d2"],
Cell[103024, 2326, 2973, 92, 77, "Output",ExpressionUUID->"cab18fa0-df82-4076-9f48-184c3724b564"]
}, Open  ]]
}
]
*)

