(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     93334,       2094]
NotebookOptionsPosition[     91764,       2058]
NotebookOutlinePosition[     92155,       2075]
CellTagsIndexPosition[     92112,       2072]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"2cd90f68-3a5a-43ee-8eb6-\
9f919490b66d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PNG", "\[Equal]", "True"}], ",", 
     RowBox[{"ImportString", "@", 
      RowBox[{"ExportString", "[", 
       RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"highlightCORRECT", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"debug", "\[Equal]", "False"}], ",", "s", ",", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PNG", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debug", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myFONTSIZE", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myLINEBREAKS", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textFORMAT", "[", "s_", "]"}], ":=", 
   RowBox[{"Text", "[", 
    RowBox[{"Style", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InsertLinebreaks", "[", 
       RowBox[{
        RowBox[{"ToString", "@", "s"}], ",", "myLINEBREAKS"}], "]"}], ",", 
      "myFONTSIZE", ",", 
      RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"textFORMAT2", "[", "s_", "]"}], ":=", 
    RowBox[{"Text", "[", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"InsertLinebreaks", "[", 
        RowBox[{"s", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
       RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lisp", "[", 
     RowBox[{"expression1_", ",", "expression2_", ",", "expression3_"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"expression", ",", "list"}], "}"}], ",", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"word2", "[", "]"}], ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"w", ",", "line", ",", "str"}], "}"}], ",", "\n", 
          RowBox[{
           RowBox[{"While", "[", "\n", " ", 
            RowBox[{
             RowBox[{"inputbuffer", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", "\n", " ", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"line", " ", "=", " ", 
                RowBox[{"Read", "[", 
                 RowBox[{"i", ",", "Record"}], "]"}]}], ";", "\n", " ", 
               RowBox[{"If", "[", " ", 
                RowBox[{
                 RowBox[{"line", " ", "==", " ", "EndOfFile"}], ",", " ", 
                 RowBox[{"Abort", "[", "]"}]}], " ", "]"}], ";", "\n", " ", 
               RowBox[{"Print", "@", " ", "line"}], ";", "\n", " ", 
               RowBox[{"Print", "[", 
                RowBox[{"{", 
                 RowBox[{"o", ",", "line"}], "}"}], "]"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"line", "=", "code"}], ";", "\n", " ", 
              RowBox[{"(*", " ", 
               RowBox[{
               "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
                "codes"}], " ", "*)"}], "\n", " ", 
              RowBox[{"line", " ", "=", " ", 
               RowBox[{"FromCharacterCode", "@", "\n", " ", 
                RowBox[{"Cases", "[", " ", 
                 RowBox[{
                  RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
                  RowBox[{"n_Integer", " ", "/;", " ", 
                   RowBox[{
                   "32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], " ",
                  "]"}]}]}], ";", "\n", " ", 
              RowBox[{"str", " ", "=", " ", 
               RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
              RowBox[{"inputbuffer", " ", "=", " ", 
               RowBox[{"ReadList", "[", 
                RowBox[{
                "str", ",", " ", "Word", ",", "\n", 
                 "                        ", 
                 RowBox[{"TokenWords", "->", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<(\>\"", ",", " ", "\"\<)\>\"", ",", " ", "\"\<[\>\"", 
                    ",", " ", "\"\<]\>\"", ",", " ", "\"\<'\>\"", ",", " ", 
                    "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], ";", "\n", " ", 
              RowBox[{"Close", "@", " ", "str"}]}]}], "\n", "]"}], ";", "\n", 
           
           RowBox[{"w", " ", "=", " ", 
            RowBox[{"First", "@", " ", "inputbuffer"}]}], ";", "\n", 
           RowBox[{"inputbuffer", " ", "=", " ", 
            RowBox[{"Rest", "@", " ", "inputbuffer"}]}], ";", "\n", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DigitQ", "@", "w"}], ",", " ", 
             RowBox[{"ToExpression", "@", "w"}], ",", " ", "w"}], "]"}]}]}], 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "convert", " ", "string", " ", "of", " ", "digits", " ", "to", " ", 
           "integer"}], " ", "*)"}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"word", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "w", "}"}], ",", "\n", 
          RowBox[{"While", "[", " ", 
           RowBox[{"True", ",", "\n", " ", 
            RowBox[{
             RowBox[{"w", " ", "=", " ", 
              RowBox[{"word2", "[", "]"}]}], ";", "\n", " ", 
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"w", " ", "=!=", " ", "\"\<[\>\""}], ",", " ", 
               RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", 
             " ", 
             RowBox[{"While", "[", " ", 
              RowBox[{
               RowBox[{"word", "[", "]"}], " ", "=!=", " ", "\"\<]\>\""}], 
              " ", "]"}]}]}], "\n", "]"}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"get", "[", 
         RowBox[{
          RowBox[{"sexp_:", "False"}], ",", 
          RowBox[{"rparenokay_:", "False"}]}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"w", " ", "=", " ", 
             RowBox[{"word", "[", "]"}]}], ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", 
             RowBox[{"{", "}"}]}], ",", " ", "name", ",", " ", "def", ",", 
            " ", "body", ",", " ", "varlist"}], "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", " ", 
             RowBox[{
              RowBox[{"While", "[", " ", 
               RowBox[{
                RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                 RowBox[{"(", 
                  RowBox[{"d", " ", "=", " ", 
                   RowBox[{"get", "[", 
                    RowBox[{"sexp", ",", "True"}], "]"}]}], ")"}]}], ",", 
                "\n", " ", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
              "\n", " ", 
              RowBox[{"Return", "@", " ", "l"}]}]}], "\n", " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"sexp", ",", " ", 
             RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<\\\"\>\"", ",", " ", 
             RowBox[{"get", "[", "True", "]"}], ",", "\n", " ", 
             "\"\<cadr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}], ",", "\n", " ", 
             "\"\<caddr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<cdr\>\"", ",", 
                   RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], ",", 
             "\n", " ", "\"\<let\>\"", ",", "\n", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"name", ",", "def", ",", "body"}], "}"}], " ", "=", 
               " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], ";", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{"!", 
                 RowBox[{"MatchQ", "[", 
                  RowBox[{"name", ",", 
                   RowBox[{
                    RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], 
                  "]"}]}], ",", "\n", " ", 
                RowBox[{
                 RowBox[{"varlist", " ", "=", " ", 
                  RowBox[{"Rest", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"name", " ", "=", " ", 
                  RowBox[{"First", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"def", " ", "=", " ", 
                  RowBox[{"{", 
                   RowBox[{"\"\<'\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<lambda\>\"", ",", "varlist", ",", "def"}], 
                    "}"}]}], "}"}]}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<'\>\"", ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<lambda\>\"", ",", 
                    RowBox[{"{", "name", "}"}], ",", "body"}], "}"}]}], "}"}],
                 ",", "def"}], "}"}]}], ",", "\n", " ", 
             RowBox[{"\"\<read-bit\>\"", "|", "\"\<read-exp\>\""}], ",", "\n",
              "                   ", 
             RowBox[{"{", "w", "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<car\>\"", "|", "\"\<cdr\>\"", "|", "\"\<atom\>\"", "|", 
              "\"\<'\>\"", "|", "\"\<display\>\"", "|", "\"\<eval\>\"", "|", 
              "\"\<bits\>\"", "|", "\"\<debug\>\"", "|", "\n", " ", 
              "\"\<length\>\"", "|", "\"\<size\>\"", "|", 
              "\"\<base2-to-10\>\"", "|", "\"\<base10-to-2\>\""}], ",", "\n", 
             "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<cons\>\"", "|", "\"\<=\>\"", "|", "\"\<lambda\>\"", "|", 
              "\"\<append\>\"", "|", "\"\<define\>\"", "|", "\"\<+\>\"", "|", 
              "\"\<-\>\"", "|", "\"\<*\>\"", "|", "\"\<^\>\"", "|", 
              "\"\<<\>\"", "|", "\"\<>\>\"", "|", "\"\<<=\>\"", "|", 
              "\"\<>=\>\""}], ",", "\n", "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{"\"\<if\>\"", "|", "\"\<let\>\"", "|", "\"\<try\>\""}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", "_", ",", 
             " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"getbit", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "x", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"trouble", " ", "=", " ", "False"}], ";", " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "tape"}], ",", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"trouble", " ", "=", " ", "True"}], ";", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], ")"}]}], 
            "]"}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"x", " ", "===", " ", "0"}], ",", " ", "0", ",", " ", 
             "1"}], " ", "]"}]}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getchar", "[", "]"}], " ", ":=", " ", 
        RowBox[{"FromCharacterCode", "[", "\n", "  ", 
         RowBox[{
          RowBox[{"128", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"64", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"32", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"16", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", "\n", "  ", 
          RowBox[{"8", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"4", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"2", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"getbit", "[", "]"}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getrecord", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"c", ",", " ", 
            RowBox[{"line", " ", "=", " ", "\"\<\>\""}], ",", " ", "str"}], 
           " ", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"{", "}"}]}], ";", "\n", " ", 
           RowBox[{"While", "[", " ", 
            RowBox[{
             RowBox[{"\"\<\\n\>\"", " ", "=!=", " ", 
              RowBox[{"(", 
               RowBox[{"c", " ", "=", " ", 
                RowBox[{"getchar", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             RowBox[{"line", " ", "=", " ", 
              RowBox[{"line", " ", "<>", " ", "c"}]}]}], " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"trouble", ",", " ", 
             RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], "]"}], ";",
            " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
             "codes"}], " ", "*)"}], "\n", " ", 
           RowBox[{"line", " ", "=", " ", 
            RowBox[{"FromCharacterCode", "@", "\n", " ", 
             RowBox[{"Cases", "[", " ", 
              RowBox[{
               RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
               RowBox[{"n_Integer", " ", "/;", " ", 
                RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}],
               " ", "]"}]}]}], ";", "\n", " ", 
           RowBox[{"str", " ", "=", " ", 
            RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"ReadList", "[", 
             RowBox[{"str", ",", " ", "Word", ",", " ", 
              RowBox[{"TokenWords", "->", 
               RowBox[{"{", 
                RowBox[{"\"\<(\>\"", ",", " ", "\"\<)\>\""}], "}"}]}]}], 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"Close", "@", " ", "str"}], ";", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "convert", " ", "strings", " ", "of", " ", "digits", " ", "to", 
             " ", "integers"}], " ", "*)"}], "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"DigitQ", "@", "#"}], ",", " ", 
                RowBox[{"ToExpression", "@", "#"}], ",", " ", "#"}], "]"}], 
              "&"}], " ", "/@", " ", "inputbuffer2"}]}], " ", ";"}]}], "\n", 
         "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getexp", "[", 
         RowBox[{"rparenokay_:", "False"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"w", ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", " ", 
             RowBox[{"{", "}"}]}]}], " ", "}"}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{" ", 
              RowBox[{"supply", " ", "unlimited", " ", "number", " ", "of"}], 
              " ", ")"}], "'"}], "s", " ", "if", " ", "tokens", " ", "run", 
            " ", "out"}], " ", "*)"}], "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"inputbuffer2", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", " ", 
             RowBox[{"w", " ", "=", " ", "\"\<)\>\""}], ",", "\n", " ", 
             RowBox[{
              RowBox[{"w", " ", "=", " ", 
               RowBox[{"First", "@", " ", "inputbuffer2"}]}], ";", "\n", " ", 
              
              RowBox[{"inputbuffer2", " ", "=", " ", 
               RowBox[{"Rest", "@", " ", "inputbuffer2"}]}]}]}], " ", "]"}], 
           ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"While", "[", " ", 
                RowBox[{
                 RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                  RowBox[{"(", 
                   RowBox[{"d", " ", "=", " ", 
                    RowBox[{"getexp", "[", "True", "]"}]}], ")"}]}], ",", 
                 "\n", " ", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
               "\n", " ", 
               RowBox[{"Return", "@", " ", "l"}]}], "\n", ")"}], ",", "\n", 
             " ", "_", ",", " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"atom", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"MatchQ", "[", " ", 
         RowBox[{"x", ",", " ", 
          RowBox[{
           RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], " ", 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"car", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
          RowBox[{"First", "@", " ", "x"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"cdr", "[", "x_", "]"}], " ", ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "\n", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
            RowBox[{"Rest", "@", " ", "x"}]}], " ", "]"}]}], "]"}]}], ";", 
       "\n", 
       RowBox[{
        RowBox[{"cons", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"y", ",", 
            RowBox[{"_String", "|", "_Integer"}]}], "]"}], ",", " ", "x", ",",
           " ", 
          RowBox[{"Prepend", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], " ", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"without", " ", "lamda"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Module", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z"}], "}"}], ",",
           "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"debug", "@", "e"}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<int\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_String"}], "]"}], ",", "  ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<str\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"atom", "@", " ", "e"}], ",", " ", 
               RowBox[{"Block", "[", " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", 
                 "\n", "   ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
                   "a"}], ";", "\n", "   ", 
                  RowBox[{"pos", " ", "=", " ", 
                   RowBox[{"Position", "[", 
                    RowBox[{"names", ",", "e", ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", 
                  RowBox[{"debug", "@", 
                   RowBox[{"{", 
                    RowBox[{"\"\<->\>\"", ",", "a", ",", "e", ",", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    "}"}]}], ";", "  ", 
                  RowBox[{"Return", "@", " ", 
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";"}], 
            "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\[IndentingNewLine]", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<f \>\"", ",", "f", ",", "\"\< \>\"", ",", "e"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<'() \>\"", ",", "f", ",", "\"\< e= \>\"", ",", "e", ",", 
                 
                 RowBox[{"car", "@", " ", "e"}]}], "}"}]}], ";", " ", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"car", "@", " ", "e"}]}]}], ",", "\n", " ", 
             "\"\<if\>\"", ",", " ", 
             RowBox[{"Return", "@", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"eval", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                  "]"}], " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                 "]"}], ",", "\n", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                 "]"}]}], "\n", " ", "]"}]}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"TODO", ":", " ", 
              RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
             "*)"}], "\n", " ", "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<before args \>\"", ",", "\"\< \>\"", ",", "f", ",", 
              "\"\< \>\"", " ", ",", "e"}], "}"}]}], ";", "\n", 
           RowBox[{"args", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"eval", "[", 
               RowBox[{
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}],
               ",", 
              RowBox[{"{", 
               RowBox[{"ii", ",", "1", ",", 
                RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<args \>\"", ",", "\"\< \>\"", ",", "args"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"Switch", "[", "\n", 
            RowBox[{
            "f", ",", "\[IndentingNewLine]", "\n", " ", "\"\<read-bit\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"",
              ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", 
                 ",", "y", ",", "z"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<+\>\"", ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", 
                 ",", "y", ",", "z"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                 RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<*\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
             "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", 
              "]"}], ";", "\n", " ", 
             RowBox[{"d", "--"}], ";", "\n", " ", 
             RowBox[{"Switch", "[", "\n", " ", 
              RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", 
               " ", "\"\<try\>\"", ",", " ", 
               RowBox[{"Return", "@", "\n", " ", 
                RowBox[{"Block", "[", " ", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"out", " ", "=", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", 
                    RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                    RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                    "xx"}], "}"}], ",", "\n", " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                    ",", " ", 
                    RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                    RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                    " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
                 "]"}]}]}], " ", 
              RowBox[{"(*", " ", 
               RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
             ";"}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "switch"}], " ", "*)"}], 
            "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<end \>\"", ",", "e"}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"f", " ", "=", " ", 
              RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
             "\n", 
             RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
              RowBox[{
               RowBox[{"f", " ", "=", " ", 
                RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"eval", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
                 RowBox[{"bind", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                  "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
             "\[IndentingNewLine]", "\n", " ", 
             RowBox[{"eval", "[", " ", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
               RowBox[{"bind", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval2", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Module", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z", ",", 
            "values", ",", "pos", ",", "xxx", ",", "vars", ",", "func", ",", 
            "names0"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"debug", "@", "e"}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<int\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", 
           "\[IndentingNewLine]", "   ", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", "a"}], 
           ";", 
           RowBox[{"pos", " ", "=", " ", 
            RowBox[{"Position", "[", 
             RowBox[{"names0", ",", "e", ",", 
              RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"MatchQ", "[", 
               RowBox[{"e", ",", "_String"}], "]"}], "&&", 
              RowBox[{"pos", "\[Equal]", 
               RowBox[{"{", "}"}]}]}], ",", "  ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<str\>\"", ",", "e"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", "e"}]}]}], " ", "]"}], ";", "\n", 
           " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "e"}], ",", " ", 
             RowBox[{"Block", "[", " ", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"(*", 
                 RowBox[{"names", ",", "values", ",", "pos"}], "*)"}], "}"}], 
               ",", "\n", "   ", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", 
                 "a"}], ";", "\n", "   ", 
                RowBox[{"pos", " ", "=", " ", 
                 RowBox[{"Position", "[", 
                  RowBox[{"names0", ",", "e", ",", 
                   RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", 
                RowBox[{"debug", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<->\>\"", ",", "a", ",", "e", ",", 
                   RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                  "}"}]}], ";", "  ", 
                RowBox[{"Return", "@", " ", 
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                   RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                  " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";", "\n", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval2", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\[IndentingNewLine]", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<f \>\"", ",", "f", ",", "\"\< \>\"", ",", "e"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<'() \>\"", ",", "f", ",", "\"\< e= \>\"", ",", "e", ",", 
                 
                 RowBox[{"car", "@", " ", "e"}]}], "}"}]}], ";", " ", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"car", "@", " ", "e"}]}]}], ",", "\n", " ", 
             "\"\<if\>\"", ",", " ", 
             RowBox[{"Return", "@", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"eval2", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                  "]"}], " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
                RowBox[{"eval2", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                 "]"}], ",", "\n", " ", 
                RowBox[{"eval2", "[", 
                 RowBox[{
                  RowBox[{"car", "@", 
                   RowBox[{"cdr", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                 "]"}]}], "\n", " ", "]"}]}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"TODO", ":", " ", 
              RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
             "*)"}], "\n", " ", "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{
             "\"\<before args \>\"", ",", "\"\< \>\"", ",", "f", ",", 
              "\"\< \>\"", " ", ",", "e"}], "}"}]}], ";", "\n", 
           RowBox[{"args", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"eval2", "[", 
               RowBox[{
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}],
               ",", 
              RowBox[{"{", 
               RowBox[{"ii", ",", "1", ",", 
                RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<args \>\"", ",", "\"\< \>\"", ",", "args"}], 
             "}"}]}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", 
           "\[IndentingNewLine]", "\n", " ", 
           RowBox[{"Switch", "[", "\n", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", "f"}], "\[GreaterEqual]", "3"}], ",", 
               RowBox[{
                RowBox[{"vars", "=", 
                 RowBox[{
                  RowBox[{"f", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                RowBox[{"func", "=", 
                 RowBox[{
                  RowBox[{"f", "[", 
                   RowBox[{"[", "3", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                RowBox[{"f", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], ",", " ", "f"}], "]"}], 
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\"\<lambda\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<...\>\"", ",", "f", ",", "e", ",", "\"\< vars \>\"", ",",
                  "vars", ",", " ", "\"\<  func \>\"", ",", "func"}], "}"}]}],
               ";", 
              RowBox[{"xxx", "=", 
               RowBox[{"func", "/.", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"vars", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}], "\[Rule]", 
                   RowBox[{"e", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"ii", ",", "1", ",", " ", 
                    RowBox[{"Length", "@", "vars"}]}], "}"}]}], "]"}]}]}], 
              ";", 
              RowBox[{"Return", "@", "xxx"}]}], ",", "\n", " ", 
             "\"\<read-bit\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"",
              ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", 
                 ",", "y", ",", "z"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"cdr", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<+\>\"", ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<cdr@x\>\"", ",", "f", ",", "e", ",", "args", ",", "x", 
                 ",", "y", ",", "z"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                 RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<*\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "\"\<true\>\"", ",", 
                " ", "\"\<false\>\""}], "]"}]}], ",", "\n", " ", 
             "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", 
              "]"}], ";", "\n", " ", 
             RowBox[{"d", "--"}], ";", "\n", " ", 
             RowBox[{"Switch", "[", "\n", " ", 
              RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", 
               " ", "\"\<try\>\"", ",", " ", 
               RowBox[{"Return", "@", "\n", " ", 
                RowBox[{"Block", "[", " ", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"out", " ", "=", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", 
                    RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                    RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                    "xx"}], "}"}], ",", "\n", " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                    ",", " ", 
                    RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                    RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                    " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
                 "]"}]}]}], " ", 
              RowBox[{"(*", " ", 
               RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
             ";"}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "switch"}], " ", "*)"}], 
            "\[IndentingNewLine]", "*)"}], "\n", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<end \>\"", ",", "e"}], "}"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"f", " ", "=", " ", 
              RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
             "\n", 
             RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
              RowBox[{
               RowBox[{"f", " ", "=", " ", 
                RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"eval", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
                 RowBox[{"bind", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                  "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
             "\[IndentingNewLine]", "\n", " ", 
             RowBox[{"eval", "[", " ", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
               RowBox[{"bind", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}],
        ";", "\n", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"nmb", "[", "n_Integer", "]"}], " ", ":=", " ", "n"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nmb", "[", "x_", "]"}], " ", ":=", "x"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{
          RowBox[{"vars_", "?", "atom"}], ",", "args_", ",", "a_"}], "]"}], 
        " ", ":=", "a"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{"vars_", ",", "args_", ",", "a_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", 
          " ", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
            RowBox[{"bind", "[", " ", 
             RowBox[{
              RowBox[{"cdr", "@", " ", "vars"}], ",", " ", 
              RowBox[{"cdr", "@", " ", "args"}], ",", " ", "a"}], " ", 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"pos", " ", "=", " ", 
            RowBox[{"Position", "[", 
             RowBox[{"names", ",", " ", 
              RowBox[{"car", "@", " ", "vars"}], ",", " ", 
              RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"names", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "vars"}]}], "]"}], ",", "\n", "  ", 
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"values", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "args"}]}], "]"}]}], "}"}]}]}], "\n", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", "e_", "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"out", " ", "=", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
          RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"print", "[", " ", 
             RowBox[{"\"\<expression\>\"", ",", " ", 
              RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"debug", "@", 
           RowBox[{"{", 
            RowBox[{"\"\<names,defs\>\"", ",", "names", ",", "defs"}], 
            "}"}]}], ";", "\n", " ", 
          RowBox[{"Catch", "[", " ", 
           RowBox[{"eval", "[", " ", 
            RowBox[{"e", ",", " ", 
             RowBox[{"{", 
              RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], 
            " ", "]"}], " ", "]"}]}], "\n", ")"}]}], ";", 
       "\[IndentingNewLine]", "\n", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval2", "[", "e_", "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"out", " ", "=", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
          RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"print", "[", " ", 
             RowBox[{"\"\<expression\>\"", ",", " ", 
              RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"debug", "@", 
           RowBox[{"{", 
            RowBox[{"\"\<names,defs\>\"", ",", "names", ",", "defs"}], 
            "}"}]}], ";", "\n", " ", 
          RowBox[{"Catch", "[", " ", 
           RowBox[{"eval2", "[", " ", 
            RowBox[{"e", ",", " ", 
             RowBox[{"{", 
              RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], 
            " ", "]"}], " ", "]"}]}], "\n", ")"}]}], ";", "\n", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e_", ",", "Null", ",", "d_"}], "]"}], " ", ":=", " ", 
        RowBox[{"eval", "[", 
         RowBox[{"e", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<nil\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "d"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"let", "[", 
         RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"print", "[", " ", 
            RowBox[{"\"\<define\>\"", ",", " ", 
             RowBox[{"output", "@", " ", "n"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"print", "[", " ", 
            RowBox[{"\"\<value\>\"", ",", " ", 
             RowBox[{"output", "@", " ", "d"}]}], " ", "]"}], ";"}], "*)"}], 
         "\n", " ", 
         RowBox[{
          RowBox[{"PrependTo", "[", 
           RowBox[{"names", ",", "n"}], "]"}], ";", "\n", " ", 
          RowBox[{"PrependTo", "[", 
           RowBox[{"defs", ",", "d"}], "]"}], ";"}], "\n", ")"}]}], ";", 
       "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"output2", "[", "x_String", "]"}], " ", ":=", " ", 
          RowBox[{"x", "<>", "\"\< \>\""}]}], ";", "\n", 
         RowBox[{
          RowBox[{"output2", "[", "x_Integer", "]"}], " ", ":=", " ", 
          RowBox[{
           RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";"}], 
        "*)"}], "\[IndentingNewLine]", "\n", 
       RowBox[{
        RowBox[{"output2", "[", "x_", "]"}], ":=", 
        RowBox[{
         RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output2", "[", 
         RowBox[{"{", "x___", "}"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "s", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"s", " ", "=", " ", 
            RowBox[{"StringJoin", "[", 
             RowBox[{"\"\<(\>\"", ",", " ", 
              RowBox[{"output2", " ", "/@", " ", 
               RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"StringTake", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}], " ", "==", " ", "\"\< \>\""}], 
             ",", " ", 
             RowBox[{"s", " ", "=", " ", 
              RowBox[{"StringDrop", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}]}]}], " ", "]"}], ";", "\n", " ", 
           RowBox[{"s", " ", "<>", " ", "\"\<) \>\""}]}]}], "\n", "]"}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{"blanks", " ", "=", " ", 
        RowBox[{"StringJoin", "@", " ", 
         RowBox[{"Table", "[", 
          RowBox[{"\"\< \>\"", ",", 
           RowBox[{"{", "12", "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"print2", "[", 
            RowBox[{"x", ",", 
             RowBox[{"StringTake", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"print", "[", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"StringDrop", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}]}], ")"}], " ", "/;", 
         " ", 
         RowBox[{
          RowBox[{"StringLength", "[", "y", "]"}], " ", ">", " ", "50"}]}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print2", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print2", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print3", "[", 
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{
            RowBox[{"x", "<>", "blanks"}], ",", "12"}], "]"}], "<>", "y"}], 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print3", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"(", 
         RowBox[{"Print", "[", "x", "]"}], 
         RowBox[{"(*", 
          RowBox[{";", " ", 
           RowBox[{"WriteString", "[", 
            RowBox[{"o", ",", "x", ",", "\"\<\\n\>\""}], "]"}]}], "*)"}], 
         ")"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"debug", "[", "x_", "]"}], ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"debugflag", "==", "True"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"list", ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"ctr", "++"}]}], "}"}]}], "]"}], ",", "Nothing"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"debugflag", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"code1", "=", "expression1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"code2", "=", "expression2"}], ";", "\[IndentingNewLine]", 
          RowBox[{"code3", "=", "expression3"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression1"}], ";", 
          RowBox[{"first", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", " ", 
          RowBox[{"names", " ", "=", " ", 
           RowBox[{"{", "\"\<nil\>\"", "}"}]}], ";", " ", 
          RowBox[{"defs", " ", "=", " ", 
           RowBox[{"{", 
            RowBox[{"{", "}"}], "}"}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Quiet", "@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"eval", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
              RowBox[{"get", "[", "]"}]}], ")"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<define\>\"", ",", "func_", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"\"\<lambda\>\"", ",", "vars___", ",", 
                  RowBox[{"{", "def__", "}"}]}], "}"}], "}"}]}], "}"}], " ", ":>",
              " ", 
             RowBox[{"let", "[", 
              RowBox[{"func", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda\>\"", ",", 
                 RowBox[{"{", "vars", "}"}], ",", "def"}], "}"}]}], "]"}]}], 
            "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression2"}], ";", 
          RowBox[{"first", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Quiet", "@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"eval", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
              RowBox[{"get", "[", "]"}]}], ")"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<define\>\"", ",", "func_", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"\"\<lambda\>\"", ",", "vars___", ",", 
                  RowBox[{"{", "def__", "}"}]}], "}"}], "}"}]}], "}"}], " ", ":>",
              " ", 
             RowBox[{"let", "[", 
              RowBox[{"func", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda\>\"", ",", 
                 RowBox[{"{", "vars", "}"}], ",", "def"}], "}"}]}], "]"}]}], 
            "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression3"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"res", "=", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"eval2", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
             RowBox[{"get", "[", "]"}]}], ")"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"res", ",", "InputForm"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<{\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
              RowBox[{"\"\<}\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
              RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<\>\""}], ",", 
              RowBox[{"\"\<\\\"\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
           "]"}]}], "\[IndentingNewLine]", "}"}]}]}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.668701916815751*^9, 3.66870193624583*^9}, {
   3.668702133786916*^9, 3.668702134347089*^9}, 3.6687022853581867`*^9, {
   3.6687023887130537`*^9, 3.668702431753148*^9}, {3.668702614804088*^9, 
   3.668702625199012*^9}, {3.6687027298143806`*^9, 3.668702756813094*^9}, {
   3.668702877190712*^9, 3.668702935882134*^9}, {3.66870296651546*^9, 
   3.66870298115119*^9}, {3.6687030616129713`*^9, 3.668703076596231*^9}, {
   3.6687032983584623`*^9, 3.668703329036998*^9}, {3.668703359547501*^9, 
   3.668703364937311*^9}, {3.668703409385564*^9, 3.668703409598823*^9}, {
   3.668703451281674*^9, 3.6687034539581423`*^9}, {3.668703510951167*^9, 
   3.668703581870448*^9}, {3.6687039495461273`*^9, 3.668703986468754*^9}, {
   3.668704034787966*^9, 3.668704107158821*^9}, {3.66870434254609*^9, 
   3.668704391482483*^9}, {3.668704866202161*^9, 3.6687049166354513`*^9}, {
   3.6687049703789988`*^9, 3.668705016862217*^9}, {3.6687050581514177`*^9, 
   3.6687051409960737`*^9}, {3.6687051853865957`*^9, 3.66870519864028*^9}, {
   3.66870530439258*^9, 3.6687053058318567`*^9}, {3.668705396406801*^9, 
   3.6687054449499273`*^9}, {3.668705727226926*^9, 3.668705760863277*^9}, {
   3.6687209180348263`*^9, 3.668720939416154*^9}, 3.668722524214611*^9, {
   3.721457652040442*^9, 3.721457659126416*^9}, {3.7214577653528957`*^9, 
   3.721457851048711*^9}, {3.721457919819281*^9, 3.7214579203696547`*^9}, {
   3.721458310459865*^9, 3.7214583299327602`*^9}, {3.721458374957127*^9, 
   3.721458387725543*^9}, {3.721458441637535*^9, 3.721458517261661*^9}, {
   3.721458573941455*^9, 3.721458588881013*^9}, {3.721458621215254*^9, 
   3.7214586315983877`*^9}, {3.721458687018977*^9, 3.721458702386259*^9}, {
   3.721459211034535*^9, 3.7214592617629347`*^9}, {3.7214593029271*^9, 
   3.7214593145595713`*^9}, {3.721459425330224*^9, 3.721459425656097*^9}, {
   3.721463532835463*^9, 3.721463535309825*^9}, 3.721505197215242*^9, {
   3.721505468875614*^9, 3.7215054734755*^9}, {3.721508064655298*^9, 
   3.721508072182108*^9}, {3.7215081096316347`*^9, 3.721508112465963*^9}, {
   3.7215332454364023`*^9, 3.721533280851383*^9}, {3.7215334454449787`*^9, 
   3.721533455479636*^9}, {3.721533538115106*^9, 3.721533546765699*^9}, {
   3.7215353422374*^9, 3.721535357125392*^9}, 3.7215359945581007`*^9, {
   3.7215632700342817`*^9, 3.721563333620592*^9}, {3.721568349314021*^9, 
   3.721568355163103*^9}, {3.72206933003051*^9, 3.7220693303554068`*^9}, 
   3.722069380066366*^9, {3.722069540265856*^9, 3.72206956972978*^9}, {
   3.722069617986521*^9, 3.722069620432428*^9}, {3.722069675297456*^9, 
   3.722069677663872*^9}, 3.722070274881424*^9, {3.722070379491681*^9, 
   3.722070380210538*^9}, {3.722071740854188*^9, 3.722071744839407*^9}, {
   3.722073171158132*^9, 3.722073230321724*^9}, {3.722223999433947*^9, 
   3.72222401172821*^9}, {3.722224097099599*^9, 3.7222241818050137`*^9}, {
   3.7222242174282417`*^9, 3.7222242421507883`*^9}, {3.722224357099609*^9, 
   3.722224367907178*^9}, {3.722273073777082*^9, 3.722273078171007*^9}, {
   3.722279499406726*^9, 3.722279500076798*^9}, 3.722279540230859*^9, {
   3.722279631427246*^9, 3.7222796358817377`*^9}, {3.722279812399248*^9, 
   3.722279843303878*^9}},ExpressionUUID->"35279de8-5a6c-4eae-b99b-\
469b4aee237a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<expression\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "\[Rule]", 
            "\"\<(cdr ((+ (func1 100 1 2) (func2 6)) (func2 -5)))\>\""}], 
           "|>"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<function1\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "->", 
            "\"\<(define func1 (lambda (z y x) (+ y (* x z))))\>\""}], 
           "|>"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<function2\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "\[Rule]", 
            "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\""}], 
           "|>"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Lisp Interpreter with functions \>\"", ",", "Orange", ",", 
             " ", "Bold", ",", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Run\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"lisp", "[", 
       RowBox[{"#function1", ",", "#function2", ",", "#expression"}], "]"}], 
      "&"}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.6687019387415037`*^9, {3.668702018945513*^9, 3.668702021362136*^9}, {
   3.6687020551480513`*^9, 3.668702107897636*^9}, {3.668702178807077*^9, 
   3.6687021958064547`*^9}, {3.668702239952825*^9, 3.6687023436087427`*^9}, {
   3.6687025518166237`*^9, 3.668702596420607*^9}, {3.668702652491873*^9, 
   3.6687026812797422`*^9}, {3.6687036692618027`*^9, 3.668703684450075*^9}, {
   3.7214581991277103`*^9, 3.721458199429619*^9}, {3.7214582473786182`*^9, 
   3.721458296733281*^9}, {3.721458338348125*^9, 3.721458357664834*^9}, 
   3.721458429093857*^9, {3.721458790532482*^9, 3.721458793028949*^9}, {
   3.72145885229639*^9, 3.7214588949001627`*^9}, {3.721459273923686*^9, 
   3.721459278513587*^9}, {3.721459437413912*^9, 3.721459471760054*^9}, {
   3.721459561797625*^9, 3.721459568389389*^9}, {3.721463500119329*^9, 
   3.721463506317503*^9}, 3.721463545830546*^9, 3.72146362007117*^9, {
   3.7214636580407143`*^9, 3.7214637336560707`*^9}, {3.721463766044441*^9, 
   3.7214637708248587`*^9}, 3.721508095043187*^9, 3.721533489347207*^9, 
   3.721534682279892*^9, {3.7215634053304157`*^9, 3.7215634132620077`*^9}, 
   3.7220696505233917`*^9, {3.722073279339679*^9, 3.722073314564149*^9}, 
   3.722073757361457*^9, {3.7222798793593893`*^9, 3.722279976010249*^9}, {
   3.72228002338774*^9, 3.722280037178404*^9}, {3.722280078480661*^9, 
   3.722280134156954*^9}},ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-\
88036260f931"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-\
efb0ac26d102\"",
     "https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-\
efb0ac26d102"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-efb0ac26d102"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.668702440473839*^9, 3.668702599311335*^9, 3.668702630234618*^9, 
   3.66870276172163*^9, {3.668702884776046*^9, 3.6687029013214397`*^9}, 
   3.668702940803843*^9, 3.668703086106824*^9, 3.6687031423779497`*^9, 
   3.668703336512856*^9, 3.6687033694726467`*^9, 3.668703414525476*^9, 
   3.6687034594849052`*^9, {3.668703521112142*^9, 3.668703586411539*^9}, {
   3.668703678090148*^9, 3.668703687206891*^9}, 3.668703991240896*^9, 
   3.668704097623562*^9, 3.668704397243503*^9, 3.668705280205473*^9, 
   3.668705416430118*^9, 3.6687054505580053`*^9, 3.66870576754501*^9, 
   3.668720951596919*^9, 3.668722539478557*^9, 3.721458392959919*^9, 
   3.7214584315862827`*^9, {3.721458523281312*^9, 3.721458540233698*^9}, 
   3.721458636446863*^9, {3.7214586900420227`*^9, 3.7214587050497217`*^9}, 
   3.7214588022533007`*^9, 3.721458910416202*^9, 3.7214592803511543`*^9, 
   3.7214593180516233`*^9, {3.72145942949817*^9, 3.72145943871248*^9}, 
   3.721459473463122*^9, 3.721459572978836*^9, 3.72146350755993*^9, 
   3.7214635675093613`*^9, 3.721463631482452*^9, {3.721463671717452*^9, 
   3.721463692610738*^9}, 3.721463740218576*^9, 3.7214637714238977`*^9, 
   3.721505681368531*^9, {3.721508087606447*^9, 3.7215081154021397`*^9}, {
   3.72153349165814*^9, 3.72153349720348*^9}, 3.721533552074951*^9, 
   3.7215346840011873`*^9, 3.721563442261989*^9, 3.721568380596117*^9, {
   3.7220733118500633`*^9, 3.722073315854253*^9}, 3.722073759539748*^9, 
   3.722280041887496*^9, 3.722280101077608*^9, 
   3.722280137945015*^9},ExpressionUUID->"00592e20-f000-4912-bf99-\
fa8cf617b828"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"lisp", "[", 
   RowBox[{
   "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
    "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
    "\"\<(car ((+ (func1 1 2) (func2 6)) (func2 -5)))\>\""}], " ", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.721533386443975*^9, 3.721533386854467*^9}, {
  3.72206968635201*^9, 3.722069694342019*^9}, {3.7220737370731907`*^9, 
  3.7220737482457037`*^9}, {3.722279559127697*^9, 3.7222795963674593`*^9}, {
  3.72228067573464*^9, 3.722280700978385*^9}, {3.7222807344450493`*^9, 
  3.72228073471378*^9}},ExpressionUUID->"44d4a5b7-13a0-4e04-961c-\
3f3e04b5a33f"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"((1 + 6*x*y + 2*z))\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.72206969770576*^9, 3.72207027948031*^9, 3.722070430809999*^9, 
   3.7220717726660557`*^9, {3.7220737432742357`*^9, 3.722073748556281*^9}, 
   3.722279641496366*^9, 3.7222797314949083`*^9, 3.722279848156872*^9, 
   3.722280703738687*^9, 
   3.722280736541141*^9},ExpressionUUID->"fff9bd8e-ba21-4cd7-839c-\
fe189cf91130"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\"\<(car (d e fgh))\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7220704704029207`*^9, 3.722070482687192*^9}, 
   3.72207356478878*^9},ExpressionUUID->"af57530a-4531-4c40-a3e5-\
f1ffa1de80f8"],

Cell[BoxData[
 RowBox[{"lisp", "[", "\<\"(car (d e fgh))\"\>", "]"}]], "Output",
 CellChangeTimes->{
  3.7222731590565157`*^9},ExpressionUUID->"5758b608-efd2-4ef1-9076-\
dc283053bd99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["list"], "Input",
 CellChangeTimes->{{3.722073120391779*^9, 
  3.722073120922089*^9}},ExpressionUUID->"6d47f478-1871-4b72-8f35-\
237a61b1d232"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.722073121908452*^9},ExpressionUUID->"59c6add4-8617-432e-b59a-\
1d3b721a8e05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ctr"], "Input",
 CellChangeTimes->{{3.722073155241357*^9, 
  3.722073155742424*^9}},ExpressionUUID->"07f7c144-824f-4709-a04d-\
f83ec33b8614"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.722073156647114*^9},ExpressionUUID->"cbad6367-f3af-4ac2-a5de-\
a3c002001c21"]
}, Open  ]]
},
WindowSize->{1259, 1088},
WindowMargins->{{Automatic, 186}, {14, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"2cd90f68-3a5a-43ee-8eb6-9f919490b66d"],
Cell[1747, 54, 82297, 1819, 9334, "Input",ExpressionUUID->"35279de8-5a6c-4eae-b99b-469b4aee237a"],
Cell[CellGroupData[{
Cell[84069, 1877, 3234, 65, 220, "Input",ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-88036260f931"],
Cell[87306, 1944, 2011, 35, 37, "Output",ExpressionUUID->"00592e20-f000-4912-bf99-fa8cf617b828"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89354, 1984, 676, 13, 73, "Input",ExpressionUUID->"44d4a5b7-13a0-4e04-961c-3f3e04b5a33f"],
Cell[90033, 1999, 594, 14, 35, "Output",ExpressionUUID->"fff9bd8e-ba21-4cd7-839c-fe189cf91130"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90664, 2018, 229, 4, 30, "Input",ExpressionUUID->"af57530a-4531-4c40-a3e5-f1ffa1de80f8"],
Cell[90896, 2024, 184, 4, 34, "Output",ExpressionUUID->"5758b608-efd2-4ef1-9076-dc283053bd99"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91117, 2033, 156, 3, 30, "Input",ExpressionUUID->"6d47f478-1871-4b72-8f35-237a61b1d232"],
Cell[91276, 2038, 147, 4, 34, "Output",ExpressionUUID->"59c6add4-8617-432e-b59a-1d3b721a8e05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[91460, 2047, 155, 3, 30, "Input",ExpressionUUID->"07f7c144-824f-4709-a04d-f83ec33b8614"],
Cell[91618, 2052, 130, 3, 34, "Output",ExpressionUUID->"cbad6367-f3af-4ac2-a5de-a3c002001c21"]
}, Open  ]]
}
]
*)

