(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    128279,       2913]
NotebookOptionsPosition[    121972,       2800]
NotebookOutlinePosition[    122358,       2817]
CellTagsIndexPosition[    122315,       2814]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"2cd90f68-3a5a-43ee-8eb6-\
9f919490b66d"],

Cell[TextData[{
 "\n\n",
 StyleBox["Supports If", "Title"]
}], "Text",
 CellChangeTimes->{{3.75181422841143*^9, 
  3.751814236817361*^9}},ExpressionUUID->"97bbd8a9-8cb7-44a9-9ef5-\
4561fd2fa577"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PNG", "\[Equal]", "True"}], ",", 
     RowBox[{"ImportString", "@", 
      RowBox[{"ExportString", "[", 
       RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"highlightCORRECT", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"debug", "\[Equal]", "False"}], ",", "s", ",", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PNG", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myFONTSIZE", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myLINEBREAKS", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textFORMAT", "[", "s_", "]"}], ":=", 
   RowBox[{"Text", "[", 
    RowBox[{"Style", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InsertLinebreaks", "[", 
       RowBox[{
        RowBox[{"ToString", "@", "s"}], ",", "myLINEBREAKS"}], "]"}], ",", 
      "myFONTSIZE", ",", 
      RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"textFORMAT2", "[", "s_", "]"}], ":=", 
    RowBox[{"Text", "[", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"InsertLinebreaks", "[", 
        RowBox[{"s", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
       RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"lisp", "[", 
     RowBox[{"expression1_", ",", "expression2_", ",", "expression3_"}], 
     "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"expression", ",", "list"}], "}"}], ",", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"word2", "[", "]"}], ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"w", ",", "line", ",", "str"}], "}"}], ",", "\n", 
          RowBox[{
           RowBox[{"While", "[", "\n", " ", 
            RowBox[{
             RowBox[{"inputbuffer", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", "\n", " ", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"line", " ", "=", " ", 
                RowBox[{"Read", "[", 
                 RowBox[{"i", ",", "Record"}], "]"}]}], ";", "\n", " ", 
               RowBox[{"If", "[", " ", 
                RowBox[{
                 RowBox[{"line", " ", "==", " ", "EndOfFile"}], ",", " ", 
                 RowBox[{"Abort", "[", "]"}]}], " ", "]"}], ";", "\n", " ", 
               RowBox[{"Print", "@", " ", "line"}], ";", "\n", " ", 
               RowBox[{"Print", "[", 
                RowBox[{"{", 
                 RowBox[{"o", ",", "line"}], "}"}], "]"}], ";"}], "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"line", "=", "code"}], ";", "\n", " ", 
              RowBox[{"(*", " ", 
               RowBox[{
               "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
                "codes"}], " ", "*)"}], "\n", " ", 
              RowBox[{"line", " ", "=", " ", 
               RowBox[{"FromCharacterCode", "@", "\n", " ", 
                RowBox[{"Cases", "[", " ", 
                 RowBox[{
                  RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
                  RowBox[{"n_Integer", " ", "/;", " ", 
                   RowBox[{
                   "32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}], " ",
                  "]"}]}]}], ";", "\n", " ", 
              RowBox[{"str", " ", "=", " ", 
               RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
              RowBox[{"inputbuffer", " ", "=", " ", 
               RowBox[{"ReadList", "[", 
                RowBox[{
                "str", ",", " ", "Word", ",", "\n", 
                 "                        ", 
                 RowBox[{"TokenWords", "->", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<(\>\"", ",", " ", "\"\<)\>\"", ",", " ", "\"\<[\>\"", 
                    ",", " ", "\"\<]\>\"", ",", " ", "\"\<'\>\"", ",", " ", 
                    "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], ";", "\n", " ", 
              RowBox[{"Close", "@", " ", "str"}]}]}], "\n", "]"}], ";", "\n", 
           
           RowBox[{"w", " ", "=", " ", 
            RowBox[{"First", "@", " ", "inputbuffer"}]}], ";", "\n", 
           RowBox[{"inputbuffer", " ", "=", " ", 
            RowBox[{"Rest", "@", " ", "inputbuffer"}]}], ";", "\n", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"DigitQ", "@", "w"}], ",", " ", 
             RowBox[{"ToExpression", "@", "w"}], ",", " ", "w"}], "]"}]}]}], 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "convert", " ", "string", " ", "of", " ", "digits", " ", "to", " ", 
           "integer"}], " ", "*)"}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"word", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "w", "}"}], ",", "\n", 
          RowBox[{"While", "[", " ", 
           RowBox[{"True", ",", "\n", " ", 
            RowBox[{
             RowBox[{"w", " ", "=", " ", 
              RowBox[{"word2", "[", "]"}]}], ";", "\n", " ", 
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"w", " ", "=!=", " ", "\"\<[\>\""}], ",", " ", 
               RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", 
             " ", 
             RowBox[{"While", "[", " ", 
              RowBox[{
               RowBox[{"word", "[", "]"}], " ", "=!=", " ", "\"\<]\>\""}], 
              " ", "]"}]}]}], "\n", "]"}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"get", "[", 
         RowBox[{
          RowBox[{"sexp_:", "False"}], ",", 
          RowBox[{"rparenokay_:", "False"}]}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"w", " ", "=", " ", 
             RowBox[{"word", "[", "]"}]}], ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", 
             RowBox[{"{", "}"}]}], ",", " ", "name", ",", " ", "def", ",", 
            " ", "body", ",", " ", "varlist"}], "}"}], ",", 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", " ", 
             RowBox[{
              RowBox[{"While", "[", " ", 
               RowBox[{
                RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                 RowBox[{"(", 
                  RowBox[{"d", " ", "=", " ", 
                   RowBox[{"get", "[", 
                    RowBox[{"sexp", ",", "True"}], "]"}]}], ")"}]}], ",", 
                "\n", " ", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
              "\n", " ", 
              RowBox[{"Return", "@", " ", "l"}]}]}], "\n", " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"sexp", ",", " ", 
             RowBox[{"Return", "@", " ", "w"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<\\\"\>\"", ",", " ", 
             RowBox[{"get", "[", "True", "]"}], ",", "\n", " ", 
             "\"\<cadr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}], ",", "\n", " ", 
             "\"\<caddr\>\"", ",", "\n", " ", 
             RowBox[{"{", 
              RowBox[{"\"\<car\>\"", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<cdr\>\"", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<cdr\>\"", ",", 
                   RowBox[{"get", "[", "]"}]}], "}"}]}], "}"}]}], "}"}], ",", 
             "\n", " ", "\"\<let\>\"", ",", "\n", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"name", ",", "def", ",", "body"}], "}"}], " ", "=", 
               " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}], ",", 
                 RowBox[{"get", "[", "]"}]}], "}"}]}], ";", "\n", " ", 
              RowBox[{"If", "[", "\n", " ", 
               RowBox[{
                RowBox[{"!", 
                 RowBox[{"MatchQ", "[", 
                  RowBox[{"name", ",", 
                   RowBox[{
                    RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], 
                  "]"}]}], ",", "\n", " ", 
                RowBox[{
                 RowBox[{"varlist", " ", "=", " ", 
                  RowBox[{"Rest", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"name", " ", "=", " ", 
                  RowBox[{"First", "@", " ", "name"}]}], ";", "\n", " ", 
                 RowBox[{"def", " ", "=", " ", 
                  RowBox[{"{", 
                   RowBox[{"\"\<'\>\"", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\<lambda\>\"", ",", "varlist", ",", "def"}], 
                    "}"}]}], "}"}]}]}]}], "\n", " ", "]"}], ";", "\n", " ", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"\"\<'\>\"", ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<lambda\>\"", ",", 
                    RowBox[{"{", "name", "}"}], ",", "body"}], "}"}]}], "}"}],
                 ",", "def"}], "}"}]}], ",", "\n", " ", 
             RowBox[{"\"\<read-bit\>\"", "|", "\"\<read-exp\>\""}], ",", "\n",
              "                   ", 
             RowBox[{"{", "w", "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<car\>\"", "|", "\"\<cdr\>\"", "|", "\"\<atom\>\"", "|", 
              "\"\<'\>\"", "|", "\"\<display\>\"", "|", "\"\<eval\>\"", "|", 
              "\"\<bits\>\"", "|", "\"\<debug\>\"", "|", "\n", " ", 
              "\"\<length\>\"", "|", "\"\<size\>\"", "|", 
              "\"\<base2-to-10\>\"", "|", "\"\<base10-to-2\>\""}], ",", "\n", 
             "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{
             "\"\<cons\>\"", "|", "\"\<=\>\"", "|", "\"\<lambda\>\"", "|", 
              "\"\<append\>\"", "|", "\"\<define\>\"", "|", "\"\<+\>\"", "|", 
              "\"\<-\>\"", "|", "\"\<*\>\"", "|", "\"\<^\>\"", "|", 
              "\"\<<\>\"", "|", "\"\<>\>\"", "|", "\"\<<=\>\"", "|", 
              "\"\<>=\>\"", "|", "\"\<and\>\"", "|", "\"\<or\>\""}], ",", 
             "\n", "                   ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", 
             RowBox[{"\"\<if\>\"", "|", "\"\<let\>\"", "|", "\"\<try\>\""}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{"w", ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}], ",", 
               RowBox[{"get", "[", "]"}]}], "}"}], ",", "\n", " ", "_", ",", 
             " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"getbit", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "x", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"trouble", " ", "=", " ", "False"}], ";", " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "tape"}], ",", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"trouble", " ", "=", " ", "True"}], ";", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], ")"}]}], 
            "]"}], ";", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "tape"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"x", " ", "===", " ", "0"}], ",", " ", "0", ",", " ", 
             "1"}], " ", "]"}]}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getchar", "[", "]"}], " ", ":=", " ", 
        RowBox[{"FromCharacterCode", "[", "\n", "  ", 
         RowBox[{
          RowBox[{"128", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"64", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"32", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"16", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", "\n", "  ", 
          RowBox[{"8", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"4", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"2", "*", 
           RowBox[{"getbit", "[", "]"}]}], " ", "+", " ", 
          RowBox[{"getbit", "[", "]"}]}], "\n", "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getrecord", "[", "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"c", ",", " ", 
            RowBox[{"line", " ", "=", " ", "\"\<\>\""}], ",", " ", "str"}], 
           " ", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"{", "}"}]}], ";", "\n", " ", 
           RowBox[{"While", "[", " ", 
            RowBox[{
             RowBox[{"\"\<\\n\>\"", " ", "=!=", " ", 
              RowBox[{"(", 
               RowBox[{"c", " ", "=", " ", 
                RowBox[{"getchar", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             RowBox[{"line", " ", "=", " ", 
              RowBox[{"line", " ", "<>", " ", "c"}]}]}], " ", "]"}], ";", 
           "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{"trouble", ",", " ", 
             RowBox[{"Throw", "@", " ", "\"\<out-of-data\>\""}]}], "]"}], ";",
            " ", 
           RowBox[{"(*", " ", 
            RowBox[{"Mma", " ", "bug", " ", "bypass"}], " ", "*)"}], "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "keep", " ", "only", " ", "printable", " ", "ASCII", " ", 
             "codes"}], " ", "*)"}], "\n", " ", 
           RowBox[{"line", " ", "=", " ", 
            RowBox[{"FromCharacterCode", "@", "\n", " ", 
             RowBox[{"Cases", "[", " ", 
              RowBox[{
               RowBox[{"ToCharacterCode", "@", " ", "line"}], ",", " ", 
               RowBox[{"n_Integer", " ", "/;", " ", 
                RowBox[{"32", " ", "<=", " ", "n", " ", "<", " ", "127"}]}]}],
               " ", "]"}]}]}], ";", "\n", " ", 
           RowBox[{"str", " ", "=", " ", 
            RowBox[{"StringToStream", "@", " ", "line"}]}], ";", "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{"ReadList", "[", 
             RowBox[{"str", ",", " ", "Word", ",", " ", 
              RowBox[{"TokenWords", "->", 
               RowBox[{"{", 
                RowBox[{"\"\<(\>\"", ",", " ", "\"\<)\>\""}], "}"}]}]}], 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"Close", "@", " ", "str"}], ";", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
            "convert", " ", "strings", " ", "of", " ", "digits", " ", "to", 
             " ", "integers"}], " ", "*)"}], "\n", " ", 
           RowBox[{"inputbuffer2", " ", "=", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"DigitQ", "@", "#"}], ",", " ", 
                RowBox[{"ToExpression", "@", "#"}], ",", " ", "#"}], "]"}], 
              "&"}], " ", "/@", " ", "inputbuffer2"}]}], " ", ";"}]}], "\n", 
         "]"}]}], ";", "\n", " ", "\n", 
       RowBox[{
        RowBox[{"getexp", "[", 
         RowBox[{"rparenokay_:", "False"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{"w", ",", " ", "d", ",", " ", 
            RowBox[{"l", " ", "=", " ", 
             RowBox[{"{", "}"}]}]}], " ", "}"}], ",", "\n", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{
             RowBox[{" ", 
              RowBox[{"supply", " ", "unlimited", " ", "number", " ", "of"}], 
              " ", ")"}], "'"}], "s", " ", "if", " ", "tokens", " ", "run", 
            " ", "out"}], " ", "*)"}], "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"inputbuffer2", " ", "==", " ", 
              RowBox[{"{", "}"}]}], ",", " ", 
             RowBox[{"w", " ", "=", " ", "\"\<)\>\""}], ",", "\n", " ", 
             RowBox[{
              RowBox[{"w", " ", "=", " ", 
               RowBox[{"First", "@", " ", "inputbuffer2"}]}], ";", "\n", " ", 
              
              RowBox[{"inputbuffer2", " ", "=", " ", 
               RowBox[{"Rest", "@", " ", "inputbuffer2"}]}]}]}], " ", "]"}], 
           ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"w", ",", "\n", " ", "\"\<)\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{"rparenokay", ",", "\"\<)\>\"", ",", 
                RowBox[{"{", "}"}]}], "]"}]}], ",", "\n", " ", "\"\<(\>\"", 
             ",", "\n", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"While", "[", " ", 
                RowBox[{
                 RowBox[{"\"\<)\>\"", " ", "=!=", " ", 
                  RowBox[{"(", 
                   RowBox[{"d", " ", "=", " ", 
                    RowBox[{"getexp", "[", "True", "]"}]}], ")"}]}], ",", 
                 "\n", " ", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"l", ",", "d"}], "]"}]}], "\n", " ", "]"}], ";", 
               "\n", " ", 
               RowBox[{"Return", "@", " ", "l"}]}], "\n", ")"}], ",", "\n", 
             " ", "_", ",", " ", "w"}], "\n", " ", "]"}]}]}], "\n", "]"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"atom", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"MatchQ", "[", " ", 
         RowBox[{"x", ",", " ", 
          RowBox[{
           RowBox[{"{", "}"}], "|", "_String", "|", "_Integer"}]}], " ", 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"car", "[", "x_", "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
          RowBox[{"First", "@", " ", "x"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"cdr", "[", "x_", "]"}], " ", ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "}"}], ",", "\n", 
          RowBox[{"If", "[", " ", 
           RowBox[{
            RowBox[{"atom", "@", " ", "x"}], ",", " ", "x", ",", " ", 
            RowBox[{"Rest", "@", " ", "x"}]}], " ", "]"}]}], "]"}]}], ";", 
       "\n", 
       RowBox[{
        RowBox[{"cons", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", "\n", " ", 
        RowBox[{"If", "[", " ", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{"y", ",", 
            RowBox[{"_String", "|", "_Integer"}]}], "]"}], ",", " ", "x", ",",
           " ", 
          RowBox[{"Prepend", "[", 
           RowBox[{"y", ",", "x"}], "]"}]}], " ", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{"without", " ", "lamda"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Module", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z", ",", "if", 
            ",", "else"}], "}"}], ",", "\[IndentingNewLine]", "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_String"}], "]"}], ",", "  ", 
             RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"atom", "@", " ", "e"}], ",", " ", 
               RowBox[{"Block", "[", " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", 
                 "\n", "   ", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
                   "a"}], ";", "\n", "   ", 
                  RowBox[{"pos", " ", "=", " ", 
                   RowBox[{"Position", "[", 
                    RowBox[{"names", ",", "e", ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", 
                  RowBox[{"debug", "@", 
                   RowBox[{"{", 
                    RowBox[{"\"\<->\>\"", ",", "a", ",", "e", ",", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    "}"}]}], ";", "  ", 
                  RowBox[{"Return", "@", " ", 
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                    RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                    " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";"}], 
            "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\[IndentingNewLine]", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
           "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "e"}]}], ",", "\n", " ", "\"\<if\>\"", 
             ",", 
             RowBox[{
              RowBox[{"if", "=", 
               RowBox[{"eval", "[", 
                RowBox[{
                 RowBox[{"e", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", 
              RowBox[{"else", "=", 
               RowBox[{"eval", "[", 
                RowBox[{
                 RowBox[{"e", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"boole", "=", 
               RowBox[{"eval", "[", 
                RowBox[{
                 RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"boole", "=", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"BooleanQ", "@", "boole"}], ",", "boole", ",", 
                 RowBox[{"boole", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Print", "[", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<If0\>\"", ",", "e", ",", "if", ",", "else", ",", 
                   RowBox[{"eval", "[", 
                    RowBox[{
                    RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                    "]"}]}], "}"}], "]"}], ";", " ", 
                RowBox[{"Return", "@", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"eval", "[", 
                    RowBox[{
                    RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                    "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "if", ",", "else"}], 
                  "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{
                "\"\<If0\>\"", ",", "e", ",", "if", ",", "else", ",", 
                 RowBox[{"eval", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                  "]"}]}], "}"}], "]"}], ";", " ", 
              RowBox[{"Return", "@", 
               RowBox[{"If", "[", 
                RowBox[{"boole", ",", "if", ",", "else"}], "]"}]}]}]}], "\n", 
            " ", 
            RowBox[{"(*", 
             RowBox[{"If", "[", "\n", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"eval", "[", 
                 RowBox[{
                  RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}],
                 " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
               RowBox[{"eval", "[", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                "]"}], ",", "\n", " ", 
               RowBox[{"eval", "[", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", 
                   RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                "]"}]}], "\n", " ", "]"}], "*)"}], "\[IndentingNewLine]", 
            "\n", 
            RowBox[{"(*", 
             RowBox[{"TODO", ":", " ", 
              RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
             "*)"}], "\[IndentingNewLine]", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", 
           RowBox[{"args", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"eval", "[", 
               RowBox[{
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}],
               ",", 
              RowBox[{"{", 
               RowBox[{"ii", ",", "1", ",", 
                RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\n", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"Switch", "[", "\n", 
            RowBox[{
            "f", ",", "\[IndentingNewLine]", "\n", " ", "\"\<read-bit\>\"", 
             ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"",
              ",", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cdr", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<+\>\"", ",", " ", 
             RowBox[{
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<+  \>\"", ",", "x", ",", "y"}], "}"}], "]"}], 
              ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "+", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ",", " ", "0", ",", " ", 
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "-", " ", 
                 RowBox[{"nmbif", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<*\>\"", ",", " ", 
             RowBox[{
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<*  \>\"", ",", "x", ",", "y"}], "}"}], "]"}], 
              ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "*", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmbif", "@", "x"}], " ", "^", " ", 
                RowBox[{"nmbif", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ",", " ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ",", "  ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ",", " ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmbif", "@", "y"}]}], ",", " ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\[IndentingNewLine]", "\"\<and\>\"",
              ",", 
             RowBox[{"Return", "@", 
              RowBox[{"(", 
               RowBox[{"And", "[", 
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], ",", 
                 RowBox[{"nmbif", "@", "y"}]}], "]"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "\"\<or\>\"", ",", 
             RowBox[{"Return", "@", 
              RowBox[{"(", 
               RowBox[{"Or", "[", 
                RowBox[{
                 RowBox[{"nmbif", "@", "x"}], ",", 
                 RowBox[{"nmbif", "@", "y"}]}], "]"}], ")"}]}], ",", "\n", 
             " ", "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", 
              "]"}], ";", "\n", " ", 
             RowBox[{"d", "--"}], ";", "\n", " ", 
             RowBox[{"Switch", "[", "\n", " ", 
              RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", 
               " ", "\"\<try\>\"", ",", " ", 
               RowBox[{"Return", "@", "\n", " ", 
                RowBox[{"Block", "[", " ", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"out", " ", "=", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", 
                    RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                    RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                    "xx"}], "}"}], ",", "\n", " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                    ",", " ", 
                    RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                    RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                    " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
                 "]"}]}]}], " ", 
              RowBox[{"(*", " ", 
               RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
             ";"}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "switch"}], " ", "*)"}], 
            "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"f", " ", "=", " ", 
              RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
             "\n", 
             RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
              RowBox[{
               RowBox[{"f", " ", "=", " ", 
                RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"eval", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
                 RowBox[{"bind", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                  "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
             "\[IndentingNewLine]", "\n", " ", 
             RowBox[{"eval", "[", " ", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
               RowBox[{"bind", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval2", "[", 
         RowBox[{"e2_", ",", "a_", ",", "d2_"}], "]"}], " ", ":=", "\n", " ", 
        "\n", 
        RowBox[{"Module", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"e", " ", "=", " ", "e2"}], ",", " ", 
            RowBox[{"d", " ", "=", " ", "d2"}], ",", " ", "f", ",", " ", 
            "args", ",", " ", "x", ",", " ", "y", ",", " ", "z", ",", 
            "values", ",", "pos", ",", "xxx", ",", "vars", ",", "func", ",", 
            "names0"}], "}"}], ",", "\[IndentingNewLine]", "\n", " ", 
          RowBox[{
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"MatchQ", "[", 
              RowBox[{"e", ",", "_Integer"}], "]"}], ",", " ", 
             RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", 
           "\[IndentingNewLine]", "   ", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", "a"}], 
           ";", 
           RowBox[{"pos", " ", "=", " ", 
            RowBox[{"Position", "[", 
             RowBox[{"names0", ",", "e", ",", 
              RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
           
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"MatchQ", "[", 
               RowBox[{"e", ",", "_String"}], "]"}], "&&", 
              RowBox[{"pos", "\[Equal]", 
               RowBox[{"{", "}"}]}]}], ",", "  ", 
             RowBox[{"Return", "@", " ", "e"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{"atom", "@", " ", "e"}], ",", " ", 
             RowBox[{"Block", "[", " ", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"(*", 
                 RowBox[{"names", ",", "values", ",", "pos"}], "*)"}], "}"}], 
               ",", "\n", "   ", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"names0", ",", "values"}], "}"}], " ", "=", " ", 
                 "a"}], ";", "\n", "   ", 
                RowBox[{"pos", " ", "=", " ", 
                 RowBox[{"Position", "[", 
                  RowBox[{"names0", ",", "e", ",", 
                   RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", "  ", 
                RowBox[{"Return", "@", " ", 
                 RowBox[{"If", "[", " ", 
                  RowBox[{
                   RowBox[{"pos", " ", "==", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", "e", ",", " ", 
                   RowBox[{"values", "[", 
                    RowBox[{"[", 
                    RowBox[{"pos", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], 
                  " ", "]"}]}]}]}], "\n", " ", "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", "\n", " ", 
           RowBox[{"f", " ", "=", 
            RowBox[{"eval2", "[", 
             RowBox[{
              RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], "]"}]}], 
           ";", "\[IndentingNewLine]", " ", 
           RowBox[{"e", " ", "=", " ", 
            RowBox[{"cdr", "@", " ", "e"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"debug", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<f    \>\"", ",", "f"}], "}"}]}], ";", "\n", " ", 
           RowBox[{"Switch", "[", "\n", " ", 
            RowBox[{"f", ",", "\n", " ", "\"\<'\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "e"}]}], ",", "\n", " ", "\"\<if\>\"", 
             ",", 
             RowBox[{"(*", " ", 
              RowBox[{"Return", "@", "\n", " ", 
               RowBox[{"If", "[", "\n", " ", 
                RowBox[{
                 RowBox[{
                  RowBox[{"eval2", "[", 
                   RowBox[{
                    RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                   "]"}], " ", "=!=", " ", "\"\<false\>\""}], ",", "\n", " ", 
                 
                 RowBox[{"eval2", "[", 
                  RowBox[{
                   RowBox[{"car", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}], ",", "a", ",", "d"}], 
                  "]"}], ",", "\n", " ", 
                 RowBox[{"eval2", "[", 
                  RowBox[{
                   RowBox[{"car", "@", 
                    RowBox[{"cdr", "@", 
                    RowBox[{"cdr", "@", " ", "e"}]}]}], ",", "a", ",", "d"}], 
                  "]"}]}], "\n", " ", "]"}]}], "*)"}], "\[IndentingNewLine]", 
             
             RowBox[{
              RowBox[{"if", "=", 
               RowBox[{"eval2", "[", 
                RowBox[{
                 RowBox[{"e", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", 
              RowBox[{"else", "=", 
               RowBox[{"eval2", "[", 
                RowBox[{
                 RowBox[{"e", "[", 
                  RowBox[{"[", "3", "]"}], "]"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"boole1", "=", 
               RowBox[{"eval2", "[", 
                RowBox[{
                 RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"boole", "=", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"boole1", "===", "\"\<True\>\""}], "||", 
                  RowBox[{"boole1", "===", "\"\<False\>\""}]}], ",", "boole1",
                  ",", 
                 RowBox[{"boole1", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"debug", "[", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<If0\>\"", ",", "e", ",", "if", ",", "else", ",", 
                   RowBox[{"eval2", "[", 
                    RowBox[{
                    RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                    "]"}]}], "}"}], "]"}], ";", " ", 
                RowBox[{"Return", "@", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"eval2", "[", 
                    RowBox[{
                    RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                    "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "if", ",", "else"}], 
                  "]"}]}]}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{
                "\"\<If0\>\"", ",", "e", ",", "if", ",", "else", ",", 
                 RowBox[{"eval2", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "e"}], ",", "a", ",", "d"}], 
                  "]"}]}], "}"}], "]"}], ";", " ", 
              RowBox[{"Return", "@", 
               RowBox[{"If", "[", 
                RowBox[{"boole", ",", "if", ",", "else"}], "]"}]}]}]}], "\n", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"TODO", ":", " ", 
              RowBox[{"lambda", " ", "should", " ", "be", " ", "here"}]}], 
             "*)"}], "\[IndentingNewLine]", " ", "]"}], ";", "\n", 
           "\[IndentingNewLine]", 
           RowBox[{"args", " ", "=", " ", 
            RowBox[{"Table", "[", 
             RowBox[{
              RowBox[{"eval2", "[", 
               RowBox[{
                RowBox[{"e", "[", 
                 RowBox[{"[", "ii", "]"}], "]"}], ",", "a", ",", "d"}], "]"}],
               ",", 
              RowBox[{"{", 
               RowBox[{"ii", ",", "1", ",", 
                RowBox[{"Length", "@", "e"}]}], "}"}]}], "]"}]}], ";", "\n", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"x", " ", "=", " ", 
            RowBox[{"car", "@", " ", "args"}]}], ";", "\n", " ", 
           RowBox[{"y", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", " ", "args"}]}]}], ";", "\n", " ", 
           RowBox[{"z", " ", "=", " ", 
            RowBox[{"car", "@", 
             RowBox[{"cdr", "@", 
              RowBox[{"cdr", "@", " ", "args"}]}]}]}], ";", "\n", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"Switch", "[", "\[IndentingNewLine]", "\n", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"TODOL", "}"}], ":", "func"}], "=", 
               RowBox[{
                RowBox[{"f", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ";", " ", 
              RowBox[{
              "was", " ", "altered", " ", "to", " ", "support", " ", "nested",
                " ", "if"}]}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Length", "@", "f"}], "\[GreaterEqual]", "3"}], ",", 
                
                RowBox[{
                 RowBox[{"vars", "=", 
                  RowBox[{
                   RowBox[{"f", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                 RowBox[{"func", "=", 
                  RowBox[{
                   RowBox[{"f", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ";", 
                 RowBox[{"f", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], ",", " ", "f"}], "]"}], 
              ","}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Length", "@", "f"}], "\[GreaterEqual]", "3"}], ",", 
               RowBox[{
                RowBox[{"vars", "=", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "@", 
                    RowBox[{"(", 
                    RowBox[{"f", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}], 
                    "\[GreaterEqual]", "1"}], ",", 
                   RowBox[{
                    RowBox[{"f", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{"{", "}"}]}], "]"}]}], ";", 
                RowBox[{"func", "=", 
                 RowBox[{"f", "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], ";", 
                RowBox[{"f", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], ",", " ", 
               RowBox[{"func", "=", "f"}]}], "]"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda0   \>\"", ",", 
                 RowBox[{"Length", "@", "f"}], ",", "f", ",", "e", ",", 
                 "\"\< vars \>\"", ",", "vars", ",", " ", "\"\<  func \>\"", 
                 ",", "func"}], "}"}], "]"}], ";", "\[IndentingNewLine]", 
              "\"\<lambda\>\""}], ",", 
             RowBox[{
              RowBox[{"return", "=", 
               RowBox[{"(", 
                RowBox[{"func", "/.", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"vars", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}], "\[Rule]", 
                    RowBox[{"e", "[", 
                    RowBox[{"[", "ii", "]"}], "]"}]}], ",", 
                   RowBox[{"{", 
                    RowBox[{"ii", ",", "1", ",", " ", 
                    RowBox[{"Length", "@", "vars"}]}], "}"}]}], "]"}]}], 
                ")"}]}], ";", 
              RowBox[{"debug", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<Return  \>\"", ",", "return"}], "}"}], "]"}], 
              ";", 
              RowBox[{"Return", "@", "return"}]}], ",", "\n", " ", 
             "\"\<read-bit\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"getbit", "[", "]"}]}], ",", "\n", " ", 
             "\"\<read-exp\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"getrecord", "[", "]"}], ";", " ", 
                RowBox[{"getexp", "[", "]"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<bits\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Flatten", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"Rest", "@", " ", 
                   RowBox[{"IntegerDigits", "[", 
                    RowBox[{
                    RowBox[{"256", " ", "+", " ", "#"}], ",", " ", "2"}], 
                    "]"}]}], " ", ")"}], "&"}], " ", "/@", "\n", 
                "                            ", 
                RowBox[{"ToCharacterCode", "[", " ", 
                 RowBox[{
                  RowBox[{"output", "@", "x"}], " ", "<>", " ", 
                  "\"\<\\n\>\""}], " ", "]"}]}], " ", "]"}]}], ",", "\n", 
             " ", "\"\<car\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"car", "@", " ", "x"}]}], ",", "\n", " ", "\"\<cdr\>\"",
              ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cdr", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<cons\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"cons", "[", 
               RowBox[{"x", ",", "y"}], "]"}]}], ",", "\n", " ", 
             "\"\<size\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"StringLength", "@", " ", 
               RowBox[{"output", "@", " ", "x"}]}]}], ",", "\n", " ", 
             "\"\<length\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Length", "@", " ", "x"}]}], ",", "\n", " ", 
             "\"\<+\>\"", ",", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<++  \>\"", ",", "x", ",", "y"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "+", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<-\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", " ", "0", ",", " ", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "-", " ", 
                 RowBox[{"nmb", "@", "y"}]}]}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<*\>\"", ",", " ", 
             RowBox[{
              RowBox[{"debug", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<**  \>\"", ",", "x", ",", "y"}], "}"}]}], ";", 
              RowBox[{"Return", "@", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "*", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ")"}]}]}], ",", "\n", " ", 
             "\"\<^\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], " ", "^", " ", 
                RowBox[{"nmb", "@", "y"}]}], ")"}]}], ",", "\n", " ", 
             "\"\<<\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", "  ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<>\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", "  ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<>=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", ">=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", "  ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\n", " ", "\"\<<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], " ", "<=", " ", 
                 RowBox[{"nmb", "@", "y"}]}], ",", "  ", "True", ",", " ", 
                "False"}], "]"}]}], ",", "\[IndentingNewLine]", "\"\<and\>\"",
              ",", 
             RowBox[{"Return", "@", 
              RowBox[{"(", 
               RowBox[{"And", "[", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], ",", 
                 RowBox[{"nmb", "@", "y"}]}], "]"}], ")"}]}], ",", 
             "\[IndentingNewLine]", "\"\<or\>\"", ",", 
             RowBox[{"Return", "@", 
              RowBox[{"(", 
               RowBox[{"Or", "[", 
                RowBox[{
                 RowBox[{"nmb", "@", "x"}], ",", 
                 RowBox[{"nmb", "@", "y"}]}], "]"}], ")"}]}], ",", "\n", " ", 
             "\"\<base10-to-2\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"IntegerDigits", "[", 
               RowBox[{
                RowBox[{"nmb", "@", "x"}], ",", " ", "2"}], "]"}]}], ",", 
             "\n", " ", "\"\<base2-to-10\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Fold", "[", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"2", " ", "#1"}], " ", "+", " ", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#2", "===", "0"}], ",", "0", ",", "1"}], "]"}]}],
                   ")"}], "&"}], ",", " ", "0", ",", " ", "x"}], " ", "]"}]}],
              ",", "\n", " ", "\"\<append\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"Join", "[", " ", 
               RowBox[{
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "x"}], ",", 
                  RowBox[{"{", "}"}], ",", "x"}], "]"}], ",", " ", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"atom", "@", "y"}], ",", 
                  RowBox[{"{", "}"}], ",", "y"}], "]"}]}], " ", "]"}]}], ",", 
             "\n", " ", "\"\<atom\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"atom", "@", " ", "x"}], ",", " ", "\"\<true\>\"", 
                ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<=\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"If", "[", " ", 
               RowBox[{
                RowBox[{"x", " ", "===", " ", "y"}], ",", " ", "\"\<true\>\"",
                 ",", " ", "\"\<false\>\""}], " ", "]"}]}], ",", "\n", " ", 
             "\"\<display\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"out", ",", "x"}], "]"}], ";", "\n", 
                "               ", 
                RowBox[{"If", "[", " ", 
                 RowBox[{"display", ",", " ", 
                  RowBox[{"print", "[", " ", 
                   RowBox[{"\"\<display\>\"", ",", " ", 
                    RowBox[{"output", "@", " ", "x"}]}], " ", "]"}]}], " ", 
                 "]"}], ";", "\n", "               ", "x"}], ")"}]}], ",", 
             "\n", " ", "\"\<debug\>\"", ",", " ", 
             RowBox[{"Return", "@", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"print", "[", " ", 
                 RowBox[{"\"\<debug\>\"", ",", " ", 
                  RowBox[{"output", "@", " ", "x"}]}], " ", "]"}], ";", "\n", 
                "               ", "x"}], ")"}]}]}], "\n", " ", "]"}], ";", 
           "\[IndentingNewLine]", "\n", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{"d", " ", "==", " ", "0"}], ",", " ", 
               RowBox[{"Throw", "@", " ", "\"\<out-of-time\>\""}]}], " ", 
              "]"}], ";", "\n", " ", 
             RowBox[{"d", "--"}], ";", "\n", " ", 
             RowBox[{"Switch", "[", "\n", " ", 
              RowBox[{"f", ",", "\n", " ", "\"\<eval\>\"", ",", " ", 
               RowBox[{"Return", "@", " ", 
                RowBox[{"eval", "[", 
                 RowBox[{"x", ",", "Null", ",", "d"}], "]"}]}], ",", "\n", 
               " ", "\"\<try\>\"", ",", " ", 
               RowBox[{"Return", "@", "\n", " ", 
                RowBox[{"Block", "[", " ", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"out", " ", "=", " ", 
                    RowBox[{"{", "}"}]}], ",", " ", 
                    RowBox[{"tape", " ", "=", " ", "z"}], ",", " ", 
                    RowBox[{"display", " ", "=", " ", "False"}], ",", " ", 
                    "xx"}], "}"}], ",", "\n", " ", 
                  RowBox[{
                   RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"x", " ", "===", " ", "\"\<no-time-limit\>\""}], 
                    ",", " ", 
                    RowBox[{"xx", " ", "=", " ", "Infinity"}], ",", " ", 
                    RowBox[{"xx", " ", "=", " ", 
                    RowBox[{"nmb", "@", " ", "x"}]}]}], " ", "]"}], ";", "\n",
                    " ", 
                   RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"xx", " ", "<", " ", "d"}], ",", "\n", " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "xx"}], "]"}], ",", 
                    "out"}], "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}], " ", ",", "\n",
                     " ", 
                    RowBox[{
                    RowBox[{"Catch", "@", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<success\>\"", ",", 
                    RowBox[{"eval", "[", 
                    RowBox[{"y", ",", "Null", ",", "d"}], "]"}], ",", "out"}],
                     "}"}]}], " ", "//", "\n", " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-time\>\""}], 
                    ",", " ", 
                    RowBox[{"Throw", "@", " ", "#"}], ",", " ", "#"}], " ", 
                    "]"}], " ", "&"}]}]}], "\n", " ", "]"}], " ", "//", "\n", 
                    " ", 
                    RowBox[{
                    RowBox[{"If", "[", " ", 
                    RowBox[{
                    RowBox[{"#", " ", "===", " ", "\"\<out-of-data\>\""}], 
                    ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"\"\<failure\>\"", ",", "#", ",", "out"}], "}"}], 
                    ",", " ", "#"}], " ", "]"}], " ", "&"}]}]}]}], " ", 
                 "]"}]}]}], " ", 
              RowBox[{"(*", " ", 
               RowBox[{"end", " ", "block"}], " ", "*)"}], "\n", " ", "]"}], 
             ";"}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{"end", " ", "switch"}], " ", "*)"}], 
            "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"f", " ", "=", " ", 
              RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
             "\n", 
             RowBox[{"(*", " ", "\[IndentingNewLine]", " ", 
              RowBox[{
               RowBox[{"f", " ", "=", " ", 
                RowBox[{"cdr", "@", " ", "f"}]}], ";", "\[IndentingNewLine]", 
               
               RowBox[{"eval", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", 
                  RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
                 RowBox[{"bind", "[", 
                  RowBox[{
                   RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                  "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
             "\[IndentingNewLine]", "\n", " ", 
             RowBox[{"eval", "[", " ", 
              RowBox[{
               RowBox[{"car", "@", 
                RowBox[{"cdr", "@", " ", "f"}]}], ",", " ", 
               RowBox[{"bind", "[", " ", 
                RowBox[{
                 RowBox[{"car", "@", " ", "f"}], ",", "args", ",", "a"}], 
                "]"}], ",", " ", "d"}], " ", "]"}]}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Join", "[", 
            RowBox[{
             RowBox[{"{", "f", "}"}], ",", "args"}], "]"}]}]}], "\n", "]"}]}],
        ";", "\[IndentingNewLine]", "\n", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"nmb", "[", "n_Integer", "]"}], " ", ":=", " ", "n"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nmbif", "[", "x_", "]"}], " ", ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"atom", "@", "x"}], "\[Equal]", "True"}], ",", "x", ",", 
          RowBox[{"car", "@", "x"}]}], "]"}]}], ";", "  ", 
       RowBox[{"(*", 
        RowBox[{"DARA", ":", " ", 
         RowBox[{"eval", " ", "returns", " ", 
          RowBox[{"{", 
           RowBox[{"a", "+", "b"}], "}"}]}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"nmb", "[", "x_", "]"}], " ", ":=", "x"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{
          RowBox[{"vars_", "?", "atom"}], ",", "args_", ",", "a_"}], "]"}], 
        " ", ":=", "a"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"bind", "[", 
         RowBox[{"vars_", ",", "args_", ",", "a_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"names", ",", "values", ",", "pos"}], "}"}], ",", "\n", 
          " ", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"names", ",", "values"}], "}"}], " ", "=", " ", 
            RowBox[{"bind", "[", " ", 
             RowBox[{
              RowBox[{"cdr", "@", " ", "vars"}], ",", " ", 
              RowBox[{"cdr", "@", " ", "args"}], ",", " ", "a"}], " ", 
             "]"}]}], ";", "\n", " ", 
           RowBox[{"pos", " ", "=", " ", 
            RowBox[{"Position", "[", 
             RowBox[{"names", ",", " ", 
              RowBox[{"car", "@", " ", "vars"}], ",", " ", 
              RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"names", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "vars"}]}], "]"}], ",", "\n", "  ", 
             RowBox[{"Prepend", "[", 
              RowBox[{
               RowBox[{"Delete", "[", 
                RowBox[{"values", ",", "pos"}], "]"}], ",", " ", 
               RowBox[{"car", "@", " ", "args"}]}], "]"}]}], "}"}]}]}], "\n", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", "e_", "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"out", " ", "=", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
          RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"print", "[", " ", 
             RowBox[{"\"\<expression\>\"", ",", " ", 
              RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{"Catch", "[", " ", 
           RowBox[{"eval", "[", " ", 
            RowBox[{"e", ",", " ", 
             RowBox[{"{", 
              RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], 
            " ", "]"}], " ", "]"}]}], "\n", ")"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\n", 
       RowBox[{
        RowBox[{"eval2", "[", "e_", "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", " ", 
         RowBox[{
          RowBox[{"out", " ", "=", " ", 
           RowBox[{"tape", " ", "=", " ", 
            RowBox[{"{", "}"}]}]}], ";", "\n", " ", 
          RowBox[{"display", " ", "=", " ", "True"}], ";", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"print", "[", " ", 
             RowBox[{"\"\<expression\>\"", ",", " ", 
              RowBox[{"output", "@", " ", "e"}]}], " ", "]"}], ";"}], "*)"}], 
          "\[IndentingNewLine]", "\n", " ", 
          RowBox[{"Catch", "[", " ", 
           RowBox[{"eval2", "[", " ", 
            RowBox[{"e", ",", " ", 
             RowBox[{"{", 
              RowBox[{"names", ",", "defs"}], "}"}], ",", " ", "Infinity"}], 
            " ", "]"}], " ", "]"}]}], "\n", ")"}]}], ";", "\n", " ", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"eval", "[", 
         RowBox[{"e_", ",", "Null", ",", "d_"}], "]"}], " ", ":=", " ", 
        RowBox[{"eval", "[", 
         RowBox[{"e", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\"\<nil\>\"", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"{", "}"}], "}"}]}], "}"}], ",", "d"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"let", "[", 
         RowBox[{"n_", ",", "d_"}], "]"}], " ", ":=", "\n", 
        RowBox[{"(", "\n", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"print", "[", " ", 
            RowBox[{"\"\<define\>\"", ",", " ", 
             RowBox[{"output", "@", " ", "n"}]}], " ", "]"}], ";", "\n", " ", 
           
           RowBox[{"print", "[", " ", 
            RowBox[{"\"\<value\>\"", ",", " ", 
             RowBox[{"output", "@", " ", "d"}]}], " ", "]"}], ";"}], "*)"}], 
         "\n", " ", 
         RowBox[{
          RowBox[{"PrependTo", "[", 
           RowBox[{"names", ",", "n"}], "]"}], ";", "\n", " ", 
          RowBox[{"PrependTo", "[", 
           RowBox[{"defs", ",", "d"}], "]"}], ";"}], "\n", ")"}]}], ";", 
       "\[IndentingNewLine]", " ", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"output2", "[", "x_String", "]"}], " ", ":=", " ", 
          RowBox[{"x", "<>", "\"\< \>\""}]}], ";", "\n", 
         RowBox[{
          RowBox[{"output2", "[", "x_Integer", "]"}], " ", ":=", " ", 
          RowBox[{
           RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";"}], 
        "*)"}], "\[IndentingNewLine]", "\n", 
       RowBox[{
        RowBox[{"output2", "[", "x_", "]"}], ":=", 
        RowBox[{
         RowBox[{"ToString", "[", "x", "]"}], "<>", "\"\< \>\""}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"output2", "[", 
         RowBox[{"{", "x___", "}"}], "]"}], " ", ":=", "\n", 
        RowBox[{"Block", "[", " ", 
         RowBox[{
          RowBox[{"{", "s", "}"}], ",", "\n", " ", 
          RowBox[{
           RowBox[{"s", " ", "=", " ", 
            RowBox[{"StringJoin", "[", 
             RowBox[{"\"\<(\>\"", ",", " ", 
              RowBox[{"output2", " ", "/@", " ", 
               RowBox[{"{", "x", "}"}]}]}], "]"}]}], ";", "\n", " ", 
           RowBox[{"If", "[", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"StringTake", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}], " ", "==", " ", "\"\< \>\""}], 
             ",", " ", 
             RowBox[{"s", " ", "=", " ", 
              RowBox[{"StringDrop", "[", 
               RowBox[{"s", ",", 
                RowBox[{"-", "1"}]}], "]"}]}]}], " ", "]"}], ";", "\n", " ", 
           RowBox[{"s", " ", "<>", " ", "\"\<) \>\""}]}]}], "\n", "]"}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"output", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"StringDrop", "[", " ", 
         RowBox[{
          RowBox[{"output2", "@", "x"}], " ", ",", 
          RowBox[{"-", "1"}]}], " ", "]"}]}], ";", "\n", 
       RowBox[{"blanks", " ", "=", " ", 
        RowBox[{"StringJoin", "@", " ", 
         RowBox[{"Table", "[", 
          RowBox[{"\"\< \>\"", ",", 
           RowBox[{"{", "12", "}"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"print2", "[", 
            RowBox[{"x", ",", 
             RowBox[{"StringTake", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", " ", 
           RowBox[{"print", "[", 
            RowBox[{"\"\<\>\"", ",", 
             RowBox[{"StringDrop", "[", 
              RowBox[{"y", ",", "50"}], "]"}]}], "]"}]}], ")"}], " ", "/;", 
         " ", 
         RowBox[{
          RowBox[{"StringLength", "[", "y", "]"}], " ", ">", " ", "50"}]}]}], 
       ";", "\n", 
       RowBox[{
        RowBox[{"print", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print2", "[", 
         RowBox[{"x", ",", "y"}], "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print2", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
        RowBox[{"print3", "[", 
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{
            RowBox[{"x", "<>", "blanks"}], ",", "12"}], "]"}], "<>", "y"}], 
         "]"}]}], ";", "\n", 
       RowBox[{
        RowBox[{"print3", "[", "x_", "]"}], " ", ":=", " ", 
        RowBox[{"(", 
         RowBox[{"Print", "[", "x", "]"}], 
         RowBox[{"(*", 
          RowBox[{";", " ", 
           RowBox[{"WriteString", "[", 
            RowBox[{"o", ",", "x", ",", "\"\<\\n\>\""}], "]"}]}], "*)"}], 
         ")"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"debug", "[", "x_", "]"}], ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"debugflag", "==", "True"}], ",", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"debuglist", ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", 
              RowBox[{"debugctr", "++"}]}], "}"}]}], "]"}], ",", "Nothing"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"debugflag", "=", "False"}], ";", "\[IndentingNewLine]", 
       RowBox[{"debuglist", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"debugctr", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"code1", "=", "expression1"}], ";", "\[IndentingNewLine]", 
          RowBox[{"code2", "=", "expression2"}], ";", "\[IndentingNewLine]", 
          RowBox[{"code3", "=", "expression3"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression1"}], ";", 
          RowBox[{"first", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", " ", 
          RowBox[{"names", " ", "=", " ", 
           RowBox[{"{", "\"\<nil\>\"", "}"}]}], ";", " ", 
          RowBox[{"defs", " ", "=", " ", 
           RowBox[{"{", 
            RowBox[{"{", "}"}], "}"}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Quiet", "@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"eval", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
              RowBox[{"get", "[", "]"}]}], ")"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<define\>\"", ",", "func_", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"\"\<lambda\>\"", ",", "vars___", ",", 
                  RowBox[{"{", "def__", "}"}]}], "}"}], "}"}]}], "}"}], " ", ":>",
              " ", 
             RowBox[{"let", "[", 
              RowBox[{"func", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda\>\"", ",", 
                 RowBox[{"{", "vars", "}"}], ",", "def"}], "}"}]}], "]"}]}], 
            "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression2"}], ";", 
          RowBox[{"first", "=", "True"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Quiet", "@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"eval", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
              RowBox[{"get", "[", "]"}]}], ")"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"\"\<define\>\"", ",", "func_", ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"\"\<lambda\>\"", ",", "vars___", ",", 
                  RowBox[{"{", "def__", "}"}]}], "}"}], "}"}]}], "}"}], " ", ":>",
              " ", 
             RowBox[{"let", "[", 
              RowBox[{"func", ",", 
               RowBox[{"{", 
                RowBox[{"\"\<lambda\>\"", ",", 
                 RowBox[{"{", "vars", "}"}], ",", "def"}], "}"}]}], "]"}]}], 
            "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"code", "=", "expression3"}], ";", "\[IndentingNewLine]", 
          RowBox[{"inputbuffer", "=", 
           RowBox[{"list", "=", 
            RowBox[{"{", "}"}]}]}], ";", 
          RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
          RowBox[{"res", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"eval2", "@", "#"}], ")"}], "&"}], ")"}], "@", " ", 
              RowBox[{"get", "[", "]"}]}], ")"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<True\>\"", "\[Rule]", "True"}], ",", 
              RowBox[{"\"\<False\>\"", "\[Rule]", "False"}]}], "}"}]}]}], ";",
           "\[IndentingNewLine]", 
          RowBox[{"StringReplace", "[", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"res", ",", "InputForm"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<{\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
              RowBox[{"\"\<}\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
              RowBox[{"\"\<,\>\"", "\[Rule]", "\"\<\>\""}], ",", 
              RowBox[{"\"\<\\\"\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
           "]"}]}], "\[IndentingNewLine]", "}"}]}]}]}], "\[IndentingNewLine]",
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.668701916815751*^9, 3.66870193624583*^9}, {
   3.668702133786916*^9, 3.668702134347089*^9}, 3.6687022853581867`*^9, {
   3.6687023887130537`*^9, 3.668702431753148*^9}, {3.668702614804088*^9, 
   3.668702625199012*^9}, {3.6687027298143806`*^9, 3.668702756813094*^9}, {
   3.668702877190712*^9, 3.668702935882134*^9}, {3.66870296651546*^9, 
   3.66870298115119*^9}, {3.6687030616129713`*^9, 3.668703076596231*^9}, {
   3.6687032983584623`*^9, 3.668703329036998*^9}, {3.668703359547501*^9, 
   3.668703364937311*^9}, {3.668703409385564*^9, 3.668703409598823*^9}, {
   3.668703451281674*^9, 3.6687034539581423`*^9}, {3.668703510951167*^9, 
   3.668703581870448*^9}, {3.6687039495461273`*^9, 3.668703986468754*^9}, {
   3.668704034787966*^9, 3.668704107158821*^9}, {3.66870434254609*^9, 
   3.668704391482483*^9}, {3.668704866202161*^9, 3.6687049166354513`*^9}, {
   3.6687049703789988`*^9, 3.668705016862217*^9}, {3.6687050581514177`*^9, 
   3.6687051409960737`*^9}, {3.6687051853865957`*^9, 3.66870519864028*^9}, {
   3.66870530439258*^9, 3.6687053058318567`*^9}, {3.668705396406801*^9, 
   3.6687054449499273`*^9}, {3.668705727226926*^9, 3.668705760863277*^9}, {
   3.6687209180348263`*^9, 3.668720939416154*^9}, 3.668722524214611*^9, {
   3.721457652040442*^9, 3.721457659126416*^9}, {3.7214577653528957`*^9, 
   3.721457851048711*^9}, {3.721457919819281*^9, 3.7214579203696547`*^9}, {
   3.721458310459865*^9, 3.7214583299327602`*^9}, {3.721458374957127*^9, 
   3.721458387725543*^9}, {3.721458441637535*^9, 3.721458517261661*^9}, {
   3.721458573941455*^9, 3.721458588881013*^9}, {3.721458621215254*^9, 
   3.7214586315983877`*^9}, {3.721458687018977*^9, 3.721458702386259*^9}, {
   3.721459211034535*^9, 3.7214592617629347`*^9}, {3.7214593029271*^9, 
   3.7214593145595713`*^9}, {3.721459425330224*^9, 3.721459425656097*^9}, {
   3.721463532835463*^9, 3.721463535309825*^9}, 3.721505197215242*^9, {
   3.721505468875614*^9, 3.7215054734755*^9}, {3.721508064655298*^9, 
   3.721508072182108*^9}, {3.7215081096316347`*^9, 3.721508112465963*^9}, {
   3.7215332454364023`*^9, 3.721533280851383*^9}, {3.7215334454449787`*^9, 
   3.721533455479636*^9}, {3.721533538115106*^9, 3.721533546765699*^9}, {
   3.7215353422374*^9, 3.721535357125392*^9}, 3.7215359945581007`*^9, {
   3.7215632700342817`*^9, 3.721563333620592*^9}, {3.721568349314021*^9, 
   3.721568355163103*^9}, {3.72206933003051*^9, 3.7220693303554068`*^9}, 
   3.722069380066366*^9, {3.722069540265856*^9, 3.72206956972978*^9}, {
   3.722069617986521*^9, 3.722069620432428*^9}, {3.722069675297456*^9, 
   3.722069677663872*^9}, 3.722070274881424*^9, {3.722070379491681*^9, 
   3.722070380210538*^9}, {3.722071740854188*^9, 3.722071744839407*^9}, {
   3.722073171158132*^9, 3.722073230321724*^9}, {3.722223999433947*^9, 
   3.72222401172821*^9}, {3.722224097099599*^9, 3.7222241818050137`*^9}, {
   3.7222242174282417`*^9, 3.7222242421507883`*^9}, {3.722224357099609*^9, 
   3.722224367907178*^9}, {3.722273073777082*^9, 3.722273078171007*^9}, {
   3.722279499406726*^9, 3.722279500076798*^9}, 3.722279540230859*^9, {
   3.722279631427246*^9, 3.7222796358817377`*^9}, {3.722279812399248*^9, 
   3.722279843303878*^9}, {3.751820322091267*^9, 3.7518203222590113`*^9}, {
   3.751821012914525*^9, 3.7518210206196833`*^9}, {3.751821058492402*^9, 
   3.7518210586458893`*^9}, {3.751821419068367*^9, 3.751821440061429*^9}, {
   3.7518217174505*^9, 3.7518217222880573`*^9}, {3.751822173629694*^9, 
   3.751822173922531*^9}, {3.75182229303353*^9, 3.751822295315558*^9}, {
   3.751822330481863*^9, 3.751822356280149*^9}, {3.751822431721713*^9, 
   3.751822440395549*^9}, {3.751822548467388*^9, 3.7518226179942913`*^9}, {
   3.751822661171864*^9, 3.7518226708916197`*^9}, {3.7518227648732967`*^9, 
   3.751822767683406*^9}, {3.751822866601136*^9, 3.751822868397818*^9}, {
   3.751822976029755*^9, 3.751822983376389*^9}, {3.7518230298404922`*^9, 
   3.751823117714023*^9}, {3.751823253204327*^9, 3.751823284712233*^9}, {
   3.751823319467917*^9, 3.751823373669113*^9}, {3.751823444378189*^9, 
   3.75182344479331*^9}, {3.751823525694193*^9, 3.751823571064827*^9}, {
   3.751823659311018*^9, 3.751823670927916*^9}, 3.751824563388836*^9, {
   3.75182803204926*^9, 3.7518280738368597`*^9}, {3.751828224835433*^9, 
   3.7518282721487226`*^9}, {3.751828668729807*^9, 3.751828673387258*^9}, {
   3.7518290552103243`*^9, 3.751829065140698*^9}, {3.751830252051813*^9, 
   3.751830252264748*^9}, {3.7518302995382233`*^9, 3.7518302997967377`*^9}, {
   3.751830446975251*^9, 3.751830484109632*^9}, {3.751830551433961*^9, 
   3.751830554590815*^9}, 3.7518306766017714`*^9, {3.751831015297789*^9, 
   3.751831043123822*^9}, {3.751831114784525*^9, 3.751831115569666*^9}, {
   3.751831271029273*^9, 3.751831319684896*^9}, {3.7518313578654737`*^9, 
   3.751831406166675*^9}, 3.751831469529767*^9, {3.7518315214018087`*^9, 
   3.751831579224304*^9}, {3.751831635026535*^9, 3.751831657301558*^9}, {
   3.751831876952594*^9, 3.7518318775119257`*^9}, {3.7518319504955482`*^9, 
   3.751831950897766*^9}, {3.751832301071844*^9, 3.751832303940249*^9}, {
   3.75183304804321*^9, 3.7518330797336617`*^9}, {3.7518331326993933`*^9, 
   3.751833134827265*^9}, {3.751833284385017*^9, 3.751833373727437*^9}, {
   3.7518334860839863`*^9, 3.751833496814762*^9}, {3.7518336186425323`*^9, 
   3.751833618853073*^9}, {3.7518336738537416`*^9, 3.751833730254081*^9}, {
   3.751833782125705*^9, 3.7518338285237217`*^9}, {3.751838865809366*^9, 
   3.751838891091262*^9}, {3.7518390869820766`*^9, 3.75183909550919*^9}, {
   3.751839268083005*^9, 3.751839275632605*^9}, {3.751839586049327*^9, 
   3.751839589770543*^9}, {3.751839629128256*^9, 3.751839640294457*^9}, {
   3.751840172181766*^9, 3.7518401849285192`*^9}, {3.751840441129159*^9, 
   3.751840442309235*^9}, {3.751840913021452*^9, 3.751840915583537*^9}, 
   3.7518410334318647`*^9, {3.751841411413197*^9, 3.7518414180373087`*^9}, {
   3.751841627443398*^9, 3.751841628495723*^9}, {3.7518417883276663`*^9, 
   3.75184180506732*^9}, {3.751841861186594*^9, 3.7518418613177834`*^9}, 
   3.751842012771044*^9, {3.751842215736719*^9, 3.7518422371541758`*^9}, {
   3.751842457536133*^9, 3.7518425440211573`*^9}, {3.7518426084512243`*^9, 
   3.7518426090754004`*^9}, {3.751843514542776*^9, 3.751843552544034*^9}, {
   3.751843720899075*^9, 3.751843737592311*^9}, {3.7518437849244947`*^9, 
   3.7518437922127533`*^9}, 3.751843843311956*^9, {3.751843882669092*^9, 
   3.7518439045957108`*^9}, {3.751844028864431*^9, 3.751844035818615*^9}, {
   3.751844075132609*^9, 3.751844097770589*^9}, {3.7518441889434032`*^9, 
   3.751844200608719*^9}, {3.751844351759882*^9, 3.751844393439754*^9}, {
   3.751844430294546*^9, 3.751844618065921*^9}, {3.751845219449332*^9, 
   3.751845248708047*^9}, {3.751845392909295*^9, 3.751845394121964*^9}, {
   3.751845558440363*^9, 3.751845577425012*^9}, {3.751845649837817*^9, 
   3.7518456590016413`*^9}, 3.75184642163269*^9, {3.7518470934370127`*^9, 
   3.751847106812231*^9}, {3.7518476099446707`*^9, 3.75184762932978*^9}, {
   3.751847811291218*^9, 3.751847825666862*^9}, {3.751847970330422*^9, 
   3.751847984620173*^9}, {3.7518480247527027`*^9, 3.7518480396946993`*^9}, {
   3.751848071171557*^9, 3.7518480724515247`*^9}, {3.751848128445347*^9, 
   3.7518481631061563`*^9}, {3.751848248843337*^9, 3.751848290393362*^9}, {
   3.7518484731545773`*^9, 3.751848483514934*^9}, 3.7518488828264227`*^9, {
   3.751848926317786*^9, 3.7518489337526197`*^9}, {3.751849307275694*^9, 
   3.751849311829297*^9}, {3.7518501089975967`*^9, 3.751850127704941*^9}, {
   3.751850390714424*^9, 3.751850394359066*^9}, {3.751850559683483*^9, 
   3.751850592485278*^9}, {3.751850773830947*^9, 3.751850823201661*^9}, {
   3.751850868965629*^9, 3.7518509077960577`*^9}, {3.7518509465993834`*^9, 
   3.7518509484688663`*^9}, {3.7518510780701027`*^9, 3.751851116332465*^9}, {
   3.7518511772976723`*^9, 3.751851192479084*^9}, {3.751853356324695*^9, 
   3.75185344161123*^9}, {3.751854883067889*^9, 3.751854888274268*^9}, {
   3.751855286333055*^9, 3.751855286500276*^9}, {3.751887280523472*^9, 
   3.7518873183395367`*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"35279de8-5a6c-4eae-b99b-469b4aee237a"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.7518534532981567`*^9},ExpressionUUID->"69fa0180-07c4-42df-b1b6-\
142ba01a81c7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<expression\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "\[Rule]", 
            "\"\<(cdr ((+ (func1 100 1 2) (func2 6)) (func2 -5)))\>\""}], 
           "|>"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<function1\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "->", 
            "\"\<(define func1 (lambda (z y x) (+ y (* x z))))\>\""}], 
           "|>"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<function2\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
           "\"\<Input\>\"", "\[Rule]", 
            "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\""}], 
           "|>"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Lisp Interpreter with functions \>\"", ",", "Orange", ",", 
             " ", "Bold", ",", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Run\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"lisp", "[", 
       RowBox[{"#function1", ",", "#function2", ",", "#expression"}], "]"}], 
      "&"}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.6687019387415037`*^9, {3.668702018945513*^9, 3.668702021362136*^9}, {
   3.6687020551480513`*^9, 3.668702107897636*^9}, {3.668702178807077*^9, 
   3.6687021958064547`*^9}, {3.668702239952825*^9, 3.6687023436087427`*^9}, {
   3.6687025518166237`*^9, 3.668702596420607*^9}, {3.668702652491873*^9, 
   3.6687026812797422`*^9}, {3.6687036692618027`*^9, 3.668703684450075*^9}, {
   3.7214581991277103`*^9, 3.721458199429619*^9}, {3.7214582473786182`*^9, 
   3.721458296733281*^9}, {3.721458338348125*^9, 3.721458357664834*^9}, 
   3.721458429093857*^9, {3.721458790532482*^9, 3.721458793028949*^9}, {
   3.72145885229639*^9, 3.7214588949001627`*^9}, {3.721459273923686*^9, 
   3.721459278513587*^9}, {3.721459437413912*^9, 3.721459471760054*^9}, {
   3.721459561797625*^9, 3.721459568389389*^9}, {3.721463500119329*^9, 
   3.721463506317503*^9}, 3.721463545830546*^9, 3.72146362007117*^9, {
   3.7214636580407143`*^9, 3.7214637336560707`*^9}, {3.721463766044441*^9, 
   3.7214637708248587`*^9}, 3.721508095043187*^9, 3.721533489347207*^9, 
   3.721534682279892*^9, {3.7215634053304157`*^9, 3.7215634132620077`*^9}, 
   3.7220696505233917`*^9, {3.722073279339679*^9, 3.722073314564149*^9}, 
   3.722073757361457*^9, {3.7222798793593893`*^9, 3.722279976010249*^9}, {
   3.72228002338774*^9, 3.722280037178404*^9}, {3.722280078480661*^9, 
   3.722280134156954*^9}},ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-\
88036260f931"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-\
efb0ac26d102\"",
     "https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-\
efb0ac26d102"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/4d0665ef-9f4d-4039-ac42-efb0ac26d102"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.668702440473839*^9, 3.668702599311335*^9, 3.668702630234618*^9, 
   3.66870276172163*^9, {3.668702884776046*^9, 3.6687029013214397`*^9}, 
   3.668702940803843*^9, 3.668703086106824*^9, 3.6687031423779497`*^9, 
   3.668703336512856*^9, 3.6687033694726467`*^9, 3.668703414525476*^9, 
   3.6687034594849052`*^9, {3.668703521112142*^9, 3.668703586411539*^9}, {
   3.668703678090148*^9, 3.668703687206891*^9}, 3.668703991240896*^9, 
   3.668704097623562*^9, 3.668704397243503*^9, 3.668705280205473*^9, 
   3.668705416430118*^9, 3.6687054505580053`*^9, 3.66870576754501*^9, 
   3.668720951596919*^9, 3.668722539478557*^9, 3.721458392959919*^9, 
   3.7214584315862827`*^9, {3.721458523281312*^9, 3.721458540233698*^9}, 
   3.721458636446863*^9, {3.7214586900420227`*^9, 3.7214587050497217`*^9}, 
   3.7214588022533007`*^9, 3.721458910416202*^9, 3.7214592803511543`*^9, 
   3.7214593180516233`*^9, {3.72145942949817*^9, 3.72145943871248*^9}, 
   3.721459473463122*^9, 3.721459572978836*^9, 3.72146350755993*^9, 
   3.7214635675093613`*^9, 3.721463631482452*^9, {3.721463671717452*^9, 
   3.721463692610738*^9}, 3.721463740218576*^9, 3.7214637714238977`*^9, 
   3.721505681368531*^9, {3.721508087606447*^9, 3.7215081154021397`*^9}, {
   3.72153349165814*^9, 3.72153349720348*^9}, 3.721533552074951*^9, 
   3.7215346840011873`*^9, 3.721563442261989*^9, 3.721568380596117*^9, {
   3.7220733118500633`*^9, 3.722073315854253*^9}, 3.722073759539748*^9, 
   3.722280041887496*^9, 3.722280101077608*^9, 
   3.722280137945015*^9},ExpressionUUID->"00592e20-f000-4912-bf99-\
fa8cf617b828"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<( (func1 1 2) (func2 6)) (func2 -5)\>\""}], 
  " ", "]"}]], "Input",
 CellChangeTimes->{{3.75188994691158*^9, 3.7518899584658613`*^9}},
 CellLabel->"In[29]:=",ExpressionUUID->"f260dca0-59b7-4676-9bcf-4b1a6727fb86"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(1 + 2*z 6*x*y)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751889949776998*^9, 3.7518899588432417`*^9}},
 CellLabel->"Out[29]=",ExpressionUUID->"382dec7b-d60d-4ab2-abf2-948159d52084"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"lisp", "[", "\[IndentingNewLine]", 
   RowBox[{
   "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
    "\[IndentingNewLine]", 
    "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
    "\[IndentingNewLine]", 
    "\"\<car ((+ (func1 1 2) (func2 6)) (func2 -5))\>\""}], " ", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.721533386443975*^9, 3.721533386854467*^9}, {
  3.72206968635201*^9, 3.722069694342019*^9}, {3.7220737370731907`*^9, 
  3.7220737482457037`*^9}, {3.722279559127697*^9, 3.7222795963674593`*^9}, {
  3.72228067573464*^9, 3.722280700978385*^9}, {3.7222807344450493`*^9, 
  3.72228073471378*^9}, {3.751820394587171*^9, 3.7518204280104113`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"44d4a5b7-13a0-4e04-961c-3f3e04b5a33f"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(1 + 6*x*y + 2*z)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.72206969770576*^9, 3.72207027948031*^9, 3.722070430809999*^9, 
   3.7220717726660557`*^9, {3.7220737432742357`*^9, 3.722073748556281*^9}, 
   3.722279641496366*^9, 3.7222797314949083`*^9, 3.722279848156872*^9, 
   3.722280703738687*^9, 3.722280736541141*^9, 3.751819872144412*^9, {
   3.751820337936561*^9, 3.751820344808305*^9}, 3.75182039941365*^9, 
   3.751840534629674*^9, 3.751851197434684*^9, 3.75185322753414*^9},
 CellLabel->"Out[9]=",ExpressionUUID->"76064ab6-1293-431b-80b1-2c50eb3e188c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(car (d e fgh))\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.7220704704029207`*^9, 3.722070482687192*^9}, 
   3.72207356478878*^9, {3.751851229262944*^9, 3.75185123001607*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"af57530a-4531-4c40-a3e5-f1ffa1de80f8"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(d)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7222731590565157`*^9, 3.751840541187821*^9, {3.751851200568606*^9, 
   3.751851230532267*^9}, 3.7518532690986*^9},
 CellLabel->"Out[12]=",ExpressionUUID->"816f1bb9-1fe1-44b8-8554-d82f3d6aa154"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["list"], "Input",
 CellChangeTimes->{{3.722073120391779*^9, 
  3.722073120922089*^9}},ExpressionUUID->"6d47f478-1871-4b72-8f35-\
237a61b1d232"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{
  3.722073121908452*^9},ExpressionUUID->"59c6add4-8617-432e-b59a-\
1d3b721a8e05"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ctr"], "Input",
 CellChangeTimes->{{3.722073155241357*^9, 
  3.722073155742424*^9}},ExpressionUUID->"07f7c144-824f-4709-a04d-\
f83ec33b8614"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.722073156647114*^9},ExpressionUUID->"cbad6367-f3af-4ac2-a5de-\
a3c002001c21"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", 
   "\"\<car ((+ (func1 1 2) (func2 6)) (func2 -5))\>\""}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.751820466328636*^9, 3.751820466541645*^9}, 
   3.75185124629611*^9},
 CellLabel->"In[13]:=",ExpressionUUID->"3447bd4d-1a8e-45ca-ac2f-8940b2c0c5e9"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(1 + 6*x*y + 2*z)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.751820466771844*^9, 3.751840523182672*^9, {3.751851241185203*^9, 
   3.751851246546001*^9}, 3.751853271484177*^9},
 CellLabel->"Out[13]=",ExpressionUUID->"e69a2b9e-5395-4994-97bd-01762d44898c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"lisp", "[", "\[IndentingNewLine]", 
   RowBox[{
   "\"\<(define pass? (lambda (x) (if (> x 40) pass fail)))\>\"", ",", 
    "\[IndentingNewLine]", 
    "\"\<(define func2 (lambda (z ) (* y (* x z)))) \>\"", " ", ",", 
    "\[IndentingNewLine]", "\"\<(pass? 300)\>\""}], " ", "]"}]}]], "Input",
 CellChangeTimes->{{3.751820531461115*^9, 3.75182064437354*^9}, {
  3.7518206892521067`*^9, 3.75182070621579*^9}, {3.751851251595437*^9, 
  3.751851255229313*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"e9f4e81d-2eb1-40e8-a424-2d50b7427151"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"pass\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751820588640799*^9, 3.7518206480733147`*^9}, 
   3.751820706798348*^9, 3.7518210262707043`*^9, 3.7518210668775473`*^9, 
   3.7518405163125257`*^9, {3.75185125195245*^9, 3.7518512555907173`*^9}, 
   3.7518532743175783`*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"c374f3fc-221a-4051-b1bc-d8f42c2390ca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) pass fail)))\>\"", ",", 
   "\[IndentingNewLine]", "\"\<()\>\"", " ", ",", "\[IndentingNewLine]", 
   "\"\<(pass? 300)\>\""}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.75185329502409*^9, 3.751853295090837*^9}},
 CellLabel->"In[15]:=",ExpressionUUID->"5a9dc7c3-d36e-4028-b4c5-251ba70c0786"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"pass\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.75185329586594*^9},
 CellLabel->"Out[15]=",ExpressionUUID->"556434a7-4752-4f72-930b-29714211b930"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define pass2? (lambda (x) (if (> x 40) True False)))\>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(and (pass? 300) (pass2? 30))\>\""}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.75185347974503*^9, 3.751853528465172*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"e355b9e5-861c-475d-a20b-9535e1c8abbd"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(False)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751853506890668*^9, 3.7518535289635572`*^9}},
 CellLabel->"Out[45]=",ExpressionUUID->"5be214aa-37f7-4265-a522-d4b47a810c07"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define pass2? (lambda (x) (if (> x 40) True False)))\>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(or (pass? 300) (pass2? 30))\>\""}], " ", 
  "]"}]], "Input",
 CellLabel->"In[11]:=",ExpressionUUID->"21f8109d-36e7-471d-b8cd-7e4f762660d7"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(True)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.751887399791778*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"98b1965b-aca8-4d4b-ae0b-45b3e4ce132d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define pass2? (lambda (x) (if (> x 40) True False)))\>\"", " ", ",", 
   "\[IndentingNewLine]", 
   "\"\<(if (and (pass? 300) (pass2? 60)) (+ x y )  (* u v))\>\""}], " ", 
  "]"}]], "Input",
 CellLabel->"In[27]:=",ExpressionUUID->"0d86e52a-71f4-48d2-8d28-b02fdc2161a9"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"((x + y))\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.751887976370771*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"a024020e-cd93-48c3-aa37-c76ac401be81"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define pass2? (lambda (x) (if (> x 40) True False)))\>\"", " ", ",", 
   "\[IndentingNewLine]", 
   "\"\<(if (and (pass? 300) (pass2? 30)) 1_ 3_ )\>\""}], " ", "]"}]], "Input",\

 CellChangeTimes->{{3.751820626885578*^9, 3.75182062951173*^9}, {
  3.751853555662416*^9, 3.751853617589139*^9}, {3.751855303770515*^9, 
  3.751855333008061*^9}, {3.751855364173808*^9, 
  3.7518553758827143`*^9}},ExpressionUUID->"620f10a1-1c05-4baa-a731-\
7cfeba6cb8b1"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(3_)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751853599034843*^9, 3.751853619504408*^9}, 
   3.7518536574835777`*^9, {3.7518553081809607`*^9, 3.7518553333421783`*^9}, 
   3.751855366236245*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"ebc1bf02-8559-4999-bb21-2f0a8c013c93"]
}, Open  ]],

Cell[BoxData["\[Divide]"], "Input",
 CellChangeTimes->{
  3.751855305856814*^9},ExpressionUUID->"51764908-41e1-41be-a94c-\
5b8ce7647a73"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass? (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define pass2? (lambda (x) (if (> x 40) True False)))\>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<( 1_1 )\>\""}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.751853914482594*^9, 3.751853917271681*^9}, {
  3.7518552349321337`*^9, 3.75185526185042*^9}},
 CellLabel->"In[32]:=",ExpressionUUID->"177e085d-b908-4e66-89ea-672ed7a21fd4"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(1_1)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751853920100593*^9, 3.751853930836073*^9}, {
  3.7518552526172*^9, 3.751855298010145*^9}},
 CellLabel->"Out[32]=",ExpressionUUID->"8390f829-c88f-4ed1-bb53-ea96ac492f79"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", 
   RowBox[{"StringToStream", "[", "\"\<( \\\"1\\\" )\>\"", " ", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ReadList", "[", 
  RowBox[{"str", ",", "Word", ",", 
   RowBox[{"TokenWords", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<(\>\"", ",", "\"\<)\>\"", ",", "\"\<[\>\"", ",", "\"\<]\>\"", ",", 
      "\"\<'\>\"", ",", "\"\<\\\"\>\""}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.7518539831013002`*^9, {3.751854014058505*^9, 3.751854026410758*^9}},
 CellLabel->"In[55]:=",ExpressionUUID->"6c969cb5-3660-449a-9dda-811478898319"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"(\"\>", ",", "\<\"\\\"\"\>", ",", "\<\"1\"\>", 
   ",", "\<\"\\\"\"\>", ",", "\<\")\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.751853983712237*^9, 3.751854026968851*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"60cb1802-f227-4931-a04c-8183cd77bbbf"]
}, Open  ]],

Cell[BoxData[" "], "Input",
 CellChangeTimes->{
  3.7518539187858963`*^9},ExpressionUUID->"219c0264-7f6f-420e-a89f-\
58d65b44e207"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define passfail (lambda (x) (if (> (+ x 1) (* 40 (+ 1 6))) 100 200)))\
\>\"", ",", "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z y) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<((passfail 400) (func2 1 2))\>\""}], " ", 
  "]"}]], "Input",
 CellLabel->"In[16]:=",ExpressionUUID->"59e41929-5d9d-4d09-8502-c89835b781b9"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(100 2*x)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.751840561476124*^9, 3.751851258669731*^9, 
  3.751853321915324*^9},
 CellLabel->"Out[16]=",ExpressionUUID->"e3d7c13f-b63f-40eb-989d-424310715ee5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define passfail (lambda (x) (if (> (+ x 1) (* 40 (+ 1 6))) 100 200)))\
\>\"", ",", "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z y) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", 
   "\"\<(if (> (passfail 400) 10) (func2 1 2) fail )\>\""}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{3.751840578173538*^9, 3.75184068735863*^9},
 CellLabel->"In[17]:=",ExpressionUUID->"2a62f8a2-971c-4ac7-958f-af8668d0b877"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(2*x)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.751840572329236*^9, 3.75184057859297*^9}, {
   3.7518406823768673`*^9, 3.751840687757347*^9}, 3.75185126659524*^9, 
   3.751853325672667*^9},
 CellLabel->"Out[17]=",ExpressionUUID->"06bc22a0-a1f6-47f2-b735-5bda5877a431"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define func1 (lambda (y x) (* y (* x z))))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (t)   (* y (* t x)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(func1 u v)\>\""}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "debuglist"}]}], "Input",
 CellLabel->"In[18]:=",ExpressionUUID->"977a606b-1857-403f-a3d0-c98dd33801f2"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"u*v*z\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.751851298577367*^9, 3.7518533271150217`*^9},
 CellLabel->"Out[18]=",ExpressionUUID->"937459e5-3700-4ecb-8180-704318b9b336"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}]]], "Output",
 CellChangeTimes->{3.751851298577367*^9, 3.7518533271265173`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"db445dae-5632-40c6-9290-da304c06d07e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define func1 (lambda (y x) (+ y (* x z))))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (t)   (* y (* t x)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(func1 u v)\>\""}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "debuglist"}]}], "Input",
 CellLabel->"In[20]:=",ExpressionUUID->"78b66430-beff-4a23-8457-42f19b98519b"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"u + v*z\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.7518513138275757`*^9, 3.751853329499508*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"b10fac53-dd57-4f9f-8c1d-7e5b3d4cf72f"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}]]], "Output",
 CellChangeTimes->{3.7518513138275757`*^9, 3.751853329510984*^9},
 CellLabel->"Out[21]=",ExpressionUUID->"1ff67783-289f-4b6f-8e22-81098897bee0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define pass (lambda (x) (if (> x 40) True False)))\>\"", ",", 
   "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z y) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<(if (pass 400)  55 fail )\>\""}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "debuglist"}]}], "Input",
 CellChangeTimes->{{3.751851358437108*^9, 3.751851366840498*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"ed49ed45-4a81-45a4-a453-fa5a113b6f60"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(55)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.7518513589536743`*^9, 3.751851367188847*^9}, 
   3.7518533312534103`*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"38e70eb2-9554-4f9b-86fa-8258e66ac7a5"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}]]], "Output",
 CellChangeTimes->{{3.7518513589536743`*^9, 3.751851367188847*^9}, 
   3.75185333126519*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"64d1bac7-2ec1-4874-a5b2-e19e89a61e30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define passfail (lambda (x) (if (> (+ x 1) (* 40 (+ 1 6))) 100 200)))\
\>\"", ",", "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z y) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", 
   "\"\<(if (> (passfail 400) 10) (func2 1 2) fail )\>\""}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "debuglist"}]}], "Input",
 CellChangeTimes->{3.751851383841055*^9},
 CellLabel->"In[24]:=",ExpressionUUID->"bf7aab50-440c-4050-b3fa-cd74e06ebe2a"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(2*x)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.751851384697748*^9, 3.751853332317135*^9},
 CellLabel->"Out[24]=",ExpressionUUID->"fdb919a5-e54a-4ae2-afb2-38ffaa184542"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}]]], "Output",
 CellChangeTimes->{3.751851384697748*^9, 3.751853332328849*^9},
 CellLabel->"Out[25]=",ExpressionUUID->"02cd360d-6e95-4551-8507-5a1b795f63d4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"lisp", "[", "\[IndentingNewLine]", 
  RowBox[{
  "\"\<(define passfail (lambda (x) (if (> (+ x 1) (* 40 (+ 1 6))) 100 200)))\
\>\"", ",", "\[IndentingNewLine]", 
   "\"\<(define func2 (lambda (z y) (* y (* x z)))) \>\"", " ", ",", 
   "\[IndentingNewLine]", "\"\<((passfail 400) (func2 1 2))\>\""}], " ", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "debuglist"}]}], "Input",
 CellChangeTimes->{{3.7518514070606737`*^9, 3.751851407251391*^9}},
 CellLabel->"In[26]:=",ExpressionUUID->"eff99c45-3dc8-49ae-b2f2-f13ef4d0523b"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(100 2*x)\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{3.75185140752707*^9, 3.751853334017964*^9},
 CellLabel->"Out[26]=",ExpressionUUID->"a4db7a45-3116-4997-9fbf-f226870287b9"],

Cell[BoxData[
 InterpretationBox[
  TagBox[GridBox[{
     {""}
    },
    DefaultBaseStyle->"Column",
    GridBoxAlignment->{"Columns" -> {{Left}}},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Column"],
  Column[{}]]], "Output",
 CellChangeTimes->{3.75185140752707*^9, 3.751853334026354*^9},
 CellLabel->"Out[27]=",ExpressionUUID->"7c43dbd2-33f5-41e8-b886-e0a6a9507177"]
}, Open  ]]
},
WindowSize->{1259, 1088},
WindowMargins->{{Automatic, 543}, {Automatic, 21}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"2cd90f68-3a5a-43ee-8eb6-9f919490b66d"],
Cell[1747, 54, 195, 6, 120, "Text",ExpressionUUID->"97bbd8a9-8cb7-44a9-9ef5-4561fd2fa577"],
Cell[1945, 62, 92726, 2010, 9649, "Input",ExpressionUUID->"35279de8-5a6c-4eae-b99b-469b4aee237a"],
Cell[94674, 2074, 149, 3, 52, "Input",ExpressionUUID->"69fa0180-07c4-42df-b1b6-142ba01a81c7"],
Cell[CellGroupData[{
Cell[94848, 2081, 3234, 65, 220, "Input",ExpressionUUID->"8f738a38-e3d9-44c2-ad7e-88036260f931"],
Cell[98085, 2148, 2011, 35, 37, "Output",ExpressionUUID->"00592e20-f000-4912-bf99-fa8cf617b828"]
}, Open  ]],
Cell[CellGroupData[{
Cell[100133, 2188, 475, 9, 94, "Input",ExpressionUUID->"f260dca0-59b7-4676-9bcf-4b1a6727fb86"],
Cell[100611, 2199, 393, 9, 35, "Output",ExpressionUUID->"382dec7b-d60d-4ab2-abf2-948159d52084"]
}, Open  ]],
Cell[CellGroupData[{
Cell[101041, 2213, 822, 15, 115, "Input",ExpressionUUID->"44d4a5b7-13a0-4e04-961c-3f3e04b5a33f"],
Cell[101866, 2230, 771, 15, 35, "Output",ExpressionUUID->"76064ab6-1293-431b-80b1-2c50eb3e188c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[102674, 2250, 518, 9, 94, "Input",ExpressionUUID->"af57530a-4531-4c40-a3e5-f1ffa1de80f8"],
Cell[103195, 2261, 452, 11, 35, "Output",ExpressionUUID->"816f1bb9-1fe1-44b8-8554-d82f3d6aa154"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103684, 2277, 156, 3, 30, "Input",ExpressionUUID->"6d47f478-1871-4b72-8f35-237a61b1d232"],
Cell[103843, 2282, 147, 4, 34, "Output",ExpressionUUID->"59c6add4-8617-432e-b59a-1d3b721a8e05"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104027, 2291, 155, 3, 30, "Input",ExpressionUUID->"07f7c144-824f-4709-a04d-f83ec33b8614"],
Cell[104185, 2296, 130, 3, 34, "Output",ExpressionUUID->"cbad6367-f3af-4ac2-a5de-a3c002001c21"]
}, Open  ]],
Cell[CellGroupData[{
Cell[104352, 2304, 510, 11, 94, "Input",ExpressionUUID->"3447bd4d-1a8e-45ca-ac2f-8940b2c0c5e9"],
Cell[104865, 2317, 466, 11, 35, "Output",ExpressionUUID->"e69a2b9e-5395-4994-97bd-01762d44898c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105368, 2333, 617, 11, 136, "Input",ExpressionUUID->"e9f4e81d-2eb1-40e8-a424-2d50b7427151"],
Cell[105988, 2346, 559, 12, 35, "Output",ExpressionUUID->"c374f3fc-221a-4051-b1bc-d8f42c2390ca"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106584, 2363, 409, 7, 94, "Input",ExpressionUUID->"5a9dc7c3-d36e-4028-b4c5-251ba70c0786"],
Cell[106996, 2372, 355, 9, 35, "Output",ExpressionUUID->"556434a7-4752-4f72-930b-29714211b930"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107388, 2386, 486, 9, 94, "Input",ExpressionUUID->"e355b9e5-861c-475d-a20b-9535e1c8abbd"],
Cell[107877, 2397, 385, 9, 35, "Output",ExpressionUUID->"5be214aa-37f7-4265-a522-d4b47a810c07"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108299, 2411, 420, 8, 94, "Input",ExpressionUUID->"21f8109d-36e7-471d-b8cd-7e4f762660d7"],
Cell[108722, 2421, 358, 9, 35, "Output",ExpressionUUID->"98b1965b-aca8-4d4b-ae0b-45b3e4ce132d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109117, 2435, 448, 9, 94, "Input",ExpressionUUID->"0d86e52a-71f4-48d2-8d28-b02fdc2161a9"],
Cell[109568, 2446, 361, 9, 35, "Output",ExpressionUUID->"a024020e-cd93-48c3-aa37-c76ac401be81"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109966, 2460, 628, 13, 94, "Input",ExpressionUUID->"620f10a1-1c05-4baa-a731-7cfeba6cb8b1"],
Cell[110597, 2475, 484, 11, 35, "Output",ExpressionUUID->"ebc1bf02-8559-4999-bb21-2f0a8c013c93"]
}, Open  ]],
Cell[111096, 2489, 137, 3, 30, "Input",ExpressionUUID->"51764908-41e1-41be-a94c-5b8ce7647a73"],
Cell[CellGroupData[{
Cell[111258, 2496, 512, 9, 94, "Input",ExpressionUUID->"177e085d-b908-4e66-89ea-672ed7a21fd4"],
Cell[111773, 2507, 428, 10, 35, "Output",ExpressionUUID->"8390f829-c88f-4ed1-bb53-ea96ac492f79"]
}, Open  ]],
Cell[CellGroupData[{
Cell[112238, 2522, 607, 14, 52, "Input",ExpressionUUID->"6c969cb5-3660-449a-9dda-811478898319"],
Cell[112848, 2538, 296, 5, 34, "Output",ExpressionUUID->"60cb1802-f227-4931-a04c-8183cd77bbbf"]
}, Open  ]],
Cell[113159, 2546, 131, 3, 30, "Input",ExpressionUUID->"219c0264-7f6f-420e-a89f-58d65b44e207"],
Cell[CellGroupData[{
Cell[113315, 2553, 427, 8, 94, "Input",ExpressionUUID->"59e41929-5d9d-4d09-8502-c89835b781b9"],
Cell[113745, 2563, 408, 10, 35, "Output",ExpressionUUID->"e3d7c13f-b63f-40eb-989d-424310715ee5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114190, 2578, 510, 10, 94, "Input",ExpressionUUID->"2a62f8a2-971c-4ac7-958f-af8668d0b877"],
Cell[114703, 2590, 479, 11, 35, "Output",ExpressionUUID->"06bc22a0-a1f6-47f2-b735-5bda5877a431"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115219, 2606, 450, 9, 115, "Input",ExpressionUUID->"977a606b-1857-403f-a3d0-c98dd33801f2"],
Cell[115672, 2617, 381, 9, 34, "Output",ExpressionUUID->"937459e5-3700-4ecb-8180-704318b9b336"],
Cell[116056, 2628, 410, 11, 34, "Output",ExpressionUUID->"db445dae-5632-40c6-9290-da304c06d07e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[116503, 2644, 450, 9, 115, "Input",ExpressionUUID->"78b66430-beff-4a23-8457-42f19b98519b"],
Cell[116956, 2655, 383, 9, 34, "Output",ExpressionUUID->"b10fac53-dd57-4f9f-8c1d-7e5b3d4cf72f"],
Cell[117342, 2666, 410, 11, 34, "Output",ExpressionUUID->"1ff67783-289f-4b6f-8e22-81098897bee0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117789, 2682, 538, 10, 115, "Input",ExpressionUUID->"ed49ed45-4a81-45a4-a453-fa5a113b6f60"],
Cell[118330, 2694, 410, 10, 35, "Output",ExpressionUUID->"38e70eb2-9554-4f9b-86fa-8258e66ac7a5"],
Cell[118743, 2706, 437, 12, 34, "Output",ExpressionUUID->"64d1bac7-2ec1-4874-a5b2-e19e89a61e30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[119217, 2723, 554, 11, 115, "Input",ExpressionUUID->"bf7aab50-440c-4050-b3fa-cd74e06ebe2a"],
Cell[119774, 2736, 379, 9, 35, "Output",ExpressionUUID->"fdb919a5-e54a-4ae2-afb2-38ffaa184542"],
Cell[120156, 2747, 408, 11, 34, "Output",ExpressionUUID->"02cd360d-6e95-4551-8507-5a1b795f63d4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[120601, 2763, 560, 10, 115, "Input",ExpressionUUID->"eff99c45-3dc8-49ae-b2f2-f13ef4d0523b"],
Cell[121164, 2775, 382, 9, 35, "Output",ExpressionUUID->"a4db7a45-3116-4997-9fbf-f226870287b9"],
Cell[121549, 2786, 407, 11, 34, "Output",ExpressionUUID->"7c43dbd2-33f5-41e8-b886-e0a6a9507177"]
}, Open  ]]
}
]
*)

