(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     79663,       1654]
NotebookOptionsPosition[     78534,       1626]
NotebookOutlinePosition[     78925,       1643]
CellTagsIndexPosition[     78882,       1640]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},ExpressionUUID->"ccee5a14-2190-4c40-8063-\
f8c35b383272"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"lsys", "[", 
     RowBox[{"nn0_", ",", "mm0_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"nn", "=", 
        RowBox[{"ToExpression", "@", "nn0"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"mm", "=", 
        RowBox[{"ToExpression", "@", "mm0"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"imageSize", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{"480", ",", " ", "400"}], "}"}]}], ";", "\n", 
       RowBox[{"thumbSize", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{"26", ",", " ", "26"}], "}"}]}], ";", "\n", 
       RowBox[{"thumbPadding", " ", "=", " ", "2"}], ";", "\n", 
       RowBox[{"nextStyle", " ", "=", " ", 
        RowBox[{"{", 
         RowBox[{"RGBColor", "[", 
          RowBox[{"1", ",", " ", "0", ",", " ", "0"}], "]"}], 
         RowBox[{"(*", 
          RowBox[{",", " ", 
           RowBox[{"Dashing", "[", 
            RowBox[{"1", " ", "/", " ", 
             RowBox[{"(", 
              RowBox[{"40", " ", "+", " ", 
               RowBox[{"3", "^", 
                RowBox[{"(", 
                 RowBox[{"i", "+", "1"}], ")"}]}]}], ")"}]}], "]"}]}], "*)"}],
          "}"}]}], ";", "\n", 
       RowBox[{"maxIterations", " ", "=", " ", "5"}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{"initialized", " ", "so", " ", 
         RowBox[{"it", "'"}], "s", " ", "not", " ", "Null"}], " ", "*)"}], 
       "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{"ignore", " ", "these", " ", "warnings"}], " ", "*)"}], "\n", 
       
       RowBox[{"Off", "[", 
        RowBox[{"Part", "::", "partw"}], "]"}], ";", "\n", 
       RowBox[{"Off", "[", 
        RowBox[{"Rule", "::", "rhs"}], "]"}], ";", "\n", 
       RowBox[{"Off", "[", 
        RowBox[{"Join", "::", "heads"}], "]"}], ";", "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{"main", " ", "LSystem", " ", 
         RowBox[{"function", ".", " ", "it"}], " ", "does", " ", "ReplaceAll",
          "\n", "\t", "in", " ", "a", " ", "way", " ", "that", " ", "splices",
          " ", "into", " ", "the", " ", "list"}], " ", "*)"}], "\n", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"adjustment", " ", "=", " ", 
           RowBox[{"{", "\n", "\t", 
            RowBox[{
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"a_", ",", " ", "b_"}], "]"}], " ", ":>", " ", 
              RowBox[{"Rule", "[", 
               RowBox[{"a", ",", " ", 
                RowBox[{"Sequence", " ", "@@", " ", "b"}]}], "]"}]}], ",", 
             "\n", "\t", 
             RowBox[{
              RowBox[{"RuleDelayed", "[", 
               RowBox[{"a_", ",", " ", "b_"}], "]"}], " ", ":>", " ", 
              RowBox[{"RuleDelayed", "[", 
               RowBox[{"a", ",", " ", 
                RowBox[{"Sequence", " ", "@@", " ", "b"}]}], "]"}]}]}], 
            "}"}]}], "}"}], ",", "\n", "\n", "\t", 
         RowBox[{
          RowBox[{
           RowBox[{"LSystem", "[", 
            RowBox[{"0", ",", " ", "axiom_", ",", " ", "_"}], "]"}], " ", ":=",
            " ", "axiom"}], ";", "\n", "\t", 
          RowBox[{
           RowBox[{"LSystem", "[", 
            RowBox[{"iterations_", ",", " ", "axiom_", ",", " ", "rule_"}], 
            "]"}], " ", ":=", "\n", "\t\t\t", 
           RowBox[{
            RowBox[{"LSystem", "[", 
             RowBox[{
              RowBox[{"iterations", " ", "-", " ", "1"}], ",", " ", "axiom", 
              ",", " ", "rule"}], "]"}], " ", "/.", " ", 
            RowBox[{"(", 
             RowBox[{"rule", " ", "/.", " ", "adjustment"}], ")"}]}]}], 
          ";"}]}], "\n", "]"}], ";", "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{"main", " ", "drawing", " ", 
         RowBox[{"function", ".", " ", "executes"}], " ", "a", " ", 
         "sequence", " ", "of", " ", "movement", " ", "commands"}], " ", 
        "*)"}], "\n", 
       RowBox[{
        RowBox[{"LOGO", "[", 
         RowBox[{"commands_", ",", " ", 
          RowBox[{"{", 
           RowBox[{"startx_", ",", " ", "starty_", ",", " ", "starta_"}], 
           "}"}]}], "]"}], " ", ":=", " ", 
        RowBox[{"Block", "[", 
         RowBox[{
          RowBox[{"{", "\n", "\t", 
           RowBox[{"(*", " ", 
            RowBox[{
            "note", " ", "that", " ", "these", " ", "commands", " ", "are", 
             " ", "functions", " ", "*", "which", " ", "construct", "*", "\n",
              "\t\t", "transformations", " ", "that", " ", "operate", " ", 
             "on", " ", "the", " ", 
             RowBox[{"turtle", "'"}], "s", " ", "state"}], " ", "*)"}], "\n", 
           "\t", 
           RowBox[{
            RowBox[{"forward", " ", "=", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x_Real", ",", " ", "y_Real", ",", " ", "a_Real"}], 
                "}"}], " ", "->", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"x", " ", "+", " ", 
                  RowBox[{"#", " ", 
                   RowBox[{"Cos", "[", "a", "]"}]}]}], ",", " ", 
                 RowBox[{"y", " ", "+", " ", 
                  RowBox[{"#", " ", 
                   RowBox[{"Sin", "[", "a", "]"}]}]}], ",", " ", "a"}], 
                "}"}]}], " ", "&"}]}], ",", "\n", "\t", 
            RowBox[{"left", " ", "=", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"x_Real", ",", " ", "y_Real", ",", " ", "a_Real"}], 
                "}"}], " ", "->", " ", 
               RowBox[{"{", 
                RowBox[{"x", ",", " ", "y", ",", " ", 
                 RowBox[{"a", " ", "+", " ", 
                  RowBox[{"#", " ", "Degree"}]}]}], "}"}]}], " ", "&"}]}], 
            ",", "\t", "\n", "\t", 
            RowBox[{"backward", " ", "=", " ", 
             RowBox[{
              RowBox[{"forward", "[", 
               RowBox[{"-", "#"}], "]"}], " ", "&"}]}], ",", "\n", "\t", 
            RowBox[{"right", " ", "=", " ", 
             RowBox[{
              RowBox[{"left", "[", 
               RowBox[{"-", "#"}], "]"}], " ", "&"}]}], ",", "\n", "\t", 
            "push", ",", " ", "pop"}], "}"}], ",", "\n", "\n", "\t", 
          RowBox[{"(*", " ", 
           RowBox[{"LIFO", " ", "stack"}], " ", "*)"}], "\n", "\t", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"push", ",", " ", "pop"}], "}"}], " ", "=", " ", 
            RowBox[{"Module", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"list", " ", "=", " ", 
                RowBox[{"{", "}"}]}], "}"}], ",", "\n", "\t\t", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"triple_", " ", ":>", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"AppendTo", "[", 
                    RowBox[{"list", ",", " ", "triple"}], "]"}], ";", " ", 
                   "triple"}], ")"}]}], ",", "\n", "\t\t", 
                RowBox[{"_", " ", ":>", " ", 
                 RowBox[{"Module", "[", "\n", "\t\t\t", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"val", " ", "=", " ", 
                    RowBox[{"list", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}], ",", "\n", 
                   "\t\t\t", 
                   RowBox[{
                    RowBox[{"list", " ", "=", " ", 
                    RowBox[{"Delete", "[", 
                    RowBox[{"list", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}], ";", "\n", "\t\t\t", 
                    "val"}]}], "]"}]}]}], "}"}]}], "]"}]}], ";", "\n", "\n", 
           "\t", 
           RowBox[{"Block", "[", 
            RowBox[{
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{"(*", " ", 
               RowBox[{
                RowBox[{"remove", " ", "non"}], "-", "commands"}], " ", 
               "*)"}], "\n", "\t\t", 
              RowBox[{
               RowBox[{"filteredCommands", " ", ":=", " ", 
                RowBox[{"filteredCommands", " ", "=", " ", 
                 RowBox[{"Cases", "[", 
                  RowBox[{"commands", ",", " ", 
                   RowBox[{"_Rule", " ", "|", " ", "_RuleDelayed"}]}], 
                  "]"}]}]}], ",", "\n", "\n", "\t\t", 
               RowBox[{"(*", " ", 
                RowBox[{
                "split", " ", "lines", " ", "where", " ", "there", " ", "is", 
                 " ", "a", " ", "pop", " ", "command"}], " ", "*)"}], "\n", 
               "\t\t", 
               RowBox[{"spans", " ", ":=", " ", 
                RowBox[{"spans", " ", "=", " ", 
                 RowBox[{"Join", "[", 
                  RowBox[{
                   RowBox[{"{", "0", "}"}], ",", "\n", "\t\t\t", 
                   RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{"filteredCommands", ",", " ", "pop"}], "]"}], " ",
                     "//", " ", "Flatten"}], ",", "\n", "\t\t\t", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"filteredCommands", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], " ", "=!=", " ", 
                    "pop"}], ",", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Length", "[", "filteredCommands", "]"}], "+", 
                    "1"}], "}"}], ",", " ", 
                    RowBox[{"{", "}"}]}], "]"}]}], "]"}]}]}], ",", "\n", 
               "\t\t", 
               RowBox[{"removeAngles", " ", "=", " ", 
                RowBox[{
                 RowBox[{"ArrayPad", "[", 
                  RowBox[{"#", ",", " ", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", " ", "0"}], "}"}], ",", " ", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", " ", 
                    RowBox[{"-", "1"}]}], "}"}]}], "}"}]}], "]"}], " ", 
                 "&"}]}], ",", "\n", "\t\t", 
               RowBox[{"splitLines", " ", "=", " ", 
                RowBox[{"Function", "[", 
                 RowBox[{"lines", ",", "\n", "\t\t\t", 
                  RowBox[{"Cases", "[", 
                   RowBox[{
                    RowBox[{"Partition", "[", 
                    RowBox[{"spans", ",", " ", "2", ",", " ", "1"}], "]"}], 
                    ",", "\n", "\t\t\t\t", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"start_", ",", " ", "end_"}], "}"}], " ", ":>", 
                    " ", 
                    RowBox[{"lines", "[", 
                    RowBox[{"[", " ", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"start", " ", "+", " ", "1"}], ")"}], " ", ";;", 
                    " ", "end"}], " ", "]"}], "]"}]}]}], "]"}]}], "]"}]}]}], 
              "}"}], ",", "\n", "\n", "\t\t", 
             RowBox[{"(*", " ", 
              RowBox[{"execute", " ", 
               RowBox[{"commands", "."}]}], " ", "*)"}], "\n", "\t\t", 
             RowBox[{"(*", " ", 
              RowBox[{
              "note", " ", "that", " ", "duplicate", " ", "points", " ", 
               "created", " ", "by", " ", 
               RowBox[{"left", "/", "right"}], " ", "are", " ", "not", " ", 
               "removed"}], " ", "*)"}], "\n", "\t\t", 
             RowBox[{
              RowBox[{
               RowBox[{"FoldList", "[", 
                RowBox[{"Replace", ",", " ", 
                 RowBox[{"{", 
                  RowBox[{"startx", ",", " ", "starty", ",", " ", 
                   RowBox[{"starta", " ", "Degree"}]}], "}"}], ",", " ", 
                 "filteredCommands"}], "]"}], "\n", "\t\t", "//", " ", 
               "removeAngles"}], "\n", "\t\t", "//", " ", "splitLines"}]}], 
            "]"}]}]}], "\n", "]"}]}], ";", "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "executes", " ", "LOGO", " ", "commands", " ", "within", " ", "the", 
          " ", "context", " ", "of", " ", "the", " ", "given", " ", "L"}], 
         "-", "system"}], " ", "*)"}], "\n", 
       RowBox[{
        RowBox[{"geometry", "[", 
         RowBox[{"system_", ",", " ", "iterations_"}], "]"}], " ", ":=", " ", 
        
        RowBox[{"Block", "[", 
         RowBox[{
          RowBox[{"{", "\n", "\t", 
           RowBox[{
            RowBox[{"i", " ", "=", " ", "iterations"}], ",", "\n", "\t", 
            RowBox[{"(*", " ", 
             RowBox[{
             "set", " ", "a", " ", "default", " ", "offset", " ", "if", " ", 
              "one", " ", 
              RowBox[{"isn", "'"}], "t", " ", "defined"}], " ", "*)"}], "\n", 
            "\t", 
            RowBox[{"offset", " ", "=", " ", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"offset", " ", "/.", " ", "system"}], ")"}], " ", "/.",
               " ", 
              RowBox[{"(", 
               RowBox[{"offset", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{"0.", ",", " ", "0."}], "}"}]}], ")"}]}]}]}], "}"}], 
          ",", "\n", "\n", "\t", 
          RowBox[{
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"LOGO", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"LSystem", "[", 
                 RowBox[{"i", ",", " ", "axiom", ",", " ", "rules"}], "]"}], 
                " ", "/.", " ", "conversions"}], ",", "\n", "\t\t", 
               RowBox[{"Append", "[", 
                RowBox[{"offset", ",", " ", "orientation"}], "]"}]}], "]"}], 
             "]"}], "\n", "\t", "/.", " ", "system"}], "\n", "\t", "//", " ", 
           "ReleaseHold"}]}], "\n", "]"}]}], ";", "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "generates", " ", "the", " ", "thumbnail", " ", "for", " ", "the", 
          " ", "given", " ", "L"}], "-", "system"}], " ", "*)"}], "\n", 
       RowBox[{
        RowBox[{"thumbnail", "[", "system_", "]"}], " ", ":=", " ", 
        RowBox[{"Tooltip", "[", "\n", "\t", 
         RowBox[{
          RowBox[{"Graphics", "[", 
           RowBox[{
            RowBox[{"Line", " ", "/@", " ", 
             RowBox[{"geometry", "[", 
              RowBox[{"system", ",", " ", 
               RowBox[{"(", 
                RowBox[{"thumbIterations", " ", "/.", " ", "system"}], 
                ")"}]}], "]"}]}], ",", "\n", "\t\t", 
            RowBox[{"ImagePadding", " ", "->", " ", "thumbPadding"}], ",", 
            " ", 
            RowBox[{"ImageSize", " ", "->", " ", "thumbSize"}]}], "]"}], ",", 
          "\n", "\t", 
          RowBox[{"(", 
           RowBox[{"name", " ", "/.", " ", "system"}], ")"}], ",", " ", 
          RowBox[{"TooltipDelay", " ", "->", " ", ".3"}]}], "]"}]}], ";", 
       "\n", "\n", 
       RowBox[{"(*", " ", 
        RowBox[{
        "these", " ", "are", " ", "the", " ", "structure", " ", "definitions",
          " ", "for", " ", "the", " ", 
         RowBox[{"curves", ".", "  ", "the"}], " ", "list", " ", 
         "replacement", "\n", "\t", "is", " ", "very", " ", "flexible", " ", 
         "since", " ", "it", " ", "uses", " ", 
         RowBox[{"Mathematica", "'"}], "s", " ", "symbolic", " ", 
         RowBox[{"transformations", " ", "--"}], "\n", "\t", "I", " ", "have",
          " ", "two", " ", "different", " ", "methods", " ", "of", " ", 
         "scaling", " ", "here", " ", "as", " ", 
         RowBox[{"examples", ".", "\n", " ", "a"}], " ", "scaling", " ", 
         "option", " ", "that", " ", "I", " ", 
         RowBox[{"didn", "'"}], "t", " ", "implement", " ", "is", " ", "to", 
         " ", "use", " ", "matrix", " ", "transformations"}], " ", "*)"}], 
       "\n", 
       RowBox[{"curves", " ", "=", " ", 
        RowBox[{"{", "\n", "\t", "\n", 
         RowBox[{
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<L\[EAcute]vy C Curve\>\""}], 
            ",", "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", "0."}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{"forward", "[", "1", "]"}], "}"}]}], ",", "\n", "\n", 
            "\t", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "scaling", " ", "method", " ", "1.", " ", "scale", " ", 
               "within", " ", "the", " ", "rules", " ", "of", " ", "the", " ",
                "L"}], "-", 
              RowBox[{"system", " ", "itself"}]}], " ", "*)"}], "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", " ", 
              RowBox[{
               RowBox[{"forward", "[", "x_", "]"}], " ", "->", "\n", "\t\t", 
               RowBox[{"{", 
                RowBox[{"R", ",", " ", 
                 RowBox[{"forward", "[", 
                  RowBox[{
                   RowBox[{"Cos", "[", 
                    RowBox[{"45.", " ", "Degree"}], "]"}], " ", "x"}], "]"}], 
                 ",", " ", "L", ",", " ", "L", ",", " ", 
                 RowBox[{"forward", "[", 
                  RowBox[{
                   RowBox[{"Cos", "[", 
                    RowBox[{"45.", " ", "Degree"}], "]"}], " ", "x"}], "]"}], 
                 ",", " ", "R"}], "}"}]}], "}"}]}], ",", "\n", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "45", "]"}]}], ",", " ", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "45", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".5"}], ",", " ", "1.5"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", " ", ".25"}], "}"}]}], "}"}]}], ",",
             "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "5"}], ",", "\n", 
            "    ", 
            RowBox[{"maxIters", " ", "->", " ", "13"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "6"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Sierpinski Triangle\>\""}], 
            ",", "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", 
             RowBox[{"60.", " ", 
              RowBox[{"Mod", "[", 
               RowBox[{"i", ",", " ", "2"}], "]"}]}]}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", "A", "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"A", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "B", ",", " ", "R", ",", " ", "A", ",", " ", "R", ",", " ", 
                  "B"}], "}"}]}], ",", "\n", "\t\t", 
               RowBox[{"B", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "A", ",", " ", "L", ",", " ", "B", ",", " ", "L", ",", " ", 
                  "A"}], "}"}]}]}], "}"}]}], ",", "\n", "\n", "\t", 
            RowBox[{"(*", " ", 
             RowBox[{
             "scaling", " ", "method", " ", "2.", " ", "scale", " ", 
              "\"\<globally\>\"", " ", "after", " ", "iteration"}], " ", 
             "*)"}], "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"A", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{"2.", "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"B", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{"2.", "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "60", "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "60", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", " ", "1"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".1"}], ",", " ", "1"}], "}"}]}], "}"}]}], ",", 
            "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "3"}], ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "9"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "5"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Hilbert Curve\>\""}], ",", 
            "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", "180."}], ",", "\n", "\t", 
            
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", "A", "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"A", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "L", ",", " ", "B", ",", " ", "F", ",", " ", "R", ",", " ", 
                  "A", ",", " ", "F", ",", " ", "A", ",", " ", "R", ",", " ", 
                  "F", ",", " ", "B", ",", " ", "L"}], "}"}]}], ",", "\n", 
               "\t\t", 
               RowBox[{"B", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "R", ",", " ", "A", ",", " ", "F", ",", " ", "L", ",", " ", 
                  "B", ",", " ", "F", ",", " ", "B", ",", " ", "L", ",", " ", 
                  "F", ",", " ", "A", ",", " ", "R"}], "}"}]}]}], "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{"2.", "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "90", "]"}]}], ",", " ", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "90", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", " ", ".01"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1.01"}], ",", " ", ".01"}], "}"}]}], "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "3"}], ",", "\n", "\t", 
            RowBox[{"offset", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", 
                RowBox[{"2.", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "i"}], "-", "1"}], ")"}]}]}], ",", " ", 
               RowBox[{"-", 
                RowBox[{"2.", "^", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "i"}], "-", "1"}], ")"}]}]}]}], " ", "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "7"}], ",", "\n", "   \t", 
            RowBox[{"minIters", " ", "->", " ", "1"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "4"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Heighway Dragon Curve\>\""}],
             ",", "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", 
             RowBox[{"45.", " ", "i"}]}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{"F", ",", " ", "X"}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"X", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "X", ",", " ", "R", ",", " ", "Y", ",", " ", "F", ",", " ", 
                  "R"}], "}"}]}], ",", "\n", "\t\t", 
               RowBox[{"Y", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "L", ",", " ", "F", ",", " ", "X", ",", " ", "L", ",", " ", 
                  "Y"}], "}"}]}]}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{
                  RowBox[{"Sqrt", "[", "2.", "]"}], "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "90", "]"}]}], ",", " ", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "90", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".4"}], ",", " ", "1.22"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".5"}], ",", " ", ".8"}], "}"}]}], "}"}]}], ",",
             "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "5"}], ",", "\n", 
            "    ", 
            RowBox[{"maxIters", " ", "->", " ", "13"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "6"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Pinwheel Embroidery\>\""}], 
            ",", "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", "45."}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
              "X", ",", " ", "push", ",", " ", "L", ",", " ", "X", ",", " ", 
               "R", ",", " ", "R", ",", " ", "X", ",", " ", "pop", ",", " ", 
               "R", ",", " ", "X", ",", " ", "L", ",", " ", "L", ",", " ", 
               "X", ",", " ", "R", ",", " ", "F"}], "}"}]}], ",", "\n", "\t", 
            
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "F", ",", " ", "push", ",", " ", "L", ",", " ", "X", ",", 
                  " ", "R", ",", " ", "R", ",", " ", "X", ",", " ", "pop", 
                  ",", " ", "R", ",", " ", "X", ",", " ", "L", ",", " ", "L", 
                  ",", " ", "X", ",", " ", "R", ",", " ", "F"}], "}"}]}], ",",
                "\n", "\t\t", 
               RowBox[{"X", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                 "F", ",", " ", "push", ",", " ", "L", ",", " ", "F", ",", 
                  " ", "R", ",", " ", "R", ",", " ", "R", ",", " ", "F", ",", 
                  " ", "pop", ",", " ", "R", ",", " ", "F", ",", " ", "L", 
                  ",", " ", "L", ",", " ", "F", ",", " ", "R", ",", " ", 
                  "F"}], "}"}]}]}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"forward", "[", "1", "]"}]}], ",", " ", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "45", "]"}]}], ",", " ", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "45", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", "Automatic"}], ",", "\n", 
            "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "2"}], ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "4"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", 
             RowBox[{"-", "1"}]}]}], " ", "}"}], ",", "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Koch Snowflake\>\""}], ",", 
            "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", "0."}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{"F", ",", " ", 
               RowBox[{"right", "[", "120", "]"}], ",", " ", "F", ",", " ", 
               RowBox[{"right", "[", "120", "]"}], ",", " ", "F"}], "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{"F", " ", "->", " ", 
               RowBox[{"{", 
                RowBox[{"F", ",", " ", 
                 RowBox[{"left", "[", "60", "]"}], ",", " ", "F", ",", " ", 
                 RowBox[{"right", "[", "120", "]"}], ",", " ", "F", ",", " ", 
                 
                 RowBox[{"left", "[", "60", "]"}], ",", " ", "F"}], "}"}]}], 
              "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{"F", " ", "->", " ", 
               RowBox[{"forward", "[", 
                RowBox[{"3.", "^", 
                 RowBox[{"(", 
                  RowBox[{"-", "i"}], ")"}]}], "]"}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".1"}], ",", " ", "1.1"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".92"}], ",", " ", ".33"}], "}"}]}], "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "2"}], ",", "\n", 
            "    ", 
            RowBox[{"maxIters", " ", "->", " ", "5"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "3"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Ces\[AGrave]ro Curve\>\""}], 
            ",", "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", "0."}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", "F", "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{"F", " ", "->", " ", 
               RowBox[{"{", 
                RowBox[{
                "F", ",", " ", "L", ",", " ", "F", ",", " ", "R", ",", " ", 
                 "R", ",", " ", "F", ",", " ", "L", ",", " ", "F"}], "}"}]}], 
              "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"2", " ", "+", " ", 
                    RowBox[{"2", " ", 
                    RowBox[{"Cos", "[", 
                    RowBox[{"85.", " ", "Degree"}], "]"}]}]}], ")"}], "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "85", "]"}]}], ",", " ", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "85", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", " ", "1"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".1"}], ",", " ", ".5"}], "}"}]}], "}"}]}], ",",
             "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "2"}], ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "7"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "4"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"(*", " ", 
           RowBox[{"empirically", " ", "find", " ", 
            RowBox[{"magnitude", "/", "rotation"}], " ", "transform", " ", 
            "for", " ", "Gosper", " ", "curve", "\n", "    ", "since", " ", 
            RowBox[{"it", "'"}], "s", " ", "not", " ", "immediately", " ", 
            "straightforward"}], " ", "*)"}], "\n", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"gosper", ",", " ", "abs", ",", " ", "arg"}], "}"}], ",",
             "\n", "\t", 
            RowBox[{
             RowBox[{
              RowBox[{"gosper", "[", 
               RowBox[{"abs_", ",", " ", "arg_", ",", " ", "baseAngle_"}], 
               "]"}], " ", ":=", " ", 
              RowBox[{"{", "\n", "\t\t", 
               RowBox[{
                RowBox[{"name", " ", "->", " ", "\"\<Gosper Curve\>\""}], ",",
                 "\n", "\t\t", 
                RowBox[{"orientation", " ", "->", " ", 
                 RowBox[{"baseAngle", " ", "+", " ", 
                  RowBox[{"arg", " ", 
                   RowBox[{"Degree", "^", 
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}]}], " ", "i"}]}]}], ",", "\n", 
                "\t\t", 
                RowBox[{"axiom", " ", "->", " ", 
                 RowBox[{"{", 
                  RowBox[{"F", ",", " ", "X"}], "}"}]}], ",", "\n", "\t\t", 
                RowBox[{"rules", " ", "->", " ", 
                 RowBox[{"{", "\n", "\t\t\t", 
                  RowBox[{
                   RowBox[{"X", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    "X", ",", " ", "R", ",", " ", "Y", ",", " ", "F", ",", 
                    " ", "R", ",", " ", "R", ",", " ", "Y", ",", " ", "F", 
                    ",", " ", "L", ",", " ", "F", ",", " ", "X", ",", " ", 
                    "L", ",", " ", "L", ",", " ", "F", ",", " ", "X", ",", 
                    " ", "F", ",", " ", "X", ",", " ", "L", ",", " ", "Y", 
                    ",", " ", "F", ",", " ", "R"}], "}"}]}], ",", "\n", 
                   "\t\t\t", 
                   RowBox[{"Y", " ", "->", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    "L", ",", " ", "F", ",", " ", "X", ",", " ", "R", ",", 
                    " ", "Y", ",", " ", "F", ",", " ", "Y", ",", " ", "F", 
                    ",", " ", "R", ",", " ", "R", ",", " ", "Y", ",", " ", 
                    "F", ",", " ", "R", ",", " ", "F", ",", " ", "X", ",", 
                    " ", "L", ",", " ", "L", ",", " ", "F", ",", " ", "X", 
                    ",", " ", "L", ",", " ", "Y"}], "}"}]}]}], "}"}]}], ",", 
                "\n", "\t\t", 
                RowBox[{"conversions", " ", "->", " ", 
                 RowBox[{"{", "\n", "\t\t\t", 
                  RowBox[{
                   RowBox[{"F", " ", "->", " ", 
                    RowBox[{"forward", "[", 
                    RowBox[{"abs", "^", 
                    RowBox[{"(", 
                    RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", "\n", "\t\t\t", 
                   RowBox[{"R", " ", "->", " ", 
                    RowBox[{"right", "[", "60", "]"}]}], ",", " ", 
                   RowBox[{"L", " ", "->", " ", 
                    RowBox[{"left", "[", "60", "]"}]}]}], "}"}]}], ",", "\n", 
                "\t\t", 
                RowBox[{"plotRange", " ", "->", " ", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", ".4"}], ",", " ", "1"}], "}"}], ",", " ", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", ".2"}], ",", " ", "1.2"}], "}"}]}], "}"}]}], 
                ",", "\n", "\t\t", 
                RowBox[{"thumbIterations", " ", "->", " ", "2"}], ",", "\n", 
                "\t\t", 
                RowBox[{"maxIters", " ", "->", " ", "5"}], ",", "\n", "\t\t", 
                
                RowBox[{"maxShowNext", " ", "->", " ", "3"}]}], " ", "}"}]}], 
             ";", "\n", "\n", "\t", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"abs", ",", " ", "arg"}], "}"}], " ", "=", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"geometry", "[", 
                    RowBox[{
                    RowBox[{"gosper", "[", 
                    RowBox[{"1.", ",", " ", "0.", ",", " ", "0."}], "]"}], 
                    ",", " ", "1"}], "]"}], " ", "//", " ", "Last"}], " ", "//",
                   " ", "Last"}], ")"}], " ", 
                RowBox[{"(*", " ", 
                 RowBox[{"last", " ", "point"}], " ", "*)"}], "\n", 
                "\t\t\t\t ", "/.", " ", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"x_", ",", " ", "y_"}], "}"}], " ", "->", " ", 
                 RowBox[{"x", " ", "+", " ", 
                  RowBox[{"y", " ", "I"}]}]}]}], " ", 
               RowBox[{"(*", " ", 
                RowBox[{"convert", " ", "to", " ", "complex"}], " ", "*)"}], 
               "\n", "\t\t\t\t ", "//", " ", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", " ", "//", " ", "Abs"}], ",", " ", 
                  RowBox[{"#", " ", "//", " ", "Arg"}]}], "}"}], " ", 
                "&"}]}]}], ";", "\n", "\n", "\t", 
             RowBox[{"gosper", "[", 
              RowBox[{"abs", ",", " ", 
               RowBox[{"-", "arg"}], ",", " ", "90."}], "]"}]}]}], "]"}], ",",
           "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Penrose Tiling\>\""}], ",", 
            "\n", "\t", 
            RowBox[{"orientation", " ", "->", " ", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", " ", ">", " ", "6"}], ",", " ", "0.", ",", " ", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                 "36.", ",", " ", "0.", ",", " ", "0.", ",", " ", "36.", ",", 
                  " ", "36."}], "}"}], "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ",", "\n", "\t", 
            RowBox[{"axiom", " ", "->", "\n", "\t\t", 
             RowBox[{"{", 
              RowBox[{"SV", ",", " ", "7", ",", " ", "RS", ",", " ", 
               RowBox[{"2", "R"}], ",", " ", "SV", ",", " ", "7", ",", " ", 
               "RS", ",", " ", 
               RowBox[{"2", "R"}], ",", " ", "SV", ",", " ", "7", ",", " ", 
               "RS", ",", " ", 
               RowBox[{"2", "R"}], ",", " ", "SV", ",", " ", "7", ",", " ", 
               "RS", ",", " ", 
               RowBox[{"2", "R"}], ",", " ", "SV", ",", " ", "7", ",", " ", 
               "RS"}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"6", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{"8", ",", " ", "1", ",", " ", 
                  RowBox[{"2", "R"}], ",", " ", "9", ",", " ", "1", ",", " ", 
                  
                  RowBox[{"4", "L"}], ",", " ", "7", ",", " ", "1", ",", " ", 
                  "SV", ",", " ", "L", ",", " ", "8", ",", " ", "1", ",", " ", 
                  RowBox[{"4", "L"}], ",", " ", "6", ",", " ", "1", ",", " ", 
                  "RS", ",", " ", 
                  RowBox[{"2", "R"}]}], "}"}]}], ",", "\n", "\t\t", 
               RowBox[{"7", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{"R", ",", " ", "8", ",", " ", "1", ",", " ", 
                  RowBox[{"2", "L"}], ",", " ", "9", ",", " ", "1", ",", " ", 
                  "SV", ",", " ", 
                  RowBox[{"3", "L"}], ",", " ", "6", ",", " ", "1", ",", " ", 
                  
                  RowBox[{"2", "L"}], ",", " ", "7", ",", " ", "1", ",", " ", 
                  "RS", ",", " ", "R"}], "}"}]}], ",", "\n", "\t\t", 
               RowBox[{"8", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{"L", ",", " ", "6", ",", " ", "1", ",", " ", 
                  RowBox[{"2", "R"}], ",", " ", "7", ",", " ", "1", ",", " ", 
                  "SV", ",", " ", 
                  RowBox[{"3", "R"}], ",", " ", "8", ",", " ", "1", ",", " ", 
                  
                  RowBox[{"2", "R"}], ",", " ", "9", ",", " ", "1", ",", " ", 
                  "RS", ",", " ", "L"}], "}"}]}], ",", "\n", "\t\t", 
               RowBox[{"9", " ", "->", " ", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"2", "L"}], ",", " ", "8", ",", " ", "1", ",", " ", 
                  
                  RowBox[{"4", "R"}], ",", " ", "6", ",", " ", "1", ",", " ", 
                  "SV", ",", " ", "R", ",", " ", "9", ",", " ", "1", ",", " ", 
                  RowBox[{"4", "R"}], ",", " ", "7", ",", " ", "1", ",", " ", 
                  "RS", ",", " ", 
                  RowBox[{"2", "L"}], ",", " ", "7", ",", " ", "1"}], "}"}]}],
                ",", "\n", "\t\t", 
               RowBox[{"1", " ", "->", " ", 
                RowBox[{"{", "}"}]}]}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"1", " ", "->", " ", 
                RowBox[{"forward", "[", "1", "]"}]}], ",", " ", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"x_", " ", ":", " ", "1"}], ")"}], " ", "L"}], " ", 
                "->", " ", 
                RowBox[{"left", "[", 
                 RowBox[{"36", " ", "x"}], "]"}]}], ",", "\n", "\t\t", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"x_", " ", ":", " ", "1"}], ")"}], " ", "R"}], " ", 
                "->", " ", 
                RowBox[{"right", "[", 
                 RowBox[{"36", " ", "x"}], "]"}]}], ",", " ", 
               RowBox[{"SV", " ", "->", " ", "push"}], ",", " ", 
               RowBox[{"RS", " ", "->", " ", "pop"}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", "Automatic"}], ",", "\n", 
            "\t", 
            RowBox[{"customStyle", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{"JoinForm", "[", "\"\<Round\>\"", "]"}], "}"}]}], ",", 
            "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "1"}], ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "5"}], ",", "\n", "\t", 
            RowBox[{"minIters", " ", "->", " ", "1"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "3"}]}], " ", "}"}], ",", 
          "\n", "\n", 
          RowBox[{"{", " ", 
           RowBox[{
            RowBox[{"name", " ", "->", " ", "\"\<Plant\>\""}], ",", "\n", 
            "\t", 
            RowBox[{"orientation", " ", "->", " ", "90."}], ",", " ", "\n", 
            "\t", 
            RowBox[{"axiom", " ", "->", " ", 
             RowBox[{"{", "F", "}"}]}], ",", "\n", "\t", 
            RowBox[{"rules", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{"F", " ", "->", " ", 
               RowBox[{"{", 
                RowBox[{
                "F", ",", " ", "push", ",", " ", "L", ",", " ", "F", ",", " ",
                  "F", ",", " ", "pop", ",", " ", "F", ",", " ", "push", ",", 
                 " ", "R", ",", " ", "F", ",", " ", "F", ",", " ", "pop", ",",
                  " ", "F"}], "}"}]}], "}"}]}], ",", "\n", "\t", 
            RowBox[{"conversions", " ", "->", " ", 
             RowBox[{"{", "\n", "\t\t", 
              RowBox[{
               RowBox[{"F", " ", "->", " ", 
                RowBox[{"forward", "[", 
                 RowBox[{"3.", "^", 
                  RowBox[{"(", 
                   RowBox[{"-", "i"}], ")"}]}], "]"}]}], ",", " ", 
               RowBox[{"L", " ", "->", " ", 
                RowBox[{"left", "[", "25", "]"}]}], ",", " ", 
               RowBox[{"R", " ", "->", " ", 
                RowBox[{"right", "[", "25", "]"}]}]}], "}"}]}], ",", "\n", 
            "\t", 
            RowBox[{"plotRange", " ", "->", " ", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".4"}], ",", " ", ".48"}], "}"}], ",", " ", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".01"}], ",", " ", "1.36"}], "}"}]}], "}"}]}], 
            ",", "\n", "\t", 
            RowBox[{"thumbIterations", " ", "->", " ", "2"}], ",", "\n", "\t", 
            RowBox[{"maxIters", " ", "->", " ", "4"}], ",", "\n", "\t", 
            RowBox[{"maxShowNext", " ", "->", " ", "3"}]}], " ", "}"}]}], 
         "\n", "}"}]}], ";", "\n", "\[IndentingNewLine]", 
       RowBox[{"PNG", "=", "True"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"PNG", "\[Equal]", "True"}], ",", 
          RowBox[{"ImportString", "@", 
           RowBox[{"ExportString", "[", 
            RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
       ";", "\n", 
       RowBox[{"lineThickness", "=", "0.005"}], ";", "\[IndentingNewLine]", 
       RowBox[{"color", "=", "Black"}], ";", "\[IndentingNewLine]", 
       RowBox[{"maxIterations", " ", "=", " ", 
        RowBox[{"(", 
         RowBox[{"maxIters", " ", "/.", " ", "system"}], ")"}]}], ";", " ", 
       RowBox[{"(*", " ", 
        RowBox[{"readjust", " ", "slider", " ", "max"}], " ", "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"nn1", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"nn", ">", "10"}], ",", "10", ",", "nn"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"system", "=", 
        RowBox[{"curves", "[", 
         RowBox[{"[", "nn1", "]"}], "]"}]}], ";", "\n", 
       RowBox[{"iterations", " ", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"mm", ">", "maxIterations"}], ",", "maxIterations", ",", 
          "mm"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"oo1", "=", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"oo", ">", "3"}], ",", "2", ",", "oo"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"oo1", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"myPNG", "@", "\[IndentingNewLine]", 
        RowBox[{"Column", "@", 
         RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"name", "/.", " ", "system"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"rules", "/.", "system"}], ",", "\[IndentingNewLine]", 
           RowBox[{"conversions", "/.", "system"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Show", "[", "\n", "\n", "\t", 
            RowBox[{"(*", " ", 
             RowBox[{"next", " ", "iteration"}], " ", "*)"}], "\n", "\t", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"False", ",", "\n", "\t\t", 
               RowBox[{"Block", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"i", " ", "=", " ", 
                   RowBox[{"iterations", " ", "+", " ", "1"}]}], "}"}], ",", 
                 " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                  "i", " ", "is", " ", "used", " ", "in", " ", "nextStyle"}], 
                  " ", "*)"}], "\n", "\t\t\t", 
                 RowBox[{"Graphics", "[", 
                  RowBox[{"Join", "[", "\n", "\t\t\t\t", 
                   RowBox[{"nextStyle", ",", "\n", "\t\t\t\t", 
                    RowBox[{"{", 
                    RowBox[{"Thickness", "[", 
                    RowBox[{"lineThickness", "/", "2"}], "]"}], "}"}], ",", 
                    "\n", "\t\t\t\t", 
                    RowBox[{"Line", " ", "/@", " ", 
                    RowBox[{"geometry", "[", 
                    RowBox[{"system", ",", " ", 
                    RowBox[{"iterations", " ", "+", "oo1"}]}], "]"}]}]}], 
                   "]"}], "]"}]}], "]"}], ",", " ", "\n", "\t\t", 
               RowBox[{"{", "}"}]}], "]"}], ",", "\n", "\n", "\t", 
             RowBox[{"(*", " ", 
              RowBox[{"current", " ", "iteration"}], " ", "*)"}], "\n", "\t", 
             
             RowBox[{"Graphics", "[", 
              RowBox[{"Join", "[", "\n", "\t\t", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"color", ",", " ", 
                  RowBox[{"Thickness", "[", "lineThickness", "]"}]}], "}"}], 
                ",", "\n", "\t\t", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"customStyle", " ", "/.", " ", "system"}], ")"}], 
                 " ", "/.", " ", 
                 RowBox[{"(", 
                  RowBox[{"customStyle", " ", "->", " ", 
                   RowBox[{"{", "}"}]}], ")"}]}], ",", "\n", "\t\t", 
                RowBox[{"Line", " ", "/@", " ", 
                 RowBox[{"geometry", "[", 
                  RowBox[{"system", ",", " ", "iterations"}], "]"}]}]}], 
               "]"}], "]"}], ",", "\n", "\t", 
             RowBox[{"PlotRange", " ", "->", " ", 
              RowBox[{"(", 
               RowBox[{"plotRange", " ", "/.", " ", "system"}], ")"}]}], ",", 
             " ", 
             RowBox[{"ImageSize", " ", "->", " ", "imageSize"}]}], "]"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}]}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lsys2", "[", "n_", "]"}], ":=", 
    RowBox[{"lsys", "[", 
     RowBox[{"\"\<2\>\"", ",", "n"}], "]"}]}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.7224417584660263`*^9, 3.722441781802047*^9}, {
   3.7224435264948874`*^9, 3.722443565246273*^9}, {3.7224435978240843`*^9, 
   3.722443717033819*^9}, {3.722443750327053*^9, 3.722443757557909*^9}, {
   3.722443889119895*^9, 3.722443892370656*^9}, {3.722444161671647*^9, 
   3.7224442442491083`*^9}, {3.7224443079826307`*^9, 3.722444342838015*^9}, {
   3.7224445052164373`*^9, 3.722444506575569*^9}, {3.722444537703953*^9, 
   3.72244454730434*^9}, {3.7224446735539503`*^9, 3.722444693555243*^9}, {
   3.7224450411944237`*^9, 3.722445046208851*^9}, {3.722445204243272*^9, 
   3.722445235597788*^9}, {3.722445334882856*^9, 3.722445336895886*^9}, {
   3.722445380896925*^9, 3.722445406965266*^9}, {3.722445502457078*^9, 
   3.722445527502496*^9}, {3.722445661704979*^9, 3.722445693375348*^9}, 
   3.722445746837967*^9, {3.722446637563867*^9, 3.722446673227603*^9}, {
   3.726554993076985*^9, 
   3.726555017460642*^9}},ExpressionUUID->"c7b3bd70-46f9-4944-b3a5-\
5c909ea2153e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lsys", "[", 
  RowBox[{"\"\<2\>\"", ",", "\"\<2\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.722443659574349*^9, 3.7224436668592243`*^9}, {
   3.722443709634266*^9, 3.72244370973442*^9}, {3.7224437638154163`*^9, 
   3.7224437641299973`*^9}, {3.7224438196738453`*^9, 
   3.7224438204378777`*^9}, {3.722443905772914*^9, 3.722443922321883*^9}, {
   3.722444083775835*^9, 3.722444084224985*^9}, 3.7224441321985207`*^9, {
   3.7224443507703037`*^9, 3.72244435092659*^9}, {3.72244439782001*^9, 
   3.7224444085516853`*^9}, 3.722444518929162*^9, {3.7224445565172663`*^9, 
   3.7224446005169783`*^9}, {3.7224447035927763`*^9, 3.722444780590712*^9}, {
   3.7224448911710243`*^9, 3.722444896030787*^9}, 3.722444996755515*^9, {
   3.722445050880947*^9, 3.722445060342767*^9}, {3.7224451042863483`*^9, 
   3.7224451625631723`*^9}, {3.722445253680747*^9, 3.7224452659316187`*^9}, {
   3.722445300886444*^9, 3.7224453092795267`*^9}, 3.722445341848091*^9, {
   3.722445403782343*^9, 3.722445454002692*^9}, {3.722445532869491*^9, 
   3.722445589638176*^9}, {3.722445697496307*^9, 3.722445698034525*^9}, {
   3.72244577872344*^9, 3.722445793304069*^9}, {3.722446286328948*^9, 
   3.722446290064085*^9}, {3.72244647890471*^9, 3.722446484559325*^9}, {
   3.72244665742197*^9, 3.7224466610998907`*^9}, {3.726554722683237*^9, 
   3.726554723095038*^9}},ExpressionUUID->"9ee76762-2df2-48fa-9bb8-\
d596748c2bfa"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3QmUq3V9//GZu3C5bBdZpHAURAWVYtxai9WiOdZW6hIF3Gq6iBLqUhhB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    "], {{0, 462}, {489, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 2, 2, 10, 5, 23.}, "Instant", "Gregorian", 0.]]]],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{489, 462},
  PlotRange->{{0, 489}, {0, 462}}]], "Output",
 CellChangeTimes->{{3.7224436681241207`*^9, 3.7224437289722*^9}, 
   3.722443764508491*^9, 3.722443820844293*^9, {3.722443895850583*^9, 
   3.7224439226467*^9}, 3.7224440846047583`*^9, 3.722444132612821*^9, 
   3.722444210578184*^9, 3.722444248189938*^9, 3.722444316932572*^9, 
   3.722444351479704*^9, {3.722444398949667*^9, 3.722444408848851*^9}, {
   3.722444511890555*^9, 3.722444519329422*^9}, {3.7224445526619864`*^9, 
   3.7224446008244743`*^9}, {3.722444704713093*^9, 3.722444781021791*^9}, {
   3.722444891464568*^9, 3.722444896535407*^9}, {3.722444994154112*^9, 
   3.722444997351018*^9}, {3.722445048492783*^9, 3.722445062320463*^9}, {
   3.7224451135193663`*^9, 3.7224451644158497`*^9}, {3.7224452405884047`*^9, 
   3.722445309626655*^9}, {3.722445342269327*^9, 3.722445347136195*^9}, {
   3.722445393618793*^9, 3.722445454637879*^9}, {3.7224455310826817`*^9, 
   3.722445590136859*^9}, {3.7224456992982273`*^9, 3.7224457045087*^9}, {
   3.722445751395859*^9, 3.722445794647182*^9}, {3.722446286874196*^9, 
   3.722446290492242*^9}, 3.722446402784197*^9, {3.722446479414872*^9, 
   3.722446484799717*^9}, {3.7224466623761806`*^9, 3.7224466772245417`*^9}, 
   3.726554724278963*^9},ExpressionUUID->"f26e90b1-3870-4d65-b471-\
2967592b3431"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<type\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
            RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<10\>\""}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", 
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<1:Levy C Curve, 2:Sierpinski, 3:Hilbert, 4:Highway \
Dragon,5:Pinwheel Embroidery, 6:Koch Snowflake, 7:cesaro Curve, 8:Gosper \
Curve, 9:Penrose Tiling, 10:Plant\>\"", ",", "Blue"}], "]"}]}]}], "|>"}]}], 
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<iterations\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<1\>\""}], "|>"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<L-System Sampler\>\"", ",", "Orange", ",", " ", "Bold", ",", 
             
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"lsys", "[", 
       RowBox[{"#type", ",", "#iterations"}], "]"}], "&"}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722445640962592*^9, 3.722445653258436*^9}, {
   3.7224458912833633`*^9, 3.722445955995364*^9}, {3.7224460061272497`*^9, 
   3.722446216553644*^9}, {3.7224462578325977`*^9, 3.722446272501732*^9}, {
   3.722446570244418*^9, 3.722446628036056*^9}, 
   3.722446706486068*^9},ExpressionUUID->"ca93edda-5678-45be-a950-\
51cd467f6b39"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/c5d5e2dd-5e20-4bbf-a0d2-\
8bca7b2e2cf8\"",
     "https://www.wolframcloud.com/objects/c5d5e2dd-5e20-4bbf-a0d2-\
8bca7b2e2cf8"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/c5d5e2dd-5e20-4bbf-a0d2-8bca7b2e2cf8"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.722446220463262*^9, 3.722446313528014*^9, 3.7224464248285847`*^9, {
   3.722446573798546*^9, 3.7224465965301847`*^9}, 3.7224466802802143`*^9, 
   3.7224467317352867`*^9},ExpressionUUID->"9ce8ffb0-9039-4cb4-9409-\
e4776e2232fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{
       "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"\"\<iterations\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<1\>\""}], "|>"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<L-System: Sierpi\:0144ski arrowhead curve\>\"", ",", 
             "Orange", ",", " ", "Bold", ",", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"lsys2", "[", "#iterations", "]"}], "&"}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722445640962592*^9, 3.722445653258436*^9}, {
   3.7224458912833633`*^9, 3.722445955995364*^9}, {3.7224460061272497`*^9, 
   3.722446216553644*^9}, {3.7224462578325977`*^9, 3.722446272501732*^9}, {
   3.722446570244418*^9, 3.722446628036056*^9}, 3.722446706486068*^9, {
   3.7265549374457006`*^9, 
   3.726554985585188*^9}},ExpressionUUID->"642bc527-2c97-4372-b959-\
3bac3f3c915f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/119992e2-2296-4250-8acc-\
149c06252aef\"",
     "https://www.wolframcloud.com/objects/119992e2-2296-4250-8acc-\
149c06252aef"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/119992e2-2296-4250-8acc-149c06252aef"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.722446220463262*^9, 3.722446313528014*^9, 3.7224464248285847`*^9, {
   3.722446573798546*^9, 3.7224465965301847`*^9}, 3.7224466802802143`*^9, 
   3.7224467317352867`*^9, 3.726554957787258*^9, 
   3.726555030611279*^9},ExpressionUUID->"62529d9e-ff9b-480a-ae0c-\
9f7c18a43655"]
}, Open  ]]
},
WindowSize->{1061, 995},
WindowMargins->{{Automatic, 566}, {175, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1292, 32, 94, "Input",ExpressionUUID->"ccee5a14-2190-4c40-8063-f8c35b383272"],
Cell[1853, 54, 52423, 1119, 6100, "Input",ExpressionUUID->"c7b3bd70-46f9-4944-b3a5-5c909ea2153e"],
Cell[CellGroupData[{
Cell[54301, 1177, 1415, 21, 30, "Input",ExpressionUUID->"9ee76762-2df2-48fa-9bb8-d596748c2bfa"],
Cell[55719, 1200, 17574, 293, 479, "Output",ExpressionUUID->"f26e90b1-3870-4d65-b471-2967592b3431"]
}, Open  ]],
Cell[CellGroupData[{
Cell[73330, 1498, 2145, 47, 325, "Input",ExpressionUUID->"ca93edda-5678-45be-a950-51cd467f6b39"],
Cell[75478, 1547, 668, 16, 37, "Output",ExpressionUUID->"9ce8ffb0-9039-4cb4-9409-e4776e2232fb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76183, 1568, 1616, 36, 220, "Input",ExpressionUUID->"642bc527-2c97-4372-b959-3bac3f3c915f"],
Cell[77802, 1606, 716, 17, 37, "Output",ExpressionUUID->"62529d9e-ff9b-480a-ae0c-9f7c18a43655"]
}, Open  ]]
}
]
*)

