(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    166869,       3918]
NotebookOptionsPosition[    164162,       3864]
NotebookOutlinePosition[    164552,       3881]
CellTagsIndexPosition[    164509,       3878]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.726563774099002*^9, 3.7265638124328403`*^9}, 
   3.726564196402256*^9},ExpressionUUID->"9653b724-3bf1-40e3-99ec-\
5f1fc8f13b68"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"w", "=", 
  RowBox[{"StringSplit", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"SubstitutionSystem", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
         RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
       "\"\<A\>\"", ",", 
       RowBox[{"{", "2", "}"}]}], "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<\>\""}], "]"}]}]], "Input",
 CellChangeTimes->{{3.726592852112294*^9, 3.726592947120327*^9}, {
  3.7265929803872023`*^9, 3.72659298102745*^9}, {3.726595393238699*^9, 
  3.7265954071647987`*^9}},ExpressionUUID->"2f324d08-b3c3-4e56-908e-\
7ddce7b4ad3c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"A\"\>", ",", "\<\"+\"\>", ",", "\<\"B\"\>", ",", "\<\"+\"\>", 
   ",", "\<\"A\"\>", ",", "\<\"-\"\>", ",", "\<\"B\"\>", ",", "\<\"-\"\>", 
   ",", "\<\"A\"\>", ",", "\<\"-\"\>", ",", "\<\"B\"\>", ",", "\<\"-\"\>", 
   ",", "\<\"A\"\>", ",", "\<\"+\"\>", ",", "\<\"B\"\>", ",", "\<\"+\"\>", 
   ",", "\<\"A\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.726592866913328*^9, 3.7265929473466997`*^9}, 
   3.7265929813231773`*^9, 3.726594446181005*^9, {3.7265953935257387`*^9, 
   3.726595407934367*^9}},ExpressionUUID->"841d82f2-6755-4e06-b20c-\
7017fee9778a"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"lsysSierpinskiCurve", "[", 
     RowBox[{"n0_", ",", "\[Theta]0_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "history", ",", "\[Theta]", ",", "n", ",", "pts", ",", "pts0", ",", 
        "assoc", ",", "trans", ",", "w", ",", "w1", ",", "w1s", ",", "ctr", 
        ",", "w2", ",", "wspl", ",", "w2s", ",", "w3", ",", "w3s", ",", "w4", 
        ",", "ww2s", ",", "w4s", ",", "indices", ",", "history0"}], "}"}], 
      ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\[Theta]", "=", 
        RowBox[{"ToExpression", "@", "\[Theta]0"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"n", "=", 
        RowBox[{"ToExpression", "@", "n0"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"n", ">", "7"}], ",", 
         RowBox[{"n", "=", "7"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"history0", "=", 
        RowBox[{"SubstitutionSystem", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
            RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
          "\"\<A\>\"", ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"w", "=", 
        RowBox[{"StringSplit", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"SubstitutionSystem", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
               RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], 
             ",", "\"\<A\>\"", ",", 
             RowBox[{"{", "n", "}"}]}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pts", "=", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"trans", "=", 
        RowBox[{"RotationMatrix", "[", "0", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"assoc", ":=", 
        RowBox[{"<|", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<A\>\"", "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"pts", ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Last", "@", "pts"}], ")"}], "+", 
                RowBox[{"trans", ".", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}]}]}]}], "]"}], ";"}], ")"}]}],
           ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<B\>\"", "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"pts", ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Last", "@", "pts"}], ")"}], "+", 
                RowBox[{"trans", ".", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", "0"}], "}"}]}]}]}], "]"}], ";"}], ")"}]}],
           ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<+\>\"", "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"trans", "=", 
              RowBox[{
               RowBox[{"RotationMatrix", "[", "\[Theta]", "]"}], ".", 
               "trans"}]}], ";"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<-\>\"", "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"trans", "=", 
              RowBox[{
               RowBox[{"RotationMatrix", "[", 
                RowBox[{"-", "\[Theta]"}], "]"}], ".", "trans"}]}], ";"}], 
            ")"}]}]}], "\[IndentingNewLine]", "|>"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"assoc", "[", 
          RowBox[{"w", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "@", "w"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pts0", "=", "pts"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"split", "[", "w_", "]"}], ":=", 
        RowBox[{
         RowBox[{
          RowBox[{"StringSplit", "[", 
           RowBox[{
            RowBox[{"StringReplace", "[", 
             RowBox[{"#", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
                RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], 
             "]"}], ",", "\"\<\>\""}], "]"}], "&"}], "/@", "w"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"indices", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Subscript", "[", 
              RowBox[{"\"\<A\>\"", ",", "i"}], "]"}], "\[Rule]", 
             "\"\<A\>\""}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", "1000"}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Subscript", "[", 
              RowBox[{"\"\<B\>\"", ",", "i"}], "]"}], "\[Rule]", 
             "\"\<B\>\""}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Subscript", "[", 
              RowBox[{"\"\<+\>\"", ",", "i"}], "]"}], "\[Rule]", 
             "\"\<+\>\""}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}], ",", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Subscript", "[", 
              RowBox[{"\"\<-\>\"", ",", "i"}], "]"}], "\[Rule]", 
             "\"\<-\>\""}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"ctr", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"n", "=", "4"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"history", "=", 
        RowBox[{"SubstitutionSystem", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
            RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
          "\"\<A\>\"", ",", "n"}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"w1", "=", 
          RowBox[{"StringSplit", "[", 
           RowBox[{
            RowBox[{"StringReplace", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"SubstitutionSystem", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
                   RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}],
                  ",", "\"\<A\>\"", ",", 
                 RowBox[{"{", "1", "}"}]}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
                RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], 
             "]"}], ",", "\"\<\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"w1s", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"w1", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"ctr", "++"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}]}], "}"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"w2", "=", 
        RowBox[{"w1", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
           RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"wspl", "=", 
        RowBox[{"split", "[", "w2", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"w2s", "=", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"w1s", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
                RowBox[{
                 RowBox[{
                  RowBox[{"w1s", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}],
                ",", 
               RowBox[{
                RowBox[{"w1s", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"Subscript", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"wspl", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", 
                   RowBox[{"ctr", "++"}]}], "]"}], ")"}]}], ",", "Nothing"}], 
              "]"}], ",", " ", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "@", 
                RowBox[{"wspl", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "w1s"}]}], "}"}]}], "]"}]}]}], ";", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"w1s", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"Subscript", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"wspl", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", 
                 RowBox[{"ctr", "++"}]}], "]"}], ")"}]}], ",", " ", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "@", 
                RowBox[{"wspl", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "w1s"}]}], "}"}]}], "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"w3", "=", 
          RowBox[{"StringSplit", "[", 
           RowBox[{
            RowBox[{"StringReplace", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"SubstitutionSystem", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
                   RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}],
                  ",", "\"\<A\>\"", ",", 
                 RowBox[{"{", "2", "}"}]}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
                RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], 
             "]"}], ",", "\"\<\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"w3s", "=", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{"w3", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", 
              RowBox[{"ctr", "++"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{"Length", "@", "w3"}]}], "}"}]}], "]"}]}]}], "}"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"w4", "=", 
        RowBox[{"w3", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
           RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}]}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"wspl", "=", 
        RowBox[{"DeleteCases", "[", 
         RowBox[{
          RowBox[{"DeleteCases", "[", 
           RowBox[{
            RowBox[{"split", "[", "w4", "]"}], ",", 
            RowBox[{"{", "\"\<-\>\"", "}"}]}], "]"}], ",", 
          RowBox[{"{", "\"\<+\>\"", "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"ww2s", "=", 
        RowBox[{"w2s", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"ww2s", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"ww2s", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
             RowBox[{
              RowBox[{
               RowBox[{"ww2s", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}], 
            ",", 
            RowBox[{"ww2s", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "Nothing"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "@", "ww2s"}]}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"w4s", "=", 
        RowBox[{"Flatten", "@", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"ww2s", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ww2s", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}],
                ",", 
               RowBox[{
                RowBox[{"ww2s", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                RowBox[{"Subscript", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"wspl", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", 
                  RowBox[{"ctr", "++"}]}], "]"}]}], ",", "Nothing"}], "]"}], 
             ",", " ", 
             RowBox[{"{", 
              RowBox[{"j", ",", "1", ",", 
               RowBox[{"Length", "@", 
                RowBox[{"wspl", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "ww2s"}]}], "}"}]}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Column", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"Short", "[", 
                 RowBox[{"#", ",", "2"}], "]"}], ",", 
                RowBox[{"FontSize", "\[Rule]", "10"}]}], "]"}], "&"}], "/@", 
             "history0"}], ",", 
            RowBox[{"Background", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"LightOrange", ",", "LightGreen"}], "}"}], "}"}]}], 
            ",", 
            RowBox[{"Frame", "\[Rule]", "True"}], ",", 
            RowBox[{"Dividers", "\[Rule]", "All"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"Graphics", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Line", "[", "pts0", "]"}], ",", "Red", ",", 
              RowBox[{"Point", "[", 
               RowBox[{"First", "@", "pts0"}], "]"}]}], "}"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TreePlot", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Sequence", "@@", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"w1s", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Sequence", "@@", "w2s"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
             "Left", "\[IndentingNewLine]", ",", 
             RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
             RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
           "indices"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TreePlot", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Sequence", "@@", 
                RowBox[{"Table", "[", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"w1s", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Sequence", "@@", "w2s"}], ",", "\[IndentingNewLine]", 
               
               RowBox[{"Sequence", "@@", "w4s"}]}], "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
             "\[IndentingNewLine]", "Left", "\[IndentingNewLine]", ",", 
             RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
             RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "350"}]}], "]"}], "/.", 
           "indices"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "}"}]}]}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7267727357828903`*^9, 3.726772861552806*^9}, {
   3.726772895340108*^9, 3.7267729181076403`*^9}, {3.726773266559642*^9, 
   3.726773308063781*^9}, 3.726773347474258*^9, {3.7267733808529453`*^9, 
   3.7267733820027122`*^9}, {3.7267735869023447`*^9, 3.726773626535676*^9}, {
   3.7267737980706997`*^9, 3.72677380218476*^9}, {3.726774030755752*^9, 
   3.726774031013488*^9}, {3.726774097052805*^9, 3.726774134538127*^9}, {
   3.726774186007924*^9, 3.726774206764497*^9}, 3.72677425415287*^9, {
   3.726785776510262*^9, 
   3.726785810473282*^9}},ExpressionUUID->"9448508c-1b97-40f1-bb82-\
f765cf31c8eb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lsysSierpinskiCurve", "[", 
  RowBox[{"\"\<2\>\"", ",", "\"\<Pi/3\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.726772921864046*^9, 3.72677294237239*^9}, {
   3.726773812170377*^9, 3.726773823937702*^9}, 3.726773937093068*^9, {
   3.7267856964192266`*^9, 3.7267856969773493`*^9}, 3.7267857483689127`*^9, 
   3.726785801784554*^9},ExpressionUUID->"94fe4826-04c2-46c9-aaf2-\
056b9b0e6eba"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TagBox[GridBox[{
        {
         StyleBox[
          TagBox["\<\"A\"\>",
           Short[#, 2]& ],
          StripOnInput->False,
          FontSize->10]},
        {
         StyleBox[
          TagBox["\<\"B-A-B\"\>",
           Short[#, 2]& ],
          StripOnInput->False,
          FontSize->10]},
        {
         StyleBox[
          TagBox["\<\"A+B+A-B-A-B-A+B+A\"\>",
           Short[#, 2]& ],
          StripOnInput->False,
          FontSize->10]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxBackground->{"Columns" -> {{Automatic}}, "Rows" -> {{
            RGBColor[1, 0.9, 0.8], 
            RGBColor[0.88, 1, 0.88]}}},
       GridBoxDividers->{"Columns" -> {{True}}, "Rows" -> {{True}}},
       GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     GraphicsBox[{
       LineBox[NCache[{{0, 0}, {1, 0}, {
          Rational[3, 2], Rational[1, 2] 3^Rational[1, 2]}, {
          1, 3^Rational[1, 2]}, {
          Rational[3, 2], Rational[3, 2] 3^Rational[1, 2]}, {
          Rational[5, 2], Rational[3, 2] 3^Rational[1, 2]}, {
          3, 3^Rational[1, 2]}, {
          Rational[5, 2], Rational[1, 2] 3^Rational[1, 2]}, {3, 0}, {4, 
          0}}, {{0, 0}, {1, 0}, {1.5, 0.8660254037844386}, {
          1, 1.7320508075688772`}, {1.5, 2.598076211353316}, {2.5, 
          2.598076211353316}, {3, 1.7320508075688772`}, {2.5, 
          0.8660254037844386}, {3, 0}, {4, 0}}]], 
       {RGBColor[1, 0, 0], PointBox[{0, 0}]}},
      ImageSize->400]},
    {
     GraphicsBox[
      TagBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQNhG7zumaizO2w6aeD+ufSWfSuYfmW/EspXnZ5S
Wnbjs30nlB8OVd8E5UPEuRySoHx1sHphh6VQc2D2LITyu6Dq5qLwX9nPgtLq
UPumQfkQ83/ZT4Lyv9XW8ezoZHDoRVHP7NAJ5UdA3deKop8L6t5X9rseiW3Y
eITXoQ7FPAGHKii/r+ujg7ihkEMpivnCDoVQ/v7F11derRd1yEWxT9wBAGaS
oK8=
        "], {
         {RGBColor[0.5, 0., 0.], Arrowheads[{{0.021530857437587737`, 0.7}}], 
          ArrowBox[{1, 2}], ArrowBox[{1, 3}], ArrowBox[{1, 4}], 
          ArrowBox[{1, 5}], ArrowBox[{1, 6}], ArrowBox[{2, 7}], 
          ArrowBox[{2, 8}], ArrowBox[{2, 9}], ArrowBox[{2, 10}], 
          ArrowBox[{2, 11}], ArrowBox[{4, 12}], ArrowBox[{4, 13}], 
          ArrowBox[{4, 14}], ArrowBox[{4, 15}], ArrowBox[{4, 16}], 
          ArrowBox[{6, 17}], ArrowBox[{6, 18}], ArrowBox[{6, 19}], 
          ArrowBox[{6, 20}], ArrowBox[{6, 21}]}, {InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 1], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 2], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 3], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 4], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 5], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 6], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 7], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 8], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 9], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 10], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 11], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 12], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 13], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 14], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 15], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 16], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 17], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 18], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 19], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 20], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 21]}}],
       Annotation[#, VertexCoordinateRules -> CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQNhG7zumaizO2w6aeD+ufSWfSuYfmW/EspXnZ5S
Wnbjs30nlB8OVd8E5UPEuRySoHx1sHphh6VQc2D2LITyu6Dq5qLwX9nPgtLq
UPumQfkQ83/ZT4Lyv9XW8ezoZHDoRVHP7NAJ5UdA3deKop8L6t5X9rseiW3Y
eITXoQ7FPAGHKii/r+ujg7ihkEMpivnCDoVQ/v7F11derRd1yEWxT9wBAGaS
oK8=
         "]]& ],
      AspectRatio->2.645751311064586,
      FrameTicks->None,
      ImageSize->300,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {
     GraphicsBox[
      TagBox[GraphicsComplexBox[CompressedData["
1:eJxV0ktIVFEYB/CbZoho+CjHJqt5uikkyEwJOf+GqNEkyXFgILIYMsMejiSa
ryIbEDVkAnsMkUQRLnSjVOLK3LQQhAqKHoZDhBotMqkwcZHO/Z/Fd+Fy+HHP
vd/3/e+xB+sraxIMw/Cs3eurvub6mnsWz2Xjzsy/ti9lr9WNQ3/uJ95cVRG6
LL4aOEbr/UfooT0HggMXLNhAj80FLJH3DrTHHVOlXFu51k/9LS4PLagQ3cl6
l2hd7ywdiu9PRoBObx339VZkwE+/s7TsLq7KZH8xtcD+dN1h9qfoiSf7J/3X
tmMfbb5nw146f+hjbcG0DXm0nsdFR58XJc4HnLDSzl9jo56gG4OcS+f6lNa5
PRaOqUd0A9eH4vmiekBX+5Y/9Z/6raJi/7K6S4eZX79430CENvNJQJ/43kb0
0mZem9Atvp+MLnolqen7YEsKwqJeKjrptI5G7+lbm3Fd1E9HB63/V5voJxNX
aTPPLDSJ/rbgCm3muxUNot9sXKb1/70o+s9BHV14/kXGSuM21Ip5rKih9XkI
ivlycYb2zj4LjXTtQLWYdydO0m+tBba027sQEPPb4Kf1efKJPOw4QS95o+rr
GzuOi3wcKKf1+SsVeTlxlG4P5/ws+ezEYZGfCx4ajg+vfsy6AJGnGyV00st7
A9Fvbhyk5+P55uE/Ot4RRw==
        "], {
         {RGBColor[0.5, 0., 0.], Arrowheads[{{0.015777670002824522`, 0.7}}], 
          ArrowBox[{1, 2}], ArrowBox[{1, 3}], ArrowBox[{1, 4}], 
          ArrowBox[{1, 5}], ArrowBox[{1, 6}], ArrowBox[{2, 7}], 
          ArrowBox[{2, 8}], ArrowBox[{2, 9}], ArrowBox[{2, 10}], 
          ArrowBox[{2, 11}], ArrowBox[{4, 12}], ArrowBox[{4, 13}], 
          ArrowBox[{4, 14}], ArrowBox[{4, 15}], ArrowBox[{4, 16}], 
          ArrowBox[{6, 17}], ArrowBox[{6, 18}], ArrowBox[{6, 19}], 
          ArrowBox[{6, 20}], ArrowBox[{6, 21}], ArrowBox[{7, 22}], 
          ArrowBox[{7, 23}], ArrowBox[{7, 24}], ArrowBox[{7, 25}], 
          ArrowBox[{7, 26}], ArrowBox[{9, 27}], ArrowBox[{9, 28}], 
          ArrowBox[{9, 29}], ArrowBox[{9, 30}], ArrowBox[{9, 31}], 
          ArrowBox[{11, 32}], ArrowBox[{11, 33}], ArrowBox[{11, 34}], 
          ArrowBox[{11, 35}], ArrowBox[{11, 36}], ArrowBox[{12, 37}], 
          ArrowBox[{12, 38}], ArrowBox[{12, 39}], ArrowBox[{12, 40}], 
          ArrowBox[{12, 41}], ArrowBox[{14, 42}], ArrowBox[{14, 43}], 
          ArrowBox[{14, 44}], ArrowBox[{14, 45}], ArrowBox[{14, 46}], 
          ArrowBox[{16, 47}], ArrowBox[{16, 48}], ArrowBox[{16, 49}], 
          ArrowBox[{16, 50}], ArrowBox[{16, 51}], ArrowBox[{17, 52}], 
          ArrowBox[{17, 53}], ArrowBox[{17, 54}], ArrowBox[{17, 55}], 
          ArrowBox[{17, 56}], ArrowBox[{19, 57}], ArrowBox[{19, 58}], 
          ArrowBox[{19, 59}], ArrowBox[{19, 60}], ArrowBox[{19, 61}], 
          ArrowBox[{21, 62}], ArrowBox[{21, 63}], ArrowBox[{21, 64}], 
          ArrowBox[{21, 65}], ArrowBox[{21, 66}]}, {InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 1], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 2], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 3], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 4], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 5], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 6], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 7], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 8], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 9], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 10], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 11], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 12], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 13], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 14], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 15], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 16], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 17], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 18], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 19], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 20], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 21], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 22], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 23], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 24], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 25], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 26], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 27], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 28], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 29], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 30], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 31], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 32], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 33], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 34], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 35], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 36], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 37], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 38], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 39], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 40], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 41], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 42], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 43], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 44], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 45], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 46], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 47], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 48], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 49], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 50], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 51], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 52], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 53], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 54], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 55], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 56], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 57], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 58], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 59], InsetBox[
           FrameBox["\<\"+\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 60], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 61], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 62], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 63], InsetBox[
           FrameBox["\<\"A\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 64], InsetBox[
           FrameBox["\<\"-\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 65], InsetBox[
           FrameBox["\<\"B\"\>",
            Background->RGBColor[1, 1, 0.8],
            FrameStyle->RGBColor[0.94, 0.85, 0.36],
            StripOnInput->False], 66]}}],
       Annotation[#, VertexCoordinateRules -> CompressedData["
1:eJxV0ktIVFEYB/CbZoho+CjHJqt5uikkyEwJOf+GqNEkyXFgILIYMsMejiSa
ryIbEDVkAnsMkUQRLnSjVOLK3LQQhAqKHoZDhBotMqkwcZHO/Z/Fd+Fy+HHP
vd/3/e+xB+sraxIMw/Cs3eurvub6mnsWz2Xjzsy/ti9lr9WNQ3/uJ95cVRG6
LL4aOEbr/UfooT0HggMXLNhAj80FLJH3DrTHHVOlXFu51k/9LS4PLagQ3cl6
l2hd7ywdiu9PRoBObx339VZkwE+/s7TsLq7KZH8xtcD+dN1h9qfoiSf7J/3X
tmMfbb5nw146f+hjbcG0DXm0nsdFR58XJc4HnLDSzl9jo56gG4OcS+f6lNa5
PRaOqUd0A9eH4vmiekBX+5Y/9Z/6raJi/7K6S4eZX79430CENvNJQJ/43kb0
0mZem9Atvp+MLnolqen7YEsKwqJeKjrptI5G7+lbm3Fd1E9HB63/V5voJxNX
aTPPLDSJ/rbgCm3muxUNot9sXKb1/70o+s9BHV14/kXGSuM21Ip5rKih9XkI
ivlycYb2zj4LjXTtQLWYdydO0m+tBba027sQEPPb4Kf1efKJPOw4QS95o+rr
GzuOi3wcKKf1+SsVeTlxlG4P5/ws+ezEYZGfCx4ajg+vfsy6AJGnGyV00st7
A9Fvbhyk5+P55uE/Ot4RRw==
         "]]& ],
      AspectRatio->3.829708431025337,
      FrameTicks->None,
      ImageSize->350,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.726772929862385*^9, 3.726772943388729*^9}, 
   3.726773313063046*^9, 3.726773354854516*^9, 3.726773387327845*^9, 
   3.7267736435623493`*^9, {3.726773808950758*^9, 3.7267738248013287`*^9}, 
   3.726773899334755*^9, 3.7267739378404713`*^9, 3.726773971917511*^9, 
   3.7267741392804737`*^9, 3.7267743717994328`*^9, 3.72678569794287*^9, 
   3.7267857490705976`*^9, {3.726785798296989*^9, 
   3.7267858025258703`*^9}},ExpressionUUID->"4f73fdc6-cd3a-4d78-9cb1-\
b9ba94e2fd30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormFunction", "@@", 
    RowBox[{"APIFunction", "[", 
     RowBox[{
      RowBox[{
      "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\"\<n\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<2\>\""}], "|>"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\"\<angle\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<Pi/3\>\""}], "|>"}]}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{
       RowBox[{"lsysSierpinskiCurve", "[", 
        RowBox[{"#n", ",", "#angle"}], "]"}], "&"}], ",", "\"\<PDF\>\"", ",", 
      
      RowBox[{"AppearanceRules", "\[Rule]", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<L-System: Sierpinski arrowhead curve \>\"", ",", "Orange", 
            ",", " ", "Bold", ",", 
            RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", 
         RowBox[{"\"\<Description\>\"", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Geometrical Rendering of Sierpinski arrowhead curve \>\"", 
            ",", "Bold", ",", "Orange"}], "]"}]}], ",", 
         RowBox[{
         "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
        "|>"}]}]}], "]"}]}], ",", " ", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.726772982030739*^9, 3.7267730751369267`*^9}, {
   3.726773435998907*^9, 3.7267734379663486`*^9}, 3.726773715195509*^9, {
   3.7267747250245037`*^9, 
   3.726774737218636*^9}},ExpressionUUID->"1ec82d63-ee1d-4511-ae2e-\
66f01c585bf6"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/5a70b4b4-6bec-4268-9bb2-\
d8437eb00b03\"",
     "https://www.wolframcloud.com/objects/5a70b4b4-6bec-4268-9bb2-\
d8437eb00b03"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/5a70b4b4-6bec-4268-9bb2-d8437eb00b03"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.726773077969866*^9, 3.726773396314848*^9, 3.726773684147641*^9, 
   3.726773717490197*^9, {3.726773875869926*^9, 3.7267739058652267`*^9}, 
   3.726773976145527*^9, 3.7267741444712152`*^9, 3.726774378611536*^9, 
   3.726774738373207*^9, 
   3.726785821842473*^9},ExpressionUUID->"303bcb0f-f8a1-4a58-81a4-\
0b70f36601ac"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"lsysGEO", "[", 
      RowBox[{"s0_", ",", "\[Theta]0_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "l", ",", "w", ",", "\[Theta]", ",", "pts", ",", "trans", ",", 
         "assoc", ",", "t", ",", "pts2", ",", "lastpoint", ",", "ctr", ",", 
         "sign", ",", "tmp", ",", "pts3"}], "}"}], ",", "\[IndentingNewLine]",
        "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"myVEC", "[", "v_", "]"}], ":=", 
         RowBox[{"TraditionalForm", "@", 
          RowBox[{"Row", "@", 
           RowBox[{"{", 
            RowBox[{"\"\<(\>\"", ",", 
             RowBox[{"Sequence", "@@", 
              RowBox[{"Riffle", "[", 
               RowBox[{"v", ",", "\"\<,\>\""}], "]"}]}], ",", "\"\<)\>\""}], 
            "}"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"assoc", ":=", 
         RowBox[{"<|", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<A\>\"", "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"pts", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"Last", "@", "pts"}], ")"}], "+", 
                 RowBox[{"trans", ".", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}]}]}]}], "]"}], ";"}], 
             ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<B\>\"", "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"AppendTo", "[", 
               RowBox[{"pts", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"Last", "@", "pts"}], ")"}], "+", 
                 RowBox[{"trans", ".", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}]}]}]}], "]"}], ";"}], 
             ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<+\>\"", "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"trans", "=", 
               RowBox[{
                RowBox[{"RotationMatrix", "[", "\[Theta]", "]"}], ".", 
                "trans"}]}], ";"}], ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<-\>\"", "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"trans", "=", 
               RowBox[{
                RowBox[{"RotationMatrix", "[", 
                 RowBox[{"-", "\[Theta]"}], "]"}], ".", "trans"}]}], ";"}], 
             ")"}]}]}], "\[IndentingNewLine]", "|>"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"l", "=", 
         RowBox[{"w", "=", 
          RowBox[{"StringSplit", "[", 
           RowBox[{"s0", ",", "\"\<\>\""}], "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Theta]", "=", 
         RowBox[{"ToExpression", "@", "\[Theta]0"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pts", "=", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"trans", "=", 
         RowBox[{"RotationMatrix", "[", "0", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"w", "=", 
           RowBox[{"StringSplit", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"SubstitutionSystem", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], 
                ",", "\"\<A\>\"", ",", 
                RowBox[{"{", "1", "}"}]}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<\>\""}], "]"}]}], 
          ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"assoc", "[", 
           RowBox[{"w", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "@", "w"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pts2", "=", "pts"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"trans", "=", 
         RowBox[{"RotationMatrix", "[", "0", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"pts", "=", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"lastpoint", "=", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"t", "=", "0.3"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ctr", "=", "1"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Column", "@", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Which", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], ",", 
             RowBox[{
              RowBox[{"ctr", "++"}], ";", " ", 
              RowBox[{"Column", "@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Highlighted", "@", "\"\<A\>\""}], ",", 
                    "\"\<: Draw Line:\>\"", ",", 
                    RowBox[{"myVEC", "@", "lastpoint"}], ",", "\"\< to \>\"", 
                    ",", 
                    RowBox[{"MatrixForm", "@", "trans"}], ",", "\"\<\>\"", 
                    ",", 
                    RowBox[{"MatrixForm", "@", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "}"}], "]"}]}], ",", 
                    "\"\<=\>\"", ",", " ", 
                    RowBox[{"Superscript", "[", 
                    RowBox[{
                    RowBox[{"myVEC", "@", 
                    RowBox[{"(", 
                    RowBox[{"trans", ".", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], ")"}]}], ",", 
                    "\"\<T\>\""}], "]"}], ",", "\"\<;\>\"", ",", 
                    "\"\<LastPoint\>\"", ",", "\"\<=\>\"", ",", 
                    RowBox[{
                    RowBox[{"lastpoint", "=", 
                    RowBox[{"lastpoint", "+", 
                    RowBox[{"trans", ".", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}]}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"myVEC", "@", "lastpoint"}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightOrange"}]}], 
                    "]"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Graphics", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Line", "[", 
                    RowBox[{"Take", "[", 
                    RowBox[{"pts2", ",", "ctr"}], "]"}], "]"}], ",", "Red", 
                    ",", 
                    RowBox[{"Point", "[", 
                    RowBox[{"First", "@", "pts2"}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "Red", ",", 
                    "Dashed", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ctr", ">", "2"}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "=", 
                    RowBox[{"Take", "[", 
                    RowBox[{"pts2", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ctr", "-", "2"}], ",", "ctr"}], "}"}]}], "]"}]}],
                     ";", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}]}], "}"}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ctr", ">", "2"}], ",", 
                    RowBox[{"Text", "[", 
                    RowBox[{
                    RowBox[{"sign", "*", "\"\<\[Theta]\>\""}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"0.3", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ")"}], "+", 
                    RowBox[{"(", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}], ")"}]}], 
                    ")"}]}]}]}], "]"}], ",", "Nothing"}], "]"}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
                   
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"200", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
                   RowBox[{"PlotLabel", "\[Rule]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"Take", "[", 
                    RowBox[{"w", ",", "i"}], "]"}]}]}]}], "]"}]}], "}"}]}]}], 
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}], ",", 
             RowBox[{
              RowBox[{"ctr", "++"}], ";", "  ", 
              RowBox[{"Column", "@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Highlighted", "@", "\"\<A\>\""}], ",", 
                    "\"\<: Draw Line:\>\"", ",", 
                    RowBox[{"myVEC", "@", "lastpoint"}], ",", "\"\< to \>\"", 
                    ",", 
                    RowBox[{"MatrixForm", "@", "trans"}], ",", "\"\<\>\"", 
                    ",", 
                    RowBox[{"MatrixForm", "@", 
                    RowBox[{"Transpose", "[", 
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], "}"}], "]"}]}], ",", 
                    "\"\<=\>\"", ",", " ", 
                    RowBox[{"Superscript", "[", 
                    RowBox[{
                    RowBox[{"myVEC", "@", 
                    RowBox[{"(", 
                    RowBox[{"trans", ".", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], ")"}]}], ",", 
                    "\"\<T\>\""}], "]"}], ",", "\"\<;\>\"", ",", 
                    "\"\<LastPoint\>\"", ",", "\"\<=\>\"", ",", 
                    RowBox[{
                    RowBox[{"lastpoint", "=", 
                    RowBox[{"lastpoint", "+", 
                    RowBox[{"trans", ".", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}]}]}], ";", 
                    RowBox[{"Highlighted", "[", 
                    RowBox[{
                    RowBox[{"myVEC", "@", "lastpoint"}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightOrange"}]}], 
                    "]"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Graphics", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Line", "[", 
                    RowBox[{"Take", "[", 
                    RowBox[{"pts2", ",", "ctr"}], "]"}], "]"}], ",", "Red", 
                    ",", 
                    RowBox[{"Point", "[", 
                    RowBox[{"First", "@", "pts2"}], "]"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "Red", ",", 
                    "Dashed", ",", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ctr", ">", "2"}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "=", 
                    RowBox[{"Take", "[", 
                    RowBox[{"pts2", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ctr", "-", "2"}], ",", "ctr"}], "}"}]}], "]"}]}],
                     ";", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}]}], "}"}], 
                    "]"}]}], ",", "Nothing"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"ctr", ">", "2"}], ",", 
                    RowBox[{"Text", "[", 
                    RowBox[{
                    RowBox[{"sign", "*", "\"\<\[Theta]\>\""}], ",", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"0.3", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ")"}], "+", 
                    RowBox[{"(", 
                    RowBox[{"t", "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "-", 
                    RowBox[{"pts3", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ")"}]}], ")"}]}], 
                    ")"}]}]}]}], "]"}], ",", "Nothing"}], "]"}]}], 
                    "\[IndentingNewLine]", "}"}], ",", 
                   RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"200", ",", "200"}], "}"}]}], ",", 
                   RowBox[{"Frame", "\[Rule]", "True"}], ",", 
                   RowBox[{"PlotLabel", "\[Rule]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"Take", "[", 
                    RowBox[{"w", ",", "i"}], "]"}]}]}]}], "]"}]}], "}"}]}]}], 
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "\"\<+\>\""}], ",", 
             RowBox[{
              RowBox[{"sign", "=", "1"}], ";", " ", 
              RowBox[{"tmp", "=", "trans"}], ";", 
              RowBox[{"trans", "=", 
               RowBox[{
                RowBox[{"RotationMatrix", "[", "\[Theta]", "]"}], ".", 
                "trans"}]}], ";", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Highlighted", "@", "\"\<+\>\""}], ",", 
                 "\"\<: Set rotation to \>\"", ",", 
                 RowBox[{"MatrixForm", "@", 
                  RowBox[{"RotationMatrix", "[", "\[Theta]", "]"}]}], ",", 
                 RowBox[{"MatrixForm", "@", "tmp"}], ",", "\"\<=\>\"", ",", 
                 RowBox[{"Highlighted", "[", " ", 
                  RowBox[{
                   RowBox[{"MatrixForm", "@", "trans"}], ",", 
                   RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}],
                 "}"}]}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"l", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "\[Equal]", "\"\<-\>\""}], ",", 
             RowBox[{
              RowBox[{"sign", "=", 
               RowBox[{"-", "1"}]}], ";", " ", 
              RowBox[{"tmp", "=", "trans"}], ";", 
              RowBox[{"trans", "=", 
               RowBox[{
                RowBox[{"RotationMatrix", "[", "\[Theta]", "]"}], ".", 
                "trans"}]}], ";", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Highlighted", "@", "\"\<-\>\""}], ",", 
                 "\"\<: Set rotation to \>\"", ",", 
                 RowBox[{"MatrixForm", "@", 
                  RowBox[{"RotationMatrix", "[", 
                   RowBox[{"-", "\[Theta]"}], "]"}]}], ",", 
                 RowBox[{"MatrixForm", "@", "tmp"}], ",", "\"\<=\>\"", ",", 
                 " ", 
                 RowBox[{"Highlighted", "[", " ", 
                  RowBox[{
                   RowBox[{"MatrixForm", "@", "trans"}], ",", 
                   RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}],
                 "}"}]}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]",
              "True", ",", "Nothing"}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "l"}]}], "}"}]}], "]"}]}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.7267514941032887`*^9, 3.726751515252926*^9}, 
   3.726753772027293*^9, {3.7267697633301287`*^9, 3.726769783377379*^9}, {
   3.726769948688531*^9, 3.726770111309765*^9}, {3.726771007076236*^9, 
   3.726771057747458*^9}, {3.726771087966227*^9, 3.7267710904410458`*^9}, {
   3.726771578707559*^9, 3.726771582655127*^9}, {3.726771628897711*^9, 
   3.726771629996179*^9}, {3.72677177652055*^9, 3.726771832061252*^9}, {
   3.726772351044788*^9, 3.7267723513246937`*^9}, {3.726774487680369*^9, 
   3.726774515693932*^9}},ExpressionUUID->"6e5ade19-2f9f-47b3-a9a8-\
3d95ed1d03c9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lsysGEO", "[", 
  RowBox[{"\"\<A+B+A-B-A-B-A+B+A\>\"", ",", "\"\<Pi/4\>\""}], "]"}]], "Input",\

 CellChangeTimes->{{3.72677012466052*^9, 3.726770146552793*^9}, 
   3.726772324212734*^9, 
   3.72677447602498*^9},ExpressionUUID->"96319fa9-8b4a-4c7f-84cc-\
023cdc4379d4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, "RowDefault"],
              TraditionalForm], TraditionalForm, Editable -> True],"\" to \"",
           TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1", "0"}, {"0", "1"}}, RowSpacings -> 1, 
               ColumnSpacings -> 1, RowAlignments -> Baseline, 
               ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "1", "\",\"", "0", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], "\"T\""}, "Superscript", SyntaxForm -> SuperscriptBox],
           "\";\"","\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "1", "\",\"", "0", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], FrameStyle -> None, Background -> RGBColor[1, 0.9, 0.8]},
             "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{LineBox[{{0, 0}, {1, 0}}], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            TemplateBox[{"\"A\""}, "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"+\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          
          GridBox[{{"1", "0"}, {"0", "1"}}, RowSpacings -> 1, ColumnSpacings -> 
           1, RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{
               FractionBox["1", 
                SqrtBox["2"]], 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}]}, {
               FractionBox["1", 
                SqrtBox["2"]], 
               FractionBox["1", 
                SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
             RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", "1", "\",\"", "0", "\")\""}, "RowDefault"],
              TraditionalForm], TraditionalForm, Editable -> True],"\" to \"",
           TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{
                 FractionBox["1", 
                  SqrtBox["2"]], 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}]}, {
                 FractionBox["1", 
                  SqrtBox["2"]], 
                 FractionBox["1", 
                  SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 FractionBox["1", 
                  SqrtBox["2"]], "\",\"", 
                 FractionBox["1", 
                  SqrtBox["2"]], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], "\"T\""}, "Superscript", 
            SyntaxForm -> SuperscriptBox],"\";\"","\"LastPoint\"","\"=\"",
           TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"1", "+", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 FractionBox["1", 
                  SqrtBox["2"]], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], FrameStyle -> None, 
             Background -> RGBColor[1, 0.9, 0.8]}, "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}}, {{0, 0}, {1, 0}, {
              1.7071067811865475`, 0.7071067811865475}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[{{1, 0}, {1.3, 0.}}], 
            InsetBox["\<\"\[Theta]\"\>", \
{1.1536396103067892, 0.06363961030678926}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            TemplateBox[{"\"A\"", "\"+\"", "\"B\""}, "RowDefault"], 
            TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"+\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{"0", 
               RowBox[{"-", "1"}]}, {"1", "0"}}, RowSpacings -> 1, 
             ColumnSpacings -> 1, RowAlignments -> Baseline, ColumnAlignments -> 
             Center], "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", 
               RowBox[{"1", "+", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], "\",\"", 
               FractionBox["1", 
                SqrtBox["2"]], "\")\""}, "RowDefault"], TraditionalForm], 
            TraditionalForm, Editable -> True],"\" to \"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{"0", 
                 RowBox[{"-", "1"}]}, {"1", "0"}}, RowSpacings -> 1, 
               ColumnSpacings -> 1, RowAlignments -> Baseline, 
               ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "0", "\",\"", "1", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], "\"T\""}, "Superscript", SyntaxForm -> SuperscriptBox],
           "\";\"","\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"1", "+", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 RowBox[{"1", "+", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], 
             FrameStyle -> None, Background -> RGBColor[1, 0.9, 0.8]}, 
            "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}}, {{0, 0}, {1, 
              0}, {1.7071067811865475`, 0.7071067811865475}, {
              1.7071067811865475`, 1.7071067811865475`}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
               1.9192388155425117`, 0.9192388155425117}}, {{
              1.7071067811865475`, 0.7071067811865475}, {1.9192388155425117`, 
              0.9192388155425117}}]], 
            InsetBox["\<\"\[Theta]\"\>", \
{1.7707463914933368, 0.8607463914933368}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{"\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\""}, 
             "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"-\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{"0", 
             RowBox[{"-", "1"}]}, {"1", "0"}}, RowSpacings -> 1, 
           ColumnSpacings -> 1, RowAlignments -> Baseline, ColumnAlignments -> 
           Center], "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}]}, {
               FractionBox["1", 
                SqrtBox["2"]], 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
             RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", 
               RowBox[{"1", "+", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], "\",\"", 
               RowBox[{"1", "+", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], "\")\""}, "RowDefault"], TraditionalForm], 
            TraditionalForm, Editable -> True],"\" to \"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}]}, {
                 FractionBox["1", 
                  SqrtBox["2"]], 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 FractionBox["1", 
                  SqrtBox["2"]], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], "\"T\""}, "Superscript", 
            SyntaxForm -> SuperscriptBox],"\";\"","\"LastPoint\"","\"=\"",
           TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", "1", "\",\"", 
                 RowBox[{"1", "+", 
                   SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], FrameStyle -> None, 
             Background -> RGBColor[1, 0.9, 0.8]}, "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}}, {{0, 0}, {1, 0}, {
              1.7071067811865475`, 0.7071067811865475}, {1.7071067811865475`, 
              1.7071067811865475`}, {2.414213562373095, 2.414213562373095}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
               1.7071067811865475`, 2.0071067811865477`}}, {{
              1.7071067811865475`, 1.7071067811865475`}, {1.7071067811865475`,
               2.0071067811865477`}}]], InsetBox[
             RowBox[{
             "-", "\<\"\[Theta]\"\>"}], \
{1.7707463914933368, 1.8607463914933366}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\""}, 
             "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"-\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{
               RowBox[{"-", "1"}], "0"}, {"0", 
               RowBox[{"-", "1"}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
             RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", "1", "\",\"", 
               RowBox[{"1", "+", 
                 SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
            TraditionalForm, Editable -> True],"\" to \"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{
                 RowBox[{"-", "1"}], "0"}, {"0", 
                 RowBox[{"-", "1"}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"-", "1"}], "\",\"", "0", "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], "\"T\""},
             "Superscript", SyntaxForm -> SuperscriptBox],"\";\"",
           "\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", "0", "\",\"", 
                 RowBox[{"1", "+", 
                   SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], FrameStyle -> None, 
             Background -> RGBColor[1, 0.9, 0.8]}, "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}}, {{0, 0}, {1, 0}, {
              1.7071067811865475`, 0.7071067811865475}, {1.7071067811865475`, 
              1.7071067811865475`}, {2.414213562373095, 2.414213562373095}, {
              3.414213562373095, 2.414213562373095}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
               2.6263455967290597`, 2.6263455967290597`}}, {{
              2.414213562373095, 2.414213562373095}, {2.6263455967290597`, 
              2.6263455967290597`}}]], InsetBox[
             RowBox[{
             "-", "\<\"\[Theta]\"\>"}], \
{2.567853172679884, 2.4778531726798843}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\"", 
              "\"-\"", "\"A\""}, "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"-\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             RowBox[{"-", "1"}], "0"}, {"0", 
             RowBox[{"-", "1"}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], 
               FractionBox["1", 
                SqrtBox["2"]]}, {
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
             RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", "0", "\",\"", 
               RowBox[{"1", "+", 
                 SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
            TraditionalForm, Editable -> True],"\" to \"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], 
                 FractionBox["1", 
                  SqrtBox["2"]]}, {
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], "\"T\""},
             "Superscript", SyntaxForm -> SuperscriptBox],"\";\"",
           "\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 RowBox[{"1", "-", 
                   FractionBox["1", 
                    SqrtBox["2"]], "+", 
                   SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
              TraditionalForm, Editable -> True], FrameStyle -> None, 
             Background -> RGBColor[1, 0.9, 0.8]}, "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], 1 - 2^Rational[-1, 2] + 
               2^Rational[1, 2]}}, {{0, 0}, {1, 0}, {1.7071067811865475`, 
              0.7071067811865475}, {1.7071067811865475`, 
              1.7071067811865475`}, {2.414213562373095, 2.414213562373095}, {
              3.414213562373095, 2.414213562373095}, {4.121320343559643, 
              1.7071067811865477`}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
               3.7142135623730947`, 2.414213562373095}}, {{3.414213562373095, 
              2.414213562373095}, {3.7142135623730947`, 2.414213562373095}}]],
             InsetBox[
             RowBox[{
             "-", "\<\"\[Theta]\"\>"}], \
{3.567853172679884, 2.350573952066306}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\"", 
              "\"-\"", "\"A\"", "\"-\"", "\"B\""}, "RowDefault"], 
            TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"-\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{"0", "1"}, {
               RowBox[{"-", "1"}], "0"}}, RowSpacings -> 1, ColumnSpacings -> 
             1, RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], "\",\"", 
               RowBox[{"1", "-", 
                 FractionBox["1", 
                  SqrtBox["2"]], "+", 
                 SqrtBox["2"]}], "\")\""}, "RowDefault"], TraditionalForm], 
            TraditionalForm, Editable -> True],"\" to \"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{"0", "1"}, {
                 RowBox[{"-", "1"}], "0"}}, RowSpacings -> 1, ColumnSpacings -> 
               1, RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", "0", "\",\"", 
                 RowBox[{"-", "1"}], "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], "\"T\""},
             "Superscript", SyntaxForm -> SuperscriptBox],"\";\"",
           "\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\",\"", 
                 RowBox[{
                   SqrtBox["2"], "-", 
                   RowBox[{
                    FractionBox["1", 
                    SqrtBox["2"]]}]}], "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], 
             FrameStyle -> None, Background -> RGBColor[1, 0.9, 0.8]}, 
            "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], 1 - 2^Rational[-1, 2] + 
               2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], -2^Rational[-1, 2] + 
               2^Rational[1, 2]}}, {{0, 0}, {1, 0}, {1.7071067811865475`, 
              0.7071067811865475}, {1.7071067811865475`, 
              1.7071067811865475`}, {2.414213562373095, 2.414213562373095}, {
              3.414213562373095, 2.414213562373095}, {4.121320343559643, 
              1.7071067811865477`}, {4.121320343559643, 
              0.7071067811865477}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{
               2 + 2^Rational[-1, 2] + 2^Rational[1, 2], 1 - 2^
                Rational[-1, 2] + 2^Rational[1, 2]}, {4.333452377915607, 
               1.4949747468305834`}}, {{4.121320343559643, 
              1.7071067811865477`}, {4.333452377915607, 
              1.4949747468305834`}}]], InsetBox[
             RowBox[{
             "-", "\<\"\[Theta]\"\>"}], \
{4.184959953866432, 1.5534671708797583}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\"", 
              "\"-\"", "\"A\"", "\"-\"", "\"B\"", "\"-\"", "\"A\""}, 
             "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"+\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{"0", "1"}, {
             RowBox[{"-", "1"}], "0"}}, RowSpacings -> 1, ColumnSpacings -> 1,
            RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            GridBox[{{
               FractionBox["1", 
                SqrtBox["2"]], 
               FractionBox["1", 
                SqrtBox["2"]]}, {
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], 
               FractionBox["1", 
                SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
             RowAlignments -> Baseline, ColumnAlignments -> Center], 
            "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", 
               RowBox[{"-", 
                 FractionBox["1", 
                  SqrtBox["2"]]}], "\",\"", 
               RowBox[{
                 SqrtBox["2"], "-", 
                 RowBox[{
                   FractionBox["1", 
                    SqrtBox["2"]]}]}], "\")\""}, "RowDefault"], 
             TraditionalForm], TraditionalForm, Editable -> True],"\" to \"",
           TagBox[
            RowBox[{"(", "\[NoBreak]", 
              GridBox[{{
                 FractionBox["1", 
                  SqrtBox["2"]], 
                 FractionBox["1", 
                  SqrtBox["2"]]}, {
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], 
                 FractionBox["1", 
                  SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               TemplateBox[{"\"(\"", 
                 FractionBox["1", 
                  SqrtBox["2"]], "\",\"", 
                 RowBox[{"-", 
                   FractionBox["1", 
                    SqrtBox["2"]]}], "\")\""}, "RowDefault"], 
               TraditionalForm], TraditionalForm, Editable -> True], "\"T\""},
             "Superscript", SyntaxForm -> SuperscriptBox],"\";\"",
           "\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], FrameStyle -> None, Background -> RGBColor[1, 0.9, 0.8]},
             "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], 1 - 2^Rational[-1, 2] + 
               2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], -2^Rational[-1, 2] + 
               2^Rational[1, 2]}, {2 + 2 2^Rational[1, 2], 0}}, {{0, 0}, {1, 
              0}, {1.7071067811865475`, 0.7071067811865475}, {
              1.7071067811865475`, 1.7071067811865475`}, {2.414213562373095, 
              2.414213562373095}, {3.414213562373095, 2.414213562373095}, {
              4.121320343559643, 1.7071067811865477`}, {4.121320343559643, 
              0.7071067811865477}, {4.82842712474619, 0}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{
               2 + 2^Rational[-1, 2] + 2^Rational[1, 2], -2^Rational[-1, 2] + 
                2^Rational[1, 2]}, {4.121320343559643, 
               0.40710678118654764`}}, {{4.121320343559643, 
              0.7071067811865477}, {4.121320343559643, 
              0.40710678118654764`}}]], 
            InsetBox["\<\"\[Theta]\"\>", \
{4.184959953866432, 0.5534671708797584}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\"", 
              "\"-\"", "\"A\"", "\"-\"", "\"B\"", "\"-\"", "\"A\"", "\"+\"", 
              "\"B\""}, "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]},
    {
     TemplateBox[{
      TemplateBox[{"\"+\"", FrameStyle -> None}, "Highlighted"],
       "\": Set rotation to \"",TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}, {
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],TagBox[
        RowBox[{"(", "\[NoBreak]", 
          GridBox[{{
             FractionBox["1", 
              SqrtBox["2"]], 
             FractionBox["1", 
              SqrtBox["2"]]}, {
             RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], 
             FractionBox["1", 
              SqrtBox["2"]]}}, RowSpacings -> 1, ColumnSpacings -> 1, 
           RowAlignments -> Baseline, ColumnAlignments -> Center], 
          "\[NoBreak]", ")"}], 
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
         TagBox[
          RowBox[{"(", "\[NoBreak]", 
            
            GridBox[{{"1", "0"}, {"0", "1"}}, RowSpacings -> 1, 
             ColumnSpacings -> 1, RowAlignments -> Baseline, ColumnAlignments -> 
             Center], "\[NoBreak]", ")"}], 
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]], FrameStyle -> None, Background -> 
         RGBColor[0.88, 1, 0.88]}, "Highlighted"]},
      "RowDefault"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          TemplateBox[{"\"A\"", FrameStyle -> None}, "Highlighted"],
           "\": Draw Line:\"",TagBox[
            FormBox[
             TemplateBox[{"\"(\"", "0", "\",\"", "0", "\")\""}, "RowDefault"],
              TraditionalForm], TraditionalForm, Editable -> True],"\" to \"",
           TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1", "0"}, {"0", "1"}}, RowSpacings -> 1, 
               ColumnSpacings -> 1, RowAlignments -> Baseline, 
               ColumnAlignments -> Center], "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"\"",TagBox[
            RowBox[{"(", "\[NoBreak]", 
              
              GridBox[{{"1"}, {"0"}}, RowSpacings -> 1, ColumnSpacings -> 1, 
               RowAlignments -> Baseline, ColumnAlignments -> Center], 
              "\[NoBreak]", ")"}], 
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]],"\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "1", "\",\"", "0", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], "\"T\""}, "Superscript", SyntaxForm -> SuperscriptBox],
           "\";\"","\"LastPoint\"","\"=\"",TemplateBox[{
             TagBox[
              FormBox[
               
               TemplateBox[{"\"(\"", "1", "\",\"", "0", "\")\""}, 
                "RowDefault"], TraditionalForm], TraditionalForm, Editable -> 
              True], FrameStyle -> None, Background -> RGBColor[1, 0.9, 0.8]},
             "Highlighted"]},
          "RowDefault"]},
        {
         GraphicsBox[{
           LineBox[NCache[{{0, 0}, {1, 0}, {
              1 + 2^Rational[-1, 2], 2^Rational[-1, 2]}, {
              1 + 2^Rational[-1, 2], 1 + 2^Rational[-1, 2]}, {
              1 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[1, 2], 1 + 2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], 1 - 2^Rational[-1, 2] + 
               2^Rational[1, 2]}, {
              2 + 2^Rational[-1, 2] + 2^Rational[1, 2], -2^Rational[-1, 2] + 
               2^Rational[1, 2]}, {2 + 2 2^Rational[1, 2], 0}, {
              3 + 2 2^Rational[1, 2], 0}}, {{0, 0}, {1, 0}, {
              1.7071067811865475`, 0.7071067811865475}, {1.7071067811865475`, 
              1.7071067811865475`}, {2.414213562373095, 2.414213562373095}, {
              3.414213562373095, 2.414213562373095}, {4.121320343559643, 
              1.7071067811865477`}, {4.121320343559643, 0.7071067811865477}, {
              4.82842712474619, 0}, {5.82842712474619, 0}}]], 
           {RGBColor[1, 0, 0], PointBox[{0, 0}]}, 
           {RGBColor[1, 0, 0], Dashing[{Small, Small}], 
            LineBox[NCache[{{2 + 2 2^Rational[1, 2], 0}, {
               5.040559159102155, -0.2121320343559643}}, {{
               4.82842712474619, 0}, {
               5.040559159102155, -0.2121320343559643}}]], 
            InsetBox["\<\"\[Theta]\"\>", \
{4.98206673505298, -0.06363961030678929}]}},
          Frame->True,
          ImageSize->{200, 200},
          PlotLabel->FormBox[
            
            TemplateBox[{
             "\"A\"", "\"+\"", "\"B\"", "\"+\"", "\"A\"", "\"-\"", "\"B\"", 
              "\"-\"", "\"A\"", "\"-\"", "\"B\"", "\"-\"", "\"A\"", "\"+\"", 
              "\"B\"", "\"+\"", "\"A\""}, "RowDefault"], TraditionalForm]]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.7267701468456993`*^9, {3.7267710654163713`*^9, 3.7267710944519567`*^9}, 
   3.726771683118505*^9, 3.7267718414241*^9, {3.72677232537011*^9, 
   3.726772354878846*^9}, 3.7267727117952957`*^9, 
   3.726774523431877*^9},ExpressionUUID->"a427cfe6-5d95-4c43-84d7-\
4b7659eef067"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "FIXME", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"CloudDeploy", "[", 
   RowBox[{
    RowBox[{"FormPage", "[", 
     RowBox[{
      RowBox[{"FormObject", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<string\>\"", "->", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<A+A-B+A\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", 
              RowBox[{"Style", "[", 
               RowBox[{
               "\"\<1:Levy C Curve, 2:Sierpinski, 3:Hilbert, 4:Highway \
Dragon,5:Pinwheel Embroidery, 6:Koch Snowflake, 7:cesaro Curve, 8:Gosper \
Curve, 9:Penrose Tiling, 10:Plant\>\"", ",", "Blue"}], "]"}]}]}], "|>"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<\[Theta]\>\"", "->", 
           RowBox[{"<|", 
            RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<Pi/3\>\""}], "|>"}]}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"AppearanceRules", "\[Rule]", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<L-System Geometry\>\"", ",", "Orange", ",", " ", "Bold", 
              ",", 
              RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
           RowBox[{
           "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
          "|>"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"lsysGEO", "[", 
        RowBox[{"#string", ",", "#\[Theta]"}], "]"}], "&"}]}], "]"}], ",", 
    RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]}]], "Input",\

 CellChangeTimes->{
  3.7267702182653303`*^9, {3.726770265997208*^9, 3.726770369925912*^9}, 
   3.72677045232793*^9, {3.72677126786203*^9, 
   3.7267712733841553`*^9}},ExpressionUUID->"6ab9c88d-a174-4346-b713-\
c75f40578f4a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/7547840d-e97b-40b1-880c-\
ebba7252c6e5\"",
     "https://www.wolframcloud.com/objects/7547840d-e97b-40b1-880c-\
ebba7252c6e5"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/7547840d-e97b-40b1-880c-ebba7252c6e5"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{3.726770397872285*^9, 
  3.726770454217083*^9},ExpressionUUID->"ea54afac-8c12-4d7d-9169-\
27ffcd91b1dd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"help", "=", 
   RowBox[{"Style", "[", 
    RowBox[{
     RowBox[{
     "\"\<A, B draw forward, \[PlusMinus] rotate \[PlusMinus]\[Theta]. \>\"", 
      "<>", "\"\<Sierpinski arrowhead curve:\>\"", "<>", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"SubstitutionSystem", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
            RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
          "\"\<A\>\"", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ")"}]}], ",", "Blue"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormFunction", "@@", 
    RowBox[{"APIFunction", "[", 
     RowBox[{
      RowBox[{
      "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\"\<string\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<A+A-B+A\>\""}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", "help"}]}], "|>"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<angle\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<Pi/3\>\""}], "|>"}]}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{
       RowBox[{"lsysGEO", "[", 
        RowBox[{"#string", ",", "#angle"}], "]"}], "&"}], ",", "\"\<PDF\>\"", 
      ",", 
      RowBox[{"AppearanceRules", "\[Rule]", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<L-System Geometry Viewer\>\"", ",", "Orange", ",", " ", 
            "Bold", ",", 
            RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", 
         RowBox[{"\"\<Description\>\"", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Geometrical Rendering of L-System String\>\"", ",", "Bold", 
            ",", "Orange"}], "]"}]}], ",", 
         RowBox[{
         "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
        "|>"}]}]}], "]"}]}], ",", " ", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.7267705385718946`*^9, {3.726770583245414*^9, 3.726770634940268*^9}, 
   3.726770691333322*^9, {3.726770729483233*^9, 3.726770734274705*^9}, {
   3.7267707852664948`*^9, 3.726770848441717*^9}, 3.72677088011532*^9, {
   3.726771223356762*^9, 3.726771248644958*^9}, {3.7267713354866943`*^9, 
   3.726771411750175*^9}, {3.726771464136304*^9, 3.7267715676446733`*^9}, {
   3.726771639927692*^9, 3.726771647914373*^9}, {3.726771953976902*^9, 
   3.7267719582737627`*^9}, {3.726771993261647*^9, 3.726772012364221*^9}, {
   3.726772107890942*^9, 3.726772115621441*^9}, {3.726772146254245*^9, 
   3.726772165929867*^9}, {3.726772198142786*^9, 3.726772247369759*^9}, 
   3.726772434642211*^9, {3.7267725129096518`*^9, 3.726772526769238*^9}, 
   3.726772602798203*^9, {3.7267746851312513`*^9, 
   3.726774699304881*^9}},ExpressionUUID->"8de7484a-0e36-44d2-822b-\
cdab9afd64f1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/ce8ba3aa-0f06-487b-91eb-\
86d5490b4aa0\"",
     "https://www.wolframcloud.com/objects/ce8ba3aa-0f06-487b-91eb-\
86d5490b4aa0"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/ce8ba3aa-0f06-487b-91eb-86d5490b4aa0"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.7267706920602407`*^9, {3.726770734993198*^9, 3.726770743360794*^9}, 
   3.726770850527047*^9, 3.726770882048225*^9, 3.726771388682088*^9, 
   3.726771856840678*^9, 3.726772013888206*^9, 3.726772168252277*^9, {
   3.726772220595797*^9, 3.726772248948601*^9}, 3.726772373340652*^9, 
   3.7267725284328947`*^9, 3.7267726045638933`*^9, 3.726774538391272*^9, {
   3.726774695188146*^9, 
   3.7267747000206547`*^9}},ExpressionUUID->"75c152a1-f2fe-4ea2-ad44-\
f8ba73722ba2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"help", "=", 
   RowBox[{"Style", "[", 
    RowBox[{
     RowBox[{
     "\"\<A, B draw forward, \[PlusMinus] rotate \[PlusMinus]\[Theta]. \>\"", 
      "<>", "\"\<Sierpinski arrowhead curve:\>\"", "<>", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"SubstitutionSystem", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
            RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
          "\"\<A\>\"", ",", 
          RowBox[{"{", "2", "}"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ")"}]}], ",", "Blue"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormFunction", "@@", 
    RowBox[{"APIFunction", "[", 
     RowBox[{
      RowBox[{
      "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\"\<string\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<A+A-B+A\>\""}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", "help"}]}], "|>"}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<angle\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<Pi/3\>\""}], "|>"}]}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{
       RowBox[{"lsysGEO", "[", 
        RowBox[{"#string", ",", "#angle"}], "]"}], "&"}], ",", "\"\<PNG\>\"", 
      ",", 
      RowBox[{"AppearanceRules", "\[Rule]", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<L-System Geometry Viewer\>\"", ",", "Orange", ",", " ", 
            "Bold", ",", 
            RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", 
         RowBox[{"\"\<Description\>\"", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Geometrical Rendering of L-System String\>\"", ",", "Bold", 
            ",", "Orange"}], "]"}]}], ",", 
         RowBox[{
         "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Grow!\>\""}]}], 
        "|>"}]}]}], "]"}]}], ",", " ", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.7267705385718946`*^9, {3.726770583245414*^9, 3.726770634940268*^9}, 
   3.726770691333322*^9, {3.726770729483233*^9, 3.726770734274705*^9}, {
   3.7267707852664948`*^9, 3.726770848441717*^9}, 3.72677088011532*^9, {
   3.726771223356762*^9, 3.726771248644958*^9}, {3.7267713354866943`*^9, 
   3.726771411750175*^9}, {3.726771464136304*^9, 3.7267715676446733`*^9}, {
   3.726771639927692*^9, 3.726771647914373*^9}, {3.726771953976902*^9, 
   3.7267719582737627`*^9}, {3.726771993261647*^9, 3.726772012364221*^9}, {
   3.726772107890942*^9, 3.726772115621441*^9}, {3.726772146254245*^9, 
   3.726772165929867*^9}, {3.726772198142786*^9, 3.726772247369759*^9}, 
   3.726772434642211*^9, {3.7267725129096518`*^9, 3.726772526769238*^9}, 
   3.726772602798203*^9, {3.7267746851312513`*^9, 3.726774699304881*^9}, {
   3.729021972960538*^9, 
   3.729021973600954*^9}},ExpressionUUID->"37c37e79-1a7f-4066-bfad-\
db9ba4a9d7af"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/ab7921ac-5449-473c-8f18-\
ace2cd750d20\"",
     "https://www.wolframcloud.com/objects/ab7921ac-5449-473c-8f18-\
ace2cd750d20"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/ab7921ac-5449-473c-8f18-ace2cd750d20"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.729021977337718*^9},ExpressionUUID->"c100d220-a569-49c3-8e7a-\
47ffbb81e381"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"split", "[", "w_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"StringSplit", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], "]"}], 
       ",", "\"\<\>\""}], "]"}], "&"}], "/@", "w"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"indices", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<A\>\"", ",", "i"}], "]"}], "\[Rule]", "\"\<A\>\""}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "1000"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<B\>\"", ",", "i"}], "]"}], "\[Rule]", "\"\<B\>\""}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<+\>\"", ",", "i"}], "]"}], "\[Rule]", "\"\<+\>\""}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}], ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<-\>\"", ",", "i"}], "]"}], "\[Rule]", "\"\<-\>\""}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", "1000"}], "}"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Theta]", "=", 
   RowBox[{"Pi", "/", "3"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ctr", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"n", "=", "4"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"history", "=", 
    RowBox[{"SubstitutionSystem", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
        RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], ",", 
      "\"\<A\>\"", ",", "n"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"w1", "=", 
     RowBox[{"StringSplit", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SubstitutionSystem", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
              RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], 
            ",", "\"\<A\>\"", ",", 
            RowBox[{"{", "1", "}"}]}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], "]"}], 
       ",", "\"\<\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"w1s", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Subscript", "[", 
        RowBox[{
         RowBox[{"w1", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"ctr", "++"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"w2", "=", 
   RowBox[{"w1", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
      RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wspl", "=", 
   RowBox[{"split", "[", "w2", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"w2s", "=", 
   RowBox[{"Flatten", "@", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"w1s", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
           
           RowBox[{
            RowBox[{
             RowBox[{"w1s", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}], ",", 
          RowBox[{
           RowBox[{"w1s", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"wspl", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", 
              RowBox[{"ctr", "++"}]}], "]"}], ")"}]}], ",", "Nothing"}], 
         "]"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "@", 
           RowBox[{"wspl", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "@", "w1s"}]}], "}"}]}], "]"}]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"w1s", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"Subscript", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"wspl", "[", 
              RowBox[{"[", "i", "]"}], "]"}], "[", 
             RowBox[{"[", "j", "]"}], "]"}], ",", 
            RowBox[{"ctr", "++"}]}], "]"}], ")"}]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{"j", ",", "1", ",", 
          RowBox[{"Length", "@", 
           RowBox[{"wspl", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", 
        RowBox[{"Length", "@", "w1s"}]}], "}"}]}], "]"}], ";"}], "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"w3", "=", 
     RowBox[{"StringSplit", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"SubstitutionSystem", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
              RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}], 
            ",", "\"\<A\>\"", ",", 
            RowBox[{"{", "2", "}"}]}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], "]"}], 
       ",", "\"\<\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"w3s", "=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Subscript", "[", 
        RowBox[{
         RowBox[{"w3", "[", 
          RowBox[{"[", "i", "]"}], "]"}], ",", 
         RowBox[{"ctr", "++"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "w3"}]}], "}"}]}], "]"}]}]}], "}"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"w4", "=", 
    RowBox[{"w3", "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<A\>\"", "\[Rule]", "\"\<B-A-B\>\""}], ",", 
       RowBox[{"\"\<B\>\"", "\[Rule]", "\"\<A+B+A\>\""}]}], "}"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"wspl", "=", 
   RowBox[{"DeleteCases", "[", 
    RowBox[{
     RowBox[{"DeleteCases", "[", 
      RowBox[{
       RowBox[{"split", "[", "w4", "]"}], ",", 
       RowBox[{"{", "\"\<-\>\"", "}"}]}], "]"}], ",", 
     RowBox[{"{", "\"\<+\>\"", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ww2s", "=", 
    RowBox[{"w2s", "[", 
     RowBox[{"[", 
      RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ww2s", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"ww2s", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
        RowBox[{
         RowBox[{
          RowBox[{"ww2s", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}], ",", 
       RowBox[{"ww2s", "[", 
        RowBox[{"[", "i", "]"}], "]"}], ",", "Nothing"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "ww2s"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"w4s", "=", 
    RowBox[{"Flatten", "@", 
     RowBox[{"Table", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"ww2s", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<A\>\""}], "||", 
            RowBox[{
             RowBox[{
              RowBox[{"ww2s", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", "\"\<B\>\""}]}], 
           ",", 
           RowBox[{
            RowBox[{"ww2s", "[", 
             RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
            RowBox[{"Subscript", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"wspl", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", 
              RowBox[{"ctr", "++"}]}], "]"}]}], ",", "Nothing"}], "]"}], ",", 
         " ", 
         RowBox[{"{", 
          RowBox[{"j", ",", "1", ",", 
           RowBox[{"Length", "@", 
            RowBox[{"wspl", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", 
         RowBox[{"Length", "@", "ww2s"}]}], "}"}]}], "]"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.72662966783718*^9, 3.7266296941394033`*^9}, 
   3.726629747837103*^9, {3.726629843126251*^9, 3.726629854255828*^9}, {
   3.7266299222156467`*^9, 3.726629952748304*^9}, {3.7266304131964893`*^9, 
   3.726630444471116*^9}, {3.72663049013704*^9, 3.726630512073349*^9}, {
   3.7266306145989017`*^9, 3.726630618635477*^9}, {3.726630670690812*^9, 
   3.7266307706597033`*^9}, {3.726631098526024*^9, 3.726631104289168*^9}, {
   3.726631134401267*^9, 3.726631151748797*^9}, 3.7266314025385723`*^9, {
   3.726631904623104*^9, 3.72663191591848*^9}, {3.7266331381852417`*^9, 
   3.7266331668942413`*^9}, {3.726650421435808*^9, 3.726650437948617*^9}, {
   3.726650520233778*^9, 3.726650662110093*^9}, 3.7266507913852262`*^9, {
   3.726650831570822*^9, 3.7266508417077312`*^9}, {3.726651195259347*^9, 
   3.7266512422697077`*^9}, {3.726651738914249*^9, 3.726651746492016*^9}, {
   3.726651822963715*^9, 3.726651832803988*^9}, 3.7266518711255617`*^9, {
   3.726652016677322*^9, 3.726652028084676*^9}, {3.726652151791657*^9, 
   3.72665225152553*^9}, {3.726653274585423*^9, 3.7266532802635593`*^9}, 
   3.7266534426015053`*^9, {3.726653517093442*^9, 3.7266535390073013`*^9}, {
   3.726653571993678*^9, 3.726653595381467*^9}, {3.726653729970038*^9, 
   3.726653740802491*^9}, {3.7266538315578833`*^9, 3.7266538325243*^9}, 
   3.7266539172958*^9, {3.72665398484544*^9, 3.72665398901512*^9}, 
   3.726654028064993*^9, {3.726654413126672*^9, 3.726654464993085*^9}, {
   3.7266545248388453`*^9, 3.726654556163027*^9}, {3.726654928756276*^9, 
   3.726654975095004*^9}, {3.726655033685986*^9, 3.7266550700571012`*^9}, 
   3.726655618564966*^9, {3.726734667348291*^9, 3.726734667909605*^9}, {
   3.726742573215469*^9, 3.7267426178004303`*^9}, {3.7267426858638477`*^9, 
   3.726742693704698*^9}, {3.726742734307407*^9, 3.7267427362531443`*^9}, {
   3.72674279715099*^9, 3.7267427995923033`*^9}, {3.726742843199527*^9, 
   3.726742851231277*^9}, {3.726742887795375*^9, 3.7267429090786448`*^9}, {
   3.726743288706525*^9, 3.726743321792552*^9}, {3.7267434104334517`*^9, 
   3.726743411794457*^9}, {3.7267436249968147`*^9, 3.726743626684292*^9}, {
   3.726743676679731*^9, 3.7267437044106216`*^9}, {3.7267437374872828`*^9, 
   3.7267437745895023`*^9}, {3.726743899558508*^9, 3.726743902639667*^9}, {
   3.7267440373838797`*^9, 3.726744050930263*^9}, {3.726744300897943*^9, 
   3.726744380086093*^9}, {3.726746131327973*^9, 3.726746141776381*^9}, {
   3.726746299371004*^9, 3.726746374634412*^9}, 3.726746752563636*^9, {
   3.7267513821394873`*^9, 3.726751387720008*^9}, {3.726773224834351*^9, 
   3.726773230231731*^9}},ExpressionUUID->"073b966a-cd0a-4a02-9c6f-\
c8edf0e4766b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"TreePlot", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Sequence", "@@", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"\"\<A\>\"", "\[Rule]", 
            RowBox[{"w1s", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", 
             RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", "w2s"}]}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", "Left", 
      "\[IndentingNewLine]", ",", 
      RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
      RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
      RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", "indices"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.726655268686167*^9, 
  3.726655315491975*^9}},ExpressionUUID->"52ee81e8-007d-4897-b86d-\
6dc74be2a718"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQNhG7zumaizO2w6aeD+ufSWfSuYfmW/EspXnZ5S
Wnbjs30nlB8OVd8E5UPEuRySoHx1sHphh6VQc2D2LITyu6Dq5qLwX9nPgtLq
UPumQfkQ83/ZT4Lyv9XW8ezoZHDoRVHP7NAJ5UdA3deKop8L6t5X9rseiW3Y
eITXoQ7FPAGHKii/r+ujg7ihkEMpivnCDoVQ/v7F11derRd1yEWxT9wBAGaS
oK8=
    "], {
     {RGBColor[0.5, 0., 0.], Arrowheads[{{0.021530857437587737`, 0.7}}], 
      ArrowBox[{1, 2}], ArrowBox[{1, 3}], ArrowBox[{1, 4}], ArrowBox[{1, 5}], 
      ArrowBox[{1, 6}], ArrowBox[{2, 7}], ArrowBox[{2, 8}], ArrowBox[{2, 9}], 
      ArrowBox[{2, 10}], ArrowBox[{2, 11}], ArrowBox[{4, 12}], 
      ArrowBox[{4, 13}], ArrowBox[{4, 14}], ArrowBox[{4, 15}], 
      ArrowBox[{4, 16}], ArrowBox[{6, 17}], ArrowBox[{6, 18}], 
      ArrowBox[{6, 19}], ArrowBox[{6, 20}], ArrowBox[{6, 21}]}, {InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 1], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 2], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 3], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 4], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 5], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 6], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 7], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 8], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 9], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 10], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 11], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 12], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 13], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 14], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 15], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 16], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 17], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 18], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 19], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 20], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 21]}}],
   Annotation[#, VertexCoordinateRules -> CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQNhG7zumaizO2w6aeD+ufSWfSuYfmW/EspXnZ5S
Wnbjs30nlB8OVd8E5UPEuRySoHx1sHphh6VQc2D2LITyu6Dq5qLwX9nPgtLq
UPumQfkQ83/ZT4Lyv9XW8ezoZHDoRVHP7NAJ5UdA3deKop8L6t5X9rseiW3Y
eITXoQ7FPAGHKii/r+ujg7ihkEMpivnCDoVQ/v7F11derRd1yEWxT9wBAGaS
oK8=
     "]]& ],
  AspectRatio->2.645751311064586,
  FrameTicks->None,
  ImageSize->300,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{{3.726655280158752*^9, 3.726655315750105*^9}, 
   3.726655625862382*^9, 3.726734675065814*^9, 3.7267425831197*^9, 
   3.726742621996017*^9, 3.726742697651311*^9, 3.7267427399463882`*^9, 
   3.726742805720438*^9, {3.7267428994701023`*^9, 3.726742911839932*^9}, 
   3.72674298310286*^9, 3.726743295840474*^9, 3.72674342083963*^9, {
   3.726743606779296*^9, 3.7267436324205093`*^9}, 3.726743806402439*^9, 
   3.726744325137465*^9, 3.7267443836874866`*^9, 3.726746145505972*^9, 
   3.726746380390394*^9, 3.7267467578355923`*^9, 3.7267513937397127`*^9, 
   3.72677323397169*^9},ExpressionUUID->"be9e82bf-0c63-4c62-ac3a-\
b67a6bbdcbaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TreePlot", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Sequence", "@@", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"\"\<A\>\"", "\[Rule]", 
           RowBox[{"w1s", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "1", ",", 
            RowBox[{"Length", "@", "w1"}]}], "}"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", "w2s"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Sequence", "@@", "w4s"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", "Left", "\[IndentingNewLine]", ",", 
     RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
     RowBox[{"VertexLabeling", "\[Rule]", "True"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "350"}]}], "]"}], "/.", "indices"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.726629733628079*^9, 3.726629800386138*^9}, {
   3.726629966912096*^9, 3.726630026617153*^9}, 3.7266307809991293`*^9, {
   3.726630933641667*^9, 3.726630974536386*^9}, {3.726631194949381*^9, 
   3.7266312033422117`*^9}, {3.7266312981478033`*^9, 
   3.7266313318079147`*^9}, {3.7266316164722357`*^9, 
   3.7266316235362062`*^9}, {3.7266328139892073`*^9, 3.726632850752543*^9}, {
   3.726632960465168*^9, 3.7266329640196743`*^9}, {3.72663315232619*^9, 
   3.726633153169158*^9}, 3.726633189091363*^9, {3.726633324184196*^9, 
   3.7266333332732983`*^9}, 3.726650383341126*^9, {3.726650641319035*^9, 
   3.72665065719201*^9}, {3.72665175731511*^9, 3.726651757538898*^9}, 
   3.726651838293468*^9, {3.726652258330761*^9, 3.7266522677909718`*^9}, {
   3.726654585849004*^9, 3.726654589323934*^9}, {3.726654650316465*^9, 
   3.726654670453858*^9}, 3.726654706361367*^9, {3.726654750573353*^9, 
   3.726654797553754*^9}, {3.726654855788871*^9, 3.726654865189721*^9}, {
   3.72665517184866*^9, 3.726655178387782*^9}, 3.726742472819785*^9, 
   3.726744397557473*^9},ExpressionUUID->"7682f7f0-0447-4cb0-91d0-\
97f3b38f40de"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[CompressedData["
1:eJxV0ktIVFEYB/CbZoho+CjHJqt5uikkyEwJOf+GqNEkyXFgILIYMsMejiSa
ryIbEDVkAnsMkUQRLnSjVOLK3LQQhAqKHoZDhBotMqkwcZHO/Z/Fd+Fy+HHP
vd/3/e+xB+sraxIMw/Cs3eurvub6mnsWz2Xjzsy/ti9lr9WNQ3/uJ95cVRG6
LL4aOEbr/UfooT0HggMXLNhAj80FLJH3DrTHHVOlXFu51k/9LS4PLagQ3cl6
l2hd7ywdiu9PRoBObx339VZkwE+/s7TsLq7KZH8xtcD+dN1h9qfoiSf7J/3X
tmMfbb5nw146f+hjbcG0DXm0nsdFR58XJc4HnLDSzl9jo56gG4OcS+f6lNa5
PRaOqUd0A9eH4vmiekBX+5Y/9Z/6raJi/7K6S4eZX79430CENvNJQJ/43kb0
0mZem9Atvp+MLnolqen7YEsKwqJeKjrptI5G7+lbm3Fd1E9HB63/V5voJxNX
aTPPLDSJ/rbgCm3muxUNot9sXKb1/70o+s9BHV14/kXGSuM21Ip5rKih9XkI
ivlycYb2zj4LjXTtQLWYdydO0m+tBba027sQEPPb4Kf1efKJPOw4QS95o+rr
GzuOi3wcKKf1+SsVeTlxlG4P5/ws+ezEYZGfCx4ajg+vfsy6AJGnGyV00st7
A9Fvbhyk5+P55uE/Ot4RRw==
    "], {
     {RGBColor[0.5, 0., 0.], Arrowheads[{{0.015777670002824522`, 0.7}}], 
      ArrowBox[{1, 2}], ArrowBox[{1, 3}], ArrowBox[{1, 4}], ArrowBox[{1, 5}], 
      ArrowBox[{1, 6}], ArrowBox[{2, 7}], ArrowBox[{2, 8}], ArrowBox[{2, 9}], 
      ArrowBox[{2, 10}], ArrowBox[{2, 11}], ArrowBox[{4, 12}], 
      ArrowBox[{4, 13}], ArrowBox[{4, 14}], ArrowBox[{4, 15}], 
      ArrowBox[{4, 16}], ArrowBox[{6, 17}], ArrowBox[{6, 18}], 
      ArrowBox[{6, 19}], ArrowBox[{6, 20}], ArrowBox[{6, 21}], 
      ArrowBox[{7, 22}], ArrowBox[{7, 23}], ArrowBox[{7, 24}], 
      ArrowBox[{7, 25}], ArrowBox[{7, 26}], ArrowBox[{9, 27}], 
      ArrowBox[{9, 28}], ArrowBox[{9, 29}], ArrowBox[{9, 30}], 
      ArrowBox[{9, 31}], ArrowBox[{11, 32}], ArrowBox[{11, 33}], 
      ArrowBox[{11, 34}], ArrowBox[{11, 35}], ArrowBox[{11, 36}], 
      ArrowBox[{12, 37}], ArrowBox[{12, 38}], ArrowBox[{12, 39}], 
      ArrowBox[{12, 40}], ArrowBox[{12, 41}], ArrowBox[{14, 42}], 
      ArrowBox[{14, 43}], ArrowBox[{14, 44}], ArrowBox[{14, 45}], 
      ArrowBox[{14, 46}], ArrowBox[{16, 47}], ArrowBox[{16, 48}], 
      ArrowBox[{16, 49}], ArrowBox[{16, 50}], ArrowBox[{16, 51}], 
      ArrowBox[{17, 52}], ArrowBox[{17, 53}], ArrowBox[{17, 54}], 
      ArrowBox[{17, 55}], ArrowBox[{17, 56}], ArrowBox[{19, 57}], 
      ArrowBox[{19, 58}], ArrowBox[{19, 59}], ArrowBox[{19, 60}], 
      ArrowBox[{19, 61}], ArrowBox[{21, 62}], ArrowBox[{21, 63}], 
      ArrowBox[{21, 64}], ArrowBox[{21, 65}], ArrowBox[{21, 66}]}, {InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 1], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 2], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 3], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 4], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 5], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 6], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 7], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 8], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 9], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 10], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 11], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 12], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 13], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 14], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 15], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 16], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 17], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 18], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 19], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 20], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 21], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 22], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 23], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 24], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 25], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 26], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 27], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 28], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 29], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 30], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 31], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 32], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 33], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 34], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 35], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 36], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 37], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 38], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 39], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 40], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 41], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 42], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 43], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 44], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 45], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 46], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 47], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 48], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 49], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 50], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 51], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 52], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 53], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 54], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 55], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 56], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 57], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 58], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 59], InsetBox[
       FrameBox["\<\"+\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 60], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 61], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 62], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 63], InsetBox[
       FrameBox["\<\"A\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 64], InsetBox[
       FrameBox["\<\"-\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 65], InsetBox[
       FrameBox["\<\"B\"\>",
        Background->RGBColor[1, 1, 0.8],
        FrameStyle->RGBColor[0.94, 0.85, 0.36],
        StripOnInput->False], 66]}}],
   Annotation[#, VertexCoordinateRules -> CompressedData["
1:eJxV0ktIVFEYB/CbZoho+CjHJqt5uikkyEwJOf+GqNEkyXFgILIYMsMejiSa
ryIbEDVkAnsMkUQRLnSjVOLK3LQQhAqKHoZDhBotMqkwcZHO/Z/Fd+Fy+HHP
vd/3/e+xB+sraxIMw/Cs3eurvub6mnsWz2Xjzsy/ti9lr9WNQ3/uJ95cVRG6
LL4aOEbr/UfooT0HggMXLNhAj80FLJH3DrTHHVOlXFu51k/9LS4PLagQ3cl6
l2hd7ywdiu9PRoBObx339VZkwE+/s7TsLq7KZH8xtcD+dN1h9qfoiSf7J/3X
tmMfbb5nw146f+hjbcG0DXm0nsdFR58XJc4HnLDSzl9jo56gG4OcS+f6lNa5
PRaOqUd0A9eH4vmiekBX+5Y/9Z/6raJi/7K6S4eZX79430CENvNJQJ/43kb0
0mZem9Atvp+MLnolqen7YEsKwqJeKjrptI5G7+lbm3Fd1E9HB63/V5voJxNX
aTPPLDSJ/rbgCm3muxUNot9sXKb1/70o+s9BHV14/kXGSuM21Ip5rKih9XkI
ivlycYb2zj4LjXTtQLWYdydO0m+tBba027sQEPPb4Kf1efKJPOw4QS95o+rr
GzuOi3wcKKf1+SsVeTlxlG4P5/ws+ezEYZGfCx4ajg+vfsy6AJGnGyV00st7
A9Fvbhyk5+P55uE/Ot4RRw==
     "]]& ],
  AspectRatio->3.829708431025337,
  FrameTicks->None,
  ImageSize->350,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.726630027183798*^9, 3.726630782452024*^9, {3.726630967394853*^9, 
   3.7266309753268347`*^9}, 3.726631162220971*^9, 3.726631203834704*^9, {
   3.72663129948411*^9, 3.726631332140552*^9}, 3.726631623802726*^9, 
   3.72663285121894*^9, 3.726632964418001*^9, {3.726633148311344*^9, 
   3.7266331894428587`*^9}, 3.726633333598785*^9, 3.726650383933473*^9, 
   3.7266505299261017`*^9, {3.726650642731476*^9, 3.7266506641875277`*^9}, 
   3.726651764326597*^9, 3.726651839649522*^9, 3.726652268140459*^9, 
   3.726653600246151*^9, 3.726653926868898*^9, {3.726654004928769*^9, 
   3.726654031420868*^9}, 3.726654420073473*^9, 3.72665446992063*^9, 
   3.726654559390664*^9, 3.7266545897208138`*^9, {3.726654660261714*^9, 
   3.726654671408904*^9}, {3.726654754576541*^9, 3.726654797925929*^9}, {
   3.726654856792025*^9, 3.726654865492414*^9}, {3.726654948546837*^9, 
   3.726654960295856*^9}, {3.7266550358025827`*^9, 3.726655073299008*^9}, 
   3.72665517970185*^9, 3.726655628223843*^9, 3.726734678593891*^9, 
   3.726742473463006*^9, 3.726742627458275*^9, 3.726742762162931*^9, 
   3.726742914136235*^9, 3.726744331601263*^9, {3.726744386194194*^9, 
   3.726744397995089*^9}, 3.726746149126871*^9, 3.726746382910611*^9, 
   3.726746760339286*^9, 3.726751397649097*^9, 
   3.7267732365493097`*^9},ExpressionUUID->"7f3aa7a7-52a4-4dc0-8205-\
262f4979eaff"]
}, Open  ]]
},
WindowSize->{1279, 1276},
WindowMargins->{{541, Automatic}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1144, 30, 94, "Input",ExpressionUUID->"9653b724-3bf1-40e3-99ec-5f1fc8f13b68"],
Cell[CellGroupData[{
Cell[1727, 54, 696, 17, 30, "Input",ExpressionUUID->"2f324d08-b3c3-4e56-908e-7ddce7b4ad3c"],
Cell[2426, 73, 602, 10, 34, "Output",ExpressionUUID->"841d82f2-6755-4e06-b20c-7017fee9778a"]
}, Open  ]],
Cell[3043, 86, 20440, 486, 1795, "Input",ExpressionUUID->"9448508c-1b97-40f1-bb82-f765cf31c8eb"],
Cell[CellGroupData[{
Cell[23508, 576, 412, 7, 30, "Input",ExpressionUUID->"94fe4826-04c2-46c9-aaf2-056b9b0e6eba"],
Cell[23923, 585, 22563, 494, 2487, "Output",ExpressionUUID->"4f73fdc6-cd3a-4d78-9cb1-b9ba94e2fd30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46523, 1084, 1846, 44, 220, "Input",ExpressionUUID->"1ec82d63-ee1d-4511-ae2e-66f01c585bf6"],
Cell[48372, 1130, 760, 18, 37, "Output",ExpressionUUID->"303bcb0f-f8a1-4a58-81a4-0b70f36601ac"]
}, Open  ]],
Cell[49147, 1151, 19715, 442, 1459, "Input",ExpressionUUID->"6e5ade19-2f9f-47b3-a9a8-3d95ed1d03c9"],
Cell[CellGroupData[{
Cell[68887, 1597, 293, 7, 30, "Input",ExpressionUUID->"96319fa9-8b4a-4c7f-84cc-023cdc4379d4"],
Cell[69183, 1606, 46697, 1094, 2751, "Output",ExpressionUUID->"a427cfe6-5d95-4c43-84d7-4b7659eef067"]
}, Open  ]],
Cell[CellGroupData[{
Cell[115917, 2705, 2142, 49, 346, "Input",ExpressionUUID->"6ab9c88d-a174-4346-b713-c75f40578f4a"],
Cell[118062, 2756, 540, 14, 37, "Output",ExpressionUUID->"ea54afac-8c12-4d7d-9169-27ffcd91b1dd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118639, 2775, 3314, 75, 283, "Input",ExpressionUUID->"8de7484a-0e36-44d2-822b-cdab9afd64f1"],
Cell[121956, 2852, 908, 20, 37, "Output",ExpressionUUID->"75c152a1-f2fe-4ea2-ad44-f8ba73722ba2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122901, 2877, 3364, 76, 283, "Input",ExpressionUUID->"37c37e79-1a7f-4066-bfad-db9ba4a9d7af"],
Cell[126268, 2955, 518, 14, 37, "Output",ExpressionUUID->"c100d220-a569-49c3-8e7a-47ffbb81e381"]
}, Open  ]],
Cell[126801, 2972, 13360, 346, 766, "Input",ExpressionUUID->"073b966a-cd0a-4a02-9c6f-c8edf0e4766b"],
Cell[CellGroupData[{
Cell[140186, 3322, 1116, 27, 220, "Input",ExpressionUUID->"52ee81e8-007d-4897-b86d-6dc74be2a718"],
Cell[141305, 3351, 5347, 121, 809, "Output",ExpressionUUID->"be9e82bf-0c63-4c62-ac3a-b67a6bbdcbaf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146689, 3477, 2161, 41, 241, "Input",ExpressionUUID->"7682f7f0-0447-4cb0-91d0-97f3b38f40de"],
Cell[148853, 3520, 15293, 341, 1355, "Output",ExpressionUUID->"7f3aa7a7-52a4-4dc0-8205-262f4979eaff"]
}, Open  ]]
}
]
*)

