(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     43575,       1079]
NotebookOptionsPosition[     41810,       1041]
NotebookOutlinePosition[     42202,       1058]
CellTagsIndexPosition[     42159,       1055]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"89b774c6-cd65-4d3e-bc2d-\
de95a38cf98f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PNG", "\[Equal]", "True"}], ",", 
     RowBox[{"ImportString", "@", 
      RowBox[{"ExportString", "[", 
       RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"highlightCORRECT", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"debug", "\[Equal]", "False"}], ",", "s", ",", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PNG", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debug", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myFONTSIZE", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myLINEBREAKS", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textFORMAT", "[", "s_", "]"}], ":=", 
   RowBox[{"Text", "[", 
    RowBox[{"Style", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InsertLinebreaks", "[", 
       RowBox[{
        RowBox[{"ToString", "@", "s"}], ",", "myLINEBREAKS"}], "]"}], ",", 
      "myFONTSIZE", ",", 
      RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"textFORMAT2", "[", "s_", "]"}], ":=", 
    RowBox[{"Text", "[", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"InsertLinebreaks", "[", 
        RowBox[{"s", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
       RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"parser", "[", "expression0_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "expression", "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"expression", "=", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"expression0", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"\"\<+\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], ",", 
            RowBox[{"\"\<-\>\"", "->", " ", "\"\<\[Diamond]\>\""}], ",", 
            RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\[CircleTimes]\>\""}], ",", 
            RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\[SmallCircle]\>\""}], ",", 
            RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<\[Wedge]\>\""}], ",", 
            RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<sqr@\>\""}], ",", 
            RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<sin@\>\""}], ",", 
            RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<cos@\>\""}]}], "}"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"myPNG", "@", 
        RowBox[{"Column", "@", 
         RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TreeForm", "[", 
            RowBox[{
             RowBox[{"ToExpression", "@", "expression"}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
             RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
             RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}], ",", 
             RowBox[{"CircleTimes", "\[Rule]", "\"\<*\>\""}], ",", " ", 
             RowBox[{"SmallCircle", "\[Rule]", "\"\</\>\""}], ",", 
             RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
             RowBox[{"Wedge", "\[Rule]", "\"\<^\>\""}], ",", 
             RowBox[{"Diamond", "\[Rule]", "\"\<-\>\""}]}], "}"}]}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}]}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.668701916815751*^9, 3.66870193624583*^9}, {
   3.668702133786916*^9, 3.668702134347089*^9}, 3.6687022853581867`*^9, {
   3.6687023887130537`*^9, 3.668702431753148*^9}, {3.668702614804088*^9, 
   3.668702625199012*^9}, {3.6687027298143806`*^9, 3.668702756813094*^9}, {
   3.668702877190712*^9, 3.668702935882134*^9}, {3.66870296651546*^9, 
   3.66870298115119*^9}, {3.6687030616129713`*^9, 3.668703076596231*^9}, {
   3.6687032983584623`*^9, 3.668703329036998*^9}, {3.668703359547501*^9, 
   3.668703364937311*^9}, {3.668703409385564*^9, 3.668703409598823*^9}, {
   3.668703451281674*^9, 3.6687034539581423`*^9}, {3.668703510951167*^9, 
   3.668703581870448*^9}, {3.6687039495461273`*^9, 3.668703986468754*^9}, {
   3.668704034787966*^9, 3.668704107158821*^9}, {3.66870434254609*^9, 
   3.668704391482483*^9}, {3.668704866202161*^9, 3.6687049166354513`*^9}, {
   3.6687049703789988`*^9, 3.668705016862217*^9}, {3.6687050581514177`*^9, 
   3.6687051409960737`*^9}, {3.6687051853865957`*^9, 3.66870519864028*^9}, {
   3.66870530439258*^9, 3.6687053058318567`*^9}, {3.668705396406801*^9, 
   3.6687054449499273`*^9}, {3.668705727226926*^9, 3.668705760863277*^9}, {
   3.6687209180348263`*^9, 3.668720939416154*^9}, 3.668722524214611*^9, {
   3.721457652040442*^9, 3.721457659126416*^9}, {3.7214577653528957`*^9, 
   3.721457851048711*^9}, {3.721457919819281*^9, 3.7214579203696547`*^9}, {
   3.721458310459865*^9, 3.7214583299327602`*^9}, {3.721458374957127*^9, 
   3.721458387725543*^9}, {3.721458441637535*^9, 3.721458517261661*^9}, {
   3.721458573941455*^9, 3.721458588881013*^9}, {3.721458621215254*^9, 
   3.7214586315983877`*^9}, {3.721458687018977*^9, 3.721458702386259*^9}, {
   3.721459211034535*^9, 3.7214592617629347`*^9}, {3.7214593029271*^9, 
   3.7214593145595713`*^9}, {3.721459425330224*^9, 3.721459425656097*^9}, {
   3.721463532835463*^9, 3.721463535309825*^9}, 3.721505197215242*^9, {
   3.721505468875614*^9, 3.7215054734755*^9}, {3.721508064655298*^9, 
   3.721508072182108*^9}, {3.7215081096316347`*^9, 3.721508112465963*^9}, {
   3.7215332454364023`*^9, 3.721533280851383*^9}, {3.7215334454449787`*^9, 
   3.721533455479636*^9}, {3.721533538115106*^9, 3.721533546765699*^9}, {
   3.7215353422374*^9, 3.721535357125392*^9}, 3.7215359945581007`*^9, {
   3.7215632700342817`*^9, 3.721563333620592*^9}, {3.721568349314021*^9, 
   3.721568355163103*^9}},ExpressionUUID->"fd64d276-fa87-42f9-8448-\
22d746827138"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"\"\<expression\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{
          "\"\<Input\>\"", "\[Rule]", 
           "\"\<3+(sqr(x-1/z)-12)^cosl+2*(3^0.1)+1/1\>\""}], "|>"}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Arithmetic Parse Tree\>\"", ",", "Orange", ",", " ", "Bold", 
             ",", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Parse\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"parser", "[", "#expression", "]"}], "&"}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.6687019387415037`*^9, {3.668702018945513*^9, 3.668702021362136*^9}, {
   3.6687020551480513`*^9, 3.668702107897636*^9}, {3.668702178807077*^9, 
   3.6687021958064547`*^9}, {3.668702239952825*^9, 3.6687023436087427`*^9}, {
   3.6687025518166237`*^9, 3.668702596420607*^9}, {3.668702652491873*^9, 
   3.6687026812797422`*^9}, {3.6687036692618027`*^9, 3.668703684450075*^9}, {
   3.7214581991277103`*^9, 3.721458199429619*^9}, {3.7214582473786182`*^9, 
   3.721458296733281*^9}, {3.721458338348125*^9, 3.721458357664834*^9}, 
   3.721458429093857*^9, {3.721458790532482*^9, 3.721458793028949*^9}, {
   3.72145885229639*^9, 3.7214588949001627`*^9}, {3.721459273923686*^9, 
   3.721459278513587*^9}, {3.721459437413912*^9, 3.721459471760054*^9}, {
   3.721459561797625*^9, 3.721459568389389*^9}, {3.721463500119329*^9, 
   3.721463506317503*^9}, 3.721463545830546*^9, 3.72146362007117*^9, {
   3.7214636580407143`*^9, 3.7214637336560707`*^9}, {3.721463766044441*^9, 
   3.7214637708248587`*^9}, 3.721508095043187*^9, 3.721533489347207*^9, 
   3.721534682279892*^9, {3.7215634053304157`*^9, 
   3.7215634132620077`*^9}},ExpressionUUID->"57bbb27d-b1a1-4aeb-806f-\
9f400116c866"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/915d4d42-b3e7-4d03-b571-\
60b204e0b94b\"",
     "https://www.wolframcloud.com/objects/915d4d42-b3e7-4d03-b571-\
60b204e0b94b"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/915d4d42-b3e7-4d03-b571-60b204e0b94b"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.668702440473839*^9, 3.668702599311335*^9, 3.668702630234618*^9, 
   3.66870276172163*^9, {3.668702884776046*^9, 3.6687029013214397`*^9}, 
   3.668702940803843*^9, 3.668703086106824*^9, 3.6687031423779497`*^9, 
   3.668703336512856*^9, 3.6687033694726467`*^9, 3.668703414525476*^9, 
   3.6687034594849052`*^9, {3.668703521112142*^9, 3.668703586411539*^9}, {
   3.668703678090148*^9, 3.668703687206891*^9}, 3.668703991240896*^9, 
   3.668704097623562*^9, 3.668704397243503*^9, 3.668705280205473*^9, 
   3.668705416430118*^9, 3.6687054505580053`*^9, 3.66870576754501*^9, 
   3.668720951596919*^9, 3.668722539478557*^9, 3.721458392959919*^9, 
   3.7214584315862827`*^9, {3.721458523281312*^9, 3.721458540233698*^9}, 
   3.721458636446863*^9, {3.7214586900420227`*^9, 3.7214587050497217`*^9}, 
   3.7214588022533007`*^9, 3.721458910416202*^9, 3.7214592803511543`*^9, 
   3.7214593180516233`*^9, {3.72145942949817*^9, 3.72145943871248*^9}, 
   3.721459473463122*^9, 3.721459572978836*^9, 3.72146350755993*^9, 
   3.7214635675093613`*^9, 3.721463631482452*^9, {3.721463671717452*^9, 
   3.721463692610738*^9}, 3.721463740218576*^9, 3.7214637714238977`*^9, 
   3.721505681368531*^9, {3.721508087606447*^9, 3.7215081154021397`*^9}, {
   3.72153349165814*^9, 3.72153349720348*^9}, 3.721533552074951*^9, 
   3.7215346840011873`*^9, 3.721563442261989*^9, 
   3.721568380596117*^9},ExpressionUUID->"e562aa68-3535-4508-84f2-\
ff0a676b36e0"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  "\"\<(2*(3-1/4)+3.5^(x-1))/(x^2)\>\""}]], "Input",
 CellChangeTimes->{{3.721533386443975*^9, 
  3.721533386854467*^9}},ExpressionUUID->"b03cc2ca-5bb5-4e5e-8b4c-\
2b266070367f"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(2*(3-1/4)+3.5^(x-1))/(x^2)\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression", "=", 
   RowBox[{"StringReplace", "[", 
    RowBox[{"expression0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<+\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], ",", 
       RowBox[{"\"\<-\>\"", "->", " ", "\"\<\[Diamond]\>\""}], ",", 
       RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\[CircleTimes]\>\""}], ",", 
       RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\[SmallCircle]\>\""}], ",", 
       RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<\[Wedge]\>\""}], ",", 
       RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<sqr@\>\""}], ",", 
       RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<sin@\>\""}], ",", 
       RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<cos@\>\""}]}], "}"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TreeForm", "[", 
   RowBox[{
    RowBox[{"ToExpression", "@", "expression"}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
    RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}], ",", 
    RowBox[{"CircleTimes", "\[Rule]", "\"\<*\>\""}], ",", " ", 
    RowBox[{"SmallCircle", "\[Rule]", "\"\</\>\""}], ",", 
    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
    RowBox[{"Wedge", "\[Rule]", "\"\<^\>\""}], ",", 
    RowBox[{"Diamond", "\[Rule]", "\"\<-\>\""}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.721458607085268*^9, 3.721458611066403*^9}, 
   3.721458904644861*^9, {3.721459118152174*^9, 3.721459141349493*^9}, {
   3.72145917736658*^9, 3.7214592000138397`*^9}, {3.7214593400096283`*^9, 
   3.721459415643203*^9}, 3.721505588815546*^9, {3.721507660832012*^9, 
   3.7215076659944067`*^9}, {3.72150770585565*^9, 3.7215078494319487`*^9}, {
   3.721507892937779*^9, 3.7215080387083483`*^9}, {3.721533304616399*^9, 
   3.721533336473034*^9}, {3.7215333948300657`*^9, 3.721533418150833*^9}, 
   3.7215334663174257`*^9, 3.7215632509361763`*^9, {3.721563340440113*^9, 
   3.721563419698842*^9}, {3.721568281548431*^9, 
   3.7215683279340982`*^9}},ExpressionUUID->"f44ed7bd-73cf-4d11-8b92-\
5f68b0085256"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{2.2395410336608657`, 4.071892788474301}, {
    1.2215678365422902`, 3.257514230779441}, {0.4071892788474301, 
    2.443135673084581}, {0., 1.6287571153897207`}, {0.8143785576948602, 
    1.6287571153897207`}, {0.4071892788474301, 0.8143785576948601}, {
    1.2215678365422902`, 0.8143785576948601}, {0.8143785576948602, 0.}, {
    1.6287571153897205`, 0.}, {2.0359463942371505`, 2.443135673084581}, {
    1.6287571153897205`, 1.6287571153897207`}, {2.4431356730845804`, 
    1.6287571153897207`}, {2.0359463942371505`, 0.8143785576948601}, {
    2.8503249519320106`, 0.8143785576948601}, {3.257514230779441, 
    3.257514230779441}, {2.8503249519320106`, 2.443135673084581}, {
    3.6647035096268707`, 2.443135673084581}}, {
     {RGBColor[0.55, 0.45, 0.45], 
      LineBox[{{1, 2}, {1, 15}, {2, 3}, {2, 10}, {3, 4}, {3, 5}, {5, 6}, {5, 
       7}, {7, 8}, {7, 9}, {10, 11}, {10, 12}, {12, 13}, {12, 14}, {15, 16}, {
       15, 17}}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"/\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 1],
        TagBox[
         RowBox[{"\"/\"", "[", 
           RowBox[{
             RowBox[{"\"+\"", "[", 
               RowBox[{
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"2", ",", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{"3", ",", 
                    RowBox[{"\"/\"", "[", 
                    RowBox[{"1", ",", "4"}], "]"}]}], "]"}]}], "]"}], ",", 
                 RowBox[{"\"^\"", "[", 
                   RowBox[{"3.5`", ",", 
                    RowBox[{"\"-\"", "[", 
                    RowBox[{"x", ",", "1"}], "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"\"^\"", "[", 
               RowBox[{"x", ",", "2"}], "]"}]}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "/"[
          "+"[
           "*"[2, 
            "-"[3, 
             "/"[1, 4]]], 
           "^"[3.5, 
            "-"[$CellContext`x, 1]]], 
          "^"[$CellContext`x, 2]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"+\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 2],
        TagBox[
         RowBox[{"\"+\"", "[", 
           RowBox[{
             RowBox[{"\"*\"", "[", 
               RowBox[{"2", ",", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{"3", ",", 
                    RowBox[{"\"/\"", "[", 
                    RowBox[{"1", ",", "4"}], "]"}]}], "]"}]}], "]"}], ",", 
             RowBox[{"\"^\"", "[", 
               RowBox[{"3.5`", ",", 
                 RowBox[{"\"-\"", "[", 
                   RowBox[{"x", ",", "1"}], "]"}]}], "]"}]}], "]"}], 
         HoldForm]],
       Annotation[#, 
        HoldForm[
         "+"[
          "*"[2, 
           "-"[3, 
            "/"[1, 4]]], 
          "^"[3.5, 
           "-"[$CellContext`x, 1]]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"*\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 3],
        TagBox[
         RowBox[{"\"*\"", "[", 
           RowBox[{"2", ",", 
             RowBox[{"\"-\"", "[", 
               RowBox[{"3", ",", 
                 RowBox[{"\"/\"", "[", 
                   RowBox[{"1", ",", "4"}], "]"}]}], "]"}]}], "]"}], 
         HoldForm]],
       Annotation[#, 
        HoldForm[
         "*"[2, 
          "-"[3, 
           "/"[1, 4]]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 4],
        TagBox["2", HoldForm]],
       Annotation[#, 
        HoldForm[2], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"-\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 5],
        TagBox[
         RowBox[{"\"-\"", "[", 
           RowBox[{"3", ",", 
             RowBox[{"\"/\"", "[", 
               RowBox[{"1", ",", "4"}], "]"}]}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "-"[3, 
          "/"[1, 4]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["3",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 6],
        TagBox["3", HoldForm]],
       Annotation[#, 
        HoldForm[3], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"/\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 7],
        TagBox[
         RowBox[{"\"/\"", "[", 
           RowBox[{"1", ",", "4"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "/"[1, 4]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 8],
        TagBox["1", HoldForm]],
       Annotation[#, 
        HoldForm[1], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["4",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 9],
        TagBox["4", HoldForm]],
       Annotation[#, 
        HoldForm[4], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"^\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 10],
        TagBox[
         RowBox[{"\"^\"", "[", 
           RowBox[{"3.5`", ",", 
             RowBox[{"\"-\"", "[", 
               RowBox[{"x", ",", "1"}], "]"}]}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "^"[3.5, 
          "-"[$CellContext`x, 1]]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["3.5`",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 11],
        TagBox["3.5`", HoldForm]],
       Annotation[#, 
        HoldForm[3.5], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"-\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 12],
        TagBox[
         RowBox[{"\"-\"", "[", 
           RowBox[{"x", ",", "1"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "-"[$CellContext`x, 1]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["x",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 13],
        TagBox["x", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`x], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 14],
        TagBox["1", HoldForm]],
       Annotation[#, 
        HoldForm[1], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"^\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 15],
        TagBox[
         RowBox[{"\"^\"", "[", 
           RowBox[{"x", ",", "2"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "^"[$CellContext`x, 2]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["x",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 16],
        TagBox["x", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`x], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 17],
        TagBox["2", HoldForm]],
       Annotation[#, 
        HoldForm[2], "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{2.2395410336608657`, 4.071892788474301}, {
     1.2215678365422902`, 3.257514230779441}, {0.4071892788474301, 
     2.443135673084581}, {0., 1.6287571153897207`}, {0.8143785576948602, 
     1.6287571153897207`}, {0.4071892788474301, 0.8143785576948601}, {
     1.2215678365422902`, 0.8143785576948601}, {0.8143785576948602, 0.}, {
     1.6287571153897205`, 0.}, {2.0359463942371505`, 2.443135673084581}, {
     1.6287571153897205`, 1.6287571153897207`}, {2.4431356730845804`, 
     1.6287571153897207`}, {2.0359463942371505`, 0.8143785576948601}, {
     2.8503249519320106`, 0.8143785576948601}, {3.257514230779441, 
     3.257514230779441}, {2.8503249519320106`, 2.443135673084581}, {
     3.6647035096268707`, 2.443135673084581}}]& ],
  AspectRatio->NCache[2^Rational[1, 2], 1.4142135623730951`],
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  ImageSize->400,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.7214586113888197`*^9, 3.721458905928978*^9, {3.721459121518505*^9, 
   3.721459142708028*^9}, {3.721459187015172*^9, 3.721459202167267*^9}, 
   3.721459342629443*^9, {3.72145938467521*^9, 3.721459415983945*^9}, 
   3.7215055893181763`*^9, 3.7215076666974697`*^9, 3.721507767016193*^9, {
   3.721507802430295*^9, 3.721507830492709*^9}, {3.721507918744638*^9, 
   3.7215079259007893`*^9}, {3.721507969804599*^9, 3.7215080390757236`*^9}, {
   3.721533320309663*^9, 3.721533337702797*^9}, 3.721533419818666*^9, 
   3.72153346754296*^9, 3.721563251983988*^9, {3.7215633518371058`*^9, 
   3.721563420882601*^9}, 3.7215672446849194`*^9, {3.7215682844737873`*^9, 
   3.721568328322133*^9}},ExpressionUUID->"31bb6809-44b0-4091-9ca1-\
c76bfe5406f9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(4-1)+A^B+1/(x-0.3)\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression", "=", 
   RowBox[{"StringReplace", "[", 
    RowBox[{"expression0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<+\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], ",", 
       RowBox[{"\"\<-\>\"", "->", " ", "\"\<\[Diamond]\>\""}], ",", 
       RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\[CircleTimes]\>\""}], ",", 
       RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\[SmallCircle]\>\""}], ",", 
       RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<\[Wedge]\>\""}], ",", 
       RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<sqr@\>\""}], ",", 
       RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<sin@\>\""}], ",", 
       RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<cos@\>\""}]}], "}"}]}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", "\"\< \>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"i", "=", 
   RowBox[{"-", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"levels", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"While", "[", 
    RowBox[{
     RowBox[{"s", "=!=", 
      RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"i", "++"}], ";", "\[IndentingNewLine]", 
      RowBox[{"s", "=", 
       RowBox[{
        RowBox[{"Level", "[", 
         RowBox[{
          RowBox[{"ToExpression", "@", "expression"}], ",", 
          RowBox[{"{", "i", "}"}]}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
          RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
          RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}], ",", 
          RowBox[{"CircleTimes", "\[Rule]", "\"\<*\>\""}], ",", " ", 
          RowBox[{"SmallCircle", "\[Rule]", "\"\</\>\""}], ",", 
          RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
          RowBox[{"Wedge", "\[Rule]", "\"\<^\>\""}], ",", 
          RowBox[{"Diamond", "\[Rule]", "\"\<-\>\""}]}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{"levels", ",", 
           RowBox[{"StringReplace", "[", 
            RowBox[{
             RowBox[{"ToString", "[", "s", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"\"\<[\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
               RowBox[{"\"\<]\>\"", "\[Rule]", "\"\<)\>\""}]}], "}"}]}], 
            "]"}]}], "]"}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"AppendTo", "[", 
       RowBox[{"levels", ",", "s"}], "]"}]}]}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Column", "@", "levels"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.721567250983*^9, 3.721567272120963*^9}, 
   3.721567376611478*^9, {3.72156752258463*^9, 3.721567564413392*^9}, {
   3.721567659288703*^9, 3.7215677190614557`*^9}, {3.721567785125256*^9, 
   3.721567788307822*^9}, {3.721567852874734*^9, 3.721568137891128*^9}, {
   3.7215681976999493`*^9, 3.7215682275349207`*^9}, {3.721568446514331*^9, 
   3.7215685539092484`*^9}, {3.721568794761298*^9, 3.72156880028118*^9}, {
   3.721583930733309*^9, 
   3.721583946697925*^9}},ExpressionUUID->"2c14c047-3f65-49ff-a955-\
dc6715f3932c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"\<\"+\"\>", "[", 
       RowBox[{
        RowBox[{"\<\"-\"\>", "[", 
         RowBox[{"4", ",", "1"}], "]"}], ",", 
        RowBox[{"\<\"^\"\>", "[", 
         RowBox[{"A", ",", "B"}], "]"}], ",", 
        RowBox[{"\<\"/\"\>", "[", 
         RowBox[{"1", ",", 
          RowBox[{"\<\"-\"\>", "[", 
           RowBox[{"x", ",", "0.3`"}], "]"}]}], "]"}]}], "]"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\<\"-\"\>", "[", 
        RowBox[{"4", ",", "1"}], "]"}], ",", 
       RowBox[{"\<\"^\"\>", "[", 
        RowBox[{"A", ",", "B"}], "]"}], ",", 
       RowBox[{"\<\"/\"\>", "[", 
        RowBox[{"1", ",", 
         RowBox[{"\<\"-\"\>", "[", 
          RowBox[{"x", ",", "0.3`"}], "]"}]}], "]"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "1", ",", "A", ",", "B", ",", "1", ",", 
       RowBox[{"\<\"-\"\>", "[", 
        RowBox[{"x", ",", "0.3`"}], "]"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"x", ",", "0.3`"}], "}"}]},
    {
     RowBox[{"{", "}"}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.72156851894773*^9, 3.7215685544903*^9}, 
   3.721568800804113*^9, 3.7215838465725183`*^9, 
   3.721583947728516*^9},ExpressionUUID->"76aa01d2-7d7d-4d59-aa8e-\
d4c76629d9c3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"parserLEVELS", "[", "expression0_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"expression", ",", "s", ",", "i", ",", "levels"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"expression", "=", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"expression0", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<+\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], ",", 
           RowBox[{"\"\<-\>\"", "->", " ", "\"\<\[Diamond]\>\""}], ",", 
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\[CircleTimes]\>\""}], ",", 
           RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\[SmallCircle]\>\""}], ",", 
           RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<\[Wedge]\>\""}], ",", 
           RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<sqr@\>\""}], ",", 
           RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<sin@\>\""}], ",", 
           RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<cos@\>\""}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"s", "=", "\"\< \>\""}], ";", "\[IndentingNewLine]", 
      RowBox[{"i", "=", 
       RowBox[{"-", "1"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"levels", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{"s", "=!=", 
         RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"i", "++"}], ";", "\[IndentingNewLine]", 
         RowBox[{"s", "=", 
          RowBox[{
           RowBox[{"Level", "[", 
            RowBox[{
             RowBox[{"ToExpression", "@", "expression"}], ",", 
             RowBox[{"{", "i", "}"}]}], "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
             RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
             RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}], ",", 
             RowBox[{"CircleTimes", "\[Rule]", "\"\<*\>\""}], ",", " ", 
             RowBox[{"SmallCircle", "\[Rule]", "\"\</\>\""}], ",", 
             RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
             RowBox[{"Wedge", "\[Rule]", "\"\<^\>\""}], ",", 
             RowBox[{"Diamond", "\[Rule]", "\"\<-\>\""}]}], "}"}]}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"AppendTo", "[", 
          RowBox[{"levels", ",", 
           RowBox[{"{", 
            RowBox[{"StringReplace", "[", 
             RowBox[{
              RowBox[{"ToString", "[", "s", "]"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"\"\<[\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
                RowBox[{"\"\<]\>\"", "\[Rule]", "\"\<)\>\""}]}], "}"}]}], 
             "]"}], "}"}]}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Grid", "[", 
       RowBox[{
        RowBox[{"Drop", "[", 
         RowBox[{"levels", ",", 
          RowBox[{"-", "1"}]}], "]"}], ",", 
        RowBox[{"Alignment", "\[Rule]", "Left"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.72156860715869*^9, 3.7215686455023613`*^9}, 
   3.721568687519763*^9, {3.7215688242007923`*^9, 3.7215688294994793`*^9}, {
   3.7215688834342546`*^9, 
   3.721568934366186*^9}},ExpressionUUID->"416472b4-1cce-4ba2-9e5e-\
2c688ea0aadd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"parserLEVELS", "[", "\"\<(4-1)+sqr(B)+1/(x-0.3)\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{3.7215686637498837`*^9, 
  3.721583634381155*^9},ExpressionUUID->"18b66de8-af22-4772-9c3b-\
5857a4af9ba8"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"{+(-(4, 1), sqr(B), /(1, -(x, 0.3)))}\"\>"},
    {"\<\"{-(4, 1), sqr(B), /(1, -(x, 0.3))}\"\>"},
    {"\<\"{4, 1, B, 1, -(x, 0.3)}\"\>"},
    {"\<\"{x, 0.3}\"\>"}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.721568665549163*^9, 3.721568690302203*^9}, 
   3.721568831590932*^9, {3.7215689285351763`*^9, 3.721568936690401*^9}, 
   3.721583635843974*^9},ExpressionUUID->"a595b3f7-7516-491c-9884-\
ace7de8da59f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormPage", "[", 
    RowBox[{
     RowBox[{"FormObject", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"\"\<expression\>\"", "->", 
         RowBox[{"<|", 
          RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<(4-1)+A^B+1/(x-0.3)\>\""}],
           "|>"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"AppearanceRules", "\[Rule]", 
        RowBox[{"<|", 
         RowBox[{
          RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
           RowBox[{"Style", "[", 
            RowBox[{
            "\"\<Arithmetic Parse Levels\>\"", ",", "Orange", ",", " ", 
             "Bold", ",", 
             RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
          RowBox[{
          "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Levels\>\""}]}], 
         "|>"}]}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"parserLEVELS", "[", "#expression", "]"}], "&"}]}], "]"}], ",", 
   
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.721568710807722*^9, 
  3.721568766361538*^9}},ExpressionUUID->"c9319bbd-aaf4-4369-bb65-\
bfb5d311e58b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/0ffd4390-27c9-463d-85f9-\
18f286f4df9a\"",
     "https://www.wolframcloud.com/objects/0ffd4390-27c9-463d-85f9-\
18f286f4df9a"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/0ffd4390-27c9-463d-85f9-18f286f4df9a"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{3.721568736115205*^9, 3.721568767760284*^9, 
  3.72156883869383*^9, 
  3.721568942740231*^9},ExpressionUUID->"0b96d0f4-6bd1-4ac0-a875-\
a057c53738d3"]
}, Open  ]]
},
WindowSize->{1259, 1088},
WindowMargins->{{Automatic, 650}, {130, Automatic}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"89b774c6-cd65-4d3e-bc2d-de95a38cf98f"],
Cell[1747, 54, 6498, 130, 577, "Input",ExpressionUUID->"fd64d276-fa87-42f9-8448-22d746827138"],
Cell[CellGroupData[{
Cell[8270, 188, 2385, 47, 178, "Input",ExpressionUUID->"57bbb27d-b1a1-4aeb-806f-9f400116c866"],
Cell[10658, 237, 1867, 33, 37, "Output",ExpressionUUID->"e562aa68-3535-4508-84f2-ff0a676b36e0"]
}, Open  ]],
Cell[12540, 273, 225, 5, 52, "Input",ExpressionUUID->"b03cc2ca-5bb5-4e5e-8b4c-2b266070367f"],
Cell[CellGroupData[{
Cell[12790, 282, 2247, 44, 94, "Input",ExpressionUUID->"f44ed7bd-73cf-4d11-8b92-5f68b0085256"],
Cell[15040, 328, 15650, 427, 593, "Output",ExpressionUUID->"31bb6809-44b0-4091-9ca1-c76bfe5406f9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30727, 760, 3375, 77, 304, "Input",ExpressionUUID->"2c14c047-3f65-49ff-a955-dc6715f3932c"],
Cell[34105, 839, 1456, 43, 105, "Output",ExpressionUUID->"76aa01d2-7d7d-4d59-aa8e-d4c76629d9c3"]
}, Open  ]],
Cell[35576, 885, 3452, 75, 346, "Input",ExpressionUUID->"416472b4-1cce-4ba2-9e5e-2c688ea0aadd"],
Cell[CellGroupData[{
Cell[39053, 964, 223, 5, 30, "Input",ExpressionUUID->"18b66de8-af22-4772-9c3b-5857a4af9ba8"],
Cell[39279, 971, 599, 14, 87, "Output",ExpressionUUID->"a595b3f7-7516-491c-9884-ace7de8da59f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39915, 990, 1290, 31, 178, "Input",ExpressionUUID->"c9319bbd-aaf4-4369-bb65-bfb5d311e58b"],
Cell[41208, 1023, 586, 15, 37, "Output",ExpressionUUID->"0b96d0f4-6bd1-4ac0-a875-a057c53738d3"]
}, Open  ]]
}
]
*)

