(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    126051,       2550]
NotebookOptionsPosition[    123196,       2496]
NotebookOutlinePosition[    123581,       2513]
CellTagsIndexPosition[    123538,       2510]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"94123e90-0ee0-4fe0-9738-\
3d78bfc33376"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"PNG", "\[Equal]", "True"}], ",", 
     RowBox[{"ImportString", "@", 
      RowBox[{"ExportString", "[", 
       RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}], ",", "s"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"highlightCORRECT", "[", "s_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"debug", "\[Equal]", "False"}], ",", "s", ",", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PNG", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debug", "=", "True"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myFONTSIZE", "=", "16"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myLINEBREAKS", "=", "40"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textFORMAT", "[", "s_", "]"}], ":=", 
   RowBox[{"Text", "[", 
    RowBox[{"Style", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"InsertLinebreaks", "[", 
       RowBox[{
        RowBox[{"ToString", "@", "s"}], ",", "myLINEBREAKS"}], "]"}], ",", 
      "myFONTSIZE", ",", 
      RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"textFORMAT2", "[", "s_", "]"}], ":=", 
    RowBox[{"Text", "[", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"InsertLinebreaks", "[", 
        RowBox[{"s", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
       RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
    "FIXME", " ", "did", " ", "not", " ", "work", " ", "for", " ", "cloud", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Needs", "[", "\"\<Notation`\>\"", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"op_", " ", "x_", " ", "y_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"op_", "[", 
          RowBox[{"x_", ",", "y_"}], "]"}]},
       "NotationTemplateTag"]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"Notation", "[", 
     RowBox[{
      TemplateBox[{RowBox[{"(", 
          RowBox[{"op_", " ", "x_"}], ")"}]},
       "NotationTemplateTag"], " ", "\[DoubleLongRightArrow]", " ", 
      TemplateBox[{RowBox[{"op_", "[", "x_", "]"}]},
       "NotationTemplateTag"]}], "]"}], ";"}], "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"parserPREFIX", "[", "expression00_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "expression0", ",", "expression", ",", "expression2", ",", 
        "expression3", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", 
        "f", ",", "g", ",", "h", ",", "i", ",", "j", ",", "k", ",", "l", ",", 
        "m", ",", "n", ",", "o", ",", "p", ",", "q", ",", "r", ",", "s", ",", 
        "t", ",", "u", ",", "v", ",", "w", ",", "x", ",", "y", ",", "z", ",", 
        "A", ",", "B", ",", "C", ",", "D", ",", "E", ",", "F", ",", "G", ",", 
        "H", ",", "I", ",", "J", ",", "K", ",", "L", ",", "M", ",", "N", ",", 
        "O", ",", "P", ",", "Q", ",", "R", ",", "S", ",", "T", ",", "U", ",", 
        "V", ",", "W", ",", "X", ",", "Y", ",", "Z"}], "}"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"myPARAN3", "[", "x_", "]"}], ":=", 
        RowBox[{"Row", "@", 
         RowBox[{"{", 
          RowBox[{"\"\<(\>\"", ",", "x", ",", "\"\<)\>\""}], "}"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"myPLUS", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
             RowBox[{"x0", "=", 
              RowBox[{"ToString", "@", "x"}]}], ",", 
             RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
             RowBox[{"y0", "=", 
              RowBox[{"ToString", "@", "y"}]}], ",", 
             RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Plus", "[", 
            RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"myTIMES", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
             RowBox[{"x0", "=", 
              RowBox[{"ToString", "@", "x"}]}], ",", 
             RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
             RowBox[{"y0", "=", 
              RowBox[{"ToString", "@", "y"}]}], ",", 
             RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Times", "[", 
            RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"myPLUS2", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
             RowBox[{"x0", "=", 
              RowBox[{"myPARAN3", "[", 
               RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
             RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
             RowBox[{"y0", "=", 
              RowBox[{"myPARAN3", "[", 
               RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
             RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Plus", "[", 
            RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"myTIMES2", "[", 
         RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
             RowBox[{"x0", "=", 
              RowBox[{"myPARAN3", "[", 
               RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
             RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
             RowBox[{"y0", "=", 
              RowBox[{"myPARAN3", "[", 
               RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
             RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Times", "[", 
            RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"myPNG", "@", 
        RowBox[{"Column", "@", 
         RowBox[{
         "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"expression0", "=", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"StringReplace", "[", 
                RowBox[{"expression00", ",", 
                 RowBox[{"{", 
                  RowBox[{"\"\<  \>\"", "\[Rule]", "\"\<\[SuchThat]\>\""}], 
                  "}"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<)\[SuchThat]\>\"", "\[Rule]", "\"\<) \>\""}], 
                 ",", 
                 RowBox[{"\"\<\[SuchThat]\>\"", "\[Rule]", "\"\<\>\""}]}], 
                "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"expression", "=", 
             RowBox[{"StringReplace", "[", 
              RowBox[{
               RowBox[{"StringReplace", "[", 
                RowBox[{"expression0", ",", 
                 RowBox[{
                 "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                   RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                   RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", 
                   RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                   ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   
                   RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   
                   RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   
                   RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   
                   RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", 
                   RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   
                   RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                   RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
                   RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                 "\"\<Plus\>\"", "\[Rule]", "\"\<CCNPREFIX`Plus2\>\""}], ",", 
                 
                 RowBox[{
                 "\"\<Times\>\"", "\[Rule]", "\"\<CCNPREFIX`Times2\>\""}], 
                 ",", 
                 RowBox[{
                 "\"\<Subtract\>\"", "\[Rule]", 
                  "\"\<CCNPREFIX`Subtract2\>\""}]}], "}"}]}], "]"}]}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"expression2", "=", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"expression0", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 
                 RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"(*", 
                  RowBox[{
                   RowBox[{"\"\< (\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
                   RowBox[{"\"\<( \>\"", "\[Rule]", "\"\<[\>\""}], ",", 
                   RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ","}], 
                  "*)"}], 
                 RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                 RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                 RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
                 RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
              "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"expression2", "=", 
             RowBox[{"StringReplace", "[", 
              RowBox[{"expression0", ",", 
               RowBox[{
               "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                 RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 
                 RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], 
                 ",", 
                 RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 
                 RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
                 RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
                 RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
              "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"Expand", "@", 
             RowBox[{"ToExpression", "@", "expression2"}]}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TreeForm", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"ToExpression", "@", "expression"}], ")"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"CCNPREFIX`Plus2", "\[Rule]", "\"\<+\>\""}], ",", 
              RowBox[{"CCNPREFIX`Times2", "\[Rule]", "\"\<*\>\""}], ",", " ", 
              
              RowBox[{"CCNPREFIX`Subtract2", "\[Rule]", "\"\<-\>\""}]}], 
             "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "}"}]}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"parserPREFIX2", "[", "expression00_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "expression0", ",", "expression", ",", "expression2", ",", 
       "expression3", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", 
       "f", ",", "g", ",", "h", ",", "i", ",", "j", ",", "k", ",", "l", ",", 
       "m", ",", "n", ",", "o", ",", "p", ",", "q", ",", "r", ",", "s", ",", 
       "t", ",", "u", ",", "v", ",", "w", ",", "x", ",", "y", ",", "z", ",", 
       "A", ",", "B", ",", "C", ",", "D", ",", "E", ",", "F", ",", "G", ",", 
       "H", ",", "I", ",", "J", ",", "K", ",", "L", ",", "M", ",", "N", ",", 
       "O", ",", "P", ",", "Q", ",", "R", ",", "S", ",", "T", ",", "U", ",", 
       "V", ",", "W", ",", "X", ",", "Y", ",", "Z"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"myPARAN3", "[", "x_", "]"}], ":=", 
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", "x", ",", "\"\<)\>\""}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"myPLUS", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
            RowBox[{"x0", "=", 
             RowBox[{"ToString", "@", "x"}]}], ",", 
            RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
            RowBox[{"y0", "=", 
             RowBox[{"ToString", "@", "y"}]}], ",", 
            RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Plus", "[", 
           RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"myTIMES", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
            RowBox[{"x0", "=", 
             RowBox[{"ToString", "@", "x"}]}], ",", 
            RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
            RowBox[{"y0", "=", 
             RowBox[{"ToString", "@", "y"}]}], ",", 
            RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Times", "[", 
           RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"myPLUS2", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
            RowBox[{"x0", "=", 
             RowBox[{"myPARAN3", "[", 
              RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
            RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
            RowBox[{"y0", "=", 
             RowBox[{"myPARAN3", "[", 
              RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
            RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Plus", "[", 
           RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"myTIMES2", "[", 
        RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
            RowBox[{"x0", "=", 
             RowBox[{"myPARAN3", "[", 
              RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
            RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
            RowBox[{"y0", "=", 
             RowBox[{"myPARAN3", "[", 
              RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
            RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Times", "[", 
           RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"expression0", "=", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"StringReplace", "[", 
          RowBox[{"expression00", ",", 
           RowBox[{"{", 
            RowBox[{"\"\<  \>\"", "\[Rule]", "\"\<\[SuchThat]\>\""}], "}"}]}],
           "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<)\[SuchThat]\>\"", "\[Rule]", "\"\<) \>\""}], ",", 
           RowBox[{"\"\<\[SuchThat]\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"expression", "=", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"StringReplace", "[", 
          RowBox[{"expression0", ",", 
           RowBox[{
           "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<Plus\>\"", "\[Rule]", "\"\<CCNPREFIX`Plus2\>\""}], 
           ",", 
           RowBox[{"\"\<Times\>\"", "\[Rule]", "\"\<CCNPREFIX`Times2\>\""}], 
           ",", 
           RowBox[{
           "\"\<Subtract\>\"", "\[Rule]", "\"\<CCNPREFIX`Subtract2\>\""}]}], 
          "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"expression2", "=", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"expression0", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"\"\< (\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
             RowBox[{"\"\<( \>\"", "\[Rule]", "\"\<[\>\""}], ",", 
             RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ","}], "*)"}], 
           RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
           RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
           RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
           RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"expression2", "=", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"expression0", ",", 
         RowBox[{
         "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
           RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
           RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
           RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\"\<expression2\>\"", "->", "expression2"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"\"\<evaluated\>\"", "->", 
         RowBox[{"Expand", "@", 
          RowBox[{"ToExpression", "@", "expression2"}]}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<tree\>\"", "->", 
          RowBox[{"TreeForm", "[", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"ToExpression", "@", "expression"}], ")"}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"CCNPREFIX`Plus2", "\[Rule]", "\"\<+\>\""}], ",", 
           RowBox[{"CCNPREFIX`Times2", "\[Rule]", "\"\<*\>\""}], ",", " ", 
           RowBox[{"CCNPREFIX`Subtract2", "\[Rule]", "\"\<-\>\""}]}], 
          "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}],
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.668701916815751*^9, 3.66870193624583*^9}, {
   3.668702133786916*^9, 3.668702134347089*^9}, 3.6687022853581867`*^9, {
   3.6687023887130537`*^9, 3.668702431753148*^9}, {3.668702614804088*^9, 
   3.668702625199012*^9}, {3.6687027298143806`*^9, 3.668702756813094*^9}, {
   3.668702877190712*^9, 3.668702935882134*^9}, {3.66870296651546*^9, 
   3.66870298115119*^9}, {3.6687030616129713`*^9, 3.668703076596231*^9}, {
   3.6687032983584623`*^9, 3.668703329036998*^9}, {3.668703359547501*^9, 
   3.668703364937311*^9}, {3.668703409385564*^9, 3.668703409598823*^9}, {
   3.668703451281674*^9, 3.6687034539581423`*^9}, {3.668703510951167*^9, 
   3.668703581870448*^9}, {3.6687039495461273`*^9, 3.668703986468754*^9}, {
   3.668704034787966*^9, 3.668704107158821*^9}, {3.66870434254609*^9, 
   3.668704391482483*^9}, {3.668704866202161*^9, 3.6687049166354513`*^9}, {
   3.6687049703789988`*^9, 3.668705016862217*^9}, {3.6687050581514177`*^9, 
   3.6687051409960737`*^9}, {3.6687051853865957`*^9, 3.66870519864028*^9}, {
   3.66870530439258*^9, 3.6687053058318567`*^9}, {3.668705396406801*^9, 
   3.6687054449499273`*^9}, {3.668705727226926*^9, 3.668705760863277*^9}, {
   3.6687209180348263`*^9, 3.668720939416154*^9}, 3.668722524214611*^9, {
   3.721457652040442*^9, 3.721457659126416*^9}, {3.7214577653528957`*^9, 
   3.721457851048711*^9}, {3.721457919819281*^9, 3.7214579203696547`*^9}, {
   3.721458310459865*^9, 3.7214583299327602`*^9}, {3.721458374957127*^9, 
   3.721458387725543*^9}, {3.721458441637535*^9, 3.721458517261661*^9}, {
   3.721458573941455*^9, 3.721458588881013*^9}, {3.721458621215254*^9, 
   3.7214586315983877`*^9}, {3.721458687018977*^9, 3.721458702386259*^9}, {
   3.721459211034535*^9, 3.7214592617629347`*^9}, {3.7214593029271*^9, 
   3.7214593145595713`*^9}, {3.721459425330224*^9, 3.721459425656097*^9}, {
   3.721463532835463*^9, 3.721463535309825*^9}, 3.721505197215242*^9, {
   3.721505468875614*^9, 3.7215054734755*^9}, {3.721508064655298*^9, 
   3.721508072182108*^9}, {3.7215081096316347`*^9, 3.721508112465963*^9}, {
   3.7215332454364023`*^9, 3.721533280851383*^9}, {3.7215334454449787`*^9, 
   3.721533455479636*^9}, {3.721533538115106*^9, 3.721533546765699*^9}, {
   3.7215353422374*^9, 3.721535357125392*^9}, {3.721537407470562*^9, 
   3.7215374212735233`*^9}, {3.721539125107892*^9, 3.721539138551162*^9}, {
   3.7215405060691433`*^9, 3.721540506968492*^9}, {3.721540581356291*^9, 
   3.721540592314699*^9}, {3.72154064075102*^9, 3.7215406647363453`*^9}, {
   3.7215408284710817`*^9, 3.7215408309902887`*^9}, 3.721541107964315*^9, {
   3.721541263446815*^9, 3.7215412798354*^9}, 3.721541312529853*^9, {
   3.7215418378661213`*^9, 3.7215418384277554`*^9}, 3.721541895291453*^9, {
   3.721542291392674*^9, 3.721542297118072*^9}, 3.721542397291991*^9, {
   3.7215425837558527`*^9, 3.7215425940376863`*^9}, {3.721542639220544*^9, 
   3.721542639559017*^9}, {3.721542682480888*^9, 3.72154268271303*^9}, {
   3.721765931290331*^9, 3.7217659336393957`*^9}, {3.721766237379463*^9, 
   3.721766238097559*^9}, {3.721769349491749*^9, 3.721769358333272*^9}, {
   3.721774741210005*^9, 3.721774753290792*^9}, {3.721785268290381*^9, 
   3.721785282441472*^9}, {3.721785435458219*^9, 3.7217854816182137`*^9}, {
   3.721785559821692*^9, 3.721785562677773*^9}, {3.72178563412923*^9, 
   3.721785690256213*^9}, {3.721785754272039*^9, 3.721785763698882*^9}, {
   3.72178579436852*^9, 3.721785794738759*^9}, {3.7217858342060738`*^9, 
   3.721785846028675*^9}, {3.721785889826733*^9, 3.721785890096363*^9}, {
   3.7217859409485617`*^9, 3.7217859462352962`*^9}, {3.721786098096448*^9, 
   3.721786150565176*^9}, {3.72178674788689*^9, 3.721786779236899*^9}, 
   3.721786909690407*^9, {3.7217869528092117`*^9, 3.721786964734845*^9}, {
   3.72178708104034*^9, 3.721787124344096*^9}, {3.721787236815797*^9, 
   3.7217872722751904`*^9}, {3.7491581731220913`*^9, 3.749158190985878*^9}, {
   3.749158273349256*^9, 3.7491582804251623`*^9}, {3.749158324808793*^9, 
   3.749158363181898*^9}, {3.749158843728718*^9, 3.749158867304412*^9}, {
   3.749158992682386*^9, 3.749159003525713*^9}, {3.749159066556696*^9, 
   3.7491590684677563`*^9}, {3.749159128708047*^9, 3.749159200029652*^9}, {
   3.749159255641363*^9, 3.7491592732900963`*^9}, {3.749159351108261*^9, 
   3.749159435775964*^9}, {3.749159541698084*^9, 3.749159543496912*^9}, {
   3.7491595924947367`*^9, 3.749159595586443*^9}, {3.7491596740913277`*^9, 
   3.749159756722547*^9}, {3.749159830412429*^9, 3.749159848370364*^9}, {
   3.7491599202267838`*^9, 3.749159962600975*^9}, {3.749160145275962*^9, 
   3.7491602043669367`*^9}, {3.749160251797719*^9, 3.749160277408699*^9}, 
   3.749160388073368*^9, {3.749160671028319*^9, 3.7491608113507223`*^9}, 
   3.749160854377911*^9, {3.7491608895511427`*^9, 3.749160893971795*^9}, {
   3.749161013946618*^9, 3.749161027389195*^9}, {3.749466015681411*^9, 
   3.749466070729867*^9}, {3.749466102731954*^9, 3.7494661066874933`*^9}, {
   3.7494668167328863`*^9, 3.749466830986065*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"51fc8fbc-e959-49fb-90ab-729ea4d5aa53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"CloudDeploy", "[", 
   RowBox[{
    RowBox[{"FormPage", "[", 
     RowBox[{
      RowBox[{"FormObject", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<expression\>\"", "->", 
          RowBox[{"<|", 
           RowBox[{
            RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<(+ (*A B) (-C D))\>\""}],
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<Help\>\"", " ", "\[Rule]", " ", 
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<A,B,C ... or a,b,c, ... or numerals. * + - \>\"", ",", 
               "Blue"}], "]"}]}]}], "|>"}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AppearanceRules", "\[Rule]", 
         RowBox[{"<|", 
          RowBox[{
           RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
            RowBox[{"Style", "[", 
             RowBox[{
             "\"\<Arithmetic Prefix Syntax Tree\>\"", ",", "Orange", ",", " ",
               "Bold", ",", 
              RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
           RowBox[{
           "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Parse\>\""}]}], 
          "|>"}]}]}], "]"}], ",", 
      RowBox[{
       RowBox[{"parserPREFIX", "[", "#expression", "]"}], "&"}]}], "]"}], ",", 
    RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]}]], "Input",\

 CellChangeTimes->{
  3.6687019387415037`*^9, {3.668702018945513*^9, 3.668702021362136*^9}, {
   3.6687020551480513`*^9, 3.668702107897636*^9}, {3.668702178807077*^9, 
   3.6687021958064547`*^9}, {3.668702239952825*^9, 3.6687023436087427`*^9}, {
   3.6687025518166237`*^9, 3.668702596420607*^9}, {3.668702652491873*^9, 
   3.6687026812797422`*^9}, {3.6687036692618027`*^9, 3.668703684450075*^9}, {
   3.7214581991277103`*^9, 3.721458199429619*^9}, {3.7214582473786182`*^9, 
   3.721458296733281*^9}, {3.721458338348125*^9, 3.721458357664834*^9}, 
   3.721458429093857*^9, {3.721458790532482*^9, 3.721458793028949*^9}, {
   3.72145885229639*^9, 3.7214588949001627`*^9}, {3.721459273923686*^9, 
   3.721459278513587*^9}, {3.721459437413912*^9, 3.721459471760054*^9}, {
   3.721459561797625*^9, 3.721459568389389*^9}, {3.721463500119329*^9, 
   3.721463506317503*^9}, 3.721463545830546*^9, 3.72146362007117*^9, {
   3.7214636580407143`*^9, 3.7214637336560707`*^9}, {3.721463766044441*^9, 
   3.7214637708248587`*^9}, 3.721508095043187*^9, 3.721533489347207*^9, 
   3.721534682279892*^9, {3.7215405279653587`*^9, 3.7215405340964127`*^9}, 
   3.721540717373624*^9, {3.721540810912201*^9, 3.72154081372119*^9}, {
   3.721541434689147*^9, 3.7215415455022*^9}, 3.721541842143722*^9, {
   3.721541898168404*^9, 3.7215419002382603`*^9}, {3.721542079524444*^9, 
   3.721542113162117*^9}, 3.721785323100567*^9, {3.721785367426103*^9, 
   3.721785406398608*^9}, {3.749160060497347*^9, 3.749160093526417*^9}, {
   3.749160296459895*^9, 3.7491603004176292`*^9}, 3.749161096348222*^9},
 CellLabel->
  "In[277]:=",ExpressionUUID->"5826637b-f56c-44f0-b467-68c44a5e6f0f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/4fe5a030-7f9b-4de9-943f-\
ac6e45155bb7\"",
     "https://www.wolframcloud.com/objects/4fe5a030-7f9b-4de9-943f-\
ac6e45155bb7"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/4fe5a030-7f9b-4de9-943f-ac6e45155bb7"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.668702440473839*^9, 3.668702599311335*^9, 3.668702630234618*^9, 
   3.66870276172163*^9, {3.668702884776046*^9, 3.6687029013214397`*^9}, 
   3.668702940803843*^9, 3.668703086106824*^9, 3.6687031423779497`*^9, 
   3.668703336512856*^9, 3.6687033694726467`*^9, 3.668703414525476*^9, 
   3.6687034594849052`*^9, {3.668703521112142*^9, 3.668703586411539*^9}, {
   3.668703678090148*^9, 3.668703687206891*^9}, 3.668703991240896*^9, 
   3.668704097623562*^9, 3.668704397243503*^9, 3.668705280205473*^9, 
   3.668705416430118*^9, 3.6687054505580053`*^9, 3.66870576754501*^9, 
   3.668720951596919*^9, 3.668722539478557*^9, 3.721458392959919*^9, 
   3.7214584315862827`*^9, {3.721458523281312*^9, 3.721458540233698*^9}, 
   3.721458636446863*^9, {3.7214586900420227`*^9, 3.7214587050497217`*^9}, 
   3.7214588022533007`*^9, 3.721458910416202*^9, 3.7214592803511543`*^9, 
   3.7214593180516233`*^9, {3.72145942949817*^9, 3.72145943871248*^9}, 
   3.721459473463122*^9, 3.721459572978836*^9, 3.72146350755993*^9, 
   3.7214635675093613`*^9, 3.721463631482452*^9, {3.721463671717452*^9, 
   3.721463692610738*^9}, 3.721463740218576*^9, 3.7214637714238977`*^9, 
   3.721505681368531*^9, {3.721508087606447*^9, 3.7215081154021397`*^9}, {
   3.72153349165814*^9, 3.72153349720348*^9}, 3.721533552074951*^9, 
   3.7215346840011873`*^9, 3.721540540465413*^9, 3.721540596401998*^9, 
   3.7215407856670103`*^9, {3.721540816568226*^9, 3.721540834219254*^9}, {
   3.721541082836399*^9, 3.721541111065958*^9}, 3.721541284059106*^9, {
   3.7215413157884827`*^9, 3.721541321430045*^9}, 3.721541436900796*^9, {
   3.721541472235566*^9, 3.721541546979267*^9}, 3.7215416176292067`*^9, 
   3.72154181365574*^9, 3.721541868717265*^9, {3.7215420973355217`*^9, 
   3.721542115417403*^9}, 3.721542301274502*^9, {3.721785297975905*^9, 
   3.721785324446711*^9}, 3.7217854075960417`*^9, {3.721785677002804*^9, 
   3.7217856927485313`*^9}, 3.721785767942212*^9, {3.721785838169282*^9, 
   3.721785848584105*^9}, 3.721785952562611*^9, {3.721786155808311*^9, 
   3.7217861821430063`*^9}, 3.72178697693071*^9, 3.7217871323511887`*^9, 
   3.721787277071127*^9, 3.749158376161274*^9, 3.7491599731404457`*^9, 
   3.7491600976145277`*^9, 3.749161054989509*^9, 3.749161107311942*^9},
 CellLabel->
  "Out[277]=",ExpressionUUID->"7b2bc221-1a77-4c91-acff-5366439bc95f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"expr0", "=", 
     RowBox[{"RandomChoice", "@", 
      RowBox[{"{", 
       RowBox[{
       "\"\<(op1 (op3 A B) (op2 C (op4 D E)))\>\"", ",", 
        "\"\<(op1 (op2 (op3 B C) A) D)\>\"", " ", ",", 
        "\"\<(op1 (op2 A B) (op3 C D))\>\""}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"expr", "=", 
    RowBox[{"StringReplace", "[", 
     RowBox[{"expr0", ",", 
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"\"\<A\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ToString", "@", 
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"0.1", "*", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<B\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ToString", "@", 
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"0.1", "*", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<C\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ToString", "@", 
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"0.1", "*", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<D\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ToString", "@", 
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"0.1", "*", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<E\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"ToString", "@", 
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
            RowBox[{"ToString", "[", 
             RowBox[{"0.1", "*", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"CharacterRange", "[", 
              RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}]}]}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<op1\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<op2\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<op3\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}], "}"}], 
          "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"\"\<op4\>\"", "\[Rule]", 
         RowBox[{"RandomChoice", "[", 
          RowBox[{"{", 
           RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}], "}"}], 
          "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"parserPREFIX2", "[", "expr", "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.7494660906846333`*^9, {3.749466230784669*^9, 3.749466329616284*^9}, {
   3.7494663605887814`*^9, 3.749466418864224*^9}, {3.7494664508057623`*^9, 
   3.749466517933016*^9}, {3.749466561225274*^9, 3.749466594367304*^9}, {
   3.74946671750253*^9, 3.7494667242186832`*^9}, {3.749466932505364*^9, 
   3.749466953057515*^9}, {3.749466997440852*^9, 3.749467113631372*^9}, {
   3.749467151355379*^9, 3.749467154515074*^9}, {3.74946719547855*^9, 
   3.749467202553689*^9}, {3.7494672441018133`*^9, 3.7494672795499697`*^9}},
 CellLabel->
  "In[233]:=",ExpressionUUID->"ea05d6fd-2bc5-4328-ba66-1f79cce253e5"],

Cell[BoxData["\<\"(- (* n 0.3) (+ 0.2 0.2))\"\>"], "Output",
 CellChangeTimes->{{3.74946609211309*^9, 3.749466111202838*^9}, {
   3.7494663234525433`*^9, 3.749466330175802*^9}, {3.74946639734579*^9, 
   3.7494664193037577`*^9}, {3.7494664519771423`*^9, 3.749466455195333*^9}, 
   3.749466595603936*^9, 3.7494667186161346`*^9, {3.7494667673756447`*^9, 
   3.749466770777274*^9}, 3.7494668357136602`*^9, {3.749466954601739*^9, 
   3.74946696437149*^9}, {3.749467046727407*^9, 3.7494670790406227`*^9}, 
   3.7494671151696253`*^9, 3.74946715504841*^9, {3.749467189955546*^9, 
   3.749467191522801*^9}, {3.7494672597805977`*^9, 3.749467291088716*^9}},
 CellLabel->
  "Out[234]=",ExpressionUUID->"6b929f77-7be3-4489-b2f6-80a7f981312d"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"expression2\"\>", 
    "\[Rule]", "\<\"Subtract[Times[n,0.3],Plus[0.2,0.2]]\"\>"}], ",", 
   RowBox[{"\<\"evaluated\"\>", "\[Rule]", 
    RowBox[{
     RowBox[{"-", "0.4`"}], "+", 
     RowBox[{"0.3`", " ", "n"}]}]}], ",", 
   RowBox[{"\<\"tree\"\>", "\[Rule]", 
    GraphicsBox[
     TagBox[
      GraphicsComplexBox[{{1.2247448713915892`, 1.6329931618554523`}, {
       0.4082482904638631, 0.8164965809277261}, {0., 0.}, {0.8164965809277261,
        0.}, {2.041241452319315, 0.8164965809277261}, {1.6329931618554523`, 
       0.}, {2.4494897427831783`, 0.}}, {
        {RGBColor[0.55, 0.45, 0.45], 
         LineBox[{{1, 2}, {1, 5}, {2, 3}, {2, 4}, {5, 6}, {5, 7}}]}, {
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox["\<\"-\"\>", "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox[
            RowBox[{"\"-\"", "[", 
              RowBox[{
                RowBox[{"\"*\"", "[", 
                  RowBox[{"n", ",", "0.3`"}], "]"}], ",", 
                RowBox[{"\"+\"", "[", 
                  RowBox[{"0.2`", ",", "0.2`"}], "]"}]}], "]"}], HoldForm]],
          Annotation[#, 
           HoldForm[
            "-"[
             "*"[$CellContext`n, 0.3], 
             "+"[0.2, 0.2]]], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox["\<\"*\"\>", "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 2],
           TagBox[
            RowBox[{"\"*\"", "[", 
              RowBox[{"n", ",", "0.3`"}], "]"}], HoldForm]],
          Annotation[#, 
           HoldForm[
            "*"[$CellContext`n, 0.3]], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["n",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 3],
           TagBox["n", HoldForm]],
          Annotation[#, 
           HoldForm[$CellContext`n], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["0.3`",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 4],
           TagBox["0.3`", HoldForm]],
          Annotation[#, 
           HoldForm[0.3], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox["\<\"+\"\>", "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 5],
           TagBox[
            RowBox[{"\"+\"", "[", 
              RowBox[{"0.2`", ",", "0.2`"}], "]"}], HoldForm]],
          Annotation[#, 
           HoldForm[
            "+"[0.2, 0.2]], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["0.2`",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 6],
           TagBox["0.2`", HoldForm]],
          Annotation[#, 
           HoldForm[0.2], "Tooltip"]& ], 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["0.2`",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 7],
           TagBox["0.2`", HoldForm]],
          Annotation[#, 
           HoldForm[0.2], "Tooltip"]& ]}}],
      Annotation[#, 
       VertexCoordinateRules -> {{1.2247448713915892`, 1.6329931618554523`}, {
        0.4082482904638631, 0.8164965809277261}, {0., 0.}, {
        0.8164965809277261, 0.}, {2.041241452319315, 0.8164965809277261}, {
        1.6329931618554523`, 0.}, {2.4494897427831783`, 0.}}]& ],
     AspectRatio->NCache[Rational[3, 5]^Rational[1, 2], 0.7745966692414834],
     FormatType:>StandardForm,
     FrameTicks->Automatic,
     ImageSize->400,
     PlotRange->All,
     PlotRangePadding->Scaled[0.1]]}]}], "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.74946609211309*^9, 3.749466111202838*^9}, {
   3.7494663234525433`*^9, 3.749466330175802*^9}, {3.74946639734579*^9, 
   3.7494664193037577`*^9}, {3.7494664519771423`*^9, 3.749466455195333*^9}, 
   3.749466595603936*^9, 3.7494667186161346`*^9, {3.7494667673756447`*^9, 
   3.749466770777274*^9}, 3.7494668357136602`*^9, {3.749466954601739*^9, 
   3.74946696437149*^9}, {3.749467046727407*^9, 3.7494670790406227`*^9}, 
   3.7494671151696253`*^9, 3.74946715504841*^9, {3.749467189955546*^9, 
   3.749467191522801*^9}, {3.7494672597805977`*^9, 3.7494672911038094`*^9}},
 CellLabel->
  "Out[235]=",ExpressionUUID->"997127d5-4423-48c8-bd29-2e26dd92bafc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"parserPREFIX", "[", "\"\<(+ (*A B) (*C (- x D)))\>\"", 
  "]"}]], "Input",
 CellChangeTimes->{
  3.721540686841935*^9, 3.721540853753421*^9, {3.7217662627364187`*^9, 
   3.7217662636578417`*^9}, 3.721766498443852*^9, 3.721785491844327*^9, {
   3.7217867896424427`*^9, 3.721786794209134*^9}, 3.749158703322521*^9, 
   3.749158918129017*^9, 3.749159088535788*^9, 3.74915956151752*^9, {
   3.749160310734941*^9, 3.749160313680962*^9}, 3.749160609451804*^9, 
   3.749160825747396*^9, 3.7491609790653543`*^9},
 CellLabel->"In[44]:=",ExpressionUUID->"6edd9676-4e53-4415-b798-c3155b41fb64"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3UlTG+m+JnC6e9PL/gq9q5XXtWVREd0rV9yOXpwIb+6Jvu6ozW2fezui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    "], {{0, 584}, {400, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 10, 25, 15, 31, 17.}, "Instant", "Gregorian", 1.]]]],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{400, 584},
  PlotRange->{{0, 400}, {0, 584}}]], "Output",
 CellChangeTimes->{
  3.721542670610136*^9, 3.721765885908383*^9, 3.721765940237812*^9, 
   3.7217662642781982`*^9, 3.7217664991112432`*^9, 3.721785493296399*^9, 
   3.721785567306203*^9, 3.721785646828536*^9, 3.721785707261644*^9, 
   3.721785775148233*^9, 3.72178585387814*^9, 3.7217858970007563`*^9, 
   3.7217860395578814`*^9, {3.721786138322074*^9, 3.721786177088873*^9}, {
   3.721786765906708*^9, 3.721786797272807*^9}, 3.72178691357614*^9, 
   3.721786967674399*^9, 3.721787128169673*^9, 3.72178726167906*^9, 
   3.749158706056252*^9, 3.749158873408349*^9, 3.7491589186070957`*^9, 
   3.749159009900105*^9, {3.749159072154077*^9, 3.749159088960164*^9}, 
   3.749159204809271*^9, 3.749159241895158*^9, 3.749159276567133*^9, {
   3.749159382521758*^9, 3.749159441791606*^9}, {3.749159546506298*^9, 
   3.7491595622591867`*^9}, 3.749159598992634*^9, {3.7491596922504883`*^9, 
   3.749159731454163*^9}, 3.749159852851748*^9, 3.7491599660144377`*^9, {
   3.749160305881237*^9, 3.749160339181093*^9}, 3.7491603969493237`*^9, 
   3.749160465371399*^9, 3.7491606098898497`*^9, 3.749160826268837*^9, {
   3.749160860368485*^9, 3.749160914816801*^9}, 3.749160982017087*^9, {
   3.749161024134026*^9, 3.749161029990061*^9}, 3.7494666779565496`*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"e8c5afee-0e37-47a0-b72f-382ea3700f06"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"parserPREFIX", "[", "\"\<(- 2 3)\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.749160941510132*^9, 3.749160950453396*^9}},
 CellLabel->
  "In[275]:=",ExpressionUUID->"a18d3f9b-67be-454e-afdd-2e277e1271eb"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3cdzmweaoHHN7mWO+y/srU8+99WHrto9ddds7WGq+jJd257aS6+nZ6t2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    "], {{0, 584}, {400, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 10, 22, 2, 37, 30.}, "Instant", "Gregorian", 1.]]]],
   
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{400, 584},
  PlotRange->{{0, 400}, {0, 584}}]], "Output",
 CellChangeTimes->{3.74916095093226*^9, 3.749161050789551*^9},
 CellLabel->
  "Out[275]=",ExpressionUUID->"00e04ec1-7c6b-436e-94e7-c6bccea76674"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  
  RowBox[{
   RowBox[{
    RowBox[{"expression0", "=", "\"\<+((* A (+ B C)) D)\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (* A (+ B C)) D)\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (+ (+   2 1) 3 )    4)\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (* A B) (* C D))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (* A (+ B C) D))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (* A B) (+ C D))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (* A B) (* C D))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(*(*(*B C) A))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+(+(+B C) A))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (*A B) (*C D))\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(* (* (*   2 1) 3 )    4)\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myPARAN3", "[", "x_", "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{"\"\<(\>\"", ",", "x", ",", "\"\<)\>\""}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myPLUS", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
          RowBox[{"x0", "=", 
           RowBox[{"myPARAN3", "[", 
            RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
          RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
          RowBox[{"y0", "=", 
           RowBox[{"myPARAN3", "[", 
            RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
          RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Plus", "[", 
         RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myTIMES", "[", 
      RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x0", ",", "y0"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NumberQ", "@", "x"}], "\[Equal]", "True"}], ",", " ", 
          RowBox[{"x0", "=", 
           RowBox[{"myPARAN3", "[", 
            RowBox[{"ToString", "@", "x"}], "]"}]}], ",", 
          RowBox[{"x0", "=", "x"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"NumberQ", "@", "y"}], "==", "True"}], ",", " ", 
          RowBox[{"y0", "=", 
           RowBox[{"myPARAN3", "[", 
            RowBox[{"ToString", "@", "y"}], "]"}]}], ",", 
          RowBox[{"y0", "=", "y"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Times", "[", 
         RowBox[{"x0", ",", "y0"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
     ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"expression0", "=", 
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{"expression0", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<  \>\"", "\[Rule]", "\"\<\[SuchThat]\>\""}], "}"}]}], 
        "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<)\[SuchThat]\>\"", "\[Rule]", "\"\<) \>\""}], ",", 
         RowBox[{"\"\<\[SuchThat]\>\"", "\[Rule]", "\"\<\>\""}]}], "}"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"expression", "=", 
    RowBox[{"StringReplace", "[", 
     RowBox[{
      RowBox[{"StringReplace", "[", 
       RowBox[{"expression0", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
          RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"\"\< (\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
            RowBox[{"\"\<( \>\"", "\[Rule]", "\"\<[\>\""}], ",", 
            RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ","}], "*)"}], 
          RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
          RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
          RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
          RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
          RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
          RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<Plus\>\"", "\[Rule]", "\"\<myPLUS\>\""}], ",", 
        RowBox[{"\"\<Times\>\"", "\[Rule]", "\"\<myTIMES\>\""}]}], "}"}]}], 
     "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"ToExpression", "@", "expression"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721768820031521*^9, 3.7217688383732977`*^9}, {
   3.721768909678607*^9, 3.721769164780942*^9}, {3.7217692411833887`*^9, 
   3.721769254750414*^9}, {3.721769285320032*^9, 3.721769308347452*^9}, 
   3.721769364420526*^9, {3.721769442059409*^9, 3.72176944628858*^9}, {
   3.721769493824638*^9, 3.7217697042045603`*^9}, {3.721769746473235*^9, 
   3.721769850269652*^9}, {3.7217698916374197`*^9, 3.721769919269755*^9}, {
   3.7217699772083263`*^9, 3.7217699805945597`*^9}, {3.721770013693643*^9, 
   3.721770022512904*^9}, 3.7217701502646437`*^9, {3.72177023622622*^9, 
   3.721770258670125*^9}, {3.721770310355023*^9, 3.7217703162501907`*^9}, {
   3.7217705754485683`*^9, 3.72177060486751*^9}, {3.7217707903636217`*^9, 
   3.7217708529947453`*^9}, {3.721770962878024*^9, 3.7217709733846684`*^9}, {
   3.7217710078681583`*^9, 3.721771035138473*^9}, {3.72177122446061*^9, 
   3.721771230872443*^9}, {3.72177126151023*^9, 3.721771329887092*^9}, {
   3.7217716421862907`*^9, 3.721771704254404*^9}, {3.7217717424284363`*^9, 
   3.72177177658327*^9}, {3.7217718384501743`*^9, 3.7217718447493877`*^9}, {
   3.7217718960293903`*^9, 3.721771939083736*^9}, {3.721772059172018*^9, 
   3.721772096196876*^9}, {3.721772155475093*^9, 3.721772158872035*^9}, {
   3.7217725980198383`*^9, 3.721772601349312*^9}, {3.721772647128005*^9, 
   3.7217726741845703`*^9}, {3.7217727158915977`*^9, 3.7217727711405*^9}, {
   3.721772830858235*^9, 3.721772860862492*^9}, {3.7217729292989264`*^9, 
   3.721773020921685*^9}, 3.721773093037156*^9, {3.721773133035981*^9, 
   3.7217731637789583`*^9}, {3.721773473953402*^9, 3.721773542670458*^9}, {
   3.721773605471018*^9, 3.721773644755094*^9}, {3.7217736876540623`*^9, 
   3.72177374365819*^9}, {3.721773794285198*^9, 3.7217738279582663`*^9}, {
   3.721773974910421*^9, 3.721773976237773*^9}, {3.7217740175390463`*^9, 
   3.721774035381545*^9}, {3.721774100206422*^9, 3.721774152194519*^9}, {
   3.721774218819171*^9, 3.721774355781069*^9}, {3.72177443295924*^9, 
   3.721774619029024*^9}, {3.721774674011128*^9, 3.72177473207309*^9}, 
   3.72178523675395*^9, {3.721786265648673*^9, 3.721786267535277*^9}, {
   3.721786398771262*^9, 3.7217865410990257`*^9}, {3.721786572815302*^9, 
   3.7217865753681383`*^9}, {3.721786638843782*^9, 3.7217866995053053`*^9}, {
   3.721786820109837*^9, 
   3.72178689814196*^9}},ExpressionUUID->"4a7ce3a8-02fd-4dbe-921c-\
e35addd45add"],

Cell[BoxData["\<\"myTIMES[myTIMES[myTIMES[2,1],3],4]\"\>"], "Output",
 CellChangeTimes->{{3.721773822035818*^9, 3.7217738283257113`*^9}, 
   3.721773976592496*^9, {3.721774026596796*^9, 3.721774036259975*^9}, {
   3.721774100541169*^9, 3.7217741534477377`*^9}, {3.7217742268215227`*^9, 
   3.721774289719825*^9}, {3.721774326033598*^9, 3.721774356430154*^9}, {
   3.7217744334764433`*^9, 3.721774541749547*^9}, {3.7217745950430183`*^9, 
   3.721774619345636*^9}, {3.721774677810439*^9, 3.721774732846188*^9}, {
   3.7217852215740843`*^9, 3.721785237214306*^9}, 3.721786046708248*^9, 
   3.7217862680856943`*^9, 3.721786541670793*^9, 3.7217865763326893`*^9, {
   3.721786645406465*^9, 3.721786699950438*^9}, 
   3.721786898541855*^9},ExpressionUUID->"f9e3863b-af16-469a-81fe-\
efbef36f48ee"],

Cell[BoxData[
 RowBox[{
  TemplateBox[{"\"(\"","\"1\"","\")\""},
   "RowDefault"], " ", 
  TemplateBox[{"\"(\"","\"2\"","\")\""},
   "RowDefault"], " ", 
  TemplateBox[{"\"(\"","\"3\"","\")\""},
   "RowDefault"], " ", 
  TemplateBox[{"\"(\"","\"4\"","\")\""},
   "RowDefault"]}]], "Output",
 CellChangeTimes->{{3.721773822035818*^9, 3.7217738283257113`*^9}, 
   3.721773976592496*^9, {3.721774026596796*^9, 3.721774036259975*^9}, {
   3.721774100541169*^9, 3.7217741534477377`*^9}, {3.7217742268215227`*^9, 
   3.721774289719825*^9}, {3.721774326033598*^9, 3.721774356430154*^9}, {
   3.7217744334764433`*^9, 3.721774541749547*^9}, {3.7217745950430183`*^9, 
   3.721774619345636*^9}, {3.721774677810439*^9, 3.721774732846188*^9}, {
   3.7217852215740843`*^9, 3.721785237214306*^9}, 3.721786046708248*^9, 
   3.7217862680856943`*^9, 3.721786541670793*^9, 3.7217865763326893`*^9, {
   3.721786645406465*^9, 3.721786699950438*^9}, 
   3.72178689855523*^9},ExpressionUUID->"8c9ea3d1-13b6-4899-beef-\
97ac66b575a8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"myPLUS", "[", 
  RowBox[{
   RowBox[{"myPLUS", "[", 
    RowBox[{"2", ",", "1"}], "]"}], ",", "3"}], "]"}]], "Input",
 CellChangeTimes->{
  3.721786619865769*^9},ExpressionUUID->"3ec46274-79bc-4194-92e6-\
06efcc17eab4"],

Cell[BoxData[
 RowBox[{"\<\"3\"\>", "+", "x0$9762"}]], "Output",
 CellChangeTimes->{{3.7217866043849688`*^9, 
  3.721786620835314*^9}},ExpressionUUID->"480a931c-00d9-46ef-a7f2-\
a76e1f3940a2"]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.72177174846481*^9},ExpressionUUID->"e1a860fe-f923-4e5a-a2bc-ae736ee3ea15"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"expression0", "=", "\"\<( + (* (1 -5) 2) 7)\>\""}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (+ (+(A B)) C) D)\>\""}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(+ (* A B) (* C D))\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression0", "=", "\"\<( + (* (1 -5) 2) 7)\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(+ (* A B) (* C D))\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(+(*(1 5) 2))\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"expression", "=", 
  RowBox[{"StringReplace", "[", 
   RowBox[{"expression0", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<+\>\"", "->", " ", "\"\<\\\"\[CirclePlus]\\\"\>\""}], ",", 
      
      RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\\\"\[CircleTimes]\\\"\>\""}], ",", 
      RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\\\"\[SmallCircle]\\\"\>\""}], ",", 
      RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<Sqrt@\>\""}], ",", 
      RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin@\>\""}], ",", 
      RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos@\>\""}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Release", "[", 
   RowBox[{"ToExpression", "[", 
    RowBox[{"expression", ",", "StandardForm", ",", "Hold"}], "]"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"\"\<\[CirclePlus]\>\"", "\[Rule]", "Plus"}], ",", 
    RowBox[{"\"\<\[CircleTimes]\>\"", "\[Rule]", "Times"}]}], 
   "}"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.721766565281313*^9, 3.721766574540379*^9}, {
  3.721766622513039*^9, 3.721766626325871*^9}, {3.721766673388232*^9, 
  3.7217666784149303`*^9}, {3.721766733812735*^9, 3.721766819248228*^9}, {
  3.7217669522068033`*^9, 3.721766959000701*^9}, {3.721767038002787*^9, 
  3.7217670914627666`*^9}, {3.721768511709353*^9, 
  3.721768675648625*^9}},ExpressionUUID->"f7995f40-dc34-4dca-97ca-\
57f9f2117982"],

Cell[BoxData["\<\"(\\\"\[CirclePlus]\\\"(\\\"\[CircleTimes]\\\"(1 5) \
2))\"\>"], "Output",
 CellChangeTimes->{
  3.721766574944625*^9, 3.721766626601268*^9, 3.721766678834794*^9, {
   3.7217667384315233`*^9, 3.7217668195519447`*^9}, {3.721766953285198*^9, 
   3.721766959421935*^9}, {3.7217670487158747`*^9, 3.721767092072011*^9}, {
   3.7217684892206793`*^9, 3.721768587596697*^9}, {3.7217686310441217`*^9, 
   3.721768676355214*^9}, 
   3.721768721219472*^9},ExpressionUUID->"9c8a8bad-ca70-4b1b-931e-\
c86610abdb4a"],

Cell[BoxData[
 RowBox[{"2", " ", 
  RowBox[{"1", "[", "5", "]"}]}]], "Output",
 CellChangeTimes->{
  3.721766574944625*^9, 3.721766626601268*^9, 3.721766678834794*^9, {
   3.7217667384315233`*^9, 3.7217668195519447`*^9}, {3.721766953285198*^9, 
   3.721766959421935*^9}, {3.7217670487158747`*^9, 3.721767092072011*^9}, {
   3.7217684892206793`*^9, 3.721768587596697*^9}, {3.7217686310441217`*^9, 
   3.721768676355214*^9}, 
   3.721768721230891*^9},ExpressionUUID->"c2fd792a-b859-49de-8e2d-\
79291ef28e8b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"expression0", "=", "\"\<( + (* ( - 5) 2) 7)\>\""}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"expression0", "=", "\"\<(+ (+ (+(A B)) C) D)\>\""}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression0", "=", "\"\<(+ (* A B) (* C D))\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"expression0", "=", 
  "\"\<(+ (*A B) (*C D))\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expression", "=", 
   RowBox[{"StringReplace", "[", 
    RowBox[{"expression0", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<+\>\"", "->", " ", "\"\<\\\"\[CirclePlus]\\\"\>\""}], ",", 
       RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<\\\"\[CircleTimes]\\\"\>\""}], 
       ",", 
       RowBox[{"\"\</\>\"", "\[Rule]", "\"\<\\\"\[SmallCircle]\\\"\>\""}], 
       ",", 
       RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<Sqrt@\>\""}], ",", 
       RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin@\>\""}], ",", 
       RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos@\>\""}]}], "}"}]}], "]"}]}],
   "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"expression", "=", 
    RowBox[{"StringReplace", "[", 
     RowBox[{"expression0", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<+\>\"", "->", " ", "\"\<Plus\>\""}], ",", 
        RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
        RowBox[{"\"\</\>\"", "\[Rule]", "\"\<Divide\>\""}], ",", 
        RowBox[{"\"\<sqr\>\"", "\[Rule]", "\"\<Sqrt@\>\""}], ",", 
        RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin@\>\""}], ",", 
        RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos@\>\""}]}], "}"}]}], 
     "]"}]}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TreeForm", "[", 
   RowBox[{"Release", "[", 
    RowBox[{"ToExpression", "[", 
     RowBox[{"expression", ",", "StandardForm", ",", "Hold"}], "]"}], "]"}], 
   "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", " ", 
    RowBox[{"\"\<\[CirclePlus]\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
    RowBox[{"\"\<\[CircleTimes]\>\"", "\[Rule]", "\"\<*\>\""}], ",", " ", 
    RowBox[{"SmallCircle", "\[Rule]", "\"\</\>\""}], ",", 
    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
    RowBox[{"\"\<\[SmallCircle]\>\"", "\[Rule]", "\"\</\>\""}]}], 
   "}"}]}]}], "Input",
 CellChangeTimes->{
  3.72153539716501*^9, 3.721535512186109*^9, {3.721535608815198*^9, 
   3.721535620436302*^9}, {3.721535665509489*^9, 3.7215356973918858`*^9}, {
   3.7215357284899683`*^9, 3.721535762843749*^9}, {3.721535809279025*^9, 
   3.721535902876704*^9}, {3.721536106094968*^9, 3.72153611963912*^9}, {
   3.721536168791853*^9, 3.721536169131484*^9}, {3.721536220735354*^9, 
   3.7215362265170727`*^9}, {3.7215363294364862`*^9, 3.721536356098878*^9}, 
   3.721536410045567*^9, {3.72153649365804*^9, 3.721536510543741*^9}, {
   3.721536838965377*^9, 3.721536849292378*^9}, 3.7215369130271683`*^9, {
   3.721537108760878*^9, 3.7215371140473423`*^9}, {3.721537146374065*^9, 
   3.72153714844042*^9}, {3.72153727804534*^9, 3.721537374932549*^9}, {
   3.721537453562314*^9, 3.721537557852244*^9}, {3.7215392563326187`*^9, 
   3.721539306046636*^9}, {3.721539370940381*^9, 3.7215394264259157`*^9}, {
   3.721539872808717*^9, 3.721539894723897*^9}, {3.7215401320317373`*^9, 
   3.721540198214149*^9}, {3.7215402322060328`*^9, 3.7215402527883167`*^9}, {
   3.7215403009634933`*^9, 3.721540328233572*^9}, {3.7215403660474854`*^9, 
   3.721540418292984*^9}, {3.721540465016479*^9, 3.72154049374907*^9}, {
   3.721540741494323*^9, 3.7215407456786337`*^9}, {3.721541019074679*^9, 
   3.721541020131627*^9}, 3.721541061320201*^9, {3.721773842786055*^9, 
   3.7217738674905167`*^9}, {3.721773898294034*^9, 3.721773922539065*^9}, 
   3.721773955447349*^9, {3.721785540322777*^9, 3.721785547243059*^9}, 
   3.721785972899002*^9},ExpressionUUID->"e098f90c-9be5-485f-b793-\
6ba63782b870"],

Cell[BoxData["\<\"(+ (*A B) (*C D))\"\>"], "Output",
 CellChangeTimes->{
  3.721541029525977*^9, 3.7215410619710407`*^9, 3.721765915883274*^9, 
   3.721765948624526*^9, 3.721766278466132*^9, 3.721766784193392*^9, {
   3.721773847821136*^9, 3.721773867801854*^9}, {3.721773898852566*^9, 
   3.7217739232445374`*^9}, 3.7217739561560287`*^9, {3.721785541700066*^9, 
   3.721785547725292*^9}, 3.721785973838113*^9, 
   3.7217860596291513`*^9},ExpressionUUID->"95cdb880-e72b-498a-8e5c-\
acd15704cbdf"],

Cell[BoxData["\<\"(\\\"\[CirclePlus]\\\" (\\\"\[CircleTimes]\\\"A B) (\\\"\
\[CircleTimes]\\\"C D))\"\>"], "Output",
 CellChangeTimes->{
  3.721541029525977*^9, 3.7215410619710407`*^9, 3.721765915883274*^9, 
   3.721765948624526*^9, 3.721766278466132*^9, 3.721766784193392*^9, {
   3.721773847821136*^9, 3.721773867801854*^9}, {3.721773898852566*^9, 
   3.7217739232445374`*^9}, 3.7217739561560287`*^9, {3.721785541700066*^9, 
   3.721785547725292*^9}, 3.721785973838113*^9, 
   3.72178605963477*^9},ExpressionUUID->"790ad02a-c897-4635-9307-\
e2d03124dc89"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{1.6641005886756874`, 1.1094003924504583`}, {
    0.2773500981126146, 0.5547001962252291}, {0., 0.}, {0.5547001962252291, 
    0.}, {0.8320502943378437, 0.5547001962252291}, {1.386750490563073, 
    0.5547001962252291}, {1.9414506867883021`, 0.5547001962252291}, {
    2.4961508830135313`, 0.5547001962252291}, {3.05085107923876, 
    0.5547001962252291}}, {
     {RGBColor[0.55, 0.45, 0.45], 
      LineBox[{{1, 2}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {2, 3}, {2, 
       4}}]}, {
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"*\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 1],
        TagBox[
         RowBox[{"\"*\"", "[", 
           RowBox[{
             RowBox[{"\"^\"", "[", 
               RowBox[{"\"*\"", ",", "2"}], "]"}], ",", "\"+\"", ",", "A", 
             ",", "B", ",", "C", ",", "D"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "*"[
          "^"["*", 2], "+", $CellContext`A, $CellContext`B, C, D]], 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox["\<\"^\"\>", "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 2],
        TagBox[
         RowBox[{"\"^\"", "[", 
           RowBox[{"\"*\"", ",", "2"}], "]"}], HoldForm]],
       Annotation[#, 
        HoldForm[
         "^"["*", 2]], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"*\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 3],
        TagBox["\"*\"", HoldForm]],
       Annotation[#, 
        HoldForm["*"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 4],
        TagBox["2", HoldForm]],
       Annotation[#, 
        HoldForm[2], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"+\"\>",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 5],
        TagBox["\"+\"", HoldForm]],
       Annotation[#, 
        HoldForm["+"], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["A",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 6],
        TagBox["A", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`A], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["B",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 7],
        TagBox["B", HoldForm]],
       Annotation[#, 
        HoldForm[$CellContext`B], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["C",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 8],
        TagBox["C", HoldForm]],
       Annotation[#, 
        HoldForm[C], "Tooltip"]& ], 
      TagBox[
       TooltipBox[InsetBox[
         FrameBox[
          StyleBox[
           TagBox["D",
            HoldForm], "StandardForm", "Output",
           StripOnInput->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontSize->Scaled[0.05],
           FontColor->GrayLevel[0]],
          Background->RGBColor[1., 1., 0.871],
          FrameStyle->GrayLevel[0.5],
          StripOnInput->False], 9],
        TagBox["D", HoldForm]],
       Annotation[#, 
        HoldForm[D], "Tooltip"]& ]}}],
   Annotation[#, 
    VertexCoordinateRules -> {{1.6641005886756874`, 1.1094003924504583`}, {
     0.2773500981126146, 0.5547001962252291}, {0., 0.}, {0.5547001962252291, 
     0.}, {0.8320502943378437, 0.5547001962252291}, {1.386750490563073, 
     0.5547001962252291}, {1.9414506867883021`, 0.5547001962252291}, {
     2.4961508830135313`, 0.5547001962252291}, {3.05085107923876, 
     0.5547001962252291}}]& ],
  AspectRatio->1,
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.721541029525977*^9, 3.7215410619710407`*^9, 3.721765915883274*^9, 
   3.721765948624526*^9, 3.721766278466132*^9, 3.721766784193392*^9, {
   3.721773847821136*^9, 3.721773867801854*^9}, {3.721773898852566*^9, 
   3.7217739232445374`*^9}, 3.7217739561560287`*^9, {3.721785541700066*^9, 
   3.721785547725292*^9}, 3.721785973838113*^9, 
   3.721786059640345*^9},ExpressionUUID->"7604bc7d-328f-479c-aedf-\
ce8e6e537fdf"]
}, Open  ]]
},
WindowSize->{1277, 1088},
WindowMargins->{{Automatic, 586}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"94123e90-0ee0-4fe0-9738-3d78bfc33376"],
Cell[1747, 54, 40255, 767, 4022, "Input",ExpressionUUID->"51fc8fbc-e959-49fb-90ab-729ea4d5aa53"],
Cell[CellGroupData[{
Cell[42027, 825, 3192, 60, 241, "Input",ExpressionUUID->"5826637b-f56c-44f0-b467-68c44a5e6f0f"],
Cell[45222, 887, 2765, 45, 37, "Output",ExpressionUUID->"7b2bc221-1a77-4c91-acff-5366439bc95f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48024, 937, 5913, 134, 409, "Input",ExpressionUUID->"ea05d6fd-2bc5-4328-ba66-1f79cce253e5"],
Cell[53940, 1073, 729, 10, 34, "Output",ExpressionUUID->"6b929f77-7be3-4489-b2f6-80a7f981312d"],
Cell[54672, 1085, 7237, 180, 329, "Output",ExpressionUUID->"997127d5-4423-48c8-bd29-2e26dd92bafc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61946, 1270, 607, 10, 30, "Input",ExpressionUUID->"6edd9676-4e53-4415-b798-c3155b41fb64"],
Cell[62556, 1282, 19375, 322, 601, "Output",ExpressionUUID->"e8c5afee-0e37-47a0-b72f-382ea3700f06"]
}, Open  ]],
Cell[CellGroupData[{
Cell[81968, 1609, 228, 4, 30, "Input",ExpressionUUID->"a18d3f9b-67be-454e-afdd-2e277e1271eb"],
Cell[82199, 1615, 13579, 231, 601, "Output",ExpressionUUID->"00e04ec1-7c6b-436e-94e7-c6bccea76674"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95815, 1851, 9133, 191, 766, "Input",ExpressionUUID->"4a7ce3a8-02fd-4dbe-921c-e35addd45add"],
Cell[104951, 2044, 790, 11, 34, "Output",ExpressionUUID->"f9e3863b-af16-469a-81fe-efbef36f48ee"],
Cell[105744, 2057, 1010, 20, 34, "Output",ExpressionUUID->"8c9ea3d1-13b6-4899-beef-97ac66b575a8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106791, 2082, 243, 7, 30, "Input",ExpressionUUID->"3ec46274-79bc-4194-92e6-06efcc17eab4"],
Cell[107037, 2091, 192, 4, 34, "Output",ExpressionUUID->"480a931c-00d9-46ef-a7f2-a76e1f3940a2"]
}, Open  ]],
Cell[107244, 2098, 144, 2, 52, "Input",ExpressionUUID->"e1a860fe-f923-4e5a-a2bc-ae736ee3ea15"],
Cell[CellGroupData[{
Cell[107413, 2104, 2076, 49, 199, "Input",ExpressionUUID->"f7995f40-dc34-4dca-97ca-57f9f2117982"],
Cell[109492, 2155, 519, 9, 34, "Output",ExpressionUUID->"9c8a8bad-ca70-4b1b-931e-c86610abdb4a"],
Cell[110014, 2166, 506, 10, 34, "Output",ExpressionUUID->"c2fd792a-b859-49de-8e2d-79291ef28e8b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[110557, 2181, 4012, 81, 220, "Input",ExpressionUUID->"e098f90c-9be5-485f-b793-6ba63782b870"],
Cell[114572, 2264, 496, 8, 34, "Output",ExpressionUUID->"95cdb880-e72b-498a-8e5c-acd15704cbdf"],
Cell[115071, 2274, 557, 9, 34, "Output",ExpressionUUID->"790ad02a-c897-4635-9307-e2d03124dc89"],
Cell[115631, 2285, 7549, 208, 377, "Output",ExpressionUUID->"7604bc7d-328f-479c-aedf-ce8e6e537fdf"]
}, Open  ]]
}
]
*)

