(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    201512,       4155]
NotebookOptionsPosition[    200416,       4129]
NotebookOutlinePosition[    200801,       4146]
CellTagsIndexPosition[    200758,       4143]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},ExpressionUUID->"b9964c67-bebc-4915-a78b-\
c8c861b0efd7"],

Cell[BoxData[
 RowBox[{"\n", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"versionSTRING", "=", "\"\<4.0.1\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"highlightCORRECT", "[", "ss_", "]"}], ":=", 
     RowBox[{"Framed", "[", 
      RowBox[{"ss", ",", 
       RowBox[{"Background", "->", "LightGreen"}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"highlightCORRECT2", "[", "ss_", "]"}], ":=", 
     RowBox[{"Framed", "[", 
      RowBox[{"ss", ",", 
       RowBox[{"Background", "->", "LightGreen"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myFONTSIZE", "=", "12"}], ";"}], "\n", 
   RowBox[{
    RowBox[{"myLINEBREAKS", "=", "60"}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"textFORMAT", "[", "ss_", "]"}], ":=", 
     RowBox[{"Text", "[", 
      RowBox[{"Style", "[", "\n", 
       RowBox[{
        RowBox[{"InsertLinebreaks", "[", 
         RowBox[{
          RowBox[{"ToString", "@", "ss"}], ",", "myLINEBREAKS"}], "]"}], ",", 
        "myFONTSIZE", ",", 
        RowBox[{"LineIndent", "->", "0"}]}], "]"}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"textFORMAT2", "[", "ss_", "]"}], ":=", 
     RowBox[{"Text", "[", 
      RowBox[{"Style", "[", "\n", 
       RowBox[{
        RowBox[{"InsertLinebreaks", "[", 
         RowBox[{"ss", ",", "myLINEBREAKS"}], "]"}], ",", "myFONTSIZE", ",", 
        RowBox[{"LineIndent", "->", "0"}]}], "]"}], "]"}]}], ";"}], "\n", 
   "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"frameLabel", "[", 
      RowBox[{"ss_", ",", "lbl_", ",", "color_", ",", "flag_"}], "]"}], ":=", 
     
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"flag", "\[Equal]", "True"}], ",", " ", 
       RowBox[{"Labeled", "[", 
        RowBox[{
         RowBox[{"Framed", "[", 
          RowBox[{"ss", ",", 
           RowBox[{"RoundingRadius", "\[Rule]", "10"}], ",", 
           RowBox[{"Background", "\[Rule]", "color"}]}], "]"}], ",", 
         RowBox[{"Row", "[", 
          RowBox[{"TraditionalForm", "/@", "lbl"}], "]"}], ",", 
         RowBox[{"{", "Top", "}"}], ",", 
         RowBox[{"LabelStyle", "\[Rule]", "Red"}]}], "]"}], ",", "ss"}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"randFILE", "[", "file_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "tmp", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FileNameJoin", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"file", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<cache\>\"", ",", 
            RowBox[{"tmp", "=", 
             RowBox[{
              RowBox[{"file", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "<>", 
              RowBox[{"ToString", "[", 
               RowBox[{"RandomInteger", "[", 
                RowBox[{"{", 
                 RowBox[{"1000000000", ",", "10000000000"}], "}"}], "]"}], 
               "]"}], "<>", "\"\<.\>\"", "<>", 
              RowBox[{"file", "[", 
               RowBox[{"[", "3", "]"}], "]"}]}]}]}], "}"}], "]"}], ",", "tmp",
          ",", " ", 
         RowBox[{"file", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"nnnn", "=", "3"}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{
       "Use", " ", "this", " ", "only", " ", "if", " ", "there", " ", "is", 
        " ", "no", " ", "hardware", " ", "support", " ", "for", " ", "the", 
        " ", "anti"}], "-", 
       RowBox[{"aliasing", "\n", 
        RowBox[{"myRASTER", "[", "s_", "]"}]}]}], ":=", 
      RowBox[{"ImageResize", "[", 
       RowBox[{
        RowBox[{"Rasterize", "[", 
         RowBox[{"s", ",", "\"\<Image\>\"", ",", " ", 
          RowBox[{"ImageResolution", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"nnnn", "*", "100"}], ")"}]}], ",", 
          RowBox[{"ImageFormattingWidth", "\[Rule]", "\[Infinity]"}]}], "]"}],
         ",", " ", 
        RowBox[{"Scaled", "[", 
         RowBox[{"1", "/", "nnnn"}], "]"}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myRASTER", "[", "s_", "]"}], ":=", 
     RowBox[{"Rasterize", "[", 
      RowBox[{"s", ",", "\"\<Image\>\"", ",", " ", 
       RowBox[{"ImageResolution", "\[Rule]", 
        RowBox[{"(", "100", ")"}]}], ",", 
       RowBox[{"ImageFormattingWidth", "\[Rule]", "\[Infinity]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myRASTER3D", "[", "s_", "]"}], ":=", 
     RowBox[{"Rasterize", "[", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{"s", ",", 
         RowBox[{"RenderingOptions", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
           "\"\<Graphics3DRenderingEngine\>\"", "\[Rule]", 
            "\"\<HardwareDepthPeeling\>\""}], "}"}]}]}], "]"}], ",", 
       "\"\<Image\>\"", ",", " ", 
       RowBox[{"ImageResolution", "\[Rule]", 
        RowBox[{"(", "100", ")"}]}], ",", 
       RowBox[{"ImageFormattingWidth", "\[Rule]", "\[Infinity]"}]}], "]"}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myFRAME1", "[", "s_", "]"}], ":=", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"ImageMargins", "\[Rule]", "5"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", " ", 
          RowBox[{"Directive", "[", 
           RowBox[{"Thickness", "[", "5", "]"}], "]"}], ",", "LightRed"}], 
         "}"}]}], ",", 
       RowBox[{"RoundingRadius", "\[Rule]", "10"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myFRAME2", "[", "s_", "]"}], ":=", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"ImageMargins", "\[Rule]", "5"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", " ", 
          RowBox[{"Directive", "[", 
           RowBox[{"Thickness", "[", "5", "]"}], "]"}], ",", "Orange"}], 
         "}"}]}], ",", 
       RowBox[{"RoundingRadius", "\[Rule]", "10"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myFRAME3", "[", "s_", "]"}], ":=", 
     RowBox[{"Framed", "[", 
      RowBox[{"s", ",", 
       RowBox[{"ImageMargins", "\[Rule]", "5"}], ",", 
       RowBox[{"FrameStyle", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Thick", ",", " ", 
          RowBox[{"Directive", "[", 
           RowBox[{"Thickness", "[", "5", "]"}], "]"}], ",", "LightGreen"}], 
         "}"}]}], ",", 
       RowBox[{"RoundingRadius", "\[Rule]", "10"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"randFILEPRINT", "[", 
      RowBox[{"file_", ",", "rand_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "tmp", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FileNameJoin", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"file", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<cache\>\"", ",", 
            RowBox[{"tmp", "=", 
             RowBox[{
              RowBox[{"file", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
              RowBox[{"ToString", "[", "rand", "]"}], "<>", "\"\<.\>\"", "<>", 
              RowBox[{"file", "[", 
               RowBox[{"[", "3", "]"}], "]"}]}]}]}], "}"}], "]"}], ",", "tmp",
          ",", " ", 
         RowBox[{"file", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"cloudEXPORT", "[", 
       RowBox[{"file_", ",", "ss_"}], "]"}], ":=", 
      RowBox[{"Module", "[", 
       RowBox[{
        RowBox[{"{", "}"}], ",", 
        RowBox[{
         RowBox[{"Export", "[", 
          RowBox[{
           RowBox[{"file", "[", 
            RowBox[{"[", "1", "]"}], "]"}], ",", 
           RowBox[{"myRASTER", "@", 
            RowBox[{"Style", "[", 
             RowBox[{"ss", ",", 
              RowBox[{"ImageSizeMultipliers", "->", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], ",", 
              RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}]}], ",", 
           RowBox[{"file", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ";", 
         RowBox[{"file", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ";"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cloudEXPORT", "[", 
      RowBox[{"file_", ",", "ss_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"file", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "ss", ",", 
          RowBox[{"file", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ";", 
        RowBox[{"file", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"cloudEXPORT2", "[", 
      RowBox[{"file_", ",", "ss_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{
        RowBox[{"Export", "[", 
         RowBox[{
          RowBox[{"file", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"myRASTER", "@", "ss"}], ",", 
          RowBox[{"file", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ";", 
        RowBox[{"file", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myPARAN", "[", "c_", "]"}], ":=", 
     RowBox[{"Which", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"NumberQ", "[", "c", "]"}], "\[Equal]", "True"}], "&&", 
        RowBox[{"c", "<", "0"}]}], ",", " ", 
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<(\>\"", ",", 
          RowBox[{"TraditionalForm", "[", "c", "]"}], ",", "\"\<)\>\""}], 
         "}"}]}], ",", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"NumberQ", "[", "c", "]"}], "\[Equal]", "True"}], "&&", 
        RowBox[{"c", ">=", "0"}]}], ",", " ", 
       RowBox[{"TraditionalForm", "[", "c", "]"}], ",", 
       RowBox[{
        RowBox[{"NumberQ", "[", "c", "]"}], "\[Equal]", "False"}], ",", "c"}],
       "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myPARAN2", "[", "x_", "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{"\"\<(\>\"", ",", "x", ",", "\"\<)\>\""}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"number", " ", "chopping", " ", "and", " ", "rounding"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myCHOP1", "[", 
      RowBox[{"s_", ",", "n_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"N", "@", 
       RowBox[{"IntegerPart", "[", 
        RowBox[{"s", "*", 
         RowBox[{"(", 
          RowBox[{"10", "^", "n"}], ")"}]}], "]"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"10", "^", "n"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"handling", " ", "log", " ", "output"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"log2ln", "[", "s_", "]"}], ":=", 
     RowBox[{"TraditionalForm", "@", 
      RowBox[{"ToExpression", "@", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{
           RowBox[{"Log", "[", "s", "]"}], ",", "InputForm"}], "]"}], ",", 
         " ", 
         RowBox[{"{", 
          RowBox[{"\"\<Log\>\"", "\[Rule]", "\"\<ln\>\""}], "}"}]}], 
        "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myLOG", "[", 
      RowBox[{"h_", ",", "s_"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<log\>\"", ",", "h"}], "]"}], ",", " ", "\"\<(\>\"", ",",
         "s", ",", "\"\<)\>\""}], "}"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myLOG2", "[", 
      RowBox[{"h_", ",", "s_"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"\"\<log\>\"", ",", "h"}], "]"}], ",", " ", "\"\<(\>\"", ",", 
        RowBox[{"TraditionalForm", "@", "s"}], ",", "\"\<)\>\""}], "}"}]}]}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"handling", " ", "limit", " ", "output"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myLIM", "[", 
      RowBox[{"f_", ",", "x_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"TraditionalForm", "@", 
      RowBox[{"Row", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DisplayForm", "@", 
          RowBox[{"Underscript", "[", 
           RowBox[{"\"\<lim \>\"", ",", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{"x", ",", "\"\<\[LongRightArrow]\>\"", ",", "a"}], 
              "}"}]}]}], "]"}]}], ",", "f"}], "}"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myLIMR", "[", 
      RowBox[{"f_", ",", "x_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"TraditionalForm", "@", 
      RowBox[{"Row", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DisplayForm", "@", 
          RowBox[{"Underscript", "[", 
           RowBox[{"\"\<lim\>\"", ",", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{"x", ",", "\"\<\[LongRightArrow]\>\"", ",", 
               RowBox[{"Superscript", "[", 
                RowBox[{"a", ",", "\"\<+\>\""}], "]"}]}], "}"}]}]}], "]"}]}], 
         ",", "f"}], "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"myLIML", "[", 
      RowBox[{"f_", ",", "x_", ",", "a_"}], "]"}], ":=", 
     RowBox[{"TraditionalForm", "@", 
      RowBox[{"Row", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DisplayForm", "@", 
          RowBox[{"Underscript", "[", 
           RowBox[{"\"\<lim\>\"", ",", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{"x", ",", "\"\<\[LongRightArrow]\>\"", ",", 
               RowBox[{"Superscript", "[", 
                RowBox[{"a", ",", "\"\<-\>\""}], "]"}]}], "}"}]}]}], "]"}]}], 
         ",", "f"}], "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"AI", " ", "language", " ", "generator"}], "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"aAN", "[", "s_", "]"}], ":=", 
     RowBox[{
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<A\>\"", ",", "\"\<a\>\"", ",", "\"\<i\>\"", ",", "\"\<I\>\"",
              ",", "\"\<o\>\"", ",", "\"\<O\>\"", ",", "\"\<E\>\"", ",", 
             "\"\<e\>\""}], "}"}], ",", 
           RowBox[{"First", "@", 
            RowBox[{"Characters", "@", "s"}]}]}], "]"}], "\[Equal]", "True"}],
         ",", " ", "\"\<an\>\"", ",", "\"\<a\>\""}], "]"}], "<>", "\"\< \>\"",
       "<>", "s"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"appendFIRST", "[", 
      RowBox[{"a_", ",", "s_"}], "]"}], ":=", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", "a", "}"}], ",", 
          RowBox[{"s", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "}"}], ",", " ", 
       RowBox[{"Drop", "[", 
        RowBox[{"s", ",", "1"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "\[ReturnIndicator]", " ", "manually", " ", "done", " ", "by", " ", "the",
      " ", "programmer"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"textGEN2", "[", 
      RowBox[{"template_", ",", "assoc_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "text", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"text", "=", 
         RowBox[{"template", "@", "assoc"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"Flatten", "@", 
            RowBox[{"StringReplace", "[", 
             RowBox[{"#", ",", 
              RowBox[{"\"\<\[SpaceIndicator]\>\"", "\[Rule]", "\"\< \>\""}]}],
              "]"}]}], "&"}], "/@"}], "*)"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"StringSplit", "[", 
            RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
          RowBox[{"StringSplit", "[", 
           RowBox[{
            RowBox[{"StringJoin", "@", 
             RowBox[{"StringRiffle", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringReplacePart", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"ToUpperCase", "@", 
                    RowBox[{"StringTake", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{"TextSentences", "@", "text"}], ")"}]}], ")"}], ",",
                " ", "\"\< \>\""}], "]"}]}], ",", " ", 
            "\"\<\[ReturnIndicator]\>\""}], "]"}]}], ")"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"textGEN", "[", 
      RowBox[{"template_", ",", "assoc_", ",", "n_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"text", ",", "tmp", ",", "tmp2", ",", "flag"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"text", "=", 
         RowBox[{"StringSplit", "[", 
          RowBox[{
           RowBox[{"template", "@", "assoc"}], ",", "\"\< \>\""}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"text", "=", 
           RowBox[{"StringRiffle", "@", 
            RowBox[{"Riffle", "[", 
             RowBox[{
              RowBox[{"StringSplit", "[", 
               RowBox[{"text", ",", "\"\< \>\""}], "]"}], ",", 
              "\"\<\[ReturnIndicator]\>\"", ",", "n"}], "]"}]}]}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"tmp", "=", 
         RowBox[{"tmp2", "=", 
          RowBox[{"{", "}"}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"text", "=", 
         RowBox[{"StringJoin", "[", 
          RowBox[{"Riffle", "[", 
           RowBox[{
            RowBox[{"Flatten", "@", 
             RowBox[{"Join", "@", 
              RowBox[{"Riffle", "[", 
               RowBox[{
                RowBox[{"Table", "[", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"flag", "=", "False"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"StringContainsQ", "[", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    "\"\<\[CloverLeaf]plot\>\""}], "]"}], "\[Equal]", 
                    "False"}], ",", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{"tmp", ",", 
                    RowBox[{"text", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}], ";", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"Which", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"StringContainsQ", "[", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", 
                    "\"\<\[CloverLeaf]plot\>\""}], "]"}], "\[Equal]", 
                    "True"}], ",", 
                    RowBox[{
                    RowBox[{"tmp2", "=", 
                    RowBox[{"text", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], ";", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"flag", "=", "True"}], ";", "tmp2"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "+", "1"}], ")"}], "<=", 
                    RowBox[{"Length", "@", "text"}]}], "&&", 
                    RowBox[{
                    RowBox[{"StringContainsQ", "[", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", 
                    "\"\<\[CloverLeaf]plot\>\""}], "]"}], "\[Equal]", 
                    "True"}]}], ",", 
                    RowBox[{
                    RowBox[{"tmp2", "=", "tmp"}], ";", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"flag", "=", "True"}], ";", "tmp2"}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"i", "+", "1"}], ")"}], "<=", 
                    RowBox[{"Length", "@", "text"}]}], "&&", 
                    RowBox[{
                    RowBox[{"StringContainsQ", "[", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", 
                    "\"\<\[ReturnIndicator]\>\""}], "]"}], "\[Equal]", 
                    "True"}], "&&", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "!=", 
                    "\"\<\[ReturnIndicator]\>\""}]}], ",", 
                    RowBox[{
                    RowBox[{"tmp2", "=", "tmp"}], ";", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"flag", "=", "True"}], ";", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "=", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{
                    RowBox[{"text", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], ",", "1"}], 
                    "]"}]}], ";", "tmp2"}], ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"flag", "==", "False"}], "&&", 
                    RowBox[{
                    RowBox[{"Total", "@", 
                    RowBox[{"(", 
                    RowBox[{"StringLength", "[", "tmp", "]"}], ")"}]}], 
                    "\[GreaterEqual]", "n"}]}], "||", 
                    RowBox[{"i", "\[Equal]", 
                    RowBox[{"Length", "@", "text"}]}]}], ",", " ", 
                    RowBox[{
                    RowBox[{"tmp2", "=", "tmp"}], ";", 
                    RowBox[{"tmp", "=", 
                    RowBox[{"{", "}"}]}], ";", 
                    RowBox[{"flag", "=", "True"}], ";", "tmp2"}], ",", " ", 
                    "True", ",", "Nothing"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  "\[IndentingNewLine]", 
                  RowBox[{"{", 
                   RowBox[{"i", ",", "1", ",", 
                    RowBox[{"Length", "@", "text"}]}], "}"}]}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{"{", "\"\<\[ReturnIndicator]\>\"", "}"}], "}"}]}], 
               "]"}]}]}], ",", "\"\< \>\""}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"StringSplit", "[", 
            RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
          RowBox[{"StringSplit", "[", 
           RowBox[{
            RowBox[{"StringJoin", "@", 
             RowBox[{"StringRiffle", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringReplacePart", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"ToUpperCase", "@", 
                    RowBox[{"StringTake", "[", 
                    RowBox[{"#", ",", 
                    RowBox[{"{", "1", "}"}]}], "]"}]}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{"TextSentences", "@", "text"}], ")"}]}], ")"}], ",",
                " ", "\"\< \>\""}], "]"}]}], ",", " ", 
            "\"\<\[ReturnIndicator]\>\""}], "]"}]}], ")"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"FIXME", ":", " ", 
     RowBox[{"n", ">", 
      RowBox[{"70", " ", "has", " ", "additional", " ", "wraparounds"}]}]}], 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"paragGEN", "[", 
      RowBox[{
      "ctr_", ",", "template_", ",", "assoc_", ",", "replace_", ",", "n_"}], 
      "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{"Row", "/@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Riffle", "[", 
           RowBox[{"#", ",", "\"\< \>\""}], "]"}], "&"}], "/@", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"StringTrim", "@", "ctr"}], " ", "\[NotEqual]", " ", 
            "\"\<\>\""}], ",", 
           RowBox[{"appendFIRST", "[", 
            RowBox[{
             RowBox[{"StringTrim", "@", "ctr"}], ",", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"textGEN", "[", 
                RowBox[{"template", ",", "assoc", ",", "n"}], "]"}], "/.", 
               "replace"}], ")"}]}], "]"}], ",", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"textGEN", "[", 
              RowBox[{"template", ",", "assoc", ",", "n"}], "]"}], "/.", 
             "replace"}], ")"}]}], "]"}]}], ")"}]}], ")"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "used", " ", "for", " ", "resizing", " ", "the", " ", "Arabic", " ", 
     "modules"}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"mySTYLE", "[", "s_", "]"}], ":=", 
    RowBox[{"Style", "[", 
     RowBox[{"s", ",", 
      RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
      RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"or", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{"x", ",", "\"\< or \>\"", ",", "y"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"or", "[", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
       "x", ",", "\"\< or \>\"", ",", "y", ",", "\"\< or \>\"", ",", "z"}], 
       "}"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"or", "[", 
       RowBox[{"x_", ",", "y_", ",", "z_", ",", "t_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
       "x", ",", "\"\< or \>\"", ",", "y", ",", "\"\< or \>\"", ",", "z", ",",
         " ", "\"\< or \>\"", ",", " ", "t"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"and", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{"x", ",", "\"\< and \>\"", ",", "y"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"and", "[", 
       RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
       "x", ",", "\"\< and \>\"", ",", "y", ",", "\"\< and \>\"", ",", "z"}], 
       "}"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"and", "[", 
       RowBox[{"x_", ",", "y_", ",", "z_", ",", "t_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{
       "x", ",", "\"\< and \>\"", ",", "y", ",", "\"\< and \>\"", ",", "z", 
        ",", "\"\< and \>\"", ",", "t"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{"equal", "[", 
       RowBox[{"x_", ",", "y_"}], "]"}], "]"}], ":=", 
     RowBox[{"Row", "@", 
      RowBox[{"{", 
       RowBox[{"x", ",", "\"\<=\>\"", ",", "y"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"qTYPE", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<1\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<2\>\"", "\[Rule]", "\"\<2\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<3\>\"", "\[Rule]", "\"\<3\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<4\>\"", "\[Rule]", "\"\<4\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<5\>\"", "->", "\"\<5\>\""}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", "variation", "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"etc", "=", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
        RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
        RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
        RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], ";"}], 
    "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"makeVAR", "[", 
      RowBox[{
      "ctr_", ",", "logic_", ",", "mywords_", ",", "abcd_", ",", "etc_"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "type", ",", "index", ",", "links", ",", "linksTEXT", ",", "hint", 
         ",", "api", ",", "apiTEXT", ",", "tmp", ",", "tmp2", ",", "correct", 
         ",", " ", "wrong", ",", "tutorial", ",", "question", ",", "example", 
         ",", "algebra", ",", "results"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         StyleBox["LOGIC",
          FontColor->RGBColor[1, 0, 0]], ":", " ", 
         RowBox[{"add", " ", "your", " ", "logic", " ", 
          RowBox[{"here", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"results", "=", 
         RowBox[{"logic", "[", 
          RowBox[{"ctr", ",", " ", "mywords", ",", "abcd"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["QUESTION",
           FontColor->RGBColor[1, 0, 0]], ":", " ", 
          RowBox[{
           RowBox[{
           "TEXT", " ", "and", " ", "numbers", " ", "and", " ", "formulas", 
            " ", "and", " ", "plots"}], "..."}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"question", "=", 
         RowBox[{"results", "[", "\"\<question\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           StyleBox["EXAMPLE",
            FontColor->RGBColor[1, 0, 0]], ":", " ", 
           RowBox[{"ACTUAL", " ", "SOLVED", " ", "SOLUTION"}]}], ",", " ", 
          RowBox[{
           RowBox[{
           "question", " ", "TEXT", " ", "and", " ", "numbers", " ", "and", 
            " ", "formulas", " ", "and", " ", "plots"}], "..."}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"example", "=", 
         RowBox[{"results", "[", "\"\<example\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["ANSWERS",
           FontColor->RGBColor[1, 0, 0]], ":", " ", 
          RowBox[{"correct", " ", "and", " ", "wrong"}]}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"correct", "=", 
         RowBox[{"results", "[", "\"\<correct\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"results", "[", "\"\<wrong\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["TUTORIAL",
           FontColor->RGBColor[1, 0, 0]], ":", " ", 
          RowBox[{
          "place", " ", "your", " ", "full", " ", "solutions", " ", "or", " ",
            "tutorials", " ", "here"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"tutorial", "=", 
         RowBox[{"Column", "@", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"results", "[", "\"\<question labeled\>\"", "]"}], "}"}],
             ",", "\[IndentingNewLine]", 
            RowBox[{"(", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"wrong", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"wrong", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"highlightCORRECT2", "@", "correct"}], ",", 
               RowBox[{"(*", 
                RowBox[{
                "Correct", " ", "answer", " ", "is", " ", "the", " ", "3", 
                 "rd", " ", "item", " ", "in", " ", "\"\<choices\>\""}], 
                "*)"}], "\[IndentingNewLine]", 
               RowBox[{"wrong", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], "\[IndentingNewLine]", 
              "}"}], ")"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{"#", ",", 
                 RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}], "&"}], 
              "/@"}], "*)"}], 
            RowBox[{"(", 
             RowBox[{"results", "[", "\"\<solution\>\"", "]"}], ")"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         StyleBox["Hint",
          FontColor->RGBColor[1, 0, 0]], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"hint", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["Hyperlinks",
           FontColor->RGBColor[1, 0, 0]], ":", " ", "References"}], " ", 
         "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"links", "=", 
         RowBox[{"{", "\[IndentingNewLine]", "}"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"linksTEXT", "=", 
         RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["APIs",
           FontColor->RGBColor[1, 0, 0]], ":", " ", "References"}], " ", 
         "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "in", " ", "some", " ", "cases", " ", "the", " ", "APIs", " ", 
          "build", " ", "earlier", " ", "and", " ", "stored", " ", "into", 
          " ", "vars"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"api", "=", 
         RowBox[{
         "{", "\[IndentingNewLine]", "\"\<\>\"", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"apiTEXT", "=", 
         RowBox[{
         "{", "\[IndentingNewLine]", "\"\<\>\"", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          StyleBox["Type",
           FontColor->RGBColor[1, 0, 0]], ":", " ", 
          RowBox[{"question", " ", "type"}]}], "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"type", "=", 
         RowBox[{"etc", "[", "\"\<type\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           StyleBox["PARAMS",
            FontColor->RGBColor[1, 0, 0]], ":", " ", 
           RowBox[{
           "place", " ", "your", " ", "parameters", " ", "for", " ", "the", 
            " ", "question", " ", "here"}]}], ",", " ", 
          RowBox[{
          "to", " ", "be", " ", "passed", " ", "to", " ", "next", " ", 
           "questions"}]}], "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"algebra", "=", 
         RowBox[{"results", "[", "\"\<abcd\>\"", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"index", "=", 
         RowBox[{"RandomSample", "[", 
          RowBox[{
           RowBox[{"Range", "@", "4"}], ",", "4"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
         "Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"isSERVER", "\[Equal]", "\"\<JSON\>\""}], ",", 
           RowBox[{"\"\<json\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"\"\<algebra\>\"", "\[Rule]", 
                RowBox[{"ToString", "[", 
                 RowBox[{"algebra", ",", "InputForm"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<question\>\"", "\[Rule]", 
                RowBox[{"cloudEXPORT", "[", 
                 RowBox[{
                  RowBox[{"randFILE", "[", 
                   RowBox[{"etc", "[", "\"\<question\>\"", "]"}], "]"}], ",", 
                  "question"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"\"\<links\>\"", "\[Rule]", "links"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<links_text\>\"", "\[Rule]", "linksTEXT"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<tutorial\>\"", "\[Rule]", 
                RowBox[{"cloudEXPORT", "[", 
                 RowBox[{
                  RowBox[{"randFILE", "[", 
                   RowBox[{"etc", "[", "\"\<tutorial\>\"", "]"}], "]"}], ",", 
                  "tutorial"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"\"\<hint\>\"", "\[Rule]", 
                RowBox[{"If", "[", " ", 
                 RowBox[{
                  RowBox[{"hint", "\[NotEqual]", "\"\<\>\""}], ",", 
                  RowBox[{"cloudEXPORT", "[", 
                   RowBox[{
                    RowBox[{"randFILE", "[", "myDIRECTORY", "]"}], ",", 
                    "hint"}], "]"}], ",", "\"\<\>\""}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<example\>\"", "\[Rule]", 
                RowBox[{"cloudEXPORT", "[", 
                 RowBox[{
                  RowBox[{"randFILE", "[", "myDIRECTORY", "]"}], ",", 
                  "example"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"\"\<algebra\>\"", "\[Rule]", 
                  RowBox[{"ToString", "[", 
                   RowBox[{"algebra", ",", "InputForm"}], "]"}]}], ","}], 
                "*)"}], "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"results", "[", "\"\<anime\>\"", "]"}], 
                  "\[NotEqual]", 
                  RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"\"\<anime\>\"", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"<|", 
                    RowBox[{
                    RowBox[{"\"\<image\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"cloudEXPORT", "[", 
                    RowBox[{
                    RowBox[{"randFILE", "[", 
                    RowBox[{"etc", "[", "\"\<anime\>\"", "]"}], "]"}], ",", 
                    RowBox[{"results", "[", "\"\<anime\>\"", "]"}]}], "]"}], 
                    ")"}]}], ",", " ", 
                    RowBox[{"\"\<slider\>\"", "\[Rule]", "\"\<true\>\""}], 
                    ",", " ", 
                    RowBox[{"\"\<optimize\>\"", "\[Rule]", "0"}]}], "|>"}], 
                   ")"}]}], ",", "Nothing"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"results", "[", "\"\<example_anime\>\"", "]"}], 
                  "\[NotEqual]", 
                  RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"<|", 
                    RowBox[{
                    RowBox[{"\"\<image\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"cloudEXPORT", "[", 
                    RowBox[{
                    RowBox[{"randFILE", "[", 
                    RowBox[{"etc", "[", "\"\<anime\>\"", "]"}], "]"}], ",", 
                    RowBox[{"results", "[", "\"\<example_anime\>\"", "]"}]}], 
                    "]"}], ")"}]}], ",", " ", 
                    RowBox[{"\"\<slider\>\"", "\[Rule]", "\"\<true\>\""}], 
                    ",", " ", 
                    RowBox[{"\"\<optimize\>\"", "\[Rule]", "0"}]}], "|>"}], 
                   ")"}]}], ",", "Nothing"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{"results", "[", "\"\<tutorial_anime\>\"", "]"}], 
                  "\[NotEqual]", 
                  RowBox[{"{", "}"}]}], ",", 
                 RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"<|", 
                    RowBox[{
                    RowBox[{"\"\<image\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"cloudEXPORT", "[", 
                    RowBox[{
                    RowBox[{"randFILE", "[", 
                    RowBox[{"etc", "[", "\"\<anime\>\"", "]"}], "]"}], ",", 
                    RowBox[{"results", "[", "\"\<tutorial_anime\>\"", "]"}]}],
                     "]"}], ")"}]}], ",", " ", 
                    RowBox[{"\"\<slider\>\"", "\[Rule]", "\"\<true\>\""}], 
                    ",", " ", 
                    RowBox[{"\"\<optimize\>\"", "\[Rule]", "0"}]}], "|>"}], 
                   ")"}]}], ",", "Nothing"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<video\>\"", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"results", "[", "\"\<video\>\"", "]"}], ")"}]}], ",",
                "\[IndentingNewLine]", 
               RowBox[{"\"\<API\>\"", "\[Rule]", "api"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<API_text\>\"", "\[Rule]", "apiTEXT"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<cdf\>\"", "\[Rule]", "\"\<\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<cloud\>\"", "\[Rule]", "\"\<\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<type\>\"", "\[Rule]", "type"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<typeTEXT\>\"", "\[Rule]", 
                RowBox[{"qTYPE", "[", "type", "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<pdf\>\"", "\[Rule]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"results", "[", "\"\<example PDF\>\"", "]"}], "===", 
                   RowBox[{"{", "}"}]}], ",", 
                  RowBox[{"cloudEXPORT", "[", 
                   RowBox[{
                    RowBox[{"randFILE", "[", "myPDFDIRECTORY", "]"}], ",", 
                    "tutorial"}], "]"}], ",", 
                  RowBox[{"cloudEXPORT", "[", 
                   RowBox[{
                    RowBox[{"randFILE", "[", "myPDFDIRECTORY", "]"}], ",", 
                    RowBox[{"results", "[", "\"\<example PDF\>\"", "]"}]}], 
                   "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"\"\<choices\>\"", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"cloudEXPORT", "[", 
                    RowBox[{
                    RowBox[{"randFILE", "[", "myDIRECTORY", "]"}], ",", "#"}],
                     "]"}], "&"}], "/@", 
                  RowBox[{"{", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", "correct", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "Correct", " ", "answer", " ", "is", " ", "the", " ", "3",
                     "rd", " ", "item", " ", "in", " ", "\"\<choices\>\""}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "\[IndentingNewLine]", 
                   "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"\"\<index\>\"", "\[Rule]", "index"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<forum\>\"", "\[Rule]", "\"\<\>\""}]}], 
              "\[IndentingNewLine]", "}"}], ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"isSERVER", "\[Equal]", "\"\<PDF\>\""}], ",", 
           RowBox[{"\"\<pdf\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"\"\<question\>\"", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"Style", "[", 
                  RowBox[{
                   RowBox[{"Column", "[", 
                    RowBox[{"{", 
                    RowBox[{"question", ",", 
                    RowBox[{"Grid", "[", " ", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", "False", "]"}], ",", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", "False", "]"}], ",", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", "False", "]"}], ",", "correct"}],
                     "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "Correct", " ", "answer", " ", "is", " ", "the", " ", "3",
                     "rd", " ", "item", " ", "in", " ", "\"\<choices\>\""}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Checkbox", "[", "False", "]"}], ",", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], 
                    "\[IndentingNewLine]", "}"}], "[", 
                    RowBox[{"[", "index", "]"}], "]"}], "]"}]}], "}"}], "]"}],
                    ",", 
                   RowBox[{"Magnification", "\[Rule]", "1"}], ",", 
                   RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], ")"}]}], 
               ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<answer\>\"", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"Column", "[", 
                  RowBox[{"{", 
                   RowBox[{"question", ",", " ", 
                    RowBox[{"Column", "@", 
                    RowBox[{
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"highlightCORRECT2", "@", "correct"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    "Correct", " ", "answer", " ", "is", " ", "the", " ", "3",
                     "rd", " ", "item", " ", "in", " ", "\"\<choices\>\""}], 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"wrong", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "\[IndentingNewLine]", 
                    "}"}], "[", 
                    RowBox[{"[", "index", "]"}], "]"}]}]}], "}"}], "]"}], 
                 ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\<links\>\"", "\[Rule]", "links"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<links_text\>\"", "\[Rule]", "linksTEXT"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<tutorial\>\"", "\[Rule]", "tutorial"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<example\>\"", "\[Rule]", 
                RowBox[{"(", "example", ")"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"\"\<algebra\>\"", "\[Rule]", 
                RowBox[{"ToString", "[", 
                 RowBox[{"algebra", ",", "InputForm"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<cdf\>\"", "\[Rule]", "\"\<\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<cloud\>\"", "\[Rule]", "\"\<\>\""}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<type\>\"", "\[Rule]", "type"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\<typeTEXT\>\"", "\[Rule]", 
                RowBox[{"qTYPE", "[", "type", "]"}]}]}], "|>"}], ")"}]}], ",",
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "True", ",", "Null"}], "]"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "|>"}]}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"logic", "&"}], "word", " ", "functions"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic1", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "expression", ",", "list", ",", 
         "expression0", ",", "expressions"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "||", 
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "||", 
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"a", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"c", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"expressions", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"a", "*", "x"}], "+", 
                  RowBox[{"b", "*", "y"}], "+", 
                  RowBox[{"c", "*", "z"}]}], ",", " ", 
                 RowBox[{
                  RowBox[{"a", "*", 
                   RowBox[{"x", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}], "+", 
                  RowBox[{"b", "*", 
                   RowBox[{"y", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], ",", 
                 RowBox[{
                  RowBox[{"x", "/", "a"}], "+", 
                  RowBox[{"b", "/", "y"}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], " ", ",", 
                 RowBox[{
                  RowBox[{"a", "*", 
                   RowBox[{"x", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], "+", 
                  RowBox[{"b", "*", 
                   RowBox[{"y", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}]}]}], "}"}], 
               "/.", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                 RowBox[{"y", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                 RowBox[{"z", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}], ",", "4"}], 
             "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"expression0", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"ToString", "[", 
               RowBox[{"#", ",", "InputForm"}], "]"}], "&"}], "/@", 
             "expressions"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"expression", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"StringReplace", "[", 
               RowBox[{"#", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\</\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], 
                 "}"}]}], "]"}], "&"}], "/@", "expression0"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{"expressions", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "}"}]}]}], "  ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"expressions", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "/.", 
               RowBox[{"{", 
                RowBox[{"a", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"-", "a"}], ")"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"expressions", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "/.", 
               RowBox[{"{", 
                RowBox[{"b", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"-", "b"}], ")"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"expressions", "[", 
                  RowBox[{"[", "1", "]"}], "]"}], "}"}]}], "/.", 
               RowBox[{"{", 
                RowBox[{"c", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"-", "c"}], ")"}]}], "}"}]}]}], "}"}]}], ";"}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
            RowBox[{
            "(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"myFRAME1", "@", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                   "ctr", ",", 
                    "\"\<Which expression matches this parse tree:\>\""}], 
                   "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"TreeForm", "[", 
                   RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"(", 
                    RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                    RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], 
                   "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "}"}]}]}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<question\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"myFRAME1", "@", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                   "ctr", ",", 
                    "\"\<Which expression matches this parse tree:\>\""}], 
                   "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"TreeForm", "[", 
                   RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"(", 
                    RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                    RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], 
                   "}"}]}]}], "\[IndentingNewLine]", "}"}]}]}], 
             "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]",
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<example\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Example Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "}"}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
             "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
             "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]",
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<solution\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Solution\>\"", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
               "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<correct\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
             ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<wrong\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
              "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], 
           ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<video\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<abcd\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ",", 
           RowBox[{"y", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"z", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic2", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "expression", ",", "list", ",", 
         "expression0", ",", "expressions"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\""}], "}"}]}], "]"}], ",", "3"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], "||", 
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "||", 
           RowBox[{"correct", "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}], "||", 
           RowBox[{
            RowBox[{"wrong", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "===", 
            RowBox[{"wrong", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"a", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"c", "=", 
            RowBox[{
             RowBox[{"RandomInteger", "[", 
              RowBox[{"{", 
               RowBox[{"2", ",", "100"}], "}"}], "]"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "^", 
               RowBox[{"RandomInteger", "[", "]"}]}], ")"}]}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"expressions", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"a", "*", "x"}], "+", 
                  RowBox[{"b", "*", "y"}], "+", 
                  RowBox[{"c", "*", "z"}]}], ",", " ", 
                 RowBox[{
                  RowBox[{"a", "*", 
                   RowBox[{"x", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}], "+", 
                  RowBox[{"b", "*", 
                   RowBox[{"y", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], ",", 
                 RowBox[{
                  RowBox[{"x", "/", "a"}], "+", 
                  RowBox[{"b", "/", "y"}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], " ", ",", 
                 RowBox[{
                  RowBox[{"a", "*", 
                   RowBox[{"x", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], "+", 
                  RowBox[{"b", "*", 
                   RowBox[{"y", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}], "+", 
                  RowBox[{"c", "*", 
                   RowBox[{"z", "^", 
                    RowBox[{"-", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "100"}], "}"}], "]"}]}]}]}]}]}], "}"}], 
               "/.", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"x", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                 RowBox[{"y", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                 RowBox[{"z", "\[Rule]", 
                  RowBox[{"vv", "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}], ",", "4"}], 
             "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"expression0", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"ToString", "[", 
               RowBox[{"#", ",", "InputForm"}], "]"}], "&"}], "/@", 
             "expressions"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"expression", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"StringReplace", "[", 
               RowBox[{"#", ",", 
                RowBox[{"{", 
                 RowBox[{"\"\</\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}], 
                 "}"}]}], "]"}], "&"}], "/@", "expression0"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"TreeForm", "[", 
                RowBox[{
                 RowBox[{"ToExpression", "@", 
                  RowBox[{"(", 
                   RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}], ",", 
                 RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                 RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                 RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                 RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], "}"}]}], 
              "}"}]}]}], "  ", ";", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"expression0", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"#", ",", "InputForm"}], "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{"expressions", "/.", 
                   RowBox[{"{", 
                    RowBox[{"a", "\[Rule]", 
                    RowBox[{"-", "a"}]}], "}"}]}], ")"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"expression", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\</\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}],
                     "}"}]}], "]"}], "&"}], "/@", "expression0"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"TreeForm", "[", 
                   RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{"a", "\[Rule]", 
                    RowBox[{"-", "a"}]}], "}"}]}], ")"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                    RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], "}"}]}],
                  "}"}]}]}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expression0", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"#", ",", "InputForm"}], "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{"expressions", "/.", 
                   RowBox[{"{", 
                    RowBox[{"b", "\[Rule]", 
                    RowBox[{"-", "b"}]}], "}"}]}], ")"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"expression", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\</\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}],
                     "}"}]}], "]"}], "&"}], "/@", "expression0"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"TreeForm", "[", 
                   RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{"b", "\[Rule]", 
                    RowBox[{"-", "b"}]}], "}"}]}], ")"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                    RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], "}"}]}],
                  "}"}]}]}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expression0", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"ToString", "[", 
                   RowBox[{"#", ",", "InputForm"}], "]"}], "&"}], "/@", 
                 RowBox[{"(", 
                  RowBox[{"expressions", "/.", 
                   RowBox[{"{", 
                    RowBox[{"c", "\[Rule]", 
                    RowBox[{"-", "c"}]}], "}"}]}], ")"}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"expression", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"#", ",", 
                    RowBox[{"{", 
                    RowBox[{"\"\</\>\"", "->", " ", "\"\<\[CirclePlus]\>\""}],
                     "}"}]}], "]"}], "&"}], "/@", "expression0"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"TreeForm", "[", 
                   RowBox[{
                    RowBox[{"ToExpression", "@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"expression", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/.", 
                    RowBox[{"{", 
                    RowBox[{"c", "\[Rule]", 
                    RowBox[{"-", "c"}]}], "}"}]}], ")"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}], "/.", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
                    RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
                    RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
                    RowBox[{"CirclePlus", "\[Rule]", "\"\</\>\""}]}], "}"}]}],
                  "}"}]}]}]}], "}"}]}], ";"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{
         RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
            RowBox[{
            "(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"myFRAME1", "@", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                   "ctr", ",", 
                    "\"\<Which parse tree matches this expression:\>\""}], 
                   "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"expressions", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
                "}"}]}]}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<question\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"myFRAME1", "@", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                   "ctr", ",", 
                    "\"\<Which parse tree matches this expression:\>\""}], 
                   "}"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"expressions", "[", 
                  RowBox[{"[", "1", "]"}], "]"}]}], "\[IndentingNewLine]", 
                "}"}]}]}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]",
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<example\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Example Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "}"}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
            "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", 
             "to", " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", 
             "is", " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{"Column", "@", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]",
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<solution\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<Solution\>\"", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
               "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<correct\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", 
             RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
             ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<wrong\>\"", "\[Rule]", 
            RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"myFRAME2", "@", 
                RowBox[{"wrong", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
              "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], 
           ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<video\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"\"\<abcd\>\"", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"x", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ",", 
           RowBox[{"y", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], ",", 
           RowBox[{"z", "\[Rule]", 
            RowBox[{"vv", "[", 
             RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.715672590225608*^9, 3.715672680758436*^9}, {
   3.7156730014293756`*^9, 3.715673042865117*^9}, {3.7156731549647827`*^9, 
   3.715673190648404*^9}, {3.715673263979743*^9, 3.7156734604728937`*^9}, {
   3.7156735128563747`*^9, 3.715673550228595*^9}, {3.715673608831208*^9, 
   3.715673637056087*^9}, 3.715673672611883*^9, {3.715673703827639*^9, 
   3.7156737060309963`*^9}, {3.7156737537220163`*^9, 3.715673914681834*^9}, {
   3.715673947928261*^9, 3.715673948197551*^9}, {3.715674046430978*^9, 
   3.7156741330027857`*^9}, {3.715674308613782*^9, 3.715674402435034*^9}, {
   3.715674460689313*^9, 3.7156744718709927`*^9}, {3.715674575215659*^9, 
   3.715674641793273*^9}, {3.715674679010993*^9, 3.715674687785102*^9}, {
   3.7156747450724916`*^9, 3.715674769832285*^9}, {3.715674875213126*^9, 
   3.715674951432777*^9}, {3.7156749885589523`*^9, 3.715675066860895*^9}, {
   3.715675106820595*^9, 3.7156751179572563`*^9}, {3.715675186559423*^9, 
   3.715675229906802*^9}, {3.715675273703516*^9, 3.715675280172159*^9}, {
   3.7156753290678673`*^9, 3.715675369849062*^9}, 3.715675407911953*^9, {
   3.715675451447926*^9, 3.7156754516603127`*^9}, {3.715675499834889*^9, 
   3.7156755043111258`*^9}, {3.715675541417487*^9, 3.7156756444886436`*^9}, {
   3.715680379847517*^9, 3.715680380960196*^9}, 3.71568372864264*^9, 
   3.715685369930393*^9, 3.7158885441537657`*^9, {3.7158897309950647`*^9, 
   3.71588977238424*^9}, {3.715896146720785*^9, 3.715896148214527*^9}, {
   3.7159323011359987`*^9, 3.71593230898594*^9}, 3.71648213121729*^9, {
   3.7164857772585573`*^9, 3.716485803365793*^9}, {3.716486065717132*^9, 
   3.716486067055005*^9}, 3.716802926972432*^9, {3.717063687312025*^9, 
   3.717063690765329*^9}, 3.717088987285632*^9, 3.717323777667368*^9, {
   3.717324435172152*^9, 3.717324533374116*^9}, {3.7173306921993523`*^9, 
   3.7173306947750053`*^9}, {3.717670115108698*^9, 3.717670118693686*^9}, 
   3.7177504826688538`*^9, {3.7178349750806513`*^9, 3.717834975588356*^9}, {
   3.717871700231214*^9, 3.717871706563184*^9}, 3.7178718698068743`*^9, 
   3.7178730773166733`*^9, {3.718290837549704*^9, 3.718290871379149*^9}, {
   3.7195639398425293`*^9, 3.719563940215005*^9}, {3.719564034757428*^9, 
   3.719564105517271*^9}, {3.7199215784640703`*^9, 3.719921588748432*^9}, 
   3.719924587845545*^9, {3.7199247413298492`*^9, 3.719924749124503*^9}, {
   3.7202857804822083`*^9, 3.720285783717793*^9}, {3.720286263422349*^9, 
   3.720286293436346*^9}, {3.720879791328335*^9, 3.7208797914840307`*^9}, {
   3.721464057443535*^9, 3.721464137751882*^9}, {3.7214641983001747`*^9, 
   3.721464498288966*^9}, {3.7214645308768177`*^9, 3.7214645320203876`*^9}, {
   3.7214645786007442`*^9, 3.721464684062376*^9}, {3.721464753250856*^9, 
   3.721464757471951*^9}, {3.721464865377735*^9, 3.721465109633658*^9}, {
   3.721465175370235*^9, 3.721465233187255*^9}, {3.721465313908185*^9, 
   3.7214653679768887`*^9}, {3.721465415429448*^9, 3.721465428492988*^9}, {
   3.721465465420662*^9, 3.7214656417533627`*^9}, {3.7214656837899017`*^9, 
   3.7214657105910597`*^9}, {3.721465754319457*^9, 3.721465785488431*^9}, {
   3.721465844428589*^9, 3.721465853917791*^9}, 3.7214658877824183`*^9, {
   3.721465928733481*^9, 3.721465964877398*^9}, {3.7214666616833572`*^9, 
   3.7214666656914787`*^9}, {3.721466815438938*^9, 3.721466848503893*^9}, {
   3.7214669065289707`*^9, 3.721466933930434*^9}, {3.721466969066023*^9, 
   3.721467015310498*^9}, {3.72146706008222*^9, 3.7214670629070663`*^9}, {
   3.721467569634123*^9, 3.7214675706099977`*^9}, {3.721505224031066*^9, 
   3.721505244334593*^9}},
 CellLabel->"In[7]:=",ExpressionUUID->"71cb9b49-4c7c-45cf-b6dc-068086459f40"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"LaunchKernels", "[", "64", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 
   3.721467782751121*^9},ExpressionUUID->"a9d50eb9-5fde-4275-b8e2-\
4543c510aa24"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"25", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"26", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"27", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"28", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9},ExpressionUUID->"1dd66e97-0804-4c57-a786-\
7118341085ae"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 
   3.71567570442386*^9},ExpressionUUID->"a708520b-e1fd-4d73-8144-\
87c07e9d9350"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<parse_\>\"", ",", 
     "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<parse_\>\"", ",", 
     "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<parse_\>\"", ",", 
     "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<parse_\>\"", ",", 
      "\"\<pdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic1", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], 
           RowBox[{"(*", 
            RowBox[{",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"logic2", ",", 
               RowBox[{"{", "}"}], ",", 
               RowBox[{"<|", 
                RowBox[{
                 RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
                 RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
                 RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
                 RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], 
                "|>"}]}], "}"}]}], "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"logic1", ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{"<|", 
                  RowBox[{
                   RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
                   RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
                   RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
                   RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], 
                  "|>"}]}], "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"logic2", ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{"<|", 
                  RowBox[{
                   RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
                   RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
                   RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
                   RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], 
                  "|>"}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], "*)"}], 
           "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "8", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.721467750960915*^9, 3.721467778455165*^9}, {3.749865169889759*^9, 
   3.749865172756899*^9}, {3.7498652641555023`*^9, 
   3.749865264400976*^9}},ExpressionUUID->"53478b29-9a5c-49cc-8357-\
28b34dfad1dc"],

Cell[CellGroupData[{

Cell["\<\


PDF\
\>", "Title",
 CellChangeTimes->{{3.716111141711953*^9, 
  3.716111142510111*^9}},ExpressionUUID->"1e4335df-b5cc-423c-9ad8-\
e88e091dbe56"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"mathematica", ".", "stackexchange", ".", "com"}], "/", 
        "questions"}], "/", "31780"}], "/", "export"}], "-", "list", "-", 
     "elements", "-", "each", "-", "to", "-", "its", "-", "own", "-", "page", 
     "-", "in", "-", "a", "-", "multi", "-", "paged", "-", "pdf", "-", 
     "document"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetOptions", "[", 
     RowBox[{
      RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
      RowBox[{"PageBreakWithin", "\[Rule]", "True"}]}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"CloseKernels", "[", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"LaunchKernels", "[", "4", "]"}]}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"hintON", "=", "False"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"isSERVER", "=", "\"\<PDF\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myDIRECTORY", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<QMS702_Q5_\>\"", 
       ",", "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myCDFDIRECTORY", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<QMS702_Q5_\>\"", 
       ",", "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myGIFDIRECTORY", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<QMS702_Q5_\>\"", 
       ",", "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myPDFDIRECTORY", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], ",", 
       "\"\<QMS702_Q5_PRINT_\>\"", ",", "\"\<pdf\>\""}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myTITLE", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<QMS702\>\"", ",", "\"\<Quiz 5\>\"", ",", 
       "\"\<Prof. Boza Tasic\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myTITLE2", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<QMS702\>\"", ",", "\"\<Quiz 5\>\"", ",", "\"\< \>\"", ",", 
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{
         "\"\<Prof. Boza Tasic\>\"", ",", "\"\<      \>\"", ",", 
          "\"\<           \>\""}], "}"}]}], ",", "\"\< \>\"", ",", 
       "\"\<Name: __________________________\>\"", ",", "\"\< \>\""}], " ", 
      "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"page", "=", "1"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"varilist", "=", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Q5logic1", ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
             RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<tutorial\>\"", "->", "myGIFDIRECTORY"}], ",", 
             RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Q5logic2", ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<2\>\""}], ",", 
             RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Q5logic3", ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<3\>\""}], ",", 
             RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Q5logic4", ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<4\>\""}], ",", 
             RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"Q5logic5", ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"<|", 
            RowBox[{
             RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<5\>\""}], ",", 
             RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
             RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
          "}"}]}], "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"nn", "=", 
       RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"varilist", "=", 
       RowBox[{"RandomSample", "[", 
        RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"tmp", "=", 
       RowBox[{"ConstantArray", "[", 
        RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"logics", "=", 
       RowBox[{"varilist", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"words", "=", 
       RowBox[{"varilist", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"etc", "=", 
       RowBox[{"varilist", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"module", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tmp", "[", 
           RowBox[{"[", "ii", "]"}], "]"}], "=", 
          RowBox[{
           RowBox[{"makeVAR", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"ToString", "[", "ii", "]"}], "<>", "\"\<. \>\""}], ",", 
             RowBox[{"logics", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], ",", 
             RowBox[{"words", "[", 
              RowBox[{"[", "ii", "]"}], "]"}], ",", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"ii", "\[Equal]", "1"}], ",", 
               RowBox[{"{", "}"}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", " ", 
                  RowBox[{"tmp", "[", 
                   RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
             RowBox[{"etc", "[", 
              RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<pdf\>\"", 
           "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"ii", ",", "page", ",", "nn"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"rand", "=", 
       RowBox[{"ToString", "@", 
        RowBox[{"RandomInteger", "[", 
         RowBox[{"{", 
          RowBox[{"1000000", ",", "9000000"}], "}"}], "]"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"myList", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Column", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Image", "[", 
                RowBox[{
                 GraphicsBox[
                  TagBox[RasterBox[CompressedData["
1:eJzsfXVgVdfy7om7hyS412+F3uLuToi74k6wBA0uxZIQdycNlAItUkopFClQ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                    
                    "], {{0, 87}, {250, 0}}, {0, 255},
                    ColorFunction->RGBColor],
                   BoxForm`ImageTag[
                   "Byte", ColorSpace -> "RGB", Interleaving -> True],
                   Selectable->False],
                  BaseStyle->"ImageGraphics",
                  ImageSize->Automatic,
                  ImageSizeRaw->{250, 87},
                  PlotRange->{{0, 250}, {0, 87}}], ",", 
                 RowBox[{"ImageSize", "\[Rule]", "125"}]}], "]"}], ",", 
               RowBox[{"Column", "@", "myTITLE2"}], ",", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"nn", ",", " ", "\"\< questions\>\""}], "}"}]}], ",",
                "rand", ",", "\"\< \>\""}], "}"}]}], ",", 
            RowBox[{"Magnification", "\[Rule]", "1.5"}], ",", 
            RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Column", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"module", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", "\"\<question\>\"", 
               "]"}], ",", "rand"}], "}"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], "]"}]}], 
      ";", "\n", 
      RowBox[{"report", "=", 
       RowBox[{"CreateDocument", "[", 
        RowBox[{"Null", ",", 
         RowBox[{"PageHeaders", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"None", ",", "None", ",", "None"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"None", ",", "None", ",", "None"}], "}"}]}], "}"}]}]}], 
        "]"}]}], ";", "\n", 
      RowBox[{"Do", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Paste", "[", 
          RowBox[{"report", ",", "i"}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"NotebookWrite", "[", 
          RowBox[{"report", ",", 
           RowBox[{"Cell", "[", 
            RowBox[{"\"\<\>\"", ",", "\"\<PageBreak\>\"", ",", 
             RowBox[{"PageBreakBelow", "\[Rule]", "True"}]}], "]"}]}], "]"}], 
         ";"}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "myList"}], "}"}]}], "]"}], ";", "\n", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{"FileNameJoin", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"NotebookDirectory", "[", "]"}], ",", 
           RowBox[{
           "\"\<QMS702_Q5_\>\"", "<>", "rand", "<>", "\"\<.pdf\>\""}]}], 
          "}"}], "]"}], ",", "report"}], "]"}], ";", "\n", 
      RowBox[{"NotebookClose", "[", "report", "]"}], ";", "\n", 
      RowBox[{"Clear", "[", "report", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"myList", "=", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"Column", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Image", "[", 
                RowBox[{
                 GraphicsBox[
                  TagBox[RasterBox[CompressedData["
1:eJzsfXVgVdfy7om7hyS412+F3uLuToi74k6wBA0uxZIQdycNlAItUkopFClQ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                    
                    "], {{0, 87}, {250, 0}}, {0, 255},
                    ColorFunction->RGBColor],
                   BoxForm`ImageTag[
                   "Byte", ColorSpace -> "RGB", Interleaving -> True],
                   Selectable->False],
                  BaseStyle->"ImageGraphics",
                  ImageSize->Automatic,
                  ImageSizeRaw->{250, 87},
                  PlotRange->{{0, 250}, {0, 87}}], ",", 
                 RowBox[{"ImageSize", "\[Rule]", "125"}]}], "]"}], ",", 
               RowBox[{"Column", "@", "myTITLE2"}], ",", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"nn", ",", " ", "\"\< questions\>\""}], "}"}]}], ",",
                "rand", ",", "\"\< \>\""}], "}"}]}], ",", 
            RowBox[{"Magnification", "\[Rule]", "1.5"}], ",", 
            RowBox[{"LineIndent", "\[Rule]", "0"}]}], "]"}], "}"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"Column", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"module", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], "[", "\"\<answer\>\"", "]"}],
               ",", "rand"}], "}"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], "]"}]}], 
      ";", "\n", 
      RowBox[{"report", "=", 
       RowBox[{"CreateDocument", "[", 
        RowBox[{"Null", ",", 
         RowBox[{"PageHeaders", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"None", ",", "None", ",", "None"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"None", ",", "None", ",", "None"}], "}"}]}], "}"}]}]}], 
        "]"}]}], ";", "\n", 
      RowBox[{
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Paste", "[", 
           RowBox[{"report", ",", "i"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"NotebookWrite", "[", 
           RowBox[{"report", ",", 
            RowBox[{"Cell", "[", 
             RowBox[{"\"\<\>\"", ",", "\"\<PageBreak\>\"", ",", 
              RowBox[{"PageBreakBelow", "\[Rule]", "True"}]}], "]"}]}], "]"}],
           ";"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "myList"}], "}"}]}], "]"}], "\n", 
       RowBox[{"Export", "[", 
        RowBox[{
         RowBox[{"FileNameJoin", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"NotebookDirectory", "[", "]"}], ",", 
            RowBox[{
            "\"\<QMS702_Q2_\>\"", "<>", "rand", "<>", 
             "\"\<_ANSWERS.pdf\>\""}]}], "}"}], "]"}], ",", "report"}], 
        "]"}]}], ";", "\n", 
      RowBox[{"NotebookClose", "[", "report", "]"}], ";", "\n", 
      RowBox[{"Clear", "[", "report", "]"}], ";"}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.714753866667685*^9, 3.714753866669038*^9}, {
   3.714753923819436*^9, 3.714753925260529*^9}, {3.714753971104944*^9, 
   3.714753981837225*^9}, {3.7147540324739523`*^9, 3.714754104193594*^9}, 
   3.714754248107897*^9, 3.71475442001031*^9, {3.714755062823988*^9, 
   3.7147550841530437`*^9}, {3.714755456051944*^9, 3.714755477133725*^9}, {
   3.714756131603298*^9, 3.7147561342145033`*^9}, {3.714838039824821*^9, 
   3.714838056631562*^9}, {3.7148382156089287`*^9, 3.714838258111175*^9}, {
   3.714838336739854*^9, 3.714838354919141*^9}, 3.714838426111397*^9, {
   3.7148384629463778`*^9, 3.7148384688175173`*^9}, {3.714838507833551*^9, 
   3.714838539052009*^9}, {3.714838588869281*^9, 3.714838608263051*^9}, {
   3.714838794061491*^9, 3.71483882654988*^9}, 3.714839036976282*^9, {
   3.714841576001893*^9, 3.714841585811264*^9}, {3.7148416380680723`*^9, 
   3.714841648405321*^9}, {3.714841686680006*^9, 3.714841689975417*^9}, 
   3.715525684435883*^9, {3.715525723784176*^9, 3.715525734335403*^9}, {
   3.716111175502902*^9, 3.7161111863683367`*^9}, 3.716111871023943*^9, {
   3.7161119474792747`*^9, 3.716111947971591*^9}, {3.716112058067129*^9, 
   3.716112065502717*^9}, {3.71611233289946*^9, 3.7161123366668053`*^9}, {
   3.717144466911413*^9, 3.717144515666177*^9}, {3.7171448359877777`*^9, 
   3.717144836304722*^9}, 3.717145186188814*^9, 3.717145307613256*^9, {
   3.717145342569409*^9, 3.717145354134554*^9}, {3.717330386100607*^9, 
   3.717330406365644*^9}, {3.717333300964321*^9, 
   3.717333301128093*^9}},ExpressionUUID->"709c7595-f4ee-47b3-bc0f-\
d071ecf66437"]
}, Open  ]]
},
WindowSize->{1278, 1139},
WindowMargins->{{Automatic, 500}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1292, 32, 94, "Input",ExpressionUUID->"b9964c67-bebc-4915-a78b-c8c861b0efd7"],
Cell[1853, 54, 99551, 2250, 12421, "Input",ExpressionUUID->"71cb9b49-4c7c-45cf-b6dc-068086459f40"],
Cell[CellGroupData[{
Cell[101429, 2308, 521, 10, 73, "Input",ExpressionUUID->"a9d50eb9-5fde-4275-b8e2-4543c510aa24"],
Cell[101953, 2320, 687, 15, 34, "Output",ExpressionUUID->"1dd66e97-0804-4c57-a786-7118341085ae"]
}, Open  ]],
Cell[102655, 2338, 321, 9, 120, "Text",ExpressionUUID->"a708520b-e1fd-4d73-8144-87c07e9d9350"],
Cell[102979, 2349, 13503, 275, 1333, "Input",ExpressionUUID->"53478b29-9a5c-49cc-8357-28b34dfad1dc"],
Cell[CellGroupData[{
Cell[116507, 2628, 156, 7, 222, "Title",ExpressionUUID->"1e4335df-b5cc-423c-9ad8-e88e091dbe56"],
Cell[116666, 2637, 83734, 1489, 1481, "Input",ExpressionUUID->"709c7595-f4ee-47b3-bc0f-d071ecf66437"]
}, Open  ]]
}
]
*)

