(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    268024,       5366]
NotebookOptionsPosition[    265809,       5325]
NotebookOutlinePosition[    266195,       5342]
CellTagsIndexPosition[    266152,       5339]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"ea4cd128-64ee-418e-adb7-a5f722736585"],

Cell[TextData[{
 "\n",
 StyleBox["Cloud Libraries", "Title"]
}], "Text",
 CellChangeTimes->{{3.743591388320754*^9, 
  3.743591403158967*^9}},ExpressionUUID->"6ed3a729-90d7-48fe-8708-\
2d06df1d6550"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "init", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"CloudGet", "[", 
  "\"\<https://www.wolframcloud.com/objects/ccn/module/v5\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"init", "[", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.743591044100066*^9, 3.743591074844936*^9}, {
   3.743592808007864*^9, 3.743592817276636*^9}, {3.747645999216069*^9, 
   3.7476460093427067`*^9}, 3.747647933421784*^9, 3.749457146980092*^9},
 CellLabel->"In[6]:=",ExpressionUUID->"b8e1aaaa-b037-457e-8e2b-e56ccd25d81f"],

Cell[BoxData[
 RowBox[{"{", "NHoldRest", "}"}]], "Output",
 CellChangeTimes->{3.749457336084852*^9, 3.749467351612701*^9, 
  3.749473685068589*^9, 3.749891266260399*^9},
 CellLabel->"Out[7]=",ExpressionUUID->"27b25e77-74f6-4798-a0a6-2e815b5337b2"],

Cell[BoxData[
 RowBox[{"{", "\<\"vesion 5\"\>", "}"}]], "Output",
 CellChangeTimes->{3.749457336084852*^9, 3.749467351612701*^9, 
  3.749473685068589*^9, 3.7498912662716913`*^9},
 CellLabel->"Out[8]=",ExpressionUUID->"a44d609e-8cde-4e26-9a3e-5ef7844032d5"]
}, Open  ]],

Cell[TextData[StyleBox["Logic and Word Functions ", "Title"]], "Text",
 CellChangeTimes->{{3.7435914178749313`*^9, 
  3.743591421271768*^9}},ExpressionUUID->"c807bd37-c960-400d-b9ef-\
2d53221263af"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"parserPREFIX2", "[", "expression00_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "expression0", ",", "expression", ",", "expression2", ",", 
         "expression3", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e", ",",
          "f", ",", "g", ",", "h", ",", "i", ",", "j", ",", "k", ",", "l", 
         ",", "m", ",", "n", ",", "o", ",", "p", ",", "q", ",", "r", ",", "s",
          ",", "t", ",", "u", ",", "v", ",", "w", ",", "x", ",", "y", ",", 
         "z", ",", "A", ",", "B", ",", "C", ",", "D", ",", "E", ",", "F", ",",
          "G", ",", "H", ",", "I", ",", "J", ",", "K", ",", "L", ",", "M", 
         ",", "N", ",", "O", ",", "P", ",", "Q", ",", "R", ",", "S", ",", "T",
          ",", "U", ",", "V", ",", "W", ",", "X", ",", "Y", ",", "Z"}], "}"}],
        ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"myPARAN3", "[", "x_", "]"}], ":=", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<(\>\"", ",", "x", ",", "\"\<)\>\""}], "}"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"expression0", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{
           RowBox[{"StringReplace", "[", 
            RowBox[{"expression00", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<  \>\"", "\[Rule]", "\"\<\[SuchThat]\>\""}], 
              "}"}]}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\"\<)\[SuchThat]\>\"", "\[Rule]", "\"\<) \>\""}], ",", 
             RowBox[{"\"\<\[SuchThat]\>\"", "\[Rule]", "\"\<\>\""}]}], 
            "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"expression", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{
           RowBox[{"StringReplace", "[", 
            RowBox[{"expression0", ",", 
             RowBox[{
             "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
               RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               
               RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"(*", 
                RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], "*)"}], 
               RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\< /(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\</( \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\</(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\</ (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\< / (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\</ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\</\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\<(/ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               RowBox[{"\"\<(/\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\< sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<sqrt( \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\< sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<(sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               RowBox[{"\"\<(sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\< ^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<^( \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\< ^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<(^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               RowBox[{"\"\<(^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\< minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               
               RowBox[{"\"\<minus( \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               
               RowBox[{"\"\<minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               RowBox[{"\"\<minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               
               RowBox[{"\"\< minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               RowBox[{"\"\<minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               RowBox[{"\"\<minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               RowBox[{"\"\<(minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               
               RowBox[{"\"\<(minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\< sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<sin( \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\< sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<(sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               RowBox[{"\"\<(sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"\"\< cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<cos( \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\< cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<(cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               RowBox[{"\"\<(cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
               RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
               RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
            "]"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\"\<Plus\>\"", "\[Rule]", "\"\<CCNPREFIX`Plus2\>\""}], 
             ",", 
             RowBox[{"\"\<Times\>\"", "\[Rule]", "\"\<CCNPREFIX`Times2\>\""}],
              ",", 
             RowBox[{
             "\"\<Subtract\>\"", "\[Rule]", "\"\<CCNPREFIX`Subtract2\>\""}], 
             ",", 
             RowBox[{"\"\<Sqrt\>\"", "\[Rule]", "\"\<CCNPREFIX`Sqrt2\>\""}], 
             ",", 
             RowBox[{"\"\<Sin\>\"", "\[Rule]", "\"\<CCNPREFIX`Sin2\>\""}], 
             ",", 
             RowBox[{"\"\<Cos\>\"", "\[Rule]", "\"\<CCNPREFIX`Cos2\>\""}], 
             ",", 
             RowBox[{
             "\"\<Divide\>\"", "\[Rule]", "\"\<CCNPREFIX`Divide2\>\""}], ",", 
             
             RowBox[{"\"\<Minus\>\"", "\[Rule]", "\"\<CCNPREFIX`Minus2\>\""}],
              ",", 
             RowBox[{
             "\"\<Power\>\"", "\[Rule]", "\"\<CCNPREFIX`Power2\>\""}]}], 
            "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"expression2", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{"expression0", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"\"\< (\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
               RowBox[{"\"\<( \>\"", "\[Rule]", "\"\<[\>\""}], ",", 
               RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ","}], "*)"}], 
             RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"(*", 
              RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], "*)"}], 
             RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< /(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</( \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</ (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\< / (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\<(/ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\<(/\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt( \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\< sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<(sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<(sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< ^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^( \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\< ^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<(^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<(^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus( \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\< minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<(minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<(minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin( \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\< sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<(sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<(sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\< cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos( \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\< cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<(cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<(cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"expression2", "=", 
         RowBox[{"StringReplace", "[", 
          RowBox[{"expression0", ",", 
           RowBox[{
           "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\"\< )\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< -(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-( \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<-(\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\< - (\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"(*", 
              RowBox[{"\"\<-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], "*)"}], 
             RowBox[{"\"\<(- \>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             RowBox[{"\"\<(-\>\"", "\[Rule]", "\"\<Subtract[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< *(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*( \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*(\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\< * (\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(* \>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             RowBox[{"\"\<(*\>\"", "\[Rule]", "\"\<Times[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< /(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</( \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</(\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</ (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\< / (\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\</\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\<(/ \>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             RowBox[{"\"\<(/\>\"", "\[Rule]", "\"\<Divide[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt( \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt(\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\< sqrt (\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<(sqrt \>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             RowBox[{"\"\<(sqrt\>\"", "\[Rule]", "\"\<Sqrt[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< ^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^( \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^(\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\< ^ (\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<(^ \>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             RowBox[{"\"\<(^\>\"", "\[Rule]", "\"\<Power[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus( \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus(\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\< minus (\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<(minus \>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             RowBox[{"\"\<(minus\>\"", "\[Rule]", "\"\<Minus[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"\"\< sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin( \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin(\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\< sin (\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<(sin \>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             RowBox[{"\"\<(sin\>\"", "\[Rule]", "\"\<Sin[\>\""}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\< cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos( \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos(\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\< cos (\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<(cos \>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             RowBox[{"\"\<(cos\>\"", "\[Rule]", "\"\<Cos[\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"\"\< +(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+( \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< + (\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+(\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+ \>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\<(+\>\"", "\[Rule]", "\"\<Plus[\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}], ",", 
             RowBox[{"\"\< \>\"", "\[Rule]", "\"\<,\>\""}]}], "}"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<expression2\>\"", "->", "expression2"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<evaluated\>\"", "->", 
           RowBox[{"Expand", "@", 
            RowBox[{"ToExpression", "@", "expression2"}]}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<tree\>\"", "->", 
            RowBox[{"TreeForm", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"ToExpression", "@", "expression"}], ")"}], ",", 
              RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"CCNPREFIX`Plus2", "\[Rule]", "\"\<+\>\""}], ",", 
             RowBox[{"CCNPREFIX`Times2", "\[Rule]", "\"\<*\>\""}], ",", 
             RowBox[{"CCNPREFIX`Divide2", "\[Rule]", "\"\</\>\""}], ",", " ", 
             
             RowBox[{"CCNPREFIX`Subtract2", "\[Rule]", "\"\<-\>\""}], ",", 
             RowBox[{"CCNPREFIX`Sqrt2", "\[Rule]", "\"\<Sqrt\>\""}], ",", 
             RowBox[{"CCNPREFIX`Sin2", "\[Rule]", "\"\<Sin\>\""}], ",", 
             RowBox[{"CCNPREFIX`Cos2", "\[Rule]", "\"\<Cos\>\""}], ",", 
             RowBox[{"CCNPREFIX`Minus2", "\[Rule]", "Minus"}], ",", 
             RowBox[{"CCNPREFIX`Power2", "->", "\"\<^\>\""}]}], "}"}]}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic1", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "d", ",", "\[Theta]", ",", "\[Theta]0",
          ",", "k", ",", "example", ",", "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "eval", ",", "eval0", ",", "eval1", ",", 
         "eval2", ",", "eval3", ",", "eval4", ",", "expr", ",", "expr0", ",", 
         "varnames", ",", "s1", ",", "s2", ",", "s3", ",", "s4", ",", "s5", 
         ",", "rules"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"expr0", "=", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<(op1 (op3 A B) (op2 C (op4 D E)))\>\"", ",", 
               "\"\<(op4 (op1 (op2 (op3 B C) A) D) E)\>\"", " ", ",", 
               "\"\<(op1 (op2 (op4 A E) B) (op3 C D))\>\""}], "}"}]}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"varnames", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"CharacterRange", "[", 
               RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", "5"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"expr", "=", 
            RowBox[{"If", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"RandomInteger", "[", "]"}], "\[Equal]", "0"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"expr0", ",", 
                RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<C\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<D\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s4", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<E\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s5", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op1\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op2\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op3\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op4\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], "]"}],
               ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"expr0", ",", 
                RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<C\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<D\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s4", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<E\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s5", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op1\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op2\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op3\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op4\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
               "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"eval", "=", 
            RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"eval", "[", "\"\<tree\>\"", "]"}]}], " ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{
            "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"eval0", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval0", "[", "\"\<tree\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval1", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval1", "[", "\"\<tree\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval2", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval2", "[", "\"\<tree\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval3", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval3", "[", "\"\<tree\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval4", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval4", "[", "\"\<tree\>\"", "]"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"3", ",", 
                 RowBox[{"Length", "@", "wrong"}]}], "}"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", 
                   RowBox[{"eval", "[", "\"\<evaluated\>\"", "]"}], ",", 
                   "\"\< matches which AST\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", 
                   RowBox[{"eval", "[", "\"\<evaluated\>\"", "]"}], ",", 
                   "\"\< matches which AST\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\"\<\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic2", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "d", ",", "\[Theta]", ",", "\[Theta]0",
          ",", "k", ",", "example", ",", "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "eval", ",", "eval0", ",", "eval1", ",", 
         "eval2", ",", "eval3", ",", "eval4", ",", "expr", ",", "expr0", ",", 
         "varnames", ",", "s1", ",", "s2", ",", "s3", ",", "s4", ",", "s5", 
         ",", "rules"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"expr0", "=", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<(op1 (op3 A B) (op2 C (op4 D E)))\>\"", ",", 
               "\"\<(op4 (op1 (op2 (op3 B C) A) D) E)\>\"", " ", ",", 
               "\"\<(op1 (op2 (op4 A E) B) (op3 C D))\>\""}], "}"}]}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"varnames", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"CharacterRange", "[", 
               RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", "5"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"expr", "=", 
            RowBox[{"If", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"RandomInteger", "[", "]"}], "\[Equal]", "0"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"expr0", ",", 
                RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<C\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<D\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s4", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<E\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s5", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op1\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op2\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op3\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op4\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], "]"}],
               ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"expr0", ",", 
                RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<C\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<D\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s4", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<E\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s5", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op1\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op2\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op3\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op4\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
               "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"eval", "=", 
            RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"eval", "[", "\"\<evaluated\>\"", "]"}]}], " ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{
            "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"eval0", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval0", "[", "\"\<evaluated\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval1", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval1", "[", "\"\<evaluated\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval2", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval2", "[", "\"\<evaluated\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval3", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval3", "[", "\"\<evaluated\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s4"}], "]"}], "\[Equal]", "True"}], ",", "s4", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "s5"}], "]"}], "\[Equal]", "True"}], ",", "s5", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "5"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<D\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "4", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<E\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "5", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\""}],
                     "}"}], "]"}]}]}], "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"eval4", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval4", "[", "\"\<evaluated\>\"", "]"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"3", ",", 
                 RowBox[{"Length", "@", "wrong"}]}], "}"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", 
                   "\"\<The following AST matches which expression\>\""}], 
                  "}"}]}], ",", 
                RowBox[{"eval", "[", "\"\<tree\>\"", "]"}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "ctr", ",", 
                   "\"\<The following AST matches which expression\>\""}], 
                  "}"}]}], ",", 
                RowBox[{"eval", "[", "\"\<tree\>\"", "]"}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\"\<\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              "correct"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"logic3", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "d", ",", "\[Theta]", ",", "\[Theta]0",
          ",", "k", ",", "example", ",", "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "eval", ",", "eval0", ",", "eval1", ",", 
         "eval2", ",", "eval3", ",", "eval4", ",", "expr", ",", "expr0", ",", 
         "varnames", ",", "s1", ",", "s2", ",", "s3", ",", "s4", ",", "s5", 
         ",", "ss1", ",", "ss2", ",", "ss3", ",", "ss4", ",", "ss5", ",", 
         "rules", ",", "tmp1", ",", "exprcorrect"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], 
          RowBox[{
           RowBox[{"expr0", "=", 
            RowBox[{"RandomChoice", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<(/ (+ (* -1 B) (sqrt (- (* B B) (* 4 (* A C))))) (* 2 \
A))\>\"", ",", 
               "\"\<(/ (- (* -1 B) (sqrt (- (* B B) (* 4 (* A C))))) (* 2 A))\
\>\"", ",", "\"\<(op1 (op3 (cos (op2 B C)) 2) (op4 (sin A) 3))\>\"", ",", 
               "\"\<(op1 (op2 (cos (op3 B 4)) A) (op4 (sin C) 5))\>\"", ",", 
               "\"\<(op1 (op2 (cos (op3 B (sqrt 7))) A) (op4 (sin (cos C)) \
5))\>\""}], "}"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"varnames", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"CharacterRange", "[", 
               RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", "5"}], 
             "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"exprcorrect", "=", 
            RowBox[{"If", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"RandomInteger", "[", "]"}], "\[Equal]", "0"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"ss2", "=", "0"}], ";", 
               RowBox[{"ss1", "=", 
                RowBox[{"ss3", "=", "1"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"While", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"ss2", "^", "2"}], "-", 
                   RowBox[{"4", "*", "ss1", "*", "ss3"}]}], "<", "0"}], ",", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"tmp1", "=", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"expr0", ",", 
                    RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"ss1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}], ",", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
                    RowBox[{"ToString", "@", "ss1"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"ss2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}], ",", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
                    RowBox[{"ToString", "@", "ss2"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"ss3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}], ",", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}]}], ";", 
                    RowBox[{"ToString", "@", "ss3"}]}], ")"}]}], ",", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", "}"}]}], "]"}]}]}], "]"}], ";", 
               RowBox[{"s1", "=", 
                RowBox[{"ToString", "@", "ss1"}]}], ";", 
               RowBox[{"s2", "=", 
                RowBox[{"ToString", "@", "ss2"}]}], ";", 
               RowBox[{"s3", "=", 
                RowBox[{"ToString", "@", "ss3"}]}], ";", "tmp1"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"expr0", ",", 
                RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<A\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s1", "=", 
                    RowBox[{"ss1", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "}"}], "]"}]}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<B\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s2", "=", 
                    RowBox[{"ss2", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "}"}], "]"}]}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", 
                  RowBox[{"\"\<C\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"s3", "=", 
                    RowBox[{"ss3", "=", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{"varnames", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "}"}], "]"}]}]}], ")"}]}],
                   ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"\"\<op1\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"\"\<op2\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"\"\<op3\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", 
                  RowBox[{"\"\<op4\>\"", "\[Rule]", 
                   RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "}"}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"eval", "=", 
            RowBox[{"parserPREFIX2", "[", "exprcorrect", "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"correct", "=", 
            RowBox[{"TraditionalForm", "@", 
             RowBox[{"eval", "[", "\"\<evaluated\>\"", "]"}]}]}], " ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{
            "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "3"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"eval0", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"TraditionalForm", "@", 
                RowBox[{"eval0", "[", "\"\<evaluated\>\"", "]"}]}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "3"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval1", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval1", "[", "\"\<evaluated\>\"", "]"}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "3"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval2", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"TraditionalForm", "@", 
                RowBox[{"eval2", "[", "\"\<evaluated\>\"", "]"}]}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "3"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval3", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"TraditionalForm", "@", 
                RowBox[{"eval3", "[", "\"\<evaluated\>\"", "]"}]}]}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"expr", "=", 
                RowBox[{"StringReplace", "[", 
                 RowBox[{"expr0", ",", 
                  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"rules", "=", 
                    RowBox[{"RandomSample", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss1"}], "]"}], "\[Equal]", "True"}], ",", "s1", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss2"}], "]"}], "\[Equal]", "True"}], ",", "s2", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"(", 
                    RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"MemberQ", "[", 
                    RowBox[{
                    RowBox[{"CharacterRange", "[", 
                    RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                    "ss3"}], "]"}], "\[Equal]", "True"}], ",", "s3", ",", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ToString", "@", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], ",", 
                    RowBox[{"ToString", "[", 
                    RowBox[{"0.1", "*", 
                    RowBox[{"RandomInteger", "[", 
                    RowBox[{"{", 
                    RowBox[{"2", ",", "10"}], "}"}], "]"}]}], "]"}]}], "}"}], 
                    "]"}]}], "]"}], ")"}]}], "}"}], ",", "3"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"Sequence", "@@", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"\"\<A\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<B\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                    RowBox[{"\"\<C\>\"", "\[Rule]", 
                    RowBox[{"rules", "[", 
                    RowBox[{"[", "3", "]"}], "]"}]}]}], "}"}]}]}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op1\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op2\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op3\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"\"\<op4\>\"", "\[Rule]", 
                    RowBox[{"RandomChoice", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<*\>\"", ",", "\"\<+\>\"", ",", "\"\<-\>\"", ",", 
                    "\"\</\>\"", ",", "\"\<^\>\""}], "}"}], "]"}]}]}], 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   "\[IndentingNewLine]", "}"}]}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"eval4", "=", 
                RowBox[{"parserPREFIX2", "[", "expr", "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"TraditionalForm", "@", 
                RowBox[{"eval4", "[", "\"\<evaluated\>\"", "]"}]}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", "3"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", 
                   RowBox[{"RandomChoice", "@", 
                    RowBox[{"{", "exprcorrect", "}"}]}], ",", 
                   "\"\< matches\\nwhich of the following\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", 
                   RowBox[{"RandomChoice", "@", 
                    RowBox[{"{", "exprcorrect", "}"}]}], ",", 
                   "\"\< matches\\nwhich of the following\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\"\<\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              "correct", ",", "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              RowBox[{"eval", "[", "\"\<tree\>\"", "]"}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.743591378145288*^9, 3.7435913783228416`*^9}, 
   3.7435914245272923`*^9, {3.747645912435511*^9, 3.747645912931457*^9}, {
   3.747646046339014*^9, 3.747646104958357*^9}, {3.747646178268447*^9, 
   3.7476462659830914`*^9}, {3.747646303851428*^9, 3.747646587917054*^9}, {
   3.7476468978391333`*^9, 3.747647021994542*^9}, {3.747647067615756*^9, 
   3.747647120247527*^9}, {3.747647157595894*^9, 3.7476478158261003`*^9}, {
   3.747648021545681*^9, 3.7476480304993067`*^9}, 3.747648158538848*^9, {
   3.747648217601945*^9, 3.747648277189116*^9}, {3.74764836065056*^9, 
   3.7476483863363857`*^9}, 3.747648584754449*^9, {3.747648653315894*^9, 
   3.747648675106042*^9}, 3.747648712019691*^9, {3.747652072587161*^9, 
   3.7476521769394712`*^9}, {3.747652214338584*^9, 3.747652299051979*^9}, {
   3.747652333005484*^9, 3.7476523859824667`*^9}, {3.747652425461397*^9, 
   3.747652498575881*^9}, {3.7476526613459806`*^9, 3.747652721734255*^9}, {
   3.7476527607964582`*^9, 3.7476528915116158`*^9}, {3.747652934960745*^9, 
   3.747652942452117*^9}, {3.7476531362383423`*^9, 3.747653140118181*^9}, 
   3.747653175139617*^9, {3.74765321397654*^9, 3.7476532305923443`*^9}, {
   3.7476532609698353`*^9, 3.7476532794190617`*^9}, {3.7476533395760403`*^9, 
   3.747653349136445*^9}, {3.7476533958824873`*^9, 3.7476534498820887`*^9}, {
   3.747653509228681*^9, 3.7476535109926033`*^9}, {3.7476536234851427`*^9, 
   3.7476536745256968`*^9}, {3.747653792136223*^9, 3.7476538165727882`*^9}, {
   3.749310498199704*^9, 3.749310752574253*^9}, {3.7493108956394367`*^9, 
   3.749310896112463*^9}, {3.749310930797447*^9, 3.749310930970457*^9}, {
   3.7493127297564497`*^9, 3.749312836278832*^9}, {3.74931287267999*^9, 
   3.7493129446128283`*^9}, 3.749312984136682*^9, 3.749313023986938*^9, {
   3.7493130638110533`*^9, 3.749313117922997*^9}, {3.749313196778408*^9, 
   3.7493132260951347`*^9}, {3.749313261396337*^9, 3.749313274873561*^9}, {
   3.749313315894134*^9, 3.749313324330102*^9}, 3.7493134487578793`*^9, {
   3.749313483062097*^9, 3.7493135468583813`*^9}, {3.749313588317573*^9, 
   3.7493136097019663`*^9}, {3.749459796146912*^9, 3.749459839728794*^9}, {
   3.749459869739799*^9, 3.749459980040701*^9}, {3.749460036153413*^9, 
   3.7494600454723454`*^9}, {3.7494601361625147`*^9, 3.749460289854395*^9}, {
   3.749460362210907*^9, 3.749460445361331*^9}, {3.749460626277074*^9, 
   3.749460661886858*^9}, {3.749460695366205*^9, 3.749460725505011*^9}, {
   3.749460813300625*^9, 3.74946085107701*^9}, {3.749460895226184*^9, 
   3.7494609003419933`*^9}, {3.749460948349914*^9, 3.7494609835143642`*^9}, 
   3.749461021621361*^9, 3.749461073085087*^9, 3.749461143765396*^9, 
   3.7494613447386847`*^9, {3.749461386868702*^9, 3.749461415996285*^9}, 
   3.74946148893038*^9, {3.7494616380859528`*^9, 3.749461649257185*^9}, {
   3.749461734433096*^9, 3.749461737111203*^9}, {3.749461811170672*^9, 
   3.749461813678812*^9}, {3.749461846046998*^9, 3.7494618634717484`*^9}, {
   3.7494619637133827`*^9, 3.749462155650631*^9}, 3.749462236372751*^9, {
   3.74946236714539*^9, 3.7494624788826103`*^9}, {3.749462531138633*^9, 
   3.7494625549998417`*^9}, {3.749462832358444*^9, 3.749462891617042*^9}, {
   3.749462927186809*^9, 3.74946294517558*^9}, {3.749463014976994*^9, 
   3.749463027250081*^9}, {3.7494630630716867`*^9, 3.749463138252387*^9}, {
   3.749463175103156*^9, 3.749463185340044*^9}, 3.749463225487875*^9, {
   3.7494632788424587`*^9, 3.7494633158129807`*^9}, {3.749463360595656*^9, 
   3.749463381216318*^9}, {3.749463519944255*^9, 3.749463564439849*^9}, {
   3.749463701387545*^9, 3.749463723391382*^9}, {3.749467371057939*^9, 
   3.7494673721573544`*^9}, {3.74946741185347*^9, 3.749467527348374*^9}, {
   3.7494675602410393`*^9, 3.749467565324172*^9}, {3.749467599364121*^9, 
   3.749467647481121*^9}, {3.7494677194755077`*^9, 3.7494678124136047`*^9}, {
   3.749468240011241*^9, 3.749468240087572*^9}, {3.7494687807976923`*^9, 
   3.749468887425562*^9}, {3.7494689242946987`*^9, 3.749468957740863*^9}, {
   3.749469165900448*^9, 3.749469171222925*^9}, {3.749469203394649*^9, 
   3.74946936904421*^9}, {3.749469540501629*^9, 3.74946963174551*^9}, {
   3.7494697676459303`*^9, 3.749469839417884*^9}, {3.749469924901971*^9, 
   3.749469927305863*^9}, {3.749470205065028*^9, 3.749470440566597*^9}, {
   3.7494705137362967`*^9, 3.749470558626081*^9}, {3.749470773053194*^9, 
   3.749470797868965*^9}, {3.7494709009328337`*^9, 3.7494709315593023`*^9}, {
   3.749471164990287*^9, 3.749471172502543*^9}, {3.749471209089053*^9, 
   3.749471224770075*^9}, 3.749473795278554*^9, {3.749473833073503*^9, 
   3.749473841440771*^9}, {3.7494739103114567`*^9, 3.749473929146937*^9}, {
   3.749473970372484*^9, 3.749473988099221*^9}, {3.749474033141807*^9, 
   3.749474065421585*^9}, 3.7494758361146803`*^9, 3.749476797603215*^9, {
   3.7494768517494783`*^9, 3.749476918647838*^9}, {3.749476951887903*^9, 
   3.7494770168661013`*^9}, {3.749479480404317*^9, 3.7494794857856293`*^9}, {
   3.7494795489509163`*^9, 3.749479549173388*^9}, {3.7494796456307697`*^9, 
   3.7494796619465322`*^9}, {3.749479747047242*^9, 3.7494797499721746`*^9}, {
   3.749479837340473*^9, 3.74947994546583*^9}, {3.749480033257021*^9, 
   3.7494800411018677`*^9}, {3.7494865443557158`*^9, 3.749486765786998*^9}, {
   3.7494868782620687`*^9, 3.749486881223905*^9}, 3.749486940815421*^9, {
   3.749487121566595*^9, 3.749487132009574*^9}, {3.749487385373889*^9, 
   3.749487476291781*^9}, {3.749487745626899*^9, 3.7494878332774973`*^9}, {
   3.749487994639351*^9, 3.749488002862369*^9}, {3.7494884881486397`*^9, 
   3.7494885090515547`*^9}, {3.7494885405774193`*^9, 3.749488570774682*^9}, {
   3.7494898983060017`*^9, 3.7494899263330917`*^9}, {3.749490039246862*^9, 
   3.749490049630962*^9}, {3.7494901230611563`*^9, 3.749490159555094*^9}, {
   3.749490216171072*^9, 3.749490245102201*^9}, {3.749490282854282*^9, 
   3.749490304626705*^9}, {3.7494904742925167`*^9, 3.7494904790337563`*^9}, {
   3.74949052820258*^9, 3.749490529754702*^9}, {3.749490714000915*^9, 
   3.7494907254875307`*^9}, 3.749490766152519*^9, {3.7494909925782547`*^9, 
   3.7494910031526747`*^9}, {3.7494910759701777`*^9, 3.749491076462982*^9}, 
   3.7494912699014187`*^9, {3.749491658398419*^9, 3.74949167432717*^9}, 
   3.749491775788618*^9, {3.749492466321588*^9, 3.749492481338091*^9}, {
   3.74949251160688*^9, 3.74949253442249*^9}, {3.749492617196961*^9, 
   3.749492646754611*^9}, {3.749493127860939*^9, 3.7494931568550167`*^9}, {
   3.749493219392786*^9, 3.7494932598418093`*^9}, {3.749493332586521*^9, 
   3.749493337636118*^9}, {3.749493385229518*^9, 3.749493395319746*^9}, {
   3.749493455284466*^9, 3.7494934556685457`*^9}, {3.749493525671019*^9, 
   3.749493634214143*^9}, {3.749493770066187*^9, 3.749493885456376*^9}, {
   3.749493921897222*^9, 3.7494939268251743`*^9}, {3.7494939868128223`*^9, 
   3.749493991219418*^9}, {3.7494940898912363`*^9, 3.7494940904013653`*^9}, {
   3.74949421659385*^9, 3.749494224157543*^9}, {3.749494257269277*^9, 
   3.749494290966372*^9}, {3.7494943544974117`*^9, 3.749494415922893*^9}, {
   3.749494477540934*^9, 3.749494487187039*^9}, {3.74949451870527*^9, 
   3.7494945214836063`*^9}, {3.749494585340762*^9, 3.74949458553581*^9}, {
   3.749494619348791*^9, 3.749494630278192*^9}, {3.749494669082324*^9, 
   3.7494947078094*^9}, {3.7494947984980297`*^9, 3.749494802934119*^9}, {
   3.749494917727889*^9, 3.749494930843391*^9}, {3.7494952383743267`*^9, 
   3.749495296092967*^9}, {3.749495365653524*^9, 3.749495401594598*^9}, {
   3.749496190558791*^9, 3.749496243042658*^9}, {3.749497502438302*^9, 
   3.749497657616905*^9}, {3.749497745063478*^9, 3.749497778746418*^9}, {
   3.749498443757893*^9, 3.749498562467388*^9}, 3.749498773272656*^9, 
   3.7494996875874577`*^9, {3.7494997241213923`*^9, 3.749499733384283*^9}, {
   3.74949977030538*^9, 3.7494998748922453`*^9}, 3.749499929092354*^9, {
   3.749500256941969*^9, 3.749500310772647*^9}, 3.7498913428071623`*^9, {
   3.749891420775272*^9, 3.749891438164369*^9}, {3.749891495156201*^9, 
   3.749891513347268*^9}, {3.749891594923911*^9, 3.7498916858846493`*^9}, {
   3.749891866598564*^9, 3.749891882245813*^9}},
 CellLabel->"In[64]:=",ExpressionUUID->"23492e2a-b216-4751-9773-f8572f7b738b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"LaunchKernels", "[", "64", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 3.730843910893158*^9, 3.730844121510347*^9, 
   3.730844251350174*^9, {3.730844390877315*^9, 3.730844392778469*^9}, {
   3.743597517958117*^9, 3.743597520679738*^9}, 
   3.74359770736696*^9},ExpressionUUID->"bf8c716b-e954-4fb8-99c8-\
dc528fa5dced"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9, 3.730844128232019*^9, 3.730844253679215*^9, 
   3.7308443463882*^9, 
   3.743597667837785*^9},ExpressionUUID->"7cd15d09-32f7-4e5e-a7a0-\
20c149582d6c"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["PRAC1 JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 3.71567570442386*^9, {3.749474170422374*^9, 
   3.749474175211754*^9}},ExpressionUUID->"ca2c833e-9bf8-45e1-8429-\
cee1bb943d91"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", 
      "\"\<prefixparseAST1_\>\"", ",", "\"\<pdf\>\""}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic1", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"6", "\[Rule]", "\"\<6. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "8", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.730843810079851*^9, 3.730843837162004*^9}, {3.730844126877118*^9, 
   3.73084412854283*^9}, {3.730844386133678*^9, 3.730844388043399*^9}, {
   3.743597528738099*^9, 3.743597584436431*^9}, {3.743597697322775*^9, 
   3.743597699998611*^9}, {3.7476089314393787`*^9, 3.747608964867762*^9}, {
   3.7476563245503187`*^9, 3.747656369313794*^9}, {3.749463433670292*^9, 
   3.74946344994176*^9}, {3.749467853874359*^9, 
   3.749467866552602*^9}},ExpressionUUID->"b9bf5bc8-478b-4cdc-9ea3-\
71b9fc2c8c79"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"LaunchKernels", "[", "64", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 3.730843910893158*^9, 3.730844121510347*^9, 
   3.730844251350174*^9, {3.730844390877315*^9, 3.730844392778469*^9}, {
   3.743597517958117*^9, 3.743597520679738*^9}, 
   3.74359770736696*^9},ExpressionUUID->"884548bc-36b8-43ce-aa6a-\
decc0836a7d8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9, 3.730844128232019*^9, 3.730844253679215*^9, 
   3.7308443463882*^9, 
   3.743597667837785*^9},ExpressionUUID->"f0e96aff-02a6-4ddd-babf-\
e35b4e27a3ea"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["PRAC2 JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 3.71567570442386*^9, {3.7494741530941343`*^9, 
   3.749474183075582*^9}},ExpressionUUID->"157dc61f-a1eb-44ad-b8da-\
a2a54c42d559"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", 
      "\"\<prefixparseAST1_\>\"", ",", "\"\<pdf\>\""}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic2", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"6", "\[Rule]", "\"\<6. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "8", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.730843810079851*^9, 3.730843837162004*^9}, {3.730844126877118*^9, 
   3.73084412854283*^9}, {3.730844386133678*^9, 3.730844388043399*^9}, {
   3.743597528738099*^9, 3.743597584436431*^9}, {3.743597697322775*^9, 
   3.743597699998611*^9}, {3.7476089314393787`*^9, 3.747608964867762*^9}, {
   3.7476563245503187`*^9, 3.747656369313794*^9}, {3.749463433670292*^9, 
   3.74946344994176*^9}, {3.749467853874359*^9, 3.749467866552602*^9}, 
   3.749474126577874*^9},ExpressionUUID->"9ed63bdb-34f7-4c02-af59-\
142781ebd957"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"LaunchKernels", "[", "64", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 3.730843910893158*^9, 3.730844121510347*^9, 
   3.730844251350174*^9, {3.730844390877315*^9, 3.730844392778469*^9}, {
   3.743597517958117*^9, 3.743597520679738*^9}, 
   3.74359770736696*^9},ExpressionUUID->"70ee5fec-3200-4a59-9cc8-\
5e5c5dc3761c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9, 3.730844128232019*^9, 3.730844253679215*^9, 
   3.7308443463882*^9, 
   3.743597667837785*^9},ExpressionUUID->"73024d31-3c79-41cb-b4c3-\
bac83fb6dcf9"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["PRAC3 JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 3.71567570442386*^9, {3.7494741530941343`*^9, 
   3.749474183075582*^9}, 
   3.749500387649378*^9},ExpressionUUID->"d315e0e4-c515-47ed-9bf0-\
98b6321aa477"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<prefixparseAST1_\>\"",
      ",", "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", 
      "\"\<prefixparseAST1_\>\"", ",", "\"\<pdf\>\""}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic3", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"6", "\[Rule]", "\"\<6. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "8", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.730843810079851*^9, 3.730843837162004*^9}, {3.730844126877118*^9, 
   3.73084412854283*^9}, {3.730844386133678*^9, 3.730844388043399*^9}, {
   3.743597528738099*^9, 3.743597584436431*^9}, {3.743597697322775*^9, 
   3.743597699998611*^9}, {3.7476089314393787`*^9, 3.747608964867762*^9}, {
   3.7476563245503187`*^9, 3.747656369313794*^9}, {3.749463433670292*^9, 
   3.74946344994176*^9}, {3.749467853874359*^9, 3.749467866552602*^9}, 
   3.749474126577874*^9, 
   3.7495003910816507`*^9},ExpressionUUID->"1d010aa8-65d3-4f0e-85ce-\
305a1192e4a2"]
},
WindowSize->{1337, 1078},
WindowMargins->{{Automatic, 332}, {Automatic, 12}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1313, 32, 94, "Input",ExpressionUUID->"ea4cd128-64ee-418e-adb7-a5f722736585"],
Cell[1874, 54, 198, 6, 97, "Text",ExpressionUUID->"6ed3a729-90d7-48fe-8708-2d06df1d6550"],
Cell[CellGroupData[{
Cell[2097, 64, 572, 10, 94, "Input",ExpressionUUID->"b8e1aaaa-b037-457e-8e2b-e56ccd25d81f"],
Cell[2672, 76, 247, 4, 34, "Output",ExpressionUUID->"27b25e77-74f6-4798-a0a6-2e815b5337b2"],
Cell[2922, 82, 256, 4, 34, "Output",ExpressionUUID->"a44d609e-8cde-4e26-9a3e-5ef7844032d5"]
}, Open  ]],
Cell[3193, 89, 198, 3, 73, "Text",ExpressionUUID->"c807bd37-c960-400d-b9ef-2d53221263af"],
Cell[3394, 94, 219994, 4333, 20317, "Input",ExpressionUUID->"23492e2a-b216-4751-9773-f8572f7b738b"],
Cell[CellGroupData[{
Cell[223413, 4431, 841, 17, 178, "Input",ExpressionUUID->"bf8c716b-e954-4fb8-99c8-dc528fa5dced"],
Cell[224257, 4450, 777, 17, 34, "Output",ExpressionUUID->"7cd15d09-32f7-4e5e-a7a0-20c149582d6c"]
}, Open  ]],
Cell[225049, 4470, 373, 9, 120, "Text",ExpressionUUID->"ca2c833e-9bf8-45e1-8429-cee1bb943d91"],
Cell[225425, 4481, 12068, 244, 1207, "Input",ExpressionUUID->"b9bf5bc8-478b-4cdc-9ea3-71b9fc2c8c79"],
Cell[CellGroupData[{
Cell[237518, 4729, 841, 17, 178, "Input",ExpressionUUID->"884548bc-36b8-43ce-aa6a-decc0836a7d8"],
Cell[238362, 4748, 777, 17, 34, "Output",ExpressionUUID->"f0e96aff-02a6-4ddd-babf-e35b4e27a3ea"]
}, Open  ]],
Cell[239154, 4768, 375, 9, 120, "Text",ExpressionUUID->"157dc61f-a1eb-44ad-b8da-a2a54c42d559"],
Cell[239532, 4779, 12090, 244, 1207, "Input",ExpressionUUID->"9ed63bdb-34f7-4c02-af59-142781ebd957"],
Cell[CellGroupData[{
Cell[251647, 5027, 841, 17, 178, "Input",ExpressionUUID->"70ee5fec-3200-4a59-9cc8-5e5c5dc3761c"],
Cell[252491, 5046, 777, 17, 34, "Output",ExpressionUUID->"73024d31-3c79-41cb-b4c3-bac83fb6dcf9"]
}, Open  ]],
Cell[253283, 5066, 401, 10, 120, "Text",ExpressionUUID->"d315e0e4-c515-47ed-9bf0-98b6321aa477"],
Cell[253687, 5078, 12118, 245, 1207, "Input",ExpressionUUID->"1d010aa8-65d3-4f0e-85ce-305a1192e4a2"]
}
]
*)

