(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    203199,       4843]
NotebookOptionsPosition[    197675,       4746]
NotebookOutlinePosition[    198044,       4762]
CellTagsIndexPosition[    198001,       4759]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},ExpressionUUID->"6808b9cc-4aea-4188-8f7d-\
4057223655ef"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fibold", "[", "n_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"n", "\[Equal]", "1"}], "||", 
          RowBox[{"n", "==", "2"}]}], ",", 
         RowBox[{"Return", "@", "1"}]}], "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"AppendTo", "[", 
        RowBox[{"list", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<)\>\""}], 
              "}"}]}], "\[Rule]", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<-\>\"", 
               ",", "1", ",", "\"\<)\>\""}], "}"}]}]}], ",", 
           RowBox[{
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<)\>\""}], 
              "}"}]}], "\[Rule]", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
              "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<-\>\"", 
               ",", "2", ",", "\"\<)\>\""}], "}"}]}]}]}], "}"}]}], "]"}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{"list", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<)\>\""}],
                 "}"}]}], "\[Rule]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<fib\>\"", ",", "\"\<(\>\"", ",", 
                 RowBox[{"n", "-", "1"}], ",", "\"\<)\>\""}], "}"}]}]}], ",", 
             
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "n", ",", "\"\<)\>\""}],
                 "}"}]}], "\[Rule]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<fib\>\"", ",", "\"\<(\>\"", ",", 
                 RowBox[{"n", "-", "2"}], ",", "\"\<)\>\""}], "}"}]}]}]}], 
            "}"}]}], "]"}], ";"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{
         RowBox[{"fib", "[", 
          RowBox[{"n", "-", "1"}], "]"}], "+", 
         RowBox[{"fib", "[", 
          RowBox[{"n", "-", "2"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.722372855127211*^9, 3.722372914037334*^9}, {
   3.722372955854944*^9, 3.722372999989757*^9}, {3.722373035382546*^9, 
   3.7223731314959373`*^9}, 3.722373178710219*^9, {3.722373358998075*^9, 
   3.72237336035583*^9}, {3.7223734876515017`*^9, 3.722373491138589*^9}, {
   3.722373563702931*^9, 3.722373569237097*^9}, {3.722373677926105*^9, 
   3.722373690875058*^9}, {3.7223737556085873`*^9, 3.722373769051738*^9}, {
   3.722374012644668*^9, 3.7223740161740627`*^9}, {3.722374109157001*^9, 
   3.722374124653285*^9}, {3.722374194807917*^9, 3.722374205188426*^9}, {
   3.722374391581752*^9, 3.7223744561007833`*^9}, {3.7223745994937477`*^9, 
   3.7223746012061577`*^9}, {3.722374696372913*^9, 3.722374697575335*^9}, {
   3.722375027656036*^9, 3.722375142350871*^9}, {3.722375221721611*^9, 
   3.722375291944675*^9}, {3.7223753409171257`*^9, 3.722375416777483*^9}, {
   3.722375481927257*^9, 3.7223755095688343`*^9}, {3.722375947606677*^9, 
   3.722375977779065*^9}, {3.7223765543740673`*^9, 
   3.722376562125123*^9}},ExpressionUUID->"7b9906c3-b124-4813-8629-\
042e0ad37233"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"TreeForm", "[", 
  RowBox[{
   RowBox[{"fib", "[", "10", "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Subscript", "\[Rule]", "\"\<\>\""}], ",", 
     RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}]}], "}"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.7223730047189827`*^9, 3.722373015592671*^9}, {
  3.722373089292794*^9, 3.72237309634662*^9}, {3.722373212639977*^9, 
  3.722373217432302*^9}, {3.722373387614627*^9, 3.722373434335957*^9}, {
  3.72237360091073*^9, 3.722373615542734*^9}, {3.7223746523159037`*^9, 
  3.722374658727487*^9}, {3.722374865293316*^9, 3.722374865539997*^9}, {
  3.7223756337483263`*^9, 
  3.7223756338938217`*^9}},ExpressionUUID->"340dca61-350e-48cb-ba69-\
f740dc09519c"],

Cell[BoxData[
 GraphicsBox[
  TagBox[GraphicsComplexBox[{{0., 0.}}, {
     {RGBColor[0.55, 0.45, 0.45]}, 
     TagBox[
      TooltipBox[InsetBox[
        FrameBox[
         StyleBox[
          TagBox["55",
           HoldForm], "StandardForm", "Output",
          StripOnInput->False,
          LineColor->GrayLevel[0],
          FrontFaceColor->GrayLevel[0],
          BackFaceColor->GrayLevel[0],
          GraphicsColor->GrayLevel[0],
          FontSize->Scaled[0.05],
          FontColor->GrayLevel[0]],
         Background->RGBColor[1., 1., 0.871],
         FrameStyle->GrayLevel[0.5],
         StripOnInput->False], 1],
       TagBox["55", HoldForm]],
      Annotation[#, 
       HoldForm[55], "Tooltip"]& ]}],
   Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
  AspectRatio->1,
  FormatType:>StandardForm,
  FrameTicks->Automatic,
  PlotRange->All,
  PlotRangePadding->Scaled[0.1]]], "Output",
 CellChangeTimes->{
  3.7223746656168737`*^9, 3.722374701976885*^9, 3.722374866195737*^9, {
   3.7223751222097187`*^9, 3.722375145429302*^9}, 3.722375299693268*^9, 
   3.722375419064363*^9, 3.722375512893002*^9, 3.72237563429988*^9, 
   3.722375997412323*^9},ExpressionUUID->"deef277a-0c87-4485-8cdb-\
dfa96155483e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Flatten", "@", "list"}], "\[IndentingNewLine]", 
 RowBox[{"Graph", "[", 
  RowBox[{
   RowBox[{"DeleteDuplicates", "@", 
    RowBox[{"Flatten", "@", "list"}]}], ",", 
   RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.722373801131991*^9, 3.722373801688157*^9}, {
   3.7223751622636433`*^9, 3.722375176326078*^9}, {3.722375377570861*^9, 
   3.722375383682001*^9}, 3.7223754446024714`*^9, {3.722375594699098*^9, 
   3.7223755984790697`*^9}},ExpressionUUID->"bdf94545-e9fe-45ac-8ba2-\
f8092365c674"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","10","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","10","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","10","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","10","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","9","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","9","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","9","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","9","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","8","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","8","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","8","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","8","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
     "RowDefault"]}], ",", 
   RowBox[{
    TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
     "RowDefault"], "\[Rule]", 
    TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
     "RowDefault"]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.722373801958239*^9, 3.722374023560011*^9, 3.722374173540284*^9, 
   3.722374214185437*^9, 3.7223744402224283`*^9, 3.7223745223149633`*^9, 
   3.722374930125916*^9, {3.7223751337389717`*^9, 3.7223751766217422`*^9}, 
   3.722375301642096*^9, 3.722375384966967*^9, {3.72237542094556*^9, 
   3.7223754459701357`*^9}, 3.72237551457519*^9, 3.7223756008858223`*^9, 
   3.722375637533751*^9, {3.722375983304954*^9, 
   3.72237600061873*^9}},ExpressionUUID->"03bc05e1-5ad5-4c8e-a6d2-\
bdf72450c8a3"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{
       Row[{"fib", "(", 10, ")"}], 
       Row[{"fib", "(", 10, "-", 1, ")"}], 
       Row[{"fib", "(", 10, "-", 2, ")"}], 
       Row[{"fib", "(", 9, ")"}], 
       Row[{"fib", "(", 9, "-", 1, ")"}], 
       Row[{"fib", "(", 9, "-", 2, ")"}], 
       Row[{"fib", "(", 8, ")"}], 
       Row[{"fib", "(", 8, "-", 1, ")"}], 
       Row[{"fib", "(", 8, "-", 2, ")"}], 
       Row[{"fib", "(", 7, ")"}], 
       Row[{"fib", "(", 7, "-", 1, ")"}], 
       Row[{"fib", "(", 7, "-", 2, ")"}], 
       Row[{"fib", "(", 6, ")"}], 
       Row[{"fib", "(", 6, "-", 1, ")"}], 
       Row[{"fib", "(", 6, "-", 2, ")"}], 
       Row[{"fib", "(", 5, ")"}], 
       Row[{"fib", "(", 5, "-", 1, ")"}], 
       Row[{"fib", "(", 5, "-", 2, ")"}], 
       Row[{"fib", "(", 4, ")"}], 
       Row[{"fib", "(", 4, "-", 1, ")"}], 
       Row[{"fib", "(", 4, "-", 2, ")"}], 
       Row[{"fib", "(", 3, ")"}], 
       Row[{"fib", "(", 3, "-", 1, ")"}], 
       Row[{"fib", "(", 3, "-", 2, ")"}]}, {{{1, 2}, {1, 3}, {4, 5}, {4, 6}, {
       7, 8}, {7, 9}, {10, 11}, {10, 12}, {13, 14}, {13, 15}, {16, 17}, {16, 
       18}, {19, 20}, {19, 21}, {22, 23}, {22, 24}}, Null}, {
      VertexLabels -> {"Name"}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[0.02312845938503176], 
        ArrowBox[{{2.500039999999999, -3.25005}, {
         2.500039999999999, -4.25005}}, 0.037005905071400974`], 
        ArrowBox[{{2.500039999999999, -3.25005}, {
         3.500039999999999, -4.25005}}, 0.037005905071400974`], 
        ArrowBox[{{1.7500299999999993`, -0.25001000000000007`}, {
         1.7500299999999993`, -1.25001}}, 0.037005905071400974`], 
        ArrowBox[{{1.7500299999999993`, -0.25001000000000007`}, {
         2.7500299999999993`, -1.25001}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -1.7500300000000002`}, {
         0.2500099999999996, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -1.7500300000000002`}, {
         1.2500099999999996`, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{1.7500299999999998`, -1.7500300000000002`}, {
         1.7500299999999998`, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{1.7500299999999998`, -1.7500300000000002`}, {
         2.7500299999999998`, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{3.250049999999999, -0.25001000000000007`}, {
         3.250049999999999, -1.25001}}, 0.037005905071400974`], 
        ArrowBox[{{3.250049999999999, -0.25001000000000007`}, {
         4.250049999999999, -1.25001}}, 0.037005905071400974`], 
        ArrowBox[{{3.250049999999999, -1.7500300000000002`}, {
         3.250049999999999, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{3.250049999999999, -1.7500300000000002`}, {
         4.250049999999999, -2.75003}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -3.25005}, {
         0.2500099999999996, -4.25005}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -3.25005}, {
         1.2500099999999996`, -4.25005}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -0.25001000000000007`}, {
         0.2500099999999996, -1.25001}}, 0.037005905071400974`], 
        ArrowBox[{{0.2500099999999996, -0.25001000000000007`}, {
         1.2500099999999996`, -1.25001}}, 0.037005905071400974`]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {DiskBox[{2.500039999999999, -3.25005}, 0.037005905071400974],
          InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","10","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {2.5370459050714, -3.2130440949285988}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{2.500039999999999, -4.25005}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","10","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {2.5370459050714, -4.213044094928599}], ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{3.500039999999999, -4.25005}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","10","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {3.5370459050714, -4.213044094928599}], ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.7500299999999993, -0.25001000000000007}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","9","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.7870359050714002, -0.2130040949285991}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.7500299999999993, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","9","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.7870359050714002, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{2.7500299999999993, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","9","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {2.7870359050714004, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -1.7500300000000002}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","8","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -1.7130240949285993}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -2.713024094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.2500099999999996, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","8","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.2870159050714005, -2.713024094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.7500299999999998, -1.7500300000000002}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","7","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.7870359050714006, -1.7130240949285993}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.7500299999999998, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.7870359050714006, -2.713024094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{2.7500299999999998, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","7","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {2.787035905071401, -2.713024094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{3.250049999999999, -0.25001000000000007}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","6","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {3.2870559050714, -0.2130040949285991}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{3.250049999999999, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {3.2870559050714, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{4.250049999999999, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","6","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {4.2870559050714, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{3.250049999999999, -1.7500300000000002}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","5","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {3.2870559050714, -1.7130240949285993}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{3.250049999999999, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {3.2870559050714, -2.713024094928599}], ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{4.250049999999999, -2.75003}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","5","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {4.2870559050714, -2.713024094928599}], ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -3.25005}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","4","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -3.2130440949285988}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -4.25005}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -4.213044094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.2500099999999996, -4.25005}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","4","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.2870159050714005, -4.213044094928599}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -0.25001000000000007}, 
          0.037005905071400974], InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","3","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -0.2130040949285991}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.2500099999999996, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","1","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {0.2870159050714006, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.2500099999999996, -1.25001}, 0.037005905071400974], 
         InsetBox[
          TemplateBox[{"\"fib\"","\"(\"","3","\"-\"","2","\")\""},
           "RowDefault"], 
          Offset[{2, 2}, {1.2870159050714005, -1.2130040949285992}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.722373801958239*^9, 3.722374023560011*^9, 3.722374173540284*^9, 
   3.722374214185437*^9, 3.7223744402224283`*^9, 3.7223745223149633`*^9, 
   3.722374930125916*^9, {3.7223751337389717`*^9, 3.7223751766217422`*^9}, 
   3.722375301642096*^9, 3.722375384966967*^9, {3.72237542094556*^9, 
   3.7223754459701357`*^9}, 3.72237551457519*^9, 3.7223756008858223`*^9, 
   3.722375637533751*^9, {3.722375983304954*^9, 
   3.722376000814886*^9}},ExpressionUUID->"a85dda94-778d-4f18-87ac-\
9c3356c66cd0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"n", "=", "9"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vnames", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Highlighted", "@", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{
           "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "1", ",", "\"\<)\>\"", ",", 
            "\"\<=\>\"", ",", "1"}], "}"}]}]}], ",", 
        RowBox[{"Highlighted", "@", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{
           "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "2", ",", "\"\<)\>\"", ",", 
            "\"\<=\>\"", ",", "1"}], "}"}]}]}]}], "}"}], "~", "Join", "~", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Row", "@", 
         RowBox[{"{", 
          RowBox[{
          "\"\<fib\>\"", ",", "\"\<(\>\"", ",", "nn", ",", "\"\<)\>\"", ",", 
           "\"\<=\>\"", ",", "\"\<fib\>\"", ",", "\"\<(\>\"", ",", 
           RowBox[{"nn", "-", "1"}], ",", "\"\<)\>\"", ",", "\"\<+\>\"", ",", 
           "\"\<fib\>\"", ",", "\"\<(\>\"", ",", 
           RowBox[{"nn", "-", "2"}], ",", "\"\<)\>\"", ",", "\"\<=\>\"", ",", 
           
           RowBox[{"Fibonacci", "[", "nn", "]"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"nn", ",", "3", ",", "n"}], "}"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"RelationGraph", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "-", "#2"}], "\[Equal]", "1"}], "||", 
         RowBox[{
          RowBox[{"#1", "-", "#2"}], "\[Equal]", "2"}]}], ")"}], "&&", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"#1", ">", "2"}], "||", 
         RowBox[{"#2", ">", "2"}]}], ")"}]}], "&"}], ",", " ", 
     RowBox[{"Range", "@", 
      RowBox[{"(", "n", ")"}]}], ",", 
     RowBox[{"VertexLabels", "\[Rule]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"i", "\[Rule]", 
         RowBox[{"vnames", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.722376398985999*^9, 3.722376534696726*^9}, {
  3.722376628752513*^9, 3.722376635678646*^9}, {3.722376684111555*^9, 
  3.722376702864543*^9}, {3.722376746564611*^9, 3.722376826403296*^9}, {
  3.722376904211561*^9, 3.72237692521418*^9}, {3.7223769888904467`*^9, 
  3.722377004361784*^9}, {3.7223770930014*^9, 3.722377153391316*^9}, {
  3.722377205941009*^9, 3.722377206108838*^9}, {3.722377262732045*^9, 
  3.722377266874592*^9}, {3.722377391288185*^9, 3.722377433632956*^9}, {
  3.722377476250049*^9, 3.7223774820989237`*^9}, {3.722377521733837*^9, 
  3.72237758318152*^9}, {3.722377690643917*^9, 3.7223777011850348`*^9}, {
  3.722378046701915*^9, 3.722378046847052*^9}, {3.722378099263842*^9, 
  3.72237812008965*^9}, {3.722379033661642*^9, 
  3.722379080470105*^9}},ExpressionUUID->"108da33c-d9a7-4d72-8ac8-\
49b0b9680d03"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9}, {
       SparseArray[
       Automatic, {9, 9}, 0, {
        1, {{0, 0, 0, 2, 4, 6, 8, 10, 12, 14}, {{1}, {2}, {2}, {3}, {3}, {
          4}, {4}, {5}, {5}, {6}, {6}, {7}, {7}, {8}}}, Pattern}], Null}, {
      VertexLabels -> {
        6 -> Row[{
           "fib", "(", 6, ")", "=", "fib", "(", 5, ")", "+", "fib", "(", 4, 
            ")", "=", 8}], 3 -> 
         Row[{"fib", "(", 3, ")", "=", "fib", "(", 2, ")", "+", "fib", "(", 1,
             ")", "=", 2}], 5 -> 
         Row[{"fib", "(", 5, ")", "=", "fib", "(", 4, ")", "+", "fib", "(", 3,
             ")", "=", 5}], 8 -> 
         Row[{"fib", "(", 8, ")", "=", "fib", "(", 7, ")", "+", "fib", "(", 6,
             ")", "=", 21}], 7 -> 
         Row[{"fib", "(", 7, ")", "=", "fib", "(", 6, ")", "+", "fib", "(", 5,
             ")", "=", 13}], 9 -> 
         Row[{"fib", "(", 9, ")", "=", "fib", "(", 8, ")", "+", "fib", "(", 7,
             ")", "=", 34}], 4 -> 
         Row[{"fib", "(", 4, ")", "=", "fib", "(", 3, ")", "+", "fib", "(", 2,
             ")", "=", 3}], 2 -> Highlighted[
           Row[{"fib", "(", 2, ")", "=", 1}]], 1 -> Highlighted[
           Row[{"fib", "(", 1, ")", "=", 1}]]}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
        ArrowBox[{{0., 1.}, {0., 0.}}, 0.05338164251207729], 
        ArrowBox[{{0., 1.}, {1., 0.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQDQEf7KEMBxh/+byN3dft/9vD+EkTjT6UZP+zZ4Ty
9W406d5o+guX5yle5MzY9gfO/5UI0vAbwV/iD0II9TZ3Z8mL/YTzDdWtRBJO
fIfz08DgG5y/GKz9C5z/2KIPiD7D3aOsBAKf4PKJ3NsSuLd9gPPtX062ezn5
HZy/ZzcIvIbzLUHGPX4B54N0J3A/g/ONweAxnA8OnvwHcP45/u4pjctvw90j
nnNQLOfgNbi8ZMUuU3udS3D+ivQ3j76ePw3nT7EDOfAwnP/g5bU/Gzx2wvn/
tM508rGugPNhMQcApt6NHA==
         "]], 0.05338164251207729], 
        ArrowBox[{{1., 2.}, {0., 1.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQjQo4HGCskPM3jr6ezw7nb/KQrNhliuCL5xwUyznI
Bue3WV5cyOCM4P/dANLACufXXVKvvaSO4HPMyzvL380C588UluUyeMIM55sY
gwCCfwWkvZYJzi+UOQ5EjHC+kCAIIPgbWaM3sEYzwPkLvnjO/+L53x7Gv3cX
BP7C+bIg4wr/wPkxG0AG/IbzZ80EgZ9wPjh4zH/A+Z8PK6U+ePkNzmcHWb/h
K4IP9u8XOP9rT+yef5Wf4Xxw8NR+gvPByqd8hPMjEv1KNA58gPMh4IM9AIO9
YI0=
         "]], 0.05338164251207729], 
        ArrowBox[{{0., 3.}, {1., 2.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQDQEf7CG0gAOMH3z+xtHX8/nh/I0ekhW7TPkdGKF8
iZyDYjkH+eDyrZYXFzI4I/h/NoA08ML5dZfUay+pI/hs8/LO8nfzwPkzhGW5
DJ5ww/nGYIDgXwRpr+WC84tkjhfKHOeEu0dYEAQ44fIbWKOBiAPOD/i1xP/X
EnY4//07EGCD8/seWwARgq93o0n3RhMrnH8GDFjg/LQ3j76el0bwfyVONPpQ
wgx3T4suyAAmuDyL//Zn7a4IftUxvbj/exjh/FeT7V5OtkPwwcpPMcD5awzU
rUQSEHwIzeAAABQdeIM=
         "]], 0.05338164251207729], 
        ArrowBox[{{1., 4.}, {0., 3.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQjQpEHGCslelvHn09LwznRyzhsbk7C8Hn2ZbAvS0B
wT8850VAgyKCXwfWIATn27+cbPdyMoLP4r/9Wbsrgn+mk49V4pMgnD9rJggg
+K9A2u0QfMu+xxZ9jwXg/K4OEEDwbzTpAhGCH/Brif+vJfxw/od3IMAH54ON
s0Dw9cAG8ML5Z8+AAA+cDw4eaQT/V+JEow8l3HB+C8j6G1xo/kXwq4/pxf3f
w4nmPwQfrPwUB5y/xkDdSiQBwYcADgcAb9xhQg==
         "]], 0.05338164251207729], 
        ArrowBox[{{0., 5.}, {1., 4.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQDQEf7CG0hAOMvzL9zaOv58Xh/MglPDZ3Z4k7MEL5
PNsSuLclIOQPz3kR0KCI4NdHgDSIwfn2LyfbvZyM4LP4b3/W7orgn+3kY5X4
JArnz5oJAgg+WLsdgm/Z99ii77EI3D2dHSAgApe/2aR7o0kXwdeovaRee0kY
zq8oBwEE/3ihDBAh+OI5B8VyDgrB+WlggOCblH389ZwXwf+7wUOyYpcg3D2H
xEAGCMLlm5ZHfz6shODbJYuvr78nAOd/8ZwPRAj+CpDyVAQ/bIawLJcBgg+h
BRwAWAB52g==
         "]], 0.05338164251207729], 
        ArrowBox[{{1., 6.}, {0., 5.}}, 0.05338164251207729], 
        ArrowBox[BezierCurveBox[CompressedData["
1:eJxTTMoPSmViYGCQAWIQjQpkHGCslelvHn09Lw3nRy7hsbk7C8Hn2ZbAvS0B
wT8850VAgyKC3xAB0iAF5zu8nGz3cjKCz+K//Vm7K4J/tpOPVeKTJJw/ayYI
IPhg7XYIvkXfYyCSgPM7O0AAwb/ZpHujSRfB16i9pF57SRzOrygHAQT/eKEM
ECH44jkHxYAIzk8DAwTfqOzjr+e8CP7fDR6SFbtE4Xyw7hwEv3F59OfDSgi+
bbL4+vp7InD+F8/5QITgg5WnIvhhM4RluQwQfAgQcQAAd0FZHg==
         "]], 
         0.05338164251207729], 
        ArrowBox[{{0., 7.}, {1., 6.}}, 0.05338164251207729]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {DiskBox[{0., 0.}, 0.05338164251207729], InsetBox[
          
          TemplateBox[{
           TemplateBox[{"\"fib\"", "\"(\"", "1", "\")\"", "\"=\"", "1"}, 
             "RowDefault"],FrameStyle -> None},
           "Highlighted"], 
          Offset[{2, 2}, {0.05338164251207729, 0.05338164251207729}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{1., 0.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           TemplateBox[{"\"fib\"", "\"(\"", "2", "\")\"", "\"=\"", "1"}, 
             "RowDefault"],FrameStyle -> None},
           "Highlighted"], 
          Offset[{2, 2}, {1.0533816425120772, 0.05338164251207729}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{0., 1.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","3","\")\"","\"=\"","\"fib\"","\"(\"","2",
            "\")\"","\"+\"","\"fib\"","\"(\"","1","\")\"","\"=\"","2"},
           "RowDefault"], 
          Offset[{2, 2}, {0.05338164251207729, 1.0533816425120772}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{1., 2.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","4","\")\"","\"=\"","\"fib\"","\"(\"","3",
            "\")\"","\"+\"","\"fib\"","\"(\"","2","\")\"","\"=\"","3"},
           "RowDefault"], 
          Offset[{2, 2}, {1.0533816425120772, 2.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{0., 3.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","5","\")\"","\"=\"","\"fib\"","\"(\"","4",
            "\")\"","\"+\"","\"fib\"","\"(\"","3","\")\"","\"=\"","5"},
           "RowDefault"], 
          Offset[{2, 2}, {0.05338164251207729, 3.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{1., 4.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","6","\")\"","\"=\"","\"fib\"","\"(\"","5",
            "\")\"","\"+\"","\"fib\"","\"(\"","4","\")\"","\"=\"","8"},
           "RowDefault"], 
          Offset[{2, 2}, {1.0533816425120772, 4.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{0., 5.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","7","\")\"","\"=\"","\"fib\"","\"(\"","6",
            "\")\"","\"+\"","\"fib\"","\"(\"","5","\")\"","\"=\"","13"},
           "RowDefault"], 
          Offset[{2, 2}, {0.05338164251207729, 5.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{1., 6.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","8","\")\"","\"=\"","\"fib\"","\"(\"","7",
            "\")\"","\"+\"","\"fib\"","\"(\"","6","\")\"","\"=\"","21"},
           "RowDefault"], 
          Offset[{2, 2}, {1.0533816425120772, 6.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{0., 7.}, 0.05338164251207729], 
         InsetBox[
          
          TemplateBox[{
           "\"fib\"","\"(\"","9","\")\"","\"=\"","\"fib\"","\"(\"","8",
            "\")\"","\"+\"","\"fib\"","\"(\"","7","\")\"","\"=\"","34"},
           "RowDefault"], 
          Offset[{2, 2}, {0.05338164251207729, 7.053381642512077}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.7223767032535*^9, 3.722376763199883*^9, {3.722376804939166*^9, 
   3.722376826805509*^9}, {3.722376920000461*^9, 3.722376925634519*^9}, 
   3.722377006121551*^9, {3.722377097313264*^9, 3.722377170709714*^9}, 
   3.7223772074427423`*^9, 3.722377267822209*^9, 3.722377435060647*^9, 
   3.722377482515912*^9, {3.722377561776079*^9, 3.7223775859223967`*^9}, 
   3.7223777014689837`*^9, 3.722378047331973*^9, 3.722378121641015*^9, {
   3.722379035024343*^9, 
   3.722379081195372*^9}},ExpressionUUID->"eeee6dba-d8c1-4b2c-974b-\
aea0415babc2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"n", "=", "8"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"vnames", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Highlighted", "@", 
        RowBox[{"Row", "@", 
         RowBox[{"{", 
          RowBox[{"0", ",", "\"\<!\>\"", ",", "\"\<=\>\"", ",", "1"}], 
          "}"}]}]}], "}"}], "~", "Join", "~", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Row", "@", 
         RowBox[{"{", 
          RowBox[{
          "nn", ",", "\"\<!\>\"", ",", "\"\<=\>\"", ",", "nn", ",", 
           "\"\<\[Cross]\>\"", ",", 
           RowBox[{"nn", "-", "1"}], ",", "\"\<!\>\"", ",", "\"\<=\>\"", ",", 
           
           RowBox[{"nn", "!"}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"nn", ",", "1", ",", "n"}], "}"}]}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"RelationGraph", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"#1", "-", "#2"}], "\[Equal]", "1"}], ")"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#1", ">", "0"}], ")"}]}], "&"}], ",", " ", 
     RowBox[{"Range", "[", 
      RowBox[{"0", ",", "n"}], "]"}], ",", 
     RowBox[{"VertexLabels", "\[Rule]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"i", "-", "1"}], ")"}], "\[Rule]", 
         RowBox[{"vnames", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "1", ",", 
          RowBox[{"n", "+", "1"}]}], "}"}]}], "]"}]}], ",", 
     RowBox[{"GraphLayout", "->", "\"\<CircularEmbedding\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.722378436802541*^9, 3.7223784725884247`*^9}, {
   3.722378511222179*^9, 3.722378600457843*^9}, {3.722378665271022*^9, 
   3.7223787121269712`*^9}, 3.722378747442018*^9, 3.7223788392328033`*^9, {
   3.722378885909339*^9, 3.7223789121557493`*^9}, {3.722378948156947*^9, 
   3.722378951598857*^9}, {3.722379011214329*^9, 3.7223790213621483`*^9}, 
   3.722379089144112*^9},ExpressionUUID->"8740169b-710c-434a-82b5-\
7aab61909f15"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{0, 1, 2, 3, 4, 5, 6, 7, 8}, {
       SparseArray[
       Automatic, {9, 9}, 0, {
        1, {{0, 0, 1, 2, 3, 4, 5, 6, 7, 8}, {{1}, {2}, {3}, {4}, {5}, {6}, {
          7}, {8}}}, Pattern}], Null}, {
      GraphLayout -> "CircularEmbedding", 
       VertexLabels -> {
        6 -> Row[{6, "!", "=", 6, "\[Cross]", 5, "!", "=", 720}], 3 -> 
         Row[{3, "!", "=", 3, "\[Cross]", 2, "!", "=", 6}], 5 -> 
         Row[{5, "!", "=", 5, "\[Cross]", 4, "!", "=", 120}], 8 -> 
         Row[{8, "!", "=", 8, "\[Cross]", 7, "!", "=", 40320}], 7 -> 
         Row[{7, "!", "=", 7, "\[Cross]", 6, "!", "=", 5040}], 4 -> 
         Row[{4, "!", "=", 4, "\[Cross]", 3, "!", "=", 24}], 2 -> 
         Row[{2, "!", "=", 2, "\[Cross]", 1, "!", "=", 2}], 1 -> 
         Row[{1, "!", "=", 1, "\[Cross]", 0, "!", "=", 1}], 0 -> Highlighted[
           Row[{0, "!", "=", 1}]]}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[0.028386821578112776`], 
        ArrowBox[{{{-0.9848077530122081, 
         0.17364817766693114`}, {-0.6427876096865398, 
         0.7660444431189786}}, {{-0.8660254037844384, -0.4999999999999994}, \
{-0.9848077530122081, 
         0.17364817766693114`}}, {{-0.3420201433256684, -0.9396926207859079}, \
{-0.8660254037844384, -0.4999999999999994}}, {{
         0.3420201433256691, -0.9396926207859085}, {-0.3420201433256684, \
-0.9396926207859079}}, {{0.8660254037844389, -0.5000000000000012}, {
         0.3420201433256691, -0.9396926207859085}}, {{0.984807753012208, 
         0.17364817766692903`}, {0.8660254037844389, -0.5000000000000012}}, {{
         0.6427876096865388, 0.7660444431189772}, {0.984807753012208, 
         0.17364817766692903`}}, {{-7.044813998280222*^-16, 1.}, {
         0.6427876096865388, 0.7660444431189772}}}, 0.022364449578799767`]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {
         DiskBox[{-0.6427876096865398, 0.7660444431189786}, 
          0.022364449578799767], InsetBox[
          TemplateBox[{
           TemplateBox[{"0", "\"!\"", "\"=\"", "1"}, "RowDefault"],FrameStyle -> 
            None},
           "Highlighted"], 
          Offset[{2, 2}, {-0.62042316010774, 0.7884088926977784}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9848077530122081, 0.17364817766693114}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "1","\"!\"","\"=\"","1","\"\[Cross]\"","0","\"!\"","\"=\"","1"},
           "RowDefault"], 
          Offset[{2, 2}, {-0.9624433034334083, 0.1960126272457309}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.8660254037844384, -0.4999999999999994}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "2","\"!\"","\"=\"","2","\"\[Cross]\"","1","\"!\"","\"=\"","2"},
           "RowDefault"], 
          Offset[{2, 2}, {-0.8436609542056386, -0.47763555042119965}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.3420201433256684, -0.9396926207859079}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "3","\"!\"","\"=\"","3","\"\[Cross]\"","2","\"!\"","\"=\"","6"},
           "RowDefault"], 
          Offset[{2, 2}, {-0.31965569374686864, -0.9173281712071081}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.3420201433256691, -0.9396926207859085}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "4","\"!\"","\"=\"","4","\"\[Cross]\"","3","\"!\"","\"=\"","24"},
           "RowDefault"], 
          Offset[{2, 2}, {0.3643845929044689, -0.9173281712071087}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.8660254037844389, -0.5000000000000012}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "5","\"!\"","\"=\"","5","\"\[Cross]\"","4","\"!\"","\"=\"","120"},
           "RowDefault"], 
          Offset[{2, 2}, {0.8883898533632387, -0.4776355504212014}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.984807753012208, 0.17364817766692903}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "6","\"!\"","\"=\"","6","\"\[Cross]\"","5","\"!\"","\"=\"","720"},
           "RowDefault"], 
          Offset[{2, 2}, {1.0071722025910077, 0.1960126272457288}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.6427876096865388, 0.7660444431189772}, 
          0.022364449578799767], InsetBox[
          
          TemplateBox[{
           "7","\"!\"","\"=\"","7","\"\[Cross]\"","6","\"!\"","\"=\"","5040"},
           
           "RowDefault"], 
          Offset[{2, 2}, {0.6651520592653386, 0.788408892697777}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-7.044813998280222*^-16, 1.}, 0.022364449578799767], 
         InsetBox[
          
          TemplateBox[{
           "8","\"!\"","\"=\"","8","\"\[Cross]\"","7","\"!\"","\"=\"","40320"},
           "RowDefault"], 
          Offset[{2, 2}, {0.022364449578799062, 1.0223644495787998}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.722378752647463*^9, 3.722378839692194*^9, {3.72237888870162*^9, 
   3.722378897302002*^9}, {3.722378927509194*^9, 3.722378962402972*^9}, {
   3.722379016684516*^9, 3.722379021680097*^9}, 
   3.722379089749557*^9},ExpressionUUID->"08aeb01f-f952-4f1f-8972-\
c2522815e008"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.722378750512146*^9, 
  3.722378750519292*^9}},ExpressionUUID->"7e82b77c-6f98-4ca5-b575-\
6acd03796b32"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"n", "=", "6"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"list", "=", 
    RowBox[{"Tuples", "[", 
     RowBox[{
      RowBox[{"Range", "[", "n", "]"}], ",", "2"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vnames", "=", 
    RowBox[{"<|", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"list", "[", 
          RowBox[{"[", "nn", "]"}], "]"}], "\[Rule]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "nn", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "nn", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<gcd(\>\"", ",", 
              RowBox[{
               RowBox[{"list", "[", 
                RowBox[{"[", "nn", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<,\>\"", ",", 
              RowBox[{"Mod", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "nn", "]"}], "]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"list", "[", 
                  RowBox[{"[", "nn", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", "\"\<)\>\""}], 
             "}"}]}], ",", 
           RowBox[{
            RowBox[{"list", "[", 
             RowBox[{"[", "nn", "]"}], "]"}], "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"nn", ",", "1", ",", 
          RowBox[{"Length", "@", "list"}]}], "}"}]}], "]"}]}], 
     "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"test", "[", 
     RowBox[{"s1_", ",", "s2_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s2", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
       RowBox[{"s1", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"s2", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
       RowBox[{"Mod", "[", 
        RowBox[{
         RowBox[{"s1", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"s1", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"g", "=", 
   RowBox[{"RelationGraph", "[", 
    RowBox[{"test", ",", " ", "list", ",", 
     RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vlist", "=", 
    RowBox[{"VertexList", "@", "g"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"g2", "=", 
    RowBox[{"RelationGraph", "[", 
     RowBox[{"test", ",", " ", "list", ",", 
      RowBox[{"VertexLabels", "\[Rule]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"vlist", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
          RowBox[{"Row", "@", 
           RowBox[{"{", 
            RowBox[{"\"\<gcd\>\"", ",", "\"\<(\>\"", ",", 
             RowBox[{"vlist", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", "\"\<)=(\>\"", ",", 
             RowBox[{"vnames", "[", 
              RowBox[{"vlist", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", "\"\<)\>\""}], 
            "}"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{"Length", "@", "vlist"}]}], "}"}]}], "]"}]}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]",
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"NeighborhoodGraph", "[", 
  RowBox[{"g2", ",", 
   RowBox[{"vlist", "[", 
    RowBox[{"[", "9", "]"}], "]"}], ",", "100", ",", 
   RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.722379882406239*^9, 3.722379887996717*^9}, {
   3.722380149721444*^9, 3.722380242670413*^9}, {3.72238028041556*^9, 
   3.722380284183251*^9}, {3.722380316123312*^9, 3.722380380259872*^9}, {
   3.722380486305127*^9, 3.722380503494822*^9}, {3.722380602283071*^9, 
   3.722380652357308*^9}, {3.7223806836213627`*^9, 3.7223807367571774`*^9}, {
   3.7223807705529203`*^9, 3.722380770821842*^9}, {3.722380806399151*^9, 
   3.72238084553485*^9}, 3.7223809330956078`*^9, {3.72238098805256*^9, 
   3.722380995713152*^9}, {3.72238104046734*^9, 3.722381051007736*^9}, {
   3.722381676418456*^9, 3.722381679466251*^9}, {3.722381737494746*^9, 
   3.7223817817300453`*^9}, {3.72238195809927*^9, 3.7223819671668043`*^9}, {
   3.72238200065948*^9, 3.722382003077469*^9}, {3.722382044332037*^9, 
   3.722382083764045*^9}, {3.722382167818287*^9, 3.722382178591764*^9}, {
   3.7223823155300093`*^9, 3.722382341381556*^9}, {3.722382373772224*^9, 
   3.7223823938561707`*^9}, {3.7223825238943167`*^9, 
   3.7223825417844753`*^9}, {3.722382578851756*^9, 3.7223826071233*^9}, {
   3.722382658649485*^9, 3.7223826777731237`*^9}, {3.722382716003168*^9, 
   3.722382725565956*^9}, {3.7223829446857157`*^9, 3.722382946889027*^9}, {
   3.722382989404677*^9, 3.72238301446905*^9}, {3.7223830760199003`*^9, 
   3.722383280682177*^9}, {3.7223833324452763`*^9, 3.722383367570077*^9}, {
   3.722383533531789*^9, 3.7223836508585577`*^9}, {3.722383699808793*^9, 
   3.7223837317249727`*^9}, 3.722383843801766*^9, {3.722383876865047*^9, 
   3.7223838891156063`*^9}, 3.7223839240634537`*^9, 3.722383979692293*^9, {
   3.722384029113958*^9, 3.722384045526877*^9}, {3.7223840974144373`*^9, 
   3.722384125819417*^9}, 3.722384156285963*^9, 3.7223841864286737`*^9, {
   3.722384218499897*^9, 3.722384254476465*^9}, {3.7223843148788*^9, 
   3.722384386126348*^9}, {3.72238452277232*^9, 3.7223846138413353`*^9}, {
   3.722384741092915*^9, 3.722384741778118*^9}, {3.722384775026884*^9, 
   3.722384788387745*^9}, {3.722384995392467*^9, 3.722385029636683*^9}, {
   3.7223850933513803`*^9, 3.722385187927824*^9}, {3.7223857125921164`*^9, 
   3.722385721797777*^9}},ExpressionUUID->"4503befb-2593-4ace-b883-\
64e1b69ce9bc"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{2, 3}, {1, 2}, {2, 1}, {2, 5}, {3, 2}, {3, 5}, {5, 2}, {5, 3}}, {
      
       SparseArray[
       Automatic, {8, 8}, 0, {
        1, {{0, 1, 2, 2, 3, 4, 5, 6, 7}, {{5}, {3}, {7}, {3}, {8}, {3}, {5}}},
          Pattern}], Null}, {
      VertexLabels -> {"Name"}, 
       VertexCoordinates -> {{0.17858142857142845`, -1.1785814285714284`}, {
        0.17858142857142845`, -2.1785814285714284`}, {
        1.1785814285714284`, -3.1785814285714284`}, {
        2.1785814285714284`, -1.1785814285714284`}, {
        1.1785814285714284`, -2.1785814285714284`}, {
        1.1785814285714284`, -0.17858142857142845`}, {
        2.1785814285714284`, -2.1785814285714284`}, {
        1.1785814285714284`, -1.1785814285714284`}}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
        ArrowBox[{{0.17858142857142845`, -1.1785814285714284`}, {
         1.1785814285714284`, -2.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{0.17858142857142845`, -2.1785814285714284`}, {
         1.1785814285714284`, -3.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{2.1785814285714284`, -1.1785814285714284`}, {
         2.1785814285714284`, -2.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{1.1785814285714284`, -2.1785814285714284`}, {
         1.1785814285714284`, -3.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{1.1785814285714284`, -0.17858142857142845`}, {
         1.1785814285714284`, -1.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{2.1785814285714284`, -2.1785814285714284`}, {
         1.1785814285714284`, -3.1785814285714284`}}, 0.030239520958083826`], 
        ArrowBox[{{1.1785814285714284`, -1.1785814285714284`}, {
         1.1785814285714284`, -2.1785814285714284`}}, 0.030239520958083826`]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {
         DiskBox[{0.17858142857142845, -1.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"2", ",", "3"}], "}"}], 
          Offset[{2, 2}, {0.20882094952951227, -1.1483419076133445}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.17858142857142845, -2.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], 
          Offset[{2, 2}, {0.20882094952951227, -2.1483419076133448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.1785814285714284, -3.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}], 
          Offset[{2, 2}, {1.2088209495295124, -3.1483419076133448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{2.1785814285714284, -1.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"2", ",", "5"}], "}"}], 
          Offset[{2, 2}, {2.208820949529512, -1.1483419076133445}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.1785814285714284, -2.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"3", ",", "2"}], "}"}], 
          Offset[{2, 2}, {1.2088209495295124, -2.1483419076133448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.1785814285714284, -0.17858142857142845}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"3", ",", "5"}], "}"}], 
          Offset[{2, 2}, {1.2088209495295124, -0.14834190761334462}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{2.1785814285714284, -2.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"5", ",", "2"}], "}"}], 
          Offset[{2, 2}, {2.208820949529512, -2.1483419076133448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.1785814285714284, -1.1785814285714284}, 
          0.030239520958083826], InsetBox[
          RowBox[{"{", 
           RowBox[{"5", ",", "3"}], "}"}], 
          Offset[{2, 2}, {1.2088209495295124, -1.1483419076133445}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.7223841570640907`*^9, 3.722384187784276*^9, 3.722384218724188*^9, {
   3.7223843160414343`*^9, 3.722384386499956*^9}, {3.722384523089911*^9, 
   3.722384530008616*^9}, {3.722384576479508*^9, 3.722384614647048*^9}, 
   3.722384742179885*^9, {3.7223847760696917`*^9, 3.722384788720565*^9}, {
   3.722385002388626*^9, 3.722385030115806*^9}, {3.7223851003518887`*^9, 
   3.722385148454792*^9}, {3.7223851787431583`*^9, 3.722385188360834*^9}, {
   3.722385714474269*^9, 
   3.7223857229135847`*^9}},ExpressionUUID->"083633eb-a5f1-4f3a-9e52-\
e4e916f923f3"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"gcd", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "rem", "}"}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"rem", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{"a", ",", "b"}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", " ", "[", 
      RowBox[{
       RowBox[{"rem", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"list", ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b"}], "}"}], "\[Rule]", "b"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "@", "b"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"list", ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"a", ",", "b"}], "}"}], "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"b", ",", "rem"}], "}"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "@", 
         RowBox[{"gcd", "[", 
          RowBox[{"b", ",", "rem"}], "]"}]}]}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.72238522848938*^9, 3.722385378437345*^9}, {
  3.72238540986008*^9, 
  3.722385431009676*^9}},ExpressionUUID->"173d8b7c-9d76-425b-bbd2-\
70de81b41b8c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"list", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"gcd", "[", 
  RowBox[{"45", ",", "4"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Graph", "[", 
  RowBox[{"list", ",", 
   RowBox[{"VertexLabels", "\[Rule]", "\"\<Name\>\""}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.722385332147903*^9, 3.722385363845813*^9}, {
  3.7223854496408167`*^9, 3.722385469327703*^9}, {3.7223855502401533`*^9, 
  3.722385664192346*^9}},ExpressionUUID->"9ea9199b-947e-40d3-aae1-\
000ae09a9235"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.7223853395122223`*^9, {3.72238543380153*^9, 3.722385469964341*^9}, {
   3.722385556063718*^9, 
   3.722385664680887*^9}},ExpressionUUID->"0b55e64c-5213-4839-9af4-\
096692fe7723"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{{45, 4}, {4, 1}, 1}, {{{1, 2}, {2, 3}}, Null}, {
      VertexLabels -> {"Name"}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
        ArrowBox[{{{0., 3.6739403974420594`*^-16}, {1., 
         2.4492935982947064`*^-16}}, {{1., 2.4492935982947064`*^-16}, {2., 
         0.}}}, 0.02261146496815286]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {DiskBox[{0., 3.6739403974420594*^-16}, 0.02261146496815286], 
         InsetBox[
          RowBox[{"{", 
           RowBox[{"45", ",", "4"}], "}"}], 
          Offset[{2, 2}, {0.02261146496815286, 0.02261146496815323}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1., 2.4492935982947064*^-16}, 0.02261146496815286], InsetBox[
          RowBox[{"{", 
           RowBox[{"4", ",", "1"}], "}"}], 
          Offset[{2, 2}, {1.0226114649681528, 0.022611464968153108}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{2., 0.}, 0.02261146496815286], 
         InsetBox["1", 
          Offset[{2, 2}, {2.022611464968153, 0.02261146496815286}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None]], "Output",
 CellChangeTimes->{
  3.7223853395122223`*^9, {3.72238543380153*^9, 3.722385469964341*^9}, {
   3.722385556063718*^9, 
   3.722385664711812*^9}},ExpressionUUID->"1e451c55-6e41-4c04-90d7-\
cd07cba30cc5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["list"], "Input",
 CellChangeTimes->{{3.722385437416884*^9, 
  3.722385438625811*^9}},ExpressionUUID->"4667181e-45c2-494d-b215-\
95022fe1ad1d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"15", ",", "4"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"4", ",", "3"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "3"}], "}"}], "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}]}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1"}], "}"}], "\[Rule]", "1"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.722385438830587*^9, 
  3.722385452097947*^9}},ExpressionUUID->"5b985d92-18bb-4a57-9f2f-\
857ac856adb4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "g", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"steps", "=", 
  RowBox[{"RecurrenceTable", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"g", "[", "n", "]"}], "==", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"g", "[", 
          RowBox[{"n", "-", "1"}], "]"}], "+", 
         RowBox[{"g", "[", 
          RowBox[{"n", "-", "2"}], "]"}]}], ")"}]}], ",", 
      RowBox[{
       RowBox[{"g", "[", "1", "]"}], "\[Equal]", "1"}], ",", 
      RowBox[{
       RowBox[{"g", "[", "2", "]"}], "\[Equal]", "1"}]}], "}"}], ",", "g", 
    ",", 
    RowBox[{"{", 
     RowBox[{"n", ",", "3", ",", "10"}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7224655803665113`*^9, 3.722465630111361*^9}, {
  3.722465665292759*^9, 3.722465716750618*^9}, {3.722465863186667*^9, 
  3.7224658759700537`*^9}, {3.7224659562275343`*^9, 3.7224659693330803`*^9}, {
  3.722466071869923*^9, 3.722466097812725*^9}, {3.722466165349934*^9, 
  3.722466167734291*^9}},ExpressionUUID->"9fec0d83-a5f5-47c8-b173-\
8ba363e8a6a8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "5", ",", "8", ",", "13", ",", "21", ",", "34", ",", 
   "55"}], "}"}]], "Output",
 CellChangeTimes->{{3.722465609409388*^9, 3.7224656310263243`*^9}, {
   3.722465665785666*^9, 3.7224657076821003`*^9}, 3.7224658401835337`*^9, 
   3.72246587729906*^9, {3.722465946982527*^9, 3.722465972165897*^9}, {
   3.722466076477313*^9, 3.722466098307715*^9}, 
   3.722466169693388*^9},ExpressionUUID->"0e31c161-66e9-4ed8-b6f5-\
484e682664f1"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"EdgeForm", "[", "Thin", "]"}], ",", "Orange", ",", 
       RowBox[{"Rectangle", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
       RowBox[{"tr", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}], ",", "n"}], "]"}], ",", 
       RowBox[{"tr", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "2"}], "}"}], ",", "n"}], "]"}], ",", 
       RowBox[{"tr", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", "n"}], "]"}], ",", 
       RowBox[{"tr", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", "n"}], "]"}]}], "}"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"450", ",", "450"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "1", ",", "\"\<level\>\""}], "}"}], ",", "1", ",", 
     "8", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Initialization", "\[RuleDelayed]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"tr", "[", 
        RowBox[{"u_", ",", "v_", ",", "1"}], "]"}], ":=", 
       RowBox[{"{", 
        RowBox[{"Rectangle", "[", 
         RowBox[{"u", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"u", "+", "v"}], ")"}], "/", "2"}]}], "]"}], "}"}]}], ";",
       "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"tr", "[", 
        RowBox[{
         RowBox[{"u", ":", 
          RowBox[{"{", 
           RowBox[{"x_", ",", "y_"}], "}"}]}], ",", 
         RowBox[{"v", ":", 
          RowBox[{"{", 
           RowBox[{"h_", ",", "k_"}], "}"}]}], ",", "n_"}], "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"z", "=", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"u", "+", "v"}], ")"}], "/", "2."}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Rectangle", "[", 
             RowBox[{"u", ",", "z"}], "]"}], "}"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{"z", ",", "v", ",", 
             RowBox[{"n", "-", "1"}]}], "]"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"x", ",", 
               RowBox[{"Last", "[", "z", "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               FractionBox[
                RowBox[{
                 RowBox[{"3.", "x"}], "-", "h"}], "2"], ",", "k"}], "}"}], 
             ",", 
             RowBox[{"n", "-", "1"}]}], "]"}], ",", 
           RowBox[{"tr", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"First", "[", "z", "]"}], ",", "y"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"h", ",", 
               FractionBox[
                RowBox[{
                 RowBox[{"3.", "y"}], "-", "k"}], "2"]}], "}"}], ",", 
             RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], ";"}], 
     "\[IndentingNewLine]", ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.722466904982242*^9},ExpressionUUID->"39540f32-1d65-4fc8-b371-\
0fd3f353c5b7"],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellChangeTimes->{
  3.7224670644286327`*^9},ExpressionUUID->"e5cd7f72-0f60-4f91-b6e9-\
3889dc90baab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CloudDeploy", "[", 
   RowBox[{
    RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Column", "@", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Highlighted", "@", 
          RowBox[{"Row", "@", 
           RowBox[{"{", 
            RowBox[{"\"\<level\>\"", ",", "\"\<=\>\"", ",", "n"}], "}"}]}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"Graphics", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"EdgeForm", "[", "Thin", "]"}], ",", "Orange", ",", 
             RowBox[{"Rectangle", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
             RowBox[{"tr", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "2"}], "}"}], ",", "n"}], "]"}], ",", 
             RowBox[{"tr", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "1"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "2"}], "}"}], ",", "n"}], "]"}], 
             ",", 
             RowBox[{"tr", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", "n"}], "]"}], ",", 
             RowBox[{"tr", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", 
                 RowBox[{"-", "1"}]}], "}"}], ",", "n"}], "]"}]}], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"450", ",", "450"}], "}"}]}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"n", ",", "1", ",", "\"\<level\>\""}], "}"}], ",", "1", ",", 
        "6", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Initialization", "\[RuleDelayed]", 
       RowBox[{"(", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"tr", "[", 
           RowBox[{"u_", ",", "v_", ",", "1"}], "]"}], ":=", 
          RowBox[{"{", 
           RowBox[{"Rectangle", "[", 
            RowBox[{"u", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"u", "+", "v"}], ")"}], "/", "2"}]}], "]"}], "}"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"tr", "[", 
           RowBox[{
            RowBox[{"u", ":", 
             RowBox[{"{", 
              RowBox[{"x_", ",", "y_"}], "}"}]}], ",", 
            RowBox[{"v", ":", 
             RowBox[{"{", 
              RowBox[{"h_", ",", "k_"}], "}"}]}], ",", "n_"}], "]"}], ":=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"z", "=", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"u", "+", "v"}], ")"}], "/", "2."}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Rectangle", "[", 
                RowBox[{"u", ",", "z"}], "]"}], "}"}], ",", 
              RowBox[{"tr", "[", 
               RowBox[{"z", ",", "v", ",", 
                RowBox[{"n", "-", "1"}]}], "]"}], ",", 
              RowBox[{"tr", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", 
                  RowBox[{"Last", "[", "z", "]"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  FractionBox[
                   RowBox[{
                    RowBox[{"3.", "x"}], "-", "h"}], "2"], ",", "k"}], "}"}], 
                ",", 
                RowBox[{"n", "-", "1"}]}], "]"}], ",", 
              RowBox[{"tr", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"First", "[", "z", "]"}], ",", "y"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"h", ",", 
                  FractionBox[
                   RowBox[{
                    RowBox[{"3.", "y"}], "-", "k"}], "2"]}], "}"}], ",", 
                RowBox[{"n", "-", "1"}]}], "]"}]}], "]"}]}], "]"}]}], ";"}], 
        "\[IndentingNewLine]", ")"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
    RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.722466933647381*^9, 3.7224669537520943`*^9}, {
   3.722467119325165*^9, 3.722467147719803*^9}, 3.722467233471405*^9, {
   3.722467267559937*^9, 
   3.722467270844651*^9}},ExpressionUUID->"30f6edb1-1337-4357-af43-\
86688490bd12"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/b51683bd-4eb4-419c-bda7-\
d6be8ce2fa8b\"",
     "https://www.wolframcloud.com/objects/b51683bd-4eb4-419c-bda7-\
d6be8ce2fa8b"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/b51683bd-4eb4-419c-bda7-d6be8ce2fa8b"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{3.722466956263298*^9, 3.722467149323696*^9, 
  3.722467237091757*^9, 
  3.722467272948328*^9},ExpressionUUID->"6f686ce6-4a58-49e7-9fec-\
8001d14b32d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Column", "@", 
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Highlighted", "@", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<level\>\"", ",", "\"\<=\>\"", ",", "n"}], "}"}]}]}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"Graphics", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"EdgeForm", "[", "Thin", "]"}], ",", 
            RowBox[{"putCube", "[", 
             RowBox[{"0", ",", 
              SuperscriptBox["\[Zeta]", 
               RowBox[{"-", "3.5"}]]}], "]"}], ",", 
            RowBox[{"gen", "[", 
             RowBox[{"0", ",", 
              RowBox[{
               FractionBox["1", "2"], 
               SuperscriptBox["\[Zeta]", 
                RowBox[{"-", "0.5"}]]}], ",", "n"}], "]"}]}], "}"}], ",", 
          RowBox[{"ImageSize", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"500", ",", "450"}], "}"}]}]}], "]"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", "1", ",", "\"\<level\>\""}], "}"}], ",", "1", ",", 
       "6", ",", "1"}], "}"}], ",", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Initialization", "\[RuleDelayed]", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"toXY", "[", "g_", "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Re", "[", "#", "]"}], ",", 
             RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}], "/@", "g"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"putCube", "[", 
          RowBox[{"w_", ",", "s_"}], "]"}], ":=", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"First", "[", "#", "]"}], ",", 
             RowBox[{"Polygon", "[", 
              RowBox[{"toXY", "[", 
               RowBox[{"w", "+", 
                RowBox[{"s", " ", 
                 RowBox[{"Last", "[", "#", "]"}]}]}], "]"}], "]"}]}], "}"}], 
           "&"}], "/@", "cube"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"gen", "[", 
          RowBox[{"w_", ",", "s_", ",", "1"}], "]"}], ":=", 
         RowBox[{"putCube", "[", 
          RowBox[{"w", ",", "s"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"gen", "[", 
          RowBox[{"w_", ",", "s_", ",", "n_"}], "]"}], ":=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"putCube", "[", 
             RowBox[{"w", ",", "s"}], "]"}], ",", 
            RowBox[{"gen", "[", 
             RowBox[{
              RowBox[{"w", "+", 
               RowBox[{"s", " ", 
                SuperscriptBox["\[Zeta]", "2"]}]}], ",", 
              RowBox[{"s", "/", "2"}], ",", 
              RowBox[{"n", "-", "1"}]}], "]"}], ",", 
            RowBox[{"gen", "[", 
             RowBox[{
              RowBox[{"w", "+", 
               RowBox[{"s", " ", 
                SuperscriptBox["\[Zeta]", "4"]}]}], ",", 
              RowBox[{"s", "/", "2"}], ",", 
              RowBox[{"n", "-", "1"}]}], "]"}], ",", 
            RowBox[{"gen", "[", 
             RowBox[{
              RowBox[{"w", "+", "s"}], " ", ",", 
              RowBox[{"s", "/", "2"}], ",", 
              RowBox[{"n", "-", "1"}]}], "]"}]}], "}"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"\[Zeta]", "=", 
         RowBox[{"1.", 
          SuperscriptBox["\[ExponentialE]", 
           FractionBox[
            RowBox[{"\[Pi]", " ", "\[ImaginaryI]"}], "3."]]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"cube", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Orange", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               SuperscriptBox["\[Zeta]", "5"], ",", 
               SuperscriptBox["\[Zeta]", "6"], ",", 
               SuperscriptBox["\[Zeta]", "7"]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"LightBrown", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "\[Zeta]", ",", 
               SuperscriptBox["\[Zeta]", "2"], ",", 
               SuperscriptBox["\[Zeta]", "3"]}], "}"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Brown", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               SuperscriptBox["\[Zeta]", "3"], ",", 
               SuperscriptBox["\[Zeta]", "4"], ",", 
               SuperscriptBox["\[Zeta]", "5"]}], "}"}]}], "}"}]}], "}"}]}], 
        ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", ")"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722467722264423*^9, 
  3.722467907457024*^9}},ExpressionUUID->"097ad7b5-4e6f-4fe1-a320-\
beee27470caf"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/372c29f7-a59e-4a99-8089-\
6f1bafec2c9f\"",
     "https://www.wolframcloud.com/objects/372c29f7-a59e-4a99-8089-\
6f1bafec2c9f"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/372c29f7-a59e-4a99-8089-6f1bafec2c9f"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{{3.722467764434761*^9, 3.722467775448153*^9}, {
  3.722467816398822*^9, 
  3.722467912554324*^9}},ExpressionUUID->"38303612-687c-4398-8f51-\
16d009b4aa61"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Manipulate", "[", 
    RowBox[{
     RowBox[{"Grid", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"timeComplex", "[", "n", "]"}], ",", " ", 
           RowBox[{"spaceComplex", "[", "n", "]"}]}], "}"}], ",", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{"itTree", "[", "n", "]"}], "]"}], ",", " ", 
             RowBox[{
             "PlotLabel", " ", "\[Rule]", " ", "\"\<iterative tree\>\""}]}], 
            "]"}], ",", " ", 
           RowBox[{"Show", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{"recTree", "[", "n", "]"}], "]"}], ",", " ", 
             RowBox[{
             "PlotLabel", " ", "\[Rule]", " ", "\"\<recursive tree\>\""}]}], 
            "]"}]}], "}"}]}], "}"}], ",", "  ", 
       RowBox[{"Alignment", " ", "\[Rule]", 
        RowBox[{"{", " ", 
         RowBox[{"Center", ",", " ", "Top"}], "}"}]}], ",", 
       RowBox[{"Frame", " ", "\[Rule]", " ", "All"}]}], "]"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", " ", "2", ",", " ", "\"\<Fibonacci number\>\""}], 
        "}"}], ",", " ", "2", ",", " ", "10", ",", " ", "1", ",", 
       RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}]}], "}"}], ",", 
     RowBox[{"ControlPlacement", "\[Rule]", "Top"}], ",", " ", 
     RowBox[{"SaveDefinitions", "\[Rule]", "True"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Initialization", "\[RuleDelayed]", 
      RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"recFxnTime", "[", "x_", "]"}], " ", ":=", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"Sqrt", "[", "5", "]"}]}], ")"}], "/", "2"}], ")"}], 
           "^", "x"}], ")"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"timeComplex", "[", "n_", "]"}], " ", ":=", " ", 
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"recFxnTime", "[", "x", "]"}], ",", " ", "x"}], "}"}], 
           ",", " ", 
           RowBox[{"{", 
            RowBox[{"x", ",", " ", "0", ",", " ", "n"}], "}"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", " ", "10"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"PlotStyle", " ", "\[Rule]", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Thickness", "[", "0.02", "]"}], ",", " ", 
              RowBox[{"Thickness", "[", "0.01", "]"}]}], "}"}]}], ",", " ", 
           RowBox[{"PlotLabel", "\[Rule]", "  ", "\"\<time complexity\>\""}], 
           ",", 
           RowBox[{"AxesLabel", " ", "\[Rule]", " ", 
            RowBox[{"{", 
             RowBox[{"\"\<n\>\"", ",", " ", "\"\<time\>\""}], "}"}]}], ",", 
           RowBox[{"PlotLegends", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<recursive\>\"", ",", " ", "\"\<iterative\>\""}], 
             "}"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"200", ",", "200"}], "}"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"spaceComplex", "[", "n_", "]"}], " ", ":=", " ", 
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "*", "x"}], ",", " ", "1"}], "}"}], ",", " ", 
           RowBox[{"{", 
            RowBox[{"x", ",", " ", "0", ",", " ", "n"}], "}"}], ",", 
           RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", " ", "10"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"0", ",", "20"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"PlotStyle", " ", "\[Rule]", " ", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Thickness", "[", "0.02", "]"}], ",", " ", 
              RowBox[{"Thickness", "[", "0.01", "]"}]}], "}"}]}], ",", " ", 
           RowBox[{"PlotLabel", "\[Rule]", "  ", "\"\<space complexity\>\""}],
            ",", 
           RowBox[{"AxesLabel", " ", "\[Rule]", " ", 
            RowBox[{"{", 
             RowBox[{"\"\<n\>\"", ",", " ", "\"\<space\>\""}], "}"}]}], ",", 
           " ", 
           RowBox[{"PlotLegends", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"\"\<recursive\>\"", ",", " ", "\"\<iterative\>\""}], 
             "}"}]}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"200", ",", "200"}], "}"}]}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"itTree", "[", "n_", "]"}], ":=", 
         RowBox[{"Module", "[", " ", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"itTreeArray", " ", "=", " ", 
              RowBox[{"{", "}"}]}], ",", " ", 
             RowBox[{"n0", " ", "=", " ", "n"}]}], "}"}], " ", ",", 
           "\[IndentingNewLine]", "\t\t\t\t\t", 
           RowBox[{
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"i", "=", "2"}], ",", 
              RowBox[{"i", "\[LessEqual]", "n0"}], ",", 
              RowBox[{"i", "++"}], ",", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"itTreeArray", ",", " ", 
                 RowBox[{
                  RowBox[{"i", "-", "2"}], " ", "\[Rule]", " ", "i"}]}], 
                "]"}], ";", "  ", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"itTreeArray", ",", 
                 RowBox[{
                  RowBox[{"i", "-", "1"}], " ", "\[Rule]", " ", "i"}]}], 
                "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", "\t\t\t\t\t", 
            RowBox[{"TreePlot", "[", 
             RowBox[{"itTreeArray", ",", "Right", "  ", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"VertexLabeling", "\[Rule]", "True"}], ","}], " ", 
               "*)"}], ",", 
              RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", " ", 
              RowBox[{"(*", 
               RowBox[{"VertexRenderingFunction", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Inset", "[", 
                   RowBox[{"#2", ",", "#1"}], "]"}], "&"}], ")"}]}], "*)"}], 
              " ", 
              RowBox[{"VertexLabels", "\[Rule]", "Automatic"}], ",", 
              RowBox[{"PlotStyle", "\[Rule]", 
               RowBox[{"Directive", "[", 
                RowBox[{"PointSize", "[", "Medium", "]"}], "]"}]}], ",", 
              RowBox[{"ImageSize", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"200", ",", "200"}], "}"}]}]}], "]"}]}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"___", ",", "0"}], "]"}], ":=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"___", ",", "1"}], "]"}], ":=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"f", "[", 
          RowBox[{"m___", ",", "p_"}], "]"}], ":=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"m", ",", "p"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"m", ",", "p", ",", 
              RowBox[{"p", "-", "1"}]}], "}"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"m", ",", "p"}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"m", ",", "p", ",", 
              RowBox[{"p", "-", "2"}]}], "}"}]}], ",", 
           RowBox[{"f", "[", 
            RowBox[{"m", ",", "p", ",", 
             RowBox[{"p", "-", "1"}]}], "]"}], ",", 
           RowBox[{"f", "[", 
            RowBox[{"m", ",", "p", ",", 
             RowBox[{"p", "-", "2"}]}], "]"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", "\t", 
        RowBox[{
         RowBox[{"j", "[", "n_", "]"}], " ", ":=", " ", 
         RowBox[{
          RowBox[{"f", "[", "n", "]"}], "//", "Flatten"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"recTree", "[", "n_", "]"}], " ", ":=", 
         RowBox[{"TreePlot", "[", 
          RowBox[{
           RowBox[{"j", "[", "n", "]"}], ",", "Top", ",", 
           RowBox[{"{", "n", "}"}], ",", 
           RowBox[{"DirectedEdges", "\[Rule]", "True"}], ",", 
           RowBox[{"VertexRenderingFunction", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Inset", "[", 
               RowBox[{
                RowBox[{"Row", "[", 
                 RowBox[{"{", 
                  RowBox[{"Last", "[", "#2", "]"}], "}"}], "]"}], ",", "#1"}],
                "]"}], "&"}], ")"}]}], ",", " ", 
           RowBox[{"PlotRangePadding", "\[Rule]", "0"}], ",", " ", 
           RowBox[{"PlotStyle", "\[Rule]", 
            RowBox[{"Directive", "[", 
             RowBox[{"PointSize", "[", "Medium", "]"}], "]"}]}], ",", " ", 
           RowBox[{"AspectRatio", "\[Rule]", "0.7"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"200", ",", "200"}], "}"}]}]}], "]"}]}], ";"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       ")"}]}]}], "]"}], ",", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.774636583206933*^9, 3.774636584205966*^9}, 
   3.774636980710252*^9, {3.774637075967979*^9, 3.77463707651431*^9}, {
   3.7746371802539463`*^9, 3.774637238338737*^9}, {3.774637339871888*^9, 
   3.7746373720131807`*^9}, {3.774637491199512*^9, 3.774637524767858*^9}},
 CellLabel->"In[14]:=",ExpressionUUID->"b66f9803-5323-4dee-a12d-18f552f62711"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/obj/8a52af37-6031-4de5-b999-f69423a57dbb\"\
","https://www.wolframcloud.com/obj/8a52af37-6031-4de5-b999-f69423a57dbb"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/obj/8a52af37-6031-4de5-b999-f69423a57dbb"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{3.722524514704105*^9, 3.722524558054775*^9, 
  3.72252473206389*^9, 3.722525220235654*^9, 3.774636647190237*^9, 
  3.774636997076991*^9, 3.774637481720724*^9, 3.774637526825095*^9},
 CellLabel->"Out[14]=",ExpressionUUID->"32648653-5884-4323-b929-8207c360f333"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"fib", "[", "n0_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"num1", ",", "num2"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<declaration\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"n0", "\[Equal]", "1"}], "||", 
           RowBox[{"n0", "==", "2"}]}], ",", 
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"his", ",", 
             RowBox[{
              RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"n", "\[Rule]", "n0"}], ",", 
                RowBox[{"nn", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
            "]"}], ";", 
           RowBox[{"Return", "@", "1"}]}], ",", 
          RowBox[{
           RowBox[{"AppendTo", "[", 
            RowBox[{"his", ",", 
             RowBox[{
              RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"n", "\[Rule]", "n0"}], ",", 
                RowBox[{"nn", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
            "]"}], ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<call1\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", 
        RowBox[{"num1", "=", 
         RowBox[{"fib", "[", 
          RowBox[{"n0", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<return1\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<call2\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", 
        RowBox[{"num2", "=", 
         RowBox[{"fib", "[", 
          RowBox[{"n0", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<return2\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"his", ",", 
          RowBox[{
           RowBox[{"history", "[", "\"\<return\>\"", "]"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"n", "\[Rule]", "n0"}], ",", 
             RowBox[{"nn", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
         "]"}], ";", 
        RowBox[{"Return", "[", 
         RowBox[{"num1", "+", "num2"}], "]"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"code", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<declaration\>\"", "\[Rule]", 
        RowBox[{
        "(", "\"\<public static int fibonacci(int number)\>\"", ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<vars\>\"", "\[Rule]", 
        RowBox[{"(", "\"\<int num_minus1, num_minus2;\>\"", ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
        RowBox[{"(", "\"\<if(number == 1 || number == 2)\>\"", ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<if return\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<return \>\"", ",", 
            RowBox[{"Highlighted", "[", 
             RowBox[{
              RowBox[{"Fibonacci", "[", "1", "]"}], ",", 
              RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], ",", 
            "\"\<; //\!\(\*SubscriptBox[\(F\), \(1\)]\)=1 , \
\!\(\*SubscriptBox[\(F\), \(2\)]\)=1\>\""}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<call1\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{
          "{", "\"\<num_minus1=fibonacci(number-1); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)\>\"", "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<return1\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Highlighted", "[", 
          RowBox[{
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<\[UpArrow]\>\"", ",", "\"\<Return to \>\""}], 
             "}"}]}], ",", 
           RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<call2\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{
          "{", "\"\<num_minus2=fibonacci(number-2); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<return2\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Highlighted", "[", 
          RowBox[{
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<\[UpArrow]\>\"", ",", "\"\<Return to \>\""}], 
             "}"}]}], ",", 
           RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<return\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{
          "{", "\"\<return num_minus1+num_minus2;   \
//\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)+\!\(\*SubscriptBox[\(F\), \(n - 2\)]\
\)\>\"", "}"}]}], ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "|>"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"listing", "=", 
     RowBox[{"Column", "@", 
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
       "\"\<public static int fibonacci(int number){\>\"", ",", 
        "\[IndentingNewLine]", "\"\<int num_minus1, num_minus2;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<if(number == 1 || number == 2){\>\"", ",",
         "\[IndentingNewLine]", "\"\<return 1;\>\"", ",", 
        "\[IndentingNewLine]", "\"\<}\>\"", ",", "\[IndentingNewLine]", 
        "\"\<num_minus1=fibonacci(number-1); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)\>\"", ",", "\[IndentingNewLine]", 
        "\"\<num_minus2=fibonacci(number-2); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", ",", "\[IndentingNewLine]", 
        "\"\<return num_minus1+num_minus2;   //\!\(\*SubscriptBox[\(F\), \(n \
- 1\)]\)+\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", ",", 
        "\[IndentingNewLine]", "\"\<}\>\""}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "}"}]}]}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"history", "=", 
     RowBox[{"<|", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<declaration\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
            RowBox[{"code", "[", "\"\<declaration\>\"", "]"}], ",", 
            "\"\<: \>\"", ",", "\"\<number\>\"", ",", "\"\<=\>\"", ",", 
            RowBox[{"Highlighted", "@", "n"}]}], " ", "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
            RowBox[{"code", "[", "\"\<if boolean\>\"", "]"}], ",", " ", 
            "\"\<: \>\"", ",", " ", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"n", "\[Equal]", "1"}], "||", 
               RowBox[{"n", "\[Equal]", "2"}]}], ",", " ", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"\"\<True, \>\"", ",", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"code", "[", "\"\<if return\>\"", "]"}], "}"}]}]}],
                 "}"}]}], ",", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<False, \>\"", ",", 
                 "\"\<Do nothing! Go to next line\>\""}], "}"}]}]}], "]"}]}], 
           "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<call1\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
            RowBox[{"code", "[", "\"\<call1\>\"", "]"}], ",", " ", 
            "\"\<: \>\"", ",", "\"\<Call fibonacci(int number)\>\"", ",", 
            " ", "\"\<, number\>\"", ",", "\"\<=\>\"", ",", " ", "n", ",", 
            "\"\<-\>\"", ",", "1", ",", "\"\<=\>\"", ",", 
            RowBox[{"Highlighted", "[", 
             RowBox[{"n", "-", "1"}], "]"}]}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<return1\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"code", "[", "\"\<return1\>\"", "]"}], ",", 
            "\"\<Level-\>\"", ",", "nn"}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<call2\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
            RowBox[{"code", "[", "\"\<call2\>\"", "]"}], ",", " ", 
            "\"\<: \>\"", ",", "\"\<Call fibonacci(int number)\>\"", ",", 
            " ", "\"\<, number\>\"", ",", "\"\<=\>\"", ",", " ", "n", ",", 
            "\"\<-\>\"", ",", "2", ",", "\"\<=\>\"", ",", " ", 
            RowBox[{"Highlighted", "[", 
             RowBox[{"n", "-", "2"}], "]"}]}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<return2\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"code", "[", "\"\<return2\>\"", "]"}], ",", 
            "\"\<Level-\>\"", ",", "nn"}], "}"}]}], ")"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<return\>\"", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"Row", "@", 
          RowBox[{"{", 
           RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
            RowBox[{"code", "[", "\"\<return\>\"", "]"}], " ", ",", 
            "\"\<: \>\"", ",", 
            RowBox[{"Subscript", "[", 
             RowBox[{"\"\<F\>\"", ",", 
              RowBox[{"n", "-", "1"}]}], "]"}], ",", "\"\<+\>\"", ",", 
            RowBox[{"Subscript", "[", 
             RowBox[{"\"\<F\>\"", ",", 
              RowBox[{"n", "-", "2"}]}], "]"}], ",", "\"\<=\>\"", ",", 
            RowBox[{"Highlighted", "[", 
             RowBox[{
              RowBox[{"Fibonacci", "[", "n", "]"}], ",", 
              RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], 
           "}"}]}], ")"}]}]}], "\[IndentingNewLine]", "|>"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.722568524722081*^9, 3.7225685251542177`*^9}, {
   3.72256862945551*^9, 3.722568756447343*^9}, {3.7225688288201017`*^9, 
   3.722569520965733*^9}, {3.722569551993556*^9, 3.722569661581897*^9}, {
   3.722569760202141*^9, 3.7225701840416737`*^9}, {3.7225702624128*^9, 
   3.7225703753777113`*^9}, {3.722570411513667*^9, 3.7225704837132*^9}, {
   3.722570569664661*^9, 3.722570596596745*^9}, {3.722570638346079*^9, 
   3.7225706791850367`*^9}, {3.72257079966503*^9, 3.72257080815766*^9}, {
   3.722570844835511*^9, 3.7225708507721777`*^9}, {3.722570887391553*^9, 
   3.722570910533877*^9}, {3.722571095858129*^9, 3.722571176017757*^9}, {
   3.722571236846436*^9, 3.722571296621236*^9}, {3.722571351272009*^9, 
   3.722571360373263*^9}, {3.7225714409011383`*^9, 3.722571458832212*^9}, {
   3.722571501058476*^9, 3.72257165229356*^9}, {3.722571704169402*^9, 
   3.722571719567032*^9}, {3.7225717637932*^9, 3.722571774065518*^9}, {
   3.722571886892975*^9, 3.7225718898623333`*^9}, {3.7225719311500063`*^9, 
   3.722571951516551*^9}, {3.722572166156806*^9, 3.722572292144923*^9}, {
   3.722574278232284*^9, 3.7225742860730257`*^9}, {3.72257437256242*^9, 
   3.722574386478443*^9}, {3.722574422300644*^9, 3.722574467682329*^9}, {
   3.722574691460351*^9, 3.7225746918070173`*^9}, 3.722574765755567*^9, {
   3.7225748964721107`*^9, 3.7225750640317917`*^9}, {3.7225750998516808`*^9, 
   3.7225751056227407`*^9}},ExpressionUUID->"56d0cbc8-a39c-4e54-b3a7-\
b52358eff503"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"his", "=", 
     RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"arg", "=", "5"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"fib", "[", "arg", "]"}], "\[IndentingNewLine]", 
   "listing"}]}]], "Input",
 CellChangeTimes->{{3.722570488949432*^9, 3.722570501824746*^9}, {
   3.722571367469503*^9, 3.72257137430976*^9}, 3.7225717934245977`*^9, {
   3.722574265875043*^9, 3.722574290513671*^9}, {3.72257478086224*^9, 
   3.722574799909039*^9}, {3.7225750526106443`*^9, 
   3.72257505352146*^9}},ExpressionUUID->"ceacb302-2292-44e9-bfdb-\
50c2d90b6a23"],

Cell[BoxData["8"], "Output",
 CellChangeTimes->{
  3.722570504098481*^9, {3.722570574966989*^9, 3.7225706049068813`*^9}, 
   3.722570682347522*^9, 3.722570814738146*^9, 3.7225708535838413`*^9, 
   3.7225709134068403`*^9, 3.7225711790525713`*^9, 3.722571303079081*^9, 
   3.722571375062063*^9, 3.722571657316451*^9, 3.72257172262394*^9, {
   3.722571777820219*^9, 3.722571793806403*^9}, 3.7225718939627657`*^9, {
   3.722571944360949*^9, 3.7225719540153913`*^9}, {3.722572276677607*^9, 
   3.722572294349678*^9}, 3.7225741151509457`*^9, 3.722574291844919*^9, 
   3.722574398138997*^9, {3.722574450858583*^9, 3.722574470713538*^9}, 
   3.722574698484696*^9, {3.722574771924898*^9, 3.722574800262636*^9}, {
   3.722575053826775*^9, 3.722575066673192*^9}, 
   3.722575108579576*^9},ExpressionUUID->"281dd7e9-49ca-44d0-8865-\
21779b0a15e7"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"public static int fibonacci(int number){\"\>"},
    {"\<\"int num_minus1, num_minus2;\"\>"},
    {"\<\"if(number == 1 || number == 2){\"\>"},
    {"\<\"return 1;\"\>"},
    {"\<\"}\"\>"},
    {"\<\"num_minus1=fibonacci(number-1); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 1\\)]\\)\"\>"},
    {"\<\"num_minus2=fibonacci(number-2); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\"\>"},
    {"\<\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\"\>"},
    {"\<\"}\"\>"}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.722570504098481*^9, {3.722570574966989*^9, 3.7225706049068813`*^9}, 
   3.722570682347522*^9, 3.722570814738146*^9, 3.7225708535838413`*^9, 
   3.7225709134068403`*^9, 3.7225711790525713`*^9, 3.722571303079081*^9, 
   3.722571375062063*^9, 3.722571657316451*^9, 3.72257172262394*^9, {
   3.722571777820219*^9, 3.722571793806403*^9}, 3.7225718939627657`*^9, {
   3.722571944360949*^9, 3.7225719540153913`*^9}, {3.722572276677607*^9, 
   3.722572294349678*^9}, 3.7225741151509457`*^9, 3.722574291844919*^9, 
   3.722574398138997*^9, {3.722574450858583*^9, 3.722574470713538*^9}, 
   3.722574698484696*^9, {3.722574771924898*^9, 3.722574800262636*^9}, {
   3.722575053826775*^9, 3.722575066673192*^9}, 
   3.722575108592613*^9},ExpressionUUID->"9f1dc7c7-fb05-497d-ac85-\
5f3818f756ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Column", "@", "his"}]], "Input",
 CellChangeTimes->{{3.722570505812435*^9, 
  3.7225705114317207`*^9}},ExpressionUUID->"7051a40d-328d-4ef5-abec-\
ee671e96b8d2"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"Level-\"","1","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"5", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","1","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","1","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","5","\"-\"",
       "1","\"=\"",TemplateBox[{"4", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"4", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","4","\"-\"",
       "1","\"=\"",TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "1","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "2","\"=\"",TemplateBox[{"1", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "2"],"\"+\"",
       SubscriptBox["\"F\"", "1"],"\"=\"",
       TemplateBox[{
        "2", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","2"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","4","\"-\"",
       "2","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "1","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "2","\"=\"",TemplateBox[{"1", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "2"],"\"+\"",
       SubscriptBox["\"F\"", "1"],"\"=\"",
       TemplateBox[{
        "2", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","2"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "3"],"\"+\"",
       SubscriptBox["\"F\"", "2"],"\"=\"",
       TemplateBox[{
        "3", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","1"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","1","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","5","\"-\"",
       "2","\"=\"",TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"4", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","4","\"-\"",
       "1","\"=\"",TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "1","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "2","\"=\"",TemplateBox[{"1", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "2"],"\"+\"",
       SubscriptBox["\"F\"", "1"],"\"=\"",
       TemplateBox[{
        "2", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","2"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","4","\"-\"",
       "2","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
        "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus1=fibonacci(number-1); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "1","\"=\"",TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"num_minus2=fibonacci(number-2); //recursion \\!\\(\\*SubscriptBox[\
\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
       "\"Call fibonacci(int number)\"","\", number\"","\"=\"","3","\"-\"",
       "2","\"=\"",TemplateBox[{"1", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"public static int fibonacci(int number)\"",
       "\": \"","\"number\"","\"=\"",
       TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","4","\": \"","\"if(number == 1 || number == 2)\"","\": \"",
       TemplateBox[{"\"True, \"", 
         TemplateBox[{
           TemplateBox[{"\"return \"", 
             
             TemplateBox[{
              "1", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]},
               "Highlighted"], 
             "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \
\\!\\(\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, 
          "RowDefault"]}, "RowDefault"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","3"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","3","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "2"],"\"+\"",
       SubscriptBox["\"F\"", "1"],"\"=\"",
       TemplateBox[{
        "2", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","2"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","2","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "3"],"\"+\"",
       SubscriptBox["\"F\"", "2"],"\"=\"",
       TemplateBox[{
        "3", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]},
    {
     TemplateBox[{TemplateBox[{
         TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
         FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
        "Highlighted"],"\"Level-\"","1"},
      "RowDefault"]},
    {
     TemplateBox[{
      "\"Level-\"","1","\": \"",
       TemplateBox[{
        "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, 
        "RowDefault"],"\": \"",SubscriptBox["\"F\"", "4"],"\"+\"",
       SubscriptBox["\"F\"", "3"],"\"=\"",
       TemplateBox[{
        "5", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
        "Highlighted"]},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.722570506999127*^9, 3.7225705128754177`*^9}, {
   3.722570576083646*^9, 3.7225706058537827`*^9}, 3.722570683427918*^9, 
   3.7225708167684793`*^9, 3.722570855701357*^9, 3.7225709147525806`*^9, 
   3.7225711801547194`*^9, 3.722571303906837*^9, 3.722571377595888*^9, 
   3.722571658381753*^9, 3.7225717239021606`*^9, {3.722571778619288*^9, 
   3.72257179634055*^9}, 3.722571896394518*^9, {3.7225719453790903`*^9, 
   3.7225719555739202`*^9}, {3.722572278708035*^9, 3.722572295217298*^9}, 
   3.7225741177807817`*^9, 3.722574294888878*^9, 3.722574399225589*^9, {
   3.722574451756763*^9, 3.7225744715279512`*^9}, 3.7225746991868753`*^9, {
   3.722574774388364*^9, 3.7225748025193872`*^9}, 
   3.7225751111302147`*^9},ExpressionUUID->"b8d0aeb8-65e8-4345-bc31-\
193a2cb4bd5e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fibhistory", "[", "arg0_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "arg", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"arg", "=", 
       RowBox[{"ToExpression", "@", "arg0"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fib", "[", "n0_", "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"num1", ",", "num2"}], "}"}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<declaration\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"n0", "\[Equal]", "1"}], "||", 
             RowBox[{"n0", "==", "2"}]}], ",", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{
                RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"n", "\[Rule]", "n0"}], ",", 
                  RowBox[{"nn", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], 
                 "}"}]}]}], "]"}], ";", 
             RowBox[{"Return", "@", "1"}]}], ",", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{
                RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"n", "\[Rule]", "n0"}], ",", 
                  RowBox[{"nn", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], 
                 "}"}]}]}], "]"}], ";"}]}], "]"}], ";", "\[IndentingNewLine]",
           "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<call1\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", 
          RowBox[{"num1", "=", 
           RowBox[{"fib", "[", 
            RowBox[{"n0", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<return1\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<call2\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", 
          RowBox[{"num2", "=", 
           RowBox[{"fib", "[", 
            RowBox[{"n0", "-", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<return2\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<return\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"n", "\[Rule]", "n0"}], ",", 
               RowBox[{"nn", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"arg", "-", "n0", "+", "1"}], ")"}]}]}], "}"}]}]}], 
           "]"}], ";", 
          RowBox[{"Return", "[", 
           RowBox[{"num1", "+", "num2"}], "]"}]}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"code", "=", 
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<declaration\>\"", "\[Rule]", 
          RowBox[{
          "(", "\"\<public static int fibonacci(int number)\>\"", ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<vars\>\"", "\[Rule]", 
          RowBox[{"(", "\"\<int num_minus1, num_minus2;\>\"", ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
          RowBox[{"(", "\"\<if(number == 1 || number == 2)\>\"", ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<if return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<return \>\"", ",", 
              RowBox[{"Highlighted", "[", 
               RowBox[{
                RowBox[{"Fibonacci", "[", "1", "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
              ",", "\"\<; //\!\(\*SubscriptBox[\(F\), \(1\)]\)=1 , \
\!\(\*SubscriptBox[\(F\), \(2\)]\)=1\>\""}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<call1\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{
            "{", "\"\<num_minus1=fibonacci(number-1); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)\>\"", "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<return1\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Highlighted", "[", 
            RowBox[{
             RowBox[{"Row", "@", 
              RowBox[{"{", 
               RowBox[{"\"\<\[UpArrow]\>\"", ",", "\"\<Return to \>\""}], 
               "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<call2\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{
            "{", "\"\<num_minus2=fibonacci(number-2); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<return2\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Highlighted", "[", 
            RowBox[{
             RowBox[{"Row", "@", 
              RowBox[{"{", 
               RowBox[{"\"\<\[UpArrow]\>\"", ",", "\"\<Return to \>\""}], 
               "}"}]}], ",", 
             RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{
            "{", "\"\<return num_minus1+num_minus2;   \
//\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)+\!\(\*SubscriptBox[\(F\), \(n - 2\)]\
\)\>\"", "}"}]}], ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "|>"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"listing", "=", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
         "\"\<public static int fibonacci(int number){\>\"", ",", 
          "\[IndentingNewLine]", "\"\<int num_minus1, num_minus2;\>\"", ",", 
          "\[IndentingNewLine]", "\"\<if(number == 1 || number == 2){\>\"", 
          ",", "\[IndentingNewLine]", "\"\<return 1;\>\"", ",", 
          "\[IndentingNewLine]", "\"\<}\>\"", ",", "\[IndentingNewLine]", 
          "\"\<num_minus1=fibonacci(number-1); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 1\)]\)\>\"", ",", "\[IndentingNewLine]", 
          "\"\<num_minus2=fibonacci(number-2); //recursion \
\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", ",", "\[IndentingNewLine]", 
          "\"\<return num_minus1+num_minus2;   //\!\(\*SubscriptBox[\(F\), \
\(n - 1\)]\)+\!\(\*SubscriptBox[\(F\), \(n - 2\)]\)\>\"", ",", 
          "\[IndentingNewLine]", "\"\<}\>\""}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"history", "=", 
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<declaration\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
              RowBox[{"code", "[", "\"\<declaration\>\"", "]"}], ",", 
              "\"\<: \>\"", ",", "\"\<number\>\"", ",", "\"\<=\>\"", ",", 
              RowBox[{"Highlighted", "@", "n"}]}], " ", "}"}]}], ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
              RowBox[{"code", "[", "\"\<if boolean\>\"", "]"}], ",", " ", 
              "\"\<: \>\"", ",", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"n", "\[Equal]", "1"}], "||", 
                 RowBox[{"n", "\[Equal]", "2"}]}], ",", " ", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<True, \>\"", ",", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"code", "[", "\"\<if return\>\"", "]"}], 
                    "}"}]}]}], "}"}]}], ",", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<False, \>\"", ",", 
                   "\"\<Do nothing! Go to next line\>\""}], "}"}]}]}], 
               "]"}]}], "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<call1\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
              RowBox[{"code", "[", "\"\<call1\>\"", "]"}], ",", " ", 
              "\"\<: \>\"", ",", 
              "\"\<\\n\[ReturnIndicator]Call fibonacci(int number)\>\"", ",", 
              " ", "\"\<, number\>\"", ",", "\"\<=\>\"", ",", " ", "n", ",", 
              "\"\<-\>\"", ",", "1", ",", "\"\<=\>\"", ",", 
              RowBox[{"Highlighted", "[", 
               RowBox[{"n", "-", "1"}], "]"}]}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<return1\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"code", "[", "\"\<return1\>\"", "]"}], ",", 
              "\"\<Level-\>\"", ",", "nn"}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<call2\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
              RowBox[{"code", "[", "\"\<call2\>\"", "]"}], ",", " ", 
              "\"\<: \>\"", ",", 
              "\"\<\\n\[ReturnIndicator]Call fibonacci(int number)\>\"", ",", 
              " ", "\"\<, number\>\"", ",", "\"\<=\>\"", ",", " ", "n", ",", 
              "\"\<-\>\"", ",", "2", ",", "\"\<=\>\"", ",", " ", 
              RowBox[{"Highlighted", "[", 
               RowBox[{"n", "-", "2"}], "]"}]}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<return2\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"code", "[", "\"\<return2\>\"", "]"}], ",", 
              "\"\<Level-\>\"", ",", "nn"}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Level-\>\"", ",", "nn", ",", "\"\<: \>\"", ",", 
              RowBox[{"code", "[", "\"\<return\>\"", "]"}], " ", ",", 
              "\"\<: \>\"", ",", 
              RowBox[{"Subscript", "[", 
               RowBox[{"\"\<F\>\"", ",", 
                RowBox[{"n", "-", "1"}]}], "]"}], ",", "\"\<+\>\"", ",", 
              RowBox[{"Subscript", "[", 
               RowBox[{"\"\<F\>\"", ",", 
                RowBox[{"n", "-", "2"}]}], "]"}], ",", "\"\<=\>\"", ",", 
              RowBox[{"Highlighted", "[", 
               RowBox[{
                RowBox[{"Fibonacci", "[", "n", "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}]}], 
             "}"}]}], ")"}]}]}], "\[IndentingNewLine]", "|>"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"his", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Column", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Highlighted", "[", 
          RowBox[{"listing", ",", 
           RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"fib", "[", "arg", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Column", "@", "his"}]}]}], "\[IndentingNewLine]", 
        "}"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.7225751720769978`*^9, 3.722575279339911*^9}, {
  3.722575317858724*^9, 3.722575389377108*^9}, {3.722575523681439*^9, 
  3.722575539680303*^9}, {3.722575673612767*^9, 3.722575676953422*^9}, {
  3.722575723754204*^9, 
  3.722575730384425*^9}},ExpressionUUID->"203a959e-0abe-42f7-b73c-\
a1080a46bec5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fibhistory", "[", "\"\<3\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.722575293297258*^9, 3.722575311082926*^9}, {
  3.722575545447044*^9, 
  3.722575546447837*^9}},ExpressionUUID->"5d647a0f-b491-4b0b-9477-\
3d6d9a60b0a8"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{TagBox[
        GridBox[{{"\"public static int fibonacci(int number){\""}, {
          "\"int num_minus1, num_minus2;\""}, {
          "\"if(number == 1 || number == 2){\""}, {"\"return 1;\""}, {
          "\"}\""}, {
          "\"num_minus1=fibonacci(number-1); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 1\\)]\\)\""}, {
          "\"num_minus2=fibonacci(number-2); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, {
          "\"return num_minus1+num_minus2;   //\\!\\(\\*SubscriptBox[\\(F\\), \
\\(n - 1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, {
          "\"}\""}}, GridBoxAlignment -> {"Columns" -> {{Left}}}, 
         DefaultBaseStyle -> "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"],
       FrameStyle -> None,Background -> RGBColor[0.87, 0.94, 1]},
      "Highlighted"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          "\"Level-\"","1","\": \"",
           "\"public static int fibonacci(int number)\"","\": \"",
           "\"number\"","\"=\"",
           TemplateBox[{"3", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","1","\": \"","\"if(number == 1 || number == 2)\"",
           "\": \"",
           TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
            "RowDefault"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","1","\": \"",
           TemplateBox[{
            "\"num_minus1=fibonacci(number-1); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 1\\)]\\)\""}, "RowDefault"],"\": \"",
           "\"\\n\[ReturnIndicator]Call fibonacci(int number)\"",
           "\", number\"","\"=\"","3","\"-\"","1","\"=\"",
           TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","2","\": \"",
           "\"public static int fibonacci(int number)\"","\": \"",
           "\"number\"","\"=\"",
           TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","2","\": \"","\"if(number == 1 || number == 2)\"",
           "\": \"",TemplateBox[{"\"True, \"", 
             TemplateBox[{
               TemplateBox[{"\"return \"", 
                 
                 TemplateBox[{
                  "1", FrameStyle -> None, Background -> 
                   RGBColor[0.88, 1, 0.88]}, "Highlighted"], 
                 "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \\!\\(\
\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, "RowDefault"]}, 
            "RowDefault"]},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
             FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
            "Highlighted"],"\"Level-\"","1"},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","1","\": \"",
           TemplateBox[{
            "\"num_minus2=fibonacci(number-2); //recursion \
\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],"\": \"",
           "\"\\n\[ReturnIndicator]Call fibonacci(int number)\"",
           "\", number\"","\"=\"","3","\"-\"","2","\"=\"",
           TemplateBox[{"1", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","2","\": \"",
           "\"public static int fibonacci(int number)\"","\": \"",
           "\"number\"","\"=\"",
           TemplateBox[{"2", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","2","\": \"","\"if(number == 1 || number == 2)\"",
           "\": \"",TemplateBox[{"\"True, \"", 
             TemplateBox[{
               TemplateBox[{"\"return \"", 
                 
                 TemplateBox[{
                  "1", FrameStyle -> None, Background -> 
                   RGBColor[0.88, 1, 0.88]}, "Highlighted"], 
                 "\"; //\\!\\(\\*SubscriptBox[\\(F\\), \\(1\\)]\\)=1 , \\!\\(\
\\*SubscriptBox[\\(F\\), \\(2\\)]\\)=1\""}, "RowDefault"]}, "RowDefault"]}, 
            "RowDefault"]},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"\[UpArrow]\"", "\"Return to \""}, "RowDefault"], 
             FrameStyle -> None, Background -> RGBColor[1, 0.5, 0.5]}, 
            "Highlighted"],"\"Level-\"","1"},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Level-\"","1","\": \"",
           TemplateBox[{
            "\"return num_minus1+num_minus2;   \
//\\!\\(\\*SubscriptBox[\\(F\\), \\(n - \
1\\)]\\)+\\!\\(\\*SubscriptBox[\\(F\\), \\(n - 2\\)]\\)\""}, "RowDefault"],
           "\": \"",SubscriptBox["\"F\"", "2"],"\"+\"",SubscriptBox[
           "\"F\"", "1"],"\"=\"",
           TemplateBox[{
            "2", FrameStyle -> None, Background -> RGBColor[0.88, 1, 0.88]}, 
            "Highlighted"]},
          "RowDefault"]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.7225752935963993`*^9, 3.722575338198153*^9}, {
   3.7225753764911757`*^9, 3.722575392334091*^9}, 3.722575546682973*^9, 
   3.72257568103407*^9, 
   3.7225757346389303`*^9},ExpressionUUID->"36380fbe-d7c8-4ab8-980f-\
787aa6410aa7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormFunction", "@@", 
    RowBox[{"APIFunction", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<n\>\"", "->", 
        RowBox[{"<|", 
         RowBox[{"\"\<Input\>\"", "->", "\"\<3\>\""}], "|>"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{
       RowBox[{"fibhistory", "[", "#n", "]"}], "&"}], ",", "\"\<PDF\>\"", ",", 
      RowBox[{"AppearanceRules", "\[Rule]", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Fibonacci: Recursion History\>\"", ",", "Black", ",", 
            "Bold"}], "]"}]}], ",", 
         RowBox[{"\"\<Description\>\"", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Computes the history of computations for recursion\>\"", ",", 
            "Bold", ",", "Orange"}], "]"}]}], ",", 
         RowBox[{
         "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", 
          "\"\<Get Recursion!\>\""}]}], "|>"}]}]}], "]"}]}], ",", " ", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.722575408477954*^9, 3.722575512450069*^9}, {
  3.7225755635050077`*^9, 
  3.722575600134781*^9}},ExpressionUUID->"59f6faf6-f584-4a0d-bb3a-\
eea54964c7d2"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/fc842609-2142-45ef-aea1-\
e13a40a8e012\"",
     "https://www.wolframcloud.com/objects/fc842609-2142-45ef-aea1-\
e13a40a8e012"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/fc842609-2142-45ef-aea1-e13a40a8e012"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{{3.722575552527842*^9, 3.7225755713707857`*^9}, 
   3.7225756092852592`*^9, 
   3.722575749755275*^9},ExpressionUUID->"03359de0-6df6-453e-a1d7-\
11fd5a94fc02"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"fibloophistory", "[", "arg0_", "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"arg", ",", "number"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"number", "=", 
       RowBox[{"ToExpression", "@", "arg0"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"fibloop", "[", "number_", "]"}], ":=", 
       RowBox[{"Module", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"fibo1", "=", "1"}], ",", 
           RowBox[{"fibo2", "=", "1"}], ",", 
           RowBox[{"fibonacci", "=", "1"}], ",", "i"}], "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<declaration\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{"n", "\[Rule]", "number"}], "}"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"number", "\[Equal]", "1"}], "||", 
             RowBox[{"number", "==", "2"}]}], ",", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{
                RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{"n", "\[Rule]", "number"}], "}"}]}]}], "]"}], ";", 
             RowBox[{"Return", "@", "1"}]}], ",", 
            RowBox[{
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{
                RowBox[{"history", "[", "\"\<if boolean\>\"", "]"}], "/.", 
                RowBox[{"{", 
                 RowBox[{"n", "\[Rule]", "number"}], "}"}]}]}], "]"}], 
             ";"}]}], "]"}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{
             RowBox[{"history", "[", "\"\<for\>\"", "]"}], "/.", 
             RowBox[{"{", 
              RowBox[{"n", "\[Rule]", "number"}], "}"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Highlighted", "[", 
                RowBox[{"\"\<fibonacci\>\"", ",", 
                 RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
               ",", "\"\<=\>\"", ",", "fibonacci", ",", "\"\<, \>\"", ",", 
               ",", "\"\<fibo1\>\"", ",", "\"\<=\>\"", ",", "fibo1", ",", 
               "\"\<, \>\"", ",", "\"\<fibo2\>\"", ",", "\"\<=\>\"", ",", 
               "fibo2"}], "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"i", "=", "3"}], ",", 
            RowBox[{"i", "\[LessEqual]", "number"}], ",", 
            RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"i", "==", "3"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"his", ",", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"\"\<Iteration \>\"", ",", 
                    RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ",", 
                    RowBox[{"i", "-", "2"}], ",", "\"\<, \>\"", ",", 
                    RowBox[{"Highlighted", "@", "\"\<i\>\""}], ",", 
                    "\"\<=\>\"", ",", "i", ",", " ", "\"\< initial i\>\""}], 
                   "}"}]}]}], "]"}], ",", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"his", ",", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Highlighted", "[", 
                    RowBox[{"\"\<Iteration \>\"", ",", 
                    RowBox[{"Background", "\[Rule]", "Pink"}]}], "]"}], ",", 
                    RowBox[{"i", "-", "2"}], ",", "\"\<, \>\"", ",", 
                    RowBox[{"Highlighted", "@", "\"\<i++\>\""}], ",", 
                    "\"\<=\>\"", ",", "i", ",", " ", 
                    "\"\< new incremented i\>\""}], "}"}]}]}], "]"}]}], "]"}],
              ";", "\[IndentingNewLine]", 
             RowBox[{"fibonacci", "=", 
              RowBox[{"fibo1", "+", "fibo2"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"history", "[", "\"\<for1\>\"", "]"}], "/.", 
                   RowBox[{"{", 
                    RowBox[{"n", "\[Rule]", "number"}], "}"}]}], ",", 
                  "\"\<  \>\"", ",", 
                  RowBox[{"Highlighted", "[", 
                   RowBox[{"\"\<fibonacci\>\"", ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
                  ",", "\"\<=\>\"", ",", "fibonacci", ",", "\"\<, \>\"", ",", 
                  ",", "\"\<fibo1\>\"", ",", "\"\<=\>\"", ",", "fibo1", ",", 
                  "\"\<, \>\"", ",", "\"\<fibo2\>\"", ",", "\"\<=\>\"", ",", 
                  "fibo2"}], "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"fibo1", "=", "fibo2"}], ";", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"history", "[", "\"\<for2\>\"", "]"}], "/.", 
                   RowBox[{"{", 
                    RowBox[{"n", "\[Rule]", "number"}], "}"}]}], ",", 
                  "\"\<  \>\"", ",", 
                  RowBox[{"Highlighted", "[", 
                   RowBox[{"\"\<fibonacci\>\"", ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
                  ",", "\"\<=\>\"", ",", "fibonacci", ",", "\"\<, \>\"", ",", 
                  ",", "\"\<fibo1\>\"", ",", "\"\<=\>\"", ",", "fibo1", ",", 
                  "\"\<, \>\"", ",", "\"\<fibo2\>\"", ",", "\"\<=\>\"", ",", 
                  "fibo2"}], "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"fibo2", "=", "fibonacci"}], ";", "\[IndentingNewLine]", 
             
             RowBox[{"AppendTo", "[", 
              RowBox[{"his", ",", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"history", "[", "\"\<for3\>\"", "]"}], "/.", 
                   RowBox[{"{", 
                    RowBox[{"n", "\[Rule]", "number"}], "}"}]}], ",", 
                  "\"\<  \>\"", ",", 
                  RowBox[{"Highlighted", "[", 
                   RowBox[{"\"\<fibonacci\>\"", ",", 
                    RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
                  ",", "\"\<=\>\"", ",", "fibonacci", ",", "\"\<, \>\"", ",", 
                  ",", "\"\<fibo1\>\"", ",", "\"\<=\>\"", ",", "fibo1", ",", 
                  "\"\<, \>\"", ",", "\"\<fibo2\>\"", ",", "\"\<=\>\"", ",", 
                  "fibo2"}], "}"}]}]}], "]"}], ";"}]}], "\[IndentingNewLine]",
            "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"his", ",", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"history", "[", "\"\<return\>\"", "]"}], ",", 
               "\"\<, \>\"", ",", 
               RowBox[{"Highlighted", "[", 
                RowBox[{"\"\<fibonacci\>\"", ",", 
                 RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
               ",", "\"\<=\>\"", ",", "fibonacci"}], "}"}]}]}], "]"}], ";", 
          "fibonacci"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"code", "=", 
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<declaration\>\"", "\[Rule]", 
          RowBox[{
          "(", "\"\<public static int fibonacciLoop(int number)\>\"", ")"}]}],
          ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<vars\>\"", "\[Rule]", 
          RowBox[{
          "(", "\"\<int fibo1 = 1, fibo2 = 1, fibonacci = 1;\>\"", ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
          RowBox[{"(", "\"\<if(number == 1 || number == 2)\>\"", ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<if return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<return \>\"", ",", 
              RowBox[{"Highlighted", "[", 
               RowBox[{
                RowBox[{"Fibonacci", "[", "1", "]"}], ",", 
                RowBox[{"Background", "\[Rule]", "LightGreen"}]}], "]"}], 
              ",", "\"\<; //\!\(\*SubscriptBox[\(F\), \(1\)]\)=1 , \
\!\(\*SubscriptBox[\(F\), \(2\)]\)=1\>\""}], "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<for\>\"", "->", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", "\"\<for (int i = 3; i <= number; i++)\>\"", "}"}]}],
            ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<for1\>\"", "->", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", "\"\<fibonacci = fibo1 + fibo2;\>\"", "}"}]}], 
           ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<for2\>\"", "->", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", "\"\<fibo1 = fibo2;\>\"", "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<for3\>\"", "->", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", "\"\<fibo2 = fibonacci;\>\"", "}"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", "\"\<return fibonacci;\>\"", "}"}]}], ")"}]}]}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"listing", "=", 
       RowBox[{"Column", "@", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
         "\"\<public static int fibonacciLoop(int number) {\>\"", ",", 
          "\[IndentingNewLine]", "\"\<if (number == 1 || number == 2) {\>\"", 
          ",", "\[IndentingNewLine]", "\"\<    return 1;\>\"", ",", 
          "\[IndentingNewLine]", "\"\<}\>\"", ",", "\[IndentingNewLine]", 
          "\"\<int fibo1 = 1, fibo2 = 1, fibonacci = 1;\>\"", ",", 
          "\[IndentingNewLine]", 
          "\"\<for (int i = 3; i <= number; i++) {\>\"", ",", 
          "\[IndentingNewLine]", "\"\<     fibonacci = fibo1 + fibo2;\>\"", 
          ",", "\[IndentingNewLine]", "\"\<     fibo1 = fibo2;\>\"", ",", 
          "\[IndentingNewLine]", "\"\<     fibo2 = fibonacci;\>\"", ",", 
          "\[IndentingNewLine]", "\"\<}\>\"", ",", "\[IndentingNewLine]", 
          "\"\<return fibonacci;\>\"", ",", "\[IndentingNewLine]", 
          "\"\<}\>\""}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "}"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"history", "=", 
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<declaration\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"code", "[", "\"\<declaration\>\"", "]"}], ",", 
              "\"\<: \>\"", ",", "\"\<number\>\"", ",", "\"\<=\>\"", ",", 
              RowBox[{"Highlighted", "@", "n"}]}], " ", "}"}]}], ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"\"\<if boolean\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"code", "[", "\"\<if boolean\>\"", "]"}], ",", " ", 
              "\"\<: \>\"", ",", " ", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"n", "\[Equal]", "1"}], "||", 
                 RowBox[{"n", "\[Equal]", "2"}]}], ",", " ", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"\"\<True, \>\"", ",", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"code", "[", "\"\<if return\>\"", "]"}], 
                    "}"}]}]}], "}"}]}], ",", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<False, \>\"", ",", 
                   "\"\<Do nothing! Go to next line\>\""}], "}"}]}]}], 
               "]"}]}], "}"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<for\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"\"\<Enter Loop: \>\"", ",", " ", 
              RowBox[{"code", "[", "\"\<for\>\"", "]"}], ",", "\"\<, \>\"", 
              ",", 
              RowBox[{"Highlighted", "@", "\"\<i=3\>\""}]}], "}"}]}], ")"}]}],
          ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<for1\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"code", "[", "\"\<for1\>\"", "]"}], "}"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<for2\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"code", "[", "\"\<for2\>\"", "]"}], "}"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"\"\<for3\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"code", "[", "\"\<for3\>\"", "]"}], "}"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<return\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Row", "@", 
            RowBox[{"{", 
             RowBox[{"code", "[", "\"\<return\>\"", "]"}], "}"}]}], ")"}]}]}],
         "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"his", "=", 
       RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Column", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Highlighted", "[", 
          RowBox[{"listing", ",", 
           RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"fibloop", "[", "number", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Column", "@", "his"}]}]}], "\[IndentingNewLine]", 
        "}"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.7225751720769978`*^9, 3.722575279339911*^9}, {
   3.722575317858724*^9, 3.722575389377108*^9}, {3.722575523681439*^9, 
   3.722575539680303*^9}, {3.722575673612767*^9, 3.722575676953422*^9}, {
   3.722575723754204*^9, 3.722575730384425*^9}, {3.722590320443766*^9, 
   3.722590323559918*^9}, {3.7225903590674973`*^9, 3.7225904784111567`*^9}, {
   3.722590549269718*^9, 3.722590666016974*^9}, {3.722590698900236*^9, 
   3.722590815125967*^9}, {3.722590868464299*^9, 3.722590874898141*^9}, 
   3.7225909074574137`*^9, 3.722590948936645*^9, {3.7225915557844276`*^9, 
   3.722591788065084*^9}, {3.722591821367618*^9, 3.722591935668076*^9}, {
   3.7225919664982967`*^9, 3.722591993943988*^9}, {3.7225920372020607`*^9, 
   3.7225921770003967`*^9}, {3.7225923332547894`*^9, 3.722592515965386*^9}, {
   3.722592560031831*^9, 3.722592684158411*^9}, {3.722592735086308*^9, 
   3.722592754154395*^9}, 3.722592784700056*^9, {3.7225928507617817`*^9, 
   3.7225928624157057`*^9}, {3.722592900846929*^9, 3.7225929115231123`*^9}, {
   3.722593023958578*^9, 3.7225931237695932`*^9}, {3.722593158005175*^9, 
   3.722593185223146*^9}, 3.722593245103685*^9, 3.722593307170888*^9, 
   3.722593347266625*^9, {3.722593395352828*^9, 3.7225934127308607`*^9}, {
   3.722593498975339*^9, 3.7225935436649313`*^9}, {3.722593604379549*^9, 
   3.7225936377353573`*^9}, {3.722593774706924*^9, 3.722593841603326*^9}, 
   3.722593895379877*^9},ExpressionUUID->"753636c3-a52b-4ba3-a182-\
e6654e4f300b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fibloophistory", "[", "\"\<5\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.722592014552884*^9, 3.722592016037208*^9}, {
  3.7225933310742273`*^9, 3.7225933320971813`*^9}, {3.7225935519493427`*^9, 
  3.7225935709164124`*^9}, {3.722593863456189*^9, 
  3.7225938637702913`*^9}},ExpressionUUID->"490fe7df-a71c-4754-b176-\
983b7c48646b"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{TagBox[
        GridBox[{{"\"public static int fibonacciLoop(int number) {\""}, {
          "\"if (number == 1 || number == 2) {\""}, {"\"    return 1;\""}, {
          "\"}\""}, {"\"int fibo1 = 1, fibo2 = 1, fibonacci = 1;\""}, {
          "\"for (int i = 3; i <= number; i++) {\""}, {
          "\"     fibonacci = fibo1 + fibo2;\""}, {
          "\"     fibo1 = fibo2;\""}, {"\"     fibo2 = fibonacci;\""}, {
          "\"}\""}, {"\"return fibonacci;\""}, {"\"}\""}}, 
         GridBoxAlignment -> {"Columns" -> {{Left}}}, DefaultBaseStyle -> 
         "Column", 
         GridBoxItemSize -> {
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}], "Column"],
       FrameStyle -> None,Background -> RGBColor[0.87, 0.94, 1]},
      "Highlighted"]},
    {
     TagBox[GridBox[{
        {
         TemplateBox[{
          "\"public static int fibonacciLoop(int number)\"","\": \"",
           "\"number\"","\"=\"",
           TemplateBox[{"5", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"if(number == 1 || number == 2)\"","\": \"",
           TemplateBox[{"\"False, \"", "\"Do nothing! Go to next line\""}, 
            "RowDefault"]},
          "RowDefault"]},
        {
         TemplateBox[{
          "\"Enter Loop: \"",
           TemplateBox[{"\"for (int i = 3; i <= number; i++)\""}, 
            "RowDefault"],"\", \"",
           TemplateBox[{"\"i=3\"", FrameStyle -> None}, "Highlighted"]},
          "RowDefault"]},
        {
         TemplateBox[{
          TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","1","\", \"","",
           "\"fibo1\"","\"=\"","1","\", \"","\"fibo2\"","\"=\"","1"},
          "RowDefault"]},
        {
         TemplateBox[{
          TemplateBox[{
            "\"Iteration \"", FrameStyle -> None, Background -> 
             RGBColor[1, 0.5, 0.5]}, "Highlighted"],"1","\", \"",
           TemplateBox[{"\"i\"", FrameStyle -> None}, "Highlighted"],"\"=\"",
           "3","\" initial i\""},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibonacci = fibo1 + fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","2","\", \"","",
           "\"fibo1\"","\"=\"","1","\", \"","\"fibo2\"","\"=\"","1"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo1 = fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","2","\", \"","",
           "\"fibo1\"","\"=\"","1","\", \"","\"fibo2\"","\"=\"","1"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo2 = fibonacci;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","2","\", \"","",
           "\"fibo1\"","\"=\"","1","\", \"","\"fibo2\"","\"=\"","2"},
          "RowDefault"]},
        {
         TemplateBox[{
          TemplateBox[{
            "\"Iteration \"", FrameStyle -> None, Background -> 
             RGBColor[1, 0.5, 0.5]}, "Highlighted"],"2","\", \"",
           TemplateBox[{"\"i++\"", FrameStyle -> None}, "Highlighted"],
           "\"=\"","4","\" new incremented i\""},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibonacci = fibo1 + fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","3","\", \"","",
           "\"fibo1\"","\"=\"","1","\", \"","\"fibo2\"","\"=\"","2"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo1 = fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","3","\", \"","",
           "\"fibo1\"","\"=\"","2","\", \"","\"fibo2\"","\"=\"","2"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo2 = fibonacci;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","3","\", \"","",
           "\"fibo1\"","\"=\"","2","\", \"","\"fibo2\"","\"=\"","3"},
          "RowDefault"]},
        {
         TemplateBox[{
          TemplateBox[{
            "\"Iteration \"", FrameStyle -> None, Background -> 
             RGBColor[1, 0.5, 0.5]}, "Highlighted"],"3","\", \"",
           TemplateBox[{"\"i++\"", FrameStyle -> None}, "Highlighted"],
           "\"=\"","5","\" new incremented i\""},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibonacci = fibo1 + fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","5","\", \"","",
           "\"fibo1\"","\"=\"","2","\", \"","\"fibo2\"","\"=\"","3"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo1 = fibo2;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","5","\", \"","",
           "\"fibo1\"","\"=\"","3","\", \"","\"fibo2\"","\"=\"","3"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"fibo2 = fibonacci;\""}, "RowDefault"]}, 
            "RowDefault"],"\"  \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","5","\", \"","",
           "\"fibo1\"","\"=\"","3","\", \"","\"fibo2\"","\"=\"","5"},
          "RowDefault"]},
        {
         TemplateBox[{TemplateBox[{
             TemplateBox[{"\"return fibonacci;\""}, "RowDefault"]}, 
            "RowDefault"],"\", \"",
           TemplateBox[{
            "\"fibonacci\"", FrameStyle -> None, Background -> 
             RGBColor[0.88, 1, 0.88]}, "Highlighted"],"\"=\"","5"},
          "RowDefault"]}
       },
       DefaultBaseStyle->"Column",
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.722592016742136*^9, 3.722592068597252*^9, 3.722592112710113*^9, 
   3.722592181208486*^9, 3.7225926304339857`*^9, {3.722592664143949*^9, 
   3.7225926890940866`*^9}, 3.722592758767047*^9, 3.7225929162374687`*^9, {
   3.722593163720446*^9, 3.7225932109393873`*^9}, {3.7225933117522993`*^9, 
   3.722593352383832*^9}, 3.722593417501933*^9, 3.722593503796479*^9, {
   3.722593548575467*^9, 3.7225935712340927`*^9}, 3.722593641673163*^9, {
   3.722593846091007*^9, 3.722593863959981*^9}, 
   3.722593898869172*^9},ExpressionUUID->"3dee12db-c18a-47ce-8500-\
fc917a03ff2c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fibonacci", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.7225938523136797`*^9, 
  3.722593860947455*^9}},ExpressionUUID->"306c559d-284e-48cb-b85f-\
bb82734f5c44"],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{{3.722593857620605*^9, 
  3.722593861233397*^9}},ExpressionUUID->"1fc8a6ac-c332-4ffb-b28f-\
e32d2c31527e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudDeploy", "[", 
  RowBox[{
   RowBox[{"FormFunction", "@@", 
    RowBox[{"APIFunction", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"\"\<n\>\"", "->", 
        RowBox[{"<|", 
         RowBox[{"\"\<Input\>\"", "->", "\"\<3\>\""}], "|>"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      RowBox[{
       RowBox[{"fibloophistory", "[", "#n", "]"}], "&"}], ",", "\"\<PDF\>\"", 
      ",", 
      RowBox[{"AppearanceRules", "\[Rule]", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Fibonacci: Loop History\>\"", ",", "Black", ",", "Bold"}], 
           "]"}]}], ",", 
         RowBox[{"\"\<Description\>\"", "\[Rule]", 
          RowBox[{"Style", "[", 
           RowBox[{
           "\"\<Computes the history of computations for looping\>\"", ",", 
            "Bold", ",", "Orange"}], "]"}]}], ",", 
         RowBox[{
         "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", "\"\<Get Loops!\>\""}]}],
         "|>"}]}]}], "]"}]}], ",", " ", 
   RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7225939284149637`*^9, 
  3.722593951988002*^9}},ExpressionUUID->"7d8b9e88-9806-40d1-b063-\
9bb423de4ac7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/objects/e586ec33-94e2-4d1b-bb24-\
860aa0393104\"",
     "https://www.wolframcloud.com/objects/e586ec33-94e2-4d1b-bb24-\
860aa0393104"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/objects/e586ec33-94e2-4d1b-bb24-860aa0393104"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.722593956728298*^9},ExpressionUUID->"ec61fcfb-8d55-464f-a49c-\
b5c2683ed8b7"]
}, Open  ]]
},
WindowSize->{1029, 1299},
WindowMargins->{{Automatic, 229}, {Automatic, 19}},
Background->GrayLevel[0.85],
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1292, 32, 94, "Input",ExpressionUUID->"6808b9cc-4aea-4188-8f7d-4057223655ef"],
Cell[1853, 54, 4016, 94, 241, "Input",ExpressionUUID->"7b9906c3-b124-4813-8629-042e0ad37233"],
Cell[CellGroupData[{
Cell[5894, 152, 849, 19, 73, "Input",ExpressionUUID->"340dca61-350e-48cb-ba69-f740dc09519c"],
Cell[6746, 173, 1225, 34, 377, "Output",ExpressionUUID->"deef277a-0c87-4485-8cdb-dfa96155483e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8008, 212, 568, 11, 52, "Input",ExpressionUUID->"bdf94545-e9fe-45ac-8ba2-f8092365c674"],
Cell[8579, 225, 20228, 551, 392, "Output",ExpressionUUID->"03bc05e1-5ad5-4c8e-a6d2-bdf72450c8a3"],
Cell[28810, 778, 11953, 245, 355, "Output",ExpressionUUID->"a85dda94-778d-4f18-87ac-9c3356c66cd0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40800, 1028, 3124, 74, 199, "Input",ExpressionUUID->"108da33c-d9a7-4d72-8ac8-49b0b9680d03"],
Cell[43927, 1104, 8773, 181, 449, "Output",ExpressionUUID->"eeee6dba-d8c1-4b2c-974b-aea0415babc2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52737, 1290, 2203, 57, 178, "Input",ExpressionUUID->"8740169b-710c-434a-82b5-7aab61909f15"],
Cell[54943, 1349, 6004, 130, 326, "Output",ExpressionUUID->"08aeb01f-f952-4f1f-8972-c2522815e008"]
}, Open  ]],
Cell[60962, 1482, 152, 3, 30, "Input",ExpressionUUID->"7e82b77c-6f98-4ca5-b575-6acd03796b32"],
Cell[CellGroupData[{
Cell[61139, 1489, 6733, 158, 556, "Input",ExpressionUUID->"4503befb-2593-4ace-b883-64e1b69ce9bc"],
Cell[67875, 1649, 5344, 108, 449, "Output",ExpressionUUID->"083633eb-a5f1-4f3a-9e52-e4e916f923f3"]
}, Open  ]],
Cell[73234, 1760, 1563, 41, 325, "Input",ExpressionUUID->"173d8b7c-9d76-425b-bbd2-70de81b41b8c"],
Cell[CellGroupData[{
Cell[74822, 1805, 534, 12, 73, "Input",ExpressionUUID->"9ea9199b-947e-40d3-aae1-000ae09a9235"],
Cell[75359, 1819, 231, 5, 34, "Output",ExpressionUUID->"0b55e64c-5213-4839-9af4-096692fe7723"],
Cell[75593, 1826, 1782, 39, 47, "Output",ExpressionUUID->"1e451c55-6e41-4c04-90d7-cd07cba30cc5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77412, 1870, 156, 3, 30, "Input",ExpressionUUID->"4667181e-45c2-494d-b215-95022fe1ad1d"],
Cell[77571, 1875, 555, 18, 34, "Output",ExpressionUUID->"5b985d92-18bb-4a57-9f2f-857ac856adb4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78163, 1898, 1093, 28, 52, "Input",ExpressionUUID->"9fec0d83-a5f5-47c8-b173-8ba363e8a6a8"],
Cell[79259, 1928, 492, 10, 34, "Output",ExpressionUUID->"0e31c161-66e9-4ed8-b6f5-484e682664f1"]
}, Open  ]],
Cell[79766, 1941, 3987, 115, 304, "Input",ExpressionUUID->"39540f32-1d65-4fc8-b371-0fd3f353c5b7"],
Cell[83756, 2058, 149, 3, 52, "Input",ExpressionUUID->"e5cd7f72-0f60-4f91-b6e9-3889dc90baab"],
Cell[CellGroupData[{
Cell[83930, 2065, 5127, 131, 417, "Input",ExpressionUUID->"30f6edb1-1337-4357-af43-86688490bd12"],
Cell[89060, 2198, 587, 15, 37, "Output",ExpressionUUID->"6f686ce6-4a58-49e7-9fec-8001d14b32d3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[89684, 2218, 5295, 134, 567, "Input",ExpressionUUID->"097ad7b5-4e6f-4fe1-a320-beee27470caf"],
Cell[94982, 2354, 591, 15, 37, "Output",ExpressionUUID->"38303612-687c-4398-8f51-16d009b4aa61"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95610, 2374, 10355, 242, 661, "Input",ExpressionUUID->"b66f9803-5323-4dee-a12d-18f552f62711"],
Cell[105968, 2618, 676, 13, 37, "Output",ExpressionUUID->"32648653-5884-4323-b929-8207c360f333"]
}, Open  ]],
Cell[106659, 2634, 14414, 323, 1354, "Input",ExpressionUUID->"56d0cbc8-a39c-4e54-b3a7-b52358eff503"],
Cell[CellGroupData[{
Cell[121098, 2961, 661, 15, 115, "Input",ExpressionUUID->"ceacb302-2292-44e9-bfdb-50c2d90b6a23"],
Cell[121762, 2978, 835, 13, 34, "Output",ExpressionUUID->"281dd7e9-49ca-44d0-8865-21779b0a15e7"],
Cell[122600, 2993, 1604, 31, 197, "Output",ExpressionUUID->"9f1dc7c7-fb05-497d-ac85-5f3818f756ba"]
}, Open  ]],
Cell[CellGroupData[{
Cell[124241, 3029, 184, 4, 30, "Input",ExpressionUUID->"7051a40d-328d-4ef5-abec-ee671e96b8d2"],
Cell[124428, 3035, 22564, 556, 1997, "Output",ExpressionUUID->"b8d0aeb8-65e8-4345-bc31-193a2cb4bd5e"]
}, Open  ]],
Cell[147007, 3594, 14826, 329, 1627, "Input",ExpressionUUID->"203a959e-0abe-42f7-b73c-a1080a46bec5"],
Cell[CellGroupData[{
Cell[161858, 3927, 246, 5, 30, "Input",ExpressionUUID->"5d647a0f-b491-4b0b-9477-3d6d9a60b0a8"],
Cell[162107, 3934, 5823, 137, 591, "Output",ExpressionUUID->"36380fbe-d7c8-4ab8-980f-787aa6410aa7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[167967, 4076, 1415, 33, 178, "Input",ExpressionUUID->"59f6faf6-f584-4a0d-bb3a-eea54964c7d2"],
Cell[169385, 4111, 595, 15, 37, "Output",ExpressionUUID->"03359de0-6df6-453e-a1d7-11fd5a94fc02"]
}, Open  ]],
Cell[169995, 4129, 17067, 357, 1942, "Input",ExpressionUUID->"753636c3-a52b-4ba3-a182-e6654e4f300b"],
Cell[CellGroupData[{
Cell[187087, 4490, 355, 6, 30, "Input",ExpressionUUID->"490fe7df-a71c-4754-b176-983b7c48646b"],
Cell[187445, 4498, 7909, 177, 801, "Output",ExpressionUUID->"3dee12db-c18a-47ce-8500-fc917a03ff2c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195391, 4680, 190, 4, 30, "Input",ExpressionUUID->"306c559d-284e-48cb-b85f-bb82734f5c44"],
Cell[195584, 4686, 154, 3, 34, "Output",ExpressionUUID->"1fc8a6ac-c332-4ffb-b28f-e32d2c31527e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195775, 4694, 1363, 33, 178, "Input",ExpressionUUID->"7d8b9e88-9806-40d1-b063-9bb423de4ac7"],
Cell[197141, 4729, 518, 14, 37, "Output",ExpressionUUID->"ec61fcfb-8d55-464f-a49c-b5c2683ed8b7"]
}, Open  ]]
}
]
*)

