(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     57948,       1222]
NotebookOptionsPosition[     56211,       1185]
NotebookOutlinePosition[     56579,       1201]
CellTagsIndexPosition[     56536,       1198]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"8b8e3fb3-b495-4611-8841-c8522780ca69"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CloudConnect", "[", 
  RowBox[{"\"\<wayne@compclassnotes.com\>\"", ",", "\"\<Wolf!123\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",ExpressionUUID->"ea563225-b93d-4aae-8c65-d678b5c4e1cf"],

Cell[BoxData["\<\"wayne@compclassnotes.com\"\>"], "Output",
 CellChangeTimes->{3.776336013391506*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"dbd7dd52-0000-497a-a6c9-4816c0d2be9e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "stack", " ", "is", " ", "just", " ", "an", " ", "ordered", " ", "list"}], 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"initSTACK", "[", "name_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<stack\>\"", "->", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"\"\<name\>\"", "\[Rule]", "name"}], ",", 
         RowBox[{"\"\<ctr\>\"", "->", "0"}]}], "|>"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"pop", "[", 
      RowBox[{"s_", ",", "id_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"res", ",", "s0", ",", "tmp1"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s0", "=", "s"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], "===", 
           RowBox[{"{", "}"}]}], ",", 
          RowBox[{"res", "=", 
           RowBox[{"<|", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"\"\<item\>\"", "\[Rule]", "\"\<\>\""}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", 
              RowBox[{
               RowBox[{"Drop", "[", 
                RowBox[{"s", ",", 
                 RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
               "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
               " ", "list"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{"\"\<stack\>\"", "\[Rule]", 
              RowBox[{"(", "s0", ")"}]}]}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "|>"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "=", 
            RowBox[{
             RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "-", "1"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"tmp1", ",", "CCNconorstack`history"}], "}"}], "=", 
            RowBox[{"push", "[", 
             RowBox[{"CNconorstack`history", ",", 
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{
                "\"\<\[DoubleStruckCapitalX]\>\"", ",", "\"\<: \>\"", ",", 
                 RowBox[{"s0", "[", "\"\<name\>\"", "]"}]}], "}"}]}], ",", 
              "id"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"res", "=", 
            RowBox[{"<|", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\"\<item\>\"", "\[Rule]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Last", "@", 
                  RowBox[{"s0", "[", "\"\<stack\>\"", "]"}]}], ")"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Drop", "[", 
                 RowBox[{"s", ",", 
                  RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
                "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
                " ", "list"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"\"\<stack\>\"", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], "=", 
                 RowBox[{"Drop", "[", 
                  RowBox[{
                   RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], ",", 
                   RowBox[{"-", "1"}]}], "]"}]}], ")"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}]}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"res", ",", " ", "s0"}], "}"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"push", "[", 
      RowBox[{"s_", ",", "item_", ",", "id_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"res", ",", "s0"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"s0", "=", "s"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"item", "=!=", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "=", 
            RowBox[{
             RowBox[{"s", "[", "\"\<ctr\>\"", "]"}], "+", "1"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"res", "=", 
            RowBox[{"<|", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\"\<item\>\"", "\[Rule]", "item"}], ",", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"Drop", "[", 
                 RowBox[{"s", ",", 
                  RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ", 
                "last", " ", "item", " ", "and", " ", "shortens", " ", "the", 
                " ", "list"}], "*)"}], "\[IndentingNewLine]", 
              RowBox[{"\"\<stack\>\"", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{"AppendTo", "[", 
                 RowBox[{
                  RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"item", ",", 
                    RowBox[{"Highlighted", "@", "id"}]}], "]"}], ",", 
                    "item"}], "}"}]}], "]"}], ")"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"res", "=", "Nothing"}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"res", ",", "s0"}], "}"}]}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"plotSTACK", "[", "s_", "]"}], ":=", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"s", "[", "\"\<stack\>\"", "]"}], "!=", 
        RowBox[{"{", "}"}]}], ",", 
       RowBox[{"Column", "[", 
        RowBox[{
         RowBox[{"s", "[", "\"\<name\>\"", "]"}], ",", 
         RowBox[{"Reverse", "@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"s", "[", "\"\<stack\>\"", "]"}], ")"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ",", 
         RowBox[{"ItemSize", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], ",", 
         RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.751200441100293*^9, 3.751200508837242*^9}, {
   3.7512005511161222`*^9, 3.7512005988728733`*^9}, 3.751200886185362*^9, {
   3.751200917062553*^9, 3.751200971040511*^9}, {3.751201047103549*^9, 
   3.7512011294651403`*^9}, {3.751201187439313*^9, 3.7512011902387447`*^9}, {
   3.75120124590774*^9, 3.751201249359015*^9}, {3.751201332038053*^9, 
   3.7512013405528517`*^9}, {3.75120138678063*^9, 3.751201417460631*^9}, {
   3.7512014518077793`*^9, 3.751201453269761*^9}, {3.7512015940325937`*^9, 
   3.751201596731176*^9}, {3.751201635827509*^9, 3.7512016382669277`*^9}, {
   3.7512016839782333`*^9, 3.7512016873973846`*^9}, {3.7512019190782843`*^9, 
   3.7512019656259623`*^9}, {3.751202048217671*^9, 3.751202136628832*^9}, {
   3.751202185039852*^9, 3.751202218833825*^9}, {3.751202251786414*^9, 
   3.751202273420498*^9}, 3.751202410920209*^9, {3.7512024434338512`*^9, 
   3.751202517729327*^9}, {3.751202618656742*^9, 3.75120267615457*^9}, {
   3.751202748146016*^9, 3.751202753994627*^9}, {3.751202906740991*^9, 
   3.751202924710394*^9}, {3.751203027487212*^9, 3.751203031265551*^9}, {
   3.751206419444875*^9, 3.7512064548967953`*^9}, 3.751206588133823*^9, 
   3.751206670519857*^9, {3.751208011844419*^9, 3.75120801201052*^9}, {
   3.7512082292101*^9, 3.751208233434948*^9}, {3.751208467183668*^9, 
   3.751208474685853*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"5ca3327d-249a-4639-a631-53fb44a305e8"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"stack", "[", 
     RowBox[{
     "item1_", ",", "op1_", ",", "item2_", ",", "op2_", ",", "item3_", ",", 
      "op3_", ",", "id0_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "plotSTACK", ",", "initSTACK", ",", "pop", ",", "push", ",", "res1", 
        ",", "res2", ",", "res3", ",", "myPNG", ",", "stack1", ",", "stack2", 
        ",", "stack3"}], "}"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{
           RowBox[{"CloudSymbol", "[", "\"\<CS4221STACKmembers\>\"", "]"}], 
           ",", "id0"}], "]"}], "\[Equal]", "False"}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Style", "[", 
         RowBox[{"\"\<User unknown\>\"", ",", "Red", ",", "Bold"}], "]"}], 
        ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"initSTACK", "[", "name_", "]"}], ":=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", "}"}], ",", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<stack\>\"", "->", 
               RowBox[{"{", "}"}]}], ",", 
              RowBox[{"\"\<name\>\"", "\[Rule]", "name"}], ",", 
              RowBox[{"\"\<ctr\>\"", "->", "0"}]}], "|>"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"pop", "[", 
           RowBox[{"s_", ",", "id_"}], "]"}], ":=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"res", ",", "s0", ",", "tmp1"}], "}"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"s0", "=", "s"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], "===", 
                RowBox[{"{", "}"}]}], ",", 
               RowBox[{"res", "=", 
                RowBox[{"<|", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<item\>\"", "\[Rule]", "\"\<\>\""}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", 
                    " ", "last", " ", "item", " ", "and", " ", "shortens", 
                    " ", "the", " ", "list"}], "*)"}], "\[IndentingNewLine]", 
                  
                  RowBox[{"\"\<stack\>\"", "\[Rule]", 
                   RowBox[{"(", "s0", ")"}]}]}], "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "|>"}]}], ",", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "=", 
                 RowBox[{
                  RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "-", "1"}]}], ";", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"tmp1", ",", "CCNconorstack`history"}], "}"}], "=", 
                 
                 RowBox[{"push", "[", 
                  RowBox[{"CNconorstack`history", ",", 
                   RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{
                    "\"\<\[DoubleStruckCapitalX]\>\"", ",", "\"\<: \>\"", ",", 
                    RowBox[{"s0", "[", "\"\<name\>\"", "]"}]}], "}"}]}], ",", 
                   "id"}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"res", "=", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<item\>\"", "\[Rule]", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Last", "@", 
                    RowBox[{"s0", "[", "\"\<stack\>\"", "]"}]}], ")"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", 
                    " ", "last", " ", "item", " ", "and", " ", "shortens", 
                    " ", "the", " ", "list"}], "*)"}], "\[IndentingNewLine]", 
                   
                   RowBox[{"\"\<stack\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], "=", 
                    RowBox[{"Drop", "[", 
                    RowBox[{
                    RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], ",", 
                    RowBox[{"-", "1"}]}], "]"}]}], ")"}]}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}]}], 
              "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"res", ",", " ", "s0"}], "}"}]}]}], 
           "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"push", "[", 
           RowBox[{"s_", ",", "item_", ",", "id_"}], "]"}], ":=", 
          RowBox[{"Module", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"res", ",", "s0"}], "}"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"s0", "=", "s"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"item", "=!=", "\"\<\>\""}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"s0", "[", "\"\<ctr\>\"", "]"}], "=", 
                 RowBox[{
                  RowBox[{"s", "[", "\"\<ctr\>\"", "]"}], "+", "1"}]}], ";", 
                "\[IndentingNewLine]", 
                RowBox[{"res", "=", 
                 RowBox[{"<|", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"\"\<item\>\"", "\[Rule]", "item"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", 
                    " ", "last", " ", "item", " ", "and", " ", "shortens", 
                    " ", "the", " ", "list"}], "*)"}], "\[IndentingNewLine]", 
                   
                   RowBox[{"\"\<stack\>\"", "\[Rule]", 
                    RowBox[{"(", 
                    RowBox[{"AppendTo", "[", 
                    RowBox[{
                    RowBox[{"s0", "[", "\"\<stack\>\"", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"item", ",", 
                    RowBox[{"Highlighted", "@", "id"}]}], "]"}], ",", 
                    "item"}], "}"}]}], "]"}], ")"}]}]}], 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"res", "=", "\"\<\>\""}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"res", ",", "s0"}], "}"}]}]}], "\[IndentingNewLine]", 
           "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"plotSTACK", "[", "s_", "]"}], ":=", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"s", "[", "\"\<stack\>\"", "]"}], "!=", 
             RowBox[{"{", "}"}]}], ",", 
            RowBox[{"Column", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"s", "[", "\"\<name\>\"", "]"}], ",", 
               RowBox[{"Column", "[", 
                RowBox[{
                 RowBox[{"Reverse", "@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"s", "[", "\"\<stack\>\"", "]"}], ")"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ",", 
                 RowBox[{"ItemSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], ",", 
                 RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], "}"}], "]"}],
             ",", "\[IndentingNewLine]", 
            RowBox[{"Column", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"s", "[", "\"\<name\>\"", "]"}], ",", 
               RowBox[{"Column", "[", 
                RowBox[{
                 RowBox[{"{", "\"\<   \>\"", "}"}], ",", 
                 RowBox[{"ItemSize", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], ",", 
                 RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], "}"}], 
             "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "stack1", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "[", 
             "\"\<ctr\>\"", "]"}], ">", "10"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "=", 
            RowBox[{"initSTACK", "[", "\"\<Stack1\>\"", "]"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"item1", "\[NotEqual]", "\"\<\>\""}], "&&", 
            RowBox[{
             RowBox[{"ToLowerCase", "[", "op1", "]"}], "\[Equal]", 
             "\"\<o\>\""}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res1", ",", "stack1"}], "}"}], "=", 
             RowBox[{"push", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], ",", 
               "item1", ",", "id0"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "=", 
             "stack1"}], ";"}], "\[IndentingNewLine]", ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ToLowerCase", "[", "op1", "]"}], "\[Equal]", 
            "\"\<x\>\""}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res1", ",", "stack1"}], "}"}], "=", 
             RowBox[{"pop", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], ",", 
               "\"\<SYS\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "=", 
             "stack1"}], ";"}]}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "stack2", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "[", 
             "\"\<ctr\>\"", "]"}], ">", "10"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "=", 
            RowBox[{"initSTACK", "[", "\"\<Stack2\>\"", "]"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"item2", "\[NotEqual]", "\"\<\>\""}], "&&", 
            RowBox[{
             RowBox[{"ToLowerCase", "[", "op2", "]"}], "\[Equal]", 
             "\"\<o\>\""}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res2", ",", "stack2"}], "}"}], "=", 
             RowBox[{"push", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], ",", 
               "item2", ",", "id0"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "=", 
             "stack2"}], ";"}], "\[IndentingNewLine]", ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ToLowerCase", "[", "op2", "]"}], "\[Equal]", 
            "\"\<x\>\""}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res2", ",", "stack2"}], "}"}], "=", 
             RowBox[{"pop", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], ",", 
               "\"\<SYS\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "=", 
             "stack2"}], ";"}]}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", "stack3", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"Which", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "[", 
             "\"\<ctr\>\"", "]"}], ">", "10"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "=", 
            RowBox[{"initSTACK", "[", "\"\<Stack3\>\"", "]"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"item3", "\[NotEqual]", "\"\<\>\""}], "&&", 
            RowBox[{
             RowBox[{"ToLowerCase", "[", "op3", "]"}], "\[Equal]", 
             "\"\<o\>\""}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res3", ",", "stack3"}], "}"}], "=", 
             RowBox[{"push", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], ",", 
               "item3", ",", "id0"}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "=", 
             "stack3"}], ";"}], "\[IndentingNewLine]", ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ToLowerCase", "[", "op3", "]"}], "\[Equal]", 
            "\"\<x\>\""}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"res3", ",", "stack3"}], "}"}], "=", 
             RowBox[{"pop", "[", 
              RowBox[{
               RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], ",", 
               "\"\<SYS\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "=", 
             "stack3"}], ";"}]}], "\[IndentingNewLine]", 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"myPNG", "[", "s_", "]"}], ":=", 
          RowBox[{"ImportString", "@", 
           RowBox[{"ExportString", "[", 
            RowBox[{"s", ",", "\"\<PNG\>\""}], "]"}]}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"myPNG", "@", 
          RowBox[{"Grid", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Riffle", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"plotSTACK", "@", 
                  RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}]}], ",", 
                 
                 RowBox[{"plotSTACK", "@", 
                  RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}]}], ",", 
                 
                 RowBox[{"plotSTACK", "@", 
                  RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}]}]}], 
                "}"}], ",", "\"\<  \>\""}], "]"}], "}"}], ",", 
            RowBox[{"Alignment", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"Center", ",", "Top"}], "}"}]}]}], "]"}]}]}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",\

 CellChangeTimes->{{3.751206771951067*^9, 3.751207038148986*^9}, {
   3.751207262882996*^9, 3.7512073891884823`*^9}, {3.7512074531135902`*^9, 
   3.751207491760397*^9}, {3.751207546264249*^9, 3.7512076144853573`*^9}, {
   3.751207790225215*^9, 3.7512078024654284`*^9}, {3.751207845209577*^9, 
   3.751207931966722*^9}, {3.751208023679126*^9, 3.751208023958727*^9}, {
   3.7512080950934067`*^9, 3.7512081735530024`*^9}, {3.751208249091907*^9, 
   3.751208252686118*^9}, {3.751208291680957*^9, 3.751208316508922*^9}, {
   3.751208511398278*^9, 3.751208518900507*^9}, 3.7512086669764433`*^9, 
   3.751208750878869*^9, {3.7512087960313883`*^9, 3.7512088435578833`*^9}, {
   3.751208885117107*^9, 3.751208885724085*^9}, {3.751208916358611*^9, 
   3.7512089474658413`*^9}, {3.751209034059146*^9, 3.751209038973166*^9}, {
   3.7512091373696527`*^9, 3.751209140810135*^9}, {3.751209184979233*^9, 
   3.751209188713505*^9}, {3.7512092240633907`*^9, 3.751209243795075*^9}, {
   3.751209316922591*^9, 3.751209317190587*^9}, {3.751209351494175*^9, 
   3.751209380788069*^9}, {3.751209780904088*^9, 3.7512097955164137`*^9}, {
   3.751209852211258*^9, 3.751209942859487*^9}, {3.7512102422628317`*^9, 
   3.7512102954086847`*^9}, 3.7512103894392157`*^9, {3.751210474545738*^9, 
   3.751210481935545*^9}, {3.751210539858097*^9, 3.7512106449290257`*^9}, {
   3.751210684731984*^9, 3.751210771740343*^9}, {3.751210934960374*^9, 
   3.751210945196993*^9}, {3.751211071472272*^9, 3.751211071627602*^9}, {
   3.751211329908702*^9, 3.751211373075799*^9}, {3.751212189482038*^9, 
   3.7512122676120377`*^9}, {3.751219183485166*^9, 3.7512192229450817`*^9}, {
   3.751219324118477*^9, 3.7512193376856422`*^9}, {3.751219587575581*^9, 
   3.751219604686872*^9}, {3.751219705354014*^9, 3.751219705633556*^9}, {
   3.7512197374979*^9, 3.751219737607066*^9}, 3.776337100506667*^9, {
   3.776337387417625*^9, 3.77633739837178*^9}, {3.777049154836432*^9, 
   3.777049176126906*^9}, {3.7770495035311947`*^9, 3.777049573947455*^9}, {
   3.777049742796773*^9, 3.7770497434251842`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"423c3bd1-dc30-42f8-832c-dbb6dab3043d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack1\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack2\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack3\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<history\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<history\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<CS4221STACKmembers\>\"", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{"\"\<Conor\>\"", ",", "\"\<Dara\>\"", ",", "\"\<Muhammad\>\""}],
       "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"stack", "[", 
    RowBox[{
    "\"\<6\>\"", ",", "\"\<x\>\"", ",", "\"\<hi\>\"", ",", "\"\<x\>\"", ",", 
     "\"\<bye\>\"", ",", "\"\<x\>\"", ",", "\"\<totty\>\""}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.751207524302177*^9, 3.751207537647769*^9}, {
  3.7512076248115396`*^9, 3.751207676268498*^9}, {3.7512083512254877`*^9, 
  3.7512083577830963`*^9}, {3.751208396540819*^9, 3.7512084020754128`*^9}, {
  3.751208588762227*^9, 3.751208596950728*^9}, {3.751208673858877*^9, 
  3.751208685842701*^9}, {3.751209680346377*^9, 3.751209740251766*^9}, {
  3.751209830749331*^9, 3.751209839581874*^9}, {3.75121050821428*^9, 
  3.751210522772006*^9}, {3.777049438975164*^9, 
  3.7770494908598137`*^9}},ExpressionUUID->"152e2ccf-f9c2-475d-b475-\
4ffb8212ef7a"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnE+I3NYdx1/bS2/by158MDQQKGsiSgllCXuIGkzshlq7WSeHeGBJqCft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    "], {{0, 60}, {271, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 11, 14, 21, 29, 44.}, "Instant", "Gregorian", 0.]]]],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{271, 60},
  PlotRange->{{0, 271}, {0, 60}}]], "Output",
 CellChangeTimes->{{3.751207806727914*^9, 3.7512078186981363`*^9}, 
   3.751208030887429*^9, 3.751208082956964*^9, 3.751208176846746*^9, 
   3.751208257256845*^9, 3.751208321152179*^9, 3.751208358032716*^9, 
   3.751208403279683*^9, 3.7512084851268597`*^9, {3.751208526667733*^9, 
   3.751208618430121*^9}, {3.751208670080152*^9, 3.7512086910169477`*^9}, 
   3.75120884802005*^9, 3.751208889251548*^9, {3.751208926813776*^9, 
   3.7512089679599237`*^9}, {3.751209041828247*^9, 3.751209046100285*^9}, {
   3.751209143783704*^9, 3.751209151046329*^9}, 3.751209190946741*^9, {
   3.751209237010468*^9, 3.7512092456744213`*^9}, 3.751209319330698*^9, {
   3.751209364194957*^9, 3.751209382416277*^9}, 3.7512098361253033`*^9, 
   3.751209952946479*^9, {3.7512099985681953`*^9, 3.751210009668927*^9}, 
   3.7512103066993217`*^9, 3.751210404133882*^9, 3.7512104493492517`*^9, {
   3.751210490353507*^9, 3.751210573983246*^9}, 3.751210620650549*^9, 
   3.751210787960705*^9, 3.751211091178965*^9, {3.751211358896875*^9, 
   3.751211384285171*^9}, 3.751219784192959*^9},
 CellLabel->
  "Out[1079]=",ExpressionUUID->"a27b000c-cc83-4eeb-a363-edbe5e4e536d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stack", "[", 
  RowBox[{
  "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<hi\>\"", ",", "\"\<x\>\"", ",", 
   "\"\<bye\>\"", ",", "\"\<x\>\"", ",", "\"\<totty\>\""}], "]"}]], "Input",
 CellLabel->
  "In[1006]:=",ExpressionUUID->"ef0fe0d2-b7db-4042-b921-e18dd5cdf727"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnUGI3NYdxtX2kpt78cUHQwOBsiailFBM2EPUYGI31GPHTg7xgEmoJ+3F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    "], {{0, 128}, {264, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 11, 14, 19, 10, 24.}, "Instant", "Gregorian", 0.]]]],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{264, 128},
  PlotRange->{{0, 264}, {0, 128}}]], "Output",
 CellChangeTimes->{{3.751208972838072*^9, 3.7512089745137033`*^9}, 
   3.751209047379464*^9, 3.751209145332396*^9, 3.751209193291565*^9, {
   3.751209239099472*^9, 3.7512092470974607`*^9}, {3.751209385156142*^9, 
   3.751209386833143*^9}, 3.7512107968668537`*^9, {3.751211096230974*^9, 
   3.7512111131956472`*^9}, 3.7512113906091957`*^9, 3.751211424403015*^9},
 CellLabel->
  "Out[1006]=",ExpressionUUID->"3c7ff919-9e9f-452c-aba4-2ea4d66f9e28"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stack", "[", 
  RowBox[{
  "\"\<me\>\"", ",", "\"\<x\>\"", ",", "\"\<hi\>\"", ",", "\"\<o\>\"", ",", 
   "\"\<\>\"", ",", "\"\<x\>\"", ",", "\"\<totty\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.7512087134130898`*^9, 3.751208726563868*^9}},
 CellLabel->
  "In[999]:=",ExpressionUUID->"dbaffd5a-0b7c-495a-98ac-5335d5cd1fad"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnU+o3MYdx9X2kpt78cUHQwOB8kxEKaGY8A5Rg4ndUMvOc3KIl5qEWmkv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    "], {{0, 94}, {264, 
    0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag[
   "Byte", ColorSpace -> "RGB", Interleaving -> True, MetaInformation -> 
    Association[
     "Exif" -> Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com"], 
      "Comments" -> 
      Association[
       "Software" -> "Created with the Wolfram Language : www.wolfram.com", 
        "Creation Time" -> 
        DateObject[{2018, 11, 14, 19, 9, 54.}, "Instant", "Gregorian", 0.]]]],
   
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSizeRaw->{264, 94},
  PlotRange->{{0, 264}, {0, 94}}]], "Output",
 CellChangeTimes->{
  3.751209260981204*^9, {3.751209388743104*^9, 3.7512093914542627`*^9}, {
   3.7512111020673037`*^9, 3.751211107997014*^9}, 3.7512113948606043`*^9},
 CellLabel->
  "Out[999]=",ExpressionUUID->"e3648275-d306-4f6c-a302-90c009f078b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"CloudConnect", "[", 
    RowBox[{"\"\<wayne@compclassnotes.com\>\"", ",", "\"\<Wolf!123\>\""}], 
    "]"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"initSTACK", "[", "name_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"<|", 
        RowBox[{
         RowBox[{"\"\<stack\>\"", "->", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"\"\<name\>\"", "\[Rule]", "name"}], ",", 
         RowBox[{"\"\<ctr\>\"", "->", "0"}]}], "|>"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack1\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack1\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack2\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack2\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<stack3\>\"", "]"}], "=", 
     RowBox[{"initSTACK", "[", "\"\<Stack3\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CloudSymbol", "[", "\"\<CS4221STACKmembers\>\"", "]"}], "=", 
     RowBox[{"{", 
      RowBox[{"\"\<Conor\>\"", ",", "\"\<Dara\>\"", ",", "\"\<Muhammad\>\""}],
       "}"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"CCNconorstack`history", "=", 
     RowBox[{"initSTACK", "[", "\"\<Pop history\>\"", "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"CloudDeploy", "[", 
    RowBox[{
     RowBox[{"FormPage", "[", 
      RowBox[{
       RowBox[{"FormObject", "[", 
        RowBox[{
         RowBox[{
         "{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"\"\<id\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<\>\""}], "|>"}]}], ",", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<item1\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<op1\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<o\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<item2\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<op2\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<o\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"\"\<item3\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"\"\<op3\>\"", "->", 
            RowBox[{"<|", 
             RowBox[{
              RowBox[{"\"\<Input\>\"", "\[Rule]", "\"\<o\>\""}], ",", " ", 
              RowBox[{"\"\<Required\>\"", "\[Rule]", " ", "False"}]}], 
             "|>"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"AppearanceRules", "\[Rule]", 
          RowBox[{"<|", 
           RowBox[{
            RowBox[{"\"\<Title\>\"", " ", "\[Rule]", 
             RowBox[{"Style", "[", 
              RowBox[{
              "\"\<Cloud Stack \>\"", ",", "Orange", ",", " ", "Bold", ",", 
               RowBox[{"FontSize", "\[Rule]", "18"}]}], "]"}]}], ",", " ", 
            RowBox[{
            "\"\<SubmitLabel\>\"", " ", "\[Rule]", " ", 
             "\"\<o for push, x for pop\>\""}]}], "|>"}]}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"stack", "[", 
         RowBox[{
         "#item1", ",", "#op1", ",", "#item2", ",", "#op2", ",", "#item3", 
          ",", "#op3", ",", "#id"}], "]"}], "&"}]}], "]"}], ",", 
     RowBox[{"Permissions", "\[Rule]", "\"\<Public\>\""}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.751209454778861*^9, 3.751209586765877*^9}, {
  3.751209626694322*^9, 3.7512096282958*^9}, {3.751211143277285*^9, 
  3.7512111524221354`*^9}, {3.7512115539320707`*^9, 3.751211585172299*^9}, {
  3.751211787936274*^9, 3.7512117908485727`*^9}, {3.751211826839786*^9, 
  3.7512118271752987`*^9}, {3.751211863200238*^9, 3.7512118634007797`*^9}, {
  3.75121197790064*^9, 3.7512120052883883`*^9}, {3.751219423921935*^9, 
  3.7512194262334414`*^9}, {3.776337168732386*^9, 3.776337169397725*^9}, {
  3.777049186577023*^9, 3.7770492061510973`*^9}, {3.777049377571349*^9, 
  3.7770494040651617`*^9}, {3.777049595937797*^9, 3.7770495964018803`*^9}, {
  3.7770496342574053`*^9, 3.7770496349350443`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"7c13d361-776a-4403-8a37-946bdb617f8b"],

Cell[BoxData["\<\"wayne@compclassnotes.com\"\>"], "Output",
 CellChangeTimes->{
  3.751209591166753*^9, 3.751210609788435*^9, 3.751211158158812*^9, 
   3.751211396176653*^9, 3.751211560226487*^9, 3.751211792947036*^9, 
   3.751211830079051*^9, 3.751211864288315*^9, 3.751212009382223*^9, 
   3.751212281036869*^9, 3.751219349740695*^9, 3.7512193931654577`*^9, 
   3.751219429834141*^9, 3.751219614126606*^9, 3.751219790799448*^9, {
   3.7763371461345997`*^9, 3.776337173386814*^9}, 3.776337408508606*^9, {
   3.777049617934272*^9, 3.777049638272294*^9}, 3.777049753503834*^9},
 CellLabel->"Out[23]=",ExpressionUUID->"3a84e150-22a8-47aa-b031-4762320d848d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"CloudObject", "[", 
   TemplateBox[{
    "\"https://www.wolframcloud.com/obj/84008af6-4742-4990-8694-e92000821ff3\"\
","https://www.wolframcloud.com/obj/84008af6-4742-4990-8694-e92000821ff3"},
    "HyperlinkURL"], "]"}],
  CloudObject[
  "https://www.wolframcloud.com/obj/84008af6-4742-4990-8694-e92000821ff3"],
  SelectWithContents->True]], "Output",
 CellChangeTimes->{
  3.751209591166753*^9, 3.751210609788435*^9, 3.751211158158812*^9, 
   3.751211396176653*^9, 3.751211560226487*^9, 3.751211792947036*^9, 
   3.751211830079051*^9, 3.751211864288315*^9, 3.751212009382223*^9, 
   3.751212281036869*^9, 3.751219349740695*^9, 3.7512193931654577`*^9, 
   3.751219429834141*^9, 3.751219614126606*^9, 3.751219790799448*^9, {
   3.7763371461345997`*^9, 3.776337173386814*^9}, 3.776337408508606*^9, {
   3.777049617934272*^9, 3.777049638272294*^9}, 3.777049755898464*^9},
 CellLabel->"Out[30]=",ExpressionUUID->"8b3ea126-5863-4c2a-95b6-b3a89f8d6d2a"]
}, Open  ]]
},
WindowSize->{1060, 1068},
WindowMargins->{{553, Automatic}, {Automatic, 0}},
Background->GrayLevel[0.85],
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1313, 32, 94, "Input",ExpressionUUID->"8b8e3fb3-b495-4611-8841-c8522780ca69"],
Cell[CellGroupData[{
Cell[1896, 56, 215, 4, 30, "Input",ExpressionUUID->"ea563225-b93d-4aae-8c65-d678b5c4e1cf"],
Cell[2114, 62, 179, 2, 34, "Output",ExpressionUUID->"dbd7dd52-0000-497a-a6c9-4816c0d2be9e"]
}, Open  ]],
Cell[2308, 67, 8881, 196, 1207, "Input",ExpressionUUID->"5ca3327d-249a-4639-a631-53fb44a305e8"],
Cell[11192, 265, 19434, 405, 2656, "Input",ExpressionUUID->"423c3bd1-dc30-42f8-832c-dbb6dab3043d"],
Cell[CellGroupData[{
Cell[30651, 674, 1996, 44, 325, "Input",ExpressionUUID->"152e2ccf-f9c2-475d-b475-4ffb8212ef7a"],
Cell[32650, 720, 5231, 91, 77, "Output",ExpressionUUID->"a27b000c-cc83-4eeb-a363-edbe5e4e536d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37918, 816, 283, 6, 30, "Input",ExpressionUUID->"ef0fe0d2-b7db-4042-b921-e18dd5cdf727"],
Cell[38204, 824, 5393, 95, 145, "Output",ExpressionUUID->"3c7ff919-9e9f-452c-aba4-2ea4d66f9e28"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43634, 924, 350, 7, 30, "Input",ExpressionUUID->"dbaffd5a-0b7c-495a-98ac-5335d5cd1fad"],
Cell[43987, 933, 4866, 89, 111, "Output",ExpressionUUID->"e3648275-d306-4f6c-a302-90c009f078b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48890, 1027, 5652, 124, 682, "Input",ExpressionUUID->"7c13d361-776a-4403-8a37-946bdb617f8b"],
Cell[54545, 1153, 655, 9, 34, "Output",ExpressionUUID->"3a84e150-22a8-47aa-b031-4762320d848d"],
Cell[55203, 1164, 992, 18, 37, "Output",ExpressionUUID->"8b3ea126-5863-4c2a-95b6-b3a89f8d6d2a"]
}, Open  ]]
}
]
*)

