(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     51375,       1083]
NotebookOptionsPosition[     49243,       1041]
NotebookOutlinePosition[     49682,       1060]
CellTagsIndexPosition[     49639,       1057]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9},
 CellLabel->"In[14]:=",ExpressionUUID->"d3a81193-5b95-4b63-a627-710cb8ed9f74"],

Cell[TextData[{
 "\n",
 StyleBox["Cloud Libraries", "Title"]
}], "Text",
 CellChangeTimes->{{3.743591388320754*^9, 
  3.743591403158967*^9}},ExpressionUUID->"904f75c0-c7fe-4c85-8e19-\
eb762f16bff6"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "init", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"CloudGet", "[", 
  "\"\<https://www.wolframcloud.com/objects/ccn/module/v5\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"init", "[", "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.743591044100066*^9, 3.743591074844936*^9}, {
   3.743592808007864*^9, 3.743592817276636*^9}, {3.747645999216069*^9, 
   3.7476460093427067`*^9}, 3.747647933421784*^9, 3.749899337640698*^9},
 CellLabel->"In[1]:=",ExpressionUUID->"274a6bea-261d-4d1e-971b-dc0db75c09c8"],

Cell[BoxData[
 RowBox[{"{", "NHoldRest", "}"}]], "Output",
 CellChangeTimes->{3.743591079788818*^9, 3.743591249786457*^9, 
  3.743591956351903*^9, 3.743592298579329*^9, 3.743592821111335*^9, 
  3.7435943461041327`*^9, 3.747647841449217*^9, 3.74764795896497*^9, 
  3.747657750183769*^9, 3.74775562527512*^9, 3.749901062189886*^9, 
  3.750079614964823*^9, 3.750102905585353*^9},
 CellLabel->"Out[2]=",ExpressionUUID->"ed416b0f-41ca-4985-9600-25b89e48b17c"],

Cell[BoxData[
 RowBox[{"{", "\<\"vesion 5\"\>", "}"}]], "Output",
 CellChangeTimes->{3.743591079788818*^9, 3.743591249786457*^9, 
  3.743591956351903*^9, 3.743592298579329*^9, 3.743592821111335*^9, 
  3.7435943461041327`*^9, 3.747647841449217*^9, 3.74764795896497*^9, 
  3.747657750183769*^9, 3.74775562527512*^9, 3.749901062189886*^9, 
  3.750079614964823*^9, 3.750102905600182*^9},
 CellLabel->"Out[3]=",ExpressionUUID->"ce18c3ec-cd2a-4c0d-84ca-683226ee27e9"]
}, Open  ]],

Cell[TextData[StyleBox["Logic and Word Functions ", "Title"]], "Text",
 CellChangeTimes->{{3.7435914178749313`*^9, 
  3.743591421271768*^9}},ExpressionUUID->"a005360a-0834-4552-8e46-\
735d06e988d9"],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"logic1", "[", 
      RowBox[{"ctr_", ",", "mywords_", ",", "abcd_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "correct", ",", "vv", ",", "words", ",", "wrong", ",", "vars", ",", 
         "a", ",", "b", ",", "c", ",", "\[Theta]", ",", "\[Theta]0", ",", "k",
          ",", "sol1", ",", "sol2", ",", " ", "sol3", ",", " ", "solutions", 
         ",", " ", "solutions1", ",", " ", "solutions3", ",", "example", ",", 
         "choices", ",", 
         RowBox[{"molecule", "=", 
          RowBox[{"{", "}"}]}], ",", 
         RowBox[{"wrongmolecule", "=", 
          RowBox[{"{", "}"}]}], ",", "item", ",", "initSTACK", ",", "pop", 
         ",", "push", ",", "plotSTACK", ",", "\[Xi]", ",", "ctr0", ",", 
         "output", ",", "item2", ",", "ops"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "stack", " ", "is", " ", "just", " ", "an", " ", "ordered", " ", 
         "list"}], "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"initSTACK", "[", "]"}], ":=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\[Xi]", "=", 
            RowBox[{"{", "}"}]}], ";", 
           RowBox[{"ctr0", "=", "0"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"pop", "[", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ctr0", "--"}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"\[Xi]", "===", 
               RowBox[{"{", "}"}]}], ",", 
              RowBox[{"res", "=", 
               RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"res", "=", 
                RowBox[{"<|", "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{"\"\<item\>\"", "\[Rule]", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Last", "@", "\[Xi]"}], ")"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], ",", 
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                  RowBox[{"(*", 
                   RowBox[{
                    RowBox[{"Drop", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", 
                    " ", "last", " ", "item", " ", "and", " ", "shortens", 
                    " ", "the", " ", "list"}], "*)"}], "\[IndentingNewLine]", 
                  
                  RowBox[{"\"\<stack\>\"", "\[Rule]", 
                   RowBox[{"(", 
                    RowBox[{"\[Xi]", "=", 
                    RowBox[{"Drop", "[", 
                    RowBox[{"\[Xi]", ",", 
                    RowBox[{"-", "1"}]}], "]"}]}], ")"}]}]}], 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
               ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", "res"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"push", "[", "item_", "]"}], ":=", 
         RowBox[{"Module", "[", 
          RowBox[{
           RowBox[{"{", "res", "}"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ctr0", "++"}], ";", "\[IndentingNewLine]", 
            RowBox[{"res", "=", 
             RowBox[{"<|", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"\"\<item\>\"", "\[Rule]", "item"}], ",", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"Drop", "[", 
                  RowBox[{"s", ",", 
                   RowBox[{"-", "1"}]}], "]"}], " ", "drops", " ", "the", " ",
                  "last", " ", "item", " ", "and", " ", "shortens", " ", 
                 "the", " ", "list"}], "*)"}], "\[IndentingNewLine]", 
               RowBox[{"\"\<stack\>\"", "\[Rule]", 
                RowBox[{"(", 
                 RowBox[{"AppendTo", "[", 
                  RowBox[{"\[Xi]", ",", 
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Subscript", "[", 
                    RowBox[{"item", ",", 
                    RowBox[{"Highlighted", "@", "ctr0"}]}], "]"}], ",", 
                    "item"}], "}"}]}], "]"}], ")"}]}]}], 
              "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", "res"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"plotSTACK", "[", "]"}], ":=", 
         RowBox[{"Column", "[", 
          RowBox[{
           RowBox[{"Reverse", "@", 
            RowBox[{"(", 
             RowBox[{"\[Xi]", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ",", 
           RowBox[{"ItemSize", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Automatic", ",", "Automatic"}], "}"}]}], ",", 
           RowBox[{"Frame", "\[Rule]", "All"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"vv", "=", 
         RowBox[{"Release", "@", 
          RowBox[{"Map", "[", 
           RowBox[{
            RowBox[{"Hold", "[", 
             RowBox[{"RandomChoice", "@", 
              RowBox[{"{", 
               RowBox[{"ToUpperCase", ",", "ToLowerCase"}], "}"}]}], "]"}], 
            ",", 
            RowBox[{"RandomSample", "[", 
             RowBox[{
              RowBox[{"Complement", "[", 
               RowBox[{
                RowBox[{"CharacterRange", "[", 
                 RowBox[{"\"\<a\>\"", ",", "\"\<z\>\""}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<l\>\"", ",", "\"\<o\>\"", ",", " ", "\"\<i\>\"", ",", 
                  "\"\<e\>\"", ",", "\"\<k\>\"", ",", "\"\<n\>\"", ",", 
                  "\"\<m\>\""}], "}"}]}], "]"}], ",", "2"}], "]"}]}], 
           "]"}]}]}], 
        StyleBox[";",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        StyleBox["\[IndentingNewLine]",
         FontWeight->"Plain"], 
        RowBox[{"correct", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"wrong", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}], ",", 
           RowBox[{"{", "}"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"choices", "=", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"While", "[", 
         RowBox[{
          RowBox[{"Or", "@@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}], "===", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "&"}], "/@", 
             RowBox[{"Permutations", "[", 
              RowBox[{"choices", ",", " ", 
               RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}]}], ",", 
          StyleBox["\[IndentingNewLine]",
           FontWeight->"Plain"], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"correct", "=", 
            RowBox[{"Row", "@", 
             RowBox[{"{", 
              RowBox[{"ArcCos", "[", "a", "]"}], "}"}]}]}], "  ", ";", 
           "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong1\>\"", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong2\>\"", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong3\>\"", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong4\>\"", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong5\>\"", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<wrong6\>\"", "}"}]}]}], "}"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"wrong", "=", 
            RowBox[{"RandomSample", "[", 
             RowBox[{"wrong", ",", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{"5", ",", 
                 RowBox[{"Length", "@", "wrong"}]}], "}"}], "]"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"choices", "=", 
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", "correct", "}"}], ",", "wrong"}], "]"}]}], ";"}]}],
          "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"If", " ", "[", 
         RowBox[{
          RowBox[{"mywords", "=!=", 
           RowBox[{"{", "}"}]}], ",", " ", 
          RowBox[{"words", "=", 
           RowBox[{"mywords", "[", 
            RowBox[{"vars", ",", "ctr"}], "]"}]}], ",", " ", 
          RowBox[{
           RowBox[{"words", "[", "s_", "]"}], ":=", "Nothing"}]}], "]"}], ";",
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"\"\<question labeled\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text_labeled\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", "\"\<Answer this?\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<question\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME1", "@", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"words", "[", "\"\<text\>\"", "]"}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"ctr", ",", "\"\<Answer this?\>\""}], "}"}]}]}], 
               "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"(*", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"ImageResize", "[", 
                 RowBox[{
                  RowBox[{"myRASTER", "[", "#", "]"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"450", ",", "540"}], "}"}]}], "]"}], "&"}], "/@", 
               "list"}], "*)"}], "}"}], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", ")"}]}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<tutorial_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example\>\"", "\[Rule]", 
           RowBox[{
           "(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"example", "=", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Row", "@", 
                 RowBox[{"{", 
                  RowBox[{"Style", "[", 
                   RowBox[{"\"\<Stacks: Reverse\>\"", ",", "Orange", ",", 
                    RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                  "}"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                
                RowBox[{
                 RowBox[{
                 "item", "=", "\"\<dkjhgkdjfhgljdfhglkdfjhglkfjdhgldjh\>\""}],
                  ";", "\[IndentingNewLine]", 
                 RowBox[{"While", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"StringLength", "@", "item"}], ">", "5"}], ",", 
                   RowBox[{
                    RowBox[{"item", "=", 
                    RowBox[{"RandomWord", "[", "]"}]}], " ", ";"}]}], "]"}], 
                 ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"item", "=", 
                  RowBox[{"StringPartition", "[", 
                   RowBox[{"item", ",", "1"}], "]"}]}], " ", ";", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"Row", "@", 
                  RowBox[{"{", 
                   RowBox[{"\"\<Reverse the string \>\"", ",", 
                    RowBox[{"Highlighted", "[", " ", 
                    RowBox[{
                    RowBox[{"StringJoin", "@", "item"}], ",", 
                    RowBox[{"Background", "\[Rule]", "LightBlue"}]}], "]"}]}],
                    "}"}]}]}], ",", "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"initSTACK", "[", "]"}], ";", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", "\"\<Initialize Stack to Empty\>\""}],
                 ",", "\[IndentingNewLine]", 
                RowBox[{"plotSTACK", "[", "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"output", "=", "\"\<\>\""}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"ops", "=", "\"\<\>\""}], ";", "\[IndentingNewLine]", 
                 RowBox[{"Sequence", "@@", 
                  RowBox[{"(", 
                   RowBox[{"Flatten", "@", 
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Framed", "[", 
                    RowBox[{
                    RowBox[{"Column", "@", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Push\>\"", ",", 
                    RowBox[{"mySPACE", "@", "5"}], ",", 
                    RowBox[{"item", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Spacer", "@", "100"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"push", "[", " ", 
                    RowBox[{"item", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"plotSTACK", "[", "]"}], "}"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<operations: \>\"", ",", " ", 
                    RowBox[{"Spacer", "@", "5"}], ",", 
                    RowBox[{"ops", "=", 
                    RowBox[{"StringJoin", "[", 
                    RowBox[{"ops", ",", "\"\<P\>\""}], "]"}]}]}], "}"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<output: \>\"", ",", 
                    RowBox[{"Spacer", "@", "2"}], ",", "output"}], "}"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Spacer", "@", "100"}]}], "\[IndentingNewLine]", 
                    "}"}]}], ",", 
                    RowBox[{"FrameStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Dashed", ",", " ", "Orange"}], "}"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"StringLength", "@", 
                    RowBox[{"StringJoin", "@", "item"}]}]}], "}"}]}], "]"}]}],
                    ")"}]}]}], ",", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"Sequence", "@@", 
                 RowBox[{"(", 
                  RowBox[{"Flatten", "@", 
                   RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Framed", "[", 
                    RowBox[{
                    RowBox[{"Column", "@", 
                    RowBox[{"{", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Row", "@", 
                    RowBox[{"{", "\"\<Pop\>\"", "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Spacer", "@", "100"}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"item2", "=", 
                    RowBox[{"pop", "[", "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"plotSTACK", "[", "]"}], "}"}]}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<operations: \>\"", ",", " ", 
                    RowBox[{"Spacer", "@", "5"}], ",", 
                    RowBox[{"ops", "=", 
                    RowBox[{"StringJoin", "[", 
                    RowBox[{"ops", ",", "\"\<O\>\""}], "]"}]}]}], "}"}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"Row", "@", 
                    RowBox[{"{", 
                    RowBox[{"\"\<output: \>\"", ",", 
                    RowBox[{"Spacer", "@", "2"}], ",", 
                    RowBox[{"output", "=", 
                    RowBox[{"StringJoin", "[", 
                    RowBox[{"output", ",", 
                    RowBox[{"item2", "[", "\"\<item\>\"", "]"}]}], "]"}]}]}], 
                    "}"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Spacer", "@", "100"}]}], "\[IndentingNewLine]", 
                    "}"}]}], ",", 
                    RowBox[{"FrameStyle", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"Dashed", ",", " ", "Orange"}], "}"}]}]}], "]"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"i", ",", "1", ",", 
                    RowBox[{"StringLength", "@", 
                    RowBox[{"StringJoin", "@", "item"}]}]}], "}"}]}], "]"}]}],
                   ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], 
            "\[IndentingNewLine]", "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
           "This", " ", "was", " ", "added", " ", "in", " ", "4.0", " ", "to",
             " ", "allow", " ", "for", " ", "pdf", " ", "that", " ", "is", 
            " ", "different", " ", "than", " ", "exampl"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"\"\<example PDF\>\"", "\[Rule]", 
           RowBox[{
           "(", "\[IndentingNewLine]", "\[IndentingNewLine]", "example", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", 
             RowBox[{"Column", "@", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{"Row", "@", 
                RowBox[{"{", 
                 RowBox[{"Style", "[", 
                  RowBox[{"\"\<PDF Stuff\>\"", ",", "Orange", ",", 
                   RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], 
                 "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
               "}"}]}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<example_anime\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"{", "}"}], "\[IndentingNewLine]", ")"}]}], ",", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<solution\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Row", "@", 
               RowBox[{"{", 
                RowBox[{"Style", "[", 
                 RowBox[{"\"\<Solution\>\"", ",", 
                  RowBox[{"FontSize", "\[Rule]", "18"}], ",", 
                  RowBox[{"FontWeight", "\[Rule]", "Bold"}]}], "]"}], "}"}]}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"words", "[", "\"\<solution\>\"", "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
              RowBox[{"Row", "@", 
               RowBox[{"{", "\"\<Do this!\>\"", "}"}]}]}], 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", ")"}]}], 
          ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<correct\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "@", "correct"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<wrong\>\"", "\[Rule]", 
           RowBox[{"(", "\[IndentingNewLine]", 
            RowBox[{"myFRAME2", "/@", "wrong"}], "\[IndentingNewLine]", 
            ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<video\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"\"\<molecule\>\"", "\[Rule]", 
           RowBox[{"(", "molecule", ")"}]}], ",", " ", 
          RowBox[{"(*", 
           RowBox[{
           "used", " ", "for", " ", "the", " ", "question", " ", "or", " ", 
            "example"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"\"\<abcd\>\"", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{"{", "}"}], ")"}]}]}], "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.743591378145288*^9, 3.7435913783228416`*^9}, 
   3.7435914245272923`*^9, {3.747645912435511*^9, 3.747645912931457*^9}, {
   3.747646046339014*^9, 3.747646104958357*^9}, {3.747646178268447*^9, 
   3.7476462659830914`*^9}, {3.747646303851428*^9, 3.747646587917054*^9}, {
   3.7476468978391333`*^9, 3.747647021994542*^9}, {3.747647067615756*^9, 
   3.747647120247527*^9}, {3.747647157595894*^9, 3.7476478158261003`*^9}, {
   3.747648021545681*^9, 3.7476480304993067`*^9}, 3.747648158538848*^9, {
   3.747648217601945*^9, 3.747648277189116*^9}, {3.74764836065056*^9, 
   3.7476483863363857`*^9}, 3.747648584754449*^9, {3.747648653315894*^9, 
   3.747648675106042*^9}, 3.747648712019691*^9, {3.747652072587161*^9, 
   3.7476521769394712`*^9}, {3.747652214338584*^9, 3.747652299051979*^9}, {
   3.747652333005484*^9, 3.7476523859824667`*^9}, {3.747652425461397*^9, 
   3.747652498575881*^9}, {3.7476526613459806`*^9, 3.747652721734255*^9}, {
   3.7476527607964582`*^9, 3.7476528915116158`*^9}, {3.747652934960745*^9, 
   3.747652942452117*^9}, {3.7476531362383423`*^9, 3.747653140118181*^9}, 
   3.747653175139617*^9, {3.74765321397654*^9, 3.7476532305923443`*^9}, {
   3.7476532609698353`*^9, 3.7476532794190617`*^9}, {3.7476533395760403`*^9, 
   3.747653349136445*^9}, {3.7476533958824873`*^9, 3.7476534498820887`*^9}, {
   3.747653509228681*^9, 3.7476535109926033`*^9}, {3.7476536234851427`*^9, 
   3.7476536745256968`*^9}, {3.747653792136223*^9, 3.7476538165727882`*^9}, {
   3.747657684011483*^9, 3.747657719476804*^9}, {3.747755387603992*^9, 
   3.747755594775975*^9}, 3.747755664405353*^9, {3.7477557700221663`*^9, 
   3.747755771943378*^9}, {3.7477559067237186`*^9, 3.747755914968247*^9}, {
   3.747755977251218*^9, 3.747755986710528*^9}, {3.747756031016384*^9, 
   3.747756032938099*^9}, {3.7477560942847567`*^9, 3.747756114862994*^9}, {
   3.747757043373507*^9, 3.7477571211133223`*^9}, {3.747757175451339*^9, 
   3.747757217843132*^9}, {3.747757290970533*^9, 3.747757320668579*^9}, 
   3.7477573770008907`*^9, 3.747757441599079*^9, 3.747757539770707*^9, {
   3.74775757939053*^9, 3.747757602913329*^9}, {3.747758152813561*^9, 
   3.7477581553663197`*^9}, {3.74775823453484*^9, 3.747758237716332*^9}, {
   3.747758394805051*^9, 3.747758415166554*^9}, {3.747758476660748*^9, 
   3.747758517159707*^9}, {3.747758598916047*^9, 3.7477586398552647`*^9}, {
   3.747758801553321*^9, 3.747758811037794*^9}, 3.747758852821617*^9, {
   3.74775898991617*^9, 3.747759094643096*^9}, {3.747759158727518*^9, 
   3.747759191083475*^9}, {3.747759248548039*^9, 3.747759256793214*^9}, {
   3.749899287897168*^9, 3.7498993546647053`*^9}, {3.7498993850292053`*^9, 
   3.749899474016615*^9}, {3.749899613218589*^9, 3.749899614848016*^9}, {
   3.749899662021825*^9, 3.7498998451724157`*^9}, {3.74989988223138*^9, 
   3.749899990211074*^9}, {3.749900057184896*^9, 3.749900077592111*^9}, {
   3.749900245298415*^9, 3.749900248718545*^9}, {3.749900298196938*^9, 
   3.749900376520252*^9}, {3.7499005045495367`*^9, 3.749900524414012*^9}, {
   3.749900621246146*^9, 3.749900661690011*^9}, 3.7499006980530643`*^9, {
   3.749900905696843*^9, 3.749901021136734*^9}, {3.7499010886276293`*^9, 
   3.74990111383492*^9}, 3.7499011701779537`*^9, {3.7500794470920057`*^9, 
   3.750079465772596*^9}, {3.750079573374668*^9, 3.7500796085827093`*^9}, {
   3.750079674994081*^9, 3.750079838392001*^9}, {3.7500798855973463`*^9, 
   3.750079952602363*^9}, {3.750080002554082*^9, 3.75008009731293*^9}, {
   3.750080164749098*^9, 3.750080272996009*^9}, {3.750080347777001*^9, 
   3.750080385127924*^9}, {3.7500806413633633`*^9, 3.750080664401249*^9}, {
   3.750080716581388*^9, 3.750080736470241*^9}, {3.7500807689726963`*^9, 
   3.750080815851409*^9}, {3.750080847546114*^9, 3.75008091813962*^9}, {
   3.750080977192647*^9, 3.7500810080062733`*^9}, {3.750081038686339*^9, 
   3.7500810472115593`*^9}, {3.750082846582631*^9, 3.750082882577339*^9}, {
   3.750082915308641*^9, 3.750082942859433*^9}, {3.7500829865663652`*^9, 
   3.750082996321699*^9}, {3.750083094422861*^9, 3.75008317912534*^9}, {
   3.750083214114328*^9, 3.750083234455131*^9}, {3.750083287544785*^9, 
   3.75008329240341*^9}, {3.750083887461985*^9, 3.750083909660634*^9}, {
   3.750083943194852*^9, 3.750083952433617*^9}, {3.750083997838702*^9, 
   3.750084043534717*^9}, {3.750084616789651*^9, 3.750084667470994*^9}, {
   3.750102984233968*^9, 3.750102987472867*^9}, {3.75106712861125*^9, 
   3.75106713213026*^9}},ExpressionUUID->"01fbbe7d-3c8b-4d9c-8ac2-\
e4e2df2a40bc"],

Cell[BoxData[" "], "Input",
 CellChangeTimes->{
  3.750102992277067*^9},ExpressionUUID->"4a0cf7d2-fd44-4d34-abb6-\
f144d27eda97"],

Cell[TextData[StyleBox["\nDATA", "Title"]], "Text",
 CellChangeTimes->{{3.749899632416209*^9, 
  3.74989963313564*^9}},ExpressionUUID->"2c78abc7-86c8-46ce-8376-\
71d0306a8373"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "cache", " ", "items", " ", "to", " ", "avoid", " ", "wolfram", " ", 
    "uploads"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"items", "=", 
    RowBox[{"Table", "[", 
     RowBox[{"myITEM", ",", "128"}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.749900116186491*^9, 3.749900116320121*^9}, {
  3.749900196355455*^9, 3.749900196939002*^9}, {3.749900478623866*^9, 
  3.7499004820752068`*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"f2353949-af7b-40e2-aad1-fa8609391451"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"CloseKernels", "[", "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"LaunchKernels", "[", "4", "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{
  3.6929863650419817`*^9, 3.692986454414958*^9, 3.6952307852877607`*^9, 
   3.695230832145823*^9, 3.7154929585094347`*^9, 3.7154930444499702`*^9, {
   3.7155420050107937`*^9, 3.715542013503138*^9}, 3.715542179804946*^9, 
   3.715675712568962*^9, 3.730843910893158*^9, 3.730844121510347*^9, 
   3.730844251350174*^9, {3.730844390877315*^9, 3.730844392778469*^9}, {
   3.743597517958117*^9, 3.743597520679738*^9}, 3.74359770736696*^9, 
   3.749899625610067*^9, 3.7499001062646627`*^9, 3.750103032211162*^9},
 CellLabel->"In[10]:=",ExpressionUUID->"46d0027e-97d6-4609-ac6d-5ae6406cfb81"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"1", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"2", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"3", ",", "\<\"local\"\>"}], "]"}], ",", 
   RowBox[{"\<\"KernelObject\"\>", "[", 
    RowBox[{"4", ",", "\<\"local\"\>"}], "]"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7156762042658167`*^9, {3.715676237396799*^9, 3.7156762804823227`*^9}, 
   3.715676515697391*^9, {3.715676645702715*^9, 3.715676662093045*^9}, 
   3.716485950107836*^9, 3.730844128232019*^9, 3.730844253679215*^9, 
   3.7308443463882*^9, 3.743597667837785*^9, 3.7499000934134827`*^9, 
   3.750103050000362*^9},
 CellLabel->"Out[11]=",ExpressionUUID->"127423bd-7b6a-4437-849b-6c42db39936e"]
}, Open  ]],

Cell[TextData[{
 "\n",
 StyleBox["JSON ", "Title"],
 "\n"
}], "Text",
 CellChangeTimes->{{3.6835691058589563`*^9, 3.683569113484405*^9}, {
   3.683968837220786*^9, 3.683968837474803*^9}, {3.6879978170939083`*^9, 
   3.687997818004569*^9}, 
   3.71567570442386*^9},ExpressionUUID->"e695621a-5ea5-4ab1-a4ad-\
4ba5b535f69c"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"PNG", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"debugCORRECT", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"isSERVER", "=", "\"\<JSON\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<stackreverse1_\>\"", 
     ",", "\"\<SVG\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myGIFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<stackreverse1_\>\"", 
     ",", "\"\<GIF\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myCDFDIRECTORY", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<stackreverse1_\>\"", 
     ",", "\"\<cdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myPDFDIRECTORY", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<stackreverse1_\>\"", 
      ",", "\"\<pdf\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"myTITLE", "=", 
    RowBox[{"{", 
     RowBox[{"\"\< \>\"", ",", "\"\< \>\"", ",", "\"\< \>\""}], "}"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "ParallelTable", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"varilist", "=", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"logic1", ",", 
             RowBox[{"{", "}"}], ",", 
             RowBox[{"<|", 
              RowBox[{
               RowBox[{"\"\<type\>\"", "\[Rule]", "\"\<1\>\""}], ",", 
               RowBox[{"\"\<question\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<tutorial\>\"", "->", "myDIRECTORY"}], ",", 
               RowBox[{"\"\<anime\>\"", "->", "myGIFDIRECTORY"}]}], "|>"}]}], 
            "}"}], "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"nn", "=", 
          RowBox[{"Length", "@", "varilist"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"varilist", "=", 
          RowBox[{"RandomSample", "[", 
           RowBox[{"varilist", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
          "uncomment", " ", "these", " ", "two", " ", "lines", " ", "if", " ",
            "chained", " ", "questions"}], "*)"}], "\[IndentingNewLine]", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"varilist", "=", 
            RowBox[{"Flatten", "[", 
             RowBox[{"varilist", ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"nn", "=", 
            RowBox[{"Length", "@", "varilist"}]}], ";"}], "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"tmp", "=", 
          RowBox[{"ConstantArray", "[", 
           RowBox[{"\"\<\>\"", ",", "nn"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"logics", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"words", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"etc", "=", 
          RowBox[{"varilist", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "3"}], "]"}], "]"}]}], ";", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"title", "=", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"1", "\[Rule]", "\"\<\>\""}], ",", "\[IndentingNewLine]", 
            
            RowBox[{"2", "\[Rule]", "\"\<2. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"3", "\[Rule]", "\"\<3. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"4", "\[Rule]", "\"\<4. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"5", "\[Rule]", "\"\<5. \>\""}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"6", "\[Rule]", "\"\<6. \>\""}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "ii", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{"makeVAR", "[", 
              RowBox[{
               RowBox[{"title", "[", "ii", "]"}], ",", 
               RowBox[{"logics", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"words", "[", 
                RowBox[{"[", "ii", "]"}], "]"}], ",", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"ii", "\[Equal]", "1"}], ",", 
                 RowBox[{"{", "}"}], ",", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"(", " ", 
                    RowBox[{"tmp", "[", 
                    RowBox[{"[", 
                    RowBox[{"ii", "-", "1"}], "]"}], "]"}], ")"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "]"}], ",", 
               RowBox[{"etc", "[", 
                RowBox[{"[", "ii", "]"}], "]"}]}], "]"}], "[", "\"\<json\>\"",
              "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"ii", ",", "1", ",", "nn"}], "}"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"{", "32", "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "4", "}"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"vars", "=", 
    RowBox[{"Flatten", "[", 
     RowBox[{"vars", ",", "1"}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Export", "[", 
    RowBox[{
     RowBox[{"FileNameJoin", "@", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], ",", "\"\<cache\>\"", ",", 
        "\"\<cache.json\>\""}], "}"}]}], ",", "vars"}], "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"CloseKernels", "[", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.683569147776939*^9, 3.683569206197641*^9}, {
   3.6835697350372877`*^9, 3.683569735361682*^9}, 3.683570213191965*^9, {
   3.683570379155171*^9, 3.6835703885256433`*^9}, 3.683570675473517*^9, {
   3.6835741023361177`*^9, 3.683574124746027*^9}, 3.683574208987146*^9, {
   3.683968848293377*^9, 3.68396894259125*^9}, 3.683969708290792*^9, {
   3.6839967522182293`*^9, 3.683996784583543*^9}, 3.683996934606318*^9, {
   3.683998214157271*^9, 3.683998214403244*^9}, {3.6840470985844507`*^9, 
   3.68404711329843*^9}, {3.684058315175214*^9, 3.684058347405676*^9}, {
   3.684058478709052*^9, 3.684058480237769*^9}, {3.6840620724929647`*^9, 
   3.684062081345399*^9}, 3.684062121868043*^9, {3.684062217899884*^9, 
   3.684062220575553*^9}, {3.6844334000107193`*^9, 3.684433494523073*^9}, {
   3.684433562161273*^9, 3.684433563915319*^9}, {3.684468075316896*^9, 
   3.6844680781719313`*^9}, {3.6844681818570833`*^9, 
   3.6844682203656597`*^9}, {3.684469149848482*^9, 3.68446920230729*^9}, 
   3.6844692657816973`*^9, {3.684663488523902*^9, 3.684663601034597*^9}, {
   3.684663632143784*^9, 3.684663646969202*^9}, 3.684663719758614*^9, {
   3.685208865699643*^9, 3.6852088695791597`*^9}, {3.6852224497213097`*^9, 
   3.685222475732339*^9}, {3.685222544268159*^9, 3.6852225497247553`*^9}, {
   3.6860386415521383`*^9, 3.686038723958976*^9}, {3.686038896908696*^9, 
   3.686038898978252*^9}, {3.686040862451523*^9, 3.6860408671200647`*^9}, {
   3.6860666312782173`*^9, 3.686066655319268*^9}, {3.6860668986960506`*^9, 
   3.686066898762806*^9}, {3.6863350098331337`*^9, 3.686335010394196*^9}, 
   3.68633717401134*^9, {3.686832282918125*^9, 3.686832344198402*^9}, {
   3.686832727848927*^9, 3.686832760328903*^9}, {3.686833273574872*^9, 
   3.686833277376639*^9}, {3.6868381447329283`*^9, 3.6868381447892523`*^9}, {
   3.6871344031350927`*^9, 3.687134407273718*^9}, {3.687134508573378*^9, 
   3.687134509505727*^9}, {3.687134541875031*^9, 3.687134561855377*^9}, 
   3.687134739419014*^9, {3.687997822438352*^9, 3.687997874798586*^9}, 
   3.6879995419083843`*^9, {3.688061890149387*^9, 3.688061927240719*^9}, {
   3.688062017806532*^9, 3.6880620197294283`*^9}, {3.688062063559791*^9, 
   3.688062078928267*^9}, {3.688062200621763*^9, 3.68806220107028*^9}, {
   3.688483463735353*^9, 3.688483463835477*^9}, {3.6888696931435223`*^9, 
   3.688869695268732*^9}, {3.689850736309804*^9, 3.689850825346669*^9}, {
   3.689871385479834*^9, 3.689871395614653*^9}, {3.690017892148489*^9, 
   3.6900179165162888`*^9}, {3.690018075312461*^9, 3.690018075435377*^9}, {
   3.690302171829175*^9, 3.690302202452557*^9}, 3.690302751887293*^9, {
   3.690309368911311*^9, 3.690309372487529*^9}, {3.690322636693387*^9, 
   3.690322659452149*^9}, {3.69032271144116*^9, 3.690322713059854*^9}, {
   3.692746146408525*^9, 3.692746182270113*^9}, 3.692746225878511*^9, {
   3.6927464184154787`*^9, 3.692746421959099*^9}, {3.692986374065197*^9, 
   3.692986395750598*^9}, {3.692986448621711*^9, 3.692986450465274*^9}, {
   3.695204665517051*^9, 3.6952046712013764`*^9}, {3.695204702280154*^9, 
   3.6952047160599422`*^9}, {3.695230752419141*^9, 3.695230775400646*^9}, {
   3.695230806134601*^9, 3.695230837105688*^9}, {3.6968451926748333`*^9, 
   3.696845224917677*^9}, {3.69697529329644*^9, 3.696975298536854*^9}, {
   3.701175316514217*^9, 3.7011753417316594`*^9}, {3.706109694181323*^9, 
   3.70610970012134*^9}, {3.706109866312333*^9, 3.706109866883911*^9}, {
   3.715443730846878*^9, 3.715443754370517*^9}, {3.715492925187255*^9, 
   3.715492964280024*^9}, {3.7154930128816633`*^9, 3.715493013086049*^9}, {
   3.7154930494891233`*^9, 3.715493051829221*^9}, {3.71554170777013*^9, 
   3.7155417155649567`*^9}, {3.715541883126856*^9, 3.715541891563876*^9}, {
   3.715542009398087*^9, 3.7155420110289288`*^9}, {3.715542183438938*^9, 
   3.715542185305827*^9}, 3.7155425945107203`*^9, {3.715542924388612*^9, 
   3.715542928099658*^9}, {3.715543003398696*^9, 3.715543013264819*^9}, {
   3.715675730525919*^9, 3.7156757448794823`*^9}, {3.715675842499428*^9, 
   3.715675860599105*^9}, 3.7156759109810677`*^9, {3.715675979210672*^9, 
   3.715675979603969*^9}, {3.715676028127158*^9, 3.715676177374057*^9}, {
   3.715676230925146*^9, 3.715676260332451*^9}, {3.715676620439131*^9, 
   3.715676655214316*^9}, {3.7158981069831963`*^9, 3.715898130686473*^9}, {
   3.715931581969088*^9, 3.7159316304449263`*^9}, {3.717094778903976*^9, 
   3.71709477920865*^9}, 3.717323834568632*^9, {3.71775413123803*^9, 
   3.717754132599062*^9}, 3.7199097374131317`*^9, {3.7199246234527817`*^9, 
   3.719924703238511*^9}, {3.720042601829308*^9, 3.7200426035605383`*^9}, {
   3.730843810079851*^9, 3.730843837162004*^9}, {3.730844126877118*^9, 
   3.73084412854283*^9}, {3.730844386133678*^9, 3.730844388043399*^9}, {
   3.743597528738099*^9, 3.743597584436431*^9}, {3.743597697322775*^9, 
   3.743597699998611*^9}, {3.7476089314393787`*^9, 3.747608964867762*^9}, {
   3.7476563245503187`*^9, 3.747656369313794*^9}, {3.74990073721008*^9, 
   3.749900765839369*^9}, {3.7501030578852253`*^9, 3.750103071407653*^9}},
 CellLabel->"In[12]:=",ExpressionUUID->"2eb2e082-0344-400c-b8b9-756f2e6fe122"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox["\<\"Initializing WordData indices ....\"\>",
  StringForm["Initializing `1` indices ....", "WordData"],
  Editable->False]], "Print",
 ShowCellLabel->True,
 CellChangeTimes->{3.750103073820994*^9},
 CellLabel->
  "(kernel 4)",ExpressionUUID->"0171c234-c61e-4d38-b204-0817b4212099"],

Cell[BoxData[
 InterpretationBox["\<\"Initializing WordData indices ....\"\>",
  StringForm["Initializing `1` indices ....", "WordData"],
  Editable->False]], "Print",
 ShowCellLabel->True,
 CellChangeTimes->{3.750103073848345*^9},
 CellLabel->
  "(kernel 3)",ExpressionUUID->"75ce31b1-85fc-4e60-a8f3-e1133e6fc957"],

Cell[BoxData[
 InterpretationBox["\<\"Initializing WordData indices ....\"\>",
  StringForm["Initializing `1` indices ....", "WordData"],
  Editable->False]], "Print",
 ShowCellLabel->True,
 CellChangeTimes->{3.7501030738990726`*^9},
 CellLabel->
  "(kernel 2)",ExpressionUUID->"a1c8591b-d8cc-4c68-8b70-6d68c3848d05"],

Cell[BoxData[
 InterpretationBox["\<\"Initializing WordData indices ....\"\>",
  StringForm["Initializing `1` indices ....", "WordData"],
  Editable->False]], "Print",
 ShowCellLabel->True,
 CellChangeTimes->{3.750103073943315*^9},
 CellLabel->
  "(kernel 1)",ExpressionUUID->"e84e3e3f-06f3-4429-ad78-3d2c406d7623"]
}, Open  ]]
}, Open  ]]
},
WindowSize->{935, 1023},
WindowMargins->{{Automatic, 805}, {Automatic, 81}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
Background->GrayLevel[0.85],
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1314, 32, 94, "Input",ExpressionUUID->"d3a81193-5b95-4b63-a627-710cb8ed9f74"],
Cell[1875, 54, 198, 6, 97, "Text",ExpressionUUID->"904f75c0-c7fe-4c85-8e19-eb762f16bff6"],
Cell[CellGroupData[{
Cell[2098, 64, 572, 10, 94, "Input",ExpressionUUID->"274a6bea-261d-4d1e-971b-dc0db75c09c8"],
Cell[2673, 76, 454, 7, 34, "Output",ExpressionUUID->"ed416b0f-41ca-4985-9600-25b89e48b17c"],
Cell[3130, 85, 461, 7, 34, "Output",ExpressionUUID->"ce18c3ec-cd2a-4c0d-84ca-683226ee27e9"]
}, Open  ]],
Cell[3606, 95, 198, 3, 73, "Text",ExpressionUUID->"a005360a-0834-4552-8e46-735d06e988d9"],
Cell[3807, 100, 28983, 575, 4483, "Input",ExpressionUUID->"01fbbe7d-3c8b-4d9c-8ac2-e4e2df2a40bc"],
Cell[32793, 677, 129, 3, 30, "Input",ExpressionUUID->"4a0cf7d2-fd44-4d34-abb6-f144d27eda97"],
Cell[32925, 682, 176, 3, 135, "Text",ExpressionUUID->"2c78abc7-86c8-46ce-8376-71d0306a8373"],
Cell[33104, 687, 571, 13, 73, "Input",ExpressionUUID->"f2353949-af7b-40e2-aad1-fa8609391451"],
Cell[CellGroupData[{
Cell[33700, 704, 930, 17, 178, "Input",ExpressionUUID->"46d0027e-97d6-4609-ac6d-5ae6406cfb81"],
Cell[34633, 723, 845, 17, 34, "Output",ExpressionUUID->"127423bd-7b6a-4437-849b-6c42db39936e"]
}, Open  ]],
Cell[35493, 743, 321, 9, 120, "Text",ExpressionUUID->"e695621a-5ea5-4ab1-a4ad-4ba5b535f69c"],
Cell[CellGroupData[{
Cell[35839, 756, 12080, 243, 1270, "Input",ExpressionUUID->"2eb2e082-0344-400c-b8b9-756f2e6fe122"],
Cell[CellGroupData[{
Cell[47944, 1003, 315, 7, 24, "Print",ExpressionUUID->"0171c234-c61e-4d38-b204-0817b4212099"],
Cell[48262, 1012, 315, 7, 24, "Print",ExpressionUUID->"75ce31b1-85fc-4e60-a8f3-e1133e6fc957"],
Cell[48580, 1021, 317, 7, 24, "Print",ExpressionUUID->"a1c8591b-d8cc-4c68-8b70-6d68c3848d05"],
Cell[48900, 1030, 315, 7, 24, "Print",ExpressionUUID->"e84e3e3f-06f3-4429-ad78-3d2c406d7623"]
}, Open  ]]
}, Open  ]]
}
]
*)

