(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     41126,       1008]
NotebookOptionsPosition[     39503,        973]
NotebookOutlinePosition[     39893,        990]
CellTagsIndexPosition[     39850,        987]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SetOptions", "[", 
    RowBox[{
     RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
     RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.721468406944483*^9, 
  3.721468427810919*^9}},ExpressionUUID->"eaa3350a-0c7e-4938-95ea-\
18d46dd76ec6"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"expr1", "=", 
  RowBox[{"RandomChoice", "@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CirclePlus", "[", 
      RowBox[{
       RowBox[{"CircleTimes", "[", 
        RowBox[{"1", ",", "2"}], "]"}], ",", 
       RowBox[{"CircleTimes", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "]"}], ",", 
     RowBox[{"CirclePlus", "[", 
      RowBox[{"2", ",", 
       RowBox[{"CircleTimes", "[", 
        RowBox[{"3", ",", "4"}], "]"}]}], "]"}], ",", 
     RowBox[{"CirclePlus", "[", 
      RowBox[{"1", ",", 
       RowBox[{"CircleTimes", "[", 
        RowBox[{
         RowBox[{"CircleTimes", "[", 
          RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}]}], "]"}]}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list0", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TraceScan", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"AppendTo", "[", 
       RowBox[{"list0", ",", 
        RowBox[{"#", "/.", 
         RowBox[{"{", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"HoldForm", "\[Rule]", "Identity"}], ",", 
            RowBox[{"Plus", "\[Rule]", "\"\<+\>\""}], ",", 
            RowBox[{"Times", "\[Rule]", "\"\<*\>\""}], ",", 
            RowBox[{"Divide", "\[Rule]", "\"\</\>\""}], ",", 
            RowBox[{"Subtract", "\[Rule]", "\"\<-\>\""}], ",", 
            RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
            RowBox[{"Sqrt", "->", "\"\<sqr\>\""}]}], "*)"}], "}"}]}]}], "]"}],
       "&"}], ",", 
     RowBox[{"CirclePlus", "[", 
      RowBox[{"1", ",", 
       RowBox[{"CircleTimes", "[", 
        RowBox[{
         RowBox[{"CircleTimes", "[", 
          RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}]}], "]"}]}], "]"}],
    ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"#", ",", "InputForm"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"\"\<HoldForm\>\"", "\[Rule]", "\"\<\>\""}], ",", 
         RowBox[{"\"\<[\>\"", "\[Rule]", "\"\<(\>\""}], ",", 
         RowBox[{"\"\<]\>\"", "\[Rule]", "\"\<)\>\""}], ",", 
         RowBox[{"\"\<CirclePlus\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
         RowBox[{"\"\<\[CirclePlus]\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
         RowBox[{"\"\<CircleTimes\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
         RowBox[{"\"\<\[CircleTimes]\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
         RowBox[{"\"\<Divide\>\"", "\[Rule]", "\"\</\>\""}], ",", 
         RowBox[{"\"\<Subtract\>\"", "\[Rule]", "\"\<-\>\""}], ",", 
         RowBox[{"\"\<Power\>\"", "\[Rule]", "\"\<^\>\""}], ",", 
         RowBox[{"\"\<Sqrt\>\"", "->", "\"\<sqr\>\""}]}], "}"}]}], "]"}], 
     "&"}], "/@", "list0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"list1", "=", 
  RowBox[{"Reverse", "@", "list1"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.721593164185485*^9, 3.721593172521349*^9}, {
   3.72159330770715*^9, 3.7215933090332527`*^9}, {3.721593343438283*^9, 
   3.72159336092033*^9}, 3.721593463168357*^9, {3.7215935010110617`*^9, 
   3.721593568973488*^9}, {3.72159367130824*^9, 3.721593732873455*^9}, {
   3.721593991955558*^9, 3.721593995543086*^9}, {3.721594049084972*^9, 
   3.7215940724628*^9}, {3.7215942044408693`*^9, 3.721594207545805*^9}, {
   3.721594385080593*^9, 3.721594467721168*^9}, 3.721594504657899*^9, {
   3.72159465659503*^9, 3.721594658294735*^9}, {3.7215947127223053`*^9, 
   3.721594741364979*^9}, {3.7215949767243347`*^9, 3.721594976869055*^9}, {
   3.7215950277452183`*^9, 3.721595030623632*^9}, {3.721595081015444*^9, 
   3.721595087010742*^9}, {3.721595138673429*^9, 3.721595143419945*^9}, {
   3.7215951756531353`*^9, 3.721595227179173*^9}, {3.72159582961551*^9, 
   3.721595831674693*^9}, {3.721595950613224*^9, 3.721595950916279*^9}, 
   3.721596623683838*^9, {3.721596705323295*^9, 3.721596719801928*^9}, {
   3.721596819323196*^9, 3.721596822585672*^9}, {3.721596879716589*^9, 
   3.721596884281795*^9}, {3.721597037381564*^9, 3.72159717154928*^9}, {
   3.721597214752146*^9, 3.7215972150882473`*^9}, {3.7215973226099863`*^9, 
   3.721597353367248*^9}, {3.721597515677779*^9, 3.7215975163967*^9}, 
   3.721597553084868*^9, {3.7215981777767563`*^9, 3.721598183521412*^9}, {
   3.721598262938945*^9, 3.72159827816331*^9}, {3.7215984207137747`*^9, 
   3.721598430166888*^9}, {3.721598517916809*^9, 3.721598518895153*^9}, {
   3.721598554233449*^9, 3.721598575219572*^9}, {3.721629758376452*^9, 
   3.721629766978237*^9}, {3.721632224646132*^9, 3.721632393379911*^9}, {
   3.721632827059988*^9, 3.7216328947637053`*^9}, {3.721632926771068*^9, 
   3.72163293644704*^9}, {3.721633037565507*^9, 3.7216330429084578`*^9}, {
   3.721633137243779*^9, 3.7216331437570677`*^9}, {3.7216331775316877`*^9, 
   3.72163321272185*^9}, {3.721633280236952*^9, 3.721633344915037*^9}, {
   3.7216333815011663`*^9, 3.721633396812316*^9}, {3.721633428257884*^9, 
   3.72163343584007*^9}, {3.721633506279387*^9, 3.7216335750980453`*^9}, {
   3.72163365784546*^9, 3.721633709753758*^9}, {3.721633975498987*^9, 
   3.7216339841723967`*^9}, {3.7216343868469963`*^9, 3.721634404610063*^9}, 
   3.721634465183002*^9, {3.721634513053418*^9, 3.721634527003065*^9}, {
   3.721634559055231*^9, 3.721634632474791*^9}, {3.721642599672454*^9, 
   3.721642647383502*^9}, {3.7216427679318438`*^9, 3.72164278937493*^9}, {
   3.721642837111002*^9, 3.7216428430619164`*^9}, {3.721643335491941*^9, 
   3.721643336784265*^9}, {3.721643444619824*^9, 3.721643453225111*^9}, {
   3.72164351707209*^9, 3.721643518669025*^9}, 3.721643561907515*^9, {
   3.721643600324956*^9, 3.7216436213959103`*^9}, {3.721643668783593*^9, 
   3.7216436844772367`*^9}, {3.7216437262507257`*^9, 
   3.7216437454988832`*^9}, {3.721643778163451*^9, 3.7216437878836184`*^9}, 
   3.721643887309691*^9, 
   3.72164395311695*^9},ExpressionUUID->"d7b79285-cf6b-4c22-a06e-\
9940e4a5c546"],

Cell[BoxData[
 RowBox[{
  RowBox[{"1", "\[CircleTimes]", "2"}], "\[CirclePlus]", 
  RowBox[{"3", "\[CircleTimes]", "4"}]}]], "Output",
 CellChangeTimes->{
  3.721642648383864*^9, {3.721642776104034*^9, 3.7216427899270973`*^9}, 
   3.721642843329363*^9, 3.721643337224842*^9, 3.721643454643524*^9, 
   3.721643562772417*^9, {3.721643621745594*^9, 3.7216436241061897`*^9}, {
   3.721643673310883*^9, 3.7216436848289127`*^9}, 3.721643746197365*^9, {
   3.721643778943989*^9, 3.72164378900816*^9}, {3.7216438885572777`*^9, 
   3.721643889893404*^9}, {3.721643954416801*^9, 
   3.721643955722021*^9}},ExpressionUUID->"e1f3b5f6-23f0-4b97-a5ed-\
6f223e5111f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"(4)\"\>", ",", "\<\"(3)\"\>", ",", "\<\"(2)\"\>", 
   ",", "\<\"(*)\"\>", ",", "\<\"(2 * 3)\"\>", ",", "\<\"(*)\"\>", 
   ",", "\<\"((2 * 3) * 4)\"\>", ",", "\<\"(1)\"\>", ",", "\<\"(+)\"\>", 
   ",", "\<\"(1 + (2 * 3) * 4)\"\>"}], "}"}]], "Output",
 CellChangeTimes->{
  3.721642648383864*^9, {3.721642776104034*^9, 3.7216427899270973`*^9}, 
   3.721642843329363*^9, 3.721643337224842*^9, 3.721643454643524*^9, 
   3.721643562772417*^9, {3.721643621745594*^9, 3.7216436241061897`*^9}, {
   3.721643673310883*^9, 3.7216436848289127`*^9}, 3.721643746197365*^9, {
   3.721643778943989*^9, 3.72164378900816*^9}, {3.7216438885572777`*^9, 
   3.721643889893404*^9}, {3.721643954416801*^9, 
   3.721643955733025*^9}},ExpressionUUID->"82bd7a02-885d-4982-8357-\
4da2cbabf8d3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["list0"], "Input",
 CellChangeTimes->{{3.721634409452696*^9, 
  3.721634413992581*^9}},ExpressionUUID->"14a1df8e-9de9-49d9-85ab-\
b6311d6cbfb0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox["expr",
    HoldForm], ",", 
   TagBox[
    RowBox[{
     RowBox[{"1", "\[CircleTimes]", "2"}], "\[CirclePlus]", 
     RowBox[{"3", "\[CircleTimes]", "4"}]}],
    HoldForm]}], "}"}]], "Output",
 CellChangeTimes->{{3.72163441079471*^9, 3.7216344146746607`*^9}, {
   3.721634519028839*^9, 3.721634546227045*^9}, 3.721634635396043*^9, 
   3.721642652881404*^9},ExpressionUUID->"e1d0cae4-2dc6-4c51-bd7a-\
055a4fa5ba0b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "list1"}]], "Input",
 CellChangeTimes->{{3.7216345478004827`*^9, 
  3.721634548884158*^9}},ExpressionUUID->"8e1f81db-eaa3-4431-b573-\
be976f6a99cf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"(1 * 2 + 3 * 4)\"\>", ",", "\<\"(expr)\"\>"}], "}"}]], "Output",\

 CellChangeTimes->{3.721634549931487*^9, 3.721634636284309*^9, 
  3.721642654243629*^9},ExpressionUUID->"48c62492-6f09-4653-8cab-\
97f78fe025ce"]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"list2", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TraceScan", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AppendTo", "[", 
      RowBox[{"list2", ",", 
       RowBox[{
        RowBox[{"TreeForm", "[", 
         RowBox[{"#", ",", 
          RowBox[{"ImageSize", "\[Rule]", "200"}], ",", 
          RowBox[{"AspectRatio", "\[Rule]", ".4"}]}], "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"HoldForm", "\[Rule]", "Identity"}], ",", 
          RowBox[{"CirclePlus", "\[Rule]", "\"\<+\>\""}], ",", 
          RowBox[{"CircleTimes", "\[Rule]", "\"\<*\>\""}], ",", 
          RowBox[{"Subtract", "\[Rule]", "\"\<-\>\""}], ",", 
          RowBox[{"Power", "\[Rule]", "\"\<^\>\""}], ",", 
          RowBox[{"Divide", "\[Rule]", "\"\</\>\""}], ",", 
          RowBox[{"Sqrt", "->", "\"\<sqr\>\""}]}], "}"}]}]}], "]"}], "&"}], 
    ",", 
    RowBox[{"CirclePlus", "[", 
     RowBox[{"1", ",", 
      RowBox[{"CircleTimes", "[", 
       RowBox[{
        RowBox[{"CircleTimes", "[", 
         RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"list2", "=", 
   RowBox[{"Reverse", "@", "list2"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.721593241535204*^9, 3.721593280401311*^9}, {
   3.721593369227509*^9, 3.721593387111397*^9}, {3.721593423046262*^9, 
   3.72159343827919*^9}, {3.721594034978827*^9, 3.721594054967495*^9}, 
   3.721594087717369*^9, {3.7215947673313847`*^9, 3.72159476752181*^9}, {
   3.721594980953064*^9, 3.721594981189528*^9}, {3.721595202877844*^9, 
   3.721595231645372*^9}, {3.721595265206064*^9, 3.721595310050499*^9}, {
   3.7215953488298607`*^9, 3.721595408771822*^9}, {3.7215954577450333`*^9, 
   3.7215954722154207`*^9}, {3.721595524493577*^9, 3.7215955281275263`*^9}, 
   3.7215956133974648`*^9, {3.7215956598918533`*^9, 3.721595688523728*^9}, {
   3.721595806881187*^9, 3.721595834508727*^9}, {3.721595904531638*^9, 
   3.72159594406458*^9}, {3.721596107217874*^9, 3.7215961260588007`*^9}, {
   3.7215962254712276`*^9, 3.721596249242414*^9}, {3.721596558022498*^9, 
   3.7215965699344597`*^9}, {3.721596600660129*^9, 3.7215966080172987`*^9}, 
   3.721596723232423*^9, {3.721596827186741*^9, 3.7215968297518063`*^9}, {
   3.721596888804626*^9, 3.7215968903454323`*^9}, {3.721597137453698*^9, 
   3.721597141994483*^9}, 3.721597177155632*^9, {3.721597288036517*^9, 
   3.7215972888685427`*^9}, 3.721597392578566*^9, {3.7215975066202383`*^9, 
   3.721597509747003*^9}, 3.721597549057014*^9, 3.7215981912429743`*^9, 
   3.721598283315612*^9, {3.721598447245006*^9, 3.721598452630352*^9}, {
   3.721642676308116*^9, 3.7216426769830103`*^9}, 3.72164356592341*^9, 
   3.721643629036962*^9, 3.721643753872658*^9, {3.721643792978744*^9, 
   3.72164380384658*^9}, 3.721643883845028*^9, {3.7216439425712*^9, 
   3.721643949277081*^9}},ExpressionUUID->"93867fef-e690-47d6-ba1d-\
ba6e011e5d99"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Length", "@", "list1"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "@", "list2"}], "\[IndentingNewLine]", 
 RowBox[{"Grid", "[", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"list1", "[", 
       RowBox[{"[", "i", "]"}], "]"}], ",", 
      RowBox[{"list2", "[", 
       RowBox[{"[", "i", "]"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "1", ",", 
      RowBox[{"Length", "@", "list1"}]}], "}"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.721594093111823*^9, 3.721594159191242*^9}, 
   3.721594888982212*^9, {3.721594983742786*^9, 
   3.721594985025186*^9}},ExpressionUUID->"1bcaeda2-bf3f-4f2e-a45a-\
b93baea6b90e"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{{3.721594143048637*^9, 3.721594159436337*^9}, 
   3.721594211338841*^9, 3.721594533421892*^9, {3.7215947550259933`*^9, 
   3.721594770100663*^9}, 3.721594889470584*^9, 3.721594985308457*^9, {
   3.721595194695229*^9, 3.721595234512436*^9}, {3.721595287073091*^9, 
   3.721595312419714*^9}, 3.721595351498851*^9, {3.721595382074448*^9, 
   3.721595411375268*^9}, 3.721595474769713*^9, 3.721595530488291*^9, 
   3.721595617662674*^9, {3.721595662865917*^9, 3.721595690904626*^9}, {
   3.721595812126678*^9, 3.721595836616741*^9}, {3.721595906621397*^9, 
   3.721595955289885*^9}, 3.7215961294388037`*^9, {3.721596227755488*^9, 
   3.721596253629116*^9}, 3.72159657229294*^9, {3.7215966108495913`*^9, 
   3.721596627081999*^9}, {3.721596709527199*^9, 3.721596724897273*^9}, 
   3.721596832207346*^9, 3.721596892869142*^9, 3.721597144096879*^9, 
   3.721597181298484*^9, 3.7215972921012363`*^9, 3.721597395756774*^9, 
   3.7215975203655567`*^9, 3.721597558161825*^9, 3.721598196492096*^9, 
   3.721598287023552*^9, 3.721598455207128*^9, 3.7215985231139183`*^9, 
   3.7215985807958097`*^9, 3.721629599157144*^9, 3.7216426803028297`*^9, 
   3.7216435692168493`*^9, 3.72164363311406*^9, 3.721643758423135*^9, 
   3.721643807881442*^9, 3.721643893808436*^9, 
   3.721643960100727*^9},ExpressionUUID->"89cfcf59-a688-41b5-85f5-\
45ae6a91596b"],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{{3.721594143048637*^9, 3.721594159436337*^9}, 
   3.721594211338841*^9, 3.721594533421892*^9, {3.7215947550259933`*^9, 
   3.721594770100663*^9}, 3.721594889470584*^9, 3.721594985308457*^9, {
   3.721595194695229*^9, 3.721595234512436*^9}, {3.721595287073091*^9, 
   3.721595312419714*^9}, 3.721595351498851*^9, {3.721595382074448*^9, 
   3.721595411375268*^9}, 3.721595474769713*^9, 3.721595530488291*^9, 
   3.721595617662674*^9, {3.721595662865917*^9, 3.721595690904626*^9}, {
   3.721595812126678*^9, 3.721595836616741*^9}, {3.721595906621397*^9, 
   3.721595955289885*^9}, 3.7215961294388037`*^9, {3.721596227755488*^9, 
   3.721596253629116*^9}, 3.72159657229294*^9, {3.7215966108495913`*^9, 
   3.721596627081999*^9}, {3.721596709527199*^9, 3.721596724897273*^9}, 
   3.721596832207346*^9, 3.721596892869142*^9, 3.721597144096879*^9, 
   3.721597181298484*^9, 3.7215972921012363`*^9, 3.721597395756774*^9, 
   3.7215975203655567`*^9, 3.721597558161825*^9, 3.721598196492096*^9, 
   3.721598287023552*^9, 3.721598455207128*^9, 3.7215985231139183`*^9, 
   3.7215985807958097`*^9, 3.721629599157144*^9, 3.7216426803028297`*^9, 
   3.7216435692168493`*^9, 3.72164363311406*^9, 3.721643758423135*^9, 
   3.721643807881442*^9, 3.721643893808436*^9, 
   3.7216439601063957`*^9},ExpressionUUID->"77823135-63f8-4d36-b9e4-\
a37613973688"],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"(4)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["4",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["4", HoldForm]],
          Annotation[#, 
           HoldForm[4], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(3)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["3",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["3", HoldForm]],
          Annotation[#, 
           HoldForm[3], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(2)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["2",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["2", HoldForm]],
          Annotation[#, 
           HoldForm[2], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(*)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["\<\"*\"\>",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["\"*\"", HoldForm]],
          Annotation[#, 
           HoldForm["*"], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(2 * 3)\"\>", 
     GraphicsBox[
      TagBox[
       GraphicsComplexBox[{{0.4472135954999579, 0.8944271909999159}, {0., 
        0.}, {0.8944271909999159, 0.}}, {
         {RGBColor[0.55, 0.45, 0.45], LineBox[{{1, 2}, {1, 3}}]}, {
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 1],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"2", ",", "3"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[2, 3]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["2",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 2],
            TagBox["2", HoldForm]],
           Annotation[#, 
            HoldForm[2], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["3",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 3],
            TagBox["3", HoldForm]],
           Annotation[#, 
            HoldForm[3], "Tooltip"]& ]}}],
       Annotation[#, 
        VertexCoordinateRules -> {{0.4472135954999579, 0.8944271909999159}, {
         0., 0.}, {0.8944271909999159, 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(*)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["\<\"*\"\>",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["\"*\"", HoldForm]],
          Annotation[#, 
           HoldForm["*"], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"((2 * 3) * 4)\"\>", 
     GraphicsBox[
      TagBox[
       GraphicsComplexBox[{{0.8944271909999159, 1.7888543819998317`}, {
        0.4472135954999579, 0.8944271909999159}, {0., 0.}, {
        0.8944271909999159, 0.}, {1.3416407864998738`, 
        0.8944271909999159}}, {
         {RGBColor[0.55, 0.45, 0.45], 
          LineBox[{{1, 2}, {1, 5}, {2, 3}, {2, 4}}]}, {
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 1],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}], 
             HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[
              "*"[2, 3], 4]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 2],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"2", ",", "3"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[2, 3]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["2",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 3],
            TagBox["2", HoldForm]],
           Annotation[#, 
            HoldForm[2], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["3",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 4],
            TagBox["3", HoldForm]],
           Annotation[#, 
            HoldForm[3], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["4",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 5],
            TagBox["4", HoldForm]],
           Annotation[#, 
            HoldForm[4], "Tooltip"]& ]}}],
       Annotation[#, 
        VertexCoordinateRules -> {{0.8944271909999159, 1.7888543819998317`}, {
         0.4472135954999579, 0.8944271909999159}, {0., 0.}, {
         0.8944271909999159, 0.}, {1.3416407864998738`, 
         0.8944271909999159}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(1)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["1",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["1", HoldForm]],
          Annotation[#, 
           HoldForm[1], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(+)\"\>", 
     GraphicsBox[
      TagBox[GraphicsComplexBox[{{0., 0.}}, {
         {RGBColor[0.55, 0.45, 0.45]}, 
         TagBox[
          TooltipBox[InsetBox[
            FrameBox[
             StyleBox[
              TagBox["\<\"+\"\>",
               HoldForm], "StandardForm", "Output",
              StripOnInput->False,
              LineColor->GrayLevel[0],
              FrontFaceColor->GrayLevel[0],
              BackFaceColor->GrayLevel[0],
              GraphicsColor->GrayLevel[0],
              FontSize->Scaled[0.05],
              FontColor->GrayLevel[0]],
             Background->RGBColor[1., 1., 0.871],
             FrameStyle->GrayLevel[0.5],
             StripOnInput->False], 1],
           TagBox["\"+\"", HoldForm]],
          Annotation[#, 
           HoldForm["+"], "Tooltip"]& ]}],
       Annotation[#, VertexCoordinateRules -> {{0., 0.}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]},
    {"\<\"(1 + (2 * 3) * 4)\"\>", 
     GraphicsBox[
      TagBox[
       GraphicsComplexBox[{{0.4472135954999579, 2.6832815729997477`}, {0., 
        1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
        0.4472135954999579, 0.894427190999916}, {0., 0.}, {0.8944271909999159,
         0.}, {1.3416407864998738`, 0.894427190999916}}, {
         {RGBColor[0.55, 0.45, 0.45], 
          LineBox[{{1, 2}, {1, 3}, {3, 4}, {3, 7}, {4, 5}, {4, 6}}]}, {
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"+\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 1],
            TagBox[
             RowBox[{"\"+\"", "[", 
               RowBox[{"1", ",", 
                 RowBox[{"\"*\"", "[", 
                   RowBox[{
                    RowBox[{"\"*\"", "[", 
                    RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}]}], 
               "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "+"[1, 
              "*"[
               "*"[2, 3], 4]]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["1",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 2],
            TagBox["1", HoldForm]],
           Annotation[#, 
            HoldForm[1], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 3],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{
                 RowBox[{"\"*\"", "[", 
                   RowBox[{"2", ",", "3"}], "]"}], ",", "4"}], "]"}], 
             HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[
              "*"[2, 3], 4]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox["\<\"*\"\>", "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 4],
            TagBox[
             RowBox[{"\"*\"", "[", 
               RowBox[{"2", ",", "3"}], "]"}], HoldForm]],
           Annotation[#, 
            HoldForm[
             "*"[2, 3]], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["2",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 5],
            TagBox["2", HoldForm]],
           Annotation[#, 
            HoldForm[2], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["3",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 6],
            TagBox["3", HoldForm]],
           Annotation[#, 
            HoldForm[3], "Tooltip"]& ], 
          TagBox[
           TooltipBox[InsetBox[
             FrameBox[
              StyleBox[
               TagBox["4",
                HoldForm], "StandardForm", "Output",
               StripOnInput->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontSize->Scaled[0.05],
               FontColor->GrayLevel[0]],
              Background->RGBColor[1., 1., 0.871],
              FrameStyle->GrayLevel[0.5],
              StripOnInput->False], 7],
            TagBox["4", HoldForm]],
           Annotation[#, 
            HoldForm[4], "Tooltip"]& ]}}],
       Annotation[#, 
        VertexCoordinateRules -> {{0.4472135954999579, 2.6832815729997477`}, {
         0., 1.788854381999832}, {0.8944271909999159, 1.788854381999832}, {
         0.4472135954999579, 0.894427190999916}, {0., 0.}, {
         0.8944271909999159, 0.}, {1.3416407864998738`, 
         0.894427190999916}}]& ],
      AspectRatio->0.4,
      FormatType:>StandardForm,
      FrameTicks->Automatic,
      ImageSize->200,
      PlotRange->All,
      PlotRangePadding->Scaled[0.1]]}
   },
   AutoDelete->False,
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.721594143048637*^9, 3.721594159436337*^9}, 
   3.721594211338841*^9, 3.721594533421892*^9, {3.7215947550259933`*^9, 
   3.721594770100663*^9}, 3.721594889470584*^9, 3.721594985308457*^9, {
   3.721595194695229*^9, 3.721595234512436*^9}, {3.721595287073091*^9, 
   3.721595312419714*^9}, 3.721595351498851*^9, {3.721595382074448*^9, 
   3.721595411375268*^9}, 3.721595474769713*^9, 3.721595530488291*^9, 
   3.721595617662674*^9, {3.721595662865917*^9, 3.721595690904626*^9}, {
   3.721595812126678*^9, 3.721595836616741*^9}, {3.721595906621397*^9, 
   3.721595955289885*^9}, 3.7215961294388037`*^9, {3.721596227755488*^9, 
   3.721596253629116*^9}, 3.72159657229294*^9, {3.7215966108495913`*^9, 
   3.721596627081999*^9}, {3.721596709527199*^9, 3.721596724897273*^9}, 
   3.721596832207346*^9, 3.721596892869142*^9, 3.721597144096879*^9, 
   3.721597181298484*^9, 3.7215972921012363`*^9, 3.721597395756774*^9, 
   3.7215975203655567`*^9, 3.721597558161825*^9, 3.721598196492096*^9, 
   3.721598287023552*^9, 3.721598455207128*^9, 3.7215985231139183`*^9, 
   3.7215985807958097`*^9, 3.721629599157144*^9, 3.7216426803028297`*^9, 
   3.7216435692168493`*^9, 3.72164363311406*^9, 3.721643758423135*^9, 
   3.721643807881442*^9, 3.721643893808436*^9, 
   3.721643960134598*^9},ExpressionUUID->"e7f66233-7968-43e5-b86f-\
e4bd78ff21ef"]
}, Open  ]]
},
WindowSize->{975, 955},
WindowMargins->{{Automatic, 724}, {Automatic, 195}},
Background->GrayLevel[0.85],
FrontEndVersion->"11.2 for Mac OS X x86 (32-bit, 64-bit Kernel) (September \
10, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1186, 32, 136, "Input",ExpressionUUID->"eaa3350a-0c7e-4938-95ea-18d46dd76ec6"],
Cell[CellGroupData[{
Cell[1769, 56, 6048, 118, 304, "Input",ExpressionUUID->"d7b79285-cf6b-4c22-a06e-9940e4a5c546"],
Cell[7820, 176, 653, 12, 34, "Output",ExpressionUUID->"e1f3b5f6-23f0-4b97-a5ed-6f223e5111f3"],
Cell[8476, 190, 812, 14, 34, "Output",ExpressionUUID->"82bd7a02-885d-4982-8357-4da2cbabf8d3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9325, 209, 157, 3, 30, "Input",ExpressionUUID->"14a1df8e-9de9-49d9-85ab-b6311d6cbfb0"],
Cell[9485, 214, 465, 13, 34, "Output",ExpressionUUID->"e1d0cae4-2dc6-4c51-bd7a-055a4fa5ba0b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9987, 232, 194, 4, 52, "Input",ExpressionUUID->"8e1f81db-eaa3-4431-b573-be976f6a99cf"],
Cell[10184, 238, 256, 6, 34, "Output",ExpressionUUID->"48c62492-6f09-4653-8cab-97f78fe025ce"]
}, Open  ]],
Cell[10455, 247, 3000, 58, 136, "Input",ExpressionUUID->"93867fef-e690-47d6-ba1d-ba6e011e5d99"],
Cell[CellGroupData[{
Cell[13480, 309, 708, 18, 73, "Input",ExpressionUUID->"1bcaeda2-bf3f-4f2e-a45a-b93baea6b90e"],
Cell[14191, 329, 1382, 20, 34, "Output",ExpressionUUID->"89cfcf59-a688-41b5-85f5-45ae6a91596b"],
Cell[15576, 351, 1384, 20, 34, "Output",ExpressionUUID->"77823135-63f8-4d36-b9e4-a37613973688"],
Cell[16963, 373, 22524, 597, 901, "Output",ExpressionUUID->"e7f66233-7968-43e5-b86f-e4bd78ff21ef"]
}, Open  ]]
}
]
*)

