(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     40791,       1047]
NotebookOptionsPosition[     35279,        942]
NotebookOutlinePosition[     35647,        958]
CellTagsIndexPosition[     35604,        955]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Copyright]", " ", "2012"}], "-", 
     RowBox[{"Present", " ", "Computational", " ", "ClassNotes"}]}], ",", " ", 
    RowBox[{"lossofgenerality", ".", "org"}], ",", " ", 
    RowBox[{"Creative", " ", "Commons", " ", "License"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"https", ":"}], "//", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"creativecommons", ".", "org"}], "/", "licenses"}], "/", 
       "by"}], "-", "nc", "-", 
      RowBox[{
       RowBox[{
        RowBox[{"sa", "/", "3.0"}], "/", "us"}], "/"}]}], "  ", ":", "  ", 
     RowBox[{"Attribution", "-", "NonCommercial", "-", "ShareAlike"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"SetOptions", "[", 
   RowBox[{
    RowBox[{"EvaluationNotebook", "[", "]"}], ",", 
    RowBox[{"Background", "\[Rule]", "LightGray"}]}], "]"}], " "}]], "Input",
 CellChangeTimes->{{3.6756206902779303`*^9, 3.675620691576756*^9}, 
   3.675620769219532*^9, {3.681116767801195*^9, 3.681116772670809*^9}, 
   3.6834046045226316`*^9, {3.715672552230839*^9, 3.715672583528247*^9}, 
   3.7180927735424337`*^9, 3.772617869780849*^9, {3.772717208049241*^9, 
   3.772717208858294*^9}, {3.772717660184099*^9, 3.77271766257882*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"5e261624-1a2c-4658-9d1f-777403e31d94"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ops0", "=", 
    RowBox[{
    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ops", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "|>"}]}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
    RowBox[{"RandomSample", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
     "]"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ops1", "\[Rule]", 
      RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
     RowBox[{"ops2", "\[Rule]", 
      RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
     RowBox[{"ops3", "\[Rule]", 
      RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rules2", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<ops1\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
      RowBox[{"\"\<ops2\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
      RowBox[{"\"\<ops3\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"expression", "=", 
    RowBox[{"RandomChoice", "@", 
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"<|", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
               "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", ",", 
                "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"1", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
               "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"2", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"3", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
            "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<hold\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Hold", "[", "  ", 
            RowBox[{"(", 
             RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", " ", 
              RowBox[{"(", 
               RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                RowBox[{"x", " ", ".", " ", 
                 RowBox[{"(", 
                  RowBox[{
                  "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", "x"}],
                   ")"}]}]}], ")"}], 
              RowBox[{"(", 
               RowBox[{
               "\[Paragraph]", " ", "3", " ", "ops3", " ", "2", "  ", "x"}], 
               ")"}]}], ")"}], "]"}], ")"}]}], ",", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"\"\<expr\>\"", "\[Rule]", 
          RowBox[{
          "(", "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
           ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"<|", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"<|", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"0", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{
               "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", ",", 
                "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"2", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
               "]"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"3", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"1", "\[Rule]", 
              RowBox[{"StringReplace", "[", 
               RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
            "\[IndentingNewLine]", "|>"}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<hold\>\"", "\[Rule]", 
          RowBox[{"(", 
           RowBox[{"Hold", "[", "  ", 
            RowBox[{"(", 
             RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", "  ", 
              RowBox[{"(", 
               RowBox[{
               "\[Paragraph]", " ", "1", " ", "ops3", " ", "2", "  ", "x"}], 
               ")"}], 
              RowBox[{"(", 
               RowBox[{"\[Paragraph]", " ", "2", " ", "\[Lambda]", " ", 
                RowBox[{"x", " ", ".", " ", 
                 RowBox[{"(", 
                  RowBox[{
                  "\[Paragraph]", " ", "3", " ", "ops1", " ", "y", " ", "x"}],
                   ")"}]}]}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
         "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"\"\<expr\>\"", "\[Rule]", 
          RowBox[{
          "(", "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
           ")"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "}"}]}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", "rules"}], ",", 
      RowBox[{"StringReplace", "[", 
       RowBox[{
        RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", "rules2"}], 
       "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trace0", "=", 
    RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "ordere", " ", "corresponds", " ", "to", " ", "tags", " ", "to", " ", 
    "the", " ", "subexpressions"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trace", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"MissingQ", "[", 
         RowBox[{
          RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
          RowBox[{"order2", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Equal]", "True"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"Row", "[", 
        RowBox[{"trace0", "[", 
         RowBox[{"order2", "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"StringJoin", "[", 
          RowBox[{"trace0", "[", 
           RowBox[{"order2", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
          RowBox[{"order2", "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}], "]"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", "trace0"}]}], "}"}]}], "]"}]}], ";"}]}], "Input",\

 CellLabel->"In[25]:=",ExpressionUUID->"ef8f25b6-28b7-4eac-80f1-b74428ac0bc1"],

Cell[CellGroupData[{

Cell[BoxData["trace"], "Input",
 CellChangeTimes->{{3.772792773989975*^9, 3.772792778601988*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"018b8daa-5e46-4cf2-bf79-dd560c949ab5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TemplateBox[{"\"(* (\[Lambda] x . (+ y x)) (^ 2 x))\""},
    "RowDefault"], ",", 
   TemplateBox[{
    "\"(\[Lambda] x . (+ y x))\"","\"[\"","x",OverscriptBox[
     "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
     TemplateBox[{
      "x$7449", FrameStyle -> None, Background -> RGBColor[1, 0.925, 0.925]}, 
      "Highlighted"],"\"]\"",
     "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
    "RowDefault"], ",", "\<\"(+ y x$7449)\"\>", ",", 
   TemplateBox[{"\"(^ 2 x)\""},
    "RowDefault"]}], "}"}]], "Output",
 CellChangeTimes->{3.772792779064948*^9, 3.772802751855824*^9, 
  3.772874736557788*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"745d6b93-4628-4a60-8f3f-4d285fc902df"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]4"], "Input",
 CellLabel->"In[36]:=",ExpressionUUID->"13d76ef5-5717-469f-afae-cabde12d769f"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.772801620532386*^9, 3.7728747401351433`*^9},
 CellLabel->"Out[36]=",ExpressionUUID->"74b02f46-ddd7-4829-bc0c-7c56b87d1e01"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["res"], "Input",
 CellChangeTimes->{{3.772792788356436*^9, 3.7727927887000732`*^9}},
 CellLabel->"In[37]:=",ExpressionUUID->"8b9bf34e-9118-404e-9593-93e811664616"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"input\"\>", 
    "\[Rule]", "\<\"(* (\[Lambda] x . (+ y x)) (^ 2 x))\"\>"}], ",", 
   RowBox[{"\<\"output1\"\>", "\[Rule]", 
    RowBox[{"op2", "[", 
     RowBox[{
      RowBox[{"op1", "[", 
       RowBox[{"y", ",", "tmp"}], "]"}], ",", 
      RowBox[{"op3", "[", 
       RowBox[{"2", ",", "x"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"\<\"output2\"\>", "\[Rule]", 
    RowBox[{"op2", "[", 
     RowBox[{
      RowBox[{"op1", "[", 
       RowBox[{"y", ",", "x$7449"}], "]"}], ",", 
      RowBox[{"op3", "[", 
       RowBox[{"2", ",", "x"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"\<\"output\"\>", "\[Rule]", 
    RowBox[{"op2", "[", 
     RowBox[{
      RowBox[{"op1", "[", 
       RowBox[{"y", ",", "x$7449"}], "]"}], ",", 
      RowBox[{"op3", "[", 
       RowBox[{"2", ",", "x"}], "]"}]}], "]"}]}], ",", 
   RowBox[{"\<\"free\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"x\"\>", ",", "\<\"y\"\>"}], "}"}]}], ",", 
   RowBox[{"\<\"bound\"\>", "\[Rule]", 
    RowBox[{"{", "\<\"x$7449\"\>", "}"}]}], ",", 
   RowBox[{"\<\"stack\"\>", "\[Rule]", 
    RowBox[{"{", "x$7449", "}"}]}], ",", 
   RowBox[{"\<\"trace\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"0", "\[Rule]", 
       RowBox[{"{", "\<\"(* (\[Lambda] x . (+ y x)) (^ 2 x))\"\>", "}"}]}], 
      ",", 
      RowBox[{"1", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"\<\"(\[Lambda] x . (+ y x))\"\>", ",", "\<\"[\"\>", ",", "x",
          ",", 
         OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
         
         TemplateBox[{
          "x$7449",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
          "Highlighted"], ",", "\<\"]\"\>", 
         ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\
\[ScriptI]\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\
\[ScriptE]\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}]}],
       ",", 
      RowBox[{"2", "\[Rule]", 
       RowBox[{"{", "\<\"(+ y x)\"\>", "}"}]}], ",", 
      RowBox[{"3", "\[Rule]", 
       RowBox[{"{", "\<\"(^ 2 x)\"\>", "}"}]}]}], "\[RightAssociation]"}]}], 
   ",", 
   RowBox[{"\<\"order\"\>", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "2", ",", "3"}], "}"}]}], ",", 
   RowBox[{"\<\"replace\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{"2", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"x$7449\"\>"}], "}"}]}], 
     "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"\[Alpha]\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{"1", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\<\"(\[Lambda] x . (+ y x))\"\>", ",", "\<\"[\"\>", ",", "x", 
        ",", 
        OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
        TemplateBox[{
         "x$7449",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
         
         "Highlighted"], ",", "\<\"]\"\>", 
        ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\
\[ScriptI]\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\
\[ScriptE]\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}]}],
      "\[RightAssociation]"}]}], ",", 
   RowBox[{"\<\"\[Beta]\"\>", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", "\[RightAssociation]"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{
  3.772792788944281*^9, {3.772794071464799*^9, 3.772794118850519*^9}, 
   3.772794165145851*^9, {3.772801189863613*^9, 3.7728012135033293`*^9}, 
   3.772801419437159*^9, 3.772801839598765*^9, 3.772802358886199*^9, 
   3.772802644181072*^9, 3.7728027490658484`*^9, 3.772802882758277*^9, 
   3.7728747412712812`*^9},
 CellLabel->"Out[37]=",ExpressionUUID->"828d92d4-0d1e-4318-939b-cd44a877aa0e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Nu]", " ", 
  RowBox[{"(", 
   RowBox[{"res", "[", "\"\<output1\>\"", "]"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.772802387935845*^9, 3.7728023881811857`*^9}, {
  3.7728026005985403`*^9, 3.772802600776312*^9}},
 CellLabel->
  "In[124]:=",ExpressionUUID->"02063b73-29c6-4328-8fee-69651c234500"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"x\"\>", ",", "\<\"y\"\>", ",", "\<\"tmp\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.772802380058366*^9, 3.772802388370459*^9}, 
   3.772802600988995*^9},
 CellLabel->
  "Out[124]=",ExpressionUUID->"384b2342-e4cd-4982-9a1f-9faf04ebfab9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DeleteCases", "[", 
  RowBox[{
   RowBox[{"\[Nu]", " ", 
    RowBox[{"(", 
     RowBox[{"res", "[", "\"\<output1\>\"", "]"}], ")"}]}], ",", 
   "\"\<tmp\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.7728020051455793`*^9, 3.772802044813507*^9}, 
   3.7728020847008343`*^9, {3.772802155731147*^9, 3.772802158215642*^9}, {
   3.7728022085283203`*^9, 3.772802286749338*^9}},
 CellLabel->"In[83]:=",ExpressionUUID->"f5e88042-b199-4bf3-b508-3ee816b03e3f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"y\"\>", ",", "\<\"x\"\>"}], "}"}]], "Output",
 CellChangeTimes->{{3.772802019083836*^9, 3.772802045154119*^9}, {
   3.772802085609702*^9, 3.772802091458171*^9}, 3.7728021587202168`*^9, {
   3.772802208963511*^9, 3.772802287354788*^9}},
 CellLabel->"Out[83]=",ExpressionUUID->"8cb644c3-6063-4173-8cf3-bfc2d3b15c26"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DeleteCases", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\"\<y\>\"", ",", "\"\<x\>\""}], "}"}], ",", 
   RowBox[{
    RowBox[{"#", "===", "x"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{3.77280227224037*^9, 3.772802302377201*^9},
 CellLabel->"In[84]:=",ExpressionUUID->"e8993a20-4310-4fdc-98d6-567de86441de"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"y\"\>", ",", "\<\"x\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.772802272685322*^9, 3.772802302924926*^9},
 CellLabel->"Out[84]=",ExpressionUUID->"c1abd435-a088-49f7-9bbc-2e33e7b114c6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["tmp"], "Input",
 CellChangeTimes->{{3.772802037772356*^9, 3.772802037991106*^9}},
 CellLabel->"In[73]:=",ExpressionUUID->"7d85621f-5145-4a48-9497-03822a7f5720"],

Cell[BoxData["tmp"], "Output",
 CellChangeTimes->{3.77280203845831*^9},
 CellLabel->"Out[73]=",ExpressionUUID->"818e4c79-6d78-4aba-99a2-85e902891c72"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]1"], "Input",
 CellLabel->
  "In[121]:=",ExpressionUUID->"48f595c3-110c-4b8c-9075-719fb3157d18"],

Cell[BoxData[
 RowBox[{"{", "x$36271", "}"}]], "Output",
 CellChangeTimes->{3.772801971921932*^9, 3.7728024424402723`*^9},
 CellLabel->
  "Out[121]=",ExpressionUUID->"1cb29e0e-c540-48e8-97bb-541531ec8902"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ToString", "/@", "\[Xi]1"}]], "Input",
 CellLabel->
  "In[122]:=",ExpressionUUID->"478727cb-885b-489f-af92-e13a328172fe"],

Cell[BoxData[
 RowBox[{"{", "\<\"x$36271\"\>", "}"}]], "Output",
 CellChangeTimes->{3.772802454781847*^9},
 CellLabel->
  "Out[122]=",ExpressionUUID->"4fd9984a-637b-46fd-ab32-4746109e3846"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]4"], "Input",
 CellLabel->
  "In[123]:=",ExpressionUUID->"36b07d71-457a-4966-91df-4028368bcb9c"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.7728024828500137`*^9},
 CellLabel->
  "Out[123]=",ExpressionUUID->"a881ef85-0c15-471b-a753-9cd529cbfd7b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["tmp"], "Input",
 CellChangeTimes->{{3.7728015489653893`*^9, 3.7728015491634073`*^9}},
 CellLabel->"In[19]:=",ExpressionUUID->"b53784eb-ce0e-428d-a725-3113ec623dc0"],

Cell[BoxData["tmp"], "Output",
 CellChangeTimes->{3.7728015499123507`*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"d0f1cff3-7ab0-43eb-880e-3fd518d827ba"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]2"], "Input",
 CellLabel->"In[19]:=",ExpressionUUID->"e634ed7d-1aa3-4f73-bf83-503d0cb64b2d"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"0", "\[Rule]", 
    RowBox[{"{", "\<\"(+ (* 2 x) (\[Lambda] x . (^ y x)))\"\>", "}"}]}], ",", 
   
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", "\<\"(* 2 x)\"\>", "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"(\[Lambda] x . (^ y x))\"\>", ",", "\<\"[\"\>", ",", "x", 
      ",", 
      OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
      TemplateBox[{
       "x$23455",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
       "Highlighted"], ",", "\<\"]\"\>", 
      ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", "\<\"(^ y x)\"\>", "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.772792816367156*^9},
 CellLabel->"Out[19]=",ExpressionUUID->"984acd0a-5aa2-4990-816c-9c5d20298004"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<replace\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.7727929678651857`*^9, 3.7727929751313953`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"81081114-158b-463f-8a5c-4935a7f3e723"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{"3", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"\<\"x\"\>", "\[Rule]", "\<\"x$23455\"\>"}], "}"}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.7727929755236597`*^9},
 CellLabel->"Out[20]=",ExpressionUUID->"64d35d17-a8e5-4420-b8fa-67f5e3350200"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "/@", "trace"}]], "Input",
 CellChangeTimes->{{3.772793110719997*^9, 3.7727931126205187`*^9}, {
  3.772793160390328*^9, 3.7727931673864803`*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"f74cd786-6c05-4a92-8001-d424b9291733"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{"Row", "[", 
      RowBox[{"{", "\"\<(+ (* 2 x) (\[Lambda] x . (^ y x)))\>\"", "}"}], "]"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[
     Row[{"(+ (* 2 x) (\[Lambda] x . (^ y x)))"}]],
    AutoDelete->True,
    Editable->True], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Row", "[", 
      RowBox[{"{", "\"\<(* 2 x)\>\"", "}"}], "]"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[
     Row[{"(* 2 x)"}]],
    AutoDelete->True,
    Editable->True], ",", 
   InterpretationBox[
    StyleBox[
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{
       "\"\<(\[Lambda] x . (^ y x))\>\"", ",", " ", "\"\<[\>\"", ",", " ", 
        "x", ",", " ", 
        RowBox[{"Overscript", "[", 
         RowBox[{"\"\<\[LongRightArrow]\>\"", ",", " ", "\"\<\[Alpha]\>\""}], 
         "]"}], ",", " ", 
        RowBox[{"Highlighted", "[", 
         RowBox[{"x$23455", ",", " ", 
          RowBox[{"Background", " ", "->", " ", 
           RowBox[{"RGBColor", "[", 
            RowBox[{"1", ",", " ", "0.925", ",", " ", "0.925"}], "]"}]}]}], 
         "]"}], ",", " ", "\"\<]\>\"", ",", " ", 
        "\"\< \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\>\""}], "}"}], "]"}],
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm[
     Row[{"(\[Lambda] x . (^ y x))", "[", $CellContext`x, 
       Overscript["\[LongRightArrow]", "\[Alpha]"], 
       Highlighted[$CellContext`x$23455, Background -> 
        RGBColor[1, 0.925, 0.925]], "]", 
       " \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]"}]],
    AutoDelete->True,
    Editable->True], ",", 
   InterpretationBox[
    StyleBox["\"\<(^ y x$23455)\>\"",
     ShowStringCharacters->True,
     NumberMarks->True],
    InputForm["(^ y x$23455)"],
    AutoDelete->True,
    Editable->True]}], "}"}]], "Output",
 CellChangeTimes->{3.7727931129157743`*^9, 3.7727931685555353`*^9},
 CellLabel->"Out[22]=",ExpressionUUID->"e31cb368-9c7a-494f-906a-d0e3c86c82bb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"InputForm", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "[", 
   RowBox[{"[", "5", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.7727946540462227`*^9, 3.7727946552030897`*^9}, {
  3.772795363663863*^9, 3.772795377691329*^9}, {3.772795435495417*^9, 
  3.77279543620366*^9}, {3.772795486730049*^9, 3.772795576101667*^9}},
 CellLabel->
  "In[171]:=",ExpressionUUID->"7e58387f-8e11-45cb-a031-998a686ddbb6"],

Cell["\<\
Highlighted[x$47497, Background -> RGBColor[1, 0.925, 0.925]]\
\>", "Output",
 CellChangeTimes->{{3.772794648406979*^9, 3.772794655811672*^9}, {
   3.7727953552813883`*^9, 3.772795372042693*^9}, 3.7727954366071672`*^9, {
   3.772795474760468*^9, 3.77279557663897*^9}},
 CellLabel->
  "Out[171]//InputForm=",ExpressionUUID->"d6ecf503-6e31-4b96-8dbd-\
86303e209b50"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Values", "@", "\[Xi]2"}]], "Input",
 CellChangeTimes->{{3.772794766097866*^9, 3.772794774852572*^9}},
 CellLabel->
  "In[155]:=",ExpressionUUID->"87b30885-8deb-4ce5-a905-04ddc4152d86"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "\<\"(^ (\[Lambda] x . (* y x)) (+ 2 x))\"\>", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"(\[Lambda] x . (* y x))\"\>", ",", "\<\"[\"\>", ",", "x", 
     ",", 
     OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
     TemplateBox[{
      "x$47497",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
      "Highlighted"], ",", "\<\"]\"\>", 
     ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}], ",", 
   RowBox[{"{", "\<\"(* y x)\"\>", "}"}], ",", 
   RowBox[{"{", "\<\"(+ 2 x)\"\>", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.772794775208778*^9},
 CellLabel->
  "Out[155]=",ExpressionUUID->"23273223-2795-4330-bb2e-305147230fe9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StringReplace", "[", 
  RowBox[{
   RowBox[{"ToString", "[", 
    RowBox[{"InputForm", "[", 
     TemplateBox[{
      "x$47497",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
      "Highlighted"], "]"}], "]"}], ",", 
   RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<y\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7727951847295*^9, 3.772795265842108*^9}},
 CellLabel->
  "In[157]:=",ExpressionUUID->"8b02bd6d-be74-489b-a303-8d3e078eef18"],

Cell[BoxData["\<\"y$47497\"\>"], "Output",
 CellChangeTimes->{3.772795200096054*^9, 3.772795266189054*^9},
 CellLabel->
  "Out[157]=",ExpressionUUID->"1d8fd499-0ce5-4fdc-9006-7c2103aa273b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Highlighted", "[", 
  RowBox[{
   RowBox[{"StringReplace", "[", 
    RowBox[{
     RowBox[{"ToString", "[", 
      RowBox[{"InputForm", "[", 
       TemplateBox[{
        "x$47497",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
        
        "Highlighted"], "]"}], "]"}], ",", 
     RowBox[{"\"\<x\>\"", "\[Rule]", "\"\<y\>\""}]}], "]"}], ",", 
   RowBox[{"Background", "\[Rule]", "LightPink"}]}], "]"}]], "Input",
 CellChangeTimes->{3.772795302769691*^9, 3.772795446447174*^9},
 CellLabel->
  "In[158]:=",ExpressionUUID->"2b967cae-1d54-4a9c-a0dd-88d6897298ac"],

Cell[BoxData[
 TemplateBox[{
  "\"y$47497\"",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
  "Highlighted"]], "Output",
 CellChangeTimes->{3.7727953036116877`*^9},
 CellLabel->
  "Out[158]=",ExpressionUUID->"35c2cebd-5450-40b9-9dd7-a836eea8319f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Column", "[", 
  RowBox[{"Row", "/@", 
   RowBox[{"(", 
    RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Column", "[", 
   RowBox[{"Row", "/@", 
    RowBox[{"(", 
     RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{"x", "\[Rule]", "y"}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.7727942934995832`*^9, 3.772794322636235*^9}, {
  3.772794564438772*^9, 3.77279458095586*^9}},
 CellLabel->
  "In[151]:=",ExpressionUUID->"35e2fd33-dd14-41c5-9f63-3c395af2a0e0"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(\[Lambda] x . (* y x))\"","\"[\"","x",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "x$47497", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.77279382618439*^9, 3.772793890493634*^9, {3.772794283496583*^9, 
   3.772794322975305*^9}, {3.772794568711566*^9, 3.772794581382008*^9}},
 CellLabel->
  "Out[151]=",ExpressionUUID->"54d16039-0da1-47da-a323-f60d42fcc636"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      "\"(\[Lambda] x . (* y x))\"","\"[\"","y",OverscriptBox[
       "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
       TemplateBox[{
        "x$47497", FrameStyle -> None, Background -> 
         RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
       "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
      "RowDefault"]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{
  3.77279382618439*^9, 3.772793890493634*^9, {3.772794283496583*^9, 
   3.772794322975305*^9}, {3.772794568711566*^9, 3.772794581386417*^9}},
 CellLabel->
  "Out[152]=",ExpressionUUID->"87872356-cd9d-490b-b79e-94f77459e4bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Xi]2"], "Input",
 CellChangeTimes->{{3.7727934470672207`*^9, 3.7727934593083773`*^9}},
 CellLabel->"In[97]:=",ExpressionUUID->"28e5312d-f349-4e8f-9503-8270082e7cce"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"0", "\[Rule]", 
    RowBox[{"{", "\<\"(^ (+ 2 x) (\[Lambda] x . (* y x)))\"\>", "}"}]}], ",", 
   
   RowBox[{"1", "\[Rule]", 
    RowBox[{"{", "\<\"(+ 2 x)\"\>", "}"}]}], ",", 
   RowBox[{"2", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\<\"(\[Lambda] x . (* y x))\"\>", ",", "\<\"[\"\>", ",", "x", 
      ",", 
      OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
      TemplateBox[{
       "x$44659",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
       "Highlighted"], ",", "\<\"]\"\>", 
      ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}]}], ",", 
   RowBox[{"3", "\[Rule]", 
    RowBox[{"{", "\<\"(* y x)\"\>", "}"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{{3.772793453422902*^9, 3.772793459540844*^9}, 
   3.772793824431467*^9, 3.7727938890648117`*^9},
 CellLabel->"Out[97]=",ExpressionUUID->"729ba01c-1737-4b54-a360-d24e4a16edf1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Last", "@", 
  RowBox[{"Normal", "@", "\[Xi]2"}]}]], "Input",
 CellChangeTimes->{{3.7727938365607557`*^9, 3.772793854008589*^9}},
 CellLabel->"In[79]:=",ExpressionUUID->"1eb5eecc-910b-4541-9c94-552e41b8fdc2"],

Cell[BoxData[
 RowBox[{"3", "\[Rule]", 
  RowBox[{"{", "\<\"(+ 2 x)\"\>", "}"}]}]], "Output",
 CellChangeTimes->{{3.7727938416442547`*^9, 3.7727938544689198`*^9}},
 CellLabel->"Out[79]=",ExpressionUUID->"f5ba9558-ddaf-4d77-952c-d7d311ed39a7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Beta]\[Xi]"], "Input",
 CellLabel->
  "In[115]:=",ExpressionUUID->"91b2ca63-0bd1-4ef3-b2e8-88389ce6bba0"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", "\[RightAssociation]"}]], "Output",
 CellChangeTimes->{3.772794067599915*^9},
 CellLabel->
  "Out[115]=",ExpressionUUID->"a82598d5-2af1-4d52-abaf-5c6e33656b59"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"trace\[Lambda]", "[", "res_", "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"If", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"MissingQ", "[", 
         RowBox[{
          RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
          RowBox[{
           RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], "\[Equal]", "True"}],
        ",", "\[IndentingNewLine]", 
       RowBox[{"Row", "[", 
        RowBox[{
         RowBox[{"res", "[", "\"\<trace\>\"", "]"}], "[", 
         RowBox[{
          RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
          RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"StringJoin", "[", 
          RowBox[{
           RowBox[{"res", "[", "\"\<trace\>\"", "]"}], "[", 
           RowBox[{
            RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
          RowBox[{
           RowBox[{"res", "[", "\"\<order\>\"", "]"}], "[", 
           RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}], "]"}], 
     "\[IndentingNewLine]", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", 
       RowBox[{"Length", "@", 
        RowBox[{"res", "[", "\"\<trace\>\"", "]"}]}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->
  "In[130]:=",ExpressionUUID->"5a8897e0-ac31-4d25-bf8e-82cb5ee310aa"]
},
WindowSize->{808, 911},
WindowMargins->{{134, Automatic}, {Automatic, 151}},
Background->GrayLevel[0.85],
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1435, 33, 136, "Input",ExpressionUUID->"5e261624-1a2c-4658-9d1f-777403e31d94"],
Cell[1996, 55, 9320, 221, 1774, "Input",ExpressionUUID->"ef8f25b6-28b7-4eac-80f1-b74428ac0bc1"],
Cell[CellGroupData[{
Cell[11341, 280, 176, 2, 30, "Input",ExpressionUUID->"018b8daa-5e46-4cf2-bf79-dd560c949ab5"],
Cell[11520, 284, 872, 19, 76, "Output",ExpressionUUID->"745d6b93-4628-4a60-8f3f-4d285fc902df"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12429, 308, 111, 1, 30, "Input",ExpressionUUID->"13d76ef5-5717-469f-afae-cabde12d769f"],
Cell[12543, 311, 190, 3, 34, "Output",ExpressionUUID->"74b02f46-ddd7-4829-bc0c-7c56b87d1e01"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12770, 319, 176, 2, 30, "Input",ExpressionUUID->"8b9bf34e-9118-404e-9593-93e811664616"],
Cell[12949, 323, 3830, 90, 217, "Output",ExpressionUUID->"828d92d4-0d1e-4318-939b-cd44a877aa0e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16816, 418, 323, 7, 30, "Input",ExpressionUUID->"02063b73-29c6-4328-8fee-69651c234500"],
Cell[17142, 427, 287, 7, 34, "Output",ExpressionUUID->"384b2342-e4cd-4982-9a1f-9faf04ebfab9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17466, 439, 474, 10, 30, "Input",ExpressionUUID->"f5e88042-b199-4bf3-b508-3ee816b03e3f"],
Cell[17943, 451, 358, 6, 34, "Output",ExpressionUUID->"8cb644c3-6063-4173-8cf3-bfc2d3b15c26"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18338, 462, 340, 8, 30, "Input",ExpressionUUID->"e8993a20-4310-4fdc-98d6-567de86441de"],
Cell[18681, 472, 232, 4, 34, "Output",ExpressionUUID->"c1abd435-a088-49f7-9bbc-2e33e7b114c6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18950, 481, 174, 2, 30, "Input",ExpressionUUID->"7d85621f-5145-4a48-9497-03822a7f5720"],
Cell[19127, 485, 150, 2, 34, "Output",ExpressionUUID->"818e4c79-6d78-4aba-99a2-85e902891c72"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19314, 492, 115, 2, 30, "Input",ExpressionUUID->"48f595c3-110c-4b8c-9075-719fb3157d18"],
Cell[19432, 496, 205, 4, 34, "Output",ExpressionUUID->"1cb29e0e-c540-48e8-97bb-541531ec8902"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19674, 505, 145, 3, 30, "Input",ExpressionUUID->"478727cb-885b-489f-af92-e13a328172fe"],
Cell[19822, 510, 189, 4, 34, "Output",ExpressionUUID->"4fd9984a-637b-46fd-ab32-4746109e3846"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20048, 519, 115, 2, 30, "Input",ExpressionUUID->"36b07d71-457a-4966-91df-4028368bcb9c"],
Cell[20166, 523, 172, 4, 34, "Output",ExpressionUUID->"a881ef85-0c15-471b-a753-9cd529cbfd7b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20375, 532, 178, 2, 30, "Input",ExpressionUUID->"b53784eb-ce0e-428d-a725-3113ec623dc0"],
Cell[20556, 536, 153, 2, 34, "Output",ExpressionUUID->"d0f1cff3-7ab0-43eb-880e-3fd518d827ba"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20746, 543, 111, 1, 30, "Input",ExpressionUUID->"e634ed7d-1aa3-4f73-bf83-503d0cb64b2d"],
Cell[20860, 546, 1060, 23, 79, "Output",ExpressionUUID->"984acd0a-5aa2-4990-816c-9c5d20298004"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21957, 574, 219, 3, 30, "Input",ExpressionUUID->"81081114-158b-463f-8a5c-4935a7f3e723"],
Cell[22179, 579, 317, 7, 37, "Output",ExpressionUUID->"64d35d17-a8e5-4420-b8fa-67f5e3350200"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22533, 591, 260, 4, 30, "Input",ExpressionUUID->"f74cd786-6c05-4a92-8001-d424b9291733"],
Cell[22796, 597, 2362, 62, 98, "Output",ExpressionUUID->"e31cb368-9c7a-494f-906a-d0e3c86c82bb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25195, 664, 532, 12, 30, "Input",ExpressionUUID->"7e58387f-8e11-45cb-a031-998a686ddbb6"],
Cell[25730, 678, 374, 8, 45, "Output",ExpressionUUID->"d6ecf503-6e31-4b96-8dbd-86303e209b50"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26141, 691, 208, 4, 30, "Input",ExpressionUUID->"87b30885-8deb-4ce5-a905-04ddc4152d86"],
Cell[26352, 697, 891, 18, 76, "Output",ExpressionUUID->"23273223-2795-4330-bb2e-305147230fe9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27280, 720, 470, 11, 42, "Input",ExpressionUUID->"8b02bd6d-be74-489b-a303-8d3e078eef18"],
Cell[27753, 733, 189, 3, 34, "Output",ExpressionUUID->"1d8fd499-0ce5-4fdc-9006-7c2103aa273b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27979, 741, 602, 15, 71, "Input",ExpressionUUID->"2b967cae-1d54-4a9c-a0dd-88d6897298ac"],
Cell[28584, 758, 261, 6, 46, "Output",ExpressionUUID->"35c2cebd-5450-40b9-9dd7-a836eea8319f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28882, 769, 587, 16, 52, "Input",ExpressionUUID->"35e2fd33-dd14-41c5-9f63-3c395af2a0e0"],
Cell[29472, 787, 957, 22, 47, "Output",ExpressionUUID->"54d16039-0da1-47da-a323-f60d42fcc636"],
Cell[30432, 811, 957, 22, 47, "Output",ExpressionUUID->"87872356-cd9d-490b-b79e-94f77459e4bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31426, 838, 181, 2, 30, "Input",ExpressionUUID->"28e5312d-f349-4e8f-9503-8270082e7cce"],
Cell[31610, 842, 1134, 24, 79, "Output",ExpressionUUID->"729ba01c-1737-4b54-a360-d24e4a16edf1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32781, 871, 232, 4, 30, "Input",ExpressionUUID->"1eb5eecc-910b-4541-9c94-552e41b8fdc2"],
Cell[33016, 877, 242, 4, 34, "Output",ExpressionUUID->"f5ba9558-ddaf-4d77-952c-d7d311ed39a7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[33295, 886, 121, 2, 30, "Input",ExpressionUUID->"91b2ca63-0bd1-4ef3-b2e8-88389ce6bba0"],
Cell[33419, 890, 205, 4, 34, "Output",ExpressionUUID->"a82598d5-2af1-4d52-abaf-5c6e33656b59"]
}, Open  ]],
Cell[33639, 897, 1636, 43, 136, "Input",ExpressionUUID->"5a8897e0-ac31-4d25-bf8e-82cb5ee310aa"]
}
]
*)

