(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     29265,        684]
NotebookOptionsPosition[     27092,        638]
NotebookOutlinePosition[     27430,        653]
CellTagsIndexPosition[     27387,        650]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ops0", "=", 
    RowBox[{
    "<|", "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"op1", "\[Rule]", "Plus"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"op2", "\[Rule]", "Times"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"op3", "\[Rule]", "Power"}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], ";", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"ops", "=", 
    RowBox[{"<|", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"\"\<op1\>\"", "\[Rule]", "\"\<Plus\>\""}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"\"\<op2\>\"", "\[Rule]", "\"\<Times\>\""}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"\"\<op3\>\"", "\[Rule]", "\"\<Power\>\""}]}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "|>"}]}], ";", "\[IndentingNewLine]", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ops1", ",", "ops2", ",", "ops3"}], "}"}], "=", 
    RowBox[{"RandomSample", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"op1", ",", "op2", ",", "op3"}], "}"}], ",", " ", "3"}], 
     "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"rules", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ops1", "\[Rule]", 
       RowBox[{"ops0", "[", "ops1", "]"}]}], ",", 
      RowBox[{"ops2", "\[Rule]", 
       RowBox[{"ops0", "[", "ops2", "]"}]}], ",", 
      RowBox[{"ops3", "\[Rule]", 
       RowBox[{"ops0", "[", "ops3", "]"}]}]}], "}"}]}], ";", 
   "\[IndentingNewLine]", 
   RowBox[{"rules2", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<ops1\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops1", "]"}], "]"}]}], ",", 
      RowBox[{"\"\<ops2\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops2", "]"}], "]"}]}], ",", 
      RowBox[{"\"\<ops3\>\"", "\[Rule]", 
       RowBox[{"ops", "[", 
        RowBox[{"ToString", "[", "ops3", "]"}], "]"}]}]}], "}"}]}], ";", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"expression", "=", 
    RowBox[{"RandomChoice", "@", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Clear", "[", "res", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "\[Rho]0", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"\[Rho]0", "=", 
               RowBox[{"<|", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"0", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                   "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"1", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                   "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                   "]"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"2", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"3", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                "\[IndentingNewLine]", "|>"}]}], ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<hold\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"Hold", "[", "  ", 
               RowBox[{"(", 
                RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", " ", 
                 RowBox[{"(", 
                  RowBox[{"\[Paragraph]", " ", "1", " ", "\[Lambda]", " ", 
                   RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "2", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{
                  "\[Paragraph]", " ", "3", " ", "ops3", " ", "2", "  ", 
                   "x"}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<stitch\>\"", "\[Rule]", 
             RowBox[{"Hold", "[", 
              RowBox[{"(", 
               RowBox[{"StringJoin", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops2 \>\"", ",", "rules2"}], "]"}], ",", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                    RowBox[{"\[Rho]0", "[", "1", "]"}], ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
                    RowBox[{"1", "+", "1"}], "]"}]}], "]"}], ",", "\"\<)\>\"",
                   ",", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\< (ops3 2 x))\>\"", ",", "rules2"}], "]"}]}], 
                 "}"}]}], ")"}], "]"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"\"\<expr\>\"", "\[Rule]", 
             RowBox[{
             "(", "\"\<(ops2 (\[Lambda] x . (ops1 y x)) (ops3 2 x))\>\"", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], "]"}]}], 
       ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Clear", "[", "res", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Module", "[", 
         RowBox[{
          RowBox[{"{", "\[Rho]0", "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"<|", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"\"\<\[Rho]\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"\[Rho]0", "=", 
               RowBox[{"<|", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"0", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                   "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
                    ",", "rules2"}], "]"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"2", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                   "\"\<(\[Lambda] x . (ops1 y x))\>\"", ",", "rules2"}], 
                   "]"}]}], ",", "\[IndentingNewLine]", 
                 RowBox[{"3", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops1 y x)\>\"", ",", "rules2"}], "]"}]}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"1", "\[Rule]", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops3 2 x)\>\"", ",", "rules2"}], "]"}]}]}], 
                "\[IndentingNewLine]", "|>"}]}], ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<hold\>\"", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"Hold", "[", "  ", 
               RowBox[{"(", 
                RowBox[{"\[Paragraph]", " ", "0", " ", "ops2", "  ", 
                 RowBox[{"(", 
                  RowBox[{
                  "\[Paragraph]", " ", "1", " ", "ops3", " ", "2", "  ", 
                   "x"}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{"\[Paragraph]", " ", "2", " ", "\[Lambda]", " ", 
                   RowBox[{"x", " ", ".", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    "\[Paragraph]", " ", "3", " ", "ops1", " ", "y", " ", 
                    "x"}], ")"}]}]}], ")"}]}], ")"}], "]"}], ")"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<stitch\>\"", "\[Rule]", 
             RowBox[{"Hold", "[", 
              RowBox[{"(", 
               RowBox[{"StringJoin", "@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"StringReplace", "[", 
                   RowBox[{"\"\<(ops2 (ops3 2 x) \>\"", ",", "rules2"}], 
                   "]"}], ",", 
                  RowBox[{"StringReplace", "[", 
                   RowBox[{
                    RowBox[{"\[Rho]0", "[", "2", "]"}], ",", 
                    RowBox[{
                    RowBox[{"res", "[", "\"\<replace\>\"", "]"}], "[", 
                    RowBox[{"2", "+", "1"}], "]"}]}], "]"}], ",", 
                  "\"\<)\>\""}], "}"}]}], ")"}], "]"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<expr\>\"", "\[Rule]", 
             RowBox[{
             "(", "\"\<(ops2 (ops3 2 x) (\[Lambda] x . (ops1 y x)))\>\"", 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<sym\>\"", "\[Rule]", "x"}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"\"\<wrongsym\>\"", "\[Rule]", "y"}]}], 
           "\[IndentingNewLine]", "\[IndentingNewLine]", "|>"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "}"}]}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]", "=", 
    RowBox[{"expression", "[", "\"\<\[Rho]\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"res", "=", 
    RowBox[{"eval\[Lambda]", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"expression", "[", "\"\<hold\>\"", "]"}], "/.", "rules"}], ",", 
      RowBox[{"StringReplace", "[", 
       RowBox[{
        RowBox[{"expression", "[", "\"\<expr\>\"", "]"}], ",", "rules2"}], 
       "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"trace", "=", 
    RowBox[{"trace\[Lambda]", "[", "res", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"parsetrace", "=", 
    RowBox[{"Column", "@", 
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<\[Lambda] expression: \>\"", ",", 
          RowBox[{"res", "[", "\"\<input\>\"", "]"}]}], "}"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Row", "@", 
        RowBox[{"{", 
         RowBox[{"\"\<Evaluation: \>\"", ",", 
          RowBox[{
           RowBox[{"res", "[", "\"\<output\>\"", "]"}], "/.", "rules"}]}], 
         "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"Spacer", "@", "100"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Row", "@", 
        RowBox[{"{", "\"\<Trace: \>\"", "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"Column", "[", 
        RowBox[{"trace", ",", 
         RowBox[{"Dividers", "\[Rule]", "All"}], ",", 
         RowBox[{"FrameStyle", "\[Rule]", "Orange"}]}], "]"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
  StyleBox["\[IndentingNewLine]",
   FontWeight->"Plain"], 
  StyleBox[
   RowBox[{
    StyleBox[
     RowBox[{"(", "*"}]], 
    RowBox[{
     RowBox[{"TODO", ":", " ", 
      RowBox[{"this", " ", "needs", " ", "to", " ", "be", " ", "a", " ", 
       RowBox[{"colum", "@", 
        RowBox[{"{", "}"}]}]}]}], ",", " ", 
     RowBox[{"assymed", " ", "single", " ", "alpha"}]}], 
    StyleBox[
     RowBox[{"*", ")"}]]}],
   FontWeight->"Plain"]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"correct", "=", 
   RowBox[{"\[Mho]", " ", 
    RowBox[{"ReleaseHold", "@", 
     RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}]}]}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{"variable", " ", "number", " ", "of", " ", "choices"}], " ", 
   "*)"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ops", "=", 
   RowBox[{"RandomChoice", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
        RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
        RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"wrong", "=", 
  RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"\"\<None\>\"", ",", 
    RowBox[{"StringReplace", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[Mho]", " ", 
        RowBox[{"ReleaseHold", "[", 
         RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], "]"}]}], ")"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "]"}], "\[Rule]", 
        RowBox[{"ToString", "[", 
         RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}], "]"}]}], 
       "}"}]}], "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ops", "=", 
      RowBox[{"RandomChoice", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
           RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
        "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Mho]", " ", 
         RowBox[{"ReleaseHold", "[", 
          RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], "]"}]}], ")"}], 
       ",", "ops"}], "]"}]}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ops", "=", 
      RowBox[{"RandomChoice", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
           RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
        "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Mho]", " ", 
         RowBox[{"ReleaseHold", "[", 
          RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], "]"}]}], ")"}], 
       ",", "ops"}], "]"}]}], ",", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ops", "=", 
      RowBox[{"RandomChoice", "@", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<*\>\"", "\[Rule]", "\"\<+\>\""}], ",", 
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<^\>\""}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<+\>\"", "\[Rule]", "\"\<*\>\""}], ",", 
           RowBox[{"\"\<^\>\"", "\[Rule]", "\"\<*\>\""}]}], "}"}]}], 
        "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"StringReplace", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Mho]", " ", 
           RowBox[{"ReleaseHold", "[", 
            RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}], "]"}]}], 
          ")"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"ToString", "[", 
            RowBox[{"expression", "[", "\"\<sym\>\"", "]"}], "]"}], "\[Rule]", 
           RowBox[{"ToString", "[", 
            RowBox[{"expression", "[", "\"\<wrongsym\>\"", "]"}], "]"}]}], 
          "}"}]}], "]"}], ",", "ops"}], "]"}]}]}], "\[IndentingNewLine]", 
   "}"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.77699756378869*^9, 3.776997571910226*^9}, {
   3.77699761315456*^9, 3.776997615257827*^9}, {3.776998626148221*^9, 
   3.776998640413167*^9}, {3.7769987798317413`*^9, 3.776998781695602*^9}, {
   3.776998849176014*^9, 3.776998871979925*^9}, {3.776998904932082*^9, 
   3.776998913966075*^9}, {3.776999036235608*^9, 3.776999055169875*^9}, {
   3.7769990878868427`*^9, 3.776999148322927*^9}, {3.776999632540395*^9, 
   3.776999632853649*^9}, {3.776999711686289*^9, 3.776999720944212*^9}, {
   3.776999763416478*^9, 3.77699990074771*^9}, {3.777000037388672*^9, 
   3.777000044167531*^9}, {3.777000079058496*^9, 3.7770000836452017`*^9}, {
   3.7770002758141623`*^9, 3.7770003352474194`*^9}, {3.777000420292396*^9, 
   3.7770004338132753`*^9}, {3.77700049771749*^9, 3.777000500550879*^9}, {
   3.777037581121606*^9, 3.777037584977972*^9}, {3.777037729544404*^9, 
   3.777037789333991*^9}, {3.7770380720216913`*^9, 3.777038122332443*^9}, {
   3.777038340872059*^9, 3.77703838410326*^9}, {3.777038461122385*^9, 
   3.777038505940209*^9}, {3.7770385370508947`*^9, 3.777038559682439*^9}, 
   3.777038648145109*^9, {3.7770386890837383`*^9, 3.777038726230414*^9}, {
   3.7770387580799103`*^9, 3.7770388750264587`*^9}, {3.777038920662936*^9, 
   3.7770389454109993`*^9}, {3.7770389976671677`*^9, 
   3.777039003290288*^9}},ExpressionUUID->"b47e2ff6-b9b9-4b67-83a8-\
2f71e97ebca4"],

Cell[BoxData["\<\"(+ (\[Lambda] x$39293 . (* y x$39293))) (^ 2 x))\"\>"], \
"Output",
 CellChangeTimes->{
  3.777000336076441*^9, 3.777000434386623*^9, 3.777000505894795*^9, 
   3.777037585388885*^9, {3.777037664842836*^9, 3.77703769296754*^9}, {
   3.7770377354642487`*^9, 3.777037770046014*^9}, {3.7770381554378347`*^9, 
   3.777038174958932*^9}, 3.777038352394801*^9, {3.777038385189026*^9, 
   3.7770384036728*^9}, {3.7770384739848843`*^9, 3.777038506230554*^9}, 
   3.777038559994171*^9, {3.777038644878991*^9, 3.7770386484408007`*^9}, {
   3.777038785620525*^9, 3.777038805722167*^9}, {3.777038847414748*^9, 
   3.7770388753132*^9}, {3.777038921949925*^9, 3.777038947200593*^9}},
 CellLabel->
  "Out[612]=",ExpressionUUID->"c4fba14b-f06d-4231-9c40-56bf246eade7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"None\"\>", 
   ",", "\<\"(+ (\[Lambda] y$39293 . (* y y$39293))) (^ 2 y))\"\>", 
   ",", "\<\"(* (\[Lambda] x$39293 . (* y x$39293))) (* 2 x))\"\>", 
   ",", "\<\"(^ (\[Lambda] x$39293 . (+ y x$39293))) (^ 2 x))\"\>", 
   ",", "\<\"(* (\[Lambda] y$39293 . (* y y$39293))) (* 2 y))\"\>"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.777000336076441*^9, 3.777000434386623*^9, 3.777000505894795*^9, 
   3.777037585388885*^9, {3.777037664842836*^9, 3.77703769296754*^9}, {
   3.7770377354642487`*^9, 3.777037770046014*^9}, {3.7770381554378347`*^9, 
   3.777038174958932*^9}, 3.777038352394801*^9, {3.777038385189026*^9, 
   3.7770384036728*^9}, {3.7770384739848843`*^9, 3.777038506230554*^9}, 
   3.777038559994171*^9, {3.777038644878991*^9, 3.7770386484408007`*^9}, {
   3.777038785620525*^9, 3.777038805722167*^9}, {3.777038847414748*^9, 
   3.7770388753132*^9}, {3.777038921949925*^9, 3.777038947202327*^9}},
 CellLabel->
  "Out[614]=",ExpressionUUID->"0bd146ca-4844-4840-8eb3-2f3d40cb0d40"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<input\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.77700036407098*^9, 3.7770003685476627`*^9}},
 CellLabel->
  "In[192]:=",ExpressionUUID->"70613610-65c5-4ef0-8c4d-16c2214f10de"],

Cell[BoxData["\<\"(^ (\[Lambda] x . (+ y x)) (* 2 x))\"\>"], "Output",
 CellChangeTimes->{3.777000368917164*^9, 3.777000517717153*^9},
 CellLabel->
  "Out[192]=",ExpressionUUID->"d3e89243-bd0a-4a6a-8043-61e7a465549e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{"correct", "\[IndentingNewLine]", "wrong"}], "Input",
 CellChangeTimes->{{3.7769748202708597`*^9, 3.776974831317328*^9}},
 CellLabel->
  "In[166]:=",ExpressionUUID->"29777fcb-5899-42fa-9b5b-539482d763ce"],

Cell[BoxData["\<\"(* (+ 2 x$26138)) (+ 2 x))\"\>"], "Output",
 CellChangeTimes->{{3.776974821633206*^9, 3.7769748316222763`*^9}, 
   3.776999157592073*^9, 3.777000016895454*^9, 3.777000048306033*^9, 
   3.777000087704797*^9, {3.777000310428664*^9, 3.777000326763027*^9}},
 CellLabel->
  "Out[166]=",ExpressionUUID->"a9f8de5b-7e49-4db9-81da-8aea781e06b0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"None\"\>", ",", 
   TagBox[GridBox[{
      {
       TemplateBox[{
        "\"(\[Lambda] x . (^ y x))\"","\"[\"","y",OverscriptBox[
         "\"\[LongRightArrow]\"", "\"\[Alpha]\""],
         TemplateBox[{
          "x$26138", FrameStyle -> None, Background -> 
           RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
         "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
        "RowDefault"]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{"Columns" -> {{Left}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Column"], ",", 
   TagBox[GridBox[{
      {
       TemplateBox[{
        "\"(\[Lambda] x . (^ y x))\"","\"[\"","x",OverscriptBox[
         "\"\[LongRightArrow]\"", "\"\[Beta]\""],
         TemplateBox[{
          "x$26138", FrameStyle -> None, Background -> 
           RGBColor[1, 0.925, 0.925]}, "Highlighted"],"\"]\"",
         "\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\""},
        "RowDefault"]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{"Columns" -> {{Left}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
    "Column"]}], "}"}]], "Output",
 CellChangeTimes->{{3.776974821633206*^9, 3.7769748316222763`*^9}, 
   3.776999157592073*^9, 3.777000016895454*^9, 3.777000048306033*^9, 
   3.777000087704797*^9, {3.777000310428664*^9, 3.7770003267649603`*^9}},
 CellLabel->
  "Out[167]=",ExpressionUUID->"634b1a2a-f9c8-42d5-96b9-83df116286ee"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Mho]", " ", 
  RowBox[{"ReleaseHold", "@", 
   RowBox[{"expression", "[", "\"\<stitch\>\"", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7769994163851643`*^9, 3.77699945673908*^9}, {
  3.776999738431171*^9, 3.776999739213397*^9}},
 CellLabel->
  "In[140]:=",ExpressionUUID->"a083d110-00ed-4796-baf1-645aa2ba685c"],

Cell[BoxData["\<\"(+ (\[Lambda] x$26111 . (^ y x$26111))) (* 2 x))\"\>"], \
"Output",
 CellChangeTimes->{
  3.7769750148661003`*^9, {3.7769994219919786`*^9, 3.7769994571754017`*^9}, 
   3.776999641425756*^9, {3.776999725747321*^9, 3.776999739765999*^9}, {
   3.776999773605085*^9, 3.7769997790969057`*^9}, {3.776999914540382*^9, 
   3.77699993600484*^9}, 3.777000052176071*^9, 3.777000089799741*^9},
 CellLabel->
  "Out[140]=",ExpressionUUID->"5b62582b-d0a2-46a1-8ce8-c4500024b6b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<input\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.77699960991441*^9, 3.7769996104410257`*^9}, {
  3.7770000243554993`*^9, 3.777000024915946*^9}},
 CellLabel->
  "In[130]:=",ExpressionUUID->"067ca46e-6de2-4c25-9176-2b35eb67dfe1"],

Cell[BoxData["\<\"(* (\[Lambda] x . (^ y x)) (+ 2 x))\"\>"], "Output",
 CellChangeTimes->{{3.7769995933730297`*^9, 3.7769996107200823`*^9}, {
  3.777000025352602*^9, 3.7770000548817463`*^9}},
 CellLabel->
  "Out[130]=",ExpressionUUID->"f541495f-489a-4ae7-bdd7-1413e08601b2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Row", "/@", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Drop", "[", 
      RowBox[{"#", ",", 
       RowBox[{"-", "6"}]}], "]"}], "&"}], "/@", 
    RowBox[{"(", 
     RowBox[{"Values", "@", "\[Alpha]\[Xi]"}], ")"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.776975243283107*^9, 3.77697529981763*^9}},
 CellLabel->"In[41]:=",ExpressionUUID->"f7ae889b-617f-4f4a-90b4-e94941b2c233"],

Cell[BoxData[
 RowBox[{"{", 
  TemplateBox[{"\"(\[Lambda] x . (^ y x))\""},
   "RowDefault"], "}"}]], "Output",
 CellChangeTimes->{{3.7769752492308283`*^9, 3.776975261250206*^9}, {
  3.7769752964011374`*^9, 3.77697530028645*^9}},
 CellLabel->"Out[41]=",ExpressionUUID->"1a6df6a8-7925-44f6-8c42-9bf90ab10e55"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Values", "@", "\[Alpha]\[Xi]"}]], "Input",
 CellLabel->"In[39]:=",ExpressionUUID->"88992783-364e-49ea-87da-b1ba96add1bc"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"\<\"(\[Lambda] x . (^ y x))\"\>", ",", "\<\"[\"\>", ",", "x", ",", 
    OverscriptBox["\<\"\[LongRightArrow]\"\>", "\<\"\[Alpha]\"\>"], ",", 
    TemplateBox[{
     "x$6447",FrameStyle -> None,Background -> RGBColor[1, 0.925, 0.925]},
     "Highlighted"], ",", "\<\"]\"\>", 
    ",", "\<\" \[ScriptS]\[ScriptU]\[ScriptB]\[ScriptS]\[ScriptT]\[ScriptI]\
\[ScriptT]\[ScriptU]\[ScriptT]\[ScriptE] \[ScriptA] \[ScriptN]\[ScriptE]\
\[ScriptW] \[ScriptC]\[ScriptO]\[ScriptP]\[ScriptY]\"\>"}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.776975266153623*^9},
 CellLabel->"Out[39]=",ExpressionUUID->"2ed1a160-34dd-4ab4-ae66-433d6b9d7f75"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.776995970283353*^9, 3.776995980993211*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"75739e74-c635-412a-9c01-5e3eb3c1f106"],

Cell[BoxData["\<\"(Power y x)\"\>"], "Output",
 CellChangeTimes->{{3.7769959714630737`*^9, 3.7769959812165833`*^9}},
 CellLabel->"Out[43]=",ExpressionUUID->"95413f99-c80e-4732-98f0-7de5cc0fe6c9"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{416, Automatic}, {Automatic, 65}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 18259, 411, 2845, "Input",ExpressionUUID->"b47e2ff6-b9b9-4b67-83a8-2f71e97ebca4"],
Cell[18842, 435, 768, 12, 34, "Output",ExpressionUUID->"c4fba14b-f06d-4231-9c40-56bf246eade7"],
Cell[19613, 449, 1036, 18, 77, "Output",ExpressionUUID->"0bd146ca-4844-4840-8eb3-2f3d40cb0d40"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20686, 472, 218, 4, 30, "Input",ExpressionUUID->"70613610-65c5-4ef0-8c4d-16c2214f10de"],
Cell[20907, 478, 217, 3, 34, "Output",ExpressionUUID->"d3e89243-bd0a-4a6a-8043-61e7a465549e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21161, 486, 218, 3, 52, "Input",ExpressionUUID->"29777fcb-5899-42fa-9b5b-539482d763ce"],
Cell[21382, 491, 354, 5, 34, "Output",ExpressionUUID->"a9f8de5b-7e49-4db9-81da-8aea781e06b0"],
Cell[21739, 498, 1816, 41, 81, "Output",ExpressionUUID->"634b1a2a-f9c8-42d5-96b9-83df116286ee"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23592, 544, 337, 7, 30, "Input",ExpressionUUID->"a083d110-00ed-4796-baf1-645aa2ba685c"],
Cell[23932, 553, 482, 8, 34, "Output",ExpressionUUID->"5b62582b-d0a2-46a1-8ce8-c4500024b6b0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24451, 566, 269, 5, 30, "Input",ExpressionUUID->"067ca46e-6de2-4c25-9176-2b35eb67dfe1"],
Cell[24723, 573, 274, 4, 34, "Output",ExpressionUUID->"f541495f-489a-4ae7-bdd7-1413e08601b2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25034, 582, 416, 11, 30, "Input",ExpressionUUID->"f7ae889b-617f-4f4a-90b4-e94941b2c233"],
Cell[25453, 595, 308, 6, 34, "Output",ExpressionUUID->"1a6df6a8-7925-44f6-8c42-9bf90ab10e55"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25798, 606, 145, 2, 30, "Input",ExpressionUUID->"88992783-364e-49ea-87da-b1ba96add1bc"],
Cell[25946, 610, 691, 13, 46, "Output",ExpressionUUID->"2ed1a160-34dd-4ab4-ae66-433d6b9d7f75"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26674, 628, 204, 3, 30, "Input",ExpressionUUID->"75739e74-c635-412a-9c01-5e3eb3c1f106"],
Cell[26881, 633, 195, 2, 34, "Output",ExpressionUUID->"95413f99-c80e-4732-98f0-7de5cc0fe6c9"]
}, Open  ]]
}
]
*)

